# -*- coding: utf-8 -*-
# python methods for the character module

import object
import character
import options

__doc__ = """add-in module for module character

this module isn't meant to be used directly. everything defined here will be
part of the character module. 
"""


def update_appearance( object_id ):
	"set appearance from attributes"

	baseres = "textures\\characters\\human\\"

	model = None
	if object.has_attribute( object_id, "model" ):
		model = object.get_attribute( object_id, "model" )
	gender = None
	if object.has_attribute( object_id, "gender" ):
		gender = object.get_attribute( object_id, "gender" )
	skin = None
	if object.has_attribute( object_id, "skin" ):
		skin = object.get_attribute( object_id, "skin" )
	clothes = None
	if object.has_attribute( object_id, "clothes" ):
		clothes = object.get_attribute( object_id, "clothes" )
	clothes_boots = None
	if object.has_attribute( object_id, "clothes_boots" ):
		clothes_boots = object.get_attribute( object_id, "clothes_boots" )
	clothes_gloves = None
	if object.has_attribute( object_id, "clothes_gloves" ):
		clothes_gloves = object.get_attribute( object_id, "clothes_gloves" )
	face = None
	if object.has_attribute( object_id, "face" ):
		face = object.get_attribute( object_id, "face" )
	helmet = None
	if object.has_attribute( object_id, "helmet" ):
		helmet = object.get_attribute( object_id, "helmet" )
	hair = None
	if object.has_attribute( object_id, "hair" ):
		hair = object.get_attribute( object_id, "hair" )

	try:
		if model=="low_pregnant":
			if gender=="female":
				ap_basedir = "objects\\characters\\anims\\female\\"
				ap_model = "objects\\characters\\female\\female_pregnant.gr2"
				valid_clothes = \
					{"pregnant": ("body_pregnant", "body_pregnant", baseres+"special\\female\\pregnant_%(skin)s.png")}
				valid_faces = \
					{"pregnant_01": baseres+"special\\faces\\female_pregnant_01.png"}
			else: raise ValueError, "gender female"

		elif model=="low":
			if gender=="male":
				ap_basedir = "objects\\characters\\anims\\male\\"
				ap_model = "objects\\characters\\male\\male_low.gr2"
				valid_clothes = \
					{"ll_001": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_001_%(skin)s.png"),
					 "ll_002": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_002_%(skin)s.png"),
					 "ll_003": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_003_%(skin)s.png"),
					 "ll_004": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_004_%(skin)s.png"),
					 "ll_seeker": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_seeker_%(skin)s.png"),
					 "ll_seeker_leather": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_seeker_leather_%(skin)s.png"),
					 "ll_gno_guard": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_gno_guard_%(skin)s.png"),
					 "ll_gno_guard_leather": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_gno_guard_leather_%(skin)s.png"),
					 "ll_nomad_01": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_nomad_01_%(skin)s.png"),
					 "ll_nomad_02": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_nomad_02_%(skin)s.png"),
					 "ll_shadow_01": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_shadow_01_%(skin)s.png"),
					 "ll_shadow_02": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_shadow_02_%(skin)s.png"),
					 "ll_astronaut": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_astronaut_%(skin)s.png"),
					 "indian_01": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "indian_02": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_02_%(skin)s.png"),
					 "indian_03": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_03_%(skin)s.png"),
					 "indian_04": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_04_%(skin)s.png"),
					 "indian_05": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_05_%(skin)s.png"),
					 "indian_06": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_06_%(skin)s.png"),
					 "indian_07": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_07_%(skin)s.png"),
					 "indian_08": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_08_%(skin)s.png"),
					 "indian_09": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_09_%(skin)s.png"),
					 "indian_10": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_10_%(skin)s.png"),
					 "indian_11": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_11_%(skin)s.png"),
					 "indian_12": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_12_%(skin)s.png"),
					 "overall": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_overall_%(skin)s.png"),
					 "rat_fur_jacket": ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_rat_fur_jacket_%(skin)s.png"),
					 "ls_001": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_001_%(skin)s.png"),
					 "ls_002": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_002_%(skin)s.png"),
					 "ls_003": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_003_%(skin)s.png"),
					 "ls_004": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_004_%(skin)s.png"),
					 "ls_nomad_01": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_nomad_01_%(skin)s.png"),
					 "ls_nomad_02": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_nomad_02_%(skin)s.png"),
					 "ls_shadow_01": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_shadow_01_%(skin)s.png"),
					 "ls_shadow_02": ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_shadow_02_%(skin)s.png"),
					 "sl_001": ("sl", "body", baseres+"low\\male\\sl\\low_body_sl_001_%(skin)s.png"),
					 "sl_002": ("sl", "body", baseres+"low\\male\\sl\\low_body_sl_002_%(skin)s.png"),
					 "sl_003": ("sl", "body", baseres+"low\\male\\sl\\low_body_sl_003_%(skin)s.png"),
					 "sl_004": ("sl", "body", baseres+"low\\male\\sl\\low_body_sl_004_%(skin)s.png"),
					 "ss_001": ("ss", "body", baseres+"low\\male\\ss\\low_body_ss_001_%(skin)s.png"),
					 "ss_002": ("ss", "body", baseres+"low\\male\\ss\\low_body_ss_002_%(skin)s.png"),
					 "ss_003": ("ss", "body", baseres+"low\\male\\ss\\low_body_ss_003_%(skin)s.png"),
					 "ss_004": ("ss", "body", baseres+"low\\male\\ss\\low_body_ss_004_%(skin)s.png"),
					 "uni_001": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_001_%(skin)s.png"),
					 "uni_002": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_002_%(skin)s.png"),
					 "uni_003": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_003_%(skin)s.png"),
					 "uni_004": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_004_%(skin)s.png"),
					 "desertmonk": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_desertmonk_%(skin)s.png"),
					 "desertmonk_chef": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_desertmonk_chef_%(skin)s.png"),
					 "ratskull": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_ratskull_%(skin)s.png"),
					 "ratskull_bulletproof": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_ratskull_bulletproof_%(skin)s.png"),
					 "ratskull_leather": ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_ratskull_leather_%(skin)s.png"),
					 					 
					 #new clothes added 070704 - roger
					 "dead_body"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_dead_body.png"),
					 "railroader"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_railroader_%(skin)s.png"),
					 "scarecrow_01"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_scarecrow_01.png"),
					 "scarecrow_02"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_scarecrow_02.png"),
					 "scarecrow_03"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_scarecrow_03.png"),
					 "sectarian"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_sects_%(skin)s.png"),
					 "transvestit"		: ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_transvestit.png"),
					 
					 #new clothes added 230804 - roger
					 "ratskull_phoenix"	: ("uni", "body", baseres+"low\\male\\uni\\low_body_uni_ratskull_phoenix.png"),
					 "nomad_boss"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_nomad_boss.png"),
					 "shadow_abel"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_shadow_abel.png"),
					 "shadow_general"	: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_shadow_general.png"),
					 "sl_shaman"		: ("sl", "body", baseres+"low\\male\\sl\\low_body_sl_shaman.png"),
					 
					 #new clothes added 101004 - roger
					 "president_hayes"	: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_president_hayes.png"),
					 "wesley"			: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_wesley.png"),
					 "sects_chief"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_sects_chief.png"),
					 "shadow_doctor"	: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_shadow_doctor.png"),
					 "doctor"			: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_doctor_%(skin)s.png"),
					 "gangleader"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_gangleader.png"),
					 "general_lewis"	: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_general_lewis.png"),
					 "indian_chief"		: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_indian_chief.png"),
					 "marko"			: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_marko.png"),
					 "host"				: ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_host.png"),
					 "monk"				: ("ls", "body", baseres+"low\\male\\ls\\low_body_ls_monk_%(skin)s.png"),
					 "hunter"			: ("ll", "body", baseres+"low\\male\\ll\\low_body_ll_hunter.png"),
					 }
				valid_faces = \
					{
					# common faces
					"adalbert": baseres+"low\\faces\\male_low_face_adalbert.png",
					"albin": baseres+"low\\faces\\male_low_face_albin.png",
					"ascan": baseres+"low\\faces\\male_low_face_ascan.png",
					"bernulf": baseres+"low\\faces\\male_low_face_bernulf.png",
					"blankard": baseres+"low\\faces\\male_low_face_blankard.png",
					"dagwin": baseres+"low\\faces\\male_low_face_dagwin.png",
					"dietbert": baseres+"low\\faces\\male_low_face_dietbert.png",
					"eberwin": baseres+"low\\faces\\male_low_face_eberwin.png",
					"eginhard": baseres+"low\\faces\\male_low_face_eginhard.png",
					"erkmar": baseres+"low\\faces\\male_low_face_erkmar.png",
					"folkward": baseres+"low\\faces\\male_low_face_folkward.png",
					"gandolf": baseres+"low\\faces\\male_low_face_gandolf.png",
					"gerbod": baseres+"low\\faces\\male_low_face_gerbod.png",
					"godbert": baseres+"low\\faces\\male_low_face_godbert.png",
					"gudmunt": baseres+"low\\faces\\male_low_face_gudmunt.png",
					"heilwig": baseres+"low\\faces\\male_low_face_heilwig.png",
					"hildegar": baseres+"low\\faces\\male_low_face_hildegar.png",
					"kunolf": baseres+"low\\faces\\male_low_face_kunolf.png",
					"otilo": baseres+"low\\faces\\male_low_face_otilo.png",
					"reimund": baseres+"low\\faces\\male_low_face_reimund.png",
					"scarecrow": baseres+"low\\faces\\male_low_face_scarecrow.png",

					"desertmonk_chef": baseres+"low\\faces\\male_low_face_desertmonk_chef.png",
					"desertmonk01": baseres+"low\\faces\\male_low_face_desertmonk01.png",
					"desertmonk02": baseres+"low\\faces\\male_low_face_desertmonk02.png",
					"desertmonk03": baseres+"low\\faces\\male_low_face_desertmonk03.png",
					"desertmonk04": baseres+"low\\faces\\male_low_face_desertmonk04.png",
					"desertmonk05": baseres+"low\\faces\\male_low_face_desertmonk05.png",
					"desertmonk06": baseres+"low\\faces\\male_low_face_desertmonk06.png",
					"desertmonk07": baseres+"low\\faces\\male_low_face_desertmonk07.png",
					"desertmonk08": baseres+"low\\faces\\male_low_face_desertmonk08.png",
					"desertmonk09": baseres+"low\\faces\\male_low_face_desertmonk09.png",
					"desertmonk10": baseres+"low\\faces\\male_low_face_desertmonk10.png",
					"desertmonk11": baseres+"low\\faces\\male_low_face_desertmonk11.png",
					"desertmonk12": baseres+"low\\faces\\male_low_face_desertmonk12.png",
					"desertmonk13": baseres+"low\\faces\\male_low_face_desertmonk13.png",
					"desertmonk14": baseres+"low\\faces\\male_low_face_desertmonk14.png",
					"desertmonk15": baseres+"low\\faces\\male_low_face_desertmonk15.png",

					"indy01": baseres+"low\\faces\\male_low_face_indy01.png",
					"indy02": baseres+"low\\faces\\male_low_face_indy02.png",
					"indy03": baseres+"low\\faces\\male_low_face_indy03.png",
					"indy04": baseres+"low\\faces\\male_low_face_indy04.png",
					"indy05": baseres+"low\\faces\\male_low_face_indy05.png",
					"indy06": baseres+"low\\faces\\male_low_face_indy06.png",
					"indy07": baseres+"low\\faces\\male_low_face_indy07.png",

					"clown": baseres+"low\\faces\\male_low_face_clown.png",

					"shadow01": baseres+"low\\faces\\male_low_face_shadow01.png",
					"shadow02": baseres+"low\\faces\\male_low_face_shadow02.png",
					"shadow03": baseres+"low\\faces\\male_low_face_shadow03.png",
					"shadow04": baseres+"low\\faces\\male_low_face_shadow04.png",
					"shadow05": baseres+"low\\faces\\male_low_face_shadow05.png",
					"shadow06": baseres+"low\\faces\\male_low_face_shadow06.png",
					"shadow07": baseres+"low\\faces\\male_low_face_shadow07.png",
					"shadow08": baseres+"low\\faces\\male_low_face_shadow08.png",
					"shadow09": baseres+"low\\faces\\male_low_face_shadow09.png",
					"shadow10": baseres+"low\\faces\\male_low_face_shadow10.png",

					"evil01": baseres+"low\\faces\\male_low_face_evil01.png",
					"evil02": baseres+"low\\faces\\male_low_face_evil02.png",
					"evil03": baseres+"low\\faces\\male_low_face_evil03.png",
					"evil04": baseres+"low\\faces\\male_low_face_evil04.png",
					"evil05": baseres+"low\\faces\\male_low_face_evil05.png",
					"evil06": baseres+"low\\faces\\male_low_face_evil06.png",
					"evil07": baseres+"low\\faces\\male_low_face_evil07.png",
					"evil08": baseres+"low\\faces\\male_low_face_evil08.png",
					"evil09": baseres+"low\\faces\\male_low_face_evil09.png",
					"evil10": baseres+"low\\faces\\male_low_face_evil10.png",
					"evil11": baseres+"low\\faces\\male_low_face_evil11.png",
					"evil12": baseres+"low\\faces\\male_low_face_evil12.png",
					"evil13": baseres+"low\\faces\\male_low_face_evil13.png",
					"evil14": baseres+"low\\faces\\male_low_face_evil14.png",
					"evil15": baseres+"low\\faces\\male_low_face_evil15.png",
					"evil16": baseres+"low\\faces\\male_low_face_evil16.png",
					"evil17": baseres+"low\\faces\\male_low_face_evil17.png",
					"evil18": baseres+"low\\faces\\male_low_face_evil18.png",
					"evil19": baseres+"low\\faces\\male_low_face_evil19.png",

					# dialog faces
					"adrian": baseres+"low\\dialog_faces\\male_low_adrian.png",
					"ben": baseres+"low\\dialog_faces\\male_low_ben.png",
					"bobby": baseres+"low\\dialog_faces\\male_low_bobby.png",
					"chuck": baseres+"low\\dialog_faces\\male_low_chuck.png",
					"colin": baseres+"low\\dialog_faces\\male_low_colin.png",
					"david": baseres+"low\\dialog_faces\\male_low_david.png",
					"donald": baseres+"low\\dialog_faces\\male_low_donald.png",
					"drill_instructor": baseres+"low\\dialog_faces\\male_low_drill_instructor.png",
					"george": baseres+"low\\dialog_faces\\male_low_george.png",
					"gonzo": baseres+"low\\dialog_faces\\male_low_gonzo.png",
					"guard_of_quarters_01": baseres+"low\\dialog_faces\\male_low_guard_of_quarters_01.png",
					"guard_of_quarters_02": baseres+"low\\dialog_faces\\male_low_guard_of_quarters_02.png",
					"hermit": baseres+"low\\dialog_faces\\male_low_hermit.png",
					"jason": baseres+"low\\dialog_faces\\male_low_jason.png",
					"jay": baseres+"low\\dialog_faces\\male_low_jay.png",
					"jim_bob": baseres+"low\\dialog_faces\\male_low_jim_bob.png",
					"jim_bob_tidy": baseres+"low\\dialog_faces\\male_low_jim_bob_tidy.png",
					"lucas": baseres+"low\\dialog_faces\\male_low_lucas.png",
					"luis": baseres+"low\\dialog_faces\\male_low_luis.png",
					"mckanzee": baseres+"low\\dialog_faces\\male_low_mckanzee.png",
					"miles": baseres+"low\\dialog_faces\\male_low_miles.png",
					"nigel": baseres+"low\\dialog_faces\\male_low_nigel.png",
					"president_companion_01": baseres+"low\\dialog_faces\\male_low_president_companion_01.png",
					"president_companion_02": baseres+"low\\dialog_faces\\male_low_president_companion_02.png",
					"president_guard_01": baseres+"low\\dialog_faces\\male_low_president_guard_01.png",
					"president_guard_02": baseres+"low\\dialog_faces\\male_low_president_guard_02.png",
					"president_hayes": baseres+"low\\dialog_faces\\male_low_president_hayes.png",
					"ratmeat_trader": baseres+"low\\dialog_faces\\male_low_ratmeat_trader.png",
					"ratskull_guard": baseres+"low\\dialog_faces\\male_low_ratskull_guard.png",
					"ratskull_member_0012": baseres+"low\\dialog_faces\\male_low_ratskull_member_0012.png",
					"ratskull_member_0013": baseres+"low\\dialog_faces\\male_low_ratskull_member_0013.png",
					"reporter": baseres+"low\\dialog_faces\\male_low_reporter.png",
					"timetraveller": baseres+"low\\dialog_faces\\male_low_timetraveller.png",
					"trader_001": baseres+"low\\dialog_faces\\male_low_trader_001.png",
					"village_elder": baseres+"low\\dialog_faces\\male_low_village_elder.png",
					"wesley": baseres+"low\\dialog_faces\\male_low_wesley.png",
					"william": baseres+"low\\dialog_faces\\male_low_william.png",
					"adian": baseres+"low\\dialog_faces\\male_low_adian.png",
					"dick": baseres+"low\\dialog_faces\\male_low_dick.png",
					"ian": baseres+"low\\dialog_faces\\male_low_ian.png",
					"zachary": baseres+"low\\dialog_faces\\male_low_zachary.png",
					"phoenix": baseres+"low\\dialog_faces\\male_low_phoenix.png",
					"nicholas": baseres+"low\\dialog_faces\\male_low_nicholas.png",
					"mustafa": baseres+"low\\dialog_faces\\male_low_mustafa.png",
					"manny": baseres+"low\\dialog_faces\\male_low_manny.png",
					"general_of_the_shadows": baseres+"low\\dialog_faces\\male_low_general_of_the_shadows.png",
					"franklin": baseres+"low\\dialog_faces\\male_low_franklin.png",
					"donald_z6": baseres+"low\\dialog_faces\\male_low_donald_z6.png",
					"bill": baseres+"low\\dialog_faces\\male_low_bill.png",
					"sectarian": baseres+"low\\dialog_faces\\male_low_sectarian.png",
					"peco": baseres+"low\\dialog_faces\\male_low_peco.png",
					"madison": baseres+"low\\dialog_faces\\male_low_madison.png",
					"joshua": baseres+"low\\dialog_faces\\male_low_joshua.png",
					"doubleganger_general": baseres+"low\\dialog_faces\\male_low_doubleganger_general.png",
					"caleb": baseres+"low\\dialog_faces\\male_low_caleb.png",
					"wiggler": baseres+"low\\dialog_faces\\male_low_wiggler.png",
					"andrew": baseres+"low\\dialog_faces\\male_low_andrew.png",
					"rupert": baseres+"low\\dialog_faces\\male_low_rupert.png",
					"craig": baseres+"low\\dialog_faces\\male_low_craig.png",
					"brad": baseres+"low\\dialog_faces\\male_low_brad.png",
					"abraham": baseres+"low\\dialog_faces\\male_low_abraham.png",
					"stitch": baseres+"low\\dialog_faces\\male_low_stitch.png",
					"stuffle": baseres+"low\\dialog_faces\\male_low_stuffle.png",
					"hickey": baseres+"low\\dialog_faces\\male_low_hickey.png",
					"tyee": baseres+"low\\dialog_faces\\male_low_tyee.png",
					"yuma": baseres+"low\\dialog_faces\\male_low_yuma.png",
					"tadi": baseres+"low\\dialog_faces\\male_low_tadi.png",
					"nantan": baseres+"low\\dialog_faces\\male_low_nantan.png",
					"shaman": baseres+"low\\dialog_faces\\male_low_shaman.png",
					"ian_chase": baseres+"low\\dialog_faces\\male_low_ian_chase.png",
					"fredo": baseres+"low\\dialog_faces\\male_low_fredo.png",
					"herman": baseres+"low\\dialog_faces\\male_low_herman.png",
					"luke": baseres+"low\\dialog_faces\\male_low_luke.png",
					"nick": baseres+"low\\dialog_faces\\male_low_nick.png",
					"ratskull_leader": baseres+"low\\dialog_faces\\male_low_ratskull_leader.png",
					"waldemar": baseres+"low\\dialog_faces\\male_low_waldemar.png",
					"george_p_smythes": baseres+"low\\dialog_faces\\male_low_george_p_smythes.png",
					"ashton": baseres+"low\\dialog_faces\\male_low_ashton.png",
					"michael_collins": baseres+"low\\dialog_faces\\male_low_michael_collins.png",
					"general_lewis": baseres+"low\\dialog_faces\\male_low_general_lewis.png",
					"tizoc": baseres+"low\\dialog_faces\\male_low_tizoc.png",
					"dan": baseres+"low\\dialog_faces\\male_low_dan.png",
					"patrick": baseres+"low\\dialog_faces\\male_low_patrick.png",
					"morton": baseres+"low\\dialog_faces\\male_low_morton.png",
					"max": baseres+"low\\dialog_faces\\male_low_max.png",
					"vick": baseres+"low\\dialog_faces\\male_low_vick.png",
					"jacob": baseres+"low\\dialog_faces\\male_low_jacob.png",
					"hyde": baseres+"low\\dialog_faces\\male_low_hyde.png",
					"wright": baseres+"low\\dialog_faces\\male_low_wright.png",
					"erlan": baseres+"low\\dialog_faces\\male_low_erlan.png",
					"samson": baseres+"low\\dialog_faces\\male_low_samson.png",
					"zeke": baseres+"low\\dialog_faces\\male_low_zeke.png",
					"arik": baseres+"low\\dialog_faces\\male_low_arik.png",
					"horatio": baseres+"low\\dialog_faces\\male_low_horatio.png",
					"angus": baseres+"low\\dialog_faces\\male_low_angus.png",
					"honest": baseres+"low\\dialog_faces\\male_low_honest.png",
					"fun": baseres+"low\\dialog_faces\\male_low_fun.png",
					"lickit": baseres+"low\\dialog_faces\\male_low_lickit.png",
					"aaron": baseres+"low\\dialog_faces\\male_low_aaron.png",
					"remus": baseres+"low\\dialog_faces\\male_low_remus.png",
					"lou": baseres+"low\\dialog_faces\\male_low_lou.png",
					"abel": baseres+"low\\dialog_faces\\male_low_abel.png",
					"hale": baseres+"low\\dialog_faces\\male_low_hale.png",
					"marco": baseres+"low\\dialog_faces\\male_low_marco.png",
					"lee":baseres+"low\\dialog_faces\\male_low_lee.png",
					"trader_gene":baseres+"low\\dialog_faces\\male_low_trader_gene.png",
					"warren":baseres+"low\\dialog_faces\\male_low_warren.png",
					"marcus":baseres+"low\\dialog_faces\\male_low_marcus.png",
					"lincoln":baseres+"low\\dialog_faces\\male_low_lincoln.png",
					"robin":baseres+"low\\dialog_faces\\male_low_robin.png",
					"arthur_lawrence":baseres+"low\\dialog_faces\\male_low_arthur_lawrence.png",
					"david_bronfmaker":baseres+"low\\dialog_faces\\male_low_david_bronfmaker.png",
					"michael_shawman":baseres+"low\\dialog_faces\\male_low_michael_shawman.png",
					}
			elif gender=="female":
				ap_basedir = "objects\\characters\\anims\\female\\"
				ap_model = "objects\\characters\\female\\female_low.gr2"

				valid_clothes = {
					 "ll_001": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_001_%(skin)s.png"),
					 "ll_002": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_002_%(skin)s.png"),
					 "ll_003": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_003_%(skin)s.png"),
					 "ll_004": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_004_%(skin)s.png"),
					 "ll_nomad_01": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_nomad_01_%(skin)s.png"),
					 "ll_nomad_02": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_nomad_02_%(skin)s.png"),
					 "ll_nomad_03": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_nomad_03_%(skin)s.png"),
					 "ll_seeker": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_seeker_%(skin)s.png"),
					 "ll_gno_guard": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_gno_guard_%(skin)s.png"),
					 "ll_shadow_01": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_shadow_01_%(skin)s.png"),
					 "ll_shadow_02": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_shadow_02_%(skin)s.png"),
					 "ll_shadow_03": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_shadow_03_%(skin)s.png"),
					 "indian_01": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "indian_02": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "indian_03": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "indian_04": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "indian_05": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "indian_06": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_indian_01_%(skin)s.png"),
					 "overall": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_overall_%(skin)s.png"),
					 "ls_001": ("ls", "body", baseres+"low\\female\\ls\\low_body_ls_001_%(skin)s.png"),
					 "ls_002": ("ls", "body", baseres+"low\\female\\ls\\low_body_ls_002_%(skin)s.png"),
					 "ls_003": ("ls", "body", baseres+"low\\female\\ls\\low_body_ls_003_%(skin)s.png"),
					 "ls_004": ("ls", "body", baseres+"low\\female\\ls\\low_body_ls_004_%(skin)s.png"),
					 "sl_001": ("sl", "body", baseres+"low\\female\\sl\\low_body_sl_001_%(skin)s.png"),
					 "sl_002": ("sl", "body", baseres+"low\\female\\sl\\low_body_sl_002_%(skin)s.png"),
					 "sl_003": ("sl", "body", baseres+"low\\female\\sl\\low_body_sl_003_%(skin)s.png"),
					 "sl_004": ("sl", "body", baseres+"low\\female\\sl\\low_body_sl_004_%(skin)s.png"),
					 "ss_001": ("ss", "body", baseres+"low\\female\\ss\\low_body_ss_001_%(skin)s.png"),
					 "ss_002": ("ss", "body", baseres+"low\\female\\ss\\low_body_ss_002_%(skin)s.png"),
					 "ss_003": ("ss", "body", baseres+"low\\female\\ss\\low_body_ss_003_%(skin)s.png"),
					 "ss_004": ("ss", "body", baseres+"low\\female\\ss\\low_body_ss_004_%(skin)s.png"),
					 "uni_001": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_001_%(skin)s.png"),
					 "uni_002": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_002_%(skin)s.png"),
					 "uni_003": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_003_%(skin)s.png"),
					 "uni_004": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_004_%(skin)s.png"),
					 "ratskull": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_ratskull_%(skin)s.png"),
					 "jenna": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_jenna.png"),
					 "shanti": ("uni", "body", baseres+"low\\female\\uni\\low_body_uni_shanti.png"),
					 
					 #new clothes added 070704 by roger
					 "dead_body": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_dead_body.png"),
					 "anie": ("ss", "body", baseres+"low\\female\\ss\\low_body_ss_anie_%(skin)s.png"),
					 "shadow_doctor": ("ll", "body", baseres+"low\\female\\ll\\low_body_ll_shadow_doctor.png"),
				}
				valid_faces = \
					{
					#common faces
					"asbirg": baseres+"low\\faces\\female_low_face_asbirg.png",
					"blitgard": baseres+"low\\faces\\female_low_face_blitgard.png",
					"edeltraud": baseres+"low\\faces\\female_low_face_edeltraud.png",
					"erkhild": baseres+"low\\faces\\female_low_face_erkhild.png",
					"fladhild": baseres+"low\\faces\\female_low_face_fladhild.png",
					"fulberta": baseres+"low\\faces\\female_low_face_fulberta.png",
					"hallgard": baseres+"low\\faces\\female_low_face_hallgard.png",
					"irmela": baseres+"low\\faces\\female_low_face_irmela.png",
					"kunigunde": baseres+"low\\faces\\female_low_face_kunigunde.png",
					"lioba": baseres+"low\\faces\\female_low_face_lioba.png",
					"meinhild": baseres+"low\\faces\\female_low_face_meinhild.png",
					"nortrun": baseres+"low\\faces\\female_low_face_nortrun.png",
					"ostara": baseres+"low\\faces\\female_low_face_ostara.png",
					"richlind": baseres+"low\\faces\\female_low_face_richlind.png",
					"rinelda": baseres+"low\\faces\\female_low_face_rinelda.png",
					"roswitha": baseres+"low\\faces\\female_low_face_roswitha.png",
					"saxhild": baseres+"low\\faces\\female_low_face_saxhild.png",
					"thrasolde": baseres+"low\\faces\\female_low_face_thrasolde.png",
					"vrederun": baseres+"low\\faces\\female_low_face_vrederun.png",
					"wintrud": baseres+"low\\faces\\female_low_face_wintrud.png",

					"shadow01": baseres+"low\\faces\\female_low_face_shadow01.png",
					"shadow02": baseres+"low\\faces\\female_low_face_shadow02.png",
					"shadow03": baseres+"low\\faces\\female_low_face_shadow03.png",
					"shadow04": baseres+"low\\faces\\female_low_face_shadow04.png",
					"shadow05": baseres+"low\\faces\\female_low_face_shadow05.png",

					"evil01": baseres+"low\\faces\\female_low_face_evil01.png",
					"evil02": baseres+"low\\faces\\female_low_face_evil02.png",
					"evil03": baseres+"low\\faces\\female_low_face_evil03.png",
					"evil04": baseres+"low\\faces\\female_low_face_evil04.png",

					"indy01": baseres+"low\\faces\\female_low_face_indy01.png",
					"indy02": baseres+"low\\faces\\female_low_face_indy02.png",
					"indy03": baseres+"low\\faces\\female_low_face_indy03.png",
					"indy04": baseres+"low\\faces\\female_low_face_indy04.png",
					"indy05": baseres+"low\\faces\\female_low_face_indy05.png",
					"indy06": baseres+"low\\faces\\female_low_face_indy06.png",
					"indy07": baseres+"low\\faces\\female_low_face_indy07.png",

					# dialog faces
					"barbara": baseres+"low\\dialog_faces\\female_low_barbara.png",
					"dana": baseres+"low\\dialog_faces\\female_low_dana.png",
					"dana_untidy": baseres+"low\\dialog_faces\\female_low_dana_untidy.png",
					"female_citizen_001": baseres+"low\\dialog_faces\\female_low_female_citizen_001.png",
					"lovely_layla": baseres+"low\\dialog_faces\\female_low_lovely_layla.png",
					"luisa": baseres+"low\\dialog_faces\\female_low_luisa.png",
					"maren": baseres+"low\\dialog_faces\\female_low_maren.png",
					"mia": baseres+"low\\dialog_faces\\female_low_mia_pia.png",
					"pia": baseres+"low\\dialog_faces\\female_low_mia_pia.png",
					"sara": baseres+"low\\dialog_faces\\female_low_sara.png",
					"fatma": baseres+"low\\dialog_faces\\female_low_fatma.png",
					"isabella": baseres+"low\\dialog_faces\\female_low_isabella.png",
					"sue": baseres+"low\\dialog_faces\\female_low_sue.png",
					"conny": baseres+"low\\dialog_faces\\female_low_conny.png",
					"emily": baseres+"low\\dialog_faces\\female_low_emily.png",
					"kayla": baseres+"low\\dialog_faces\\female_low_kayla.png",
					"gerda": baseres+"low\\dialog_faces\\female_low_gerda.png",
					"anie": baseres+"low\\dialog_faces\\female_low_anie.png",
					"shanti": baseres+"low\\dialog_faces\\female_low_shanti.png",
					"fair": baseres+"low\\dialog_faces\\female_low_fair.png",
					"agnes": baseres+"low\\dialog_faces\\female_low_agnes.png",
					"myriam": baseres+"low\\dialog_faces\\female_low_myriam.png",
					"ex": baseres+"low\\dialog_faces\\female_low_ex.png",
					"jenna" : baseres+"low\\dialog_faces\\female_low_jenna.png",
					"fran" : baseres+"low\\dialog_faces\\female_low_fran.png",
					"iris" : baseres+"low\\dialog_faces\\female_low_iris.png",
					}
			else:
				raise ValueError, "gender female|male"

		elif model=="high":
			if gender=="male":
				ap_basedir = "objects\\characters\\anims\\male\\"
				#ap_model = "objects\\characters\\male\\male.gr2"
				ap_model = "objects\\characters\\male\\male_high.gr2"

				valid_clothes = \
					{"naked": ("body_naked", "body_naked", baseres+"high\\male\\naked\\naked_%(skin)s.png"),
					"SET_NORMAL_CLOTHES_1":("body_normal_clothes_1","body_normal_clothes_1", baseres+"high\\male\\normal_clothes_1\\normal_clothes_1_%(skin)s.png"),
					"SET_NORMAL_CLOTHES_2":("body_normal_clothes_2","body_normal_clothes_2", baseres+"high\\male\\normal_clothes_2\\normal_clothes_2_%(skin)s.png"),
					"SET_NORMAL_CLOTHES_3":("body_normal_clothes_3","body_normal_clothes_3", baseres+"high\\male\\normal_clothes_3\\normal_clothes_3_%(skin)s.png"),
					"SET_NORMAL_CLOTHES_4":("body_normal_clothes_4","body_normal_clothes_4", baseres+"high\\male\\normal_clothes_4\\normal_clothes_4_%(skin)s.png"),
					"SET_NORMAL_CLOTHES_5":("body_normal_clothes_5","body_normal_clothes_5", baseres+"high\\male\\normal_clothes_5\\normal_clothes_5_%(skin)s.png"),
					"SET_NORMAL_CLOTHES_6":("body_normal_clothes_6","body_normal_clothes_6", baseres+"high\\male\\normal_clothes_6\\normal_clothes_6_%(skin)s.png"),
					"SET_OVERALL":("body_normal_clothes_6","body_normal_clothes_6", baseres+"high\\male\\normal_clothes_6\\overall_%(skin)s.png"),
					"SET_BULLET_CATCH": ("body_bullet_catch", "body_bullet_catch", baseres+"high\\male\\bullet_catch\\bullet_catch_%(skin)s.png"),
					"SET_LEATHER_CLOTHES": ("body_leather_clothes", "body_leather_clothes", baseres+"high\\male\\leather_clothes\\leather_clothes_%(skin)s.png"),
					"SET_BULLET_PROOF_CLOTHES": ("body_bullet_proof_clothes", "body_bullet_proof_clothes", baseres+"high\\male\\bullet_proof_clothes\\bullet_proof_clothes.png"),
					"SET_PLATE_ARMOR": ("body_plate_armor", "body_plate_armor", baseres+"high\\male\\plate_armor\\plate_armor_%(skin)s.png"),
					"SET_CHAIN_MAIL": ("body_chain_mail", "body_chain_mail", baseres+"high\\male\\chain_mail\\chain_mail_%(skin)s.png"),
					"SET_DT21_LIGHT_ARMOR": ("body_dt21_light_armor", "body_dt21_light_armor", baseres+"high\\male\\dt21_light_armor\\dt21_light_armor.png"),
					 "SET_INTRO_CLOTHES": ("body_intro_clothes", "body_intro_clothes",  baseres+"high\\male\\intro_clothes\\intro_jacket_%(skin)s.png"),
 					 "SET_M46_HEAVY_ARMOR": ("body_m46_heavy_armor", "body_m46_heavy_armor", baseres+"high\\male\\m46_heavy_armor\\m46_heavy_armor.png"),
					}
				valid_faces = \
					{"hero1": 		baseres+"high\\faces\\male_face_hero1.png",
					 "hero2": 		baseres+"high\\faces\\male_face_hero2.png",
					 "hero3": 		baseres+"high\\faces\\male_face_hero3.png",
					 "hero4": 		baseres+"high\\faces\\male_face_hero4.png",
					 "hero5": 		baseres+"high\\faces\\male_face_hero5.png",
					 "hero6": 		baseres+"high\\faces\\male_face_hero6.png",
					 "hero7": 		baseres+"high\\faces\\male_face_hero7.png",
					 "hero8": 		baseres+"high\\faces\\male_face_hero8.png",
					 "ed": 			baseres+"high\\faces\\male_face_ed.png",
					 "brian": 		baseres+"high\\faces\\male_face_brian.png",
					 "ernest": 		baseres+"high\\faces\\male_face_ernest.png",
					 "jack": 		baseres+"high\\faces\\male_face_jack.png",
					 "jordan": 		baseres+"high\\faces\\male_face_jordan.png",
					 "milton": 		baseres+"high\\faces\\male_face_milton.png",
					 "phil": 		baseres+"high\\faces\\male_face_phil.png",
					 "sevensouls": 	baseres+"high\\faces\\male_face_sevensouls.png",
					}

			elif gender=="female":
				ap_basedir = "objects\\characters\\anims\\female\\"
				#ap_model = "objects\\characters\\female\\female.gr2"
				ap_model = "objects\\characters\\female\\female_high.gr2"

				valid_clothes = \
					{"naked": ("body_naked", "body_naked", baseres+"high\\female\\naked\\naked_%(skin)s.png"),
					 "SET_NORMAL_CLOTHES_1":("body_normal_clothes_1","body_normal_clothes_1", baseres+"high\\female\\normal_clothes_1\\normal_clothes_1_%(skin)s.png"),
					 "SET_NORMAL_CLOTHES_2":("body_normal_clothes_2","body_normal_clothes_2", baseres+"high\\female\\normal_clothes_2\\normal_clothes_2_%(skin)s.png"),
					 "SET_NORMAL_CLOTHES_3":("body_normal_clothes_3","body_normal_clothes_3", baseres+"high\\female\\normal_clothes_3\\normal_clothes_3_%(skin)s.png"),
					 "SET_NORMAL_CLOTHES_4":("body_normal_clothes_4","body_normal_clothes_4", baseres+"high\\female\\normal_clothes_4\\normal_clothes_4_%(skin)s.png"),
					 "SET_NORMAL_CLOTHES_5":("body_normal_clothes_5","body_normal_clothes_5", baseres+"high\\female\\normal_clothes_5\\normal_clothes_5_%(skin)s.png"),
					 "SET_NORMAL_CLOTHES_6":("body_normal_clothes_6","body_normal_clothes_6", baseres+"high\\female\\normal_clothes_6\\normal_clothes_6_%(skin)s.png"),
					 "SET_OVERALL":("body_normal_clothes_6","body_normal_clothes_6", baseres+"high\\female\\normal_clothes_6\\overall_%(skin)s.png"),
					 "SET_BULLET_CATCH": ("body_bullet_catch", "body_bullet_catch", baseres+"high\\female\\bullet_catch\\bullet_catch_%(skin)s.png"),
					 "SET_LEATHER_CLOTHES": ("body_leather_clothes", "body_leather_clothes", baseres+"high\\female\\leather_clothes\\leather_clothes_%(skin)s.png"),
					 "SET_BULLET_PROOF_CLOTHES": ("body_bullet_proof_clothes", "body_bullet_proof_clothes", baseres+"high\\female\\bullet_proof_clothes\\bullet_proof_clothes.png"),
					 "SET_PLATE_ARMOR": ("body_plate_armor", "body_plate_armor", baseres+"high\\female\\plate_armor\\plate_armor_%(skin)s.png"),
					 "SET_CHAIN_MAIL": ("body_chain_mail", "body_chain_mail", baseres+"high\\female\\chain_mail\\chain_mail_%(skin)s.png"),
					 "SET_DT21_LIGHT_ARMOR": ("body_dt21_light_armor", "body_dt21_light_armor", baseres+"high\\female\\dt21_light_armor\\dt21_light_armor.png"),
					 "SET_INTRO_CLOTHES": ("body_intro_clothes", "body_intro_clothes",  baseres+"high\\female\\intro_clothes\\intro_jacket_%(skin)s.png"),
 					 "SET_M46_HEAVY_ARMOR": ("body_m46_heavy_armor", "body_m46_heavy_armor", baseres+"high\\female\\m46_heavy_armor\\m46_heavy_armor.png"),
  					 #"SET_M46_HEAVY_ARMOR": ("body_intro_clothes", "body_intro_clothes", baseres+"high\\male\\intro_clothes\\intro_jacket_%(skin)s.png")
					}
				valid_faces = \
					{"heroine1": 	baseres+"high\\faces\\female_face_heroine1.png",
					 "heroine2": 	baseres+"high\\faces\\female_face_heroine2.png",
					 "heroine3": 	baseres+"high\\faces\\female_face_heroine3.png",
					 "heroine4": 	baseres+"high\\faces\\female_face_heroine4.png",
					 "heroine5": 	baseres+"high\\faces\\female_face_heroine5.png",
					 "heroine6": 	baseres+"high\\faces\\female_face_heroine6.png",
					 "heroine7": 	baseres+"high\\faces\\female_face_heroine7.png",
					 "heroine8": 	baseres+"high\\faces\\female_face_heroine8.png",
					 "amber": 		baseres+"high\\faces\\female_face_amber.png",
					 "ira": 		baseres+"high\\faces\\female_face_ira.png",
					 "kate": 		baseres+"high\\faces\\female_face_kate.png",
					 "luise": 		baseres+"high\\faces\\female_face_luise.png",
					 "pat": 		baseres+"high\\faces\\female_face_pat.png",
					 "sand": 		baseres+"high\\faces\\female_face_sand.png",
					 "storm": 		baseres+"high\\faces\\female_face_storm.png",
					}
			else:
				raise ValueError, "gender female|male"

		elif model=="child":
			ap_basedir = "objects\\characters\\anims\\child\\"
			if gender=="male":
				ap_model = "objects\\characters\\male\\boy.gr2"

				valid_clothes = \
					{"ll_001": 		("boy", "body", baseres+"child\\male\\ll\\child_body_ll_001_%(skin)s.png"),
					 "childgang_01": 	("boy", "body", baseres+"child\\male\\ll\\child_body_ll_childgang_01_%(skin)s.png"),
					 "childgang_02": 	("boy", "body", baseres+"child\\male\\ll\\child_body_ll_childgang_02_%(skin)s.png"),
					 "childgang_03": 	("boy", "body", baseres+"child\\male\\ll\\child_body_ll_childgang_03_%(skin)s.png"),
					 "indian_01": 		("boy", "body", baseres+"child\\male\\ll\\child_body_ll_indian_01_%(skin)s.png"),
					 "indian_02": 		("boy", "body", baseres+"child\\male\\ll\\child_body_ll_indian_02_%(skin)s.png"),
					 "nomad_01": 		("boy", "body", baseres+"child\\male\\ll\\child_body_ll_nomad_01_%(skin)s.png"),
					}
				valid_faces = \
					{	"001": 	baseres+"child\\faces\\male_face_01.png",
						"002": 	baseres+"child\\faces\\male_face_02.png",
						"003": 	baseres+"child\\faces\\male_face_03.png",
						"childgang_01": 	baseres+"child\\faces\\male_face_childgang_01.png",
						"childgang_02": 	baseres+"child\\faces\\male_face_childgang_02.png",
						"childgang_03": 	baseres+"child\\faces\\male_face_childgang_03.png",
						"childgang_04": 	baseres+"child\\faces\\male_face_childgang_04.png",
						"indian_01": 	baseres+"child\\faces\\male_face_indian_01.png",
						"indian_02": 	baseres+"child\\faces\\male_face_indian_02.png",
						"indian_03": 	baseres+"child\\faces\\male_face_indian_03.png",
						"nomad_01": 	baseres+"child\\faces\\male_face_nomad_01.png",
					}
			elif gender=="female":
				ap_model = "objects\\characters\\female\\girl.gr2"

				valid_clothes = \
					{"ll_001": 			("girl", "body", baseres+"child\\female\\ll\\child_body_ll_001_%(skin)s.png"),
					 "childgang_01": 	("girl", "body", baseres+"child\\female\\ll\\child_body_ll_childgang_01_%(skin)s.png"),
					 "childgang_02": 	("girl", "body", baseres+"child\\female\\ll\\child_body_ll_childgang_02_%(skin)s.png"),
					 "childgang_03": 	("girl", "body", baseres+"child\\female\\ll\\child_body_ll_childgang_03_%(skin)s.png"),
					 "childgang_04": 	("girl", "body", baseres+"child\\female\\ll\\child_body_ll_childgang_04_%(skin)s.png"),
					 "indian_01": 		("girl", "body", baseres+"child\\female\\ll\\child_body_ll_indian_01_%(skin)s.png"),
					}

				valid_faces = \
					{	"001": 	baseres+"child\\faces\\female_face_01.png",
						"002": 	baseres+"child\\faces\\female_face_02.png",
						"003": 	baseres+"child\\faces\\female_face_03.png",
						"004": 	baseres+"child\\faces\\female_face_04.png",
						"childgang_01": 	baseres+"child\\faces\\female_face_childgang_01.png",
						"childgang_02": 	baseres+"child\\faces\\female_face_childgang_02.png",
						"childgang_03": 	baseres+"child\\faces\\female_face_childgang_03.png",
						"childgang_04": 	baseres+"child\\faces\\female_face_childgang_04.png",
						"indian_01": 	baseres+"child\\faces\\female_face_indian_01.png",
						#dialog faces
						"mia_pia": 	baseres+"low\\dialog_faces\\female_low_mia_pia.png",
						"alexa":	baseres+"low\\dialog_faces\\female_low_alexa.png",
					}

			else:
				raise ValueError, "gender female|male"

		else:
			raise ValueError, "model low|high|child"

		if not (clothes in valid_clothes.keys()):
			exc = None
			for valid in valid_clothes.keys():
				if exc:
					exc = exc + "|" + valid
				else:
					exc = valid
			raise ValueError, "clothes " + exc

		if not skin in ["black","white","red","grey"]:
			raise ValueError, "skin black|white|red|grey"

		ap_mesh = valid_clothes[clothes][0]
		ap_meshmaterial = valid_clothes[clothes][1]
		ap_meshtexture = valid_clothes[clothes][2] % {"skin":skin}

		if not (face in valid_faces.keys()):
			exc = None
			for valid in valid_faces.keys():
				if exc:
					exc = exc + "|" + valid
				else:
					exc = valid
			raise ValueError, "face " + exc
		ap_facetexture = valid_faces[face]

		if model=="high":
			valid_hands = ["naked","SET_LEATHER_GLOVES","SET_DT21_GAUNTLETS","SET_M46_GAUNTLETS","SET_PLATE_GLOVES","SET_PROTECTIVE_GLOVES"]
			gloves = {
				"naked":"naked",
				"SET_LEATHER_GLOVES":"leather_gloves",
				"SET_DT21_GAUNTLETS":"dt21_gauntlets",
				"SET_M46_GAUNTLETS":"m46_gauntlets",
				"SET_PLATE_GLOVES":"plate_gloves",
				"SET_PROTECTIVE_GLOVES":"protective_gloves" }
			if not (clothes_gloves in valid_hands):
				exc = None
				for valid in valid_hands:
					if exc:
						exc = exc + "|" + valid
					else:
						exc = valid
				raise ValueError, "clothes_gloves " + exc
			clothes_gloves = gloves[clothes_gloves]
			if clothes_gloves == "naked":
				clothes_gloves = clothes_gloves + "_" + skin
			ap_handtexture = baseres+"high\\hands\\hand_" + clothes_gloves + ".png"

			valid_boots = ["naked","SET_LEATHER_BOOTS","SET_DT21_STEEL_CLAD_BOOTS","SET_LOW_SHOES","SET_STEEL_CLAD_BOOTS","SET_M46_STEEL_CLAD_BOOTS"]
			boots = {
				"naked":"naked",
				"SET_LOW_SHOES":"low_shoes",
				"SET_LEATHER_BOOTS":"leather_boots",
				"SET_STEEL_CLAD_BOOTS":"steel_clad_boots",
				"SET_DT21_STEEL_CLAD_BOOTS":"dt21_steel_clad_boots",
				"SET_M46_STEEL_CLAD_BOOTS":"m46_steel_clad_boots" }
			if not (clothes_boots in valid_boots):
				exc = None
				for valid in valid_boots:
					if exc:
						exc = exc + "|" + valid
					else:
						exc = valid
				raise ValueError, "clothes_boots " + exc
			clothes_boots = boots[clothes_boots]
			if clothes_boots == "naked" or clothes_boots == "low_shoes":
				clothes_boots = clothes_boots + "_" + skin
			ap_foottexture = baseres+"high\\feet\\foot_" + clothes_boots + ".png"

			valid_helmet = \
					{"SET_LEATHER_CAP": ("helmet_leather_cap", "leather_cap", baseres+"high\\accessoires\\helmet_leather_cap.png"),
					 "SET_DT21_STEEL_CLAD_HELMET": ("helmet_dt21_steel_clad_helmet", "dt21_steel_clad_helmet", baseres+"high\\accessoires\\helmet_dt21_steel_clad_helmet.png"),
					 "SET_KEVLAR_HELMET": ("helmet_kevlar_helmet", "kevlar_helmet", baseres+"high\\accessoires\\helmet_kevlar_helmet.png"),
					 "SET_M46_ARMORED_HELMET": ("helmet_m46_armored_helmet", "m46_armored_helmet", baseres+"high\\accessoires\\helmet_m46_armored_helmet.png"),
					 "SET_NANO_BOT_SURGICAL_DEVICE_EQUIPED": ("helmet_nano_bot_surgicat_device", "nano_bot_surgical_device", baseres+"high\\accessoires\\helmet_nano_bot_surgicat_device.png"),
					 #"SET_NANO_BOT_SURGICAL_DEVICE_EQUIPED": ("helmet_ordinary_helmet", "ordinary_helmet", baseres+"high\\accessoires\\helmet_ordinary_helmet.png"),
					 "SET_ORDINARY_HELMET": ("helmet_ordinary_helmet", "ordinary_helmet", baseres+"high\\accessoires\\helmet_ordinary_helmet.png"),
					 "SET_STEEL_HELMET": ("helmet_steel_helmet", "steel_helmet", baseres+"high\\accessoires\\helmet_steel_helmet.png"),
					}

			if not (helmet in valid_helmet.keys()):
				if not helmet:
					ap_helmet_mesh = None
					ap_helmet_material = None
					ap_helmet_texture = None
				else:
					exc = None
					for valid in valid_helmet.keys():
						if exc:
							exc = exc + "|" + valid
						else:
							exc = valid
					raise ValueError, "helmet None|" + exc

			else:
				ap_helmet_mesh = valid_helmet[helmet][0]
				ap_helmet_material = valid_helmet[helmet][1]
				ap_helmet_texture = valid_helmet[helmet][2]

			ap_hair_mesh = None
			ap_hair_material = None
			ap_hair_texture = None
			if not helmet in ["SET_DT21_STEEL_CLAD_HELMET", "SET_M46_ARMORED_HELMET"]:
				if gender == "female":
					valid_hair = \
							{"heroine1": ("hair_heroine1", "hair_heroine1", baseres+"high\\hair\\female_hair_heroine1.png"),
							 "heroine2": ("hair_heroine2", "hair_heroine2", baseres+"high\\hair\\female_hair_heroine2.png"),
							 "heroine3": ("hair_heroine3", "hair_heroine3", baseres+"high\\hair\\female_hair_heroine3.png"),
							 "heroine4": ("hair_heroine4", "hair_heroine4", baseres+"high\\hair\\female_hair_heroine4.png"),
							 "heroine5": ("hair_heroine5", "hair_heroine5", baseres+"high\\hair\\female_hair_heroine5.png"),
							 "heroine6": ("hair_heroine6", "hair_heroine6", baseres+"high\\hair\\female_hair_heroine6.png"),
							 "heroine7": ("hair_heroine7", "hair_heroine7", baseres+"high\\hair\\female_hair_heroine7.png"),
							 "heroine8": ("hair_heroine8", "hair_heroine8", baseres+"high\\hair\\female_hair_heroine8.png"),
							 "ira": ("hair_ira", "hair_ira", baseres+"high\\hair\\female_hair_ira.png"),
							 "amber": ("hair_amber", "hair_amber_luise", baseres+"high\\hair\\female_hair_luise.png"),
							 "luise": ("hair_luise", "hair_amber_luise", baseres+"high\\hair\\female_hair_luise.png"),
							 "sand": ("hair_sand", "hair_sand", baseres+"high\\hair\\female_hair_sand.png"),
							 "storm": ("hair_storm", "hair_storm", baseres+"high\\hair\\female_hair_storm.png"),
							 "kate": ("hair_kate", "hair_kate", baseres+"high\\hair\\female_hair_kate.png"),
							}
				else:
					valid_hair = \
							{"hero1": ("hair_hero1", "hair_hero1", baseres+"high\\hair\\male_hair_hero1.png"),
							 "hero2": ("hair_hero2", "hair_hero2", baseres+"high\\hair\\male_hair_hero2.png"),
							 "hero3": ("hair_hero3", "hair_hero3", baseres+"high\\hair\\male_hair_hero3.png"),
							 "hero4": ("hair_hero4", "hair_hero4", baseres+"high\\hair\\male_hair_hero4.png"),
							 "hero5": ("hair_hero5", "hair_hero5", baseres+"high\\hair\\male_hair_hero5.png"),
							 "hero6": ("hair_hero6", "hair_hero6", baseres+"high\\hair\\male_hair_hero6.png"),
							 "hero7": ("hair_hero7", "hair_hero7", baseres+"high\\hair\\male_hair_hero7.png"),
							 "hero8": ("hair_hero8", "hair_hero8", baseres+"high\\hair\\male_hair_hero8.png"),
							 "sevensouls": ("hair_sevensouls", "hair_sevensouls", baseres+"high\\hair\\male_hair_sevensouls.png"),
							 "milton": ("hair_milton", "hair_milton", baseres+"high\\hair\\male_hair_milton.png"),
							 "jordan": ("hair_jordan", "hair_jordan", baseres+"high\\hair\\male_hair_jordan.png"),
							 "jack": ("hair_jack", "hair_jack", baseres+"high\\hair\\male_hair_jack.png"),
							 "ernest": ("hair_ernest", "hair_ernest", baseres+"high\\hair\\male_hair_ernest.png"),
							 "ed": ("hair_ed", "hair_ed", baseres+"high\\hair\\male_hair_ed.png"),
							}

				if not (hair in valid_hair):
					if not hair:
						ap_hair_mesh = None
						ap_hair_material = None
						ap_hair_texture = None
					else:
						exc = None
						for valid in valid_hair:
							if exc:
								exc = exc + "|" + valid
							else:
								exc = valid
						raise ValueError, "hair None|" + exc

				else:
					ap_hair_mesh = valid_hair[hair][0]
					ap_hair_material = valid_hair[hair][1]
					ap_hair_texture = valid_hair[hair][2]

		character.set_animation_base_directory( object_id, ap_basedir )
		character.set_model( object_id, ap_model )
		character.set_mesh_visible( object_id, ap_mesh, True )
		character.set_texture( object_id, ap_meshmaterial, ap_meshtexture )

		character.set_texture( object_id, "head", ap_facetexture )
		if model=="high":
			character.set_texture( object_id, "hand", ap_handtexture )
			character.set_texture( object_id, "foot", ap_foottexture )

			if ap_helmet_mesh:
				character.set_mesh_visible( object_id, ap_helmet_mesh, True )
				character.set_texture( object_id, ap_helmet_material, ap_helmet_texture )

			if ap_hair_mesh:
				character.set_mesh_visible( object_id, ap_hair_mesh, True )
				character.set_texture( object_id, ap_hair_material, ap_hair_texture )

	except ValueError, e:
		raise ValueError, "attribute has invalid value\n'" \
			+ str(e) + "'\n" \
			+ "id='" + object_id + "'\n" \
			+ "model='" + str(model) + "' " \
			+ "gender='" + str(gender) + "' " \
			+ "skin='" + str(skin) + "' " \
			+ "clothes='" + str(clothes) + "' " \
			+ "clothes_boots='" + str(clothes_boots) + "' " \
			+ "clothes_gloves='" + str(clothes_gloves) + "' " \
			+ "face='" + str(face) + "'" \
			+ "helmet='" + str(helmet) + "'" \
			+ "hair='" + str(hair) + "'"

	return

def add_experience( char, experience ):
	"add experience to a character"

	object.set_attribute( char, "experience", \
		object.get_attribute( char, "experience" ) + experience )

def add_experience_party( experience ):
	"""add experience to all player characters
	
The exp is distributed between the chars.
"""
	import system
	pcs = system.get_pcs()
	count_mercenaries = len(pcs)-1 
	experience_alter_ego = experience
	experience_mercenary = None
	experience_mercenaries = None
	experience_mercenaries_rest = None
	#only mc		mc = 100%
	#mc + 1 pc		mc = 70%, pc = 30%
	#mc + 2 pcs		mc = 60%, pcs = 40%
	#mc + 3 pcs		mc = 50%, pcs = 50%
	#mc + 4 pcs		mc = 40%, pcs = 60%
	#mc + 5 pcs		mc = 30%, pcs = 70%
	
	if count_mercenaries>0:
		#assign constanst values directly to avoid precision problem
		f = 0.7
		if count_mercenaries==2: f = 0.6
		elif count_mercenaries==3: f = 0.5
		elif count_mercenaries==4: f = 0.4
		elif count_mercenaries==5: f = 0.3
		experience_alter_ego = int(experience * f)
		experience_mercenaries_rest = experience_mercenaries = experience-experience_alter_ego
		experience_mercenary = int((experience_mercenaries)/(len(pcs)-1))

	for pc in pcs:
		exp = 0
		if pc=="ALTER_EGO":
			exp = experience_alter_ego
		else:
			exp = experience_mercenary
			experience_mercenaries_rest-=experience_mercenary

		object.set_attribute( pc, "experience", \
			object.get_attribute( pc, "experience" ) + exp )

	pcs.remove("ALTER_EGO")
	while experience_mercenaries_rest > 0:
		import random
		lucky_one = random.choice(pcs)
		object.set_attribute( lucky_one, "experience", \
			object.get_attribute( lucky_one, "experience" ) + 1 )
		experience_mercenaries_rest-=1

	import globaltext
	name = None
	if (object.has_attribute("ALTER_EGO","passport") and 
		object.has_attribute("ALTER_EGO","name")):
		name = object.get_attribute("ALTER_EGO","name")

	if (name!=None and experience_mercenaries!=None):
		text = globaltext.MESSAGE_EXPERIENCE_POINTS % {"experience":experience}
		system.add_text(text)

	if name!=None:
		text = globaltext.MESSAGE_EXPERIENCE_POINTS_ALTER_EGO % {"name_alter_ego":name,"experience_alter_ego":experience_alter_ego}
		system.add_text(text)

		if experience_mercenaries!=None:
			text = globaltext.MESSAGE_EXPERIENCE_POINTS_PARTY % {"experience_party":experience_mercenaries}
			system.add_text(text)

def is_equiped(char,  equipment):
	"""return True if the char has the item equiped
	
equipment can be the id of a specific item or an item type like "SET_UZI"
"""
	inventory = None
	if equipment in map(lambda x: x[0][0], filter(lambda x: len(x[0]), object.get_inventory_ids(char))):
		inventory = object.get_inventory_ids(char)
	else:
		inventory = object.get_inventory(char)
	slotindex = 0
	for slot in inventory:
		if len(slot[0]) and slot[1]: # slot not empty and equiped
			if slot[0][0] == equipment:
					return True
		slotindex = slotindex + 1		
	return False
		
def equip(char,  equipment, direct_ammo_load = False):
	"""the character equips the item
	
equipment can be the id of a specific item or an item type like "SET_UZI".
if direct_ammo_load is True and the item is a weapon the weapon will be loaded
with ammo immediately. no reload animation will be played.
ValueError is thrown, if the char hasn't the item or if the item is already
equiped. 
"""
	inventory = None
	equipment_id = None
	if equipment in map(lambda x: x[0][0], filter(lambda x: len(x[0]), object.get_inventory_ids(char))):
		inventory = object.get_inventory_ids(char)
		equipment_id = equipment 
	else:
		inventory = object.get_inventory(char)
	slotindex = 0
	for slot in inventory:
		if len(slot[0]) and not slot[1]: # slot not empty and not equiped
			if slot[0][0] == equipment:
				if	direct_ammo_load\
				and object.has_attribute(equipment, "item_type")\
				and object.get_attribute(equipment, "item_type") == "weapon"\
				and object.has_attribute(equipment, "munitionsarten"):
					ammo_types = object.get_attribute(equipment, "munitionsarten") # munitions possible
					ammo_count = object.get_attribute(equipment, "magazingroesse") # nb balles chargeur (arme)
					if len(ammo_types):
						ammo_type = ammo_types[0]
						if not equipment_id: equipment_id = object.get_inventory_ids(char)[slotindex][0][0] 
						object.set_attribute(equipment_id, "act_ammo_type", ammo_type)
						object.set_attribute(equipment_id, "act_ammo_count", ammo_count)
				character.equip_slot(char, slotindex)
				return
		slotindex = slotindex + 1
	if equipment in map(lambda x: x[0][0], filter(lambda x: len(x[0]), inventory)):
		raise ValueError, "'" + equipment + "' found in inventory, but is already equiped."
	else:
		raise ValueError, "'" + str(equipment) + "' not found in inventory."

def unequip(char,  equipment):
	"""the character unequips the item
	
equipment can be the id of a specific item or an item type like "SET_UZI".
ValueError is thrown, if the char hasn't the item or if the item is not equiped. 
"""
	inventory = None
	if equipment in map(lambda x: x[0][0], filter(lambda x: len(x[0]), object.get_inventory_ids(char))):
		inventory = object.get_inventory_ids(char)
	else:
		inventory = object.get_inventory(char)
	slotindex = 0
	for slot in inventory:
		if len(slot[0]) and slot[1]: # slot not empty and equiped
			if slot[0][0] == equipment:
				character.un_equip_slot(char, slotindex)
				return
		slotindex = slotindex + 1
	if equipment in map(lambda x: x[0][0], filter(lambda x: len(x[0]), inventory)):
		raise ValueError, "'" + equipment + "' found in inventory, but isn't equiped."
	else:
		raise ValueError, "'" + equipment + "' not found in inventory."

def equip_direct(char,  equipment, creation = False, direct_ammo_load = False):
	"""the character equips/links the item without playing an animation
	
equipment can be the id of a specific item or an item type like "SET_UZI".
if creation is True and the equipment is an item type then the item will be
created in the characters inventory.
if the item is created and the item is a weapon then an ammo pack for the
weapon will also be created.
if direct_ammo_load is True and the item is a weapon the weapon will be loaded
with ammo immediately. no reload animation will be played.
ValueError is thrown, if the char hasn't the item (and creation is False) or
if the item is already equiped. 
"""
	if creation:
		if object.count_in_inventory(char, equipment)==0:
			object.create_item_in_inventory(object=char,equipment=equipment)
			if not direct_ammo_load and object.has_attribute(equipment, "item_type"):
				if object.get_attribute(equipment, "item_type")=="weapon":
					object.create_item_in_inventory(char, object.get_attribute(equipment, "munitionsarten")[0])

	object.set_attribute(char, "direct_equip", True)
	equip(char,  equipment, direct_ammo_load)
	object.set_attribute(char, "direct_equip", False)

def unequip_direct(char,  equipment):
	"""the character unequips/unlinks the item without playing an animation
	
equipment can be the id of a specific item or an item type like "SET_UZI".
ValueError is thrown, if the char hasn't the item or if the item is not equiped. 
"""
	object.set_attribute(char, "direct_equip", True)
	unequip(char,  equipment)
	object.set_attribute(char, "direct_equip", False)


def scale(object_id, height="empty", height_max="empty"):
	"""function scales character to a metrical height

object_id is id of character
height (metrical) can be height value to be set or list/tuple of 
min value and max value for random height
height_max (metrical) must be set if random value is desired 
and height is min value"""
	scale_norm_male = 1.8
	scale_norm_female = 1.7
	scale = 1.0
	import random
	
	if object.has_attribute(object_id,"gender"):
		gender = object.get_attribute(object_id,"gender")
		scale_norm = scale_norm_female
		if gender == "male":
			scale_norm = scale_norm_male
		
		scale_desired = 0.0
		## min max values defined
		try:
			if (height != "empty"):
				if (isinstance(height,list) or isinstance(height,tuple)):
					if len(height) == 2:
						if height[1] > height[0]:
							scale_desired = height[0] + (random.random() * (height[1]-height[0]))
						else:
							raise ValueError, "height_max less or equal height\n\tmust be height_max > height"
					else:
						raise ValueError, "illegal height given\n\tmust be [min,max]"
				else:
					if (height_max != "empty"):
						if height_max > height:
							scale_desired = height + (random.random() * (height_max-height))
						else:
							raise ValueError, "height_max less or equal height\n\tmust be height_max > height"
					else:
						scale_desired = height
			else:
				raise ValueError, "no height given\n\tusage: object.scale(object_id, height)"
			if scale_desired < 0:
				raise ValueError, "height must be greater 0"
			scale = (1.0/scale_norm) * scale_desired

		except ValueError, e:
			print "***\n\error while scaling char occured:\n",str(e),"\n***"
			return
		object.set_scale(object_id,scale)
	else:
		return

	
def get_load(char):
	"""returns the current load of the char

the weight of all items carried by this char is added and returned.

parameters:
    char - (string) id of the char
output:
    (float) totaled weight of all items"""
	list = object.get_inventory_id_list(char)
	weight_sum = 0
	for item in list:
		weight = object.get_attribute(item, "weight")

		import globals
		if globals.has_talent(char, "heavy_weapons", "shoulder"):
			if object.has_attribute(item, "item_type"):
				if object.get_attribute(item, "item_type")=="weapon":
					if object.get_attribute(item, "weapon_type")=="schwer":
						weight /= 2.0;
		
		weight_sum += weight

	return weight_sum

def arm_direct(char_id):
	"""makes a character equip a weapon direct after having a 
scheduled work with some item equiped (like: cook, hunt, clean weapon...)
function makes char the first weapon found in inventory
"""
	if not object.is_destroyed(char_id) and not object.is_unconscious(char_id):
		items = get_items_in_hands(char_id)
		has_weapon_equiped = False
		if len(items):
			for item in items:
				if item != None:
					if object.has_attribute(item, "weapon_type"):
						has_weapon_equiped = True
		
		if not has_weapon_equiped:
			unequip_hands(char_id)
			inventory = object.get_inventory_ids(char_id)
			if len(inventory):
				for item in inventory:
					if len(item[0]):
						item_id = item[0][0]
						if object.has_attribute(item_id, "weapon_type"):
							has_weapon_equiped = True
							equip_direct(char_id, item_id)
							break
		
		#if has_weapon_equiped == None:
		#	# todo: fehlerhafte waffen, zb he grenade: raise Exception, "character "+char_id+" has no weapon in inventory to be equiped"
		#	object.create_item_in_inventory(char_id, ["SET_MP5", "SET_AMMOPACK_9_MM"])
		#	equip_direct(char_id, "SET_MP5")

def get_items_in_hands(char_id):
	""" returns a list of items that are in left and right hand of char """
	items = [None,None]
	if not object.is_destroyed(char_id):
		if object.has_attribute(char_id, "slots"):
			slots = object.get_attribute(char_id, "slots")
			if "left_hand" in slots:
				if slots["left_hand"] != None:
					items.append(slots["left_hand"])
			if "right_hand" in slots:
				if slots["right_hand"] != None:
					items.append(slots["right_hand"])
	return items

def unequip_hands(char_id, direct_unequip=True):
	"""makes char unequip all equiped items and weapons"""
	if not object.is_destroyed(char_id):
		items = get_items_in_hands(char_id)
		if len(items):
			for item in items:
				if item != None:
					if is_equiped(char_id, item):
						if direct_unequip:
							unequip_direct(char_id, item)
						else:
							unequip(char_id, item)

import sys
# add methods to character module
sys.modules["character"].update_appearance = update_appearance
sys.modules["character"].add_experience = add_experience
sys.modules["character"].add_experience_party = add_experience_party
sys.modules["character"].equip = equip
sys.modules["character"].un_equip = unequip
sys.modules["character"].equip_direct = equip_direct
sys.modules["character"].un_equip_direct = unequip_direct
sys.modules["character"].is_equiped = is_equiped
sys.modules["character"].scale = scale
sys.modules["character"].get_load = get_load
sys.modules["character"].arm_direct = arm_direct
sys.modules["character"].unequip_hands = unequip_hands
