# -*- coding: utf-8 -*-
from globals import *

def copy_item_attributes(source_item, target_item):
    attributes=object.get_attributes(object=source_item)
    source_item_type=object.get_attribute(object=source_item, attribute="typeid")
    type_attributes=object.get_attributes(object=source_item_type)
    not_copy_list=["id","type","3d_id","typeid","grid"]
    # copy attributes
    for act_attribute in attributes:
        if (act_attribute not in not_copy_list and
           act_attribute not in type_attributes):
               print "copy attribute: "+act_attribute
               object.set_attribute(object=target_item,
                attribute=act_attribute,
                value=object.get_attribute(object=source_item, attribute=act_attribute))

def disassemble_over_and_under_gun(character_id, item):
    #todo: auseinandergebaute waffe wieder equipen
    if object.has_attribute(item, "item_combination"):
        if character.is_equiped(character_id, item):
            character.un_equip_direct(character_id, item)

        combination = object.get_attribute(item, "item_combination")
        all_combinations = combination["combination_list"]
        object.remove_item_from_inventory(character_id, item)
        combi = []
        max_len = 0
        for act_combination in all_combinations:
            if len(act_combination) > max_len:
                combi = act_combination[:]
        if combi!=None:
            for act_item in combi:
                object.create_item_in_inventory(object=character_id, equipment=act_item)
        return True
    return False

def disassemble_weapon_silencer_laserpointer(character_id, item):
    #todo: auseinandergebaute waffe wieder equipen
    if object.has_attribute(item, "item_combination"):
        if character.is_equiped(character_id, item):
            character.un_equip_direct(character_id, item)

        combination = object.get_attribute(item, "item_combination")
        all_combinations = combination["combination_list"]
        object.remove_item_from_inventory(character_id, item)
        combi = []
        max_len = 0
        for act_combination in all_combinations:
            if len(act_combination) > max_len:
                combi = act_combination[:]
        if combi!=None:
            for act_item in combi:
                object.create_item_in_inventory(object=character_id, equipment=act_item)
        return True
    return False

def assemble_over_and_under_gun(character_id, items, item):
    # remove all non weapons of the combination
    weapon=[]
    for act_item in items:
        remove=True
        if object.has_attribute(object=act_item, attribute="item_type"):
            if object.get_attribute(object=act_item, attribute="item_type")=="weapon":
                weapon.append(act_item)
                remove=False 
        if remove: 
            object.remove_item_from_inventory(character_id, act_item)

#    assert len(weapon)==1
    source_item=weapon[0]

    #create new item
    target_item=source_item+"_COMBINED"
    object.create_item_in_inventory(object=character_id, equipment=item, id=target_item)

    # unequip weapon if equiped
    was_equiped = False
    if character.is_equiped(character_id, source_item):
        character.un_equip_direct(character_id, source_item)
        was_equiped = True

    #copy item attributes
    copy_item_attributes(source_item, target_item)

    #remove old object
    for act_item in weapon:
            object.remove_item_from_inventory(character_id, act_item)

    # equip again if wepaon was equiped
    if was_equiped:
        character.equip_direct(character_id, target_item)

    return True
    
def assemble_weapon_silencer_laserpointer(character_id, items, item):
    # remove all non weapons of the combination
    weapon=[]
    for act_item in items:
        remove=True
        if object.has_attribute(object=act_item, attribute="item_type"):
            if object.get_attribute(object=act_item, attribute="item_type")=="weapon":
                weapon.append(act_item)
                remove=False 
        if remove: 
            object.remove_item_from_inventory(character_id, act_item)

    assert len(weapon)==1
    source_item=weapon[0]

    #create new item
    target_item=source_item+"_COMBINED"
    object.create_item_in_inventory(object=character_id, equipment=item, id=target_item)

    # unequip weapon if equiped
    was_equiped = False
    if character.is_equiped(character_id, source_item):
        character.un_equip_direct(character_id, source_item)
        was_equiped = True

    #copy item attributes
    copy_item_attributes(source_item, target_item)

    #remove old weapon
    object.remove_item_from_inventory(character_id, source_item)

    # equip again if wepaon was equiped
    if was_equiped:
        character.equip_direct(character_id, target_item)

    return True

def assemble_weapon_sawed_off(character_id, items, item):
    for act_item in items:
        if object.get_attribute(act_item, "typeid")!="SET_HACKSAW":
            object.remove_item_from_inventory(character_id, act_item)
    
    #copy_item_attributes
    #create new item
    object.create_item_in_inventory(object=character_id, equipment=item)
    gain_xp(character_id,item,1)
    return True

def assemble_dumdum_munition(character_id, items, item):
    for act_item in items:
        if object.get_attribute(act_item, "typeid")!="SET_RASP":
            object.remove_item_from_inventory(character_id, act_item)
    
    #copy_item_attributes
    #create new item
    object.create_item_in_inventory(object=character_id, equipment=item)
    gain_xp(character_id,item,0.05)
    return True

    
def assemble_parlor_game(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_GIANT_KNIFE" and
            object.get_attribute(act_item, "typeid")!="SET_KNIFE"):
            object.remove_item_from_inventory(character_id, act_item)
    
    #copy_item_attributes
    #create new item
    object.create_item_in_inventory(object=character_id, equipment=item)
    gain_xp(character_id,item,1)
    return True

def assemble_vamped_picklock_set(character_id, items, item):
    for act_item in items:
        if object.get_attribute(act_item, "typeid")!="SET_PLIERS":
            object.remove_item_from_inventory(character_id, act_item)
    
    #copy_item_attributes
    #create new item
    object.create_item_in_inventory(object=character_id, equipment=item)
    gain_xp(character_id,item,1)
    return True

def assemble_chain_mail(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_CRANK" and
            object.get_attribute(act_item, "typeid")!="SET_PLIERS"):
            object.remove_item_from_inventory(character_id, act_item)
    
    #copy_item_attributes
    #create new item
    object.create_item_in_inventory(object=character_id, equipment=item)
    gain_xp(character_id,item,1)
    return True

def assemble_plate_armor(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_SLEDGE_HAMMER"):
            object.remove_item_from_inventory(character_id, act_item)
    
    #copy_item_attributes
    #create new item
    object.create_item_in_inventory(object=character_id, equipment=item)
    gain_xp(character_id,item,1)
    return True

def assemble_alternative_medicine(character_id, items, item):
    if has_talent( character_id, "medicine", "alternative_medicine" ):
        for act_item in items:
            object.remove_item_from_inventory(character_id, act_item)
        object.create_item_in_inventory(object=character_id, equipment=item)
        gain_xp(character_id,item,1)
        return True
    return False

# Cration de corde longue  partir de fourrures et un couteau (cr par CS)
# Parameters:
#        id - Id of owner of items.
#        items        - List of id of items to combine.
#        item         - The item_type of new item.
def cree_longue_corde(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_KNIFE"):
            object.remove_item_from_inventory(character_id, act_item)
    object.create_item_in_inventory(character_id, [item]*8 )
    gain_xp(character_id,item,0.2)
    return True

# Cration de corde courte  partir de corde longue et un couteau (cr par CS)
def cree_courte_corde(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_KNIFE"):
            object.remove_item_from_inventory(character_id, act_item)
    #create 4 new item
    object.create_item_in_inventory(character_id, [item]*4 )
    gain_xp(character_id,item,0.05)
    return True

def cree_chiffon(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_KNIFE"):
            object.remove_item_from_inventory(character_id, act_item)
    #create 8 new item
    object.create_item_in_inventory(character_id, [item]*8 )
    gain_xp(character_id,item,0.2)
    return True

# decoupe la viande en morceau (cr par CS)
def couper_viande(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")=="SET_MEAT_COOKED_HUMONGOUS"):x=4
        else:x=2
#                object.create_item_in_inventory(object=character_id, equipment=item)
        if (object.get_attribute(act_item, "typeid")!="SET_KNIFE"):
            object.remove_item_from_inventory(character_id, act_item)
    #create 2 new item
    object.create_item_in_inventory(character_id, [item]*x )
    gain_xp(character_id,item,0.05*x)
    return True

# decoupe la viande en morceau (cr par CS)
def coupe_clous(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")=="SET_LONG_NAILS"):
            object.remove_item_from_inventory(character_id, act_item)
    #create item
    object.create_item_in_inventory(character_id, item)
    gain_xp(character_id,item,0.2)
    return True

# cre des outres vides (cr par CS)
def cree_outre(character_id, items, item):
    for act_item in items:
        if (object.get_attribute(act_item, "typeid")!="SET_KNIFE"):
            object.remove_item_from_inventory(character_id, act_item)
    #create item
    for i in range(2):
        object.create_item_in_inventory(character_id, item )
#        object.set_attribute(object=item, attribute="act_ammo_count", value= 0)
#        object.set_attribute(object=item, attribute="ammo_count", value= 0)
    gain_xp(character_id,item,0.2)
    return True

#
# le gain d'XP est la difficult de combinaison de l'objet multipli par un coefficient donn (coef) car pour certains objets cela augmenterait trop l'exprience
def gain_xp(character_id,item,coef):
    combination =  object.get_attribute(item, "item_combination")
    gain = int(combination["difficulty_assemble"] * coef)
    print id
    if gain > 0:
        xp=object.get_attribute(character_id, "experience")
        object.set_attribute(character_id, "experience", xp + gain)
