﻿# -*- coding: utf-8 -*-
#
#import sys
#import dialog
#import debug
#import animation
#import vehicle
#from timerepr import *
#import globaltext
#import skies
from globals import *
import system
import character
#import skill_tables
import object
import random
import math
import enemy_script
import daily_routine as dr
import system as sys

#
### liste fonctions ###
# arme_npc      degaine     arme_groupe     leplusproche    group_as_obj        group_has_1_of       del_party_inv       tranf_item_party        teleport_party
# teleport_party_gr     anyone_has_skill
#
# Attention, parfois la synthaxe :  if machin:x=1    n'a pas l'air de fonctionner le faire en 2 lignes
#
def arme_npc(perso,arme="SET_SPECIAL_38",equipe=0):
    """ crée une "arme" dans l'inventaire le pc/npc ("perso") avec les munitions correspondantes. Si "arme" n'est pas précisé => 38 spécial
    si equipe    = 0 => ne l'en équipe pas (défaut)
            = 1 => l'en équipe (arme à la main) s'il ne l'est déjà.
            = 2 => l'en équipe (arme à la main) s'il ne l'est déjà. Et les munitions crées sont les dernières de la liste (généralement les + perfomantes)
    """
    object.create_item_in_inventory(perso,arme)
    if object.has_attribute(arme, "munitionsarten"):
        if equipe == 2:
            munitions = object.get_attribute(arme, "munitionsarten") # munitions possible
            object.create_item_in_inventory(perso, [ munitions[len(munitions)-1] ]*3 )
        else:
            munitions = object.get_attribute(arme, "munitionsarten") # munitions possible
            object.create_item_in_inventory(perso, [ munitions[0] ]*3 )
    if not character.is_equiped(perso, arme) and (equipe == 2 or equipe == 1):
        character.equip(perso, arme)

def degaine(perso):
    """ équipe le personnage ("perso") d'une arme (dans l'ordre suivant : sniper, lourde=schwer, poing=leicht, lancer=wurf, cc=nahkampf, bomb=explosiv), s'il ne l'est pas.
    puis attaque l'ennemi le + proche
    """
    system.get_pcs()
    sniper=[];    lourde=[];    poing=[];    lancer=[];    cc=[];   bomb=[]
    inventory = object.get_inventory_id_list(perso)
    if len(inventory):
        for item in inventory:
            if object.has_attribute(item, "weapon_type"):
                if  object.get_attribute(item, "weapon_type")=="sniper":
                    sniper.append(item)
                elif  object.get_attribute(item, "weapon_type")=="schwer":
                    lourde.append(item)
                elif  object.get_attribute(item, "weapon_type")=="leicht":
                    poing.append(item)
                elif  object.get_attribute(item, "weapon_type")=="wurf":
                    lancer.append(item)
                elif  object.get_attribute(item, "weapon_type")=="nahkampf":
                    cc.append(item)
                elif  object.get_attribute(item, "weapon_type")=="explosiv":
                    bomb.append(item)
    if sniper:
        arme=sniper[0]
    elif lourde:
        arme=lourde[0]
    elif poing:
        arme=poing[0]
    elif lancer:
        arme=lancer[0]
    elif cc:
        arme=cc[0]
    elif bomb:
        arme=bomb[0]
    if arme:
        if object.has_attribute(arme, "munitionsarten"):
            ok=0
            for i in object.get_attribute(arme, "munitionsarten"):
                for item in inventory:
                    if object.get_attribute(item,"typeid")==i:
                        ok=1
            if not character.is_equiped(perso, arme):
                if ok:
                    character.equip(perso, arme)
                else:
                    character.equip(perso, arme, direct_ammo_load=True)
        else:
            if not character.is_equiped(perso, arme):
                character.equip(perso, arme)
        enemis = []
        for enemi in character.get_visible_enemies(perso):
            if not object.is_destroyed(enemi):
                enemis.append(enemi)
        if len(enemis):
            object.cancel_commandos(perso)
            object.attack(perso, leplusproche(perso,enemis) )

def arme_groupe(groupe,liste_arme):
    """ equipe (arme à la main) chacun des np/npc de "groupe" avec l'indice correspondant (ex : groupe[3] <= liste_arme[3]). Si liste_arme n'a pas d'arme => 38 spécial
    """
    for i in range( len(groupe) ):
        if i<len(liste_arme):
            arme_npc(groupe[i],liste_arme[i],2)
        else:
            arme_npc(groupe[i])

def leplusproche(perso,groupe):
    """ renvoie le + proche  de "perso" parmis les pc/npc de "groupe"
    """
    dist=10000
    proche=groupe[0]
    for npc in groupe:
        dist_tmp = object.get_distance(perso, npc)
        if dist_tmp < dist:
            dist=dist_tmp
            proche=npc
    return proche

def group_as_obj(obj,nb=1,radius=50,perso="ALTER_EGO",groupe=None):
    """ teste si le groupe à, au moins, "nb" objets ("obj"). Ne sont pas pris en compte les membre du groupe à plus de "radius" de "perso"
    renvoi le nombre d'objet ("obj") que possède le groupe, ou False si aucun
    par défaut : nb=1,radius=50,perso=joueur principal ,groupe=groupe joueur
    """
    nombre=0
    if groupe==None:groupe=system.get_pcs()
    if isinstance(obj, list) or isinstance(obj, tuple):
        retour = group_has_1_of(obj,radius,perso,groupe)
        return retour
    else:
        for pc in enemy_script.is_in_area(groupe, radius, perso):# ne prend pas en cpte ceux éloigné de plus de "radius" de "perso"
            if object.count_in_inventory(pc, obj) > 0:
                nombre+=object.count_in_inventory(pc, obj)
    if nombre>0:
        return nombre
    else:
        return False

def group_has_1_of(objs,radius=50,perso="ALTER_EGO",groupe=None):
    """ teste si le groupe à, au moins un objet de la liste ("objs"). Ne sont pas pris en compte les membre du groupe à plus de "radius" de "perso"
    renvoi le nombre d'objet que possède le groupe, ou False si aucun
    par défaut : nb=1,radius=50,perso=joueur principal ,groupe=groupe joueur
    objs doit être une liste càd ["dfv","dvf"]
    """
    nombre=0
    if not isinstance(objs, list) and not isinstance(objs, tuple):
        dbg(" Mauvaise utilisation de group_has_1_of")
        group_as_obj(objs,radius,perso,groupe)
    if groupe==None:
        groupe=system.get_pcs()
    print objs, groupe
    for pc in enemy_script.is_in_area(groupe, radius, perso):# ne prend pas en cpte ceux éloigné de plus de "radius" de "perso"
        for obj in objs:
            if object.count_in_inventory(pc, obj) > 0:
                nombre+=object.count_in_inventory(pc, obj)
    if nombre>0:
        return nombre
    else:
        return False

def del_party_inv(obj,nb=1):
    """ supprime de l'inventaire du groupe l'objet ("obj")  "nb" fois. S'il s'agit d'1 liste mettre dans celle-ci d'abord les objets à éliminer en 1er
    """
    if isinstance(obj, list) or isinstance(obj, tuple):
        k=0
        while nb > 0 and k < len(obj):
            nb=del_party_inv_1(obj[k],nb)
            k+=1
    else:
        del_party_inv_1(obj,nb)
        
def del_party_inv_1(obj,nb):
    """ fonction de del_party_inv
    """
    pcs_obj=who_as_obj(obj,nb)
    i=0
    while nb > 0 and i < len(pcs_obj):
        if nb <= pcs_obj[i][1]:
            max=range(nb)
        else:
            max=nb
        for j in max:
            object.remove_item_from_inventory(pcs_obj[0][0], obj)
            nb-=1
        i+=1
    return nb

def tranf_item_party(obj,beneficiary,nb=1):
    """ tranfère nb objets ("obj")  du groupe du joueur vers "beneficiary". Accepte les listes
    par défaut : nb=1
    """
    if isinstance(obj, list) or isinstance(obj, tuple):
        k=0
        while nb > 0 and k < len(obj):
            nb=tranf_item_party_1( obj[k],beneficiary,nb )
            k+=1
    else:
        tranf_item_party_1( obj,beneficiary,nb )

def tranf_item_party_1(obj,beneficiary,nb): # fonction de tranf_item_party
    pcs_obj=who_as_obj(obj,nb)
    i=0
    if pcs_obj:
        while nb > 0 and i < len(pcs_obj):
            if nb > pcs_obj[i][1]:
                max=pcs_obj[i][1]
            else:
                max=nb
            if max > 0:
                for j in range(max):
                    object.transfer_item(pcs_obj[i][0], obj, beneficiary)
                    nb-=1
            i+=1
    return nb

def teleport_party(x,y,chef=None):
    """ teleporte le goupe du joueur aux coordonnées (x,y). sauf le personnage principal si on a mis 1 (ou quelque chose de vrai)  à "chef".
    """
    groupe=system.get_pcs()
    for id in groupe:
        if not (chef and id=="ALTER_EGO"):
            object.cancel_commandos(id)
            object.set_position(id,x,y)
            if (groupe.index(id) % 2)==0:
                x+=1
            else:
                y+=1

def teleport_party_gr(x,y,gr):
    #  teleporte le goupe du joueur aux coordonnées (x,y). & un autre groupe de NPC, ceux-ci retournent, ensuite, à leurs occupations
    teleport_party(x,y)
    for id in gr:
        object.cancel_commandos(id)
        object.set_position(id,x,y)
        dr.allow_activity(id)
#        schedules.Activity(id)
        x-=1;y-=1

def anyone_has_skill(skill, value):
    """ vrai si 1 mercenaire du groupe joueur a-t-il au moins "value" en l'aptitude"skill"
    """
    for id in system.get_pcs():
        if object.has_attribute(id,skill):
            if object.get_attribute(id,skill) >= value:
                return id
    return False

def who_as_obj(obj,nb=1,groupe=None):
    """  retourne la liste des (pc/npc, nombre) du "groupe" ayant cet objet. Par défaut le groupe joueur est pris
    """
    objets=[]
    if groupe==None:
        groupe=system.get_pcs()
    for pc in groupe:
        if object.count_in_inventory(pc, obj) > 0:
            objets.append([pc,object.count_in_inventory(pc, obj)])
    if objets<>[]:
        return objets
    else:
        return False

def who_as_1_of(objs,groupe=None):
    """ retourne la liste des (pc/npc, nombre) du "groupe" ayant au moins 1 des objets de la liste "objs" . Par défaut le groupe joueur est pris
    """
    objets=[]
    if groupe==None:
        groupe=system.get_pcs()
    for pc in groupe:
        for obj in objs:
            if object.count_in_inventory(pc, obj) > 0:
                objets.append([pc, object.count_in_inventory(pc, obj), obj])
    if objets<>[]:
        return objets
    else:
        return False

def patchit():# fonction crée pour être lancée dans le jeu (débugage) : pour mettre des tests ou actions impossibles à effectuer en mode commande
    print "Ppachit"
#    import const
    for ombre in data().SCHATTEN_NPCS:
        if not object.is_destroyed(ombre):
            print ombre, object.get_position(ombre)

def dbg(texte):
#    co.comment("ALTER_EGO",'CHR_DEBUG % {"value":texte}' )# abandonné avant de tester, à voir si le temps
    sys.add_text(globaltext.CHR_DEBUG % {"value":texte})
#    sys.open_console()# ouvre la console de python dans le jeu (par ce fait le met aussi en pause)


### tester tranf_item_party ###
#
## liste fonctions :###
# arme_npc      degaine     arme_groupe     leplusproche    group_as_obj        group_has_1_of       del_party_inv       tranf_item_party        teleport_party
# teleport_party_gr     anyone_has_skill