# -*- coding: utf-8 -*-
import globals
import system
import object
import math
import character
import sounds
import string
import random
import globaltext
import dialog
from timerepr import time
from skill_tables import attributes
from skill_tables import skills


__doc__= """rest and what happens if the chars don't rest
"""

data = globals.data
Lambda = globals.Lambda


# todo:
# camping objecte beseitigen oder auf nicht speicherbar schalten
# char im auto abfangen
# movetoobject auf settodummy umstellen

cutscene = True
moviestripes = False
cyclic_fatigue_check_interval = 30*1000
talk_chance = 5

SEEKER = {
	#all clothes once
	0 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "evil01"]),
	1 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil03"]),
	2 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "black", "ll_seeker", "evil02"]),
	3 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "white", "ll_seeker", "evil01"]),
	4 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker_leather", "evil02"]),
	5 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker_leather", "evil04"]),
	#5males
	6 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil18"]),
	7 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil19"]),
	8 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "albin"]),
	9 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "hildegar"]),
	10 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "godbert"]),
	#5females
	11 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "white", "ll_seeker", "evil03"]),
	12 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "white", "ll_seeker", "evil04"]),
	13 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "white", "ll_seeker", "hallgard"]),
	14 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "white", "ll_seeker", "fulberta"]),
	15 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "female", "black", "ll_seeker", "fladhild"]),
	#another 5males mixes clothes
	16 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil07"]),
	17 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "evil05"]),
	18 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "evil06"]),
	19 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker_leather", "evil09"]),
	20 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker_leather", "evil08"]),
	#another 5males mixes clothes
	21 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil10"]),
	22 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil12"]),
	23 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker", "evil13"]),
	24 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "white", "ll_seeker_leather", "evil14"]),
	25 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker_leather", "evil11"]),
	#some more males
	26 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "evil15"]),
	27 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "evil16"]),
	28 : ( 	["male", "REST_RAIDERS", 310, globaltext.NAME_SEEKER],
			["low", "male", "black", "ll_seeker", "evil17"]),
}

def init_data():
	if not hasattr(data("rest"), "legal_rest_areas"):
		data("rest").legal_rest_areas = { 
			"zone_1": [ ( 510.60, 269.11 ), ( 566.57, 504.53 ) ], #okay
			"zone_2": [ ( 640.17, 677.96 ), ( 684.78, 709.34 ), ( 761.71, 773.84 ), ( 865.19, 495.79 ), ( 447.06, 480.92 ), ( 250.66, 387.74 ) ],
			"zone_3": [ ( 334.45, 371.59 ), ( 487.78, 588.77 ), ( 281.15, 547.42 ), ( 261.63, 307.45 ) ],
			"zone_4": [ ( 553.55, 347.11 ), ( 700.85, 576.58 ), ( 587.78, 554.07 ), ( 413.47, 545.32 ), ( 409.47, 547.51 ) ],
			"zone_5": [ ( 416.79, 828.49 ), ( 461.49, 466.32 ), ( 400.96, 216.18 ), ( 269.22, 845.43 ) ],
			"zone_6": [ ( 226.51, 382.55 ), ( 657.68, 271.97 ), ( 526.56, 940.65 ), ( 379.95, 797.95 ) ],
			"zone_7": [],
			"zone_8": [ ( 772.67, 296.97 ), ( 679.04, 443.56 ) ],
			"zone_9": [ ( 398.02, 291.81 ), ( 307.97, 574.63 ), ( 598.78, 472.65 ) ],
			"zzone_1": [ ( 267.04, 380.79 ), ( 414.36, 237.91 ), ( 284.93, 321.21 ), ( 290.10, 517.62 ) ],
			"zzone_2": [ ( 255.29, 278.00 ), ( 255.06, 626.44 ), ( 337.57, 389.94 ) ],
			"zzone_3": [ ( 291.71, 601.32 ), ( 349.49, 629.87 ), ( 312.38, 207.08 ) ],
			"zzone_4": [ ( 474.25, 229.38 ), ( 359.31, 482.75 ), ( 400.65, 435.80 ) ],
			"zzone_5": [ ( 557.00, 464.00 ) ],
			"zzone_6": [ ( 316.77, 341.97 ), ( 338.45, 550.55 ), ( 481.10, 563.29 ) ],
			"zzone_7": [], # no rest areas in this zone
			"zzone_8": [], # no rest areas in this zone
			"sqzone_1": [ ( 238.44, 274.67 ) ],
			"sqzone_2": [ ( 390.98, 305.82 ), ( 280.07, 212.36 ) ],
			"sqzone_3": [ ( 347.20, 367.06 ), ( 207.70, 361.09 ) ],
			"sqzone_4": [],
			"sqzone_5": [ ( 227.27, 305.63 ) ],
			"sqzone_6": [ ( 206.89, 266.19 ), ( 402.02, 432.39 ), ( 349.20, 241.85 ) ]
			} # end of legal_rest_areas dict

	# remove illegal rest position from savegame
	epsilon = 0.001
	for elem in data("rest").legal_rest_areas["zone_6"]:
		if elem[0]-567.70 < epsilon and elem[1]-420.95 < epsilon:
			data("rest").legal_rest_areas["zone_6"].remove(elem)

def get_last_rest_time():
	if not hasattr(data("rest"), "last_rest_time"):
		data("rest").last_rest_time = system.get_mission_time()
	if data("rest").last_rest_time > system.get_mission_time():
		data("rest").last_rest_time = system.get_mission_time()
	
	return data("rest").last_rest_time
	
def cyclic_fatigue_check():
	##### HELPER FUNCTION ######################################
	def calc_fatigue(att_penalty, skill_penalty, hp_factor):
		def sub_calc_fatigue(char, att_or_skill, penalty, fatigue_dict):
			changed = False
			dict_value = 0
			if att_or_skill in fatigue_dict:
				dict_value = fatigue_dict[att_or_skill]
				penalty -= dict_value
			value = object.get_attribute(char, att_or_skill)
			import types
			if type(value) not in (types.IntType, types.LongType):
				exc = "illegal type %s in attribute/skill '%s' for char '%s' (value: <%s>)" % (
						str(type(value)), att_or_skill, char, repr(value))
				raise TypeError, exc 
			diff = min(penalty, value-1)
			if diff != 0:
				changed = True
				object.set_attribute(char, att_or_skill, value-diff)
				fatigue_dict[att_or_skill] = dict_value + diff
			return changed
		
		changed = False
		for char in system.get_pcs():
			if object.has_attribute(char, "fatigue"):
				fatigue = object.get_attribute(char, "fatigue")
			else:
				fatigue = {}
			for att in attributes:
				change = sub_calc_fatigue(char, att, att_penalty, fatigue)
				changed = changed or change 
			for skill in skills:
				change = sub_calc_fatigue(char, skill, skill_penalty, fatigue)
				changed = changed or change 

			object.set_attribute(char, "fatigue", fatigue)

			act_hp = object.get_attribute(char, "hitpoints")		
			max_hp = object.get_attribute(char, "maxhitpoints")
			hp = min(act_hp, math.ceil(max_hp * hp_factor))
			object.set_attribute(char, "hitpoints", hp)
		return changed
	def talk(changed, choices):
		if changed:
			char="ALTER_EGO"
			talk = True
		else:
			char = random.choice(system.get_pcs())
			talk = random.randint(0, talk_chance)==0
		if talk:
			dialog.init_dialog(type=globals.DIALOGSMALL)	
			dialog.add_text(text=random.choice(choices), speaker=char, follower="ENDDIALOG")
			dialog.start()
	def msg(changed, msg):
		if not changed: changed = random.randint(0, talk_chance)==0
		if changed: system.add_text(msg)
	##### HELPER FUNCTION ######################################
	
	last = get_last_rest_time()
	awake = system.get_mission_time() - last
	
	print "awake for:", awake
	#if globals.LOCAL_USER == globals.USER_ALEXANDER_MISELER:
	#	system.add_text("awake for:" + str(awake))
	
	for char in system.get_pcs():
		if awake >= time("36:0:0"):
			if not object.has_attribute(char, "needs_rest_LED")\
			or not object.get_attribute(char, "needs_rest_LED"):
				object.set_attribute(char, "needs_rest_LED", True);
				system.update_ui()
		else:
			if object.has_attribute(char, "needs_rest_LED")\
			and object.get_attribute(char, "needs_rest_LED"):
				object.set_attribute(char, "needs_rest_LED", False);
				system.update_ui()

	if awake >= time("60:0:0"):
		"""60+ Stunden			Charakter Health geht auf 1 Punkt, er wird 
		ohnmächtig und bleibt es für 12, Spielstunden, 
		anschließend ist er voll ausgeruht"""
		changed = False
		for char in system.get_pcs():
				object.set_attribute(char, "unconscious_subtract_hp", False)
				object.destroy(char, unconscious=True)
				changed = True
		if changed:
			data("rest").unconscious_start = system.get_mission_time()
			msg(True, globaltext.REST_FATIGUE_WARNING_4)
			system.notify_global_timer("fatigue_unconscious_timer", 30*1000)
			system.update_ui()
	elif awake >= time("56:0:0"):
		"56 – 60 Stunden		-8 auf alle Attribute, -50% (absoluter Wert) auf alle Skills"
		"Charakter verliert 50% seiner aktuellen Healthpoints"
		att_penalty = 8
		skill_penalty = 50
		hp_factor = 0.5
		changed = calc_fatigue(att_penalty, skill_penalty, hp_factor)
		msg(changed, globaltext.REST_FATIGUE_WARNING_3)
	elif awake >= time("48:0:0"):
		"48 – 56 Stunden		-4 auf alle Attribute, -30% (absoluter Wert) auf alle Skills"
		"Charakter verliert 30% seiner aktuellen Healthpoints"
		att_penalty = 4
		skill_penalty = 30
		hp_factor = 0.7
		changed = calc_fatigue(att_penalty, skill_penalty, hp_factor)
		msg(changed, globaltext.REST_FATIGUE_WARNING_2)
	elif awake >= time("36:0:0"):
		"36 – 48 Stunden		-2 auf alle Attribute, -10% (absoluter Wert) auf alle Skills"
		att_penalty = 2
		skill_penalty = 10
		hp_factor = 1.0
		changed = calc_fatigue(att_penalty, skill_penalty, hp_factor)
		msg(changed, globaltext.REST_FATIGUE_WARNING_1)
	else:
		att_penalty = 0
		skill_penalty = 0
		hp_factor = 1.0
		changed = calc_fatigue(att_penalty, skill_penalty, hp_factor)
		if awake >= time("32:0:0"):
			talk(changed, ['REST_FATIGUE_STAGE_2_1', 'REST_FATIGUE_STAGE_2_2', 'REST_FATIGUE_STAGE_2_2'])
			# Charakter zeigt Müdigkeitsgeste 3
		elif awake >= time("28:0:0"):
			talk(changed, ['REST_FATIGUE_STAGE_1_1', 'REST_FATIGUE_STAGE_1_2', 'REST_FATIGUE_STAGE_1_2'])
			# Charakter zeigt Müdigkeitsgeste 2
		elif awake >= time("24:0:0"):
			# Charakter zeigt Müdigkeitsgeste 1
			pass

def helper_distribute_litter(item):
	radius = random.uniform(data("rest").radius_beds+0.7, data("rest").radius_beds+1.5)
	angle = random.uniform(math.pi*0.3, math.pi*1.6)
	x = data("rest").rest_x + math.sin(angle) * radius
	y = data("rest").rest_y - math.cos(angle) * radius
	data("rest").camp_objects.append(system.create_object(item, x, y, direction=random.randint(0,360)))
def distribute_litter():
	for i in range(random.randint(1,3)): helper_distribute_litter("SET_BIG_BACKPACK") 
	for i in range(random.randint(1,3)): helper_distribute_litter("SET_PAN") 
	for i in range(random.randint(1,3)): helper_distribute_litter("SET_COOKING_POT") 
	for i in range(random.randint(0,1)): helper_distribute_litter("SET_CAMPING_STOVE") 
	for i in range(random.randint(0,1)): helper_distribute_litter("RES3D_BASKET_W_APPLES") 	

def check_for_legal_rest_area(x, y, with_dialogs = True):
	# check for non-rest-area (village or something...)
	# with_dialogs determines if dialogs should pop up if the area is illegal
	regions = []
	if hasattr(data("rest"), "non_rest_areas"):
		for region in data("rest").non_rest_areas:
			coords = system.get_region(region)
			if coords: regions.append(coords)
			else: raise Exception, "unknown region '%s'" % region
		for char in system.get_pcs():
			for region in regions:
				if	min(region[0], region[2]) <= x and max(region[0], region[2]) >= x\
				and min(region[1], region[3]) <= y and max(region[1], region[3]) >= y:
					if with_dialogs:
						dialog.init_dialog(type=globals.DIALOGSMALL)
						dialog.add_text(text="REST_AREA_NOT_ALLOWED", speaker="ALTER_EGO", follower="ENDDIALOG")
						dialog.start()
					return False
	
	# check if area is empty
	objects = system.get_objects(type=None, left=x-3.5, top=y-3.5, right=x+3.5, bottom=y+3.5)
	objects = filter(lambda obj: object.is_active(obj), objects)
	objects = filter(lambda obj: obj not in system.get_pcs(), objects)
	objects = filter(lambda obj: object.get_attribute(obj, "type") != "equipment", objects)
	if len(objects):
		if with_dialogs:
			dialog.init_dialog(type=globals.DIALOGSMALL)	
			dialog.add_text(text="REST_AREA_NOT_EMPTY", speaker="ALTER_EGO", follower="ENDDIALOG")
			dialog.start()
		return False
		
	#check if area is flat enough
	import grids
	test_points = []
	heights = []
	x_points = []
	y_points = []
	x1 = x-3.5
	y1 = y-3.5
	while x1<=x+3.5:
		x1+=0.5
		x_points.append(x1)
	while y1<=y+3.5:
		y1+=0.5
		y_points.append(y1)
	for y1 in y_points:
		for x1 in x_points:
			test_points.append([x1,y1])
	for point in test_points:
		heights.append(grids.get_height(point[0], point[1]))
	max_height = max(heights)
	min_height = min(heights)
	if (max_height - min_height) >= 1.0:
		if with_dialogs:
			dialog.init_dialog(type=globals.DIALOGSMALL)	
			dialog.add_text(text="REST_AREA_NOT_FLAT", speaker="ALTER_EGO", follower="ENDDIALOG")
			dialog.start()
		if globals.LOCAL_USER == globals.USER_ALEXANDER_MISELER:
			system.add_text(str(max_height - min_height) + " Meter Höhenunterschied")
		return False
	
	return True

def start_rest(x=-1, y=-1):
	x, y = get_nearest_legal_rest_area( x, y )
	if x == -1 and y == -1: 
		dialog.init_dialog(type=globals.DIALOGSMALL)
		dialog.add_text(text="REST_AREA_NOT_ALLOWED", speaker="ALTER_EGO", follower="ENDDIALOG")
		dialog.start()
		return
	#if not check_for_legal_rest_area(x, y): return
	if not hasattr(data("rest"), "rest_after_raid") or not data("rest").rest_after_raid:
		data("rest").rest_after_raid = False
		data("rest").pcs = system.get_pcs()
		data("rest").companion_npcs = []
	data("rest").chars_ready = []
	data("rest").resting = True
	data("rest").char_activity = {}
	data("rest").camp_objects = []
	data("rest").bed_order = {}
	data("rest").start_rest_move_counter = 0
	data("rest").radius_chars = 2
	data("rest").radius_beds = 3
	data("rest").rest_x = x
	data("rest").rest_y = y
	for char in system.get_npcs():
		if	object.has_attribute(char, "zone_transfer") \
		and	object.get_attribute(char, "zone_transfer")==True \
		and object.is_active(char):
			data("rest").companion_npcs.append(char)
			object.set_active_state(char, False)
			
	system.show_battle_panel( False )
	system.fade(globals.FADE_OUT, start_camp_fire)

def on_char_ready(char):
	print "mark 5"
	data("rest").chars_ready.append(char)
	if len(data("rest").chars_ready) == len(system.get_pcs()):		
		print "mark 6"
		if data("rest").rest_after_raid:
			data("rest").guards = filter(lambda char: char in system.get_pcs(), data("rest").guards)
			rest(data("rest").hours_to_rest, data("rest").guards)
		else:
			system.set_speed_factor(1.0)
			sounds.play_3d_sound_object(sfx_id="campfire_big",object=data("rest").camp_fire,loop=True, identifier=data("rest").camp_fire)
			system.fade(globals.FADE_IN, group_found_rest_place_dialog)

def group_found_rest_place_dialog():
	dialog.init_dialog(type=globals.DIALOGSMALL)
	dialog.add_text(text="REST_GROUP_FOUND_PLACE", speaker="ALTER_EGO", follower="ENDDIALOG")
	dialog.start()

def start_camp_fire():
	# continue rest only if there are still pcs standing :)
	if not len(system.get_pcs()):
		system.fade(globals.FADE_IN)
		return		
			
	# hide old raiders
	if hasattr(data("rest"), "rest_raiders") and len(data("rest").rest_raiders):
		pos = object.get_attribute("ALTER_EGO", "pos_before_rest")
		for raider in data("rest").rest_raiders:
			if object.exists(raider):
				if object.is_destroyed(raider):
					object.set_position(object=raider, x=pos[0], y=pos[1], grid=pos[2])
					for item in object.get_inventory_id_list(raider):
						object.drop_item(raider, item)
				object.set_active_state(raider, False)
	data("rest").rest_raiders = []

	# teleport chars to rest location
	for char in system.get_pcs():
		dist = math.sqrt((data("rest").rest_x-object.get_x(char))**2 + (data("rest").rest_y-object.get_y(char))**2)
		radius = random.uniform(data("rest").radius_beds*0.2, data("rest").radius_beds+1)
		angle = random.uniform(0, math.pi*2)
		x = data("rest").rest_x + math.sin(angle) * radius
		y = data("rest").rest_y - math.cos(angle) * radius

		if not data("rest").rest_after_raid:
			object.set_attribute( char, "pos_before_rest", ( object.get_x( char ), object.get_y( char ), object.get_grid(char) ) )
			object.cancel_commandos( char )
			if object.has_attribute( char, "is_carrying" ): # handle a carried char
				if object.get_attribute( char, "is_carrying" ) == True:
					carried_char = object.get_attribute( char, "carried_char" )
					object.set_attribute( char, "layed_down_before_rest", carried_char )
	
					radius = random.uniform(data("rest").radius_beds*0.2, data("rest").radius_beds+1)
					angle = random.uniform(0, math.pi*2)
					tmp_x = data("rest").rest_x + math.sin(angle) * radius
					tmp_y = data("rest").rest_y - math.cos(angle) * radius
	
					object.set_attribute( char, "is_carrying", False )
					object.set_attribute( char, "carried_char", None )
					object.set_attribute( carried_char, "pos_before_rest", ( object.get_x( carried_char ), object.get_y( carried_char ), object.get_grid(carried_char) ) )
					object.set_position( carried_char, tmp_x, tmp_y, "landscape" )
					object.set_active_state( carried_char, False )

		print "data.rest_x, data.rest_y", data("rest").rest_x, data("rest").rest_y
		object.set_position( char, x, y, "landscape" )

	if not moviestripes: globals.data('cutscene').deactivate_moviestripes=True
	if cutscene: system.start_cutscene(globals.INTERACTIVE)
	
	print "mark 2"
	# alex todo: remove debug code
	system.close_console()
	system.set_uielement_state(globals.UI_ELEMENT_MINIMAP, globals.UIVIS_INVISIBLE)
	system.set_uielement_state(globals.UI_ELEMENT_RESTPANEL, globals.UIVIS_VISIBLE)
	
	#view = [x-4.0, y-8.1, 5.0, 0.38, 0.76, -0.53]
	#view = [x-2.9, y-5.3, 3.9, 0.37, 0.68, -0.63]
	import grids
	view = [data("rest").rest_x-4.0, data("rest").rest_y-6.9, 4.7+grids.get_height(data("rest").rest_x,data("rest").rest_y), 0.41, 0.73, -0.54]
	system.set_camera_view(view)
	party_members = system.get_pcs()
	data("rest").step = 2 * math.pi / len(party_members)
	data("rest").offset = random.uniform(0, 2 * math.pi)
	data("rest").angles = {}
	counter = 0
	system.set_speed_factor(20.0)
	data("rest").camp_objects.append(system.create_object("RES3D_LAGERFEUER_KLEIN", data("rest").rest_x, data("rest").rest_y))
	data("rest").camp_fire = data("rest").camp_objects[-1]
	#system.clear_ground_pattern(data("rest").camp_fire)
	system.start_effect_object(object=data("rest").camp_objects[-1],node="effekt_feuer",parameter=globals.fx_fire_lagerfeuer_small)
	system.start_effect_object(object=data("rest").camp_objects[-1],node="holz",parameter=globals.fx_fire_lagerfeuer_small)
	system.start_effect_object(object=data("rest").camp_objects[-1],node="asche",parameter=globals.fx_fire_lagerfeuer_small)
	distribute_litter()
	
	data("rest").char_clean_up = {}
	for char in party_members:
		data("rest").char_clean_up[char] = []
		# prevent trouble with full inventory and items created for camp fire activities
		object.set_inventory_slot_count(char, object.get_inventory_slot_count(char)+3)		
		data("rest").char_clean_up[char].append(Lambda("object.set_inventory_slot_count('%s', object.get_inventory_slot_count('%s')-3)" % (char,char)))
		object.cancel_commandos(char)
		weapon = character.get_primary_weapon(char)
		if weapon != "":
			if object.get_attribute(weapon, "typeid") == "SET_FIST":
				weapon = ""
		if weapon != "":
			character.un_equip_direct(char, weapon)
			data("rest").char_clean_up[char].append(Lambda("character.equip('%s', '%s')" % (char,weapon)))
		else:
			data("rest").char_clean_up[char].append(Lambda("None"))
	
	print "mark 3"
	def make_bed(char, bed_type):
		data("rest").char_activity[char] = None
		counter = party_members.index(char)
		
		data("rest").angles[char] = data("rest").offset + data("rest").step * counter
		
		x2 = data("rest").rest_x + math.sin(data("rest").offset + data("rest").step * counter) * data("rest").radius_beds
		y2 = data("rest").rest_y - math.cos(data("rest").offset + data("rest").step * counter) * data("rest").radius_beds
		
		if bed_type==0:
			#gray-silver sleeping bag
			direction = 90 + 180*random.randint(0,1) + 360*((data("rest").offset + data("rest").step*counter)/(2.0*math.pi))
			data("rest").camp_objects.append(system.create_object("RES3D_TRES_OBJECTS_BUILDING_SLEEPING_BAG_01", x2, y2, direction=direction))
			data("rest").bed_order[char] = data("rest").camp_objects[-1] 
			system.clear_ground_pattern(data("rest").camp_objects[-1])
		elif bed_type==1:
			#worn out red sleeping bag
			direction = 90 + 180*random.randint(0,1) + 360*((data("rest").offset + data("rest").step*counter)/(2.0*math.pi))
			data("rest").camp_objects.append(system.create_object("RES3D_TRES_OBJECTS_BUILDING_SLEEPING_BAG_02", x2, y2, direction=direction))
			data("rest").bed_order[char] = data("rest").camp_objects[-1] 
			system.clear_ground_pattern(data("rest").camp_objects[-1])
		elif bed_type==2:			
			#camping bed
			direction = 180 + 360*((data("rest").offset + data("rest").step*counter)/(2.0*math.pi))
			data("rest").camp_objects.append(system.create_object("RES3D_TRES_OBJECTS_BUILDING_FELDBETT", x2, y2, direction=direction))
			data("rest").bed_order[char] = data("rest").camp_objects[-1] 
			system.clear_ground_pattern(data("rest").camp_objects[-1])
		else: assert False

		y1 = data("rest").rest_y - math.cos(data("rest").offset + data("rest").step * counter) * data("rest").radius_chars
		x1 = data("rest").rest_x + math.sin(data("rest").offset + data("rest").step * counter) * data("rest").radius_chars
		object.set_position(char, x1, y1)
	def make_sleeping_bag(char):
		if random.randint(0,2)!=0:
			# 2/3 chance for gray-silver sleeping bag
			make_bed(char, 0)
		else:
			# 1/3 chance for worn out red sleeping bag
			make_bed(char, 1)
	def make_camping_bed(char):
		# camping bed
		make_bed(char, 2)
	def position_card_player(chars):
		assert len(chars)>=2 and len(chars)<=4
		radius = 0.70
		counter = party_members.index(chars[random.randint(0,len(chars)-1)])
		offset_center = data("rest").offset + 0.5 * data("rest").step
		center_x = data("rest").rest_x + math.sin(offset_center + data("rest").step * counter) * data("rest").radius_chars
		center_y = data("rest").rest_y - math.cos(offset_center + data("rest").step * counter) * data("rest").radius_chars
		card_game=system.create_object("SET_HAND_OF_PLAYING_CARDS", center_x, center_y, direction=random.randint(0,360))
		data("rest").camp_objects.append(card_game)		
		step_players = 2 * math.pi / len(chars)
		offset_players = random.uniform(0, 2 * math.pi)
		counter_players = 0
		for char in chars:
			x1 = center_x + math.sin(offset_players + step_players * counter_players) * radius
			y1 = center_y - math.cos(offset_players + step_players * counter_players) * radius
			object.set_position_free(char, x1, y1, 0)
			object.turn_to_object(char, card_game)
			counter_players += 1

	def cards(chars):
		for char in chars:
			make_sleeping_bag(char)
			play_cards(char)
		position_card_player(chars)
	def cook(char):
		make_sleeping_bag(char)
		cook_meal(char)
	def read(char):
		make_camping_bed(char)
		read_book(char)
	def eat(char):
		make_sleeping_bag(char)
		eat_and_drink(char)
	def flute(char):
		make_camping_bed(char)
		play_flute(char)
	
	shuffled_party = party_members
	random.shuffle(shuffled_party)
	if len(shuffled_party)==6:
		variant = random.randint(0,5)
		#variant = -1
		print "players:", len(shuffled_party), " variant:", variant
		if variant == 0:
			cards(shuffled_party[:3])
			cook(shuffled_party[3])
			read(shuffled_party[4])
			eat(shuffled_party[5])
		elif variant == -1:
			cook(shuffled_party[0])
			cook(shuffled_party[1])
			cook(shuffled_party[2])
			cook(shuffled_party[3])
			cook(shuffled_party[4])
			cook(shuffled_party[5])
		elif variant == 1:
			cards(shuffled_party[:3])
			cook(shuffled_party[3])
			flute(shuffled_party[4])
			cook(shuffled_party[5])
		elif variant == 2:
			cards(shuffled_party[:4])
			cook(shuffled_party[4])
			eat(shuffled_party[5])
		elif variant == 3:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			flute(shuffled_party[3])
			cook(shuffled_party[4])
			eat(shuffled_party[5])
		elif variant == 4:
			eat(shuffled_party[0])
			read(shuffled_party[1])
			cook(shuffled_party[2])
			flute(shuffled_party[3])
			cook(shuffled_party[4])
			eat(shuffled_party[5])
		elif variant == 5:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			cards(shuffled_party[3:5])
			eat(shuffled_party[5])
		else: assert False
	elif len(shuffled_party)==5:
		variant = random.randint(0,5)
		print "players:", len(shuffled_party), " variant:", variant
		if variant == 0:
			cards(shuffled_party[:3])
			cook(shuffled_party[3])
			read(shuffled_party[4])
		elif variant == 1:
			cards(shuffled_party[:3])
			cook(shuffled_party[3])
			flute(shuffled_party[4])
		elif variant == 2:
			cards(shuffled_party[:4])
			cook(shuffled_party[4])
		elif variant == 3:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			read(shuffled_party[3])
			eat(shuffled_party[4])
		elif variant == 4:
			eat(shuffled_party[0])
			read(shuffled_party[1])
			cook(shuffled_party[2])
			flute(shuffled_party[3])
			cook(shuffled_party[4])
		elif variant == 5:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			cards(shuffled_party[3:5])
		else: assert False
	elif len(shuffled_party)==4:
		variant = random.randint(0,5)
		print "players:", len(shuffled_party), " variant:", variant
		if variant == 0:
			cards(shuffled_party[:3])
			cook(shuffled_party[3])
		elif variant == 1:
			cards(shuffled_party[:3])
			flute(shuffled_party[3])
		elif variant == 2:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			flute(shuffled_party[3])
		elif variant == 3:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			eat(shuffled_party[3])
		elif variant == 4:
			eat(shuffled_party[0])
			read(shuffled_party[1])
			cook(shuffled_party[2])
			flute(shuffled_party[3])
		elif variant == 5:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
			read(shuffled_party[3])
		else: assert False
	elif len(shuffled_party)==3:
		variant = random.randint(0,6)
		print "players:", len(shuffled_party), " variant:", variant
		if variant == 0:
			cards(shuffled_party[:2])
			cook(shuffled_party[2])
		elif variant == 1:
			cards(shuffled_party[:2])
			read(shuffled_party[2])
		elif variant == 2:
			cards(shuffled_party[:2])
			flute(shuffled_party[2])
		elif variant == 3:
			cards(shuffled_party[:2])
			eat(shuffled_party[2])
		elif variant == 4:
			eat(shuffled_party[0])
			read(shuffled_party[1])
			cook(shuffled_party[2])
		elif variant == 5:
			eat(shuffled_party[0])
			flute(shuffled_party[1])
			cook(shuffled_party[2])
		elif variant == 6:
			cook(shuffled_party[0])
			eat(shuffled_party[1])
			cook(shuffled_party[2])
		else: assert False
	elif len(shuffled_party)==2:
		variant = random.randint(0,6)
		print "players:", len(shuffled_party), " variant:", variant
		if variant == 0:
			cards(shuffled_party[:2])
		elif variant == 1:
			cook(shuffled_party[0])
			read(shuffled_party[1])
		elif variant == 2:
			cook(shuffled_party[0])
			eat(shuffled_party[1])
		elif variant == 3:
			cook(shuffled_party[0])
			flute(shuffled_party[1])
		elif variant == 4:
			flute(shuffled_party[0])
			read(shuffled_party[1])
		elif variant == 5:
			read(shuffled_party[0])
			eat(shuffled_party[1])
		elif variant == 6:
			cook(shuffled_party[0])
			cook(shuffled_party[1])
		else: assert False
	elif len(shuffled_party)==1:
		variant = random.randint(0,3)
		#variant = 0
		print "players:", len(shuffled_party), " variant:", variant
		if variant == 0:
			cook(shuffled_party[0])
		elif variant == 1:
			read(shuffled_party[0])
		elif variant == 2:
			eat(shuffled_party[0])
		elif variant == 3:
			flute(shuffled_party[0])
		else: assert False
	else: assert False
	print "mark 4"




def finish_rest():
	print "rest clean up mark 1"
	system.fade(globals.FADE_OUT, finish_rest_clean_up)

def finish_rest_clean_up():
	print "rest clean up mark 2"
	system.set_sky_speed()
	sounds.stop_sound(data("rest").camp_fire)
	system.set_speed_factor(20.0)
	for obj in data("rest").camp_objects:
		object.set_active_state(obj, False)
	clean_up_items()
	for char in data("rest").char_clean_up:
		data("rest").char_clean_up[char].reverse()
		for action in data("rest").char_clean_up[char]:
			action()
	data("rest").char_activity = {}
	data("rest").camp_objects = []
	data("rest").bed_order = {}
	data("rest").used_fire_dummies = []
	data("rest").cleaned_chars = 0
	print "rest clean up mark 3"
	if not( hasattr(data("rest"), "raid") and data("rest").raid ):
		for char in data("rest").companion_npcs:
			object.set_active_state(char, True)
			
		for char in data("rest").pcs:
			if object.has_attribute( char, "pos_before_rest" ):
				pos = object.get_attribute( char, "pos_before_rest" )
				object.set_attribute( char, "pos_before_rest", None )
				object.set_position( char, pos[ 0 ], pos[ 1 ], pos[2] )
	
			# let the char carry the one he carried before rest
			if object.has_attribute( char, "layed_down_before_rest" ):
				layed_down_char = object.get_attribute( char, "layed_down_before_rest" )
				object.set_attribute( char, "layed_down_before_rest", None )
				object.set_attribute( char, "is_carrying", True )
				object.set_attribute( char, "carried_char", layed_down_char )
	
				if not( hasattr(data("rest"), "raid") and data("rest").raid ):
					pos = object.get_attribute( layed_down_char, "pos_before_rest" )
					object.set_position( layed_down_char, pos[ 0 ], pos[ 1 ], pos[2] )
				else:
					object.set_position( layed_down_char, object.get_x( char ), object.get_y( char ), object.get_grid(char) )
	
				object.set_active_state( layed_down_char, True )
		data("rest").pcs = []
		
	# sometimes finish_rest_char_ready gets never called, even though character.play_animation is called correctly.
	# this leads to https://silver.berlin.kkf.net/cgi-bin/bugzilla/show_bug.cgi?id=11700 (black screen freeze at end of rest)
	# the additional "ONCANCEL" callback MIGHT fix the problem, but the bug isn't reproducible, so i can't verify the fix.
	# just to be sure i implemented an additional timer based fallback.
	data("rest").finish_rest_fallback = True
	system.notify_global_timer("finish_rest_fallback_timer", 20*1000)

	for char in system.get_pcs( True ):
		if object.is_unconscious( char ):
			print "unconscious:", char
			object.destroy( char )
		else:
			print "conscious:", char
			character.set_body_mode(char, "STAND")
			character.play_animation(char, "CM_NPC_STEHEN_WARTEN_5", [["ONEND", finish_rest_char_ready], ["ONCANCEL", finish_rest_on_cancel]])
			
def finish_rest_on_cancel(char):
	print "############# finish_rest_on_cancel ##############"
	finish_rest_char_ready(char)

def finish_rest_char_ready(char):
	print "rest clean up mark 4"
	data("rest").cleaned_chars += 1
	if data("rest").cleaned_chars == len(system.get_pcs()):
		data("rest").finish_rest_fallback = False
		data("rest").cleaned_chars = 0
		finish_rest_fade_in()
def finish_rest_fade_in():
	print "rest clean up mark 5"
	system.set_speed_factor(1.0)
	if hasattr(data("rest"), "hours_rested") and data("rest").hours_rested > 0:
		system.set_mission_time(system.get_mission_time() + time(str(data("rest").hours_rested) + ":0:0"))
		data("rest").last_rest_time = system.get_mission_time()
	data("rest").resting = False
	if cutscene: system.end_cutscene()
	if not moviestripes: globals.data('cutscene').deactivate_moviestripes=False
	system.set_uielement_state(globals.UI_ELEMENT_RESTPANEL, globals.UIVIS_INVISIBLE)
	system.fade(globals.FADE_IN)
	if hasattr(data("rest"), "raid") and data("rest").raid:
		print "rest clean up mark 6"
		create_raid()
	data("rest").hours_rested = 0
	print "rest clean up mark 7"
	
def rest(hours, guards):
	print "rest", hours, guards
	data("rest").hours_to_rest = hours
	data("rest").guards = guards
	data("rest").rest_ready_chars = 0
	for char in data("rest").char_clean_up:
		while len(data("rest").char_clean_up[char]) > 2:
			action = data("rest").char_clean_up[char].pop(-1)
			action()
	sleepers = filter(lambda char: char not in guards, system.get_pcs())
	for char in sleepers:
		lie_down(char)
	
	char_offset = 1
	if len(guards): char_offset = len(system.get_pcs()) / len(guards)
	if char_offset==0: char_offset=1
	counter = 0
	data("rest").guard_positions = []
	for char in guards:
		angle = data("rest").offset + data("rest").step * (counter * char_offset + 0.5)
		x2 = data("rest").rest_x + math.sin(angle) * data("rest").radius_beds
		y2 = data("rest").rest_y - math.cos(angle) * data("rest").radius_beds
		data("rest").guard_positions.append([x2,y2,angle])
		counter += 1
	for char in guards:
		pos = None
		pos = data("rest").guard_positions.pop(0)
		if data("rest").char_activity[char] == "cook_meal":
			object.step_away(char, callback=
				["ONEND", Lambda("rest_guard_callback('%s', %f, %f, %f)" % (char, pos[0], pos[1], pos[2]))])
		else:
			wait_animations = ["CM_NPC_STEHEN_WARTEN_1", "CM_NPC_STEHEN_WARTEN_2", "CM_NPC_STEHEN_WARTEN_3", "CM_NPC_STEHEN_WARTEN_4", "CM_NPC_STEHEN_WARTEN_5"]
			character.play_animation(char, random.choice(wait_animations), 
				["ONEND", Lambda("rest_guard_callback('%s', %f, %f, %f)" % (char, pos[0], pos[1], pos[2]))])
		data("rest").char_activity[char] = "script"
	data("rest").raid = None
	guards = len(data("rest").guards)
	chance = 0
	for hour in range(data("rest").hours_to_rest):
#		if guards==0: chance=0.04
		if guards==0: chance=0.99
		elif guards==1: chance=0.03
		elif guards==2: chance=0.02
		elif guards==3: chance=0.01
		else: assert False
		if random.random() <= chance:
			if not hasattr(globals.data("cheat"), "no_raid") or not globals.data("cheat").no_raid:
				if not data("rest").rest_after_raid:
					data("rest").raid = hour + 1
					break

def rest_guard_callback(char, x, y, angle):
	action = data("rest").char_clean_up[char].pop(-1)
	action()
	object.move_to(char, x, y)
	object.turn_to_direction(char, 360*angle/(2*math.pi), callback=["ONEND", Lambda("rest_char_ready_callback('%s')" % char)])
def rest_char_ready_callback(char):
	data("rest").rest_ready_chars += 1
	if data("rest").rest_ready_chars == len(system.get_pcs()):
		if data("rest").rest_after_raid:
			system.set_speed_factor(1.0)
			system.set_rest_panel(data("rest").guards, data("rest").hours_to_rest, True)
			system.fade(globals.FADE_IN, rest_char_ready_callback_2)
			data("rest").rest_after_raid = False
		else:
			rest_char_ready_callback_2()
def rest_char_ready_callback_2():
	data("rest").hours_rested = 0
	system.set_sky_speed(fade_time = 4*1000, time_factor=75.0, load_sky_texture=False)
	system.notify_global_timer("resting", 2000)
		
def rest_hourly_callback():
	data("rest").hours_rested += 1
	rest_heal(1, data("rest").guards)
	if data("rest").hours_rested >= data("rest").hours_to_rest or data("rest").raid and data("rest").hours_rested >= data("rest").raid:
		if data("rest").raid and data("rest").hours_rested >= data("rest").raid:
			data("rest").rest_after_raid = True
			data("rest").hours_to_rest = data("rest").hours_to_rest - data("rest").hours_rested 
		else:
			data("rest").hours_to_rest = 0
			data("rest").guards = []
		finish_rest()
	else:
		system.notify_global_timer("resting", 2000)
def rest_heal(hours, guards):
	import object_events
	data("rest").last_rest_time = system.get_mission_time()
	cyclic_fatigue_check()
	for char in system.get_pcs():
		if not hasattr(data, "hp_leftover"): data("rest").hp_leftover = {}
		if char not in data("rest").hp_leftover: data("rest").hp_leftover[char] = 0
		max_hp = object.get_attribute(char, "maxhitpoints")
		act_hp = object.get_attribute(char, "hitpoints")
		hp_bonus = 0
		for i in range(hours):
			# Pro Stunde rasten werden 5 Healthpoints regeneriert.
			hp_bonus += 5
			# special bonus of 20% if talent medicine/regeneration
			if object_events.has_talent( char, "medicine", "regeneration" ):
				hp_bonus += 1

		hp_rounded = hp_bonus
		if char in guards:
			if len(guards)==1: hp_bonus *= 0.1
			elif len(guards)==2: hp_bonus *= 0.3
			elif len(guards)==3: hp_bonus *= 0.5
			else: assert False
			hp_bonus += data("rest").hp_leftover[char]
			hp_rounded = int(math.floor(hp_bonus))
			data("rest").hp_leftover[char] = hp_bonus - hp_rounded
		act_hp = min(act_hp+hp_rounded, max_hp)
		object.set_attribute(char, "hitpoints", act_hp)

		
def create_raid():
	level = 0.0
	for char in system.get_pcs():
		level += object.get_attribute(char, "level")
	level /= len(system.get_pcs())
	level = int(round(level))
	level = random.randint(max(1, level-3), max(1, level))
	
	possible_attackers = [0]*10 + [globals.ANIMAL_BEAR, globals.ANIMAL_WOLF]
	if globals.is_zone_enabled("zone_6"): possible_attackers += [globals.ANIMAL_WARG]
	if globals.is_zone_enabled("zone_5") and not system.get_act_mission_name()=="zone_3.zone_3":
		possible_attackers += [globals.ANIMAL_TIGER]
		
	attacker = random.choice(possible_attackers)
	if attacker == 0:
		min_raider_count = round(1.0*len(system.get_pcs()))
		max_raider_count = round(1.5*len(system.get_pcs()))
	elif attacker in [globals.ANIMAL_BEAR, globals.ANIMAL_TIGER]:
		min_raider_count = 2
		max_raider_count = 4
	elif attacker in [globals.ANIMAL_WOLF, globals.ANIMAL_WARG]:
		min_raider_count = len(system.get_pcs()) + 1
		max_raider_count = len(system.get_pcs()) + 5
	raider_count = random.randint(min_raider_count, max_raider_count)
	
	try:
		system.create_party(id="REST_RAIDERS",type=globals.PT_COMPUTER)
	except ValueError:
		pass
	print raider_count, attacker 
	pcs = system.get_pcs()
	data("rest").rest_raiders = []
	for i in range(raider_count):
		import time
		id = "REST_RAIDER_"+str(time.clock())
		data("rest").rest_raiders.append(id)
		if attacker==0:
			create_seeker(id, x=data("rest").rest_x+20, y=data("rest").rest_y+20)
			loot_count = 0
			if i==0:				
				if len(pcs) <= 2:
					loot_count = random.randint(1, 2)
				elif len(pcs) <= 4:
					loot_count = random.randint(2, 3)
				else:
					loot_count = random.randint(2, 4)
			equip_seeker(id, loot_count)
		else:
			system.create_animal(id=id, type=attacker, party="REST_RAIDERS", x=data("rest").rest_x+20, y=data("rest").rest_y+20)
		if object.has_attribute(id, "level"): object.set_attribute(id, "level", level)
		object.set_attribute(id, "foes", pcs)
		object.attack(id, random.choice(pcs))

	if attacker==0:
		dialog.init_dialog(type=globals.DIALOGSMALL)
		globaltext.REST_RAID_SEEKER_TEMP = globaltext.REST_RAID_SEEKER % {"hours": data("rest").hours_rested}
		dialog.add_text(text="REST_RAID_SEEKER_TEMP", speaker="ALTER_EGO", follower="ENDDIALOG")
		dialog.start()
	else:
		dialog.init_dialog(type=globals.DIALOGSMALL)
		globaltext.REST_RAID_ANIMALS_TEMP = globaltext.REST_RAID_ANIMALS % {"hours": data("rest").hours_rested}
		dialog.add_text(text="REST_RAID_ANIMALS_TEMP", speaker="ALTER_EGO", follower="ENDDIALOG")
		dialog.start()

	system.notify_global_timer("rest_raid_min_time_timer", 10*1000)
		
def lie_down(char):
	data("rest").char_activity[char] = "script"
	bed = data("rest").bed_order[char]
	if object.get_attribute(bed, "typeid")=="RES3D_TRES_OBJECTS_BUILDING_FELDBETT":
		#character.play_animation(char, "CM_NPC_SITZEN_BODEN_AUFSTEHEN", ["ONEND", Lambda("lie_down_camping_bed_2('%s', '%s')" % (char, bed))])
		lie_down_camping_bed_2(char, bed)
	elif object.get_attribute(bed, "typeid")=="RES3D_TRES_OBJECTS_BUILDING_SLEEPING_BAG_02":
		#character.play_animation(char, "CM_NPC_SITZEN_BODEN_AUFSTEHEN", ["ONEND", Lambda("lie_down_sleeping_bag_red_2('%s', '%s')" % (char, bed))])
		lie_down_sleeping_bag_red_2(char, bed)
	elif object.get_attribute(bed, "typeid")=="RES3D_TRES_OBJECTS_BUILDING_SLEEPING_BAG_01":
		#character.play_animation(char, "CM_NPC_SITZEN_BODEN_AUFSTEHEN", ["ONEND", Lambda("lie_down_sleeping_bag_gray_2('%s', '%s')" % (char, bed))])
		lie_down_sleeping_bag_gray_2(char, bed)
def lie_down_camping_bed_2(char, bed):	
	object.move_to_object(char, bed, "dmyp_001", callback=["ONEND", Lambda("lie_down_camping_bed_3('%s')" % char)])
def lie_down_camping_bed_3(char):
	character.play_animation(char, "CM_NPC_HINLEGEN_BETT", ["ONEND", Lambda("lie_down_camping_bed_4('%s')" % char)])	
def lie_down_camping_bed_4(char):
	rest_char_ready_callback(char)
	data("rest").char_activity[char] = "lie_on_camping_bed"
def lie_down_sleeping_bag_red_2(char, bed):	
	object.move_to_object(char, bed, "dmyp_001", callback=["ONEND", Lambda("lie_down_sleeping_bag_red_3('%s')" % char)])
def lie_down_sleeping_bag_red_3(char):
	character.play_animation(char, "CM_NPC_LIEGEN_HINLEGEN", ["ONEND", Lambda("lie_down_sleeping_bag_red_4('%s')" % char)])	
def lie_down_sleeping_bag_red_4(char):
	rest_char_ready_callback(char)
	data("rest").char_activity[char] = "lie_on_sleeping_bag"
def lie_down_sleeping_bag_gray_2(char, bed):	
	object.move_to_object(char, bed, "dmyp_001", callback=["ONEND", Lambda("lie_down_sleeping_bag_gray_3('%s')" % char)])
def lie_down_sleeping_bag_gray_3(char):
	character.play_animation(char, "CM_NPC_LIEGEN_HINLEGEN", ["ONEND", Lambda("lie_down_sleeping_bag_gray_4('%s')" % char)])	
def lie_down_sleeping_bag_gray_4(char):
	rest_char_ready_callback(char)
	data("rest").char_activity[char] = "lie_on_sleeping_bag"
	
	
def make_item(char, item, equip=True):
	id = object.create_item_in_inventory(char, item)
	if equip: character.equip_direct(char, id)
	print "make_item", char, item, id
	if not hasattr(data("rest"), "items_to_remove"):
		data("rest").items_to_remove = {}
	if not char in data("rest").items_to_remove:
		data("rest").items_to_remove[char] = []
	data("rest").items_to_remove[char].append(id)
def clean_up_items():
	print "clean_up_items", data("rest").items_to_remove
	for char in data("rest").items_to_remove:
		for item in data("rest").items_to_remove[char]:
			object.remove_item_from_inventory(char, item)
	data("rest").items_to_remove = {}

	
def play_cards(char):
	data("rest").char_activity[char] = "script"
	make_item(char, "SET_HAND_OF_PLAYING_CARDS")	
	make_item(char, "SET_PLAYING_CARD", False)	
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BODEN_AUFSTEHEN')" % (char)))
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BODEN_KARTEN_SPIELEN_ENDE')" % (char)))			
	on_char_ready(char)
	data("rest").char_activity[char] = "play_cards"
	
def cook_meal(char):
	data("rest").char_activity[char] = "script"
	make_item(char, "SET_PAN_WITH_MEAT")
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_STEHEN_PFANNE_SCHWENKEN_AUFSTEHEN')" % char))
		
	# select fire dummy
	dummies = 	[	('dmyp_001', math.pi*1.0), 
					('dmyp_002', math.pi*0.66),
					('dmyp_003', math.pi*0),
					('dmyp_004', math.pi*1.33),
					('dmyp_005', math.pi*0.33),
					('dmyp_006', math.pi*1.66)
				]
	if not hasattr(data, "used_fire_dummies"): data("rest").used_fire_dummies = []
	dummies = filter(lambda x: x not in data("rest").used_fire_dummies, dummies)

	angle = data("rest").angles[char]
	while angle > 2*math.pi:
		angle -= 2*math.pi
	while angle < 0:
		angle += 2*math.pi
	dummies.sort(lambda a, b: cmp(abs(a[1]-angle), abs(b[1]-angle)))
	index = 0

	data("rest").used_fire_dummies.append(dummies[index])

	# exceute movements & animation	
	object.turn_to_position(char, data("rest").rest_x, data("rest").rest_y)
	object.move_to_object(char, data("rest").camp_fire, dummies[index][0])
	character.play_animation(char, "CM_NPC_STEHEN_PFANNE_SCHWENKEN_LOOP", callback=["ONEND", Lambda("cook_meal_2('%s')" % char)])		
def cook_meal_2(char):
	on_char_ready(char)
	data("rest").char_activity[char] = "cook_meal"

def play_flute(char):
	data("rest").char_activity[char] = "script"
	bed = data("rest").bed_order[char]
	make_item(char, "SET_FLUTE")
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BANK_AUFSTEHEN')" % char))
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BANK_FLOETE_WEGSTECKEN')" % (char)))		
	object.move_to_object(char, bed, "dmyp_004", callback=["ONEND", Lambda("play_flute_2('%s')" % char)])
def play_flute_2(char):
	character.play_animation(char, "CM_NPC_STEHEN_HINSETZEN", ["ONEND", Lambda("play_flute_3('%s')" % char)])
def play_flute_3(char):
	on_char_ready(char)
	data("rest").char_activity[char] = "play_flute"

def read_book(char):
	data("rest").char_activity[char] = "script"
	bed = data("rest").bed_order[char]
	make_item(char, "SET_OPEN_BOOK")
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BANK_AUFSTEHEN')" % char))
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BANK_BUCH_LESEN_ENDE')" % (char)))		
	object.move_to_object(char, bed, "dmyp_004", callback=["ONEND", Lambda("read_book_2('%s')" % char)])
def read_book_2(char):
	character.play_animation(char, "CM_NPC_STEHEN_HINSETZEN", ["ONEND", Lambda("read_book_3('%s')" % char)])
def read_book_3(char):
	on_char_ready(char)
	data("rest").char_activity[char] = "read_book"

def drink(char):
	data("rest").char_activity[char] = "script"
	make_item(char, "SET_EMPTY_BOTTLE", False)
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BODEN_AUFSTEHEN')" % (char)))		
	object.turn_to_position(char, data("rest").rest_x, data("rest").rest_y)
	character.play_animation(char, "CM_NPC_SITZEN_BODEN_HINSETZEN", ["ONEND", Lambda("drink_2('%s')" % char)])
def drink_2(char):
	on_char_ready(char)
	data("rest").char_activity[char] = "drink"

def eat_and_drink(char):
	data("rest").char_activity[char] = "script"
	make_item(char, "SET_EMPTY_BOTTLE", False)
	data("rest").char_clean_up[char].append(Lambda("character.play_animation('%s', 'CM_NPC_SITZEN_BODEN_AUFSTEHEN')" % (char)))		
	object.turn_to_position(char, data("rest").rest_x, data("rest").rest_y)
	character.play_animation(char, "CM_NPC_SITZEN_BODEN_HINSETZEN", ["ONEND", Lambda("eat_and_drink_2('%s')" % char)])

def eat_and_drink_2(char):
	on_char_ready(char)
	data("rest").char_activity[char] = "eat_and_drink"

def create_seeker(id, x, y):
	global SEEKER
	nr = random.randint(1,28)
	seeker_data = SEEKER[nr]
	look = seeker_data[0]
	clothes = seeker_data[1]
	system.create_character(
		id=id,
		gender=look[0],
		party=look[1],
		x=x,
		y=y,
		direction=look[2],
		name=look[3],
		resourceui="")
	object.set_attributes(id,
		model=clothes[0],
		gender=clothes[1],
		skin=clothes[2],
		clothes=clothes[3],
		face=clothes[4])
	character.update_appearance(id)
	object.set_attribute(id, "faction", "SEEKER")

#def equip_seeker(id, additional_loot):
def equip_seeker(id, additional_loot=0):
	weapon_list = 	["SET_WALTER_PPK"]*5 + ["SET_SPECIAL_38"]*5 + ["SET_BERETTA_92F"]*5 + [
					"SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL", "SET_COLT_45", "SET_UZI", "SET_MP5", 
					"SET_AK_74", "SET_SAWED_OFF_REMINGTON_M870", "SET_P90_SMG", "SET_SIMONOV_SKS"]
	#weapon_list = 	["SET_WALTER_PPK"] + ["SET_SIMONOV_SKS"]
	#weapon_list = 	["SET_SIMONOV_SKS"]
	weapon = random.choice(weapon_list)
	character.equip_direct(id, weapon, creation=True, direct_ammo_load=True)
	
	loot_list = [
		# ammo
		"SET_AMMOPACK_7_65_MM", "SET_AMMOPACK_357", "SET_AMMOPACK_9_MM", "SET_AMMOPACK_50", 
		"SET_AMMOPACK_45", "SET_AMMOPACK_5_7_MM_SUBSONIC", "SET_AMMOPACK_4_6_MM", "SET_AMMOPACK_7_62NATO_MM",
		"SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_7_62SOVJET_MM", "SET_AMMOPACK_5_45_MM",
		
		# standard
		"SET_BASIC_PICKLOCK", "SET_MEAT_RAW_TINY", "SET_WATER_SKIN", "SET_BREAD", "SET_LEATHER_CAP", "SET_DUCT_TAPE",
		
		# better
		"SET_PROTECTIVE_GLOVES", "SET_STEEL_CLAD_BOOTS", "SET_MEDIPACK_SMALL", 
		
		# good
		"SET_MEDIPACK_BIG", "SET_LASERPOINTER", "SET_BULLET_PROOF_CLOTHES"
		]
# rajout car ne sort peut-tre pas
	object.create_item_in_inventory(id, random.choice(loot_list))
	# random items as loot
	for i in range(additional_loot):
		object.create_item_in_inventory(id, random.choice(loot_list))
		object.create_item_in_inventory(id, random.choice(loot_list))
		object.create_item_in_inventory(id, random.choice(loot_list))
	

def get_nearest_legal_rest_area( x, y ):
	"""Searches for the nearest rest aera and
	checks it. If it is legal then use it. Otherwise search next.

x,y - coordinates of the rest are. Returns -1,-1, if no legal rest area was found.
	"""
	zone = string.split( system.get_act_mission_name(), "." )[0]

	if data("rest").legal_rest_areas.has_key( zone ):
		dist = None
		nearest_pos = ( -1, -1 )
		for pos in data("rest").legal_rest_areas[ zone ]:
			tmp_dist = math.hypot( x - pos[ 0 ], y - pos[ 1 ] )
			if tmp_dist < dist or dist == None:
				dist = tmp_dist
				nearest_pos = pos

		return nearest_pos

	return ( -1, -1 )
