# -*- coding: utf-8 -*-
from globals import *
import character
import object
import globaltext
import system
import character_py

__doc__= """this module contains data access functions for skills, talents and attributes.
the effects of skill & attribute values are determined here.

updated to the_fall_attribute_fertigkeiten.doc version:
    974
    28.04.2004

incomplete, not all skills are here yet
"""


attributes =     ["strength", "agility", "dexterity", "constitution", "intelligence", "charisma"]
skills =         ["light_weapons", "heavy_weapons", "sniper_weapons", "speech", "throw_weapons",
                "explosives", "survival", "technic", "medicine", "sneak", "driving", "pick_pocket",
                "lock_pick", "close_combat"]

####################################################################################################
# attributes
####################################################################################################

def DtoS(x):
    Vstr=""
    if x > 0:Vstr="+%d" %x
    else:Vstr="%0d" %x
    return Vstr

def DtoS_pourc(x):
    Vstr=""
    if x < 1:Vstr="%0d%%" %( (x*100)-100 )
    elif x >=1:Vstr="+%0d%%" %( (x*100)-100 )
    return Vstr

def DtoS_pourc_inv(x):
    Vstr=""
    if x <= 1:Vstr="+%0d%%" %( 100-(x*100))
    elif x >1:Vstr="%0d%%" %( 100-(x*100))
    return Vstr

def strength_max_load(strength):
    """returns max load (i.e. max. added weight of all inventory items) in kg

chars can carry more than max load but they get penalties then.
"""
    assert strength >= 1 and strength <= 20
    return strength * 3

def strength_move_speed(rel_load):
    """returns the speed factor

this presents the movement penalty when the char carries more than his strength
allows.
"""
    if rel_load<=1:return 1
    else:
        if rel_load<=1.1:return 0.95
        elif rel_load<=1.2:return 0.85
        elif rel_load<=1.3:return 0.7
        else:return 0.55

def strength_heavy_weapons_hitchance(strength):
    """returns the hit chance factor

hit chance for heavy weapons depends on strength"""
    assert strength >= 1 and strength <= 20
    if strength <= 3: return 0.4
    if strength <= 6: return 0.6
    if strength <= 8: return 0.8
    if strength <= 12: return 1.0
    if strength <= 15: return 1.1
    if strength <= 18: return 1.15
    if strength <= 19: return 1.2
    if strength <= 20: return 1.25

def strength_heavy_weapons_speed(strength):
    """returns speed factor

speed (i.e. reload speed) for heavy weapons depends on strength"""
    assert strength >= 1 and strength <= 20
    if strength <= 3: return 1.3
    if strength <= 6: return 1.2
    if strength <= 8: return 1.1
    if strength <= 12: return 1.0
    if strength <= 15: return 0.9
    if strength <= 18: return 0.85
    if strength <= 19: return 0.8
    if strength <= 20: return 0.75

def strength_close_combat_damage(strength):
    """returns damage factor

damage dealed in melee depends on strength"""
    assert strength >= 1 and strength <= 20
    if strength <= 3: return 0.4
    if strength <= 6: return 0.6
    if strength <= 8: return 0.8
    if strength <= 12: return 1.0
    if strength <= 15: return 1.1
    if strength <= 18: return 1.15
    if strength <= 19: return 1.2
    if strength <= 20: return 1.25

def agility_move_speed(agility):
    """returns speed factor

movement speed depends on agility"""
    assert agility >= 1 and agility <= 20
    if agility <= 3: return 0.7
    if agility <= 6: return 0.8
    if agility <= 8: return 0.9
    if agility <= 12: return 1.0
    if agility <= 15: return 1.1
    if agility <= 18: return 1.2
    if agility <= 19: return 1.3
    if agility <= 20: return 1.4

def agility_armor(agility):
    """returns the armor bonus

agility gives an armor bonus or malus"""
    assert agility >= 1 and agility <= 20
    if agility <= 3: return -6
    if agility <= 6: return -4
    if agility <= 8: return -2
    if agility <= 12: return 0
    if agility <= 15: return +2
    if agility <= 18: return +4
    if agility <= 19: return +6
    if agility <= 20: return +8

def agility_move_silently_factor(agility):
    """returns speed factor

movement speed while moving silently depends on agility"""
    assert agility >= 1 and agility <= 20
    if agility <= 3: return 1.3
    if agility <= 6: return 1.2
    if agility <= 8: return 1.1
    if agility <= 12: return 1.0
    if agility <= 15: return 0.95
    if agility <= 18: return 0.90
    if agility <= 19: return 0.85
    if agility <= 20: return 0.80

def dexterity_weapons_hitchance(dexterity):
    """returns hit chance factor

weapon hit chance depends on dexterity (except heavy weapons depend on strength)"""
    assert dexterity >= 1 and dexterity <= 20
    if dexterity <= 3: return 0.7
    if dexterity <= 6: return 0.8
    if dexterity <= 8: return 0.9
    if dexterity <= 12: return 1.0
    if dexterity <= 15: return 1.1
    if dexterity <= 18: return 1.15
    if dexterity <= 19: return 1.2
    if dexterity <= 20: return 1.25

def dexterity_weapons_speed(dexterity):
    """returns speed factor

weapon speed (i.e. reload speed) depends on dexterity (except for heavy weapons)"""
    assert dexterity >= 1 and dexterity <= 20
    if dexterity <= 3: return 1.3
    if dexterity <= 6: return 1.2
    if dexterity <= 8: return 1.1
    if dexterity <= 12: return 1.0
    if dexterity <= 15: return 0.9
    if dexterity <= 18: return 0.85
    if dexterity <= 19: return 0.8
    if dexterity <= 20: return 0.75

def dexterity_pick_pocket(dexterity):
    """returns pick pocket success chance factor

pick pocket success chance depends on dexterity"""
    assert dexterity >= 1 and dexterity <= 20
    if dexterity <= 3: return 0.7
    if dexterity <= 6: return 0.8
    if dexterity <= 8: return 0.9
    if dexterity <= 12: return 1.0
    if dexterity <= 15: return 1.1
    if dexterity <= 18: return 1.15
    if dexterity <= 19: return 1.2
    if dexterity <= 20: return 1.25

def dexterity_lock_picking(dexterity):
    """returns lock picking success chance factor

lock picking success chance depends on dexterity"""
    assert dexterity >= 1 and dexterity <= 20
    if dexterity <= 3: return 0.7
    if dexterity <= 6: return 0.8
    if dexterity <= 8: return 0.9
    if dexterity <= 12: return 1.0
    if dexterity <= 15: return 1.1
    if dexterity <= 18: return 1.15
    if dexterity <= 19: return 1.2
    if dexterity <= 20: return 1.25

def constitution_life_energy_start(constitution):
    """returns health points at game start

how much HP a char starts with depends on constitution"""
    assert constitution >= 1 and constitution <= 20
    if constitution <= 3: return 5
    if constitution <= 6: return 10
    if constitution <= 8: return 15
    if constitution <= 12: return 20
    if constitution <= 15: return 25
    if constitution <= 18: return 30
    if constitution <= 19: return 35
    if constitution <= 20: return 40

def constitution_life_energy_level(constitution):
    """returns health points at level up

how much HP a char gets on level up depends on constitution
each char gets 4-8 HP per level. this is modified with this bonus.
(char can loose HP on level up!!! -2 HP if const is <= 3 and player is unlucky)
"""
    assert constitution >= 1 and constitution <= 20
    if constitution <= 3: return -6
    if constitution <= 6: return -4
    if constitution <= 8: return -2
    if constitution <= 12: return 0
    if constitution <= 15: return 2
    if constitution <= 18: return 4
    if constitution <= 19: return 6
    if constitution <= 20: return 8

def intelligence_skill_points(intelligence):
    """returns skill point modifier on level up or character creation

how much skill points a char gets at level up or character creation depends on intelligence
the char can distribute 25+this modifier points on level up."""
    assert intelligence >= 1 and intelligence <= 20
    if intelligence <= 3: return -6
    if intelligence <= 6: return -4
    if intelligence <= 8: return -2
    if intelligence <= 12: return 0
    if intelligence <= 15: return 2
    if intelligence <= 18: return 4
    if intelligence <= 19: return 6
    if intelligence <= 20: return 8

def charisma_talk_bonus_factor(charisma):
    """returns talk bonus factor

a char gets a bonus in his npc communication depending on his charisma.
"""
    assert charisma >= 1 and charisma <= 20
    if charisma <= 3: return 0.7
    if charisma <= 6: return 0.8
    if charisma <= 8: return 0.9
    if charisma <= 12: return 1.0
    if charisma <= 15: return 1.1
    if charisma <= 18: return 1.15
    if charisma <= 19: return 1.2
    if charisma <= 20: return 1.25

def charisma_npc_bad_mood_time_factor(charisma):
    """returns the bad mood factor

when the player has done something bad (pick pocket, killing peaceful npcs, etc.)
the npcs will not talk to him. this factor influences how long this bad mood
lasts.
"""
    assert charisma >= 1 and charisma <= 20
    if charisma <= 3: return 1.3
    if charisma <= 6: return 1.2
    if charisma <= 8: return 1.1
    if charisma <= 12: return 1.0
    if charisma <= 15: return 0.9
    if charisma <= 18: return 0.8
    if charisma <= 19: return 0.7
    if charisma <= 20: return 0.6

####################################################################################################
# skills
####################################################################################################

def close_combat_weapons_hit_chance(close_combat):
    """returns hit chance factor depending on close combat skill"""
    assert close_combat >= 1
    if close_combat <= 10: return 0.4
    if close_combat <= 29: return 0.6
    if close_combat <= 44: return 0.8
    if close_combat <= 54: return 1.0
    if close_combat <= 69: return 1.2
    if close_combat <= 84: return 1.4
    if close_combat <= 94: return 1.6
    if close_combat <= 99: return 1.8
    return 2.0

def close_combat_weapons_damage(close_combat):
    """returns damage factor depending on close combat skill"""
    assert close_combat >= 1
    if close_combat <= 10: return 0.4
    if close_combat <= 29: return 0.6
    if close_combat <= 44: return 0.8
    if close_combat <= 54: return 1.0
    if close_combat <= 69: return 1.2
    if close_combat <= 84: return 1.4
    if close_combat <= 94: return 1.6
    if close_combat <= 99: return 1.8
    return 2.0

def light_weapons_hit_chance(light_weapons):
    """returns hit chance factor depending on light weapons skill"""
    assert light_weapons >= 1
    if light_weapons <= 10: return 0.4
    if light_weapons <= 29: return 0.6
    if light_weapons <= 44: return 0.8
    if light_weapons <= 54: return 1.0
    if light_weapons <= 69: return 1.2
    if light_weapons <= 84: return 1.4
    if light_weapons <= 94: return 1.6
    if light_weapons <= 99: return 1.8
    return 2.0

def light_weapons_speed(light_weapons):
    """returns weapon speed factor depending on light weapons skill"""
    assert light_weapons >= 1
    if light_weapons <= 10: return 1.6
    if light_weapons <= 29: return 1.4
    if light_weapons <= 44: return 1.2
    if light_weapons <= 54: return 1.0
    if light_weapons <= 69: return 0.8
    if light_weapons <= 84: return 0.6
    if light_weapons <= 94: return 0.4
    if light_weapons <= 99: return 0.2
    return 0.0

def heavy_weapons_hit_chance(heavy_weapons):
    """returns hit chance factor depending on heavy weapons skill"""
    assert heavy_weapons >= 1
    if heavy_weapons <= 10: return 0.4
    if heavy_weapons <= 29: return 0.6
    if heavy_weapons <= 44: return 0.8
    if heavy_weapons <= 54: return 1.0
    if heavy_weapons <= 69: return 1.2
    if heavy_weapons <= 84: return 1.4
    if heavy_weapons <= 94: return 1.6
    if heavy_weapons <= 99: return 1.8
    return 2.0

def heavy_weapons_speed(heavy_weapons):
    """returns weapon speed factor depending on heavy weapons skill"""
    assert heavy_weapons >= 1
    if heavy_weapons <= 10: return 1.6
    if heavy_weapons <= 29: return 1.4
    if heavy_weapons <= 44: return 1.2
    if heavy_weapons <= 54: return 1.0
    if heavy_weapons <= 69: return 0.8
    if heavy_weapons <= 84: return 0.6
    if heavy_weapons <= 94: return 0.4
    if heavy_weapons <= 99: return 0.2
    return 0.0

def sniper_weapons_hit_chance(sniper_weapons):
    """returns hit chance factor depending on sniper skill"""
    assert sniper_weapons >= 1
    if sniper_weapons <= 10: return 0.4
    if sniper_weapons <= 29: return 0.6
    if sniper_weapons <= 44: return 0.8
    if sniper_weapons <= 54: return 1.0
    if sniper_weapons <= 69: return 1.2
    if sniper_weapons <= 84: return 1.4
    if sniper_weapons <= 94: return 1.6
    if sniper_weapons <= 99: return 1.8
    return 2.0

def sniper_weapons_speed(sniper_weapons):
    """returns weapon speed factor depending on sniper skill"""
    assert sniper_weapons >= 1
    if sniper_weapons <= 10: return 1.6
    if sniper_weapons <= 29: return 1.4
    if sniper_weapons <= 44: return 1.2
    if sniper_weapons <= 54: return 1.0
    if sniper_weapons <= 69: return 0.8
    if sniper_weapons <= 84: return 0.6
    if sniper_weapons <= 94: return 0.4
    if sniper_weapons <= 99: return 0.2
    return 0.0

def throw_weapons_hit_chance(throw_weapons):
    """returns hit chance factor depending on throw skill"""
    assert throw_weapons >= 1
    if throw_weapons <= 10: return 0.4
    if throw_weapons <= 29: return 0.6
    if throw_weapons <= 44: return 0.8
    if throw_weapons <= 54: return 1.0
    if throw_weapons <= 69: return 1.2
    if throw_weapons <= 84: return 1.4
    if throw_weapons <= 94: return 1.6
    if throw_weapons <= 99: return 1.8
    return 2.0

def throw_weapons_speed(throw_weapons):
    """returns weapon speed factor depending on throw skill"""
    assert throw_weapons >= 1
    if throw_weapons <= 10: return 1.6
    if throw_weapons <= 29: return 1.4
    if throw_weapons <= 44: return 1.2
    if throw_weapons <= 54: return 1.0
    if throw_weapons <= 69: return 0.8
    if throw_weapons <= 84: return 0.6
    if throw_weapons <= 94: return 0.4
    if throw_weapons <= 99: return 0.2
    return 0.0

def throw_weapons_miss_radius_factor(throw_weapons):
    """returns miss radius factor depending on throw skill"""
    assert throw_weapons >= 1
    if throw_weapons <= 10: return 0.6
    if throw_weapons <= 29: return 0.5
    if throw_weapons <= 44: return 0.4
    if throw_weapons <= 54: return 0.3
    if throw_weapons <= 69: return 0.2
    if throw_weapons <= 84: return 0.1
    if throw_weapons <= 94: return 0.05
    if throw_weapons <= 99: return 0.0
    return 0.0

def sneak_detection_factor(sneak):
    """returns sneak detection factor depending on sneak skill"""
    assert sneak >= 1
    if sneak <= 14: return 8.0
    if sneak <= 39: return 4.0
    if sneak <= 44: return 2.0
    if sneak <= 59: return 1.0
    if sneak <= 64: return 0.7
    if sneak <= 69: return 0.5
    if sneak <= 74: return 0.4
    if sneak <= 79: return 0.3
    if sneak <= 84: return 0.2
    if sneak <= 89: return 0.1
    if sneak <= 94: return 0.06
    if sneak <= 99: return 0.03
    return 0.03

def pick_pocket_success_front(pick_pocket):
    """returns pick pocket success modifier depending on pick pocket skill

basic success chance is 0.1 + this modifier
"""
    assert pick_pocket >= 1
    if pick_pocket <= 14: return -0.1
    if pick_pocket <= 39: return -0.05
    if pick_pocket <= 54: return 0
    if pick_pocket <= 69: return 0.1
    if pick_pocket <= 84: return 0.3
    if pick_pocket <= 94: return 0.5
    if pick_pocket <= 99: return 0.7
    return 0.7

def pick_pocket_success_back(pick_pocket):
    """returns pick pocket success modifier depending on pick pocket skill

basic success chance is 0.2 + this modifier
"""
    assert pick_pocket >= 1
    if pick_pocket <= 14: return -0.2
    if pick_pocket <= 39: return -0.1
    if pick_pocket <= 54: return 0
    if pick_pocket <= 69: return 0.2
    if pick_pocket <= 84: return 0.4
    if pick_pocket <= 94: return 0.6
    if pick_pocket <= 99: return 0.8
    return 0.8

def medicine_aloe_vera(medicine):
    """returns HP modifier for medicine_aloe_vera depending on alternative_medicine skill

HP healed is 4 HP + this modifier"""
    assert medicine >= 1
    if medicine <= 14: return 0
    if medicine <= 39: return 1
    if medicine <= 54: return 3
    if medicine <= 69: return 4
    if medicine <= 84: return 5
    if medicine <= 94: return 7
    if medicine <= 99: return 8
    return +8

def medicine_wood_garlic(medicine):
    """returns HP modifier for medicine_wood_garlic depending on alternative_medicine skill"""
    assert medicine >= 1
    if medicine <= 14: return 0
    if medicine <= 39: return 2
    if medicine <= 54: return 4
    if medicine <= 69: return 6
    if medicine <= 84: return 8
    if medicine <= 94: return 10
    if medicine <= 99: return 12
    return +12

def medicine_burnet(medicine):
    """HP healed is 8 HP + this modifier"""
    assert medicine >= 1
    if medicine <= 14: return 0
    if medicine <= 39: return 3
    if medicine <= 54: return 6
    if medicine <= 69: return 8
    if medicine <= 84: return 11
    if medicine <= 94: return 14
    if medicine <= 99: return 16
    return +16

def medicine_aloe_vera_ointmant(medicine):
    """returns HP modifier for medicine_aloe_vera depending on alternative_medicine skill

HP healed is 8 HP + this modifier"""
    assert medicine >= 1
    if medicine <= 14: return 0
    if medicine <= 39: return 3
    if medicine <= 54: return 6
    if medicine <= 69: return 8
    if medicine <= 84: return 11
    if medicine <= 94: return 14
    if medicine <= 99: return 16
    return +16

def medicine_wood_garlic_ointmant(medicine):
    """returns HP modifier for medicine_wood_garlic depending on alternative_medicine skill"""
    assert medicine >= 1
    if medicine <= 14: return 0
    if medicine <= 39: return 4
    if medicine <= 54: return 8
    if medicine <= 69: return 12
    if medicine <= 84: return 16
    if medicine <= 94: return 20
    if medicine <= 99: return 24
    return +24

def medicine_burnet_ointmant(medicine):
    """HP healed is 8 HP + this modifier"""
    assert medicine >= 1
    if medicine <= 14: return 0
    if medicine <= 39: return 6
    if medicine <= 54: return 12
    if medicine <= 69: return 16
    if medicine <= 84: return 22
    if medicine <= 94: return 28
    if medicine <= 99: return 32
    return +32

def medicine_medipack_standard(medicine):
    """returns HP modifier for small medipack depending on medicine skill

HP healed is 10 HP + this modifier
"""
    assert medicine >= 1
    if medicine <= 14: return -10
    if medicine <= 39: return -5
    if medicine <= 54: return 0
    if medicine <= 69: return +2
    if medicine <= 84: return +4
    if medicine <= 94: return +6
    if medicine <= 99: return +10
    return +10

def medicine_medipack_big(medicine):
    """returns HP modifier for big medipack depending on medicine skill

HP healed is 25 HP + this modifier
"""
    assert medicine >= 1
    if medicine <= 14: return -25
    if medicine <= 39: return -15
    if medicine <= 54: return 0
    if medicine <= 69: return +5
    if medicine <= 84: return +10
    if medicine <= 94: return +15
    if medicine <= 99: return +25
    return +25

def technic_combination_value(technic):
    """returns max. combination difficulty depending on technic skill"""
    assert technic >= 1
    return technic

def survival_water_dection_range(survival):
    """returns water detection range in meter depending on survival skill"""
    assert survival >= 1
    if survival <= 69: return 0.0
    if survival <= 84: return 30.0
    if survival <= 94: return 50.0
    if survival <= 99: return 80.0
    return 80.0
#
def get_attribute_skill_text( id, attribute, value ):
    """returns UI display strings for the attribute&skill effects"""
    text = ""
    attr_value = object.get_attribute( id, attribute )
### ATTRIBUTES ###
### STRENGTH ###
    if attribute=="strength":
        if value=="effect_1":# strength_max_load
            attr_value*=3
            text = globaltext.STRENGTH_EFFECT_1 % {"value":attr_value}
            return text
        if value=="effect_2":#  hit chance for heavy weapons depends on strength
            text = globaltext.STRENGTH_EFFECT_2 % {\
                "value":DtoS_pourc(strength_heavy_weapons_hitchance(attr_value))}
        if value=="effect_3":
            pass
        if value=="name":
            return globaltext.MISSION_ATTRIBUTE_NAME_STRENGTH
        if value=="name_short":
            return globaltext.MISSION_ATTRIBUTE_NAME_SHORT_STRENGTH
        if value=="hint":
            return "MISSION_ATTRIBUTE_STRENGTH_HINT"
### AGILITY ###
    if attribute=="agility":
        if value=="effect_1":# agility_move_speed : movement speed depends on agility
            text = globaltext.AGILITY_EFFECT_1 % {"value":DtoS_pourc(agility_move_speed(attr_value))}
        if value=="effect_2":# agility_armor : agility gives an armor bonus or malus
            text = globaltext.AGILITY_EFFECT_2 % {"value":DtoS(agility_armor(attr_value))}
        if value=="name":
            return globaltext.MISSION_ATTRIBUTE_NAME_AGILITY
        if value=="name_short":
            return globaltext.MISSION_ATTRIBUTE_NAME_SHORT_AGILITY
        if value=="hint":
            return "MISSION_ATTRIBUTE_AGILITY_HINT"

### DEXTERITY ###
    if attribute=="dexterity":
        if value=="effect_1":# dexterity_weapons_hitchance : weapon hit chance depends on dexterity (except heavy weapons depend on strength)
            text = globaltext.DEXTERITY_EFFECT_1 % {"value":DtoS_pourc(dexterity_weapons_hitchance(attr_value))}
        if value=="effect_2":# dexterity_weapons_speed : weapon speed (i.e. reload speed) depends on dexterity (except for heavy weapons)
            text = globaltext.DEXTERITY_EFFECT_2 % {\
                "value":DtoS_pourc_inv(dexterity_weapons_speed(attr_value))}
        if value=="name":
            return globaltext.MISSION_ATTRIBUTE_NAME_DEXTERITY
        if value=="name_short":
            return globaltext.MISSION_ATTRIBUTE_NAME_SHORT_DEXTERITY
        if value=="hint":
            return "MISSION_ATTRIBUTE_DEXTERITY_HINT"

### CONSTITUTION ###
    if attribute=="constitution":
        if value=="effect_1":# constitution_life_energy_start : how much HP a char starts with depends on constitution
            text = globaltext.CONSTITUTION_EFFECT_1 % {"value":DtoS(constitution_life_energy_start(attr_value))}
        if value=="effect_2":# constitution_life_energy_level : how much HP a char gets on level up depends on constitution
            text = globaltext.CONSTITUTION_EFFECT_2 % {"value":DtoS(constitution_life_energy_level(attr_value))}
        if value=="name":
            return globaltext.MISSION_ATTRIBUTE_NAME_CONSTITUTION
        if value=="name_short":
            return globaltext.MISSION_ATTRIBUTE_NAME_SHORT_CONSTITUTION
        if value=="hint":
            return "MISSION_ATTRIBUTE_CONSTITUTION_HINT"

### INTELLIGENCE ###
    if attribute=="intelligence":
        if value=="effect_1":# intelligence_skill_points : how much skill points a char gets at level up or character creation depends on intelligence
            text = globaltext.INTELLIGENCE_EFFECT_1 % {"value":DtoS(intelligence_skill_points(attr_value))}
        if value=="effect_2":
            pass
        if value=="name":
            return globaltext.MISSION_ATTRIBUTE_NAME_INTELLIGENCE
        if value=="name_short":
            return globaltext.MISSION_ATTRIBUTE_NAME_SHORT_INTELLIGENCE
        if value=="hint":
            return "MISSION_ATTRIBUTE_INTELLIGENCE_HINT"

### CHARISMA ###
    if attribute=="charisma":
        if value=="effect_1":# charisma_talk_bonus_factor : a char gets a bonus in his npc communication depending on his charisma.
            text = globaltext.CHARISMA_EFFECT_1 % {\
                "value":DtoS_pourc_inv(charisma_talk_bonus_factor(attr_value))}
        if value=="effect_2":
            pass
        if value=="name":
            return globaltext.MISSION_ATTRIBUTE_NAME_CHARISMA
        if value=="name_short":
            return globaltext.MISSION_ATTRIBUTE_NAME_SHORT_CHARISMA
        if value=="hint":
            return "MISSION_ATTRIBUTE_CHARISMA_HINT"

### SKILLS ###

### LIGHT WEAPONS ###
    if attribute=="light_weapons":
        if value=="effect_1":# light_weapons_speed
            text = globaltext.LIGHT_WEAPONS_EFFECT_1 % {"value":DtoS_pourc(light_weapons_speed(attr_value))}
        if value=="effect_2":# light_weapons_hit_chance
            text = globaltext.LIGHT_WEAPONS_EFFECT_2 % {
                "value":DtoS_pourc(light_weapons_hit_chance(attr_value))}
        if value=="effect_3":#
			pass
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_LIGHT_WEAPONS
        if value=="hint":
            return "MISSION_SKILL_LIGHT_WEAPONS_HINT"

### HEAVY WEAPONS ###
    if attribute=="heavy_weapons":
        if value=="effect_1":# heavy_weapons_speed
            text = globaltext.HEAVY_WEAPONS_EFFECT_1 % {"value":DtoS_pourc(heavy_weapons_speed(attr_value))}

        if value=="effect_2":#heavy_weapons_hit_chance
            text = globaltext.HEAVY_WEAPONS_EFFECT_2 % {
                "value":DtoS_pourc(heavy_weapons_hit_chance(attr_value))}
        if value=="effect_3":#
			pass
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_HEAVY_WEAPONS
        if value=="hint":
            return "MISSION_SKILL_HEAVY_WEAPONS_HINT"

### SNIPER WEAPONS ###
    if attribute=="sniper_weapons":
        if value=="effect_1":# sniper_weapons_speed
            text = globaltext.SNIPER_WEAPONS_EFFECT_1 % {"value":DtoS_pourc(sniper_weapons_speed(attr_value))}
        if value=="effect_2":#sniper_weapons_hit_chance
            text = globaltext.SNIPER_WEAPONS_EFFECT_2 % {\
                "value":DtoS_pourc(sniper_weapons_hit_chance(attr_value))}
        if value=="effect_3":#
			pass
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_SNIPER_WEAPONS
        if value=="hint":
            return "MISSION_SKILL_SNIPER_WEAPONS_HINT"

### THROW WEAPONS ###
    if attribute=="throw_weapons":
        if value=="effect_1":# throw_weapons_speed
            text = globaltext.THROW_WEAPONS_EFFECT_1 % {"value":DtoS_pourc(throw_weapons_speed(attr_value))}

        if value=="effect_2":# throw_weapons_hit_chance
            text = globaltext.THROW_WEAPONS_EFFECT_2 % {\
                "value":DtoS_pourc(throw_weapons_hit_chance(attr_value))}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_THROW_WEAPONS
        if value=="hint":
            return "MISSION_SKILL_THROW_WEAPONS_HINT"

### EXPLOSIVES ###
    if attribute=="explosives":
        if value=="effect_1":
            str = ""
            if attr_value >= 1 and attr_value <= 14: text = globaltext.EXPLOSIVES_EFFECT_1_A % {"value":"100 %"}
            elif attr_value >= 15 and attr_value <= 39: text = globaltext.EXPLOSIVES_EFFECT_1_A % {"value":"50 %"}
            elif attr_value >= 40 and attr_value <= 54: text = globaltext.EXPLOSIVES_EFFECT_1_B
            elif attr_value >= 55 and attr_value <= 69: text = globaltext.EXPLOSIVES_EFFECT_1_C
            elif attr_value >= 70 and attr_value <= 84: text = globaltext.EXPLOSIVES_EFFECT_1_D
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.EXPLOSIVES_EFFECT_1_D
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.EXPLOSIVES_EFFECT_1_D
        if value=="effect_2":
            str = ""
            if attr_value >= 85 and attr_value <= 94: text = globaltext.EXPLOSIVES_EFFECT_2
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.EXPLOSIVES_EFFECT_2
        if value=="effect_3":
            str = ""
            if attr_value >= 95 and attr_value <= 99: text = globaltext.EXPLOSIVES_EFFECT_3
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_EXPLOSIVES

        if value=="hint":
            return "MISSION_SKILL_EXPLOSIVES_HINT"

### SURVIVAL ###
    if attribute=="survival":
        if value=="effect_1":
            str = ""
            if attr_value >= 1 and attr_value <= 14: text = globaltext.SURVIVAL_EFFECT_1_A % {"value":"+ 40 %"}
            elif attr_value >= 15 and attr_value <= 39: text = globaltext.SURVIVAL_EFFECT_1_A % {"value":"+ 20 %"}
            elif attr_value >= 40 and attr_value <= 54: text = globaltext.SURVIVAL_EFFECT_1_B % {"value":"1"}
            elif attr_value >= 55 and attr_value <= 69: text = globaltext.SURVIVAL_EFFECT_1_B % {"value":"3"}
            elif attr_value >= 70 and attr_value <= 84: text = globaltext.SURVIVAL_EFFECT_1_B % {"value":"6"}
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.SURVIVAL_EFFECT_1_B % {"value":"8"}
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.SURVIVAL_EFFECT_1_B % {"value":"10"}

        if value=="effect_2":
            str = ""
            if attr_value >= 70 and attr_value <= 84: text = globaltext.SURVIVAL_EFFECT_2_A
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.SURVIVAL_EFFECT_2_B
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.SURVIVAL_EFFECT_2_C

        if value=="effect_3":
            str = ""
            if attr_value >= 70 and attr_value <= 84: text = globaltext.SURVIVAL_EFFECT_3 % {"value1":"10", "value2":"30"}
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.SURVIVAL_EFFECT_3 % {"value1":"10", "value2":"50"}
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.SURVIVAL_EFFECT_3 % {"value1":"10", "value2":"80"}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_SURVIVAL

        if value=="hint":
            return "MISSION_SKILL_SURVIVAL_HINT"

### SNEAK ###
    if attribute=="sneak":
        if value=="effect_1":#sneak_detection_factor
            text = globaltext.SNEAK_EFFECT_1 % {"value":DtoS_pourc_inv(sneak_detection_factor(attr_value))}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_SNEAK
        if value=="hint":
            return "MISSION_SKILL_SNEAK_HINT"

### TECHNIC ###
    if attribute=="technic":
        if value=="effect_1":
            str = ""
            if attr_value >= 1 and attr_value <= 54: text = globaltext.TECHNIC_EFFECT_1_A
            elif attr_value >= 55 and attr_value <= 69: text = globaltext.TECHNIC_EFFECT_1_B
            elif attr_value >= 70 and attr_value <= 84: text = globaltext.TECHNIC_EFFECT_1_C
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.TECHNIC_EFFECT_1_D
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.TECHNIC_EFFECT_1_E

        if value=="effect_2":
            str = ""
            if attr_value >= 1 and attr_value <= 14: text = globaltext.TECHNIC_EFFECT_2_A % {"value":"+ 60 %"}
            elif attr_value >=15 and attr_value <= 39: text = globaltext.TECHNIC_EFFECT_2_A % {"value":"+ 30 %"}
            elif attr_value >=40 and attr_value <= 54: text = globaltext.TECHNIC_EFFECT_2_B % {"value":"+- 0 %"}
            elif attr_value >=55 and attr_value <= 69: text = globaltext.TECHNIC_EFFECT_2_C % {"value":"+ 30 %"}
            elif attr_value >=70 and attr_value <= 84: text = globaltext.TECHNIC_EFFECT_2_C % {"value":"+ 60 %"}
            elif attr_value >=85 and attr_value <= 94: text = globaltext.TECHNIC_EFFECT_2_C % {"value":"+ 80 %"}
            elif attr_value >=95 and attr_value <= 99: text = globaltext.TECHNIC_EFFECT_2_C % {"value":"+ 90 %"}

        if value=="effect_3":
            str = ""
            if attr_value >= 55 and attr_value <= 69: text = globaltext.TECHNIC_EFFECT_3 % {"value":"+ 20 %"}
            elif attr_value >= 70 and attr_value <= 84: text = globaltext.TECHNIC_EFFECT_3 % {"value":"+ 40 %"}
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.TECHNIC_EFFECT_3 % {"value":"+ 60 %"}
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.TECHNIC_EFFECT_3 % {"value":"+ 80 %"}

        if value=="name":
            return globaltext.MISSION_SKILL_NAME_TECHNIC

        if value=="hint":
            return "MISSION_SKILL_TECHNIC_HINT"

### MEDICINE ###
    if attribute=="medicine":
        if value=="effect_1":# medicine_medipack_standard
            globaltext.MEDICINE_EFFECT_1_A % {"value":DtoS(medicine_medipack_standard(attr_value))}
        if value=="effect_2":# medicine_medipack_big
            globaltext.MEDICINE_EFFECT_2_C % {"value":DtoS(medicine_medipack_big(attr_value))}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_MEDICINE

        if value=="hint":
            return "MISSION_SKILL_MEDICINE_HINT"

### DRIVING ###
    if attribute=="driving":
        if value=="effect_1":
            str = ""
            if attr_value >= 1 and attr_value <= 54: text = globaltext.DRIVING_EFFECT_1_A
            elif attr_value >=55 and attr_value <= 69: text = globaltext.DRIVING_EFFECT_1_B % {"value":"+- 0 %"}
            elif attr_value >=70 and attr_value <= 84: text = globaltext.DRIVING_EFFECT_1_B % {"value":"+ 20 %"}
            elif attr_value >=85 and attr_value <= 94: text = globaltext.DRIVING_EFFECT_1_B % {"value":"+ 30 %"}
            elif attr_value >=95 and attr_value <= 99: text = globaltext.DRIVING_EFFECT_1_B % {"value":"+ 50 %"}
        if value=="effect_2":
            str = ""
            if attr_value >= 1 and attr_value <= 39: text = globaltext.DRIVING_EFFECT_2_A
            elif attr_value >=40 and attr_value <= 54: text = globaltext.DRIVING_EFFECT_2_B % {"value":"- 50 %"}
            elif attr_value >=55 and attr_value <= 69: text = globaltext.DRIVING_EFFECT_2_B % {"value":"- 20 %"}
            elif attr_value >=70 and attr_value <= 84: text = globaltext.DRIVING_EFFECT_2_B % {"value":"+- 0 %"}
            elif attr_value >=85 and attr_value <= 94: text = globaltext.DRIVING_EFFECT_2_B % {"value":"+ 20 %"}
            elif attr_value >=95 and attr_value <= 99: text = globaltext.DRIVING_EFFECT_2_B % {"value":"+ 50 %"}
        if value=="effect_3":
            str = ""
            if attr_value >= 1 and attr_value <= 39: text = globaltext.DRIVING_EFFECT_3_A
            elif attr_value >=40 and attr_value <= 54: text = globaltext.DRIVING_EFFECT_3_B % {"value":"+ 30 %"}
            elif attr_value >=55 and attr_value <= 69: text = globaltext.DRIVING_EFFECT_3_C
            elif attr_value >=70 and attr_value <= 84: text = globaltext.DRIVING_EFFECT_3_B % {"value":"- 10 %"}
            elif attr_value >=85 and attr_value <= 94: text = globaltext.DRIVING_EFFECT_3_B % {"value":"- 20 %"}
            elif attr_value >=95 and attr_value <= 99: text = globaltext.DRIVING_EFFECT_3_B % {"value":"- 30 %"}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_DRIVING

        if value=="hint":
            return "MISSION_SKILL_DRIVING_HINT"


### LOCK PICK ###
    if attribute=="lock_pick":
        if value=="effect_1":
            str = ""
            if attr_value >= 1 and attr_value <= 14: str = "- 75 %"
            elif attr_value >= 15 and attr_value <= 39: str = "- 50 %"
            elif attr_value >= 40 and attr_value <= 54: str = "+- 0 %"
            elif attr_value >= 55 and attr_value <= 69: str = "+ 30 %"
            elif attr_value >= 70 and attr_value <= 84: str = "+ 50 %"
            elif attr_value >= 85 and attr_value <= 94: str = "+ 70 %"
            elif attr_value >= 95 and attr_value <= 99: str = "+ 90 %"
            text = globaltext.LOCK_PICK_EFFECT_1 % {"value":str}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_LOCK_PICK
        if value=="hint":
            return "MISSION_SKILL_LOCK_PICK_HINT"

### PICK POCKET ###
    if attribute=="pick_pocket":
        if value=="effect_1":
            str = ""
            if attr_value >= 1 and attr_value <= 14: str = "- 80 %"
            elif attr_value >= 15 and attr_value <= 39: str = "- 50 %"
            elif attr_value >= 40 and attr_value <= 54: str = "+- 0 %"
            elif attr_value >= 55 and attr_value <= 69: str = "+ 30 %"
            elif attr_value >= 70 and attr_value <= 84: str = "+ 50 %"
            elif attr_value >= 85 and attr_value <= 94: str = "+ 70 %"
            elif attr_value >= 95 and attr_value <= 99: str = "+ 90 %"
            text = globaltext.PICK_POCKET_EFFECT_1 % {"value":str}
        if value=="effect_2":
            str = ""
            if attr_value >= 1 and attr_value <= 14: str = "- 80 %"
            elif attr_value >= 15 and attr_value <= 39: str = "- 50 %"
            elif attr_value >= 40 and attr_value <= 54: str = "+- 0 %"
            elif attr_value >= 55 and attr_value <= 69: str = "+ 30 %"
            elif attr_value >= 70 and attr_value <= 84: str = "+ 50 %"
            elif attr_value >= 85 and attr_value <= 94: str = "+ 70 %"
            elif attr_value >= 95 and attr_value <= 99: str = "+ 90 %"
            text = globaltext.PICK_POCKET_EFFECT_2 % {"value":str}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_PICK_POCKET

        if value=="hint":
            return "MISSION_SKILL_PICK_POCKET_HINT"


### CLOSE COMBAT ###
    if attribute=="close_combat":
        if value=="effect_1":# close_combat_weapons_hit_chance
            text = globaltext.CLOSE_COMBAT_EFFECT_1 % {\
                "value":DtoS_pourc(close_combat_weapons_hit_chance(attr_value))}
        if value=="effect_2":# close_combat_weapons_damage
            text = globaltext.CLOSE_COMBAT_EFFECT_2 % {\
                "value":DtoS_pourc(close_combat_weapons_damage(attr_value))}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_CLOSE_COMBAT

        if value=="hint":
            return "MISSION_SKILL_CLOSE_COMBAT_HINT"


### SPEECH ###
    if attribute=="speech":
        if value=="effect_1":
            if attr_value >= 1 and attr_value <= 14: text = globaltext.SPEECH_EFFECT_1_A
            elif attr_value >= 15 and attr_value <= 39: text = globaltext.SPEECH_EFFECT_1_B
            elif attr_value >= 40 and attr_value <= 54: text = globaltext.SPEECH_EFFECT_1_C
            elif attr_value >= 55 and attr_value <= 69: text = globaltext.SPEECH_EFFECT_1_D % {"value":"+ 50 %"}
            elif attr_value >= 70 and attr_value <= 84: text = globaltext.SPEECH_EFFECT_1_D % {"value":"+ 60 %"}
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.SPEECH_EFFECT_1_D % {"value":"+ 80 %"}
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.SPEECH_EFFECT_1_D % {"value":"+ 100 %"}
        if value=="effect_2":
            if attr_value >= 1 and attr_value <= 14: text = globaltext.SPEECH_EFFECT_2_A % {"value":"- 60 %"}
            elif attr_value >= 15 and attr_value <= 39: text = globaltext.SPEECH_EFFECT_2_A % {"value":"- 40 %"}
            elif attr_value >= 40 and attr_value <= 54: text = globaltext.SPEECH_EFFECT_2_B % {"value":"0 %"}
            elif attr_value >= 55 and attr_value <= 69: text = globaltext.SPEECH_EFFECT_2_C % {"value":"+ 20 %"}
            elif attr_value >= 70 and attr_value <= 84: text = globaltext.SPEECH_EFFECT_2_C % {"value":"+ 40 %"}
            elif attr_value >= 85 and attr_value <= 94: text = globaltext.SPEECH_EFFECT_2_C % {"value":"+ 60 %"}
            elif attr_value >= 95 and attr_value <= 99: text = globaltext.SPEECH_EFFECT_2_C % {"value":"+ 80 %"}
        if value=="name":
            return globaltext.MISSION_SKILL_NAME_SPEECH
        if value=="hint":
            return "MISSION_SKILL_SPEECH_HINT"

    return text

####################################################################################################
# other tables
####################################################################################################

def get_trade_text( trader_id, character_id, value ):
    """returns UI display strings for the charisma trading effects"""
    attr_value = object.get_attribute( character_id, "charisma" )
    if value=="line_1":# charisma_npc_bad_mood_time_factor
        text = globaltext.MISSION_TRADINGPANEL_DISADVANTAGE % {\
            "value1":DtoS_pourc(charisma_npc_bad_mood_time_factor(attr_value)), "value2": attr_value }
        return text
    elif value=="line_2":
        bonus_malus = {}
        if object.has_attribute(trader_id, "bonus_malus"):
            bonus_malus = object.get_attribute( trader_id, "bonus_malus")
            if character_id in bonus_malus:
                return globaltext.MISSION_TRADINGPANEL_BONUS_MALUS % {"value": bonus_malus[character_id]}
        return ""

def weapon_accustoming(id_kills, type_kills):
    """returns skill bonus for being accustomed to this weapon/weapon type"""
    if id_kills <= 9: id_bonus = 0
    elif id_kills <= 29: id_bonus = 5
    elif id_kills <= 59: id_bonus = 10
    elif id_kills <= 99: id_bonus = 15
    else: id_bonus = 20
    if type_kills <= 9: type_bonus = 0
    elif type_kills <= 29: type_bonus = 0
    elif type_kills <= 59: type_bonus = 5
    elif type_kills <= 99: type_bonus = 10
    else: type_bonus = 15
    return max(id_bonus, type_bonus)

