# -*- coding: utf-8 -*-
from global_defines import *
from npc_activities import *
import const
import global_schedules

#*********************************************************************
#		aktuelle revison: Rev 8, 08.07.2004
#*********************************************************************

################################################################################
## Tagesabläufe
################################################################################
def sqzone_1_working_on_plants_sound():
	return lambda c: sqzone_1_sound_helper(c, 1)
	
def sqzone_1_sound_helper(char, sound):
	if sound == 1:
		r = random.randint(0,10)
		if r <= 5:
			d = random.randint(0,10)
			if d <= 5:
				sounds.play_3d_sound_object(sfx_id="fissling_plants_1", object=char, loop = False)
			else:
				sounds.play_3d_sound_object(sfx_id="fissling_plants_2", object=char, loop = False)

schedules = {}

def init_schedules():
	global schedules
	schedules = {
################################################################################
#Michael_Collins
################################################################################
"MICHAEL_COLLINS":{
	#schlafen
	"22:00:00":{
		S_START  :(lay_down_to_sleep()),
		S_LOOP	 :(sleep()),
		},
	#Frühstück suchen und essen
	"09:00:00":{
		S_START  :[goto(254.86, 243.97),
				start_gut_body(),
				gut_body(),
				lambda char: character.play_animation(char, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE'),
				goto_object("BUILDING_110"),
				turn_to_object("BUILDING_110")
				],
		S_LOOP	 :[wash_laundry(),
				sqzone_1_working_on_plants_sound()],
	},
	#Vor der Kapsel sitzen und Funken
	"09:53:00":{
		S_START  :(goto_object("BUILDING_348"),
				turn_to_object("BUILDING_348"),
				start_kneel()),
		S_LOOP	 :(kneel()),
	},
	#Um Kapsel gehen und Sonnensegel kontrollieren
	"21:00:00":{
		S_START  :(),
		S_LOOP	 :(goto(252.00, 233.00), 
				turn_to_object("BUILDING_340"),
				stand("look_around"),
				goto(246.00, 231.00),
				turn_to_object("BUILDING_340"), 
				stand("look_around"),
				goto(252.00, 226.50), 
				turn_to_object("BUILDING_340"), 
				stand("look_around"),
				goto(256.00,230.00)),
	},
}}
	# update with global schedules
	schedules.update(global_schedules.update_schedules(schedules))

### wrapper functions, do not modify!
def Activity(id):
	return npc_activity(id, schedules)
	
def GetCurrentPlan(id):
	return npc_get_current_plan(id, schedules)
	
def Dialog(id, partymemberid):
	return npc_dialog(id, partymemberid, schedules)
