# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import schedules
import object_events
from const import *

#*********************************************************************
#		aktuelle revison: Rev 8, 08.07.2004
#*********************************************************************

def initParties():
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="UISPIELER",type=PT_HUMAN)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(314.0, 340.0),
	 		"SOUTH":	(314.0, 340.0),
	 		"WEST":		(314.0, 340.0),
	 		"EAST":		(314.0, 340.0),
	 	}
	return start_locations["SOUTH"]
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("orange")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Raumkapsel",265,225,235,250)
	
	data("rest").non_rest_areas.append("Raumkapsel")

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()
	npc.initNPCS()
	npc.initAnimals()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	initItems()
	initHerbs()
	initExitZones()
	initDialogZones()
	initFX()
	
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	initFoes()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_non_rest_areas()
	anim_apollo_kapsel()
	
	system.add_region("KAPSEL",265,225,235,250)
	system.notify_region_entered("KAPSEL", partyid="UISPIELER")
	
def anim_apollo_kapsel(objectid=None):
	object.play_animation('BUILDING_340','ANIM_APOLLO_KAPSEL',callback=['ONEND',anim_apollo_kapsel])
	#if not hasattr(data(),"windradsound"):
	#	data().windradsound=True
	#	sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_340', loop=True)
	
# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	system.mark_for_script_use('BUILDING_340')

	# Bienenst�cke SQZone 1
	
	

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		object.set_immortal_state(npc, True)
		
def initFoes():
	## animals sind feindlich und erstmal inactiv
	for animal in data().Animals:
		#print animal
		object.set_attribute(animal,"foes", ["UISPIELER"])
		
		
def initDialogZones():
	#system.add_region( id = data().Region_Kapsel_1, x1 = 249.00, y1 = 226.07, x2 = 254.07, y2 = 235.12 )
	#system.notify_region_entered(data().Region_Kapsel_1, partyid="UISPIELER")
	system.add_region( id = data().Region_Hoerweite, x1 = 225.00, y1 = 225.00, x2 = 266.00, y2 = 252.00 )
	system.notify_region_entered(data().Region_Hoerweite, partyid="UISPIELER")
	
def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)
	
def on_enter_region(id, objectid, partyid ):
	#print "[on_enter_region(",id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if id == "KAPSEL":
		if not data().player_knows_Raumkapsel:
			data().player_knows_Raumkapsel = True
			system.add_minimap_marker(249.99,230.44,"MM_001")# Raumkapsel
	
	if (id == data().Region_Hoerweite) and (not data().MichaelTot):
		system.notify_timer(data().Timer_Comment,data().Timervalue_Comment)
		system.notify_timer(data().Timer_IstInHoerweite,data().Timervalue_IstInHoerweite)

def on_object_killed(victim, attacker, weapon_type, weapon_id):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	if victim == "MICHAEL_COLLINS":
		data().MichaelTot = True
		
def on_timer(id):
	#print "[debug on_timer()",id,"]"
	if (id == data().Timer_Comment) and (not data().MichaelTot):
		clock = system.get_mission_time().get_day_time()
		if (clock >= time("10:00:00") and clock < time("22:00:00")):
			import random
			Text = random.choice(data().Funksprueche)
			if not dialog.is_dialog_active():
				if (not (Text == 'D_008_T_001'))and(clock > time("21:00:00")):
					dialog.init_dialog(type=DIALOGSMALL)
					dialog.add_text(text=Text, speaker="MICHAEL_COLLINS", follower='ENDDIALOG')
					dialog.start(False)
				else:
					dialog.init_dialog(type=DIALOGSMALL)
					dialog.add_text(text=Text, speaker="MICHAEL_COLLINS", follower='ENDDIALOG')
					dialog.start(False)
			
	elif id == data().Timer_IstInHoerweite:
		if Weg():
			system.notify_region_entered(data().Region_Hoerweite, partyid="UISPIELER")
		else:
			system.notify_timer(data().Timer_Comment,data().Timervalue_Comment)
		
		system.notify_timer(data().Timer_IstInHoerweite,data().Timervalue_IstInHoerweite)
	
def Weg():
	if ((object.get_x("ALTER_EGO")< 225.00) or (object.get_x("ALTER_EGO")> 266.00)
			and (object.get_y("ALTER_EGO")< 225.00) or (object.get_y("ALTER_EGO")> 252.00)):
		return True
	else:
		return False
		
def on_wait_for_commando(id):
	return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
	return False
## TODO: Dialog starten wen Klappe untersucht wird
def on_examine_object( character_id, object_id ):
	return False

def CanLeaveZone():
	return False

def initItems():
	## Normale Loot- Items
	## Raumkapsel
	object.create_item_in_inventory("BUILDING_111",	["SET_SOLAR_CELLS","SET_RUSTY_IRON_ROD","SET_RED_SHARD"])
	object.create_item_in_inventory("BUILDING_108",	["SET_LEATHER_CAP"])
	object.create_item_in_inventory("BUILDING_109",	["SET_COMPUTER_KEYBOARD"])
	## NPC tems
	##Mainquest NPCs
	object.create_item_in_inventory( 	object="MICHAEL_COLLINS",equipment=["SET_WALTER_PPK","SET_AMMOPACK_7_65_MM"])
	#weitere items
	#schrottplatz
	object.create_item_in_inventory("BUILDING_349",	["SET_IRON_PLATES","SET_BROKEN_SHOVEL"])
	#tisch raumkapsel
	object.create_item_in_inventory("BUILDING_348",	["SET_DUCT_TAPE","SET_APPLE"])
	#klo
	object.create_item_in_inventory("BUILDING_347",	["SET_WALTER_PPK","SET_AMMOPACK_7_65_MM"])
	
	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_597', equipment=[ 'SET_WATER_SKIN', 'SET_LEATHER_CAP', 'SET_BOTTLE_OF_HOOCH' ] )
	
	
def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x=259.85, y=243.52)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=334.79, y=269.6)
	system.create_object(equipmenttype="SET_BURNET", x=325.7, y=288.57)

def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 543.00, y2 = 200.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 543.00, y1 = 543.00, x2 = 200.00, y2 = 343.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 543.00, x2 = 200.00, y2 = 200.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 543.00, y1 = 200.00, x2 = 343.00, y2 = 343.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
	# brennende Tonne bei der Raumkapsel
	system.start_effect_object(object="BUILDING_346",node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object="BUILDING_346",loop=True)

def InitChestsSafes():
	object.add_closed_lock("BUILDING_597", "lock1", closure_type='normal')
	
def init_patch():
	if "ANIE" in system.get_npcs():
		data("zone_7.zone_7").anie_folgt = True
