# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
import schedules
from dynamic_camera import *

#*********************************************************************
#		aktuelle revison: Rev 2, 1.6.2004
#*********************************************************************

def on_approach( target, operator ):
	if dialog.is_dialog_active():
		return
	if schedules.Dialog( target, operator ):
		return

#Spieler untersucht einen Humvee erstmals
def initDlg_001_SpielerUntersuchtHumvee(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_001_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda(lambda_string))
	#,callback=Lambda("data().humveeuntersucht=0"))
	dialog.start()

#Spieler untersucht einen Humvee ein 2. mal
def initDlg_002_SpielerUntersuchtHumveeNochmals(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	lambda_humvee = 'HumveeUntersucht("'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_002_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback = [Lambda(lambda_string), 
												  Lambda(lambda_humvee)])
	dialog.start()

def HumveeUntersucht(object_id):
	data().HumveeUntersucht.append(object_id)

#Spieler untersucht weitere Humvees
def initDlg_003_SpielerUntersuchtWeiterenHumvee(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_003_T_001', speaker="ALTER_EGO", follower ='D_003_T_003')
	dialog.add_text(text='D_003_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda(lambda_string))
	dialog.start()

#Spieler untersucht den 3. 4. .... Humvee
def initDlg_003_SpielerUntersuchtNochWeitereHumvees(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_003_T_002', speaker="ALTER_EGO", follower ='D_003_T_003')
	dialog.add_text(text='D_003_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda(lambda_string))
	dialog.start()

#Spieler untersucht erstmals eine Leiche
def initCutsceneDlg_004_SpielerUntersuchtErstmalsLeiche(character_id, object_id):
	#print character_id, object_id
	if(object_id == 'SQZONE_2_BUILDING_390'):
		data().posX 	= 313.61
		data().posY 	= 342.30
		data().Direct 	= 60
		data().body   	= 'KNEEL'
		data().CamView_1= data().CamViews_390_1
		data().CamView_2= data().CamViews_390_2
	elif(object_id == 'SQZONE_2_BUILDING_387' or object_id == 'SQZONE_2_BUILDING_392'):
		data().posX = 317.35
		data().posY = 339.72
		data().Direct = 240
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_387_392_1
		data().CamView_2= data().CamViews_387_392_2
	elif(object_id == 'SQZONE_2_BUILDING_405'):
		data().posX = 315.19
		data().posY = 331.56
		data().Direct = 280
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_405_1
		data().CamView_2= data().CamViews_405_2
	elif(object_id == 'SQZONE_2_BUILDING_406'):
		data().posX = 310.82
		data().posY = 332.20
		data().Direct = 60
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_406_1
		data().CamView_2= data().CamViews_406_2
	elif(object_id == 'SQZONE_2_BUILDING_403'):
		data().posX = 308.88
		data().posY = 320.34
		data().Direct = 90
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_403_1
		data().CamView_2= data().CamViews_403_2
	elif(object_id == 'SQZONE_2_BUILDING_404'):
		data().posX = 308.88
		data().posY = 320.34
		data().Direct = 90
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_404_1
		data().CamView_2= data().CamViews_404_2
	elif(object_id == 'SQZONE_2_BUILDING_395'):
		data().posX = 314.83
		data().posY = 312.31
		data().Direct = 80
		data().body   	= 'KNEEL'
		data().CamView_1= data().CamViews_395_1
		data().CamView_2= data().CamViews_395_2
	elif(object_id == 'SQZONE_2_BUILDING_389'):
		data().posX = 310.72
		data().posY = 304.16
		data().Direct = 50
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_389_1
		data().CamView_2= data().CamViews_389_2
	elif(object_id == 'SQZONE_2_BUILDING_388'):
		data().posX = 314.12
		data().posY = 301.74
		data().Direct = 270
		data().body   	= 'STAND'
		data().CamView_1= data().CamViews_388_1
		data().CamView_2= data().CamViews_388_2
	elif(object_id == 'SQZONE_2_BUILDING_394'):
		data().posX = 310.45
		data().posY = 286.98
		data().Direct = 291
		data().body   	= 'KNEEL'
		data().CamView_1= data().CamViews_394_1
		data().CamView_2= data().CamViews_394_2
	
	onCutsceneDlg_004_SpielerUntersuchtErstmalsLeiche(character_id, object_id)
	
def onCutsceneDlg_004_SpielerUntersuchtErstmalsLeiche(character_id, object_id):
	lambda_string_390 = """object.turn_to_direction('ALTER_EGO',data().Direct , callback = ['ONEND', Lambda('character.change_body_mode("ALTER_EGO", "'+ data().body +'")')] )"""
	lambda_string_Dialog = 'onCutsceneDlg_004_SpielerUntersuchtErstmalsLeiche_("'+ character_id+ '","'+ object_id +'")'
	system.start_cutscene()
	system.set_camera_view(data().CamView_1)
	object.move_to('ALTER_EGO', data().posX, data().posY, callback = ['ONEND', Lambda(lambda_string_390)])
	object.move_to('ALTER_EGO', data().posX, data().posY, callback = ['ONEND', Lambda(lambda_string_Dialog)])
	
def onCutsceneDlg_004_SpielerUntersuchtErstmalsLeiche_(character_id, object_id):
	lambda_string = 'endCutsceneDlg_004("'+ character_id +'","'+ object_id +'")'
	lambda_string_CamView_2 = 'system.set_camera_view(data().CamView_2)'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_004_T_001', speaker="ALTER_EGO", callback = Lambda(lambda_string_CamView_2))
	dialog.add_text(text='D_004_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_004_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_004_T_004', speaker="ALTER_EGO", follower='ENDDIALOG', callback = Lambda(lambda_string))
	dialog.start()

def endCutsceneDlg_004(character_id, object_id):
	lambda_string_Pannel = 'endCutsceneDlg_004_Pannel("'+ character_id +'","'+ object_id +'")'
	character.change_body_mode("ALTER_EGO", "STAND")
	object.turn_to_direction('ALTER_EGO', data().Direct, callback = ['ONEND', Lambda(lambda_string_Pannel)])

def endCutsceneDlg_004_Pannel(character_id, object_id):
	end_cutscene()
	onInit_Pannel(character_id, object_id)

#Spieler untersucht zweite Leiche
def initDlg_005_SpielerUntersuchtWeitereLeiche(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_005_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_005_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda(lambda_string))
	dialog.start()

#Spieler untersucht weiter Leichen
def initDlg_005_SpielerUntersuchtWeitereLeichen(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_005_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_005_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda(lambda_string))
	dialog.start()

#Spieler untersucht eine Leiche ein zweites mal
def initDlg_006_SpielerUntersuchtLeicheErneut(character_id, object_id):
	lambda_string = 'onInit_Pannel("'+ character_id +'","'+ object_id +'")'
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_006_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda(lambda_string))
	dialog.start()

def initDlg_007_Zone_Verlassen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_007_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_007_Zone_Verlassen)
	dialog.start()

def onDlg_007_Zone_Verlassen():
	if was_zone_entered('zone_3.zone_3'):
		system.set_qb_entry_state(data('zone_3.zone_3').QB_024, IMPOSSIBLE)

## Inventar öffnet sich wenn eine Leiche oder ein Humvee ein zweites mal untersucht wird nach dem Dialog
def onInit_Pannel(character_id, object_id):
	for substring in HUMVEES:
		if object_id.endswith(substring):
			### Inventar öffnet wenn was drin ist ###
			inventorylist = object.get_inventory_list(object_id)
			if inventorylist:
				#show object inventory
				system.item_panel( character_id, object_id )
	for substring in LEICHEN:
		if object_id.endswith(substring):
			### Inventar öffnet wenn was drin ist ###
			inventorylist = object.get_inventory_list(object_id)
			if inventorylist:
				#show object inventory
				system.item_panel( character_id, object_id )
			

