# -*- coding: utf-8 -*-
from globals import *
import npc
import water
import dialogs
from const import *
import schedules
import object_events
import system_events

#*********************************************************************
#		aktuelle revison: Rev 2, 1.6.2004
#*********************************************************************

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="NPCS",type=PT_COMPUTER)


def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(342.0, 203.0),
	 		"SOUTH":	(345.0, 405.0),
	 		"WEST":		(345.0, 405.0),
	 		"EAST":		(369.0, 307.0),
			#"EAST":		(301.0, 400.0),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection
def GetZoneEnterLocationVehicles(enterdirection):
	start_locations = \
		{	"NORTH":	(339.17, 388.97),
	 		"SOUTH":	(335.87, 223.87),
	 		"WEST":		(368.91, 296.12),
	 		"EAST":		(339.17, 388.97),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("orange")
		
def initWaterResources():
	water.set_water_source(245.1, 395.9, 1)

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	npc.initNPCS()
	npc.initAnimals()
	system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	initItems()
	initHerbs()
	initExitZones()
	initFX()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	init_character_states()	
	init_non_rest_areas()
	
	system.add_region("KONVOI",302,292,320,350)
	system.notify_region_entered("KONVOI", partyid="UISPIELER")


# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	#system.mark_for_script_use(id)
	pass
	# Bienenstöcke SQZone 2

	

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		object.set_immortal_state(npc, True)	

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)
	
def on_enter_region(id, objectid, partyid ):
	#print "[on_enter_region(",id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
		
	if id == "KONVOI":
		if not data().player_knows_Konvoi:
			data().player_knows_Konvoi = True
			system.add_minimap_marker(311.65, 325.95,"MM_001")# Konvoi

def on_timer(id):
	#print "[debug on_timer()",id,"]"
	if (id == data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		if (clock < time("16:00:00") or clock > time("23:00:00")):
			npc.spawnAnimals(INACTIVE)
		else:
			npc.spawnAnimals(ACTIVE)
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

## Feuereffekte: brennende Tonne
def fxBrennendeTonne(_objectid):
	system.start_effect_object(object=_objectid,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)

def on_wait_for_commando(id):
	return schedules.Activity(id)

def CanLeaveZone():
	return False


def initItems():
	### Objecte ###
	# Location: Umgehungsstraße Tonne
	object.create_item_in_inventory( "BUILDING_185", ["SET_COOKING_POT"])
	# Location: Umgehungsstraße Grab
	object.create_item_in_inventory( "BUILDING_192", ["SET_BOTTLE_OF_BOOZE"])
	# Location: Umgehungsstraße Fass 
	object.create_item_in_inventory( "BUILDING_70", ["SET_MOLOTOV_COCKTAIL", "SET_MOLOTOV_COCKTAIL"])
	# Location: Kiste Anfang Umgehungsstraße									
	object.create_item_in_inventory( "BUILDING_195", ["SET_MOLOTOV_COCKTAIL", "SET_THROWING_KNIFE"])
	
	### Humvees ###							
	object.create_item_in_inventory( "BUILDING_385", ['SET_AMMOPACK_2_12_MM', 'SET_KNIFE'])
	object.create_item_in_inventory( "BUILDING_386", [ 'SET_AMMOPACK_2_12_MM', 'SET_AMMOPACK_45'])
	object.create_item_in_inventory( "BUILDING_407", ['SET_UZI', 'SET_AMMOPACK_9_MM_SUBSONIC'])
	object.create_item_in_inventory( "BUILDING_408", [ 'SET_AMMOPACK_45', 'SET_KNIFE'])
	### NPCs Leichen ###							
	object.create_item_in_inventory( "BUILDING_387", ['SET_MAC_10', 'SET_AMMOPACK_45'])
	object.create_item_in_inventory( "BUILDING_388", ['SET_UZI', 'SET_AMMOPACK_9_MM', 'SET_UZI_W_SILENCER'])
	object.create_item_in_inventory( "BUILDING_390", ['SET_REMINGTON_M870', 'SET_AMMOPACK_2_12_MM', 'SET_AMMOPACK_2_12_MM_QB_8'])
	object.create_item_in_inventory( "BUILDING_392", ['SET_MICRO_UZI', 'SET_AMMOPACK_9_MM'])
	object.create_item_in_inventory( "BUILDING_395", ['SET_COLT_ANACONDA', 'SET_AMMOPACK_44'])
	object.create_item_in_inventory( "BUILDING_403", ['SET_UZI', 'SET_AMMOPACK_9_MM'])
	object.create_item_in_inventory( "BUILDING_404", ['SET_MP5', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM_SUBSONIC'])
	object.create_item_in_inventory( "BUILDING_406", ['SET_MP5', 'SET_AMMOPACK_9_MM'])

def initHerbs():
	system.create_object(equipmenttype="SET_ANGELICA", x=247.59, y=393.21)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=276.30, y=328.53)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=399.28, y=227.91)
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 580.00, y2 = 200.0 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 0.00, y1 = 407.00, x2 = 580.00, y2 = 600.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 0.00, x2 = 200.00, y2 = 600.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 408.00, y1 = 0.00, x2 = 580.00, y2 = 600.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
	# brennende Tonne Ende Umgehung
	fxBrennendeTonne("BUILDING_68")
	# brennende Tonne weit im Süden in der Exit Zone
	#fxBrennendeTonne("BUILDING_65")
	# brennende Tonne weit im Süden in der Exit Zone
	#fxBrennendeTonne("BUILDING_66")

#examine zone objects	
def can_examine_object( character_id, object_id ) :
	"returns true if the object can be examined "\
	"character_id - id of the character "\
	"object_id - id of the object"
	for substring in ["BUILDING_190", 'BUILDING_185', 'BUILDING_192']:	
		if object_id.endswith(substring):
			return True
	for substring in HUMVEES:
		if object_id.endswith(substring):
			return True
	for substring in LEICHEN:
		if object_id.endswith(substring):
			return True

def on_examine_object( character_id, object_id ):
	"called if an item is examined by a character "\
	"character_id - id of the character "\
	"object_id - id of the object"
	# Inventarliste für Sonstige Objecte
	for substring in ["BUILDING_190", 'BUILDING_185', 'BUILDING_192' ]:	
		if object_id.endswith(substring):
			### Inventar öffnet wenn was drin ist ###
			inventorylist = object.get_inventory_list(object_id)
			if inventorylist:
				#show object inventory
				system.item_panel( character_id, object_id )
			
	#Humvees untersuchen
	for substring in HUMVEES:
		if object_id.endswith(substring):
			CHARACTER_ID_DIALOG = character_id
			OBJECT_ID_DIALOG = object_id
			if not object_id in data().humveeuntersucht:
				if (len(data().humveeuntersucht) < 1):
					data().humveeuntersucht.append(object_id)
					dialogs.initDlg_001_SpielerUntersuchtHumvee(character_id, object_id)
				else:
					if (data().weitererhumveeuntersucht == 0):
						data().humveeuntersucht.append(object_id)
						dialogs.initDlg_003_SpielerUntersuchtWeiterenHumvee(character_id, object_id)
						data().weitererhumveeuntersucht = 1
					else:
						data().humveeuntersucht.append(object_id)
						dialogs.initDlg_003_SpielerUntersuchtNochWeitereHumvees(character_id, object_id)
			else:	
				if not object_id in data().HumveeUntersucht :
					dialogs.initDlg_002_SpielerUntersuchtHumveeNochmals(character_id, object_id)
				else: 
					dialogs.onInit_Pannel(character_id, object_id)
				
	#Leichen untersuchen
	for substring in LEICHEN:
		if object_id.endswith(substring):
			if not object_id in data().leicheuntersucht:
				if (len(data().leicheuntersucht) < 1):
					data().leicheuntersucht.append(object_id)
					dialogs.initCutsceneDlg_004_SpielerUntersuchtErstmalsLeiche(character_id, object_id)
				else:
					if (data().weitereleicheuntersucht == 0):
						data().leicheuntersucht.append(object_id)
						dialogs.initDlg_005_SpielerUntersuchtWeitereLeiche(character_id, object_id)
						data().weitereleicheuntersucht = 1
					else:
						data().leicheuntersucht.append(object_id)
						dialogs.initDlg_005_SpielerUntersuchtWeitereLeichen(character_id, object_id)
			else:	
				dialogs.initDlg_006_SpielerUntersuchtLeicheErneut(character_id, object_id)

def on_pick_up( character_id, item_id, item_type ):
	return True

def on_region_click(regionname, x, y):
	if regionname in ['REGION_EXIT_NORD', 'REGION_EXIT_WEST', 'REGION_EXIT_SUED', 'REGION_EXIT_OST']:
		if (len(data().humveeuntersucht) >= 1) and (len(data().leicheuntersucht) >= 1) and not data().Dlg_007_Gelaufen:
			data().Dlg_007_Gelaufen = True
			dialogs.initDlg_007_Zone_Verlassen()
			return None
	
	system_events.on_region_click(regionname, x, y)
	

def init_patch():
	if "ANIE" in system.get_npcs():
		data("zone_7.zone_7").anie_folgt = True

	for animal in ["ANIMAL_ANTILOPE_001","ANIMAL_ANTILOPE_002","ANIMAL_ANTILOPE_003"]:
		if object.exists(animal): # and not object.is_destroyed(animal):
			object.set_attribute(animal,"foes", ["UISPIELER"])
