# -*- coding: utf-8 -*-
from globals import *
from npc_activities import *
from const import *
import global_schedules
import enemy_script
import const

#*** aktuelle revison: Rev 3, 15.06.2004 *********************************

def switchCondition(id):
	return True

def setAshtonMode(mode):
	if mode == "diesel":
		if data().ashton_klaut_diesel:
			return Lambda('data().ashton_klaut_diesel = False')
		else:
			return Lambda('data().ashton_klaut_diesel = True')
	else:
		if data().ashton_winkt:
			return Lambda('data().ashton_winkt = False')
		else:
			return Lambda('data().ashton_winkt = True')


def ashton_der_verraeter_start():
	return lambda c: ashton_ta_helper(c, "start")

def ashton_der_verraeter_loop():
	return lambda c: ashton_ta_helper(c, "loop")

def ashton_der_verraeter_ende():
	return lambda c: ashton_ta_helper(c, "ende")

def check_ashton_equip():
	if object.count_in_inventory("ASHTON", "ASHTONS_WATER_CANISTER"):
		if not character.is_equiped("ASHTON", "ASHTONS_WATER_CANISTER"):
			character.equip("ASHTON", "ASHTONS_WATER_CANISTER")
	enemy_script.delay(1.0, Lambda('ashton_ta_start_moving("ASHTON")'))

def ashton_ta_start_moving(char):
	object.move_to(char, 373.32, 226.48, grid="landscape", speed=MT_FAST)
	object.turn_to_object(char, "SQZONE_3_BUILDING_1366", callback=['ONEND', ashton_ta_start])

def ashton_ta_start(char):
	if object.count_in_inventory(char, "ASHTONS_WATER_CANISTER"):
		object.drop_item(char, "ASHTONS_WATER_CANISTER")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_START")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_LOOP")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_LOOP")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_LOOP")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_LOOP")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_LOOP")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_LOOP")
	character.play_animation(char, "CM_NPC_GEHEN_KANISTER_AUFTANKEN_ENDE", callback=['ONEND',ashton_ta_done])

def ashton_ta_helper(char, mode="start"):
	if mode == "start":
		if not object.exists("ASHTONS_WATER_CANISTER"):
			if not object.count_in_inventory(char, "ASHTONS_WATER_CANISTER"):
				object.create_item_in_inventory(char, "SET_WATER_CANISTER", "ASHTONS_WATER_CANISTER")
		enemy_script.delay(1.0, Lambda('check_ashton_equip()'))
		return "perform_wait_command"
	
	elif mode=="loop":
		return "perform_wait_command"
	
	else:
		if object.count_in_inventory(char, "ASHTONS_WATER_CANISTER"):
			if character.is_equiped(char, "ASHTONS_WATER_CANISTER"):
				character.unequip(char, "ASHTONS_WATER_CANISTER")
			object.remove_item_from_inventory(char, "ASHTONS_WATER_CANISTER")
		return "perform_wait_command"

def ashton_ta_done(char):
	object.pick_up_item(char, "ASHTONS_WATER_CANISTER")
	object.move_to(char, 355.60, 225.88, grid="landscape", speed=MT_FAST)
	object.turn_to_direction(char, globals.DIR_NORTH_WEST)

### Tagesabläufe
schedules = {}

def init_schedules():
	global schedules
	schedules = {
		"MERCENARY_STORM" : {
			"00:00:00":{
				S_START  :[goto_dummy("SQZONE_3_BUILDING_162","dmyp_001"),
						   sit_down_on_bench()],
				S_LOOP   :[sit_on_bench()],
						},
				},
		"MERCENARY_SAND" : {
			"00:00:00":{
				S_START  :[goto_dummy("SQZONE_3_BUILDING_162","dmyp_003"),
						   sit_down_on_bench()],
				S_LOOP   :[sit_on_bench()],
						},
				},
		"GEORGE_P_SMYTHES" : ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Schlafen
			"22:00:00":{
				S_START  :(goto(390,315),
						lay_down_to_sleep("BUILDING_978")),
				S_LOOP   :(sleep()),
			},
			#Andacht auf dem Abstellgleis
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_SMYTHES_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_21"),
						goto(330,252),
						turn_to_position(325.35,253.42)),
				S_LOOP   :(stand(), conversate(TANPCS_ANDACHT)),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_SMYTHES_T_002',
				S_START  :(goto(210,324),
						turn_to_position((208,328)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Vor dem Schaffnerhäuschen sitzen
			"09:00:00":{
				S_DIALOG : 'NPC_SMYTHES_T_003',
				S_START	 :(goto(410.83,252.46),
						turn_to_direction(DIR_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Andacht auf dem Abstellgleis
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_SMYTHES_T_003',
				S_START  :(goto(330,252),
						turn_to_position(325.35,253.42)),
				S_LOOP   :(stand(), conversate(TANPCS_ANDACHT)),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_SMYTHES_T_004',
				S_START  :(goto(210,324),
						turn_to_position((208,328)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Freizeit (Lagerfeuer, etc.)
			"20:00:00":{
				S_DIALOG : 'NPC_SMYTHES_T_005',
				S_START  :(goto_dummy("SQZONE_3_BUILDING_173", "dmyp_002"),
						sit_down_on_bench()),
				S_LOOP   :(read_book_on_bench()),
			},
			S_SECONDDIALOG : 'NPC_SMYTHES_T_006'
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(conversate(TANPCS_ANDACHT)),
				S_NOSTOP	: [1,2]
			}
		}
		),
		"ASHTON": {
			#Schlafen
			"01:30:00":{
				S_START  :(ashton_der_verraeter_ende(), 
							setAshtonMode("diesel"),
							goto(230,361),
							enter_building("SQZONE_3_BUILDING_869"),
							turn_to_direction(DIR_WEST),
							lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_ASHTON_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_869"),
						goto(208,326),
						turn_to_position((206,328)),
						sit_down_on_ground()),				
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Im Dorf rumlaufen
			"08:30:00":{
				S_DIALOG : 'NPC_ASHTON_T_002',
				S_START  :(),
				S_LOOP   :(patrol(ROUTE_ASHTON),
						stand()),
			},
			"09:00:00":{
				S_DIALOG : 'NPC_ASHTON_T_002',
				S_START	 :(goto(364.64,232.84,speed=MT_FAST),
						turn_to_direction(DIR_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			"10:30:00":{
				S_DIALOG : 'NPC_ASHTON_T_002',
				S_START  :(),
				S_LOOP   :(patrol(ROUTE_ASHTON),
						stand()),
			},
			#Von einem der zu vermessenden Hügel winken
			"16:30:00":{
				S_DIALOG : 'NPC_ASHTON_T_003',
				S_START  :(setAshtonMode("signal"),
						goto(474,450),
						turn_to_position((420,428)),
						start_wave()),
				S_LOOP   :(wave()),
			},
			#Abendessen
			"19:00:00":{
				S_DIALOG : 'NPC_ASHTON_T_004',
				S_START  :(setAshtonMode("signal"),
						goto(208,326),
						turn_to_position((206,326)),
						sit_down_on_ground()),				
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Freizeit
			"20:00:00":{
				S_DIALOG : 'NPC_ASHTON_T_005',
				S_START  :(goto(233,362),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground("ramdom")),
			},
			#Diesel klauen und verhökern
			#Erweitern!!!
			"22:30:00":{
				S_DIALOG : 'NPC_ASHTON_T_006',
				S_START  :(setAshtonMode("diesel"),
						ashton_der_verraeter_start()),
				S_LOOP   :(ashton_der_verraeter_loop()),
			},
			S_SECONDDIALOG : 'NPC_ASHTON_T_007'
		},
		
		"GANGER_1": {
			"23:00:00" : {
				S_START : (goto(353.64, 225.66,speed=MT_FAST),
					turn_to_object("ASHTON")
				),
				S_LOOP  : (
					turn_to_object("ASHTON"),
					stand()
				)
			},
			"01:00:00":{
				S_START : (goto(248.93, 197.96,speed=MT_SLOW),
					lambda _c_: object.set_active_state(_c_,0)
				),
				S_LOOP  : (
				)
			}
		},
		
		"GANGER_2": {
			"23:00:00" : {
				S_START : (goto(355.10, 223.83,speed=MT_FAST),
					turn_to_object("ASHTON")
				),
				S_LOOP  : (
					turn_to_object("ASHTON"),
					stand()
				)
			},
			"01:00:00":{
				S_START : (goto(249.18, 196.56,speed=MT_SLOW),
					lambda _c_: object.set_active_state(_c_,0)
				),
				S_LOOP  : (
				)
			}
		},
		
		"WILLIAM_SQZ3": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Andacht
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_WILLIAM_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_1288"),
						goto(323,251),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_WILLIAM_T_002',
				S_START  :(goto_dummy("SQZONE_3_BUILDING_169","dmyp_001"),
						sit_down_on_bench()),
				S_LOOP   :(sit_eat_drink_on_bench),
			},
			#Jagen
			"09:00:00":{
				S_DIALOG : 'NPC_WILLIAM_T_003',
				S_START  :(goto(352,406),
						goto(373,368),
						stand("look_around"),
						start_hunt()),
				S_LOOP   :(hunt()),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_WILLIAM_T_004',
				S_START  :(end_hunt(),
						goto(323,251),
						turn_to_position(330,252),
						sit_down_on_ground()),				
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_WILLIAM_T_005',
				S_START  :(goto_dummy("SQZONE_3_BUILDING_169","dmyp_001"),
						sit_down_on_bench()),
				S_LOOP   :(sit_eat_drink_on_bench),
			},
			#Freizeit/Lagerfeuer	
			"20:00:00":{
				S_DIALOG : 'NPC_WILLIAM_T_006',
				S_START  :(goto(485,272),
						turn_to_direction(DIR_SOUTH),
						sit_down_to_play_cards()),
				S_LOOP   :(play_cards()),
			},
			#Schlafen
			"22:00:00":{
				S_START  :(goto(423,346),
						enter_building("SQZONE_3_BUILDING_1288"),# In den Container kann keiner rein
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_WILLIAM_T_007'
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1,2]
			}
		}),
		"HAROLD": (
			{
				S_CONDITION: lambda: not const.AndachtLaeuft,
				#Andacht
				"05:00:00"	: {
					S_LOCATION	: 1,
					S_DIALOG		: ('NPC_HAROLD_T_001'),
					S_START		: (leave_building("SQZONE_3_BUILDING_1294"), goto(326.45,252.56), turn_to_position(330,252), sit_down_on_ground()),
					S_LOOP		: (sit_on_ground()),
				},
				#Frühstück
				"07:00:00"	: {
					S_DIALOG		: ('NPC_HAROLD_T_002'),
					S_START		: (goto(503,295), turn_to_direction(DIR_SOUTH), sit_down_on_ground()),
					S_LOOP		: (sit_eat_drink_on_ground),
				},
				#Wasser suchen
				"09:00:00":{
					S_DIALOG : 'NPC_HAROLD_T_003',
					S_START  :(goto_find_water(326,349)),
					S_LOOP   :(find_water()),
				},
				#Andacht
				"16:00:00":{
					S_LOCATION	: 2,
					S_DIALOG : 'NPC_HAROLD_T_004',
					S_START  :(goto(326.45,252.56), turn_to_position(330,252), sit_down_on_ground()),
					S_LOOP   :(sit_on_ground()),
				},
				#Abendessen
				"18:00:00":{
					S_DIALOG : 'NPC_HAROLD_T_005',
					S_START  :(goto(503,295), turn_to_direction(DIR_SOUTH), sit_down_on_ground()), 
					S_LOOP   :(sit_eat_drink_on_ground),
				},
				#Freizeit/Lagerfeueraction
				"20:00:00":{
					S_DIALOG : 'NPC_HAROLD_T_006',
					S_START  :(goto_dummy("BUILDING_168",'dmyp_001'), sit_down_on_bench()),
					S_LOOP   :(sit_on_bench()),
				},
				#Schlafen
				"22:00:00":{
					S_START  :(goto(418,316), enter_building("SQZONE_3_BUILDING_1294"), lay_down_to_sleep()),
					S_LOOP   :(sleep()),
				},
				S_SECONDDIALOG : 'NPC_HAROLD_T_007'
			},
			{
				"00:00:00":{
					S_START	:(),
					S_LOOP	:(sit_on_ground()),
					S_NOSTOP	: [1,2]
				}
			}
		),
		"JEREMY": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Andacht
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_JEREMY_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_1362"),
						goto(335,251),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_JEREMY_T_002',
				S_START  :(goto(209,321),
						turn_to_position((206,326)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Holz fällen
			"09:00:00":{
				S_DIALOG : 'NPC_JEREMY_T_003',
				S_START  :(goto(269.69,341.16),
						turn_to_position((270.65,340.07)),
						start_chop_wood()),
				S_LOOP   :(chop_wood()),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_JEREMY_T_004',
				S_START  :(goto(325,251),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),		
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_JEREMY_T_005',
				S_START  :(goto(209,321),
						turn_to_position((206,326)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Freizeit
			"20:00:00":{
				S_DIALOG : 'NPC_JEREMY_T_006',
				S_START  :(goto(286.51,339.40),
						turn_to_direction(DIR_SOUTH_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground("random")),
			},
			#Schlafen
			"22:00:00":{
				S_START  :(goto(287,336),
						enter_building("SQZONE_3_BUILDING_1362"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_JEREMY_T_007'		
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1,2]
			}
		}),
		"MATTHEW": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Andacht
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_MATTHEW_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_1293"),
						goto(327.48,253.75),
						turn_to_position(330,252),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_MATTHEW_T_002',
				S_START  :(goto(498.27,300.45),
						turn_to_direction(DIR_WEST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),				
			},
			#Im Dorf rumwerkeln
			#Verbessern!!!
			#Erweitern!!!
			"09:00:00":{
				S_DIALOG : 'NPC_MATTHEW_T_003',
				S_START  :(goto(434.58,327.51),
						turn_to_direction(DIR_EAST),
						start_shovel_sand()),
				S_LOOP   :(shovel_sand()),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_MATTHEW_T_004',
				S_START  :(goto(327.48,253.75),
						turn_to_position(330,252),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_MATTHEW_T_005',
				S_START  :(goto(492.57,299.14),
						turn_to_direction(DIR_WEST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),				
			},
			#Freizeit/Lagerfeueraction
			"20:00:00":{
				S_DIALOG : 'NPC_MATTHEW_T_006',
				S_START  :(goto(490.76,298.39),
						turn_to_direction(DIR_NORTH),
						sit_down_to_play_cards()),
				S_LOOP   :(play_cards()),
			},
			#Schlafen
			"22:00:00":{
				S_START  :(goto(403,310),
						enter_building("SQZONE_3_BUILDING_1293"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_MATTHEW_T_007'		
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1,2]
			}
		}),
		"HUCKLEBERRY": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Andacht
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_HUCK_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_1287"),
						goto(325.35,253.42),
						turn_to_position(330,252),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_HUCK_T_002',
				S_START  :(goto(445,339),
						turn_to_direction(DIR_NORTH_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),				
			},
			#Essen vorbereiten
			"09:00:00":{
				S_DIALOG : 'NPC_HUCK_T_003',
				S_START  :(goto_dummy("BUILDING_172","dmyp_006"),
						sit_down_to_cook()),
				S_LOOP   :(cook()),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_HUCK_T_004',
				S_START  :(goto(325.35,253.42),
						turn_to_position(330,252),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_HUCK_T_005',
				S_START  :(goto_dummy("SQZONE_3_BUILDING_167","dmyp_001"),
						#turn_to_direction(DIR_EAST),
						sit_down_on_bench()),
				S_LOOP   :(sit_eat_drink_on_bench),				
			},
			#Freizeit/Lagerfeueraction
			"20:00:00":{
				S_DIALOG : 'NPC_HUCK_T_006',
				S_START  :(goto(488,267),
						turn_to_direction(DIR_NORTH_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground("drink")),
			},
			#Schlafen
			"22:00:00":{
				S_START  :(goto(444,338),
						enter_building("SQZONE_3_BUILDING_1287"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_HUCK_T_007'		
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1,2]
			}
		}),
		"CARLTON": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Andacht
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_CARLTON_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_22"),
						goto(325.48,252.42),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_CARLTON_T_002',
				S_START  :(goto(502 ,299),
						turn_to_direction(DIR_SOUTH_WEST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),				
			},
			#Wache schieben
			"09:00:00":{
				S_DIALOG : 'NPC_CARLTON_T_003',
				S_START  :(),
				S_LOOP   :(patrol(ROUTE_CARLTON,True),
						stand("look_around")),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_CARLTON_T_004',
				S_START  :(goto(325.48,252.42),
						turn_to_position(330,252),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_CARLTON_T_005',
				S_START  :(goto(502 ,299),
						turn_to_direction(DIR_SOUTH_WEST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),				
			},
			#Freizeit/Lagerfeueraction
			"20:00:00":{
				S_DIALOG : 'NPC_CARLTON_T_006',
				S_START  :(goto(490,265),
						turn_to_position((489,264)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground("drink")),
			},
			#Schlafen
			"22:00:00":{
				S_START  :(goto(484,276),
						enter_building("SQZONE_3_BUILDING_22"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_CARLTON_T_007'
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1,2]
			}
		}),
		"JACK_SQZ3": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_JACK_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_1362"),
						goto(208,322),
						turn_to_position((206,326)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),				
			},
			#Lesen
			"09:00:00":{
				S_DIALOG : 'NPC_JACK_T_002',
				S_START  :(goto_dummy("SQZONE_3_BUILDING_978", "dmyp_002"),
						sit_down_on_bench()),
				S_LOOP   :(read_book_on_bench()),
			},
			#Spielen
			"15:00:00":{
				S_DIALOG : 'NPC_JACK_T_003',
				S_START  :(goto(395,358),
						enter_building("SQZONE_3_BUILDING_492"),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground("random")),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_JACK_T_004',
				S_START  :(goto(326.54,253.78),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_JACK_T_005',
				S_START  :(goto(208,322),
						turn_to_position((206,326)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Freizeit/Lagerfeueraction
			"19:00:00":{
				S_DIALOG : 'NPC_JACK_T_006',
				S_START  :(goto(286,340),
						turn_to_direction(DIR_SOUTH_WEST),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground("random")),
			},
			#Schlafen
			"20:00:00":{
				S_START  :(goto(287,336),
						enter_building("SQZONE_3_BUILDING_1362"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_JACK_T_007'
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1]
			}
		}),
		"EMMA": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Andacht
			"05:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_EMMA_T_001',
				S_START  :(leave_building("SQZONE_3_BUILDING_1290"),
						goto(328.91,253.74),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_EMMA_T_002',
				S_START  :(goto(203,328),
						turn_to_direction(DIR_NORTH_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Wache schieben
			"09:00:00":{
				S_DIALOG : 'NPC_EMMA_T_003',
				S_START  :(),
				S_LOOP   :(patrol(ROUTE_EMMA,True),
						stand()),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 2,
				S_DIALOG : 'NPC_EMMA_T_004',
				S_START  :(goto(328.91,253.74),
						turn_to_position((330,252)),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			"18:00:00":{
				S_DIALOG : 'NPC_EMMA_T_005',
				S_START  :(goto(203,328),
						turn_to_direction(DIR_NORTH_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Freizeit/Lagerfeueraction
			"20:00:00":{
				S_DIALOG : 'NPC_EMMA_T_006',
				S_START  :(goto(501,294),
						turn_to_direction(DIR_SOUTH_WEST)),
				S_LOOP   :(dance()),
			},
			#Schlafen
			"22:00:00":{
				S_START  :(goto(388,339),
						enter_building("SQZONE_3_BUILDING_1290"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_EMMA_T_007'
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1,2]
			}
		}),		
		"CAROLINE": ({
			S_CONDITION: lambda: not const.AndachtLaeuft,
			#Frühstück
			"07:00:00":{
				S_DIALOG : 'NPC_CAROLINE_T_002',
				S_START  :(leave_building("SQZONE_3_BUILDING_1290"),
						goto(390,362),
						turn_to_position((206,326)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Lesen
			"09:00:00":{
				S_DIALOG : 'NPC_CAROLINE_T_003',
				S_START  :(goto_dummy("SQZONE_3_BUILDING_170", "dmyp_001"),
						sit_down_on_bench()),
				S_LOOP   :(read_book_on_bench()),
			},
			#Spielen
			"15:00:00":{
				S_DIALOG : 'NPC_CAROLINE_T_004',
				S_START  :(goto(443,410),
						turn_to_direction(DIR_SOUTH_WEST)),
				S_LOOP   :(dance("random")),
			},
			#Andacht
			"16:00:00":{
				S_LOCATION: 1,
				S_DIALOG : 'NPC_CAROLINE_T_005',
				S_START  :(goto(327.70,254.79),
						turn_to_position(330,252),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Abendessen
			#Prüfen!!!
			"18:00:00":{
				S_DIALOG : 'NPC_CAROLINE_T_006',
				S_START  :(goto(406,332),
						turn_to_position((206,326)),
						sit_down_on_ground()),
				S_LOOP   :(sit_eat_drink_on_ground),
			},
			#Freizeit/Lagerfeueraction
			"19:00:00":{
				S_DIALOG : 'NPC_CAROLINE_T_006',
				S_START  :(goto(487,265),
						turn_to_direction(DIR_NORTH_EAST),
						sit_down_on_ground()),
				S_LOOP   :(sit_on_ground()),
			},
			#Schlafen
			"20:00:00":{
				S_START  :(goto(387,338),
						enter_building("SQZONE_3_BUILDING_1290"),
						lay_down_to_sleep()),
				S_LOOP   :(sleep()),
			},
			S_SECONDDIALOG : 'NPC_CAROLINE_T_007'
		}, {
			"00:00:00":{
				S_START	:(),
				S_LOOP	:(sit_on_ground()),
				S_NOSTOP	: [1]
			}
		}),
	}
	# update with global schedules
	schedules.update(global_schedules.update_schedules(schedules))

### wrapper functions, do not modify!
def Activity(id):
	return npc_activity(id, schedules)
	
def GetCurrentPlan(id):
	return npc_get_current_plan(id, schedules)
	
def Dialog(id, partymemberid):
	return npc_dialog(id, partymemberid, schedules)
