# -*- coding: utf-8 -*-
from globals import *
from const import *
import const
import npc
import dialogs
import schedules
import object_events
import object
import char_autogeneration
import system_events
import math
import daily_routine

#*** aktuelle revison: Rev 3, 15.06.2004 *********************************

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="NPC_GANG",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(420.0, 212.0),
	 		"SOUTH":	(332.0, 496.0),
	 		"WEST":		(200.0, 300.0),
	 		"EAST":		(496.0, 432.0),
	 	}
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("orange")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Dorf_der_Sekte",455,360,295,235)
		system.add_region("Bahngleise",200,237,500,242)
	
	data("rest").non_rest_areas.append("Dorf_der_Sekte")
	data("rest").non_rest_areas.append("Bahngleise")

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()	
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	npc.initNPCS()
	npc.initAnimals()
	char_autogeneration.init_Mercenary('MERCENARY_SAND')
	char_autogeneration.init_Mercenary('MERCENARY_STORM')
	initItems()
	initHerbs()
	initExitZones()
	initFX()
	initRegions()
	
	data().QB_001 = system.register_qb_entry('SQZONE3_AIM_01')
	data().QB_002 = system.register_qb_entry('SQZONE3_AIM_02')
	data().QB_003 = system.register_qb_entry('SQZONE3_AIM_03')

	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_non_rest_areas()
	animate_flag(obj="SQZONE_3_BUILDING_473")
	
	character.set_approachable_state("MERCENARY_SAND",APPROACHABLE)
	character.set_approachable_state("MERCENARY_STORM",APPROACHABLE)

	

def animate_flag(obj=None):
	object.play_animation(obj, "ANIM_FAHNENMAST_1", callback=['ONEND', animate_flag])

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	#lagerfeuer
	system.mark_for_script_use("BUILDING_172")
	system.mark_for_script_use("BUILDING_1005")

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		if not npc in ["GANGER_1", "GANGER_2", 'MERCENARY_STORM', 'MERCENARY_SAND']:
			object.set_immortal_state(npc, True)
		else:
			character.set_approachable_state(npc, False)

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)
	
def on_enter_region(id, objectid, partyid ):
    objects_in_region = None
#   print "[on_enter_region(",id, str(objectid), partyid,"]"
# non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        objects_in_region = objectid[:]
        if len(objectid): objectid=objectid[0]
        else: return

    if id == "CONTAINERDORF":
        if not data().player_knows_Containerdorf:
            data().player_knows_Containerdorf = True
            system.add_minimap_marker(403.11,335.53,"MM_001")# Containerdorf

    if id == "BENZINTANK":
        if not data().player_knows_Benzintank:
            data().player_knows_Benzintank = True
            system.add_minimap_marker(379.82,234.36,"MM_002")# Benzintank

    #Vermessungspunkt Norden
    if(id == Region_PunktNordenComment and
       data().PunktNordenVermessen == False and
       object.exists('Z4 MYRIAMS_THEODOLIT')):
        dialogs.initDlg_014_NoerdlicherVermessungspunkt()

    #Vermessungspunkt Westen
    if(id == Region_PunktWestenComment and
       data().PunktWestenVermessen == False and
       object.exists('Z4 MYRIAMS_THEODOLIT')):
        dialogs.initDlg_015_WestlicherVermessungspunkt()

    #Vermessungspunkt Sueden
    if(id == Region_PunktSuedenComment and
       data().PunktSuedenVermessen == False and
       object.exists('Z4 MYRIAMS_THEODOLIT')):
        dialogs.initDlg_016_SuedlicherVermessungspunkt()
        
    if(id == Region_AshtonBeginntWinken):
        system.notify_region_entered(Region_AshtonWinkt, objectid="ALTER_EGO", permanent=True)

    #Ashton beim Winken
    if(id == Region_AshtonWinkt and data().AshtonWinktGesehen == False):
        clock = system.get_mission_time().get_day_time()
        if(clock >= time("16:30:00") and clock < time("19:00:00")):
            if data().ashton_winkt and (object.get_distance("ALTER_EGO", "ASHTON") <= 15.0):
                dialogs.initDlg_008_SpielerHegtVerdacht()

    #Ashton klaut Benzin
    if(id == Region_AshtonKlautBenzin and data().AshtonKlautGesehen == False):
        system.notify_region_entered(Region_AshtonKlautBenzinSpieler, objectid="ALTER_EGO")

    if(id == Region_AshtonKlautBenzinSpieler):
        if data().ashton_klaut_diesel and (object.get_distance("ALTER_EGO", "ASHTON") <= 25.0):
            dialogs.initDlg_009_SpielerWirdMisstrauischer()
            data().AshtonKlautGesehen = True

    #Ashton verkauft Benzin
    if(id == Region_AshtonVerkauftBenzin):
        AshtonVerkauftBenzin(objects_in_region, objectid)
        clock = system.get_mission_time().get_day_time()
        if clock > time("01:00:00") and clock < time("23:00:00") and force_quete_oui():
            dialogs.initDlg_force_quete_1()

    #Die Andacht
    if(id == Region_AndachtBeginnt and not data().AndachtGesehen):
        clock = system.get_mission_time().get_day_time()
#        if not data().AndachtGesehen:
        if check_andacht(clock):
            dialogs.initCutscene_Dlg_010_DieAndacht()
        else:
            system.notify_timer(data().timer_andachtchecker, data().timervalue_andachtchecker)

def force_quete_oui():# spar car sinon  marche pas ???
    if (system.get_qb_entry_state(data().QB_001) == UNCOMPLETE or
        system.get_qb_entry_state(data().QB_002) == UNCOMPLETE or
        system.get_qb_entry_state(data().QB_003) == UNCOMPLETE):return False
    elif system.get_qb_entry_state(data().QB_003) == COMPLETE:return False
    else:return True

#check funktion für die andacht
def check_andacht(clock):
	if ((clock >= time("05:45:00") and clock < time("07:00:00")) or 
		(clock >= time("16:45:00") and clock < time("18:00:00"))):
			if (object.get_distance("ALTER_EGO", "GEORGE_P_SMYTHES") <= 15.0):
				p = object.get_position("GEORGE_P_SMYTHES")
				dx = p[0] - 330
				dy = p[1] - 252
				dist = math.sqrt(dx * dy)
				if dist < 2.0:
					return True
	return False
	
def can_use( character_id, object_id ):
	if (object_id == "Z4 MYRIAMS_THEODOLIT"):
		return True
	return object_events.can_use( character_id, object_id )
		
def on_use( character_id, object_id, item_id, item_type ):
	#Theodolit wird benutzt
	#-Vermessungspunkt Norden
	if(character_id == "ALTER_EGO" and
		item_type == "SET_THEODOLIT" and
		data().PunktNordenVermessen == False and
		object.get_x("ALTER_EGO") < 498 and
		object.get_x("ALTER_EGO") > 473 and
		object.get_y("ALTER_EGO") < 311 and
		object.get_y("ALTER_EGO") > 258):
		object.set_direction("ALTER_EGO", 225)
		if object.count_in_inventory("ALTER_EGO", "Z4 MYRIAMS_THEODOLIT"):
			object.drop_item("ALTER_EGO",'Z4 MYRIAMS_THEODOLIT')
		object.set_position('Z4 MYRIAMS_THEODOLIT', object.get_x("ALTER_EGO")-0.5, object.get_y("ALTER_EGO")+0.5)
		object.set_direction("Z4 MYRIAMS_THEODOLIT", 225)
		check_points_measured()
		data().PunktNordenVermessen = True
		return True

	#-Vermessungspunkt Westen
	if(character_id == "ALTER_EGO" and
		item_type == "SET_THEODOLIT" and
		data().PunktWestenVermessen == False and
		object.get_x("ALTER_EGO") < 248 and
		object.get_x("ALTER_EGO") > 206 and
		object.get_y("ALTER_EGO") < 435 and
		object.get_y("ALTER_EGO") > 313):
		object.set_direction("ALTER_EGO", 90)
		if object.count_in_inventory("ALTER_EGO", "Z4 MYRIAMS_THEODOLIT"):
			object.drop_item("ALTER_EGO",'Z4 MYRIAMS_THEODOLIT')
		object.set_position('Z4 MYRIAMS_THEODOLIT', object.get_x("ALTER_EGO")+0.5, object.get_y("ALTER_EGO"))
		object.set_direction("Z4 MYRIAMS_THEODOLIT", 90)
		check_points_measured()
		data().PunktWestenVermessen = True
		return True

	#-Vermessungspunkt Sueden
	if(character_id == "ALTER_EGO" and
		item_type == "SET_THEODOLIT" and
		data().PunktSuedenVermessen == False and
		object.get_x("ALTER_EGO") < 487 and
		object.get_x("ALTER_EGO") > 473 and
		object.get_y("ALTER_EGO") < 472 and
		object.get_y("ALTER_EGO") > 440):
		object.set_direction("ALTER_EGO", 315)
		if object.count_in_inventory("ALTER_EGO", "Z4 MYRIAMS_THEODOLIT"):
			object.drop_item("ALTER_EGO",'Z4 MYRIAMS_THEODOLIT')
		object.set_position('Z4 MYRIAMS_THEODOLIT', object.get_x("ALTER_EGO")-0.5, object.get_y("ALTER_EGO")-0.5)
		object.set_direction("Z4 MYRIAMS_THEODOLIT", 315)
		check_points_measured()
		data().PunktSuedenVermessen = True
		return True
		
	return object_events.on_use( character_id, object_id, item_id, item_type )

def check_points_measured():
	if(data().SQZ3_PunkteVermessen == 0):
		dialogs.initCutscene_Dlg_011_VermessungErsterPunkt()
	elif(data().SQZ3_PunkteVermessen == 1):
		dialogs.initCutscene_Dlg_012_VermessungZweiterPunkt()
	elif(data().SQZ3_PunkteVermessen == 2):
		dialogs.initCutscene_Dlg_013_VermessungDritterPunkt()
	data().SQZ3_PunkteVermessen += 1

def on_timer(id):
#	print "[debug on_timer()",id,"]"
	if(id == data().Timer_Satz):
		dialogs.initDlg_006_SpielerWundertSichUeberSmythes()
	
	if (id == data().timer_andachtchecker):
		if not data().AndachtGesehen:
			clock = system.get_mission_time().get_day_time()
			if check_andacht(clock):
				dialogs.initCutscene_Dlg_010_DieAndacht()
			else:
				system.notify_timer(data().timer_andachtchecker, data().timervalue_andachtchecker)

def on_wait_for_commando(id):
	clock = system.get_mission_time().get_day_time()
	if clock >= time("23:00:00") or clock < time("01:00:00"): # je pense qu'il faut plutot un and mais prudence
		if not data().AshtonUndGangerZusammen:
			for id in ["GANGER_1","GANGER_2"]:
				object.set_active_state(id,1)
			data().AshtonUndGangerZusammen = True
	else:
		if data().counter_ashtonandgang > 0:
			data().AshtonUndGangerZusammen = False
			data().counter_ashtonandgang = 0
#	if id in TANPCS_ANDACHT and const.AndachtLaeuft:
#		set_activity(id,WORK_LOOP)

	return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
	return False

def on_examine_object( character_id, object_id ):
	return False

def on_pick_up( character_id, item_id, item_type ):
	if item_id == "ASHTONS_WATER_CANISTER":
		if character_id in system.get_pcs():
			if object.is_destroyed("ASHTON"):
				return True
			else:
				return False
	return True
	
def on_object_killed(victim, attacker, weapon_type, weapon_id):
    if(victim == "ASHTON"):
        if not data().AshtonTot:dialogs.Dlg_quete_fin()
        data().AshtonTot = True
        system.set_qb_entry_state( data().QB_002, INACTIVE )
        system.set_qb_entry_state( data().QB_003, UNCOMPLETE )

    if victim in ["WILLIAM_SQZ3", "HAROLD", "JEREMY", "MATTHEW", "HUCKLEBERRY", "CARLTON", "EMMA"]:
        data().AnhaengerTot += 1
	
    if data().AnhaengerTot >= 7:
        character.set_approachable_state("GEORGE_P_SMYTHES",APPROACHABLE)

    object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)

	
def CanLeaveZone():
	return False

def initItems():
	#Bewaffnung der NPCs
	object.create_item_in_inventory(object = "GEORGE_P_SMYTHES", equipment = 'SET_BASEBALL_BAT')
	
	object.create_item_in_inventory(object = "ASHTON", equipment = ["SET_WALTER_PPK", "SET_AMMOPACK_7_65_MM"])
	character.equip("ASHTON", equipment="SET_WALTER_PPK")
	
	object.create_item_in_inventory(object = "GANGER_1", equipment = ['SET_UZI', 'SET_AMMOPACK_9_MM'])
	character.equip("GANGER_1", equipment="SET_UZI")
	
	object.create_item_in_inventory(object = "GANGER_2", equipment = ['SET_REMINGTON_M870', 'SET_AMMOPACK_2_12_MM'])
	character.equip("GANGER_2", equipment="SET_REMINGTON_M870")
	
	object.create_item_in_inventory(object = "HAROLD", equipment = 'SET_RUSTY_IRON_ROD')
	object.create_item_in_inventory(object = "JEREMY", equipment = 'SET_AXE')
	object.create_item_in_inventory(object = "MATTHEW", equipment = 'SET_BRASS_KNUCKLES')
	object.create_item_in_inventory(object = "HUCKLEBERRY", equipment = 'SET_GIANT_KNIFE')
	
	object.create_item_in_inventory(object = "CARLTON", equipment = 'SET_CLUB')
	character.equip("CARLTON", equipment="SET_CLUB")
	
	object.create_item_in_inventory(object = "EMMA", equipment = 'SET_CLUB')
	
	object.create_item_in_inventory("EMMA", "SET_CLUB")
	object.create_item_in_inventory("WILLIAM_SQZ3", "SET_SIMONOV_SKS")
	object.create_item_in_inventory("GEORGE_P_SMYTHES", "SET_BASEBALL_BAT")
	
	#some random items
	#waescheleine
	object.create_item_in_inventory("BUILDING_183",["SET_NORMAL_CLOTHES_2","SET_NORMAL_CLOTHES_1"])
	#container
	object.create_item_in_inventory("BUILDING_171",["SET_DIESEL"])
	#hundehütte
	#object.create_item_in_inventory("BUILDING_9",["SET_STUNGRENADE","SET_STUNGRENADE"])
	#tisch
	object.create_item_in_inventory("BUILDING_979",["SET_SMALL_BAG","SET_HEADPHONE","SET_TOOTHBRUSH"])
	#zelt
	object.create_item_in_inventory("BUILDING_22",["SET_WATER_SKIN","SET_MEDIPACK_SMALL","SET_BASIC_PICKLOCK"])
	#KABELROLLE
	object.create_item_in_inventory("BUILDING_1284",["SET_REEL_OF_STEEL_WIRE"])
	#schrottauto
	object.create_item_in_inventory("BUILDING_772",["SET_BATTERY","SET_CAR_EXHAUST_PIPE","SET_HEAD_REST"])

	# Bienenstöcke SQZ3
	object.create_item_in_inventory( 'BUILDING_2946', equipment=[ 'SET_BEESWAX' ] )
	object.create_item_in_inventory( 'BUILDING_2947', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )

	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_2942', equipment=[ 'SET_FUSE', 'SET_WATER_CAN', 'SET_SET_OF_PICKLOCKS' ] )
	object.create_item_in_inventory( 'BUILDING_2943', equipment=[ 'SET_CORN_COB', 'SET_AMMOPACK_357_SUBSONIC_DUMDUM', 'SET_PLATE_GLOVES' ] )

	# Elektrokasten
	object.create_item_in_inventory( 'BUILDING_4', equipment=[ 'SET_C4_REMOTE_CONTROL' ] )
	# Kiste
	object.create_item_in_inventory( 'BUILDING_12', equipment=[ 'SET_THROWING_KNIFE', 'SET_C4_TIMEBASED' ] )
	# Schreibtisch
	object.create_item_in_inventory( 'BUILDING_2408', equipment=[ 'SET_STAPLE_GUN' ] )
	# Sandkasten
	object.create_item_in_inventory( 'BUILDING_492', equipment=[ 'SET_CAKE_TIN' ] )

	
def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x=378.05, y=313.83)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=354.90, y=385.70)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=419.26, y=396.05)

	
def initRegions():
	# Regionen für Hinweis auf Vermessungspunkt
	system.add_region(Region_PunktNordenComment, 431,247, 500,379)
	system.add_region(Region_PunktWestenComment, 219,500, 317,269)
	system.add_region(Region_PunktSuedenComment, 500,379, 397,500)
	system.add_region(Region_AshtonWinkt, 372,368, 485,466)
	system.add_region(Region_AshtonKlautBenzinSpieler, 346.86, 243.57, 384.14, 218.33)
	system.add_region(Region_AshtonKlautBenzin, 370.73, 221.09, 375.84, 227.79)
	system.add_region(Region_AshtonVerkauftBenzin, 359.76, 218.68, 344.90, 234.65)
	system.add_region(Region_AndachtBeginnt, 311,237, 355, 268)
	system.add_region(Region_AshtonBeginntWinken, 475,449, 472,451)

	system.notify_region_entered(Region_PunktNordenComment, objectid="ALTER_EGO", permanent=True)
	system.notify_region_entered(Region_PunktWestenComment, objectid="ALTER_EGO", permanent=True)
	system.notify_region_entered(Region_PunktSuedenComment, objectid="ALTER_EGO", permanent=True)
	system.notify_region_entered(Region_AshtonKlautBenzin, objectid="ASHTON", permanent=True)
	system.notify_region_entered(Region_AshtonVerkauftBenzin, objectid="ALTER_EGO", permanent=True)
	system.notify_region_entered(Region_AshtonVerkauftBenzin, objectid="ASHTON", permanent=True)
	system.notify_region_entered(Region_AshtonVerkauftBenzin, objectid="GANGER_1", permanent=True)
	system.notify_region_entered(Region_AshtonVerkauftBenzin, objectid="GANGER_2", permanent=True)
	system.notify_region_entered(Region_AndachtBeginnt, objectid="ALTER_EGO")
	system.notify_region_entered(Region_AshtonBeginntWinken, objectid="ASHTON")
	
	system.add_region("CONTAINERDORF",364,285,452,355)
	system.notify_region_entered("CONTAINERDORF",  partyid="UISPIELER")
	system.add_region("BENZINTANK",382.72, 216.99, 356.71, 237.63)
	system.notify_region_entered("BENZINTANK",  partyid="UISPIELER")
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 703.00, y2 = 209.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 703.00, y1 = 703.00, x2 = 0.00, y2 = 500.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 703.00, x2 = 200.00, y2 = 209.0 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 703.00, y1 = 209.00, x2 = 500.00, y2 = 500.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
	fxLagerFeuer("BUILDING_172")
	fxLagerFeuer("BUILDING_1005")
	for barrel in BURNING_BARRELS:
		fxBrennendeTonne(barrel)

#fx fuer brennende tonnen
def fxBrennendeTonne(objectid):
	system.start_effect_object(object=objectid,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=objectid,loop=True)

#fx fuer lagerfeuer
def fxLagerFeuer(_objectid):
	system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

	
def AshtonVerkauftBenzin(objects_in_region,objectid):
	if objectid in ["ASHTON", "GANGER_1", "GANGER_2"]:
		data().counter_ashtonandgang = data().counter_ashtonandgang + 1
	if ((data().counter_ashtonandgang >= 2 and objectid == "ALTER_EGO") or
		(data().counter_ashtonandgang >= 2 and object.get_distance("ALTER_EGO","ASHTON")<= 20.0)):
		if(data().AshtonBeobachtet == False):
			dialogs.initCutscene_Dlg_007_SpielerBeobachtetAshton()
			data().AshtonBeobachtet = True

		elif(data().SmythesAuftrag == True):
			pcs = system.get_pcs()
			object.set_attribute("ASHTON","foes",["UISPIELER"])
			object.set_attribute("GANGER_1","foes",["UISPIELER"])
			object.set_attribute("GANGER_2","foes",["UISPIELER"])

def on_begin_cutscene():
	"""is called when a cutscene is started""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()

	for mob in mobs:
		system_events.save_foes(mob)
		system_events.save_speedfactor(mob)

	# make sure AE is available
	if object.is_unconscious("ALTER_EGO"):
		import object_events
		object_events.on_resuscitate("ALTER_EGO", "ALTER_EGO")
		
	## makes chars stand
	import dynamic_camera
	for pc in system.get_pcs():
		object.cancel_commandos( pc )
		if data().standup_in_cutscene:
			dynamic_camera.set_body_mode(char_id=pc)
	
	#make npcs and animals visible during a cutscene
	#deactivate visibility fading
	for id in (system.get_npcs() + system.get_animals()):
		object.set_attribute(id, "visibility", UIVIS_VISIBLE)
		object.set_attribute(id, "visibility_fade", False)

def on_end_cutscene():
	"""is called when a cutscene ends""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()

	for mob in mobs:
		system_events.restore_foes(mob)
		system_events.restore_speedfactor(mob)
		
	#activate visibilty fading
	for id in (system.get_npcs() + system.get_animals()):
		object.set_attribute(id,"visibility_fade", True)
	
	data().standup_in_cutscene = True

def on_enemy_spotted(object_id):
	enemys = character.get_visible_enemies(object_id)
	#print "[debug: on_enemy_spotted:",object_id,"]"
	if object.is_npc(object_id) and len(enemys):
		object.attack(object_id, random.choice(enemys))

def on_region_click(regionname, x, y):
	return system_events.on_region_click(regionname, x, y)

def InitChestsSafes():
	object.add_closed_lock("BUILDING_2942", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_2943", "lock1", closure_type='booby-trap')

def init_patch():
	if "ANIE" in system.get_npcs():
		data("zone_7.zone_7").anie_folgt = True
	npcs = system.get_npcs()
	if 'MERCENARY_SAND' in npcs:
		character.set_approachable_state("MERCENARY_SAND",APPROACHABLE)
	if 'MERCENARY_STORM' in npcs:
		character.set_approachable_state("MERCENARY_STORM",APPROACHABLE)
