# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
import schedules
import cs_function as cs
from dynamic_camera import *

#*********************************************************************
#		aktuelle revison: Revision 6, 18.08.2004
#*********************************************************************

def MercenaryDenyTalk(id,type='default'):
	gender = object.get_attribute("ALTER_EGO","gender")
	dialog.init_dialog(type=DIALOGSMALL)
	if type == 'default':
		if gender == MALE:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY_F', speaker=id, follower='ENDDIALOG')
	else:
		if gender == MALE:
			dialog.add_text(text='MERCENERY_USEITEM_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_USEITEM_DENY_F', speaker=id, follower='ENDDIALOG')
	dialog.start(False)

def on_approach( target, operator ):
	if dialog.is_dialog_active():
		return
	if schedules.Dialog( target, operator ):
		return
	pass

def fight():
	if( was_zone_entered( "zone_5.zone_5" ) ):
		system.set_qb_entry_state(data("zone_5.zone_5").QB_018, COMPLETE)

	for id in data().gegner:
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

#Dialog 001: Die Scheune wurde präpariert
def initDlg_001_ScheunePraepariert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_001_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 003: Auch die Scheune wurde präpariert
def initDlg_003_ScheuneAuchPraepariert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_003_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 002: Die Scheune scheint noch recht frisch zu sein
def initDlg_002_ScheuneScheintFrischZuSein():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_002_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 004: Auch die Scheune sieht auf den ersten Blick noch frisch aus
def initDlg_004_AuchDieScheuneSiehtErstmalFrischAus():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_004_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 005: Das Farmhaus scheint präpariert zu sein
def initDlg_005_FarmhausPraepariert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_005_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 006: Auch das Farmhaus scheint präpariert zu sein
def initDlg_006_FarmhausAuchPraepariert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_006_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 007: Auch das Farmhaus sieht frisch aus
def initDlg_007_AuchDasFarmhausSiehtFrischAus():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_007_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 008: Das Farmhaus sieht aus wie frisch zerstört
def initDlg_008_FarmhausSiehtFrischZerstoertAus():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_008_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 009: Auch die Leichen sind präpariert
def initCutscene_009_AuchDieLeichenSindPraepariert():
	pos = object.get_position("LEICHE_2")
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_DEADBODYS_FOUND)
	object.move_to("ALTER_EGO",pos[0]-1.0,pos[1])
	object.turn_to_object("ALTER_EGO", "LEICHE_2")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_009_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=initCutscene_013_GangRuecktAn)
	dialog.start()

#Dialog 010: Der Spieler riecht den Braten mit den Leichen
def initCutscene_010_SpielerRiechtDenBraten():
	pos = object.get_position("LEICHE_2")
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_DEADBODYS_FOUND)
	object.move_to("ALTER_EGO",pos[0]-1.0,pos[1])
	object.turn_to_object("ALTER_EGO", "LEICHE_2")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_010_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=initCutscene_013_GangRuecktAn)
	dialog.start()

#Dialog 011: Auch die Leichen sehen erst mal echt aus
def initDlg_011_AuchDieLeichenSehenErstmalEchtAus():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_011_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 012: Die Leichen sehen echt aus
def initDlg_012_LeichenSehenEchtAus():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_012_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#Dialog 013: Die Gang rückt an
def initCutscene_013_GangRuecktAn():
	system.set_camera_view(CAMVIEW_GANG_APPROACH)
	#object.move_to_object( "GANG_LEADER_MAX", "ALTER_EGO")
	object.move_to("GANG_LEADER_MAX",x = 272.06, y = 264.44)
	object.turn_to_object( "GANG_LEADER_MAX", "ALTER_EGO")
	#object.move_to_object("GANGMEMBER_VICK", "ALTER_EGO")
	object.move_to("GANGMEMBER_VICK",x = 269.47, y = 265.67)
	object.turn_to_object("GANGMEMBER_VICK", "ALTER_EGO")
	
	object.move_to("GANGMEMBER_001",x=278.97,y=267.46)
	object.turn_to_position("GANGMEMBER_001",271,269)
	object.move_to("GANGMEMBER_003",x=277.49,y=265.37)
	object.turn_to_position("GANGMEMBER_003",271,269)
	object.move_to("GANGMEMBER_005",x=274.75,y=262.15)
	object.turn_to_position("GANGMEMBER_005",271,269)
	
	object.move_to("GANGMEMBER_002",x=267.36,y=274.76)
	object.turn_to_position("GANGMEMBER_002",271,269)
	object.move_to("GANGMEMBER_004",x=265.35,y=272.06)
	object.turn_to_position("GANGMEMBER_004",271,269)
	object.move_to("GANGMEMBER_006",x=264.86,y=268.81)
	object.turn_to_position("GANGMEMBER_006",271,269)
	
	object.turn_to_object("ALTER_EGO","GANG_LEADER_MAX")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_013_T_001', speaker="ALTER_EGO", callback=Lambda('system.set_camera_view(CAMVIEW_AE_BACK); set_conversation("GANGMEMBER_VICK","ALTER_EGO",mode="medium",new_camera=False)'))
	dialog.add_text(text='D_013_T_002', speaker="GANGMEMBER_VICK", callback=Lambda('set_conversation("GANG_LEADER_MAX","ALTER_EGO",mode="medium",new_camera=False)'))
	dialog.add_text(text='D_013_T_003', speaker="GANG_LEADER_MAX", callback=Lambda('system.set_camera_view(CAMVIEW_AE_CLOSE); set_conversation("ALTER_EGO","GANG_LEADER_MAX", mode="close", new_camera=False)'))
	dialog.add_text(text='D_013_T_004', speaker="ALTER_EGO", callback=Lambda('system.set_camera_view(CAMVIEW_GANG_CLOSE); set_conversation("GANGMEMBER_VICK","ALTER_EGO",mode="close", new_camera=False)'))
	dialog.add_text(text='D_013_T_005', speaker="GANGMEMBER_VICK", callback=Lambda('set_conversation("GANG_LEADER_MAX","GANGMEMBER_VICK",mode="close_deep", first_obj="GANG_LEADER_MAX")'))
	dialog.add_text(text='D_013_T_006', speaker="GANG_LEADER_MAX", callback=Lambda('set_conversation("GANGMEMBER_VICK","GANG_LEADER_MAX",mode="close_deep")'))
	dialog.add_text(text='D_013_T_007', speaker="GANGMEMBER_VICK", callback=Lambda('system.set_camera_view(CAMVIEW_GANG_CLOSE); set_conversation("GANG_LEADER_MAX","ALTER_EGO",mode="close_deep", new_camera=False, first_obj="ALTER_EGO")'))
	if object.get_attribute("ALTER_EGO","gender")==MALE:
		dialog.add_text(text='D_013_T_008', speaker="GANG_LEADER_MAX", follower='ENDDIALOG', callback=endeCutscene_013)
	else:
		dialog.add_text(text='D_013_T_008F', speaker="GANG_LEADER_MAX", follower='ENDDIALOG', callback=endeCutscene_013)
	dialog.start()
	
def endeCutscene_013():
	system.set_camera_view(data().CamView_GangKommt)
	end_cutscene(chars=["GANGMEMBER_VICK","GANG_LEADER_MAX","ALTER_EGO"])
	initDlg_014_GangBeisstAufGranit()
#Dialog 014: Die Loser-Gang beißt beim Spieler auf Granit
def initDlg_014_GangBeisstAufGranit():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_choice(text='D_014_C_001_1', follower='ENDDIALOG', callback=fight)
	dialog.add_choice(text='D_014_C_001_2', follower='D_014_T_008')
	if cs.anyone_has_skill('speech',70):
		dialog.add_choice(text='D_014_C_001_3', follower='D_014_T_022')
	else:
		dialog.add_choice(text='D_014_C_001_3', follower='D_014_T_013')
	dialog.add_choice(text='D_014_C_001_4', follower='D_014_T_010')
	
	dialog.add_text(text='D_014_T_008', speaker="GANGMEMBER_VICK")
	dialog.add_text(text='D_014_T_009', speaker="GANG_LEADER_MAX", follower='D_014_C_001')
	
	dialog.add_text(text='D_014_T_010', speaker="GANG_LEADER_MAX")
	dialog.add_text(text='D_014_T_011', speaker="GANGMEMBER_VICK")
	dialog.add_text(text='D_014_T_012', speaker="GANG_LEADER_MAX", follower='ENDDIALOG', callback=initCutscene_015_GangHautAb)
	
	dialog.add_text(text='D_014_T_013', speaker="GANGMEMBER_VICK")
	dialog.add_text(text='D_014_T_014', speaker="GANG_LEADER_MAX")
	dialog.add_text(text='D_014_T_015', speaker="ALTER_EGO")
	dialog.add_text(text='D_014_T_016', speaker="GANGMEMBER_VICK")
	dialog.add_text(text='D_014_T_017', speaker="GANG_LEADER_MAX")
	dialog.add_text(text='D_014_T_018', speaker="ALTER_EGO")
	dialog.add_text(text='D_014_T_019', speaker="GANGMEMBER_VICK")
	dialog.add_text(text='D_014_T_020', speaker="GANG_LEADER_MAX")
	dialog.add_text(text='D_014_T_021', speaker="ALTER_EGO", follower='ENDDIALOG', callback=fight)
	
	dialog.add_text(text='D_014_T_022', speaker="GANGMEMBER_VICK", follower='D_014_T_023')
	dialog.add_text(text='D_014_T_023', speaker="GANG_LEADER_MAX", follower='ENDDIALOG', callback=on_dialog_014_ende_flucht)
	
	dialog.start(False)

def on_dialog_014_ende_flucht():
	for id in system.get_npcs():
		if not object.is_destroyed(id):
			if id not in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
				object.move_to(id, 0.0,0.0, callback=['ONEND', Lambda('object.set_active_state("%s", 0)' %(id))])

def initCutscene_015_GangHautAb():
	for R in system.get_pcs():
		for id in object.get_inventory_id_list(object_id=R):
			object.remove_item_from_inventory(object=R, equipment=id)
	system.start_cutscene()
	system.set_camera_view(data().CamView_GangHautAb)
	for id in data().gegner:
		if (not object.is_destroyed(id)):
			object.move_to(object=id,x=288.9,y=310)
	system.notify_timer(data().Timer_FadeOut,data().Timervalue_FadeOut)
	if( was_zone_entered( "zone_5.zone_5" ) ):
		system.set_qb_entry_state(data("zone_5.zone_5").QB_018, COMPLETE)

def GangIstAbgehauen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_015_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=end_cutscene)
	dialog.start()
