# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import object_events
import schedules
from const import *
import const

#*********************************************************************
#		aktuelle revison: Revision 6, 18.08.2004
#*********************************************************************

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="GANG",type=PT_COMPUTER)
	system.create_party(id="LEICHEN",type=PT_COMPUTER)
	system.create_party(id="NPCS",type=PT_COMPUTER)
	
def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(285.00, 308.00),
	 		"SOUTH":	(285.00, 308.00),#288.55, 300.00
	 		"WEST":		(285.00, 308.00),
	 		"EAST":		(285.00, 308.00),
	 	}
	
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("redrock")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Ruinendorf",315,280,255,250)
	
	data("rest").non_rest_areas.append("Ruinendorf")

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	npc.initLeichen()
	initItems()
	initHerbs()
	initExitZones()
	initFX()
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	initRegions()

	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_non_rest_areas()

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	#lagerfeuer
	#system.mark_for_script_use(id)
	# Bienenstöcke SQZone 5
	system.mark_for_script_use('BUILDING_948')

	pass
	
# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		object.set_immortal_state(npc, True)

def initRegions():
	
	system.add_region(id = data().Region_AnnaehernScheune,x1=287.00,y1=243.00,x2=324.00,y2=308.00)				
	system.add_region(id = data().Region_NaheScheune,x1=293.00,y1=253.00,x2=315.00,y2=277.00)
	system.add_region(id = data().Region_AnnaehernFarmhaus,x1=233.00,y1=281.00,x2=284.00,y2=312.00)
	system.add_region(id = data().Region_NaheFarmhaus,x1=243.00,y1=291.00,x2=256.00,y2=302.00)
	system.add_region(id = data().Region_AnnaehernLeichen,x1=257.00,y1=252.00,x2=287.00,y2=270.00)
	system.add_region(id = data().Region_AnnaehernLeichen2,x1=257.00,y1=270.00,x2=270.00,y2=277.00)
	system.add_region(id = data().Region_AnnaehernLeichen3,x1=270.00,y1=270.00,x2=278.00,y2=271.00)
	system.add_region(id = data().Region_NaheLeichen,x1=260,y1=264.00,x2=278.00,y2=270.00)
	
	system.notify_region_entered(region=data().Region_AnnaehernScheune,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_NaheScheune,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_AnnaehernFarmhaus,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_NaheFarmhaus,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_AnnaehernLeichen,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_AnnaehernLeichen2,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_AnnaehernLeichen3,objectid="ALTER_EGO")	
	system.notify_region_entered(region=data().Region_NaheLeichen,objectid="ALTER_EGO")	
	
def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)
	
def on_enter_region(id, objectid, partyid ):
	#print "[on_enter_region(",id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	if id == data().Region_NaheLeichen:
		npc.initNPCS()
		if data().visitBuilding:
			data().LeichenGefunden = True
			for id in data().gegner:
				object.set_active_state(object=id, state=True)
			dialogs.initCutscene_009_AuchDieLeichenSindPraepariert()
		else:
			data().LeichenGefunden = True
			for id in data().gegner:
				object.set_active_state(object=id, state=True)
			dialogs.initCutscene_010_SpielerRiechtDenBraten()
	else:
		system.notify_timer(data().Timer_Comment, data().Timervalue_Comment)
		data().Comment = id
		
def StartComment():
	id = data().Comment
	if (id == data().Region_AnnaehernScheune):
		for R in system.get_pcs():
			object.cancel_commandos(R)
		if data().visitBuilding:
			dialogs.initDlg_004_AuchDieScheuneSiehtErstmalFrischAus()
		else:
			dialogs.initDlg_002_ScheuneScheintFrischZuSein()
	elif (id == data().Region_NaheScheune) and (not data().LeichenGefunden):
		for R in system.get_pcs():
			object.cancel_commandos(R)
		if data().visitBuilding:
			dialogs.initDlg_003_ScheuneAuchPraepariert()
		else:
			data().visitBuilding = True
			dialogs.initDlg_001_ScheunePraepariert()
	elif id == data().Region_AnnaehernFarmhaus:
		for R in system.get_pcs():
			object.cancel_commandos(R)
		if data().visitBuilding:
			dialogs.initDlg_007_AuchDasFarmhausSiehtFrischAus()
		else:
			dialogs.initDlg_008_FarmhausSiehtFrischZerstoertAus()
	elif (id == data().Region_NaheFarmhaus) and (not data().LeichenGefunden):
		for R in system.get_pcs():
			object.cancel_commandos(R)
		if data().visitBuilding:
			dialogs.initDlg_006_FarmhausAuchPraepariert()
		else:
			data().visitBuilding = True
			dialogs.initDlg_005_FarmhausPraepariert()
	elif ((id == data().Region_AnnaehernLeichen) or (id == data().Region_AnnaehernLeichen2) or (id == data().Region_AnnaehernLeichen3)):
		for R in system.get_pcs():
			object.cancel_commandos(R)
		if(not data().RegionBetreten):
			data().RegionBetreten = True
			if data().visitBuilding:
				dialogs.initDlg_011_AuchDieLeichenSehenErstmalEchtAus()
			else:
				dialogs.initDlg_012_LeichenSehenEchtAus()

def on_object_killed(victim, attacker, weapon_type, weapon_id):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	if victim in data().gegner:
		data().gegnerKilled+=1

def on_timer(id):
	#print "[debug on_timer()",id,"]"
	if (id==data().Timer_FadeOut):
		system.fade(FADE_OUT)
		system.notify_timer(data().Timer_FadeIn, data().Timervalue_FadeIn)
	elif(id==data().Timer_FadeIn):
		for id in data().gegner:
			if (not object.is_destroyed(id)):
				object.set_active_state(object=id, state=False)
		system.fade(FADE_IN)
		dialogs.GangIstAbgehauen()
	elif not dialog.is_dialog_active():
		StartComment()
	else:
		system.notify_timer(data().Timer_Comment, data().Timervalue_Comment)

def on_wait_for_commando(id):
	return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
	return False

def on_examine_object( character_id, object_id ):
	return False

def CanLeaveZone():
	return False

def initItems():
	object.create_item_in_inventory("LEICHE_1",	["SET_NORMAL_CLOTHES_1","SET_DART","SET_BIG_KNIFE"])
	object.create_item_in_inventory("LEICHE_1",	["SET_CAKE_TIN","SET_BINOCULARS"])
	object.create_item_in_inventory("LEICHE_1",	["SET_NORMAL_CLOTHES_5","SET_GAME_JOY"])
	object.create_item_in_inventory("BUILDING_1",	["SET_MACHETE"])
	object.create_item_in_inventory("BUILDING_2",	["SET_BULLET_CASINGS"])
	object.create_item_in_inventory("BUILDING_22",	["SET_CRANK","SET_BELT"])
	object.create_item_in_inventory("BUILDING_15",	["SET_BOTTLE_OF_HOOCH","SET_BOTTLE_OF_HOOCH","SET_TIN_CAN","SET_TIN_CAN","SET_TIN_CAN"])
	
	# Bienenstöcke SQZ5
	object.create_item_in_inventory( 'BUILDING_948', equipment=[ 'SET_BEESWAX' ] )

	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_836', equipment=[ 'SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM', 'SET_KEVLAR_HELMET', 'SET_GAS_CANISTER' ] )

	
def initHerbs():
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=242.02, y=281)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=211.19, y=307.94)
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 330.00, y2 = 200.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 511.00, y1 = 511.00, x2 = 192.00, y2 = 312.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 511.00, x2 = 200.00, y2 = 200.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 511.00, y1 = 311.0, x2 = 330.00, y2 = 0.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def fx_aschetonne(tonne):
	system.start_effect_object(object=tonne,node="dmyp_fx",parameter=fx_smoke)
	sounds.play_3d_sound_object(sfx_id="smooth_firecracks",object=tonne,loop=True)

def fx_brennende_tonne(tonne):
	system.start_effect_object(object=tonne,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=tonne,loop=True)
	
def initFX():
	#fx für aschetonnen und brennende tonnen
	for id in ["BUILDING_436","BUILDING_435","BUILDING_437","BUILDING_434","BUILDING_433"]:
		fx_aschetonne(id)
	
	for id in ["BUILDING_9","BUILDING_12","BUILDING_222"]:
		fx_brennende_tonne(id)

def InitChestsSafes():
	object.add_closed_lock("BUILDING_836", "lock1", closure_type='booby-trap')

def init_patch():
	if "ANIE" in system.get_npcs():
		data("zone_7.zone_7").anie_folgt = True
