# -*- coding: utf-8 -*-
from globals import *
import npc
import water
import dialogs
from const import *
import schedules
import object_events
import enemy_script
import sounds
import daily_routine
import cs_function as cs

def initParties():
    system.create_party(id="NPCS",type=PT_COMPUTER)
    system.create_party(id="UISPIELER",type=PT_HUMAN)

def GetZoneEnterLocation(enterdirection):
    start_locations = {"NORTH":(300.02, 494.74), "SOUTH":(229.65, 211.96), "WEST":(495.65, 428.31), "EAST":(229.65, 211.96)}

    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
    skies.init_sky_preset("redrock")

def initWaterResources():
    water.set_water_source(351.9, 481.3, 1)
    water.set_water_source(207.0, 264.6, 3)
    water.set_water_source(408.9, 219.0, 2)

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
        #spezielle non rest regionen
        system.add_region("Kampfarena",305,315,375,405)
    
    data("rest").non_rest_areas.append("Kampfarena")

def on_map_loaded():
    init_data()
    initParties()
    # place player characters
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    npc.initNPCS()
    initItems()
    initHerbs()
    initExitZones()
    initFX()
    initRegions()
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
    schedules.init_schedules() ## immer nach dem initQuestbook()
    init_scriptuse_objects()
    InitChestsSafes()
    init_character_states()
    init_non_rest_areas()
    init_Object_Animation()
    # object.add_closed_lock("marco sein haus", "lock1", closure_type='normal')

def init_Object_Animation():
    for id in BANNER:
        Anim_Banner(id)
    init_Windrad_449()

def Anim_Banner(id):
    object.play_animation(id, 'ANIM_BANNER', callback = ['ONEND', Lambda('Anim_Banner("%s")'%id)])

def init_Windrad_449():
    object.play_animation('SQZONE_6_BUILDING_449', 'ANIM_WINDRAD', callback = ['ONEND', Lambda('init_Windrad_449()')])

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
    system.mark_for_script_use('BUILDING_460')
    system.mark_for_script_use('BUILDING_32')
    # object.add_closed_lock("BUILDING_32", "lock1", closure_type='normal')
    #lagerfeuer
    
    # Bienenstöcke SQZone 6
    # system.mark_for_script_use('BUILDING_2203')
    # system.mark_for_script_use('BUILDING_2204')
    
    
def can_enter_building( character_id, building_id ):
    if building_id == "BUILDING_32":
        if character_id in system.get_pcs():
            return False
    return object_events.can_enter_building( character_id, building_id )
    
# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
    npcs = system.get_npcs()
    #mortality
    for npc in npcs:
        object.set_immortal_state(npc, True)

def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    init_non_rest_areas()
    schedules.init_schedules()
    init_patch()

def on_post_load():
    initFX()
    schedules.init_schedules()
    init_patch()

def on_attack(operator_id, target_id):
    #print 'on_attack(',operator_id, target_id,')'
    if target_id in ARENA_KAEMPFER_ID and data().Kampf and operator_id == 'ALTER_EGO' and data().Ego_Im_Kampf:
        if not system.is_cutscene():
            if object.get_attribute(target_id, 'hitpoints') <= 5:
                system.start_cutscene()
                data().Kampf = False
                object.cancel_commandos(operator_id)
                object.set_attribute(target_id, 'foes', None)
                object.set_attribute(target_id, 'hitpoints', object.get_attribute(target_id, 'maxhitpoints'))
                object.set_immortal_state(target_id, True)
                system.set_camera_view([319.67578125, 360.43869018554687, 26.685552597045898,\
                    0.52781170606613159, -0.18094483017921448, -0.8298637866973877])
                character.play_animation(target_id, 'CM_OHNMACHT_STEHEN_HINFALLEN_WAFFENLOS',\
                    callback = ['ONEND', Lambda('on_attack_helper("%s", "%s")'%(target_id, operator_id))])
                object.set_attribute(target_id, 'foes', None)
                character.play_animation(target_id, 'CM_OHNMACHT_LOOP')
                character.play_animation(target_id, 'CM_OHNMACHT_LOOP')
                character.play_animation(target_id, 'CM_OHNMACHT_LOOP')
                character.play_animation(target_id, 'CM_OHNMACHT_AUFSTEHEN_WAFFELOS',\
                    callback = ['ONEND', Lambda('Kampf_End_0_0("%s", "%s")'%(target_id, operator_id))])
    
    if target_id in ARENA_KAEMPFER_ID and operator_id in ARENA_KAEMPFER_ID and data().Kampf:
        if object.get_attribute(target_id, 'hitpoints') <= 5:
            data().Kampf = False
            object.cancel_commandos(operator_id)
            object.set_attribute(target_id, 'foes', None)
            object.set_attribute(operator_id, 'foes', None)
            object.set_attribute(target_id, 'hitpoints', object.get_attribute(target_id, 'maxhitpoints'))
            object.set_attribute(operator_id, 'hitpoints', object.get_attribute(operator_id, 'maxhitpoints'))
            object.set_immortal_state(target_id, True)
            character.play_animation(target_id, 'CM_OHNMACHT_STEHEN_HINFALLEN_WAFFENLOS',\
                callback = ['ONEND', Lambda('on_attack_helper("%s", "%s")'%(target_id, operator_id))])
            object.set_attribute(target_id, 'foes', None)
            character.play_animation(target_id, 'CM_OHNMACHT_LOOP')
            character.play_animation(target_id, 'CM_OHNMACHT_LOOP')
            character.play_animation(target_id, 'CM_OHNMACHT_LOOP')
            character.play_animation(target_id, 'CM_OHNMACHT_AUFSTEHEN_WAFFELOS',\
                callback = ['ONEND', Lambda('Kampf_End_0_0("%s", "%s")'%(target_id, operator_id))])
    
    
    if operator_id in system.get_pcs() and target_id in system.get_npcs() and not data().Ego_Im_Kampf and not object.get_party(target_id) == 'REST_RAIDERS':
        for char in system.get_npcs():
            object.set_immortal_state(char, False)
            if object.is_active(char):
                daily_routine.prohibit_activity(char)
                dialogs.Fans_Holen_End()
            object.set_attribute(char, 'foes', ['UISPIELER'])
            
def on_attack_helper(id, Gewinner):
    if id == 'ALTER_EGO' or Gewinner == 'ALTER_EGO':
        object.cancel_commandos('ALTER_EGO')
        if system.is_cutscene():
            system.end_cutscene()
    if Gewinner == 'ALTER_EGO':
        dialogs.EGO_Kampf_Gewonnen(data().Gegner, Gewinner)  
    else:
        dialogs.Preis_Waehlen_Ohne_Ego(id, Gewinner)

def can_pick_up(character_id, item_id):
    print 'can_pick_up(',character_id, item_id,')'
    if character_id in system.get_pcs():
        if data().Ego_Im_Kampf:
            if object.has_attribute(item_id, 'weapon_type'):
                return False
                
    return object_events.can_pick_up(character_id, item_id)

def on_sector_cleared(object_id):
    if object_id in system.get_npcs():
        for char in system.get_npcs():
            if object.is_fighting(char):
                return None
        daily_routine.allow_activity(object_id)
        
    object_events.on_sector_cleared(object_id)

def Kampf_End(id_1, id_2):
    sounds.play_3d_sound_object(sfx_id="audience_applause",object='SQZONE_6_BUILDING_460')
    sounds.play_3d_sound_object(sfx_id="audience_applause",object='SQZONE_6_BUILDING_460')
    sounds.play_3d_sound_object(sfx_id="audience_applause",object='SQZONE_6_BUILDING_460')
    if id_1 == 'ALTER_EGO' or id_2 =='ALTER_EGO': 
        system.start_cutscene()
    dialogs.initDlg_021_Sieger_Wird_Verkuendet(id_1, id_2)
    
def Kampf_End_0_0(id_1, id_2):
    if id_1 == 'ALTER_EGO' or id_2 == 'ALTER_EGO':
        if id_1 == 'ALTER_EGO':
            object.set_attribute('ALTER_EGO', 'unconscious', 0)
            character.play_animation(id_1, 'CM_OHNMACHT_AUFSTEHEN_WAFFELOS')
            Kampf_End_0(id_1, id_2)
        else:
            Kampf_End_0(id_1, id_2)
    else:
        Kampf_End_0(id_1, id_2)

def Kampf_End_0(id_1, id_2):
    object.move_to(id_1, 336.58, 355.53, callback = ['ONEND', Lambda('Kampf_End_0_1("%s", "%s")' %(id_1, id_2))])
    object.step_to(id_1, 334.27, 343.52, callback = ['ONEND', Lambda('Kampf_End_0_1("%s", "%s")' %(id_1, id_2))])
    object.step_to(id_1, 333.23, 338.31)
    object.step_to(id_1, 332.73, 333.84)
    object.step_away(id_1, callback = ["ONEND", Lambda('Kampf_End_2("%s", "%s", "%s")'%(id_1, id_2, id_1))])
    object.move_to(id_2, 336.58, 355.53, callback = ['ONEND', Lambda('Kampf_End_0_1("%s", "%s")' %(id_1, id_2))])
    object.step_to(id_2, 334.27, 343.52, callback = ['ONEND', Lambda('Kampf_End_0_1("%s", "%s")' %(id_1, id_2))])
    object.step_to(id_2, 333.23, 338.31)
    object.step_to(id_2, 332.73, 333.84)
    object.step_away(id_2, callback = ["ONEND", Lambda('Kampf_End_2("%s", "%s", "%s")'%(id_1, id_2, id_2))])
    
def Kampf_End_0_1(id_1, id_2):
    data().Count_2 += 1
    if data().Count_2 == 1:
        if id_1 == 'ALTER_EGO' or id_2 == 'ALTER_EGO':
            system.set_camera_view([339.64471435546875, 360.63507080078125, 12.182533264160156,\
                -0.40990522503852844, -0.88642704486846924, -0.214999720454216])
        object.play_animation("SQZONE_6_BUILDING_460", "ANIM_ARENA_TUER_OPEN")
        object.play_animation("SQZONE_6_BUILDING_631", "ANIM_GENERIC_DOOR1_ALTERNATIV_OPEN")
    if data().Count_2 == 4:
        data().Count_2 = 0
        Kampf_End_1(id_1, id_2)
    
def Kampf_End_1(id_1, id_2):
    if id_1 == 'ALTER_EGO' or id_2 == 'ALTER_EGO':
        system.set_camera_view([340.542724609375, 324.43121337890625, 12.515514373779297,\
            -0.43161517381668091, 0.87010419368743896, -0.2379641979932785])

def Kampf_End_2(id_1, id_2, AKTUELL_ID):
    data().Count += 1
    if data().Count == 1:
        object.move_to(AKTUELL_ID, 332.69, 331.75)
    if data().Count == 2:
        data().Count = 0
        object.cancel_commandos(id_1)
        object.cancel_commandos(id_2)
        if id_1 != 'ALTER_EGO':
            allow_activity(id_1)
        if id_2 != 'ALTER_EGO':
            allow_activity(id_2)
        if id_1 == 'ALTER_EGO' or id_2 == 'ALTER_EGO':
            dialogs.Marco_End()
            dialogs.Fans_Holen_End()
            object.play_animation("SQZONE_6_BUILDING_460", "ANIM_ARENA_TUER_CLOSE")
            object.play_animation('SQZONE_6_BUILDING_631', 'ANIM_GENERIC_DOOR1_ALTERNATIV_CLOSE',\
                callback = ['ONEND', Lambda('Kampf_End_3("%s", "%s")'%(id_1, id_2))])
        else:
            dialogs.Marco_End()
            dialogs.Fans_Holen_End()
            object.play_animation("SQZONE_6_BUILDING_460", "ANIM_ARENA_TUER_CLOSE")
            object.play_animation('SQZONE_6_BUILDING_631', 'ANIM_GENERIC_DOOR1_ALTERNATIV_CLOSE')

def Kampf_End_3(id_1, id_2):
    if id_1 == 'ALTER_EGO' or id_2 =='ALTER_EGO': 
        system.end_cutscene()
    if data().PartyWaffen.keys():
        for char in data().PartyWaffen.keys():
            if len(data().PartyWaffen[char]):
                for item_id in data().PartyWaffen[char]:
                    if item_id[1]:
                        object.transfer_item(char + '_BACKPACK', item_id[0], char)
                        if item_id[0] in object.get_inventory_id_list(char):
                            character.equip(char, item_id[0])
                    else:
                        object.transfer_item(char + '_BACKPACK', item_id[0], char)
    data().Waffen = []
    data().PartyWaffen = {}
    if len(data().ExtraMunition):
        for item_id in data().ExtraMunition:
            object.create_item_in_inventory('ALTER_EGO', item_id)
    data().ExtraMunition = []
    data().Ego_Im_Kampf = False

def on_attribute_change(object_id, attribute_name, new_value, old_value):
    if object_id == 'ALTER_EGO' and data().Ego_Im_Kampf:
        if attribute_name == 'unconscious':
            data().Ego_Im_Kampf = False
            object.set_attribute(data().Gegner, 'foes', None)
            object.set_attribute(data().Gegner, 'hitpoints', object.get_attribute(data().Gegner, 'maxhitpoints'))
            object.set_immortal_state(data().Gegner, True)
            enemy_script.delay(2, Lambda('dialogs.EGO_Kampf_Verloren("%s")'%data().Gegner))
    
    object_events.on_attribute_change(object_id, attribute_name, new_value, old_value)
            
def on_approach(target,operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)
    
def on_enter_region(id, objectid, partyid ):
    #print "[on_enter_region(",id, str(objectid), partyid,"]"
    # non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid): objectid=objectid[0]
        else: return
    
    if id == "ARENA":
        if not data().player_knows_Arena:
            data().player_knows_Arena = True
            system.add_minimap_marker(334.91,355.71    ,"MM_001")# Arena
    
    if (data().Baracken_Betrachtet == 0):
        data().Baracken_Betrachtet = 1
        for substring in REGION_BARACKEN:
            if(id == substring):
                dialogs.initDlg_001_Betrachten_Der_Baracken()
                return
    
    if (data().Haus_Marco_Betrachtet == 0):
        if ((id == REGION_HAUS_MARCO) and (data().Baracken_Betrachtet == 1)):
            dialogs.initDlg_002_Haus_Ist_Besser_Als_Unterkuenfte()
            return
        elif((id == REGION_HAUS_MARCO) and (data().Baracken_Betrachtet == 0)):
            dialogs.initDlg_003_Haus_Gefaellt_Spieler()
            return
            
def on_timer(id):
    #print "[debug on_timer()",id,"]"
    pass

def on_wait_for_commando(id):
    # print '[debug on_wait_for_commando: ]', id
    Time = system.get_mission_time().get_day_time()
    if (Time > time('06:03:00')) and (Time < time('06:10:00')):
        for Fan in ['FAN_001', 'FAN_002', 'FAN_004', 'FAN_006', 'FAN_009', 'FAN_011', 'FAN_012', 'FAN_014', 'FAN_015', 'FAN_016', 'FAN_018']:
            object.set_active_state(Fan, True)
    if (Time > time('06:33:00')) and (Time < time('06:40:00')):
        for Fan in ['FAN_003', 'FAN_007', 'FAN_020']:
            object.set_active_state(Fan, True)
    if (Time > time('07:03:00')) and (Time < time('07:10:00')):
        for Fan in ['FAN_005', 'FAN_008', 'FAN_013', 'FAN_019']:
            object.set_active_state(Fan, True)
    if (Time > time('08:03:00')) and (Time < time('08:10:00')):
        for Fan in ['FAN_010', 'FAN_017']:
            object.set_active_state(Fan, True)
    ################################################################################
    return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
    for substring in (OBJECT_IDS_Arena):
        if object_id.endswith(substring):
            return True
    for substring in (OBJECT_IDS_WOHNHAUS):
        if object_id.endswith(substring):
            return True
    for substring in (OBJECT_IDS_UNTERKUENFTE):
        if object_id.endswith(substring):
            return True

def on_examine_object( character_id, object_id ):
    for substring in (OBJECT_IDS_Arena):    
        if object_id.endswith(substring):
            InventarOeffnen(character_id, object_id)
    for substring in (OBJECT_IDS_WOHNHAUS):    
        if object_id.endswith(substring):
            InventarOeffnen(character_id, object_id)
    for substring in (OBJECT_IDS_UNTERKUENFTE):    
        if object_id.endswith(substring):
            InventarOeffnen(character_id, object_id)
            

# öffnet das Inventory
def InventarOeffnen(character_id, object_id) :
    inventorylist = object.get_inventory_list(object_id)
    if inventorylist:
        #show object inventory
        system.item_panel( character_id, object_id )
                
def CanLeaveZone():
    return False

def cit(npc,items):
    object.create_item_in_inventory(object=npc, equipment=items)

def initItems():
    
    ### NPCs ###
    
    cit('RADLEY', ["SET_M46_GAUNTLETS", "SET_WATER_BOTTLE","SET_NORMAL_CLOTHES_1", "SET_BOTTLE_OF_WHISKEY",\
                "SET_BOOMERANG"])
    cit('IRVING', ["SET_M46_ARMORED_HELMET", "SET_COW_SKIN", "SET_NORMAL_CLOTHES_2", "SET_DART", "SET_GAS_BOMB"])
    cit('DANTON', ["SET_DT21_LIGHT_ARMOR", "SET_WATER_BOTTLE", "SET_ORDINARY_HELMET", "SET_NORMAL_CLOTHES_3",\
                "SET_BOTTLE_OF_WHISKEY","SET_SHURIKEN"])
    cit('KEAGAN', ["SET_M46_STEEL_CLAD_BOOTS", "SET_COW_SKIN", "SET_DT21_LIGHT_ARMOR", "SET_BOTTLE_OF_WHISKEY"])
    cit('SABRINA',["SET_M46_HEAVY_ARMOR", "SET_WATER_BOTTLE", "SET_ORDINARY_HELMET", "SET_POT_ON_A_BAR",\
                "SET_GAS_BOMB"])
    
    cs.arme_npc("MARCO", "SET_UZI", 2), 
    cs.arme_npc("WACHE_001", "SET_SAWED_OFF_REMINGTON_M870", 2), 
    cs.arme_npc("WACHE_002", "SET_SIMONOV_SKS", 2), 
                
    
    cit("FAN_001", ["SET_BOTTLE_OF_WHISKEY"])
    
    ### Objecte ###
    # Location: Arena 
    cit("BUILDING_320", ["SET_COMPUTER_KEYBOARD"]) 
    cit("BUILDING_241", ["SET_MEAT_RAW_BIG"]) 
    cit("BUILDING_275", ["SET_WATERING_CAN"]) 
    cit("BUILDING_233", ["SET_APPLE"]*2) 
    cit("BUILDING_144", ["SET_CAR_EXHAUST_PIPE"]) 
    
    # Location: Wohnhaus
    cit("BUILDING_280", ["SET_NORMAL_CLOTHES_3"]) 
    cit("BUILDING_882", ["SET_TIN_CAN"]) 
    cit("BUILDING_281", ["SET_RAGS"]) 
    cit("BUILDING_872", ["SET_RAT_MEAT"]*3) 
    cit("BUILDING_195", ["SET_VERY_NICE_BRACELET"]) 
    
    # Location: Unterkünfte
    cit("BUILDING_263", ["SET_GRAPHICS_CARD"]) 
    cit("BUILDING_153", ["SET_WHEEL"]) 
    cit("BUILDING_169", ["SET_HAIRSTYLE_MAGAZINE"]) 
    cit("BUILDING_1166",["SET_STIMULANT_DRUG"]) 
    cit("BUILDING_157", ["SET_BULLET_CASINGS"]) 
                                
    # Bienenstöcke SQZ6
    # object.create_item_in_inventory( 'BUILDING_2203', equipment=[ 'SET_BEESWAX' ] )
    # object.create_item_in_inventory( 'BUILDING_2204', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )

    # Items in Kisten
    cit('BUILDING_2190', [ 'SET_AMMONIUM_NITRATE', 'SET_PLATE_ARMOR', 'SET_CHEESE' ] )
    cit('BUILDING_1500', [ 'SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM', 'SET_KATANA', 'SET_C4_TIMEBASED' ] )
    cit('BUILDING_2191', [ 'SET_TOASTER', 'SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', 'SET_M46_GAUNTLETS' ] )
    cit('BUILDING_1596', [ 'SET_DT21_STEEL_CLAD_HELMET', 'SET_GIANT_KNIFE', 'SET_PITCHER' ] )

                                
def initHerbs():
    system.create_object(equipmenttype="SET_BURNET", x=305.17, y=250.26)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=282.54, y=382)
    system.create_object(equipmenttype="SET_ANGELICA", x=312.44, y=384.56)
    
def initExitZones():
    system.add_region( id = "REGION_EXIT_NORD", x1 = 28.00, y1 = 65.00, x2 = 680.00, y2 = 200.00 )
    system.register_exit(regionname = "REGION_EXIT_NORD" )
    system.add_region( id = "REGION_EXIT_SUED", x1 = 28.00, y1 = 700.00, x2 = 680.00, y2 = 503.00 )
    system.register_exit(regionname = "REGION_EXIT_SUED" )
    system.add_region( id = "REGION_EXIT_WEST", x1 = 28.00, y1 = 65.00, x2 = 200.00, y2 = 700.00 )
    system.register_exit(regionname = "REGION_EXIT_WEST" )
    system.add_region( id = "REGION_EXIT_OST", x1 = 680.00, y1 = 65.00, x2 = 504.00, y2 = 700.00 )
    system.register_exit(regionname = "REGION_EXIT_OST" )

def initRegions():
    
    ### Region Baracken ###
    system.add_region( id = "REGION_BARACKEN_001", x1 = 453.75, y1 = 426.72, x2 = 430.00, y2 = 277.50 )
    system.notify_region_entered( region="REGION_BARACKEN_001", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_002", x1 = 410.02, y1 = 438.32, x2 = 430.00, y2 = 403.11 )
    system.notify_region_entered( region="REGION_BARACKEN_002", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_003", x1 = 430.00, y1 = 403.11, x2 = 420.00, y2 = 390.69 )
    system.notify_region_entered( region="REGION_BARACKEN_003", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_004", x1 = 461.06, y1 = 420.47, x2 = 453.75, y2 = 294.19 )
    system.notify_region_entered( region="REGION_BARACKEN_004", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_005", x1 = 470.92, y1 = 408.86, x2 = 461.06, y2 = 300.50 )
    system.notify_region_entered( region="REGION_BARACKEN_005", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_006", x1 = 482.52, y1 = 389.53, x2 = 470.92, y2 = 308.55 )
    system.notify_region_entered( region="REGION_BARACKEN_006", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_007", x1 = 489.25, y1 = 367.63, x2 = 482.52, y2 = 346.04 )
    system.notify_region_entered( region="REGION_BARACKEN_007", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_008", x1 = 430.00, y1 = 278.50, x2 = 394.50, y2 = 268.00 )
    system.notify_region_entered( region="REGION_BARACKEN_008", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_009", x1 = 422.50, y1 = 268.00, x2 = 394.50, y2 = 260.00 )
    system.notify_region_entered( region="REGION_BARACKEN_009", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_010", x1 = 408.12, y1 = 260.00, x2 = 394.50, y2 = 256.50 )
    system.notify_region_entered( region="REGION_BARACKEN_010", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_011", x1 = 394.50, y1 = 275.00, x2 = 390.00, y2 = 257.00 )
    system.notify_region_entered( region="REGION_BARACKEN_011", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_012", x1 = 430.00, y1 = 287.00, x2 = 415.00, y2 = 278.50 )
    system.notify_region_entered( region="REGION_BARACKEN_012", partyid="UISPIELER" )
    system.add_region( id = "REGION_BARACKEN_013", x1 = 430.00, y1 = 300.00, x2 = 420.00, y2 = 287.00 )
    system.notify_region_entered( region="REGION_BARACKEN_013", partyid="UISPIELER" )
    ###----------###
    
    ### Region Haus von Marco ###
    system.add_region( id = "REGION_Haus_Marco_001", x1 = 277.00, y1 = 249.21, x2 = 304.28, y2 = 278.70 )
    system.notify_region_entered( region="REGION_Haus_Marco_001", partyid="UISPIELER" )
    
    system.add_region("ARENA",305,315,375,405)
    system.notify_region_entered( "ARENA", partyid="UISPIELER" )

def initFX():
    pass
    for p_1 in PILLAR_1:
        fxPillar_1(p_1)
    for p_2 in PILLAR_2:
        fxPillar_2(p_2)
    
    sounds.load_sound(sfx_id='audience_applause')

def fxPillar_2(objectid):
    system.start_effect_object(object = objectid,node="dmyp_fire0",parameter=fx_fire_pilar_2)
    system.start_effect_object(object = objectid,node="dmyp_fire1",parameter=fx_fire_pilar_2)
    system.start_effect_object(object = objectid,node="dmyp_fire2",parameter=fx_fire_pilar_2)
    system.start_effect_object(object = objectid,node="dmyp_fire3",parameter=fx_fire_pilar_2)
    sounds.play_3d_sound_object(sfx_id="campfire_small",object=objectid,loop=True)
    
def fxPillar_1(objectid):
    system.start_effect_object(object = objectid,node="dmyp_fire",parameter=fx_fire_pilar_1)
    sounds.play_3d_sound_object(sfx_id="campfire_small",object=objectid,loop=True)

def on_pick_up( character_id, item_id, item_type ):
    print 'on_pick_up(',character_id, item_id, item_type,')'
    if character_id in system.get_pcs():
        if data().Ego_Im_Kampf:
            if object.has_attribute(item_type, 'weapon_type'):
                return False
    return True

def InitChestsSafes():
    object.add_closed_lock("BUILDING_2190", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_1500", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_2191", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_1596", "lock1", closure_type='booby-trap')

def init_patch():
    if "ANIE" in system.get_npcs():
        data("zone_7.zone_7").anie_folgt = True
    
    ANZAHL_KAEMPFER = 0
    for char in ARENA_KAEMPFER_ID:
        if object.is_fighting(char):
            ANZAHL_KAEMPFER += 1
    if ANZAHL_KAEMPFER == 0 or ANZAHL_KAEMPFER == 2:
        data().Ego_Im_Kampf = False
    
    if not hasattr(data('sqzone_6.sqzone_6'), 'PartyWaffen'):
        data().PartyWaffen = {}
        if len(data().Waffen):
            for equ in data().Waffen:
                object.create_item_in_inventory('ALTER_EGO', equ)
            data().Waffen =  []
            if data().Ego_Im_Kampf:
                dialogs.WaffenDeaktivieren()
    
