# -*- coding: utf-8 -*-
from globals import *
from types import *
from const import *
from npc_activities import *
from char_autogeneration import CHANCE_TABLE

#***  act. Revision 46, 30.09.2004 **********************************************

def initNPCS():
	initMC()
	initMercenaries()
	initScheduledNPCs()

	system.create_character(
		id="DRILL_INSTRUCTOR",
		gender="male",
		party="DORFBEWOHNER",
		x=322,
		y=326,
		name=globaltext.NAME_DRILL_INSTRUCTOR,
		direction = 90,
		resourceui="drill_instructor.png" )

	object.set_attribute("DRILL_INSTRUCTOR", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("DRILL_INSTRUCTOR", "level", 1 )
	object.set_attributes("DRILL_INSTRUCTOR",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="drill_instructor")
	character.update_appearance("DRILL_INSTRUCTOR")
	character.scale("DRILL_INSTRUCTOR",1.85)

	system.create_character(
		id="SEBASTIAN",
		gender="male",
		party="DORFBEWOHNER",
		x=322,
		y=340,
		name=globaltext.NAME_SEBASTIAN,
		direction = globals.DIR_WEST,
		resourceui="dan.png" )
	object.set_attribute("SEBASTIAN", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("SEBASTIAN", "level", 1 )
	object.set_attributes("SEBASTIAN",
		model="low",
		gender="male",
		skin="white",
		clothes="ss_004",
		face="evil12")
	character.update_appearance("SEBASTIAN")
	character.scale("SEBASTIAN",1.70)
	object.set_attribute("SEBASTIAN", "trader", True)
	object.set_attribute("SEBASTIAN", "trader_type", "all")
	object.set_position("SEBASTIAN", x=400.78, y=459.45, grid="ZONE_1_BUILDING_196_INTERIOR_GRID")
	
	system.create_character(
		id="PRESIDENT_HAYES",
		gender="male",
		party="DORFBEWOHNER",
		x=308.14,
		y=482.43,
		name=globaltext.NAME_PRESIDENT_HAYES,
		direction = 0,
		resourceui="president_hayes.png" )
		# ratskull_member_0012
	object.set_attribute("PRESIDENT_HAYES", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("PRESIDENT_HAYES", "level", 1 )
	object.set_attributes("PRESIDENT_HAYES",
		model="low",
		gender="male",
		skin="white",
		clothes="president_hayes",
		face="president_hayes")
	character.set_main_quest_npc_state(char="PRESIDENT_HAYES", state=True)
	character.update_appearance("PRESIDENT_HAYES")
	character.set_approachable_state("PRESIDENT_HAYES",NOTAPPROACHABLE)
	character.scale("PRESIDENT_HAYES",1.85)
	
	system.create_character(
		id="WESLEY",
		gender="male",
		party="DORFBEWOHNER",
		x=454.25,
		y=300.30,
		name=globaltext.NAME_WESLEY,
		direction = data().DIR_NORTH_WEST,
		resourceui="wesley.png" )
		# village_elder
	object.set_attribute("WESLEY", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("WESLEY", "level", 1 )
	object.set_attributes("WESLEY",
		model="low",
		gender="male",
		skin="white",
		clothes="wesley",
		face="wesley")
	character.set_main_quest_npc_state(char="WESLEY", state=True)
	character.update_appearance("WESLEY")
	character.scale("WESLEY",1.83)
	
	system.create_character(
		id="PRESIDENT_GUARD_01",
		gender="male",
		party="WACHEN",
		#x=310,y=424,
		x=313.42,
		y=424.55,
		name=globaltext.NAME_PRESIDENT_GUARD,
		direction = 90,
		resourceui="president_guard_01.png" )
	object.set_attribute("PRESIDENT_GUARD_01", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("PRESIDENT_GUARD_01", "level", 1 )
	object.set_attributes("PRESIDENT_GUARD_01",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="president_guard_01")
	character.update_appearance("PRESIDENT_GUARD_01")
	object.create_item_in_inventory	( object="PRESIDENT_GUARD_01", 	equipment = [ "SET_M_16", "SET_AMMOPACK_5_56_MM",
																"SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_5_56_MM" ] )
	character.equip( "PRESIDENT_GUARD_01", equipment="SET_M_16" )

	system.create_character(
		id="PRESIDENT_GUARD_02",
		gender="male",
		party="WACHEN",
		x=310.6,
		y=437.6,
		name=globaltext.NAME_PRESIDENT_GUARD,
		direction = 90,
		resourceui="president_guard_02.png" )
	object.set_attribute("PRESIDENT_GUARD_02", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("PRESIDENT_GUARD_02", "level", 1 )
	object.set_attributes("PRESIDENT_GUARD_02",
		model="low",
		gender="male",
		skin="white",
		#Democode
		clothes="ll_gno_guard",
		#clothes="ll_004",
		face="president_guard_02")
	character.update_appearance("PRESIDENT_GUARD_02")
	object.create_item_in_inventory	( object="PRESIDENT_GUARD_02", 	equipment = [ "SET_M_16", "SET_AMMOPACK_5_56_MM","SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_5_56_MM" ] )
	character.equip( "PRESIDENT_GUARD_02", equipment="SET_M_16" )

	# Paßaussteller
	system.create_character(
		id = "LUCAS",
		gender="male",
		party = "DORFBEWOHNER",
		x = 474.88,
		y = 373,
		name=globaltext.NAME_LUCAS,
		direction = 270,
		resourceui = "lucas.png" )
	object.set_attribute("LUCAS", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("LUCAS", "level", 1 )
	object.set_attributes("LUCAS",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="lucas")
	character.set_main_quest_npc_state(char="LUCAS", state=True)
	character.update_appearance("LUCAS")
	character.scale("LUCAS",1.74)
	
	# Informant Nick
	system.create_character(
		id = "NICK",
		gender="male",
		party = "DORFBEWOHNER",
		x = 420.0,
		y = 353.5,
		name=globaltext.NAME_NICK,
		direction = 180,
		resourceui = "nick.png")

	object.set_attribute("NICK", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("NICK", "level", 1 )
	object.set_attributes("NICK",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="nick")
	character.update_appearance("NICK")

	## 3 Untote beim Grad des Vaters
	system.create_character(
		id = "UNDEAD_1",
		gender="male",
		party = "DORFBEWOHNER",
		x = 567.05,
		y = 352.03,
		name=globaltext.NAME_UNDEAD,
		direction = 170,
		resourceui = "" )
	object.set_attribute("UNDEAD_1", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("UNDEAD_1", "level", 1 )
	object.set_attributes("UNDEAD_1",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_seeker",
		face="evil03")
	character.update_appearance("UNDEAD_1")
	character.set_approachable_state("UNDEAD_1",NOTAPPROACHABLE)
	object.set_active_state("UNDEAD_1",INACTIVE)

	system.create_character(
		id = "UNDEAD_2",
		gender="male",
		party = "DORFBEWOHNER",
		x = 568.9,
		y = 353.3,
		name=globaltext.NAME_UNDEAD,
		direction = 180,
		resourceui = "" )
	object.set_attribute("UNDEAD_2", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("UNDEAD_2", "level", 1 )
	object.set_attributes("UNDEAD_2",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_seeker",
		face="evil04")
	character.update_appearance("UNDEAD_2")
	character.set_approachable_state("UNDEAD_2",NOTAPPROACHABLE)
	object.set_active_state("UNDEAD_2",INACTIVE)

	system.create_character(
		id = "UNDEAD_3",
		gender="male",
		party = "DORFBEWOHNER",
		x = 566.0,
		y = 352.8,
		name=globaltext.NAME_UNDEAD,
		direction = 190,
		resourceui = "" )
	object.set_attribute("UNDEAD_3", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("UNDEAD_3", "level", 1 )
	object.set_attributes("UNDEAD_3",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_seeker",
		face="evil07")
	character.update_appearance("UNDEAD_3")
	character.set_approachable_state("UNDEAD_3",NOTAPPROACHABLE)
	object.set_active_state("UNDEAD_3",INACTIVE)

	system.create_character(
		id="GUARD_QUARTERS_01",
		gender="male",
		party="DORFBEWOHNER",
		x = 314,
		y = 468,
		name=globaltext.NAME_GUARD,
		direction = 90,
		resourceui="guard_of_quarters_01.png" )

	object.set_attribute("GUARD_QUARTERS_01", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("GUARD_QUARTERS_01", "level", 1 )
	object.set_attributes("GUARD_QUARTERS_01",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="guard_of_quarters_01")
	character.update_appearance("GUARD_QUARTERS_01")
	object.create_item_in_inventory	( object="GUARD_QUARTERS_01", equipment = ["SET_M_16", "SET_AMMOPACK_5_56_MM",
										"SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_5_56_MM"])
	character.equip( "GUARD_QUARTERS_01", equipment="SET_M_16",direct_ammo_load=True)

	system.create_character(
		id="GUARD_QUARTERS_02",
		gender="male",
		party="DORFBEWOHNER",
		x = 314,
		y = 474,
		name=globaltext.NAME_GUARD,
		direction = 90,
		resourceui="guard_of_quarters_02.png")

	object.set_attribute("GUARD_QUARTERS_02", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("GUARD_QUARTERS_02", "level", 1 )
	object.set_attributes("GUARD_QUARTERS_02",
		model="low",
		gender="male",
		skin="white",
		#Democode
		clothes="ll_gno_guard",
		#clothes="sl_004",
		face="guard_of_quarters_02")
	character.update_appearance("GUARD_QUARTERS_02")
	object.create_item_in_inventory	( object="GUARD_QUARTERS_02", 	equipment = [ "SET_M_16", "SET_AMMOPACK_5_56_MM","SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_5_56_MM" ] )
	character.equip( "GUARD_QUARTERS_02", equipment="SET_M_16",direct_ammo_load=True)

	system.create_character(
		id="PRESIDENT_COMPANION_01",
		gender="male",
		party="DORFBEWOHNER",
		x = 308.14,
		y = 485.43,
		name=globaltext.NAME_COMPANION,
		direction = 0,
		resourceui="president_companion_01.png")
	object.set_attribute("PRESIDENT_COMPANION_01", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("PRESIDENT_COMPANION_01", "level", 1 )
	object.set_attributes("PRESIDENT_COMPANION_01",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="albin")
	character.update_appearance("PRESIDENT_COMPANION_01")
	character.scale("PRESIDENT_COMPANION_01",1.80)
	
	system.create_character(
		id="PRESIDENT_COMPANION_02",
		gender="male",
		party="DORFBEWOHNER",
		x = 310.32,
		y = 482.43,
		name=globaltext.NAME_COMPANION,
		direction = 0,
		resourceui="president_companion_02.png")
	object.set_attribute("PRESIDENT_COMPANION_02", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("PRESIDENT_COMPANION_02", "level", 1 )
	object.set_attributes("PRESIDENT_COMPANION_02",
		model="low",
		gender="male",
		skin="black",
		clothes="ll_gno_guard",
		face="reimund")
	character.update_appearance("PRESIDENT_COMPANION_02")
	character.scale("PRESIDENT_COMPANION_02",1.82)

	system.create_character(
		id="GUARD_CAMP_01",
		gender="male",
		party="DORFBEWOHNER",
		x = 366.62,
		y = 552.74,
		name=globaltext.NAME_GUARD,
		direction = data().DIR_SOUTH_EAST,
		resourceui="guard_of_quarters_01.png" )
	object.set_attribute("GUARD_CAMP_01", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("GUARD_CAMP_01", "level", 1 )
	object.set_attributes("GUARD_CAMP_01",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="guard_of_quarters_01")
	character.update_appearance("GUARD_CAMP_01")
	object.create_item_in_inventory	( object="GUARD_CAMP_01", 	equipment = [ "SET_M_16", "SET_AMMOPACK_5_56_MM",
																"SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_5_56_MM" ] )
	character.equip( "GUARD_CAMP_01", equipment="SET_M_16",direct_ammo_load=True)
	object.set_position_free("GUARD_CAMP_01",366.62,552.74,0,grid="landscape")
	
	system.create_character(
		id="GUARD_CAMP_02",
		gender="male",
		party="DORFBEWOHNER",
		x = 382.8,
		y = 544.4,
		name=globaltext.NAME_GUARD,
		direction = 180,
		resourceui="guard_of_quarters_02.png")
	object.set_attribute("GUARD_CAMP_02", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("GUARD_CAMP_02", "level", 1 )
	object.set_attributes("GUARD_CAMP_02",
		model="low",
		gender="male",
		skin="white",
		#Democode
		clothes="ll_gno_guard",
		#clothes="sl_004",
		face="guard_of_quarters_02")
	character.update_appearance("GUARD_CAMP_02")
	object.create_item_in_inventory	( object="GUARD_CAMP_02", 	equipment = [ "SET_M_16", "SET_AMMOPACK_5_56_MM",
																"SET_AMMOPACK_5_56_MM", "SET_AMMOPACK_5_56_MM" ] )
	character.equip( "GUARD_CAMP_02", equipment="SET_M_16",direct_ammo_load=True)
	object.set_position_free("GUARD_CAMP_02",382.8,544.4,0,grid="landscape")

##############################################################################################################
## TA NPCs Ergaenzung | Roger 12.01.2004
##############################################################################################################
	system.create_character(
		id="SEAMUS",
		gender="male",
		party="DORFBEWOHNER",
		x = 310.0,
		y = 480.0,
		name=globaltext.NAME_COMPANION,
		direction = 0,
		resourceui="")
	object.set_attribute("SEAMUS", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("SEAMUS", "level", 1 )
	object.set_attributes("SEAMUS",
		model="low",
		gender="male",
		skin="white",
		clothes="ls_001",
		face="albin")
	character.update_appearance("SEAMUS")

	system.create_character(
		id="JOHN_GRAY",
		gender="male",
		party="DORFBEWOHNER",
		x = 312.0,
		y = 480.0,
		name=globaltext.NAME_JOHN_GRAY,
		direction = 0,
		resourceui="")
	object.set_attribute("JOHN_GRAY", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("JOHN_GRAY", "level", 1 )
	object.set_attributes("JOHN_GRAY",
		model="low",
		gender="male",
		skin="white",
		clothes="ls_002",
		face="gandolf")
	character.update_appearance("JOHN_GRAY")

	system.create_character(
		id="VICTOR_Z1",
		gender="male",
		party="DORFBEWOHNER",
		x = 314.0,
		y = 480.0,
		name=globaltext.NAME_VICTOR_Z1,
		direction = 0,
		resourceui="")
	object.set_attribute("VICTOR_Z1", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("VICTOR_Z1", "level", 1 )
	object.set_attributes("VICTOR_Z1",
		model="low",
		gender="male",
		skin="black",
		clothes="uni_004",
		face="godbert")
	character.update_appearance("VICTOR_Z1")

	system.create_character(
		id="BOB",
		gender="male",
		party="DORFBEWOHNER",
		x = 316.0,
		y = 480.0,
		name=globaltext.NAME_BOB,
		direction = 0,
		resourceui="")
	object.set_attribute("BOB", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("BOB", "level", 1 )
	object.set_attributes("BOB",
		model="low",
		gender="male",
		skin="white",
		clothes="ss_004",
		face="gudmunt")
	character.update_appearance("BOB")

	system.create_character(
		id="GORDON_MILLER",
		gender="male",
		party="DORFBEWOHNER",
		x = 318.0,
		y = 480.0,
		name=globaltext.NAME_GORDON_MILLER,
		direction = 0,
		resourceui="")
	object.set_attribute("GORDON_MILLER", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("GORDON_MILLER", "level", 1 )
	object.set_attributes("GORDON_MILLER",
		model="low",
		gender="male",
		skin="black",
		clothes="ll_002",
		face="otilo")
	character.update_appearance("GORDON_MILLER")

	system.create_character(
		id="MEL",
		gender="male",
		party="DORFBEWOHNER",
		x = 320.0,
		y = 480.0,
		name=globaltext.NAME_MEL,
		direction = 0,
		resourceui="")
	object.set_attribute("MEL", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("MEL", "level", 1 )
	object.set_attributes("MEL",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_002",
		face="heilwig")
	character.update_appearance("MEL")

	system.create_character(
		id="WALLY",
		gender="male",
		party="DORFBEWOHNER",
		x = 375.0,
		y = 540.0,
		name=globaltext.NAME_WALLY,
		direction = 0,
		resourceui="")
	object.set_attribute("WALLY", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("WALLY", "level", 1 )
	object.set_attributes("WALLY",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="albin")
	character.update_appearance("WALLY")
	object.create_item_in_inventory("WALLY",["SET_MP5","SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM"])
	character.equip("WALLY",equipment="SET_MP5",direct_ammo_load=True)

	system.create_character(
		id="FRANK",
		gender="male",
		party="DORFBEWOHNER",
		x = 320.0,
		y = 429.0,
		name=globaltext.NAME_FRANK,
		direction = 0,
		resourceui="")
	object.set_attribute("FRANK", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("FRANK", "level", 1 )
	object.set_attributes("FRANK",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="blankard")
	character.update_appearance("FRANK")
	object.create_item_in_inventory("FRANK",["SET_MP5","SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM"])
	character.equip("FRANK",equipment="SET_MP5",direct_ammo_load=True)

	system.create_character(
		id="CARL_Z1",
		gender="male",
		party="DORFBEWOHNER",
		x = 387.0,
		y = 544.0,
		name=globaltext.NAME_CARL_Z1,
		direction = 0,
		resourceui="")
	object.set_attribute("CARL_Z1", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("CARL_Z1", "level", 1 )
	object.set_attributes("CARL_Z1",
		model="low",
		gender="male",
		skin="black",
		clothes="ll_gno_guard",
		face="dietbert")
	character.update_appearance("CARL_Z1")
	object.create_item_in_inventory("CARL_Z1",["SET_FAMAS","SET_AMMOPACK_5_56_MM","SET_AMMOPACK_5_56_MM"])
	character.equip("CARL_Z1",equipment="SET_FAMAS",direct_ammo_load=True)

	system.create_character(
		id="LINDA_Z1",
		gender="female",
		party="DORFBEWOHNER",
		x = 214.0,
		y = 294.0,
		name=globaltext.NAME_LINDA_Z1,
		direction = 0,
		resourceui="")
	object.set_attribute("LINDA_Z1", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("LINDA_Z1", "level", 1 )
	object.set_attributes("LINDA_Z1",
		model="low",
		gender="female",
		skin="white",
		clothes="ll_gno_guard",
		face="fulberta")
	character.update_appearance("LINDA_Z1")
	object.create_item_in_inventory("LINDA_Z1",["SET_FAMAS","SET_AMMOPACK_5_56_MM","SET_AMMOPACK_5_56_MM"])
	character.equip("LINDA_Z1",equipment="SET_FAMAS",direct_ammo_load=True)

	system.create_character(
		id="GENE",
		gender="male",
		party="DORFBEWOHNER",
		x = 502.0,
		y = 233.0,
		name=globaltext.NAME_GENE,
		direction = 0,
		resourceui="")
	object.set_attribute("GENE", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("GENE", "level", 1 )
	object.set_attributes("GENE",
		model="low",
		gender="male",
		skin="black",
		clothes="ll_gno_guard",
		face="kunolf")
	character.update_appearance("GENE")
	object.create_item_in_inventory("GENE",["SET_FAMAS","SET_AMMOPACK_5_56_MM","SET_AMMOPACK_5_56_MM"])
	character.equip("GENE",equipment="SET_FAMAS",direct_ammo_load=True)

	## !! >> remove before
	#for npc in ADDITIONAL_NPC_IDS:
	#	object.set_active_state(npc, INACTIVE)

##############################################################################################################

	if( data().Execution == 0 ):
		initExecution()

def initExecution():
	object.set_position( "PRESIDENT_HAYES", 386.41, 439.35 )
	object.turn_to_direction( "PRESIDENT_HAYES", data().DIR_NORTH_WEST )
	object.set_active_state( "PRESIDENT_HAYES", ACTIVE)

	object.set_position( "PRESIDENT_COMPANION_01", 386.68, 441.17 )
	object.turn_to_direction( "PRESIDENT_COMPANION_01", data().DIR_NORTH_WEST )
	object.set_active_state( "PRESIDENT_COMPANION_01", ACTIVE)

	object.set_position( "PRESIDENT_COMPANION_02", 386.56, 439.35 )
	object.turn_to_direction( "PRESIDENT_COMPANION_02", data().DIR_SOUTH )
	object.set_active_state( "PRESIDENT_COMPANION_02", ACTIVE)

	object.set_position( "MASON", 376.38, 430.56 )
	object.turn_to_direction( "MASON", data().DIR_EAST )

	object.set_position( "KATHARINE", 377.5, 423.7 )
	object.turn_to_direction( "KATHARINE", data().DIR_SOUTH )

	object.set_position( "WILMA", 374.29, 428.44 )
	object.turn_to_direction( "WILMA", data().DIR_SOUTH_EAST )

	object.set_position( "HERB", 376.40, 426.64 )
	object.turn_to_direction( "HERB", data().DIR_SOUTH_EAST )

	object.set_position( "AARON", 377.18,426.11 )
	object.turn_to_direction( "AARON", data().DIR_SOUTH )

	object.set_position( "JON", 387.73, 426.65 )
	object.turn_to_direction( "JON", data().DIR_SOUTH_WEST )

	object.set_position( "ORSON", 382.26, 428.79 )
	object.turn_to_direction( "ORSON", data().DIR_SOUTH_WEST )

	object.set_position( "JOSEFINE", 385.14, 429.15 )
	object.turn_to_direction( "JOSEFINE", data().DIR_SOUTH_WEST )

	object.set_position( "VAL", 382.87, 430.06 )
	object.turn_to_direction( "VAL", data().DIR_SOUTH_WEST )

	object.set_position( "SIERRA", 376.69, 426.15 )
	object.turn_to_direction( "SIERRA", data().DIR_SOUTH_EAST )

	object.set_position( "FAITH", 381.64, 426.35 )
	object.turn_to_direction( "FAITH", data().DIR_SOUTH_WEST )

	object.set_position( "MERCENARY_AGNES", 383.85, 427.74 )
	object.turn_to_direction( "MERCENARY_AGNES", data().DIR_SOUTH_WEST )

	object.set_position( "MERCENARY_CARMEN", 387.86,427.38 )
	object.turn_to_direction( "MERCENARY_CARMEN", data().DIR_SOUTH_WEST )

	object.set_position( "MERCENARY_VASQUEZ", 385.08, 426.16 )
	object.turn_to_direction( "MERCENARY_VASQUEZ", data().DIR_SOUTH_WEST )

	object.set_position( "MERCENARY_IVANA", 384.05,426.29 )
	object.turn_to_direction( "MERCENARY_IVANA", data().DIR_SOUTH_WEST )

	object.set_position( "MERCENARY_SALLY", 381.16, 425.47 )
	object.turn_to_direction( "MERCENARY_SALLY", data().DIR_SOUTH )

	object.set_position( "MERCENARY_BUTCH", 378.71, 423.41 )
	object.turn_to_direction( "MERCENARY_BUTCH", data().DIR_SOUTH )

	object.set_position( "MERCENARY_FRANCIS", 372.12, 428.02 )
	object.turn_to_direction( "MERCENARY_FRANCIS", data().DIR_SOUTH_EAST )

	object.set_position( "MERCENARY_VICTOR", 372.32,426.21 )
	object.turn_to_direction( "MERCENARY_VICTOR", data().DIR_SOUTH_EAST )

	object.set_position( "SEAMUS",		376.9,422.6 )
	object.turn_to_object( "SEAMUS","BUILDING_2066")
	object.set_position( "JOHN_GRAY",	376.37,423.09 )
	object.turn_to_object( "JOHN_GRAY","BUILDING_2066")
	object.set_position( "VICTOR_Z1",	375.4,428.0 )
	object.turn_to_object( "VICTOR_Z1","BUILDING_2066")
	object.set_position( "BOB",		371.0,426.2 )
	object.turn_to_object( "BOB","BUILDING_2066")
	object.set_position( "GORDON_MILLER",	385.9,424.1 )
	object.turn_to_object( "GORDON_MILLER","BUILDING_2066")
	object.set_position( "MEL",		382.0,424.3 )
	object.turn_to_object( "MEL","BUILDING_2066")

def initMC():

	gender = "female"

	if( system.get_pcidentifier()=="HERO1"	or
		system.get_pcidentifier()=="HERO2"	or
		system.get_pcidentifier()=="HERO3"	or
		system.get_pcidentifier()=="HERO4"	or
		system.get_pcidentifier()=="HERO5"	or
		system.get_pcidentifier()=="HERO6"	or
		system.get_pcidentifier()=="HERO7"	or
		system.get_pcidentifier()=="HERO8"):
			gender = "male"

	system.create_character(
		id="ALTER_EGO",
		gender=gender,
		party="UISPIELER",
		x=369,
		y=588,
		name="",
		resourceui="FACE_STARTMALE_001")

	skin = "white"
	face = "hero1"
	uiface = "character1.png"
	mc_identifier = system.get_pcidentifier()

	if( mc_identifier == "HERO1" ):
		skin = "white"
		face = "hero1"
		hair = "hero1"
	elif( mc_identifier == "HERO2" ):
		skin = "black"
		face = "hero2"
		#hair = "hero2"
		hair = None
	elif( mc_identifier == "HERO3" ):
		skin = "white"
		face = "hero3"
		hair = "hero3"
	elif( mc_identifier == "HERO4" ):
		skin = "white"
		face = "hero4"
		hair = "hero4"
	elif( mc_identifier == "HERO5" ):
		skin = "white"
		face = "hero5"
		hair = None
	elif( mc_identifier == "HERO6" ):
		skin = "white"
		face = "hero6"
		hair = "hero6"
	elif( mc_identifier == "HERO7" ):
		skin = "white"
		face = "hero7"
		hair = "hero7"
	elif( mc_identifier == "HERO8" ):
		skin = "white"
		face = "hero8"
		hair = "hero8"
	elif( mc_identifier == "HEROINE1" ):
		skin = "white"
		face = "heroine1"
		hair = "heroine1"
	elif( mc_identifier == "HEROINE2" ):
		skin = "black"
		face = "heroine2"
		hair = "heroine2"
	elif( mc_identifier == "HEROINE3" ):
		skin = "white"
		face = "heroine3"
		hair = "heroine3"
	elif( mc_identifier == "HEROINE4" ):
		skin = "white"
		face = "heroine4"
		hair = "heroine4"
	elif( mc_identifier == "HEROINE5" ):
		skin = "white"
		face = "heroine5"
		hair = "heroine5"
	elif( mc_identifier == "HEROINE6" ):
		skin = "white"
		face = "heroine6"
		hair = "heroine6"
	elif( mc_identifier == "HEROINE7" ):
		skin = "white"
		face = "heroine7"
		hair = "heroine7"
	elif( mc_identifier == "HEROINE8" ):
		skin = "white"
		face = "heroine8"
		hair = "heroine8"

	object.set_attribute( "ALTER_EGO","gender",gender)
	object.set_attribute( "ALTER_EGO","skin",skin)
	object.set_attribute( "ALTER_EGO","face",face)
	object.set_attribute( "ALTER_EGO","model","high")

	object.set_attribute( "ALTER_EGO","clothes","naked")
	object.set_attribute( "ALTER_EGO","clothes_gloves","naked")
	object.set_attribute( "ALTER_EGO","clothes_boots","naked")

	object.set_attribute( "ALTER_EGO", "hair", hair )

	object.create_item_in_inventory( "ALTER_EGO", [ "SET_INTRO_CLOTHES", "SET_LEATHER_BOOTS" ] )
	character.equip( "ALTER_EGO", "SET_INTRO_CLOTHES" )
	character.equip( "ALTER_EGO", "SET_LEATHER_BOOTS" )

	character.update_appearance( "ALTER_EGO" )
	
	ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS = 10

	object.set_attribute("ALTER_EGO", "strength", ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS )
	object.set_attribute("ALTER_EGO", "agility", ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS )
	object.set_attribute("ALTER_EGO", "dexterity", ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS )
	object.set_attribute("ALTER_EGO", "constitution", ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS )
	object.set_attribute("ALTER_EGO", "intelligence", ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS )
	object.set_attribute("ALTER_EGO", "charisma", ALTER_EGO_DEFAULT_ATTRIBUTE_POINTS )

	ALTER_EGO_DEFAULT_SKILL_POINTS = 40
	
	object.set_attribute("ALTER_EGO", "light_weapons", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "heavy_weapons", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "sniper_weapons", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "speech", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "throw_weapons", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "explosives", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "survival", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "technic", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "medicine", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "sneak", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "driving", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "pick_pocket", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "lock_pick", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "close_combat", ALTER_EGO_DEFAULT_SKILL_POINTS )
	object.set_attribute("ALTER_EGO", "level", 1 )
	object.set_attribute("ALTER_EGO", "experience", 0 )

	if gender=="female":
		object.set_attribute("ALTER_EGO", "voice_id", "AEF" )

def initMercenaries():

	#Mercenary Dictionary defines outfit, attributes and skills of the mercenaries

	#first list: general data
	#gender
	#name
	#x
	#y
	#direction

	#2nd list: 3D Model
	#model
	#skin
	#clothes
	#clothes_boots
	#clothes_glvoes
	#face
	#resourceui (face for dialogues)

	#3rd list: attributes
	#Strenght - Stärke
	#agility - Beweglichkeit
	#dexterity - Geschicklichkeit
	#constituion - Konstitution
	#intelligence - Intelligenz
	#charisma - Charisma

	#4th list: skills
	#close combat - Nahkampf
	#light weapons - Leichte Waffen
	#heavy weapons - Schwere Waffen
	#sniper weapons - Sniper-Waffen
	#special weapons - Spezialwaffen
	#throw weapons - Wurfwaffen
	#explosives - Sprengstoffe
	#Survival
	#sneak - Lautlos bewegen
	#pickpocketing - Taschendiebstahl
	#pick locks - Schlösser öffnen
	#technics - Technik
	#driving - Fahrgeschick
	#medicine - Medizin

	#to do:
	#remove clothes attribute settings when the item inventory functionality is completely done

	#Ronny, if this comments are not enough, I really can't help you. :-)

	ChanceTable = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]

	MercData = \
		{	"MERCENARY_AGNES": 			( 	( "female", globaltext.NAME_AGNES, 403.3, 285.0, 180 ),
											( "high", "white", "SET_NORMAL_CLOTHES_3", "naked", "naked", "luise", "luise", "" ),
											( 7, 8, 12, 13, 10, 10 ),
											( 	50, 50, 40, 50, 50,
												50, 50, 30, 60, 50,
												50, 50, 50, 70 ),
											( "08.09.2058", NAT_AMERICAN, RES_ARIZONA, "Single", EXP_MEDICINE, BOD_WIRY, "---" ),
												# date_of_birth, nationality, last_residence, family_status, experience_of_life
												# body_feature
											( 3, 3, 30, 50, 7, 7 ),
											( 	10, 10, 5, 10, 10,
												10, 10, 5, 30, 10,
												10, 10, 10, 50 ),
										),
			"MERCENARY_CARMEN": 		( 	( "female", globaltext.NAME_CARMEN, 407.8, 285.0, 180 ),
											( "high", "white", "SET_NORMAL_CLOTHES_6", "naked", "naked", "ira", "ira", "" ),
											( 7, 10, 10, 8, 12, 13 ),
											( 	50, 60, 50, 50, 50,
												50, 50, 50, 50, 70,
												50, 30, 50, 40 ),
											( "20.12.2054", NAT_AMERICAN, RES_ARIZONA, "Divorced", EXP_CRIME, BOD_HANDSOME, "---" ),
											( 3, 7, 7, 3, 30, 50 ),
											( 	10, 30, 10, 10, 10,
												10, 10, 10, 30, 50,
												10, 5, 10, 5 ),
										),
			"MERCENARY_VASQUEZ": 		( 	( "male", globaltext.NAME_VASQUEZ, 385.08, 426.16, 0 ),
											( "high", "black", "SET_NORMAL_CLOTHES_6", "naked", "naked", "ernest", "ernest", "" ),
											( 10, 8, 12, 10, 13, 7 ),
											( 	70, 50, 50, 50, 50,
												50, 50, 40, 30, 50,
												50, 50, 60, 50 ),
											( "20.04.2060", NAT_AMERICAN, RES_NEW_MEXICO, "Single", EXP_MARTIAL_ARTS, BOD_STRONG, "---" ),
											( 7, 3, 30, 7, 50, 3 ),
											( 	50, 10, 10, 10, 10,
												10, 10, 5, 5, 10,
												10, 10, 30, 10 ),
										),
			"MERCENARY_IVANA":			( 	( "female", globaltext.NAME_IVANA, 384.05,426.29, 0 ),
											( "high", "white", "SET_NORMAL_CLOTHES_1", "naked", "naked", "amber", "amber", "" ),
											( 13, 12, 10, 10, 7, 8 ),
											( 	50, 50, 50, 60, 70,
												50, 50, 50, 50, 50,
												40, 50, 50, 30 ),
											( "17.09.2057", NAT_AMERICAN, RES_CALIFORNIA, "Divorced", EXP_FIREARMS, BOD_TALL, "---" ),
											( 50, 30, 7, 7, 3, 3 ),
											( 	10, 10, 10, 30, 50,
												10, 10, 10, 10, 10,
												5, 10, 10, 5 ),
										),
			#"MERCENARY_HENRY":			( 	( "male", globaltext.NAME_HENRY, 430.8, 292, 0 ),
			#								( "high", "white", "SET_NORMAL_CLOTHES_3", "naked", "naked", "jack", "jack", "" ),
			#								( 8, 10, 10, 7, 12, 13 ),
			#								( 	50, 50, 50, 50, 30,
			#									40, 50, 50, 70, 50,
			#									50, 50, 60, 50 ),
			#								( "12.04.2051", NAT_AMERICAN, RES_NEW_MEXICO, "Widowed", EXP_VEHICLES, BOD_HANDSOME, "---" ),
			#								( 3, 7, 7, 3, 30, 50 ),
			#								( 	10, 10, 10, 10, 5,
			#									5, 10, 10, 50, 10,
			#									10, 10, 30, 10 ),
			#							),
			
			# sally heißt jetzt lin
			"MERCENARY_SALLY": 			( 	( "female", globaltext.NAME_SALLY, 427, 276.7, 180 ),
											( "high", "white", "SET_NORMAL_CLOTHES_6", "naked", "naked", "kate", "kate", "" ),
											( 8, 13, 12, 7, 10, 10 ),
											( 	50, 50, 50, 50, 50,
												50, 40, 50, 50, 70,
												60, 30, 50, 50 ),
											( "29.01.2062", NAT_AMERICAN, RES_ARIZONA, "Single", EXP_CRIME, BOD_SHORT, "---" ),
											( 3, 50, 30, 3, 7, 7 ),
											( 	10, 10, 10, 10, 10,
												10, 5, 10, 10, 50,
												30, 5, 10, 10 ),
										),
			"MERCENARY_BUTCH": 			( 	( "male", globaltext.NAME_BUTCH, 431.5, 270.9, 180 ),
											( "high", "white", "SET_NORMAL_CLOTHES_1", "naked", "naked", "jordan", "jordan", "" ),
											( 13, 10, 10, 12, 7, 8 ),
											( 	50, 50, 70, 50, 50,
												50, 50, 50, 50, 30,
												40, 60, 50, 50 ),
											( "19.06.2047", NAT_AMERICAN, RES_OHIO, "Single", EXP_HANDCRAFT, BOD_STRONG, "---" ),
											( 50, 7, 7, 30, 3, 3 ),
											( 	10, 10, 50, 10, 10,
												10, 10, 10, 10, 5,
												5, 30, 10, 10 ),
										),
			#"MERCENARY_SAND":			( 	( "female", globaltext.NAME_SAND, 438, 266.7, 180 ),
			#								( "high", "white", "SET_NORMAL_CLOTHES_1", "naked", "naked", "sand", "sand", "" ),
			#								( 10, 12, 13, 8, 10, 7 ),
			#								( 	50, 50, 50, 50, 50,
			#									70, 40, 50, 60, 50,
			#									50, 50, 30, 50 ),
			#								( "01.04.2077", NAT_AMERICAN, RES_NEW_MEXICO, "Single", EXP_CRIME, BOD_SHORT, "---" ),
			#								( 7, 30, 50, 3, 7, 3 ),
			#								( 	10, 10, 10, 10, 10,
			#									50, 5, 10, 30, 10,
			#									10, 10, 5, 10 ),
			#							),
			#"MERCENARY_STORM":			( 	( "female", globaltext.NAME_STORM, 444.1, 269.1, 180 ),
			#								( "high", "white", "SET_NORMAL_CLOTHES_3", "naked", "naked", "storm", "storm", "" ),
			#								( 10, 8, 13, 7, 10, 12 ),
			#								( 	50, 50, 50, 50, 50,
			#									50, 50, 40, 50, 50,
			#									60, 70, 30, 50 ),
			#								( "01.04.2077", NAT_AMERICAN, RES_NEW_MEXICO, "Single", EXP_FIREARMS, BOD_SHORT, "---" ),
			#								( 7, 3, 50, 3, 7, 30 ),
			#								( 	10, 10, 10, 10, 10,
			#									10, 10, 5, 10, 10,
			#									30, 50, 5, 10 ),
			#							),
			#"MERCENARY_SEVENSOULS": 	( 	( "male", globaltext.NAME_SIEBENSEELE, 453.6, 272.2, 180 ),
			#								( "high", "white", "SET_NORMAL_CLOTHES_3", "naked", "naked", "sevensouls", "sevensouls", "" ),
			#								( 12, 7, 10, 10, 13, 8 ),
			#								( 	60, 50, 50, 50, 50,
			#									50, 50, 50, 50, 30,
			#									40, 50, 50, 70 ),
			#								( "30.11.2033", NAT_AMERICAN, RES_ARIZONA, "Widowed", EXP_MEDICINE, BOD_UGLY, "---" ),
			#								( 30, 3, 7, 7, 50, 3 ),
			#								( 	30, 10, 10, 10, 10,
			#									10, 10, 10, 10, 5,
			#									5, 10, 10, 50 ),
			#							),
			#"MERCENARY_MILTON":			( 	( "male", globaltext.NAME_MILTON, 461.8, 275.0, 270 ),
			#								( "high", "white", "SET_NORMAL_CLOTHES_3", "naked", "naked", "milton", "milton", "" ),
			#								( 7, 12, 10, 13, 10, 8 ),
			#								( 	50, 60, 50, 50, 50,
			#									50, 30, 70, 50, 50,
			#									50, 50, 40, 50 ),
			#								( "18.03.2048", NAT_AMERICAN, RES_NEW_MEXICO, "Widowed", EXP_SURVIVAL, BOD_WIRY, "---" ),
			#								( 3, 30, 7, 50, 7, 3 ),
			#								( 	10, 30, 10, 10, 10,
			#									10,  5, 50, 10, 10,
			#									10, 10,  5, 10 ),
			#							),
			#"MERCENARY_KENO":			( 	( "male", globaltext.NAME_KENO, 459.7, 279.2, 270 ),
			#								( "high", "white", "SET_NORMAL_CLOTHES_6", "naked", "naked", "brian", "", "" ),
			#								( 8, 12, 13, 7, 10, 10 ),
			#								( 	60, 50, 50, 70, 50,
			#									30, 50, 50, 50, 50,
			#									50, 50, 50, 40 ),
			#								( "24.04.2062", NAT_AMERICAN, RES_ARIZONA, "Single", EXP_FIREARMS, BOD_TALL, "---" ),
			#								( 3, 30, 50, 3, 7, 7 ),
			#								( 	30, 10, 10, 50, 10,
			#									 5, 10, 10, 10, 10,
			#									10, 10, 10,  5 ),
			#							),
			"MERCENARY_FRANCIS":		( 	( "male", globaltext.NAME_FRANCIS, 462.2, 282.2, 270 ),
											( "high", "white", "SET_NORMAL_CLOTHES_1", "naked", "naked", "ed", "ed", "" ),
											( 8, 12, 10, 7, 13, 10 ),
											( 	50, 50, 30, 50, 50,
												50, 50, 40, 50, 50,
												50, 70, 60, 50 ),
											( "17.07.2057", NAT_AMERICAN, RES_TEXAS, "Divorced", EXP_VEHICLES, BOD_UGLY, "---" ),
											( 3, 30, 7, 3, 50, 7 ),
											( 	10, 10,  5, 10, 10,
												10, 10,  5, 10, 10,
												10, 50, 30, 10 ),
										),
			#"MERCENARY_DEBORAH":		( 	( "female", globaltext.NAME_DEBORAH, 462.8, 288.8, 0 ),
			#								( "high", "black", "SET_NORMAL_CLOTHES_6", "naked", "naked", "pat", "", "" ),
			#								( 7, 8, 12, 10, 13, 10 ),
			#								( 	50, 60, 50, 50, 40,
			#									50, 50, 70, 50, 50,
			#									50, 30, 50, 50 ),
			#								( "09.09.2048", NAT_AMERICAN, RES_ARIZONA, "Single", EXP_SURVIVAL, BOD_SHORT, "" ),
			#								( 3, 3, 30, 7, 50, 7 ),
			#								( 	10, 30, 10, 10,  5,
			#									10, 10, 50, 10, 10,
			#									10,  5, 10, 10 ),
			#							),
			"MERCENARY_VICTOR":			( 	( "male", globaltext.NAME_VICTOR, 448.4, 292.8, 0 ),
											( "high", "white", "SET_NORMAL_CLOTHES_3", "naked", "naked", "phil", "", "" ),
											( 7, 10, 13, 12, 10, 8 ),
											( 	50, 50, 60, 50, 50,
												50, 70, 30, 50, 50,
												50, 50, 50, 40 ),
											( "24.10.2063", NAT_AMERICAN, RES_ARIZONA, "Single", EXP_CRIME, BOD_WIRY, "---" ),
											( 3, 7, 50, 30, 7, 3 ),
											( 	10, 10, 30, 10, 10,
												10, 50,  5, 10, 10,
												10, 10, 10,  5 ),
										),
		}

	# in this loop all mercs are generated and receive their attribute and skill values
	for LoopMerc in MercData.keys():

		#Creating the character
		system.create_character(
			id = LoopMerc,
			gender=MercData[ LoopMerc ][ 0 ][ 0 ],
			party="DORFBEWOHNER",
			x=MercData[ LoopMerc ][ 0 ][ 2 ],
			y=MercData[ LoopMerc ][ 0 ][ 3 ],
			name=MercData[ LoopMerc ][ 0 ][ 1 ],
			resourceui=MercData[ LoopMerc ][ 1 ][ 5 ] + ".png",
			direction= MercData[ LoopMerc ][ 0 ][4 ])

		# Calculating the base level and the exp
		
		StartExp = random.randint( 100, 499 )
		AddLevel = 0
		if( StartExp <= 99 ):
			AddLevel = 1
		elif( StartExp <= 199 ):
			AddLevel = 2
		elif( StartExp <= 499 ):
			AddLevel = 3
		elif(StartExp <= 1199 ):
			AddLevel = 4
		else:
			AddLevel = 4
		
		object.set_attribute( object = LoopMerc, attribute = "experience", value = StartExp )
		
		#Setting the visual attributes
		#clothes, clothes_gloves and clothes_boots will be removed soon
		object.set_attribute( LoopMerc, "gender", 			MercData[ LoopMerc ][ 0 ][ 0 ])
		object.set_attribute( LoopMerc, "skin", 				MercData[ LoopMerc ][ 1 ][ 1 ])
		object.set_attribute( LoopMerc, "face", 				MercData[ LoopMerc ][ 1 ][ 5 ])

		if( MercData[ LoopMerc ][ 1 ][ 6 ] != "" ):
			object.set_attribute( LoopMerc, "hair", 			MercData[ LoopMerc ][ 1 ][ 6 ])

		object.set_attribute( LoopMerc, "model",				MercData[ LoopMerc ][ 1 ][ 0 ])


		object.set_attribute( LoopMerc, "clothes_gloves",	MercData[ LoopMerc ][ 1 ][ 3 ])
		object.set_attribute( LoopMerc, "clothes_boots",     MercData[ LoopMerc ][ 1 ][ 4 ])

		object.set_attribute( LoopMerc, "clothes",			"naked")
		#object.set_attribute( LoopMerc, "clothes",			MercData[ LoopMerc ][ 1 ][ 2 )
		
		object.set_attribute(LoopMerc, 'voice_id', LoopMerc)

		character.update_appearance( LoopMerc )

		#Starting the attribute calculation

		#Moving all attrib values into a temporary list
		#the algorithm gives 65 attrib points to each character, considering that the emphasises of each character are defined in the
		#3rd list of MercData
		#In MercData the attribs are defined with a average value. To make it possible to calculate with it, here all values are
		#reduced by 7
		MercAttrib = [ 	MercData[ LoopMerc ][ 2 ][ 0 ] - 7,
						MercData[ LoopMerc ][ 2 ][ 1 ] - 7,
						MercData[ LoopMerc ][ 2 ][ 2 ] - 7,
						MercData[ LoopMerc ][ 2 ][ 3 ] - 7,
						MercData[ LoopMerc ][ 2 ][ 4 ] - 7,
						MercData[ LoopMerc ][ 2 ][ 5 ] - 7 ]

		for LoopMercAttrib in range( len( MercAttrib ) ):
			MercAttrib[ LoopMercAttrib ] = 10
			
		#The maximum number of attrib points is defined
		AttribPoints = 10 + (AddLevel - 1)
		
		while AttribPoints > 0:
			AttribPos = random.randint( 0, 5 )
			if MercAttrib[ AttribPos ] < 13:
				MercAttrib[ AttribPos ] += 1
				AttribPoints -= 1
		
		#Each attrib has a variability of 3 points, so the attributes are increased here by a value between 0 and 2.
		#for LoopMercAttrib in range( len( MercAttrib ) ):
		#	MercAttrib[ LoopMercAttrib ] += random.randint( 0, 2 )
		#	AttribPoints -= MercAttrib[ LoopMercAttrib ]
			
		##here we calculate how many points we can give to any attribute. There may is a rest we distribute with the next mechanism
		#AttribPointsEach = int( AttribPoints / 6 )

		#for LoopMercAttrib in range( len( MercAttrib ) ):
		#	MercAttrib[ LoopMercAttrib ] += AttribPointsEach
		#	AttribPoints -= AttribPointsEach

		#here the rest of the points is given to the attributes
		#LoopMercAttrib = 0

		#while( AttribPoints > 0 ):
		#	MercAttrib[ LoopMercAttrib ] += 1
		#	AttribPoints -= 1
		#	LoopMercAttrib += 1
		#	if( LoopMercAttrib > 5 ):
		#		LoopMercAttrib = 0

		#this loop checks if all the attributes values are valid. Otherwise an eror occurs
		#for LoopMercAttrib in range( len( MercAttrib ) ):
		#	if( ( MercAttrib[ LoopMercAttrib ] < 0 ) or ( MercAttrib[ LoopMercAttrib ] > 20 ) ):
		#		raise 	ValueError,	"Attrib " \
		#							+ str( LoopMercAttrib ) \
		#							+ " has a value of " \
		#							+ str( MercAttrib[ LoopMercAttrib ] )

		#here are the attribute values are set to the character
		object.set_attribute( object = LoopMerc, attribute = "strength",  value = MercAttrib[ 0 ]  )
		object.set_attribute( object = LoopMerc, attribute = "agility",  value = MercAttrib[ 1 ]  )
		object.set_attribute( object = LoopMerc, attribute = "dexterity",  value = MercAttrib[ 2 ]  )
		object.set_attribute( object = LoopMerc, attribute = "constitution",  value = MercAttrib[ 3 ]  )
		object.set_attribute( object = LoopMerc, attribute = "intelligence",  value = MercAttrib[ 4 ]  )
		object.set_attribute( object = LoopMerc, attribute = "charisma",  value = MercAttrib[ 5 ]  )
		
		
		MAX_HP	= 0
		HP		= 0
		if AddLevel == 0:
			MAX_HP	= 2
			HP		= 2
		elif AddLevel == 1:
			MAX_HP	= 10
			HP		= 10
		elif AddLevel == 2:
			MAX_HP	= 16
			HP		= 16
		elif AddLevel == 3:
			MAX_HP	= 22
			HP		= 22
		elif AddLevel > 3:
			MAX_HP	= 28
			HP		= 28
		
		# setting maxhitpoints and hitpoints is not final!
		object.set_attribute( object = LoopMerc, attribute = "maxhitpoints",  value = MAX_HP  )
		object.set_attribute( object = LoopMerc, attribute = "hitpoints",  value = HP  )
		
		#Starting the skill calculation

		#Moving all ability values into a temporary list
		#the algorithm gives 65 ability points to each character, considering that the emphasises of each character are defined in the
		#4th list of MercData
		#In MercData the abilities are defined with a average value. To make it possible to calculate with it, here all values are
		#reduced by 40
 		MercAbility = [ 	MercData[ LoopMerc ][ 3 ][ 0 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 1 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 2 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 3 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 4 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 5 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 6 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 7 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 8 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 9 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 10 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 11 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 12 ] - 40,
							MercData[ LoopMerc ][ 3 ][ 13 ] - 40 ]

		#The maximum number of ability points is defined
		AbilityPoints = 700
		

		#Each ability has a variability of 5 points, so the abilities are increased here by a value between 0 and 4.
		for LoopMercAbility in range( len( MercAbility ) ):
			TVal 		  = random.randint( 0, 4 )
			MercAbility[ LoopMercAbility ] += TVal
			AbilityPoints -= MercAbility[ LoopMercAbility ]


		#here we calculate how many points we can give to each ability. There may is a rest we distribute with the next mechanism
		AbilityPointsEach = int( AbilityPoints / 14 )

		
		for LoopMercAbility in range( len( MercAbility ) ):
			MercAbility[ LoopMercAbility ] += AbilityPointsEach
			AbilityPoints -= AbilityPointsEach
		#here the rest of the points is given to the abilities
		LoopMercAbility = 0

		while( AbilityPoints > 0 ):
			MercAbility[ LoopMercAbility ] += 1
			AbilityPoints -= 1
			LoopMercAbility += 1
			if( LoopMercAbility > 5 ):
				LoopMercAbility = 0
		

		#this loop checks if all the abilities values are valid. Otherwise an eror occurs
		for LoopMercAbility in range( len( MercAbility ) ):
			if( ( MercAbility[ LoopMercAbility ] < 0 ) or ( MercAbility[ LoopMercAbility ] > 99 ) ):
				raise 	ValueError,	"Ability " \
									+ str( LoopMercAbility ) \
									+ " has a value of " \
									+ str( MercAbility[ LoopMercAbility ] )

		#here are the ability values are set to the character
		object.set_attribute( object = LoopMerc, attribute = "close_combat",  value = MercAbility[ 0 ]  )
		object.set_attribute( object = LoopMerc, attribute = "light_weapons",  value = MercAbility[ 1 ]  )
		object.set_attribute( object = LoopMerc, attribute = "heavy_weapons",  value = MercAbility[ 2 ]  )
		object.set_attribute( object = LoopMerc, attribute = "sniper_weapons",  value = MercAbility[ 3 ]  )
		object.set_attribute( object = LoopMerc, attribute = "special_weapons",  value = MercAbility[ 4 ]  )
		object.set_attribute( object = LoopMerc, attribute = "throw_weapons",  value = MercAbility[ 5 ]  )
		object.set_attribute( object = LoopMerc, attribute = "explosives",  value = MercAbility[ 6 ]  )
		object.set_attribute( object = LoopMerc, attribute = "survival",  value = MercAbility[ 7 ]  )
		object.set_attribute( object = LoopMerc, attribute = "sneak",  value = MercAbility[ 8 ]  )
		object.set_attribute( object = LoopMerc, attribute = "pick_pocket",  value = MercAbility[ 9 ]  )
		object.set_attribute( object = LoopMerc, attribute = "lock_pick",  value = MercAbility[ 10 ]  )
		object.set_attribute( object = LoopMerc, attribute = "technic",  value = MercAbility[ 11 ]  )
		object.set_attribute( object = LoopMerc, attribute = "driving",  value = MercAbility[ 12 ]  )
		object.set_attribute( object = LoopMerc, attribute = "medicine",  value = MercAbility[ 13 ]  )
		object.set_attribute( object = LoopMerc, attribute = "passport",  value = True )

		# here we set some more basic attributes of the characters
		object.set_attribute( object = LoopMerc, attribute = "date_of_birth",  value = MercData[ LoopMerc ][ 4 ][ 0 ]  )
		object.set_attribute( object = LoopMerc, attribute = "nationality",  value = MercData[ LoopMerc ][ 4 ][ 1 ]  )
		object.set_attribute( object = LoopMerc, attribute = "last_residence",  value = MercData[ LoopMerc ][ 4 ][ 2 ]  )
		#ronny: family status is obsolete
		#object.set_attribute( object = LoopMerc, attribute = "family_status",  value = MercData[ LoopMerc ][ 4 ][ 3 ]  )
		object.set_attribute( object = LoopMerc, attribute = "experience_of_life",  value = MercData[ LoopMerc ][ 4 ][ 4 ]  )
		object.set_attribute( object = LoopMerc, attribute = "body_feature",  value = MercData[ LoopMerc ][ 4 ][ 5 ]  )

		if( random.randint( 0, 99 ) < 50 ):
			object.set_attribute( object = LoopMerc, attribute = "body_eat_permission",  value = True  )
		else:
			object.set_attribute( object = LoopMerc, attribute = "body_eat_permission",  value = False  )


		#here we add the special bonuses for life experience...
		if( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_FIREARMS ):
			Val1 = object.get_attribute( object = LoopMerc, attribute = "light_weapons" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "light_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "heavy_weapons" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "heavy_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "sniper_weapons" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "sniper_weapons", value = Val1 )
			
			#ronny: special weapons skill is obsolete, rework!
			#Val1 = object.get_attribute( object = LoopMerc, attribute = "special_weapons" ) + 5
			#object.set_attribute( object = LoopMerc, attribute = "special_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "throw_weapons" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "throw_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "pick_pocket" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "pick_pocket", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "lock_pick" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "lock_pick", value = Val1 )

		elif( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_MARTIAL_ARTS ):

			Val1 = object.get_attribute( object = LoopMerc, attribute = "close_combat" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "close_combat", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "heavy_weapons" ) - 10
			object.set_attribute( object = LoopMerc, attribute = "heavy_weapons", value = Val1 )

			#ronny: special weapons skill is obsolete, rework!
			#Val1 = object.get_attribute( object = LoopMerc, attribute = "special_weapons" ) - 5
			#object.set_attribute( object = LoopMerc, attribute = "special_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "throw_weapons" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "throw_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "sneak" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "sneak", value = Val1 )

		elif( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_VEHICLES ):

			Val1 = object.get_attribute( object = LoopMerc, attribute = "survival" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "survival", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "sneak" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "sneak", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "technic" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "technic", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "driving" ) + 15
			object.set_attribute( object = LoopMerc, attribute = "driving", value = Val1 )


		elif( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_SURVIVAL ):

			Val1 = object.get_attribute( object = LoopMerc, attribute = "throw_weapons" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "throw_weapons", value = Val1 )
                                                                                  
			Val1 = object.get_attribute( object = LoopMerc, attribute = "survival" ) + 15
			object.set_attribute( object = LoopMerc, attribute = "survival", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "sneak" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "sneak", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "lock_pick" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "lock_pick", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "technic" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "technic", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "driving" ) - 10
			object.set_attribute( object = LoopMerc, attribute = "driving", value = Val1 )

		elif( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_CRIME ):

			Val1 = object.get_attribute( object = LoopMerc, attribute = "close_combat" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "close_combat", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "light_weapons" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "light_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "heavy_weapons" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "heavy_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "sniper_weapons" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "sniper_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "special_weapons" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "special_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "explosives" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "explosives", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "survival" ) - 10
			object.set_attribute( object = LoopMerc, attribute = "survival", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "pick_pocket" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "pick_pocket", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "lock_pick" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "lock_pick", value = Val1 )

		elif( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_HANDCRAFT ):

			Val1 = object.get_attribute( object = LoopMerc, attribute = "survival" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "survival", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "lock_pick" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "lock_pick", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "technic" ) + 15
			object.set_attribute( object = LoopMerc, attribute = "technic", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "medicine" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "medicine", value = Val1 )
                                                                                 
		elif( MercData[ LoopMerc ][ 4 ][ 4 ] == EXP_MEDICINE ):

			Val1 = object.get_attribute( object = LoopMerc, attribute = "close_combat" ) - 10
			object.set_attribute( object = LoopMerc, attribute = "close_combat", value = Val1 )
	
			Val1 = object.get_attribute( object = LoopMerc, attribute = "throw_weapons" ) - 5
			object.set_attribute( object = LoopMerc, attribute = "throw_weapons", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "technic" ) + 5
			object.set_attribute( object = LoopMerc, attribute = "technic", value = Val1 )

			Val1 = object.get_attribute( object = LoopMerc, attribute = "medicine" ) + 10
			object.set_attribute( object = LoopMerc, attribute = "medicine", value = Val1 )

		elif( MercData[ LoopMerc ][ 4 ][ 4 ] != "---" ):
			raise 	ValueError,	"life experience of " \
								+ LoopMerc \
								+ " is invalid."

		# ... and body features
		if( ( MercData[ LoopMerc ][ 4 ][ 5 ] == BOD_TALL ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == BOD_TALL ) ):
			# stärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) + 3
			object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
			# zweitstärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "agility" ) + 2
			object.set_attribute( object = LoopMerc, attribute = "agility", value = Val1 )
			# schwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "intelligence" ) - 3
			object.set_attribute( object = LoopMerc, attribute = "intelligence", value = Val1 )
			# zweitschwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "charisma" ) - 2
			object.set_attribute( object = LoopMerc, attribute = "charisma", value = Val1 )
			
			attribute_check(LoopMerc, "strength", "agility", "intelligence", "charisma")

		elif( ( MercData[ LoopMerc ][ 4 ][ 5 ] == BOD_SHORT ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == BOD_SHORT ) ):
			# stärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "agility" ) + 3
			object.set_attribute( object = LoopMerc, attribute = "agility", value = Val1 )
			# schwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "dexterity" ) + 2
			object.set_attribute( object = LoopMerc, attribute = "dexterity", value = Val1 )
			# schwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "constitution" ) - 3
			object.set_attribute( object = LoopMerc, attribute = "constitution", value = Val1 )
			# zweitschwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) - 2
			object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
			
			attribute_check(LoopMerc, "agility", "dexterity", "constitution", "strength")

		elif( ( MercData[ LoopMerc ][ 4 ][ 5 ] == BOD_STRONG ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == BOD_STRONG ) ):
			if LoopMerc == 'MERCENARY_VASQUEZ':
				# stärkstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "intelligence" ) + 3
				object.set_attribute( object = LoopMerc, attribute = "intelligence", value = Val1 )
				# schwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "dexterity" ) + 2
				object.set_attribute( object = LoopMerc, attribute = "dexterity", value = Val1 )
				# schwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "charisma" ) - 3
				object.set_attribute( object = LoopMerc, attribute = "charisma", value = Val1 )
				# zweitschwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "agility" ) - 2
				object.set_attribute( object = LoopMerc, attribute = "agility", value = Val1 )
				
				attribute_check(LoopMerc, "intelligence", "dexterity", "charisma", "agility")
				
			if LoopMerc == 'MERCENARY_BUTCH':
				# stärkstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) + 3
				object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
				# schwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "constitution" ) + 2
				object.set_attribute( object = LoopMerc, attribute = "constitution", value = Val1 )
				# schwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "intelligence" ) - 3
				object.set_attribute( object = LoopMerc, attribute = "intelligence", value = Val1 )
				# zweitschwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "charisma" ) - 2
				object.set_attribute( object = LoopMerc, attribute = "charisma", value = Val1 )
				
				attribute_check(LoopMerc, "strength", "constitution", "intelligence", "charisma")
				
		elif( ( MercData[ LoopMerc ][ 4 ][ 5 ] == BOD_WIRY ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == BOD_WIRY ) ):
			if LoopMerc == 'MERCENARY_AGNES':
				# stärkstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "constitution" ) + 3
				object.set_attribute( object = LoopMerc, attribute = "constitution", value = Val1 )
				# zweitstärkstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "dexterity" ) + 2
				object.set_attribute( object = LoopMerc, attribute = "dexterity", value = Val1 )
				# schwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) - 3
				object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
				# zweitschwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "agility" ) - 2
				object.set_attribute( object = LoopMerc, attribute = "agility", value = Val1 )
				
				attribute_check(LoopMerc, "constitution", "dexterity", "strength", "agility")
				
			if LoopMerc == 'MERCENARY_VICTOR':
				# stärkstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "dexterity" ) + 3
				object.set_attribute( object = LoopMerc, attribute = "dexterity", value = Val1 )
				# zweitstärkstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "constitution" ) + 2
				object.set_attribute( object = LoopMerc, attribute = "constitution", value = Val1 )
				# schwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) - 3
				object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
				# zweitschwächstes attribut
				Val1 = object.get_attribute( object = LoopMerc, attribute = "charisma" ) - 2
				object.set_attribute( object = LoopMerc, attribute = "charisma", value = Val1 )
				
				attribute_check(LoopMerc, "dexterity", "constitution", "strength", "charisma")
				                                   
		elif( ( MercData[ LoopMerc ][ 4 ][ 5 ] == BOD_HANDSOME ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == BOD_HANDSOME ) ):
			# stärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "charisma" ) + 3
			object.set_attribute( object = LoopMerc, attribute = "charisma", value = Val1 )
			# zweitstärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "intelligence" ) + 2
			object.set_attribute( object = LoopMerc, attribute = "intelligence", value = Val1 )
			# schwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) - 3
			object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
			# zweitschwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "constitution" ) - 2
			object.set_attribute( object = LoopMerc, attribute = "constitution", value = Val1 )
			
			attribute_check(LoopMerc, "charisma", "intelligence", "strength", "constitution")
			
		elif( ( MercData[ LoopMerc ][ 4 ][ 5 ] == BOD_UGLY ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == BOD_UGLY ) ):
			# stärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "intelligence" ) + 3
			object.set_attribute( object = LoopMerc, attribute = "intelligence", value = Val1 )
			# zweitstärkstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "dexterity" ) + 2
			object.set_attribute( object = LoopMerc, attribute = "dexterity", value = Val1 )
			# schwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) - 3
			object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
			# zweitschwächstes attribut
			Val1 = object.get_attribute( object = LoopMerc, attribute = "agility" ) - 2
			object.set_attribute( object = LoopMerc, attribute = "agility", value = Val1 )
			
			attribute_check(LoopMerc, "intelligence", "dexterity", "strength", "agility")
			
		elif( ( MercData[ LoopMerc ][ 4 ][ 5 ] == "---" ) or ( MercData[ LoopMerc ][ 4 ][ 6 ] == "---" ) ):
			print '---'
			pass

		else:
			raise 	ValueError,	"body features of " \
								+ LoopMerc \
								+ " are invalid."

		print 'MERCENARY : ',LoopMerc
		for att in ['strength', 'constitution', 'agility', 'intelligence', 'dexterity', 'charisma']:
			print ' "%s" : ' %att,  object.get_attribute( object = LoopMerc, attribute = att )
		
		# Setup the Chance table for the attrib calculation. There's a certain chance for each
		# attrib, different from npc to npc, which is defined in MercData[ LoopMerc ][ 5 ][ 0-4 ]
		ChanceTable[ 0 ] = MercData[ LoopMerc ][ 5 ][ 0 ]
		ChanceTable[ 1 ] = MercData[ LoopMerc ][ 5 ][ 1 ] + ChanceTable[ 0 ]
		ChanceTable[ 2 ] = MercData[ LoopMerc ][ 5 ][ 2 ] + ChanceTable[ 1 ]
		ChanceTable[ 3 ] = MercData[ LoopMerc ][ 5 ][ 3 ] + ChanceTable[ 2 ]
		ChanceTable[ 4 ] = MercData[ LoopMerc ][ 5 ][ 4 ] + ChanceTable[ 3 ]
		ChanceTable[ 5 ] = MercData[ LoopMerc ][ 5 ][ 5 ] + ChanceTable[ 4 ]
		
		# Here the attribs are alotted
		#for LoopAddLevel in range( AddLevel ):
		#	AttribPointsRest = 1
		#	while( AttribPointsRest > 0 ):
#
#				Chance = random.randint( 0, 99 )
#
#				for LoopChance in range( 6 ):
#					if( Chance < ChanceTable[ LoopChance ] ):
#						# Chance == 0: strength
#						if( LoopChance == 0 ):
#							Val1 = object.get_attribute( object = LoopMerc, attribute = "strength" ) + 1
#							if( Val1 <= 20 ):
#								object.set_attribute( object = LoopMerc, attribute = "strength", value = Val1 )
#								AttribPointsRest -= 1
#						# Chance == 1: agility
#						elif( LoopChance == 1 ):
#							Val1 = object.get_attribute( object = LoopMerc, attribute = "agility" ) + 1
#							if( Val1 <= 20 ):
#								object.set_attribute( object = LoopMerc, attribute = "agility", value = Val1 )
#								AttribPointsRest -= 1
#						# Chance == 2: dexterity
#						elif( LoopChance == 2 ):
#							Val1 = object.get_attribute( object = LoopMerc, attribute = "dexterity" ) + 1
#							if( Val1 <= 20 ):
#								object.set_attribute( object = LoopMerc, attribute = "dexterity", value = Val1 )
#								AttribPointsRest -= 1
#						# Chance == 3: constituion
#						elif( LoopChance == 3 ):
#							Val1 = object.get_attribute( object = LoopMerc, attribute = "constitution" ) + 1
#							if( Val1 <= 20 ):
#								object.set_attribute( object = LoopMerc, attribute = "constitution", value = Val1 )
#								AttribPointsRest -= 1
#						# Chance == 4: intelligence
#						elif( LoopChance == 4 ):
#							Val1 = object.get_attribute( object = LoopMerc, attribute = "intelligence" ) + 1
#							if( Val1 <= 20 ):
#								object.set_attribute( object = LoopMerc, attribute = "intelligence", value = Val1 )
#								AttribPointsRest -= 1
#						# Chance == 5: charisma
#						elif( LoopChance == 5 ):
#							Val1 = object.get_attribute( object = LoopMerc, attribute = "charisma" ) + 1
#							if( Val1 <= 20 ):
#								object.set_attribute( object = LoopMerc, attribute = "charisma", value = Val1 )
#								AttribPointsRest -= 1
#						break



		# Setup the Chance table for the skill calculation. There's a certain chance for each
		# skill, different from npc to npc, which is defined in MercData[ LoopMerc ][ 6 ][ 0-13 ]
		ChanceTable[ 0 ] = MercData[ LoopMerc ][ 6 ][ 0 ]
		ChanceTable[ 1 ] = MercData[ LoopMerc ][ 6 ][ 1 ] + ChanceTable[ 0 ]
		ChanceTable[ 2 ] = MercData[ LoopMerc ][ 6 ][ 2 ] + ChanceTable[ 1 ]
		ChanceTable[ 3 ] = MercData[ LoopMerc ][ 6 ][ 3 ] + ChanceTable[ 2 ]
		ChanceTable[ 4 ] = MercData[ LoopMerc ][ 6 ][ 4 ] + ChanceTable[ 3 ]
		ChanceTable[ 5 ] = MercData[ LoopMerc ][ 6 ][ 5 ] + ChanceTable[ 4 ]
		ChanceTable[ 6 ] = MercData[ LoopMerc ][ 6 ][ 6 ] + ChanceTable[ 5 ]
		ChanceTable[ 7 ] = MercData[ LoopMerc ][ 6 ][ 7 ] + ChanceTable[ 6 ]
		ChanceTable[ 8 ] = MercData[ LoopMerc ][ 6 ][ 8 ] + ChanceTable[ 7 ]
		ChanceTable[ 9 ] = MercData[ LoopMerc ][ 6 ][ 9 ] + ChanceTable[ 8 ]
		ChanceTable[10 ] = MercData[ LoopMerc ][ 6 ][10 ] + ChanceTable[ 9 ]
		ChanceTable[11 ] = MercData[ LoopMerc ][ 6 ][11 ] + ChanceTable[ 10 ]
		ChanceTable[12 ] = MercData[ LoopMerc ][ 6 ][12 ] + ChanceTable[ 11 ]
		ChanceTable[13 ] = MercData[ LoopMerc ][ 6 ][13 ] + ChanceTable[ 12 ]

		# Here the skills are alotted
		#for LoopAddLevel in range( AddLevel-1 ):

		SkillPointsRest = 10 * (AddLevel-1) + 50
		while( SkillPointsRest > 0 ):
			Chance = random.randint( 0, 189 )

			for LoopChance in range( 14 ):
				if( Chance < ChanceTable[ LoopChance ] ):
					# Chance == 0: close_combat
					if( LoopChance == 0 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "close_combat" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "close_combat", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 1: light_weapons
					elif( LoopChance == 1 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "light_weapons" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "light_weapons", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 2: heavy_weapons
					elif( LoopChance == 2 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "heavy_weapons" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "heavy_weapons", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 3: sniper_weapons
					elif( LoopChance == 3 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "sniper_weapons" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "sniper_weapons", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 4: special_weapons
					elif( LoopChance == 4 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "special_weapons" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "special_weapons", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 5: throw_weapons
					elif( LoopChance == 5 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "throw_weapons" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "throw_weapons", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 6: explosives
					elif( LoopChance == 6 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "explosives" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "explosives", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 7: survival
					elif( LoopChance == 7 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "survival" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "survival", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 8: sneak
					elif( LoopChance == 8 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "sneak" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "sneak", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 9: pick_pocket
					elif( LoopChance == 9 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "pick_pocket" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "pick_pocket", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 10: lock_pick
					elif( LoopChance == 10 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "lock_pick" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "lock_pick", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 11: technic
					elif( LoopChance == 11 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "technic" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "technic", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 12: driving
					elif( LoopChance == 12 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "driving" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "driving", value = Val1 )
							SkillPointsRest -= 1
					# Chance == 13: medicine
					elif( LoopChance == 13 ):
						Val1 = object.get_attribute( object = LoopMerc, attribute = "medicine" ) + 1
						if( Val1 <= 80 ):
							object.set_attribute( object = LoopMerc, attribute = "medicine", value = Val1 )
							SkillPointsRest -= 1
					break
		
		#Setting the base inventory
		#all mercenaries have some items in their inventory when they are generated
		#this is calculated by a certain random factor

		#Weapon into the inventory?
		TVal = random.randint( 1, 4 )
		if   TVal==1:object.create_item_in_inventory(LoopMerc, ["SET_SPECIAL_38"] + ["SET_AMMOPACK_38"]*3)
		elif TVal==2:object.create_item_in_inventory(LoopMerc, ["SET_WALTER_PPK"] + ["SET_AMMOPACK_7_65_MM"]*3)
		elif TVal==3:object.create_item_in_inventory(LoopMerc, ["SET_SIG_SAUER"] + ["SET_AMMOPACK_357"]*3)
		else:		object.create_item_in_inventory(LoopMerc, ["SET_COLT_ANACONDA"] + ["SET_AMMOPACK_44"]*3)

		# item into the inventory ?
		TVal = random.randint( 1, 4 )
		if   TVal==1:object.create_item_in_inventory(LoopMerc, "SET_WOOD_GARLIC")
		elif TVal==2:object.create_item_in_inventory(LoopMerc, "SET_MEAT_RAW_TINY")
		elif TVal==3:object.create_item_in_inventory(LoopMerc, "SET_MEAT_COOKED")
		else:		object.create_item_in_inventory(LoopMerc, "SET_MEDIPACK_SMALL")     

		# vtements
		TVal = random.randint( 1, 4 )
		if   TVal==1:objets= "SET_NORMAL_CLOTHES_1"
		elif TVal==2:objets= "SET_NORMAL_CLOTHES_3"
		elif TVal==3:objets= "SET_NORMAL_CLOTHES_6"
		else:		objets= "SET_LEATHER_CLOTHES"
		object.create_item_in_inventory(LoopMerc, objets)
		character.equip( LoopMerc, objets )
		
		TVal = random.randint( 1, 2 )
		if   TVal==1:objets= "SET_LOW_SHOES"
		else:		objets= "SET_LEATHER_BOOTS"
		object.create_item_in_inventory(LoopMerc, objets)
		character.equip( LoopMerc, objets )
		
		TVal = random.randint( 1, 4 )
		if   TVal==1:objets= "SET_KNIFE"
		elif TVal==2:objets= "SET_BROKEN_OFF_BOTTLE"
		elif TVal==3:objets= "SET_AMMOPACK_9_MM"
		else:		objets= "SET_AMMOPACK_44"
		object.create_item_in_inventory(LoopMerc, objets)
		objets = None

		init_mercenary_talents(LoopMerc)

def attribute_check(LoopMerc, st_att_1, st_att_2, schw_att_1, schw_att_2):
	# check für stärkstes attribut
	if object.get_attribute( object = LoopMerc, attribute = st_att_1 ) <= object.get_attribute( object = LoopMerc, attribute = st_att_2 ):
		TempVal = object.get_attribute( object = LoopMerc, attribute = st_att_1 )
		object.set_attribute( object = LoopMerc, attribute = st_att_1, value = object.get_attribute( object = LoopMerc, attribute = st_att_2 ))
		object.set_attribute( object = LoopMerc, attribute = st_att_2, value = TempVal)
	# check für schwächstes attribut
	if object.get_attribute( object = LoopMerc, attribute = schw_att_1 ) >= object.get_attribute( object = LoopMerc, attribute = schw_att_2 ):
		TempVal = object.get_attribute( object = LoopMerc, attribute = schw_att_1 )
		object.set_attribute( object = LoopMerc, attribute = schw_att_1, value = object.get_attribute( object = LoopMerc, attribute = schw_att_2 ))
		object.set_attribute( object = LoopMerc, attribute = schw_att_2, value = TempVal)

# initialisiert die talente der mercenarys
def init_mercenary_talents(mercenary):
	global CHANCE_TABLE
	
	for skill in CHANCE_TABLE["skills"]:
		if object.has_attribute(mercenary, skill):
			value = object.get_attribute(mercenary, skill)
			if value >= 95:
				update_mercenary_talent(mercenary, skill, 3)
			elif value >= 85:
				update_mercenary_talent(mercenary, skill, 2)
			elif value >= 75:
				update_mercenary_talent(mercenary, skill, 1)
			
# setzt die skilltalente für einen merc
def update_mercenary_talent(mercenary, skill, num=0):
	if not get_talent_count(mercenary, skill):
		if skill in all_talents.keys():
			talents = all_talents[skill]
			if len(talents) >= 3:
				if num == 1:
					value = [talents[0]]
				elif num == 2:
					value = [talents[0],talents[1]]
				elif num == 3:
					value = [talents[0],talents[1],talents[2]]
				if len(value):
					attribute = skill+"_talents"
					object.set_attribute(mercenary, attribute, value)

def initScheduledNPCs():
	## Katharina, die Köchin
	system.create_character(
		id="KATHARINE",
		gender="female",
		party="DORFBEWOHNER",
		x=360,
		y=310,
		name=globaltext.NAME_KATHARINE,
		direction=90,
		resourceui="")

 	object.set_attribute("KATHARINE", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("KATHARINE", "level", 1 )
	object.set_attributes("KATHARINE",
		model="low",
		gender="female",
		skin="white",
		clothes="ll_001",
		face="asbirg")
	character.update_appearance("KATHARINE")


	## Wilma, die Wäscherin
	system.create_character(
		id="WILMA",
		gender="female",
		party="DORFBEWOHNER",
		x=360,
		y=313,
		name=globaltext.NAME_WILMA,
		direction=90,
		resourceui="")

 	object.set_attribute("WILMA", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("WILMA", "level", 1 )
 	object.set_attributes("WILMA",
		model="low",
		gender="female",
		skin="white",
		#Democode
		clothes="ll_001",
		#clothes="ll_002",
		face="blitgard")
	character.update_appearance("WILMA")


	## Herb, der Hausmeister
	system.create_character(
		id="HERB",
		gender="male",
		party="DORFBEWOHNER",
		x=360,
		y=316,
		name=globaltext.NAME_HERB,
		direction=90,
		resourceui="")

 	object.set_attribute("HERB", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("HERB", "level", 1 )
 	object.set_attributes("HERB",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_002",
		face="adalbert")
	character.update_appearance("HERB")


	## Aaron, der Arbeiter
	system.create_character(
		id="AARON",
		gender="male",
		party="DORFBEWOHNER",
		x=360,
		y=319,
		name=globaltext.NAME_AARON,
		direction=90,
		resourceui="")

 	object.set_attribute("AARON", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("AARON", "level", 1 )
 	object.set_attributes("AARON",
		model="low",
		gender="male",
		skin="white",
		#Democode
		clothes="ll_003",
		#clothes="ll_004",
		face="albin")
	character.update_appearance("AARON")


	## Jon, der Arbeiter
	system.create_character(
		id="JON",
		gender="male",
		party="DORFBEWOHNER",
		x=360,
		y=322,
		name=globaltext.NAME_JON,
		direction=90,
		resourceui="")

 	object.set_attribute("JON", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("JON", "level", 1 )
 	object.set_attributes("JON",
		model="low",
		gender="male",
		skin="white",
		clothes="sl_001",
		face="ascan")
	character.update_appearance("JON")


	## Orson, der Organisator
	system.create_character(
		id="ORSON",
		gender="male",
		party="DORFBEWOHNER",
		x=360,
		y=325,
		name=globaltext.NAME_ORSON,
		direction=90,
		resourceui="")

 	object.set_attribute("ORSON", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("ORSON", "level", 1 )
 	object.set_attributes("ORSON",
		model="low",
		gender="male",
		skin="white",
		clothes="sl_002",
		face="bernulf")
	character.update_appearance("ORSON")

	## Val, der Veteran
	system.create_character(
		id="VAL",
		gender="male",
		party="DORFBEWOHNER",
		x=360,
		y=328,
		name=globaltext.NAME_VAL,
		direction=90,
		resourceui="")

 	object.set_attribute("VAL", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("VAL", "level", 1 )
 	object.set_attributes("VAL",
		model="low",
		gender="male",
		skin="black",
		clothes="sl_003",
		face="otilo")
	character.update_appearance("VAL")


	## Sierra, die alte Jungfer
	system.create_character(
		id="SIERRA",
		gender="female",
		party="DORFBEWOHNER",
		x=360,
		y=331,
		name=globaltext.NAME_SIERRA,
		direction=90,
		resourceui="")

 	object.set_attribute("SIERRA", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("SIERRA", "level", 1 )
 	object.set_attributes("SIERRA",
		model="low",
		gender="female",
		skin="white",
		clothes="sl_004",
		face="kunigunde")
	character.update_appearance("SIERRA")

	## Faith, die Waffenputzerin
	system.create_character(
		id="FAITH",
		gender="female",
		party="DORFBEWOHNER",
		x=360,
		y=334,
		name=globaltext.NAME_FAITH,
		direction=90,
		resourceui="")

 	object.set_attribute("FAITH", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("FAITH", "level", 1 )
 	object.set_attributes("FAITH",
		model="low",
		gender="female",
		skin="black",
		clothes="ss_003",
		face="irmela")
	character.update_appearance("FAITH")

	## Mason, der Henker
	system.create_character(
		id="MASON",
		gender="male",
		party="DORFBEWOHNER",
		x=360,
		y=337,
		name=globaltext.NAME_MASON,
		direction=90,
		resourceui="")

 	object.set_attribute("MASON", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("MASON", "level", 1 )
 	object.set_attributes("MASON",
		model="low",
		gender="male",
		skin="white",
		clothes="ll_004",
		face="folkward")
	character.update_appearance("MASON")


	# Josefine, die Joggerin
	system.create_character(
		id="JOSEFINE",
		gender="female",
		party="DORFBEWOHNER",
		x=360,
		y=340,
		name=globaltext.NAME_JOSEFINE,
		direction=90,
		resourceui="")

 	object.set_attribute("JOSEFINE", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("JOSEFINE", "level", 1 )
 	object.set_attributes("JOSEFINE",
		model="low",
		gender="female",
		skin="black",
		clothes="sl_003",
		face="edeltraud")
	character.update_appearance("JOSEFINE")


	# Kiki, das Kind
	system.create_character(
		id="KIKI",
		gender="female",
		party="DORFBEWOHNER",
		x=360,
		y=343,
		name=globaltext.NAME_KIKI,
		direction=90,
		resourceui="" )

 	object.set_attribute("KIKI", "faction", "VILLAGE_PEOPLE")
	object.set_attribute("KIKI", "level", 1 )
 	object.set_attributes("KIKI",
		model="child",
		gender="female",
		skin="white",
		clothes="ll_001",
		face="001")
	character.update_appearance("KIKI")

def setCharacterWait( id ):
	animWarten(id)

def setJogging( id ):
	TVal = random.randint( 0, 3 )
	if( TVal <= 0 ):
		object.move_to( object = id, x = 332.66, y = 317.61, grid="landscape", speed = MT_FAST )
	elif( TVal <= 1 ):
		object.move_to( object = id, x = 499.37, y = 258.73, grid="landscape", speed = MT_FAST )
	elif( TVal <= 2 ):
		object.move_to( object = id, x = 520.93, y = 451.31, grid="landscape", speed = MT_FAST )
	elif( TVal <= 3 ):
		object.move_to( object = id, x = 325.02, y = 488.88, grid="landscape", speed = MT_FAST )

def setGuarding( id ):
	TVal = random.randint( 0, 3 )
	if( TVal <= 0 ):
		object.move_to( object = id, x = 332.66, y = 317.61, grid="landscape", speed = MT_SLOW )
	elif( TVal <= 1 ):
		object.move_to( object = id, x = 499.37, y = 258.73, grid="landscape", speed = MT_SLOW )
	elif( TVal <= 2 ):
		object.move_to( object = id, x = 520.93, y = 451.31, grid="landscape", speed = MT_SLOW )
	elif( TVal <= 3 ):
		object.move_to( object = id, x = 325.02, y = 488.88, grid="landscape", speed = MT_SLOW )

## Initialisiert die Tiere der Zone
def initAnimals():
	system.create_animal(id="WOLF_S_LEAD",	type=ANIMAL_WOLF, party="ANIMALS", x=431.0, y=571.0, direction=globals.DIR_NORTH)
	system.create_animal(id="WOLF_S_1",	type=ANIMAL_WOLF, party="ANIMALS", x=431.0, y=569.0, direction=globals.DIR_NORTH_WEST)
	system.create_animal(id="WOLF_S_2",	type=ANIMAL_WOLF, party="ANIMALS", x=433.0, y=571.0, direction=globals.DIR_NORTH)
	system.create_animal(id="WOLF_S_3",	type=ANIMAL_WOLF, party="ANIMALS", x=433.0, y=569.0, direction=globals.DIR_NORTH_EAST)
	system.create_animal(id="WOLF_S_4",	type=ANIMAL_WOLF, party="ANIMALS", x=435.0, y=573.0, direction=globals.DIR_NORTH)
	system.create_animal(id="WOLF_S_5",	type=ANIMAL_WOLF, party="ANIMALS", x=435.0, y=567.0, direction=globals.DIR_SOUTH)
	
	## Spawnanimals sind feindlich und erstmal inactiv
	for animal in data().SpawnAnimals:
		object.set_attribute(animal,"foes", ["UISPIELER"])
		object.set_active_state(animal,INACTIVE)

	system.create_animal(id="ANTILOPE_1",	type=ANIMAL_ANTELOPE, party="ANIMALS", x=560.0, y=520.0, direction=globals.DIR_WEST)
	object.set_attribute('ANTILOPE_1',"foes", ["UISPIELER"])
	system.create_animal(id="ANTILOPE_2",	type=ANIMAL_ANTELOPE, party="ANIMALS", x=562.0, y=518.0, direction=globals.DIR_SOUTH_EAST)
	object.set_attribute('ANTILOPE_2',"foes", ["UISPIELER"])
	system.create_animal(id="ANTILOPE_3",	type=ANIMAL_ANTELOPE, party="ANIMALS", x=565.0, y=525.0, direction=globals.DIR_NORTH_WEST)
	object.set_attribute('ANTILOPE_3',"foes", ["UISPIELER"])

	system.create_animal(id="WOLF_GRAB",	type=ANIMAL_WOLF, party="ANIMALS", x=571.0, y=280.0, direction=globals.DIR_SOUTH)
	object.set_attribute('WOLF_GRAB',"foes", ["UISPIELER"])
	system.create_animal(id="WOLF_1",	type=ANIMAL_WOLF, party="ANIMALS", x=569.0, y=252.0, direction=globals.DIR_SOUTH_EAST)
	object.set_attribute('WOLF_1',"foes", ["UISPIELER"])
	system.create_animal(id="WOLF_2",	type=ANIMAL_WOLF, party="ANIMALS", x=571.0, y=253.0, direction=globals.DIR_SOUTH)
	object.set_attribute('WOLF_2',"foes", ["UISPIELER"])

## Spawns Animals
def spawnAnimals(state):
	if (state == ACTIVE):
		if not data().SpawnAnimalsSpawned:
			for id in data().SpawnAnimals:
				object.set_active_state(id,state)
			data().SpawnAnimalsSpawned = True
	else:
		if data().SpawnAnimalsSpawned:
			for id in data().SpawnAnimals:
				if not object.is_destroyed(id):
					object.set_active_state(id,state)
		data().SpawnAnimalsSpawned = False