# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
from dynamic_camera import *
import dynamic_camera
import schedules
import enemy_script
from daily_routine import *
import sounds

#*** aktuelle revison: Revision 1, 9.08.2004  *****************************

# ansprechen von chars - callback
def on_approach(target, operator):
	if dialog.is_dialog_active():
		return
	
	if schedules.Dialog(target, operator):
		return
	
	if target == 'ARTHUR_LAWRENCE':
		if data().Artur_Befreit and not data().GameOver:
			initDlg_009_Fragen_an_Arthur_Lawrence()
		else:
			initDlg_Z6_147_SpielerHatNichtsZuBereden()

	elif target == "ANIE":
		initDlg_Z9_073_SpielerWillAnieNichtAnsprechen()
	
	elif target == "ABEL":
		initDlg_Z9_072_AbelIstBeschaeftigt()
	
	else:
		initDlg_Z6_147_SpielerHatNichtsZuBereden()

	
################################################################################

#### Wenn Spieler das erste mal die Biosphäre betritt BEGINN ####
#### aufgerufen von on_map_loaded()

def initCutscene_001_Der_Spieler_betritt_die_Biosphaere():
	system.start_cutscene()
	system.set_camera_view(CAM_VIEW_ERSTES_BETRETEN)
	onCutscene_001_Der_Spieler_betritt_die_Biosphaere_1()

def onCutscene_001_Der_Spieler_betritt_die_Biosphaere_1():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text = 'D_001_T_001', speaker = 'ALTER_EGO')
	dialog.add_text(text = 'D_001_T_002', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback = EndCutscene_001_Der_Spieler_betritt_die_Biosphaere)
	dialog.start()
	
def EndCutscene_001_Der_Spieler_betritt_die_Biosphaere():
	end_cutscene()
	
#### Wenn Spieler das erste mal die Biosphäre betritt END ####	

################################################################################
################################################################################

#### Die GNO-Soldaten wollen kapitulieren BEGINN ####
#### wird aufgerufen wenn der Spieler die Region Nest 3 betritt ####
#### on_enter_region() 'REGION_NEST_3' ####

def initCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren(CamView_1, CamView_2, CamView_3, pos, GNO_char, time):
	enemy_script.delay(time, Lambda('system.set_camera_view(%s)'%CamView_2))
	enemy_script.delay(time-2, Lambda('onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_1(%s,%s,%s,%s,"%s")'%(GNO_char, pos, CamView_2, CamView_3, time)))
	system.set_camera_view(CamView_1)
	object.move_to('ALTER_EGO', pos[0][0], pos[0][1], callback = ['ONEND', Lambda('onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_2(%s,"%s",%s,%s, "%s")'%(GNO_char, GNO_char[0], CamView_2, CamView_3, time))])
	
def onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_1(GNO_char, pos, CamView_2, CamView_3, time):
	dialog.init_dialog(type=DIALOGSMALL)
	system.set_camera_view(CamView_2)
	data().GNO_Verbuendete_Cutscene = True
	object.cancel_commandos(GNO_char[0])
	object.move_to(GNO_char[0], pos[1][0], pos[1][1], speed = MT_FAST, callback = Lambda('onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_2(%s,"%s",%s,%s, "%s")'%(GNO_char, GNO_char[0], CamView_2, CamView_3, time)))
	object.cancel_commandos(GNO_char[1])
	object.move_to(GNO_char[1], pos[2][0], pos[2][1], speed = MT_FAST, callback = Lambda('onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_2(%s,"%s",%s,%s,"%s")'%(GNO_char, GNO_char[1], CamView_2, CamView_3, time)))
	dialog.add_text(text = 'D_006_T_002', speaker = GNO_char[0], follower = 'ENDDIALOG', callback = Lambda('onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_2(%s,"ALTER_EGO",%s, %s, "%s")'%(GNO_char, CamView_2, CamView_3, time)))
	dialog.start()
	
def onCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren_2(GNO_char, char, CamView_1, CamView_3, time):
	data().GNO_Counter += 1
	if char == 'ALTER_EGO':
		if CamView_3 != None:
			system.set_camera_view(CamView_3)
	if char != 'ALTER_EGO':
		object.turn_to_object(char, 'ALTER_EGO')
	if data().GNO_Counter == 4:
		data().GNO_Counter = 0
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.add_text(text = 'D_006_T_003', speaker = 'ALTER_EGO', callback = Lambda('onCutscene_006_Helper_1("%s")'%GNO_char[1]))
		dialog.add_text(text = 'D_006_T_004', speaker = GNO_char[1], callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "%s", mode = "close")'%GNO_char[1]))
		dialog.add_text(text = 'D_006_T_005', speaker = 'ALTER_EGO', callback = Lambda('dynamic_camera.set_conversation("%s","ALTER_EGO", mode = "close")'%GNO_char[0]))
		dialog.add_text(text = 'D_006_T_006', speaker = GNO_char[0], follower = 'ENDDIALOG', callback = Lambda('CutsceneEND_006_Die_GNO_Soldaten_wollen_kapitulieren("%s")'%GNO_char[0]))
		dialog.start()
	
def CutsceneEND_006_Die_GNO_Soldaten_wollen_kapitulieren(GNO_char):
	# dynamic_camera.set_conversation(GNO_char,"ALTER_EGO", mode = "close")
	dynamic_camera.end_cutscene(chars = ['GNO-Soldat A', 'GNO-Soldat B', 'ALTER_EGO'])
	# system.set_camera_view(CAM_VIEW_VERBUENDETE_WEST_1)
	initDlg_007_Spieler_befindet_ueber_das_Schicksal()
	data().GNO_Verbuendete_Cutscene = False
	enemy_script.delay(2, Lambda('CutsceneEND_006_FOES()'))
	
def CutsceneEND_006_FOES():
	for party in PARTY_ID + ['GNO_KAEMPFER_WELLE']:
		for id in system.get_objects_for_party(party):
			object.set_attribute(id, 'foes', ['UISPIELER'])
	
#### Die GNO-Soldaten wollen kapitulieren END ####

#*******************************************************************************

#### Der Spieler befindet über das Schicksal der Nest 3-Soldaten BEGINN ####
#### aufgerufen von ENDCutsceneEND_006_Die_GNO_Soldaten_wollen_kapitulieren() ####

def initDlg_007_Spieler_befindet_ueber_das_Schicksal():
	
	dialog.init_dialog(type=DIALOGLARGE)
	if object.get_attribute('ALTER_EGO', 'speech') >= 85: 
		dialog.add_choice(text='D_007_C_001_1', follower='D_007_T_003')
	
	else:
		dialog.add_choice(text='D_007_C_001_1', follower='D_007_T_004')
	
	dialog.add_choice(text='D_007_C_001_2', follower='D_007_T_001')
	dialog.add_choice(text='D_007_C_001_3', follower = 'ENDDIALOG', callback = onDlg_007_GNO_Werden_Feindlich) # todo GNO-Soldaten werden feindlich.
	dialog.add_text(text = 'D_007_T_001', speaker = 'GNO-Soldat A', follower = 'ENDDIALOG', callback = onDlg_007_GNO_Hauen_Ab) # todo GNO-Soldaten begeben sich auf dem schnellsten Wege zum Biosphären-Eingang und verschwinden dort
	dialog.add_text(text = 'D_007_T_003', speaker = 'GNO-Soldat A', follower = 'ENDDIALOG', callback = onDlg_007_GNO_Schlissen_Sich_An) # todo GNO-Soldaten schließen sich dem Spieler an und kämpfen bis zum Tode mit ihm
	dialog.add_text(text = 'D_007_T_004', speaker = 'GNO-Soldat A', follower = 'D_007_C_001_1') 
	
	dialog.start(False)

#*******************************************************************************
#### Helper Funktionen ####
def onCutscene_006_Helper_1(GNO_char):
	object.turn_to_object('ALTER_EGO', GNO_char)
	dynamic_camera.set_conversation( GNO_char, 'ALTER_EGO',mode = 'close')



#### Der Spieler befindet über das Schicksal der Nest 3-Soldaten END ####

################################################################################
################################################################################

#### Funktionen zum Dialog 007 BIGINN ####

def onDlg_007_GNO_Werden_Feindlich():
	for id in system.get_objects_for_party('GNO_VERBUENDETE'):
		enemy_script.is_equip_weapon(id)
		object.set_attribute(id, "foes", ["UISPIELER"])

def onDlg_007_GNO_Hauen_Ab():
	for id in system.get_objects_for_party('GNO_VERBUENDETE'):
		object.move_to(id, 445.19, 10.00, callback = ['ONEND', Lambda('object.set_active_state("%s", False)'%id)])

def onDlg_007_GNO_Schlissen_Sich_An():
	character.add_experience_party(1000)
	data().KAMPF_MIT_VERBUENDETE = True
	data().Verbuendete_Folgen = True
	for id in system.get_objects_for_party('GNO_VERBUENDETE'):
		enemy_script.is_equip_weapon(id)
		object.set_attribute(id, "foes", PARTY_ID)
	for id in PARTY_ID:
		for id_ in system.get_objects_for_party(id):
			object.set_attribute(id_, "foes", ["UISPIELER", 'GNO_VERBUENDETE'])
		
#### Funktionen zum Dialog 007 END ####

################################################################################
################################################################################

#### NEST 4 Arthur Lawrence berichtet über die Biosphäre BEGINN ####
#### aufruf in on_approach() ####

def initCutscene_008_Arthur_berichtet_ueber_Biosphaere(CamView):
	system.start_cutscene()
	system.set_camera_view(CamView)
	object.move_to('ALTER_EGO', 513.88, 419.48, callback = [['ONEND', Lambda('object.turn_to_object("ALTER_EGO", "ARTHUR_LAWRENCE")')], ['ONEND', onCutscene_008_Arthur_berichtet_ueber_Biosphaere_1]])
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text = 'D_008_T_001', speaker = 'ARTHUR_LAWRENCE', follower = 'ENDDIALOG', callback = [Lambda('system.set_camera_view(%s)'%CAM_VIEW_ARTHUR_END), Lambda('onCutscene_008_Arthur_berichtet_ueber_Biosphaere_1("id")')])
	dialog.start()
	
def onCutscene_008_Arthur_berichtet_ueber_Biosphaere_1(id):
	data().GNO_Counter += 1
	if data().GNO_Counter == 2:
		data().GNO_Counter = 0
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.add_text(text = 'D_008_T_002', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback = onCutscene_008_Arthur_berichtet_ueber_Biosphaere_2)
		dialog.start()
	
def onCutscene_008_Arthur_berichtet_ueber_Biosphaere_2():
	object.cancel_commandos('ARTHUR_LAWRENCE')
	object.move_to('ARTHUR_LAWRENCE', 512.55, 419.52, speed = MT_SLOW, callback = [['ONEND', Lambda('object.turn_to_object("ARTHUR_LAWRENCE", "ALTER_EGO")')], 
								     ['ONEND', Lambda('object.turn_to_object("ALTER_EGO", "ARTHUR_LAWRENCE")')], 
								     ['ONEND', Lambda('dynamic_camera.set_conversation("ARTHUR_LAWRENCE", "ALTER_EGO", mode = "close")')]])
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text = 'D_008_T_003', speaker = 'ARTHUR_LAWRENCE', follower = 'ENDDIALOG', callback = ENDCutscene_008_Arthur_berichtet_ueber_Biosphaere)
	dialog.start()

def ENDCutscene_008_Arthur_berichtet_ueber_Biosphaere():
	end_cutscene(chars=['ARTHUR_LAWRENCE', 'ALTER_EGO'])
	data().Artur_Befreit = True
	character.add_experience_party(1500)
	
#### Arthur Lawrence berichtet über die Biosphäre END ####

################################################################################
################################################################################

#### Fragen an Arthur Lawrence BEGINN ####
#### aufruf in on_approach() ####

def initDlg_009_Fragen_an_Arthur_Lawrence():
	
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_choice(text='D_009_C_001_1', follower='D_009_T_001')
	
	if data().Dialog_009_AddChoice[1]:
		dialog.add_choice(text='D_009_C_001_2', follower='D_009_T_003') # defaultmäßig inaktiv
	
	if data().Dialog_009_AddChoice[2]:
		dialog.add_choice(text='D_009_C_001_3', follower='D_009_T_004') # defaultmäßig inaktiv
	
	dialog.add_choice(text='D_009_C_001_4', follower='D_009_T_005')
	dialog.add_choice(text='D_009_C_001_5', follower='ENDDIALOG')
	
	dialog.add_text(text = 'D_009_T_001', speaker = 'ARTHUR_LAWRENCE')
	dialog.add_text(text = 'D_009_T_002', speaker = 'ARTHUR_LAWRENCE', follower='D_009_C_001_1', callback = Lambda('data().Dialog_009_AddChoice[2] = True')) # C_001_2 aktiv
	dialog.add_text(text = 'D_009_T_003', speaker = 'ARTHUR_LAWRENCE', follower='D_009_C_001_1', callback = Lambda('data().Dialog_009_AddChoice[3] = True')) # C_001_3 aktiv
	dialog.add_text(text = 'D_009_T_004', speaker = 'ARTHUR_LAWRENCE', follower='D_009_C_001_1')
	dialog.add_text(text = 'D_009_T_005', speaker = 'ARTHUR_LAWRENCE')
	dialog.add_text(text = 'D_009_T_006', speaker = 'ARTHUR_LAWRENCE', follower='D_009_C_001_1')
	dialog.start(False)
	
#### Fragen an Arthur Lawrence END ####

################################################################################
################################################################################

#### NEST 5 Hayes versucht, den Spieler zu überzeugen BEGINN ####
#### aufruf in on_approach() ####

def initCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen(id):
	data().GameOver = True
	system.set_camera_view(CAM_VIEW_HAYES_END)
	object.turn_to_object('ALTER_EGO', 'ZONE_10_BUILDING_8013', callback = ['ONEND', initCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_1])
	
def initCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_1(id):
	onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_2()
	
def onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_2():
	
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text = 'D_002_T_001', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback = Dlg002_Hayes_Helper)
	dialog.start()
	
def onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_3(id):
	dialog.init_dialog(type = DIALOGSMALL)
	object.move_to('PRESIDENT_HAYES', 286.56, 540.08, speed = MT_SLOW, callback = ['ONEND', onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_4])
	dialog.add_text(text = 'D_002_T_002', speaker = 'PRESIDENT_HAYES', follower = 'ENDDIALOG' , callback = onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_3_1)
	dialog.start()
	
def onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_3_1():
	system.set_camera_view(CAM_VIEW_HAYES_END_2)
	onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_4(None)

def onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_4(id):
	data().GNO_Counter += 1
	if data().GNO_Counter == 2:
		data().GNO_Counter = 0
		dialog.init_dialog(type = DIALOGSMALL)
		dialog.add_text(text = 'D_002_T_003', speaker = 'ALTER_EGO', callback = Lambda('dynamic_camera.set_conversation("PRESIDENT_HAYES", "ALTER_EGO", mode = "close")'))
		dialog.add_text(text = 'D_002_T_004', speaker = 'PRESIDENT_HAYES', callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "PRESIDENT_HAYES", mode = "close")'))
		dialog.add_text(text = 'D_002_T_005', speaker = 'ALTER_EGO', callback = Lambda('dynamic_camera.set_conversation("PRESIDENT_HAYES", "ALTER_EGO", mode = "close")'))
		dialog.add_text(text = 'D_002_T_006', speaker = 'PRESIDENT_HAYES', follower = 'ENDDIALOG', callback = ENDCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen)
		dialog.start()
	
def ENDCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen():
	end_cutscene(chars=['PRESIDENT_HAYES', 'ALTER_EGO'])
	Spieler_Befindet_Ueber_Schicksal_Von_Hayes()

#*******************************************************************************

def Dlg002_Hayes_Helper():
	object.cancel_commandos('PRESIDENT_HAYES')
	object.play_animation("ZONE_10_BUILDING_8013", "ANIM_GENERIC_DOOR1_OPEN")
	object.step_to('PRESIDENT_HAYES', 285.85, 545.24, speed = MT_SLOW)
	object.step_to('PRESIDENT_HAYES', 287.33, 545.20, speed = MT_SLOW, callback = ['ONEND', Lambda('object.play_animation("ZONE_10_BUILDING_8013", "ANIM_GENERIC_DOOR1_CLOSE")')])
	object.step_to('PRESIDENT_HAYES', 290.16, 545.15, speed = MT_SLOW, callback = ['ONEND', onCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen_3])
	
#*******************************************************************************
################################################################################
################################################################################

### Dialog_003 Der Spieler befindet über das Schicksal von Hayes BEGINN ###

def Spieler_Befindet_Ueber_Schicksal_Von_Hayes():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_choice(text='D_003_C_001_1', follower='D_003_T_001')
	dialog.add_choice(text='D_003_C_001_2', follower='D_003_T_002')
	dialog.add_text(text = 'D_003_T_001', speaker = 'PRESIDENT_HAYES', follower = 'ENDDIALOG', callback = Hayes_erschiessen)
	dialog.add_text(text = 'D_003_T_002', speaker = 'PRESIDENT_HAYES')
	dialog.add_text(text = 'D_003_T_003', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback = Hayes_flieht)
	dialog.start()

#*******************************************************************************
def Hayes_flieht():
	data().Hayes_Cutscene_Gelaufen = True
	system.start_cutscene()
	character.add_experience_party(2500)
	initCutscene_004_Die_neue_Hoffnung()

def Hayes_erschiessen():
	object.set_immortal_state('PRESIDENT_HAYES', False)
	data().Hayes_Cutscene_Gelaufen = True
	character.add_experience_party(2500)
	object.set_attribute('PRESIDENT_HAYES', "foes", ["UISPIELER"])
	

################################################################################
################################################################################

#### Nachdem Hayes entweder tot oder geflohen ist BEGINN ####
#### aufgerufen von Hayes_flieht(), oder on_object_killed() ####

def initCutscene_004_Die_neue_Hoffnung():
	# system.start_cutscene()
	prohibit_activity('ARTHUR_LAWRENCE', True)
	if not object.is_destroyed('PRESIDENT_HAYES'):
		system.set_camera_view(CAM_VIEW_ENDCUTSCENE_2)
		object.move_to('PRESIDENT_HAYES', 284.75, 498.68, callback = ['ONEND', Lambda('object.set_active_state("PRESIDENT_HAYES", False)')])
		enemy_script.delay(4, Lambda('initCutscene_004_Die_neue_Hoffnung_0_0()'))
	else:
		initCutscene_004_Die_neue_Hoffnung_0_0()
		
def initCutscene_004_Die_neue_Hoffnung_0_0():
	object.set_active_state('ABEL', True)
	object.set_active_state('ANIE', True)
	object.move_to('ALTER_EGO', 300.74, 521.67, speed = MT_NORMAL, callback = ['ONEND', initCutscene_004_Die_neue_Hoffnung_0])
	object.set_position('ANIE', 402.00, 353.66)
	object.cancel_commandos('ANIE')
	object.move_to('ANIE', 432.13, 388.69, speed = MT_NORMAL, callback = ['ONEND', onCutscene_004_Die_neue_Hoffnung_2])
	object.set_position('ABEL', 403.00, 351.97)
	object.cancel_commandos('ABEL')
	object.move_to('ABEL', 430.78, 385.86, speed = MT_NORMAL, callback = ['ONEND', onCutscene_004_Die_neue_Hoffnung_2])
	if not object.is_destroyed('PRESIDENT_HAYES'):
		enemy_script.delay(4, Lambda('system.fade(FADE_OUT)') )
	else:
		enemy_script.delay(2, Lambda('system.fade(FADE_OUT)') )
	
def initCutscene_004_Die_neue_Hoffnung_0(id):
	object.set_active_state('BANKS', True)
	object.set_active_state('ROWLAND', True)
	object.cancel_commandos('ALTER_EGO')
	object.set_position('ALTER_EGO', 		405.59, 391.44)
	object.move_to('ALTER_EGO', 			430.21, 387.40, speed = MT_NORMAL, callback = ['ONEND', onCutscene_004_Die_neue_Hoffnung_2])
	object.set_position('ARTHUR_LAWRENCE', 	447.91, 390.30)
	object.cancel_commandos('ARTHUR_LAWRENCE')
	object.move_to('ARTHUR_LAWRENCE', 		433.81, 388.01, speed = MT_NORMAL, callback = ['ONEND', onCutscene_004_Die_neue_Hoffnung_2])
	object.set_position('ROWLAND', 			447.80, 391.38)
	object.cancel_commandos('ROWLAND')
	object.move_to('ROWLAND', 				433.70, 386.22, speed = MT_NORMAL, callback = ['ONEND', onCutscene_004_Die_neue_Hoffnung_2])
	object.set_position('BANKS', 			447.34, 392.11)
	object.cancel_commandos('BANKS')
	object.move_to('BANKS', 				432.72, 385.16, speed = MT_NORMAL, callback = ['ONEND', onCutscene_004_Die_neue_Hoffnung_2])
	initCutscene_004_Die_neue_Hoffnung_1()
	
def initCutscene_004_Die_neue_Hoffnung_1():
	system.fade(FADE_IN)
	system.set_camera_view(CAM_VIEW_ENDCUTSCENE_1)
	
def onCutscene_004_Die_neue_Hoffnung_2(id):
	object.turn_to_position(id, 431.79, 386.82)
	data().End_Counter += 1
	if data().End_Counter == 6:
		data().End_Counter = 0
		onCutscene_004_Die_neue_Hoffnung_5()
	

def onCutscene_004_Die_neue_Hoffnung_5():
	system.set_camera_view(CAM_VIEW_ENDCUTSCENE_3)
	dialog.init_dialog(type=DIALOGSMALL)
	
	dialog.add_text(text = 'D_004_T_001', speaker = 'ALTER_EGO', callback = Dlg_004_Set_Cam_View_1)
	dialog.add_text(text = 'D_004_T_002', speaker = 'ABEL', callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "ABEL", mode = "close")'))###
	dialog.add_text(text = 'D_004_T_003', speaker = 'ALTER_EGO', callback = Hoffnung_Helper_1)
	
	if object.get_attribute('ALTER_EGO', 'gender') == 'male': 
		dialog.add_text(text = 'D_004_T_004', speaker = 'ANIE', callback = Dlg_004_Set_Cam_View_1)
	else:
		dialog.add_text(text = 'D_004_T_004F', speaker = 'ANIE', callback = Dlg_004_Set_Cam_View_1)
	dialog.add_text(text = 'D_004_T_005', speaker = 'ABEL', callback = Hoffnung_Helper_2)###
	dialog.add_text(text = 'D_004_T_006', speaker = 'BANKS', callback = Lambda('dynamic_camera.set_conversation("ANIE", "ALTER_EGO", mode = "close")'))###
	dialog.add_text(text = 'D_004_T_007', speaker = 'ANIE', callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "ANIE", mode = "close")'))
	if object.get_attribute('ALTER_EGO', 'gender') == 'male':
		dialog.add_text(text = 'D_004_T_008', speaker = 'ALTER_EGO', callback = Hoffnung_Helper_3)
	else:
		dialog.add_text(text = 'D_004_T_008F', speaker = 'ALTER_EGO', callback = Hoffnung_Helper_3)
	if object.get_attribute('ALTER_EGO', 'gender') == 'male':
		dialog.add_text(text = 'D_004_T_009', speaker = 'ANIE', callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "ANIE", mode = "close")'))
	else:
		dialog.add_text(text = 'D_004_T_009F', speaker = 'ANIE', callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "ANIE", mode = "close")'))
	dialog.add_text(text = 'D_004_T_010', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback = ENDCutscene_004_Die_neue_Hoffnung)
	
	dialog.start(False)


def ENDCutscene_004_Die_neue_Hoffnung():
	character.add_experience_party(5000)
	system.set_qb_entry_state(data().QB_001, COMPLETE)
	end_cutscene()
	EXTRO()
	
#*******************************************************************************

def Dlg_004_Set_Cam_View_1():
	dynamic_camera.set_conversation("ABEL", "ALTER_EGO", new_camera = False)
	system.set_camera_view([429.5123291015625, 388.5875244140625, 6.6614418029785156, 0.45709431171417236, -0.86304092407226563, -0.21500062942504883])

def Dlg_004_Set_Cam_View_2():
	dynamic_camera.set_conversation("ABEL", "ALTER_EGO", new_camera = False)
	
def Hoffnung_Helper_1():
	object.cancel_commandos('ANIE')
	object.turn_to_object('ANIE', 'ALTER_EGO')
	system.set_camera_view(CAM_VIEW_ENDCUTSCENE_5)
	object.cancel_commandos('ALTER_EGO')
	object.turn_to_object('ALTER_EGO', 'ANIE')
	
def Hoffnung_Helper_2():
	enemy_script.delay(4, Lambda('system.set_camera_view([430.13201904296875, 388.55865478515625, 6.2739095687866211, 0.82729935646057129, -0.52538549900054932, -0.19886136054992676])'))
	dynamic_camera.set_conversation("BANKS", "ALTER_EGO", new_camera = False)
	object.cancel_commandos('BANKS')
	object.turn_to_object('BANKS', 'ALTER_EGO')
	system.set_camera_view(CAM_VIEW_ENDCUTSCENE_6)
	object.cancel_commandos('ALTER_EGO')
	object.turn_to_object('ALTER_EGO', 'BANKS')

def Hoffnung_Helper_3():
	object.cancel_commandos('ANIE')
	object.turn_to_object('ANIE', 'ALTER_EGO')
	system.set_camera_view(CAM_VIEW_ENDCUTSCENE_7)
	object.cancel_commandos('ALTER_EGO')
	object.turn_to_object('ALTER_EGO', 'ANIE')
	
#### Nachdem Hayes entweder tot oder geflohen ist END ####

################################################################################
################################################################################

#### EXTRO BEGINN ####

def EXTRO():
	system.start_video_stream("BINK1","videos\\extro_" + system.get_language() + ".bik")

def Time_Traveller():
	if data('zone_2.zone_2').Time_Traveler_Gestartet:
		initCutscen_005_Zeitreisender_schliesst_sich_Spieler_an()
	else:
		allow_activity('ARTHUR_LAWRENCE')
		data().GameOver_1 = True

#### EXTRO END ####

################################################################################
################################################################################

#### Der Zeitreisende schließt sich dem Spieler an BEGINN ####
#### gestartet Nach dem Extro() wird (sofern in Z2 der Zeitreisende mit seiner Zeitmaschine abgehauen ist) ####

def initCutscen_005_Zeitreisender_schliesst_sich_Spieler_an():
	initCutscene_TimeTraveller()

def initCutscene_TimeTraveller():
	enemy_script.delay(1.5, Lambda('initCutscene_TimeTraveller_0()'))
	sounds.play_3d_sound_object(sfx_id = "timemachine_prebang", object = 'CAR_TIMETRAVELLER_RETURNS', loop = False, identifier = 'timemachine_prebang_sound')
	
def initCutscene_TimeTraveller_0():
	sounds.play_3d_sound_object(sfx_id = "timemachine_returns", object = 'CAR_TIMETRAVELLER_RETURNS', loop = False, identifier = 'timemachine_sound')
	system.start_cutscene()
	system.set_camera_view([477.74771118164062, 411.98358154296875, 9.4882698059082031, -0.96828055381774902, -0.12730982899665833, -0.21499991416931152])
	Fx()
	object.set_active_state('CAR_TIMETRAVELLER_RETURNS', True)
	object.play_animation('CAR_TIMETRAVELLER_RETURNS', 'TIMEMACHINE_RETURNS_BACK')
	object.play_animation('CAR_TIMETRAVELLER_RETURNS', 'TIMEMACHINE_RETURNS', callback = onCutscene_TimeTraveller_1)
	enemy_script.delay(1, Lambda('system.set_camera_view([442.20504760742187, 407.87957763671875, 7.338414192199707, 0.97363269329071045, 0.07625243067741394, -0.21500004827976227])'))
	object.move_to('ALTER_EGO', 455.21, 407.87, callback = ['ONEND', onCutscene_TimeTraveller_4])
	
def onCutscene_TimeTraveller_1(id):
	enemy_script.delay(1, Lambda('onCutscene_TimeTraveller_2()'))
	enemy_script.delay(1, Lambda('system.set_camera_view([467.00729370117187, 410.29644775390625, 5.2958316802978516, -0.95940977334976196, -0.18250493705272675, -0.21499957144260406])'))

def onCutscene_TimeTraveller_2():	
	object.set_active_state('CAR_TIMETRAVELLER', True)
	object.set_active_state('CAR_TIMETRAVELLER_RETURNS', False)
	object.cancel_commandos("TIMETRAVELLER")
	object.set_active_state("TIMETRAVELLER", True)
	character.change_body_mode('TIMETRAVELLER', 'STAND')
	onCutscene_TimeTraveller_3("TIMETRAVELLER")
	
def onCutscene_TimeTraveller_3(id):
	object.move_to("TIMETRAVELLER", 457.62, 409.83)
	onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_1()

def onCutscene_TimeTraveller_4(id):
	onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_2()
	object.turn_to_object('TIMETRAVELLER', 'ALTER_EGO')
	
def Fx():
	x = x2 = x3 = x4 = 427.42 
	y = y2 = y3 = y4 = 424.08
	x_ = x2_ = x3_ = x4_ = 427.42 
	y_ = y2_ = y3_ = y4_ = 424.08
	for i in range(80):
		time_start = 100 + (i *30)
		time_end = time_start + 1300
		# fx_fire = [globals.FX_FIRE_SHAPE,0, 1000,0,0.0,0.0,0]
		system.start_effect(x, y, 0, x, y, 1, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x_-1.5, y_-1.5, 0, x_-1.5, y_-1.5, 0, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x2, y2, 0, x2, y2, 1, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x2_-1.5, y2_-1.5, 0, x2_-1.5, y2_-1.5, 0, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x3, y3, 0, x3, y3, 1, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x3_-1.5, y3_-1.5, 0, x3_-1.5, y3_-1.5, 0, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x4, y4, 0, x4, y4, 1, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		system.start_effect(x4_-1.5, y4_-1.5, 0, x4_-1.5, y4_-1.5, 0, [FX_FIRE_SHAPE,time_start, time_end,0.15,0,0])
		x += 0.0102 * i
		y += (0.1*i) * -(0.0008*i)
		x_ += 0.0105 * i
		y_ += (0.115*i) * -(0.0008*i)
		x2 += 0.0102 * (i+0.25)
		y2 += (0.1*(i+0.25)) * -(0.0008*(i+0.25))
		x2_ += 0.0105 * (i+0.25)
		y2_ += (0.115*(i+0.25)) * -(0.0008*(i+0.25))
		x3 += 0.0102 * (i+0.5)
		y3 += (0.1*(i+0.5)) * -(0.0008*(i+0.5))
		x3_ += 0.0105 * (i+0.5)
		y3_ += (0.115*(i+0.5)) * -(0.0008*(i+0.5))
		x4 += 0.0105 * (i+0.75)
		y4 += (0.1*(i+0.75)) * -(0.0008*(i+0.75))
		x4_ += 0.0105 * (i+0.75)
		y4_ += (0.115*(i+0.75)) * -(0.0008*(i+0.75))
 
def Rauch():
	time_start 	= 0
	time_end	= 1000
	system.start_effect_object('CAR_TIMETRAVELLER_RETURNS', 'wheel_fr', [FX_DUST, 0,10000,10.0,0.0,10.0,13343851,1.0])

def Fx_Explosion():
	fx_explosion = [globals.FX_EXPLOSION_COMBO_1,0,300,4.0,45.0,2000]
	system.start_effect(336.84+2.8,399.68-1.4,1,0,0,2,parameter=fx_explosion)
	system.start_effect(336.84+3.9,399.68,1,0,0,2,parameter=fx_explosion)
	enemy_script.delay(0.4, Lambda('object.set_active_state("CAR_TIMETRAVELLER", True)'))
	enemy_script.delay(0.4, Lambda("""object.play_animation("CAR_TIMETRAVELLER","TIMEMACHINE_FAHRT", callback = ["ONEND",Lambda("system.end_cutscene()")])"""))
	 

def onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_1():
	dialog.init_dialog(type=DIALOGSMALL)
	
	dialog.add_text(text = 'D_005_T_001', speaker = 'TIMETRAVELLER', follower = 'ENDDIALOG', callback = onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_2)
	dialog.start()

def onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_2():
	data().TimeCounter += 1
	if data().TimeCounter == 2:
		data().TimeCounter = 0
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.add_text(text = 'D_005_T_002', speaker = 'ALTER_EGO', callback = onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_3)
		dialog.add_text(text = 'D_005_T_003', speaker = 'TIMETRAVELLER', callback = onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_4)
		dialog.add_text(text = 'D_005_T_004', speaker = 'ALTER_EGO', callback = Lambda('dynamic_camera.set_conversation("TIMETRAVELLER", "ALTER_EGO", mode = "close")'))
		dialog.add_text(text = 'D_005_T_005', speaker = 'TIMETRAVELLER')
		dialog.add_text(text = 'D_005_T_006', speaker = 'TIMETRAVELLER', callback = Lambda('dynamic_camera.set_conversation("ALTER_EGO", "TIMETRAVELLER", mode = "close")'))
		dialog.add_text(text = 'D_005_T_007', speaker = 'ALTER_EGO', callback = Lambda('dynamic_camera.set_conversation("TIMETRAVELLER", "ALTER_EGO", mode = "close")'))
		dialog.add_text(text = 'D_005_T_008', speaker = 'TIMETRAVELLER', follower = 'ENDDIALOG', callback = ENDCutscen_005_Zeitreisender_schliesst_sich_Spieler_an)
		
		dialog.start()

def onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_3():
	system.set_camera_view([450.77755737304687, 405.98895263671875, 5.1893186569213867, 0.9127122163772583, 0.34746396541595459, -0.21500061452388763])
	enemy_script.delay(2,Lambda('dynamic_camera.set_conversation("TIMETRAVELLER", "ALTER_EGO", mode = "close")'))
	
def onCutscen_005_Zeitreisender_schliesst_sich_Spieler_an_4():
	system.set_camera_view([457.35409545898437, 410.32794189453125, 4.2977480888366699, -0.65011858940124512, -0.72878015041351318, -0.21500058472156525])
	dynamic_camera.set_conversation("ALTER_EGO", "TIMETRAVELLER", new_camera = False)

def ENDCutscen_005_Zeitreisender_schliesst_sich_Spieler_an():
	data().TimeTrafeler = True
	data().GameOver_1 = True
	allow_activity('ARTHUR_LAWRENCE')
	end_cutscene(chars = ['ALTER_EGO', 'TIMETRAVELLER'])
	
#### Der Zeitreisende schließt sich dem Spieler an END ####


#*** dialoge nach dem ende der zone (aus allen zonen zusammengeklaut)

## [NM] zone_9 Dialog 073: Der Spieler will Anie nicht ansprechen
def initDlg_Z9_073_SpielerWillAnieNichtAnsprechen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='Z9_D_073_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

## [NM] zone_9 Dialog 072: Abel ist beschäftigt
def initDlg_Z9_072_AbelIstBeschaeftigt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='Z9_D_072_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

## [NM] zone_6 Dialog 147: Der Spieler hat mit Arik nichts mehr zu bereden
def initDlg_Z6_147_SpielerHatNichtsZuBereden():
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='Z6_D_147_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

################################################################################


# *** dialogs ******************************************************************
def initCutscene_001_Example():
	system.start_cutscene()
	system.end_cutscene()
	

#[M]Dialog 001: Beispiel
def initDlg_001_Example():
	dialog.init_dialog(DIALOGLARGE)
	dialog.start(False)

default_templates = """
def initDlg_000_():
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='', speaker='')
	dialog.start()

def initCutscene_000_():
	system.start_cutscene()
	init_cutscene(operator='', target='', dx=,dy=)
	object.turn_to_object(object='', target_object='', callback=["ONEND", onDlg_000_StartDialog])

def onDlg_000_StartDialog(char_id):
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='', speaker='')
	dialog.add_text(text='', speaker='', follower='ENDDIALOG', callback=Lambda('system.end_cutscene()'))
	dialog.start()
"""
