# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import schedules
import const
import enemy_script
import object_events
from const import *
import system_events
from daily_routine import *
import sounds
from uiresource import *

#*** aktuelle revison: Revision 1, 9.08.2004  *****************************

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(398.82, 212.38),
	 		"SOUTH":	(398.82, 212.38),
	 		"WEST":		(398.82, 212.38),
	 		"EAST":		(398.82, 212.38),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("green")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
	#system.add_region("Norden",395,570,564,480)
	#data("rest").non_rest_areas.append("Norden")

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	
	location = GetZoneEnterLocation("SOUTH")
	
	system.zone_transfer_place_characters( location[0], location[1] )
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	object.turn_to_direction('ALTER_EGO', 180)
	npc.initNPCS()
	character.change_body_mode('TIMETRAVELLER', 'KNEEL', callback = ['ONEND', Lambda('object.set_active_state("TIMETRAVELLER", False)')])
	initItems()
	initHerbs()
	initObjects()
	initRegions()
	initExitZones()
	initFX()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()

	# beim ersten betreten der Zone 
	enemy_script.delay(2, Lambda('dialogs.initCutscene_001_Der_Spieler_betritt_die_Biosphaere()'))
	init_non_rest_areas()
	Zonen_Chars_Dektivieren()
	object.add_closed_lock("ZONE_10_BUILDING_8013", "lock1", closure_type='normal')
	
	data().QB_001 = system.register_qb_entry('ZONE10_AIM_1')
	
	system.set_qb_entry_state(data().QB_001, UNCOMPLETE)
	# system.set_qb_entry_state(data('zone_8.zone_8').QB_001, INACTIVE)
	object.step_to('PRESIDENT_HAYES', 285.53, 546.66)
	sounds.load_sound('timemachine_returns')
	for char in ["ANIE", "ABEL", "PRESIDENT_HAYES", "BANKS", "ROWLAND", "ARTHUR_LAWRENCE", 'TIMETRAVELLER']:
		if object.exists(char):
			if object.has_attribute(char, 'zone_transfer'):
				object.set_attribute(char, 'zone_transfer', None)
	
	initTimeTraveller()
	
def initTimeTraveller():
	# für die Time Cutscene
	system.create_object("RES3D_TRES_OBJECTS_BUILDING_TIMETRAVELLER_RETURNS", 425.72 , 423.38, "CAR_TIMETRAVELLER_RETURNS",260)
	object.set_active_state("CAR_TIMETRAVELLER_RETURNS", False)
	object.set_active_state("TIMETRAVELLER", True)
	object.set_position("TIMETRAVELLER", 458.64, 409.35)
	character.change_body_mode("TIMETRAVELLER", "KNEEL")
	enemy_script.delay(5, Lambda('object.set_active_state("TIMETRAVELLER", False)'))
	
def Zonen_Chars_Dektivieren():
	for id in system.get_npcs():
		#if id == 'TIMETRAVELLER':
		#	object.set_active_state('TIMETRAVELLER', False)
		if id == 'ABEL':
			object.set_active_state('ABEL', False)
		if id == 'ANIE':
			object.set_active_state('ANIE', False)
		if id == 'BANKS':
			object.set_active_state('BANKS', False)
		if id == 'ROWLAND':
			object.set_active_state('ROWLAND', False)

def initRegions():
	system.add_region("ZENTRUM_2",200, 367 , 400, 361)
	system.notify_region_entered(region="ZENTRUM_2", objectid="ALTER_EGO")
	system.add_region("ZENTRUM_1",400, 367 , 600, 361)
	system.notify_region_entered(region="ZENTRUM_1", objectid="ALTER_EGO")
	system.add_region("ZENTRUM_3",330.55, 337.84, 316.96, 361.03)
	system.notify_region_entered(region="ZENTRUM_3", objectid="ALTER_EGO")
	
	system.add_region("VERBUENDETE_N_W",251.00, 319.00, 200.00, 348.00)
	system.add_region("VERBUENDETE_S_W",251.00, 348.00, 200.00, 377.00)
	system.add_region("VERBUENDETE_N_O",302.00, 319.00, 251.00, 348.00)
	system.add_region("VERBUENDETE_S_O",302.00, 348.00, 251.00, 377.00)
	system.notify_region_entered(region="VERBUENDETE_N_W", objectid="ALTER_EGO")
	system.notify_region_entered(region="VERBUENDETE_S_W", objectid="ALTER_EGO")
	system.notify_region_entered(region="VERBUENDETE_N_O", objectid="ALTER_EGO")
	system.notify_region_entered(region="VERBUENDETE_S_O", objectid="ALTER_EGO")
	
	system.add_region("ARTHUR_LAWRENCE_N_W",499.61, 409.96, 512.53, 422.62)
	system.add_region("ARTHUR_LAWRENCE_S_W",499.61, 422.62, 512.53, 435.28)
	system.add_region("ARTHUR_LAWRENCE_N_O",512.53, 409.96, 525.45, 422.62)
	system.add_region("ARTHUR_LAWRENCE_S_O",512.53, 422.62, 525.45, 435.28)
	
	system.add_region('HAYES_N_W',303.60, 560.50, 285.85, 546.98)
	system.add_region('HAYES_S_W',303.60, 546.98, 285.85, 533.46)
	system.add_region('HAYES_N_O',285.85, 560.50, 268.10, 546.98)
	system.add_region('HAYES_S_O',285.85, 546.98, 268.10, 533.46)
	
	system.add_region('GNO_FLUCHT',290.67, 511.63, 265.75, 484.91)
	system.notify_region_entered(region="GNO_FLUCHT", partyid="GNO_FLUCHT")
	

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def CanLeaveZone():
	return False


# *** callbacks ****************************************************************
# approach callback
def on_approach(target,operator):
	dialogs.on_approach( target, operator )

# region enter callback
def on_enter_region(id, objectid, partyid ):
	# print "on_enter_region(",id, objectid, partyid," )"
	
	#if id == 'EXTRO':
	#	dialogs.EXTRO()
	
	if id == 'ZENTRUM_1' and not data().Zentrum_betreten:
		data().Zentrum_1_betreten = True
		data().Zentrum_betreten = True
		for id in system.get_objects_for_party('GNO_KAEMPFER_4_PLUS'):
			system.switch_party(id, 'GNO_KAEMPFER_WELLE')
			enemy_script.is_equip_weapon(id)
		attack(operator = objectid, target = None, party = 'GNO_KAEMPFER_WELLE', target_party = None, enemys=[])
	if (id == 'ZENTRUM_2' or id == 'ZENTRUM_3') and not data().Zentrum_betreten:
		data().Zentrum_2_3_betreten = True
		data().Zentrum_betreten = True
		for id in system.get_objects_for_party('GNO_KAEMPFER_5_PLUS'):
			enemy_script.is_equip_weapon(id)
			system.switch_party(id, 'GNO_KAEMPFER_WELLE')
		attack(operator = objectid, target = None, party = 'GNO_KAEMPFER_WELLE', target_party = None, enemys=[])
	
	if id == 'VERBUENDETE_N_W' and not data().Verbuendete_betreten and not data().Nest_5_Angegriffen and not data().GameOver:
		pos = [(250.18, 337.34), (251.88, 337.49), (250.60, 339.01)]
		GNO_char = ['GNO-Soldat B','GNO-Soldat A']
		Verbuendete_Helper('N_W', pos, GNO_char, 8)
		
	if id == 'VERBUENDETE_N_O' and not data().Verbuendete_betreten and not data().Nest_5_Angegriffen and not data().GameOver:
		pos = [(273.00, 329.76), (272.71, 331.46), (270.67, 331.24)]
		GNO_char = ['GNO-Soldat A','GNO-Soldat B']
		Verbuendete_Helper('N_O', pos, GNO_char, 6)
		
	if id == 'VERBUENDETE_S_W' and not data().Verbuendete_betreten and not data().Nest_5_Angegriffen and not data().GameOver:
		pos = [(251.03, 342.39), (252.60, 342.68), (251.81, 344.11)]
		GNO_char = ['GNO-Soldat B','GNO-Soldat A']
		Verbuendete_Helper('S_W', pos, GNO_char, 6)
		
	if id == 'VERBUENDETE_S_O' and not data().Verbuendete_betreten and not data().Nest_5_Angegriffen and not data().GameOver:
		pos = [(274.11, 369.15), (273.35, 367.18), (275.60, 367.55)]
		GNO_char = ['GNO-Soldat B','GNO-Soldat A']
		Verbuendete_Helper('S_O', pos, GNO_char, 4)

	if id == 'HAYES_N_W' and not data().Hayes_Cutscene_Gelaufen and not data().GameOver:
		Hayes_Verjagen('HAYES_N_W')
	
	if id == 'HAYES_N_O' and not data().Hayes_Cutscene_Gelaufen and not data().GameOver:
		Hayes_Verjagen('HAYES_N_O')
	
	if id == 'HAYES_S_W' and not data().Hayes_Cutscene_Gelaufen and not data().GameOver:
		Hayes_Verjagen('HAYES_S_W')
	
	if id == 'HAYES_S_O' and not data().Hayes_Cutscene_Gelaufen and not data().GameOver:
		Hayes_Verjagen('HAYES_S_O')
	
	if id == 'ARTHUR_LAWRENCE_N_W' and not data().Arthur_Lawrence_betreten and not data().GameOver:
		Arthur_Helper('N_W')
		
	if id == 'ARTHUR_LAWRENCE_N_O' and not data().Arthur_Lawrence_betreten and not data().GameOver:
		Arthur_Helper('N_O')
		
	if id == 'ARTHUR_LAWRENCE_S_W' and not data().Arthur_Lawrence_betreten and not data().GameOver:
		Arthur_Helper('S_W')
		
	if id == 'ARTHUR_LAWRENCE_S_O' and not data().Arthur_Lawrence_betreten and not data().GameOver:
		Arthur_Helper('S_O')
		
	if id == 'GNO_FUCHT' and not data().Gno_Flucht_Betreten:
		data().Gno_Flucht_Betreten = True
		for id in system.get_objects_for_party('GNO_FUCHT'):
			system.switch_party(id, "GNO_KAEMPFER_5")
		
def Verbuendete_Helper(Cam_View, pos, GNO_char, time):
	CAM_VIEW_1 = 'CAM_VIEW_VERBUENDETE_' + Cam_View + '_1'
	CAM_VIEW_2 = 'CAM_VIEW_VERBUENDETE_' + Cam_View + '_2'
	if Cam_View == 'NW':
		CAM_VIEW_3 = 'CAM_VIEW_VERBUENDETE_' + Cam_View + '_3'
	else:
		CAM_VIEW_3 = 'None'
	data().Verbuendete_betreten = True
	for party in PARTY_ID + ['GNO_KAEMPFER_WELLE']:
		for id in system.get_objects_for_party(party):
			if object.has_attribute(id, 'foes'):
				object.set_attribute(id, 'foes', None)
				if object.has_attribute(id, 'foes'):
					object.set_attribute(id, 'cutscene_temp_foes', None)
			object.cancel_commandos(id)
			enemy_script.delay(1, Lambda('object.cancel_commandos("%s")'%id))
					
	system.start_cutscene()
	dialogs.initCutscene_006_Die_GNO_Soldaten_wollen_kapitulieren(eval(CAM_VIEW_1), eval(CAM_VIEW_2),  eval(CAM_VIEW_3), pos, GNO_char, time)

def Arthur_Helper(Cam_View):
	if not data().Arthur_Lawrence_betreten and not system.is_cutscene():
		data().Arthur_Lawrence_betreten	= True
		CAM_VIEW = 'CAM_VIEW_ARTHUR_' + Cam_View
		for party in PARTY_ID:
			for id in system.get_objects_for_party(party):
				if object.is_fighting(id):
					return
		Artur_Befreiung_Beginn(eval(CAM_VIEW))

def Hayes_Flucht():
	enemy_script.delay(1, Lambda('Hayes_Flucht_1()'))
	
def Hayes_Flucht_1():
	if not data().Hayes_betreten and not system.is_cutscene():
		system.start_cutscene()
		system.set_camera_view(CAM_VIEW_HAYES_FLUCHT)
		object.set_position('PRESIDENT_HAYES', 296.69, 548.18, grid = 'landscape')
		object.move_to('PRESIDENT_HAYES', 290.71, 545.45, speed = MT_FAST)
		object.step_to('PRESIDENT_HAYES', 287.33, 545.20, speed = MT_FAST, callback= ['ONEND', Lambda('object.play_animation("ZONE_10_BUILDING_8013", "ANIM_GENERIC_DOOR1_OPEN")')])
		object.step_to('PRESIDENT_HAYES', 285.85, 545.24, speed = MT_FAST)
		object.step_to('PRESIDENT_HAYES', 285.53, 546.66, speed = MT_FAST, callback= [['ONEND', Lambda('object.play_animation("ZONE_10_BUILDING_8013", "ANIM_GENERIC_DOOR1_CLOSE")')], ['ONEND', Hayes_Flucht_2]])
		
def Hayes_Flucht_2(id):
	enemy_script.delay(1, Lambda('system.end_cutscene()'))
	object.turn_to_direction('PRESIDENT_HAYES', 0)
		
def Hayes_Verjagen(id):
	CAM_VIEW = 'CAM_VIEW_' + id
	system.set_camera_view(eval(CAM_VIEW))
	if not data().Hayes_betreten:
		data().Hayes_betreten = True
		system.start_cutscene()
		object.move_to('ALTER_EGO', 285.99, 538.11, callback = ['ONEND', dialogs.initCutscene_002_Hayes_versucht_Spieler_zu_ueberzeugen])
	
def Artur_Befreiung_Beginn(Cam_View):
	if not data().Artur_Cutscene:
		data().Artur_Cutscene = True
		dialogs.initCutscene_008_Arthur_berichtet_ueber_Biosphaere(Cam_View)
		enemy_script.delay(0.5, Lambda('Artur_Befreiung_Beginn_1()'))
		
def Artur_Befreiung_Beginn_1():
	group_ = system.get_pcs()
	group_.remove('ALTER_EGO')
	# print group_
	enemy_script.evacuate(group_, [513.88, 419.48], 5, callback = Lambda('object.turn_to_object(char, "ARTHUR_LAWRENCE")', 'char'))
	
# timer event callback
def on_timer(id):
	pass
	# print "[debug on_timer()",id,"]"

# activity callback
def on_wait_for_commando(id):
	
	return schedules.Activity(id)

# use callback
def can_use( character_id, object_id ):
	return object_events.can_use( character_id, object_id )

def on_use( character_id, object_id, item_id, item_type ):
	return object_events.on_use( character_id, object_id, item_id, item_type )

# exchange callback
def can_exchange( character_id, target_id, item_id, item_type ):
	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
	return False
	
def on_object_killed(victim, attacker, weapon_type, weapon_id):
	
	if data().Arthur_Lawrence_betreten and not data().Artur_Befreit:
		for party in PARTY_ID:
			for id in system.get_objects_for_party(party):
				if not object.is_fighting(id):
					data().Arthur_Lawrence_betreten = False
					data().Artur_Befreit = True
					system.add_region("ARTHUR_LAWRENCE_N_W",499.61, 409.96, 512.53, 422.62)
					system.add_region("ARTHUR_LAWRENCE_S_W",499.61, 422.62, 512.53, 435.28)
					system.add_region("ARTHUR_LAWRENCE_N_O",512.53, 409.96, 525.45, 422.62)
					system.add_region("ARTHUR_LAWRENCE_S_O",512.53, 422.62, 525.45, 435.28)
	
	if victim in system.get_objects_for_party('GNO_VERBUENDETE') and (attacker in system.get_objects_for_party('UISPIELER') or attacker == None):
		data().Verbuendete_betreten = True					
	
	if not object.get_party(victim) == 'GNO_VERBUENDETE':
		if len(system.get_objects_for_party(object.get_party(victim))) == 1:
			if data().KAMPF_MIT_VERBUENDETE:
				for id in system.get_objects_for_party('GNO_VERBUENDETE'):
					if not object.is_destroyed(id):
						object.move_to(id, 445.19, 10.00, callback = ['ONEND', Lambda('object.set_active_state("%s", False)'%id)])
	if object.get_party(victim) == 'GNO_KAEMPFER_WELLE':
		if data().KAEMPFER_GNO_WELLE_KILL < 4:
			data().KAEMPFER_GNO_WELLE_KILL += 1
		elif data().KAEMPFER_GNO_WELLE_KILL == 4:
			data().KAEMPFER_GNO_WELLE_KILL += 1
			if data().Zentrum_1_betreten:
				for id in system.get_objects_for_party('GNO_KAEMPFER_5_PLUS'):
					if not object.is_destroyed(id):
						system.switch_party(id, 'GNO_KAEMPFER_WELLE')
				attack(operator = attacker, target = victim, party = 'GNO_KAEMPFER_WELLE', target_party = None, enemys=[attacker])
			if data().Zentrum_2_3_betreten:
				for id in system.get_objects_for_party('GNO_KAEMPFER_4_PLUS'):
					if not object.is_destroyed(id):
						system.switch_party(id, 'GNO_KAEMPFER_WELLE')
				attack(operator = attacker, target = victim, party = 'GNO_KAEMPFER_WELLE', target_party = None, enemys=[attacker])
		elif data().KAEMPFER_GNO_WELLE_KILL == 13:
			data().Welle_Abgewehrt = True
			for id in system.get_objects_for_party('GNO_KAEMPFER_WELLE'):
				if not object.is_destroyed(id):
					system.switch_party(id, 'GNO_FLUCHT')
					object.cancel_commandos(id)
					object.move_to(id, 280.55, 501.98)
		elif data().KAEMPFER_GNO_WELLE_KILL < 13:
			data().KAEMPFER_GNO_WELLE_KILL += 1
			
	if object.get_party(victim) == 'GNO_KAEMPFER_5':
		if len(system.get_objects_for_party('GNO_KAEMPFER_5')) == 1:
			system.notify_region_entered(region="HAYES_N_W", objectid="ALTER_EGO")
			system.notify_region_entered(region="HAYES_N_O", objectid="ALTER_EGO")
			system.notify_region_entered(region="HAYES_S_W", objectid="ALTER_EGO")
			system.notify_region_entered(region="HAYES_S_O", objectid="ALTER_EGO")
			object.remove_closed_lock_by_name("ZONE_10_BUILDING_8013", "lock1")
			Hayes_Flucht()
	
	if object.get_party(victim) == 'GNO_KAEMPFER_4':
		if len(system.get_objects_for_party('GNO_KAEMPFER_4')) == 1:
			data().Gno_Nest_4_Kill = True
			
			system.notify_region_entered(region="ARTHUR_LAWRENCE_N_O", objectid="ALTER_EGO")
			system.notify_region_entered(region="ARTHUR_LAWRENCE_N_W", objectid="ALTER_EGO")
			system.notify_region_entered(region="ARTHUR_LAWRENCE_S_O", objectid="ALTER_EGO")
			system.notify_region_entered(region="ARTHUR_LAWRENCE_S_W", objectid="ALTER_EGO")
		
	
	if victim == 'PRESIDENT_HAYES':
		enemy_script.delay(1, Lambda('dialogs.Hayes_flieht()'))
		
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	
def on_end_video_stream(player_id):
	if not data('zone_2.zone_2').Time_Traveler_Gestartet:
		allow_activity('ARTHUR_LAWRENCE')
		data().GameOver_1 = True
	else:
		enemy_script.delay(2, Lambda('dialogs.Time_Traveller()'))
		system_events.on_end_video_stream(player_id)

# examine callback
def can_examine_object( character_id, object_id ):
	return False

def on_examine_object( character_id, object_id ):
	return False

# pickup callback
def on_pick_up( character_id, item_id, item_type ):
	return True

# fight callbacks
def on_enemy_spotted(object_id):
	enemys = character.get_visible_enemies(object_id)
	if object.get_party(object_id) in ['GNO_KAEMPFER_4_PLUS', 'GNO_KAEMPFER_5_PLUS']:
		enemy_script.is_equip_weapon(object_id)
	if object.get_party(object_id) in ['GNO_KAEMPFER_1', 'GNO_KAEMPFER_2', 'GNO_KAEMPFER_3']:
		if not object.is_fighting(object_id):
			object.cancel_commandos(object_id)
			if enemy_script.is_equip_weapon(object_id):
				pc = random.choice(enemys)
				if not object.is_destroyed(object_id):
					if pc != None:
						object.attack(object_id, pc)
	if object.get_party(object_id) in PARTY_ID:
		if data().Zentrum_betreten:
			if not object.is_fighting(object_id):
				object.cancel_commandos(object_id)
				if enemy_script.is_equip_weapon(object_id):
					pc = random.choice(enemys)
					if not object.is_destroyed(object_id):
						if pc != None:
							object.attack(object_id, pc)
			
		
def on_attack(operator, target):
	# print "on_attack(",operator, target,")"
	if object.is_destroyed(target):
		return None
	if object.is_destroyed(operator):
		return None
	enemys = character.get_visible_enemies(target)
	# print "on_attack(",operator, target, enemys,")"
		
	if object.get_party(target) == 'UISPIELER' and data().KAMPF_MIT_VERBUENDETE:
		attack(operator, target, 'GNO_VERBUENDETE', None, enemys)
		
	if object.get_party(target) == 'GNO_KAEMPFER_2':
		if not data().GNO_2_3_Frei:
			data().GNO_2_3_Frei = True
			if not object.is_destroyed('KAEMPFER_GNO_NEST_2_3'):
				object.step_away('KAEMPFER_GNO_NEST_2_3', callback = ['ONEND', Lambda('object.attack("KAEMPFER_GNO_NEST_2_3", "%s")'%operator)])
		attack(operator, target, 'GNO_KAEMPFER_2', None, enemys)
	
	elif object.get_party(target) == 'GNO_KAEMPFER_4_PLUS':
		for id in system.get_objects_for_party('GNO_KAEMPFER_4_PLUS'):
			if not object.is_destroyed(id):
				system.switch_party(id, 'GNO_KAEMPFER_WELLE')
		data().Zentrum_betreten 	= True
		data().Zentrum_1_betreten	= True
		data().Zentrum_2_3_betreten	= True
		attack(operator, target, 'GNO_KAEMPFER_WELLE', None, enemys)
	
	elif object.get_party(target) == 'GNO_KAEMPFER_5_PLUS':
		for id in system.get_objects_for_party('GNO_KAEMPFER_5_PLUS'):
			if not object.is_destroyed(id):
				system.switch_party(id, 'GNO_KAEMPFER_WELLE')
		data().Zentrum_betreten 	= True
		data().Zentrum_1_betreten	= True
		data().Zentrum_2_3_betreten	= True
		attack(operator, target, 'GNO_KAEMPFER_WELLE', None, enemys)
		
	elif object.get_party(target) == 'GNO_KAEMPFER_WELLE':
		if not data().Welle_Abgewehrt:
			attack(operator, target, 'GNO_KAEMPFER_WELLE', None, enemys)
	
	elif object.get_party(target) == 'GNO_KAEMPFER_4':
		if not data().GNO_4_4_Frei:
			data().GNO_4_4_Frei = True
			if not object.is_destroyed('KAEMPFER_GNO_NEST_4_4'):
				object.step_to('KAEMPFER_GNO_NEST_4_4', 512.52, 423.35)
				object.step_away('KAEMPFER_GNO_NEST_4_4', callback = ['ONEND', Lambda('object.attack("KAEMPFER_GNO_NEST_4_4", "%s")'%operator)])
		attack(operator, target, 'GNO_KAEMPFER_4', None, enemys)
	
	elif object.get_party(target) == 'GNO_KAEMPFER_1':
		attack(operator, target, 'GNO_KAEMPFER_1', None, enemys)
	
	elif object.get_party(target) == 'GNO_KAEMPFER_5':
		# das wahr ein Fehler :-)
		data().Nest_5_Angegriffen = True
		for party in PARTY_ID:
			for id_ in system.get_objects_for_party(party):
				if not object.get_party(id_) == 'GNO_KAEMPFER_5':
					system.switch_party(id_, 'GNO_KAEMPFER_5')
		if not data().Verbuendete_betreten:
			for id_ in system.get_objects_for_party('GNO_VERBUENDETE'):
				if not object.get_party(id_) == 'GNO_KAEMPFER_5':
					system.switch_party(id_, 'GNO_KAEMPFER_5')
					object.set_attribute(id_, 'foes', ['UISPIELER'])
		if not object.is_destroyed('KAEMPFER_GNO_NEST_3_4'):
			object.step_away('KAEMPFER_GNO_NEST_3_4')
		attack(operator, target, 'GNO_KAEMPFER_5', PARTY_ID, enemys)
	
	elif object.get_party(target) == 'GNO_KAEMPFER_3':
		object.set_immortal_state(target, False)
		attack(operator, target, 'GNO_KAEMPFER_3', None, enemys)
		
	elif object.get_party(target) == 'GNO_VERBUENDETE' and object.get_party(operator) == 'UISPIELER':
		data().Verbuendete_betreten = True
		for id in system.get_objects_for_party('GNO_VERBUENDETE'):
			if not object.is_destroyed(id):
				object.set_immortal_state(id, False)
				object.set_attribute(id, "foes", ["UISPIELER"])
				system.switch_party(id, 'GNO_KAEMPFER_3')
		attack(operator, target, 'GNO_KAEMPFER_3', None, enemys)
		
def on_sector_cleared(id):
	pass
	# print 'on_sector_cleared:', id

def attack(operator, target, party, target_party, enemys):
	""" baut eine angriffswelle auf
params:
	operator 	= (string) Angreifer
	target 		= (string) Angegrifener
	party 		= (string) Party des angegriffenen NPC 
	target_party 	= (string oder liste oder None) Partys die angreifen sollen
	enemys		= (liste) liste der PCs die target spotted hat
"""
	if target_party == None:
		target_party = []
	if not (isinstance(target_party, list)): 
		if not len(enemys):
			for id in system.get_objects_for_party(target_party) + system.get_objects_for_party(party):
				if not object.is_destroyed(id):
					if not object.is_fighting(id):
						enemy_script.is_equip_weapon(id)
						object.move_to_object(id, operator)
			return 
		for id in system.get_objects_for_party(target_party) + system.get_objects_for_party(party):
			if not object.is_destroyed(id):
				if not object.is_fighting(id):
					pc = random.choice(enemys)
					enemy_script.is_equip_weapon(id)
					if pc != None:
						if not object.is_destroyed(pc):
							object.move_to_object(id, pc)
		return
	else:
		if not len(enemys):
			if len(target_party):
				le = len(target_party)
				for x in range(0, le):
					for id in system.get_objects_for_party(target_party[x]):
						if not object.is_destroyed(id):
							if not object.is_fighting(id):
								enemy_script.is_equip_weapon(id)
								object.move_to_object(id, operator)
			for id in system.get_objects_for_party(party):
					if not object.is_destroyed(id):
						if not object.is_fighting(id):
							enemy_script.is_equip_weapon(id)
							object.move_to_object(id, operator)
			return 
		else:
			if len(target_party):
				le = len(target_party)
				for x in range(0, le):
					for id in system.get_objects_for_party(target_party[x]):
						if not object.is_destroyed(id):
							if not object.is_fighting(id):
								pc = random.choice(enemys)
								enemy_script.is_equip_weapon(id)
								if pc != None:
									object.move_to_object(id, pc)
			for id in system.get_objects_for_party(party):
					if not object.is_destroyed(id):
						if not object.is_fighting(id):
							pc = random.choice(enemys)
							enemy_script.is_equip_weapon(id)
							if pc != None:
								object.move_to_object(id, pc)
			return 

# *** initializations **********************************************************
def initParties():
	system.create_party(id="NPCS"					,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_1"			,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_2"			,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_3"			,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_4"			,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_4_PLUS"	,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_WELLE"		,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_5"			,type = PT_COMPUTER)
	system.create_party(id="GNO_KAEMPFER_5_PLUS"	,type = PT_COMPUTER)
	system.create_party(id="GNO_VERBUENDETE" 		,type = PT_COMPUTER)
	system.create_party(id="GNO_FLUCHT"				,type = PT_COMPUTER)
	system.create_party(id="GNO_KILL"	 			,type = PT_COMPUTER)
	system.create_party(id="UISPIELER"				,type = PT_HUMAN)

# markieren von im script modifizierbaren mapobjekten
def init_scriptuse_objects():
	#example:
	#system.mark_for_script_use(id)
	system.mark_for_script_use('ZONE_10_BUILDING_13704')
	system.mark_for_script_use('ZONE_10_BUILDING_13706')
	system.mark_for_script_use('ZONE_10_BUILDING_13718')
	system.mark_for_script_use('ZONE_10_BUILDING_13721')
	system.mark_for_script_use('ZONE_10_BUILDING_13723')
	
	# Bienenst�cke Zone 10
	system.mark_for_script_use('BUILDING_13733')
	system.mark_for_script_use('BUILDING_13732')
	system.mark_for_script_use('BUILDING_13731')

	

# setzt chars mortal bzw immortal + foes attribute fuer animals
def init_character_states():
	
	for char in ["ANIE" ,"ABEL", "ROWLAND", "BANKS", "TIMETRAVELLER" ]:
		if char in system.get_npcs():
			object.set_active_state(char, False)
	
	for id in PARTY_ID:
		for id_ in system.get_objects_for_party(id):
			object.set_attribute(id_, "foes", ["UISPIELER"])
	# animals
	#for id in system.get_animals():
	#	 

# erzeugen von items im inventory von npcs oder in der zone
def initItems():
	### NEST_1 #############################################################
####################################################################################################################
#
#
	#object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_1', ['SET_LAW', 'SET_MUN_LAW', 
	#								'SET_MUN_LAW', 
	#								'SET_MUN_LAW'])
	#character.equip('KAEMPFER_GNO_NEST_1_1', 'SET_LAW')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_1', ['SET_MG_3', 'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_1_1', 'SET_MG_3')
#
#
#####################################################################################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_2', ['SET_MG_3', 'SET_AMMOPACK_7_62NATO_MM',
									'SET_AMMOPACK_7_62NATO_MM', 
									'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_1_2', 'SET_MG_3')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_3', ['SET_OICW', 'SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE',
									'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM'])
######################################################################################################################
#
#
	#object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_4', ['SET_HK_G11', 'SET_AMMOPACK_4_73_CASELESS', 
	#								'SET_AMMOPACK_4_73_CASELESS', 
	#								'SET_AMMOPACK_4_73_CASELESS', 
	#								'SET_AMMOPACK_4_73_CASELESS', 
	#								'SET_HEGRENADE'])
	#character.equip('KAEMPFER_GNO_NEST_1_4', 'SET_HK_G11')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_4', ['SET_MG_3', 'SET_AMMOPACK_7_62NATO_MM',
									'SET_AMMOPACK_7_62NATO_MM', 
									'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_1_4', 'SET_MG_3')
#
#
#######################################################################################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_5', ['SET_HK_CAWS', 'SET_AMMOPACK_3_12_MM', 
									'SET_AMMOPACK_3_12_MM'])
	character.equip('KAEMPFER_GNO_NEST_1_5', 'SET_HK_CAWS')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_1_6', ['SET_RAILGUN', 'SET_AMMOPACK_2_5_JHP_ARROW'])
	character.equip('KAEMPFER_GNO_NEST_1_6', 'SET_RAILGUN')
	### NEST_2 #############################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_1', ['SET_HK_CAWS', 'SET_AMMOPACK_3_12_MM', 
									'SET_AMMOPACK_3_12_MM'])
	character.equip('KAEMPFER_GNO_NEST_2_1', 'SET_HK_CAWS')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_2', ['SET_HK_CAWS', 'SET_AMMOPACK_3_12_MM', 
									'SET_AMMOPACK_3_12_MM'])
	character.equip('KAEMPFER_GNO_NEST_2_2', 'SET_HK_CAWS')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_3', ['SET_M_16', 'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_4', ['SET_M_16', 'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_5', ['SET_M_16', 'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_6', ['SET_LASER_GUN', 'SET_AMMOPACK_LASER_GUN'])
	character.equip('KAEMPFER_GNO_NEST_2_6', 'SET_LASER_GUN')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_2_7', ['SET_M_16', 'SET_AMMOPACK_5_56_MM', 'SET_M_16_M203'])
	### NEST_3 #############################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_3_1', ['SET_LASER_GUN', 'SET_AMMOPACK_LASER_GUN'])
	character.equip('KAEMPFER_GNO_NEST_3_1', 'SET_LASER_GUN')
	object.create_item_in_inventory('GNO-Soldat B', ['SET_HK_CAWS', 'SET_AMMOPACK_3_12_MM', 
									'SET_AMMOPACK_3_12_MM'])
	character.equip('GNO-Soldat B', 'SET_HK_CAWS')
	object.create_item_in_inventory('GNO-Soldat A', ['SET_SIG_SG_552', 'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM'])
	character.equip('GNO-Soldat A', 'SET_SIG_SG_552')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_3_4', ['SET_SIG_SG_552', 'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_3_5', ['SET_STEYR_AUG', 'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_3_5', 'SET_STEYR_AUG')
######################################################################################################################
#
#
	#object.create_item_in_inventory('KAEMPFER_GNO_NEST_3_6', ['SET_LAW', 'SET_MUN_LAW',
	#								'SET_MUN_LAW',
	#								'SET_MUN_LAW'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_3_6', ['SET_MG_3', 'SET_AMMOPACK_7_62NATO_MM'])
#
#
######################################################################################################################

	### NEST_4 #############################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_4_1', ['SET_DESERT_EAGLE', 'SET_AMMOPACK_50',
									'SET_AMMOPACK_50_AE_DUMDUM', 
									'SET_AMMOPACK_50_AE_DUMDUM'])
	character.equip('KAEMPFER_GNO_NEST_4_1', 'SET_DESERT_EAGLE')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_4_2', ['SET_HK_G36C', 'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_4_3', ['SET_STEYR_AUG', 'SET_AMMOPACK_5_56_MM', 
									'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_4_3', 'SET_STEYR_AUG')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_4_4', ['SET_HK_XM8', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_4_5', ['SET_STEYR_AUG', 'SET_AMMOPACK_5_56_MM',
									'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_4_5', 'SET_STEYR_AUG')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_4_6', ['SET_FN_MAG', 'SET_AMMOPACK_7_62NATO_MM', 
									'SET_AMMOPACK_7_62NATO_MM',
									'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_4_6', 'SET_FN_MAG')
	### NEST 4 PLUS ########################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_1',  ['SET_HK_XM8', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_2',  ['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_3',  ['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_4',  ['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_5',  ['SET_RAILGUN', 'SET_AMMOPACK_2_5_JHP_ARROW'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_6',  ['SET_RAILGUN', 'SET_AMMOPACK_2_5_JHP_ARROW'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_4_6', 'SET_RAILGUN')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_7',  ['SET_GMG_OCSW', 'SET_AMMOPACK_25_MM_HE'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_4_8',  ['SET_GMG_OCSW', 'SET_AMMOPACK_25_MM_HE'])
	### NEST_5 #############################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_1', ['SET_HK_CAWS', 'SET_AMMOPACK_3_12_MM', 
									'SET_AMMOPACK_3_12_MM'])
######################################################################################################################
#
#									
	#object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_2', ['SET_HEGRENADE'])
	# character.equip('KAEMPFER_GNO_NEST_5_2', 'SET_HEGRENADE')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_2', ['SET_MG_3', 'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_5_2', 'SET_MG_3')
	
	#object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_3', ['SET_LAW', 'SET_MUN_LAW'])
	#character.equip('KAEMPFER_GNO_NEST_5_3', 'SET_LAW')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_3', ['SET_MG_3', 'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_5_3', 'SET_MG_3')
#
#
######################################################################################################################
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_4', ['SET_AUTOMAG_3', 'SET_AMMOPACK_7_62NATO_MM',
									'SET_MOLOTOV_COCKTAIL'])
	character.equip('KAEMPFER_GNO_NEST_5_4', 'SET_AUTOMAG_3')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_5', ['SET_M60', 'SET_AMMOPACK_7_62NATO_MM',
									'SET_AMMOPACK_7_62NATO_MM',
									'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_5_5', 'SET_M60')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_5_6', ['SET_M60', 'SET_AMMOPACK_7_62NATO_MM', 
									'SET_AMMOPACK_7_62NATO_MM',
									'SET_AMMOPACK_7_62NATO_MM'])
	character.equip('KAEMPFER_GNO_NEST_5_6', 'SET_M60')
	### NEST_5_PLUS ###
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_1',  ['SET_HK_XM8', 'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_1', 'SET_HK_XM8')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_2',  ['SET_HK_XM8', 'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_2', 'SET_HK_XM8')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_3',  ['SET_HK_XM8', 'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_3', 'SET_HK_XM8')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_4',  ['SET_GMG_OCSW', 'SET_AMMOPACK_25_MM_HE'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_4', 'SET_GMG_OCSW')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_5',  ['SET_GMG_OCSW', 'SET_AMMOPACK_25_MM_HE'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_6',  ['SET_GMG_OCSW', 'SET_AMMOPACK_25_MM_HE'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_7',  ['SET_GMG_OCSW', 'SET_AMMOPACK_25_MM_HE'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_8',  ['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_9',  ['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_10', ['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_10', 'SET_M_16')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_11', ['SET_RAILGUN', 'SET_AMMOPACK_2_5_JHP_ARROW'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_11', 'SET_RAILGUN')
	object.create_item_in_inventory('KAEMPFER_GNO_NEST_PLUS_5_12', ['SET_RAILGUN', 'SET_AMMOPACK_2_5_JHP_ARROW'])
	character.equip('KAEMPFER_GNO_NEST_PLUS_5_12', 'SET_RAILGUN')
	
## El Presidente ###############################################################
	object.create_item_in_inventory('PRESIDENT_HAYES',  ['SET_RAILGUN', 'SET_AMMOPACK_2_5_JHP_ARROW'])
	character.equip('PRESIDENT_HAYES', 'SET_RAILGUN')
	
	# Bienenst�cke Z10
	object.create_item_in_inventory( 'BUILDING_13733', equipment=[ 'SET_BEESWAX' ] )
	object.create_item_in_inventory( 'BUILDING_13732', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	object.create_item_in_inventory( 'BUILDING_13731', equipment=[ 'SET_BEESWAX' ] )
	
	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_13704', equipment=[ 'SET_COOKING_POT', 'SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', 'SET_C4_TIMEBASED' ] )
	object.create_item_in_inventory( 'BUILDING_13706', equipment=[ 'SET_SMALL_SAND_SHOVEL', 'SET_SHURIKEN', 'SET_BIG_KNIFE' ] )
	object.create_item_in_inventory( 'BUILDING_13718', equipment=[ 'SET_MEDIPACK_BIG', 'SET_MEAT_RAW_HUMONGOUS', 'SET_M46_HEAVY_ARMOR' ] )
	object.create_item_in_inventory( 'BUILDING_13721', equipment=[ 'SET_CARROT', 'SET_C4_TIMEBASED', 'SET_DART' ] )
	object.create_item_in_inventory( 'BUILDING_13723', equipment=[ 'SET_HEGRENADE', 'SET_M46_ARMORED_HELMET', 'SET_KEROSENE_CANISTER' ] )

	system.create_object(equipmenttype="SET_BICYCLE_SEAT", x=507, y=231)
	#system.create_object(equipmenttype="SET_M16_SAWED_OFF_REMINGTON_M870", x=508, y=228)
	system.create_object(equipmenttype="SET_MULTI_MEDIPACK", x=506, y=231)
	system.create_object(equipmenttype="SET_KEROSENE_CANISTER", x=501, y=236)
	system.create_object(equipmenttype="SET_WATER_CAN", x=501, y=235)
	# Fass
	# object.create_item_in_inventory(object="BUILDING_1312",equipment=["SET_AMMOPACK_45_DUMDUM"])
	system.create_object(equipmenttype="SET_SMALL_PICTURE_FRAME", x=509, y=419)
	system.create_object(equipmenttype="SET_BRASS_KNUCKLES", x=506, y=422)
	# Kommode
	object.create_item_in_inventory(object="BUILDING_13714",equipment=["SET_AMMOPACK_5_7_MM_SUBSONIC_DUMDUM"])
	# Holzfa�
	object.create_item_in_inventory(object="BUILDING_13734",equipment=["SET_AMMOPACK_4_6_MM_SUBSONIC"])
	
	
def initHerbs():
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=202.92, y=489.91)
	system.create_object(equipmenttype="SET_BURNET", x=377.08, y=424.65)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=302.53, y=300.74)
	system.create_object(equipmenttype="SET_ANGELICA", x=242.15, y=236.24)
	system.create_object(equipmenttype="SET_BURNET", x=329.34, y=248.69)
	system.create_object(equipmenttype="SET_ANGELICA", x=342.88, y=443.77)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=410.70, y=460.57)
	system.create_object(equipmenttype="SET_ANGELICA", x=449.99, y=467.25)

# erzeugen von fahrezeugen, spezialobjekten etc
def initObjects():
	system.create_object("RES3D_TRES_OBJECTS_BUILDING_TIMETRAVELLER", 460.4, 408.8, "CAR_TIMETRAVELLER",153)
	object.set_active_state('CAR_TIMETRAVELLER', False)
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.0, y1 = 0.0, x2 = 799.99, y2 = 200.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 0.0, y1 = 600.00, x2 = 799.99, y2 = 799.99 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.0, y1 = 200.00, x2 = 200.00, y2 = 600.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 600.00, y1 = 200.00, x2 = 799.99, y2 = 600.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
	for object_id in const.FIREPLACES:
		fx_lagerfeuer(object_id)
	
	for object_id in const.BURNING_TONS:
		fx_brennende_tonne(object_id)

def fx_lagerfeuer(object_id):
	system.start_effect_object(object=object_id, node="effekt_feuer", parameter=fx_fire_lagerfeuer)
	system.start_effect_object(object=object_id, node="effekt_feuer01", parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=object_id, node="effekt_feuer02", parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=object_id, node="effekt_feuer03", parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=object_id, node="effekt_feuer04", parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

def fx_brennende_tonne(object_id):
	pass
	#system.start_effect_object(object=object_id, node="sort1", parameter=fx_fire_brennende_tonne)
	#sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)
	
#*** verhindern des betretens von haeusern (zb das in dem hayes sitzt)
def can_crack_lock( character_id, object_id, dummy_name ):
	if object_id == "ZONE_10_BUILDING_8013":
		return False
	return object_events.can_crack_lock( character_id, object_id, dummy_name )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
	if object_id == "ZONE_10_BUILDING_8013":
		return False
	return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

def can_blast_lock( character_id, object_id, dummy ):
	if object_id == "ZONE_10_BUILDING_8013":
		return False
	return object_events.can_blast_lock( character_id, object_id, dummy )

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
	if object_id == "ZONE_10_BUILDING_8013":
		return False
	return on_blast_lock( character_id, object_id, dummy_name, x, y, z )
	
def can_enter_building( character_id, building_id ):
	if building_id == "ZONE_10_BUILDING_8013":
		if character_id in system.get_pcs():
			return False
	return object_events.can_enter_building( character_id, building_id )

def InitChestsSafes():
	object.add_closed_lock("BUILDING_13704", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_13706", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_13718", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_13721", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_13723", "lock1", closure_type='booby-trap')

def init_patch():
	if object.has_attribute('TIMETRAVELLER', 'zone_transfer'):
		object.set_attribute('TIMETRAVELLER', 'zone_transfer', False)

	object.set_attributes("GNO-Soldat A", dialog_face="evil09.png")
	object.set_attributes("GNO-Soldat B", dialog_face="evil09.png")
	character.update_appearance("GNO-Soldat A")
	character.update_appearance("GNO-Soldat B")
	
	if object.get_party('GNO-Soldat A') == 'GNO_KAEMPFER_5':
		object.set_immortal_state('GNO-Soldat A', False)
	
	if not data().Hayes_Cutscene_Gelaufen:
		for char in ["ANIE" ,"ABEL", "ROWLAND", "BANKS", "TIMETRAVELLER" ]:
			if char in system.get_npcs():
				object.set_active_state(char, False)
