# -*- coding: utf-8 -*-
from globals import *
import dialogs
import npc
import water
from const import *
import object_events
import schedules
import char_autogeneration
import system_events
import comments
import enemy_script

#*** act revision: Revision 54, 6.08.2004 *************************************

# äöü (better)

def initParties():
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="RATSKULLS",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(370.0, 230.0),
	 		"SOUTH":	(475.5, 752.9),	# startpunkt in die naehe von davids haus verschoben
	 		"WEST":		(226.0, 631.0),
	 		"EAST":		(902.0, 429.0),
	 	}
	return start_locations["SOUTH"]
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("yellow")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Dustville",410,375,315,270)
		system.add_region("New_Safford",610,590,690,485)
		system.add_region("Davids_Hütte",395,700,445,645)
		system.add_region("Ratskullcamp",835,830,770,885)
		system.add_region("Reporter",470,565,515,535)
		system.add_region("Trader",565,425,505,455)
	
	data("rest").non_rest_areas.append("Dustville")
	data("rest").non_rest_areas.append("New_Safford")
	data("rest").non_rest_areas.append("Davids_Hütte")
	data("rest").non_rest_areas.append("Ratskullcamp")
	data("rest").non_rest_areas.append("Reporter")
	data("rest").non_rest_areas.append("Trader")

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )

	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

	npc.initNPCS()
	npc.initAnimals()
	char_autogeneration.init_Mercenary('MERCENARY_MILTON')
	initItems()
	initHerbs()
	initExitZones()
	initScriptUseObjects()
	initWaterResources()
	initFX()
	initMinimapMarkers()

	system.add_region(data().Region_InformantHuette ,397.536,646.412,448.95,700.938)
	system.add_region(data().Region_InformantOuter ,380.33,635.234,471.294,722.382)
	system.add_region(data().Region_Village_1 ,609.692,485.78,690.692,590.806)
	system.add_region(data().Region_WolfSighted ,686.694,612.758,723.494,643.84)
	system.add_region(data().Region_Wolfback ,645.734,575.800,651.188,584.328)
	system.add_region(data().Region_Marty ,501.582,538.102,516.042,548.922)
	system.add_region(data().Region_Dorf_2_Outer ,304.974,260.272,436.162,401.69)
	system.add_region(data().Region_WolfRegion ,503.544,223.592,563.42,315.862)
	system.add_region(data().Region_SeekerGelaende ,818.376,275.986,876.918,315.862)
	system.notify_region_entered(data().Region_SeekerGelaende, partyid="UISPIELER")
	system.add_region(data().Region_Sara_Inner, 817,869,793,848)
	system.notify_region_entered(data().Region_Sara_Inner,objectid="ALTER_EGO")
	system.add_region(data().Region_Fredo, 382.0,364.0,391.0,343.0)
	system.notify_region_entered(data().Region_Fredo, partyid="UISPIELER")

	initFoeLists()
	#init_interiors()

	system.create_object("RES3D_TRES_OBJECTS_BUILDING_TIMETRAVELLER",
		370,310,"CAR_TIMETRAVELLER",270)
	system.create_object("RES3D_TRES_OBJECTS_BUILDING_TIMETRAVELLER_EXPLOSION",
		372.56,278.54,"TIMETRAVELLER_EXPLOSION")
	object.set_active_state("TIMETRAVELLER_EXPLOSION",INACTIVE)

	## rattenfleisch (demoremove)
	#system.create_object("SET_RAT_MEAT",360,290,"RAT_MEAT_1",75)
	#system.create_object("SET_RAT_MEAT",360,290,"RAT_MEAT_2",0)
	
	#object.set_position_free("RAT_MEAT_1",365.21,289.76,0.95)
	#object.set_position_free("RAT_MEAT_2",365.01,289.0,0.87)
	
	character.set_main_quest_npc_state("BEN",True)
	character.set_main_quest_npc_state("SARA",True)
	character.set_main_quest_npc_state("DAVID",True)
	character.set_main_quest_npc_state("JAY",True)

	data().QB_002 = system.register_qb_entry('ZONE2_AIM_02')
	data().QB_003 = system.register_qb_entry('ZONE2_AIM_03')
	data().QB_004 = system.register_qb_entry('ZONE2_AIM_04')
	data().QB_005 = system.register_qb_entry('ZONE2_AIM_05')
	data().QB_006 = system.register_qb_entry('ZONE2_AIM_06')
	data().QB_007 = system.register_qb_entry('ZONE2_AIM_07')
	data().QB_008 = system.register_qb_entry('ZONE2_AIM_08')
	data().QB_009 = system.register_qb_entry('ZONE2_AIM_09')
	data().QB_010 = system.register_qb_entry('ZONE2_AIM_10')
	data().QB_011 = system.register_qb_entry('ZONE2_AIM_11')
	data().QB_012 = system.register_qb_entry('ZONE2_AIM_12')
	data().QB_013 = system.register_qb_entry('ZONE2_AIM_13')
	data().QB_014 = system.register_qb_entry('ZONE2_AIM_14')
	data().QB_015 = system.register_qb_entry('ZONE2_AIM_15')
	data().QB_016 = system.register_qb_entry('ZONE2_AIM_16')
	data().QB_017 = system.register_qb_entry('ZONE2_AIM_17')
	data().QB_018 = system.register_qb_entry('ZONE2_AIM_18')
	data().QB_019 = system.register_qb_entry('ZONE2_AIM_19')
	data().QB_020 = system.register_qb_entry('ZONE2_AIM_20')
	data().QB_021 = system.register_qb_entry('ZONE2_AIM_21')
	
	#neuen Eintrag im QuestBook anzeigen

	object.set_active_state("DAVID",INACTIVE)										#Aussteiger deaktivieren

	for id in data().ratskulls_david:
		object.set_active_state(id,INACTIVE)										#Ratskullmitglied 1 deaktivieren

	for id in data().ratskulls_village:
		object.set_active_state(id,INACTIVE)

	object.set_active_state("SARA",INACTIVE)
	object.set_active_state("WOLF_VARI",INACTIVE)									#Wolf von Bobby deaktivieren
	object.set_active_state("WOLF_VARI_GIRLFRIEND",INACTIVE)						#Woelfin mit der sich Bobbys Wolf vergnuegt, hat deaktivieren

	system.notify_region_entered(data().Region_InformantOuter,partyid="UISPIELER")	#Regionsbenachrichtigung
	system.notify_region_entered(data().Region_WolfRegion,objectid="ALTER_EGO")

	system.notify_object_damage("DAVID",0.9)

	for id in data().ratskulls_camp:
		object.set_active_state(id,INACTIVE)

	character.set_approachable_state("BEN",APPROACHABLE)           	#Anfueher des Dorfes ist ansprechbar
	character.set_approachable_state("BOBBY",APPROACHABLE)        	#Bobby ist sofort ansprechbar
	character.set_approachable_state("REPORTER",APPROACHABLE)      	#Reporter ansprechbar
	character.set_approachable_state("TIMETRAVELLER",APPROACHABLE) 	#Zeitreisender ansprechbar
	character.set_approachable_state("RATMEAT_TRADER",APPROACHABLE) 	#Rattenfleischverkaeufer ansprechbar
	character.set_approachable_state("JAY",APPROACHABLE)           	#Sohn des Anfuehrers
	character.set_approachable_state("DAVID",NOTAPPROACHABLE)			#David der Aussteiger
	character.set_approachable_state("SARA",NOTAPPROACHABLE)

	system.add_region(data().Region_Sara,854,906,744,784)
	system.add_region(data().Region_Gehaengter,644,550,628,566)
	system.notify_region_entered(data().Region_Gehaengter,objectid="RATSKULL_011")
	system.notify_region_entered(data().Region_Gehaengter,objectid="RATSKULL_012")
	system.notify_region_entered(data().Region_Gehaengter,objectid="RATSKULL_013")
	system.notify_region_entered(data().Region_Gehaengter,objectid="RATSKULL_014")

	system.add_region(data().Region_Gehaengter_Spieler,644,550,628,566)
	system.notify_region_entered(data().Region_Gehaengter_Spieler,objectid="ALTER_EGO")
	system.add_region(data().Region_WolfComment,500,286,448,334)
	system.notify_region_entered(data().Region_WolfComment,objectid="ALTER_EGO")
	sounds.load_sound(sfx_id='wolf_2')
	sounds.load_sound(sfx_id='wolf_3')
	system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	system.create_object("RES3D_TRES_OBJECTS_BUILDING_WALDHAUS_SPRENGUNG",
		object.get_x("BUILDING_181"),
		object.get_y("BUILDING_181"),
		"BUILDING_DAVID_SPRENGUNG",object.get_direction("BUILDING_181"))
	object.set_active_state("BUILDING_DAVID_SPRENGUNG",INACTIVE)
	system.create_object("RES3D_ERHAENGETER_SPRENGUNG",
		object.get_x(data().Obj_RatskullCorpse),
		object.get_y(data().Obj_RatskullCorpse),
		"BUILDING_ERHAENGETER_SPRENGUNG",object.get_direction(data().Obj_RatskullCorpse))
	object.set_active_state("BUILDING_ERHAENGETER_SPRENGUNG",INACTIVE)
	schedules.init_schedules() ## immer nach dem initQuestbook()
	get_combat_ready()
	init_non_rest_areas()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_main_npcs()

def init_scriptuse_objects():
	
	# truhen, kisten, tresore
	system.mark_for_script_use("BUILDING_7832")
	system.mark_for_script_use("MAPS_BUILDING_7691")
	system.mark_for_script_use("MAPS_BUILDING_7685")
	system.mark_for_script_use("BUILDING_13001")
	system.mark_for_script_use("BUILDING_12995")

	system.mark_for_script_use("BUILDING_18774")
	system.mark_for_script_use("BUILDING_18775")
	system.mark_for_script_use("BUILDING_18776")
	system.mark_for_script_use("BUILDING_18803")
	system.mark_for_script_use("BUILDING_7628")
	system.mark_for_script_use("BUILDING_18807")
	system.mark_for_script_use("MAPS_BUILDING_7758")
	system.mark_for_script_use("BUILDING_18811")
	system.mark_for_script_use("BUILDING_18812")
	
	# Bienenstöcke Zone 2
	system.mark_for_script_use('BUILDING_18944')
	system.mark_for_script_use('BUILDING_18943')

	
	# sonstiges
	system.mark_for_script_use("BUILDING_328")
	system.mark_for_script_use("BUILDING_181")
	system.mark_for_script_use("BUILDING_DAVID_SPRENGUNG")
	system.mark_for_script_use("BUILDING_ERHAENGETER_SPRENGUNG")
	system.mark_for_script_use(data().Obj_RatskullCorpse)
	
		
	animate_gehaengter()

def animate_gehaengter(obj=None):
	pass
	## todo: animation gehängter spielt nicht richtig ab
	#if not data().erhaengter_explode:
	#	object.play_animation(data().Obj_RatskullCorpse,"ANIM_ERHAENGTER_BAUMELT", callback=["ONEND",animate_gehaengter])

# setzt chars mortal bzw immortal
def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		object.set_immortal_state(npc, False)
		if npc not in data().ratskulls_david + data().ratskulls_camp + data().ratskulls_village:
			if not npc in ["DAVID", 'MERCENARY_MILTON']:
				object.set_immortal_state(npc, True)
	check_bobby_crying()

# mark objects that are used in script
def initScriptUseObjects():
	#bonfires - for cooking
	system.mark_for_script_use('BUILDING_3867')
	system.mark_for_script_use('BUILDING_3927')
	system.mark_for_script_use('BUILDING_3379')

# makes char become combat ready, equips a weapon
def get_combat_ready():
	pcs = system.get_pcs()
	for pc in pcs:
		equip_weapon(pc)

#makes char_id equip a weapon if one is found
def equip_weapon(char_id):
	inventory = object.get_inventory_ids(char_id)
	weapon = get_unequiped_weapons(char_id, inventory)
	# print ">>> check the weapon shit",char_id, weapon
	if isinstance (weapon, list):
		equip_a_weapon(char_id, weapon)
	
#checks if chars has a weapon, 
#  returns False if weapon is equiped
#  returns list of weapons if none equiped
def get_unequiped_weapons(char_id, inventory):
	import character
	weapons = []
	for item in inventory:
		if len(item[0]):
			item_type = item[0][0]
			if object.has_attribute(item_type, "weapon_type"):
				if character.is_equiped(char=char_id, equipment=item_type):
					return False
				weapons.append(item_type)
	return weapons

# equips the first item, if list of items delivered
def equip_a_weapon(char_id, item):
	import character
	if item:
		if len(item) and isinstance(item, list):
			character.equip(char_id, item[0])

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()
	
	check_reporter_state()
	
def check_reporter_state():
	if not data().reporter_in_zone_7:
		if system.get_qb_entry_state(data().QB_007) == COMPLETE:
			data().reporter_in_zone_7 = True
			object.set_position_free("REPORTER", 515.67, 224.75,0,grid="landscape",zone="zone_7.zone_7")

def on_sound_end(name):
	pass

def route_leave_village(id):
	if not object.is_destroyed(id):
		if ((id == "VILLAGE1_KIRK") and (get_location(id) == 4)):
			object.step_to(id, 648.32, 528.22)
		dialogs.RoutedMoveTo(id=id,route=ROUTE_DORFBEWOHNER_FLUCHT,speed=MT_FAST)
		if id in VILLAGE1_G4:
			dialogs.RoutedMoveTo(id=id,route=ROUTE_DORFBEWOHNER_OBERHAEUPTER_FLUCHT,speed=MT_FAST)

def stop_sound_bobby_cry():
	if object.has_attribute("BOBBY", "playing_sound"):
		object.set_attribute("BOBBY", "playing_sound", None)
		sounds.stop_sound(id="BOBBY_CRYING")

def start_sound_bobby_cry():
	if not object.has_attribute("BOBBY", "playing_sound"):
		object.set_attribute("BOBBY", "playing_sound", "BOBBY_CRYING")
		sounds.play_3d_sound_object(sfx_id="crying_female",object="BOBBY", loop=True, identifier="BOBBY_CRYING")
	
def check_bobby_crying():
	if not object.is_destroyed("BOBBY"):
		if system.get_qb_entry_state(data().QB_006) == INACTIVE:
			if data().DorfGerettet == -1 or data().DorfGerettet >= 1:
				if sounds.is_sound_playing('BOBBY_CRYING'):
					stop_sound_bobby_cry()
				enemy_script.delay(1, Lambda('start_sound_bobby_cry()'))
				system.notify_timer(data().Timer_BobbyCry, 20000)
			else:
				stop_sound_bobby_cry()
				system.notify_timer(data().Timer_BobbyCry, 20000)
		else:
			stop_sound_bobby_cry()
			system.notify_timer(data().Timer_BobbyCry, 20000)
	else:
		stop_sound_bobby_cry()

def on_timer(id):
	if id == data().Timer_BobbyCry:
		check_bobby_crying()
	
	if id == data().Timer_ScheduleDelay:
		data().ta_delay_after_village_assault = False
	
	if id == data().Timer_Delay:
		if data().delay_reason == "david_got_hit":
			sounds.play_3d_sound_object(sfx_id="hit_pain",object="DAVID",loop=False)
		if data().delay_reason == "dead_body_drops_down":
			sounds.play_3d_sound_object(sfx_id="body_bounce",object="BUILDING_ERHAENGETER_SPRENGUNG",loop=False)
			
		data().delay_reason = None
	
	if id == data().Timer_GroupedRouteLeaveVillage:
		if data().counter_groupedroutevillage == 0:
			data().counter_groupedroutevillage += 1
			for id in VILLAGE1_G1:
				route_leave_village(id)
			system.notify_timer(data().Timer_GroupedRouteLeaveVillage,data().Timervalue_GroupedRouteLeaveVillage)
			return
		elif data().counter_groupedroutevillage == 1:
			data().counter_groupedroutevillage += 1
			for id in VILLAGE1_G2:
				route_leave_village(id)
			system.notify_timer(data().Timer_GroupedRouteLeaveVillage,data().Timervalue_GroupedRouteLeaveVillage)
			return
		elif data().counter_groupedroutevillage == 2:
			data().counter_groupedroutevillage += 1
			for id in VILLAGE1_G3:
				route_leave_village(id)
			system.notify_timer(data().Timer_GroupedRouteLeaveVillage,data().Timervalue_GroupedRouteLeaveVillage)
			return
		elif data().counter_groupedroutevillage == 3:
			data().counter_groupedroutevillage += 1
			for id in VILLAGE1_G5:
				route_leave_village(id)
			system.notify_timer(data().Timer_GroupedRouteLeaveVillage,data().Timervalue_GroupedRouteLeaveVillage)
			return
		else:
			for id in VILLAGE1_G4:
				route_leave_village(id)
			return
				
	if id == data().Timer_DavidAutsch:
		dialogs.onDlg_003_RatskullsBelauschenSchlagAbfangen()
	
	if id == data().Timer_CommentWait:
		if (not dialog.is_dialog_active() and not system.is_cutscene()):
			if data().counter_comment_wait == 1:
				dialogs.initCutscene_Dlg_044_RatskullsTrauern()
			elif data().counter_comment_wait == 3:
				dialogs.initCutscene_Dlg_060_DorfbewohnerNichtGefunden()
			else:
				system.notify_timer(data().Timer_CommentWait, data().Timervalue_CommentWait)
			data().counter_comment_wait = 0
		else:
			system.notify_timer(data().Timer_CommentWait, data().Timervalue_CommentWait)

	# kamerawechsel rattenfleischquest
	if id == data().Timer_WolvesCamSwitch:
		system.set_camera_view(data().CamView_WoelfeGeheimeZutat)
	
	if id == data().Timer_MainquestKommentar:
		if not dialog.is_dialog_active() and not system.is_cutscene():
			dialogs.initDlg_089_SpielerUeberlegtOption()
		else:
			system.notify_timer(data().Timer_MainquestKommentar,data().Timervalue_MainquestKommentar)

	if id == data().Timer_TT_D_088_Kommentar:
		if not dialog.is_dialog_active() and not system.is_cutscene():
			dialogs.initDlg_088_SpielerKommentiertTT()
		else:
			system.notify_timer(data().Timer_TT_D_088_Kommentar,data().Timervalue_TT_D_088_Kommentar)

	if id == data().Timer_DoerflerRueckkehr:
		data().BenDorfPlatz = -1

	if id == data().Timer_Fredo:
		if (object.get_distance("ALTER_EGO","FREDO") <=15.0):
			if not data().Fredo_angesprochen:
				if (not dialog.is_dialog_active()):
					dialogs.initDlg_080_FredoAutoDialog()
					if not random.randint(0,10):
						sounds.play_3d_sound_object(sfx_id="whistling",object="FREDO")
		else:
			system.notify_timer(data().Timer_Fredo,data().Timervalue_Fredo)
			if get_activity("FREDO") == WORK_FORBIDDEN:
				allow_activity("FREDO")

	if id==data().Timer_RatskullsRueckkehrDorf:
		RatskullsRueckkehrDorf()

	if id==data().Timer_RatskullsSichernDorf:
		RatSkullsSichernDorf()

	if id==data().Timer_WolfRueckkehr:
		if not object.is_destroyed("WOLF_VARI"):
			WolfRueckkehrDorf()

	if (id==data().Timer_RatskullsHolzstapel and
		not data().SpielerEntdeckt):
		if not data().RatSkullKilledDorf:
			if ((not system.is_cutscene()) and (not dialog.is_dialog_active())):
				dialogs.initCutscene_Dlg_060_DorfbewohnerNichtGefunden()
			else:
				data().counter_comment_wait = 3
				system.notify_timer(data().Timer_CommentWait, data().Timervalue_CommentWait)
		else:
			dialogs.onStartSucheHolzstapelRennenLos()

	if id==data().Timer_RatskullsBelauschen:
		dialogs.initCutscene_Dlg_003_RatskullsBelauschen()

	if id==data().Timer_BenGibtAlarm:
		character.play_animation("BEN", "CM_NPC_STEHEN_HORN_BLASEN", callback=["ONEND", ben_and_villagers_flee])

	if (id==data().Timer_RatskullDorfbewohnerSuchen and
		data().SpielerEntdeckt==False):
		StartSucheDorfBewohner()

	if id==data().Timer_David and not object.is_destroyed("DAVID"):
		if not object.is_destroyed("RATSKULL_SQUAD_LEADER"):        #die Ratskullmitglieder selber noch am Leben sind
			object.cancel_commandos("RATSKULL_SQUAD_LEADER")
			object.attack("RATSKULL_SQUAD_LEADER","DAVID")
		elif not object.is_destroyed("RATSKULL_002"):
			object.cancel_commandos("RATSKULL_002")
			object.attack("RATSKULL_002","DAVID")
		elif not object.is_destroyed("RATSKULL_017"):
			object.cancel_commandos("RATSKULL_017")
			object.attack("RATSKULL_017","DAVID")

	if id==data().Timer_TimeTravellerTimeJump:
		dialogs.initDlg_039_TimeTravellerZeitsprung()

	if id==data().Timer_DorfAngriff:
		if not data().DorfangriffGestartet:
			StartDorfAngriff()

	if (id == data().Timer_DorfAngriffShorter):
		if not data().DorfangriffGestartet:
			StartDorfAngriff()

	if id==data().Timer_Schlagzeilen:
		# print ">>> schlagzeilen timer"
		PruefeSchlagzeilenKommentare()

	if id==data().Timer_BenFlucht:
		FluchtDorfbewohner()

 	if id==data().Timer_CS_TimeTraveller:
 		dialogs.onCS_GetIn()

 	if id==data().Timer_CS_TimeTraveller_FadeOut:
 		dialogs.CS_TimeTraveller_FadeOut()

 	if id==data().Timer_Ratskulls_Tor:
 		if (not object.is_destroyed("RATSKULL_015") and
 			not object.is_destroyed("RATSKULL_005") and
 			data().DorfGerettet==0 and
 			data().RatSkullsGehaengter<=4
			and (object.get_distance("RATSKULL_015", data().Obj_RatskullCorpse) < 34.0)
			and (object.get_distance("RATSKULL_015", data().Obj_RatskullCorpse) < 34.0)):
			object.cancel_commandos("RATSKULL_015")
			object.cancel_commandos("RATSKULL_005")
 			dialogs.initCutscene_Dlg_045_Wachenverwundert()

 	if id==data().Timer_CS_TimeTraveller_End:
 		dialogs.onCS_TimeTraveller_End()

	## Zeitauslöser, triggert jede Stunde
	if (id==data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			npc.spawnAnimals(INACTIVE)
		else:
			npc.spawnAnimals(ACTIVE)

# ben alarmiert die dorfbewohner, und diese fliehen dann
def ben_and_villagers_flee(char_id):
	system.notify_timer(data().Timer_BenFlucht,data().Timervalue_BenFlucht)
	DorfbewohnerZuBen()
	object.step_away("BEN")

def on_enter_region(id, objectid, partyid):
	print "[on_enter_region(",id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if (id == data().Region_SeekerGelaende):
		if not data().player_knows_Fabrikgelaende:
			data().player_knows_Fabrikgelaende = True
			system.add_minimap_marker(845.17, 329.47,"MM_005")# Verlassenes Fabrikgelände
	
	
	if (id == data().Region_Fredo):
		if (not dialog.is_dialog_active()):
			sounds.play_3d_sound_object(sfx_id="whistling",object="FREDO")
			dialogs.initDlg_080_FredoAutoDialog()
		#system.notify_region_entered(data().Region_Fredo, partyid = "UISPIELER")

	if (id==data().Region_Gehaengter_Spieler and
		data().BenHinweisSprengstoff==-1 and 		#Kommentar nur anzeigen wenn der Spieler noch nicht mit Ben ueber den
		data().DorfGerettet<1):						#Gehaengten gesprochen hat
		dialogs.initCutscene_Dlg_043_KommentarGehaengter()

	if (id==data().Region_WolfComment):
		print "[TEST]wcomment-region"

	if (id==data().Region_WolfComment and
		data().WoelfeKilled==0):
		if data().Rattenfleisch==0:
			dialogs.initCutscene_Dlg_062_WoelfeGesehen()
		elif data().Rattenfleisch==-1:
			#system.notify_region_entered(region=data().Region_WolfComment,objectid="ALTER_EGO")
			enemy_script.delay(5.0, Lambda('system.notify_region_entered(region=data().Region_WolfComment,objectid="ALTER_EGO")'))
			
	if (id==data().Region_Gehaengter and
		not data().SpielerEntdeckt and
		data().DorfGerettet==0 and
		(objectid in ["RATSKULL_011","RATSKULL_012","RATSKULL_013","RATSKULL_014"])):
		if not object.is_destroyed(objectid):
			if objectid == "RATSKULL_011":
				object.move_to("RATSKULL_011",636.5,557.4,"landscape",MT_SLOW)
				object.turn_to_object(objectid,"BUILDING_3750", callback=["ONEND", onRatsMoveHungFriendCheckAllArrived])
			elif objectid=="RATSKULL_012":
				object.move_to("RATSKULL_012",635.7,558.1,"landscape",MT_SLOW)
				object.turn_to_object(objectid,"BUILDING_3750", callback=["ONEND", onRatsMoveHungFriendCheckAllArrived])
			elif objectid=="RATSKULL_013":
				object.move_to("RATSKULL_013",637.4,558.4,"landscape",MT_SLOW)
				object.turn_to_object(objectid,"BUILDING_3750", callback=["ONEND", onRatsMoveHungFriendCheckAllArrived])
			elif objectid=="RATSKULL_014":
				object.move_to("RATSKULL_014",636.4,559.5,"landscape",MT_SLOW)
				object.turn_to_object(objectid,"BUILDING_3750", callback=["ONEND", onRatsMoveHungFriendCheckAllArrived])

	if id == data().Region_InformantOuter:
		for id in system.get_pcs():
			object.cancel_commandos(id)
		dialogs.initCutscene_Dlg_001_HuetteEntdeckt()

	if id == data().Region_InformantHuette:
		#for id in system.get_pcs():
		#	object.cancel_commandos(id)
		"""
		## fuer den fix von bug 10791
		object.set_position_free("RATSKULL_SQUAD_LEADER",434.16, 670.32, 0)
		object.set_position_free("DAVID",434.79, 670.01, 0)
		"""
		object.set_active_state("DAVID",ACTIVE)								#Aussteiger aktivieren
		object.set_active_state("RATSKULL_SQUAD_LEADER",ACTIVE)				#Ratskullmitglied 1 aktivieren
		object.set_active_state("RATSKULL_002",ACTIVE)						#Ratskullmitglied 2 aktivieren
		object.set_active_state("RATSKULL_017",ACTIVE)
		object.turn_to_object("RATSKULL_SQUAD_LEADER","DAVID")
		object.turn_to_object("RATSKULL_002","DAVID")
		object.turn_to_object("RATSKULL_017","DAVID")
		object.turn_to_object('DAVID', "RATSKULL_SQUAD_LEADER")
		dialogs.initCutscene_Dlg_002_RatskullsEntdeckt()

	if id == data().Region_WolfSighted:
		#prüfen, ob dorfangriff noch läuft, wenn nicht, wolfrettung moeglich
		if system.get_qb_entry_state(data().QB_003) in [INACTIVE,COMPLETE]:
			if (data().WolfGerettet==0 and
				not data().WolfEntdeckt and
				not object.is_destroyed("WOLF_VARI")):
				object.set_active_state("WOLF_VARI",ACTIVE)										#Bobbys Wolf aktivieren
				object.set_active_state("WOLF_VARI_GIRLFRIEND",ACTIVE)							#weibliche Begleitung aktivieren
				#x = object.get_position("WOLF_VARI")[0]
				#y = object.get_position("WOLF_VARI")[1]
				#object.move_to("WOLF_VARI",x,y, speed=globals.MT_NORMAL)
				dialogs.initCutscene_023_WolfEntdeckt()
				system.add_region(data().Region_WolfMeat,710,628,714,634)				#neue Region erzeugen in der sich der Spieler mit dem
				system.notify_region_entered(data().Region_WolfMeat,objectid="ALTER_EGO")	#Rattenfleisch befinden muss
				data().WolfEntdeckt = True
				object.move_to("WOLF_VARI_GIRLFRIEND", 726, 757, speed=MT_FAST, grid="landscape")						#seine weibliche Begleitung ergreift die Flucht wenn der Spieler
		else:
			system.notify_region_entered(data().Region_WolfSighted,"ALTER_EGO")
			#die Region betritt
			#ronny todo: vari's freundin ist nicht mehr feindlich
			#object.set_attribute("WOLF_VARI_GIRLFRIEND", attribute="foes", ["UISPIELER"])

	if id == data().Region_Marty:
		if not data().MartyPlixKompensator:
			if not data().Marty_Schlaeft:
				dialogs.CS_Marty()
			else:
				system.notify_region_entered(data().Region_Marty,objectid="ALTER_EGO")

	if id == data().Region_Sara:
		if data().TochterAussteigerGerettet==0:
			dialogs.SaraStartRettung(objectid)

	if id == data().Region_Sara_Inner:
		if object.is_destroyed("SARA"):
			dialogs.initCutscene_063_DorfbewohnerTotSaraQuestNichtAngenommen()

def onRatsMoveHungFriendCheckAllArrived(char_id):
	data().RatSkullsGehaengter+=1
	if (data().RatSkullsGehaengter==4 and data().DorfGerettet==0):
		for id in ["RATSKULL_011","RATSKULL_012","RATSKULL_013","RATSKULL_014"]:
			if object.is_destroyed(id):
				system.notify_timer(data().Timer_RatskullDorfbewohnerSuchen,data().Timervalue_RatskullDorfbewohnerSuchen)
				# print ">>> einer der ratskulls am gehaengten ist tot!"
				return
		data().RatSkullsGehaengter = -1
		if not data().SpielerEntdeckt:
			if not dialog.is_dialog_active() and not system.is_cutscene():
				dialogs.initCutscene_Dlg_044_RatskullsTrauern()
			else:
				data().counter_comment_wait = 1
				system.notify_timer(data().Timer_CommentWait, data().Timervalue_CommentWait)

def initItems():
	object.create_item_in_inventory("BUILDING_5310", ["SET_ORDINARY_HELMET"] ) # Holzstapel bei David
	object.create_item_in_inventory("BUILDING_4097", ["SET_NORMAL_CLOTHES_6"] ) # Wäscheleine bei David
	object.create_item_in_inventory("BUILDING_3866", ["SET_AMMOPACK_357"] ) # Hundehütte im Dorf (das angegriffen wird)
	object.create_item_in_inventory("BUILDING_67", ["SET_MEAT_COOKED_SMALL"] ) # Fass im Dorf (das angegriffen wird)
	object.create_item_in_inventory("BUILDING_916", ["SET_LEATHER_CLOTHES"] ) # Holzstapel im Dorf (das angegriffen wird)
	object.create_item_in_inventory("BUILDING_3886", ["SET_AMMOPACK_357"] ) # Müllcontainer im Dorf (das angegriffen wird)
	object.create_item_in_inventory("BUILDING_3911", ["SET_AMMOPACK_7_62SOVJET_MM"] ) # Müllsäcke beim Reporter
	object.create_item_in_inventory("BUILDING_1096", ["SET_AMMOPACK_7_62SOVJET_MM"] ) # Palette im Dorf 2 ???
	object.create_item_in_inventory("BUILDING_3934", ["SET_AMMOPACK_7_62SOVJET_MM"] ) # Wäscheleine im Dorf 2
	object.create_item_in_inventory("BUILDING_4730", ["SET_AMMOPACK_357"] ) # Kiste außerhalb Dorf (das angegriffen wird)
	object.create_item_in_inventory("BUILDING_4726", ["SET_FRAGGRENADE"] ) # Autoreifen außerhalb Dorf (das angegriffen wird)
	# Holzstapel ausserhalb Dorf (das angegriffen wird)
	object.create_item_in_inventory("BUILDING_3972", ["SET_STUNGRENADE", "SET_LONG_LEATHER_STRAP"] )
	object.create_item_in_inventory("BUILDING_454", ["SET_FRAGGRENADE"] ) # Schrottsammler (Schrottauto)
	object.create_item_in_inventory("BUILDING_157", ["SET_WATER_SKIN"] )# Schrottsammler (Faß)
	system.create_object(equipmenttype="SET_MEDIPACK_SMALL",x=510.37,y=684.51,direction=47) # Auf der Brücke

	### NEU ###
	system.create_object(equipmenttype="SET_DUCT_TAPE",x=676.95,y=503.39,direction=47) # beim Schrottauto in New Safford
	system.create_object(equipmenttype="SET_MEDIPACK_SMALL",x=622.24, y=549.12,direction=47) # links neben Dorfeingang(innen)
	object.create_item_in_inventory("BUILDING_3949", ["SET_MEAT_RAW_SMALL"] ) # Hundehuette in New Safford
#	object.create_item_in_inventory("BUILDING_13072", "SET_AXE") # Kistenstapel in Scheune
	object.create_item_in_inventory("BUILDING_358", ["SET_AXE"] ) # Kiste bei David
	object.create_item_in_inventory("BUILDING_4098", ["SET_WALTER_PPK"] ) # Blumentopf bei David
	system.create_object(equipmenttype="SET_DUCT_TAPE",x=405.66, y=354.03,direction=85) # Ruine in Dustville
	# Haus des Reporters
	system.create_object(equipmenttype="SET_DUCT_TAPE",x=494.11, y=551.91,direction=85)
	object.create_item_in_inventory("MAPS_BUILDING_7690", ["SET_DUCT_TAPE"] )
	# Haus in Dustville neben Ami-Bus
	system.create_object(equipmenttype="SET_EMPTY_BOTTLE", x=366.14, y=348.62, direction=185)
	object.create_item_in_inventory("BUILDING_12997", ["SET_DART"] )
	object.create_item_in_inventory("BUILDING_18822", ["SET_POWER_DRILL","SET_DUCT_TAPE"]) # in Kiste in Scheune in Dustville
	object.create_item_in_inventory("BUILDING_3923", ["SET_AMMOPACK_7_62SOVJET_MM"]*3) # in Kiste bei Schrotthaendler
	object.create_item_in_inventory("THE FALL_BUILDING_5409", ["SET_DUCT_TAPE"] ) # in Kiste bei Schrotthaendler
	# Ruine vor New Safford
	system.create_object(equipmenttype="SET_BROKEN_SHOVEL",x=612.32, y=541.45,direction=85)	#SET_HAIR_DRYER
	# neu Ende #
	#Belohnung beim alten Fabrikgelaende
	#laut Design 2 Handgranaten/Callico/Anaconda/ammopack_44/ammopack_9mm
	system.create_object(equipmenttype="SET_CALICO_M950",	x=849.20, y=306.01, direction=7)
	system.create_object(equipmenttype="SET_COLT_ANACONDA",	x=851.69, y=305.33, direction=17)
	system.create_object(equipmenttype="SET_AMMOPACK_44",	x=846.75, y=354.02, direction=20)
	system.create_object(equipmenttype="SET_AMMOPACK_9_MM",	x=847.00, y=354.50, direction=47)
	system.create_object(equipmenttype="SET_HEGRENADE",		x=861.29, y=349.25, id="OldGrenade1", direction=47)
	object.set_attribute("OldGrenade1", "quality", 23)
	system.create_object(equipmenttype="SET_HEGRENADE",		x=861.70, y=349.70, id="OldGrenade2", direction=47)
	object.set_attribute("OldGrenade2", "quality", 42)

	object.create_item_in_inventory("BUILDING_3354", ["SET_WALTER_PPK"] ) # Ratskull Lager
	object.create_item_in_inventory("BUILDING_3382", ["SET_AMMOPACK_7_65_MM"] ) # Ratskull Lager
	#Ratskull Lager
	#ronny todo: alternative zum rattenfleisch fuer die demo aktiviert, damit niemand
	#auf die idee kommt damit den wolf zu locken, muss nach der demo geklaert werden
	object.create_item_in_inventory("BUILDING_3386", ["SET_MEAT_RAW_TINY"] + ["SET_WATER_SKIN"]*2 )
	object.create_item_in_inventory("BUILDING_3958", ["SET_NORMAL_CLOTHES_1"] ) # Ratskull Lager
# Items in Kisten
	object.create_item_in_inventory('BUILDING_18774', [ 'SET_OINTMANT_JAR', 'SET_AK_74', 'SET_AMMOPACK_45' ] )
	object.create_item_in_inventory('BUILDING_18775', [ 'SET_AMMOPACK_9_MM', 'SET_LEATHER_CLOTHES', 'SET_ORDINARY_HELMET' ] )
	object.create_item_in_inventory('BUILDING_18776', [ 'SET_MEAT_RAW_SMALL', 'SET_GARLIC_PRESS', 'SET_BELT' ] )
	object.create_item_in_inventory('BUILDING_18803', [ 'SET_HACKSAW', 'SET_DESERT_EAGLE', 'SET_C4_REMOTE_CONTROL' ] )
	object.create_item_in_inventory('BUILDING_7628', [ 'SET_SHURIKEN', 'SET_MACHETE', 'SET_AMMOPACK_38' ] )
	object.create_item_in_inventory('BUILDING_18807', [ 'SET_BULLET_CATCH' ] )
	object.create_item_in_inventory( 'MAPS_BUILDING_7758', [ 'SET_BROKEN_SHOVEL', 'SET_HK_USP_45', 'SET_DART' ] )
	object.create_item_in_inventory('BUILDING_18811', [ 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_357' ] )
	object.create_item_in_inventory('BUILDING_18812', [ 'SET_BULLET_CATCH', 'SET_WATER_SKIN', 'SET_MEDIPACK_SMALL' ] )

 	object.create_item_in_inventory('BUILDING_18944', [ 'SET_BEESWAX' ] )
	object.create_item_in_inventory('BUILDING_18943', [ 'SET_BEESWAX', 'SET_BEESWAX' ] )

	object.create_item_in_inventory("RATSKULL_006", "SET_TATTERED_NOTE", id=data().Obj_TatteredNote )
	object.set_attribute(object=data().Obj_TatteredNote, attribute="generic_item", value=False)

# Ratskulls Bewaffnung
	object.create_item_in_inventory("RATSKULL_SQUAD_LEADER", ["SET_WALTER_PPK", "SET_AMMOPACK_7_65_MM", "SET_AMMOPACK_7_65_MM"] )
	object.create_item_in_inventory("RATSKULL_002", ["SET_SPECIAL_38", "SET_AMMOPACK_38", "SET_AMMOPACK_38"] )
	object.create_item_in_inventory("RATSKULL_017", ["SET_SPECIAL_38", "SET_AMMOPACK_38", "SET_AMMOPACK_38"] )

	object.create_item_in_inventory("RATSKULL_003", ["SET_SIG_SAUER", "SET_AMMOPACK_357"] )
	object.create_item_in_inventory("RATSKULL_004", ["SET_COLT_ANACONDA", "SET_AMMOPACK_44", "SET_AMMOPACK_44"] )
	object.create_item_in_inventory("RATSKULL_005", ["SET_WALTER_PPK", "SET_AMMOPACK_7_65_MM"] )
	object.create_item_in_inventory("RATSKULL_006", ["SET_SIG_SAUER", "SET_AMMOPACK_357"] )

	object.create_item_in_inventory("RATSKULL_007", ["SET_COLT_ANACONDA", "SET_AMMOPACK_44"] )
	object.create_item_in_inventory("RATSKULL_010", ["SET_COLT_ANACONDA", "SET_AMMOPACK_44", "SET_AMMOPACK_44"] )
	object.create_item_in_inventory("RATSKULL_011", ["SET_WALTER_PPK", "SET_AMMOPACK_7_65_MM"] )
	object.create_item_in_inventory("RATSKULL_012", ["SET_AUTOMAG_3", "SET_AMMOPACK_7_62NATO_MM", "SET_AMMOPACK_7_62NATO_MM"] )
	object.create_item_in_inventory("RATSKULL_013", ["SET_MICRO_UZI", "SET_AMMOPACK_9_MM"] )
	object.create_item_in_inventory("RATSKULL_014", ["SET_MICRO_UZI", "SET_AMMOPACK_9_MM", "SET_AMMOPACK_9_MM"] )
	object.create_item_in_inventory("RATSKULL_015", ["SET_AUTOMAG_3", "SET_AMMOPACK_7_62NATO_MM"] )
	object.create_item_in_inventory("RATSKULL_016", ["SET_SPECIAL_38", "SET_AMMOPACK_38"] )
	#character.equip( "RATSKULL_SQUAD_LEADER", equipment="SET_WALTER_PPK" )
	character.equip_direct( "RATSKULL_002", equipment="SET_SPECIAL_38" )
	character.equip_direct( "RATSKULL_003", equipment="SET_SIG_SAUER" )
	character.equip_direct( "RATSKULL_004", equipment="SET_COLT_ANACONDA" )
	character.equip_direct( "RATSKULL_005", equipment="SET_WALTER_PPK" )
	character.equip_direct( "RATSKULL_006", equipment="SET_SIG_SAUER" )
	character.equip_direct( "RATSKULL_007", equipment="SET_COLT_ANACONDA" )
	character.equip_direct( "RATSKULL_010", equipment="SET_COLT_ANACONDA" )
	character.equip_direct( "RATSKULL_011", equipment="SET_WALTER_PPK" )
	character.equip_direct( "RATSKULL_012", equipment="SET_AUTOMAG_3" )
	character.equip_direct( "RATSKULL_013", equipment="SET_MICRO_UZI" )
	character.equip_direct( "RATSKULL_014", equipment="SET_MICRO_UZI" )
	character.equip_direct( "RATSKULL_015", equipment="SET_AUTOMAG_3" )
	character.equip_direct( "RATSKULL_016", equipment="SET_SPECIAL_38" )
	character.equip_direct( "RATSKULL_017", equipment="SET_SPECIAL_38" )

	## TA-NPC Items und Nebenquest-NPC Items
	object.create_item_in_inventory("VILLAGE1_KIRK",   ["SET_AMMOPACK_7_62SOVJET_MM"])
	object.create_item_in_inventory("VILLAGE1_JEROD",  ["SET_LEATHER_BOOTS"])
	object.create_item_in_inventory("VILLAGE1_RAPHAEL",["SET_AMMOPACK_7_62SOVJET_MM"])
	object.create_item_in_inventory("VILLAGE1_BUTCH",  ["SET_AMMOPACK_7_62SOVJET_MM"])
	object.create_item_in_inventory("VILLAGE1_RANDY",  ["SET_LEATHER_CLOTHES", "SET_AMMOPACK_7_65_MM"])
	object.create_item_in_inventory("VILLAGE1_RICK",   ["SET_LEATHER_BOOTS"])
	object.create_item_in_inventory("VILLAGE1_STELLA", ["SET_BULLET_CATCH"])
	object.create_item_in_inventory("VILLAGE1_NICOLE", ["SET_LEATHER_BOOTS","SET_BULLET_CATCH"])
	object.create_item_in_inventory("VILLAGE1_LIONEL", ["SET_NORMAL_CLOTHES_5"])

	object.create_item_in_inventory("VILLAGE2_PETE",   ["SET_LEATHER_GLOVES"])
	object.create_item_in_inventory("VILLAGE2_LUKE",   ["SET_NORMAL_CLOTHES_2"])
	object.create_item_in_inventory("VILLAGE2_DOLORES",["SET_HAIR_SPRAY"])
	object.create_item_in_inventory("VILLAGE2_MANDY",  ["SET_LOW_SHOES"])
	object.create_item_in_inventory("VILLAGE2_SAMMY",  ["SET_PITCHER","SET_LEATHER_CAP"])
	object.create_item_in_inventory("VILLAGE2_CARL",   ["SET_AMMOPACK_7_62SOVJET_MM"])
	object.create_item_in_inventory("VILLAGE2_ELVIRA", ["SET_NORMAL_CLOTHES_6"])

	object.create_item_in_inventory("BOBBY",           ["SET_OINTMANT_JAR"])
	object.create_item_in_inventory("REPORTER",        ["SET_LEATHER_CAP"])
	object.create_item_in_inventory("MARTY",           ["SET_AK_47"])
	object.create_item_in_inventory("RATMEAT_TRADER",  ["SET_RAT_FUR_JACKET", "SET_RAT_MEAT"])
	object.create_item_in_inventory("TIMETRAVELLER",   ["SET_OINTMANT_JAR","SET_OINTMANT_JAR"])
	# alt:
	# 2 Uzi Maschinenpistolen
	# 1 Schrotflinte
	# 100 Schuss 9mm Munition
	# 20 Schuss Shotgun Shells
	# 1 Medipack
	# 1 Handgranate
	# 1 Weste
	# Rattenfleisch
											
	# Bienenstöcke Z2
	object.create_item_in_inventory( 'BUILDING_18944', equipment=[ 'SET_BEESWAX' ] )
	object.create_item_in_inventory( 'BUILDING_18943', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )

#armes & munitions | armures | divers
	object.create_item_in_inventory("TRADER", 
            ["SET_UZI"]*3 + ["SET_CALICO_M900"] + ["SET_AMMOPACK_9_MM"]*30 + ["SET_AMMOPACK_9_MM_SUBSONIC"]*20 +
            ["SET_COLT_ANACONDA"] + ["SET_AMMOPACK_44"]*10 +
            ["SET_BROWNING_B_SS_DOUBLE_BARREL"] + ["SET_REMINGTON_M870"] + ["SET_AMMOPACK_2_12_MM"]*10 +
            ["SET_AMMOPACK_357"]*5 + ["SET_AMMOPACK_45"]*5 +
            ["SET_AMMOPACK_7_62SOVJET_MM"]*25 + ["SET_AMMOPACK_5_45_MM"]*25 )
# armures
	object.create_item_in_inventory("TRADER", ["SET_BULLET_CATCH"]*3 + ["SET_STEEL_CLAD_BOOTS"]*3 +
            ["SET_STEEL_HELMET"]*3 + ["SET_PROTECTIVE_GLOVES"]*3 )
# medicaments
	object.create_item_in_inventory("TRADER", ["SET_DRUGS_PILLS_01"]*30 + ["SET_DRUGS_PILLS_02"]*10 +
            ["SET_DRUGS_PILLS_03"]*5  + ["SET_DRUGS_PILLS_04"]*4 +
            ["SET_MEDIPACK_SMALL"]*5 + ["SET_MEDIPACK_BIG"]*5 )
# divers
	object.create_item_in_inventory("TRADER", ["SET_TENT_CANVAS", "SET_TENT_CANVAS", "SET_BASIC_PICKLOCK", "SET_SPIT", "SET_PLIERS", "SET_RAT_MEAT", "SET_CHEESE"] )
	object.create_item_in_inventory("TRADER", ["SET_FRAGGRENADE", "SET_CLUB", "SET_LANDMINE", "SET_LANDMINE","SET_THROWING_KNIFE"] )


def initHerbs():
	# Berg suedlich von Dustville
	system.create_object(equipmenttype="SET_ALOE_VERA", x= 370.20, y=492.69)
	# hinter Fabrikhalle
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 894.89, y = 359.23)
	# noerdlich von Fabrikhalle
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 889.33, y = 242.60)
	#oestlich von ratmeat-trader-kraeuter-kuhle
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 641.42, y = 238.18)
	
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 575.95, y = 276.88)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 239.86, y = 537.66)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 839.40, y = 510.60)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 892.59, y = 853.88)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 357.93, y = 790.84)
	
def on_put_down(character_id, item_id, item_type):
	#print "onPutDown()",character_id,item_id,item_type
	if (item_type=="SET_RAT_MEAT" and
		object.get_distance("WOLF_VARI", character_id) < 5 and
		data().WolfGerettet!=1):
		if character_id == "ALTER_EGO":
			data().Obj_RatMeat_Drop = item_id
			dialogs.initCutscene_042_FleischAufBoden()
		else:
			dialogs.MercenaryDenyTalk(character_id)

	if (item_type == "SET_C4_REMOTE_CONTROL"):
		system.notify_timer(data().Timer_DorfAngriffShorter,data().Timervalue_DorfAngriffShorter)

def can_exchange( character_id, target_id, item_id, item_type ):
	if target_id == "FREDO":
		if character_id == "ALTER_EGO":
			if item_type != None:
				if data().Fredo_angesprochen:
					if data().counter_fredo_item_given == 0:
						if item_type.rfind("MEAT") != -1:
							return True
						elif is_water_repository(item_id):
							return True
		return False

	if (item_id==data().Obj_FluxCompensator 
		and target_id == "TIMETRAVELLER"
		and character_id == "ALTER_EGO"):
			return True
	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
	#print "exchange %s %s %s %s" % (character_id, target_id, item_id, item_type)
	if target_id == "FREDO":
		if character_id == "ALTER_EGO":
			if item_type != None:
				if ((item_type.rfind("MEAT") != -1) or 
					is_water_repository(item_id)):
					if data().counter_fredo_item_given == 0:
						data().counter_fredo_item_given += 1
						dialogs.initDlg_081_FredoInformationen()
						return True
		return False
	
	if (target_id=="TIMETRAVELLER" and
		item_id==data().Obj_FluxCompensator):
		if character_id == "ALTER_EGO":
			dialogs.initCutscene_Dlg_038_TimeTravellerPlixCapacitor()
			return True

	return object_events.on_exchange( character_id, target_id, item_id, item_type )

def is_meat(item_type=None):
	if item_type == None:
		return False
	if item_type in ["SET_MEAT_RAW_TINY", "SET_MEAT_RAW_BIG","SET_MEAT_RAW_HUMONGOUS",
						"SET_MEAT_COOKED_SMALL","SET_RAT_MEAT","SET_MEAT_RAW_SMALL",
						"SET_MEAT_RAW","SET_MEAT_COOKED_TINY", "SET_MEAT_COOKED", 
						"SET_MEAT_COOKED_BIG", "SET_MEAT_COOKED_HUMONGOUS"]:
		return True
	return False

def on_use( character_id, object_id, item_id, item_type ):
	## wolfsfleisch
	if (object_id=="WOLF_VARI" and
	    character_id == 'ALTER_EGO' and
		is_meat(item_type) and
		not object.is_destroyed("WOLF_VARI") and
		not data().WolfFolgt and system.get_qb_entry_state(data().QB_006) == UNCOMPLETE):
		if character_id == "ALTER_EGO":
			object.turn_to_object("WOLF_VARI","ALTER_EGO")
			data().WolfFolgt = True
			dialogs.initCutscene_024_WolfLocken()
		else:
			dialogs.MercenaryDenyTalk(id,type='useitem')
		return True

	## davids tagebuch
	if item_id==data().Obj_DavidsDiary:
		if character_id == "ALTER_EGO":
			if not data().tagebuch_gelesen:
				dialogs.initCutscene_Dlg_005_Diary()
				data().tagebuch_gelesen = True
			else:
				dialogs.initCutscene_Dlg_005_Diary(as_cutscene=False)
		else:
			dialogs.MercenaryDenyTalk(id,type='useitem')
		return True

	## notiz der ratskulls
	if (item_id==data().Obj_TatteredNote):
		if character_id == "ALTER_EGO":
			dialogs.initDlg_021_ZettelGefunden()
		else:
			dialogs.MercenaryDenyTalk(character_id,type='useitem')
		return True
	return object_events.on_use( character_id, object_id, item_id, item_type )


def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		if target == "BOBBY":
			stop_sound_bobby_cry()
		dialogs.on_approach(target, operator)

def on_damage_(id, attacker):
	if id=="DAVID":
		object.destroy("DAVID")
		on_object_killed("DAVID", "RATSKULL_SQUAD_LEADER", None, None)

def speech_david(id):
	if object.get_distance("ALTER_EGO", "DAVID") <= 10.0:
		if id == '1':
			dialogs.initDlg_004_DavidGetoetet()
		if id == '2':
			dialogs.initDlg_092_SpielerHatDavidSelbstgetoetet()
	else:
		enemy_script.delay(1, Lambda('speech_david("%s")' %id))

def on_object_killed(victim, attacker, weapon_type, weapon_id):
	print 'on_object_killed(victim, attacker, weapon_type, weapon_id)', victim, attacker, weapon_type, weapon_id
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	# spezialbehandlung, kann vor allen anderen ratskulls abgemurkst werden
	# wenn dies geschieht, wird geprüft ob er von den anderen ratskulls gesehen werden konnte
	
	if victim == 'DAVID' and attacker == None:
		return
	
	if victim=="RATSKULL_016":
		found = False
		for id in data().ratskulls_village:
			if not id == "RATSKULL_016":
				if object.get_distance("RATSKULL_016",id)<=20.0:
					found = True
		if not found:
			if data().SpielerEntdeckt:
				data().SpielerEntdeckt=False

	if victim=="DAVID":
		if object.get_distance("ALTER_EGO", "DAVID") <= 10.0:
			if not data().toten_david_gesehen:
					data().toten_david_gesehen = True
					if ((not dialog.is_dialog_active()) and (not system.is_cutscene())):
						if not (attacker in system.get_pcs()):
							dialogs.initDlg_004_DavidGetoetet()
						#Kommentar des Spielers zum Tot von David einblenden
						else:
							dialogs.initDlg_092_SpielerHatDavidSelbstgetoetet()
					else:
						if not (attacker in system.get_pcs()):
							data().counter_comment_wait = 2
						else:
							data().counter_comment_wait = 4
						system.notify_timer(data().Timer_CommentWait, data().Timervalue_CommentWait)
		elif object.get_distance("ALTER_EGO", "DAVID") > 10.0:
			if not (attacker in system.get_pcs()):
				enemy_script.delay(1, Lambda('speech_david("1")'))
			else:
				enemy_script.delay(1, Lambda('speech_david("2")'))
		data().AussteigerGerettet = 0								#Aussteiger ist gestorben
		if ((not system.get_qb_entry_state(data().QB_003) in [UNCOMPLETE, COMPLETE]) and
			not (system.get_qb_entry_state(data().QB_003) == INACTIVE and system.get_qb_entry_state(data().QB_004) == UNCOMPLETE)):
			system.create_object(equipmenttype="SET_DIARY_DROPOUT",
				x=421,y=680, id=data().Obj_DavidsDiary)
			object.set_attribute(object=data().Obj_DavidsDiary, attribute="generic_item", value=False)
		system.set_qb_entry_state(data().QB_002,IMPOSSIBLE)
		
		# das Leben des Aussteigers zu retten ist nicht mehr moeglich
		if was_zone_entered("zone_1.zone_1"):
			system.set_qb_entry_text(data("zone_1.zone_1").QB_004,id_reward="ZONE1_AIM_04_REWARD_02")
			system.set_qb_entry_state(data("zone_1.zone_1").QB_004,IMPOSSIBLE)
		
		for id in data().ratskulls_david:
			if not object.is_destroyed(id):
				enemy_script.delay(3.5, Lambda('object.move_to("%s", 214, 747, "landscape", MT_SLOW)' % id))

	if victim in data().ratskulls_david:
		data().RatSkullKilledAussteiger+=1

	if (data().RatSkullKilledAussteiger==3 and
		data().AussteigerGerettet==-1):
		data().AussteigerGerettet = 1								#Aussteiger ist gerettet
		character.set_approachable_state("DAVID",APPROACHABLE)		#Aussteiger wird ansprechbar
		system.set_qb_entry_state(data().QB_002,COMPLETE)				#QuestBookeintrag als erledigt markieren

	if victim in data().ratskulls_village:
		data().RatSkullKilledDorf+=1
		#print "Ratskull Killed %d" % (data().RatSkullKilledDorf)

		if (data().RatSkullKilledDorf==10):
			if (data().DorfGerettet==0):
				data().DorfGerettet = 1
				data().dorf_rettung == 2
				if not system.get_qb_entry_state(data().QB_004)==IMPOSSIBLE:
					system.set_qb_entry_state(data().QB_004,COMPLETE)
					
					if( data().Exp_Dorfrettung >= 200 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_200")
					elif( data().Exp_Dorfrettung >= 190 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_190")
					elif( data().Exp_Dorfrettung >= 180 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_180")
					elif( data().Exp_Dorfrettung >= 170 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_170")
					elif( data().Exp_Dorfrettung >= 160 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_160")
					elif( data().Exp_Dorfrettung >= 150 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_150")
					elif( data().Exp_Dorfrettung >= 140 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_140")
					elif( data().Exp_Dorfrettung >= 130 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_130")
					elif( data().Exp_Dorfrettung >= 120 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_120")
					elif( data().Exp_Dorfrettung >= 110 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_110")
					elif( data().Exp_Dorfrettung >= 100 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_100")
					elif( data().Exp_Dorfrettung >= 90 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_090")
					elif( data().Exp_Dorfrettung >= 80 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_080")
					elif( data().Exp_Dorfrettung >= 70 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_070")
					elif( data().Exp_Dorfrettung >= 60 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_060")
					elif( data().Exp_Dorfrettung >= 50 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_050")
					elif( data().Exp_Dorfrettung >= 40 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_040")
					elif( data().Exp_Dorfrettung >= 30 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_030")
					elif( data().Exp_Dorfrettung >= 20 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_020")
					elif( data().Exp_Dorfrettung >= 10 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_010")
					elif( data().Exp_Dorfrettung < 10 ):
						system.set_qb_entry_text(data().QB_004,id_reward="ZONE2_AIM_04_REWARD_000")
					
						
				#if not system.get_qb_entry_state(data().QB_003)==IMPOSSIBLE:
				#	system.set_qb_entry_state(data().QB_003,COMPLETE)
				character.add_experience_party(data().Exp_Dorfrettung)
				BenGibtSignal()

	if victim in data().wolfs_ratmeat:
		data().WoelfeKilled+=1

	if (data().WoelfeKilled>=3 and
		data().Rattenfleisch==0):
			system.set_qb_entry_state(data().QB_009,INACTIVE)			#QuestBookeintrag als erledigt markieren
			system.set_qb_entry_state(data().QB_010,UNCOMPLETE)		#neuen Eintrag im QuestBook anzeigen

	if (victim=="RATSKULL_006" or
		victim=="RATSKULL_007"):

		## todo: einen on_use_callback für diesen fall
#		if victim == "RATSKULL_006":
#			object.drop_item("RATSKULL_006",data().Obj_TatteredNote)

		data().RatSkullKilledSara+=1
		if (data().RatSkullKilledSara >= 2 and
			not data().TochterAussteigerGerettet==-2):
			onSaraBefreit()

	if (victim=="WOLF_VARI" and
		data().WolfGerettet==0):
		system.set_qb_entry_state(data().QB_006,IMPOSSIBLE)

	if victim in data().village1 + VILLAGE1_TA_ADDS:
		laenge = len(data().village1) + len(VILLAGE1_TA_ADDS) - (len(VILLAGE1_G4)-1)
		laenge -= 2
		data().DoerflerKilled += 1
		data().Exp_Dorfrettung -= data().Exp_Dorfrettung_Verluste
		if data().DoerflerKilled == laenge:
			RatskullsHabenDorfAusgeloescht()
			if not data().tote_doerfler_gesehen:
				data().tote_doerfler_gesehen = True
				if object.get_distance("ALTER_EGO", victim) <= 15.0:
					dialogs.initDlg_086_SpielerKommentiertDorfVernichtung()


def RatskullsHabenDorfAusgeloescht():
	system.notify_timer(data().Timer_RatskullsRueckkehrDorf,data().Timervalue_RatskullsRueckkehrDorf)

def RatskullsRueckkehrDorf():
	## Ratskulls verlassen 'Friedhof'
	for id in data().ratskulls_village:
		if not object.is_destroyed(id):
			dialogs.RoutedMoveTo(id=id,route=ROUTE_DORFBEWOHNER_RUECKKEHR)
	system.notify_timer(data().Timer_RatskullsSichernDorf,data().Timervalue_RatskullsSichernDorf)

def RatSkullsSichernDorf():
	## Ratskulls sichern das Dorf
	for id in data().route_active_for.keys():
		data().route_active_for[id] = True
		allow_activity(id)
	data().RatskullsKonversationAktiv = True

def StartDorfAngriff():
	data().DorfangriffGestartet = True
	data().dorf_rettung = 1
	for id in data().ratskulls_village:
		object.set_active_state(id,ACTIVE)

	#Zur Dorfmitte bewegen
	dialogs.RoutedMoveTo(id="RATSKULL_011",route=ROUTE_RATSKULLS_DORFZENTRUM)
	dialogs.RoutedMoveTo(id="RATSKULL_012",route=ROUTE_RATSKULLS_DORFZENTRUM)
	dialogs.RoutedMoveTo(id="RATSKULL_013",route=ROUTE_RATSKULLS_DORFZENTRUM)
	dialogs.RoutedMoveTo(id="RATSKULL_014",route=ROUTE_RATSKULLS_DORFZENTRUM)

	#Zum Dorfeingang bewegen
	dialogs.RoutedMoveTo(id="RATSKULL_015",route=ROUTE_RATSKULLS_DORFEINGANG)
	dialogs.RoutedMoveTo(id="RATSKULL_005",route=ROUTE_RATSKULLS_DORFEINGANG)

	for wp in ROUTE_RATSKULL_016_ZUM_DORF:
		if (wp == ROUTE_RATSKULL_016_ZUM_DORF[len(ROUTE_RATSKULL_016_ZUM_DORF)-1]):
			object.move_to("RATSKULL_016", wp[0],wp[1],speed=MT_SLOW, callback=["ONEND", onRatskull_016_EndFirstRoute])
		else:
			object.move_to("RATSKULL_016", wp[0],wp[1],speed=MT_SLOW)
	dialogs.RoutedMoveTo(id="RATSKULL_010",route=ROUTE_RATSKULLS_DORFEINGANG)
	dialogs.RoutedMoveTo(id="RATSKULL_003",route=ROUTE_RATSKULLS_AUSSEN)
	dialogs.RoutedMoveTo(id="RATSKULL_004",route=ROUTE_RATSKULLS_AUSSEN)

def onRatskull_016_EndFirstRoute(char_id):
	data().route_active_for["RATSKULL_016"] = True

def FluchtDorfbewohner():
	system.notify_timer(data().Timer_GroupedRouteLeaveVillage,data().Timer_GroupedRouteLeaveVillage)
	if (data().TochterAussteigerGerettet >= 2 or data().TochterAussteigerGerettet == -2):
		object.move_to("SARA",726.9,566.7, "landscape",MT_FAST)
		object.turn_to_direction("SARA",globals.DIR_WEST)

def StartSucheDorfBewohner():
	if (not object.is_destroyed("RATSKULL_011") and
		not object.is_destroyed("RATSKULL_013") and
		not object.is_destroyed("RATSKULL_012") and
		not object.is_destroyed("RATSKULL_014")):
		dialogs.RoutedMoveTo(id="RATSKULL_011",route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_1,speed=MT_SLOW)
		dialogs.RoutedMoveTo(id="RATSKULL_012",route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_2,speed=MT_SLOW)
		dialogs.RoutedMoveTo(id="RATSKULL_013",route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_3,speed=MT_SLOW)
		dialogs.RoutedMoveTo(id="RATSKULL_014",route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_4,speed=MT_SLOW)
		if not data().Timer_RatskullsHolzstapelNotified:
			data().Timer_RatskullsHolzstapelNotified = True
			system.notify_timer(data().Timer_RatskullsHolzstapel, data().Timervalue_RatskullsHolzstapelLonger)

def onTurnToBen(id):
	object.turn_to_object(id,"BEN")

def DorfbewohnerZuBen():
	data().BenDorfPlatz = 3
	data().ben_alarm = True
	loc_butch = get_location("VILLAGE1_BUTCH")
	
	for id in data().village1_ta_npcs:
		if not object.is_destroyed(id):
			object.cancel_commandos(id)
			prohibit_activity(id)
			character.set_approachable_state(id, NOTAPPROACHABLE)
	
	if loc_butch in [4,5,6,9]:
		if not object.is_destroyed("VILLAGE1_BUTCH"):
			object.step_to("VILLAGE1_BUTCH", 630.25,556.25)
	
	prohibit_activity("BEN")
	prohibit_activity("JAY")
	prohibit_activity("BOBBY")

	if (data().TochterAussteigerGerettet >= 2 or data().TochterAussteigerGerettet == -2):
		prohibit_activity("SARA")
		character.set_approachable_state("SARA",NOTAPPROACHABLE)
		object.move_to("SARA",object.get_x("BEN")+1.0,object.get_y("BEN")+1.0, grid="landscape",speed=MT_FAST)
		object.turn_to_object("SARA","BEN")

	character.set_approachable_state("BEN",NOTAPPROACHABLE)		#Ben ist waehrend der Evakuierung nicht ansprechbar
	character.set_approachable_state("BOBBY",NOTAPPROACHABLE)		#waehrend der Flucht und der Evakuierung sind Bobby und Jay nicht mehr ansprechbar
	character.set_approachable_state("JAY",NOTAPPROACHABLE)

	for id in VILLAGE1_G1:
		object.move_to(id, 649.0, 563.2, grid="landscape", speed=MT_FAST, callback=["ONEND",onTurnToBen])
	
	for id in VILLAGE1_G2:
		object.move_to(id, 651.08, 562.34, grid="landscape", speed=MT_FAST, callback=["ONEND",onTurnToBen])

	for id in VILLAGE1_G3:
		object.move_to(id, 652.06, 558.14, grid="landscape", speed=MT_FAST, callback=["ONEND",onTurnToBen])
	
	for id in VILLAGE1_G4:
		if id != "BEN":
			object.move_to(id, 648.4, 557.0, grid="landscape", speed=MT_FAST, callback=["ONEND",onTurnToBen])

	for id in VILLAGE1_G5:
		object.move_to(id, 646.1, 561.6, grid="landscape", speed=MT_FAST, callback=["ONEND",onTurnToBen])
	
def RueckkehrDorfbewohner(id):
	data().BenDorfPlatz = 4
	system.notify_timer(data().Timer_DoerflerRueckkehr,data().Timervalue_DoerflerRueckkehr)
	system.notify_timer(data().Timer_ScheduleDelay,data().Timervalue_ScheduleDelay)
	character.set_approachable_state("BEN",APPROACHABLE)
	character.set_approachable_state("BOBBY",APPROACHABLE)
	character.set_approachable_state("JAY",APPROACHABLE)
				

	if (data().TochterAussteigerGerettet >= 2 or data().TochterAussteigerGerettet == -2):
		allow_activity("SARA")
		object.move_to("SARA",665.9,521.3, "landscape",MT_SLOW)
		object.turn_to_direction("SARA",globals.DIR_WEST)
		character.set_approachable_state("SARA",APPROACHABLE)

	for id in data().village1 + VILLAGE1_TA_ADDS:
		count = 0
		if not object.is_destroyed(id):
			for waypoint in ROUTE_DORFBEWOHNER_RUECKKEHR:
				if count == len(ROUTE_DORFBEWOHNER_RUECKKEHR)-1:
					if id == "BEN":
						object.move_to(id,waypoint[0],waypoint[1],"landscape",MT_SLOW,callback=["ONEND",ben_approachable])
					else:
						object.move_to(id,waypoint[0],waypoint[1],"landscape",MT_SLOW,callback=["ONEND",set_npc_back])
					
				else:
					object.move_to(id,waypoint[0],waypoint[1],"landscape",MT_SLOW)
				count += 1

	#allow_activity("BOBBY")
	data().ta_delay_after_village_assault = True
	data().ben_alarm = False

def set_npc_back(id):
	allow_activity(id)
	character.set_approachable_state(id,APPROACHABLE)
	
def ben_approachable(char_id=None):
	allow_activity(char_id)
	data().ben_normal_dialog = True

def BenGibtSignal():
	point = ROUTE_DORFBEWOHNER_FLUCHT[1]
	for id in VILLAGE1_G4:
		object.move_to(id, point[0], point[1], speed=MT_FAST)
		if id == "BEN":
			object.move_to("BEN",722.0, 594.0, "landscape",MT_FAST)
			character.play_animation("BEN", "CM_NPC_STEHEN_HORN_BLASEN",callback=["ONEND",RueckkehrDorfbewohner])

def WolfRueckkehrDorf():
	#print "WolfRueckkehrDorf()"
	distance = object.get_distance("WOLF_VARI", "BOBBY")

	if (data().WolfFolgt==True and
		distance > 8 and
		distance < 200):
		system.notify_timer(data().Timer_WolfRueckkehr,
			data().Timervalue_WolfRueckkehr)

		x = object.get_x("ALTER_EGO")
		y = object.get_y("ALTER_EGO")
		object.move_to("WOLF_VARI", x, y, grid="landscape", speed=MT_FAST)
		if not random.randint(0,3):
			sounds.play_3d_sound_object(sfx_id="wolf_2",
				object="WOLF_VARI")
		else:
			sounds.play_3d_sound_object(sfx_id="wolf_3",
				object="WOLF_VARI")

	elif (data().WolfFolgt==True and
		distance > 200):
		object.cancel_commandos('WOLF_VARI')
		object.set_position("WOLF_VARI", 712.3, 631.44, grid="landscape")
		data().WolfFolgt = False
	
	elif (data().WolfFolgt==True and
		distance < 8):
		data().WolfGerettet = 1
		data().WolfFolgt = False
		object.move_to("WOLF_VARI", 643.31, 581.32, grid="landscape",speed= MT_FAST)
		object.turn_to_object("WOLF_VARI", "BOBBY")
		object.set_immortal_state('WOLF_VARI', True)
	
	
def onSaraBefreit():
	character.set_approachable_state("SARA",APPROACHABLE)		#Sara wird ansprechbar
	data().TochterAussteigerGerettet = 1					#Sara als gerettet kennzeichnen

### NEBENQUEST: SCHLAGZEILEN BESORGEN ###
def UpdateQBEntry_007Text():
	print 'UpdateQBEntry_007Text = ',data().SchlagzeilenGefunden  
	if (data().SchlagzeilenGefunden==0):
		system.set_qb_entry_text(data().QB_007,id_name =		'ZONE2_AIM_07_NAME')
		system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_SHORT_DESC')
		system.set_qb_entry_text(data().QB_007,id_desc =		'ZONE2_AIM_07_DESC')
		#system.set_qb_entry_text(data().QB_007,id_location =	'ZONE2_AIM_07_SHORT_DESC')
		#system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_DESC')
	elif (data().SchlagzeilenGefunden==1):
		system.set_qb_entry_text(data().QB_007,id_name =		'ZONE2_AIM_07_NAME')
		system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_SHORT_DESC_1')
		system.set_qb_entry_text(data().QB_007,id_desc =		'ZONE2_AIM_07_DESC_1')
		#system.set_qb_entry_text(data().QB_007,id_location =	'ZONE2_AIM_07_SHORT_DESC_1')
		#system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_DESC_1')
	elif (data().SchlagzeilenGefunden==2):
		system.set_qb_entry_text(data().QB_007,id_name =		'ZONE2_AIM_07_NAME')
		system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_SHORT_DESC_2')
		system.set_qb_entry_text(data().QB_007,id_desc =		'ZONE2_AIM_07_DESC_2')
		#system.set_qb_entry_text(data().QB_007,id_location =	'ZONE2_AIM_07_SHORT_DESC_2')
		#system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_DESC_2')
	elif (data().SchlagzeilenGefunden==3):
		system.set_qb_entry_text(data().QB_007,id_name =		'ZONE2_AIM_07_NAME')
		system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_SHORT_DESC_3')
		system.set_qb_entry_text(data().QB_007,id_desc =		'ZONE2_AIM_07_DESC_3')
		#system.set_qb_entry_text(data().QB_007,id_location =	'ZONE2_AIM_07_SHORT_DESC_3')
		#system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_DESC_3')
	elif (data().SchlagzeilenGefunden==4):
		system.set_qb_entry_text(data().QB_007,id_name =		'ZONE2_AIM_07_NAME')
		system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_SHORT_DESC_4')
		system.set_qb_entry_text(data().QB_007,id_desc =		'ZONE2_AIM_07_DESC_4')
		#system.set_qb_entry_text(data().QB_007,id_location =	'ZONE2_AIM_07_SHORT_DESC_4')
		#system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_DESC_4')
	elif (data().SchlagzeilenGefunden==5):
		system.set_qb_entry_text(data().QB_007,id_name =		'ZONE2_AIM_07_NAME')
		system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_SHORT_DESC')
		system.set_qb_entry_text(data().QB_007,id_desc =		'ZONE2_AIM_07_DESC')
		#system.set_qb_entry_text(data().QB_007,id_location =	'ZONE2_AIM_07_SHORT_DESC')
		#system.set_qb_entry_text(data().QB_007,id_short_desc =	'ZONE2_AIM_07_DESC')

def PruefeSchlagzeilenKommentare():
	if (not dialog.is_dialog_active()
		and data().Schlagzeilen==0):
		if (data().WolfGerettet >= 1 and
			not data().SchlagzeileWolfGerettet):
			dialogs.initDlg_065_SchlagzeileWolf()
			data().SchlagzeileWolfGerettet=True
			data().SchlagzeilenGefunden+=1
			UpdateQBEntry_007Text()
		
		elif (data().DorfGerettet >= 1 and
			not data().SchlagzeileDorfGerettet):
			dialogs.initDlg_064_SchlagzeileDorfRettung()
			data().SchlagzeileDorfGerettet=True
			data().SchlagzeilenGefunden+=1
			UpdateQBEntry_007Text()
		
		elif (data().AussteigerGerettet > 0 and
			not data().SchlagzeileAussteigerGerettet):
			dialogs.initDlg_061_SchlagzeileRettungAussteiger()
			data().SchlagzeileAussteigerGerettet=True
			data().SchlagzeilenGefunden+=1
			UpdateQBEntry_007Text()
		
		elif (data().Rattenfleisch > 0 and
			not data().SchlagzeileRattenfleisch):
			dialogs.initDlg_066_SchlagzeileRattenfleisch()
			data().SchlagzeileRattenfleisch=True
			data().SchlagzeilenGefunden+=1
			UpdateQBEntry_007Text()
		
		elif (data().ZeitMaschine > 0 and
			not data().SchlagzeileZeitmaschine):
			dialogs.initDlg_067_SchlagzeileZeitmaschine()
			data().SchlagzeileZeitmaschine=True
			data().SchlagzeilenGefunden+=1
			UpdateQBEntry_007Text()
		
		elif (data().AussteigerGerettet > 0 and
			data().DorfGerettet > 0 and
			data().WolfGerettet > 0 and
			data().ZeitMaschine > 0 and
			data().Rattenfleisch > 0 and
			not data().ReporterHinweisAlleSchlagzeilen):
			dialogs.initDlg_032_BenachrichtigungAlleSchlagzeilen()
			data().ReporterHinweisAlleSchlagzeilen = True
			UpdateQBEntry_007Text()

	if not data().ReporterHinweisAlleSchlagzeilen:
		system.notify_timer(data().Timer_Schlagzeilen,data().Timervalue_Schlagzeilen)

def on_wait_for_commando(id):
	if id in ["RATMEAT_TRADER"]:
		schedules.set_approach_position(id)
#	if id in data().village1 + VILLAGE1_TA_ADDS:
#		character.set_approachable_state(id, APPROACHABLE)
	return schedules.Activity(id)

def pre_examine_object( character_id, object_id ):
	if object_id != None:
		# lastwagen beim reporter
		if object_id == "ZONE_2_BUILDING_328":
			object.set_attribute(object_id, "on_examine_coordinates",[498.47, 553.35, 0])
	
# examine zone objects
def can_examine_object( character_id, object_id ):
	"returns true if the object can be examined "\
	"character_id - id of the character "\
	"object_id - id of the object"
	if (object_id =="CAR_TIMETRAVELLER"):
		if (character_id == "ALTER_EGO"):
			return True
	
	#if object_id == "ZONE_2_BUILDING_328":
	#	return False
	
	for substring in ["BUILDING_3940", "BUILDING_3941", "BUILDING_3942", "BUILDING_3943"]:
		if object_id.endswith(substring):
			return True
	for substring in map(str, range(370,382)):
		substring = "BUILDING_"+substring
		if object_id.endswith(substring):
			return True
	for substring in ["BUILDING_3925","BUILDING_3926"]:
		if object_id.endswith(substring):
			return True
	for substring in ["BUILDING_3971","BUILDING_3969","BUILDING_3972","BUILDING_3973","BUILDING_3978"]:
		if object_id.endswith(substring):
			return True
	for substring in ["BUILDING_3354","BUILDING_3355"]:
		if object_id.endswith(substring):
			return True
	else:
		return False

def on_corpse_spotted( object_id ):
	#print ">>> on_corpse_spotted",object_id
	if object_id != "ALTER_EGO":
		return

	if object.get_distance(object_id, "DAVID") <= 15.0:
		if not data().toten_david_gesehen:
			data().toten_david_gesehen = True
			if ((not dialog.is_dialog_active()) and (not system.is_cutscene())):
				dialogs.initDlg_004_DavidGetoetet()							#Kommentar des Spielers zum Tot von David einblenden
			else:
				data().counter_comment_wait = 2
				system.notify_timer(data().Timer_CommentWait, data().Timervalue_CommentWait)

	for id in data().village1 + VILLAGE1_TA_ADDS:
		if not data().tote_doerfler_gesehen:
			data().tote_doerfler_gesehen = True
			if object.get_distance(id, object_id) <= 15.0:
				if data().DoerflerKilled == len(data().village1)-1:
					dialogs.initDlg_086_SpielerKommentiertDorfVernichtung()
				return


def on_examine_object( character_id, object_id ):
	"called if an item is examined by a character "\
	"character_id - id of the character "\
	"object_id - id of the object"
	if (object_id =="CAR_TIMETRAVELLER"):
		if (character_id == "ALTER_EGO"):
			dialogs.initDlg_090_SpielerUntersuchtZeitmaschine()
	
	for substring in ["BUILDING_3940", "BUILDING_3941", "BUILDING_3942", "BUILDING_3943"]:
		if object_id.endswith(substring):
			
			# examine papers
			comments.comment(character_id=character_id, text='EXAMINE_PAPER_' + str((data().examinePapers%6) + 1))
			data().examinePapers = data().examinePapers + 1;
	
	for substring in map(str, range(370,382)):
		substring = "BUILDING_"+substring
		if object_id.endswith(substring):
			# examine herb
			comments.comment(character_id=character_id, text='EXAMINE_HERB')
	
	for substring in ["BUILDING_3925","BUILDING_3926"]:
		if object_id.endswith(substring):
			# examine rat meat
			comments.comment(character_id=character_id, text='EXAMINE_RAT_MEAT')
	
	for substring in ["BUILDING_3971","BUILDING_3969","BUILDING_3972","BUILDING_3973","BUILDING_3978"]:
		# examine lumber
		if object_id.endswith(substring):
			comments.comment(character_id=character_id, text='EXAMINE_LUMBER')
	
	for substring in ["BUILDING_3354","BUILDING_3355"]:
		# examine tents
		if object_id.endswith(substring):
			comments.comment(character_id=character_id, text='EXAMINE_TENTS')

def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 208.00, y1 = 0.00, x2 = 1119.00, y2 = 218.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD")
	system.add_region( id = "REGION_EXIT_SUED", x1 = 1119.00, y1 = 1119.00, x2 = 0.00, y2 = 917.67 )
	system.register_exit(regionname = "REGION_EXIT_SUED")
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 917.67, x2 = 208.00, y2 = 0.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST")
	system.add_region( id = "REGION_EXIT_OST", x1 = 1119.00, y1 = 218.00, x2 = 913.00, y2 = 917.67 )
	system.register_exit(regionname = "REGION_EXIT_OST")

def initFX():
	sounds.load_sound("body_bounce")
	sounds.load_sound("hit_pain")
	sounds.load_sound("hit_stomach")
	
	# brennende Tonne bei Davids Haus
	fxBrennendeTonne("BUILDING_203")
	# brennende tonne in süd-new stafford
	fxBrennendeTonne("BUILDING_337")
	# brennende Tonne in New Stafford
	fxBrennendeTonne("BUILDING_338")
	# brennende Tonne Dustville
	fxBrennendeTonne('BUILDING_245')
	# Lagerfeuer in New Stafford
	fxLagerFeuer("BUILDING_3867")
	# Lagerfeuer im Ratskull Camp
	fxLagerFeuer("BUILDING_3379")
	# brennende Tonne beim Schrottplatz
	fxBrennendeTonne("BUILDING_166")
	# Lagerfeuer im Dustville
	fxLagerFeuer("BUILDING_3927")
	#3 brennende tonnen in new stafford:
	fxBrennendeTonne("BUILDING_342")
	fxBrennendeTonne("BUILDING_68")
	fxBrennendeTonne("BUILDING_5308")

def initMinimapMarkers():
	pass

def initWaterResources():
	water.set_water_source(749.4,589.9, 4)
	water.set_water_source(821.8,875.3, 3)
	water.set_water_source(466.0,233.1, 2)
	water.set_water_source(407.9,632.5, 1)

## Feuereffekte: brennende Tonne
def fxBrennendeTonne(_objectid):
	#system.start_effect_object(object=_objectid,node="sort0",parameter=fx_smoke_brennende_tonne)
	system.start_effect_object(object=_objectid,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)

## Feuereffekte: Lagerfeuer
def fxLagerFeuer(_objectid):
	system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

def initFoeLists():
	PCs = system.get_pcs()

	for id in data().ratskulls_camp:
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

	for id in data().ratskulls_david:
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

	for id in data().ratskulls_village:
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

	for id in data().wolfs_ratmeat:
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

def on_c4explo_ratskulls_alerted(char=None):
	#nach der c4 explosion
	route = random.randint(0,50)
	if route < 15:
		dialogs.RoutedMoveTo(id=char,route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_2,speed=MT_FAST)
	elif route < 30:
		dialogs.RoutedMoveTo(id=char,route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_3,speed=MT_FAST)
	elif route <= 50:
		dialogs.RoutedMoveTo(id=char,route=ROUTE_RATSKULLS_DORFDURCHSUCHUNG_4,speed=MT_FAST)

def on_weapon_ignition(weapon_type,x,y,z):
	if weapon_type=="SET_C4_REMOTE_CONTROL":
		import math
		x2=object.get_x(data().Obj_RatskullCorpse)
		y2=object.get_y(data().Obj_RatskullCorpse)

		dist = math.sqrt((x-x2)*(x-x2)+(y-y2)*(y-y2))

		for id in ["RATSKULL_011","RATSKULL_012",
					"RATSKULL_013","RATSKULL_014"]:
			if not object.is_destroyed(id):
				object.move_to(id, x2, y2, speed=MT_FAST, callback=["ONEND", on_c4explo_ratskulls_alerted])
		
		if dist < 8.0:
			system.notify_timer(data().Timer_Delay, 1200)
			data().delay_reason = "dead_body_drops_down"
			data().erhaengter_explode = False
			object.set_active_state("BUILDING_ERHAENGETER_SPRENGUNG",ACTIVE)
			object.set_active_state(data().Obj_RatskullCorpse,INACTIVE)
			object.play_animation("BUILDING_ERHAENGETER_SPRENGUNG","ANIM_ERHAENGTER")
			object.set_immortal_state("BUILDING_ERHAENGETER_SPRENGUNG", True)
			
		if dist < 20.0:
			system.notify_timer(data().Timer_Ratskulls_Tor,data().Timervalue_Ratskulls_Tor)

		if ((dist > 20.0) and (dist < 100.0) and (system.get_qb_entry_state(data().QB_004)==UNCOMPLETE)):
			data().SprengungInDorfRegion = True
			for id in data().ratskulls_village:
				if not object.is_destroyed(id):
					x2,y2= object.get_x(id),object.get_y(id)
					ndist = math.sqrt((x-x2)*(x-x2)+(y-y2)*(y-y2))
					if ndist <= 50.0:
						object.cancel_commandos(id)
						object.move_to(id,x,y,"landscape",MT_FAST,callback=["ONEND",Wait])

def Wait(id):
	r = random.randint(1,3)
	for i in range(0,r):
		character.play_animation(id,"CM_NPC_STEHEN_WARTEN_%d" % random.randint(1,5), callback=["ONEND",Move])

def Move(id):
	import npc_activities
	r = random.randint(0,4)
	route = []
	if r == 0:
		route = ROUTE_RATSKULLS_DORFDURCHSUCHUNG_1
	elif r == 1:
		route = ROUTE_RATSKULLS_DORFDURCHSUCHUNG_2
	else:
		route = ROUTE_RATSKULLS_DORFDURCHSUCHUNG_3
		
	schedule = {id:{"00:00:00":{0 : [], 4 : [npc_activities.patrol(points=route)]}}}
	schedules.schedules.update(schedule)
	allow_activity(id)

	if not data().Timer_RatskullsHolzstapelNotified:
		data().Timer_RatskullsHolzstapelNotified = True
		system.notify_timer(data().Timer_RatskullsHolzstapel, data().Timervalue_RatskullsHolzstapelLonger)

def on_trade(target,operator):
	if target=="TRADER":
		object.cancel_commandos(target)
		if get_location("TRADER") == 1:
			prohibit_activity(target)
		lambda_string = 'system.trading_screen(trader="%s",char="%s")' %(target,operator)
		object.turn_to_object(target, operator, callback=["ONEND", Lambda(lambda_string)])

def on_exit_trader( trader_id, negotiator_id, profit ):
	allow_activity(trader_id)
	return object_events.on_exit_trader( trader_id, negotiator_id, profit)

def on_enemy_spotted(object_id):
	enemys = character.get_visible_enemies(object_id)
	# print "[debug: on_enemy_spotted:",object_id,"]"
	if object.is_npc(object_id) and len(enemys):
		if system.is_cutscene():
			object.cancel_commandos(object_id)
			return

	if len(enemys):
		enemy = random.choice(enemys)

		## Ratskulls die das Dorf angreifen
		if object_id in data().ratskulls_village:
			if not data().SpielerEntdeckt:
				data().SpielerEntdeckt = True
			if not object.is_destroyed(object_id):
				if object_id in ["RATSKULL_015","RATSKULL_005"]:
					for id in ["RATSKULL_015","RATSKULL_005"]:
						if not object.is_destroyed(id):
							attack_enemy(id, enemy)
				else:
					attack_enemy(object_id, enemy)
	
		## Ratskulls bei David
		if object_id in data().ratskulls_david:
			for id in data().ratskulls_david:
				if not object.is_destroyed(id):
					attack_enemy(id, enemy)
			if not object.is_destroyed("DAVID"):
					object.turn_to_object("DAVID", object_id)
		
		## Ratskulls bei Sara
		if object_id in data().ratskulls_camp:
			for id in data().ratskulls_camp:
				if not object.is_destroyed(id):
					attack_enemy(id, enemy)

def on_hit(object_id):
	if object_id == "DAVID" and not object.is_destroyed("DAVID"):
		object.destroy("DAVID")
		on_object_killed("DAVID", WHO_KILLED_DAVID, None, None)

def on_attack(operator, target):
	print 'on_attack(operator, target)', operator, target
	if target == "DAVID":
		if operator in system.get_pcs():
			on_attack(operator, "RATSKULL_SQUAD_LEADER")
		WHO_KILLED_DAVID = operator
#		if operator in data().ratskulls_david:
#			on_object_killed(target, operator, None, None)
#		if object.is_destroyed("DAVID"):
#			object.cancel_commandos(operator)
#		else:
#			on_object_killed(target, operator, None, None)
		


	if object.is_npc(operator):
		if system.is_cutscene():
			object.cancel_commandos(operator)
			return
	
	if not hasattr(data(), "has_been_attacked"):
		data().has_been_attacked = []
	if not target in data().has_been_attacked:
		data().has_been_attacked.append(target)
	else:
		return
		
	if (target in data().ratskulls_village):
		if (target in ["RATSKULL_011","RATSKULL_012","RATSKULL_013","RATSKULL_014"]):
			if not object.is_destroyed(target):
				for id in ["RATSKULL_011","RATSKULL_012","RATSKULL_013","RATSKULL_014"]:
					if not object.is_destroyed(id):
						if not id in data().has_been_attacked:
							data().has_been_attacked.append(id)
							attack_enemy(id,operator)
		else:
			if not object.is_destroyed(target):
				attack_enemy(target,operator)
	
	## Ratskulls bei David
	if target in data().ratskulls_david:
		for id in data().ratskulls_david:
			if not object.is_destroyed(id):
				if not id in data().has_been_attacked:
					data().has_been_attacked.append(id)
					attack_enemy(id,operator)

		if not object.is_destroyed("DAVID"):
				object.turn_to_object("DAVID", operator)
	
	## Ratskulls bei Sara
	if target in data().ratskulls_camp:
		for id in data().ratskulls_camp:
			if not object.is_destroyed(id):
				if not id in data().has_been_attacked:
					data().has_been_attacked.append(id)
					attack_enemy(id,operator)

def attack_enemy(char, enemy=None):
	#print ">>> attack_enemy for char",char
	object.cancel_commandos(char)
	if char in schedules.schedules.keys():
		prohibit_activity(char)
	enemys = character.get_visible_enemies(char)
	# print ">>> visible enemys for char",char,"are", enemys
	mindist = 100
	closest = None

	if enemy == None and len(enemys):
		for enemy in enemys:
			if object.get_distance(enemy, char) < mindist:
				closest = enemy
				mindist = object.get_distance(enemy, char)
		enemy = closest

	if enemy != None and not object.is_destroyed(enemy):
		object.attack(char, enemy)
		object.turn_to_object(char, enemy)

def on_pick_up( character_id, item_id, item_type ):
	#print "[debug: on_pick_up()", character_id, item_id, item_type,"]"

	if item_id==data().Obj_FluxCompensator:
		if not data().MartyPlixKompensator:
			if character_id=="ALTER_EGO":
				dialogs.initCutscene_Dlg_037_PlixCapacitor()
				data().MartyPlixKompensator = True
				return True
			else:
				dialogs.MercenaryDenyTalk(character_id,'useitem')
				return False

	if item_id==data().Obj_DavidsDiary:
		if character_id == "ALTER_EGO":
			if not data().tagebuch_gelesen:
				dialogs.initCutscene_Dlg_005_Diary()
				data().tagebuch_gelesen = True
			return True
		else:
			dialogs.MercenaryDenyTalk(character_id,'useitem')
			return False

	if item_id==data().Obj_TatteredNote:
		if character_id=="ALTER_EGO":
			dialogs.initDlg_021_ZettelGefunden()
			return True
		else:
			dialogs.MercenaryDenyTalk(character_id)
			return False
	#if item_id in ["RAT_MEAT_1","RAT_MEAT_2"]:
	#	return False
	return True
	
def InitChestsSafes():
	object.add_closed_lock("BUILDING_18774", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_18775", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_18776", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_18803", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_7628", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_18807", "lock1", closure_type='normal')
	object.add_closed_lock("MAPS_BUILDING_7758", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_18811", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_18812", "lock1", closure_type='booby-trap')

def init_patch():
	if "ANIE" in system.get_npcs():
		if object.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True

	init_main_npcs()
	#reinit  Bobby-Cry-Sound
	object.set_attribute("BOBBY", "playing_sound", None)
	#Sammy berichtigen
	object.set_attributes("VILLAGE2_SAMMY", model="child", clothes="childgang_01",face="002")
	character.update_appearance("VILLAGE2_SAMMY")

	#QB-Entry berichtigen
	if system.get_qb_entry_state(data().QB_009) == COMPLETE:
		system.set_qb_entry_text(data().QB_009,id_reward="ZONE2_AIM_09_REWARD_02")
		
	#Falls reporterquest geloest-> minimap-marker einblenden
	if system.get_qb_entry_state(data().QB_007) == COMPLETE:
		system.add_minimap_marker(845.17, 329.47,"MM_005")# Verlassenes Fabrikgelände

def init_main_npcs():
	npcs = system.get_npcs()
	if "TRADER" in npcs:
		character.set_main_quest_npc_state(char="TRADER", state=True)
	if "FREDO" in npcs:
		character.set_main_quest_npc_state(char="FREDO", state=True)
	if "TIMETRAVELLER" in npcs:
		character.set_main_quest_npc_state(char="TIMETRAVELLER", state=True)
