# -*- coding: utf-8 -*-
from globals import *
import dialogs
import npc
import water
import object_events
import object
from const import *
import schedules
from dynamic_camera import *
import math
import enemy_script
import char_autogeneration
import cs_function as cs

#*** actual revison: Revision 58, 17.08.2004 ***********************************

# äöü (better)

def initParties():
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="NPCS",type=PT_COMPUTER)
    system.create_party(id="ANIMALS",type=PT_COMPUTER)
    system.create_party(id="RATSKULLS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
    start_locations = {"NORTH":(311.0, 224.0),"SOUTH":(412.0, 774.0),"WEST":(217.0, 469.0),"EAST":(586.0, 549.0)}
    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registered: " + enterdirection

def on_init():
    skies.init_sky_preset("orange")

## init objects that are modified by script
def initScriptUseObjects():

#anderes
    system.mark_for_script_use(data().Obj_BisonKadaver)
    system.mark_for_script_use(data().Obj_Bunker1)
    system.mark_for_script_use("BUILDING_2552")
    system.mark_for_script_use("BUILDING_2768")

# bonfires - for cooking
    system.mark_for_script_use('BUILDING_1133')
    system.mark_for_script_use('BUILDING_1590')
# windrad
    system.mark_for_script_use("BUILDING_502")
    system.mark_for_script_use("BUILDING_363")

#stein der das rslager sperrt
    system.mark_for_script_use("BUILDING_13097")
    object.set_active_state("ZONE_3_BUILDING_13097", INACTIVE)

#kisten, truhen, tresore
    system.mark_for_script_use("BUILDING_7824")

    system.mark_for_script_use("BUILDING_15361")
    system.mark_for_script_use("BUILDING_7796")
    system.mark_for_script_use("BUILDING_15363")
    system.mark_for_script_use("BUILDING_15366")
    system.mark_for_script_use("BUILDING_15379")
    system.mark_for_script_use("BUILDING_15382")
    system.mark_for_script_use("BUILDING_15411")
    system.mark_for_script_use("BUILDING_15439")
    system.mark_for_script_use("BUILDING_15440")
    system.mark_for_script_use("BUILDING_15441")

# tresor im bunker
    object.add_closed_lock(data().Obj_KisteLuke, "lock1", closure_type='normal')

# Bienenstöcke Zone 3
    system.mark_for_script_use('BUILDING_15559')
    system.mark_for_script_use('BUILDING_15557')
    system.mark_for_script_use('BUILDING_15555')
    system.mark_for_script_use('BUILDING_15556')

    object.create_item_in_inventory( 'BUILDING_15559', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_15557', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_15555', equipment=[ 'SET_BEESWAX' ] )


def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
#spezielle non rest regionen
        system.add_region("Dorf",590,620,445,780)
        system.add_region("Distillery",525,385,570,420)
        system.add_region("Waffenlager2",445,265,550,205)
        system.add_region("Bauernhof",235,395,350,465)
        system.add_region("Einsiedler",530,525,580,560)
        system.add_region("Gonzos_Feld",245,595,340,695)

    data("rest").non_rest_areas.append("Dorf")
    data("rest").non_rest_areas.append("Distillery")
    data("rest").non_rest_areas.append("Waffenlager")
    data("rest").non_rest_areas.append("Bauernhof")
    data("rest").non_rest_areas.append("Einsiedler")
    data("rest").non_rest_areas.append("Gonzos_Feld")

#minenfelder
    data("rest").non_rest_areas.append("MINEFIELD1")
    data("rest").non_rest_areas.append("MINEFIELD2")
    data("rest").non_rest_areas.append("MINEFIELD3")
    data("rest").non_rest_areas.append("MINEFIELD4")
    data("rest").non_rest_areas.append("MINEFIELD5")
    data("rest").non_rest_areas.append("MINEFIELD6")
    data("rest").non_rest_areas.append("MINEFIELD7")
    data("rest").non_rest_areas.append("MINEFIELD8")
    data("rest").non_rest_areas.append("MINEFIELD9")
    data("rest").non_rest_areas.append("MINEFIELD9a")
    data("rest").non_rest_areas.append("MINEFIELD9b")
    data("rest").non_rest_areas.append("MINEFIELD10")
    data("rest").non_rest_areas.append("MINEFIELD11")
    data("rest").non_rest_areas.append("MINEFIELD12")
    data("rest").non_rest_areas.append("MINEFIELD13")
    data("rest").non_rest_areas.append("MINEFIELD14")
    data("rest").non_rest_areas.append("MINEFIELD15")

def on_map_loaded():
    init_data()
    initParties()
# place player characters
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )

    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

    npc.initNPCS()
    npc.initAnimals()
    char_autogeneration.init_Mercenary('MERCENARY_HENRY')
    initItems()
    initHerbs()
    initAggro()
    initExitZones()
    initFX()
    initMinimapMarkers()
    initEquipment()
    system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
    system.notify_timer(data().Timer_TiereAergern,data().Timervalue_TiereAergern)
    init_character_states()

# initQuestbook
    for i in range(2,25):# qutes 2-24 incluses
       exec("data().QB_%.3d = system.register_qb_entry('ZONE3_AIM_%.2d')" %(i,i))

# init region
    system.add_region("MiaAndPiaAtHome", 512,705,494,718)
    system.notify_region_entered(region="MiaAndPiaAtHome", objectid="MIA")
    system.notify_region_entered(region="MiaAndPiaAtHome", objectid="PIA")
    system.add_region("GonzosFeld", 284, 656, 266, 630)
    system.notify_region_entered(region="GonzosFeld", partyid="UISPIELER")

    system.add_region("bison_escape_zone", 205,347,269,395)
    object.set_attribute( "BISON", "escape_region", "bison_escape_zone" )
    object.set_attribute( "BISON", "foes", ["UISPIELER"])

    system.add_region(data().Region_Destillerie, 531, 431, 577, 374)
    system.notify_region_entered(data().Region_Destillerie, partyid="UISPIELER")

    system.add_region("REGION_HUMVEE_Z3", 362.92, 770, 332.01, 745.28)
    system.notify_region_entered(region="REGION_HUMVEE_Z3", partyid="UISPIELER")

    if not data().NoRatskulls:
        system.add_region("SaeuferAmFeuer", 502, 726, 514, 716)
        system.notify_region_entered(region="SaeuferAmFeuer", partyid="UISPIELER")
        system.add_region("SaeuferRatskulls", 518, 386, 588, 420)
        system.notify_region_entered(region="SaeuferRatskulls", partyid="UISPIELER")
        system.add_region("BunkerKommentar", 488, 224, 538, 262)
        system.notify_region_entered(region="BunkerKommentar", partyid="UISPIELER")
        system.add_region("GeorgsTraktor", 480, 208, 506, 238)

# minenfeld
# "Dere c'n onlie be whin t'ousand!" --- man kann ja nie genug regionen haben
        system.add_region("MINEFIELD1", 332, 0, 346, 202)
        system.add_region("MINEFIELD2", 336, 200, 360, 238)
        system.add_region("MINEFIELD3", 344, 236, 362, 258)
        system.add_region("MINEFIELD4", 358, 252, 364, 286)
        system.add_region("MINEFIELD5", 360, 280, 382, 294)
        system.add_region("MINEFIELD6", 374, 290, 388, 318)
        system.add_region("MINEFIELD7", 384, 324, 406, 314)
        system.add_region("MINEFIELD8", 400, 320, 422, 346)
        system.add_region("MINEFIELD9", 436, 356, 450, 342) # the one! abschalten nach dem kuh massaker
        system.add_region("MINEFIELD9a", 418, 356, 436, 342)
        system.add_region("MINEFIELD9b", 450, 356, 540, 342)
        system.add_region("MINEFIELD10", 566, 336, 536, 354)
        system.add_region("MINEFIELD11", 580, 314, 564, 340)
        system.add_region("MINEFIELD12", 608, 304, 578, 318)
        system.add_region("MINEFIELD13", 610, 308, 602, 282)
        system.add_region("MINEFIELD14", 608, 286, 628, 270)
        system.add_region("MINEFIELD15", 624, 272, 642, 174)

        for mf in ["MINEFIELD1","MINEFIELD2","MINEFIELD3","MINEFIELD4",
            "MINEFIELD5", "MINEFIELD6","MINEFIELD7","MINEFIELD8",
            "MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
            "MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
            "MINEFIELD15"]:
                system.notify_region_entered(region=mf, partyid = "UISPIELER")
                system.notify_region_entered(region=mf, objectid = "LUKE_Z3")

        system.add_region("MINEFIELD FIRST WARNING", 376, 456, 426, 432)
        system.notify_region_entered(region="MINEFIELD FIRST WARNING", partyid="UISPIELER")
        system.add_region("MINEFIELD SECOND WARNING", 422, 348, 464, 394)
        system.notify_region_entered(region="MINEFIELD SECOND WARNING", partyid="UISPIELER")

        system.add_region("MINEFIELD PATH ENTRY", 432, 354, 452, 365)
        system.notify_region_entered(region="MINEFIELD PATH ENTRY", partyid="UISPIELER")

    else:
        system.add_region("Waffenlager", 448, 211, 542, 258)
        system.notify_region_entered(region="Waffenlager", partyid="UISPIELER")

    system.add_region("Steinbruch1", 564, 684, 580, 658)
    system.add_region("Steinbruch2", 538, 642, 564, 654)
    system.add_region("Bergtigerin", 201, 611, 241, 581)
    system.notify_region_entered(region="Bergtigerin", partyid="UISPIELER")

    init_bunker_destroyed()

    initScriptUseObjects()
    InitChestsSafes()
    initWaterResources()
    checkZoneDependencies()
    schedules.init_schedules() ## immer nach dem initQuestbook()
    init_questitems()
    anim_windrad()
    init_non_rest_areas()

    system.create_object('SET_HUMVEE', 345.58, 760.64, id = 'HUMVEE_Z3', direction = 45)
    object.set_attribute('HUMVEE_Z3', 'accepted_drivers', ['UISPIELER'])

    object.set_active_state("DONALD RUMS", 0)

#bunker interieur verschieben
    init_destroy_bunker_reposition_interior()
    init_main_npcs()

def init_bunker_destroyed():
    system.create_object("RES3D_TRES_OBJECTS_BUILDING_BUNKER_L_DESTROY",
        object.get_x("ZONE_3_BUILDING_10532"),
        object.get_y("ZONE_3_BUILDING_10532"),
        'BUILDING_BUNKER_SPRENGUNG',
        object.get_direction("ZONE_3_BUILDING_10532"))

    object.set_active_state("BUILDING_BUNKER_SPRENGUNG",INACTIVE)
    system.mark_for_script_use("ZONE_3_BUILDING_10532")
    system.mark_for_script_use("BUILDING_BUNKER_SPRENGUNG")

# boxes at weapon storage
#    system.create_object("SET_AMMOPACK_7_65_MM", 518.29, 252.36, "BUNKER_TRESOR_AMMOPACK_1", 0)
#    system.create_object("SET_AMMOPACK_7_65_MM", 518.16, 252.19, "BUNKER_TRESOR_AMMOPACK_2", 150)
#    system.create_object("SET_MICRO_UZI", 517.91, 252.33, "BUNKER_TRESOR_UZI", 80)
#    system.create_object("SET_AMMOPACK_7_65_MM", 518.23, 252.18, "BUNKER_TRESOR_AMMOPACK_3", 230)

#    reposition_bunker_tresor_stuff()

def reposition_bunker_tresor_stuff():
    object.set_position_free("BUNKER_TRESOR_AMMOPACK_1", 518.30, 252.0, 0.70, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
    object.set_position_free("BUNKER_TRESOR_AMMOPACK_2", 518.10, 252.0, 0.70, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
    object.set_position_free("BUNKER_TRESOR_UZI", 517.80, 252.0, 0.70, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
    object.set_position_free("BUNKER_TRESOR_AMMOPACK_3", 518.20, 252.0, 0.16, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
    object.set_position_free("Z3 RATSKULL_DIARY", 518.0, 252.0, 0.16, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")

def anim_windrad(objectid=None):
    object.play_animation('BUILDING_502','ANIM_WINDRAD',callback=['ONEND',anim_windrad])
    if not hasattr(data(),"windradsound"):
        data().windradsound=True
        sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_502', loop=True)

## check if any zone-dependent quests are active
def checkZoneDependencies():
    if was_zone_entered("zone_5.zone_5"):
        if data("zone_5.zone_5").Familie_wird_Eskortiert:
            if data().felsenwohungsbesichtigung  == 0:
                data().ian_linda_paula_folgen = True

# init all water ressources
def initWaterResources():
    water.set_water_source(534.0,214.4, 4)
    water.set_water_source(553.5,383.9, 3)
    water.set_water_source(527.5,648.5, 2)
    water.set_water_source(405.9,630.2, 1)

# setzt chars mortal bzw immortal
def init_character_states():
    npcs = system.get_npcs()
    for npc in npcs:
        object.set_immortal_state(npc, False)
        if npc not in RATSKULLS + RATSKULLS_BUNKER:
            if not npc in ["DONALD RUMS", "HERMAN", "EINSIEDLER", "GONZO", 'MERCENARY_HENRY']:
                object.set_immortal_state(npc, True)

# initialisiert die questitems, die man durch das killen eines npcs bekommen kann
def init_questitems():
    object.create_item_in_inventory("DONALD RUMS","SET_C4_REMOTE_CONTROL",data().obj_DonaldsC4)
    object.set_attribute(object=data().obj_DonaldsC4, attribute="generic_item", value=False)

    object.create_item_in_inventory("MCKANZEE", "SET_CAR_BATTERY", id=data().obj_Autobatterie)
    object.set_attribute(object=data().obj_Autobatterie, attribute="generic_item", value=False)

def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    init_non_rest_areas()
    checkZoneDependencies()
    schedules.init_schedules()
    init_patch()

def on_post_load():
    initFX()
    checkZoneDependencies()
    schedules.init_schedules()
    init_patch()

def on_approach(target, operator):
    if not object_events.on_approach(target, operator):
#        if target == "LUISA":
#            stop_sound_luisa_cry()
        dialogs.on_approach(target, operator)

def on_wait_for_commando(id):
    if id=="GEORG" and data().Georg_LiegtUnterTraktor and not data().Georg_GenugGelegen:
        character.play_animation(id, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP")
        return True

    if id=="RATSKULLS A" and data().BesoffeneRatskullSchlaeft:
        character.play_animation(id, "CM_NPC_LIEGEN_LOOP")
        return True

    if (id in ["MIA","PIA"] and system.get_qb_entry_state(data().QB_012) != COMPLETE):
           return schedules.Activity(id)

    if ((id == "DOERFLER A" and not data().Doerfeler_TA_gestartet) 
       or (id == "DOERFLER B" and not data().Doerfeler_TA_gestartet) 
       or (id == "DOERFLER C" and not data().Doerfeler_TA_gestartet) 
       or (id == "GONZO" and data().gonzo_killing_spree) 
       or (id == "GEORG" and not (data().Georg_GenugGelegen 
            and system.get_qb_entry_state(data().QB_004) in [UNCOMPLETE,COMPLETE]))):
                return False

    if (id == 'JIMMY'):
        if data().Jimmy_Kartoffeln_Klauen:
            if not data().Jimmy_Klaut:
                character.play_animation(id, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_START')# 'CM_KNIEND_WASSERLOCH_GRABEN_START')
                character.play_animation(id, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP')# 'CM_KNIEND_WASSERLOCH_GRABEN_LOOP')
                data().Jimmy_Klaut = True
                return True
            if random.choice([1,0,0,0]):
                character.play_animation(id, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE')# 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE')
                data().Jimmy_Klaut = False
                pos = random.choice(JIMMY_KARTOFFEL_KLAUEN)
                object.move_to(id, pos[0], pos[1], callback = ['ONEND', Jimmy_Kartoffeln_Klauen_Start])
                return True
            return schedules.Activity(id)

        elif data().Jimmy_Tiere_Aergern and system.get_mission_time().get_day_time() >= time("12:30:00") and system.get_mission_time().get_day_time() <= time("16:00:00"):
            if not len(data().Animales):
                return True
            data().Tier = random.choice(data().Animales)
            data().Animales.remove(data().Tier)
            object.move_to_object('JIMMY', data().Tier, callback = [['ONEND', Lambda('object.turn_to_object("JIMMY", "%s")' %data().Tier)],
                                                                  ['ONEND', Tier_Aergern]])
            return True

    return schedules.Activity(id)

def Tier_Aergern(id):
    character.play_animation(id, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN', callback = ['ONEND', Lambda('Kuh_Haut_Ab("%s")'%data().Tier)])
    sounds.play_3d_sound(sfx_id="cow_1", x=object.get_x(id), y=object.get_y(id), z=0)

def Kuh_Haut_Ab(id):
    pos = random.choice(TIERE_BAUERNHOF)
    object.move_to(id, pos[0], pos[1],speed = MT_FAST, callback = ['ONEND', Lambda('data().Animales.append("%s")'%id)])

def Jimmy_Kartoffeln_Klauen_Start(id):
    pos = random.choice(JIMMY_KARTOFFEL_KLAUEN)
    object.move_to(id, pos[0], pos[1], callback = ['ONEND', Lambda('data().Jimmy_Kartoffeln_Klauen = True')])

def Jimmy_Kartoffeln_Klauen_Ende(id):
    character.play_animation(id, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE')# 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE')
    data().Jimmy_Kartoffeln_Klauen = False

def stop_sound_luisa_cry():
    if object.has_attribute("LUISA", "playing_sound"):
        object.set_attribute("LUISA", "playing_sound", None)
        sounds.stop_sound(id="LUISA_CRYING")

def start_sound_luisa_cry():
    if not object.has_attribute("LUISA", "playing_sound"):
        object.set_attribute("LUISA", "playing_sound", "LUISA_CRYING")
        sounds.play_3d_sound_object(sfx_id="crying_female",object="LUISA", loop=True, identifier="LUISA_CRYING")

def check_luisa_crying():
    if not object.is_destroyed("LUISA"):
        if ((system.get_qb_entry_state(data().QB_012) in [INACTIVE, UNCOMPLETE]) and 
            (not system.get_qb_entry_state(data().QB_011) == COMPLETE)):
            if get_location("LUISA") != 1:
                start_sound_luisa_cry()
                system.notify_timer(data().Timer_Luisa_Cry, 20000)
            else:
                stop_sound_luisa_cry()
                system.notify_timer(data().Timer_Luisa_Cry, 20000)
        else:
            stop_sound_luisa_cry()
            system.notify_timer(data().Timer_Luisa_Cry, 20000)
    else:
        stop_sound_luisa_cry()

def on_timer(id):
    if id == data().Timer_Luisa_Cry:
        check_luisa_crying()

    if id == data().Timer_RatskullASnork:
        if not object.is_destroyed("RATSKULLS A"):
            if data().BesoffeneRatskullSchlaeft:
                sounds.play_3d_sound_object(sfx_id="snoring_drunken_female",object="RATSKULLS A")
                system.notify_timer(data().Timer_RatskullASnork, random.randint(13000, 19000))


    if id == data().Timer_BarbaraAutsch:
        dialogs.onBarabaraKilled()

    if id == data().Timer_DonaldAnsprache:
        if not data().spieler_von_donald_angesprochen:
            if object.get_distance("ALTER_EGO", "DONALD RUMS") <= 5.0:
                if object.is_destroyed("DONALD RUMS"):
                    return
                for id in system.get_pcs():
                    object.cancel_commandos(id)
                    if id != "ALTER_EGO":
                        object.turn_to_object(id, "DONALD RUMS")
                    else:
                        object.turn_to_object(id, "DONALD RUMS", callback=["ONEND",Lambda('dialogs.initDlg_008_Sprengmeister_WillNichtJagen()')])
                        data().spieler_von_donald_angesprochen = True
            else:
                system.notify_timer(data().Timer_DonaldAnsprache,data().Timervalue_DonaldAnsprache)

#print "[debug on_timer()",id,"]"
    if id == data().Timer_CutsceneResponder:
        if ((not system.is_cutscene()) and (not dialog.is_dialog_active())):
            system.fade(FADE_OUT)
            data().counter_fade = 1
            system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
        else:
            system.notify_timer(data().Timer_CutsceneResponder,data().Timervalue_CutsceneResponder)

    if id == data().Timer_GonzoScene:
            if object.is_destroyed("BARBARA"):
                end_cutscene(chars=[])
                system.fade(FADE_IN)
# system.set_qb_entry_state(data().QB_014, IMPOSSIBLE)
            else:
                if data().counter_fade == 1:
                    object.cancel_commandos("GONZO")
                    object.move_to("GONZO", 507.14,708.30, "landscape",MT_SLOW, callback=["ONEND",GonzoKilledSeineFrau])
                    data().counter_fade = 0
                    system.fade(FADE_IN)
                    system.start_cutscene()
                    system.set_camera_view(CAMVIEW_GONZOBARBARA_INTRO)#CAMVIEW_GONZO_KILLS_BARBARA_1)
                    system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)

    if id == data().Timer_GonzoSceneCam:
            if object.is_destroyed("BARBARA"):
                system.fade(FADE_OUT)
                system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
            else:
                if ((not system.is_cutscene()) and (not dialog.is_dialog_active())):
                    system.fade(FADE_OUT)
                    data().counter_fade = 1
                    system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
                else:
                    object.cancel_commandos("GONZO")
                    system.notify_timer(data().Timer_CutsceneResponder,data().Timervalue_CutsceneResponder)

    if id == data().Timer_DonaldWiederRaus:
        object.step_to("DONALD RUMS",571.40, 645.77, speed=globals.MT_SLOW)
        allow_activity("DONALD RUMS")

    if id == data().Timer_LukeFolgt:
        if data().luke_folgt:
#object.move_to_object("LUKE_Z3","ALTER_EGO")
            if object.get_distance("ALTER_EGO","LUKE_Z3")>=30.0:
                object.cancel_commandos("LUKE_Z3")
                dialogs.initDlg_108_LukeWillNichtMehr()
            else:
                if object.get_distance("LUKE_Z3",data().Obj_KisteLuke) <= 8.0:
                    data().luke_an_kiste = True
                    data().luke_folgt = False
                    prohibit_activity("LUKE_Z3")
                    dialogs.initCutscene_110_LukeInspiziertDasSchloss()
                else:
                    system.notify_timer(data().Timer_LukeFolgt,data().Timervalue_LukeFolgt)

    elif id==data().Timer_BunkerRedskullsAppear:
        ratskulls_bunker_appear()

    elif id==data().Timer_Zone4Comment:
        if not dialog.is_dialog_active():
            if was_zone_entered("zone_4.zone_4"):
                if  (system.get_qb_entry_state(data("zone_4.zone_4").QB_010 ) in [UNCOMPLETE]):
                    dialogs.initDlg_070_Spieler_Zone4Comment()
            else:
                dialogs.initDlg_070_Spieler_Zone4Comment()
        else:
            system.notify_timer(data().Timer_Zone4Comment,data().Timervalue_Zone4Comment)

    elif id==data().Timer_GonzoGelaber:
        system.notify_region_entered(region="GonzosFeld", partyid="UISPIELER")

    elif id==data().Timer_GonzoTimeout:
        if not object.is_destroyed("GONZO"):
            data().gonzo_killing_spree = True
            finish_activity("BARBARA")
            finish_activity("GONZO")
            prohibit_activity("BARBARA")
            prohibit_activity("GONZO")
            object.move_to("BARBARA",507.1,707.68, "landscape",MT_SLOW)
            object.turn_to_direction("BARBARA",globals.DIR_SOUTH)
            object.set_attribute( object="GONZO", attribute="foes", value=["UISPIELER"])
            object.move_to("GONZO", 354.0, 662.44, "landscape", MT_FAST)
            object.move_to("GONZO", 434.0, 662.44, "landscape", MT_FAST)
            lambda_string = "system.notify_timer(data().Timer_GonzoSceneCam,data().Timervalue_GonzoSceneCamSwitch)"
            object.move_to("GONZO", 499.0, 691.44, "landscape", MT_FAST, callback=["ONEND",Lambda(lambda_string)])
            object.move_to("GONZO", 507.14,708.30, "landscape",MT_SLOW)

    elif id==data().Timer_GeorgRepariertTraktor:
        system.notify_region_entered(region="GeorgsTraktor", partyid="UISPIELER")

    elif id==data().Timer_Kuh_Massaker:
        if data().Kuh_Massaker==0:
            object.move_to(object="KUH1", x=442, y=354, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuh1Explode])
            data().Kuh_Massaker = data().Kuh_Massaker + 1
            system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_2)
        elif data().Kuh_Massaker==1:
            object.move_to(object="KUH2", x=446, y=352, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuhExplode])
            data().Kuh_Massaker = data().Kuh_Massaker + 1
            system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_3)
        elif data().Kuh_Massaker==2:
# dont move player char
# object.move_to(object="ALTER_EGO", x=450, y=364, grid="landscape")
            data().Kuh_Massaker = data().Kuh_Massaker + 1
            system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_4)
        elif data().Kuh_Massaker==3:
            object.move_to(object="KUH3", x=442, y=346, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuhExplode])
            data().Kuh_Massaker = data().Kuh_Massaker + 1
            system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_5)
        elif data().Kuh_Massaker==4:
            object.move_to(object="KUH4", x=446, y=344, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuh4Explode])
            data().Kuh_Massaker = data().Kuh_Massaker + 1
            system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_6)
        elif data().Kuh_Massaker==5:
            object.move_to(object="KUH5", x=444, y=335, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuh5Survive])
            data().Kuh_Massaker = data().Kuh_Massaker + 1
            system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_7)
        elif data().Kuh_Massaker==6:
            object.move_to(object="GEORG", x=416.66,y= 365.22, grid="landscape", speed=MT_SLOW)
            data().Kuh_Massaker = data().Kuh_Massaker + 1
# system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_8)

# wird jetzt für die Steuerung des RATSKULLS WAFFENLAGER D genutzt bei der Kuhanimation
    elif id==data().Timer_ratskull_discuss_dead_cows:
        object.move_to("RATSKULLS WAFFENLAGER D",495.32, 262.87, callback = ['ONEND', Lambda('object.turn_to_direction("RATSKULLS WAFFENLAGER D", globals.DIR_WEST)')])

    elif (id==data().Timer_SpawnTimeChecker):
        clock = system.get_mission_time().get_day_time()
        system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
        if not data().BergtigerDead:
            starteTimerBergtigerin()
        if (clock >= time("06:00:00") and clock < time("22:00:00")):
            npc.spawnAnimals(INACTIVE)
        else:
            npc.spawnAnimals(ACTIVE)

## Zeitauslöser ... Auftauchen und verschwinden des Bergtigers
## (triggert alle halbe Stunde zwischen 22:45:00 und 3:15:00) siehe starteTimerBergtigerin()
## hört auf zu triggern sobald der Bergtiger tot ist
    elif (id==data().Timer_BergTigerChecker):
        if data().BergtigerDead == False:
            clock = system.get_mission_time().get_day_time()
            if (clock >= time("22:45:00") or clock < time("3:15:00") and data().D_93_Ende2_gelaufen):
                system.notify_timer(data().Timer_BergTigerChecker,data().Timervalue_BergtigerChecker)
                if (clock >= time("0:00:00") and clock < time("2:00:00")):
                    spawnBergtigerin(ACTIVE)
                else:
                    spawnBergtigerin(INACTIVE)

## Georg hat genug gelegen, jetzt geht sein TA los
    elif (id==data().Timer_GeorgGenugGelegen):
        data().Georg_LiegtUnterTraktor = False
        finish_activity("GEORG")
        character.set_approachable_state("GEORG",NOTAPPROACHABLE)
        object.step_to("GEORG",496.0,227.5,MT_SLOW)
        object.move_to("GEORG",443.99,339.72, "landscape",MT_SLOW,callback=["ONEND",onGeorgSavesKuh5])

    elif (id == data().Timer_Wilma_Rufen):
        dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung_2()

## Georg rettet die 5te Kuh aus dem Minenfeld
def onGeorgSavesKuh5(id):
    object.turn_to_object("GEORG","KUH5")
    character.play_animation("GEORG","CM_NPC_TIER_FUETTERN_START")
    character.play_animation("GEORG","CM_NPC_TIER_FUETTERN_LOOP")
    character.play_animation("GEORG","CM_NPC_TIER_FUETTERN_ENDE",callback=["ONEND",makeTAActive])

def makeTAActive(id):
    object.move_to("GEORG",439.5,360.5, "landscape",MT_SLOW)
    object.move_to("KUH5",439.5,360.5, "landscape",MT_SLOW)
    object.move_to("KUH5",data().Pos_Kuehe["KUH5"][0],data().Pos_Kuehe["KUH5"][1], "landscape",MT_SLOW)
    data().Georg_GenugGelegen = True

def MineKaBumm(id):
    x,y,z = object.get_position(id)
    system.start_effect(startx=x,starty=y,startz=0,dirx=x,diry=y,dirz=0,
                        parameter=fx_explosion_medium)
    sounds.play_3d_sound(sfx_id="z3_landmine",x=x,y=y,z=0)

def on_enter_region(id, objectid, partyid):
    print "[on_enter_region(",id, str(objectid), partyid,"]" #jan
# non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid):objectid=objectid[0]
        else:return

    if id == 'REGION_HUMVEE_Z3':
        if not data().HUMVEE_Z3_Untersucht:
            dialogs.initDlg_133_HUMVEE()

    elif id=="MiaAndPiaAtHome":
        if objectid == "MIA":
            data().ZwillingsQuest_MiaAtHome = True
        elif objectid == "PIA":
            data().ZwillingsQuest_PiaAtHome = True
        else:
            assert False
        if data().ZwillingsQuest_MiaAtHome and data().ZwillingsQuest_PiaAtHome:
            data().miapia_folgen = False
            stop_sound_luisa_cry()
            system.set_qb_entry_state(data().QB_012, COMPLETE)
            character.add_experience_party( experience=data().Exp_MiaAndPia )

    elif id=="GonzosFeld":
        if not data().GonzoQuest_Gonzo_Dead and not system.get_qb_entry_state(data().QB_014) == UNCOMPLETE:
            system.notify_timer(data().Timer_GonzoGelaber, random.randint(7, 14) * 1000)
            if not dialog.is_dialog_active():
                if not ((get_location("GONZO") == LOCATION_1) or (get_location("GONZO") == LOCATION_2)):
                    dialogs.initDlg_023_Gonzo_AckertAufDemAcker()

    elif id=="GeorgsTraktor":
        if data().Georg_LiegtUnterTraktor:
            if not dialog.is_dialog_active():
                dialogs.initDlg_006_Bauer_TraktorKaputt()
        system.notify_timer(data().Timer_GeorgRepariertTraktor, random.randint(10, 30) * 1000)

    elif id=="SaeuferAmFeuer":
        if not data().DoerflerKilled > 0:
            if data().SchnappsQuest_Ratskulls_Killed < 2:
                if system.get_qb_entry_state(data().QB_006) == INACTIVE:
                    dialogs.initCutscene_Dlg_018_Doerfler_WoIstDerSchnapps()
            if data().SchnappsQuest_Ratskulls_Killed >=2:
                data().Doerfeler_TA_gestartet = True

    elif id=="SaeuferRatskulls":
        if (not object.is_destroyed("RATSKULLS A") and
        not object.is_destroyed("RATSKULLS B") and
        not object.is_destroyed("RATSKULLS C") and
        not data().ratskulls_schlafen):
            for id in ["RATSKULLS A","RATSKULLS B","RATSKULLS C"]:
                object.cancel_commandos(id)
                prohibit_activity(id)
                character.set_approachable_state(id,APPROACHABLE)
                dialogs.initCutscene_034_Ratskulls_WhiskyMachtSpass()

    elif id=="BunkerKommentar":
#        if data().Ratskulls_Waffenlager < 4:
#            system.notify_region_entered(region="BunkerKommentar", partyid="UISPIELER")
#        else:
        character.set_approachable_state("GEORG",APPROACHABLE)
        object.add_closed_lock("ZONE_3_BUILDING_10532", "lock1", closure_type='normal') #close the bunker
        dialogs.initCutscene_004_Spieler_BunkerUntersuchen()

    elif id=="Waffenlager":
        dialogs.initCutscene_Dlg_064_Spieler_Waffenlager()

    elif id=="Waffenlager2":
        print "waffenlager rein"
        onRatskullsAlarmOthers("RATSKULLS WAFFENLAGER D") #jan: alarm wenn region betreten

    elif (id in ["Steinbruch1", "Steinbruch2"]):
        if (not data().donald_schlaeft and
            not system.get_qb_entry_state(data().QB_005) in [COMPLETE] and
            not object.is_destroyed("DONALD RUMS")):
                system.notify_timer(data().Timer_DonaldAnsprache, data().Timervalue_DonaldAnsprache)

    elif id=="MINEFIELD FIRST WARNING":
        if not system.get_qb_entry_state(data().QB_002) in [UNCOMPLETE, COMPLETE]:
            if not data().pete_intro:
                data().pete_intro = True
                object.cancel_commandos('GEORG')
                object.turn_to_object("GEORG","ALTER_EGO", callback=["ONEND", onGeorgSightedPlayer])

    elif id=="MINEFIELD SECOND WARNING":
        if not data().MainQuest_IgnoreMines:
            if not system.get_qb_entry_state(data().QB_003) == COMPLETE:
                if system.get_qb_entry_state(data().QB_002) == INACTIVE:
                    object.cancel_commandos(objectid)
                    dialogs.initDlg_072_Warnung_Minenguertel()
                else:
                    object.cancel_commandos(objectid)
                    dialogs.initDlg_033_Spieler_KeinBockAufMinen()
        else:
            if data().luke_folgt:
                dialogs.initDlg_109_SpielerWarntLuke()

            elif object.is_destroyed("LUKE_Z3"):
                if not data().luke_leiche_gesehen:
                    data().luke_leiche_gesehen = True
                    dialogs.initDlg_116_LukeIstExplodiert()

    elif( id in ["MINEFIELD1", "MINEFIELD2","MINEFIELD3","MINEFIELD4",
            "MINEFIELD5","MINEFIELD6","MINEFIELD7","MINEFIELD8",
            "MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
            "MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
            "MINEFIELD15"]):
        if not (id=="MINEFIELD9" and data().MainQuest_IgnoreMines):
            pcs = system.get_pcs()
#print ">>> minefield -> pcs", pcs
            MineKaBumm(objectid)
            object.destroy(objectid)
            for pc in system.get_pcs():
                if not object.is_destroyed(pc):
                    object.cancel_commandos(pc)
                    object.turn_to_object(pc, objectid)
            if objectid in pcs:
                pass
#print ">>> minefield -> halt all pcs"


            system.notify_region_entered(region=id, partyid="UISPIELER")

        elif not data().MainQuest_BarbecueComment:
            data().MainQuest_BarbecueComment = True
            dialogs.initDlg_063_Kuehe_Lecker()

    elif id=="MINEFIELD PATH ENTRY" and data().MainQuest_IgnoreMines and \
        not data().MainQuest_BewareMinesDialog:
        data().MainQuest_BewareMinesDialog = True
        dialogs.initDlg_080_beware_mines()

    elif id=="Bergtigerin":
        if not data().player_knows_Bergtiger_Huegel:
            data().player_knows_Bergtiger_Huegel = True
#            system.add_minimap_marker(220.22,594.22,"MM_007")#Bergtigerin#
        if data().WaldemarHatGesagtWoDerTigerIst:
            if not data().BergtigerZoneGefunden:
                dialogs.initDlg_096_SpielerFindetBergtigerZone()
                data().BergtigerZoneGefunden = True
            else:
                if data().BergtigerAktiv:
                    dialogs.initDlg_097_SpielerFindetBergtiger()
                else:
                    clock = system.get_mission_time().get_day_time()
                    if (clock >= time("2:00:00") and clock < time("3:00:00")):
                        dialogs.initDlg_098_BergtigerHautAb()

    if (id=="Steinbruch1" or id=="Steinbruch2"):
        if not data().player_knows_Steinbruch:
            data().player_knows_Steinbruch = True
            system.add_minimap_marker(561,649,"MM_004")#Quarry

    if id==data().Region_Destillerie:
        if not data().player_knows_Destillerie:
            data().player_knows_Destillerie = True
            system.add_minimap_marker(555.43,400.53,"MM_008")# Destillerie Marker

def onGeorgSightedPlayer(char_id):
    dialogs.initDlg_001_Bauer_Warnung()

def GonzoKilledSeineFrau(id):
#system.set_camera_view(CAMVIEW_GONZO_KILLS_BARBARA)
    object.step_to("GONZO", 507.14,708.30,MT_SLOW)
    object.turn_to_object("GONZO","BARBARA")
    if data().gonzo_killing_spree:
        dialogs.initCutscene_050_Gonzo_MurkstSeineAlte()

# *KABUMM* eine der kühe ist auf ne mine getrampelt
def onKuhExplode(id):
    MineKaBumm(id)
    object.set_immortal_state(id,False)
    object.destroy(id)

def onKuh1Explode(id):
    onKuhExplode(id)
# peasant complains about dead cows
    dialogs.initDlg_061_Kuehe_Muh(id)
    dialogs.initDlg_003_Bauer_ArmeKuehe()
#system.set_qb_entry_state(data().QB_002,COMPLETE)
#system.set_qb_entry_state(data().QB_003,UNCOMPLETE)
    character.set_approachable_state("GEORG",NOTAPPROACHABLE)
    character.add_experience_party(data().Exp_Minenfeld)

def onKuh4Explode(id):
    onKuhExplode(id)
    data().MainQuest_IgnoreMines = True # path through mine field free
    system.notify_region_entered(region="Waffenlager2", partyid="UISPIELER")
    ratskull_hears_exploding_cow()

# die letzte kuh wundert sich
def onKuh5Survive(id):
    dialogs.initDlg_062_Kuehe_Muh(id)
    if not data().MainQuest_Dialog62:
        data().MainQuest_Dialog62 = True
        object.move_to(object="KUH5", x=444, y=336, grid="landscape", callback=["ONEND", dialogs.onKuhMoveMuh])

# callback fuer das zerstoeren/ toeten von objekten / npcs
def on_object_killed(victim, attacker, weapon_type, weapon_id):
    object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
    if victim == "DONALD RUMS":
        if system.get_qb_entry_state(data().QB_005) == INACTIVE:
            system.set_qb_entry_state(data().QB_019, IMPOSSIBLE)
            system.set_qb_entry_state(data().QB_020, IMPOSSIBLE)
            system.set_qb_entry_state(data().QB_021, IMPOSSIBLE)
            system.set_qb_entry_state(data().QB_022, IMPOSSIBLE)
            system.set_qb_entry_state(data().QB_023, IMPOSSIBLE)
            system.set_qb_entry_state(data().QB_005, IMPOSSIBLE)

    if victim == "EINSIEDLER":
        if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
            system.set_qb_entry_state(data().QB_008, IMPOSSIBLE)

    if victim == "HERMAN":
        pass

    if victim in ["MIA","PIA"]:
        if system.get_qb_entry_state(data().QB_011) == UNCOMPLETE:
            system.set_qb_entry_state(data().QB_011, IMPOSSIBLE)
        if system.get_qb_entry_state(data().QB_012) == UNCOMPLETE:
            system.set_qb_entry_state(data().QB_012, IMPOSSIBLE)

    if victim=="BARBARA":
        if system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
            system.set_qb_entry_state(data().QB_013, IMPOSSIBLE)
        if system.get_qb_entry_state(data().QB_014) == UNCOMPLETE:
            system.set_qb_entry_state(data().QB_014, IMPOSSIBLE)

    if victim=="GONZO" and not system.get_qb_entry_state(data().QB_014) == IMPOSSIBLE:
        dialogs.initDlg_026_Gonzo_RestInPieces()
        system.set_qb_entry_state(data().QB_014, COMPLETE)
        data().GonzoQuest_Gonzo_Dead = True

    if (victim=="GONZO" and (system.get_qb_entry_state(data().QB_013) == INACTIVE)
        and (system.get_qb_entry_state(data().QB_014) == INACTIVE)):
        data().GonzoQuest_Gonzo_Dead = True
        data().gonzo_dead_ohne_auftrag = True

    if victim in ["RATSKULLS B","RATSKULLS C"]:
        data().SchnappsQuest_Ratskulls_Killed = data().SchnappsQuest_Ratskulls_Killed + 1
        if data().SchnappsQuest_Ratskulls_Killed >=2:
            data().Doerfeler_TA_gestartet = True

    if(    victim in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B","RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]):
        data().Ratskulls_Waffenlager = data().Ratskulls_Waffenlager + 1
        if data().Ratskulls_Waffenlager >= 4:
#system.set_qb_entry_state(data().QB_003, COMPLETE)
            character.add_experience_party(data().Exp_Waffenlager_Aussen)

    if(    victim in ["RATSKULL_LEADER","RATSKULLS BUNKER A","RATSKULLS BUNKER B","RATSKULLS BUNKER C","RATSKULLS BUNKER D"]):
        data().Ratskulls_Bunker = data().Ratskulls_Bunker + 1
        if data().Ratskulls_Bunker >= 5:
#system.set_qb_entry_state(data().QB_004, COMPLETE)
            character.add_experience_party(data().Exp_Ratskulls_Bunker)
            system.notify_timer(timer=data().Timer_Zone4Comment, delay=data().Timervalue_Zone4Comment)

    if victim in data().Obj_Kuehe:
        randomBloodShed(victim)

    if victim in data().DoerflerDistilleryQuest:
        data().DoerflerKilled +=1
        if data().DoerflerKilled == 3:
            deactivateDestilleryQuest()

    if victim=="BERGTIGERIN":
        data().BergtigerDead = True
        if data().VonDonaldAufgabeBesorgeFleisch:
            dialogs.initDlg_099_BergtigerGekillt()
        else:
            dialogs.initDlg_130_SpielerHatBergtigerinErledigtOhneAuftrag()

    if victim == "BISON":
        data().BisonDead = True
        data().one_dead_bison_found = True

def deactivateDestilleryQuest():
    pass

def randomBloodShed(id):
    meat = ["SET_MEAT_RAW_TINY","SET_MEAT_RAW_SMALL","SET_MEAT_RAW","SET_MEAT_RAW_BIG","SET_MEAT_RAW_HUMONGOUS"]
    menge = random.randint(0,10)
    for item in range(menge):
        meattype = random.randint(0,len(meat)-1)
        x=object.get_x(id)
        y=object.get_y(id)
        dir = random.randint(0,359)
        distance = random.randint(0,2)
        mode = random.randint(0,8)
        if mode == 0:
            system.create_object(equipmenttype=meat[meattype],x=x+distance,y=y-distance,direction=dir)
        elif mode == 1:
            system.create_object(equipmenttype=meat[meattype],x=x-distance,y=y-distance,direction=dir)
        elif mode == 2:
            system.create_object(equipmenttype=meat[meattype],x=x+distance,y=y+distance,direction=dir)
        elif mode == 3:
            system.create_object(equipmenttype=meat[meattype],x=x-distance,y=y+distance,direction=dir)
        elif mode == 4:
            system.create_object(equipmenttype=meat[meattype],x=x,y=y+distance,direction=dir)
        elif mode == 5:
            system.create_object(equipmenttype=meat[meattype],x=x,y=y-distance,direction=dir)
        elif mode == 6:
            system.create_object(equipmenttype=meat[meattype],x=x-distance,y=y,direction=dir)
        elif mode == 7:
            system.create_object(equipmenttype=meat[meattype],x=x+distance,y=y,direction=dir)
        else:
            system.create_object(equipmenttype=meat[meattype],x=x-distance*2.0,y=y-distance*2.0,direction=dir)


def char_openes_bunker_tresure(char, blast=False):
    if char == "ALTER_EGO":
        if not data().schloss_geknackt:
            if data().luke_folgt or data().luke_an_kiste:
                return False
            if can_open_lock(char,blast):
                if not dialog.is_dialog_active():
                    dialogs.initDlg_103_SpielerWillKistenschlossOeffnen(char, with_crack=True)
                return True
            else:
                if not dialog.is_dialog_active():
                    dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(char)
                return True
    else:
        if not data().schloss_geknackt:
            if can_open_lock(char,blast):
                system.start_cutscene()
                system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
                char = data().spieler_am_schloss
                object.move_to(char,518.06, 249.5,"BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID",speed=MT_SLOW)
                object.step_to(char,518.06, 250.6,speed=MT_SLOW)
                object.turn_to_direction(char,globals.DIR_SOUTH)
                character.play_animation(char,"STEHEND_TUERSCHLOSS_KNACKEN",callback=["ONEND",on_char_opended_lock])
                return True

#*** crack lock callbacks
def can_crack_lock( character_id, object_id, dummy ):
    if object_id.endswith(data().Obj_KisteLuke):
        if can_open_lock(character_id, False):
            return True
        else:
            if not dialog.is_dialog_active() and not can_open_lock(character_id, True):
                if not data().schloss_knacken_1_fehlgeschlagen:
                    dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(character_id)
            return False
    print "global.can_crack_lock"
    return object_events.can_crack_lock( character_id, object_id, dummy )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id.endswith(data().Obj_KisteLuke):
#system.set_qb_entry_state(data().QB_015,COMPLETE)
#system.set_qb_entry_state(data().QB_016,INACTIVE)
        return char_openes_bunker_tresure(character_id,False)

    return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

#*** blast callbacks
def can_blast_lock( character_id, object_id, dummy ):
    if object_id.endswith(data().Obj_KisteLuke):
        if can_open_lock(character_id, True):
            data().can_blast_lock = True
            return True
        else:
            if not dialog.is_dialog_active() and not can_open_lock(character_id, False):
                if not data().schloss_knacken_1_fehlgeschlagen:
                    dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(character_id)
            data().can_blast_lock = False
            return False
    return object_events.can_blast_lock( character_id, object_id, dummy )

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id.endswith(data().Obj_KisteLuke):
        if char_openes_bunker_tresure(character_id, True):
            x,y,z = object.get_full_dummy_position(object_id, dummy_name)
            lambda_string = 'object_events.on_lock_explode(object_id="%s",dummy_name="%s",x=%i,y=%i,z=%i)' %(object_id, dummy_name, x,y,z)
            enemy_script.delay(2.5, Lambda(lambda_string))
            return True
        return False
    return object_events.on_blast_lock( character_id, object_id, dummy_name, x, y, z )

#*** use callbacks
def can_use( character_id, object_id ):
    if object_id == "Z3 RATSKULL_DIARY":
        return True
    return object_events.can_use( character_id, object_id )

def on_use( character_id, object_id, item_id, item_type ):
    if item_id == "Z3 RATSKULL_DIARY":
        dialogs.initDlg_132_SpielerLiestRatskulltagebuch()
        return True
    return object_events.on_use( character_id, object_id, item_id, item_type )

def on_steal(target, operator):
    """is called when a player char tries to steal something

operator - id of the thief
target   - id of the victim
"""
    inventorylist = object.get_inventory_list(target)
    pick_pocket = object.get_attribute(operator, "pick_pocket")

# Check for talent inside_pocket
    if target=="HERMAN":
        if pick_pocket >79:
            if has_talent( operator, "pick_pocket", "inside_pocket" ):
# if target ha snot yet an inside_pocket_item, then create one
                if not object.has_attribute( target, "inside_pocket_item" ):
                    inside_pocket_item_type = get_random_item()
                    inside_pocket_item_id = object.create_item_in_inventory( target, inside_pocket_item_type )
                    object.set_attribute( target, "inside_pocket_item", inside_pocket_item_id )

            if inventorylist:
# show the item panel but filter out the equiped items
                system.item_panel( operator, target, object_events.separate_out_callback )
        else: # heist was a failure
# target will abuse operator
            lambda_string = 'object_events.heist_failure( target="%s", operator="%s" )' %( target, operator )
            object.turn_to_object( target, operator, callback=[ "ONEND", Lambda( lambda_string ) ] )
    else:
        return object_events.on_steal(target, operator)

#
def can_examine_object( character_id, object_id ):

# bisonkadaver
    if object_id.endswith(data().Obj_BisonKadaver):
        if not data().bison_inspected:return True

    if object_id.endswith(data().Obj_KisteLuke):
        if not data().schloss_geknackt:return True

    if object_id=="RATSKULLS A":
        if data().BesoffeneRatskullSchlaeft:return True

    for substring in ["BUILDING_1564","BUILDING_1558","BUILDING_1420","BUILDING_1421"]:
        if object_id.endswith(substring):return True

    if object_id in ["DEAD_SHADOW"]:return True

    if object_id in ["BARBARA"]:
        if object.is_destroyed("BARBARA"):return True

    if object_id == data().obj_HermansPicklock:
        if (not data().spieler_hat_dietrich and data().luke_dietrich_gesucht):return True

    if object_id == 'ZONE_3_BUILDING_2747':
        if (data().car_battery_given or data().d_032_restart_c_001):return True

    if object_id in ['HUMVEE_Z3','ZONE_3_BUILDING_15331']:
        if not data().HUMVEE_Z3_Untersucht:return True

    return False

def on_examine_object( character_id, object_id ):
#print "on_examine_object()",character_id,object_id
    if object_id == data().Obj_KisteLuke:
        if can_open_lock(character_id, False) or can_open_lock(character_id, True):
            dialogs.initDlg_103_SpielerWillKistenschlossOeffnen(character_id, with_crack=False)
        else:
            dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(character_id)

    if object_id == data().obj_HermansPicklock:
        if not data().spieler_hat_dietrich:
            dialogs.initDlg_121_SpielerUntersuchtDietrich()

# bisonkadaver
    if (object_id == data().Obj_BisonKadaver):
        if not data().bison_inspected:
            system.add_minimap_marker(303, 325, "MM_009")# Bison cadaver
            dialogs.initCutscene_Dlg_011_Spieler_UntersuchtBison()
            data().bison_inspected = True
        else:
            comments.comment(character_id, "EXAMINE_CADAVER_%i" %(random.randint(1,5)))
        return True

    if object_id=="RATSKULLS A" and data().BesoffeneRatskullSchlaeft:
        if not object.is_destroyed("RATSKULLS A"):
            dialogs.initDlg_036_Ratskulls_BewusstloseFrau()
        else:
            object_events.on_examine_object( character_id, object_id )
            return True

    for substring in ["BUILDING_1564","BUILDING_1558"]:
        if object_id.endswith(substring):
            if not dialog.is_dialog_active():
                dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung(CAMVIEW_FELSWOHNUNG_2)

    for substring in ["BUILDING_1420","BUILDING_1421"]:
        if object_id.endswith(substring):
            if not dialog.is_dialog_active():
                dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung(CAMVIEW_FELSWOHNUNG_1)

    if object_id == "DEAD_SHADOW":
        if not data().Spieler_kennt_Schatten:
            dialogs.initDlg_090_UntersucheLeiche()
        else:
            dialogs.initDlg_091_UntersucheLeiche_SpielerKenntSchatten()

    if object_id == "BARBARA":
        if object.is_destroyed(object_id):
            dialogs.initDlg_051_GonzosFrau_Leiche()

    if object_id == 'ZONE_3_BUILDING_2747':
        inventorylist = object.get_inventory_list(object_id)
        if inventorylist:
            system.item_panel( character_id, object_id )

    return False

def on_char_opended_lock(char_id):
    if object.get_distance(char_id, "ALTER_EGO") <= 20.0:
        dialogs.initDlg_104_SpieleKnacktKistenschloss("ALTER_EGO", no_end=True)
    data().spieler_am_schloss = ""
    data().schloss_geknackt = True
    object.remove_closed_lock_by_name(data().Obj_KisteLuke, "lock1")
    system.end_cutscene()

# gut helper
def check_can_gut(char, obj):
    if cs.group_has_1_of(['SET_BIG_KNIFE', 'SET_KNIFE']):
        if cs.anyone_has_skill("survival", 60): # 1 membre du groupe a au moins 60 en survie pour dpecer ?
            if (obj != data().Obj_BisonKadaver):
                if object.is_destroyed(obj):return True
            else:return data().bison_inspected   #print "i cant"
    return False

# returns true if the object can be gutted
# character_id - id of the character
# object_id - id of the object
def can_gut_object( character_id, object_id ):
    if (object_id == data().Obj_BisonKadaver or object_id == "BISON" or object_id == "BERGTIGERIN"):
        return check_can_gut(character_id, object_id)
#print "basisfunktion:"
    return object_events.can_gut_object( character_id, object_id )

# called if an item is gutted by a character
# character_id - id of the character
# object_id - id of the object
def on_gut_object( character_id, object_id ):
    if (object_id == data().Obj_BisonKadaver or object_id == "BISON" or object_id == "BERGTIGERIN"):
        if check_can_gut(character_id, object_id):
            if not data().mq_animal_ausgeweidet[object_id]:
                data().mq_animal_ausgeweidet[object_id] = True
                new_id = ""
                if object_id=="BISON":
                    new_id = data().obj_BisonfleischKill
                    object.create_item_in_inventory(object_id, equipment="SET_BISON_MEAT", id=new_id)
                elif object_id  == "BERGTIGERIN":
                    new_id = data().obj_Tigerfleisch
                    object.create_item_in_inventory(object_id, equipment="SET_TIGER_MEAT", id=new_id)
                else: # Bisonkadaver
                    new_id = data().obj_BisonfleischKadaber
                    object.create_item_in_inventory(object_id, equipment="SET_BISON_MEAT", id=new_id)
                object.set_attribute(object=new_id, attribute="generic_item", value=False)

            inventorylist = object.get_inventory_list(object_id)
            if inventorylist:
                system.item_panel( character_id, object_id )
            return True
        else:
            return False
    return object_events.on_gut_object( character_id, object_id )

## Equipment for NPCs and TA-NPCs
def initEquipment():
#object.create_item_in_inventory("EINSIEDLER",    [""])
    object.create_item_in_inventory("MIA",           ["SET_ANGELICA"])
    object.create_item_in_inventory("PIA",           ["SET_ALOE_VERA", "SET_BEESWAX"])
    object.create_item_in_inventory("DOERFLER A",    ["SET_BULLET_PROOF_CLOTHES"])
    object.create_item_in_inventory("DOERFLER B",    ["SET_AMMOPACK_5_45_MM"])
    object.create_item_in_inventory("DOERFLER C",    ["SET_AMMOPACK_5_45_MM"])
#object.create_item_in_inventory("DORFAELTESTER", [""])
    object.create_item_in_inventory("GONZO",         ["SET_AMMOPACK_5_45_MM",]*2)
    object.create_item_in_inventory("BARBARA",       ["SET_AMMOPACK_5_45_MM"])
#object.create_item_in_inventory("HAENDLER",      ["SET_LEATHER_BOOTS","SET_NORMAL_CLOTHES_6"])
    object.create_item_in_inventory("LUISA",         ["SET_AMMOPACK_5_45_MM"])
    object.create_item_in_inventory("FRANKLIN",      ["SET_AMMOPACK_5_45_MM"])
    object.create_item_in_inventory("DORFBEWOHNERIN",["SET_RAT_MEAT"])
    object.create_item_in_inventory("MCKANZEE",      ["SET_AMMOPACK_5_45_MM"])

    object.create_item_in_inventory("SPIKE",         ["SET_AMMOPACK_2_12_MM"]*5)
    object.create_item_in_inventory("DANIEL",        ["SET_AMMOPACK_7_62SOVJET_MM"]*2)
    object.create_item_in_inventory("VALORIE",       ["SET_AMMOPACK_7_62SOVJET_MM"]*2)
    object.create_item_in_inventory("LARSON",        ["SET_CAR_EXHAUST_PIPE", "SET_HAIR_SPRAY"])
    object.create_item_in_inventory("PHOEBE",        ["SET_WATERTIGHT_RING"])
    object.create_item_in_inventory("WULF",          ["SET_HAIR_SPRAY", "SET_LIGHTER"])
    object.create_item_in_inventory("KIA",           ["SET_LIGHTER"])
    object.create_item_in_inventory("HENRY",         ["SET_CAR_EXHAUST_PIPE"])
    object.create_item_in_inventory("MAGDA",         ["SET_WATERTIGHT_RING"])
    object.create_item_in_inventory("JIMMY",         ["SET_OINTMANT_JAR","SET_OINTMANT_JAR"])
    object.create_item_in_inventory("JULIA",         ["SET_DT21_STEEL_CLAD_BOOTS"])
    object.create_item_in_inventory("ROBERT",        ["SET_BULLET_PROOF_CLOTHES"])
    object.create_item_in_inventory("MYRTHE",        ["SET_PLATE_GLOVES","SET_STEEL_HELMET"])
#object.create_item_in_inventory("JOHN",          [""])
    object.create_item_in_inventory("SUZANNE",       ["SET_PROTECTIVE_GLOVES","SET_STEEL_HELMET"])

def initItems():
    if not hasattr(data(), "patch_jan"):
        data().patch_jan = True

    object.create_item_in_inventory("BUILDING_1582", ["SET_DYNAMITE"]) # bei Steinbruch - Holzbalken
# in Waffenlager beim Traktor
    object.create_item_in_inventory("BUILDING_2627", ["SET_AMMOPACK_5_45_MM"]*3)
    object.create_item_in_inventory("BUILDING_2626", ["SET_UZI"])
    object.create_item_in_inventory("BUILDING_1984", ["SET_AMMOPACK_2_12_MM"]*3)
    object.create_item_in_inventory("BUILDING_13064", ["SET_AKSU74","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM"])
    object.create_item_in_inventory("BUILDING_15498", ["SET_AMMOPACK_5_45_MM"]*5)
    object.create_item_in_inventory("BUILDING_13063", ["SET_AMMOPACK_7_65_MM"]*5)
    object.create_item_in_inventory("BUILDING_13062", ["SET_GIANT_KNIFE"])
# Eingang zum oberen Dorfteil
    object.create_item_in_inventory("THE FALL_BUILDING_5218", ["SET_AMMOPACK_5_45_MM"]*3)
    object.create_item_in_inventory("THE FALL_BUILDING_5220", ["SET_CLUB"])
    object.create_item_in_inventory("BUILDING_2431", ["SET_AMMOPACK_5_45_MM"]*3)
    object.create_item_in_inventory("BUILDING_7921", ["SET_LEATHER_GLOVES"]) # in Haus neben Weg nach oben im Dorf
    object.create_item_in_inventory("BUILDING_2880", ["SET_AMMOPACK_45"]) # in Haus direkt vorm Haus des Dorfaeltesten
    object.create_item_in_inventory("BUILDING_2768", ["SET_COLT_ANACONDA"]) # in Kiste bei Haus des Dorfaeltesten
    object.create_item_in_inventory("BUILDING_7931", ["SET_WATER_SKIN"]*5) # in Fass in Huette neben Tank
    object.create_item_in_inventory("BUILDING_2871", ["SET_BREAD", "SET_CHEESE"]) # in Kiste in Haus neben Gueterwaggon
    object.create_item_in_inventory("BUILDING_1547", ["SET_MEDIPACK_BIG"]) # Muellcontainer beim Krankenhaus
    object.create_item_in_inventory("BUILDING_1680", ["SET_PLATE_ARMOR"]) # Waescheleine Dorfmitte
    system.create_object(equipmenttype="SET_THROWING_KNIFE", x=548.33, y=544.46) # neben Bett in Haus des Einsiedlers
    system.create_object(equipmenttype="SET_OINTMANT_JAR", x=360.17, y=531.15) # beim abgestuerzten Flugzeug
    system.create_object(equipmenttype="SET_OINTMANT_JAR", x=342.69, y=538.79)
    object.create_item_in_inventory("BUILDING_7844", ["SET_AMMOPACK_44"]*3) # in Scheune auf Farm
# in Farm-Haupthaus
    object.create_item_in_inventory("BUILDING_7799", ["SET_BEESWAX"]*3)
    object.create_item_in_inventory("BUILDING_7789", ["SET_GARLIC_PRESS", "SET_WIRE_WHISK"])
    object.create_item_in_inventory("BUILDING_7830", ["SET_AMMOPACK_357"]) # in Scheune auf Farm
# auf Tisch in Krankenhaus
    system.create_object(equipmenttype="SET_MEDIPACK_BIG", x=506.81, y=680.96, id="medipack")
    object.set_position_free("medipack", 506.81, 680.96, 0.8)

    object.create_item_in_inventory("BUILDING_554", ["SET_AMMOPACK_7_62NATO_MM"]) # Holzscheint
    object.create_item_in_inventory("BUILDING_77", ["SET_MP5_W_SILENCER"]) # Container
    object.create_item_in_inventory("BUILDING_1122", ["SET_LANDMINE"]) # Fass
    object.create_item_in_inventory("BUILDING_2558", ["SET_THROWING_KNIFE"]) # Wrack
    object.create_item_in_inventory("BUILDING_2591", ["SET_AMMOPACK_7_62NATO_MM"]) # Müllsack
    object.create_item_in_inventory("BUILDING_2658", ["SET_PROTECTIVE_GLOVES"]) # Kiste
    object.create_item_in_inventory("BUILDING_7926", ["SET_DT21_STEEL_CLAD_BOOTS"]) # Spind
    object.create_item_in_inventory("BUILDING_7922", ["SET_MEDIPACK_BIG"]) # Kommode
    object.create_item_in_inventory("BUILDING_2820", ["SET_STAPLE_GUN", "SET_BELT"]) # Doppelbett
    object.create_item_in_inventory("BUILDING_2921", ["SET_ANTITANKMINE"]) # Schrankwand

# ratskulls
    if not data().NoRatskulls:
        object.create_item_in_inventory("RATSKULLS WAFFENLAGER A", ["SET_MICRO_UZI", "SET_AMMOPACK_9_MM"])
        object.create_item_in_inventory("RATSKULLS WAFFENLAGER B", ["SET_COLT_ANACONDA","SET_AMMOPACK_44","SET_AMMOPACK_44"])
        object.create_item_in_inventory("RATSKULLS WAFFENLAGER C", ["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
        object.create_item_in_inventory("RATSKULLS WAFFENLAGER D", ["SET_SIG_SAUER","SET_AMMOPACK_357"])
        object.create_item_in_inventory("RATSKULLS BUNKER A", ["SET_CALICO_M950","SET_AMMOPACK_9_MM"])
        object.create_item_in_inventory("RATSKULLS BUNKER B", ["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
        object.create_item_in_inventory("RATSKULLS BUNKER C", ["SET_CALICO_M950","SET_AMMOPACK_9_MM"])
        object.create_item_in_inventory("RATSKULLS BUNKER D", ["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
        object.create_item_in_inventory("RATSKULL_LEADER", ["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
        character.equip( "RATSKULLS WAFFENLAGER A", "SET_MICRO_UZI" )
        character.equip( "RATSKULLS WAFFENLAGER B", "SET_COLT_ANACONDA" )
        character.equip( "RATSKULLS WAFFENLAGER C", "SET_MICRO_UZI" )
        character.equip( "RATSKULLS WAFFENLAGER D", "SET_SIG_SAUER" )
        character.equip( "RATSKULLS BUNKER A", "SET_CALICO_M950" )
        character.equip( "RATSKULLS BUNKER B", "SET_MICRO_UZI" )
        character.equip( "RATSKULLS BUNKER C", "SET_CALICO_M950" )
        character.equip( "RATSKULLS BUNKER D", "SET_MICRO_UZI" )
        character.equip( "RATSKULL_LEADER", "SET_MICRO_UZI" )

    object.create_item_in_inventory(data().Obj_KisteLuke, ["SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_MICRO_UZI"])

    object.create_item_in_inventory(data().Obj_KisteLuke,"SET_RATSKULL_DIARY", "Z3 RATSKULL_DIARY")
    object.set_attribute("Z3 RATSKULL_DIARY", "generic_item", False)

    object.create_item_in_inventory("BUILDING_2548",["SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM"])

    object.create_item_in_inventory("BUILDING_2549", ["SET_CALICO_M950"])
#ratskulltagebuch
#object.create_item_in_inventory(data().Obj_KisteLuke, equipment="SET_RATSKULL_DIARY", id="Z3 RATSKULL_DIARY")

# Händler Andrew
    object.create_item_in_inventory("HAENDLER", 
        ["SET_MP5"]*2+["SET_AMMOPACK_9_MM"]*20 + ["SET_AMMOPACK_9_MM_SUBSONIC"]*9+["SET_AMMOPACK_5_45_MM"]*30 +
        ["SET_DESERT_EAGLE"]+["SET_AMMOPACK_50"]*10 + ["SET_REMINGTON_M870"]+["SET_AMMOPACK_2_12_MM"]*15 +
        ["SET_MAC_10"]+["SET_COLT_45"]+["SET_GLOCK_21"]+["SET_AMMOPACK_45"]*20+["SET_AMMOPACK_45_SUBSONIC"]*9 +
        ["SET_M14"]+["SET_AMMOPACK_7_62NATO_MM"]*10 + ["SET_SIMONOV_SKS"]+["SET_AMMOPACK_7_62SOVJET_MM"]*30 )
#
    object.create_item_in_inventory("HAENDLER", ["SET_MACHETE","SET_MOLOTOV_COCKTAIL","SET_MOLOTOV_COCKTAIL","SET_LASERPOINTER","SET_DUCT_TAPE","SET_DUCT_TAPE","SET_BULLET_PROOF_CLOTHES","SET_BULLET_PROOF_CLOTHES","SET_STEEL_HELMET","SET_STEEL_CLAD_BOOTS","SET_PROTECTIVE_GLOVES","SET_BASIC_PICKLOCK","SET_CARROT"])
#
    object.create_item_in_inventory("HAENDLER", ["SET_DRUGS_PILLS_01"]*30 + ["SET_DRUGS_PILLS_02"]*6 +
            ["SET_DRUGS_PILLS_03"]*6  + ["SET_DRUGS_PILLS_04"]*4 +
            ["SET_MEDIPACK_SMALL"]*10 + ["SET_MEDIPACK_BIG"]*10 + ["SET_WATER_SKIN"]*10 )

# item for Gerenal Lewis (zone 5)
    object.create_item_in_inventory("HAENDLER", ["SET_TENT_CANVAS"]*4 + ["SET_WATER_DETECTOR"]*4)

## fixme: hermans picklock
    system.create_object(equipmenttype="SET_SPECIAL_PICKLOCK",\
        x=579.0,y=734.0,id=data().obj_HermansPicklock, direction=globals.DIR_SOUTH)
    object.pick_up_item_direct("HERMAN",data().obj_HermansPicklock)
#object.set_position_free(data().obj_HermansPicklock,x=579.84,y=734.78,z=0.9)

# Bienenstöcke Z3
    object.create_item_in_inventory( 'BUILDING_15559', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_15557', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_15555', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_15556', equipment=[ 'SET_BEESWAX' ] )

# Items in Kisten
    object.create_item_in_inventory( 'BUILDING_15361', [ 'SET_ANGELICA', 'SET_CALICO_M950', 'SET_ANTIDOTE','SET_MOLOTOV_COCKTAIL', 'SET_WATER_BOTTLE' ] )
    object.create_item_in_inventory( 'BUILDING_7796',  ['SET_AMMOPACK_9_MM_SUBSONIC']*5 )
    object.create_item_in_inventory( 'BUILDING_15363', ['SET_AMMOPACK_7_62SOVJET_MM']*5 + ['SET_AMMOPACK_50']*5 )
    object.create_item_in_inventory('BUILDING_15366',  ['SET_AMMOPACK_7_62NATO_MM']*5 + ['SET_AMMOPACK_9_MM']*5 )
    object.create_item_in_inventory( 'BUILDING_15379', ['SET_AMMOPACK_5_7_MM']*5 + ['SET_AMMOPACK_5_56_MM']*5 )
    object.create_item_in_inventory( 'BUILDING_15382', [ 'SET_CAR_EXHAUST_PIPE', 'SET_AUTOMAG_3' ] )
    object.create_item_in_inventory( 'BUILDING_15411', [ 'SET_THROWING_KNIFE']*2 + ['SET_P90_SMG'] )
    object.create_item_in_inventory( 'BUILDING_15439', [ 'SET_MEDIPACK_SMALL', 'SET_LONG_LEATHER_STRAP' ] )
    object.create_item_in_inventory( 'BUILDING_15440', ['SET_BASEBALL_BAT','SET_BULLET_CATCH','SET_CHAIN_MAIL'] )
    object.create_item_in_inventory( 'BUILDING_15441', [ 'SET_REEL_OF_STEEL_WIRE', 'SET_M_16', 'SET_STEYR_TMP' ] )


def initHerbs():
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 584.78, y = 476.77)
    system.create_object(equipmenttype="SET_ALOE_VERA", x = 599.05, y = 364.82)
    system.create_object(equipmenttype="SET_ALOE_VERA", x = 462.19, y = 446.212)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 353.22, y = 546.94)
    system.create_object(equipmenttype="SET_ALOE_VERA", x = 205.67, y = 604.65)
    system.create_object(equipmenttype="SET_ALOE_VERA", x = 235.35, y = 316.01)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 258.65, y = 213.44)
    system.create_object(equipmenttype="SET_ALOE_VERA", x = 432.24, y = 263.19)

def initExitZones():
    system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 799.00, y2 = 206.24 )
    system.register_exit(regionname = "REGION_EXIT_NORD" )
    system.add_region( id = "REGION_EXIT_SUED", x1 = 588.00, y1 = 991.00, x2 = 0.00, y2 = 784.00 )
    system.register_exit(regionname = "REGION_EXIT_SUED" )
    system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 784.00, x2 = 200.00, y2 = 206.24 )
    system.register_exit(regionname = "REGION_EXIT_WEST" )
    system.add_region( id = "REGION_EXIT_OST", x1 = 799.00, y1 = 206.24, x2 = 600.00, y2 = 991.00 )
    system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
# aschetonne im dorf
# system.start_effect_object(object="BUILDING_1695",node="aschetonne",parameter=fx_smoke_aschetonne)
# tonne bei den ratskulls
    init_brennende_tonne("BUILDING_762")
# tonne beim bauernhof
    init_brennende_tonne("BUILDING_45")
# lagerfeuer beim Bauer
    system.start_effect_object("BUILDING_15527","effekt_feuer",fx_fire_lagerfeuer)
    sounds.play_3d_sound_object("campfire_small","BUILDING_15527",True)
# lagerfeuer im dorf
    init_lagerfeuer("BUILDING_1590")
# lagerfeuer bei den ratskulls
    init_lagerfeuer("BUILDING_1133")
    system.notify_timer(data().Timer_Luisa_Cry, 1000)

    sounds.play_3d_sound_object(sfx_id="cadaver_fly",object=data().Obj_BisonKadaver, loop=True)

def initMinimapMarkers():
    system.add_minimap_marker(449,347,"MM_002")#Mine belt
    system.add_minimap_marker(495,240,"MM_003")#Ratskulls weapon depot

def init_lagerfeuer(object_id):
    system.start_effect_object(object=object_id,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
#system.start_effect_object(object=object_id,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
    system.start_effect_object(object=object_id,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
    system.start_effect_object(object=object_id,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
    system.start_effect_object(object=object_id,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
    system.start_effect_object(object=object_id,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
    sounds.play_3d_sound_object(sfx_id="campfire_big",object=object_id,loop=True)

def init_brennende_tonne(object_id):
#system.start_effect_object(object=object_id,node="sort0",parameter=fx_smoke_brennende_tonne)
    system.start_effect_object(object=object_id,node="sort1",parameter=fx_fire_brennende_tonne)
    sounds.play_3d_sound_object(sfx_id="campfire_small",object=object_id,loop=True)

def initAggro():
# auf aggro schalten
    if not data().NoRatskulls:
        object.set_attribute(object="RATSKULLS WAFFENLAGER A", attribute="foes", value=["UISPIELER"])
        object.set_attribute(object="RATSKULLS WAFFENLAGER B", attribute="foes", value=["UISPIELER"])
        object.set_attribute(object="RATSKULLS WAFFENLAGER C", attribute="foes", value=["UISPIELER"])
        object.set_attribute(object="RATSKULLS WAFFENLAGER D", attribute="foes", value=["UISPIELER"])

def on_trade(target,operator):
    if target=="HAENDLER":
        object.cancel_commandos(target)
        if get_location("HAENDLER") == 1:
            prohibit_activity(target)
        lambda_string = 'system.trading_screen(trader="%s",char="%s")' %(target,operator)
        object.turn_to_object(target, operator, callback=["ONEND", Lambda(lambda_string)])

def on_exit_trader( trader_id, negotiator_id, profit ):
    allow_activity(trader_id)
    return object_events.on_exit_trader( trader_id, negotiator_id, profit)


def on_weapon_ignition(weapon_type,x,y,z):
#print "onWeaponIgnition",weapon_type,x,y,z
    if weapon_type=="SET_C4_REMOTE_CONTROL" and x > 502 and x < 508 and y > 233 and y < 240:
        if not data().bunker_gesprengt:
            data().bunker_gesprengt = True
            destroy_building_bunker()
            system.notify_timer(
                timer=data().Timer_BunkerRedskullsAppear, 
                delay=data().Timervalue_BunkerRedskullsAppear)
            character.add_experience_party(data().Exp_Bunker_Gesprengt)

def ratskull_hears_exploding_cow():
    if data().ratskull_spotted_player:
        return

# suspicious ratskull guard; but only for first exploding cow
    if not data().ratskull_has_heard_exploding_cow:
        data().ratskull_has_heard_exploding_cow = True
        object.move_to( "RATSKULLS WAFFENLAGER A", 448.82, 331.12, "landscape", MT_SLOW, callback=["ONEND",onRatskullMovesToCow])

def onRatskullMovesToCow(id):
    ratskull_A_arrives_at_minebelt()

def ratskull_A_arrives_at_minebelt():
    if data().ratskull_spotted_player:
        return

# suspicious ratskull looks at exploded cows
    if not data().ratskull_A_at_minebelt:
        data().ratskull_A_at_minebelt = True
# todo vielleicht noch auf destroyed abfragen
# no player char visible
        object.turn_to_object( "RATSKULLS WAFFENLAGER A", "RATSKULLS WAFFENLAGER B")
        character.play_animation( "RATSKULLS WAFFENLAGER A", "CM_NPC_STEHEN_WARTEN_1" )
        dialogs.initDlg_074_DeadCowsSpotted()
        object.move_to( "RATSKULLS WAFFENLAGER A", 445.45, 340.35 , "landscape")
        object.turn_to_position( "RATSKULLS WAFFENLAGER A", 444.61, 342.83 )

        object.move_to( "RATSKULLS WAFFENLAGER B", 446.82, 331.12 , "landscape")
        object.move_to( "RATSKULLS WAFFENLAGER B", 443.56, 343.16 , "landscape")
        object.turn_to_position( "RATSKULLS WAFFENLAGER B", 444.61, 342.83 )

        object.move_to( "RATSKULLS WAFFENLAGER C", 448.82, 331.12 , "landscape")
        object.move_to( "RATSKULLS WAFFENLAGER C", 446.75, 343.2 , "landscape")
        object.turn_to_position( "RATSKULLS WAFFENLAGER C", 444.61, 342.83, callback=["ONEND",onRatskullsComesToSeeCow2])

def onRatskullsComesToSeeCow2(id):
    if UnEquip_Weapon_Direct("RATSKULLS WAFFENLAGER B"):
        character.play_animation("RATSKULLS WAFFENLAGER B", "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
        character.play_animation("RATSKULLS WAFFENLAGER B", "CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
        character.play_animation("RATSKULLS WAFFENLAGER B", "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback = ['ONEND', Is_Equip_Weapon])
    if UnEquip_Weapon_Direct("RATSKULLS WAFFENLAGER C"):
        character.play_animation("RATSKULLS WAFFENLAGER C", "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
        character.play_animation("RATSKULLS WAFFENLAGER C", "CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
        character.play_animation("RATSKULLS WAFFENLAGER C", "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback = ['ONEND', Is_Equip_Weapon])

    if object.get_x("RATSKULLS WAFFENLAGER C") < 447.75 and \
        object.get_x("RATSKULLS WAFFENLAGER C") > 445.75 and \
        object.get_y("RATSKULLS WAFFENLAGER C") < 344.2 and \
        object.get_y("RATSKULLS WAFFENLAGER C") > 342.2:
        ratskull_C_arrives_at_cow()

def ratskull_C_arrives_at_cow():
    if data().ratskull_spotted_player:
        return

# last ratskull arrives
# they start talking about the dead cows
    dialogs.initDlg_075_DeadCowsDiscussion()

def ratskull_says_something_about_dead_cows():
    if (not object.is_destroyed("RATSKULLS WAFFENLAGER A") and
        not object.is_destroyed("RATSKULLS WAFFENLAGER B") and
        not object.is_destroyed("RATSKULLS WAFFENLAGER C")):
            if data().ratskulls_discuss_dead_cows < 4:
                if data().ratskulls_discuss_dead_cows == 1:
                    data().ratskulls_discuss_dead_cows += 1
                    dialogs.initDlg_076_DeadCowsStrange1()
                elif data().ratskulls_discuss_dead_cows == 2:
                    data().ratskulls_discuss_dead_cows += 1
                    dialogs.initDlg_077_DeadCowsStrange2()
                elif data().ratskulls_discuss_dead_cows == 3:
                    data().ratskulls_discuss_dead_cows += 1
                    dialogs.initDlg_078_DeadCowsStrange3()
            elif data().ratskulls_discuss_dead_cows >= 4:
                if not object.is_destroyed("RATSKULLS WAFFENLAGER A"):
                    object.move_to( "RATSKULLS WAFFENLAGER A", x=446.69, y=303.24, grid="landscape", speed=MT_SLOW )
                    object.turn_to_direction("RATSKULLS WAFFENLAGER A", globals.DIR_SOUTH)
                if not object.is_destroyed("RATSKULLS WAFFENLAGER B"):
                    object.move_to( "RATSKULLS WAFFENLAGER B", x=521.16, y=290.3, grid="landscape", speed=MT_SLOW )
                    object.turn_to_direction("RATSKULLS WAFFENLAGER B", globals.DIR_SOUTH_WEST)
                if not object.is_destroyed("RATSKULLS WAFFENLAGER C"):
                    object.move_to( "RATSKULLS WAFFENLAGER C", x=523.72, y=295.44, grid="landscape", speed=MT_SLOW )
                    object.turn_to_direction("RATSKULLS WAFFENLAGER C", globals.DIR_WEST)

def ratskull_spotted_player(enemys=None):
# ratskull guards see player char
    if not data().ratskull_spotted_player:
        data().ratskull_spotted_player = True

        for ratskull in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B",
                "RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]:
            if not object.is_destroyed(ratskull):
                object.cancel_commandos(ratskull)
                if Is_Equip_Weapon(ratskull):
                    if ratskull != "RATSKULLS WAFFENLAGER D":
                        if len(enemys):
                            enemys_ = random.choice(enemys)
                            if not object.is_destroyed(enemys_):
                                object.attack(ratskull, enemys_)

        dialogs.initDlg_073_PlayerCharSpotted()

        if not object.is_destroyed("RATSKULLS WAFFENLAGER D"):
            object.move_to( "RATSKULLS WAFFENLAGER D", x=496, y=252, grid="landscape")
        onRatskullsAlarmOthers("RATSKULLS WAFFENLAGER D")

def onRatskullsAlarmOthers(id):
    ratskull_bunker_alert()

def ratskull_bunker_alert():
    print "rutscull_bunker_alert"
    if not data().ratskull_bunker_alerted:
        data().ratskull_bunker_alerted = True
        dialogs.initDlg_079_BunkerAlert()
        if not object.is_destroyed("RATSKULLS WAFFENLAGER D"):
            for id in ["RATSKULLS WAFFENLAGER A", "RATSKULLS WAFFENLAGER B", "RATSKULLS WAFFENLAGER C"]:
                if object.is_destroyed(id):
                    if Is_Equip_Weapon("RATSKULLS WAFFENLAGER D"):
                        enemys = character.get_visible_enemies(id)
                        if len(enemys):
                            enemys_ = random.choice(enemys)
                            if not object.is_destroyed(enemys_):
                                object.attack("RATSKULLS WAFFENLAGER D", enemys_)
                                return
            object.move_to("RATSKULLS WAFFENLAGER D",446.49, 329.30, callback = ['ONEND', Lambda('system.notify_timer( data().Timer_ratskull_discuss_dead_cows,random.randint(4, 8) * 1000 )')])

        if (not object.is_destroyed("RATSKULL_LEADER")):
            enemy_script.enter_building_to_position(char ='RATSKULL_LEADER' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 516.51, y = 236.16)
            object.turn_to_direction("RATSKULL_LEADER", 270, callback = ['ONEND', Bunker_Abschliesen])
        if (not object.is_destroyed("RATSKULLS BUNKER A")):
            enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER A' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 512.72, y = 239.14)
            object.turn_to_direction("RATSKULLS BUNKER A", 270, callback = ['ONEND', Bunker_Abschliesen])
        if (not object.is_destroyed("RATSKULLS BUNKER C")):
            enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER C' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 516.54, y = 239.25)
            object.turn_to_direction("RATSKULLS BUNKER C", 270, callback = ['ONEND', Bunker_Abschliesen])
        if (not object.is_destroyed("RATSKULLS BUNKER B")):
            enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER B' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 514.53, y = 239.12)
            object.turn_to_direction("RATSKULLS BUNKER B", 270, callback = ['ONEND', Bunker_Abschliesen])
        if (not object.is_destroyed("RATSKULLS BUNKER D")):
            enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER D' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 516.59, y = 237.64)
            object.turn_to_direction("RATSKULLS BUNKER D", 270, callback = ['ONEND', Bunker_Abschliesen])

            object.set_immortal_state("RATSKULLS BUNKER A", True)
            object.set_immortal_state("RATSKULLS BUNKER B", True)
            object.set_immortal_state("RATSKULLS BUNKER C", True)
            object.set_immortal_state("RATSKULLS BUNKER D", True)
            object.set_immortal_state("RATSKULL_LEADER", True)

def Bunker_Abschliesen(id):
    data().Bunker_Abschliesen += 1
    if data().Bunker_Abschliesen >= 5:
        Test_Bunker_Abschliesen()
        data().Bunker_Abschliesen = 0

def Test_Bunker_Abschliesen():
    print "bunker abschliessen"
    for id in ['RATSKULL_LEADER', 'RATSKULLS BUNKER A', 'RATSKULLS BUNKER B', 'RATSKULLS BUNKER C', 'RATSKULLS BUNKER D']:
        if object.get_attribute(id, 'grid') != 'ZONE_3_BUILDING_10532_INTERIOR_GRID':
            if id == 'RATSKULL_LEADER':
                object.set_position('RATSKULL_LEADER' , 516.51, 236.16, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
            elif id == 'RATSKULLS BUNKER A':
                object.set_position('RATSKULLS BUNKER A' , 512.72, 239.14, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
            elif id == 'RATSKULLS BUNKER B':
                object.set_position('RATSKULLS BUNKER B' , 514.53, 239.12, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
            elif id == 'RATSKULLS BUNKER C':
                object.set_position('RATSKULLS BUNKER C' , 516.54, 239.25, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
            elif id == 'RATSKULLS BUNKER D':
                object.set_position('RATSKULLS BUNKER D' , 516.59, 237.64, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')


def ratskulls_bunker_appear():
# bunker damaged
    print "ratscull bunker appear"
    if object.is_destroyed('ALTER_EGO'):
        return

    dist = object.get_distance("ALTER_EGO","BUILDING_BUNKER_SPRENGUNG")
    if dist > 50.0:
        object.cancel_commandos("ALTER_EGO")
        object.set_position_free("ALTER_EGO", 496.70, 269.08, 0.0, grid="landscape")

    system.start_cutscene()
    system.set_camera_view(CAMVIEW_BUNKER_RATSKULLS)
    object.set_immortal_state("RATSKULLS BUNKER A", False)
    object.set_immortal_state("RATSKULLS BUNKER B", False)
    object.set_immortal_state("RATSKULLS BUNKER C", False)
    object.set_immortal_state("RATSKULLS BUNKER D", False)
    object.set_immortal_state("RATSKULL_LEADER", False)

#object.set_position_free("RATSKULL_LEADER", 521.5, 237, 1 )
    character.play_animation("RATSKULL_LEADER", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULL_LEADER", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
    character.play_animation("RATSKULL_LEADER", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

#object.set_position_free("RATSKULLS BUNKER A", 511, 237, 1 )
    character.play_animation("RATSKULLS BUNKER A", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
    character.play_animation("RATSKULLS BUNKER A", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

#object.set_position_free("RATSKULLS BUNKER B", 514.5, 237, 1 )
    character.play_animation("RATSKULLS BUNKER B", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULLS BUNKER B", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
    character.play_animation("RATSKULLS BUNKER B", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

#object.set_position_free("RATSKULLS BUNKER C", 518, 237, 1 )
    character.play_animation("RATSKULLS BUNKER C", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULLS BUNKER C", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULLS BUNKER C", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
    character.play_animation("RATSKULLS BUNKER C", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

#object.set_position_free("RATSKULLS BUNKER D", 521.5, 237, 1 )
    character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS" )
    character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
    character.play_animation("RATSKULLS BUNKER D", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

    object.move_to("RATSKULLS BUNKER A",501.8,235.4)
    object.move_to("RATSKULLS BUNKER B",502.6,236.2)
    object.move_to("RATSKULLS BUNKER C",503.11,237.0)
    object.move_to("RATSKULLS BUNKER D",502.4,239.4)
    object.move_to("RATSKULL_LEADER",502.5,238.0,callback=["ONEND",on_RatskullsLeaveBunkerCam1])

    object.move_to("RATSKULL_LEADER",496.5,241.0,"landscape",speed=MT_SLOW, callback=["ONEND",on_RatskullsLeaveBunkerCam2])

    object.turn_to_object("RATSKULLS BUNKER A","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])
    object.turn_to_object("RATSKULLS BUNKER B","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])
    object.turn_to_object("RATSKULLS BUNKER C","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])
    object.turn_to_object("RATSKULLS BUNKER D","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])

def on_RatskullsLeaveBunkerHandsUp(char_id):
    data().ratskulls_hands_up[char_id] = True

def ratskulls_bunker_bag_for_life(id):
    end_cutscene(chars=["RATSKULL_LEADER","ALTER_EGO"])
    object.turn_to_object("RATSKULL_LEADER","ALTER_EGO")
    dialogs.initDlg_100_RatskullLeaderWillNichtSterben()

def on_RatskullsLeaveBunkerCam1(id):
    object.cancel_commandos("ALTER_EGO")
    object.set_position("ALTER_EGO",490.3,241.4)
    object.move_to("ALTER_EGO",494.0,242.0,"landscape",speed=MT_SLOW)
    system.set_camera_view(CAMVIEW_BUNKER_OUT)

def on_RatskullsLeaveBunkerCam2(id):
    system.set_camera_view(CAMVIEW_BUNKER_FAR)
    object.cancel_commandos("RATSKULL_LEADER")
    object.move_to("RATSKULL_LEADER",496.5,241.0,"landscape",speed=MT_SLOW)
    object.turn_to_object("ALTER_EGO","RATSKULL_LEADER",callback=["ONEND",ratskulls_bunker_bag_for_life])
    object.turn_to_object("RATSKULL_LEADER","ALTER_EGO")

def ratskulls_bunker_escaped(id):
    object.set_active_state(id, INACTIVE)
    data().Ratskulls_Bunker = data().Ratskulls_Bunker + 1
    if data().Ratskulls_Bunker >= 4:
#system.set_qb_entry_state(data().QB_004, COMPLETE)
        system.notify_timer(timer=data().Timer_Zone4Comment, delay=data().Timervalue_Zone4Comment)


# todo: quests absichern/auf failed stellen, wenn einer der noch benötigten questchars abnibbelt
# todo: lootliste für waffenlager
# todo: lootliste für bunker
def on_pick_up( character_id, item_id, item_type ):
#print 'debug: on_pick_up', character_id, item_id, item_type 
    if item_id == "Z3 RATSKULL_DIARY":
        if not data().ratskull_tagebuch_gelesen:
            dialogs.initDlg_131_SpielerFindetRatskulltagebuch()

    if item_id == data().obj_HermansPicklock:
        if object.is_destroyed("HERMAN"):
            return True

        if data().spieler_hat_dietrich:
            return True

        if object.get_attribute(character_id,"pick_pocket") >= 80 :
            if not data().spieler_hat_dietrich:
                dialogs.initDlg_120_SpielerKlautDietrich()
                return True
            else:
                return True
        else:
            dialogs.initDlg_121_SpielerUntersuchtDietrich()
            return False

    return True

def on_enemy_spotted(object_id):
    enemys = character.get_visible_enemies(object_id)
#print "[debug: on_enemy_spotted:",object_id,"]"

    if object_id in RATSKULLS_BUNKER and len(enemys):
        ratskull_spotted_player(enemys)
        attack_enemy(object_id,enemys)

    if object_id == 'HUMVEE_Z3':
        return True

def on_sector_cleared(object_id):
#print "[on_sector_cleared(",object_id,")]"
    if object_id in RATSKULLS_BUNKER:
        for id in RATSKULLS_BUNKER:
            if not object.is_destroyed(id):
                if (character.get_visible_enemies(id)):
                    return
        if not object.is_destroyed("RATSKULLS WAFFENLAGER A"):
            object.move_to( "RATSKULLS WAFFENLAGER A", x=446.69, y=303.24, grid="landscape", speed=MT_SLOW )
            object.turn_to_direction("RATSKULLS WAFFENLAGER A", globals.DIR_SOUTH)
        if not object.is_destroyed("RATSKULLS WAFFENLAGER B"):
            object.move_to( "RATSKULLS WAFFENLAGER B", x=521.16, y=290.3, grid="landscape", speed=MT_SLOW )
            object.turn_to_direction("RATSKULLS WAFFENLAGER B", globals.DIR_SOUTH_WEST)
        if not object.is_destroyed("RATSKULLS WAFFENLAGER C"):
            object.move_to( "RATSKULLS WAFFENLAGER C", x=523.72, y=295.44, grid="landscape", speed=MT_SLOW )
            object.turn_to_direction("RATSKULLS WAFFENLAGER C", globals.DIR_WEST)


def attack_enemy(char, enemys=None):
#object.cancel_commandos(char)
    if not object.is_destroyed(char):
        if enemys == None:
            enemys = character.get_visible_enemies(char)
            if not len(enemys):
                return False
        enemys_ = random.choice(enemys)
        if not object.is_destroyed(enemys_):
            object.attack(char, enemys_)

def on_attack(operator, target):
#print "[debug: on_attack:",operator,target,"]"

    if not hasattr(data(), "has_been_attacked"):
        data().has_been_attacked = []
    if not target in data().has_been_attacked:
        data().has_been_attacked.append(target)
    else:
        return

    if target in ["RATSKULLS A", "RATSKULLS B", "RATSKULLS C"]:
        enemys = character.get_visible_enemies(operator)
        for id in ["RATSKULLS A", "RATSKULLS B", "RATSKULLS C"]:
            if not object.is_destroyed(id):
                if not id in data().has_been_attacked:
                    data().has_been_attacked.append(id)
                    data().BesoffeneRatskullSchlaeft = False
                    if not object.has_attribute(id, "foes"):
                        object.set_attribute(object=id, attribute="foes", value=["UISPIELER"])
                    prohibit_activity(id)
                    object.turn_to_object(id, operator)
                    character.arm_direct(id)
            else:
                if len(enemys) and not object.is_destroyed(target):
                    enemys_ = random.choice(enemys)
                    if not object.is_destroyed(enemys_):
                        object.attack(target, enemys_)

    if target in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B","RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]:
        for id in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B","RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]:
            if not object.is_destroyed(id):
                if not id in data().has_been_attacked:
                    data().has_been_attacked.append(id)

                    if not object.is_destroyed(operator):
                        enemys = [operator]
                        ratskull_spotted_player(enemys)
                        attack_enemy(id, enemys)

def can_exchange( character_id, target_id, item_id, item_type ):

    if item_type == "SET_WATER_SKIN":
        if target_id == "MCKANZEE":
            if (character_id == "ALTER_EGO" and system.get_qb_entry_state(data().QB_009) == UNCOMPLETE):
                return True
            else:
                return False
        elif target_id not in system.get_pcs():
                return False 

    if (item_id == data().obj_Autobatterie or item_type == "SET_CAR_BATTERY"):
        if item_id == data().obj_Autobatterie:
            if (target_id == "EINSIEDLER"
                and character_id == "ALTER_EGO" 
                and system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
                    return True

        elif item_type == "SET_CAR_BATTERY":
            if target_id == "EINSIEDLER":
                if (character_id == "ALTER_EGO" and system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
                    return True
                else:
                    return False
            elif target_id not in system.get_pcs():
                return False

    return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
#   print "exchange %s %s %s %s" % (character_id, target_id, item_id, item_type)
#
#
    if item_type == "SET_WATER_SKIN":
        if (target_id == "MCKANZEE" and character_id == "ALTER_EGO"):
            if system.get_qb_entry_state(data().QB_009) == UNCOMPLETE:
                data().mckanzee_given_water += 1
                if data().mckanzee_given_water == 3:
                    dialogs.initCutscene_Dlg_031_McKanzee_BekommtWasser()
                return True
#
    if item_id == data().obj_Autobatterie:
        if (target_id == "EINSIEDLER" and character_id == "ALTER_EGO"):
            if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
                data().car_battery_given = True
                dialogs.initDlg_032_Einsiedler_BekommtBatterie()
                return True

    return object_events.on_exchange( character_id, target_id, item_id, item_type )

## Spawns Bergtigerin
def spawnBergtigerin(state):
    if not object.is_destroyed("BERGTIGERIN"):
        if (state == ACTIVE):
            if not data().BergtigerAktiv:
                object.set_active_state("BERGTIGERIN",state)
                object.cancel_commandos("BERGTIGERIN")
                object.set_position("BERGTIGERIN", 200.84, 588.05)
                object.move_to("BERGTIGERIN", 219.90, 592.21, grid="landscape", speed=MT_FAST)
                data().BergtigerAktiv = True
        else:
            if data().BergtigerAktiv:
                data().BergtigerAktiv = False
                object.cancel_commandos("BERGTIGERIN")
                object.move_to("BERGTIGERIN", 200.84, 588.05, grid="landscape", speed=MT_FAST, callback=["ONEND", bergtigerinEnde])

def bergtigerinEnde(id):
    object.set_active_state("BERGTIGERIN",INACTIVE)

## Timer Trigger für die Tigerin
def starteTimerBergtigerin():
#print "[debug starteTimerBergtigerin() ]"
    clock = system.get_mission_time().get_day_time()
    if (clock >= time("22:45:00") or clock < time("3:15:00")):
        system.notify_timer(data().Timer_BergTigerChecker,data().Timervalue_BergtigerChecker)

#prueffunktionen: kann ein char ein lock (kiste luke) oeffnen
def can_open_lock(id, blast=False):
    data().spieler_am_schloss = ""
    if can_open_lock_helper(id, blast):
        data().spieler_am_schloss = id
        return True
    else:
        for pc in system.get_pcs():
            if can_open_lock_helper(pc, blast):
                if object.get_distance(pc, id) <= 20.0:
                    data().spieler_am_schloss = pc
                return True
        return False

def can_open_lock_helper(char, blast=False):
    picklocks = []
    if blast:
        picklocks = ["SET_GUN_POWDER"]
    else:
        picklocks = ["SET_BASIC_PICKLOCK", "SET_VAMPED_PICKLOCK_SET", "SET_SET_OF_PICKLOCKS", "SET_GUN_POWDER"]

    if not len(picklocks):
        return False

    for picklock in picklocks:
        if( object.count_in_inventory( char, picklock ) ):
            if object.has_attribute(char,"lock_pick") and object.has_attribute(char,"dexterity"):
                if (object.get_attribute(char,"lock_pick") >= 75):
                    return True
    return False

def on_destroy_building_bunker_end(id):
#print " >>> on_destroy_building_bunker_end"
    object.fade_node(object="BUILDING_BUNKER_SPRENGUNG",node="parts",time=300)
    object.set_active_state(object="ZONE_3_BUILDING_10532", state=INACTIVE)

def on_destroy_building_bunker_start(id):
#print " >>> on_destroy_building_bunker_start"
    system.start_effect_object(object="BUILDING_BUNKER_SPRENGUNG",node="explosion_main",parameter=[FX_EXPLOSION_COMBO_1,0,2000,2.0,100.0])
    system.start_effect_object(object="BUILDING_BUNKER_SPRENGUNG",node="explosion_rotor",parameter=[FX_EXPLOSION_COMBO_1,200,1500,0.5,0.0])
    system.start_effect_object(object="BUILDING_BUNKER_SPRENGUNG",node="explosion_tuer",parameter=[FX_EXPLOSION_COMBO_1,300,2000,1.5,10.0])
    sounds.play_3d_sound_object(sfx_id="explosion_bunker",
        object="BUILDING_BUNKER_SPRENGUNG")

def init_destroy_bunker_reposition_interior():
    int_objs = ['BUILDING_13069','BUILDING_13064','BUILDING_15498','BUILDING_13063',
                'BUILDING_13062','BUILDING_15479','BUILDING_15484','BUILDING_15469',# tresor
                'BUILDING_15475','BUILDING_15499']
#alle objekte im grid umsetzen
    for io in int_objs:
        system.mark_for_script_use(io)
        x,y,z = object.get_position(io)
        print "reposition " + io 
        object.set_position_free(io, x, y, 0.0, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
    object.set_active_state("ZONE_3_BUILDING_13097", INACTIVE)

def destroy_building_bunker():
    print "destroy building bunker"
    object.set_active_state(object="ZONE_3_BUILDING_10532", state=INACTIVE)
    object.set_active_state(object="BUILDING_BUNKER_SPRENGUNG", state=ACTIVE)
#object.set_immortal_state("ZONE_3_BUILDING_10532", True)
    object.set_immortal_state("BUILDING_BUNKER_SPRENGUNG", True)
# object.set_position('ZONE_3_BUILDING_363', 505.48501586914062, 240.8) # sandsack verschoben original >>> 505.48501586914062, >>> 240.27565002441406

    if (not object.is_destroyed("RATSKULLS BUNKER A")):
        object.set_position('RATSKULLS BUNKER A' , 512.72, 239.14, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
    if (not object.is_destroyed("RATSKULLS BUNKER B")):
        object.set_position('RATSKULLS BUNKER B' , 514.53, 239.12, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
    if (not object.is_destroyed("RATSKULLS BUNKER C")): 
        object.set_position('RATSKULLS BUNKER C' , 516.54, 239.25, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
    if (not object.is_destroyed("RATSKULLS BUNKER D")):
        object.set_position('RATSKULLS BUNKER D' , 516.59, 237.64, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
    if (not object.is_destroyed("RATSKULL_LEADER")):
        object.set_position('RATSKULL_LEADER'    , 516.51, 236.16, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')


    object.play_animation(
        object="BUILDING_BUNKER_SPRENGUNG",
        animation="ANIM_BUNKER_L_DESTROY",
        callback=[["ONEND",on_destroy_building_bunker_end],["ONSTART",on_destroy_building_bunker_start]])

def UnEquip_Weapon_Direct(char_id):
    if object.has_attribute(char_id, 'slots'):
        if 'right_hand' in object.get_attribute(char_id, 'slots'):
            if not ((object.get_attribute(char_id, 'slots')['right_hand']) == None):
#print 'debug_UnEquip_Weapon_Direct_right_hand', char_id, object.get_attribute(char_id, 'slots')['right_hand']
                character.un_equip_direct(char_id, (object.get_attribute(char_id, 'slots')['right_hand']))
        if 'left_hand' in object.get_attribute(char_id, 'slots'):
            if not ((object.get_attribute(char_id, 'slots')['left_hand']) == None):
#print 'debug_UnEquip_Weapon_Direct_left_hand', char_id, object.get_attribute(char_id, 'slots')['right_hand']
                character.un_equip_direct(char_id, (object.get_attribute(char_id, 'slots')['left_hand']))
    return True

# ist in zz_2 beschrieben
def Is_Equip_Weapon(char_id):
    if object.has_attribute(char_id, 'slots'):
        equ = object.get_attribute(char_id, 'slots')
        if (equ['right_hand']):
            if object.has_attribute(equ['right_hand'], 'weapon_type'):
                return True
        for id in object.get_inventory_id_list(char_id):
            if object.has_attribute(id, 'weapon_type'):
                character.equip_direct(char_id, id)
                return True
    elif not object.has_attribute(char_id, 'slots'):
        for id in object.get_inventory_id_list(char_id):
            if object.has_attribute(id, 'weapon_type'):
                character.equip_direct(char_id, id)
                return True
    return False

def can_enter_building( character_id, building_id ):
#nicht gesprengter bunker
    if building_id == "ZONE_3_BUILDING_10532":
        if character_id in system.get_pcs():
            return False
#gesprengter bunker
    if building_id == "BUILDING_BUNKER_SPRENGUNG":
        if character_id in system.get_pcs():
            return data().bunker_gesprengt

    return object_events.can_enter_building( character_id, building_id )

def InitChestsSafes():
    object.add_closed_lock("BUILDING_15361", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_7796",  "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_15363", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_15366", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_15379", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_15382", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_15411", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_15439", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_15440", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_15441", "lock1", closure_type='lock-trap')

def init_patch():
    if "ANIE" in system.get_npcs():
        if object.is_active("ANIE"):
            data("zone_7.zone_7").anie_folgt = True

    if not hasattr(data(), "patch_jan"):
        data().patch_jan = True
        object.create_item_in_inventory("HAENDLER",["SET_WATER_SKIN","SET_WATER_SKIN","SET_WATER_SKIN","SET_WATER_SKIN"])
        object.create_item_in_inventory("BUILDING_13064",equipment=["SET_AKSU74","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM"])
        object.create_item_in_inventory("BUILDING_15498",equipment=["SET_WALTER_PPK","SET_WALTER_PPK","SET_WALTER_PPK"])
        object.create_item_in_inventory("BUILDING_13063",equipment=["SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM"])
        object.create_item_in_inventory("BUILDING_13062",equipment=["SET_GIANT_KNIFE"])
    object.set_attributes("DOERFLER A",
        model="low",
        gender="female",
        skin="white",
        clothes="ls_001",
        face="richlind")
    character.update_appearance("DOERFLER A")
    if (not data().spieler_hat_dietrich ):
        if( not object.count_in_inventory("HERMAN",data().obj_HermansPicklock) ):
            object.pick_up_item_direct("HERMAN",data().obj_HermansPicklock)

    pass
    init_main_npcs()

# init christian var : remis ces variables malgr qu'elles ne servent pas pour compatibilit
    if not hasattr(data('zone_3.zone_3'), 'donald_has_bisonmeat'):
        data().donald_has_bisonmeat = False
        data().donald_has_tigermeat = False

def init_main_npcs():
    character.set_main_quest_npc_state(char="HAENDLER", state=True)

