# -*- coding: utf-8 -*-
from globals import *
import dialogs
import npc
import debug
import const
from const import *
import schedules
import water
import object_events
import enemy_script
import sounds
import char_autogeneration
import random
import cs_function as cs

#*********************************************************************
#    aktuelle revison: Revision 37, 6.09.2004
# TODO: TA Doris - Spaziergang, TA Falk - Spaziergang
# - JUDY braucht ein Haus und dann gibts auch ihren TA (der ist noch gar nicht (bis auf die Struktur) vorhanden)
# - TYRON: Im Dorf herumlaufen und mit potentiellen Wählern reden (z.B. Judy und Jaffar)(auf JUDYs Haus warten)
#*********************************************************************


################################################################################
### Initialisierung ############################################################
################################################################################

### initParties
################
def initParties():
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="NPCS",type=PT_COMPUTER)
    system.create_party(id="RATSKULLS_DROGENLABOR",type=PT_COMPUTER)
    system.create_party(id="RATSKULLS_GEISELCAMP",type=PT_COMPUTER)
    system.create_party(id="ADRIAN",type=PT_COMPUTER)
    system.create_party(id="ANIMALS",type=PT_COMPUTER)
    system.create_party(id="ZOO",type=PT_COMPUTER)

### initRegions
#################
def initRegions():
############
#Regionen #
#############
#Übersicht:
#
#Region_Colins_Dad:  Beim betreten greifen die Hyänen den Spieler an
#Region_Hostagecamp: Region um das Geiselcamp die das frühe Betreten
#                     verindert (in const definiert)
#Region_Hostages_Close: Region um die Geiseln, in der sie angesprochen werden
#                     Wenn alle Bewacher tot sind
#Region_Fort_Gate:   Region vor dem Tor des RS-Stützpunktes, dient zum
#                     Triggern von Passwortdialogen
#atack-region um den Leichnahm von Colins Vater (x=424 y=237)
    
    system.add_region("REGION_JIMBOB",665,305,685,340)
    
    system.add_region("REGION_WOHNWAGEN_LEILA",348.07, 460.12, 318.20, 484.11)#665,305,685,340)

    system.add_region("REGION_NIGEL",515,565,525,575)
    system.notify_region_entered(region="REGION_NIGEL", objectid="ALTER_EGO")
    
    system.add_region("GEISEL_LAGER",214,496,299,588)
    system.notify_region_entered("GEISEL_LAGER", partyid="UISPIELER")
    
    system.add_region("Region_Colins_Dad", 405, 218, 443, 256)
    system.notify_region_entered(region="Region_Colins_Dad", partyid="UISPIELER")
    system.add_region("Region_Hostagecamp", const.Region_Hostagecamp[0],
                                           const.Region_Hostagecamp[1],
                                           const.Region_Hostagecamp[2],
                                           const.Region_Hostagecamp[3])
    system.notify_region_entered(region="Region_Hostagecamp", partyid="UISPIELER")
    system.add_region("Region_Fort_Gate", 303, 379, 327, 364)
    
    system.add_region("Region_Fort_Gate_SAVEGAME", 303, 379, 327, 364)
    system.notify_region_entered(region="Region_Fort_Gate_SAVEGAME", partyid="UISPIELER")
    data().Region_Fort_Gate_Angelegt = True
    
    system.notify_region_entered(region="Region_Fort_Gate", partyid="UISPIELER")
    system.add_region("Region_Hostages_Close", 254, 545, 240, 567)
#system.notify_region_entered(region="Region_Hostages_Close", partyid="UISPIELER")
#Tierareale
#system.add_region(data().Region_Hirsche1  ,345,485,455,560)
#system.add_region(data().Region_Hirsche2  ,785,485,715,390)
#system.add_region(data().Region_Woelfe    ,515,295,455,335)
    pt  = object.get_position(const.OBJECT_THRESHER)
    pc  = object.get_position("CHUCK")
    pfa = object.get_position(const.OBJECT_FIRE_ALERT)
    system.add_region("REGION_THRESNER", pt[0]-10, pt[1]-10, pt[0]+10,pt[1]+10)
    system.add_region("REGION_CHUCK", pc[0]-7, pc[1]-7, pc[0]+7, pc[1]+7)
    system.add_region("REGION_FIRE_ALERT", pfa[0]-7, pfa[1]-7, pfa[0]+7, pfa[1]+7)
    
### initWaterResources
#######################
def initWaterResources():
    water.set_water_source(554.7,301.3, 4)
    water.set_water_source(582.0,554.0, 3)
    water.set_water_source(309.6,443.6, 2)
    
### initExitZones
##################
def initExitZones():
#die Namen hier müssen nicht unbedingt mit den Richtungen übereinstimmen ;-)
    system.add_region(id= "REGION_EXIT_NORD",  x1=1000, y1= 799, x2= 810, y2=   0)
    system.add_region(id= "REGION_EXIT_SUED",  x1= 210, y1= 799, x2=   0, y2=   0)
    system.add_region(id= "REGION_EXIT_WEST1", x1= 810, y1= 799, x2= 532, y2= 590)
    system.add_region(id= "REGION_EXIT_WEST2", x1= 494, y1= 799, x2= 532, y2= 600)
    system.add_region(id= "REGION_EXIT_WEST3", x1= 494, y1= 799, x2= 210, y2= 590)
    system.add_region(id= "REGION_EXIT_OST",   x1= 810, y1= 210, x2= 210, y2=   0)
    system.register_exit(regionname = "REGION_EXIT_NORD")
    system.register_exit(regionname = "REGION_EXIT_SUED")
    system.register_exit(regionname = "REGION_EXIT_WEST1")
    system.register_exit(regionname = "REGION_EXIT_WEST2")
    system.register_exit(regionname = "REGION_EXIT_WEST3")
    system.register_exit(regionname = "REGION_EXIT_OST")

### initEquipment
##################
## Equipment für NPCs die auch sterben können (TAs und Nebenquest)
def initEquipment():
#Nebenquest NPCs
    object.create_item_in_inventory("NIGEL",  ["SET_NORMAL_CLOTHES_4","SET_LEATHER_BOOTS"])
    object.create_item_in_inventory("WILLIAM",["SET_NORMAL_CLOTHES_6","SET_BOTTLE_OF_WHISKEY"])
    object.create_item_in_inventory("ADRIAN", ["SET_LOW_SHOES","SET_WATER_SKIN"])
    object.create_item_in_inventory("COLIN",  ["SET_GAME_JOY"])
#TA NPCs Casa Verde
    object.create_item_in_inventory("FRED",   ["SET_HYENA_PELT"])
    object.create_item_in_inventory("TIM",    ["SET_NORMAL_CLOTHES_2","SET_POWER_DRILL"])
    object.create_item_in_inventory("RUDOLPH",["SET_SPECIAL_38","SET_AMMOPACK_38"])
    object.create_item_in_inventory("MARY",   ["SET_LEATHER_BOOTS"])
    object.create_item_in_inventory("CAREN",  ["SET_LOW_SHOES","SET_HAIRSTYLE_MAGAZINE"])
    object.create_item_in_inventory("ELVIRA", ["SET_NORMAL_CLOTHES_2","SET_LEATHER_CAP"])
#object.create_item_in_inventory("HULDA",  [""])
    object.create_item_in_inventory("JON",    ["SET_NORMAL_CLOTHES_4"])
#TA NPCs Hayden Valley
    object.create_item_in_inventory("TOM",    ["SET_NORMAL_CLOTHES_3"])
    object.create_item_in_inventory("ANDY",   ["SET_NORMAL_CLOTHES_6"])
    object.create_item_in_inventory("STEVEN", ["SET_NORMAL_CLOTHES_5","SET_LEATHER_BOOTS"])
    object.create_item_in_inventory("PEGGY",  ["SET_CAKE_TIN","SET_WIRE_WHISK"])
    object.create_item_in_inventory("SHEILA", ["SET_NORMAL_CLOTHES_1","SET_LOW_SHOES"])
    object.create_item_in_inventory("DOROTHY",["SET_LEATHER_BOOTS","SET_TENT_CANVAS"])
    object.create_item_in_inventory("SUSAN",  ["SET_NORMAL_CLOTHES_2","SET_LOW_SHOES"])
    object.create_item_in_inventory("MATTHEW",["SET_SMALL_STOOL"])
    
####################
# Händlerinventare #
####################
# Gene: (Allroundhändler)
    object.create_item_in_inventory("GENE", ["SET_DRUGS_PILLS_01"]*40 + ["SET_DRUGS_PILLS_02"]*10 + 
        ["SET_DRUGS_PILLS_03"]*4  + ["SET_DRUGS_PILLS_04"]*4 + ["SET_MEDIPACK_SMALL"]*10 + 
        ["SET_MEDIPACK_BIG"]*10 + ["SET_WATER_SKIN"]*10 )

    object.create_item_in_inventory("GENE", ["SET_DRUGS_VIALS_01","SET_DRUGS_SYRINGE","SET_APPLE","SET_DUCT_TAPE","SET_DUCT_TAPE","SET_WATER_DETECTOR"])

    object.create_item_in_inventory("GENE", ["SET_MEAT_RAW_TINY"]*4 + ["SET_MEAT_COOKED_HUMONGOUS"]*4 + 
        ["SET_WATER_BOTTLE"]*4  + ["SET_MEAT_COOKED"]*4 + ["SET_BREAD"]*4 )


def make_miles_trader():
#Miles: (Waffenhändler)
    object.create_item_in_inventory("MILES", ["SET_DRUGS_PILLS_01"]*80 + ["SET_DRUGS_PILLS_02"]*4 +
        ["SET_DRUGS_PILLS_03"]*4  + ["SET_DRUGS_PILLS_04"]*4 )

    object.create_item_in_inventory("MILES",["SET_AMMOPACK_9_MM_SUBSONIC"]*9 + ["SET_AMMOPACK_5_45_MM"]*30 +
        ["SET_AMMOPACK_50"]*10 + ["SET_AMMOPACK_45"]*20 + ["SET_AMMOPACK_45_SUBSONIC"]*9 +
        ["SET_AMMOPACK_7_62NATO_MM"]*10 + ["SET_AMMOPACK_7_62SOVJET_MM"]*30 )

    object.create_item_in_inventory("MILES",["SET_BULLET_PROOF_CLOTHES"]*3 + ["SET_STEEL_HELMET"]*3 +
        ["SET_DT21_STEEL_CLAD_BOOTS"]*5 + ["SET_DT21_GAUNTLETS"]*2 + ["SET_LASERPOINTER"]*3 )

    object.create_item_in_inventory("MILES",(
        ["SET_WALTER_PPK",#walter ppk
         "SET_COLT_ANACONDA",#colt anaconda
         "SET_DESERT_EAGLE",#desert eagle
         "SET_AUTOMAG_3",#automag3
         "SET_UZI",#uzi
         "SET_AKSU74",#aksu74
         "SET_BROWNING_B_SS_DOUBLE_BARREL",#browning double barrel
         "SET_M_16",#m16
         "SET_HK_G41",#g41
         "SET_SIMONOV_SKS",#simonov sks
         "SET_MG_3",#mg-3
         "SET_FN_MAG",#fn mag
         "SET_MAC_10",#mac 10
         "SET_DRAGUNOV"]+#dragunov
         ["SET_HEGRENADE"] * 3 +#3 x he-grenade
         ["SET_LANDMINE"] * 10 +#10 x landmine
         ["SET_ANTITANKMINE",#tankmine
         "SET_MOLOTOV_COCKTAIL",#molotov
         "SET_BASEBALL_BAT",#baseballschläger
         "SET_KNIFE",#Messer
         "SET_BOOMERANG",#Boomerang
         "SET_RASP",#Eisenfeile
         "SET_PROTECTIVE_GLOVES",#Schutzhandschuhe
         "SET_STEEL_HELMET",#Einfacher Helm
         "SET_AMMOPACK_7_65_MM",#ammopack_7_65_mm
         "SET_AMMOPACK_7_62_54_MMR"] + #1 x ammopack_7_62_54_mmr
         ["SET_AMMOPACK_44",#2 x ammopack_44
         "SET_AMMOPACK_50"] * 2 +#2 x ammopack_50AE
         ["SET_AMMOPACK_2_12_MM",#4 x ammopack_2_12
         "SET_AMMOPACK_7_62SOVJET_MM",#4 x ammopack_7_62sovjet_mm
         "SET_AMMOPACK_9_MM",#8 x ammopack_9_mm
         "SET_AMMOPACK_9_MM"] * 4 +
         ["SET_AMMOPACK_7_62NATO_MM",#5 x ammopack_7_62nato_mm
         "SET_AMMOPACK_45",#5 x ammopack_5_45_mm
         "SET_AMMOPACK_5_7_MM_DUMDUM",#5 x ammopack_5_56_mm
         "SET_AMMOPACK_45"] * 5)#5 x ammopack_45
         ) #todo: Händlerinventar aktivieren

### initItems
##############
def initItems():
#in Blumentopf bei Friseur
    object.create_item_in_inventory(object='BUILDING_3505', equipment=["SET_RED_SHARD"])
#in Kiste bei Haus hinter Maren
    object.create_item_in_inventory(object='BUILDING_617', equipment=["SET_WATERING_CAN"])
#an Waescheleine bei Maren
    object.create_item_in_inventory(object='BUILDING_479', equipment=["SET_NORMAL_CLOTHES_3"])
#bei Schrotthaufen
    object.create_item_in_inventory(object='BUILDING_427', equipment=["SET_STAPLE_GUN"])
    object.create_item_in_inventory(object='BUILDING_15617', equipment=["SET_MEAT_RAW"])
    object.create_item_in_inventory(object='BUILDING_3562', equipment=["SET_BROKEN_POCKET_CALCULATOR"])
    object.create_item_in_inventory(object='BUILDING_520', equipment=["SET_BATTERY"]) #TODO: verschliessen
    system.create_object(equipmenttype="SET_BROKEN_SHOVEL", x = 692.16, y = 331.21)
    system.create_object(equipmenttype="SET_BICYCLE_SEAT", x = 686.28, y = 331.31)
    system.create_object(equipmenttype="SET_POWER_DRILL", x = 687.90, y = 343.60)
    system.create_object(equipmenttype="SET_GRAPHICS_CARD", x = 680.78, y = 335.35)
#Schrank in Haus ???
    object.create_item_in_inventory(object='BUILDING_9639', equipment=["SET_WRITING_PAD"])
#Kommode in Haus ???
    object.create_item_in_inventory(object='BUILDING_9674', equipment=["SET_RED_SHARD", "SET_GARLIC_PRESS", "SET_SHURIKEN"])
#Holzscheite bei Haus ???
    object.create_item_in_inventory(object='BUILDING_482', equipment=["SET_RUSTY_IRON_ROD"])
#Kistenstapel bei Chuck
    object.create_item_in_inventory(object='BUILDING_4055', equipment=["SET_WATER_SKIN", "SET_SPADE"]) #TODO: verschliessen
#grosses Gebaude im oberen Dorf
    object.create_item_in_inventory(object='BUILDING_9564', equipment=["SET_SMALL_STOOL"])
    system.create_object(equipmenttype="SET_AMMOPACK_4_6_MM", x = 523.73, y = 465.09)
#in Hundehuette bei Saeufer
    object.create_item_in_inventory(object='BUILDING_3784', equipment=["SET_MEAT_RAW_SMALL"])
#Ruine im oberen Dorf
    system.create_object(equipmenttype="SET_COOKING_POT", x = 509.54, y = 529.57)
#Marktplatz
    object.create_item_in_inventory(object='BUILDING_3765', equipment=["SET_DART", "SET_HEADPHONE"])
    object.create_item_in_inventory(object='BUILDING_3746', equipment=["SET_AMMOPACK_5_7_MM"])
    object.create_item_in_inventory(object='BUILDING_3775', equipment=["SET_TRASH_CAN", "SET_SMALL_BAG"])
#Muelltonne/Muellsack bei Marktplatz
    object.create_item_in_inventory(object='BUILDING_3747', equipment=["SET_HAIR_DRYER"])
    object.create_item_in_inventory(object='BUILDING_3749', equipment=["SET_SMALL_SAND_SHOVEL"])
#Schrottauto + Reifenstapel im oberen Dorf
    object.create_item_in_inventory(object='BUILDING_999', equipment=["SET_STAPLE_GUN", "SET_LONG_LEATHER_STRAP"])
    object.create_item_in_inventory(object='BUILDING_1003', equipment=["SET_HEAD_REST"])
#bei Leila in Kiste
    object.create_item_in_inventory(object='BUILDING_1120', equipment=["SET_BIG_KNIFE"]) #TODO: verschliessen
#auf Tisch in Haus ???
    system.create_object(equipmenttype="SET_EMPTY_BOTTLE", x = 534.87, y = 569.24, id="empty bottle")
    object.set_position_free("empty bottle", x = 534.87, y = 569.24, z = 1.1)
#Schrankwand in Haus ???
    object.create_item_in_inventory(object='BUILDING_9881', equipment=["SET_FLUTE"])
#Waescheleine bei Adrian
    object.create_item_in_inventory(object='BUILDING_367', equipment=["SET_BULLET_PROOF_CLOTHES"])
    
#Drugfort
#Muelltonne
    object.create_item_in_inventory(object='BUILDING_9326', equipment=["SET_WIRE_WHISK"])
#auf Tisch in Haus ???
    system.create_object(equipmenttype="SET_DRUGS_PILLS_01", x = 287.97, y = 340.07, id="drug pills")
    object.set_position_free("drug pills", x = 287.97, y = 340.07, z = 0.8)
#Truhe in Huette
    object.create_item_in_inventory(object='BUILDING_12715', equipment=["SET_HEGRENADE", "SET_AMMOPACK_7_62NATO_MM"]) #TODO: verschliessen
#Kistenstapel+Kiste
    object.create_item_in_inventory(object='BUILDING_6520', equipment=["SET_CAKE_TIN"])
    object.create_item_in_inventory(object='BUILDING_6525', equipment=["SET_BICYCLE_SEAT"])
#in langer Halle
    object.create_item_in_inventory(object='BUILDING_9703', equipment=["SET_WATER_BOTTLE"])
    object.create_item_in_inventory(object='BUILDING_9719', equipment=["SET_AK_47"])
    system.create_object(equipmenttype="SET_PLASTIC_BOWL", x = 335.11, y = 310.34, id="plastic bowl")
    object.set_position_free("plastic bowl", x = 335.11, y = 310.34, z = 1.8)
    
# Laborschlüssel (Grüne Kiste
#todo: hier gehört ein Gefängisschlüssel hin
    object.create_item_in_inventory(object='BUILDING_4087', equipment='SET_BIG_KEY',   id='Z4PRISON_KEY')

#Bienenstöcke Z4
    object.create_item_in_inventory( 'BUILDING_610', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_612', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_614', equipment=[ 'SET_BEESWAX' ] )
            
#Items in Kisten
    object.create_item_in_inventory( 'BUILDING_16869', equipment=[ 'SET_MULTIPLE_SOCKET', 'SET_BERETTA_92F', 'SET_SHURIKEN', 'SET_SMALL_BACKPACK' ] )
    object.create_item_in_inventory( 'BUILDING_16870', equipment=[ 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_50', 'SET_AMMOPACK_9_MM' ] )
    object.create_item_in_inventory( 'BUILDING_16871', equipment=[ 'SET_BULLET_PROOF_CLOTHES', 'SET_ORDINARY_HELMET', 'SET_WATER_BOTTLE' ] )
    object.create_item_in_inventory( 'BUILDING_16892', equipment=[ 'SET_BICYCLE_SEAT', 'SET_CRANK', 'SET_ANTITANKMINE' ] )
    object.create_item_in_inventory( 'BUILDING_16928', equipment=[ 'SET_RPK_74', 'SET_BOOMERANG', 'SET_AMMOPACK_9_MM_DUMDUM', 'SET_MEDIPACK_BIG' ] )
    object.create_item_in_inventory( 'BUILDING_16929', equipment=[ 'SET_RUSTY_IRON_ROD', 'SET_AMMOPACK_357', 'SET_LEATHER_CLOTHES' ] )
    object.create_item_in_inventory( 'BUILDING_16934', equipment=[ 'SET_MEAT_RAW', 'SET_ANTIDOTE', 'SET_MACHETE', 'SET_BELT' ] )
    object.create_item_in_inventory( 'BUILDING_9656', equipment=[ 'SET_AMMOPACK_5_45_MM', 'SET_AMMOPACK_45_SUBSONIC_DUMDUM', 'SET_BULLET_CATCH' ] )
    object.create_item_in_inventory( 'BUILDING_9423', equipment=[ 'SET_WIRE_WHISK', 'SET_WATERTIGHT_RING', 'SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM' ] )
                         

### initHerbs
#############
def initHerbs():
    system.create_object(equipmenttype="SET_ALOE_VERA", x=407.92, y=568.67)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=223.23, y=576.63)
    system.create_object(equipmenttype="SET_BURNET", x=785.07, y=487.48)
    system.create_object(equipmenttype="SET_ALOE_VERA", x=267.20, y=458.37)
    system.create_object(equipmenttype="SET_ALOE_VERA", x=242.16, y=303.66)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=435.18, y=211.91)
    system.create_object(equipmenttype="SET_ANGELICA", x=414.48, y=505.36)
    system.create_object(equipmenttype="SET_ALOE_VERA", x=396.16, y=500.1)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=681.57, y=249.8)
    system.create_object(equipmenttype="SET_ALOE_VERA", x=491.72, y=326.52)
    
### initFX
###########
def initFX():
    sounds.load_sound(sfx_id='audience_applause')
    sounds.load_sound(sfx_id='laughing_audience')
    sounds.load_sound(sfx_id='splashing_water')
    sounds.load_sound(sfx_id='working_windmill')
    sounds.load_sound(sfx_id='shot_calico_m950')
    sounds.load_sound(sfx_id='crane_setting_down_container')
    
    if not hasattr(data(), "windmill_working"):
        data().windmill_working = True
        sounds.play_3d_sound_object(sfx_id="working_windmill",object="BUILDING_3817",loop=True)
    
#Windmühle Animation starten
    WindmuehleAnimation('bla')
    if not data().Thresher_sabotaged:
        ThresherOn()
    else:
        ThresherOff()
## Lagerfeuer
    for id in const.FIRE_PLACES:
        system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
#system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
        system.start_effect_object(object=id,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
        system.start_effect_object(object=id,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
        system.start_effect_object(object=id,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
        system.start_effect_object(object=id,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
        sounds.play_3d_sound_object(sfx_id="campfire_big",object=id,loop=True)
    
## Feuertonnen:
    for id in const.FIRE_BARRELS:
#system.start_effect_object(object=id,node="sort0",parameter=fx_smoke_brennende_tonne)
        system.start_effect_object(object=id,node="sort1",parameter=fx_fire_brennende_tonne)
        sounds.play_3d_sound_object(sfx_id="campfire_small",object=id,loop=True)

### initSchedules
##################
def initSchedules():
## Haustiere spawnen:
    system.create_animal(id="DOROTHY_PET1", type=ANIMAL_COW, party="ANIMALS", x=493.51, y=586.92)
    system.create_animal(id= "SUSAN_MAGGOT_SOURCE", type = ANIMAL_PIG, party="ANIMALS",
                        x = const.SUSAN_GUT_POINT[0],
                        y = const.SUSAN_GUT_POINT[1])
    
### initQuests
###############
def initQuests():
## Questbookeinträge registrieren
#for nr in range(1, 23):
#   snr = "QB_" + (("00" + str(nr))[-3:])
#   data().__dict__[snr] = system.register_qb_entry(snr)
#   #Exec("data()." + snr + " = system.register_qb_entry('" + snr + "')")
    data().QB_002 = system.register_qb_entry('ZONE4_AIM_02')
    data().QB_003 = system.register_qb_entry('ZONE4_AIM_03')
    data().QB_004 = system.register_qb_entry('ZONE4_AIM_04')
    data().QB_005 = system.register_qb_entry('ZONE4_AIM_05')
    data().QB_006 = system.register_qb_entry('ZONE4_AIM_06')
    data().QB_007 = system.register_qb_entry('ZONE4_AIM_07')
    data().QB_008 = system.register_qb_entry('ZONE4_AIM_08')
    data().QB_009 = system.register_qb_entry('ZONE4_AIM_09')
    data().QB_010 = system.register_qb_entry('ZONE4_AIM_10')
    data().QB_011 = system.register_qb_entry('ZONE4_AIM_11')
    data().QB_012 = system.register_qb_entry('ZONE4_AIM_12')
    data().QB_013 = system.register_qb_entry('ZONE4_AIM_13')
    data().QB_014 = system.register_qb_entry('ZONE4_AIM_14')
    data().QB_015 = system.register_qb_entry('ZONE4_AIM_15')
    data().QB_016 = system.register_qb_entry('ZONE4_AIM_16')
    data().QB_017 = system.register_qb_entry('ZONE4_AIM_17')
    data().QB_018 = system.register_qb_entry('ZONE4_AIM_18')
    data().QB_019 = system.register_qb_entry('ZONE4_AIM_19')
    data().QB_020 = system.register_qb_entry('ZONE4_AIM_20')
    data().QB_021 = system.register_qb_entry('ZONE4_AIM_21')
    data().QB_022 = system.register_qb_entry('ZONE4_AIM_22')
        
## Quests initialisieren:
    MarktQuestInit()
    ColinQuestInit()
    JimBobQuestInit()
    MainQuestInit()
## Questitems initialisieren:
    quest_items = [    'MARENS_SOAP',
            'COLINS_NECKLACE',
            'ADRIANS_TEDDY_BEAR',
            'Thresher_destroyer']
    map(lambda o: object.set_attribute(o, "generic_item", False), quest_items)

# setzt chars mortal bzw immortal
def init_character_states():
    npcs = system.get_npcs()
    for npc in npcs:
        object.set_immortal_state(npc, True)
        if object.has_attribute(npc, "foes"):
            if object.get_attribute(npc, "foes") != None:
                object.set_immortal_state(npc, False)
        if npc in ["MAREN", "CHUCK", "WILLIAM", "COLIN_DAD", "MERCENARY_KENO"]:
            object.set_immortal_state(npc, False)
    
    for ratskull in data().FortRatSkulls:
        character.set_approachable_state(ratskull, NOTAPPROACHABLE)
        object.set_immortal_state(ratskull, True)
        
    for ratskull in data().HostageCampRatSkulls:
        character.set_approachable_state(ratskull, NOTAPPROACHABLE)
        if not object.is_destroyed(ratskull):
            object.set_immortal_state(ratskull, True)
    
    for id in ["DRUGMANA", "DRUGMANB", 'RSWACHE']:
        character.set_approachable_state(id, False)
        object.set_immortal_state(id, True)

# initialisiert die questitems, die man durch das killen eines npcs bekommen kann
def init_questitems():
    object.create_item_in_inventory( object='CHUCK', equipment='SET_RAT_FUR_JACKET', id='CHUCKS_JACKET')
    object.create_item_in_inventory( object='CHUCK', equipment='SET_WATER_SKIN')

################################################################################
### Events #####################################################################
################################################################################

def on_post_load():
    if not data().Thresher_sabotaged:
        sounds.load_sound(sfx_id='treshing_machine')
    initFX()
    schedules.init_schedules()
    init_patch()
    
### on_init
###########
def on_init():
    skies.init_sky_preset("orange")

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
#spezielle non rest regionen
        system.add_region("Dorf_Casa_Verde",600,250,705,380)
        system.add_region("Dorf_2",480,445,565,600)
        system.add_region("Leilas_Wohnwagen",345,460,315,480)
        system.add_region("Geiselcamp",210,515,290,590)
        system.add_region("Drogenlabor",265,365,370,235)
        system.notify_region_entered(region="Drogenlabor", partyid="UISPIELER",permanent=True)

    data("rest").non_rest_areas.append("Dorf_Casa_Verde")
    data("rest").non_rest_areas.append("Dorf_2")
    data("rest").non_rest_areas.append("Leilas_Wohnwagen")
    data("rest").non_rest_areas.append("Geiselcamp")
    data("rest").non_rest_areas.append("Drogenlabor")
    

### on_map_loaded
################
def on_map_loaded():
    const.init_data()
    initParties()
## chars generieren:
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
    npc.initNPCS()
    npc.initEnemies()
## tiere initialisieren:
    npc.initAnimals()
    char_autogeneration.init_Mercenary('MERCENARY_KENO')
    if hasattr(data("zone_4.zone_4"), "Keno_has_his_Sally"):
        data("zone_4.zone_4").Keno_has_his_Sally = True
    system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
## items generieren:
    initItems()
    initHerbs()
    initEquipment()
## chars initialisieren:
    initSchedules()
    initQuests()
## level initialisieren:
    initFX()
    initMinimapMarkers()
    sounds.load_sound(sfx_id='treshing_machine')
    initRegions()
    initExitZones()
    initWaterResources()
#RSGateOpen() #no gate at the fort!
    schedules.init_schedules() ## immer nach dem initQuestbook()

    init_character_states()
    init_questitems()
    init_scriptuse_objects()
    InitChestsSafes()
    generate_animation_rsgate()
    init_non_rest_areas()
    init_lock_state(OBJECT_PRISON, 'lock')
#leilas wagen für immer abgeschlossen (nur für die pcs)
    init_lock_state("ZONE_4_BUILDING_3849", 'lock')
    init_main_npcs()

# markiert objekte die im script modifiziert werden
def init_scriptuse_objects():
    for lf in const.FIRE_PLACES:
        system.mark_for_script_use(lf)
    system.mark_for_script_use('BUILDING_3918')
    system.mark_for_script_use('BUILDING_4082')
#tor am fort
    system.mark_for_script_use('BUILDING_3862')
    system.mark_for_script_use('BUILDING_3817')
    system.mark_for_script_use(OBJECT_PRISON)
    
    
#kisten, truhen, tresore
    system.mark_for_script_use('BUILDING_16896')

    system.mark_for_script_use('BUILDING_16869')
    system.mark_for_script_use('BUILDING_16870')
    system.mark_for_script_use('BUILDING_16871')
    system.mark_for_script_use('BUILDING_16892')
    system.mark_for_script_use('BUILDING_16928')
    system.mark_for_script_use('BUILDING_16929')
    system.mark_for_script_use('BUILDING_16934')
    system.mark_for_script_use('BUILDING_9656')
    system.mark_for_script_use('BUILDING_9423')

#Bienenstöcke Zone 4
    system.mark_for_script_use('BUILDING_610')
    system.mark_for_script_use('BUILDING_612')
    system.mark_for_script_use('BUILDING_614')


### on_map_reentry
#################
def on_map_reentry():
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    if ( isinstance(data().JIMBOB_AMORE_FINISH_TIME,time) ):
        if (system.get_mission_time() - data().JIMBOB_AMORE_FINISH_TIME) > time("72:00:00"):
            data().JIMBOB_DANA_DIRTY = True
            object.set_attributes("JIMBOB",
                model="low",
                gender="male",
                skin="white",
                clothes="rat_fur_jacket",
                face="jim_bob",
                dialog_face="jim_bob_tidy.png")
            character.update_appearance("JIMBOB")
            object.set_attributes("DANA",
                model="low",
                gender="female",
                skin="white",
                clothes="sl_001",
                face="dana_untidy",
                dialog_face="dana_untidy.png")
            character.update_appearance("DANA")
    init_non_rest_areas()
    initFX()
    if not data().Thresher_sabotaged:
        sounds.load_sound(sfx_id='treshing_machine')
    schedules.init_schedules()
    
    if was_zone_entered("sqzone_3.sqzone_3"):
#        if data("sqzone_3.sqzone_3").SQZ3_PunkteVermessen >= 3:
        if data("sqzone_3.sqzone_3").PunktNordenVermessen and data("sqzone_3.sqzone_3").PunktWestenVermessen and data("sqzone_3.sqzone_3").PunktSuedenVermessen:
            if not data().myriam_quest_status >= 1:
                data().myriam_quest_status = 1
                
    init_patch()

def initMinimapMarkers():
    system.add_minimap_marker(303.50,310.47,"MM_001")#Drogenlabor der Ratskulls

### on_approach
################
def on_approach(target, operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)

#makes char_id equip a weapon if one is found
def un_equip_weapon(char_id):
    inventory = object.get_inventory_ids(char_id)
    weapon = get_equiped_weapon(char_id, inventory)
    if weapon:
        character.un_equip_direct(char_id, weapon)

#checks if chars has a weapon, 
#  returns False if no weapon is equiped
#  returns type of weapons that is equiped
def get_equiped_weapon(char_id, inventory):
    import character
    weapons = []
    for item in inventory:
        if len(item[0]):
            item_type = item[0][0]
            if object.has_attribute(item_type, "weapon_type"):
                if character.is_equiped(char=char_id, equipment=item_type):
                    return item_type
    return False

### on_wait_for_commando
#########################
def on_wait_for_commando(id):
    if id in data().AttendsToPerformance:
        if id in data().PerformancePositionTaken:
            return False
        data().PerformancePositionTaken.append(id)
        object.cancel_commandos(id)
        un_equip_weapon(id)
        object.set_position(id, data().PerformanceWatchingPositions[0][0],
                            data().PerformanceWatchingPositions[1][0])
        del data().PerformanceWatchingPositions[0][0]
        del data().PerformanceWatchingPositions[1][0]
        object.turn_to_object(id, 'ADRIAN')
        return True
    if id in data().PlayAnimation and data().PlayAnimation[id] != "":
        animation = data().PlayAnimation[id]
        if animation == "conversate":
            animation = "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 )
        if animation == "wait":
            animation = "CM_NPC_STEHEN_WARTEN_%d" % random.randint( 1, 5 )
        if animation == "sit_on_ground":
            animation = 'CM_NPC_SITZEN_BODEN_LOOP'
        if animation == "sit_on_bench":
            animation = 'CM_NPC_SITZEN_BANK_LOOP'
        if animation == 'wash':
            animation = random.choice(['CM_NPC_STEHEN_WAESCHE_WASCHEN_LOOP_SCHWITZEN'] +
                                      ['CM_NPC_STEHEN_WAESCHE_WASCHEN_LOOP'] * 5)
        character.play_animation(id, animation)
        return True
#return False
    return schedules.Activity(id)

### on_enter_region
####################
def on_enter_region(id, objectid, partyid):
    print 'on_enter_region(', id, objectid, partyid, ')'
#non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid):
            objectid=objectid[0]
        else: 
            if id == "Drogenlabor":
                enableRest()
#                print "Resting enabled"
            return
    
    if id == "Drogenlabor":
        disableRest()
#        print "Resting disabled"

    if id == "REGION_WOHNWAGEN_LEILA":
        data().region_wohnwagen_entered = True
        data().region_wohnwagen_notified = False
        
        object.cancel_commandos('ALTER_EGO')
        object.turn_to_object("ALTER_EGO", "ZONE_4_BUILDING_3849")
        if not hasattr(data(),"caravan_comment_active"):
            return False
        else:
            if data().caravan_comment_active:
                if not data().player_knows_leila:
                    dialogs.initDlg_156_SpielerSiehtRatskullsImWohnwagen_KenntLeilaNicht()
                else:
                    if not data().player_needs_password:
                        dialogs.initDlg_157_SpielerSiehtRatskullsImWohnwagen_KenntLeilaAberWeissNixVonPasswort()
                    else:
                        if ((system.get_qb_entry_state(data().QB_004) == COMPLETE) or (system.get_qb_entry_state(data().QB_009) == COMPLETE)):
                            dialogs.initDlg_159_SpielerSiehtRatskullsImWohnwagen_KenntLeilaWeissVonPasswortHatWanze()
                        else:
                            dialogs.initDlg_158_SpielerSiehtRatskullsImWohnwagen_KenntLeilaAberWeissVonPasswort()
    
    if id == "REGION_JIMBOB":
        if (data().player_knows_leila and 
            data().player_needs_password and 
            not system.get_qb_entry_state(data().QB_009) in [UNCOMPLETE, COMPLETE] and
            not system.get_qb_entry_state(data().QB_005) in [UNCOMPLETE, COMPLETE] and
            not system.get_qb_entry_state(data().QB_006) in [UNCOMPLETE, COMPLETE] and
            not system.get_qb_entry_state(data().QB_007) in [UNCOMPLETE, COMPLETE] and
            not system.get_qb_entry_state(data().QB_004) in [UNCOMPLETE, COMPLETE]):
            dialogs.initDlg_151_SpielerEntdecktJimbobsBastlerladen()
    
    if id == "REGION_NIGEL":
        if system.get_qb_entry_state(data().QB_013)==INACTIVE:
            object.cancel_commandos(objectid)
            object.turn_to_object(objectid, "NIGEL", callback=["ONEND",dialogs.initDlg_075_Nigel_preist_an])
    
    if id == "REGION_CHUCK":
        if not object.is_destroyed("CHUCK"):
            if object.get_distance(objectid, "CHUCK") <= 15.0:
                if system.get_qb_entry_state(data().QB_007) in [UNCOMPLETE]:
                    if not data().region_comment_given[id][0]:
                        dialogs.initDlg_147_SpielerBewundertChucksSakko(objectid)
                        data().region_comment_given[id][0] = True
                else:
                    if not data().region_comment_given[id][1]:
                        dialogs.initDlg_149_SpielerUeberlegtChuckSakkoAbzuknoepfen(objectid)
                        data().region_comment_given[id][1] = True
    
    elif id == "REGION_THRESNER":
        if not object.is_destroyed("CHUCK"):
            if not data().region_comment_given[id][0]:
                dialogs.initDlg_148_DreschmaschineBringtSpielerAufDummeIdeen(objectid)
                data().region_comment_given[id][0] = True
    
    elif id == "REGION_FIRE_ALERT":
        if not object.is_destroyed("CHUCK"):
            if data().Chuck_repairs:
                if not data().region_comment_given[id][0]:
                    object.cancel_commandos(objectid)
                    object.turn_to_object(objectid, const.OBJECT_FIRE_ALERT)
                    dialogs.initDlg_150_SpielerMoecheteGerneAlarmAusloesen(objectid)
                    data().region_comment_given[id][0] = True

    elif id == "Region_Colins_Dad" and partyid == "UISPIELER" \
            and not data().Dad_killers_are_foes:
        DadKillerAttackPlayer(objectid)
        data().Dad_killers_are_foes = True;
    
    elif id == "Region_Hostagecamp":
        if system.get_qb_entry_state(data().QB_011) == INACTIVE:
            g = []
            for c in system.get_pcs():
                x = object.get_attribute(c, 'x')
                y = object.get_attribute(c, 'y')
                if const.Region_Hostagecamp[0] < x and \
                   x < const.Region_Hostagecamp[2] and \
                   const.Region_Hostagecamp[1] < y and \
                y < const.Region_Hostagecamp[3]:
                    g.append(c)
            if data().Camp_escape_flag:
                system.start_cutscene()
            for c in g:
                object.cancel_commandos(c)
                px = object.get_attribute(c, "x")
                py = object.get_attribute(c, "y")
                if abs(const.Region_Hostagecamp[0] - px) \
                < abs(const.Region_Hostagecamp[2] - px):
                    shortestX = const.Region_Hostagecamp[0] - px
                else:
                    shortestX = const.Region_Hostagecamp[2] - px
                if abs(const.Region_Hostagecamp[1] - py) \
                < abs(const.Region_Hostagecamp[3] - py):
                    shortestY = const.Region_Hostagecamp[1] - py
                else:
                    shortestY = const.Region_Hostagecamp[3] - py
                if abs(shortestY) < abs(shortestX):
                    object.move_to(c, px, py + (shortestY / abs(shortestY) * 5), "landscape", MT_FAST,
                    ["ONEND", Lambda('system.notify_region_entered(region="Region_Hostagecamp", partyid="UISPIELER")')])
                    if data().Camp_escape_flag:
                        dialogs.initDlg_072_Achtung_Geiseln()
                else:
                    object.move_to(c, px + (shortestX / abs(shortestX) * 5), py, "landscape", MT_FAST,
                    ["ONEND", Lambda('system.notify_region_entered(region="Region_Hostagecamp", partyid="UISPIELER")')])
                    if data().Camp_escape_flag:
                        dialogs.initDlg_072_Achtung_Geiseln()
            
    elif id == 'Region_Hostages_Close':
        if objectid == 'ALTER_EGO':
            if not data().Region_Hostages_Close:
                data().Region_Hostages_Close = True
                dialogs.initDlg_069_Geiseln_befreit()
        else:
            Delay(5, Lambda('system.notify_region_entered(region="Region_Hostages_Close", partyid="UISPIELER")'))
            return
    
    elif id == "Region_Fort_Gate":
        data().Region_Fort_Gate = True
        if data().alter_ego_rampage:
            return
        
        if data().Fort_escape_flag:
            Delay(2, Lambda('system.notify_region_entered(region="Region_Fort_Gate", partyid="UISPIELER")'))
            return
        
        data().Fort_escape_flag = True
        map(object.cancel_commandos, system.get_pcs())
        dialogs.on_approach("RSWACHE", objectid)
        
#region wurde eingeführt um das betreten des forts auch mit kaputten savegames möglich zu machen ('Region_Fort_Gate')
    if id == 'Region_Fort_Gate_SAVEGAME' and not data().Region_Fort_Gate:
        if data().alter_ego_rampage:
            return
        
        if data().Fort_escape_flag:
            Delay(2, Lambda('system.notify_region_entered(region="Region_Fort_Gate", partyid="UISPIELER")'))
            return
        
        data().Fort_escape_flag = True
        map(object.cancel_commandos, system.get_pcs())
        dialogs.on_approach("RSWACHE", objectid)
    
    elif id == "GEISEL_LAGER":
        if not data().player_knows_geiselcamp:
            data().player_knows_geiselcamp = True
            system.add_minimap_marker(249.20, 553.06,"MM_005")# Geiselcamp

def generate_animation_rsgate():
    close_x = 315.0
    close_y = 363.7
    open_x = 322.8
    open_y = 360.0
    direction = 246
#direction = object.get_direction("BUILDING_3862")
    object.set_active_state("BUILDING_3862", 0)
    system.create_object("RES3D_SCHULBUS_TOR_OPEN",close_x,close_y,"BUS_TOR_OFFEN",direction=direction)
    object.set_active_state("BUS_TOR_OFFEN", 0)
    system.create_object("RES3D_SCHULBUS_TOR",close_x,close_y,"BUS_TOR_ZU",direction=direction)
#damit sie nicht angreifbar sind
    object.set_immortal_state('BUS_TOR_OFFEN', True)
    object.set_immortal_state('BUS_TOR_ZU', True)
    
def animate_rsgate(state="opening"):
    if  data().tor_animation_frame < len(data().tor_anmation_frames):
        x = data().tor_anmation_frames[data().tor_animation_frame][0]
        y = data().tor_anmation_frames[data().tor_animation_frame][1]
    else:
        if state == "opening":
            data().gate_state = "opened"
        elif state == "closing":
            data().gate_state = "closed"
    
#wanna open da gate?
    if state == "opening":
        if not data().gate_state == "opened":
            data().gate_state  = "opening"
            object.set_position_free('BUILDING_3862',x,y, 0)
            data().tor_animation_frame -= 1
            system.notify_timer(data().Timer_BusTorAnimation, data().Timervalue_BusTorAnimation)
            if data().tor_animation_frame <= 0:
                data().gate_state = "opened"
    
#wanna close da gate?
    elif state == "closing":
        if not data().gate_state == "closed":
            data().gate_state  = "closing"
            object.set_position_free('BUILDING_3862',x,y, 0)
            data().tor_animation_frame += 1
            system.notify_timer(data().Timer_BusTorAnimation, data().Timervalue_BusTorAnimation)
            if data().tor_animation_frame >= len(data().tor_anmation_frames):
                data().gate_state = "closed"

### on_timer
#############
def on_timer(id):
#checkt ob cutscene laeuft und startet weiter wenn negativ
    if id == data().Timer_Cutscene:
        if system.is_cutscene() or dialog.is_dialog_active():
            system.notify_timer(data().Timer_Cutscene,data().Timervalue_Cutscene)
        else:
            if data().cutscene_name == "drugcar_start":
                drugcar_reaches_leila()
    
    if id == data().Timer_BusTorAnimation:
        animate_rsgate(data().gate_state)
    
    if id == data().Timer_DialogQueue:
        if dialog.is_dialog_active() or system.is_cutscene():
            system.notify_timer(data().Timer_DialogQueue, data().Timervalue_DialogQueue)
        else:
            if data().dialog_queue == 'D_125':
                dialogs.initDlg_125_Spieler_beschaedigt_die_Muehle()
            data().dialog_queue = None
    
    if id in data().ActiveMisc: #delay Timer
        for exp in data().ActiveMisc[id]:
            exp()
        del data().ActiveMisc[id]
        data().Timer_Misc.append(id)
    
    elif id == data().Chuckwalk:
        if object.is_destroyed("CHUCK"):
            return False
        
        if data().Chuck_is_away:
            return;
        data().Chuck_is_away = True
        map(lambda p: object.move_to("CHUCK", p[0], p[1], "landscape", MT_SLOW),
            const.ChuckWalkWaypoints[:-2])
        object.move_to("CHUCK", const.ChuckWalkWaypoints[-1][0], 
                               const.ChuckWalkWaypoints[-1][1],
                               "landscape", MT_SLOW,["ONEND", ChuckIsBack])

    elif id == data().Timer_Fort_Alert:
        data().Timercount_Fort_Alert -= 1
        if data().Timercount_Fort_Alert == 0:
            makePeace()
            FortAlertOff()
    
## Zeitauslöser, triggert jede Stunde
    if (id==data().Timer_SpawnTimeChecker):
        clock = system.get_mission_time().get_day_time()
        system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
        if (clock >= time("06:00:00") and clock < time("22:00:00")):
            npc.spawnAnimals(INACTIVE)
        else:
            npc.spawnAnimals(ACTIVE)
            
#checkt den start des drogenautos
    if id==data().Timer_DrugCarStart:
        clock = system.get_mission_time().get_day_time()
        if time("09:00:00") < clock < time("10:00:00"): #todo: richtige Zeit messen, damit der Wagen um ca. 10 bei Leila ankommt
            if not data().drugcar_started:
                data().drugcar_started = True
                DrugTransportPhase1()
        else:
            system.notify_timer(data().Timer_DrugCarStart, data().Timervalue_DrugCarCheck)
    
#checkt den start des drogenautos von leila aus
    if id == data().Timer_DrugCarLeaveLeila:
        DrugTransportPhase5()
    

#################
# on_attack #
#################
def on_attack(operator_id, target_id):
    if operator_id not in system.get_pcs():
        return

    if target_id == "MAREN":
        if not object.has_attribute("MAREN", "foes"):
            dialogs.onDlg_024_Kampf()
    
    if target_id == "CHUCK":
        if not object.has_attribute("CHUCK", "foes"):
            dialogs.onDlg_037_Kampf()
    
    if target_id == "WILLIAM":
        if not object.has_attribute("WILLIAM", "foes"):
            dialogs.onDlg_083_Kampf()
            
    if target_id == "DRUGMANA":
        if not object.has_attribute(target_id, "foes"):
            object.create_item_in_inventory(target_id, ["SET_HK_USP_45_W_SILENCER","SET_AMMOPACK_45"])
            character.equip_direct(target_id,"SET_HK_USP_45_W_SILENCER",direct_ammo_load=True)
            object.set_attribute(target_id, "foes", ['UISPIELER'])
            on_attack(operator_id,"ENEMY_FORT_G10")
            on_attack(operator_id,"DRUGMANB")
            
    if target_id == "DRUGMANB":
        if not object.has_attribute(target_id, "foes"):
            object.create_item_in_inventory(target_id, ["SET_AUTOMAG_3","SET_AMMOPACK_7_62NATO_MM"])
            character.equip_direct(target_id,"SET_AUTOMAG_3",direct_ammo_load=True)
            object.set_attribute(target_id, "foes", ['UISPIELER'])
            on_attack(operator_id,"ENEMY_FORT_G10")
            on_attack(operator_id,"DRUGMANA")
    
    if target_id == "ENEMY_FORT_G10":
        if not object.has_attribute(target_id, "foes"):
            object.step_away(target_id)
            character.equip_direct(target_id,"SET_SPECIAL_38",direct_ammo_load=True)
            object.set_attribute(target_id, "foes", ['UISPIELER'])

    if target_id in ["ENEMY_FORT_P02","ENEMY_FORT_G03"]:
        if not object.has_attribute(target_id, "foes"):
            object.set_attribute(target_id, "foes", ['UISPIELER'])
            on_attack(operator_id,"ENEMY_FORT_G02")
    
    if target_id == "ENEMY_FORT_G02":
        if not object.has_attribute(target_id, "foes"):
            prohibit_activity(target_id)
            character.equip_direct(target_id,"SET_SPECIAL_38",direct_ammo_load=True)
            object.set_attribute(target_id, "foes", ['UISPIELER'])
            
    if target_id in ["RSWACHE", "ENEMY_FORT_G19", "ENEMY_FORT_G20", "RSGUARD_FRONT"]:
        if not data().alter_ego_rampage:
            if not data().player_knows_password:
                for rs in ["RSWACHE", "ENEMY_FORT_G19", "ENEMY_FORT_G20", "RSGUARD_FRONT"]:
                    if not object.is_destroyed(rs):
                        object.set_attribute(rs, "maxhitpoints", 1000)
                        object.set_attribute(rs, "hitpoints", 1000)
                        object.set_position('RSGUARD_FRONT', 309.49, 387.48)
                        object.set_attribute(rs, "foes", ["UISPIELER"])
                        object.turn_to_object(rs, operator_id)
                data().alter_ego_rampage = True
            if not data().gate_open:
                RSGateOpen()
            for id in data().FortRatSkulls:
                if not object.is_destroyed(id):
                    object.turn_to_object(id, operator_id)
                    object.set_attribute(id, "foes", ["UISPIELER"])
    
    elif target_id in data().FortRatSkulls:
        data().FriedenFlag = False
        if (data().FortAlert % 2) == 0: # nicht A (kein Alarm)
            makePCPartialEnemy(operator_id)
            makeFullEnemy(target_id)
        else:# A (Alarm ausgelöst)
            resetAlertTimer()
    else:
        object_events.on_attack(operator_id, target_id)

####################
# on_enemy_spotted #
####################
def on_enemy_spotted(object_id):
    if object_id not in (data().HostageCampRatSkulls + data().FortRatSkulls):
        return

    if object_id != 'RSWACHE':
        npc.stopEnemyActivity(object_id)
    
    if object_id in data().FortRatSkulls:
        data().FriedenFlag = False
        if (data().FortAlert % 2) == 1:#A (Alarm ausgelöst)
            resetAlertTimer()
        
        elif data().KriegImFort:
            makeFullEnemy(object_id)
            ensureRunner()

#################
# onKilled #
#################
def on_object_killed(victim, attacker, weapon_type, weapon_id):
    
    object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
    
    if victim == "CHUCK":
        if not data().ratfurjacket_picked_up:
            object.set_attributes('CHUCK', model='low', gender='male',
                skin='white', clothes='sl_004', face='chuck')
            character.update_appearance('CHUCK')
            try:
                object.drop_item("CHUCK","CHUCKS_JACKET")
            except:
                pass
    
    
    
    if victim in data().HostageCampRatSkulls:
        data().HostageCampRatSkulls.remove(victim)
        if data().HostageCampRatSkulls == []:
            system.notify_region_entered(region="Region_Hostages_Close", partyid="UISPIELER")

    elif victim in data().FortRatSkulls:
        data().FortRatSkulls.remove(victim)
        if data().FeindeImFort.count(victim) > 0:
            data().FeindeImFort.remove(victim)
        if (data().FortAlert % 2) == 1:#A (Alarm ausgelöst)
            pass
        elif data().KriegImFort:
            if victim == data().FortRunner:
                data().FortRunner = ""
            if data().FeindeImFort == []:
                makePeace()
            else:
                ensureRunner()
        if data().FortRatSkulls == []:
            data().Fort_liberated = True
            character.add_experience_party(data().Exp_LaborEingenommen)
            system.set_qb_entry_state(data().QB_010, COMPLETE)
            if was_zone_entered('zone_3.zone_3'):
                if system.get_qb_entry_state(data("zone_3.zone_3").QB_004) in [UNCOMPLETE]:
                    Delay(2, dialogs.initDlg_131_Der_Spieler_denkt_an_Zone_3)
                    

######################
# on_sector_cleared. #
######################
def on_sector_cleared(object_id):
    if object_id in data().HostageCampRatSkulls:
        npc.enemyActivity(object_id)
    elif object_id in data().FortRatSkulls:
        npc.enemyActivity(object_id)

#####################
# on_corpse_spotted #
#####################
def on_corpse_spotted(object_id):
    if object_id in ['ENEMY_FORT_P01', 'ENEMY_FORT_P02', 'ENEMY_FORT_P03',
                     'ENEMY_FORT_P04', 'ENEMY_FORT_P05']:
        if (data().FortAlert % 2) == 1:#Alarm ausgelöst:
            npc.stopEnemyActivity(object_id)
        else:
            pass # Kommentar von Feiden gibts nicht

#################
# onExamine&Co. #
#################
def pre_examine_object( character_id, object_id ):
    if object_id.endswith(const.OBJECT_STAGE) or object_id.endswith(const.OBJECT_STAGE + '_INTERIOR'):
        object.set_attribute(object_id, "on_examine_coordinates", [519.9,564.45, 0])
#return object_events.pre_examine_object( character_id, object_id )

def can_examine_object( character_id, object_id ):
    if object_id == 'DRUGCAR':
        return True
    
    if character_id == 'ALTER_EGO' and (
            object_id.endswith(const.OBJECT_THRESHER) or
            object_id.endswith(const.OBJECT_STAGE) or
            object_id.endswith(const.OBJECT_FIRE_ALERT) or
            object_id.endswith(const.OBJECT_STAGE + '_INTERIOR')):
        return True
    if object_id.endswith('BUILDING_4087'):
        return True
    
    if object_id.endswith(OBJECT_PRISON):
        if data().scientists_rescued:
            return False
        return True
    
    return False

def on_examine_object( character_id, object_id ):
    if object_id == 'DRUGCAR':
#        if character_id == "ALTER_EGO":
        dialogs.initDlg_060_SpielerUntersuchtFahrzeug()

    if object_id != None:
        if object_id.endswith(const.OBJECT_THRESHER):
            if object.is_destroyed("CHUCK"):
                return True

            if data().Thresher_repared:
                dialogs.initDlg_124_Spieler_untersucht_Muehle_nachher()
            elif data().Thresher_sabotaged:
                dialogs.initDlg_123_Spieler_untersucht_Muehle_kaputt()
            else:
                dialogs.initDlg_122_Spieler_untersucht_Muehle_vorher()

        elif object_id.endswith(const.OBJECT_STAGE) or object_id.endswith(const.OBJECT_STAGE + '_INTERIOR'):
            object.turn_to_direction(character_id, globals.DIR_NORTH, callback=["ONEND", Lambda('dialogs.initDlg_074_Spieler_untersucht_Schild_am_Markt()')])

        elif object_id.endswith(const.OBJECT_FIRE_ALERT):
            dialogs.initDlg_045_Alarm_untersuchen()

        elif object_id.endswith('BUILDING_4087'):
            if object.get_inventory_list(object_id):
                system.item_panel(character_id, object_id)

        elif object_id.endswith(OBJECT_PRISON):
            if data().Fort_liberated:
                if system.get_qb_entry_state(data().QB_011) == INACTIVE:
#
                    if dialogs.PartyHasOneItemOf("ALTER_EGO", ['Z4PRISON_KEY']):
                        init_lock_state(OBJECT_PRISON, 'unlock')
                        open_knast(character_id, True)
#                    if object.count_in_inventory(character_id, 'Z4PRISON_KEY'):
#                        if character_id != None: #== 'ALTER_EGO':
#                            init_lock_state(OBJECT_PRISON, 'unlock')
#                            open_knast(character_id, True)
#                #dialogs.initDlg_141_Spieler_oeffnet_Gefaengnis()
#                        else:
#                            not_open_knast(character_id)
#                            return True
                    else:
                        if character_id == 'ALTER_EGO':
                            dialogs.initDlg_140_Spieler_kann_Gefaengnis_nicht_oeffnen()
                        else:
                            not_open_knast(character_id)
                    return True
            else:
                dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
                return True

    return False

#################
# on_pick_up#
#################
def on_pick_up( character_id, item_id, item_type ):
    if item_id == 'COLINS_NECKLACE' and system.get_qb_entry_state(data().QB_018) == UNCOMPLETE:
        if data().One_time_only_D098:
            dialogs.initDlg_098_Spieler_findet_Kette()
            data().One_time_only_D098 = False
    
    if item_id == "ADRIANS_TEDDY_BEAR":
        if not data().teddy_picked_up:
            data().teddy_picked_up = True
            if data().Adrian_plays_with_puppies:
                dialogs.initDlg_081_Spieler_finded_Teddy_wissend()
            else:
                dialogs.initDlg_080_Spieler_finded_Teddy_unwissend()
    
    if item_id == "CHUCKS_JACKET":
        if not data().ratfurjacket_picked_up:
            if data().Chuck_is_away or data().FireAlert or object.is_destroyed("CHUCK"):
                data().ratfurjacket_picked_up = True
                data().Jacket_stolen = True
                if (system.get_qb_entry_state(data().QB_007) == UNCOMPLETE or
                    system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):

                    system.set_qb_entry_state(data().QB_007, COMPLETE)
                    if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
                        system.set_qb_entry_state(data().QB_008, INACTIVE)
                    character.add_experience_party(data().Exp_JackeBeschafft)
                CheckIfAllThingsAreReadyForJimbob()
            else:
                dialogs.initDlg_048_Cuck_passt_auf()
                return False
    
    if item_id == "MARENS_SOAP":
        if not data().soap_picked_up:
            if not data().Soap_traded:
#Seife nehmen, wenn Maren tot
                if object.is_destroyed("MAREN"):
                    set_maren_qb_entry()
                    CheckIfAllThingsAreReadyForJimbob()
                    return True

#Seifen diebstahl:
                if (object.get_attribute(character_id, 'pick_pocket') <= const.MAREN_MINIMAL_PICKPOCKET):
                    dialogs.initDlg_132_Maren_bewacht_Seife()
                    return False
                else:
                    data().Soap_stolen = True
                    set_maren_qb_entry()
                    CheckIfAllThingsAreReadyForJimbob()
                    return True
            else:
                set_maren_qb_entry()
                CheckIfAllThingsAreReadyForJimbob()
                return True
    return True

def set_maren_qb_entry():
    data().soap_picked_up = True
    if system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
        system.set_qb_entry_state(data().QB_005, COMPLETE)
        character.add_experience_party(data().Exp_SeifeBeschafft)

#################
# onExchange#
#################
def can_exchange( character_id, target_id, item_id, item_type ):
    if target_id == "COLIN" and item_id == 'COLINS_NECKLACE' and \
            character_id == 'ALTER_EGO':
        return True
    elif target_id not in ['JIMBOB'] + system.get_pcs() and (item_id == 'MARENS_SOAP' or item_id == 'CHUCKS_JACKET'):
        return False
    elif target_id == 'JIMBOB' and (item_id == 'MARENS_SOAP' or item_id == 'CHUCKS_JACKET'):
        return True
    elif target_id == 'DRUGCAR' and item_id == 'JIMBOS_BUG':
        return True
    return object_events.can_exchange( character_id, target_id, item_id, item_type )
    
def on_exchange( character_id, target_id, item_id, item_type ):
    if target_id == "COLIN" and item_id == 'COLINS_NECKLACE':
        dialogs.initDlg_099_Schlechte_Nachricht(True)
        return True
    elif target_id == 'JIMBOB' and (item_id == 'MARENS_SOAP' or item_id == 'CHUCKS_JACKET'):
        if (object.count_in_inventory('JIMBOB', 'MARENS_SOAP') +
            object.count_in_inventory('JIMBOB', 'CHUCKS_JACKET')) == 1 and \
            character_id == 'ALTER_EGO':
                dialogs.on_approach('JIMBOB', 'ALTER_EGO')
        return True
    elif target_id == 'DRUGCAR' and item_id == 'JIMBOS_BUG':
        character.play_animation(character_id, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN',
            ['ONEND', dialogs.initDialog_061_Spieler_befestigt_Wanze])
        return True
    return object_events.on_exchange( character_id, target_id, item_id, item_type )

###################
# can_use #
###################
def can_use( character_id, object_id ):
    if object_id == 'DRUGCAR':
        return True

    if object_id == "CHUCKS_JACKET":
        return True
    
#if character_id != 'ALTER_EGO':
#   return False
    
    if object_id != None:
        if object_id.endswith(OBJECT_PRISON):
            if data().scientists_rescued or not object.count_in_inventory(character_id, 'Z4PRISON_KEY'):
                if  character_id == 'ALTER_EGO':
                    return True
                else:
                    return False
            return True
        
    if object_id != None and character_id == 'ALTER_EGO':
        
        if object_id.endswith(const.OBJECT_FIRE_ALERT):
            return True
        
        if object_id.endswith(const.OBJECT_THRESHER):
            return True

    return object_events.can_use(character_id, object_id)

def on_use(operatorid, targetid, objectid, equipmenttype):
    print 'on_use(', operatorid, targetid, objectid, equipmenttype,')'
    
    if objectid == "CHUCKS_JACKET":
        return True
    
#    if targetid == 'DRUGCAR' and operatorid == "ALTER_EGO" and objectid==None:
    if targetid == 'DRUGCAR' and operatorid in system.get_pcs() and objectid==None:
        dialogs.initDlg_142_SpielerWillNichtPickUpFahren()
        return True
    
    if isinstance(targetid, str) and targetid.endswith(OBJECT_PRISON):
        if data().Fort_liberated:
            if system.get_qb_entry_state(data().QB_011) == INACTIVE:
                if (object.count_in_inventory(operatorid, 'Z4PRISON_KEY') or 
                    objectid != None and objectid == 'Z4PRISON_KEY'):
                    init_lock_state(OBJECT_PRISON, 'unlock')
                    data().scientists_rescued = True
                    open_knast(operatorid, True)
#               dialogs.initDlg_141_Spieler_oeffnet_Gefaengnis()
                else:
                    if operatorid == 'ALTER_EGO':
                        dialogs.initDlg_140_Spieler_kann_Gefaengnis_nicht_oeffnen()
                    else:
                        return False
                return True
        return False
    
    if isinstance(targetid, str) and operatorid == 'ALTER_EGO':
        if targetid.endswith(const.OBJECT_THRESHER) and (
            objectid == "Thresher_destroyer" or (
            equipmenttype == "SET_IRON_BAR" or
            equipmenttype == "SET_BROOM" or
            equipmenttype == "SET_LEAD_PIPE" or
            equipmenttype == "SET_SHOVEL" or
            equipmenttype == "SET_SPADE" or
            equipmenttype == "SET_TAIL_ROTOR")):
                
            if object.is_destroyed("CHUCK"):
                return True
            else:
                if data().Chuck_is_away or data().FireAlert:
                    if not dialog.is_dialog_active():
                        dialogs.initDlg_125_Spieler_beschaedigt_die_Muehle()
                    else:
                        data().dialog_queue = 'D_125'
                        system.notify_timer(data().Timer_DialogQueue, data().Timervalue_DialogQueue)
                    if objectid == "Thresher_destroyer":
                        object.remove_item_from_inventory(operatorid, objectid)
                    else:
                        object.remove_item_from_inventory(operatorid, equipmenttype)
                    return True
                else:
                    return False
                
        elif targetid.endswith(const.OBJECT_FIRE_ALERT) and objectid == None:
            if data().Thresher_sabotaged and not data().Thresher_repared:
                if data().Chuck_repairs:
                    if data().AlertCount == 0:
                        dialogs.initDlg_047_Alarm_ausloesen1()
                    elif data().AlertCount == 1:
                        dialogs.initDlg_127_Alarm_ausloesen2()
                    else:
                        dialogs.initDlg_128_Alarm_ausloesenx()
                    data().AlertCount += 1
                    return True
                else:
                    return False
            else:
                return False
        
        elif targetid == 'DRUGCAR' and objectid == 'JIMBOS_BUG':
            character.play_animation(operatorid, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN',
                ['ONEND', dialogs.initDialog_061_Spieler_befestigt_Wanze])
            return True
            
    
    return object_events.on_use( operatorid, targetid, objectid, equipmenttype )
    

def on_use_failed( character_id, object_id, item_id, item_type ):
    if character_id != 'ALTER_EGO':
        return False
    elif object_id != None:
        if object_id.endswith(const.OBJECT_THRESHER) and item_id == "Thresher_destroyer":
            dialogs.initDlg_138_Chuck_laesst_Spieler_nicht_an_Dreschmaschine()
            return True
        elif object_id.endswith(const.OBJECT_PRISON):
            dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
            return True
        elif object_id.endswith(const.OBJECT_FIRE_ALERT):
            dialogs.initDlg_046_Alarm_nicht_ausloesen()
            return True
    return object_events.on_use_failed( character_id, object_id, item_id, item_type )

############
# on_trade #
############
def on_trade(target,operator):
    if target=="MILES":
        system.trading_screen(trader="MILES",char=operator)
    elif target=="GENE":
        system.trading_screen(trader="GENE",char=operator)

def on_update_trader(trader):
    object_events.on_update_trader(trader)
############
# can_steal_from #
############
def can_steal_from( thief, victim ):
    if victim == "CHUCK": 
        return False
    return object_events.can_steal_from(thief, victim )    

################################################################################
### Misc. ######################################################################
################################################################################

### Delay
##########
# Delay(Zeit in Sekunden, Callbackliste) führt code Zeitverzögert aus
#  dazu werden zusätzliche Timer dynamisch aktiviert...
def Delay(delta_t, expressions):
## expressions zu einer Liste machen
    if callable(expressions):
        expressions = [expressions]
    if data().Timer_Misc == []:
#print "Error: No more timer slots for delay!"
        return
    t_nr = data().Timer_Misc[0]
#print "[debug: tnr=",str(t_nr),"delta_t=", str(delta_t),"]"
    data().ActiveMisc[t_nr] = expressions
    system.notify_timer(t_nr, delta_t * 1000)
    data().Timer_Misc.remove(t_nr)

def GetZoneEnterLocation(enterdirection):
    start_locations = {
            "NORTH":    (800.8, 260.3),
             "SOUTH":    (750.0, 580.0),
             "WEST":        (210.0, 415.0),
             "EAST":        (700.0, 440.0),
         }

    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registerd: " + enterdirection

################################################################################
### Kampf ######################################################################
################################################################################
def makePeace():
    data().FriedenFlag = True
    Delay(3, delaydings)
    
def delaydings():
    if data().FriedenFlag:
        data().KriegImFort = False
        map(lambda c: object.set_attribute(c, 'foes', []), data().FortRatSkulls)
        data().FeindeImFort = []

def makeFullEnemy(enemy):
    if enemy not in data().FeindeImFort:
        object.set_attribute(enemy, 'foes', system.get_pcs())
        data().FeindeImFort.append(enemy)
        object.cancel_commandos(enemy)
    data().KriegImFort = True

def makePCPartialEnemy(pc):
    for rs in data().FortRatSkulls:
        if object.has_attribute(rs, "foes"):
            object.set_attribute(rs, 'foes', [pc] + object.get_attribute(rs, 'foes'))
        else:
            object.set_attribute(rs, 'foes', [pc])
        
        if rs not in data().FeindeImFort and character.get_visible_enemies(rs) != []:
            on_enemy_spotted(rs)

def ensureRunner():
    if data().FortRunner == "" and (data().FortAlert % 2) == 0:
        runner = random.choice(data().FeindeImFort)
#run starten:
        object.cancel_commandos(runner)
        object.move_to(runner, const.FORT_ALERT_POINT[0],
                              const.FORT_ALERT_POINT[1], "landscape", MT_FASTEST)
        object.turn_to_object(runner, const.FORT_ALERT_OBJECT)
        character.play_animation(runner, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN')
        object.turn_to_direction(runner, 0, ['ONEND',runnerAtGoal])
        data().RunnerContactPoint = (object.get_x(runner), object.get_y(runner))
        data().FortRunner = runner

def runnerBackToWar():
    enemies = character.get_visible_enemies(data().FortRunner)
    if enemies == []:
        object.move_to(data().FortRunner, data().RunnerContactPoint[0],
                                         data().RunnerContactPoint[1],
                                         "landscape", MT_FAST)
    else:
        object.attack(data().FortRunner, enemies[0])

def resetAlertTimer():
    system.notify_timer(data().Timer_Fort_Alert, data().Timervalue_Fort_Alert)
    data().Timercount_Fort_Alert += 1

def totalWar(foeList):
    if not (isinstance(foeList, list) or isinstance(foeList, tuple)):
        foeList = (foeList)
    map(lambda c: object.set_attribute(c, 'foes', ["UISPIELER"]), foeList)

def runnerAtGoal(id = "1337"):
    FortAlertOn()
    runnerBackToWar()
    resetAlertTimer()
    totalWar(data().FortRatSkulls)

################################################################################
### Questspezifische Funktionen ################################################
################################################################################

### Main Quest
###############
def MainQuestInit():
#feinde scriptfertig machen
    map(lambda c: object.set_attribute(c, 'foes', []), data().FortRatSkulls)
    data().FeindeImFort = []
    data().KriegImFort = False
    data().FortRunner = ""
#Wissenschaftler bereit machen:
    character.play_animation('WISSENSCHAFTLER1', 'CM_NPC_SITZEN_BODEN_HINSETZEN')
    character.play_animation('WISSENSCHAFTLER2', 'CM_NPC_STEHEN_HINSETZEN')
    data().PlayAnimation['WISSENSCHAFTLER1'] = 'sit_on_ground'
    data().PlayAnimation['WISSENSCHAFTLER2'] = 'sit_on_bench'
    
    
#system.set_qb_entry_state(data().QB_001, UNCOMPLETE) # 1 Quest starten
    object.create_item_in_inventory(object="RSWACHE",
        equipment=["SET_CALICO_M950",'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM',"SET_BOTTLE_OF_BOOZE"])
    character.equip("RSWACHE","SET_CALICO_M950")

def RSGateOpen():
    if not data().player_has_entered_fort:
        data().gate_open = True
        object.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=["ONEND", open_bus_model])
        sounds.play_3d_sound_object(sfx_id="pickup_loop_idle",object="BUS_TOR_ZU")
        
def open_bus_model(object_id=None):
    object.set_active_state("BUS_TOR_OFFEN",1)
    object.set_active_state("BUS_TOR_ZU",0)

def RSGateClose():
    if not data().player_has_entered_fort:
        close_bus_model()
        object.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_CLOS", callback=['ONEND', Lambda('data().gate_open = False')])
        sounds.play_3d_sound_object(sfx_id="pickup_loop_idle",object="BUS_TOR_ZU")

def close_bus_model(object_id=None):
    object.set_active_state("BUS_TOR_OFFEN",0)
    object.set_active_state("BUS_TOR_ZU",1)


def EntryOfTheScientists(param=None):
    if not hasattr(data(), "scientists_are_back"):
        data().scientists_are_back = True
        del data().PlayAnimation['WISSENSCHAFTLER1']
        del data().PlayAnimation['WISSENSCHAFTLER2']
        character.play_animation('WISSENSCHAFTLER1', 'CM_NPC_SITZEN_BODEN_AUFSTEHEN')
        character.play_animation('WISSENSCHAFTLER2', 'CM_NPC_SITZEN_BANK_AUFSTEHEN')
#raus
        object.cancel_commandos('JEFF')
        object.step_away('JEFF')#, 300.05, 293.93, MT_SLOW)
        object.step_away('WISSENSCHAFTLER1')#, 300.05, 293.93, MT_SLOW)
        object.step_away('WISSENSCHAFTLER2')#, 300.05, 293.93, MT_SLOW)
#auf die Endpositionen
        object.move_to('WISSENSCHAFTLER1', 298.51, 297.38, grid="landscape", speed=MT_SLOW)
        object.move_to('WISSENSCHAFTLER2', 300.19, 292.93, grid="landscape", speed=MT_SLOW)
        object.move_to("JEFF", 301.09, 297.20, grid="landscape", speed=MT_SLOW, callback=
            ["ONEND", Lambda('Delay(2, dialogs.initDlg_065_Erste_Begegnung)', "char")])
        object.turn_to_position("WISSENSCHAFTLER1", 301.09, 297.20)
        object.turn_to_position("WISSENSCHAFTLER2", 301.09, 297.20)

#####################################
### Colin Quest
### Colins Dad mit Kette versorgen und töten
def ColinQuestInit():
## Klunker ins Inventar
    object.create_item_in_inventory(object="COLIN_DAD", equipment="SET_NECKLACE", id='COLINS_NECKLACE')
    object.set_attribute(object='COLINS_NECKLACE', attribute="generic_item", value=False)
## Hyänen erzeugen...
    system.create_animal(id="DADKILLER1", type=ANIMAL_WOLF, party="ZOO", x=421.90, y=236.67)
    system.create_animal(id="DADKILLER2", type=ANIMAL_WOLF, party="ZOO", x=434.00, y=238.00)
    system.create_animal(id="DADKILLER3", type=ANIMAL_WOLF, party="ZOO", x=430.00, y=233.00)
## ...und auf Papa hetzen
    object.set_attribute( "DADKILLER1", attribute="foes", value=["COLIN_DAD"])
    object.set_attribute( "DADKILLER2", attribute="foes", value=["COLIN_DAD"])
    object.set_attribute( "DADKILLER3", attribute="foes", value=["COLIN_DAD"])
#object.attack("DADKILLER1","COLIN_DAD")
#object.attack("DADKILLER2","COLIN_DAD")
#object.attack("DADKILLER3","COLIN_DAD")
#object.destroy("COLIN_DAD")
    character.play_animation('COLIN_DAD','CM_STERBEN_FALLEN_NACH_HINTEN', callback = ['ONEND', Lambda('KillDad()')])

def KillDad():
    object.set_attribute("COLIN_DAD","hitpoints",0)
    object.drop_item("COLIN_DAD", "COLINS_NECKLACE")
    
def KeepEatingColinsDad():
    if not data().Dad_killers_are_foes:
        eater= str(random.randint(1, 3))
        for foo in range(1, random.randint(3, 5)):
            object.attack("DADKILLER" + eater,"COLIN_DAD")
        Delay(random.randint(3, 10), [KeepEatingColinsDad])

### Die Hyänen bei Colins Vater greifen den Spieler an:
def DadKillerAttackPlayer(objectid):  #Parameter: 1. Char der die Region betritt
    if object.exists("DADKILLER1"):
        object.set_attribute("DADKILLER1", attribute="foes", value=system.get_pcs())
        object.attack("DADKILLER1",objectid)
    if object.exists("DADKILLER2"):
        object.set_attribute("DADKILLER2", attribute="foes", value=system.get_pcs())
        object.attack("DADKILLER2",objectid)
    if object.exists("DADKILLER3"):
        object.set_attribute("DADKILLER3", attribute="foes", value=system.get_pcs())
        object.attack("DADKILLER3",objectid)

#####################################
### Markt Quest
def MarktQuestInit():
#Teddy erzeugen, onExmaine reggen
    system.create_object(equipmenttype="SET_TEDDY_BEAR",    x=610.46, y=408.90, id="ADRIANS_TEDDY_BEAR")

#####################################
### Jim-Bob Quest
def JimBobQuestInit():
#Seife erzeugen
    system.create_object(equipmenttype="SET_SOAP", id="MARENS_SOAP",x=676.99, y=269.40)
    object.set_position_free('MARENS_SOAP', 683.54, 265.26, 0.65)
    object.move_to_object('MAREN', const.WASHING_TABLE_CV, 'dmpy001', MT_SLOW) #todo: Dummy ist falsch benannt
    character.play_animation('MAREN', 'CM_NPC_STEHEN_WAESCHE_WASCHEN_START')
    data().PlayAnimation['MAREN'] = 'wash'
#Eisenstange an der Mühle erzeugen
    system.create_object(equipmenttype="SET_IRON_BAR", x=548.90, y=450.03, id="Thresher_destroyer")
#Drogenkuriere ins Auto setzen und alles verschwinden lassen
    system.create_object('SET_PICKUP', 680.67, 622.93, "DRUGCAR", globals.DIR_NORTH_EAST)
    character.set_in ('DRUGMANA', 'DRUGCAR')
    character.set_in ('DRUGMANB', 'DRUGCAR')
    object.set_immortal_state('DRUGCAR', True)
#object.set_active_state("DRUGMANA",INACTIVE)
#object.set_active_state("DRUGMANB",INACTIVE)
    object.set_active_state('DRUGCAR', INACTIVE)
    object.set_attribute('DRUGCAR',"accepted_drivers",["RATSKULLS_DROGENLABOR"])
    data().Drug_state = "anfahrt"

#old:
#system.notify_timer(data().Drug_timer,data().Drug_timer_TICK)

#new drugcar
    system.notify_timer(data().Timer_DrugCarStart,data().Timervalue_DrugCarCheck)
    
    
### Testen ob alle Aufgaben erledigt sind um Jimbo einen neuen Look zu verpassen
def CheckIfAllThingsAreReadyForJimbob():
    pcs = system.get_pcs()
    for pc in pcs:
        if object.count_in_inventory(pc, "MARENS_SOAP"):
            if system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_005, COMPLETE)
        
        if object.count_in_inventory(pc, "CHUCKS_JACKET"):
            if system.get_qb_entry_state(data().QB_007) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_007, COMPLETE)
            if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_008, COMPLETE)
            
    if (system.get_qb_entry_state(data().QB_005) == COMPLETE and
       system.get_qb_entry_state(data().QB_006) == COMPLETE and
       (system.get_qb_entry_state(data().QB_007) == COMPLETE or
       system.get_qb_entry_state(data().QB_008) == COMPLETE)):
           system.set_qb_entry_state(data().QB_009, UNCOMPLETE)

### Chuck kommt wieder zur Mühle
def ChuckIsBack(id = ""):
    if system.is_cutscene() or dialog.is_dialog_active():
        Delay(5, Lambda("ChuckIsBack()"))
        return
    data().Chuck_is_away = False
    if data().Jacket_stolen:
        if data().One_Time_Only_D050:
            dialogs.initDlg_050_Cuck_Alarm_Ende_Jacke_weg()
            object.cancel_commandos("CHUCK")
            data().One_Time_Only_D050 = False
    elif data().Thresher_sabotaged:
        if data().One_time_only_D040:
            dialogs.initDlg_040_Chuck_verzweifelt()
            data().One_time_only_D040 = False
        else:
            dialogs.chuckStartRepair()
    else:
        object.move_to('CHUCK', 654.22, 479.98, 'landscape', MT_SLOW)
        object.turn_to_direction("CHUCK", 275)
        system.notify_timer(data().Chuckwalk, random.randint(60, 180) * 1000)

### Der Feuer Alarm wurde ausgelöst:
def FireAlertOn():
    if data().Chuck_repairs: #data().Thresher_sabotaged and not data().Thresher_repared and not data().Chuck_is_away:
        dialogs.initDlg_049_Cuck_Alarm_ausgeloest()
    else:
        object.cancel_commandos('CHUCK')
        object.move_to('CHUCK', 488.57, 525.96, 'landscape', MT_FAST)
        object.turn_to_direction('CHUCK', 180)
    sounds.load_sound(sfx_id='alarm_firehorn')
    playSound= Lambda('sounds.play_3d_sound_object(sfx_id="alarm_firehorn",object=const.OBJECT_FIRE_ALERT)')
    for i in range(1, 20):
        Delay(i*1.5, playSound)
    data().FireAlert = True
    data().Chuck_repairs = False
    data().Chuck_is_away = True
    Delay(random.randint(90, 120), [FireAlertOff])

def FireAlertOff():
    object.move_to("CHUCK", 642.57, 476.83, "landscape", MT_FAST,["ONEND", ChuckIsBack])
    data().FireAlert = False

################################
## Auftritt der Drogenkuriere ##
################################
def DrugTransportPhase1(param=None):
#start drugcar routing
    object.set_active_state('DRUGCAR', ACTIVE)
    object.cancel_commandos('DRUGCAR')
#object.set_position('DRUGCAR', 680.67, 622.93)#, 0)#const.DrugCarWaypoints1[0][0],const.DrugCarWaypoints1[0][1])
#object.set_direction("DRUGCAR", globals.DIR_NORTH_EAST)
    
    if not hasattr(data(), "first_drugcar_start"):
        data().first_drugcar_start = True
        drugcar_start()
    else:
        vehicle_add_path("DRUGCAR", const.PATH_TURN_START)
        print """vehicle_add_path("DRUGCAR", const.PATH_TURN_START)"""
        object.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_start])
        print """object.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_start])"""
    
def drugcar_start(car=None):
    vehicle_add_path("DRUGCAR", const.DrugCarWaypoints1)
    print """vehicle_add_path("DRUGCAR", const.DrugCarWaypoints1)"""
    object.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_reaches_leila])
    print """object.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_reaches_leila])"""

#helper checks if as cutscene or not as cutscene
def display_drugcar_scene_as_cutscene():
    if (system.get_qb_entry_state(data().QB_004) == COMPLETE and system.get_qb_entry_state(data().QB_009) == COMPLETE):
        if not data().player_knows_password:
            return True
    return False
    
def drugcar_reaches_leila(char=None):
    if (not system.is_cutscene() and not dialog.is_dialog_active()):
        if display_drugcar_scene_as_cutscene():
            system.start_cutscene()
            system.set_camera_view(const.CamView_Drug_Leila_view1)
        drugcar_couriers_approach_leila("DRUGCAR")
    else:
        data().cutscene_name = "drugcar_start"
        system.notify_timer(data().Timer_Cutscene,data().Timervalue_Cutscene)

def drugcar_couriers_approach_leila(id):
    if display_drugcar_scene_as_cutscene() and system.is_cutscene():
        system.fade(FADE_OUT, callback = DrugTransportPhase2)
    else:
        DrugTransportPhase2()

def DrugTransportPhase2(param=None):
    if display_drugcar_scene_as_cutscene() and system.is_cutscene():
        system.fade(FADE_IN)
    
#object.set_active_state("DRUGMANA",ACTIVE)
#object.set_active_state("DRUGMANB",ACTIVE)
    
    character.get_out('DRUGMANB')
    character.get_out('DRUGMANA')
    
    Delay(10, Lambda("object.move_to('DRUGMANA', 349.06, 458.87, 'landscape', MT_SLOW)"))
    Delay(7, Lambda("object.move_to('DRUGMANB', 347.44, 457.54, 'landscape', MT_SLOW, ['ONEND',DrugTransportPhase3])"))

    if display_drugcar_scene_as_cutscene() and system.is_cutscene():
        system.set_camera_view(const.CamView_Drug_Leila_view2)
    
    pos = object.get_position("DRUGCAR")
    character.set_approachable_state("LEILA", NOTAPPROACHABLE)

def DrugTransportPhase3(bla="666"):
    object.turn_to_object('LEILA', 'DRUGMANA')
    object.turn_to_object('DRUGMANB', 'LEILA')
    object.turn_to_object('DRUGMANA', 'LEILA')
    if dialogs.check_char_in_range("LEILA"):
        dialogs.initDialog_062_Drogenkuriere_besuchen_Laila_Ankunft()
    else:
        DrugTransportPhase4()

def DrugTransportPhase4():
    if display_drugcar_scene_as_cutscene() and system.is_cutscene():
        system.fade(FADE_OUT, callback = DrugTransportPhase4_1)
    else:
        DrugTransportPhase4_2()

def DrugTransportPhase4_1():
    system.set_camera_view(const.CamView_Drug_Leila_view3)
    system.fade(FADE_IN, callback = DrugTransportPhase4_2)

def callback_leila_opes_door(char):
    object.move_to(char, 332.80, 474.31, speed=MT_SLOW, grid="landscape")
    object.turn_to_object('LEILA','ZONE_4_BUILDING_3849', callback=['ONEND', callback_leila_opes_door2])

def callback_leila_opes_door2(char):
    character.play_animation(char, "STEHEND_TUERSCHLOSS_KNACKEN")
    object.move_to('LEILA', 334.17, 476.15, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID", speed=MT_SLOW, callback = ['ONEND', DrugTransportPhase4_3])
    
def DrugTransportPhase4_2():
    object.move_to('LEILA', 330.37, 471.81, "landscape", MT_SLOW, callback=["ONEND",callback_leila_opes_door])
    object.remove_closed_lock_by_name("ZONE_4_BUILDING_3849", "lock1")
    object.move_to('DRUGMANA', 329.05, 472.81, "landscape", MT_SLOW)
    object.turn_to_object('DRUGMANA','ZONE_4_BUILDING_3849')
    object.move_to('DRUGMANB', 329.17, 474.51, "landscape", MT_SLOW)
    object.turn_to_object('DRUGMANB','ZONE_4_BUILDING_3849')
    
def callback_enter_house(next):
    if next == "LEILA":
        object.move_to('DRUGMANB', 335.80, 474.19, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID", speed=MT_SLOW, callback = ['ONEND', DrugTransportPhase4_3])
    else:
        object.move_to('DRUGMANA', 335.21, 473.18, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID", speed=MT_SLOW, callback = ['ONEND', DrugTransportPhase4_3])

def DrugTransportPhase4_3(param=None):
## regionstrigger für dialog 156 - 159 aktivieren
    if not data().region_wohnwagen_notified:
        system.notify_region_entered("REGION_WOHNWAGEN_LEILA", objectid="ALTER_EGO")
        data().region_wohnwagen_notified= True
    if not hasattr(data(), "caravan_comment_active"):
        data().caravan_comment_active = True
    data().caravan_comment_active = True

#workaround:
    if param=="LEILA":
        object.set_position_free('LEILA', 334.17, 476.15,0, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID")
    if data().counter_drugmen_leila_in_caravan < 2:
        callback_enter_house(param)
    data().counter_drugmen_leila_in_caravan += 1
    if data().counter_drugmen_leila_in_caravan == 3:
        data().counter_drugmen_leila_in_caravan = 0
        if display_drugcar_scene_as_cutscene() and system.is_cutscene():
            Delay(2, system.end_cutscene)
        object.add_closed_lock("ZONE_4_BUILDING_3849", "lock1", closure_type='normal')
        system.notify_timer(data().Timer_DrugCarLeaveLeila, 25 * data().Timervalue_DrugCarCheck)
    
def checked_deactivation(char_id=None):
    data().drugmans_inactive += 1
    character.get_in(char_id, 'DRUGCAR')
    if data().drugmans_inactive == 2:
        Delay(4.0, DrugTransportPhase7)
        data().drugmans_inactive = 0

### erste Abschnitt beendet ####################################################

### wenn 4 un 9 complete ist data().DrogenAutoCutscene = True ##################
def DrugTransportPhase5():
    object.remove_closed_lock_by_name("ZONE_4_BUILDING_3849", "lock1")
    if (not system.is_cutscene() and not dialog.is_dialog_active()):
        if display_drugcar_scene_as_cutscene():
            system.start_cutscene()
            system.set_camera_view(const.CamView_Drug_Leila_view3)
        data().drugmans_inactive = 0
        if not hasattr(data(), "caravan_comment_active"):
            data().caravan_comment_active = False
        data().caravan_comment_active = False
        object.move_to("DRUGMANA", 330.73, 472.5, grid="landscape", speed=MT_SLOW)
        object.move_to("DRUGMANB", 329.33, 471.59, grid="landscape", speed=MT_SLOW)
        pos = object.get_position("DRUGCAR")
        object.move_to('DRUGMANA', 353.16, 457.00, speed=MT_SLOW, callback=["ONEND",checked_deactivation])
        object.move_to('DRUGMANB', 355.60, 453.47, speed=MT_SLOW, callback=["ONEND",checked_deactivation])
        Delay(2, dialogs.initDialog_137_Drogenkuriere_besuchen_Laila_Abgang)
    else:
        system.notify_timer(data().Timer_DrugCarLeaveLeila, data().Timervalue_DrugCarCheck)

def callback_leila_closes_door(char):
    object.move_to(char, 332.80, 474.31, speed=MT_SLOW, grid="landscape")
    object.turn_to_object(char, "ZONE_4_BUILDING_3849", callback=["ONEND", callback_leila_closes_door2])

def callback_leila_closes_door2(char):
    character.play_animation(char, "STEHEND_TUERSCHLOSS_KNACKEN")
    object.remove_closed_lock_by_name("ZONE_4_BUILDING_3849", "lock1")
    object.move_to('LEILA', 347.17, 459.54, grid="landscape", speed=MT_SLOW)
    object.turn_to_direction('LEILA', 45)

def DrugTransportPhase6():
    object.move_to('LEILA', 331.20, 473.23, grid="landscape", speed=MT_SLOW, callback=["ONEND",callback_leila_closes_door])

def DrugTransportPhase7(param=None):
    character.set_approachable_state("LEILA", APPROACHABLE)
    if display_drugcar_scene_as_cutscene() and system.is_cutscene():
        system.fade(FADE_OUT, callback = DrugTransportPhase7_1)
    else:
        vehicle_add_path("DRUGCAR", const.DrugCarWaypoints2)
        object.move_to('DRUGCAR', 0,0, 'landscape', MT_FAST, callback = ['ONEND', DrugTransportPhase8])

def DrugTransportPhase7_1():
    system.fade(FADE_IN)
    system.set_camera_view([312.73129272460937, 385.69210815429687, 22.061740875244141, 0.23909616470336914, -0.8901706337928772, -0.3878522515296936])#const.CamView_Drug_Gate_view1)
    object.set_position('DRUGCAR', 330,394)
    object.set_direction('DRUGCAR',155)
    object.set_attribute('DRUGCAR','script_path',None)
    vehicle_add_path("DRUGCAR", const.DrugCarWaypoints4)
    object.move_to('DRUGCAR', 0, 0, 'landscape', MT_FAST, callback = ['ONEND', DrugTransportPhase8])

def DrugTransportPhase8(param=None):
    pos = object.get_position("DRUGCAR")
    if not object.is_destroyed("RSWACHE"):
#object.move_to('RSWACHE', 312.35, 372.97, 'landscape', MT_SLOW)
        object.turn_to_direction('RSWACHE', 60)
        if data().drugcar_bug_installed:
            RSGateOpen_DrugTransportPhase8_1()
        else:
            RSGateOpen_DrugTransportPhase8_2()
    else:
        for rs in ["DRUGMANA","DRUGMANB"]:
            character.get_out(rs)
            object.set_attribute(rs, "foes", ["UISPIELER"])
            object.turn_to_object(rs, random.choice(system.get_pcs()))
            object.set_immortal_state(rs, False)

def RSGateOpen_DrugTransportPhase8_1():
    if not data().player_has_entered_fort:
        dialogs.initDialog_063_Drogenkuriere_wissen_Passwort()

def RSGateOpen_DrugTransportPhase8_2():
    if not data().player_has_entered_fort:
        object.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=[["ONEND", DrugTransportPhase9],
                                               ['ONEND', Lambda('object.set_active_state("BUS_TOR_OFFEN",1)')],
                                               ['ONEND', Lambda('object.set_active_state("BUS_TOR_ZU",0)')]])

def DrugTransportPhase9(param=None):
    if display_drugcar_scene_as_cutscene() and system.is_cutscene():
        Delay(2, system.end_cutscene)
    vehicle_add_path("DRUGCAR", const.DrugCarWaypoints3)
    if not data().drugcar_bug_installed:
        object.move_to('DRUGCAR', 0, 0, 'landscape', MT_FAST, callback=["ONEND", DrugTransportPhase10_1])
    else:
        object.move_to('DRUGCAR', 0, 0, 'landscape', MT_FAST, callback=["ONEND", DrugTransportPhase10_4])
    Delay(3, Lambda("object.turn_to_direction('RSWACHE', 150)"))
    Delay(10, Lambda("RSGateClose()"))

def RSGateOpen_DrugTransportPhase10():
    if not data().player_has_entered_fort:
        object.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=[["ONEND", DrugTransportPhase10_1],
                                               ['ONEND', Lambda('object.set_active_state("BUS_TOR_OFFEN",1)')],
                                               ['ONEND', Lambda('object.set_active_state("BUS_TOR_ZU",0)')]])

def DrugTransportPhase10_1(id):
    vehicle_add_path("DRUGCAR", const.DRUCCAR_WAYPOINTS_TURN["forward"])
    object.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', DrugTransportPhase10_threewayturn1])

def DrugTransportPhase10_threewayturn1(obj):
    object.set_attribute("DRUGCAR", "reversing", True)
    vehicle_add_path("DRUGCAR", const.DRUCCAR_WAYPOINTS_TURN["reverse"])
    object.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', DrugTransportPhase10_threewayturn2])

def DrugTransportPhase10_threewayturn2(obj):
#object.set_direction("DRUGCAR",100)
    object.set_attribute("DRUGCAR", "reversing", False)
    vehicle_add_path("DRUGCAR", const.DrugCarWaypoints5)
    object.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', DrugTransportPhase10_2])
    data().DrogenKurriereAbfahrt = False

#helper add a path to vehicle
def vehicle_add_path(car, path):
    temp = []
    for p in path:
        temp.append(p[0])
        temp.append(p[1])
    object.set_attribute('DRUGCAR','script_path',temp)
    
def DrugTransportPhase10_2(id):
    object.move_to('RSWACHE', 312.35, 372.97, 'landscape', MT_SLOW)
    RSGateOpen()
    Delay(2, Lambda("DrugTransportPhase10_3()"))

def DrugTransportPhase10_3():
    Delay(10, Lambda("RSGateClose()"))
    if not object.is_destroyed("RSWACHE"):
        Delay(10, Lambda("object.move_to('RSWACHE', 313.94, 368.92, 'landscape', MT_SLOW)"))
        Delay(14, Lambda("object.turn_to_direction('RSWACHE', 150)"))

    vehicle_add_path("DRUGCAR", const.DrugCarWaypointsBack)
    object.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', deactivate_drugcar])

def DrugTransportPhase10_4(id):
    vehicle_add_path("DRUGCAR", const.DRUCCAR_WAYPOINTS_TURN["park"])
    object.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', DrugTransportPhase10_endofdrugcarmovement])

def DrugTransportPhase10_endofdrugcarmovement(obj):
    character.get_out('DRUGMANB')
    character.get_out('DRUGMANA')
    object.set_immortal_state('DRUGMANB', False)
    object.set_immortal_state('DRUGMANA', False)
    Delay(2.5, drugmen_ta_active)
    data().drugmen_now_have_a_daily_routine = True

def drugmen_ta_active():
    data().FortRatSkulls.append('DRUGMANA')
    data().FortRatSkulls.append('DRUGMANB')
    object.step_to("DRUGMANA", 319.3,285.43)
    object.step_to("DRUGMANB", 324.37,289.22)
    
    object.move_to("DRUGMANA", 345.6,308.9, callback=["ONEND", drugmen_enter_druglab])
    object.move_to("DRUGMANB", 345.6,308.9, callback=["ONEND", drugmen_enter_druglab])

def drugmen_enter_druglab(char=None):
    if char == "DRUGMANA":
        enemy_script.enter_building_to_position('DRUGMANA', house='BUILDING_90', grid='ZONE_4_BUILDING_90_INTERIOR_GRID', x=329.87, y=307.68)
        object.turn_to_object("DRUGMANA", "DRUGMANB")
    else:
        enemy_script.enter_building_to_position('DRUGMANB', house='BUILDING_90', grid='ZONE_4_BUILDING_90_INTERIOR_GRID', x=332.2, y=311.6)
        object.turn_to_object("DRUGMANB", "DRUGMANA")

def deactivate(id):
    object.set_active_state(id,INACTIVE)

def deactivate_drugcar(id):
    object.set_active_state(id,INACTIVE)
    data().drugcar_started = False
    system.notify_timer(data().Timer_DrugCarStart, data().Timervalue_DrugCarCheck)

def on_grid_enter( object_id, grid_id, old_grid_id ):
    if object.is_pc(object_id):
#wachhaus vor dem drogenlabor
        if grid_id == "ZONE_4_BUILDING_1249_INTERIOR_GRID":
            if object.is_destroyed("RSGUARD_FRONT"):
                return object_events.on_grid_enter( object_id, grid_id, old_grid_id )
            
            if not data().alter_ego_rampage:
                object.cancel_commandos("RSGUARD_FRONT")
                if object.get_grid("RSGUARD_FRONT") != "ZONE_4_BUILDING_1249_INTERIOR_GRID":
                    object.move_to("RSGUARD_FRONT", 305.6, 383.3, grid="ZONE_4_BUILDING_1249_INTERIOR_GRID")
                    if not hasattr(data(), "watching_player"):
                        data().watching_player = None
                    data().watching_player = object_id
                    rsguard_watches_player()
        
        elif grid_id == "landscape" and old_grid_id == "ZONE_4_BUILDING_1249_INTERIOR_GRID":
            if object.is_destroyed("RSGUARD_FRONT"):
                return object_events.on_grid_enter( object_id, grid_id, old_grid_id )
            
            if not data().alter_ego_rampage:
                object.cancel_commandos("RSGUARD_FRONT")
                data().watching_player = None
                rsguard_leaves_building()
    return object_events.on_grid_enter( object_id, grid_id, old_grid_id )
        
def rsguard_watches_player(char=None):
    if data().watching_player != None:
        object.turn_to_object("RSGUARD_FRONT", data().watching_player, callback=["ONEND", rsguard_watches_player])

def rsguard_leaves_building():
    character.play_animation("RSGUARD_FRONT", "CM_NPC_STEHEN_WARTEN_2")
    character.play_animation("RSGUARD_FRONT", "CM_NPC_STEHEN_WARTEN_5")
    character.play_animation("RSGUARD_FRONT", "CM_NPC_STEHEN_WARTEN_2")
    object.move_to("RSGUARD_FRONT", 310.56,388.32, speed=MT_SLOW, grid="landscape")
    object.turn_to_direction("RSGUARD_FRONT", globals.DIR_SOUTH_EAST)

#######
#### Fight events
#######
def FortAlertOn(operator = "666"):
    data().FortAlert += 1
    npc.stopEnemyActivity('ENEMY_FORT_G02')
    npc.stopEnemyActivity('ENEMY_FORT_G10')
    data().EnemyDefaultOccupation['ENEMY_FORT_G19'][1] = (320.73, 363.81,  30)
    data().EnemyDefaultOccupation['ENEMY_FORT_G20'][1] = (310.42, 368.72, 340)
    if not object.is_destroyed("ENEMY_FORT_G19") and not object.is_destroyed("ENEMY_FORT_G20"):
        object.move_to('ENEMY_FORT_G19', 320.73, 363.81, 'landscape', MT_FAST)
        object.move_to('ENEMY_FORT_G20', 310.42, 368.72, 'landscape', MT_FAST)
        sounds.load_sound(sfx_id='alarm_fort_zone4')
        playSound= Lambda('sounds.play_3d_sound_object(sfx_id="alarm_fort_zone4",object=const.FORT_ALERT_OBJECT)')
        for i in range(1, 20):
            Delay(i*2, playSound)
            
    for id in data().FortRatSkulls:
#print "making foe", id
        if not object.is_destroyed(id):
            object.set_attribute(id, "foes", ["UISPIELER"])

def FortAlertOff():
    data().FortAlert += 1
    map(lambda c: npc.startEnemyActivity(c), data().FortRatSkulls) # alarm aus

def enableRest():
    data('rest').legal_rest_areas['zone_4'] = const.legalRestAreas
    pass
    
def disableRest():
    data('rest').legal_rest_areas['zone_4'] = const.noRestAreas
    pass
    
def ThresherOn(foo = 'bar'):
    data().Animate_Thresher = True
    treshner_sound()
    ThresherAnim()

def treshner_sound():
    if not data().treshner_sound_playing:
        data().treshner_sound_playing = True
        sounds.play_3d_sound_object(sfx_id="treshing_machine",object=const.OBJECT_THRESHER,loop=True, identifier="sound_treshner_engine")

def ThresherAnim(foo = 'bar'):
    if data().Animate_Thresher:
        object.play_animation('BUILDING_4082', 'ANIM_TRESHER_LOOP',callback=['ONEND', ThresherAnim])

def ThresherOff(foo = 'bar'):
    sounds.play_3d_sound_object(sfx_id="crane_setting_down_container",object=const.OBJECT_THRESHER)
    data().Animate_Thresher = False
    data().treshner_sound_playing = False
    sounds.stop_sound(id="sound_treshner_engine")

def WindmuehleAnimation(id=None):
    object.play_animation('BUILDING_3817', 'ANIM_WINDMUEHLE',callback=['ONEND', WindmuehleAnimation])

### DEBUGCODE ###
################################################################################
# Initialisiert alle SpielerCharaktere der Entwickler
################################################################################

#abschliessen des museeums + gefängnisses
def init_lock_state(building='BUILDING_2421', state='lock'):
    import object_events
    if state=='lock':
#system.add_text("schliessen")
        object.add_closed_lock(building, "lock1", closure_type='normal')
    else:
#system.add_text("oeffnen")
        object.remove_closed_lock_by_name(building, "lock1")

def can_crack_lock( character_id, object_id, dummy_name ):
    if object_id == 'ZONE_4_BUILDING_3923' and object.count_in_inventory(character_id, 'Z4PRISON_KEY'):
        return True
    if object_id == "ZONE_4_BUILDING_3849":
        return False
    else:
        return object_events.can_crack_lock( character_id, object_id, dummy_name )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
    
    if object_id == 'ZONE_4_BUILDING_3923' and object.count_in_inventory(character_id, 'Z4PRISON_KEY'):
        if data().Fort_liberated:
            if system.get_qb_entry_state(data().QB_011) == INACTIVE:
                open_knast(character_id, True)
                return False
        else:
            dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
            return False
    elif object_id == 'ZONE_4_BUILDING_3923' and object.get_attribute(character_id, 'lock_pick') > 90 :
        if data().Fort_liberated:
            if system.get_qb_entry_state(data().QB_011) == INACTIVE:
                open_knast(character_id, False)
                return False
        else:
            dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
            return False
    elif object_id == 'ZONE_4_BUILDING_3923' and object.get_attribute(character_id, 'lock_pick') <= 90 :
        if data().Fort_liberated:
            if system.get_qb_entry_state(data().QB_011) == INACTIVE:
                not_open_knast(character_id)
                return False
        else:
            dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
            return False
    if object_id == "ZONE_4_BUILDING_3849":
        return False
    
    return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

def can_blast_lock( character_id, object_id, dummy ):
    if object_id == "ZONE_4_BUILDING_3849":
        return False
    else:
        return object_events.can_blast_lock( character_id, object_id, dummy )

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id == "ZONE_4_BUILDING_3849":
        return False
    else:
        return on_blast_lock( character_id, object_id, dummy_name, x, y, z )
    
def can_enter_building( character_id, building_id ):
    if building_id == "ZONE_4_BUILDING_3849":
        if character_id in system.get_pcs():
            return False
    return object_events.can_enter_building( character_id, building_id )

def not_open_knast(character_id):
    system.start_cutscene()
    system.set_camera_view([305.1639404296875, 298.60061645507812, 20.010461807250977, -0.65118342638015747, -0.72782915830612183, -0.21499992907047272])
    object.cancel_commandos(character_id)
    groupe = system.get_pcs()
    del groupe[groupe.index(character_id)]
    enemy_script.evacuate( groupe, [299.85, 292.69], 4, callback = Lambda("object.turn_to_object(parameter,'ZONE_4_BUILDING_3923')", "parameter"))
    object.move_to_object(character_id, 'ZONE_4_BUILDING_3923', dummy = 'dmyp_door1_01', callback = ['ONEND', not_open_knast_0])
    
def not_open_knast_0(character_id):
    object.turn_to_direction(character_id, 0)
    character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=[ "ONEND", not_open_knast_1] )

def not_open_knast_1(character_id):
    dialog.init_dialog( type=DIALOGSMALL )
    dialog.add_text( text = 'CRACK_LOCK_FAILED_003', speaker = character_id, follower = 'ENDDIALOG',  callback = Lambda('not_open_knast_2("%s")' %character_id))
    dialog.start()

def not_open_knast_2(character_id):
    object.step_away(character_id, callback = ['ONEND', Lambda('system.end_cutscene()')])
    
def open_knast(character_id, key):
    print 'open_knast(', character_id, key,')'
    groupe = system.get_pcs()
    del groupe[groupe.index(character_id)]
    system.start_cutscene()
    enemy_script.evacuate( groupe, [299.85, 292.69], 4, callback = Lambda("object.turn_to_object(parameter,'ZONE_4_BUILDING_3923')", "parameter"))
    object.cancel_commandos(character_id)
    if character_id != 'ALTER_EGO':
        system.fade(FADE_OUT, callback = Lambda('on_open_knast("%s", %s)' %(character_id, key)))
        if not 'ALTER_EGO' in enemy_script.is_in_area(['ALTER_EGO'], 20, character_id):
            object.cancel_commandos('ALTER_EGO')
            object.set_position('ALTER_EGO', 304.17, 302.44)
        system.set_camera_view([298.1697998046875, 309.07989501953125, 18.841438293457031, 0.18734703958034515, -0.95745652914047241, -0.21949532628059387])
    else:
        on_open_knast_1(character_id, key)
    
def on_open_knast(character_id, key):
    enemy_script.delay(0.5, Lambda('system.fade(FADE_IN)'))
    object.move_to('ALTER_EGO', 301.57, 298.44, speed = MT_SLOW, callback = [ "ONEND", Lambda('on_open_knast_1("%s", %s)' %(character_id, key)) ])
    
def on_open_knast_1(character_id, key):
    character.unequip_hands(character_id, False)
    object.step_to(character_id, 299.16, 292.50)
    system.set_camera_view([295.4278564453125, 297.31304931640625, 18.888494491577148, 0.55312168598175049, -0.79921579360961914, -0.23518213629722595])
    character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=[ "ONEND", Lambda('on_open_knast_2("%s", %s)' %(character_id, key)) ] )
    
def on_open_knast_2(character_id, key):
    object.cancel_commandos(character_id)
    system.set_camera_view([291.07470703125, 312.705810546875, 25.019874572753906, 0.45909738540649414, -0.82340872287750244, -0.3335081934928894])
    object.step_away(character_id, callback = [ "ONEND", Lambda('on_open_knast_3("%s", %s)' %(character_id, key)) ])
    
def on_open_knast_3(character_id, key):
    object.move_to(character_id, 299.65, 295.43, speed = MT_SLOW, callback = [ "ONEND", Lambda('on_open_knast_4("%s", %s)' %(character_id, key)) ])
    
def on_open_knast_4(character_id, key):
    object.turn_to_object(character_id, 'JEFF', callback = [ "ONEND", Lambda('open_knast_1("%s", %s)' %(character_id, key)) ])
    system.end_cutscene()
    
def open_knast_1(character_id, key):
    crack_lock_comments = random.choice( ["CRACK_LOCK_SUCCESS_001", "CRACK_LOCK_SUCCESS_002", "CRACK_LOCK_SUCCESS_003"])
    object.remove_closed_lock_by_name('ZONE_4_BUILDING_3923', 'lock1' )
    print key
    if key:
        dialogs.initDlg_141_Spieler_oeffnet_Gefaengnis()
    else:
        dialog.init_dialog( type=DIALOGSMALL )
        dialog.add_text( text = 'CRACK_LOCK_SUCCESS_001', speaker = character_id, follower = 'ENDDIALOG', callback =EntryOfTheScientists)
        dialog.start()

def InitChestsSafes():
    object.add_closed_lock("BUILDING_16869", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_16870", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_16871", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_16892", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_16928", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_16929", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_16934", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_9656", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_9423", "lock1", closure_type='lock-trap')

def init_patch():
    if "ANIE" in system.get_npcs():
        if object.is_active("ANIE"):
            data("zone_7.zone_7").anie_folgt = True
    
    if not system.get_qb_entry_state(data().QB_002) == COMPLETE and not system.get_qb_entry_state(data().QB_003) == COMPLETE and not data().player_has_entered_fort:
        for ratskull in data().FortRatSkulls:
            object.set_immortal_state(ratskull, True)
            
        for id in ["DRUGMANA", "DRUGMANB", 'RSWACHE']:
            object.set_immortal_state(id, True)
            
    if system.get_qb_entry_state(data().QB_011) in [COMPLETE, INACTIVE]:
        for ratskull in data().HostageCampRatSkulls:
            if not object.is_destroyed(ratskull):
                object.set_immortal_state(ratskull, True)
    
    if system.get_qb_entry_state(data().QB_011) in [UNCOMPLETE]:
        for ratskull in data().HostageCampRatSkulls:
            if not object.is_destroyed(ratskull):
                object.set_immortal_state(ratskull, False)
                
    
    if object.is_destroyed("DRUGMANA"):
        if not object.is_destroyed("DRUGMANB"):
            object.set_attribute('DRUGMANB', "foes", ['UISPIELER'])
            
    if  object.is_destroyed("DRUGMANB"):
        if not object.is_destroyed("DRUGMANA"):
            object.set_attribute('DRUGMANA', "foes", ['UISPIELER'])
    
    if (object.is_destroyed("ENEMY_FORT_P02") or object.is_destroyed("ENEMY_FORT_G03")):
        if not object.is_destroyed("ENEMY_FORT_P02"):
            object.set_attribute('ENEMY_FORT_P02', "foes", ['UISPIELER'])
        if not object.is_destroyed("ENEMY_FORT_G03"):
            object.set_attribute('ENEMY_FORT_G03', "foes", ['UISPIELER'])
    
    if  (object.is_destroyed("ENEMY_FORT_G02") or  object.is_destroyed("ENEMY_FORT_G10")):
        if not object.is_destroyed("ENEMY_FORT_G02"):
            object.set_attribute('ENEMY_FORT_G02', "foes", ['UISPIELER'])
        if not object.is_destroyed("ENEMY_FORT_G10"):
            object.set_attribute('ENEMY_FORT_G10', "foes", ['UISPIELER'])
            
    if(object.is_destroyed("RSWACHE") or object.is_destroyed("ENEMY_FORT_G19") or object.is_destroyed("ENEMY_FORT_G20") or object.is_destroyed("RSGUARD_FRONT")):
        if not object.is_destroyed("RSWACHE"):
            object.set_attribute("RSWACHE", "foes", ['UISPIELER'])
        if not object.is_destroyed("ENEMY_FORT_G19"):
            object.set_attribute("ENEMY_FORT_G19", "foes", ['UISPIELER'])
        if not object.is_destroyed("ENEMY_FORT_G20"):
            object.set_attribute("ENEMY_FORT_G20", "foes", ['UISPIELER'])
        if not object.is_destroyed("RSGUARD_FRONT"):
            object.set_position('RSGUARD_FRONT', 309.49, 387.48)
            object.set_attribute("RSGUARD_FRONT", "foes", ['UISPIELER'])
    
    if not hasattr(data("zone_4.zone_4"), "Keno_has_his_Sally"):
        if object.exists("MERCENARY_KENO"):
            object.create_item_in_inventory("MERCENARY_KENO", ["SET_PSG_1","SET_AMMOPACK_7_62NATO_MM"])
            data().Keno_has_his_Sally=True
    else:
        if not data("zone_4.zone_4").Keno_has_his_Sally:
            if object.exists("MERCENARY_KENO"):
                object.create_item_in_inventory("MERCENARY_KENO", ["SET_PSG_1","SET_AMMOPACK_7_62NATO_MM"])
                data().Keno_has_his_Sally=True
                
    if not hasattr(data('zone_4.zone_4'),'Region_Fort_Gate_Angelegt'):
        data().Region_Fort_Gate_Angelegt = False
    
    if not data().player_has_entered_fort:
        if not data().Region_Fort_Gate_Angelegt:
            data().Fort_escape_flag = False
            data().Region_Fort_Gate_Angelegt = True
            system.add_region("Region_Fort_Gate_SAVEGAME", 303, 379, 327, 364)
            system.notify_region_entered(region="Region_Fort_Gate_SAVEGAME", partyid="UISPIELER")
        
    if not hasattr(data('zone_4.zone_4'),'Region_Fort_Gate'):
        data().Region_Fort_Gate = False
        
    init_main_npcs()

def init_main_npcs():
    npcs = system.get_npcs()
    if "MILES" in npcs:
        character.set_main_quest_npc_state(char="MILES", state=True)
    if "GENE" in npcs:
        character.set_main_quest_npc_state(char="GENE", state=True)
    if "MYRIAM" in npcs:
        character.set_main_quest_npc_state(char="MYRIAM", state=True)

