# -*- coding: utf-8 -*-
from globals import *
from npc_activities import *
import const
import global_schedules

#*** aktuelle revison: Revision 53, 28.09.2004 *********************************
		
def goe_crew_comment():
	return lambda c: goe_grew_comment_helper(c)

def goe_grew_comment_helper(char):
	if not dialog.is_dialog_active() and not system.is_cutscene():	
		import dialogs
		dialogs.initDlg_KommentareZuAbrahamQuest()

# pos des convoy bestimmen
def convoy_move_finished():
	return lambda c: convoy_move_finished_helper(c)
	
def convoy_move_finished_helper(char):
	# Wenn der Konvoi einen Waypoint erreicht hat, wird die neue Position bestimmt,
	# anhand dieser können bei Bill die Bewegungen des Konvois erfragt werden.
	objects = []
	if data().convoy_with_cars:
		objects = const.OBJ_CONVOY_CARS[:]
	else:
		objects = data().SCHATTEN_KONVOI_NPCS[:]
	
	if char in objects:
		posx=object.get_x(char)
		posy=object.get_y(char)
		if (((posx < 349.0) and (posx > 240.0)) and
			((posy < 646.0) and (posy > 525.0))):
			data().convoy_position = 0
		elif (((posx < 780.0) and (posx > 570.0)) and
			  ((posy < 980.0) and (posy > 775.0))):
			data().convoy_position = 3
		elif (((posx < 679.0) and (posx > 393.0)) and
			  ((posy < 774.0) and (posy > 573.0))):
			data().convoy_position = 2
		else:
			data().convoy_position = 1

def owen_work(action):
	return lambda c: owen_work_helper(c, action)

def owen_work_helper(char, action):
	if character.get_body_mode(char) == "KNEEL":
		character.change_body_mode(char, "STAND")
		return "perform_wait_command"
	r = action
	if action == 0:
		r = random.randint(0,200)
	if r <= 33:
		#fass vor kneipe
		object.move_to(char, 547.8,244.4, speed=MT_SLOW)
		object.turn_to_object(char, "BUILDING_43887")
		owen_fass_leeren(char)
		return
	elif r <= 66:
		#kneipe innen
		object.move_to(char, 551.62, 243.62, speed=MT_SLOW)
		object.turn_to_direction(char, globals.DIR_WEST)
		return "perform_wait_command"
	elif r <= 100:
		#tisch 1
		object.move_to(char, 542.38, 242.56, speed=MT_SLOW)
		object.turn_to_object(char, "BUILDING_43888")
		owen_tisch_bedienen(char)
		return "perform_wait_command"
	elif r <= 133:
		#tisch 2
		object.move_to(char, 538.34, 239.79, speed=MT_SLOW)
		object.turn_to_object(char, "BUILDING_43891")
		owen_tisch_bedienen(char)
		return "perform_wait_command"
	elif r <= 166:
		#fass auf boden hinter kneipe
		object.move_to(char, 553.22, 238.58, speed=MT_SLOW)
		object.turn_to_object(char, "BUILDING_6205")
		owen_fass_werkeln(char)
		return "perform_wait_command"
	elif r <= 200:
		#fass in kneipe
		object.move_to(char, 551.71, 240.52, speed=MT_SLOW)
		object.turn_to_object(char, "BUILDING_43886")
		owen_fass_leeren(char)
		return
		
def owen_fass_leeren(char):	
	character.play_animation(char, "CM_STEHEN_TASCHENDIEBSTAHL_VORN")
	character.play_animation(char, "CM_NPC_TIER_FUETTERN_START")
	character.play_animation(char, "CM_NPC_TIER_FUETTERN_LOOP")
	character.play_animation(char, "CM_NPC_TIER_FUETTERN_LOOP")
	character.play_animation(char, "CM_NPC_TIER_FUETTERN_ENDE")
	character.play_animation(char, "CM_STEHEN_TASCHENDIEBSTAHL_VORN")

def owen_fass_werkeln(char):
	character.change_body_mode(char, "KNEEL")

def owen_tisch_bedienen(char):
	character.play_animation(char, "CM_NPC_STEHEN_TIERTROG_FUELLEN_START")
	character.play_animation(char, "CM_NPC_STEHEN_TIERTROG_FUELLEN_LOOP")
	character.play_animation(char, "CM_NPC_STEHEN_TIERTROG_FUELLEN_LOOP")
	character.play_animation(char, "CM_NPC_STEHEN_TIERTROG_FUELLEN_ENDE")

##########################
### Tagesabläufe:
##########################
schedules = {}

def init_schedules():
	global schedules
	schedules = {

"MERCENARY_DEBORAH": {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [stand()]
	}
},
# patrols of shadows
##########################
## copperhill schatten
data().SCHATTEN_CH_NPCS[4] : {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : (patrol(points=const.SCHATTEN_CH_PATROLS[0], speed=MT_SLOW)),
	}
},
data().SCHATTEN_CH_NPCS[5] : {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : (patrol(points=const.SCHATTEN_CH_PATROLS[1], speed=MT_SLOW)),
	}
},
data().SCHATTEN_CH_NPCS[11] : {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : (patrol(points=const.SCHATTEN_CH_PATROLS[2], speed=MT_SLOW)),
	}
},
data().SCHATTEN_CH_NPCS[12] : {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : (patrol(points=const.SCHATTEN_CH_PATROLS[3], speed=MT_SLOW)),
	}
},
## westlager schatten
'WESTERNCAMP_SHADOW_02' : {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : (patrol(points=const.SCHATTEN_WEST_PATROLS[0], speed=MT_SLOW)),
	}
},
'WESTERNCAMP_SHADOW_07' : {
	"00:00:00" : {
		S_START : [],
		S_LOOP  : (patrol(points=const.SCHATTEN_WEST_PATROLS[1], speed=MT_SLOW)),
	}
},

#z6 goe crew

"ABRAHAM" : ({
	S_CONDITION	: lambda : data().abraham_und_co_folgen,
	"00:00:00" : {
		S_START		: [],
		S_LOOP		: [global_schedules.follow_in_distance("ALTER_EGO"),
					goe_crew_comment()]
	},
},{
	"01:00:00" : {  #schlafen
		S_START	: [goto(555.52,240.93),
					lay_down_to_sleep()],
		S_LOOP	: [sleep()],
	},
	"03:00:00" : {  #boden sitzen warten
		S_START	: [goto_object("BUILDING_43890"),#"dmyp_001"),
					sit_down_on_bench()],
		S_LOOP	: [sit_on_bench()],
	},
	"05:00:00" : {  #stehen warten
		S_START	: [goto(544.77, 238.58),
					turn_to_direction(globals.DIR_SOUTH)],
		S_LOOP	: [global_schedules.wait()],
	},
	"21:00:00" : {  #lagerfeuer stehen warten
		S_START	: [],
		S_LOOP	: [global_schedules.wait()],
	},
}),

"MICKEY" : ({
	S_CONDITION	: lambda : data().abraham_und_co_folgen,
	"00:00:00" : {
		S_START		: [],
		S_LOOP		: [global_schedules.follow_in_distance("ALTER_EGO")]
	},
},{
	"22:30:00" : {  #schlafen
		S_START	: [goto(557.92,242.98),
					lay_down_to_sleep()],
		S_LOOP	: [sleep()],
	},
	"02:00:00" : {  #essen und trinken
		S_START	: [goto_object("BUILDING_43889"),#,"dmyp_001"),
					sit_down_on_bench()],
		S_LOOP	: [sit_on_bench(["eat", "sit", "drink"])],
	},
	"05:00:00" : {  #bei abraham auf dem boden sitzen warten
		S_START	: [goto_object("ABRAHAM"),
					turn_to_object("ABRAHAM"),
					sit_down_on_ground()],
		S_LOOP	: [sit_on_ground()],
	},
	"18:30:00" : {  #lagerfeuer sitzen warten
		S_START	: [goto_dummy("BUILDING_43877","dmyp_001"),
					sit_down_on_bench()],
		S_LOOP	: [sit_on_bench()],
	},
}),

"SUE_Z7" : ({
	S_CONDITION	: lambda : data().abraham_und_co_folgen,
	"00:00:00" : {
		S_START		: [],
		S_LOOP		: [global_schedules.follow_in_distance("ALTER_EGO")]
	},
},{
	"01:30:00" : {  #schlafen
		S_START	: [goto(556.86,238.03),
					lay_down_to_sleep()],
		S_LOOP	: [sleep()],
	},
	"04:00:00" : {  #essen und trinken
		S_START	: [goto_dummy("BUILDING_43882","dmyp_001"),
					sit_down_on_bench()],
		S_LOOP	: [sit_on_bench(["eat", "sit", "drink"])],
	},
	"05:00:00" : {  #bei abraham auf dem boden sitzen warten
		S_START	: [goto_object("ABRAHAM"),
					turn_to_object("ABRAHAM"),
					sit_down_on_ground()],
		S_LOOP	: [sit_on_ground()],
	},
	"20:00:00" : {  #lagerfeuer sitzen warten
		S_START	: [goto_dummy("BUILDING_43877","dmyp_003"),
					sit_down_on_bench()],
		S_LOOP	: [sit_on_bench()],
	},
}),

"FJODR" : ({
	S_CONDITION	: lambda : data().abraham_und_co_folgen,
	"00:00:00" : {
		S_START		: [],
		S_LOOP		: [global_schedules.follow_in_distance("ALTER_EGO")]
	},
},{
	"22:00:00" : {  #schlafen
		S_START	: [goto(560.93,242.80),
					turn_to_object("ABRAHAM")],
		S_LOOP	: [global_schedules.wait()],
	},
	"03:00:00" : {  #kochen
		S_START	: (goto_dummy("BUILDING_1882","dmyp_008"),
					sit_down_to_cook()),
		S_LOOP	: (cook()),
	},
	"05:30:00" : {  #bei abraham stehen warten
		S_START	: [goto_object("ABRAHAM"),
					turn_to_object("ABRAHAM")],
		S_LOOP	: [global_schedules.wait()],
	},
	"19:00:00" : {  #konversation mit sue
		S_START	: [goto_object("SUE_Z7"),
					turn_to_object("SUE_Z7")],
		S_LOOP	: [conversate("SUE_Z7")],
	},
}),

"OWEN" : {
	"22:00:00" : {  #schlafen in kneipe
		S_START	: [owen_work(action=66),
					lay_down_to_sleep()],
		S_LOOP	: [sleep()],
	},
	"05:00:00" : {  #kneipe bedienen
		S_START	: (),
		S_LOOP	: (owen_work(action=0)),
	},
	"10:30:00" : {  #kneipe warten
		S_START	: [owen_work(action=66)],
		S_LOOP	: [global_schedules.wait()],
	},
	"17:00:00" : {  #kneipe bedienen
		S_START	: [],
		S_LOOP	: [owen_work(action=0)],
	},
},

# ratskulls am lastwagen
################################################
"RATSKULL_01"	:	{
	"00:00:00"	:	{
		S_LOCATION : 1,
		S_START	: (#stepto(664.10,729.20),
				turn_to_direction(globals.DIR_EAST)),
		S_LOOP	: (work_on_machine())
	}
},
"RATSKULL_03"	:	{
	"00:00:00"	:	{
		S_LOCATION : 1,
		S_START	: (#stepto(668.30,729.10),
				turn_to_direction(globals.DIR_WEST)),
		S_LOOP	: (work_on_machine())
	}
},
"RATSKULL_04"	:	{
	"00:00:00"	:	{
		S_LOCATION : 1,
		S_START	: (#stepto(666.70,725.05),
				turn_to_direction(globals.DIR_WEST)),
		S_LOOP	: (work_on_machine())
	}
},


# nomaden
################################################
"CALEB"	: {
	S_CONDITION	: lambda:data().MitCalebGesprochen == 0,
	"00:00:00"	:	{
		S_LOCATION : 1,
		S_START	: (sit_down_on_ground()),
		S_LOOP	: (sit_on_ground())
	}
},

"ADIAN" : {
#####
	"05:30:00" : { #kochen
		S_LOCATION : 2,
		S_START  : [leave_building("BUILDING_3959"),
				goto_dummy("BUILDING_3958","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"07:30:00" : { #essen
		S_LOCATION : 3,
		S_START  : [goto_dummy("BUILDING_4146","dmyp_002"), 
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"10:00:00" : { #holz hacken
		S_LOCATION : 4,
		S_START  : [goto_dummy("BUILDING_4139","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	#"14:00:00" : { #wäsche aufhängen
	#	S_LOCATION : 5,
	#	S_START  : [goto_object("BUILDING_4144"),
	#			stepto(306.36,363.44),
	#			turn_to_direction(globals.DIR_EAST)],
	#	S_LOOP   : [work_on_machine()]}, ## todo: richtige animation
	"17:00:00" : { #auf bank sitzen
		S_LOCATION : 6,
		S_START  : [goto_dummy("BUILDING_4146","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"22:00:00" : { #schlafen
		S_LOCATION : 1,
		S_START  : [goto(292.80, 357.5), 
				enter_building("BUILDING_3959"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
},
# flüchtlinge aus copper hill
################################################
"PHIL" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(649.49,879.51), 
				enter_building("BUILDING_4443"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:30:00" : { #auf bank sitzen, flöte spielen
		S_DIALOG : "NPC_PHIL_T_001",
		S_START  : [leave_building("BUILDING_4443"),
				goto_dummy("BUILDING_4708","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	"08:00:00" : { #feuer sitzen, essen und trinken
		S_DIALOG : "NPC_PHIL_T_002",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"10:00:00" : { #bank sitzen, gitarre spielem
		S_DIALOG : "NPC_PHIL_T_003",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	"15:00:00" : { #bank sitzen
		S_DIALOG : "NPC_PHIL_T_004",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #feuer sitzen, flöte spielen
		S_DIALOG : "NPC_PHIL_T_005",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	"22:00:00" : { #feuer sitzen, gitarre spielen
		S_DIALOG : "NPC_PHIL_T_006",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	S_SECONDDIALOG : "NPC_PHIL_T_007"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(534.12,803.82), 
				enter_building("BUILDING_2284"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:30:00" : { #auf bank sitzen, flöte spielen
		S_DIALOG : "NPC_PHIL_FL_T_001",
		S_START  : [leave_building("BUILDING_2284"),
				goto_dummy("BUILDING_6175","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	"08:00:00" : { #feuer sitzen, essen und trinken
		S_DIALOG : "NPC_PHIL_FL_T_002",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"10:00:00" : { #bank sitzen, gitarre spielem
		S_DIALOG : "NPC_PHIL_FL_T_003",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	"15:00:00" : { #bank sitzen
		S_DIALOG : "NPC_PHIL_FL_T_004",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #feuer sitzen, flöte spielen
		S_DIALOG : "NPC_PHIL_FL_T_005",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	"22:00:00" : { #feuer sitzen, gitarre spielen
		S_DIALOG : "NPC_PHIL_FL_T_006",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	S_SECONDDIALOG : "NPC_PHIL_FL_T_007"
}),

"IRIS" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(718.33,931.18), 
				enter_building("BUILDING_4900"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"05:30:00" : { #kochen
		S_DIALOG : "NPC_IRIS_T_001",
		S_START  : [leave_building("BUILDING_4900"),
				goto_dummy("BUILDING_6189","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"08:00:00" : { #holz hacken
		S_DIALOG : "NPC_IRIS_T_002",
		S_START  : [goto_dummy("BUILDING_6194","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"10:00:00" : { #bank sitzen bei phil
		S_DIALOG : "NPC_IRIS_T_003",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"15:00:00" : { #konversation bruno
		S_DIALOG : "NPC_IRIS_T_004",
		S_START  : [goto(655.30,889.54),
				turn_to_object("BRUNO")],
		S_LOOP   : [conversate("BRUNO")]},
	"19:00:00" : { #kochen
		S_DIALOG : "NPC_IRIS_T_005",
		S_START  : [goto_dummy("BUILDING_6189","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"22:00:00" : { #feuer sitzen bei phil
		S_DIALOG : "NPC_IRIS_T_006",
		S_START  : [goto_dummy("BUILDING_4708","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_IRIS_T_007"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(544.70,874.17), 
				enter_building("BUILDING_2283"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"05:30:00" : { #kochen
		S_DIALOG : "NPC_IRIS_FL_T_001",
		S_START  : [leave_building("BUILDING_2283"),
				goto_dummy("BUILDING_2285","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"08:00:00" : { #holz hacken
		S_DIALOG : "NPC_IRIS_FL_T_002",
		S_START  : [goto_dummy("BUILDING_6181","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"10:00:00" : { #bank sitzen bei phil
		S_DIALOG : "NPC_IRIS_FL_T_003",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"15:00:00" : { #konversation bruno
		S_DIALOG : "NPC_IRIS_FL_T_004",
		S_START  : [goto(506.02,833.43),
				turn_to_object("BRUNO")],
		S_LOOP   : [conversate("BRUNO")]},
	"19:00:00" : { #kochen
		S_DIALOG : "NPC_IRIS_FL_T_005",
		S_START  : [goto_dummy("BUILDING_2285","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"22:00:00" : { #feuer sitzen bei phil
		S_DIALOG : "NPC_IRIS_FL_T_006",
		S_START  : [goto_dummy("BUILDING_6175","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_IRIS_FL_T_007"
}),

"BRUNO" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:30:00" : { #schlafen
		S_START  : [goto(718.33,931.18), 
				enter_building("BUILDING_4900"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"05:30:00" : { #waffe reinigen
		S_DIALOG : "NPC_BRUNO_T_001",
		S_START  : [leave_building("BUILDING_4900"),
				goto(620.99,904.49),
				start_clean_weapon()],
		S_LOOP   : [clean_weapon()]},
	"08:00:00" : { #jagen
		S_DIALOG : "NPC_BRUNO_T_002",
		S_START  : [goto(595.57,855.310),
				start_hunt()],
		S_LOOP   : [hunt()]},
	"10:00:00" : { #bank sitzen in der nähe von phil und iris
		S_DIALOG : "NPC_BRUNO_T_003",
		S_START  : [end_hunt(),
				goto_dummy("BUILDING_4707","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"15:00:00" : { #konversation iris
		S_DIALOG : "NPC_BRUNO_T_004",
		S_START  : [goto(653.39,889.07),
				turn_to_object("IRIS")],
		S_LOOP   : [conversate("IRIS")]},
	"19:00:00" : { #feuer sitzen
		S_DIALOG : "NPC_BRUNO_T_005",
		S_START  : [goto_object("BUILDING_6189"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"22:00:00" : { #abseites feuer sitzen, essen und trinken
		S_DIALOG : "NPC_BRUNO_T_006",
		S_START  : [goto_dummy("BUILDING_4707","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	S_SECONDDIALOG : "NPC_BRUNO_T_007"
},{
#####
	"00:30:00" : { #schlafen
		S_START  : [goto(544.70,874.17), 
				enter_building("BUILDING_2283"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"05:30:00" : { #waffe reinigen
		S_DIALOG : "NPC_BRUNO_FL_T_001",
		S_START  : [leave_building("BUILDING_2283"),
				goto(522.30,838.28),
				start_clean_weapon()],
		S_LOOP   : [clean_weapon()]},
	"08:00:00" : { #jagen
		S_DIALOG : "NPC_BRUNO_FL_T_002",
		S_START  : [goto(568.21,851.32),
				start_hunt()],
		S_LOOP   : [hunt()]},
	"10:00:00" : { #bank sitzen in der nähe von phil und iris
		S_DIALOG : "NPC_BRUNO_FL_T_003",
		S_START  : [end_hunt(),
				goto_dummy("BUILDING_6176","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"15:00:00" : { #konversation iris
		S_DIALOG : "NPC_BRUNO_FL_T_004",
		S_START  : [goto(507.50,831.85),
				turn_to_object("IRIS")],
		S_LOOP   : [conversate("IRIS")]},
	"19:00:00" : { #feuer sitzen
		S_DIALOG : "NPC_BRUNO_FL_T_005",
		S_START  : [goto_object("BUILDING_2285"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"22:00:00" : { #abseites feuer sitzen, essen und trinken
		S_DIALOG : "NPC_BRUNO_FL_T_006",
		S_START  : [goto_dummy("BUILDING_6176","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	S_SECONDDIALOG : "NPC_BRUNO_FL_T_007"
}),

"GEORGE" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(628.90,968.67), 
				enter_building("BUILDING_4942"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"10:00:00" : { #essen + trinken
		S_DIALOG : "NPC_GEORGE_T_001",
		S_START  : [leave_building("BUILDING_4942"),
				goto_dummy("BUILDING_6183","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"11:00:00" : { #motorrad reparieren
		S_DIALOG : "NPC_GEORGE_T_002",
		S_START  : [goto(707.82,860.28),
				start_repair_motorbike("BUILDING_6209")],
		S_LOOP   : [repair_motorbike()]},
	"15:00:00" : { #rumstehen
		S_DIALOG : "NPC_GEORGE_T_003",
		S_START  : [goto(654.75,913.12),
				turn_to_direction(globals.DIR_NORTH)],
		S_LOOP   : [stand()]},
	"16:00:00" : { #waffenputzer beobachten
		S_DIALOG : "NPC_GEORGE_T_004",
		S_START  : [goto(637.65,905.75),
				turn_to_object("BRUNO")],
		S_LOOP   : [stand()]},
	"18:00:00" : { #rumsitzen
		S_DIALOG : "NPC_GEORGE_T_005",
		S_START  : [goto(666.56,960.59),
				sit_down_on_ground(),
				turn_to_direction(globals.DIR_NORTH_WEST)],
		S_LOOP   : [sit_on_ground()]},
	"19:00:00" : { #boden sitzen
		# S_DIALOG : "NPC_GEORGE_T_006",
		S_START  : [goto(665.37,962.18),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_GEORGE_T_006"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(531.68,864.58), 
				enter_building("BUILDING_5541"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"10:00:00" : { #essen + trinken
		S_DIALOG : "NPC_GEORGE_FL_T_001",
		S_START  : [leave_building("BUILDING_5541"),
				goto_dummy("BUILDING_3295","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"11:00:00" : { #motorrad reparieren
		S_DIALOG : "NPC_GEORGE_FL_T_002",
		S_START  : [goto(523.9,855.9),
				start_repair_motorbike("BUILDING_6209")],
		S_LOOP   : [repair_motorbike()]},
	"15:00:00" : { #rumstehen
		S_DIALOG : "NPC_GEORGE_FL_T_003",
		S_START  : [goto(504.56,892.21),
				turn_to_direction(globals.DIR_SOUTH)],
		S_LOOP   : [stand()]},
	"16:00:00" : { #waffenputzer beobachten
		S_DIALOG : "NPC_GEORGE_FL_T_004",
		S_START  : [goto(528.42,830.88),
				turn_to_object("BRUNO")],
		S_LOOP   : [stand()]},
	"18:00:00" : { #rumsitzen
		S_DIALOG : "NPC_GEORGE_FL_T_005",
		S_START  : [goto(481.94,918.07),
				sit_down_on_ground(),
				turn_to_direction(globals.DIR_WEST)],
		S_LOOP   : [sit_on_ground()]},
	"19:00:00" : { #bank sitzen, flöte spielen
		# S_DIALOG : "NPC_GEORGE_FL_T_006",
		S_START  : [goto_dummy("BUILDING_3295","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	S_SECONDDIALOG : "NPC_GEORGE_FL_T_006"
}),

"MEN_TOI" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:15:00" : { #schlafen
		S_START  : [goto(708.95,852.06), 
				enter_building("BUILDING_4474"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_MEN_TOI_T_001",
		S_START  : [leave_building("BUILDING_4474"),
				goto_dummy("BUILDING_6187","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"06:00:00" : { #auf anhöhe auf boden sitzen
		S_DIALOG : "NPC_MEN_TOI_T_002",
		S_START  : [goto(751.28,900.15),
				sit_down_on_ground(),
				turn_to_direction(globals.DIR_NORTH)],
		S_LOOP   : [sit_on_ground()]},
	"12:00:00" : { #holz hacken
		S_DIALOG : "NPC_MEN_TOI_T_003",
		S_START  : [goto_dummy("BUILDING_6193","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"15:00:00" : { #auf anhöhe auf boden sitzen
		S_DIALOG : "NPC_MEN_TOI_T_006",
		S_START  : [goto(751.28,900.15),
				turn_to_direction(globals.DIR_NORTH),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"21:30:00" : { #am feuer stehen
		S_DIALOG : "NPC_MEN_TOI_T_004",
		S_START  : [goto_object("BUILDING_6184"),
				turn_to_object("BUILDING_6184")],
		S_LOOP   : [stand()]},
	"23:00:00" : { #am feuer sitzen
		S_DIALOG : "NPC_MEN_TOI_T_005",
		S_START  : [goto_object("BUILDING_6184"),
				turn_to_object("BUILDING_6184"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_MEN_TOI_T_007"
},{
#####
	"00:15:00" : { #schlafen
		S_START  : [goto(470.03,842.68), 
				enter_building("BUILDING_43965"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_MEN_TOI_FL_T_001",
		S_START  : [leave_building("BUILDING_43965"),
				goto_dummy("BUILDING_6179","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"06:00:00" : { #auf anhöhe auf boden sitzen
		S_DIALOG : "NPC_MEN_TOI_FL_T_002",
		S_START  : [goto(418.01,864.68),
				sit_down_on_ground(),
				turn_to_direction(globals.DIR_SOUTH)],
		S_LOOP   : [sit_on_ground()]},
	"12:00:00" : { #holz hacken
		S_DIALOG : "NPC_MEN_TOI_FL_T_003",
		S_START  : [goto_dummy("BUILDING_2360","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"15:00:00" : { #auf anhöhe auf boden sitzen
		S_DIALOG : "NPC_MEN_TOI_FL_T_006",
		S_START  : [goto(418.01,864.68),
				turn_to_direction(globals.DIR_SOUTH),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"21:30:00" : { #am feuer stehen
		S_DIALOG : "NPC_MEN_TOI_FL_T_004",
		S_START  : [goto_object("BUILDING_3190"),
				turn_to_object("BUILDING_3190")],
		S_LOOP   : [stand()]},
	"23:00:00" : { #am feuer sitzen
		S_DIALOG : "NPC_MEN_TOI_FL_T_005",
		S_START  : [goto_object("BUILDING_3190"),
				turn_to_object("BUILDING_3190"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_MEN_TOI_FL_T_007"
}),

"IGOR" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"01:00:00" : { #schlafen
		S_START  : [goto(628.13,968.43), 
				enter_building("BUILDING_4942"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #kochen
		S_DIALOG : "NPC_IGOR_T_001",
		S_START  : [leave_building("BUILDING_4942"),
				goto_dummy("BUILDING_6184","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { #loch graben
		S_DIALOG : "NPC_IGOR_T_002",
		S_START  : [goto_object("BUILDING_3502"),#,"dmyp_001"),
				start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_IGOR_T_003",
		S_START  : [goto_dummy("BUILDING_6183","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"15:00:00" : { #loch graben
		S_DIALOG : "NPC_IGOR_T_006",
		S_START  : [goto_object("BUILDING_3499"),#,"dmyp_001"),
				start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"19:00:00" : { #feuer stehen, konversation mit doc murphy
		S_DIALOG : "NPC_IGOR_T_004",
		S_START  : [goto(618.37,949.46),
				turn_to_object("MAD_DOC_MURPHY")],
		S_LOOP   : [conversate("MAD_DOC_MURPHY")]},
	"22:00:00" : { #boden sitzen bei seinem loch
		S_DIALOG : "NPC_IGOR_T_005",
		S_START  : [goto(592.74, 744.43),
				turn_to_object("BUILDING_3501"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_IGOR_T_007"
},{
#####
	"01:00:00" : { #schlafen
		S_START  : [goto(457.63,829.52), 
				enter_building("BUILDING_3121"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #kochen
		S_DIALOG : "NPC_IGOR_FL_T_001",
		S_START  : [leave_building("BUILDING_3121"),
				goto_dummy("BUILDING_2306","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { #loch graben
		S_DIALOG : "NPC_IGOR_FL_T_002",
		S_START  : [goto_object("BUILDING_3416"),
				start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_IGOR_FL_T_003",
		S_START  : [goto_dummy("BUILDING_43971","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"15:00:00" : { #loch graben
		S_DIALOG : "NPC_IGOR_FL_T_006",
		S_START  : [goto(450.98,857.26),
					start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"19:00:00" : { #feuer stehen, konversation mit doc murphy
		S_DIALOG : "NPC_IGOR_FL_T_004",
		S_START  : [goto(482.96,869.71),
					turn_to_object("MAD_DOC_MURPHY")],
		S_LOOP   : [conversate("MAD_DOC_MURPHY")]},
	"22:00:00" : { #boden sitzen bei seinem loch
		S_DIALOG : "NPC_IGOR_FL_T_005",
		S_START  : [goto(446.44, 859.12),
						turn_to_direction(globals.DIR_NORTH_WEST),
						sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_IGOR_FL_T_007"
}),

"MEG" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(678.87,859.62), 
				enter_building("BUILDING_4413"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #wagen reparieren
		S_DIALOG : "NPC_MEG_T_001",
		S_START  : [leave_building("BUILDING_4413"),
				goto_dummy("BUILDING_4498","dmyp_001"),
				start_repair_car()],
		S_LOOP   : [repair_car()]},
	"06:00:00" : { #motorrad reparieren
		S_DIALOG : "NPC_MEG_T_002",
		S_START  : [goto_dummy("BUILDING_4498","dmyp_001"),
				start_repair_car()],
		S_LOOP   : [repair_car()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_MEG_T_003",
		S_START  : [goto_dummy("BUILDING_6188","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"15:00:00" : { #wagen reparieren
		S_DIALOG : "NPC_MEG_T_004",
		S_START  : [goto_dummy("BUILDING_4498","dmyp_001"),
				start_repair_car()],
		S_LOOP   : [repair_car()]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_MEG_T_005",
		S_START  : [goto_dummy("BUILDING_6188","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"21:00:00" : { #mit ryan auf bank sitzen
		S_DIALOG : "NPC_MEG_T_006",
		S_START  : [goto_dummy("BUILDING_6185","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_MEG_T_007"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(461.61,830.02), 
					enter_building("BUILDING_2271"),
					lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #wagen reparieren
		S_DIALOG : "NPC_MEG_FL_T_001",
		S_START  : [leave_building("BUILDING_2271"),
					goto_object("BUILDING_3309"),#,"dmyp_001"),
					start_repair_car()],
		S_LOOP   : [repair_car()]},
	"06:00:00" : { #motorrad reparieren
		S_DIALOG : "NPC_MEG_FL_T_002",
		S_START  : [goto_dummy("BUILDING_6209","dmyp_001"),
					start_repair_motorbike("BUILDING_6209")],
		S_LOOP   : [repair_motorbike()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_MEG_FL_T_003",
		S_START  : [goto_dummy("BUILDING_6179","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"15:00:00" : { #wagen reparieren
		S_DIALOG : "NPC_MEG_FL_T_004",
		S_START  : [goto_object("BUILDING_3309"),#,"dmyp_001"),
				start_repair_car()],
		S_LOOP   : [repair_car()]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_MEG_FL_T_005",
		S_START  : [goto_dummy("BUILDING_6179","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"21:00:00" : { #mit ryan auf bank sitzen
		S_DIALOG : "NPC_MEG_FL_T_006",
		S_START  : [goto_dummy("BUILDING_3295","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_MEG_FL_T_007"
}),

"RYAN" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(678.87,859.62), 
				enter_building("BUILDING_4413"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #kochen
		S_DIALOG : "NPC_RYAN_T_001",
		S_START  : [leave_building("BUILDING_4413"),
				goto_dummy("BUILDING_6191","dmyp_002"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { #holz hacken
		S_DIALOG : "NPC_RYAN_T_002",
		S_START  : [goto_dummy("BUILDING_6194","dmyp_002"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"12:00:00" : { #kochen
		S_DIALOG : "NPC_RYAN_T_003",
		S_START  : [goto_dummy("BUILDING_6191","dmyp_007"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"15:00:00" : { #wasser suchen
		S_DIALOG : "NPC_RYAN_T_004",
		S_START  : [goto_find_water([737.97,821.90])],
		S_LOOP   : [find_water()]},
	"20:00:00" : { #kochen
		S_DIALOG : "NPC_RYAN_T_005",
		S_START  : [goto_dummy("BUILDING_6191","dmyp_006"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:00:00" : { #mit meg auf bank sitzen
		S_DIALOG : "NPC_RYAN_T_006",
		S_START  : [goto_dummy("BUILDING_6185","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_RYAN_T_007"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(461.61,830.02), 
				enter_building("BUILDING_2271"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { #kochen
		S_DIALOG : "NPC_RYAN_FL_T_001",
		S_START  : [leave_building("BUILDING_2271"),
				goto_dummy("BUILDING_2306","dmyp_002"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { #holz hacken
		S_DIALOG : "NPC_RYAN_FL_T_002",
		S_START  : [goto_dummy("BUILDING_2360","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"12:00:00" : { #kochen
		S_DIALOG : "NPC_RYAN_FL_T_003",
		S_START  : [goto_dummy("BUILDING_2306","dmyp_002"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"15:00:00" : { #wasser suchen
		S_DIALOG : "NPC_RYAN_FL_T_004",
		S_START  : [goto_find_water([417.75,821.49])],
		S_LOOP   : [find_water()]},
	"20:00:00" : { #kochen
		S_DIALOG : "NPC_RYAN_FL_T_005",
		S_START  : [goto_dummy("BUILDING_2306","dmyp_002"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:00:00" : { #mit meg auf bank sitzen
		S_DIALOG : "NPC_RYAN_FL_T_006",
		S_START  : [goto_dummy("BUILDING_3295","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_RYAN_FL_T_007"
}),

"MAD_DOC_MURPHY" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:30:00" : { #schlafen
		S_START  : [goto(718.24,931.33), 
				enter_building("BUILDING_4900"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"08:00:00" : { #bank sitzen
		S_DIALOG : "NPC_MAD_DOC_MURPHY_T_001",
		S_START  : [leave_building("BUILDING_4900"),
				goto_dummy("BUILDING_6185","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_MAD_DOC_MURPHY_T_002",
		S_START  : [goto_dummy("BUILDING_6187","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"15:00:00" : { #bank sitzen, konversation mit rick
		S_DIALOG : "NPC_MAD_DOC_MURPHY_T_003",
		S_START  : [goto_dummy("BUILDING_6185","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #feuer stehen, konversation mit igor
		S_DIALOG : "NPC_MAD_DOC_MURPHY_T_004",
		S_START  : [goto_object("BUILDING_6191"),
				turn_to_object("IGOR")],
		S_LOOP   : [conversate("IGOR")]},
	"22:00:00" : { #am lagerfeuer sitzen
		S_DIALOG : "NPC_MAD_DOC_MURPHY_T_005",
		S_START  : [goto_object("BUILDING_6191"),
				turn_to_object("BUILDING_6191"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_MAD_DOC_MURPHY_T_006"
},{
#####
	"00:30:00" : { #schlafen
		S_START  : [goto(462.09,843.25), 
					enter_building("BUILDING_3119"),
					lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"08:00:00" : { #bank sitzen
		S_DIALOG : "NPC_MAD_DOC_MURPHY_FL_T_001",
		S_START  : [leave_building("BUILDING_3119"),
				goto_dummy("BUILDING_6177","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_MAD_DOC_MURPHY_FL_T_002",
		S_START  : [goto_dummy("BUILDING_3194","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"15:00:00" : { #bank sitzen, konversation mit rick
		S_DIALOG : "NPC_MAD_DOC_MURPHY_FL_T_003",
		S_START  : [goto_dummy("BUILDING_6177","dmyp_002"),
					sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #feuer stehen, konversation mit igor
		S_DIALOG : "NPC_MAD_DOC_MURPHY_FL_T_004",
		S_START  : [goto(480.55,866.45),
					turn_to_object("IGOR")],
		S_LOOP   : [conversate("IGOR")]},
	"22:00:00" : { #am lagerfeuer sitzen
		S_DIALOG : "NPC_MAD_DOC_MURPHY_FL_T_005",
		S_START  : [goto_object("BUILDING_2286"),
				turn_to_object("BUILDING_2286"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : gender_switch("NPC_MAD_DOC_MURPHY_FL_T_006F","NPC_MAD_DOC_MURPHY_FL_T_006")
}),

"RICK" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"23:00:00" : { #schlafen
		S_START  : [goto(692.95,860.71), 
				enter_building("BUILDING_4475"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"11:00:00" : { #holz hacken
		S_DIALOG : "NPC_RICK_T_001",
		S_START  : [leave_building("BUILDING_4475"),
				goto_dummy("BUILDING_6194","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"15:00:00" : { #auf bank sitzen mit mad doc reden
		S_DIALOG : "NPC_RICK_T_002",
		S_START  : [goto_dummy("BUILDING_6185","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #kochen
		S_DIALOG : "NPC_RICK_T_003",
		S_START  : [goto_dummy("BUILDING_6191","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:00:00" : { #holz hacken
		S_DIALOG : "NPC_RICK_T_004",
		S_START  : [goto_dummy("BUILDING_6194","dmyp_002"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	S_SECONDDIALOG : "NPC_RICK_T_005"
},{
#####
	"23:00:00" : { #schlafen
		S_START  : [goto(549.33, 861.45), 
				enter_building("BUILDING_5540"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"11:00:00" : { #holz hacken
		S_DIALOG : "NPC_RICK_FL_T_001",
		S_START  : [leave_building("BUILDING_5540"),
				goto_dummy("BUILDING_6181","dmyp_002"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"15:00:00" : { #auf bank sitzen mit mad doc reden
		S_DIALOG : "NPC_RICK_FL_T_002",
		S_START  : [goto_dummy("BUILDING_6177","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #kochen
		S_DIALOG : "NPC_RICK_FL_T_003",
		S_START  : [goto_dummy("BUILDING_5542","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:00:00" : { #holz hacken
		S_DIALOG : "NPC_RICK_FL_T_004",
		S_START  : [goto_dummy("BUILDING_6181","dmyp_002"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	S_SECONDDIALOG : "NPC_RICK_FL_T_005"
}),

"CRUNCHY" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(639.7,956.8), 
				enter_building("BUILDING_5923"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:00:00" : { #horn blasen am marktplatz
		S_START  : [leave_building("BUILDING_5923"),
				goto(715.73,858.78),
				turn_to_direction(globals.DIR_SOUTH_EAST)],
		S_LOOP   : [blow_horn()]},
	"06:05:00" : { #gitarre spielen am marktplatz
		S_DIALOG : "NPC_CRUNCHY_T_001",
		S_START  : [goto_dummy("BUILDING_6186","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	"12:00:00" : { #am lagerfeuer stehen, warten
		S_DIALOG : "NPC_CRUNCHY_T_002",
		S_START  : [goto(743.36,886.41),
				turn_to_object("BUILDING_6191")],
		S_LOOP   : [stand()]},
	"15:00:00" : { #flöte spielen am marktplatz
		S_START  : [goto_dummy("BUILDING_6186","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	"20:00:00" : { #kochen
		S_DIALOG : "NPC_CRUNCHY_T_003",
		S_START  : [goto_dummy("BUILDING_6191","dmyp_004"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:00:00" : { #am lagerfeuer gitarre spielen
		S_DIALOG : "NPC_CRUNCHY_T_004",
		S_START  : [goto_dummy("BUILDING_6188","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	S_SECONDDIALOG : "NPC_CRUNCHY_T_005"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(486.05, 867.23),
				enter_building("BUILDING_3216"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:00:00" : { #horn blasen am marktplatz
		S_START  : [leave_building("BUILDING_3216"),
					goto(488.47,867.46),
					turn_to_direction(globals.DIR_SOUTH_EAST)],
		S_LOOP   : [blow_horn()]},
	"06:15:00" : { #gitarre spielen am marktplatz
		S_DIALOG : "NPC_CRUNCHY_FL_T_001",
		S_START  : [goto_dummy("BUILDING_6178","dmyp_001"),
					sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	"12:00:00" : { #am lagerfeuer stehen, warten
		S_DIALOG : "NPC_CRUNCHY_FL_T_002",
		S_START  : [goto(511.99,842.79),
				turn_to_object("BUILDING_2285")],
		S_LOOP   : [stand()]},
	"15:00:00" : { #flöte spielen am marktplatz
		S_START  : [goto_dummy("BUILDING_6178","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	"20:00:00" : { #kochen
		S_DIALOG : "NPC_CRUNCHY_FL_T_003",
		S_START  : [goto_dummy("BUILDING_2285","dmyp_004"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:00:00" : { #am lagerfeuer gitarre spielen
		S_DIALOG : "NPC_CRUNCHY_FL_T_004",
		S_START  : [goto_dummy("BUILDING_6176","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	S_SECONDDIALOG : "NPC_CRUNCHY_FL_T_005"
}),

"TOBY" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"23:30:00" : { #schlafen
		S_START  : [goto(639.6,962.5), 
				enter_building("BUILDING_5924"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:05:00" : { #bei crunchy stehen, warten
		S_DIALOG : "NPC_TOBY_T_001",
		S_START  : [leave_building("BUILDING_5924"),
				goto_object("CRUNCHY"),
				turn_to_object("CRUNCHY")],
		S_LOOP   : [stand()]},
	"12:00:00" : { #irgendwo warten
		S_DIALOG : "NPC_TOBY_T_002",
		S_START  : [goto(685.67,869.81),
				turn_to_direction(globals.DIR_EAST)],
		S_LOOP   : [stand()]},
	"14:00:00" : { #essen + trinken
		S_DIALOG : "NPC_TOBY_T_003",
		S_START  : [goto_dummy("BUILDING_6187","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"16:00:00" : { #bei crunchy sitzen, auf boden
		S_DIALOG : "NPC_TOBY_T_004",
		S_START  : [goto_object("CRUNCHY"),
				turn_to_object("CRUNCHY"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_TOBY_T_005",
		S_START  : [goto_dummy("BUILDING_6187","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"22:00:00" : { #bei crunchy sitzen, auf boden
		S_DIALOG : "NPC_TOBY_T_006",
		S_START  : [goto_object("CRUNCHY"),
				turn_to_object("CRUNCHY"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_TOBY_T_007"
},{
#####
	"23:30:00" : { #schlafen
		S_START  : [goto(534.12,859.70), 
				enter_building("BUILDING_2304"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:05:00" : { #bei crunchy stehen, warten
		S_DIALOG : "NPC_TOBY_FL_T_001",
		S_START  : [leave_building("BUILDING_2304"),
				goto_object("CRUNCHY"),
				turn_to_object("CRUNCHY")],
		S_LOOP   : [stand()]},
	"12:00:00" : { #irgendwo warten
		S_DIALOG : "NPC_TOBY_FL_T_002",
		S_START  : [goto(490.60,786.18),
				turn_to_direction(globals.DIR_SOUTH_EAST)],
		S_LOOP   : [global_schedules.wait()]},
	"14:00:00" : { #essen + trinken
		S_DIALOG : "NPC_TOBY_FL_T_003",
		S_START  : [goto_dummy("BUILDING_6178","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"16:00:00" : { #bei crunchy sitzen, auf boden
		S_DIALOG : "NPC_TOBY_FL_T_004",
		S_START  : [goto_object("CRUNCHY"),
				turn_to_object("CRUNCHY"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_TOBY_FL_T_005",
		S_START  : [goto_dummy("BUILDING_6178","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"22:00:00" : { #bei crunchy sitzen, auf boden
		S_DIALOG : "NPC_TOBY_FL_T_006",
		S_START  : [goto_object("CRUNCHY"),
				turn_to_object("CRUNCHY"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_TOBY_FL_T_007"
}),

"ALOIS" : ({
#####
	S_CONDITION: lambda:data().copperhill_befreit == True,
	"00:00:00" : { #schlafen
		S_START  : [goto(639.6,962.5), 
				enter_building("BUILDING_5924"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"05:30:00" : { #tiere füttern
		S_DIALOG : "NPC_ALOIS_T_001",
		S_START  : [leave_building("BUILDING_5924"),
				lambda char:object.move_to_object(char, random.choice(["KUH_1","KUH_2"])),
				start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"08:00:00" : { #jagen
		S_DIALOG : "NPC_ALOIS_T_002",
		S_START  : [goto(596.0,782.0),
				turn_to_object("HIRSCH_1"),
				start_hunt()],
		S_LOOP   : [hunt()]},
	"12:00:00" : { #kochen
		S_DIALOG : "NPC_ALOIS_T_003",
		S_START  : [end_hunt(),
				goto_dummy("BUILDING_6191","dmyp_004"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"16:00:00" : { #wasser suchen
		S_DIALOG : "NPC_ALOIS_T_004",
		S_START  : [goto_find_water((792.60,817.47))],
		S_LOOP   : [find_water()]},
	"20:00:00" : { #holz hacken
		S_DIALOG : "NPC_ALOIS_T_005",
		S_START  : [goto_dummy("BUILDING_6193","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"21:00:00" : { #kochen
		S_DIALOG : "NPC_ALOIS_T_006",
		S_START  : [goto_dummy("BUILDING_6191","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	S_SECONDDIALOG : "NPC_ALOIS_T_007"
},{
#####
	"00:00:00" : { #schlafen
		S_START  : [goto(534.12,859.70), 
				enter_building("BUILDING_2304"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"05:30:00" : { #tiere füttern
		S_DIALOG : "NPC_ALOIS_FL_T_001",
		S_START  : [leave_building("BUILDING_2304"),
				lambda char:object.move_to_object(char, random.choice(["KUH_1","KUH_2"])),
				start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"08:00:00" : { #jagen
		S_DIALOG : "NPC_ALOIS_FL_T_002",
		S_START  : [goto(596.0,782.0),
				turn_to_object("HIRSCH_1"),
				start_hunt()],
		S_LOOP   : [hunt()]},
	"12:00:00" : { #kochen
		S_DIALOG : "NPC_ALOIS_FL_T_003",
		S_START  : [end_hunt(),
					goto_dummy("BUILDING_2306","dmyp_001"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"16:00:00" : { #wasser suchen
		S_DIALOG : "NPC_ALOIS_FL_T_004",
		S_START  : [goto_find_water((497.47,790.42))],
		S_LOOP   : [find_water()]},
	"20:00:00" : { #holz hacken
		S_DIALOG : "NPC_ALOIS_FL_T_005",
		S_START  : [goto_dummy("BUILDING_6181","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"21:00:00" : { #kochen
		S_DIALOG : "NPC_ALOIS_FL_T_006",
		S_START  : [goto_dummy("BUILDING_2306","dmyp_001"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	S_SECONDDIALOG : "NPC_ALOIS_FL_T_007"
}),

#kindergang
################################################
"SAVANNAH" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(663.0,274.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(717.27,331.74),
					stepto(714.27,331.74), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #kochen
		{	
			S_START	: (goto_dummy("BUILDING_2945","dmyp_001"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([710.44,338.29]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(718.34,339.43),
					turn_to_nearest_neighbour(["KIMBERLY","ANDREA"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #kochen
		{	
			S_START	: (goto_dummy("BUILDING_2945","dmyp_001"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
},{
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [],
	}
}),

"ANDREA" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(657.0,287.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(717.27,330.74),
					stepto(714.27,330.74), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2149","dmyp_001"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([709.33,338.60]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(718.34,339.43),
					turn_to_nearest_neighbour(["KIMBERLY","SAVANNAH"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2149","dmyp_001"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
},{
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [conversate("KIMBERLY")],
	}
}),


"KIMBERLY" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(642.0,257.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(700.58,330.13),
					stepto(700.58,327.13), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #k
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_002"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([712.71,339.36]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(718.34,339.43),
					turn_to_nearest_neighbour(["ANDREA","SAVANNAH"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #k
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_002"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
},{
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [conversate("ANDREA")],
	}
}),


"ERIN" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(663.0,274.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(701.58,330.20),
					stepto(701.58,327.20), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2149","dmyp_002"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([707.63,341.25]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(711.98,347.56),
					turn_to_nearest_neighbour(["DEVIN"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2149","dmyp_002"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
},{
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [global_schedules.wait()],
	}
}),


"DEVIN" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(657.0,287.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(702.58,330.46),
					stepto(702.58,327.46), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #k
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_003"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([713.52,341.72]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(711.98,347.56),
					turn_to_nearest_neighbour(["ERIN"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #k
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_003"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
},{
	"00:00:00" : {
		S_START : [sit_down_on_ground()],
		S_LOOP  : [sit_on_ground(["eat", "sit", "drink"])],
	}
}),


"CODY" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(642.0,257.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(714.20,349.50),
					stepto(714.20,352.50), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_003"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([712.52,343.46]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(703.87,340.52),
					turn_to_nearest_neighbour(["ANTONIO","ALEXA"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_003"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
},{
	"00:00:00" : {
		S_START : [sit_down_on_ground()],
		S_LOOP  : [sit_on_ground(["eat", "sit", "drink"])],
	}
}),


"ANTONIO" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(663.0,274.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(715.25,351.15),
					stepto(715.25,354.15), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #k
		{	
			S_START	: (goto_dummy("BUILDING_2945","dmyp_004"),
						sit_down_to_cook()),
			S_LOOP	: (cook())
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([709.90,343.85]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(703.87,340.52),
					turn_to_nearest_neighbour(["CODY","ALEXA"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #k
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_004"),
					sit_down_to_cook()),
			S_LOOP	: (cook())
		},
},{
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [global_schedules.wait()],
	}
}),


"ALEXA" : ({
	S_CONDITION : lambda: ((not data().children_at_konvoi) and system.get_qb_entry_state(data().QB_011) in [COMPLETE, IMPOSSIBLE]),
	"22:00:00": #jagen
		{	
			S_START	: (goto(657.0,287.0),
					lambda char:object.turn_to_object(char, random.choice(const.OBJ_HYAENEN)),
					start_hunt()),
			S_LOOP	: (hunt())
		},
	"03:00:00": #schlafen
		{	
			S_START	: (end_hunt(),
					goto(715.25,349.50),
					stepto(715.00,352.00), ## zeltid herausfinden
					#enter_building(),
					lay_down_to_sleep()),
			S_LOOP	: (sleep())
		},
	"11:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_003"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
	"14:00:00": #am feuer im kreis sitzen
		{	
			S_START	: (goto([713.87,342.73]),
					turn_to_object("BUILDING_2945"),
					sit_down_on_ground()),
			S_LOOP	: (sit_on_ground())
		},
	"17:00:00": #diskussion in 2er oder 3er gruppen
		{	
			S_START	: (goto(703.87,340.52),
					turn_to_nearest_neighbour(["ANTONIO","CODY"])),
			S_LOOP	: (conversate())
		},
	"20:00:00": #e+t
		{	
			S_START	: (goto_dummy("BUILDING_2148","dmyp_003"),
					sit_down_on_bench()),
			S_LOOP	: (sit_eat_drink_on_bench)
		},
},{
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [global_schedules.wait()],
	}
}),


# nomaden
################################################
"PIT" : {
	"23:00:00" : {#schlafen
		S_START  : (goto(557.32,286.43),
				enter_building("BUILDING_1843"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},
	"05:00:00" : {#kochen
		S_DIALOG : 'NPC_PIT_T_001',
		S_START  : (leave_building("BUILDING_1843"),
				goto_dummy("BUILDING_1882","dmyp_001"),
				sit_down_to_cook()),
		S_LOOP	 : (cook()),
	},	
	"06:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_PIT_T_002',
		S_START  : (goto_dummy("BUILDING_5782","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"07:00:00" : {#holz hacken
		S_DIALOG : 'NPC_PIT_T_003',
		S_START  : (goto_dummy("BUILDING_5794","dmyp_001"),
				start_chop_wood()),
		S_LOOP	 : (chop_wood()),
	},	
	"12:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_PIT_T_004',
		S_START  : (goto_dummy("BUILDING_5782","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"14:00:00" : {#holz hacken
		S_DIALOG : 'NPC_PIT_T_005',
		S_START  : (goto_dummy("BUILDING_5794","dmyp_001"),
				start_chop_wood()),
		S_LOOP	 : (chop_wood()),
	},	
	"19:00:00" : {#konversation (chris, jasmin)
		S_DIALOG : 'NPC_PIT_T_006',
		S_START  : (goto(545.0, 276.0),
				turn_to_object("CHRIS")),
		S_LOOP	 : (conversate(["CHRIS","JASMIN"])),
	},
	S_SECONDDIALOG   : 'NPC_PIT_T_007'
},


"PENNY" : {
	"00:00:00" : {#schlafen
		S_START  : (goto(557.19,284.89),
				enter_building("BUILDING_1843"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},
	"06:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_PENNY_T_001',
		S_START  : (leave_building("BUILDING_1843"),
				goto_dummy("BUILDING_5782","dmyp_002"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"07:00:00" : {#tiere füttern
		S_DIALOG : 'NPC_PENNY_T_002',
		S_START  : (goto(549.72,351.60),
				lambda char:object.move_to_object(char, random.choice(["KUH_3","KUH_4","KUH_5"])),
				lambda char:object.turn_to_object(char, random.choice(["KUH_3","KUH_4","KUH_5"])),
				start_feed_animal()),
		S_LOOP	 : (feed_animal()),
	},	
	"11:00:00" : {#kochen
		S_DIALOG : 'NPC_PENNY_T_003',
		S_START  : (goto_dummy("BUILDING_1882","dmyp_002"),
				sit_down_to_cook()),
		S_LOOP	 : (cook()),
	},	
	"12:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_PENNY_T_004',
		S_START  : (goto_dummy("BUILDING_5782","dmyp_002"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"14:00:00" : {#tiere füttern
		S_DIALOG : 'NPC_PENNY_T_005',
		S_START  : (goto(549.72,351.60),
				lambda char:object.move_to_object(char, random.choice(["KUH_3","KUH_4","KUH_5"])),
				lambda char:object.turn_to_object(char, random.choice(["KUH_3","KUH_4","KUH_5"])),
				start_feed_animal()),
		S_LOOP	 : (feed_animal()),
	},	
	"19:00:00" : {#boden sitzen
		S_DIALOG : 'NPC_PENNY_T_006',
		S_START  : (goto(542.3,276.9),
				turn_to_object("CHRIS"),
				sit_down_on_ground()),
		S_LOOP	 : (sit_on_ground()),
	},
	S_SECONDDIALOG   : 'NPC_PENNY_T_007'
},

"CHRIS" : {
	"23:00:00" : {#schlafen
		S_START  : (goto(535.56,273.76),
				enter_building("BUILDING_1854"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},
	"06:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_CHRIS_T_001',
		S_START  : (leave_building("BUILDING_1854"),
				goto_dummy("BUILDING_5782","dmyp_003"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"07:00:00" : {#loch graben
		S_DIALOG : 'NPC_CHRIS_T_002',
		S_START  : (goto_dummy("BUILDING_5793","dmyp_001"),
				start_dig_hole()),
		S_LOOP	 : (dig_hole()),
	},	
	"12:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_CHRIS_T_003',
		S_START  : (goto_dummy("BUILDING_5782","dmyp_003"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"14:00:00" : {#motorrad reparieren
		S_DIALOG : 'NPC_CHRIS_T_004',
		S_START  : (goto(552.13,288.39),
				start_repair_motorbike("BUILDING_6208")),
		S_LOOP	 : (repair_motorbike()),
	},	
	"17:00:00" : {#stehen pit beobachten
		S_DIALOG : 'NPC_CHRIS_T_005',
		S_START  : (goto(555.0,245.0),
				turn_to_object("PIT")),
		S_LOOP	 : (stand()),
	},	
	"19:00:00" : {#konversation (pit, jasmin)
		S_DIALOG : 'NPC_CHRIS_T_006',
		S_START  : (goto(547.0,276.0),
				turn_to_object("CHRIS")),
		S_LOOP	 : (conversate(["JASMIN","PIT"])),
	},
	S_SECONDDIALOG   : 'NPC_CHRIS_T_007'
},

"JASMIN" : {
	"23:00:00" : {#schlafen
		S_START  : (goto(535.94,290.58),
				enter_building("BUILDING_1856"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},
	"06:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_JASMIN_T_001',
		S_START  : (leave_building("BUILDING_1856"),
				goto_dummy("BUILDING_5780","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"08:00:00" : {#wagen reparieren
		S_DIALOG : 'NPC_JASMIN_T_002',
		S_START  : (goto_dummy("BUILDING_5792","dmyp_001"),
				start_repair_car()),
		S_LOOP	 : (repair_car()),
	},	
	"12:00:00" : {#loch graben
		S_DIALOG : 'NPC_JASMIN_T_003',
		S_START  : (goto_dummy("BUILDING_5793","dmyp_001"),
				start_dig_hole()),
		S_LOOP	 : (dig_hole()),
	},	
	"13:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_JASMIN_T_004',
		S_START  : (goto_dummy("BUILDING_5780","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"16:00:00" : {#flöte spielen
		S_START  : (goto_dummy("BUILDING_5780","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (play_fluit_on_bench()),
	},	
	"19:00:00" : {#konversation (pit, chris)
		S_DIALOG : 'NPC_JASMIN_T_005',
		S_START  : (goto(546.13,274.71),
				turn_to_object("CHRIS")),
		S_LOOP	 : (conversate(["CHRIS","PIT"])),
	},
	S_SECONDDIALOG   : 'NPC_JASMIN_T_006'
},

"CARL" : {
	"02:00:00" : {#beim feuer am boden sitzen
		S_START  : (goto(561.61,312.13),
				turn_to_object("BUILDING_1881"),
				sit_down_on_ground()),
		S_LOOP	 : (sit_on_ground()),
	},
	"04:30:00" : {#liegen
		S_DIALOG : 'NPC_CARL_T_001',
		S_START  : (goto(560.30,315.97),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},	
	"06:00:00" : {#schlafen
		S_DIALOG : 'NPC_CARL_T_002',
		S_START  : (goto(561.52,304.21),
				enter_building("BUILDING_1846"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},	
	"12:00:00" : {#boden sitzen
		S_DIALOG : 'NPC_CARL_T_003',
		S_START  : (leave_building("BUILDING_1846"),
				goto(568.81,302.66),
				sit_down_on_ground()),
		S_LOOP	 : (sit_on_ground()),
	},	
	"15:00:00" : {#auf bank sitzen
		S_DIALOG : 'NPC_CARL_T_004',
		S_START  : (goto_dummy("BUILDING_5780","dmyp_002"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench()),
	},	
	"21:30:00" : {#essen + trinken
		S_DIALOG : 'NPC_CARL_T_005',
		S_START  : (goto_dummy("BUILDING_5780","dmyp_002"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"23:00:00" : {#am feuer stehen
		S_DIALOG : 'NPC_CARL_T_006',
		S_START  : (goto(570.67,314.80),
				turn_to_object("BUILDING_1881")),
		S_LOOP	 : (stand()),
	},
	S_SECONDDIALOG   : 'NPC_CARL_T_007'
},

"LAYLA" : {
	"01:00:00" : {#schlafen
		S_START  : (goto(562.27,302.88),
				enter_building("BUILDING_1846"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},
	"07:00:00" : {#kochen
		S_DIALOG : 'NPC_LAYLA_T_001',
		S_START  : (leave_building("BUILDING_1846"),
				goto_dummy("BUILDING_1881","dmyp_003"),
				sit_down_to_cook()),
		S_LOOP	 : (cook()),
	},	
	"09:00:00" : {#stehen warten
		S_DIALOG : 'NPC_LAYLA_T_002',
		S_START  : (goto(538.67,323.44),
				turn_to_object("BUILDING_1881")),
		S_LOOP	 : (stand()),
	},	
	"13:00:00" : {#kochen
		S_DIALOG : 'NPC_LAYLA_T_003',
		S_START  : (goto_dummy("BUILDING_1881","dmyp_003"),
				sit_down_to_cook()),
		S_LOOP	 : (cook()),
	},	
	"14:00:00" : {#stehen warten
		S_DIALOG : 'NPC_LAYLA_T_004',
		S_START  : (goto(556.10,321.64),
				turn_to_object("BUILDING_1881")),
		S_LOOP	 : (stand()),
	},	
	"18:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_LAYLA_T_005',
		S_START  : (goto_dummy("BUILDING_5780","dmyp_003"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["sit","drink","eat"])),
	},	
	"21:00:00" : {#auf bank sitzen
		S_DIALOG : 'NPC_LAYLA_T_006',
		S_START  : (goto_dummy("BUILDING_5780","dmyp_003"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench()),
	},
	S_SECONDDIALOG   : 'NPC_LAYLA_T_007'
},

"T_LETH" : {
	"22:00:00" : {#schlafen
		S_START  : (goto(535.47,299.37),
				enter_building("BUILDING_1855"),
				lay_down_to_sleep()),
		S_LOOP	 : (sleep()),
	},
	"05:00:00" : {#jagen
		S_DIALOG : 'NPC_T_LETH_T_001',
		S_START  : (leave_building("BUILDING_1855"),
				goto(602.0,294.0),
				lambda char:object.turn_to_object(char, random.choice(["HYAENE_1","HYAENE_2","HYAENE_3"])),
				start_hunt()),
		S_LOOP	 : (hunt()),
	},	
	"08:00:00" : {#stehen warten
		S_DIALOG : 'NPC_T_LETH_T_002',
		S_START  : (end_hunt(),
				goto(549.0, 257.0),
				turn_to_direction(globals.DIR_NORTH)),
		S_LOOP	 : (stand()),
	},	
	"11:00:00" : {#essen + trinken
		S_DIALOG : 'NPC_T_LETH_T_003',
		S_START  : (goto_dummy("BUILDING_5783","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (sit_on_bench(["eat","sit","drink"])),
	},	
	"13:00:00" : {#gitarre spielen
		S_DIALOG : 'NPC_T_LETH_T_004',
		S_START  : (goto_dummy("BUILDING_5783","dmyp_001"),
				sit_down_on_bench()),
		S_LOOP	 : (play_guitar_on_bench()),
	},	
	"15:00:00" : {#kochen
		S_DIALOG : 'NPC_T_LETH_T_005',
		S_START  : (goto_dummy("BUILDING_1880","dmyp_004"),
				sit_down_to_cook()),
		S_LOOP	 : (cook()),
	},	
	"19:00:00" : {#waffe reinigen
		S_DIALOG : 'NPC_T_LETH_T_006',
		S_START  : (goto(539.82,305.35),
				turn_to_direction(globals.DIR_EAST),
				start_clean_weapon()),
		S_LOOP	 : (clean_weapon()),
	},
	S_SECONDDIALOG   : 'NPC_T_LETH_T_007'
},

"HADLEY" : {
	"23:25:00" : {#schlafen
		S_START : (enter_building("BUILDING_17194"),
					lay_down_to_sleep(bed="BUILDING_44211")),
		S_LOOP  : (sleep()),
	},
	"05:47:00" : {#liegestütze machen
		S_START : (leave_building("BUILDING_17194"),
					goto(683.88, 527.37),
					turn_to_direction(globals.DIR_SOUTH)),
		S_LOOP  : (make_push_up()),
	},
	"07:00:00" : {#frühstücken
		S_START : (goto(675.53,557.5),
					turn_to_direction(globals.DIR_NORTH_EAST),
					sit_down_on_ground()),
		S_LOOP  : (sit_on_ground(["eat","drink","sit"])),
	},
	"07:00:00" : {#mit horatio reden
		S_START : (goto(704.4, 531.6)),
		S_LOOP  : (conversate("HORATIO")),
	},
},
"HUGO" : {
	"22:50:00" : {#schlafen
		S_START : (enter_building("BUILDING_17194"),
					lay_down_to_sleep(bed="BUILDING_44212")),
		S_LOOP  : (sleep()),
	},
	"04:30:00" : {#essen und trinken
		S_START : (goto_dummy("BUILDING_44236", "dmyp_001"),
					sit_down_on_bench()),
		S_LOOP  : (sit_on_bench(["eat","drink","sit"])),
	},
	"08:45:00" : {#auto reparieren
		S_START : (leave_building("BUILDING_17194"),
					goto(690.0,526.8),
					stepto(691.68,525.88),
					start_repair_car()),
		S_LOOP  : (repair_car()),
	},
	"08:45:00" : {#draussen stehen warten
		S_START : (goto(712.18,542.3),
					turn_to_direction(globals.DIR_WEST)),
		S_LOOP  : (global_schedules.wait()),
	},
},
"HENRIETTA" : {
	"01:20:00" : {#schlafen
		S_START : (enter_building("BUILDING_17194"),
					lay_down_to_sleep(bed="BUILDING_44207")),
		S_LOOP  : (sleep()),
	},
	"07:15:00" : {#essen und trinken
		S_START : (goto_dummy("BUILDING_44290", "dmyp_001"),
					sit_down_on_bench()),
		S_LOOP  : (sit_on_bench(["eat","drink","sit"])),
	},
	"07:15:00" : {#am autopsietisch stehen
		S_START : (goto(716.96,532.02,grid="ZONE_6_BUILDING_17194_INTERIOR_GRID3"),
					turn_to_object("BUILDING_44228")),
		S_LOOP  : (pick_pocket()),
	},
	"15:32:00" : {#bank sitzen buch lesen
		S_START : (goto_dummy("BUILDING_44213", "dmyp_001"),
					sit_down_on_bench()),
		S_LOOP  : (read_book_on_bench()),
	},
},
## konvoi der schatten
data().SCHATTEN_KONVOI_NPCS[0] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : [patrol(points=const.SCHATTEN_WEST_PATROLS[0], speed=MT_SLOW)],
	}
},
data().SCHATTEN_KONVOI_NPCS[1] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : [patrol(points=const.SCHATTEN_WEST_PATROLS[1], speed=MT_SLOW)],
	}
},
data().SCHATTEN_KONVOI_NPCS[2] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : [stand()],
	}
},
data().SCHATTEN_KONVOI_NPCS[3] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : [patrol(points=const.SCHATTEN_WEST_PATROLS[0], speed=MT_SLOW)],
	}
},
data().SCHATTEN_KONVOI_NPCS[4] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : [stand()],
	}
},
data().SCHATTEN_KONVOI_NPCS[5] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : [patrol(points=const.SCHATTEN_WEST_PATROLS[1], speed=MT_SLOW)],
	}
},
data().SCHATTEN_KONVOI_NPCS[6] : {
	S_CONDITION : lambda : data().convoy_secures_western_camp,
	"00:00:00" : {
		S_START : (goto(287.41, 628.60, speed=MT_FAST),
					turn_to_direction(135)),
		S_LOOP  : [stand()],
	}
},}
	# update with global schedules
	schedules.update(global_schedules.update_schedules(schedules))
	
#	print schedules.keys()
### wrapper functions, do not modify!
def Activity(id):
	return npc_activity(id, schedules)
	
def GetCurrentPlan(id):
	return npc_get_current_plan(id, schedules)
	
def Dialog(id, partymemberid):
	return npc_dialog(id, partymemberid, schedules)


"""
## konvoi der schatten
data().SCHATTEN_KONVOI_NPCS[0] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW),
			convoy_move_finished()),
	}
},
data().SCHATTEN_KONVOI_NPCS[1] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW)),
	}
},
data().SCHATTEN_KONVOI_NPCS[2] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW)),
	}
},
data().SCHATTEN_KONVOI_NPCS[3] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW)),
	}
},
data().SCHATTEN_KONVOI_NPCS[4] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW)),
	}
},
data().SCHATTEN_KONVOI_NPCS[5] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW)),
	}
},
data().SCHATTEN_KONVOI_NPCS[6] : {
	S_CONDITION : lambda : data().konvoi_startet,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(points=const.WAYPOINTS_CONVOY, speed=MT_SLOW)),
	}
},"""



