# -*- coding: utf-8 -*-
from globals import *
import zonetext
import npc
import dialogs
import water
import const
from const import *
import object_events
import schedules
from dynamic_camera import *
import comments
import char_autogeneration
import system_events
from npc_activities import *
import cs_function as cs
import system

#*** aktuelle revison: Revision 53, 28.09.2004 *********************************

# äöü (better)
def animate_flag(obj=None):
    object.play_animation(obj, "ANIM_FAHNENMAST_1", callback=['ONEND', animate_flag])

def initParties():
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="NPCS",type=PT_COMPUTER)
    system.create_party(id="ANIMALS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
    if not hasattr(data(),"zone_6_already_entered"):
        data().zone_6_already_entered = True
        start_locations = {"NORTH":(365.6, 199.7),"SOUTH":(365.6, 199.7),\
                            "WEST":(365.6, 199.7), "EAST":(365.6, 199.7),}
    else:
        start_locations = {"NORTH":(365.6, 199.7),"SOUTH":(207.8, 780.0),\
                            "WEST":(205.3, 385.1), "EAST":(797.4, 603.7),}
        if  hasattr(data('zzone_5.zzone_5'), 'Player_got_plant') and\
            hasattr(data('zzone_5.zzone_5'), 'Player_got_book'):
            if  data('zzone_5.zzone_5').Player_got_plant == 1 and\
                data('zzone_5.zzone_5').Player_got_book == 0:
                start_locations = {"NORTH":(365.6, 199.7),"SOUTH":(207.8, 780.0),\
                                    "WEST":(699.0, 539.0), "EAST":(699.0, 539.0),}

    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
    skies.init_sky_preset("redrock")

def on_post_load():
    initFX()
    schedules.init_schedules()
    init_patch()

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
        system.add_region("Nomandenlager",525,330,580,235)
        system.add_region("Lager_der_Kindergang",730,320,680,365)
        system.add_region("Copper_Hill",780,775,570,980)
        system.add_region("Medizinisches_Lager",715,495,540,444)
        system.add_region("Schattenlager",349,630,240,525)
        system.add_region("Bills_Haus",410,410,385,435)
        system.add_region("Lager_des_Schamanen",305,345,285,370)
        system.add_region("Fluechtlingslager",545,925,440,785)
        system.add_region("Haus_der_Ganoven",255,750,294,710)

    data("rest").non_rest_areas.append("Nomandenlager")
    data("rest").non_rest_areas.append("Lager_der_Kindergang")
    data("rest").non_rest_areas.append("Copper_Hill")
    data("rest").non_rest_areas.append("Medizinisches_Lager")
    data("rest").non_rest_areas.append("Schattenlager")
    data("rest").non_rest_areas.append("Bills_Haus")
    data("rest").non_rest_areas.append("Lager_des_Schamanen")
    data("rest").non_rest_areas.append("Fluechtlingslager")
    data("rest").non_rest_areas.append("Haus_der_Ganoven")

#minenfelder
    """
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA1A")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA1B")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA1C")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA1D")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA1E")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA1F")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA2A")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA2B")
    data("rest").non_rest_areas.append("REGION_MINEFIELDALEXA2C")
    """
    data("rest").non_rest_areas.append("REGION_MINEFIELDCOPPERHILL")

def on_map_loaded():
    init_data()
    initParties()
#place player characters
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
# ae- and party-creation modifier | see debug_py.py for info on parameters
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
    npc.initNPCs()
    npc.initAnimals()
    char_autogeneration.init_Mercenary('MERCENARY_DEBORAH')
    initHerbs()
    initRegions()
    initExitZones()
    initItems()
    initObjects()
    initEquipment()
    initFX()
    initQuestbook()
    init_character_states()
    init_scriptuse_objects()
    InitChestsSafes()
    initVehicles()
    initWaterResources()
    init_convoy_childgang()
    checkZoneDependencies()
    system.notify_timer(data().Timer_WildPferdFluchtChecker,data().Timervalue_WildPferdFluchtChecker)
    schedules.init_schedules() ## immer nach dem initQuestbook()
    dialogs.initUeberfallenerTransporter(INACTIVE)
    anim_windrad_1()
    anim_windrad_2()
    init_non_rest_areas()

def anim_windrad_2(objectid=None):
    object.play_animation('BUILDING_34065','ANIM_WINDRAD',callback=['ONEND',anim_windrad_2])
    if not hasattr(data(),"windradsound2"):
        data().windradsound2=True
        sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_5665', loop=True)

def anim_windrad_1(objectid=None):
    object.play_animation('BUILDING_5665','ANIM_WINDRAD',callback=['ONEND',anim_windrad_1])
    if not hasattr(data(),"windradsound1"):
        data().windradsound1=True
        sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_5665', loop=True)

def windrad_sound():
    if not hasattr(data(),"windradsound1"):
        data().windradsound=True
        sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_5665', loop=True)

    if not hasattr(data(),"windradsound1"):
        data().windradsound=True
        sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_34065', loop=True)

def checkZoneDependencies():
    if was_zone_entered("zzone_5.zzone_5"):
        if data("zzone_5.zzone_5").SpokeToMarcus_bakerlist == 1:
            data().zz5_markus_toxikologiebuch = True

    if was_zone_entered("zzone_4.zzone_4"):
        data().zzone_4_betreten = True
        if not data().abraham_quest_angenommen:
            data().owen_quest_verpasst = True
            object.set_active_state("ABRAHAM",INACTIVE)
            object.set_active_state("SUE_Z7",INACTIVE)
            object.set_active_state("FJODR",INACTIVE)
            object.set_active_state("MICKEY",INACTIVE)

#markiert alle items, die im script manipuliert werden sollen
def init_scriptuse_objects():

#tresore, kisten, truhen
    system.mark_for_script_use("BUILDING_70721")
    system.mark_for_script_use("BUILDING_70733")
    system.mark_for_script_use("BUILDING_70827")
    system.mark_for_script_use("BUILDING_70828")
    system.mark_for_script_use("BUILDING_70913")
    system.mark_for_script_use("BUILDING_70914")
    system.mark_for_script_use("BUILDING_70915")
    system.mark_for_script_use("BUILDING_70916")
    system.mark_for_script_use("BUILDING_70930")
    system.mark_for_script_use("BUILDING_70937")
    system.mark_for_script_use("BUILDING_70964")
    system.mark_for_script_use("BUILDING_70970")
    system.mark_for_script_use("BUILDING_54817")

# Bienenstöcke Zone 6
    system.mark_for_script_use('BUILDING_71030')
    system.mark_for_script_use('BUILDING_71032')
    system.mark_for_script_use('BUILDING_71031')
    system.mark_for_script_use('BUILDING_71039')
    system.mark_for_script_use('BUILDING_71037')
    system.mark_for_script_use('BUILDING_71040')
    system.mark_for_script_use('BUILDING_71038')

#sonstiges
    system.mark_for_script_use("BUILDING_2941")
    system.mark_for_script_use('BUILDING_2942')
    system.mark_for_script_use(const.OBJ_WAESCHELEINE_CALEB)

# motorrad george
    system.mark_for_script_use("BUILDING_6209")
# windrad ch
    system.mark_for_script_use("BUILDING_5665")
#generator ch
    system.mark_for_script_use(const.OBJ_GENERATOR_CH)
    system.mark_for_script_use(const.OBJ_GENERATOR_ALT)
#ernteroboter
    system.mark_for_script_use(const.OBJ_ERNTEROBOTER)

#lagerfeuer markieren
    lagerfeuer = const.OBJ_LAGERFEUER_CAMP + const.OBJ_LAGERFEUER_NOMADEN + const.OBJ_LAGERFEUER_CH
    for lf in lagerfeuer:
        system.mark_for_script_use(lf)

#lagerfeuer in der west-schatten-stadt
    system.mark_for_script_use("BUILDING_30402")
    system.mark_for_script_use("BUILDING_30400")

def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    checkZoneDependencies()
    init_non_rest_areas()
    schedules.init_schedules()
    init_patch()

## Callback für Ansprechen von NPCs
def on_approach(target,operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)

def initWaterResources():
    water.set_water_source(560.1,893.7, 4)
    water.set_water_source(695.4,680.7, 3)
    water.set_water_source(723.1,350.0, 2)
    water.set_water_source(530.6,259.4, 3)
    water.set_water_source(747.1,935.8, 2)

def initDlg_SpielerZumLagerFuehren(id):
    object.turn_to_object(id,"CALEB")
    data().MitCalebGesprochen = 1
    dialogs.initCutscene_001_CalebGeleitetSpielerZuNomaden()

# regions callback
def on_enter_region(id, objectid, partyid):
#    print 'on_enter_region(', id, objectid, partyid ,')'
# non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid): objectid=objectid[0]
        else: return

    if id == data().Region_CalebVersteck or id == "MEINE":
            if not data().CalebEntdeckt and system.get_qb_entry_state(data().QB_002) == COMPLETE:
                dialogs.on_dialog_008_init_caleb()
                if not data().player_knows_Versteck_Caleb:
                    data().player_knows_Versteck_Caleb = True
                    system.add_minimap_marker(732.12, 227.75,"MM_003")# Versteck von Caleb

            if not data().hoehleneingang_gesehen:
                data().hoehleneingang_gesehen = True
                object.cancel_commandos("ALTER_EGO")
                object.turn_to_object("ALTER_EGO", "ZONE_6_BUILDING_6200", callback=["ONEND", Lambda('dialogs.initDlg_080_SpielerFindetHoehleneingang()')])

    if id == "Nomandenlager":
        if data().joshua_gesprochen:
            dialogs.initDlg_157_VerschwundeneNomanden_Kennengelernt()
        else:
            dialogs.initDlg_156_VerschwundeneNomanden_NichtKennengelernt()

    if id == "NOMADEN_LAGER":
        if not data().player_knows_Nomadencamp:
            data().player_knows_Nomadencamp = True
            system.add_minimap_marker(546.63, 293.27,"MM_001")# Nomadencamp

#general der schatten wird entdeckt
    if id == data().Region_GeneralDerSchatten:
        if data().MitGeneralGesprochen == 0:
            data().MitGeneralGesprochen += 1
            for id in data().GENERALTEAM_NPCS:
                if not object.is_destroyed(id):
                    object.cancel_commandos(id)
                    object.turn_to_object(id,"ALTER_EGO")
            if not object.is_destroyed("GENERAL_OF_THE_SHADOWS"):
                object.cancel_commandos("GENERAL_OF_THE_SHADOWS")
                object.turn_to_object("ALTER_EGO","GENERAL_OF_THE_SHADOWS")
                dialogs.initDlg_010_General_SpottInit("GENERAL_OF_THE_SHADOWS")

# Spieler betritt irgendein Minenfeld
    """
    if (id in [data().Minefield_Alexa1a, data().Minefield_Alexa1b,
                data().Minefield_Alexa1c,data().Minefield_Alexa1d,
                data().Minefield_Alexa1e,data().Minefield_Alexa1f,
                data().Minefield_Alexa2a,data().Minefield_Alexa2b,
                data().Minefield_Alexa2c,
    """
    if id == data().Minefield_CopperHill:
        pcs = system.get_pcs()
        animMinenExplosion(objectid)
        object.destroy(objectid)
        if objectid in pcs:
            for pc in system.get_pcs():
                if not object.is_destroyed(pc):
                    object.cancel_commandos(pc)
                    object.turn_to_object(pc, objectid)
        system.notify_region_entered(region=id, partyid="UISPIELER")

# spieler betritt region um copperhill
    if id in ["REGION_COPPERHILL_1","REGION_COPPERHILL_2"]:
        if not data().copperhill_betreten[0] and not data().copperhill_betreten[1]:
            system.notify_region_entered(data().Region_GeneralDerSchatten, partyid="UISPIELER")
            for pc in system.get_pcs():
                object.cancel_commandos(pc)
            if not data().schatten_ch_ext_deaktiviert:
                if not data().copperhillkommentar[0]:
                    data().copperhillkommentar[0] = True
                    dialogs.initCutscene_139_SpielerHatAngstVorUebermacht()
            else:
                if not data().copperhillkommentar[1]:
                    data().copperhillkommentar[1] = True
                    dialogs.initCutscene_140_SpielerFreutSichUeberAbgezogeneSchatten()
            if id == "REGION_COPPERHILL_1":
                data().copperhill_betreten[0] = True
            else:
                data().copperhill_betreten[1] = True
        if not data().player_knows_Copper_Hill:
            data().player_knows_Copper_Hill = True
            system.add_minimap_marker(694.62, 892.26,"MM_009")# Copper Hill

# spieler betritt region ums Medizinische Lager
    if (id == "REGION_HORATIO"):
        if not data().player_knows_Medizinisches_Lager:
            data().player_knows_Medizinisches_Lager = True
            system.add_minimap_marker(701.79, 538.11,"MM_011")# Medizinisches Lager
        dialogs.initCutscene_090_HoratioUndSeineFreundeSindFluechtlinge()

# spieler betritt region ums Schattenlager
    if id == "REGION_SCHATTENLAGER":
        if not data().player_knows_Schattenlager:
            data().player_knows_Schattenlager = True
            system.add_minimap_marker(310.39, 583.41,"MM_004")# Schattenlager

# spieler betritt region um Bills Haus
    if id == "BILLS_HAUS":
        if not data().player_knows_Bills_Haus:
            data().player_knows_Bills_Haus = True
            system.add_minimap_marker(394.42, 425.85,"MM_008")# Bills Haus

# spieler betritt region um den Bahnhof
    if id == "BAHNHOF":
        if not data().player_knows_Bahnhof:
            data().player_knows_Bahnhof = True
            system.add_minimap_marker(610.72, 625.71,"MM_005")# Bahnhof

# spieler betritt region um die Radarstation
    if id == "RADARSTATION":
        if not data().player_knows_Radarstation:
            data().player_knows_Radarstation = True
            system.add_minimap_marker(333.17, 905.03,"MM_007")# Radarstation

# spieler betritt region der Wildpferde
    if id == "WILDPFERDE":
        if not data().player_knows_Wildpferde:
            data().player_knows_Wildpferde = True
            system.add_minimap_marker(214.44, 441.89,"MM_013")# Wildpferde

    if (id==data().Region_GaunerReturnWhiskey and
    objectid in ["DICK","DONALD_Z6","COLIN_Z6"]):
        data().GaunerReturnWhiskey = True

# Spieler verlässt Startpunkt, Caleb führt ihn zu Joshua
    if ((id==data().Region_UmStartpunkt1 or
        id==data().Region_UmStartpunkt2) and
        (system.get_qb_entry_state(data().QB_001) == UNCOMPLETE and
        data().MitCalebGesprochen == 0)):
        system.start_cutscene()
        system.set_camera_view(const.CAM_CALEB_INTRO)
        for id in system.get_pcs():
            object.cancel_commandos(id)
        data().MitCalebGesprochen = 1
        character.play_animation("CALEB","CM_NPC_SITZEN_BODEN_AUFSTEHEN", callback=["ONEND", onCalebLiftUpPlayerMove])
        object.move_to("CALEB",366.0,206.6, "landscape")
        object.turn_to_object("CALEB","ALTER_EGO", callback=["ONEND", initDlg_SpielerZumLagerFuehren])
        i = 0
        for id in system.get_pcs():
            if id != "ALTER_EGO":
                object.move_to(id, const.PC_POS_INTRO[i][0],const.PC_POS_INTRO[i][1])
                i += 1
                object.turn_to_object(id, "CALEB")

# Spieler kommt 20m an die Gauner heran
    if (id==data().Region_GaunerLager20m):
        if (system.get_qb_entry_state(data().QB_012) == UNCOMPLETE or system.get_qb_entry_state(data().QB_017) == UNCOMPLETE or data().SpielerMachtWasErWill):
            if (data().MitGaunernGesprochen == 0 and not data().gauner_gesehen_quest): 
                object.turn_to_object("ALTER_EGO","COLIN_Z6")
                data().MitGaunernGesprochen = 1
                data().gauner_gesehen_quest = True
                dialogs.initDlg_055_Gauner_SindDicht(objectid)
        elif not data().gauner_gesehen:
            if system.get_qb_entry_state(data().QB_012) == INACTIVE:
                dialogs.initDlg_076_SpielerStoesstAufBetrunkene(objectid)
                data().gauner_gesehen = True

# Spieler betritt das Lager der Kindergang
    if (id==data().Region_QuartierDerKinderGang and    data().MitAlexaGesprochen == 0):
        mini_map_KinderGang# display KinderGang's camp on the mini-map
        initKindergangScene(objectid)

# Spieler kommt in die Nähe des Überfallenen Transporters
    if (id==data().Region_UeberfallenerTransport):
        if (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE):
            data().RatskullsHabenSpielerEntdeckt = True
            mini_map_RatSkullConvoy()# display convoy captured by RatSkulls on the mini-map

def mini_map_KinderGang():# display KinderGang's camp on the mini-map
    if not data().player_knows_Lager_Kindergang:
        data().player_knows_Lager_Kindergang = True
        system.add_minimap_marker(705.50, 332.16,"MM_002")# Lager der Kindergang

def mini_map_RatSkullConvoy():# display convoy captured by RatSkulls on the mini-map
    if not data().player_knows_Ueberfallener_Transporter:
        data().player_knows_Ueberfallener_Transporter = True
        system.add_minimap_marker(323.12, 804.09,"MM_010")# Überfallener Transporter

## caleb hat den spieler entdeckt
def onCalebLiftUpPlayerMove(id):
        object.move_to("ALTER_EGO",365.2,204.8,"landscape")
        object.turn_to_object("ALTER_EGO","CALEB")

## Spieler betritt Kinderganglager: 4 mögliche Regionen mit 4 verschiedenen Camviews
def initKindergangScene(objectid):
    object.cancel_commandos("ALTER_EGO")
    if objectid != "ALTER_EGO":
        pos = object.get_position(objectid)
        object.set_position("ALTER_EGO", pos[0]-1,pos[1]-1)

    ae_pos        = [703.56, 330.61]
    alexa_pos    = [705.0, 332.5]

# Spieler wird von Kindern umstellt
    set_players()
    system.start_cutscene()
    system.set_camera_view(const.CAM_KINDERGANG)
    pcs = system.get_pcs()
    mpcs = []
    for id in pcs:
        if object.get_distance(id, "ALTER_EGO") <= 15.0:
            mpcs.append(id)
            object.move_to_object(id, "ALTER_EGO")
            object.turn_to_object(id, "ALTER_EGO")

    if len(mpcs):
        for newid in const.KINDERGANG_NPCS:
            prohibit_activity(newid)
            character.arm_direct(newid)
            children_surrender_party(newid, pos_ae=ae_pos, pos_alexa=alexa_pos)

## Minenexplosionseffekt
def animMinenExplosion(id):
    system.start_effect(    startx=object.get_x(id),
                            starty=object.get_y(id),
                            startz=0,
                            dirx=object.get_x(id),
                            diry=object.get_y(id),
                            dirz=0,
                            parameter=fx_explosion_medium)
    sounds.play_3d_sound( sfx_id="landmine_explo",
                            x=object.get_x(id),
                            y=object.get_y(id),
                            z=0)

#######################################################################################################
# onUse / onExchange- Benutzungs Callback
#######################################################################################################
## Austauschen, nur für NPCs
def can_exchange( character_id, target_id, item_id, item_type ):
    if target_id in system.get_pcs():
        return True

    if ((item_id in [data().obj_BurbonWhiskey,data().obj_SingleMaltWhiskey,data().obj_ScotchWhiskey] 
        or item_type == "SET_WHISKEY_BARREL")
        and target_id == "MANNY"
        and not data().MannyHatWhiskeyWieder):
            return True
    if item_type == "SET_DISPOSABLE_SYRINGE":
        if character_id == "ALTER_EGO":
            if (target_id == "ADIAN" and data().einwegspritzen_fuer_adian):
                return True
        return False
    return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
    if target_id in system.get_pcs():
        return True
# Spieler gibt Manny den Whiskey wieder:
    if ((item_id in [data().obj_BurbonWhiskey,data().obj_SingleMaltWhiskey,data().obj_ScotchWhiskey] 
        or item_type == "SET_WHISKEY_BARREL")
        and target_id == "MANNY"
        and not data().MannyHatWhiskeyWieder):
        if data().SpielerMachtWasErWill:
            character.set_approachable_state("MANNY",APPROACHABLE)
        object.turn_to_object("MANNY","ALTER_EGO")
        data().WhiskeyFassCounter += 1
        if data().WhiskeyFassCounter == 3:
            data().MannyHatWhiskeyWieder = True
            dialogs.initDlg_023_Manny_SpielerHatWhiskey()
        return True

    if item_type == "SET_DISPOSABLE_SYRINGE":
        if character_id == "ALTER_EGO":
            if (target_id == "ADIAN" and data().einwegspritzen_fuer_adian):
                dialogs.initDlg_075_SpielerHatEinwegspritzenBesorgt()
                return True
        return False

    return object_events.on_exchange( character_id, target_id, item_id, item_type )

## Benutzen, Gegenstände / Objekte
def can_use( character_id, object_id ):
    if object_id == None: object_id = ""

    if object_id in const.OBJ_CONVOY_CARS:
        return True

    if object_id in const.OBJ_WILDPFERDE:
        if character_id not in system.get_pcs():return False
        if not data().spieler_hat_wildpferd and not data().wildpferd_folgt_spieler:
            if system.get_qb_entry_state(data().QB_015) == UNCOMPLETE:
                if object.has_attribute(character_id, "survival_talents"):
                    talents = object.get_attribute(character_id, "survival_talents")
                    if "control_animals" in talents:
                        return True
                if object.has_attribute(character_id, "survival"):
                    if object.get_attribute(character_id, "survival") > 60:
                        return True
        return False

    if character_id == "ALTER_EGO":
        if object_id.endswith(const.OBJ_GENERATOR_CH):
            return True
        if object_id == "Z6 GERDAS_APPLE":
            return True
        if object_id in ["SET_APPLE","SET_VALIUM"]:
            return True
    return object_events.can_use( character_id, object_id )

def pre_use( character_id, object_id, item_id, item_type ):
    if object_id != None:
        if object_id.endswith(const.OBJ_GENERATOR_CH):
            object.set_attribute(object_id, "on_use_coordinates", [725.6, 844.5, 0])

def on_use( character_id, object_id, item_id, item_type ):
#apfel und valium
    if object_id != None:
        if object_id in const.OBJ_CONVOY_CARS:
            dialogs.initDlg_160_SpielerWillNichtInFahrzeugEinsteigen()
            return True

        if object_id in const.OBJ_WILDPFERDE:
            if not data().spieler_hat_wildpferd and not data().wildpferd_folgt_spieler:
                data().following_wildhorse = object_id
                system.start_cutscene()
                set_camera(const.CAM_WILDHORSE_FOLLOWME)
                data().wildhorse_led_without_apple = True
                dialogs.initCutscene_086_DasBedroehntePferdFolgtDemSpieler()
    
    if character_id == "ALTER_EGO":
        if item_type == "SET_VALIUM" or item_id == "Z6 AIDANS_VALIUM":
            if (object.count_in_inventory(character_id,"SET_APPLE") or 
                object.count_in_inventory(character_id,"Z6 GERDAS_APPLE")):
                if object.count_in_inventory(character_id,"SET_VALIUM"):
                    object.remove_item_from_inventory(character_id,"SET_VALIUM")
                else:
                    object.remove_item_from_inventory(character_id,"Z6 AIDANS_VALIUM")
                if object.count_in_inventory(character_id,"SET_APPLE"):
                    object.remove_item_from_inventory(character_id,"SET_APPLE")
                else:
                    object.remove_item_from_inventory(character_id,"Z6 GERDAS_APPLE")
                object.create_item_in_inventory(character_id,"SET_APPLE_VALIUM")
                dialogs.initDlg_089_SpielerStecktDasValiumInDenApfel()
                return True
            else:
                dialogs.initDlg_088_SpielerUeberlegtWasErMitValiumMachenSoll()
                return False

        if ((item_type == "SET_APPLE") or (item_id == "Z6 GERDAS_APPLE")):
            if (object.count_in_inventory(character_id,"SET_VALIUM") or
                object.count_in_inventory(character_id,"Z6 AIDANS_VALIUM")):
                if object.count_in_inventory(character_id,"SET_VALIUM"):
                    object.remove_item_from_inventory(character_id,"SET_VALIUM")
                else:
                    object.remove_item_from_inventory(character_id,"Z6 AIDANS_VALIUM")
                if object.count_in_inventory(character_id,"SET_APPLE"):
                    object.remove_item_from_inventory(character_id,"SET_APPLE")
                else:
                    object.remove_item_from_inventory(character_id,"Z6 GERDAS_APPLE")
                object.create_item_in_inventory(character_id,"SET_APPLE_VALIUM")
                dialogs.initDlg_089_SpielerStecktDasValiumInDenApfel()
                return True
            else:
                return False

# Lesen der geheimen Dokumente
    if (item_id == data().obj_Geheimdokumente):
        if character_id == "ALTER_EGO":
            if not data().SchattenbasisDokumenteGelesen:
                if system.get_qb_entry_state(data().QB_005) in [UNCOMPLETE, INACTIVE]:
                    system.set_qb_entry_state(data().QB_005,COMPLETE)
                dialogs.initCutscene_012_SpielerLiestDokumenteZurSchattenBasis()
            else:
                dialogs.initCutscene_012_SpielerLiestDokumenteZurSchattenBasis(as_cutscene=False)
            return True
        else:
            if object.get_attribute(character_id, "gender") == "male":
                comments.comment(character_id, "MERCENERY_USEITEM_DENY")
            else:
                comments.comment(character_id, "MERCENERY_USEITEM_DENY_F")
            return True

# neuer Generator, Steuereinheit einbauen
    if object_id != None:
        if (object.has_attribute(character_id,const.SKILL_GENERATOR_QUEST[0]) and
            object.get_attribute(character_id,const.SKILL_GENERATOR_QUEST[0]) >= const.SKILL_GENERATOR_QUEST[1]):
            if (object_id.endswith(const.OBJ_GENERATOR_CH) and item_id==data().obj_GeneratorSteuereinheit):
                if (data().GeneratorRepariert == 0 and system.get_qb_entry_state(data().QB_013) == UNCOMPLETE):
                    dialogs.initCutscene_050_SpielerBautSteuereinheitInGenerator(character_id)
                    object.remove_item_from_inventory(character_id,data().obj_GeneratorSteuereinheit)
                    return True

# neuer Generator, Zündkerze einbauen
# const.SKILL_GENERATOR_QUEST =  ["technic", 75]
        if (object.has_attribute(character_id,const.SKILL_GENERATOR_QUEST[0]) and
            object.get_attribute(character_id,const.SKILL_GENERATOR_QUEST[0]) >= const.SKILL_GENERATOR_QUEST[1]):
            if (object_id.endswith(const.OBJ_GENERATOR_CH) and item_type=="SET_GLOW_PLUG"):
                if (data().GeneratorRepariert == 1 and system.get_qb_entry_state(data().QB_014) == UNCOMPLETE):
                    dialogs.initCutscene_051_SpielerBautZuendkerzenInGenerator(character_id)
                    object.remove_item_from_inventory(character_id,"SET_GLOW_PLUG")
                    return True
    return object_events.on_use( character_id, object_id, item_id, item_type )

#######################################################################################################

## Bewegt 2 Objekte zueinander und richtet sie aus
def children_surrender_party(char_id, pos_ae=None, pos_alexa=None):
    prohibit_activity(char_id)
    if char_id == "ALEXA":
        object.move_to(char_id, pos_alexa[0], pos_alexa[1], grid="landscape",speed=MT_FAST,callback=["ONEND",count_moved_children])
        object.turn_to_object("ALEXA", "ALTER_EGO")
        object.cancel_commandos("ALTER_EGO")
        move_players()
        object.move_to("ALTER_EGO", pos_ae[0], pos_ae[1],grid="landscape",speed=MT_FAST, callback=["ONEND", Lambda('object.turn_to_object("ALEXA", "ALTER_EGO")')])
        object.turn_to_object("ALTER_EGO", "ALEXA", callback=["ONEND", Lambda('object.turn_to_object("ALEXA", "ALTER_EGO")')])
    else:
        data().child_run_counter += 1
        pos = const.POS_CGS_CHILDGANG[data().child_run_counter]
        object.move_to(char_id,pos[0],pos[1],"landscape",MT_FAST,callback=["ONEND",count_moved_children])
    object.turn_to_object(char_id, "ALTER_EGO")

def set_players():
    pcs = system.get_pcs()
    counter = -1
    for pc in pcs:
        counter += 1
        object.cancel_commandos(pc)
        object.set_position(pc, (703.0-random.randint(-2,2)), (315.5-random.randint(-2,2)))

def move_players():
    pcs = system.get_pcs()
    counter = -1
    for pc in pcs:
        if pc != "ALTER_EGO":
            counter += 1
            p = const.POS_CGS_PARTY[counter]
            object.move_to(pc, p[0],p[1],speed=MT_FAST, grid="landscape", callback=["ONEND", Lambda('object.turn_to_object("%s", "ALEXA")' %(pc))])

def count_moved_children(id):
# Kindergang umstellt den Spieler
    if (id in const.KINDERGANG_NPCS and data().MitAlexaGesprochen == 0):
        data().VonKindergangUmstellt += 1
        if (data().VonKindergangUmstellt >= (len(const.KINDERGANG_NPCS.keys())/3)):
            data().MitAlexaGesprochen = 1
            dialogs.initCutscene_018_Alexa_Vorstellung()
            allow_activity(id)

#######################################################################################################
#
# Initialisierungen
#
#######################################################################################################

## Questbook
def initQuestbook():
    data().QB_001 = system.register_qb_entry('ZONE6_AIM_01')
    data().QB_002 = system.register_qb_entry('ZONE6_AIM_02')
    data().QB_003 = system.register_qb_entry('ZONE6_AIM_03')
    data().QB_004 = system.register_qb_entry('ZONE6_AIM_04')
    data().QB_005 = system.register_qb_entry('ZONE6_AIM_05')
    data().QB_007 = system.register_qb_entry('ZONE6_AIM_07')
    data().QB_008 = system.register_qb_entry('ZONE6_AIM_08')
    data().QB_010 = system.register_qb_entry('ZONE6_AIM_10')
    data().QB_011 = system.register_qb_entry('ZONE6_AIM_11')
    data().QB_012 = system.register_qb_entry('ZONE6_AIM_12')
    data().QB_013 = system.register_qb_entry('ZONE6_AIM_13')
    data().QB_014 = system.register_qb_entry('ZONE6_AIM_14')
    data().QB_015 = system.register_qb_entry('ZONE6_AIM_15')
    data().QB_016 = system.register_qb_entry('ZONE6_AIM_16')
    data().QB_017 = system.register_qb_entry('ZONE6_AIM_17')
    data().QB_018 = system.register_qb_entry('ZONE6_AIM_18')
    data().QB_019 = system.register_qb_entry('ZONE6_AIM_19')
    data().QB_020 = system.register_qb_entry('ZONE6_AIM_20')
    data().QB_021 = system.register_qb_entry('ZONE6_AIM_21')
    data().QB_022 = system.register_qb_entry('ZONE6_AIM_22')

    if not hasattr(data('zone_7.zone_7'), 'QB_001'):
        data('zone_7.zone_7').QB_001 = -1
    data('zone_7.zone_7').QB_001 = system.register_qb_entry('ZONE7_AIM_01')
    system.set_qb_entry_state(data().QB_001,UNCOMPLETE)

# Initialisierung der Effekte
def initFX():
    sounds.load_sound(sfx_id="generator_engine_off")
    sounds.load_sound(sfx_id="generator_engine_starts")
    sounds.load_sound(sfx_id="generator_loop")

    for lagerfeuer in const.OBJ_LAGERFEUER_CAMP:
        fxLagerFeuer(lagerfeuer)

    for lagerfeuer in const.OBJ_LAGERFEUER_NOMADEN:
        fxLagerFeuer(lagerfeuer)

#lagerfeuer in west-schatten-stadt
    fxLagerFeuer('BUILDING_30402')
    fxLagerFeuer('BUILDING_30400')

    fxLagerFeuer("BUILDING_2945") # Alexas
    fxLagerFeuer("BUILDING_3958") # Adians
    fxLagerFeuer("BUILDING_5458") # Bills

    for brennendetonne in const.OBJ_BRENNENDE_TONNEN:
        fxBrennendeTonne(brennendetonne)

# Ein Lagerfeuer Effekt
def fxLagerFeuer(_objectid):
    system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
    system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
    system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
    system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
    system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
    sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

def fxBrennendeTonne(_objectid):
    system.start_effect_object(object=_objectid,node="sort1",parameter=fx_fire_brennende_tonne)
    sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)

## Hinzufügen von Regionen zur Zone 6
def initRegions():
# Startpunkt
    system.add_region(data().Region_UmStartpunkt1,366,198,367,202)
    system.add_region(data().Region_UmStartpunkt2,366,200,353,202)
    system.notify_region_entered(data().Region_UmStartpunkt1,objectid="ALTER_EGO")
    system.notify_region_entered(data().Region_UmStartpunkt2,objectid="ALTER_EGO")

# Region in der die Gauner Manny den Whiskey geben
    system.add_region(data().Region_GaunerReturnWhiskey,665,850,670,865)
    system.notify_region_entered(data().Region_GaunerReturnWhiskey,objectid="COLIN_Z6")
    system.notify_region_entered(data().Region_GaunerReturnWhiskey,objectid="DICK")
    system.notify_region_entered(data().Region_GaunerReturnWhiskey,objectid="DONALD_Z6")

# Tierareale
#system.add_region(data().Region_Hirsche  ,655,805,590,700)
#system.add_region(data().Region_Baeren   ,520,925,580,860)
#system.add_region(data().Region_Kuehe    ,730,885,680,900)
#system.add_region(data().Region_Wildhunde,200,400,260,500)
#system.add_region(data().Region_Hyaenen  ,640,275,590,380)
#system.add_region(data().Region_Woelfe1  ,790,295,660,200)
#system.add_region(data().Region_Woelfe2  ,465,658,396,608)
#system.add_region(data().Region_Woelfe3  ,307,200,200,309)

## Spawntimer
    system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

# Nomadendorfzentrum
    system.add_region(data().Region_Nomadendorf,533,300,543,289.5)
#system.notify_region_entered(data().Region_Nomadendorf,objectid="ALTER_EGO",permanent=True)

# Calebversteck im östlichen Stützpunkt
    system.add_region(data().Region_CalebVersteck,719.32, 240.21, 745.47, 221.12)

# Gaunerlager, 20m Umkreis
    system.add_region(data().Region_GaunerLager20m,255,710,295,750)
    system.notify_region_entered(data().Region_GaunerLager20m, partyid="UISPIELER", permanent=True)

# Lager der Kindergang (Nord und Südeingang für unterschiedliche CamViews)
    system.add_region(data().Region_QuartierDerKinderGang, 695,320,730,355)
    system.notify_region_entered(data().Region_QuartierDerKinderGang, partyid="UISPIELER")

# Ueberfallener Transporter
    system.add_region(data().Region_UeberfallenerTransport, 360, 830, 320, 770)
    system.notify_region_entered(data().Region_UeberfallenerTransport, partyid="UISPIELER", permanent=True)

## Minenfelder
# Alexas Camp Eingang rechts
    """
    system.add_region(data().Minefield_Alexa1a,660,363,665,402)
    system.add_region(data().Minefield_Alexa1b,655,368,660,404)
    system.add_region(data().Minefield_Alexa1c,650,373,655,406)
    system.add_region(data().Minefield_Alexa1d,645,378,650,408)
    system.add_region(data().Minefield_Alexa1e,640,383,645,410)
    system.add_region(data().Minefield_Alexa1f,635,390,640,412)
# Alexas Camp Eingang links
    system.add_region(data().Minefield_Alexa2a,620,393,625,372)
    system.add_region(data().Minefield_Alexa2b,625,389,630,362)
    system.add_region(data().Minefield_Alexa2c,630,380,635,352)
    """

# Copper Hill Eingang links
    system.add_region(data().Minefield_CopperHill,671,827,703,778)

    """
    system.notify_region_entered(data().Minefield_Alexa1a,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa1b,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa1c,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa1d,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa1e,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa1f,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa2a,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa2b,partyid="UISPIELER",permanent=True)
    system.notify_region_entered(data().Minefield_Alexa2c,partyid="UISPIELER",permanent=True)
    """

    system.notify_region_entered(data().Minefield_CopperHill,partyid="UISPIELER",permanent=True)

# Zone in der der General entdeckt wird
    system.add_region(data().Region_GeneralDerSchatten,615.0,940.0,648.0,979.0)

    system.add_region("REGION_HORATIO",690,520,710,555)
    system.notify_region_entered("REGION_HORATIO",partyid="UISPIELER")

    system.add_region("REGION_SCHATTENLAGER",349,630,240,525)
    system.notify_region_entered("REGION_SCHATTENLAGER",partyid="UISPIELER")

    system.add_region("BILLS_HAUS",410,410,385,435)
    system.notify_region_entered("BILLS_HAUS",partyid="UISPIELER")

    system.add_region("BAHNHOF",540,575,696,708)
    system.notify_region_entered("BAHNHOF",partyid="UISPIELER")

    system.add_region("RADARSTATION",286,868,356,946)
    system.notify_region_entered("RADARSTATION",partyid="UISPIELER")

    system.add_region("WILDPFERDE",201,403,242,492)
    system.notify_region_entered("WILDPFERDE",partyid="UISPIELER")

    system.add_region("NOMADEN_LAGER",525,330,580,235)
    system.notify_region_entered("NOMADEN_LAGER",partyid="UISPIELER")

    system.add_region("REGION_COPPERHILL_1",780,780,590,873)
    system.add_region("REGION_COPPERHILL_2",780,873,570,980)
    system.notify_region_entered("REGION_COPPERHILL_1",partyid="UISPIELER")
    system.notify_region_entered("REGION_COPPERHILL_2",partyid="UISPIELER")

# setzt chars mortal bzw immortal + foes attribute fuer animals
def init_character_states():
# mainquest npcs
    for id in ["JOSHUA", "CALEB", "FATMA", "DOUBLEGANGER_GENERAL", "GENERAL_OF_THE_SHADOWS","SUE","ABRAHAM","HORATIO"]:
        character.set_main_quest_npc_state(id, True)
        if id in ["DOUBLEGANGER_GENERAL", "GENERAL_OF_THE_SHADOWS"]:
            character.set_approachable_state(id, NOTAPPROACHABLE)

# mortality
    for id in system.get_npcs():
        if (id not in data().RATSKULL_NPCS 
                + data().SCHATTEN_WEST_NPCS
                + data().SCHATTEN_CH_NPCS 
                + data().SCHATTEN_CH_EXT_NPCS 
                + data().SCHATTEN_NPCS
                + data().GENERALTEAM_NPCS
                + data().SCHATTEN_KONVOI_NPCS
                + data().GAUNER
                + const.GOE_NPCS
                + ['MERCENARY_DEBORAH']):
                object.set_immortal_state(id, True)
        else:
            if id not in data().GAUNER + const.GOE_NPCS and id != 'MERCENARY_DEBORAH':
                character.set_approachable_state(id, NOTAPPROACHABLE)
# animals
    for id in system.get_animals():
        if (id not in const.OBJ_WILDPFERDE and 
            id not in const.OBJ_KUEHE) and id not in ["LEICA", "POLLY"]:
            object.set_attribute(id, "foes", ["UISPIELER"])
        if id in ["LEICA", "POLLY"] + const.OBJ_KUEHE + const.OBJ_WILDPFERDE:
            object.set_immortal_state(id, True)

# Exitzonen initialisieren
def initExitZones():
    system.add_region( id = "REGION_EXIT_NORD", x1 = 0.0, y1 = 0.00, x2 = 991.0, y2 = 200.0 )
    system.register_exit(regionname = "REGION_EXIT_NORD")

    system.add_region( id = "REGION_EXIT_SUED", x1 = 0.0, y1 = 985.0, x2 = 991.0, y2 = 1183.0 )
    system.register_exit(regionname = "REGION_EXIT_SUED")

    system.add_region( id = "REGION_EXIT_WEST", x1 = 0.0, y1 = 200.0, x2 = 200.00, y2 = 985.0 )
    system.register_exit(regionname = "REGION_EXIT_WEST")

    system.add_region( id = "REGION_EXIT_OST", x1 = 790.0, y1 = 200.0, x2 = 991.00, y2 = 985.0 )
    system.register_exit(regionname = "REGION_EXIT_OST")

# Initialisiert die Items in der Zone
def initItems():
## Abrahams Garden of Eden Karte
    object.create_item_in_inventory("ABRAHAM",const.QI_GARDEN_EDEN_MAP[1],const.QI_GARDEN_EDEN_MAP[0])
    object.set_attribute(object=const.QI_GARDEN_EDEN_MAP[0], attribute="generic_item", value=False)

    system.create_object("SET_DISPOSABLE_SYRINGE",723.4,556.5,"Z6 DS_1",direction=0)
    object.set_position_free("Z6 DS_1", 716.72, 528.75, 1.0, grid="ZONE_6_BUILDING_17194_INTERIOR_GRID3")
    system.create_object("SET_DISPOSABLE_SYRINGE",722.4,558.5,"Z6 DS_2",direction=16)
    object.set_position_free("Z6 DS_2",717.10, 528.96, 1.0, grid="ZONE_6_BUILDING_17194_INTERIOR_GRID3")
    system.create_object("SET_DISPOSABLE_SYRINGE",720.9,560.0,"Z6 DS_3",direction=32)
    object.set_position_free("Z6 DS_3",707.51, 528.29, 0.9, grid="ZONE_6_BUILDING_44355_INTERIOR_GRID")

    object.create_item_in_inventory("ZONE_6_BUILDING_44231", "SET_DISPOSABLE_SYRINGE","Z6 DS_4")
    object.create_item_in_inventory("ZONE_6_BUILDING_44231", "SET_DISPOSABLE_SYRINGE","Z6 DS_5")

    for syringe in ["Z6 DS_1","Z6 DS_2","Z6 DS_3","Z6 DS_4","Z6 DS_5"]:
        object.set_attribute(object=syringe, attribute="generic_item", value=False)

# Zündkerze im Defekten Truck in Copper Hill
    object.create_item_in_inventory("BUILDING_4498","SET_GLOW_PLUG",data().obj_Zuendkerze)
    object.set_attribute(object=data().obj_Zuendkerze, attribute="generic_item", value=False)

# Noch eine Zündkerze und ne Autobatterie im östlichen Lager
    object.create_item_in_inventory("BUILDING_1242","SET_GLOW_PLUG")
    object.create_item_in_inventory("BUILDING_1242","SET_CAR_BATTERY")

    system.create_object("SET_APPLE",538.4,284.9,"Z6 GERDAS_APPLE")

## Copper Hill

    object.create_item_in_inventory("BUILDING_4492",["SET_BUG"])# Schrotthaufen, ehemaliger Hummer
    object.create_item_in_inventory("BUILDING_4703",["SET_ORDINARY_HELMET"])# Kistenstapel hinter Absperrung
    object.create_item_in_inventory("BUILDING_5088",["SET_MEDIPACK_SMALL"])# Fass, Stadtrand Süd
    object.create_item_in_inventory("BUILDING_4700",["SET_AMMOPACK_9_MM"])# Kiste, Stadteingang Nord
    object.create_item_in_inventory("BUILDING_5298",["SET_WATERING_CAN"])# Brunnen beim Bürgermeisterhaus

## Westliches Gebiet (incl. Westliches Lager)
# Wäscheleine Adian
#object.create_item_in_inventory("BUILDING_4144",["SET_NORMAL_CLOTHES_3"])
    object.create_item_in_inventory("BUILDING_158",["SET_CHAIN_SAW"])# Kistenstapel auf Weg vor Westlager
    object.create_item_in_inventory("BUILDING_5459",["SET_POWER_DRILL"])# Kiste vor Bills Haus
    object.create_item_in_inventory("BUILDING_466",["SET_AMMOPACK_9_MM","SET_AMMOPACK_357"])# Kistenstapel im Westlager
# Einige Kistenstapel im Westlager
    object.create_item_in_inventory("BUILDING_430",["SET_MEDIPACK_BIG"])
    object.create_item_in_inventory("BUILDING_428",["SET_HK_USP_45","SET_AMMOPACK_45"])
    object.create_item_in_inventory("BUILDING_427",["SET_BOTTLE_OF_GAS"])
    object.create_item_in_inventory("BUILDING_5834",["SET_HEGRENADE"])
# Reifenstapel im Westlager
    object.create_item_in_inventory("BUILDING_484",["SET_IRON_BAR"])
# Brunnen in Ruine in der Nähe vom Westlager
#object.create_item_in_inventory("BUILDING_791",["SET_LEATHER_GLOVES"])

## Gaunerlager
    object.create_item_in_inventory("BUILDING_5392",["SET_WIRE_WHISK"])# Umgekipptes Fass neben dem Haus der Gauner

## Flüchtlingslager
    object.create_item_in_inventory("BUILDING_3142",["SET_NORMAL_CLOTHES_5"])# Wäscheleine im Westen
    object.create_item_in_inventory("BUILDING_3195",["SET_HOLE_PUNCH"])# Stapel Holzbalken
    object.create_item_in_inventory("BUILDING_3059",["SET_MOLOTOV_COCKTAIL"])# Kistenstapel im Osten
    object.create_item_in_inventory("BUILDING_3150",["SET_WOLF_TEETH"])# Wassereimer an Destilieranlage

## Östliches Lager
    object.create_item_in_inventory("BUILDING_1302",["SET_MULTIPLE_SOCKET"])# Kistenstapel im Osten des Lagers
    object.create_item_in_inventory("BUILDING_1311",["SET_AMMOPACK_9_MM"])# Kistenstapel hinter Lagerhalle im Osten des Lagers
    object.create_item_in_inventory("BUILDING_1165",["SET_RAT_MEAT"])# Kiste Südlich des Lagereingangs
    object.create_item_in_inventory("BUILDING_1265",["SET_UZI"])# Kistenstapel in der Mitte des Lagers, südlich
    object.create_item_in_inventory("BUILDING_1267",["SET_AMMOPACK_9_MM"])# Kiste neben Kistenstapel

## Nomadenlager
    object.create_item_in_inventory("BUILDING_1918",["SET_HORSE_SKIN"])# Kiste hinter dem Händlerzelt
    object.create_item_in_inventory("BUILDING_2155",["SET_COOKING_POT"])# Fass am Nordrand des Lagers

## Lager der Kindergang
    object.create_item_in_inventory("BUILDING_2933",["SET_STAPLE_GUN"])# Reifenstapel
    object.create_item_in_inventory("BUILDING_2939",["SET_SMALL_SAND_SHOVEL"])# Umgekipptes Fass


## Nebenquest NPCS
    object.create_item_in_inventory("ABRAHAM", ["SET_NORMAL_CLOTHES_1"])
    object.create_item_in_inventory("MICKEY",  ["SET_LOW_SHOES"])
    object.create_item_in_inventory("SUE_Z7",  ["SET_BULLET_PROOF_CLOTHES","SET_KEVLAR_HELMET"])
    object.create_item_in_inventory("FJODR",   ["SET_BULLET_CATCH","SET_PROTECTIVE_GLOVES"])
    object.create_item_in_inventory("OWEN",    ["SET_NORMAL_CLOTHES_2"])

# Bienenstöcke Z6
    object.create_item_in_inventory( 'BUILDING_71030', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_71032', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_71031', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_71039', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_71037', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_71040', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_71038', equipment=[ 'SET_BEESWAX' ] )

# Items in Kisten
    object.create_item_in_inventory('BUILDING_70721', ['SET_HAIR_SPRAY','SET_BERETTA_92F_W_SILENCER', 'SET_HEGRENADE' ] )
    object.create_item_in_inventory('BUILDING_70733', ['SET_SHURIKEN','SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM_DUMDUM'])
    object.create_item_in_inventory('BUILDING_70827', [ 'SET_RUSTY_IRON_ROD','SET_M_79','SET_MEAT_COOKED'])
    object.create_item_in_inventory('BUILDING_70828', [ 'SET_CHEESE','SET_HEADPHONE','SET_MEDIPACK_BIG'])
    object.create_item_in_inventory('BUILDING_70913', [ 'SET_PLATE_GLOVES','SET_AMMOPACK_2_12_MM','SET_MAILBOX' ] )
    object.create_item_in_inventory('BUILDING_70914', ['SET_AMMOPACK_2_12_MM','SET_KEVLAR_HELMET','SET_KNIFE'])
    object.create_item_in_inventory('BUILDING_70915', ['SET_AMMOPACK_45','SET_AMMOPACK_5_7_MM_SUBSONIC', 'SET_DT21_LIGHT_ARMOR' ] )
    object.create_item_in_inventory('BUILDING_70916', ['SET_WATER_CAN','SET_UZI_W_LASERPOINTER','SET_HOLE_PUNCH'])
    object.create_item_in_inventory('BUILDING_70930', ['SET_M249','SET_C4_TIMEBASED_W_NAILS','SET_M46_GAUNTLETS'])
    object.create_item_in_inventory('BUILDING_70937', ['SET_STEEL_CLAD_BOOTS', 'SET_AXE', 'SET_WOODEN_BOARD' ])
    object.create_item_in_inventory('BUILDING_70964', ['SET_BROKEN_POCKET_CALCULATOR', 'SET_PLATE_ARMOR', 'SET_AMMOPACK_4_6_MM_DUMDUM' ] )
    object.create_item_in_inventory('BUILDING_70970', ['SET_AMMOPACK_357','SET_AMMOPACK_50_BMG','SET_CHAIN_SAW'])
    object.create_item_in_inventory('BUILDING_54817', ['SET_HEGRENADE', 'SET_BROWNING_B_SS_DOUBLE_BARREL', 'SET_SHURIKEN' ] )


def initHerbs():
    system.create_object(equipmenttype="SET_ALOE_VERA", x=699.91, y=209.33)
    system.create_object(equipmenttype="SET_ALOE_VERA", x=213.89, y=539.86)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=779.68, y=231.61)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=391.64, y=364.55)
    system.create_object(equipmenttype="SET_BURNET", x=429.45, y=911.08)
    system.create_object(equipmenttype="SET_BURNET", x=371.84, y=437.20)
    system.create_object(equipmenttype="SET_ANGELICA", x=777.53, y=570.39)

def initObjects():

## Whiskeyfässer, Manny Quest
    system.create_object("SET_WHISKEY_BARREL",271.00,732.80,id=data().obj_SingleMaltWhiskey,direction=globals.DIR_NORTH)
    object.set_attribute(object=data().obj_SingleMaltWhiskey, attribute="generic_item", value=False)
    system.create_object("SET_WHISKEY_BARREL",271.50,732.20,id=data().obj_ScotchWhiskey,direction=globals.DIR_NORTH)
    object.set_attribute(object=data().obj_ScotchWhiskey, attribute="generic_item", value=False)
    system.create_object("SET_WHISKEY_BARREL",272.00,733.40,id=data().obj_BurbonWhiskey,direction=globals.DIR_NORTH)
    object.set_attribute(object=data().obj_BurbonWhiskey, attribute="generic_item", value=False)

    object.set_active_state(data().obj_SingleMaltWhiskey,INACTIVE)
    object.set_active_state(data().obj_ScotchWhiskey,INACTIVE)
    object.set_active_state(data().obj_BurbonWhiskey,INACTIVE)

# motorrad für george ins fl stellen
    object.set_position("BUILDING_6209", 523.6,856.2)


def initEquipment():
## Nebenquest NPCs
#object.create_item_in_inventory("ADIAN",          [""])
    object.create_item_in_inventory("ALEXA",  ["SET_TEDDY_BEAR"])
    object.create_item_in_inventory("MADISON",["SET_LEATHER_BOOTS"])
    object.create_item_in_inventory("MANNY",  ["SET_BOTTLE_OF_BOOZE"])
#object.create_item_in_inventory("DICK",          [""])
#object.create_item_in_inventory("DONALD_Z6",      [""])
    object.create_item_in_inventory("COLIN_Z6",["SET_NORMAL_CLOTHES_4"])

## TA NPCs CopperHill
#object.create_item_in_inventory("PHIL",          [""])
    object.create_item_in_inventory("IRIS", ["SET_NORMAL_CLOTHES_2","SET_NECKLACE"])
    object.create_item_in_inventory("BRUNO",["SET_NORMAL_CLOTHES_4", "SET_WALKIE_TALKIE"])
    object.create_item_in_inventory("GEORGE",["SET_NORMAL_CLOTHES_6", "SET_SOAP"])
#object.create_item_in_inventory("MEN_TOI",      [""])
    object.create_item_in_inventory("KFH_857",["SET_COMPUTER_KEYBOARD","SET_GRAPHICS_CARD"])
    object.create_item_in_inventory("IGOR", ["SET_LEATHER_CAP"])
    object.create_item_in_inventory("MEG",  ["SET_HAIRSTYLE_MAGAZINE","SET_LOW_SHOES"])
    object.create_item_in_inventory("RYAN", ["SET_WATER_DETECTOR"])
    object.create_item_in_inventory("MAD_DOC_MURPHY",["SET_LOW_SHOES"])
    object.create_item_in_inventory("RICK", ["SET_DRUGS_VIALS_03"])
#object.create_item_in_inventory("CRUNCHY",      [""])
    object.create_item_in_inventory("ALOIS",["SET_NORMAL_CLOTHES_5","SET_WATER_DETECTOR"])
    object.create_item_in_inventory("TOBY", ["SET_GAME_JOY"])

## TA NPCs Alexas Kindergang
    object.create_item_in_inventory("SAVANNAH",["SET_NORMAL_CLOTHES_1"])
    object.create_item_in_inventory("ANDREA",  ["SET_SMALL_SAND_BUCKET"])
#object.create_item_in_inventory("KIMBERLY",      [""])
#object.create_item_in_inventory("ERIN",          [""])
    object.create_item_in_inventory("DEVIN",["SET_NORMAL_CLOTHES_3"])
    object.create_item_in_inventory("CODY", ["SET_SMALL_SAND_SHOVEL"])
#object.create_item_in_inventory("ANTONIO",          [""])

## TA NPCs Nomadencamp
#object.create_item_in_inventory("PIT",              ["SET_AXE"]) ## !! geht noch nicht
    object.create_item_in_inventory("PENNY",["SET_BISON_SKIN"])
    object.create_item_in_inventory("CHRIS",["SET_BROKEN_SHOVEL"])
    object.create_item_in_inventory("JASMIN",["SET_NORMAL_CLOTHES_6","SET_PROTECTIVE_GLOVES"])
    object.create_item_in_inventory("CARL",["SET_BOTTLE_OF_WHISKEY"])
    object.create_item_in_inventory("LAYLA",["SET_NORMAL_CLOTHES_1"])
    object.create_item_in_inventory("T_LETH",["SET_TIGER_CLAW","SET_AMMOPACK_7_62_54_MMR"])

### Marchande Sue (Trader )
    object.create_item_in_inventory("SUE", ["SET_DRUGS_PILLS_01"]*40 + ["SET_DRUGS_PILLS_02"]*10 +\
        ["SET_DRUGS_PILLS_03"]*7  + ["SET_DRUGS_PILLS_04"]*5)
    object.create_item_in_inventory("SUE", [ "SET_AMMOPACK_BOLT"]*10 + ["SET_AMMOPACK_5_7_MM_SUBSONIC"]*13 +\
        ["SET_AMMOPACK_7_62NATO_MM_SABOT"]*9 + ["SET_AMMOPACK_7_62SOVJET_MM"]*8 + ["SET_AMMOPACK_5_56_MM"]*8 +\
        ["SET_AMMOPACK_5_45_MM"]*6 + ["SET_AMMOPACK_M79_M203"]*3 + ["SET_AMMOPACK_7_62_54_MMR"]*10)

def generator_anim(generator=None):
    if data().generator_anim:
        object.play_animation(const.OBJ_GENERATOR_CH,"ANIM_GENERATOR_LOOP", callback=["ONEND",generator_anim])

##helper functions for convoy intercept
def convoy_check_spotted_player():
    for shadow in data().SCHATTEN_KONVOI_NPCS:
        for pc in system.get_pcs():
            if object.get_distance(shadow, pc) <= 35.0:
                return True
    return False

def convoy_stop_and_attack():
    if not data().convoy_stopped:
        data().convoy_stopped = True
        if data().convoy_enemy_spotted_active:
            convoy_stop()                                                    
            convoy_get_out()

def convoy_get_out():
    for shadow in data().SCHATTEN_KONVOI_NPCS:
        if not object.is_destroyed(shadow):
            character.get_out(shadow)
            convoy_attack(shadow)

def convoy_attack(char = None):
    on_enemy_spotted(char)

def convoy_stop():
    for car in const.OBJ_CONVOY_CARS:
        if object.has_attribute(car, 'script_path'):
            object.set_attribute(car, 'script_path', None)
            object.cancel_commandos(car)

#######################################################################################################
# on_timer - Callback für Timerevents
#######################################################################################################
def on_timer(id):
#    system.open_console()    

    if id == data().Timer_ConvoyIntercept:
        if convoy_check_spotted_player():
            convoy_stop_and_attack()
        else:
            system.notify_timer(data().Timer_ConvoyIntercept, data().Timervalue_ConvoyIntercept)

    if id == data().Timer_KonvoiStart:
        dialogs.convoy_start()

    if id == data().Timer_CalebRenntDavon:
        dialogs.onDlg_002_CalebRenntDavon()

    if id == data().Timer_WildPferdCutscene:
        dialogs.onDlg_086_Continue()

    if id == data().Timer_LeicaWaitPlayer and data().leica_folgt:
        if object.get_distance("LEICA", "ALTER_EGO") <= 3.0:
            data().counter_leica_position += 1
            if data().counter_leica_position <= 8:
                if data().counter_leica_position < len(const.WAYPOINTS_LEICA_TO_CALEB):
                    dialogs.leica_leads_player()
            else:
                object.move_to("LEICA", 730.18, 257.78, speed=MT_FAST, callback=["ONEND", dialogs.on_leica_reaches_point])
        else:
            object.turn_to_object("LEICA", "ALTER_EGO")
            system.notify_timer(data().Timer_LeicaWaitPlayer, data().Timervalue_LeicaWaitPlayer)

    if id == data().Timer_Fade:
        if data().fade_count == 1:
            object.set_position('GENERAL_OF_THE_SHADOWS', 648, 959, 'landscape')
            dialogs.initDlg_148_GeneralHatWichtigeInfos()
        system.fade(FADE_IN)

    if id == data().Timer_SoundDelay:
        if data().sound_delay == 1:
            data().generator_anim = True
            generator_anim()
            sounds.play_3d_sound_object(sfx_id="generator_loop", object=const.OBJ_GENERATOR_CH, loop=True, identifier="sound_generator_engine")
        data().sound_delay = 0

    if id == data().Timer_WildPferdFluchtChecker:
        for wh in const.OBJ_WILDPFERDE:
            if not object.is_destroyed(wh):
                if wh != data().following_wildhorse:
                    for pc in system.get_pcs():
                        dist = object.get_distance(pc,wh)
                        if dist < 15.0:
                            talents = ["none"]
                            if object.has_attribute(pc, "survival_talents"):
                                talents = object.get_attribute(pc, "survival_talents")
                            if not wildhorse_can_control(pc):
                                if not pc in data().wildhorse_pcs_flee:
                                    data().wildhorse_pcs_flee.append(pc)
                                if not object.has_attribute(wh, "is_fleeing"):
                                    wildhorse_flee(wh, pc)
        system.notify_timer(data().Timer_WildPferdFluchtChecker,data().Timervalue_WildPferdFluchtChecker)

## fixme: hotfix remove later!
    if id == data().Timer_HotFixHack:
        dialogs.initCutscene_085_DasPferdIsstDenValiumApfel()

# wildpferd isst apfel
    if id==data().Timer_WildPferdHatApfelGegessen:
        object.set_active_state(data().obj_apple_put_down,INACTIVE)
        dialogs.initCutscene_086_DasBedroehntePferdFolgtDemSpieler()

## Abraham und Co brechen ohne Spieler ins Paradies auf
    if (id==data().Timer_AbrahamUndCoBrechenAuf):
        if not data().abraham_quest_angenommen:
            if not data().zzone_4_betreten:
                data().owen_quest_verpasst = True
                for id in const.GOE_NPCS:
                    if id in system.get_npcs():
                        character.set_approachable_state(id,NOTAPPROACHABLE)
                        for waypoint in const.WAYPOINTS_ABRAHAM:
                            if waypoint != const.WAYPOINTS_ABRAHAM[len(const.WAYPOINTS_ABRAHAM)-1]:
                                object.move_to(id,waypoint[0],waypoint[1], "landscape",MT_SLOW)
                            else:
                                object.move_to(id,waypoint[0],waypoint[1], "landscape",MT_SLOW, callback=["ONEND",deactivate])
# wildpferd folgt dem spieler
    if id == data().Timer_WildpferdFolgt:
        if data().comment_081_given:
            data().comment_081_given = True
            dialogs.initDlg_081_SpielerZaehmtDasPferd()
        if (data().wildpferd_folgt_spieler and system.get_qb_entry_state(data().QB_015) in [UNCOMPLETE]):
            pos = object.get_position("ALTER_EGO")
            object.cancel_commandos(data().following_wildhorse)
            object.move_to(data().following_wildhorse,pos[0],pos[1], speed=MT_FAST)
            system.notify_timer(data().Timer_WildpferdFolgt, data().Timervalue_WildpferdFolgt)
            dist = object.get_distance(data().following_wildhorse,"JOSHUA")
            if dist <= 5.0:
                data().wildpferd_folgt_spieler = False
                object.cancel_commandos(data().following_wildhorse)
                data().spieler_hat_wildpferd = True
                system.set_qb_entry_state(data().QB_015,COMPLETE)

#Kinder sind am Lastwagen fertig und kehren ins Lager zurück
    if (id==data().Timer_KinderLastwagenFertig):
        lastid=const.KINDERGANG_NPCS.keys()[0]
        for id in const.KINDERGANG_NPCS:
            x= len(const.WAYPOINTS_KINDERGANGLASTWAGEN)-1
            waypoint=const.WAYPOINTS_KINDERGANGLASTWAGEN[x]
            object.move_to(id,waypoint[0],waypoint[1],"landscape")
            while (x>0):
                x-=1
                waypoint=const.WAYPOINTS_KINDERGANGLASTWAGEN[x]
                object.move_to(id,waypoint[0],waypoint[1],"landscape")
        if (id == lastid):
            object.move_to(id,const.WAYPOINTS_KINDERGANGLASTWAGEN[0][0],const.WAYPOINTS_KINDERGANGLASTWAGEN[0][1],callback=["ONEND",Lambda('data().children_at_konvoi = False')])

    if (id==data().Timer_CitizenMoveHome):
        lastid = data().COPPERHILL_NPCS[len(data().COPPERHILL_NPCS)-1]
        for id in data().COPPERHILL_NPCS:
            object.cancel_commandos(id)
            for wp in const.WAYPOINTS_CH_BEWOHNER:
                if not (wp == const.WAYPOINTS_CH_BEWOHNER[len(const.WAYPOINTS_CH_BEWOHNER)-1]):
                    object.move_to(id,wp[0],wp[1],"landscape",MT_SLOW)
                else:
                    object.move_to(id,wp[0],wp[1],"landscape",MT_SLOW,callback=["ONEND",allow_activity])
            if id == "KUH_1":
                object.move_to("KUH_1",717.81,894.61, "landscape",MT_FAST)
            elif id == "KUH_2":
                object.move_to("KUH_2",713.00,891.43, "landscape",MT_FAST)
            elif id == "MANNY":
                object.move_to("MANNY",679.00,858.60, "landscape", callback=["ONEND",activateNPC])
                object.turn_to_direction("MANNY",globals.DIR_SOUTH)
            elif id == "MADISON":
                object.move_to("MADISON",712.31,931.44, "landscape", callback=["ONEND",activateNPC])
                object.turn_to_direction("MADISON",globals.DIR_NORTH)
            if id==lastid:
                object.set_position("BUILDING_6209", 707.76, 860.77)
                data().copperhill_befreit = True

## Timer für die Rettung der Fracht des LKWs
    if (id==data().Timer_AlexaQuest):
        if (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE):
            if data().RatskullsGetoetet == 0:
                for id_ in data().RATSKULL_NPCS:
                    if object.is_fighting(id_):
                        return
                    else:
                        object.set_active_state(id_, False)
                        data().RatskullsGetoetet += 1
                system.set_qb_entry_state(data().QB_010,IMPOSSIBLE)
#hummvee hinten
                object.remove_item_from_inventory("convoy_childgang_humvee_back", "SET_BOTTLE_OF_BOOZE")
                object.remove_item_from_inventory("convoy_childgang_humvee_back", "SET_BOTTLE_OF_BOOZE")
                object.remove_item_from_inventory("convoy_childgang_humvee_back", "SET_BOTTLE_OF_BOOZE")
                object.remove_item_from_inventory("convoy_childgang_humvee_back", "SET_BOTTLE_OF_WHISKEY")
                object.remove_item_from_inventory("convoy_childgang_humvee_back", "SET_BOTTLE_OF_WHISKEY")
                object.remove_item_from_inventory("convoy_childgang_humvee_back", "SET_BOTTLE_OF_WHISKEY")
#hummvee vorne
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_WATER_BOTTLE")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_WATER_BOTTLE")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_WATER_BOTTLE")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_WATER_BOTTLE")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_COFFEE_BEANS")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_COFFEE_BEANS")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_COFFEE_BEANS")
                object.remove_item_from_inventory("convoy_childgang_humvee_front", "SET_COFFEE_BEANS")
#skelett
                object.remove_item_from_inventory("convoy_childgang_ammobox", "SET_WATER_SKIN")
                object.remove_item_from_inventory("convoy_childgang_ammobox", "SET_WATER_SKIN")
                object.remove_item_from_inventory("convoy_childgang_ammobox", "SET_WATER_SKIN")
                object.remove_item_from_inventory("convoy_childgang_ammobox", "SET_WATER_SKIN")
#konvoitruck
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED_TINY")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED_TINY")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED_SMALL")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED_SMALL")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED_BIG")
                object.remove_item_from_inventory("convoy_childgang_truck", "SET_MEAT_COOKED_BIG")
    
## Fässer des Mannyquests verschwinden nach 2 Spielstunden
    if (id==data().Timer_FaesserVerschwinden):
        object.set_active_state(data().obj_SingleMaltWhiskey,INACTIVE)
        object.set_active_state(data().obj_ScotchWhiskey,INACTIVE)
        object.set_active_state(data().obj_BurbonWhiskey,INACTIVE)
        i=len(const.WAYPOINTS_GAUNER)-1
        for id in data().GAUNER:
            if not object.is_destroyed(id):
                while (i >= 0):
                    wp = const.WAYPOINTS_GAUNER[i]
                    i-=1
                    object.move_to(id,wp[0],wp[1],"landscape",MT_FAST)

        if not object.is_destroyed("COLIN_Z6"):
            object.move_to("COLIN_Z6" ,276.0, 729.0, "landscape", MT_FAST)

        if not object.is_destroyed("DICK"):
            object.move_to("DICK",274.0, 731.0, "landscape", MT_FAST)

        if not object.is_destroyed("DONALD_Z6"):
            object.move_to("DONALD_Z6",274.0, 729.0, "landscape", MT_FAST)

## Zeitauslöser, triggert jede Stunde
    if (id==data().Timer_SpawnTimeChecker):
        clock = system.get_mission_time().get_day_time()
        system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
        if (clock >= time("06:00:00") and clock < time("22:00:00")):
            npc.spawnAnimals(INACTIVE)
        else:
            npc.spawnAnimals(ACTIVE)

##wildhorse helpers
def wildhorse_can_control(pc):
    talents = []
    survival = 0
    if object.has_attribute(pc, "survival_talents"):
        talents = object.get_attribute(pc, "survival_talents")
    if not "control_animals" in talents:
        if object.has_attribute(pc,"survival"):
            survival = object.get_attribute(pc,"survival")
    else:
        return True
    if survival > 74:
        return True
    return False

# make wildhorse flee
def wildhorse_flee(wh, pc):
    object.set_attribute(wh, "is_fleeing", True)
    dist = object.get_distance(pc,wh)
    whp = object.get_position(wh)
    aep = object.get_position(pc)
    dx, dy = dist+random.randint(0,3), dist+random.randint(0,3)
    if whp[0] < aep[0]:
        dx = 0 - dx
    if whp[1] < aep[1]:
        dy = 0 - dy
    if not object.is_destroyed(wh):
        wildhorse_check_flee_range(wh, aep[0]+dx, aep[1]+dy)

# check wildhorse region
def wildhorse_check_flee_range(wh,x,y):
    out_of_bounds = False
    bx = [201.0,241.0]
    by = [425.0,470.0]
    if x <= bx[0] or x >= bx[1]:
        out_of_bounds = True
    if y <= by[0] or y >= by[1]:
        out_of_bounds = True
    if out_of_bounds:
        x = random.randint(bx[0],bx[1])
        y = random.randint(by[0],by[1])
    object.move_to(wh, x, y, speed=MT_FAST, callback=["ONEND", Lambda('object.set_attribute("%s", "is_fleeing", None)' %(wh))])

def deactivate(char_id):
    object.set_active_state(char_id,INACTIVE)

def onQuest_007_Abbruch():
    for id in const.GOE_NPCS:
        if id in system.get_npcs():
            object.cancel_commandos(id)

## convoy intercept helper
def convoy_ae_moveto_doubleganger():
    if hasattr(data(), "is_cbm_cutscene"):
        data().is_cbm_cutscene = True
    pos = object.get_position("DOUBLEGANGER_GENERAL")
    dv = dialogs.get_dist_vector("ALTER_EGO","DOUBLEGANGER_GENERAL")
    d = dialogs.get_direction_vector(dv)
    character.change_body_mode("ALTER_EGO","STAND")
    object.cancel_commandos("ALTER_EGO")
    object.set_position("ALTER_EGO",pos[0]-(10*d[0]),pos[1]-(10*d[1]))
    system.start_cutscene()

    if int(object.get_x('CALEB')) != 732 or int(object.get_y('CALEB')) != 228:
        object.cancel_commandos('CALEB')
        object.set_position_free("CALEB", 732.43, 228.49, 0.0, grid="ZONE_6_BUILDING_6200_INTERIOR_GRID")
        object.set_active_state("CALEB",INACTIVE)

    dv = dialogs.get_dist_vector("ALTER_EGO","DOUBLEGANGER_GENERAL")
    d = dialogs.get_direction_vector(dv)
    set_conversation(talker="DOUBLEGANGER_GENERAL", cam_x=d[0]*1.0,cam_y=d[1]*1.0,mode="far")
    aex = pos[0]-(2.5*d[0])
    aey = pos[1]-(3.0*d[1])
    print "object.is_destroyed", object.is_destroyed("ALTER_EGO")
    print "object.is_unconscious", object.is_unconscious("ALTER_EGO")
    object.move_to("ALTER_EGO",aex,aey, "landscape", callback=["ONEND",convoy_doubleganger_reached])

def convoy_doubleganger_reached(char=None):
    data().player_bodymode = character.get_body_mode("ALTER_EGO")
    dv = dialogs.get_dist_vector("ALTER_EGO","DOUBLEGANGER_GENERAL")
    d = dialogs.get_direction_vector(dv)
    set_conversation(talker="DOUBLEGANGER_GENERAL", cam_x=d[0]*1.1,cam_y=d[1]*1.3,mode="medium")
    character.change_body_mode("ALTER_EGO","KNEEL")
    object.turn_to_object("ALTER_EGO","DOUBLEGANGER_GENERAL", callback=["ONEND",initDlg_004_DD_Getoetet])

def initDlg_004_DD_Getoetet(id):
    dialogs.initCutscene_004_DoppelgaengerEnttarntUndGetoetet()

def nomades_checked_deactivation():
    if not hasattr(data(),"nomandelager_region_notified"):
        data().nomandelager_region_notified = True
        if (system.get_qb_entry_state(data().QB_002) in [INACTIVE]
            and system.get_qb_entry_state(data().QB_001) in [UNCOMPLETE, INACTIVE]):
                system.notify_region_entered("Nomandenlager", objectid="ALTER_EGO")
                for id in const.NOMADEN_NPCS:
                    object.set_active_state(id, INACTIVE)
#for id in const.OBJ_NOMADEN_ZEUG:
#    object.set_active_state(id, INACTIVE)
                for lf in const.OBJ_LAGERFEUER_NOMADEN:
                    object.destroy(lf)

#def onKilled(id):
def on_object_killed(victim, attacker, weapon_type, weapon_victim):
    object_events.on_object_killed(victim, attacker, weapon_type, weapon_victim)
#wildpferde
    if victim in ["WILD_PFERD","WILD_PFERD_2","WILD_PFERD_3","WILD_PFERD_4"]:
        dead_horses = 0
        for id in ["WILD_PFERD","WILD_PFERD_2","WILD_PFERD_3","WILD_PFERD_4"]:
            if object.is_destroyed(id):
                dead_horses +=1
        if dead_horses == 4:
            if system.get_qb_entry_state(data().QB_015) in [UNCOMPLETE]:
                system.set_qb_entry_state(data().QB_015, IMPOSSIBLE)

# ABRAHAM MICKEY SUE_Z7 FJODR
    if victim in const.GOE_NPCS:
        if victim in system.get_npcs():
            const.GOE_NPCS.remove(victim)
            if (victim=="ABRAHAM"):
                if system.get_qb_entry_state(data().QB_020)==UNCOMPLETE:
                    system.set_qb_entry_state(data().QB_020,IMPOSSIBLE)

            elif (victim=="MICKEY" and system.get_qb_entry_state(data().QB_020)==UNCOMPLETE):
                if not object.is_destroyed("ABRAHAM"):
                    dialogs.initDlg_106_AbrahamGibtAufMickeyTot()

            elif (victim=="SUE_Z7" and system.get_qb_entry_state(data().QB_020)==UNCOMPLETE):
                if not object.is_destroyed("ABRAHAM"):
                    dialogs.initDlg_107_AbrahamGibtAufSueTot()

# Konvoi des Generals
    if (not data().KonvoiZerstoert and (victim in data().SCHATTEN_KONVOI_NPCS or victim in const.OBJ_CONVOY_CARS)):
        if victim in data().SCHATTEN_KONVOI_NPCS:
            data().SchattenAusKonvoiGetoetet += 1
        if not data().convoy_stopped:
            data().convoy_stopped = True

        if (data().SchattenAusKonvoiGetoetet == (len(data().SCHATTEN_KONVOI_NPCS))):
            convoy_ae_moveto_doubleganger()

# Ratskulls, die den Transport überfallen haben
    if (victim in data().RATSKULL_NPCS):
        data().RatskullsGetoetet += 1
        if (data().RatskullsGetoetet == (len(data().RATSKULL_NPCS))):
            if not system.get_qb_entry_state(data().QB_010) in [IMPOSSIBLE,INACTIVE]:
                dialogs.initDlg_038_SpielerErledigtAlexasAuftrag()
            else:
                dialogs.initDlg_070_SpielerStelltFestDassAlleRatskullsTotSind()
    
    if (victim in data().SCHATTEN_NPCS):
        data().SchattenCopperHillGetoetet  += 1
# 1-12 werden angegriffen
        if victim in data().SCHATTEN_CH_NPCS:
            if not data().schatten_ch_alerted:
                data().schatten_ch_alerted = True
# 2,4,6,7 ziehen sich in Dorfkern zurück
                if not object.is_destroyed(data().SCHATTEN_CH_EXT_NPCS[1]):
                    object.move_to(data().SCHATTEN_CH_EXT_NPCS[1],660.59,896.19, "landscape",speed=MT_FAST)
                    object.turn_to_object(data().SCHATTEN_CH_EXT_NPCS[1],"ALTER_EGO")
    
                if not object.is_destroyed(data().SCHATTEN_CH_EXT_NPCS[3]):
                    object.move_to(data().SCHATTEN_CH_EXT_NPCS[3],660.38,889.32, "landscape",speed=MT_FAST)
                    object.turn_to_object(data().SCHATTEN_CH_EXT_NPCS[3],"ALTER_EGO")
    
                if not object.is_destroyed(data().SCHATTEN_CH_EXT_NPCS[5]):
                    object.move_to(data().SCHATTEN_CH_EXT_NPCS[5],666.64,888.60, "landscape",speed=MT_FAST)
                    object.turn_to_object(data().SCHATTEN_CH_EXT_NPCS[5],"ALTER_EGO")
    
                if not object.is_destroyed(data().SCHATTEN_CH_EXT_NPCS[6]):
                    object.move_to(data().SCHATTEN_CH_EXT_NPCS[6],666.48,896.39, "landscape",speed=MT_FAST)
                    object.turn_to_object(data().SCHATTEN_CH_EXT_NPCS[6],"ALTER_EGO")

        if (data().SchattenCopperHillGetoetet == len(data().SCHATTEN_NPCS)):
            if data().konvoi_startet and not data().convoy_stopped:
                convoy_stop()
                convoy_get_out()
            elif not data().konvoi_startet:
                dialogs.initDlg_159_DieFahrzeugeFliegenInDieLuft(False)
            character.add_experience_party(data().Exp_StadtBefreit)
#            dialogs.initDlg_160_AllShadowsKilled()
            if not data().schatten_endcutscene:
                if data().schatten_general_killed == 3:
                    if system.get_qb_entry_state(data().QB_005) in [UNCOMPLETE, INACTIVE]:
                        system.set_qb_entry_state(data().QB_005, COMPLETE)
    
                if system.get_qb_entry_state(data().QB_005) == COMPLETE:
                    data().schatten_endcutscene = True
                    data().fade_count = 1
                    system.start_cutscene()
                    system.fade(FADE_OUT)
                    system.notify_timer(data().Timer_Fade, data().Timervalue_Fade)
                    nomades_checked_deactivation()

            onCopperHillBefreitCitizensReturn()
            for lagerfeuer in const.OBJ_LAGERFEUER_CAMP:
                object.destroy(lagerfeuer)
            for lagerfeuer in const.OBJ_LAGERFEUER_CH:
                fxLagerFeuer(lagerfeuer)

        if victim in data().GENERALTEAM_NPCS:
            data().schatten_general_killed += 1
            if data().schatten_general_killed == 3:
                if system.get_qb_entry_state(data().QB_005) in [UNCOMPLETE, INACTIVE]:
                    system.set_qb_entry_state(data().QB_005, COMPLETE)
                if data().SchattenCopperHillGetoetet == len(data().SCHATTEN_NPCS):
                    data().schatten_endcutscene = True
                    data().fade_count = 1
                    system.start_cutscene()
                    system.fade(FADE_OUT)
                    system.notify_timer(data().Timer_Fade, data().Timervalue_Fade)
                    nomades_checked_deactivation()
        
    if victim in data().SCHATTEN_WEST_NPCS:
        data().SCHATTEN_WEST_NPCS.remove(victim)
    
# Wenn man nen Nebenquestnpc killt
    if (victim in const.NEBENQUEST_NPCS):
        if victim == "ALEXA":
            if (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_010, IMPOSSIBLE)
            elif (system.get_qb_entry_state(data().QB_011) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_011, IMPOSSIBLE)
    
        if victim == "ADIAN":
            if (system.get_qb_entry_state(data().QB_007) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_007, IMPOSSIBLE)
            elif (system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_008, IMPOSSIBLE)
    
        if victim == "MANNY":
            if (system.get_qb_entry_state(data().QB_012) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_012, IMPOSSIBLE)

        if victim == "MADISON":
            if (system.get_qb_entry_state(data().QB_013) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_013, IMPOSSIBLE)
            elif (system.get_qb_entry_state(data().QB_014) == UNCOMPLETE):
                system.set_qb_entry_state(data().QB_014, IMPOSSIBLE)

    if victim in data().GAUNER:
        for id in data().GAUNER:
            if not object.is_destroyed(id):
                object.set_attribute(id, "foes", ["UISPIELER"])
                attack_enemy(id)
    
    if victim in ['GENERAL_OF_THE_SHADOWS', 'GENERAL_GUARD_00', 'GENERAL_GUARD_01']:
        for char in data().SCHATTEN_NPCS:
            if not object.is_fighting(char):
#                if not object.is_destroyed(char):
#                    object.move_to_object(char, attacker)
                if not object.is_destroyed(char) and object.is_active(char):
                    if char != 'GENERAL_OF_THE_SHADOWS':
                        if attacker != None:
                            object.move_to_object(char, attacker)

def allCitizensMoveToMadison(id):
    for citizen in data().COPPERHILL_NPCS:
        if not citizen in ["KUH_1","KUH_2"]:
            prohibit_activity(citizen)
            object.cancel_commandos(citizen)
            object.move_to_object(citizen,"MADISON",speed=MT_FAST)
        else:
            object.move_to(citizen,object.get_x("MADISON")-5,object.get_y("MADISON")+1,"landscape",MT_SLOW)
    system.notify_timer(data().Timer_CitizenMoveHome,data().TimerValue_CitizenMoveHome)

def onCopperHillBefreitCitizensReturn():
    prohibit_activity("MADISON")
    object.move_to("MADISON",const.WAYPOINTS_CH_BEWOHNER[0][0],const.WAYPOINTS_CH_BEWOHNER[0][1],"landscape",MT_SLOW, callback=["ONEND",MadisonsCallsCitizens])

def MadisonsCallsCitizens(id):
    character.play_animation("MADISON","CM_NPC_STEHEN_HORN_BLASEN")
    character.play_animation("MADISON","CM_NPC_STEHEN_HORN_BLASEN",callback=["ONEND",allCitizensMoveToMadison])

def activateNPC(id):
    character.set_approachable_state(id,APPROACHABLE)

#######################################################################################################
#
# Anschauen von Objekten
#
#######################################################################################################
def can_examine_object( character_id, object_id ):
    if character_id == "ALTER_EGO":
        if object_id.rfind("Z6 DS_") != -1:
            return True
        if object_id.endswith(const.OBJ_APFELKORB) and character_id=="ALTER_EGO":
            return True
        if object_id.endswith("BUILDING_6196"):
            return True
        if object_id.endswith(const.OBJ_ERNTEROBOTER):
            return True
# calebs waescheleine
    if object_id.endswith(const.OBJ_WAESCHELEINE_CALEB):# code  linge de Caleb
        if character_id in system.get_pcs():return True
        else:
            if data().caleb_kleidung_benoetigt and not object.exists(const.QI_CALEB_CLOTH[0]):
                return True
    if (object_id.endswith(const.OBJ_GENERATOR_ALT) and not data().SteuereinheitAusgebaut):
        return True
#infopfahl sqzone_6
    if object_id == "ZONE_6_BUILDING_67187":
        return True
    return False

def pre_examine_object( character_id, object_id ):
    if object_id.endswith(const.OBJ_GENERATOR_ALT):
        if not data().SteuereinheitAusgebaut:
            object.set_attribute(object_id, "on_examine_coordinates", [322.43, 912.61,0])

def on_examine_object( character_id, object_id ):
# alter Generator, Steuereinheit ausbauen
    if (object_id.endswith(const.OBJ_GENERATOR_ALT)):
        if (data().GeneratorRepariert == 0 and system.get_qb_entry_state(data().QB_013) == UNCOMPLETE
            and not data().SteuereinheitAusgebaut):
            pc = cs.anyone_has_skill(const.SKILL_GENERATOR_QUEST[0],const.SKILL_GENERATOR_QUEST[1])
            if pc:
                if object.get_distance(pc,const.OBJ_GENERATOR_ALT) <= 50.0:
                    animAnGeraetbasteln(pc,const.OBJ_GENERATOR_ALT)
                else:pc=None
            dialogs.initDlg_056_SpielerKommentiertErsatzteilAusbau(pc)

        else:
            text = "EXAMINE_GENERATOR"
            comments.comment(character_id=character_id, text=text)

    if dialog.is_dialog_active():
        return True

#infopfahl sqzone_6
    if object_id == "ZONE_6_BUILDING_67187":
        if character_id in system.get_pcs():
            if not data().infopole_seen:
                dialogs.initDlg_153_SpielerUntersuchtInfoPfahl()
                data().infopole_seen = True
                return True
        comments.comment(character_id, "EXAMINE_INFOPOLE")

# calebs waescheleine
    if object_id.endswith(const.OBJ_WAESCHELEINE_CALEB):
        if not data().joshua_gesprochen:
            dialogs.initDlg_149_SpielerInteressiertSichNichtFuerWaescheleine()
        else:
            if (system.get_qb_entry_state(data().QB_004) in [INACTIVE,COMPLETE, IMPOSSIBLE] and 
                not system.get_qb_entry_state(data().QB_016) == UNCOMPLETE):
                dialogs.initDlg_150_SpielerInteressiertSichNichtFuerCalebsWaesche()
            else:
                if data().caleb_kleidung_benoetigt:
                    if not object.exists(const.QI_CALEB_CLOTH[0]):
                        if character_id in system.get_pcs():
                            dialogs.initDlg_151_SpielerInteressiertSichFuerCalebsWaesche()
                        else:
                            dialogs.mercenary_deny(character_id)
                    else:
                        dialogs.initDlg_150_SpielerInteressiertSichNichtFuerCalebsWaesche()
                else:
                    dialogs.initDlg_150_SpielerInteressiertSichNichtFuerCalebsWaesche()

    if object_id.rfind("Z6 DS_") != -1:
        if data().einwegspritzen_fuer_adian:
            dialogs.initDlg_130_SpielerUntersuchtEinwegSpritzen()
        else:
            dialogs.initDlg_092_SpielerUntersuchtEinwegSpritzenBrauchtSieAberNicht()

    if object_id.endswith(const.OBJ_ERNTEROBOTER):
        dialogs.initDlg_ErnteRoboter()

    if object_id.endswith(const.OBJ_APFELKORB):
        dialogs.initDlg_134_SpielerUntersuchtAepfel()


# Animation eines Chars, der am Generator basteln soll
def animAnGeraetbasteln(char_id, object_id):
    character.unequip_hands(char_id)
    if object_id == const.OBJ_GENERATOR_CH:
        object.move_to(char_id, 725.48,744.86)
        object.step_to(char_id, 725.48,744.86)
    elif object_id == const.OBJ_GENERATOR_ALT:
        pos = object.get_position(const.OBJ_GENERATOR_ALT)
        object.move_to(char_id, 323.41, 912.60)
        object.step_to(char_id, 322.32, 912.65)
    else:
        object.move_to(char_id,object.get_x(object_id),object.get_y(object_id), "landscape",MT_SLOW)
    object.turn_to_object(char_id,object_id)
    animateBasteln(char_id)
    if object_id == const.OBJ_GENERATOR_ALT:
        object.step_away(char_id)
    if (object_id == const.OBJ_GENERATOR_ALT and not data().SteuereinheitAusgebaut):
        object.create_item_in_inventory(char_id,"SET_GENERATOR_CONTROL_PANEL",data().obj_GeneratorSteuereinheit)
        object.set_attribute(object=data().obj_GeneratorSteuereinheit, attribute="generic_item", value=False)
        data().SteuereinheitAusgebaut = True
        cs.teleport_party(725,844)

def animateBasteln(_id):
    character.play_animation(_id, "CM_NPC_TIER_FUETTERN_START")
    character.play_animation(_id, "CM_NPC_TIER_FUETTERN_LOOP")
    character.play_animation(_id, "CM_NPC_TIER_FUETTERN_ENDE")
    character.play_animation(_id, "CM_PRAEPARIEREN_STEHEN_ANSCHRITT")
    character.play_animation(_id, "CM_PRAEPARIEREN_STEHEN_LOOP")
    character.play_animation(_id, "CM_PRAEPARIEREN_STEHEN_ENDSCHRITT")

#######################################################################################################
# Handeln
#######################################################################################################
def on_trade(target,operator):
    if target=="SUE":
        system.trading_screen(trader="SUE",char=operator)

#######################################################################################################
# Aktivities
#######################################################################################################
def on_wait_for_commando(id):
    if id == 'ANIE':print id
    return schedules.Activity(id)

def initVehicles():
    system.create_object("SET_HUMVEE", 667.0,  936.30, "CONVOY_CAR_1", 0)
    system.create_object("SET_HUMVEE", 663.85, 920.30, "CONVOY_CAR_2", 0)
    system.create_object("SET_HUMVEE", 668.15, 944.30, "CONVOY_CAR_3", 0)#mit general drin

#todo: add konvoi npcs to accepted_drivers attribute
    object.set_attribute("CONVOY_CAR_1","accepted_drivers",data().SCHATTEN_KONVOI_NPCS)
    object.set_attribute("CONVOY_CAR_2","accepted_drivers",data().SCHATTEN_KONVOI_NPCS)
    object.set_attribute("CONVOY_CAR_3","accepted_drivers",data().SCHATTEN_KONVOI_NPCS)

#######################################################################################################
# Initialisiert alle SpielerCharaktere der Entwickler
#######################################################################################################

def on_enemy_spotted(object_id):
    enemys = character.get_visible_enemies(object_id)
    if object_id in const.OBJ_CONVOY_CARS:
        if data().convoy_with_cars:
            convoy_stop_and_attack()
        return True

    if not enemys:
        return True

    if object_id in system.get_pcs():
        for enemy in enemys:
            if enemy in const.OBJ_CONVOY_CARS:
                return True

    if not hasattr(data(), "enemy_spotted"):
        data().enemy_spotted = []
    if not object_id in data().enemy_spotted:
        data().enemy_spotted.append(object_id)
    else:
        return True

    if system.is_cutscene() and not object_id in data().SCHATTEN_KONVOI_NPCS + const.OBJ_CONVOY_CARS:
        halt_char(object_id)

    if object.is_npc(object_id) and len(enemys):
        if object_id in schedules.schedules.keys():
            halt_char(object_id)

## Ratskulls am Lastwagen
        if object_id in data().RATSKULL_NPCS:
            if not data().ratskulls_alarmiert:
                dialogs.initDlg_146_RatskullsIstEmpoertUeberUeberfall(object_id)
                data().ratskulls_alarmiert = True
                for id in data().RATSKULL_NPCS:
                    if not object.is_destroyed(id):
                        attack_enemy(id,enemys)

        if object_id in data().SCHATTEN_KONVOI_NPCS:
            if not data().schattenkonvoi_spotted_players:
                dialogs.initDlg_142_DoppelgaengerGibtAnweisungen()
                data().schattenkonvoi_spotted_players = True
                for id in data().SCHATTEN_KONVOI_NPCS:
                    if not object.has_attribute(id, "foes"):
                        object.set_attribute(id,"foes",["UISPIELER"])
                    if not object.is_destroyed(id):
                        halt_char(id)
                        object.move_to_object(id, object_id)

        if ((object_id in data().SCHATTEN_CH_NPCS) or (object_id in data().SCHATTEN_CH_EXT_NPCS)):
            if not data().schatten_ch_alarmiert:
                data().schatten_ch_alarmiert = True
                dialogs.initCutscene_141_SchattenSindAlarmiert(object_id)

            if object_id in ["COPPERHILL_SHADOW_06","COPPERHILL_SHADOW_07","COPPERHILL_SHADOW_08"]:
                groupedAttack(["COPPERHILL_SHADOW_06","COPPERHILL_SHADOW_07","COPPERHILL_SHADOW_08"],enemys)

            if object_id in ["COPPERHILL_SHADOW_10", "COPPERHILL_SUPPORT_SHADOW_04"]:
                groupedAttack(["COPPERHILL_SHADOW_10", "COPPERHILL_SUPPORT_SHADOW_04"],enemys)

        if object_id in data().SCHATTEN_WEST_NPCS:
            if not data().schatten_waffenlager_alarmiert:
                data().schatten_waffenlager_alarmiert = True
                dialogs.initCutscene_141_SchattenSindAlarmiert(object_id)
            for char in data().SCHATTEN_WEST_NPCS:
                if not object.is_destroyed(char):
                    if not object.is_fighting(char):
                        attack_enemy(char, enemys)

        if object_id in data().GENERALTEAM_NPCS:
            if data().MitGeneralGesprochen == 0:
                data().MitGeneralGesprochen += 1
                for id in data().GENERALTEAM_NPCS:
                    if not object.is_destroyed(id):
                        object.cancel_commandos(id)
                        object.turn_to_object(id,"ALTER_EGO")
                if not object.is_destroyed("GENERAL_OF_THE_SHADOWS"):
                    object.cancel_commandos("GENERAL_OF_THE_SHADOWS")
                    object.turn_to_object("ALTER_EGO","GENERAL_OF_THE_SHADOWS")
                    dialogs.initDlg_010_General_SpottInit("GENERAL_OF_THE_SHADOWS")

        if (not object_id in system.get_pcs() and not object_id in data().RATSKULL_NPCS):
            if not object_id in system.get_animals():
                attack_enemy(object_id,enemys)
    elif object_id in data().SCHATTEN_KONVOI_NPCS or object_id in ['CONVOY_CAR_1', 'CONVOY_CAR_2', 'CONVOY_CAR_3']:
        for char in data().SCHATTEN_KONVOI_NPCS:
            if not object.is_destroyed(char):
                attack_enemy(char, enemys)

def on_attack(operator, target):
    if not hasattr(data(), "enemy_spotted"):
        data().enemy_spotted = []
    if not target in data().enemy_spotted:
        data().enemy_spotted.append(target)
    else:
        return None

    if target in const.OBJ_CONVOY_CARS:
        convoy_stop_and_attack()

    if target == 'GENERAL_OF_THE_SHADOWS':
        for char in data().SCHATTEN_CH_NPCS + data().SCHATTEN_CH_EXT_NPCS:
            if not object.is_fighting(char):
                if not object.is_destroyed(char):
                    object.move_to_object(char, operator)

    if operator in system.get_pcs():
        if target in const.GOE_NPCS:
            if system.get_qb_entry_state(data("zone_6.zone_6").QB_020) != IMPOSSIBLE:
                system.set_qb_entry_state(data("zone_6.zone_6").QB_020, IMPOSSIBLE)
            data("zone_6.zone_6").abraham_und_co_folgen = False
            for goe in const.GOE_NPCS:
                if goe in system.get_npcs():
                    object.set_attribute(goe,"zone_transfer",False)
                    if not object.is_destroyed(goe) and goe != 'MICKEY':
                        halt_char(goe)
                        character.arm_direct(goe)
                        object.set_attribute(goe, "foes", ["UISPIELER"])

    if system.is_cutscene():
        if not operator in data().SCHATTEN_KONVOI_NPCS + const.OBJ_CONVOY_CARS:
            object.cancel_commandos(operator)

    if target in data().SCHATTEN_KONVOI_NPCS:
        if not data().schattenkonvoi_spotted_players:
            dialogs.initDlg_142_DoppelgaengerGibtAnweisungen()
            data().schattenkonvoi_spotted_players = True
        if not data().convoy_stopped:
            data().convoy_stopped = True
            halt_char(target)
        for id in data().SCHATTEN_KONVOI_NPCS:
            if not object.is_destroyed(id):
                if not object.has_attribute(id, "foes"):
                    object.set_attribute(id,"foes",["UISPIELER"])
                if not object.is_destroyed(id):
                    halt_char(id)
                    object.move_to_object(id, operator)

def on_sector_cleared(object_id):
    return object_events.on_sector_cleared(object_id)
#if object.is_npc(object_id):
#    unhalt_char(object_id)

def halt_char(id):
    if not object.is_destroyed(id):
        object.cancel_commandos(id)
        prohibit_activity(id)
        cs.degaine(id)

def unhalt_char(id):
    if not object.is_destroyed(id):
        object.cancel_commandos(id)
        allow_activity(id)

def attack_enemy(id, enemys=None):
    if not object.is_destroyed(id):
        if enemys == None:
            enemys = character.get_visible_enemies(id)
        if enemys and len(enemys):
            halt_char(id)
            object.attack(id, random.choice(enemys))

def groupedAttack(group,enemys):
    for id in group:
        if not object.is_destroyed(id):
            halt_char(id)
            object.attack(id,random.choice(enemys))

def on_pick_up( character_id, item_id, item_type):
    if character_id == "ALTER_EGO":
        if item_id.rfind("Z6 DS_") != -1:
            if data().einwegspritzen_fuer_adian:
                dialogs.initDlg_131_SpielerNimmtEinwegSpritzen()
            else:
                dialogs.initDlg_132_SpielerNimmtEinwegSpritzenBrauchtSieAberNicht()

# Lesen der geheimen Dokumente
        if (item_id == data().obj_Geheimdokumente):
            if not data().SchattenbasisDokumenteGelesen:
                dialogs.initCutscene_012_SpielerLiestDokumenteZurSchattenBasis()
            return True

    if item_id == "Z6 GERDAS_APPLE":
        if not object.is_destroyed("GERDA"):
            if object.has_attribute(character_id,"pick_pocket"):
                if object.get_attribute(character_id,"pick_pocket") >= 70:
                    dialogs.initDlg_135_SpielerKlautEinenApfel(character_id)
                    return True
                else:
                    dialogs.initDlg_136_GerdaHindertSpielerApfelZuNehmen(character_id)
                    return False
        else:
            dialogs.initDlg_135_SpielerKlautEinenApfel(character_id)
            return True
    return True

# hinlegen von items
def on_put_down( character_id, item_id, item_type ):
    if character_id == "ALTER_EGO":
        if item_type == "SET_APPLE_VALIUM":
            if (rightAppleLocation() and system.get_qb_entry_state(data().QB_015) == UNCOMPLETE):
                data().obj_apple_put_down = item_id
                dialogs.initDlg_082_SpielerPlatziertDenApfel()

def rightAppleLocation():
    result = False
    for wildhorse in ["WILD_PFERD","WILD_PFERD_2","WILD_PFERD_3","WILD_PFERD_4"]:
        if not object.is_destroyed(wildhorse):
            dist = object.get_distance("ALTER_EGO", wildhorse)
            if dist <= 20.0:
                data().following_wildhorse = wildhorse
                result = True
    return result

# callback zum start einer cutscene
def on_begin_cutscene():

# make sure AE is available
    if object.is_unconscious("ALTER_EGO"):
        import object_events
        object_events.on_resuscitate("ALTER_EGO", "ALTER_EGO")

    mobs = system.get_pcs() + system.get_animals() + system.get_npcs()
    for mob in mobs:
        system_events.save_foes(mob)
        system_events.save_speedfactor(mob)
## alle nicht routenden chars stoppen
#        if not mob in [ data().SCHATTEN_CH_NPCS[4],   data().SCHATTEN_CH_NPCS[5],
#                data().SCHATTEN_CH_NPCS[11],  data().SCHATTEN_CH_NPCS[12],
#                data().SCHATTEN_WEST_NPCS[1], data().SCHATTEN_WEST_NPCS[6]]: #does not work, shadows could be dead and erased from list
        if not mob in ['COPPERHILL_SHADOW_04','COPPERHILL_SHADOW_05','COPPERHILL_SHADOW_11',  'COPPERHILL_SHADOW_12','WESTERNCAMP_SHADOW_01', 'WESTERNCAMP_SHADOW_06']:
            if not mob in data().SCHATTEN_KONVOI_NPCS + const.OBJ_CONVOY_CARS:
                if not mob in system.get_pcs():
                    object.cancel_commandos(mob)

        if hasattr(data(), "is_cbm_cutscene"):
            data().is_cbm_cutscene = True

        if data().is_cbm_cutscene:
            if mob in system.get_pcs():
                object.cancel_commandos(mob)
                character.change_body_mode(mob, "STAND")

        data().is_cbm_cutscene = True

    for id in (system.get_npcs() + system.get_animals()):
        object.set_attribute(id,"visibility",UIVIS_VISIBLE)
        object.set_attribute(id,"visibility_fade",False)


# callback zum ende einer cutscene
def on_end_cutscene():


    mobs = system.get_pcs() + system.get_animals() + system.get_npcs()
    for mob in mobs:
        system_events.restore_foes(mob)
        system_events.restore_speedfactor(mob)

    for id in (system.get_npcs() + system.get_animals()):
        object.set_attribute(id,"visibility_fade",True)

def init_convoy_childgang():
#ZONE_6_BUILDING_36999 (36999), type_id = 
    system.create_object('RES3D_TRES_OBJECTS_BUILDING_CONVOY', 
        x=323.0888671875, y=801.8590087890625, id="convoy_childgang_truck", direction=127.0)

#ZONE_6_BUILDING_62848 (62848), type_id =
    system.create_object('RES3D_TRES_OBJECTS_BUILDING_AMMOBOX_1', 
        x=316.31857299804687, y=788.93341064453125, id="convoy_childgang_ammobox", direction=303.000030518)

#ZONE_6_BUILDING_37001 (37001), type_id = 
    system.create_object('RES3D_TRES_OBJECTS_BUILDING_HUMVEE_CONVOI_1', 
        x=310.89138793945312, y=791.55718994140625, id="convoy_childgang_humvee_back", direction=316.0)
#ZONE_6_BUILDING_37000 (37000), type_id = 
    system.create_object('RES3D_TRES_OBJECTS_BUILDING_HUMVEE_CONVOI_3', 
        x=335.72216796875, y=813.2659912109375, id="convoy_childgang_humvee_front", direction=289.0)

#ZONE_6_BUILDING_5239 (5239), type_id = 
    system.create_object('RES3D_TRES_OBJECTS_BUILDING_SKELETT_3', 
        x=337.22930908203125, y=815.6331787109375, id="convoy_childgang_skeleton", direction=284.0)

def on_grid_enter(object_id, grid_id, old_grid_id):
    if object.is_pc(object_id):
        if grid_id == 'ZONE_6_BUILDING_6200_INTERIOR_GRID':
            data().hoehleneingang_gesehen = True
            if not data().CalebEntdeckt and system.get_qb_entry_state(data().QB_002) == COMPLETE and (system.get_qb_entry_state(data().QB_004) == UNCOMPLETE or system.get_qb_entry_state(data().QB_016) == UNCOMPLETE):
                dialogs.initDlg_008_CalebWillFliehen()
                if not data().player_knows_Versteck_Caleb:
                    data().player_knows_Versteck_Caleb = True
                    system.add_minimap_marker(732.12, 227.75,"MM_003")# Versteck von Caleb
            else:
                if not data().hoehleneingang_gesehen:
                    data().hoehleneingang_gesehen = True
                    dialogs.initDlg_080_SpielerFindetHoehleneingang()

    return object_events.on_grid_enter( object_id, grid_id, old_grid_id )

def InitChestsSafes():
    object.add_closed_lock("BUILDING_70721", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_70733", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_70827", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_70828", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_70913", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_70914", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_70915", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_70916", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_70930", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_70937", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_70964", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_70970", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_54817", "lock1", closure_type='normal')

def init_patch():
    if "ANIE" in system.get_npcs():
        if object.is_active("ANIE"):
            data("zone_7.zone_7").anie_folgt = True

    import npc_activities 

    if not hasattr(data(), 'convoy_secures_western_camp'):
        if not data().convoy_stopped:
            data().convoy_secures_western_camp = False
        else:
            data().convoy_secures_western_camp = True

    if 'MERCENARY_DEBORAH' in system.get_npcs():
        character.set_approachable_state('MERCENARY_DEBORAH', APPROACHABLE)

    if not hasattr(data('zone_7.zone_7'), 'QB_001'):
        data('zone_7.zone_7').QB_001 = -1
    if data('zone_7.zone_7').QB_001 == -1:
        data('zone_7.zone_7').QB_001 = system.register_qb_entry('ZONE7_AIM_01')

    if hasattr(data('zone_7.zone_7'), 'QB_001'):
        if data().SchattenbasisDokumenteGelesen and not system.get_qb_entry_state(data('zone_7.zone_7').QB_001) in [UNCOMPLETE, COMPLETE]:
            if not was_zone_entered("zone_7.zone_7"):
                system.set_qb_entry_state(data('zone_7.zone_7').QB_001, UNCOMPLETE)
    init_main_npcs()

# schedulesupdates

    if not hasattr(data('zone_6.zone_6'), 'CRUNCHY'):
        data('zone_6.zone_6').CRUNCHY = True

        if schedules.schedules.has_key('CRUNCHY'):
            del schedules.schedules['CRUNCHY']
            crunchy = {
                "CRUNCHY" : ({
                    S_CONDITION: lambda:data().copperhill_befreit == True,
                    "00:00:00" : { #schlafen
                        S_START  : [goto(639.7,956.8), 
                                enter_building("BUILDING_5923"),
                                lay_down_to_sleep()],
                        S_LOOP   : [sleep()]},
                    "06:00:00" : { #horn blasen am marktplatz
                        S_START  : [leave_building("BUILDING_5923"),
                                goto(715.73,858.78),
                                turn_to_direction(globals.DIR_SOUTH_EAST)],
                        S_LOOP   : [blow_horn()]},
                    "06:05:00" : { #gitarre spielen am marktplatz
                        S_DIALOG : "NPC_CRUNCHY_T_001",
                        S_START  : [goto_dummy("BUILDING_6186","dmyp_001"),
                                sit_down_on_bench()],
                        S_LOOP   : [play_guitar_on_bench()]},
                    "12:00:00" : { #am lagerfeuer stehen, warten
                        S_DIALOG : "NPC_CRUNCHY_T_002",
                        S_START  : [goto(743.36,886.41),
                                turn_to_object("BUILDING_6191")],
                        S_LOOP   : [stand()]},
                    "15:00:00" : { #flöte spielen am marktplatz
                        S_START  : [goto_dummy("BUILDING_6186","dmyp_001"),
                                sit_down_on_bench()],
                        S_LOOP   : [play_fluit_on_bench()]},
                    "20:00:00" : { #kochen
                        S_DIALOG : "NPC_CRUNCHY_T_003",
                        S_START  : [goto_dummy("BUILDING_6191","dmyp_004"),
                                sit_down_to_cook()],
                        S_LOOP   : [cook()]},
                    "21:00:00" : { #am lagerfeuer gitarre spielen
                        S_DIALOG : "NPC_CRUNCHY_T_004",
                        S_START  : [goto_dummy("BUILDING_6188","dmyp_003"),
                                sit_down_on_bench()],
                        S_LOOP   : [play_guitar_on_bench()]},
                    S_SECONDDIALOG : "NPC_CRUNCHY_T_005"
                    },{
#####
                    "00:00:00" : { #schlafen
                        S_START  : [goto(486.05, 867.23),
                                enter_building("BUILDING_3216"),
                                lay_down_to_sleep()],
                        S_LOOP   : [sleep()]},
                    "06:00:00" : { #horn blasen am marktplatz
                        S_START  : [leave_building("BUILDING_3216"),
                                    goto(488.47,867.46),
                                    turn_to_direction(globals.DIR_SOUTH_EAST)],
                        S_LOOP   : [blow_horn()]},
                    "06:15:00" : { #gitarre spielen am marktplatz
                        S_DIALOG : "NPC_CRUNCHY_FL_T_001",
                        S_START  : [goto_dummy("BUILDING_6178","dmyp_001"),
                                    sit_down_on_bench()],
                        S_LOOP   : [play_guitar_on_bench()]},
                    "12:00:00" : { #am lagerfeuer stehen, warten
                        S_DIALOG : "NPC_CRUNCHY_FL_T_002",
                        S_START  : [goto(511.99,842.79),
                                turn_to_object("BUILDING_2285")],
                        S_LOOP   : [stand()]},
                    "15:00:00" : { #flöte spielen am marktplatz
                        S_START  : [goto_dummy("BUILDING_6178","dmyp_001"),
                                sit_down_on_bench()],
                        S_LOOP   : [play_fluit_on_bench()]},
                    "20:00:00" : { #kochen
                        S_DIALOG : "NPC_CRUNCHY_FL_T_003",
                        S_START  : [goto_dummy("BUILDING_2285","dmyp_004"),
                                sit_down_to_cook()],
                        S_LOOP   : [cook()]},
                    "21:00:00" : { #am lagerfeuer gitarre spielen
                        S_DIALOG : "NPC_CRUNCHY_FL_T_004",
                        S_START  : [goto_dummy("BUILDING_6176","dmyp_003"),
                                sit_down_on_bench()],
                        S_LOOP   : [play_guitar_on_bench()]},
                    S_SECONDDIALOG : "NPC_CRUNCHY_FL_T_005"
                    })
                }
            schedules.schedules.update(crunchy)
# rajout car aprs avoir tu toutes les Ombres, on accde jamais  la qute du tranformateur
    if system.get_qb_entry_state(data().QB_005) == COMPLETE and \
        data().SchattenCopperHillGetoetet == len(data().SCHATTEN_NPCS) and \
        not data().copperhill_befreit:
        zone_6.onCopperHillBefreitCitizensReturn()

def init_main_npcs():
    npcs = system.get_npcs()
    if 'SUE' in npcs:
        character.set_main_quest_npc_state(char="SUE", state=True)
    if 'ABRAHAM' in npcs:
        character.set_main_quest_npc_state(char="ABRAHAM", state=True)
    if 'HORATIO' in npcs:
        character.set_main_quest_npc_state(char="HORATIO", state=True)

