# -*- coding: utf-8 -*-
from globals import *
from npc_activities import *
import const
import global_schedules

#*** actual revision - Revision 34, 9.09.2004 *********************************
def reporter_ta(num=-1):
	return lambda c: reporter_ta_executor(c, num)

def reporter_ta_executor(char, n):
	if n == -1:
		n = random.randint(2,3)
	if n == -2:
		n = random.randint(1,3)
	
	grid = "ZONE_7_BUILDING_485_INTERIOR_GRID"
	if n == 1:
		d = reporter_repair(char)
	elif n == 2:
		d = reporter_search_paper(char)
	elif n == 3:
		d = reporter_search_board(char)
	elif n == 4:
		d = reporter_sit_inside(char)
	elif n == 5:
		grid = "landscape"
		d = reporter_sit_outside(char)
	
	object.move_to(char, d[0], d[1], grid=grid, speed=MT_SLOW)
	object.turn_to_direction(char, d[2])
	reporter_work_executor(char, n)

def reporter_work_executor(char, n):
	if n in [4,5]:
		character.play_animation(char, "CM_NPC_SITZEN_BODEN_HINSETZEN")
		r = random.randint(0,500)
		if r < 100:
			character.play_animation(char, 'CM_NPC_SITZEN_BODEN_ESSEN_LOOP')
		elif r < 200:
			character.play_animation(char, 'CM_NPC_SITZEN_BODEN_TRINKEN_LOOP')
		else:
			character.play_animation(char, 'CM_NPC_SITZEN_BODEN_LOOP')
	elif n == 2:
		character.play_animation(char, 'CM_NPC_STEHEN_TIERTROG_FUELLEN_START')
		character.play_animation(char, 'CM_NPC_STEHEN_TIERTROG_FUELLEN_LOOP')
		character.play_animation(char, 'CM_NPC_STEHEN_TIERTROG_FUELLEN_ENDE')
	elif n == 3:
		character.play_animation(char, 'CM_STEHEN_NACH_OBEN_GREIFEN')
		character.play_animation(char, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN')
	else:
		r = random.randint(0,200)
		if r < 50:
			character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_START")
			character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_1")
			character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_2")
			character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_3")
			character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_ENDE")
		elif r < 150:
			character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_START")
			character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_1")
			character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_2")
			character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_3")
			character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_ENDE")
		else:
			character.play_animation(char, "CM_NPC_STEHEN_WARTEN_%i" %(random.randint(1,5)))

def reporter_repair(char):
	machines = [[534.552001953125, 224.99655151367187, 246.905822754],
				[535.02484130859375, 227.376953125, 155.96762085],
				[536.84063720703125, 223.9320068359375, 327.851959229],
				[529.452880859375, 222.92111206054687, 252.938903809],
				[539.16253662109375, 222.60723876953125, 36.3853607178]]
	return random.choice(machines)

def reporter_search_paper(char):
	search_paper = [[523.032470703125, 227.45597839355469, 231.739212036],
					[525.52587890625, 229.9364013671875, 153.168899536],
					[544.0262451171875, 224.3173828125, 228.668426514],
					[540.7344970703125, 226.00172424316406, 308.0597229]]
	return random.choice(search_paper)

def reporter_search_board(char):
	search_board = [[532.17242431640625, 218.89244079589844, 53.2561035156],
					[537.72369384765625, 218.99234008789062, 31.4591808319],
					[541.459716796875, 219.03561401367187, 295.884124756]]
	return random.choice(search_board)
	
def reporter_sit_inside(char):
	sit_inside = [[544.105712890625, 231.04109191894531, 141.278686523],
					[546.1221923828125, 228.43846130371094, 35.3341255188],
					[528.01788330078125, 230.74766540527344, 297.809631348]]
	return random.choice(sit_inside)
	
def reporter_sit_outside(char):
	sit_outside = [[517.52783203125, 230.31825256347656, 335.760742188],
					[518.3792724609375, 231.37641906738281, 130.172866821],
					[517.8843994140625, 232.59867858886719, 201.77734375]]
	return random.choice(sit_outside)

def working_on_plants_sound():
	return lambda c: sound_helper(c, 1)
	
def sound_helper(char, sound):
	if sound == 1:
		r = random.randint(0,10)
		if r <= 5:
			d = random.randint(0,10)
			if d <= 5:
				sounds.play_3d_sound_object(sfx_id="fissling_plants_1", object=char, loop = False)
			else:
				sounds.play_3d_sound_object(sfx_id="fissling_plants_2", object=char, loop = False)

def rupert_inspect_mummys():
	return lambda c: rupert_inspect_mummys_helper(c)

def rupert_inspect_mummys_helper(char):
	mummydata=[[258.0,209.8,"BUILDING_4262"],
			[231.8,221.8,"BUILDING_4267"],
			[245.5,220.0,"BUILDING_4261"],
			[258.9,230.5,"BUILDING_4264"],
			[258.9,230.5,"BUILDING_4265"]]
	mummy = random.choice(mummydata)
	object.move_to(char, mummy[0],mummy[1],speed=MT_SLOW, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID1")
	object.turn_to_object(char, mummy[2])
	r = random.randint(0,5)
	if r < 2:
		character.play_animation(char, "CM_STEHEN_TASCHENDIEBSTAHL_VORN")
	else:
		character.play_animation(char, "CM_NPC_TIER_FUETTERN_START")
		character.play_animation(char, "CM_NPC_TIER_FUETTERN_LOOP")
		character.play_animation(char, "CM_NPC_TIER_FUETTERN_ENDE")

def inspectShipyard():
	return lambda c: inspect_shipard_helper(c)

def inspect_shipard_helper(char):
	wp = random.choice(const.WAYPOINTS_PETE)
	x,y = wp[0],wp[1]
	ship = wp[2]
	object.move_to(object=char,x=x,y=y,grid='landscape',speed=MT_SLOW)
	object.turn_to_object(object=char,target_object=ship)
	return "perform_wait_command"
	
def pickWeeds():
	return lambda c: pick_weeds_helper(c)

def pick_weeds_helper(char):
	plant = random.choice(const.OBJECTS_TA_EMILY)
	object.move_to_object(object=char,target_object=plant, speed=MT_SLOW)
	
def craig_work_on_flughund():
	return lambda c: craig_work_on_flughund_helper(c)

def craig_work_on_flughund_helper(char):
	pos_under 		= [611.70, 418.00]
	pos_next_to 	= [612.80, 419.30]
	pos_in_front_of = [614.70, 418.80]
	r = random.randint(0,4)
	if r == 0:
		object.move_to(char, pos_next_to[0],pos_next_to[1], grid="landscape", speed=MT_SLOW)
		object.step_to(char, pos_next_to[0],pos_next_to[1], speed=MT_SLOW)
		object.turn_to_object(char, data().qi_flughund[0])
		character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_START")
		character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_1")
		character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_2")
		character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_3")
		character.play_animation(char, "CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_ENDE")
	elif r == 1:
		object.move_to(char, pos_next_to[0],pos_next_to[1], grid="landscape", speed=MT_SLOW)
		object.step_to(char, pos_under[0],pos_under[1], speed=MT_SLOW)
		object.turn_to_object(char, data().qi_flughund[0])
		character.play_animation(char, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START")
		character.play_animation(char, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP")
		character.play_animation(char, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP")
		character.play_animation(char, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP")
		character.play_animation(char, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_ENDE")
		object.step_away(char)
	else:
		object.move_to(char, pos_in_front_of[0],pos_in_front_of[1], grid="landscape", speed=MT_SLOW)
		object.step_to(char, pos_in_front_of[0],pos_in_front_of[1], speed=MT_SLOW)
		object.turn_to_object(char, data().qi_flughund[0])
		character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_START")
		character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_1")
		character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_2")
		character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_3")
		character.play_animation(char, "CM_NPC_MOTORRAD_SCHRAUBEN_ENDE")

def switchCondition(id):
	if id == "EMILY":
		if (system.get_qb_entry_state(data().QB_010) == COMPLETE and system.get_qb_entry_state(data().QB_011) == COMPLETE):
			return 0
		else:
			return 1

	elif id == "ANDREW":
		if not data().andrew_museums_ta_aktiv:
			return 0
		else:
			return 1

	elif id == "CONNY":
		if not data().conny_aufwegzuemily:
			return 0
		else:
			return 1

	elif id == "CRAIG":
		if (data().craigbrad_craigarbeitetanflughund and 
			not data().craigbrad_flughund_fertig and
			not data().craigbrad_flughund_zerstoert):
			return 0
		elif (not data().craigbrad_craigarbeitetanflughund  and
			not data().craigbrad_flughund_zerstoert):
			return 1
		else:
			return 2

	elif id == "BRAD":
		if ((not system.get_qb_entry_state(data().QB_006)==COMPLETE)
			and data().craigbrad_flughund_zerstoert
			and data().craigbrad_ta_aktiv):
			return 0
		else:
			return 1

def checked_weapon_equip(char_id):
	#print "checked_weapon_equip(",char_id,")"
	import character
	inventory = object.get_inventory_ids(char_id)
	weapons = []
	found = False
	for item in inventory:
		if len(item[0]):
			item_type = item[0][0]
			if object.has_attribute(item_type, "weapon_type"):
				if character.is_equiped(char=char_id, equipment=item_type):
					found = True
				else:
					weapons.append(item_type)
	if not found and len(weapons):
		#print ">> no weapon found for",str(char_id),"equipping",str(weapons[0])
		character.equip_direct(char_id, weapons[0])
	else:
		pass
		"""
		if not len(weapons):
			print "schedules.py: Keine WAFFE im Inventory", char_id
		else:
			print "schedules.py: WAFFE SCHON EQUIPPED", char_id, weapons[0]
		"""

##########################
### Tagesabläufe:
##########################
schedules = {}

def init_schedules():
	global schedules
	schedules = {
# reporter und seine boten
"REPORTER"	:	{
	"06:21:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta()],
	},
	"10:34:00"	:	{
		S_START	:	[goto(519.76, 227.71),
						turn_to_direction(globals.DIR_WEST),
						sit_down_on_ground()],
		S_LOOP	:	[sit_on_ground()],
	},
},
"BOTE_1"	:	{
	"04:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(2)],
	},
	"10:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(1)],
	},
	"14:00:00"	:	{
		S_START	:	[reporter_ta(4)],
		S_LOOP	:	[sit_on_ground(["drink", "eat"])],
	},
	"22:00:00"	:	{
		S_START	:	[reporter_ta(5)],
		S_LOOP	:	[sit_on_ground()],
	},
},
"BOTE_2"	:	{
	"05:40:00"	:	{
		S_START	:	[reporter_ta(5)],
		S_LOOP	:	[sit_on_ground(["drink", "eat"])],
	},
	"11:20:40"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(1)],
	},
	"16:25:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(2)],
	},
	"20:15:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(3)],
	},
},
"BOTE_3"	:	{
	"06:50:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(1)],
	},
	"12:14:00"	:	{
		S_START	:	[reporter_ta(4)],
		S_LOOP	:	[sit_on_ground()],
	},
	"16:40:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(-1)],
	},
	"21:34:00"	:	{
		S_START	:	[reporter_ta(5)],
		S_LOOP	:	[sit_on_ground(["eat", "drink"])],
	},
},
"BOTE_4"	:	{
	"03:30:00"	:	{
		S_START	:	[reporter_ta(4)],
		S_LOOP	:	[sit_on_ground()],
	},
	"07:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(1)],
	},
	"14:00:00"	:	{
		S_START	:	[reporter_ta(5)],
		S_LOOP	:	[sit_on_ground(["eat"])],
	},
	"23:10:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(-2)],
	},
},
"BOTE_5"	:	{
	"05:25:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(-2)],
	},
	"11:11:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(1)],
	},
	"15:43:00"	:	{
		S_START	:	[reporter_ta(4)],
		S_LOOP	:	[sit_on_ground()],
	},
	"20:10:00"	:	{
		S_START	:	[reporter_ta(5)],
		S_LOOP	:	[sit_on_ground()],
	},
},
"BOTE_6"	:	{
	"05:12:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(1)],
	},
	"12:43:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(-2)],
	},
	"16:00:00"	:	{
		S_START	:	[reporter_ta(4)],
		S_LOOP	:	[sit_on_ground(['eat','drink','sit'])],
	},
	"19:45:00"	:	{
		S_START	:	[],
		S_LOOP	:	[reporter_ta(-1)],
	},
},
# geiseln der schatten
################################################
"GEISEL_1"	:	({
	S_CONDITION	: lambda: data().hostages_rescued == False,
	"00:00:00"	:	{
		S_START	:	[set_position(606.0, 356.0, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID")],
		S_LOOP	:	[goto(606.0, 356.0, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID"),
					stand(),
					stand(),
					goto(606.0, 355.0, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID"), 
					stand(), 
					goto(606.0, 352.0, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID"),
					stand(),
					stand(),
					stand()]
	}
},{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[conversate(["GEISEL_5","GEISEL_2","GEISEL_3","GEISEL_4"])]
	}
}),
"GEISEL_2"	:	({
	S_CONDITION	: lambda: data().hostages_rescued == False,
	"00:00:00"	:	{
		S_START	:	[set_position(605.5, 352.5, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID"),
						sit_down_to_play_cards()],
		S_LOOP	:	[play_cards()]
	}
},{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[conversate(["GEISEL_5","GEISEL_1","GEISEL_3","GEISEL_4"])]
	}
}),
"GEISEL_3"	:	({
	S_CONDITION	: lambda: data().hostages_rescued == False,
	"00:00:00"	:	{
		S_START	:	[set_position(605.0, 355.0, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID")],
		S_LOOP	:	[stand(), 
					stand(), 
					stand()]
	}
},{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[conversate(["GEISEL_5","GEISEL_2","GEISEL_1","GEISEL_4"])]
	}
}),
"GEISEL_4"	:	({
	S_CONDITION	: lambda: data().hostages_rescued == False,
	"00:00:00"	:	{
		S_START	:	[set_position(608.5, 352.5, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID")],
		S_LOOP	:	[conversate("GEISEL_5")]
	}
},{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[conversate(["GEISEL_5","GEISEL_2","GEISEL_3","GEISEL_1"])]
	}
}),
"GEISEL_5"	:	({
	S_CONDITION	: lambda: data().hostages_rescued == False,
	"00:00:00"	:	{
		S_START	:	[set_position(607.0, 353.0, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID")],
		S_LOOP	:	[conversate("GEISEL_4")]
	}
},{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[conversate(["GEISEL_1","GEISEL_2","GEISEL_3","GEISEL_4"])]
	}
}),
"ANIE"	:	({
	S_CONDITION	: lambda: data().hostages_rescued == False,
	"00:00:00"	:	{
		S_START	:	[set_position(605.5, 355.5, grid="ZONE_7_BUILDING_2405_INTERIOR_GRID"),
						start_kneel()],
		S_LOOP	:	[kneel()]
	}
},{
	S_CONDITION : lambda: data().anie_folgt == True,
	"00:00:00" : {
		S_START : [],
		S_LOOP  : [global_schedules.follow_in_distance("ALTER_EGO")],
	}
}),

# schatten npcs
################################################
"SHADOW_03"	:	{#kocht
	"00:00:00"	:	{
		S_START	:	[goto_dummy("BUILDING_1436","dmyp_001"),
					sit_down_to_cook()],
		S_LOOP	:	[cook()]
	}
},

"SHADOW_04"	:	{#isst + trinkt
	"00:00:00"	:	{
		S_START	:	[goto(531.0,419.32),
					stepto(531.0,419.32),
					sit_down_on_bench()],
		S_LOOP	:	[sit_on_bench(["eat","sit","drink"])]
	}
},

"SHADOW_05"	:	{#konversation mit shadow_06
	"00:00:00"	:	{
		S_START	:	[goto_object("SHADOW_06"),
					turn_to_object("SHADOW_06")],
		S_LOOP	:	[conversate("SHADOW_06")]
	}
},

"SHADOW_06"	:	{#konversation mit shadow_05
	"00:00:00"	:	{
		S_START	:	[goto_object("SHADOW_05"),
					turn_to_object("SHADOW_05")],
		S_LOOP	:	[conversate("SHADOW_05")]
	}
},

"SHADOW_07"	:	{#reinigt waffe
	"00:00:00"	:	{
		S_START	:	[lambda c:checked_weapon_equip(c),
						start_clean_weapon()],
		S_LOOP	:	[clean_weapon()]
	}
},

"SHADOW_12"	:	{#reinigt waffe
	"00:00:00"	:	{
		S_START	:	[lambda c:checked_weapon_equip(c),
						start_clean_weapon()],
		S_LOOP	:	[clean_weapon()]
	}
},

"SHADOW_08"	:	{#kocht
	"00:00:00"	:	{
		S_START	:	[goto_dummy("BUILDING_1273","dmyp_001"),
					sit_down_to_cook()],
		S_LOOP	:	[cook()]
	}
},

"SHADOW_09"	:	{#isst
	"00:00:00"	:	{
		S_START	:	[goto_dummy("BUILDING_1274","dmyp_001"),
					sit_down_on_bench()],
		S_LOOP	:	[sit_on_bench(["drink","sit","eat"])]
	}
},

"SHADOW_10"	:	{#wartet
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[stand()]
	}
},

"SHADOW_11"	:	{#kocht
	"00:00:00"	:	{
		S_START	:	[goto_dummy("BUILDING_1273","dmyp_003"),
					sit_down_to_cook()],
		S_LOOP	:	[cook()]
	}
},

"SHADOW_17"	:	{#sitze auf dem lokus
	"00:00:00"	:	{
		S_START	:	[goto_dummy("BUILDING_1885","dmyp_001"),
						stepto(636.19,395.44),
						turn_to_direction(200),
						sit_down_on_bench()],
		S_LOOP	:	[sit_on_bench()]
	}
},

## schatten patrouillen
"SHADOW_P1" :	{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[patrol(points=const.WAYPOINTS_SCHATTEN[1], speed=MT_SLOW)]
	}
},

"SHADOW_P2" :	{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[patrol(points=const.WAYPOINTS_SCHATTEN[1], speed=MT_SLOW)]
	}
},

# verlassene hafenstadt
################################################
"ANDREW" : ({
	S_CONDITION: lambda: not data().andrew_visible,
	"00:00:00" : {
		S_START : [enter_building("BUILDING_217"),
					lay_down_to_sleep(bed='BUILDING_10694', approachable=True)],
		S_LOOP  : [sleep()]
	}},{
######
	S_CONDITION: lambda: not data().andrew_museums_ta_aktiv and data().andrew_visible,
	"02:30:00" : { #kochen
		S_LOCATION : 1,
		S_START  : [leave_building("BUILDING_217"),
				goto_dummy("BUILDING_664","dmyp_003"),
			   	sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"05:00:00" : { #kran sitzen warten
		S_LOCATION : 2,
		S_START  : [goto_dummy("BUILDING_335","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"20:30:00" : { #kran stehen waren
		S_LOCATION : 3,
		S_START  : [goto((489.5,476.5)),
				turn_to_direction(globals.DIR_NORTH_EAST)],
		S_LOOP   : [stand()]},
	"23:00:00" : { #schlafen
		S_LOCATION : 4,
		S_START  : [goto((484.42,476.7)),
				enter_building("BUILDING_217"),
			   	lay_down_to_sleep(bed='BUILDING_10694', approachable=True)],
		S_LOOP   : [sleep()]},
},{
	"23:30:00" : { #Aktion: Schlafen
		S_LOCATION : 1,
		S_START : [enter_building("BUILDING_2421"),
				lay_down_to_sleep("BUILDING_4419", approachable=True)],
		S_LOOP  : [sleep()]},
	"02:30:00" : { #Aktion: im MBA herumlaufen, hier und da etwas basteln
		S_LOCATION : 2,
		S_START : [goto(231.0,211.0, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID4"),
				turn_to_direction(globals.DIR_SOUTH)],
		S_LOOP  : [stand()]},
	"05:00:00" : { #Aktion: im MBA an Werkbank stehen, basteln
		S_LOCATION : 3,
		S_START : [goto(232.0,233.0, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID5"),
				turn_to_direction(globals.DIR_NORTH)],
		S_LOOP  : [pick_pocket()]},
	"20:30:00" : { #Aktion: Konversation mit Rupert im MBA
		S_LOCATION : 4,
		S_START : [goto(246.9,220.8,grid="ZONE_7_BUILDING_2421_INTERIOR_GRID1"),
				turn_to_object("RUPERT")],
		S_LOOP  : [conversate("RUPERT")]},
}),

"CONNY" : ({
######
	S_CONDITION : lambda: not data().conny_beiemily,
	"04:00:00" : { #auf bank sitzen
		S_LOCATION : 1,
		S_START  : [leave_building("BUILDING_476"),
				goto_dummy("BUILDING_512","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"06:00:00" : { #vor haus stehen warten
		S_LOCATION : 2,
		S_START  : [goto((370.4,570.4)),
				turn_to_direction(globals.DIR_SOUTH_EAST)],
		S_LOOP   : [stand()]},
	"19:00:00" : { #holz hacken
		S_LOCATION : 3,
		S_START  : [goto_dummy("BUILDING_513","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"01:00:00" : { #schlafen
		S_LOCATION : 4,
		S_START  : [goto((370.4,570.4)),
				enter_building("BUILDING_476"),
				lay_down_to_sleep(bed="BUILDING_4384")],
		S_LOOP   : [sleep()]},
},{
	"00:00:00" : {
		S_START  : [goto_dummy("BUILDING_1273","dmyp_007"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
}),
# todo: ta für conny bei emily

"RUPERT" : ({
######
	S_CONDITION: lambda: not data().rupert_museums_ta_aktiv,
	"03:00:00" : { #rumlaufen
		S_LOCATION : 1,
		S_START  : [leave_building("BUILDING_2421")],
		S_LOOP   : [lambda _c_:goto(random.choice(const.WARYPOINTS_TA_RUPERT))(_c_), 
						stand(),
						stand(),
						stand()]},
	"04:30:00" : { #stehen warten
		S_LOCATION : 2,
		S_START  : [goto((267.45,221.34)),
					turn_to_direction(globals.DIR_EAST)],
		S_LOOP   : [stand()]},
	"20:30:00" : { #essen und trinken
		S_LOCATION : 3,
		S_START  : [goto(236.25,240.7),
					stepto(235.7,240.6),
					turn_to_direction(globals.DIR_EAST),
					sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["eat","drink","sit"])]},
	"23:00:00" : { #schlafen
		S_LOCATION : 4,
		S_START : [enter_building("BUILDING_2421"),
					lay_down_to_sleep("BUILDING_4420")
					],
		S_LOOP  : [	sleep()]},
},{
	"23:30:00" : { #schlafen
		S_LOCATION : 1,
		S_START : [enter_building("BUILDING_2421"),
					lay_down_to_sleep("BUILDING_4420", approachable=True)],
		S_LOOP  : [sleep()]},
	"03:00:00" : { #Aktion: Essen und Trinken im extra Raum des MBA
		S_LOCATION : 2,
		S_START : [leave_building("BUILDING_2421"),
					goto_dummy("BUILDING_4319","dmyp_001", speed=MT_SLOW),
					sit_down_on_bench()],
		S_LOOP  : [sit_on_bench(["eat","sit","drink"])]},
	"04:30:00" : { #Aktion: im MBA Mumien besichtigen
		S_LOCATION : 3,
		S_START : [],
		S_LOOP  : [rupert_inspect_mummys()]},
	"20:30:00" : { #Aktion: Konversation mit Andrew im MBA
		S_LOCATION : 4,
		S_START : [goto(245.3,220.7,grid="ZONE_7_BUILDING_2421_INTERIOR_GRID1"),
					turn_to_object("ANDREW")],
		S_LOOP  : [conversate("ANDREW")]}
}),

# vesseltown
################################################

"EMILY" : ({
######
	S_CONDITION: lambda: system.get_qb_entry_state(data().QB_008)==COMPLETE,
	"02:00:00" : { #kochen
		S_LOCATION : 1,
		S_START  : [leave_building("BUILDING_1126"),
				goto_dummy("BUILDING_1273","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"04:30:00" : { #stehen warten oder an den canupla pflanzen basteln (wenn quest beendet)
		S_LOCATION : 2,
		S_START  : [lambda c: object.step_away(c)],
		S_LOOP   : [pickWeeds(),
				start_gut_body(),
				gut_body(),
				working_on_plants_sound()]},
	"21:00:00" : { #kochen
		S_LOCATION : 3,
		S_START  : [goto_dummy("BUILDING_1273","dmyp_005"),
			   	sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { #schlafen
		S_LOCATION : 4,
		S_START  : [goto((624.3,497.8)),
				enter_building("BUILDING_1126"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
},{
	"02:00:00" : { #kochen
		S_LOCATION : 1,
		S_START  : [goto_dummy("BUILDING_1273","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},	
}),

"HARRY" : ({
######
	S_CONDITION: lambda: system.get_qb_entry_state(data().QB_008)==COMPLETE,
	"02:30:00" : { #herumlaufen
		S_START  : [leave_building("BUILDING_1126")],
		S_LOOP   : [lambda _c_:goto(random.choice(const.WAYPOINTS_TA_HARRY))(_c_),
				stand(),
				stand(),
				stand()]},
	"04:30:00" : { #stehen warten
		S_START  : [goto_object("EMILY"),
				turn_to_object("EMILY")],
		S_LOOP   : [stand()]},
	"21:00:00" : { #essen und trinken
		S_START  : [goto_dummy("BUILDING_1274","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["eat","drink","sit"])]},
	"23:30:00" : { #schlafen
		S_START  : [goto((624.3,497.8)),
				enter_building("BUILDING_1126"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
},{
	"04:30:00" : { #bei emily stehen warten
		S_START  : [],
		S_LOOP   : [goto_object("EMILY"),
				turn_to_object("EMILY"),
				stand()]},
}),

"LARRY" : ({
######	
	S_CONDITION: lambda: system.get_qb_entry_state(data().QB_008)==COMPLETE,
	"02:00:00" : { #am lagerfeuer sitzen warten
		S_START  : [leave_building("BUILDING_1126"),
				goto_dummy("BUILDING_1274","dmyp_003"), 
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"04:30:00" : { #bei emily stehen warten
		S_START  : [goto_object("EMILY"),
				turn_to_object("EMILY")],
		S_LOOP   : [stand()]},
	"21:00:00" : { #bei emily sitzen essen und trinken
		S_START  : [goto_object("EMILY"),
				turn_to_object("EMILY"), sit_down_on_ground()],
		S_LOOP   : [sit_on_ground(["eat","drink","sit"])]},
	"22:30:00" : { #schlafen
		S_START  : [goto((624.3,497.8)),
				enter_building("BUILDING_1126"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
},{
	"04:30:00" : { #bei emily stehen warten
		S_START  : [],
		S_LOOP   : [goto_object("EMILY"),
				turn_to_object("EMILY"),
				stand()]},
}),

"CRAIG" :
({ ## ta 1 vor und während des quests
	S_CONDITION  : lambda: switchCondition("CRAIG") == 0,
	"00:00:00": {
		S_LOCATION : 1,
		S_START	: [goto_object(data().qi_flughund[0]),
					turn_to_object(data().qi_flughund[0])],
		S_LOOP	: [craig_work_on_flughund()]
	}
},
{ ## ta 2 vor und während des quests
	S_CONDITION  : lambda: switchCondition("CRAIG") == 1,
	"00:00:00": {
		S_LOCATION : 1,
		S_START	: [goto(517.5, 475.4),
					turn_to_object(const.OBJ_STRIPPE)],
		S_LOOP	: [stand()]
	}
},
## todo: schlafen, bett
{ ## ta 2 nach questende
######
	S_CONDITION  : lambda: switchCondition("CRAIG") == 2,
	"04:30:00" : { #kochen
		S_LOCATION : 1,
		S_START  : [leave_building("BUILDING_1912"),
					goto_dummy("BUILDING_664","dmyp_003"), 
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { #am kran stehen
		S_LOCATION : 2,
		S_START  : [goto(492.32, 484.26),
					turn_to_direction(globals.DIR_EAST)],
		S_LOOP   : [stand()]},
	"21:00:00" : { #am kran sitzen
		S_LOCATION : 3,
		S_START  : [goto_dummy("BUILDING_335","dmyp_001"),
					sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"00:30:00" : { #schlafen
		S_LOCATION : 4,
		S_START  : [goto(484.42,476.7),
					enter_building("BUILDING_1912"),
					lay_down_to_sleep(bed='BUILDING_10678', approachable=True)],
		S_LOOP   : [sleep()]},
}),

"BRAD" : {
## todo: schlafen, bett
######
	S_CONDITION: lambda:(system.get_qb_entry_state(data().QB_006)==COMPLETE),
	"04:00:00" : { #essen und trinken
		S_LOCATION : 1,
		S_START  : [leave_building("BUILDING_1912"),
					goto_dummy("BUILDING_335","dmyp_001"), 
					sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","eat","drink"])]},
	"05:20:00" : { #bei craig sitzen, warten
		S_LOCATION : 2,
		S_START  : [goto_object("CRAIG"),
					turn_to_object("CRAIG"),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"22:30:00" : { #am flughund sitzen, warten
		S_LOCATION : 3,
		S_START  : [goto_object(data().qi_flughund[0]),
					turn_to_object(data().qi_flughund[0]),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"01:00:00" : { #schlafen
		S_LOCATION : 4,
		S_START  : [goto(484.42,476.7),
					enter_building("BUILDING_1912"),
					lay_down_to_sleep(bed='BUILDING_10676')],
		S_LOOP   : [sleep()]},
},

### normale tas
"AMBROSIUS" : {
#####
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_AMBROSIUS_T_001",
		S_START  : [leave_building("BUILDING_1517"),
				goto_dummy("BUILDING_1423","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit", "eat", "drink"])]},
	"06:00:00" : { #stehen, predigen
		S_DIALOG : "NPC_AMBROSIUS_T_002",
		S_START  : [goto((663.55,492.29))],
		S_LOOP   : [conversate()]},
	"12:00:00" : { #jünger segnen
		S_DIALOG : "NPC_AMBROSIUS_T_003",
		S_START  : [lambda _c_:goto_object(random.choice(const.NPCS_WITH_AMBROSIUS))(_c_),
				conversate()],
		S_LOOP   : [lambda _c_:goto_object(random.choice(const.NPCS_WITH_AMBROSIUS))(_c_),
				conversate()]},
	"15:00:00" : { #stehen, predigen
		S_DIALOG : "NPC_AMBROSIUS_T_004",
		S_START  : [goto((663.55,492.29))],
		S_LOOP   : [conversate()]},
	"21:30:00" : { #kochen
		S_DIALOG : "NPC_AMBROSIUS_T_005",
		S_START  : [goto_dummy("BUILDING_1424","dmyp_002"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { #gitarre spielen
		S_DIALOG : "NPC_AMBROSIUS_T_006",
		S_START  : [goto_dummy("BUILDING_1423","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	"00:00:00" : { #schlafen
		S_START  : [goto(620.45,582.67), 
				enter_building("BUILDING_1517"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_AMBROSIUS_T_007"
},

"ALFRED" : {
#####
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_ALFRED_T_001",
		S_START  : [leave_building("BUILDING_1415"),
				goto_dummy("BUILDING_1422","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit", "eat", "drink"])]},
	"06:00:00" : { #stehen, zuhören
		S_DIALOG : "NPC_ALFRED_T_002",
		S_START  : [goto(659.76,495.75)],
		S_LOOP   : [stand()]},
	"12:00:00" : { #stehen, zuhören, hinknien, wenn Ambrosius kommt
		S_DIALOG : "NPC_ALFRED_T_003",
		S_START  : [goto(659.76,495.75)],
		S_LOOP   : [stand()]},
	"15:00:00" : { #stehen, zuhören
		S_DIALOG : "NPC_ALFRED_T_004",
		S_START  : [goto(659.76,495.75)],
		S_LOOP   : [stand()]},
	"21:30:00" : { #essen + trinken
		S_DIALOG : "NPC_ALFRED_T_005",
		S_START  : [goto_dummy("BUILDING_1422","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["eat","sit","drink"])]},
	"23:00:00" : { #sitzen, zuhören
		S_DIALOG : "NPC_ALFRED_T_006",
		S_START  : [goto(664.0,505.15),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"00:00:00" : { #schlafen
		S_START  : [goto(586.4,410.82), 
				enter_building("BUILDING_1415"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_ALFRED_T_007"
},

"JENSON" : {
#####
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_JENSON_T_001",
		S_START  : [leave_building("BUILDING_1416"),
				goto_dummy("BUILDING_1422","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit", "eat", "drink"])]},
	"06:00:00" : { #stehen, zuhören
		S_DIALOG : "NPC_JENSON_T_002",
		S_START  : [goto(661.32,496.2)],
		S_LOOP   : [stand()]},
	"12:00:00" : { #stehen, zuhören, hinknien, wenn Ambrosius kommt
		S_DIALOG : "NPC_JENSON_T_003",
		S_START  : [goto(661.32,496.2)],
		S_LOOP   : [stand()]},
	"15:00:00" : { #stehen, zuhören
		S_DIALOG : "NPC_JENSON_T_004",
		S_START  : [goto(661.32,496.2)],
		S_LOOP   : [stand()]},
	"21:30:00" : { #essen + trinken
		S_DIALOG : "NPC_JENSON_T_005",
		S_START  : [goto_dummy("BUILDING_1422","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["eat","sit","drink"])]},
	"23:00:00" : { #sitzen, zuhören
		S_DIALOG : "NPC_JENSON_T_006",
		S_START  : [goto(665.2,501.3),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"00:00:00" : { #schlafen
		S_START  : [goto(587.6,415.5), 
				enter_building("BUILDING_1416"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_JENSON_T_007"
},

"KLAUS" : {
#####
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_KLAUS_T_001",
		S_START  : [leave_building("BUILDING_1415"),
				goto_dummy("BUILDING_1422","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit", "eat", "drink"])]},
	"06:00:00" : { #stehen, zuhören
		S_DIALOG : "NPC_KLAUS_T_002",
		S_START  : [goto(663.73,496.81)],
		S_LOOP   : [stand()]},
	"12:00:00" : { #stehen, zuhören, hinknien, wenn Ambrosius kommt
		S_DIALOG : "NPC_KLAUS_T_003",
		S_START  : [goto(663.73,496.81)],
		S_LOOP   : [stand()]},
	"15:00:00" : { #stehen, zuhören
		S_DIALOG : "NPC_KLAUS_T_004",
		S_START  : [goto(663.73,496.81)],
		S_LOOP   : [stand()]},
	"21:30:00" : { #essen + trinken
		S_DIALOG : "NPC_KLAUS_T_005",
		S_START  : [goto_dummy("BUILDING_1422","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["eat","sit","drink"])]},
	"23:00:00" : { #sitzen, zuhören
		S_DIALOG : "NPC_KLAUS_T_006",
		S_START  : [goto(663.7,507.15),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"00:00:00" : { #schlafen
		S_START  : [goto(586.4,410.82), 
				enter_building("BUILDING_1415"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_KLAUS_T_007"
},

"JUANITA" : {
#####
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_JUANITA_T_001",
		S_START  : [leave_building("BUILDING_386"),
				goto_dummy("BUILDING_1117","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit", "eat", "drink"])]},
	"06:00:00" : { #kochen
		S_DIALOG : "NPC_JUANITA_T_002",
		S_START  : [goto_dummy("BUILDING_1113","dmyp_001"), sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_JUANITA_T_003",
		S_START  : [goto_dummy("BUILDING_1117","dmyp_001"), sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit", "eat", "drink"])]},
	"15:00:00" : { #auf bank sitzen
		S_DIALOG : "NPC_JUANITA_T_004",
		S_START  : [goto_dummy("BUILDING_1116","dmyp_001"), sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"21:30:00" : { #kochen
		S_DIALOG : "NPC_JUANITA_T_005",
		S_START  : [goto_dummy("BUILDING_1113","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { #essen + trinken
		S_DIALOG : "NPC_JUANITA_T_006",
		S_START  : [goto_dummy("BUILDING_1117","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"00:00:00" : { #schlafen
		S_START  : [goto(621.7,516.8), 
				enter_building("BUILDING_386"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_JUANITA_T_007"
},

"HANNES" : {
#####
	"05:00:00" : { #essen + trinken
		S_DIALOG : "NPC_HANNES_T_001",
		S_START  : [leave_building("BUILDING_386"),
				goto_dummy("BUILDING_1118","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"07:30:00" : { #holz hacken
		S_DIALOG : "NPC_HANNES_T_002",
		S_START  : [goto_dummy("BUILDING_1420","dmyp_001"), start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"12:00:00" : { #am lagerfeuer sitzen
		S_DIALOG : "NPC_HANNES_T_003",
		S_START  : [goto_dummy("BUILDING_1113","dmyp_002"),turn_to_object("BUILDING_1113"),sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"15:00:00" : { #jagen
		S_DIALOG : "NPC_HANNES_T_004",
		S_START  : [goto(722.5,585.2), start_hunt()],
		S_LOOP   : [hunt()]},
	"19:30:00" : { #essen + trinken
		S_DIALOG : "NPC_HANNES_T_005",
		S_START  : [end_hunt(),
				goto_dummy("BUILDING_1118","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"21:30:00" : { #loch graben
		S_DIALOG : "NPC_HANNES_T_006",
		S_START  : [goto(623.2,544.06),
				start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"23:00:00" : { #schlafen
		S_START  : [goto(621.7,516.8), 
				enter_building("BUILDING_386"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_HANNES_T_007"
},

"SVETLANA" : {
#####
	"05:30:00" : { #essen + trinken
		S_DIALOG : "NPC_SVETLANA_T_001",
		S_START  : [leave_building("BUILDING_386"),
				goto_dummy("BUILDING_1118","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"07:00:00" : { #herumlaufen und spielen
		S_DIALOG : "NPC_SVETLANA_T_002",
		S_START  : [],
		S_LOOP   : [lambda _c_:goto(random.choice(const.WAYPOINTS_SVETLANA))(_c_)]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_SVETLANA_T_003",
		S_START  : [goto_dummy("BUILDING_1120","dmyp_002"),turn_to_object("BUILDING_1117"),sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"15:00:00" : { #auf dem boden sitzen
		S_DIALOG : "NPC_SVETLANA_T_004",
		S_START  : [goto(640.4,530.0),sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"17:30:00" : { #bei hannes auf dem boden sitzen
		S_DIALOG : "NPC_SVETLANA_T_005",
		S_START  : [goto_object("BUILDING_1113"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_SVETLANA_T_006",
		S_START  : [goto_dummy("BUILDING_1120","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"22:00:00" : { #schlafen
		S_START  : [goto((621.7,516.8)), 
				enter_building("BUILDING_386"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_SVETLANA_T_007"
},

"ZACK" : {
#####
	"06:00:00" : { #am lagerfeuer sitzen
		S_DIALOG : "NPC_ZACK_T_001",
		S_START  : [leave_building("BUILDING_386"),
				goto(619.6,505.9),
				turn_to_object("BUILDING_1113"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
#		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"07:30:00" : { #svetlana verfolgen
		S_DIALOG : "NPC_ZACK_T_002",
		S_START  : [],
		S_LOOP   : [goto_object("SVETLANA"),
				turn_to_object("SVETLANA")]},
	"11:00:00" : { #essen + trinken
		S_DIALOG : "NPC_ZACK_T_003",
		S_START  : [goto_dummy("BUILDING_1120","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"14:30:00" : { #auf boden sitzen
		S_DIALOG : "NPC_ZACK_T_004",
		S_START  : [goto(613.3,501.0),
				turn_to_direction(globals.DIR_SOUTH),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"17:00:00" : { #bei juanita auf der bank sitzen
		S_DIALOG : "NPC_ZACK_T_005",
		S_START  : [goto_dummy("BUILDING_1117","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_ZACK_T_006",
		S_START  : [goto_dummy("BUILDING_1118","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"21:00:00" : { #schlafen
		S_START  : [goto((621.7,516.8)), 
				enter_building("BUILDING_386"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_ZACK_T_007"
},

"SHANIA" : {
#####
	"04:30:00" : { #essen + trinken
		S_DIALOG : "NPC_SHANIA_T_001",
		S_START  : [leave_building("BUILDING_1382"),
				goto_dummy("BUILDING_1274","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"06:00:00" : { #boden sitzen
		S_DIALOG : "NPC_SHANIA_T_002",
		S_START  : [goto(583.7,477.2),
				turn_to_direction(globals.DIR_NORTH),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_SHANIA_T_003",
		S_START  : [goto_dummy("BUILDING_1274","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"15:00:00" : { #auf boden sitzen
		S_DIALOG : "NPC_SHANIA_T_004",
		S_START  : [goto(583.7,477.2),
				turn_to_direction(globals.DIR_NORTH),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"21:30:00" : { #essen + trinken
		S_DIALOG : "NPC_SHANIA_T_005",
		S_START  : [goto_dummy("BUILDING_1274","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","drink","eat"])]},
	"23:00:00" : { #tiere füttern
		S_DIALOG : "NPC_SHANIA_T_006",
		S_START  : [lambda _c:goto_object(random.choice(const.OBJ_KUEHE_SHANIA))(_c),
				start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"00:00:00" : { #schlafen
		S_START  : [goto(629.7,515.6), 
				enter_building("BUILDING_1382"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_SHANIA_T_007"
},

"ERIKA" : {
#####
	"04:00:00" : { #kochen
		S_DIALOG : "NPC_ERIKA_T_001",
		S_START  : [leave_building("BUILDING_1382"),
				goto_dummy("BUILDING_1273","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { #holz hacken
		S_DIALOG : "NPC_ERIKA_T_002",
		S_START  : [goto_dummy("BUILDING_1107","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"12:00:00" : { #kochen
		S_DIALOG : "NPC_ERIKA_T_003",
		S_START  : [goto_dummy("BUILDING_1273","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"15:00:00" : { #auf bank sitzen
		S_DIALOG : "NPC_ERIKA_T_004",
		S_START  : [goto_dummy("BUILDING_1274","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"19:00:00" : { #wäsche waschen
		S_DIALOG : "NPC_ERIKA_T_005",
		S_START  : [goto(579.2,463.8),
				turn_to_object("BUILDING_1281")],
		S_LOOP   : [wash_laundry()]},
	"21:00:00" : { #loch graben
		S_DIALOG : "NPC_ERIKA_T_006",
		S_START  : [goto_dummy("BUILDING_1247","dmyp_001"),
				start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"23:30:00" : { #schlafen
		S_START  : [goto(629.7,515.6), 
				enter_building("BUILDING_1382"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_ERIKA_T_007"
},

"SAM" : {
#####
	"06:30:00" : { #essen + trinken
		S_DIALOG : "NPC_SAM_T_001",
		S_START  : [leave_building("BUILDING_1126"),
				goto_dummy("BUILDING_1423","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"08:00:00" : { #boden sitzen
		S_DIALOG : "NPC_SAM_T_002",
		S_START  : [goto(645.4,508.9),
				turn_to_direction(globals.DIR_EAST),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"12:00:00" : { #bank sitzen
		S_DIALOG : "NPC_SAM_T_003",
		S_START  : [goto_dummy("BUILDING_1116","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"14:00:00" : { #stehen warten
		S_DIALOG : "NPC_SAM_T_004",
		S_START  : [goto(649.7,516.7),
				turn_to_direction(globals.DIR_NORTH_WEST)],
		S_LOOP   : [stand()]},
	"19:00:00" : { #stehen warten
		S_DIALOG : "NPC_SAM_T_005",
		S_START  : [goto(605.0,542.2),
				turn_to_direction(globals.DIR_SOUTH_WEST)],
		S_LOOP   : [stand()]},
	"21:00:00" : { #essen + trinken
		S_DIALOG : "NPC_SAM_T_006",
		S_START  : [goto_dummy("BUILDING_1423","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","eat","drink"])]},
	"23:30:00" : { #schlafen
		S_START  : [goto(624.17,497.42), 
				enter_building("BUILDING_1126"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_SAM_T_007"
},

"BERNIE" : {
#####
	"04:30:00" : { #tiere füttern
		S_DIALOG : "NPC_BERNIE_T_001",
		S_START  : [leave_building("BUILDING_356"),
				lambda _c_:goto_object(random.choice(const.OBJ_KUEHE_SHANIA))(_c_),
				start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"07:00:00" : { #kochen
		S_DIALOG : "NPC_BERNIE_T_002",
		S_START  : [goto_dummy("BUILDING_1273","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"12:00:00" : { #essen + trinken
		S_DIALOG : "NPC_BERNIE_T_003",
		S_START  : [goto_dummy("BUILDING_1863","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["sit","eat","drink"])]},
	"15:30:00" : { #holz hacken
		S_DIALOG : "NPC_BERNIE_T_004",
		S_START  : [goto_dummy("BUILDING_1821","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"18:00:00" : { #kochen
		S_DIALOG : "NPC_BERNIE_T_005",
		S_START  : [goto_dummy("BUILDING_1273","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"21:20:00" : { #bank sitzen
		S_DIALOG : "NPC_BERNIE_T_006",
		S_START  : [goto_dummy("BUILDING_1274","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"23:00:00" : { #schlafen
		S_START  : [goto(630.48,504.16), 
				enter_building("BUILDING_356"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_BERNIE_T_007"
},

"JONAS" : {
#####
	"22:00:00" : { #lagerfeuer stehen
		S_DIALOG : "NPC_JONAS_T_001",
		S_START  : [goto(532.5,410.1),
				turn_to_object("BUILDING_1436")],
		S_LOOP   : [stand()]},
	"05:00:00" : { #boden sitzen
		S_DIALOG : "NPC_JONAS_T_002",
		S_START  : [goto(549.2,502.6),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"06:00:00" : { #bei ambrosius stehen
		S_DIALOG : "NPC_JONAS_T_003",
		S_START  : [goto(662.2,498.2),
				turn_to_object("AMBROSIUS")],
		S_LOOP   : [sit_on_bench(["sit","eat","drink"])]},
	"11:00:00" : { #konversation mit tanja
		S_DIALOG : "NPC_JONAS_T_004",
		S_START  : [goto(627.8,465.9),
				turn_to_object("TANJA")],
		S_LOOP   : [conversate("TANJA")]},
	"14:50:00" : { #essen + trinken
		S_DIALOG : "NPC_JONAS_T_005",
		S_START  : [goto_dummy("BUILDING_1119","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"18:00:00" : { #konversation mit pete
		S_DIALOG : "NPC_JONAS_T_006",
		S_START  : [goto(557.0,477.0),
				turn_to_object("PETE")],
		S_LOOP   : [conversate("PETE")]},
	"20:00:00" : { #stehen warten
		S_START  : [goto(643.9,483.1),
				turn_to_direction(globals.DIR_WEST)],
		S_LOOP   : [stand()]},
	S_SECONDDIALOG : "NPC_JONAS_T_007"
},

"TANJA" : {
#####
	"04:00:00" : { #kochen
		S_DIALOG : "NPC_TANJA_T_001",
		S_START  : [leave_building("BUILDING_382"),
				goto_dummy("BUILDING_1273","dmyp_004"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:30:00" : { #loch graben
		S_DIALOG : "NPC_TANJA_T_002",
		S_START  : [goto(609.3,424.9),
				start_dig_hole()],
		S_LOOP   : [dig_hole()]},
	"11:00:00" : { #konversation mit jonas
		S_DIALOG : "NPC_TANJA_T_003",
		S_START  : [goto(626.4,467.3),
				turn_to_object("JONAS")],
		S_LOOP   : [conversate("JONAS")]},
	"14:50:00" : { #herumwandern
		S_DIALOG : gender_switch("NPC_TANJA_T_004F","NPC_TANJA_T_004"),
		S_START  : [lambda _c_:goto(random.choice(const.WAYPOINTS_TANJA))(_c_),
				stand(),
				stand(),
				stand()],
		S_LOOP   : [lambda _c_:goto(random.choice(const.WAYPOINTS_TANJA))(_c_),
				stand(),
				stand(),
				stand()]},
	"18:00:00" : { #essen + trinken
		S_DIALOG : "NPC_TANJA_T_005",
		S_START  : [goto_dummy("BUILDING_1119","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"20:00:00" : { #gräber suchen
		S_DIALOG : "NPC_TANJA_T_006",
		S_START  : [lambda _c_:goto(random.choice(const.WAYPOINTS_TANJA_GRABSUCHE))(_c_),
				stand(),
				stand(),
				stand()],
		S_LOOP   : [lambda _c_:goto(random.choice(const.WAYPOINTS_TANJA_GRABSUCHE))(_c_),
				stand(),
				stand(),
				stand()]},
	"23:00:00" : { #schlafen
		S_START  : [goto(630.57,511.84), 
				enter_building("BUILDING_382"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_TANJA_T_007"
},

"PETE" : {
#####
	"04:00:00" : { #kochen
		S_DIALOG : "NPC_PETE_T_001",
		S_START  : [leave_building("BUILDING_356"),
				goto_dummy("BUILDING_1113","dmyp_004"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:30:00" : { #ambrosius stehen warten
		S_DIALOG : "NPC_PETE_T_002",
		S_START  : [goto(659.9,497.8),
				turn_to_object("AMBROSIUS")],
		S_LOOP   : [stand()]},
	"11:00:00" : { #schiffe inspizieren
		S_DIALOG : "NPC_PETE_T_003",
		S_START  : [],
		S_LOOP   : [inspectShipyard()]},
	"14:50:00" : { #konversation mit jonas
		S_DIALOG : "NPC_PETE_T_004",
		S_START  : [goto(558.8,476.8),
				turn_to_object("JONAS")],
		S_LOOP   : [conversate("JONAS")]},
	"20:00:00" : { #essen + trinken
		S_DIALOG : "NPC_PETE_T_005",
		S_START  : [goto_dummy("BUILDING_1114","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit","eat"])]},
	"22:00:00" : { #lagerfeuer stehen
		S_DIALOG : "NPC_PETE_T_006",
		S_START  : [goto(571.2,508.0),
				turn_to_object("BUILDING_1720")],
		S_LOOP   : [stand()]},
	"23:40:00" : { #schlafen
		S_START  : [goto(630.48,504.16), 
				enter_building("BUILDING_356"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_PETE_T_007"
},}
	# update with global schedules
	schedules.update(global_schedules.update_schedules(schedules))

### wrapper functions, do not modify!
def Activity(id):
	return npc_activity(id, schedules)
	
def GetCurrentPlan(id):
	return npc_get_current_plan(id, schedules)
	
def Dialog(id, partymemberid):
	return npc_dialog(id, partymemberid, schedules)
	
"""
"SHADOW_08" :	{
	S_CONDITION : lambda : data().shadow_08_patrol == True,
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[patrol(points=const.WAYPOINTS_SCHATTEN[1], speed=MT_FAST)]
	}
},
"SHADOW_09" :	{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[patrol(points=const.WAYPOINTS_SCHATTEN[0], speed=MT_SLOW)]
	}
},
"SHADOW_10" :	{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[patrol(points=const.WAYPOINTS_SCHATTEN[0], speed=MT_SLOW)]
	}
},
"SHADOW_11" :	{
	"00:00:00"	:	{
		S_START	:	[],
		S_LOOP	:	[patrol(points=const.WAYPOINTS_SCHATTEN[0], speed=MT_SLOW)]
	}
},
"""
