# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import water
import const
from const import *
import object_events
import schedules
from dynamic_camera import *
import rest
import vehicle
import cs_function as cs

#*** actual revision - Revision 34, 9.09.2004 *********************************

## Parties initialisieren (nur hier!)
def initParties():
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="ANIMALS",type=PT_COMPUTER)
    system.create_party(id="NPCS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
    start_locations = { "NORTH": (374.4, 599.1), "SOUTH": (374.4, 599.1), "WEST": (374.4, 599.1),\
                        "EAST": (374.4, 599.1), }

    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
    skies.init_sky_preset("orange")

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
        system.add_region("Vesseltown_Lager_Sued",640,525,615,490)
        system.add_region("Vesseltown_Lager_Nord",588,425,610,400)
        system.add_region("Museeum_of_Body_Art",285,255,215,205)

    data("rest").non_rest_areas.append("Vesseltown_Lager_Sued")
    data("rest").non_rest_areas.append("Vesseltown_Lager_Nord")
    data("rest").non_rest_areas.append("Museeum_of_Body_Art")

def on_map_loaded():
    init_data()
    initParties()
# place player characters
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )

# ae- and party-creation modifier | see debug_py.py for info on parameters
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
    npc.initNPCS()
    check_reporter_state()
    npc.initAnimals()
    initHerbs()
    initItems()
    initVehicles()
    initExitZones()
    initRegions()
    initFX()
    initQuestbook()
    initWaterResources()
    schedules.init_schedules() ## immer nach dem initQuestbook()
    init_scriptuse_objects()
    InitChestsSafes()
    init_character_states()
    init_non_rest_areas()
    init_vesseltownies()
#    init_lock_state(building='BUILDING_2421', state='lock')
    init_lock_state(building='BUILDING_2405', state='lock')

    if not hasattr(data('rest'), 'legal_rest_areas'):
        rest.init_data()
    data('rest').legal_rest_areas['zone_7'] = REST_NONE_VESSELTOUWN

def check_reporter_state():
    if object.exists("REPORTER"):
        object.set_attribute("REPORTER","zone_transfer",False)
        data().reporter_da = True
    if not object.exists('BOTE_1'):
        npc.init_reporter()

#markieren von objekten die im script modifiziert werden
def init_scriptuse_objects():
    system.mark_for_script_use("BUILDING_2306")
#hafenkran
    system.mark_for_script_use(const.Z7_CRANE)

#lagerfeuer
    for lf in const.OBJ_LAGERFEUER:
        system.mark_for_script_use(lf)

#gefangenen kaefig
    pos = object.get_position("BUILDING_2405")
    system.mark_for_script_use("BUILDING_2405")
    object.set_position_free("BUILDING_2405", pos[0],pos[1],0,grid="landscape")

#heli wrack ersetzen
    system.mark_for_script_use(const.OBJ_HELIKOPTER)
    pos = object.get_position(const.OBJ_HELIKOPTER)
    direction = object.get_direction(const.OBJ_HELIKOPTER)
    object.set_active_state(const.OBJ_HELIKOPTER,INACTIVE)
    system.create_object(equipmenttype="RES3D_UH1_WRACK_HECKROTOR",x=pos[0],y=pos[1],id="HELI_WITH_ROTOR",direction=direction)
    object.set_position_free("HELI_WITH_ROTOR",pos[0],pos[1],0,grid="landscape")
    system.mark_for_script_use("BUILDING_2421")

#kisten truhen tresore
    system.mark_for_script_use("BUILDING_4423")
    system.mark_for_script_use('BUILDING_10895')
    system.mark_for_script_use('BUILDING_10898')
    system.mark_for_script_use('BUILDING_10899')
    system.mark_for_script_use('BUILDING_10900')
    system.mark_for_script_use('BUILDING_10901')
    system.mark_for_script_use('BUILDING_10903')
    system.mark_for_script_use('BUILDING_10923')
    system.mark_for_script_use('BUILDING_10924')
    system.mark_for_script_use('BUILDING_10946')
    system.mark_for_script_use('BUILDING_10947')
#system.mark_for_script_use('BUILDING_14266')

# Bienenstöcke Zone 7
    system.mark_for_script_use('BUILDING_10968')
    system.mark_for_script_use('BUILDING_10967')


#mark mortality, mqnpcs, animals, foes
def init_character_states():
# mortality
    for id in system.get_npcs():
        if (id not in data().SCHATTEN_NPCS.keys()):
                object.set_immortal_state(id, True)
    character.set_approachable_state("CRAIG", NOTAPPROACHABLE)
# animals
    for id in system.get_animals():
        object.set_immortal_state(id, True)
        if id not in const.OBJ_KUEHE_SHANIA + ["ESEL"]:
            object.set_attribute(id, "foes", ["UISPIELER"])
        if id in ["ESEL"]+data().SpawnAnimals:
            object.set_immortal_state(id, False)

    object.set_position("ANDREW", 479.1, 476.6, grid="ZONE_7_BUILDING_217_INTERIOR_GRID")

def on_post_load():
    initFX()
    schedules.init_schedules()

    if object.exists("REPORTER"):
        data().reporter_da = True

    init_patch()

def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    init_non_rest_areas()
    schedules.init_schedules()
    check_reporter_state()
    init_patch()

def on_approach(target,operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)

## Regionstrigger
def on_enter_region(id, objectid, partyid ):
    print "[on_enter_region(",id, str(objectid), partyid,"]"
# non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid): objectid=objectid[0]
        else: return

    if id == "REGION_HOSTAGE_CAGE":
        if not data().player_knows_Kaefig:
            data().player_knows_Kaefig = True
            system.add_minimap_marker(605.92, 354.19,"MM_003")# Käfig
        if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS.keys()):
            dialogs.initDlg_131_SpielerWillGeiselnNochNichtBefreien()

# Spieler betritt die Hafenstadt
    if (id==data().Region_VerlasseneHafenstadt):
        if (system.get_qb_entry_state(data().QB_001)==UNCOMPLETE):
            dialogs.initDlg_001_SpielerBetrittStadt()
        elif system.get_qb_entry_state(data().QB_006) == COMPLETE:
            if not was_zone_entered("zone_8.zone_8") and data().anie_folgt:
                dialogs.initDlg_111_SpielerWillZurSchattenbasis()
            else:
                if (system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and
                    system.get_qb_entry_state(data().QB_011)==UNCOMPLETE):
                        dialogs.initDlg_051_SpielerSuchtFettUndAlkoholFuerEmily()

    if id == "KRAN_REGION":
        if not data().player_knows_Kran:
            data().player_knows_Kran = True
            system.add_minimap_marker(500.22, 483.27,"MM_002")# Kran

    if id == "REGION_HELICOPTER":
        if not data().player_knows_Hubschrauberwrack:
            data().player_knows_Hubschrauberwrack = True
            system.add_minimap_marker(735.21, 289.42,"MM_005")# Hubschrauberwrack

# Spieler kommt in die Naehe des Krans
    if (id==data().Region_Kran):
        if (system.get_qb_entry_state(data().QB_001)==UNCOMPLETE):
            system.notify_timer(data().Timer_cam_vesseltown_left,data().Timervalue_cam_vesseltown_left)
            system.start_cutscene()
            system.set_camera_view(const.CAM_VESSELTOWN_LEFT)
            dialogs.initDlg_002_SpielerNaehertSichKran()

# Spieler sieht das AAC Museum
    if (id==data().Region_AACMuseeum):
        if not data().player_knows_Museum:
            data().player_knows_Museum = True
            system.add_minimap_marker(245.68, 220.70,"MM_001")# Museum Of Body Art
        if (system.get_qb_entry_state(data().QB_003)==INACTIVE):
            dialogs.initDlg_064_SpielerSiehtMuseumVorAndrew()

# Spieler sieht den Esel
    if (id==data().Region_Esel):
        if (system.get_qb_entry_state(data().QB_012)==INACTIVE):
            if data().Counter_EselBesuch == 0:
                dialogs.initDlg_068_SpielerFindetEselTeil1()
            elif data().Counter_EselBesuch >= 1:
                dialogs.initDlg_069_SpielerFindetEselTeil2()
            data().Counter_EselBesuch += 1
        elif (system.get_qb_entry_state(data().QB_012)==UNCOMPLETE):
            dialogs.initDlg_029_SpielerFindetEselMitConnyAuftrag()

## Spieler betritt den Maschinenraum/Plantage
    if (id==data().Region_MaschinenRaum):
        dialogs.initDlg_086_SpielerIstBeeindrucktVonSeansPlantage()

## Spieler naehert sich Brad und Craig, die an der Strippe ziehen
    if (id==data().Region_Strippe):
        if (object.get_distance("ALTER_EGO","BRAD") <= 4.0):
            object.turn_to_object("ALTER_EGO","BRAD")
            object.turn_to_object("CRAIG","ALTER_EGO")
            object.turn_to_object("BRAD","ALTER_EGO", callback=["ONEND",initDlg_045])
        else:
            system.notify_region_entered(data().Region_Strippe,objectid="ALTER_EGO",permanent=False)

## Spieler kommt nach Vesseltown
    if (id==data().Region_VesselTown):
#dialogs.initDlg_041_SpielerErreichtVesselTown()
        dialogs.initDlg_040_SpielerFaehrtMitKranNachVesselTown()

def initDlg_045(id):
    if (system.get_qb_entry_state(data().QB_006)==INACTIVE):
        dialogs.initDlg_045_SpielerSollVesseltownEingangErmoeglichen()

def initDlg_042(id):
    if (system.get_qb_entry_state(data().QB_008)==INACTIVE):
        dialogs.initDlg_042_SpielerSollKleinFamileHelfen()

def deactivate(char_id):
    object.set_active_state(char_id, INACTIVE)

def on_timer(id):
#print "[debug on_timer()",id,"]"
    if id == data().Timer_EmilyMachtSonneschutmittelFertig:
        data().emily_sonnenschutmittel_fertig = True

    if id == data().Timer_SoundDelay:
#crane starting
        if data().counter_sound_delay  == 0:
            data().counter_sound_delay += 1
            sounds.play_3d_sound_object(sfx_id="crane_engine_starts",object=const.Z7_CRANE,loop=False)
            system.notify_timer(data().Timer_SoundDelay, 825)

        if data().counter_sound_delay  == 1:
            data().counter_sound_delay += 1
            sounds.play_3d_sound_object(sfx_id="crane_engine_loop",object=const.Z7_CRANE,loop=True, identifier="sound_crane_engine")

#crane working
        if data().counter_sound_delay  in [3,5]:
            if data().counter_sound_delay == 3:
                data().counter_sound_delay += 1
                system.notify_timer(data().Timer_SoundDelay, 7000)
            sounds.play_3d_sound_object(sfx_id="crane_working_steel_cable",object=const.Z7_CRANE,loop=False)

        if data().counter_sound_delay  == 4:
            data().counter_sound_delay += 1
            sounds.play_3d_sound_object(sfx_id="crane_rotating",object=const.Z7_CRANE,loop=False)
            system.notify_timer(data().Timer_SoundDelay, 3400)

        if data().counter_sound_delay  == 6:
            sounds.play_3d_sound_object(sfx_id="crane_setting_down_container",object=const.Z7_CRANE,loop=False)

        else:
            return False

    if id == data().Timer_GeiselnVerschwinden:
        for id in const.NPCS_IN_HOSTAGECAGE_WOA:
            prohibit_activity(id)
            for wp in const.WAYPOINTS_HOSTAGES:
                if wp != const.WAYPOINTS_HOSTAGES[len(const.WAYPOINTS_HOSTAGES)-1]:
                    object.move_to(id, wp[0],wp[1], speed=MT_SLOW)
                else:
                    object.move_to(id, wp[0],wp[1], speed=MT_SLOW, callback=["ONEND", deactivate])

    if id == data().Timer_Fade:
        if data().fade_count == 1:
            dialogs.onDlg_133_ContinueAfterFadeToBlack()

        if data().fade_count == 6:
            system.set_camera_view(const.CAMVIEW_CRANE_LIFTDOWN)
            dialogs.onDlg_032_ContinueAfterFadeToBlack_CraneInVesselTown()

        if data().fade_count == "emily_plant_explore":
            dialogs.onDlg_043_ContinueAfterFade_InspectPlants()

        if data().fade_count == "plant_explore_done":
            dialogs.onDlg_043_ContinueAfterFade_PlantsInspected()

        system.fade(FADE_IN)

    if id == data().Timer_Delay:
        if data().delay_count == 1:
            object.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_OPEN", callback=["ONEND",dialogs.onDlg_032_CharsEnterContainer])

        elif data().delay_count == 2:
            system.set_camera_view(const.CAMVIEW_EXITCRANE_CAGE)
        else:
            return False
        data().delay_count = 0

    if id == data().Timer_FadeOut:
        if data().fade_count == 6:
            system.fade(FADE_OUT)
            system.notify_timer(data().Timer_Fade, 3000)

## Emily Ansprechen prüfen:
    if (id==data().Timer_EmilyAnprechen):
        if (not data().emily_keinechancemehr and
        system.get_qb_entry_state(data().QB_008)==INACTIVE):
            if (object.get_distance("ALTER_EGO","EMILY")<=3.0):
                prohibit_activity("EMILY")
                object.cancel_commandos("EMILY")
                object.cancel_commandos("ALTER_EGO")
                object.turn_to_object("ALTER_EGO","EMILY")
                object.move_to_object("HARRY","EMILY")
                object.move_to_object("LARRY","EMILY")
                object.turn_to_object("EMILY","ALTER_EGO", callback=["ONEND",initDlg_042])
            else:
                system.notify_timer(data().Timer_EmilyAnprechen,data().Timervalue_EmilyAnprechen)

## Craig und Brad machen den Flughund fertig
    if (id==data().Timer_FlughundFertigstellung):
        data().craigbrad_craigarbeitetanflughund = False
        prohibit_activity("CRAIG", True)
        object.set_active_state(data().qi_flughund[0],0)
        object.set_active_state(data().qi_flughund_done[0],1)
        object.move_to("CRAIG", 610.5, 421.91, speed=MT_FAST, grid="landscape", callback=["ONEND", on_craig_done])

## der Esel folgt dem Spieler zu Conny
    if (id==data().Timer_EselFolgtSpieler):
        if data().conny_esel_folgt_spieler and not data().conny_eselzurueck:
            pos = object.get_position("ALTER_EGO")
            object.move_to("ESEL",pos[0]-1.0,pos[1]+1.0, grid="landscape", speed=MT_FAST)
            if object.get_distance("ESEL","CONNY")<=4.0:
                data().conny_eselzurueck=True
            if (random.randint(0,18)==0):
                data().conny_esel_folgt_spieler = False
            system.notify_timer(data().Timer_EselFolgtSpieler,data().Timervalue_EselFolgtSpieler)

        elif not data().conny_esel_folgt_spieler and not data().conny_eselzurueck:
            if object.get_distance("ESEL","CONNY")<=4.0:
                data().conny_eselzurueck=True
            if not data().conny_eselzurueck:
                if object.get_distance("ESEL","ALTER_EGO")<=3.0:
                    dialogs.initDlg_030_SpielerZerrtEselMitConnyAuftrag()
                else:
                    system.notify_timer(data().Timer_EselFolgtSpieler,data().Timervalue_EselFolgtSpieler)

### CAMERA Timer
## Vesseltown Ueberblick
    if (id==data().Timer_cam_vesseltown_left):
        system.notify_timer(data().Timer_cam_vesseltown_mid,data().Timervalue_cam_vesseltown_mid)
        system.set_camera_view(const.CAM_VESSELTOWN_MID)
    if (id==data().Timer_cam_vesseltown_mid):
        system.notify_timer(data().Timer_cam_vesseltown_right,data().Timervalue_cam_vesseltown_right)
        system.set_camera_view(const.CAM_VESSELTOWN_RIGHT)
    if (id==data().Timer_cam_vesseltown_right):
        end_cutscene(chars=[])

## Timer fuer Spawn Animals
    if (id == data().Timer_SpawnTimeChecker):
        clock = system.get_mission_time().get_day_time()
        if (clock >= time("06:00:00") and clock < time("22:00:00")):
            npc.spawnAnimals(INACTIVE)
        else:
            npc.spawnAnimals(ACTIVE)
        system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

def on_craig_done(char):
    data().craigbrad_flughund_fertig = True
    object.turn_to_direction("CRAIG", globals.DIR_EAST)


#def onKilled(id):
def on_object_killed(victim, attacker, weapon_type, weapon_id):
    object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
## Spieler toetet einen der Schatten in Vesseltown
    if (victim in data().SCHATTEN_NPCS):
        data().Counter_AlleSchattenKilled += 1
## 3ter Schatten, Spieler wundert sich
        if (data().Counter_AlleSchattenKilled == 3):
            dialogs.initDlg_075_SpielerWundertSichUeberSchatten()
        if (data().Counter_AlleSchattenKilled == len(data().SCHATTEN_NPCS)):
            pos = object.get_position(victim)
            object.set_position_free("DYING_SHADOW",pos[0],pos[1],0)
            if "ALTER_EGO" in vehicle.get_crew("Z7 WHEELTANK"):
                character.get_out("ALTER_EGO")
            system.start_cutscene()
            object.move_to("ALTER_EGO",pos[0]+1.0,pos[1]+1.5, speed=MT_FAST)
            object.turn_to_object("ALTER_EGO","DYING_SHADOW")
            set_conversation(victim, cam_x=-3, cam_y=-3, mode="far", animate=False)
            character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_START", callback=["ONEND",onDlg_076_Cam2AndInit])
            character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE")

## Spieler toetet einen NPC
    if (victim in data().NEBENQUEST_NPCS):
# EMILY, HARRY, LARRY
        if (victim in ["EMILY", "HARRY", "LARRY"]):
            if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_008,IMPOSSIBLE)
            if system.get_qb_entry_state(data().QB_009) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_009,IMPOSSIBLE)
            if system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_010,IMPOSSIBLE)
            if system.get_qb_entry_state(data().QB_011) == UNCOMPLETE:
                system.set_qb_entry_state(data().QB_011,IMPOSSIBLE)

        elif (victim in const.NPCS_WITH_AMBROSIUS):
            const.NPCS_WITH_AMBROSIUS.remove(victim)


# Connys Esel
    elif (victim == "ESEL"):
        data().conny_eseltot = True

def onDlg_076_Cam2AndInit(id):
#freecam("ALTER_EGO","DYING_SHADOW",1.7,1.2,6.0)
    set_conversation("ALTER_EGO", cam_x=-2, cam_y=-2, mode="medium", animate=False)
    dialogs.initDlg_076_SchattenBeschimpftSpieler()

def on_wait_for_commando(id):
    if id == "ALTER_EGO":
        if data().flughund_flug:
            return True
    return schedules.Activity(id) 

## Prüf welche Objekte untersucht werden können
def can_examine_object( character_id, object_id ):
# museeumsleichen
#dialogs.initDlg_MBA_Museeumsleichen(object_id)
#    return True

    if object_id != None:
        if object_id.endswith(const.Z7_CRANE):
            if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
                return True

#leichen des museeums
        if object_id in const.OBJECTS_MBA_LEICHEN.keys():
            return True

    if (object_id.endswith("BUILDING_2405")):
        return True
    if object_id == "HELI_WITH_ROTOR":
        return True
    if object_id.endswith(const.OBJ_STRIPPE):
        return True
    if object_id.endswith(const.OBJ_MERCEDES):
        return True
    if object_id.endswith(const.OBJ_BUS):
        return True
    return False

def pre_examine_object( character_id, object_id ):
# geiselkäfig
    if object_id != None:
        if (object_id.endswith("BUILDING_2405")):
            object.set_attribute(object_id, "on_examine_coordinates",[601.0,353.89,0])

        elif (object_id == "HELI_WITH_ROTOR"):
            object.set_attribute(object_id, "on_examine_coordinates",[734.89,293.23,0])

        elif (object_id.endswith(const.Z7_CRANE)):
            object.set_attribute(object_id, "on_examine_coordinates",[492.4,476.4,0])

## Untersuchen von Objekten
def on_examine_object( character_id, object_id ):
    print "[debug on_examine_object()",character_id, object_id,"]"
    if dialog.is_dialog_active():
        return

    if object_id != None:
#leichen des museeums
        if object_id in const.OBJECTS_MBA_LEICHEN.keys():
            dialogs.initDlg_MBA_Museeumsleichen(object_id)

# hafenkran
        if object_id.endswith(const.Z7_CRANE):
            object.cancel_commandos(character_id)
            object.turn_to_object(character_id, object_id)
            if system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
                dialogs.initDlg_114_SpielerUntersuchtKaputtenKran()
            else:
                dialogs.initDlg_113_SpielerUntersuchtKran()

# geiselkäfig
    if character_id in system.get_pcs():
        if (object_id.endswith("BUILDING_2405")):
            if not data().hostages_rescued:
                if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS):
                    dialogs.initDlg_132_SpielerWillGeiselnImmerNochNichtBefreien()
                else:
                    if cs.group_as_obj(data().qi_cagekey[0]):
                        init_lock_state(building='BUILDING_2405', state='unlock')
                        dialogs.initCutscene_133_SpielerBefreitGeiseln()
                        data().hostages_rescued = True
                    elif object.get_attribute('BUILDING_2405','locked') == []:
                        dialogs.initCutscene_133_SpielerBefreitGeiseln()
                        data().hostages_rescued = True
                    else:
                        dialogs.initDlg_146_SpielerKannKaefigNichtOeffnen()

# helikopterwrack -> heckrotor für flughund
        if (object_id == "HELI_WITH_ROTOR" and character_id in system.get_pcs() and\
            not data().craigbrad_spielerhatrotorblatt):
            if (system.get_qb_entry_state(data().QB_006) == INACTIVE):
                dialogs.initDlg_080_SpielerKannMitHubschrauberNixAnfangen()
            else:
                if not data().craigbrad_rotorblattgefunden:
                    dialogs.initDlg_078_SpielerFindetRotorblatt()
                else:
                    dialogs.initDlg_082_SpielerBrauchtHubschrauberWrack()

# strippe -> aufzug nach oben
        if (object_id.endswith(const.OBJ_STRIPPE)):
            if (system.get_qb_entry_state(data().QB_006)==COMPLETE and
                data().craigbrad_flughund_zerstoert):
                dialogs.initDlg_116_SpielerBetaetigtStrippeCraigAmKran()
            else:
                dialogs.initDlg_115_SpielerWartetAnStrippe()

# mercedes -> windschutzscheibe für flughund
        if (object_id.endswith(const.OBJ_MERCEDES) and
            not data().craigbrad_spielerhatwindschutzscheibe):
            if (system.get_qb_entry_state(data().QB_006) == INACTIVE):
                dialogs.initDlg_079_SpielerFindetWindschutzscheibeNochNutzlos()
            else:
                if not data().craigbrad_windschutzscheibegefunden:
                    dialogs.initDlg_077_SpielerFindetWindschutzcheibe()
                else:
                    dialogs.initDlg_081_SpielerBrauchtWindschutzscheibe()

# alter vw bus -> vergaser für kran
        if (object_id.endswith(const.OBJ_BUS) and not cs.group_as_obj(data().qi_vergaser[0])):
            if cs.group_as_obj(data().qi_vergaser_mba[0]):
                dialogs.initDlg_036_SpielerFindetVergaserInGarageHatSchonAnderen()
            else:
                if not data().andrew_spielerhatvergaser:
                    dialogs.initDlg_033_SpielerFindetVergaserInGarage()

    else:
        print object_id
        if (     object_id.endswith(const.OBJ_BUS) or
            object_id.endswith(const.OBJ_MERCEDES) or
            object_id.endswith(const.OBJ_STRIPPE) or
            object_id.endswith(const.OBJ_HELIKOPTER) or
            object_id.endswith("HELI_WITH_ROTOR") or
            object_id.endswith("BUILDING_2405")):
                dialogs.MercenaryDenyTalk(character_id, "default")
    return True

def can_exchange( character_id, target_id, item_id, item_type ):
    if character_id in system.get_pcs():
        if target_id == "EMILY":
            if (system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and 
                item_id == data().qi_fett[0]):
                return True
            if (system.get_qb_entry_state(data().QB_011)==UNCOMPLETE and 
                item_id == data().qi_alkohol[0]):
                return True

        if target_id in ["CRAIG","BRAD"]:
            if (system.get_qb_entry_state(data().QB_006)==UNCOMPLETE and 
                item_id in [data().qi_windschutzscheibe[0],data().qi_rotorblatt[0]]):
                return True

        if target_id == "RUPERT":
            if (system.get_qb_entry_state(data().QB_014)==UNCOMPLETE):
                return (dialogs.is_paper_doc(item_id) or dialogs.is_ear_device(item_id))

        if target_id == "ANDREW" and item_type == data().qi_vergaser[1]:
            if system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
                return True

    return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):

    if target_id == "ANDREW" and item_type == data().qi_vergaser[1]:
        dialogs.initCutscene_037_SpielerBringtAndrewVergaser()

## Emily braucht Fett und Alkohol
    if (target_id == "EMILY"):
        if (system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and item_id==data().qi_fett[0]):
            if object.count_in_inventory("EMILY",data().qi_alkohol[0]):
                dialogs.initCutscene_058_SpielerBringtSachenZuEmily()
            return True
        elif (system.get_qb_entry_state(data().QB_011)==UNCOMPLETE and item_id==data().qi_alkohol[0]):
            if object.count_in_inventory("EMILY",data().qi_fett[0]):
                dialogs.initCutscene_058_SpielerBringtSachenZuEmily()
            return True

## Craig und Brad brauchen Windschutzscheibe und Rotorblatt
    if (target_id in ["CRAIG","BRAD"]):
        if system.get_qb_entry_state(data().QB_006)==UNCOMPLETE and\
            (item_id==data().qi_windschutzscheibe[0] or item_id==data().qi_rotorblatt[0]):
            if item_id==data().qi_windschutzscheibe[0]:
                data().craigbrad_windschutzscheibegegeben = True
            if item_id==data().qi_rotorblatt[0]:
                data().craigbrad_rotorblattgegeben = True
            if (data().craigbrad_rotorblattgegeben and data().craigbrad_windschutzscheibegegeben):
                dialogs.initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
            return True

    if (target_id == "RUPERT"):
        if (system.get_qb_entry_state(data().QB_014)==UNCOMPLETE):
            if (dialogs.is_ear_device(item_id) and data().rupert_tondoksgegeben < 3):
                data().rupert_tondoksgegeben += 1
                if (data().rupert_schriftdoksgegeben == 3 and data().rupert_tondoksgegeben == 3):
                    dialogs.initDlg_055_SpielerFindetTonUndSchriftDokumente()
                return True
            if (dialogs.is_paper_doc(item_id) and data().rupert_schriftdoksgegeben < 3):
                data().rupert_schriftdoksgegeben += 1
                if (data().rupert_schriftdoksgegeben == 3 and data().rupert_tondoksgegeben == 3):
                    dialogs.initDlg_055_SpielerFindetTonUndSchriftDokumente()
                return True
    return object_events.on_exchange( character_id, target_id, item_id, item_type )

## Aufheben von Gegenständen
def on_pick_up( character_id, item_id, item_type ):
#print "[debug on_pick_up()",character_id, item_id, item_type,"]"

    if (item_id == data().qi_alkohol[0]):
        data().alkohol_gefunden = True

    if (item_id == data().qi_fett[0]):
        data().fett_gefunden = True

    if dialogs.is_paper_doc(item_id):
        if data().schriftdoks_gefunden < 3:
            data().schriftdoks_gefunden += 1

    if dialogs.is_ear_device(item_id):
        if data().tondoks_gefunden < 3:
            data().tondoks_gefunden    += 1

    if (item_id == data().qi_vergaser_mba[0]):
        if character_id in system.get_pcs():
            if (system.get_qb_entry_state(data().QB_004)==UNCOMPLETE):
                if cs.group_as_obj(data().qi_vergaser[0]):
                    dialogs.initDlg_035_SpielerFindetZweitenVergaserImMuseum()
                else:
                    dialogs.initDlg_034_SpielerFindetVergaserImMuseum()
        else:
            dialogs.MercenaryDenyTalk(character_id,"default")
            return False

    if (item_id == data().qi_seansnotizena[0]):
        if character_id in system.get_pcs():
            if not data().emily_seansnotizagelesen:
                dialogs.initDlg_087_SpielerFindetSeansNotizen()
        else:
            dialogs.MercenaryDenyTalk(character_id,"default")
            return False

    if (item_id == data().qi_seansnotizenb[0]):
        if character_id in system.get_pcs():
            if not data().emily_seansnotizbgelesen:
                dialogs.initDlg_089_SpielerFindetSeansNotizenB()
        else:
            dialogs.MercenaryDenyTalk(character_id,"default")
            return False

    if (item_id in ["MBA_BROCHURE_1","MBA_BROCHURE_2","MBA_BROCHURE_3"]):
        if character_id in system.get_pcs():
            if not data().mba_brochuere_gelesen:
                data().mba_brochuere_gelesen = True
                if (system.get_qb_entry_state(data().QB_003) == INACTIVE):
                    dialogs.initDlg_063_SpielerFindetMBABroschuereOhneAndrewsAuftrag()
                    mba_brochuere_gelesen = True
                elif (system.get_qb_entry_state(data().QB_003) == UNCOMPLETE):
                    mba_brochuere_gelesen = True
                    if data().Counter_ruperterfolglos==0:
                        dialogs.initDlg_016_SpielerFindetMBABroschuereMitAndrewsAuftrag()
                    else:
                        dialogs.initDlg_017_SpielerFindetMBABroschuereNachQuizVersagen()
        else:
            dialogs.MercenaryDenyTalk(character_id,"default")
            return False
    return True

# Benutzen von Gegenständen
def can_use( character_id, object_id ):
    if character_id in system.get_pcs():
        if (object_id in ["MBA_BROCHURE_1","MBA_BROCHURE_2","MBA_BROCHURE_3"]):
            return True
        if (object_id == data().qi_seansnotizenb[0]):
            return True
        if (object_id == data().qi_seansnotizena[0]):
            return True
        if (object_id == data().qi_cagekey[0]):
            return False
# geiselkäfig
        if object_id != None:
            if (object_id.endswith("BUILDING_2405")):
                return True
#canupla pflanzen
        for substring in const.OBJECTS_TA_EMILY:
            if object_id.endswith(substring):
                return True
#strippe
        if (object_id.endswith(const.OBJ_STRIPPE)):
            return True

    return object_events.can_use( character_id, object_id )

def pre_use( character_id, object_id, item_id, item_type ):
# geiselkäfig
    if object_id != None:
        if (object_id.endswith("BUILDING_2405")):
            object.set_attribute(object_id, "on_use_coordinates",[601.0,353.89,0])

def on_use( character_id, object_id, item_id, item_type ):
#print "[debug on_use()",character_id, object_id, item_id, item_type,"]"
    if dialog.is_dialog_active():
        return

    if character_id in system.get_pcs():
        if object_id != None:
#canupla pflanzen
            for substring in const.OBJECTS_TA_EMILY:
                if object_id.endswith(substring) and item_type in ["SET_KNIFE", "SET_BIG_KNIFE"]:
                    if (system.get_qb_entry_state(data().QB_008) == INACTIVE and
                        not system.get_qb_entry_state(data().QB_009)==UNCOMPLETE and
                        not system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and
                        not system.get_qb_entry_state(data().QB_011)==UNCOMPLETE and
                        not system.get_qb_entry_state(data().QB_016)==UNCOMPLETE):

                        if (    data().emily_seansnotizbgelesen and
                            (object.get_attribute(character_id, "survival")>=80)):
                            dialogs.initDlg_144_SpielerSchneidetPflanzeNicht_Ahnung()
                        else:
                            dialogs.initDlg_143_SpielerSchneidetPflanzeNicht_EinBischenAhnung()
                    else:
                        dialogs.initDlg_142_SpielerSchneidetPflanzeNicht_KeineAhnung()
                    return True

#strippe
        if object_id != None:
            if (object_id.endswith(const.OBJ_STRIPPE)):
                if (system.get_qb_entry_state(data().QB_006)==COMPLETE and
                    data().craigbrad_flughund_zerstoert):
                    dialogs.initDlg_116_SpielerBetaetigtStrippeCraigAmKran()
                else:
                    dialogs.initDlg_115_SpielerWartetAnStrippe()
                return True

#geiselkaefig
        if object_id != None:
            if (object_id.endswith("BUILDING_2405")):
                if not data().hostages_rescued:
                    if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS):
                        dialogs.initDlg_132_SpielerWillGeiselnImmerNochNichtBefreien()

                    elif object.get_attribute('BUILDING_2405','locked') == []:
                        dialogs.initCutscene_133_SpielerBefreitGeiseln()
                        data().hostages_rescued = True
                    else:
                        if (item_id != None and item_id == data().qi_cagekey[0]) or\
                            cs.group_as_obj(data().qi_cagekey[0]):
                            init_lock_state(building='BUILDING_2405', state='unlock')
                            dialogs.initCutscene_133_SpielerBefreitGeiseln()
                            data().hostages_rescued = True
                        else:
                            dialogs.initDlg_146_SpielerKannKaefigNichtOeffnen()
                    return True

        if item_id != None:

            if (item_id == data().qi_seansnotizena[0]):
                dialogs.onDlg_087_SpielerLiestNotizen()
                return True

            if (item_id == data().qi_seansnotizenb[0]):
                if data().emily_seansnotizagelesen and not data().emily_seansnotizbgelesen:
                    dialogs.initDlg_089_SpielerFindetSeansNotizenB()
                    data().emily_seansnotizbgelesen = True
                else:
                    dialogs.onDlg_089_SpielerLiestNotizen()
                return True

            if (item_id == data().qi_cagekey[0]):
                return False

    return object_events.on_use( character_id, object_id, item_id, item_type )

## Wasserressourcen
def initWaterResources():
    water.set_water_source(828.3,288.0, 3)
    water.set_water_source(648.4,288.5, 1)
    water.set_water_source(576.1,610.2, 2)
    water.set_water_source(586.7,484.5, 1)
    water.set_water_source(560.1,608.8, 2)
    water.set_water_source(620.3,474.4, 1)
    water.set_water_source(357.2,415.0, 4)

## Fahrzeuge
def initVehicles():
## flughunde
# defekt, muss noch rotorblatt und windschutzscheibe bekommen
    system.create_object(data().qi_flughund[1],613.38,419.35,data().qi_flughund[0],globals.DIR_NORTH_EAST)

# done, muss nur noch gestartet werden
    system.create_object(data().qi_flughund_done[1],613.38,419.35,data().qi_flughund_done[0],globals.DIR_NORTH_EAST)
    object.set_active_state(data().qi_flughund_done[0],0)

# start, flughund, der losfliegen soll
    system.create_object(data().qi_flughund_start[1],628.11,418.90,data().qi_flughund_start[0],globals.DIR_SOUTH_EAST)
    object.set_active_state(data().qi_flughund_start[0],0)

# crash, flughund der crashen soll
    system.create_object(data().qi_flughund_crash[1],493.34,445.6,data().qi_flughund_crash[0],155)
    object.set_active_state(data().qi_flughund_crash[0],0)

#wheeltank of the shadows
    system.create_object(data().qi_wheeltank[1], 540.4, 500.25,data().qi_wheeltank[0],globals.DIR_SOUTH_WEST)
    object.set_attribute(data().qi_wheeltank[0],"accepted_drivers",["UISPIELER"])

## Items (Quest und Nicht-Quest Items)
def initItems():
## QUEST -Items
## Vergaser 2 fuer Andrew - MBA
    object.create_item_in_inventory("BUILDING_4349", data().qi_vergaser_mba[1],data().qi_vergaser_mba[0])
    object.set_attribute(object=data().qi_vergaser_mba[0], attribute="generic_item", value=False)

## Fett und Alkohol fuer Emily
    system.create_object(data().qi_fett[1],248.5,242.0,data().qi_fett[0],direction=globals.DIR_SOUTH_EAST)
    object.set_attribute(object=data().qi_fett[0], attribute="generic_item", value=False)
    object.set_position_free(object=data().qi_fett[0], x=233.0, y=231.8, z=1.0, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID5")
    system.create_object(data().qi_alkohol[1],248.5,242.0,data().qi_alkohol[0],direction=globals.DIR_SOUTH_EAST)
    object.set_attribute(object=data().qi_alkohol[0], attribute="generic_item", value=False)
    object.set_position_free(object=data().qi_alkohol[0], x=232.8, y=233.8, z=1.0, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID5")
## MBA Broschueren
    object.create_item_in_inventory("BUILDING_1998",data().qi_mbabrochure[1],"MBA_BROCHURE_1")
    object.set_attribute(object="MBA_BROCHURE_1", attribute="generic_item", value=False)
    system.create_object(data().qi_mbabrochure[1],227.5,214.5,"MBA_BROCHURE_2",direction=globals.DIR_SOUTH_EAST)
    object.set_attribute(object="MBA_BROCHURE_2", attribute="generic_item", value=False)
    system.create_object(data().qi_mbabrochure[1],226.7,215.6,"MBA_BROCHURE_3",direction=globals.DIR_WEST)
    object.set_attribute(object="MBA_BROCHURE_3", attribute="generic_item", value=False)

#tondokumente im mba
    devices = [data().qi_ear_device_1,data().qi_ear_device_2]
    for device in devices:
        system.create_object(device[1],248.5,242.0,device[0],direction=globals.DIR_SOUTH_EAST)
        object.set_attribute(object=device[0], attribute="generic_item", value=False)

    object.set_position_free(object=data().qi_ear_device_1[0], x=231.61, y=207.54, z=0.7, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID4")
    object.set_position_free(object=data().qi_ear_device_2[0], x=231.60, y=211.61, z=1.3, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID4")

    object.create_item_in_inventory('ZONE_7_BUILDING_10923',data().qi_ear_device_3[1],data().qi_ear_device_3[0])
    object.set_attribute(object=data().qi_ear_device_3[0], attribute="generic_item", value=False)

#schriftdokumente im mba
    paperdocs = [data().qi_paper_doc_1,data().qi_paper_doc_2]
    for paperdoc in paperdocs:
        dx, dy = random.random(), random.random()
        system.create_object(paperdoc[1],248.5,242.0,paperdoc[0],direction=globals.DIR_SOUTH_EAST)
        object.set_attribute(object=paperdoc[0], attribute="generic_item", value=False)

    object.set_position_free(object=data().qi_paper_doc_1[0], x=241.63, y=209.55, z=0, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID1")
    object.set_position_free(object=data().qi_paper_doc_2[0], x=259.69, y=210.17, z=0, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID1")

    object.create_item_in_inventory('ZONE_7_BUILDING_10924',data().qi_paper_doc_3[1],data().qi_paper_doc_3[0])
    object.set_attribute(object=data().qi_paper_doc_3[0], attribute="generic_item", value=False)

## Normale Loot- Items
## verlassene Hafenstadt
    object.create_item_in_inventory("BUILDING_257",    ["SET_MAILBOX"])
    object.create_item_in_inventory("BUILDING_2192",    ["SET_POWER_DRILL"])
    object.create_item_in_inventory("BUILDING_32",        ["SET_P90_SMG"])
    object.create_item_in_inventory("BUILDING_2194",    ["SET_SMALL_PICTURE_FRAME"])
#object.create_item_in_inventory("BUILDING_856",    ["SET_NORMAL_CLOTHES_1"])
    object.create_item_in_inventory("BUILDING_907",    ["SET_MEDIPACK_SMALL"])
    object.create_item_in_inventory("BUILDING_668",    ["SET_PLASTIC_BOWL"])
    object.create_item_in_inventory("BUILDING_665",    ["SET_MEAT_RAW"])
    object.create_item_in_inventory("BUILDING_793",    ["SET_M249"])
    object.create_item_in_inventory("BUILDING_1940",    ["SET_TOOTHBRUSH"])
    object.create_item_in_inventory("BUILDING_1936",    ["SET_WATER_BOTTLE"])
    object.create_item_in_inventory("BUILDING_1023",    ["SET_BROKEN_SHOVEL"])
    object.create_item_in_inventory("BUILDING_1022",    ["SET_MEDIPACK_BIG"])
    object.create_item_in_inventory("BUILDING_1933",    ["SET_STAPLE_GUN"])
    object.create_item_in_inventory("BUILDING_309",    ["SET_NORMAL_CLOTHES_4"])
    object.create_item_in_inventory("BUILDING_212",    ["SET_SOAP"])
## Vesseltown
    object.create_item_in_inventory("BUILDING_1884",    ["SET_AMMOPACK_5_7_MM","SET_HEAD_REST"])
    object.create_item_in_inventory("BUILDING_1210",    ["SET_TENT_CANVAS"])
    object.create_item_in_inventory("BUILDING_1828",    ["SET_WATER_BOTTLE"])
    object.create_item_in_inventory("BUILDING_1868",    ["SET_MEAT_RAW"])
    object.create_item_in_inventory("BUILDING_1440",    ["SET_SOLAR_CELLS"])
    object.create_item_in_inventory("BUILDING_1893",    ["SET_AMMOPACK_5_56_MM","SET_AMMOPACK_5_56_MM"])
    object.create_item_in_inventory("BUILDING_1418",    ["SET_MEAT_COOKED_HUMONGOUS"])
    object.create_item_in_inventory("BUILDING_1280",    ["SET_GAME_JOY"])
    object.create_item_in_inventory("BUILDING_1277",    ["SET_IRON_BAR"])
## MBA
    object.create_item_in_inventory("BUILDING_1995",    ["SET_HAIRSTYLE_MAGAZINE"])
    object.create_item_in_inventory("BUILDING_1997",    ["SET_GRAPHICS_CARD"])

## NPC Items
    object.create_item_in_inventory("EMILY",    ["SET_NORMAL_CLOTHES_3"])
    object.create_item_in_inventory("HARRY",    ["SET_TEDDY_BEAR"])
    object.create_item_in_inventory("LARRY",    ["SET_NORMAL_CLOTHES_4"])
    object.create_item_in_inventory("ESEL",    ["SET_BOTTLE_OF_BOOZE"])
## Mainquest NPCS
    object.create_item_in_inventory("AMBROSIUS",["SET_DRUGS_VIALS_01"])
    object.create_item_in_inventory("ALFRED",    ["SET_NECKLACE"])
    object.create_item_in_inventory("JENSON",    ["SET_NORMAL_CLOTHES_5"])
    object.create_item_in_inventory("KLAUS",    ["SET_BOTTLE_OF_WHISKEY"])
    object.create_item_in_inventory("JUANITA",    ["SET_GARLIC_PRESS"])
    object.create_item_in_inventory("HANNES",    ["SET_NORMAL_CLOTHES_6","SET_BOOMERANG"])
    object.create_item_in_inventory("SVETLANA",["SET_NORMAL_CLOTHES_1","SET_SMALL_SAND_BUCKET"])
    object.create_item_in_inventory("SHANIA",    ["SET_NORMAL_CLOTHES_2"])
    object.create_item_in_inventory("SAM",    ["SET_MULTIPLE_SOCKET"])
    object.create_item_in_inventory("BERNIE",    ["SET_RAT_MEAT","SET_WATER_SKIN"])
    object.create_item_in_inventory("JONAS",    ["SET_SMALL_STOOL"])
    object.create_item_in_inventory("TANJA",    ["SET_NORMAL_CLOTHES_3","SET_BROKEN_SHOVEL"])
    object.create_item_in_inventory("PETE",    ["SET_NORMAL_CLOTHES_4"])

## Shanias Sachen
    system.create_object('SET_SMALL_SAND_SHOVEL',583.85,477.98,'Z7 SHANIAS_SHOVEL',globals.DIR_NORTH_WEST)
    system.create_object('SET_SMALL_SAND_BUCKET',583.39,477.89,'Z7 SHANIAS_BUCKET',globals.DIR_NORTH)
    system.create_object('SET_TEDDY_BEAR',582.96,478.05,'Z7 SHANIAS_TEDDY',globals.DIR_WEST)
    system.create_object('SET_GAME_JOY',583.93,478.36,'Z7 SHANIAS_GAMEJOY',globals.DIR_SOUTH_EAST)

#key for hostage cage
    object.create_item_in_inventory("SHADOW_TANK_COMMANDER",data().qi_cagekey[1],data().qi_cagekey[0])
    object.set_attribute(data().qi_cagekey[0], "generic_item", False)

# Bienenstöcke Z7
    cit( 'BUILDING_10968', [ 'SET_BEESWAX' ] )
    cit( 'BUILDING_10967', [ 'SET_BEESWAX', 'SET_BEESWAX' ] )

# Items in Kisten
    cit( 'BUILDING_10895', [ 'SET_LASERPOINTER', 'SET_COLT_45_W_SILENCER', 'SET_HEGRENADE' ] )
    cit( 'BUILDING_10898', [ 'SET_CALICO_M900', 'SET_AMMOPACK_45', 'SET_AMMOPACK_45' ] )
    cit( 'BUILDING_10899', [ 'SET_MEAT_RAW_SMALL', 'SET_MULTI_MEDIPACK', 'SET_TOASTER' ] )
    cit( 'BUILDING_10900', [ 'SET_DRUGS_VIALS_01', 'SET_AMMOPACK_7_62NATO_MM_DUPLEX', 'SET_M46_HEAVY_ARMOR' ] )
    cit( 'BUILDING_10901', [ 'SET_DT21_STEEL_CLAD_HELMET', 'SET_LASERPOINTER', 'SET_BRASS_KNUCKLES' ] )
    cit( 'BUILDING_10903', [ 'SET_GLOCK_21_W_SILENCER', 'SET_FAMAS', 'SET_HEGRENADE' ] )
    cit( 'BUILDING_10923', [ 'SET_THROWING_KNIFE', 'SET_AXE', 'SET_STAPLE_GUN' ] )
    cit( 'BUILDING_10924', [ 'SET_AUTOMAG_3_W_LASERPOINTER', 'SET_HEAD_REST', 'SET_DART' ] )
    cit( 'BUILDING_10946', [ 'SET_AMMOPACK_5_45_MM', 'SET_AMMOPACK_3_12_MM', 'SET_DT21_LIGHT_ARMOR' ] )
    cit( 'BUILDING_10947', [ 'SET_C4_TIMEBASED_W_NAILS', 'SET_AKSU74_W_LASERPOINTER', 'SET_BOOMERANG' ] )
#cit( 'BUILDING_14266', [ 'SET_AMMOPACK_5_7_SUBSONIC_DUMDUM', 'SET_BREAD', 'SET_LASERPOINTER' ] )

def cit(npc,items):
    object.create_item_in_inventory(object=npc, equipment=items)

## Regionen
def initRegions():
# Spieler betritt die Hafenstadt
    system.add_region(data().Region_VerlasseneHafenstadt,375.0,550.0,500.0,300.0)
    system.notify_region_entered(data().Region_VerlasseneHafenstadt,objectid="ALTER_EGO",permanent=False)

# Spieler sieht den Kran
    system.add_region(data().Region_Kran,505.0,500.0,496.0,450.0)

    system.add_region("KRAN_REGION",505.0,500.0,496.0,450.0)
    system.notify_region_entered("KRAN_REGION",partyid="UISPIELER")

    system.add_region("REGION_HELICOPTER",715,238,760,321)
    system.notify_region_entered("REGION_HELICOPTER",partyid="UISPIELER")

# Spieler sieht das Museum
    system.add_region(data().Region_AACMuseeum,287.0,254.0,216.0,205.0)
    system.notify_region_entered(data().Region_AACMuseeum,objectid="ALTER_EGO",permanent=False)

# Spieler sieht den Esel
    system.add_region(data().Region_Esel,400.0,265.0,380.0,290.0)
    system.notify_region_entered(data().Region_Esel,objectid="ALTER_EGO",permanent=True)

## Spieler tritt in den Maschinenraum
    system.add_region(data().Region_MaschinenRaum,660.0,453.0,643.0,480.0)

## Spieler trifft auf Brad und Craig an der Strippett
    system.add_region(data().Region_Strippe,513.0,470.0,523.0,487.0)

## Vesseltown
    system.add_region(data().Region_VesselTown,513.0,593.0,706.0,398.0)

## Spieler kommt in die Naehe der Outdoorkneipe
    system.add_region(data().Region_OutdoorKneipe,423,534,442,550)
    system.notify_region_entered(data().Region_OutdoorKneipe,objectid="ALTER_EGO",permanent=False)

    system.add_region("REGION_HOSTAGE_CAGE", 595,345,615,365)
    system.notify_region_entered("REGION_HOSTAGE_CAGE",objectid="ALTER_EGO",permanent=False)

## Exitzonen
def initExitZones():
    system.add_region(id="REGION_EXIT_NORD",    x1=100.0,    y1=100.0,    x2=590.0,    y2=200.0)
    system.add_region(id="REGION_EXIT_WEST",    x1=100.0,    y1=200.0,    x2=200.0,    y2=600.0)
#system.add_region(id="REGION_EXIT_OST",    x1=984.0,    y1=200.0,    x2=1084.0,    y2=600.0)
    system.add_region(id="REGION_EXIT_SUED",    x1=100.0,    y1=600.0,    x2=504.0,    y2=700.0)

    system.register_exit(regionname="REGION_EXIT_NORD")
#system.register_exit(regionname="REGION_EXIT_OST")
    system.register_exit(regionname="REGION_EXIT_SUED")
    system.register_exit(regionname="REGION_EXIT_WEST")

## Effekte
def initFX():
    for id in const.OBJ_LAGERFEUER:
        fxLagerFeuer(id)
    for id in const.OBJ_BRENNENDE_TONNEN:
        fxBrennendeTonne(id)
    sounds.load_sound("crane_engine_loop")
    sounds.load_sound("crane_engine_starts")
    sounds.load_sound("crane_engine_off")
    sounds.load_sound("crane_lifting_container")
    sounds.load_sound("crane_rotating")
    sounds.load_sound("crane_setting_down_container")
    sounds.load_sound("crane_working_steel_cable")

    sounds.load_sound("fissling_plants_1")
    sounds.load_sound("fissling_plants_1")

## Questbook
def initQuestbook():
    if not hasattr(data('zone_7.zone_7'), 'QB_001'):
        data().QB_001 = -1
    if data().QB_001 == -1:
        data().QB_001 = system.register_qb_entry('ZONE7_AIM_01')
        if system.get_qb_entry_state(data().QB_001) != UNCOMPLETE:
            system.set_qb_entry_state(data().QB_001,UNCOMPLETE)
    data().QB_002 = system.register_qb_entry('ZONE7_AIM_02')
    data().QB_003 = system.register_qb_entry('ZONE7_AIM_03')
    data().QB_004 = system.register_qb_entry('ZONE7_AIM_04')
    data().QB_005 = system.register_qb_entry('ZONE7_AIM_05')
    data().QB_006 = system.register_qb_entry('ZONE7_AIM_06')
    data().QB_007 = system.register_qb_entry('ZONE7_AIM_07')
    data().QB_008 = system.register_qb_entry('ZONE7_AIM_08')
    data().QB_009 = system.register_qb_entry('ZONE7_AIM_09')
    data().QB_010 = system.register_qb_entry('ZONE7_AIM_10')
    data().QB_011 = system.register_qb_entry('ZONE7_AIM_11')
    data().QB_012 = system.register_qb_entry('ZONE7_AIM_12')
    data().QB_013 = system.register_qb_entry('ZONE7_AIM_13')
    data().QB_014 = system.register_qb_entry('ZONE7_AIM_14')
    data().QB_015 = system.register_qb_entry('ZONE7_AIM_15')
    data().QB_016 = system.register_qb_entry('ZONE7_AIM_16')


def initHerbs():
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=455.47, y=541.41)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=368.24, y=306.22)
    system.create_object(equipmenttype="SET_BURNET", x=418.95, y=419.00)
    system.create_object(equipmenttype="SET_BURNET", x=345.02, y=547.19)
    system.create_object(equipmenttype="SET_ANGELICA", x=315.72, y=241.54)
    system.create_object(equipmenttype="SET_ANGELICA", x=370.01, y=304.30)

def on_button_down(Button):
    return False

# Lagerfeuer FX
def fxLagerFeuer(_objectid):
    system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
    system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
    system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
    system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
    system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
    sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

# Brennende Tonne FX
def fxBrennendeTonne(_objectid):
    system.start_effect_object(object=_objectid,node="sort1",parameter=fx_fire_brennende_tonne)
    sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)

## Feind gesichtet
def on_enemy_spotted(object_id):
    if object_id == data().qi_wheeltank[0]:
        return False

    enemys = character.get_visible_enemies(object_id)
#print "[debug on_enemy_spotted",object_id,"]"

    if object.is_npc(object_id) and len(enemys):

        if not hasattr(data(), "enemy_spotted"):
            data().enemy_spotted = []
        if not object_id in data().enemy_spotted:
            data().enemy_spotted.append(object_id)
        else:
            return

#anhalten eines chars, der schedule npc ist
        if object_id in schedules.schedules.keys():
            halt_char(object_id)

# erste schatten alarmiert schatten 2
        if object_id == "SHADOW_01":
            attack_enemy(object_id)
            attack_enemy("SHADOW_02", system.get_pcs())

# patrouille alarmiert schatten 8-11
        elif object_id in ["SHADOW_P1","SHADOW_P2"]:
            halt_char(object_id)
            if not data().kampf_p1_p2_alarm:
                 data().kampf_p1_p2_alarm = True
                 onefound = False
                 for id in ["SHADOW_08","SHADOW_09","SHADOW_10","SHADOW_11"]:
                    if not onefound:
                        if not object.is_destroyed(id):
                            x,y = object.get_x(id)+1,object.get_y(id)+1
                            onefound = True
                            object.move_to(object_id,x,y,"landscape",MT_FAST, callback=["ONEND",alarm_shadows_8to11])
                 if (object_id == "SHADOW_P1"):
                    attack_enemy("SHADOW_P2", system.get_pcs())
                 else:
                    attack_enemy("SHADOW_P1", system.get_pcs())

# schatten auf dem locus
        elif object_id == "SHADOW_17":
            if not object.is_destroyed(object_id):
                object.step_to("SHADOW_17", 635.5,396.7, speed=MT_FAST, callback=["ONEND", attack_enemy])
                return True

        elif object_id in ["SHADOW_03","SHADOW_04"]:
            if not object.is_destroyed("SHADOW_03"):
                attack_enemy("SHADOW_03", enemys)
                object.step_away("SHADOW_03")
            if not object.is_destroyed("SHADOW_04"):
                attack_enemy("SHADOW_04", enemys)
                object.step_away("SHADOW_04")

# andere schatten greifen an
        elif (not object_id in system.get_pcs() and
            not object_id in ["SHADOW_01","SHADOW_P1","SHADOW_P2","SHADOW_03","SHADOW_04"]):
            if not object_id in system.get_animals():
                attack_enemy(object_id)

## angriffs-callback
def on_attack(operator, target):
#print "[debug on_attack",operator,target,"]"
    if object.is_npc(target):
        if not hasattr(data(), "enemy_attack"):
            data().enemy_attack = []
        if not target in data().enemy_attack:
            data().enemy_attack.append(target)
        else:
            return
        if not object.is_destroyed(target):
            object.turn_to_object(target,operator, callback=["ONEND", on_enemy_spotted])

## sichtbereich wieder frei?
def on_sector_cleared(object_id):
#print "[debug on_sector_cleared",object_id,"]"
#if object_id in schedules.schedules.keys():
#    unhalt_char(object_id)
    pass

## callback für waffen-abfeuern
def onWeaponIgnition(weapon_type,x,y,z):
## Shadow 16 feuert sein HE ab, Alamierung von Shadow 08-11 pruefen
## he-granate alarmiert schatten 8-11
    if weapon_type == "SET_HEGRENADE":
        near = False
        for id in ["SHADOW_08","SHADOW_09","SHADOW_10","SHADOW_11"]:
            if not object.is_destroyed(id):
                if not near:
                    sx,sy = object.get_x(id),object.get_y(id)
                    dx,dy = abs(x-sx),abs(y-sy)
                    dist = sqrt(sqr(dx) + sqr(dy))
#print "--- distance to",id,":",str(dist)
                    if dist <= 40.0:
                        near = True
                if near:
                    alarm_shadows_8to11("SHADOW_09")

# anhalten eines npcs
def halt_char(id):
    if not object.is_destroyed(id):
        object.cancel_commandos(id)
        prohibit_activity(id, False)
        character.arm_direct(id)

# weiterführen der aktionen eines npcs
def unhalt_char(id):
    if not object.is_destroyed(id):
        object.cancel_commandos(id)
        allow_activity(id)

#angreifen
def attack_enemy(id, enemys=None):
    if not object.is_destroyed(id):
        if enemys == None:
            enemys = character.get_visible_enemies(id)
        if enemys and len(enemys):
            halt_char(id)
            object.attack(id, random.choice(enemys))

# alarmierung von schatten 8-11
def alarm_shadows_8to11(id):
    if not object.is_destroyed(id):
#print "shadows have been alarmed!!"
        for attacker in ["SHADOW_09","SHADOW_10","SHADOW_11"]:
            if not object.is_destroyed(attacker):
                attack_enemy(attacker,system.get_pcs())
        if not object.is_destroyed("SHADOW_08"):
            halt_char("SHADOW_08")
            data().shadow_08_patrol = True

def kill():
    for shadow in data().SCHATTEN_NPCS:
        object.destroy(shadow)

#positionieren+deaktiviern der vesseltown bewohner
def init_vesseltownies():
    counter = 0
    vesseltownies = []
    for id in const.NPCS_IN_VESSELTOWN:
        vesseltownies.append(id)
    for id in data().TAGESABLAUF_NPCS:
        vesseltownies.append(id)

    for citizen in vesseltownies:
        x = const.POSES_VESSELTOWNIES[counter][0]
        y = const.POSES_VESSELTOWNIES[counter][1]
        d = const.POSES_VESSELTOWNIES[counter][2]
        object.set_position(citizen, x,y)
        object.set_direction(citizen,d)
        object.set_active_state(citizen, 0)
        counter += 1
#def can_enter_building( character_id, building_id ):
#    if building_id == "BUILDING_2421":
##if(data().rupert_museums_ta_aktiv != True)
#        if( system.get_qb_entry_state(data().QB_003) ) 
#            if character_id in system.get_pcs():
#                return False
#    return object_events.can_enter_building( character_id, building_id )

#abschliessen des museeums + gefängnisses
def init_lock_state(building='BUILDING_2421', state='lock'):
    import object_events
    if state=='lock':
#system.add_text("schliessen")
        print("should not happen, museum locked")
        object.add_closed_lock(building, "lock1", closure_type='normal')
    else:
#system.add_text("oeffnen")
        object.remove_closed_lock_by_name(building, "lock1")

def InitChestsSafes():
    object.add_closed_lock("BUILDING_10895", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_10898", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_10899", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_10900", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_10901", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_10903", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_10923", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_10924", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_10946", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_10947", "lock1", closure_type='booby-trap')
#object.add_closed_lock("BUILDING_14266", "lock1", closure_type='normal')

def can_crack_lock( character_id, object_id, dummy_name ):
    if object_id == "ZONE_7_BUILDING_2421":
        return False
    elif object_id == "ZONE_7_BUILDING_2405":
        return True
    else:
        return object_events.can_crack_lock( character_id, object_id, dummy_name )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id == "ZONE_7_BUILDING_2421":
        return False
    elif object_id == "ZONE_7_BUILDING_2405":
        if object.has_attribute(character_id,"lock_pick"):
            if object.get_attribute(character_id,"lock_pick") >= 90:
                if not data().hostages_rescued:
                    if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS):
                        dialogs.initDlg_132_SpielerWillGeiselnImmerNochNichtBefreien()
                    else:
                        dialogs.initCutscene_133_SpielerBefreitGeiseln()
                        data().hostages_rescued = True
                        return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )
    else:
        return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

def can_blast_lock( character_id, object_id, dummy ):
    if object_id == "ZONE_7_BUILDING_2421":
        return False
    elif object_id == "ZONE_7_BUILDING_2405":
        return True
    else:
        return object_events.can_blast_lock( character_id, object_id, dummy )

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id == "ZONE_7_BUILDING_2421":
        return False
    elif object_id == "ZONE_7_BUILDING_2405":
        if object.has_attribute(character_id,"explosives_talents"):
            if "blast_locks" in object.get_attribute(character_id,"explosives_talents"):
                if not data().hostages_rescued:
                    if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS):
                        dialogs.initDlg_132_SpielerWillGeiselnImmerNochNichtBefreien()
                    else:
                        dialogs.initCutscene_133_SpielerBefreitGeiseln()
                        data().hostages_rescued = True
                        return object_events.on_blast_lock( character_id, object_id, dummy_name, x, y, z )
    else:
        return object_events.on_blast_lock( character_id, object_id, dummy_name, x, y, z )

def can_enter_building( character_id, building_id ):
    if building_id == "ZONE_7_BUILDING_2421":
        if character_id in system.get_pcs():
            return (system.get_qb_entry_state(data().QB_003)== COMPLETE)
    return object_events.can_enter_building( character_id, building_id )

def init_patch():
    import rest
    import vehicle
    if not hasattr(data('rest'), 'legal_rest_areas'):
        rest.init_data()

    if not hasattr(data('zone_7.zone_7'), 'QB_001'):
        data('zone_7.zone_7').QB_001 = -1

    if not hasattr(data(),"aufenthaltsort"):
        x,y,z = object.get_position("ALTER_EGO")
        if y > 290:
            if x < 507:
                data().aufenthaltsort = "seaport"
            else:
                data().aufenthaltsort = "vesseltown"
        else:
            dy = 290 - y
            gx = 565+(dy*22)*0.014492753623188405797101449275362
            if x < gx:
                data().aufenthaltsort = "seaport"
            else:
                data().aufenthaltsort = "vesseltown"

    if data().craigbrad_flughund_zerstoert:
        character.set_main_quest_npc_state(char="BRAD", state=False)

    if "ANIE" in system.get_npcs():
        if "ANIE" in data().pcs:
            if object.is_active("ANIE"):
                character.change_body_mode("ANIE","STAND")
                data().hostages_rescued = True
                data().anie_folgt = True
                object.set_attribute("ANIE","zone_transfer",True)

    if object.count_in_inventory("EMILY",data().qi_fett[0]) and\
        object.count_in_inventory("EMILY",data().qi_alkohol[0]):
        if system.get_qb_entry_state(data().QB_008)==INACTIVE:
            system.set_qb_entry_state(data().QB_008, COMPLETE)
            system.set_qb_entry_state(data().QB_009, INACTIVE)
            system.set_qb_entry_state(data().QB_010, INACTIVE)
            system.set_qb_entry_state(data().QB_011, INACTIVE)
            system.set_qb_entry_state(data().QB_016, INACTIVE)

    if data().aufenthaltsort == "seaport":
        data('rest').legal_rest_areas['zone_7'] = REST_NONE_VESSELTOUWN
    else:
        data('rest').legal_rest_areas['zone_7'] = REST_VESSELTOUWN

    if data().QB_001 == -1:
        data().QB_001 = system.register_qb_entry('ZONE7_AIM_01')
        data('zone_7.zone_7').QB_001 = system.register_qb_entry('ZONE7_AIM_01')
        system.set_qb_entry_state(data('zone_7.zone_7').QB_001,UNCOMPLETE)
        system.notify_region_entered(data().Region_Kran, partyid="UISPIELER")

    if system.get_qb_entry_state(data('zone_7.zone_7').QB_001) == INACTIVE and system.get_qb_entry_state(data().QB_002) == INACTIVE:
        system.set_qb_entry_state(data('zone_7.zone_7').QB_001,UNCOMPLETE)
        system.notify_region_entered(data().Region_Kran, partyid="UISPIELER")