# -*- coding: utf-8 -*-
#Todo:
#-Questitems aus der Zone fehlen
#-Quests hinzu

################################################################################
###	Stand:	Revision 6, 21.06.2004					     ###
################################################################################

from globals import *
from const import *
import const
import npc
import dialogs
import object_events
import schedules
import dynamic_camera
import math
import enemy_script
import daily_routine
import system_events
import sounds


def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
	#Weil Höhle, gibt es nur einen Ein- und Ausgang
	start_locations = \
		{	"NORTH":	(591.02, 570,70), # am Höleneingang
	 		"SOUTH":	(591.02, 570,70), # am Höleneingang
	 		"WEST":		(591.02, 570,70), # am Höleneingang
	 		'EAST':		(591.02, 570,70)  # am Höleneingang
			
			#"EAST":	(327.00, 408.00) # bei Tony
			
			#'EAST':	(389.72, 278.00) # an Säule
			#"EAST":	(518.00, 246.00) # am Einsturz
			#'EAST':	(330.73, 364.37) # Schrottplatz
			#'EAST':	(550.44, 268.36) # Waffenlager
			#'EAST':	(584.77, 469.55) # ERLAN
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("cave")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Norden",395,570,564,480)
		system.add_region("Sueden",515,220,575,310)
		system.add_region("Waffenlager",410,324,480,410)
		system.add_region("Mittendrin",265,340,330,535)

	data("rest").non_rest_areas.append("Norden")
	data("rest").non_rest_areas.append("Sueden")
	data("rest").non_rest_areas.append("Waffenlager")
	data("rest").non_rest_areas.append("Mittendrin")

def on_map_loaded():
	init_data()
	initParties()
	initExitZones()
	initFX()
	npc.initNPCS()
	# place player characters
	location = GetZoneEnterLocation( "EAST" )
	system.zone_transfer_place_characters( location[0], location[1] )
	
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
		
	if not object.exists('ABEL'):# not in system.get_npcs():
		system.create_character(
			id="ABEL",
			gender="male",
			party="NPCS",
			x = 584.75,
			y = 569.76,
			direction=0,
			name=globaltext.NAME_ABEL,
			resourceui="abel.png")
			
		object.set_attributes("ABEL",
			model="low",
			gender="male",
			skin="grey",
			clothes="ls_shadow_02",
			face="abel")
		character.update_appearance("ABEL")
		character.scale('ABEL', 2.22)
	else:
		object.set_position('ABEL', 581.16, 564.79 )
	
	if not object.exists('ANIE'):# not in system.get_pcs():
		#Anie
		system.create_character(
		id="ANIE",
			gender="female",
			party="NPCS",
			x=561.37,
			y=558.19,
			direction=0,
			name=globaltext.NAME_ANIE,
			resourceui="anie.png")
			
		object.set_attributes("ANIE",
			model="low",
			gender="female",
			skin="grey",
			clothes="ll_shadow_03",
			face="anie")
		character.update_appearance("ANIE")
		character.scale('ANIE', 1.68)
	else:
		object.set_position('ANIE', 561.37, 558.19 )
	#################################################################
	object.set_attribute('ABEL', 'zone_transfer', False)
	object.set_attribute('ANIE', 'zone_transfer', False)
	
	object.set_position('ALTER_EGO', 587.76, 571.05)
	object.set_position('ANIE', 591.68, 570.36)
	object.set_position('ABEL', 588.78, 568.54)
	x = 0
	for id in system.get_pcs():
		if id != 'ALTER_EGO':
			object.set_position(id, START_PARTY[x][0], START_PARTY[x][1])
			x += 1
	initRegions()
	initItems()
	initHerbs()
	initMainQuestNPC()
	initImmortalNPC()
	npc.initAnimals()
	initQuestItems()
	initQuestbook()
	initZoneObjects()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_C4_Blinker(None)
	init_Object_Anim()
	init_non_rest_areas()
	init_locks()
	enemy_script.delay(2, Lambda('setAbelStartdialog()'))
	sounds.load_sound('working_excravator')
	
def init_locks():
	object.add_closed_lock("ZONE_9_BUILDING_1431", "lock1", closure_type='normal')
	object.add_closed_lock("ZONE_9_BUILDING_6600", "lock1", closure_type='normal')
	object.add_closed_lock("ZONE_9_BUILDING_6599", "lock1", closure_type='normal')
	object.add_closed_lock("ZONE_9_BUILDING_948", "lock1", closure_type='normal')
	object.add_closed_lock("ZONE_9_BUILDING_949", "lock1", closure_type='normal')

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	# herumliegende Leichen
	for id in data().Leichen:
		system.mark_for_script_use(id)
	for id in data().DYNAMIT:
		system.mark_for_script_use(id)
	# EXKAVATOR Deponie
	system.mark_for_script_use('ZONE_9_BUILDING_1427')
	# EXKAVATOR Höhle
	system.mark_for_script_use(EXKAVATOR_POS_1)
	for id in FIRE:
		system.mark_for_script_use(id)
	# kisten, truhen, tresore
	system.mark_for_script_use('ZONE_9_BUILDING_12468')
	system.mark_for_script_use('ZONE_9_BUILDING_12481')
	system.mark_for_script_use('ZONE_9_BUILDING_12485')
	system.mark_for_script_use('ZONE_9_BUILDING_12486')
	system.mark_for_script_use('ZONE_9_BUILDING_12487')
	system.mark_for_script_use('ZONE_9_BUILDING_12488')
	system.mark_for_script_use('ZONE_9_BUILDING_12490')
	system.mark_for_script_use('ZONE_9_BUILDING_12491')
	system.mark_for_script_use('ZONE_9_BUILDING_12493')
	system.mark_for_script_use('ZONE_9_BUILDING_10437')
	system.mark_for_script_use('ZONE_9_BUILDING_12494')
	
	# Käfige 
	system.mark_for_script_use("ZONE_9_BUILDING_1431")
	system.mark_for_script_use("ZONE_9_BUILDING_6600")
	system.mark_for_script_use("ZONE_9_BUILDING_6599")
	system.mark_for_script_use("ZONE_9_BUILDING_948")
	system.mark_for_script_use("ZONE_9_BUILDING_949")
	
	# Bienenstöcke Zone 9
	

def init_Object_Anim():
	init_Banner()

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	pass
	
def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( "EAST" )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	for id in data().Leichen:
		object.set_active_state(id,False)
	init_patch()

def initQuestbook():
	data().QB_001 = system.register_qb_entry('ZONE9_AIM_01')
	data().QB_002 = system.register_qb_entry('ZONE9_AIM_02')
	data().QB_003 = system.register_qb_entry('ZONE9_AIM_03')
	data().QB_004 = system.register_qb_entry('ZONE9_AIM_04')
	data().QB_005 = system.register_qb_entry('ZONE9_AIM_05')
	data().QB_006 = system.register_qb_entry('ZONE9_AIM_06')
	data().QB_007 = system.register_qb_entry('ZONE9_AIM_07')
	data().QB_009 = system.register_qb_entry('ZONE9_AIM_09')
	data().QB_010 = system.register_qb_entry('ZONE9_AIM_10')
	data().QB_012 = system.register_qb_entry('ZONE9_AIM_12')
	data().QB_013 = system.register_qb_entry('ZONE9_AIM_13')
	data().QB_014 = system.register_qb_entry('ZONE9_AIM_14')
	data().QB_016 = system.register_qb_entry('ZONE9_AIM_16')
	data().QB_017 = system.register_qb_entry('ZONE9_AIM_17')
	data().QB_018 = system.register_qb_entry('ZONE9_AIM_18')
	data().QB_019 = system.register_qb_entry('ZONE9_AIM_19')

def initMainQuestNPC():
	character.set_main_quest_npc_state("JACOB",True)
	character.set_main_quest_npc_state("HYDE",True)
	character.set_main_quest_npc_state("ABEL",True)
	character.set_main_quest_npc_state("ANIE",True)
	character.set_main_quest_npc_state("KAYLA",True)
	character.set_main_quest_npc_state("SAMSON",True)
	character.set_main_quest_npc_state("HALE",True)
	character.set_main_quest_npc_state("WRIGHT",True)
	

def initImmortalNPC():
	for id in system.get_npcs():
		object.set_immortal_state(id, True)

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def initQuestItems():
	system.create_object('SET_GAS_CANISTER',x = 571.09 , y = 528.54 , id = KANISTER_BENZIN)
	object.set_attribute(KANISTER_BENZIN, "generic_item", False)
	object.create_item_in_inventory('JACOB', 'SET_CEREBRAL_MEMORY_MODULE', id = CEREBRAL_MEMORY_MODULE)
	object.set_attribute(CEREBRAL_MEMORY_MODULE,"generic_item", False)
	# aktivierung nach ende von Quest_001
	system.create_object('SET_NANO_BOT_SURGICAL_DEVICE', x = 509.43 , y = 243.43, id = NANO_BOT_SURGICAL_DEVICE)
	object.set_attribute(NANO_BOT_SURGICAL_DEVICE,"generic_item", False)
	object.set_active_state(NANO_BOT_SURGICAL_DEVICE, False)
	system.create_object('SET_DISTRIBUTOR', 535.80, 276.40, id = VERTEILER)
	object.set_position_free(VERTEILER, 537.07, 274.65, 1.4)
	

def initZoneObjects():
	system.create_object('RES3D_TRES_OBJECTS_BUILDING_HOEHLE_2', x = 506.00, y = 239.08, id = HOEHLE_GESCHLOSSEN, direction = 129)
	system.create_object('RES3D_TRES_OBJECTS_BUILDING_HOEHLE_2_OFFEN', x = 507.54, y = 241.22, id = HOEHLE_OFFEN, direction = 129)
	object.set_active_state(HOEHLE_OFFEN, False)
	system.create_object('RES3D_TRES_OBJECTS_BUILDING_ROADHEAD', x = 516.00, y = 241.50, id = EXKAVATOR_POS_1, direction = 213)
	object.set_active_state(EXKAVATOR_POS_1, False)
	
	for id in LISTE_SCRIPT_OBJECTS:
		object.set_immortal_state(id, True)
     
def on_attack(operator_id, target_id):
	if target_id in ['ANIMAL_BEAR_001', 'ANIMAL_BEAR_002', 'ANIMAL_BEAR_003']:
		object.set_attribute('ANIMAL_BEAR_001', 'foes', ['UISPIELER'])
		object.set_attribute('ANIMAL_BEAR_002', 'foes', ['UISPIELER'])
		object.set_attribute('ANIMAL_BEAR_003', 'foes', ['UISPIELER'])
		

def on_approach(target,operator):
	
	if dialog.is_dialog_active():
		return
	
	if not object_events.on_approach(target, operator):
		if not target in ['ZEKE', 'ERLAN', 'KAYLA']:
			dialogs.on_approach(target, operator)
	
	if target == 'ZEKE':
		const.Loops_Zeke = 7
		if character.get_act_animation_name(target) in ['CM_KNIEND_WASSERLOCH_GRABEN_START', 'CM_KNIEND_WASSERLOCH_GRABEN_LOOP', 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE']:
			if character.get_act_animation_name(target) == 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE':
				finish_activity(target)
				enemy_script.delay(0.5, Lambda('object.cancel_commandos("ZEKE")'))
				on_approach_End(target, operator)
			else:
				character.play_animation(target,'CM_KNIEND_WASSERLOCH_GRABEN_ENDE', callback = ['ONEND', Lambda('on_approach_End("%s", "%s")'%(target,operator))])
			
		else:
			object.cancel_commandos('ZEKE')
			on_approach_End(target, operator)
		return True
		
	if target == 'ERLAN' and not system.get_qb_entry_state(data().QB_007) == globals.COMPLETE:
		const.Loops_Erlan = 7
		object.cancel_commandos('ERLAN')
		prohibit_activity('ERLAN')
		object.turn_to_object(target,operator, callback = ['ONEND', Lambda('dialogs.on_approach("%s","%s" )'%(target, operator))])
		return True
		
	
	if target == 'KAYLA':
		object.cancel_commandos(target)
		if data().KrankerKAYLA not in data().Kranke_Schatten:
			data().Kranke_Schatten.append(data().KrankerKAYLA)
		object.turn_to_object(target, operator, callback = ['ONEND', Lambda('dialogs.on_approach("%s", "%s")'%( target, operator ))])
		return True


	dialogs.on_approach(target, operator)
		
def on_approach_End(target, operator):
	object.turn_to_object(target, operator, callback = ['ONEND', Lambda('dialogs.on_approach("%s","%s" )'%(target, operator))])
		

def on_map_exit(next_zone):
	system_events.on_map_exit(next_zone)
	if data().HALE_Gesund:
		if 'ABEL' in system.get_npcs():
			object.cancel_commandos('ABEL')
			object.set_position_free("ABEL", 398.40, 218.59, 0.0, "landscape", "zone_10.zone_10")
		if 'ANIE' in system.get_npcs():
			object.cancel_commandos('ANIE')
			object.set_position_free("ANIE", 398.40, 218.59, 0.0, "landscape", "zone_10.zone_10")
		
def on_enter_region(id, objectid, partyid ):
	# print "[on_enter_region(",id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if id == 'REGION_EINSTURZ_SAMSON':
		dialogs.initCutscene_Dlg_051_SamsonLeitetHilfsoperation()
	
	if id == "KRANKENHAUS":
		if not data().player_knows_Krankenhaus:
			data().player_knows_Krankenhaus = True
			system.add_minimap_marker(548.63, 542.29,"MM_001")# Krankenhaus

	if id == "WAFFENKAMMER":
		if not data().player_knows_Waffenkammer:
			data().player_knows_Waffenkammer = True
			system.add_minimap_marker(539.62, 275.95,"MM_003")# Waffenkammer

	if id == "Saeule_N":
		if not data().player_knows_SaeuleN:
			data().player_knows_SaeuleN = True
			system.add_minimap_marker(351.93, 251.87,"MM_006")# Säule

	if id == "Saeule_S":
		if not data().player_knows_SaeuleS:
			data().player_knows_SaeuleS = True
			system.add_minimap_marker(364.03, 565.02,"MM_009")# Säule

	if id == "Saeule_O":
		if not data().player_knows_SaeuleO:
			data().player_knows_SaeuleO = True
			system.add_minimap_marker(579.13, 280.61,"MM_007")# Säule

	if id == "Saeule_W":
		if not data().player_knows_SaeuleW:
			data().player_knows_SaeuleW = True
			system.add_minimap_marker(533.12, 499.19,"MM_008")# Säule

	if (id == Region_Einsturz):
		if not data().player_knows_Einsturz:
			data().player_knows_Einsturz = True
			system.add_minimap_marker(511.26, 239.05,"MM_004")# Einsturz
		dialogs.initDlg_19_SchattenBefreitErstesMalDa()

	# Säule an der Wright arbeitet
	elif (id == 'Region_Saeule_N' and not data().ZoneWrightBetreten):
		if not data().player_knows_SaeuleN:
			data().player_knows_SaeuleN = True
			system.add_minimap_marker(351.93, 251.87,"MM_006")# Säule
		data().ZoneWrightBetreten = True
		data().Wright_Genaehert_Von = 'N'
		dialogs.initCutscene_Dlg_038_WrightUnd3NPCS()
	
	# Säule an der Wright arbeitet
	elif (id == 'Region_Saeule_S'and not data().ZoneWrightBetreten):
		data().ZoneWrightBetreten = True
		data().Wright_Genaehert_Von = 'S'
		dialogs.initCutscene_Dlg_038_WrightUnd3NPCS()
		
	# Säule an der Wright arbeitet
	elif (id == 'Region_Saeule_O'and not data().ZoneWrightBetreten):
		data().ZoneWrightBetreten = True
		data().Wright_Genaehert_Von = 'O'
		dialogs.initCutscene_Dlg_038_WrightUnd3NPCS()
		
	# Säule an der Wright arbeitet
	elif (id == 'Region_Saeule_W'and not data().ZoneWrightBetreten):
		data().ZoneWrightBetreten = True
		data().Wright_Genaehert_Von = 'W'
		dialogs.initCutscene_Dlg_038_WrightUnd3NPCS()
		
	elif (id in data().DYNAMIT): # werden aktiviert wenn zeit abgelaufen ist
		DynamitQuestAbgegrochen(id, objectid)
	
	elif (id == 'WASSERQUEST'):
		water.set_water_source(546.27, 394.18, 0)
	
	elif (id == 'RUTH' and not data().Region_Ruth_Betreten):
		data().Region_Ruth_Betreten = True
		dialogs.initCutscene_074_Ruth_Hat_Neuigkeiten()
		set_zone_enabled("zzone_8",True)
		
	elif (id == 'ZEKE_KNACKT'):
		system.start_cutscene()
		enemy_script.delay(3, Lambda('system.set_camera_view([559.6524658203125, 273.42135620117187, 18.396183013916016, -0.97453486919403076, 0.063693426549434662, -0.21500022709369659])'))
		object.move_to('ALTER_EGO', 546.87, 275.68, callback = ['ONEND', Lambda('dialogs.initDlg_025_SpielerKnacktSchloss()')])
		object.cancel_commandos('ZEKE')
		object.move_to('ZEKE', 547.36, 273.59, callback = ['ONEND', Lambda('dialogs.initDlg_025_SpielerKnacktSchloss()')])
		
	elif (id == 'ZEKE_SPRENGT'):
		system.start_cutscene()
		enemy_script.delay(3, Lambda('system.set_camera_view([559.6524658203125, 273.42135620117187, 18.396183013916016, -0.97453486919403076, 0.063693426549434662, -0.21500022709369659])'))
		object.move_to('ALTER_EGO', 546.87, 275.68, callback = ['ONEND', Lambda('dialogs.initDlg_026_SpielerSprengtSchloss()')])
		object.cancel_commandos('ZEKE')
		object.move_to('ZEKE', 547.36, 273.59, callback = ['ONEND', Lambda('dialogs.initDlg_026_SpielerSprengtSchloss()')])
		
	
	elif (id == 'REGION_JACOB'):
		dialogs.initCutscene_Dlg_021_ErstesMal()
		
def on_water_found(character_id, x, y):
	# print '[debug : on_water_found(',character_id, x, y,')]'
	if (545.00 < x < 547.00 and 393.00 < y < 395.00):
		data().Quelle_Gefunden = True
		on_water_marker()
	return object_events.on_water_found(character_id, x, y)

def on_water_marker():
	if not data().player_knows_Provisorischer_Brunnen:
		data().player_knows_Provisorischer_Brunnen = True
		system.add_minimap_marker(559.50, 386.50,"MM_005")# Provisorischer Brunnen

def can_put_down(character_id, item_id, item_type, x, y, grid_identifier):
	# print '[debug: can_put_down] ',character_id, item_id, item_type, x, y, grid_identifier
	#if (item_type in DYNAMITWAFFENLAGER and 
	#	enemy_script.check_char_skill(system.get_pcs(), 'explosives', 75)):
	#		if 542.00 < x < 544.50 and 272.30 < y < 274.71:
	#			if system.get_qb_entry_state(data().QB_010) == globals.UNCOMPLETE and not data().TuerOffen:
	#				PC = enemy_script.is_in_area(system.get_pcs(), 20, 'BUILDING_1431')
	#				PC = enemy_script.check_char_skill(PC,'explosives', 75) # PC der der das Schloss öffnet
	#				if not PC == None:
	#					object.cancel_commandos('ZEKE')
	#					finish_activity('ZEKE')
	#					object.remove_item_from_inventory(character_id, item_type) 
	#					const.ZEKE_VEWENDETES_DYNAMIT = item_type
	#					dialogs.initDlg_026_SpielerSprengtSchloss(PC)
	#					object.remove_closed_lock_by_name('ZONE_9_BUILDING_1431', 'lock1')
	#					data().TuerOffen = True
	#					return False
	#			else:
	#				dialogs.initDlg_067_SpielerFummeltAnWaffenkammer()
	#				return False
	return True

def can_use( character_id, object_id ):
	# print ('can_use: character_id %s \n object_id %s') %(character_id, object_id)
	if(object_id.endswith('BUILDING_1427')):
		if (system.get_qb_entry_state(data().QB_003) == globals.UNCOMPLETE):
			return True
		else:
			return False
	elif (object_id in data().DYNAMIT):
		return True
	
	return object_events.can_use( character_id, object_id )

def pre_use( character_id, object_id, item_id, item_type ):
	# print 'debug  pre_use: character_id, object_id, item_id, item_type', character_id, object_id, item_id, item_type
	if object_id != None:
		if(object_id.endswith('BUILDING_2926')):
			object.set_attribute(object_id, "on_use_coordinates", [577.57, 280.72, 0.00])
		
		elif(object_id.endswith('BUILDING_2927')):
			object.set_attribute(object_id, "on_use_coordinates", [349.03, 252.63, 0.00])
		
		elif(object_id.endswith('BUILDING_2929')):
			object.set_attribute(object_id, "on_use_coordinates", [530.18, 498.70, 0.00])
		
		elif(object_id.endswith('BUILDING_2928')):
			object.set_attribute(object_id, "on_use_coordinates", [362.91, 568.76, 0.00])

def on_use( character_id, object_id, item_id, item_type ):
	# print ('on_use: character_id: %s, object_id: %s, item_id: %s, item_type: %s') %(character_id, object_id, item_id, item_type )
	if (object_id != None):
		# Spieler betankt Bohrgerät
		if (object_id.endswith("BUILDING_1427") 
		    and (item_id == KANISTER_BENZIN or item_type == 'SET_GAS_CANISTER')
		    and system.get_qb_entry_state(data().QB_004) == globals.UNCOMPLETE):
			    dialogs.initDlg_042_SpielerBetanktBohrgeraet()
			    object.remove_item_from_inventory(character_id, item_id)
			    return True
		# Spieler erstez Verteiler
		elif ((object_id.endswith('BUILDING_1427')) 
		      and (item_id == VERTEILER or item_type == 'SET_DISTRIBUTOR')
		      and (system.get_qb_entry_state(data().QB_002) == globals.UNCOMPLETE)
		      and (system.get_qb_entry_state(data().QB_003) == globals.UNCOMPLETE or system.get_qb_entry_state(data().QB_003) == globals.INACTIVE)):
			      system.start_cutscene()
			      system.fade(globals.FADE_OUT)
			      dialogs.initDlg_041_SpielerErsetztVerteiler(character_id)
			      object.remove_item_from_inventory(character_id, item_id)
			      return True
		# Spieler verkabelt Verteiler neu
		elif (object_id.endswith('BUILDING_1427') and item_id == None and system.get_qb_entry_state(data().QB_003) == globals.UNCOMPLETE):
			group = enemy_script.is_in_area(system.get_pcs(), 20, 'BUILDING_1427')
			char_id = enemy_script.check_char_skill(group,'technic', 50) 
			if char_id == None:
				return False
			system.start_cutscene()
			system.fade(globals.FADE_OUT)
			dialogs.initDlg_040_SpielerVerkabeltVerteilerNeu(char_id, character_id)
			return True
		elif (object_id.endswith('BUILDING_1431') 
		      and not(data().MitZekeGesprochen)):
			      dialogs.initDlg_067_SpielerFummeltAnWaffenkammer()
		
		# um das Dynamit an den Säulen zu entschärfen
		elif (object_id in data().DYNAMIT):
			PCs = enemy_script.is_in_area(system.get_pcs(), 20, object_id)
			PCs = enemy_script.check_char_skill(PCs, 'explosives', 70)
			if (PCs):
				data().DYNAMIT.remove(object_id)
				data().DYNAMIT_ENTSCHAERFT = object_id
				system.fade(globals.FADE_OUT, callback = Lambda('Dynamit_Entschaerfen("%s", "%s")'%(PCs, data().DYNAMIT_ENTSCHAERFT)))
				return True
			else:
				return False
		
	return object_events.on_use( character_id, object_id, item_id, item_type )

def can_crack_lock(character_id, object_id, dummy_name):
	# print 'can_crack_lock(', character_id, object_id, dummy_name,')'
	if (object_id.endswith('BUILDING_1431')):
		if system.get_qb_entry_state(data().QB_009) == globals.UNCOMPLETE:
			if object.get_attribute(character_id, 'lock_pick') > 40:
				if (object.count_in_inventory(character_id, 'SET_BASIC_PICKLOCK') or
					object.count_in_inventory(character_id, 'SET_SET_OF_PICKLOCKS') or
					object.count_in_inventory(character_id, 'SET_VAMPED_PICKLOCK_SET')):
						return object_events.can_crack_lock(character_id, object_id, dummy_name)
				else:
					return False
			else:
				return False
		else:
			if system.get_qb_entry_state(data().QB_010) == globals.UNCOMPLETE:
				return False
			elif system.get_qb_entry_state(data().QB_010) == globals.COMPLETE:
				return False
			elif system.get_qb_entry_state(data().QB_010) != globals.COMPLETE:
				return False
		dialogs.initDlg_067_SpielerFummeltAnWaffenkammer()
		return False
	return object_events.can_crack_lock(character_id, object_id, dummy_name)

def on_crack_lock(character_id, object_id, dummy_name, x, y, z):
	# print 'on_crack_lock(', character_id, object_id, dummy_name, x, y, z,')'
	if (object_id.endswith('BUILDING_1431')):
		enemy_script.delay(5, Lambda('Tuer_Chekc("ZEKE_KNACKT")'))
	object_events.on_crack_lock(character_id, object_id, dummy_name, x, y, z)

def Tuer_Chekc(id):
	# print 'Tuer_Chekc', id
	if not object_events.is_closed_lock_dummy('ZONE_9_BUILDING_1431', 'dmyp_door1_01'):
		if not system.get_qb_entry_state(data().QB_010) == globals.COMPLETE or not system.get_qb_entry_state(data().QB_009) == globals.COMPLETE:
			if not data().Region_Zeke_Active:
				data().Region_Zeke_Active = True
				prohibit_activity('ZEKE')
				object.move_to('ZEKE', 545.88, 275.21)
				data().TuerOffen = True
				system.notify_region_entered(region = id, objectid = "ALTER_EGO")

def can_blast_lock(character_id, object_id, dummy):
	# print 'can_blast_lock(', character_id, object_id, dummy,')'
	if (object_id.endswith('BUILDING_1431')):
		if system.get_qb_entry_state(data().QB_010) == globals.UNCOMPLETE:
			if object.count_in_inventory(character_id, 'SET_GUN_POWDER') and globals.has_talent(character_id, "explosives", "blast_locks"):
				return object_events.can_blast_lock(character_id, object_id, dummy)
			else:
				return False
		else:
			if system.get_qb_entry_state(data().QB_009) == globals.UNCOMPLETE:
				return False
			elif system.get_qb_entry_state(data().QB_009) == globals.COMPLETE:
				return False
		dialogs.initDlg_067_SpielerFummeltAnWaffenkammer()
		return False
	object_events.can_blast_lock(character_id, object_id, dummy)

def on_blast_lock(character_id, object_id, dummy_name, x, y, z):
	# print 'on_blast_lock(', character_id, object_id, dummy_name, x, y, z,')'
	if (object_id.endswith('BUILDING_1431')):
		enemy_script.delay(5, Lambda('Tuer_Chekc("ZEKE_SPRENGT")'))
	object_events.on_blast_lock(character_id, object_id, dummy_name, x, y, z)
				
def can_exchange( character_id, target_id, item_id, item_type ):
	if (target_id == 'KAYLA' and item_type == 'SET_MEDIPACK_BIG' and system.get_qb_entry_state(data().QB_005) == globals.INACTIVE):
		# print 'can_exchange_in %s %s %s %s' % (character_id, target_id, item_id, item_type)
		return False
	if (target_id == 'KAYLA' and item_type == 'SET_MULTI_MEDIPACK' and system.get_qb_entry_state(data().QB_005) == globals.INACTIVE):
		return False
	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
	if target_id == 'KAYLA':
		if item_type == 'SET_MEDIPACK_BIG':
			if data().KaylaNumberMedpacks == 2:
				data().KaylaNumberMedpacks += 1
			if data().KaylaNumberMedpacks <= 1:
				data().KaylaNumberMedpacks += 1
			if(data().KaylaNumberMedpacks == 3):
				character.add_experience_party(500)
				system.set_qb_entry_state(data().QB_005, globals.COMPLETE)
			return True
			
		if item_type == 'SET_MULTI_MEDIPACK':
			if object.has_attribute(item_id, "charge"):
				charge = object.get_attribute(item_id, "charge")
				kyala_braucht = 3 - data().KaylaNumberMedpacks
				if charge > 0:
					if charge >= kyala_braucht:
						charge -= kyala_braucht
						data().KaylaNumberMedpacks == 3
						character.add_experience_party(500)
						system.set_qb_entry_state(data().QB_005, globals.COMPLETE)
						object.set_attribute(item_id, "charge", charge)
						return False
					if charge < kyala_braucht:
						data().KaylaNumberMedpacks += charge
						object.set_attribute(item_id, "charge", 0)
						return False
				return False
	
	return object_events.on_exchange( character_id, target_id, item_id, item_type )

def on_timer(id):
	if (id == data().TimerAbelRundgang_1):
		# print 'Timer TimerAbelRundgang_1 %s' % id
		dialogs.onDlg_060_AbelRundgangSamson()
	
	elif (id == data().TimerAbelRundgang_2):
		# print 'Timer TimerAbelRundgang_2 %s' % id
		dialogs.onDlg_060_AbelRundgangWright()
	
	elif (id == data().TimerDynamit):
		# print 'Timer TimerDynamit %s' % id
		data().TimerAbgelaufen = True
		if (system.get_qb_entry_state(data().QB_006) == globals.UNCOMPLETE):
			for DYNAMIT_ID in data().DYNAMIT:
				system.notify_region_entered(region = DYNAMIT_ID, objectid = 'ALTER_EGO')
			return True
		
	elif (id == data().TimerEgoBeiWright):
		# print 'Timer TimerEgoBeiWright %s' % id
		if (object.get_distance('ALTER_EGO', 'WRIGHT') < 2.0):
			dialogs.initDlg_011_SpielerHatKeineZeitMehr_IstNichtNaheDynamit()
		else:
			setTimerEgoBeiWright()
				
	# Timer für Fade dlg 60
	elif(id == data().TimerFadeDlg60):
		# print 'Timer TimerFadeDlg60 %s' % id
		dialogs.onCutscene_Dlg_060_End_2()
	
	elif(id == data().TimerJamesHundeSpiel):
		# print 'Timer TimerJamesHundeSpiel %s' % id
		data().JamesTimer = True
	
	# Timer für Hale BohrerCutscene_Endposition
	elif (id == data().TimerHaleBohrer_2):
		# print 'Timer TimerHaleBohrer_2 %s' % id
		dialogs.onCutscene_Dlg_037_HaleBedientExcavator_5()
	
	# Timer für Hale BohrerCutsceneEnde
	elif (id == data().TimerHaleBohrer_3):
		# print 'Timer TimerHaleBohrer_3 %s' % id
		dialogs.onDlg_037_End()
	
	# Timer für Zeke Cutscene
	elif (id == data().TimerZekeSchluesselsuche_2):
		# print 'Timer TimerZekeSchluesselsuche_2 %s' % id
		dialogs.onCutscene_Dlg_023_ZekeErstesMal_1()
	
	# Timer für Zeke , SpielerKnacktSchloss_1 wenn er beginnt
	elif (id == data().TimerSpielerKnacktSchloss_1):
		# print 'Timer TimerSpielerKnacktSchloss_1 %s' % id
		data().Zeke_Cutscene = True
		dialogs.onDlg_025_SpielerKnacktSchloss_1()
	
	# Timer für Zeke , SpielerKnacktSchloss_2 wenn er fertig ist
	elif (id == data().TimerSpielerKnacktSchloss_2):
		# print 'Timer TimerSpielerKnacktSchloss_2 %s' % id
		dialogs.onDlg_025_SpielerKnacktSchloss_4()
	
	# Timer für Zeke , SpielerKnacktSchloss_3 für abschließenden Dialog
	elif (id == data().TimerSpielerKnacktSchloss_3):
		# print 'Timer TimerSpielerKnacktSchloss_3 %s' % id
		dialogs.onDlg_025_SpielerKnacktSchloss_5()
	
	# Timer Bohrer
	elif (id == data().TimerBohrer):
		# print 'data().TimerBohrer %s' % id
		dialogs.Bohrer_1()
		

def rueckgabe(id):
	return schedules.Activity(id)
		
def on_wait_for_commando(id):
	if(id == 'ABEL'):
		if (not system.is_cutscene() 		and
			not data().AbelAufRundgang	and
			not data().AbelRundgangBeendet 	and
			data().CutsceneAbelGelaufen):
			dialogs.onDlg_060_AbelRundgangEgo()
			return True
		return schedules.Activity(id)
			
	if (id == 'ERLAN'):
		if (not system.get_qb_entry_state(data().QB_007) == globals.COMPLETE):
			if const.Loops_Erlan == 0:
				const.Loops_Erlan += 1
				Erlan('ERLAN')
				return True
			elif const.Loops_Erlan <= 5:
				const.Loops_Erlan += 1
				return schedules.Activity(id)
			elif const.Loops_Erlan == 6:
				const.Loops_Erlan = 0
				character.play_animation(id, data().ERLAN_ANIMATION[2])
				return True
			return True
			
	if (id == 'ZEKE'):
		if (not(system.get_qb_entry_state(data().QB_009) == globals.COMPLETE or 
			system.get_qb_entry_state(data().QB_010) == globals.COMPLETE)):
				if const.Loops_Zeke == 0:
					const.Loops_Zeke += 1
					Zeke('ZEKE')
					return True
				elif const.Loops_Zeke <= 5:
					const.Loops_Zeke += 1
					return schedules.Activity(id)
				elif const.Loops_Zeke == 6:
					const.Loops_Zeke = 0
					character.play_animation(id, data().ZEKE_ANIMATION[2])
					return True
				return True
	
	return schedules.Activity(id)
		
def Erlan(id):
	data().ERLAN_ANIMATION = random.choice(ERLAN_WASSERSUCHE_AKTIVITAETEN)
	data().ERLAN_POS = random.choice(ERLAN_WASSER_ROUTE)
	object.move_to(id, data().ERLAN_POS[0], data().ERLAN_POS[1], callback = ['ONEND', Lambda('set_activity("ERLAN", 0)')])

def Zeke(id):
	data().ZEKE_POS = random.choice(ZEKE_SCHLUESSELSUCHE)
	object.move_to(id, data().ZEKE_POS[0], data().ZEKE_POS[1], callback = ['ONEND', Lambda('set_activity("ZEKE", 0)')])

def can_examine_object( character_id, object_id ):
	if object_id.endswith('BUILDING_1427'): # and data().MitSamsonGesprochen:
		return True
	
	#if object_id == 'ZONE_9_BUILDING_62':
	#	return False
	
	# Bohrer
	if object_id != None:
		if (object_id.endswith("ZONE_9_BUILDING_1427")):
			object.set_attribute(object_id, "on_examine_coordinates",[333.21, 366.87])

def on_examine_object( character_id, object_id ):
	if object_id.endswith('BUILDING_1427'):
		dialogs.SpielerUntersuchtBohrgeraet()
	#if object_id == 'ZONE_9_BUILDING_62':
	#	return False
	
def on_object_killed(victim, attacker, weapon_type, weapon_id):
	# print ('on_object_killed:\n victim %s \n attacker %s \n weapon_type %s \n weapon_id %s') % (victim, attacker, weapon_type, weapon_id)
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	if(victim == 'ERLAN'):
		system.set_qb_entry_state(data().QB_007, globals.IMPOSSIBLE) # todo was wenn quest noch nicht aktiv war ?
		
	elif(victim == 'ZEKE'):
		system.set_qb_entry_state(data().QB_009, globals.IMPOSSIBLE) # todo was wenn quest noch nicht aktiv war ?
		system.set_qb_entry_state(data().QB_010, globals.IMPOSSIBLE) # todo was wenn quest noch nicht aktiv war ?

def initItems():
	
	# NPC-Itemverteilung
	# Mainquest
	# Jacob
	object.create_item_in_inventory(object = 'JACOB' ,equipment=['SET_MANSLAYER'])
	object.create_item_in_inventory(object = 'JACOB' ,equipment= 'SET_BIG_BACKPACK', id ='Z9 BACKPACK')
	# Hyde
	object.create_item_in_inventory(object = 'HYDE', equipment=['SET_THROWING_KNIFE', 
								'SET_THROWING_KNIFE'])
	object.create_item_in_inventory('HYDE', 'SET_NANO_BOT_SURGICAL_DEVICE_NPC_ITEM' ,id = NANO_BOT_SURGICAL_DEVICE_NPC_ITEM)
	object.create_item_in_inventory(object = 'ABEL', equipment=['SET_SHURIKEN',
								'SET_SHURIKEN',
								'SET_SHURIKEN'])
	# Anie
	object.create_item_in_inventory(object = 'ANIE', equipment=['SET_KNIFE'])
	character.equip("ANIE", equipment="SET_KNIFE")
	
	# SubQuest
	# Wright
	object.create_item_in_inventory(object = 'WRIGHT', equipment=['SET_BIG_KNIFE'])
	character.equip("WRIGHT", equipment="SET_BIG_KNIFE")
	# Kayla
	object.create_item_in_inventory(object = 'KAYLA', equipment=['SET_BROKEN_OFF_BOTTLE'])
	character.equip("KAYLA", equipment="SET_BROKEN_OFF_BOTTLE")
	# Erlan
	object.create_item_in_inventory(object = 'ERLAN', equipment=['SET_BRASS_KNUCKLES'])
	character.equip("ERLAN", equipment="SET_BRASS_KNUCKLES")
	# Samson
	object.create_item_in_inventory(object = 'SAMSON', equipment=['SET_THROWING_KNIFE',
								'SET_THROWING_KNIFE'])
	# Zeke
	object.create_item_in_inventory(object = 'ZEKE', equipment=['SET_KNIFE'])
	character.equip("ZEKE", equipment="SET_KNIFE")
	# Hale
	object.create_item_in_inventory(object = 'HALE', equipment=['SET_SHURIKEN',
								'SET_SHURIKEN',
								'SET_SHURIKEN',
								'SET_SHURIKEN'])
	
	# ZonenItems
	object.create_item_in_inventory("BUILDING_1260",["SET_BOTTLE_OF_HOOCH", 
							"SET_SCALP"])
	object.create_item_in_inventory("BUILDING_1054",["SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory("BUILDING_220",["SET_SALPETER"])
	#object.create_item_in_inventory("BUILDING_1071",["SET_BOXIN_GLOVE"]) Objekt gibt es nicht mehr
	object.create_item_in_inventory("BUILDING_185",["SET_RASP"])
	object.create_item_in_inventory("BUILDING_241",["SET_PAN"])
	object.create_item_in_inventory("BUILDING_525",["SET_MEAT_RAW_HUMONGOUS"])
	object.create_item_in_inventory("BUILDING_515",["SET_CAKE_TIN"])
	object.create_item_in_inventory("BUILDING_1273",["SET_REEL_OF_STEEL_WIRE"])
	object.create_item_in_inventory("BUILDING_1066",["SET_WOODEN_BOARD"])
	# object.create_item_in_inventory("BUILDING_1083",["SET_DUCT_TAPE"]) #todo anderes object suchen gibts nicht mehr
	object.create_item_in_inventory("BUILDING_1092",["SET_NORMAL_CLOTHES_3"])
	object.create_item_in_inventory("BUILDING_1093",["SET_SOAP"])
	object.create_item_in_inventory("BUILDING_1084",["SET_SAW"])
	object.create_item_in_inventory("BUILDING_131",["SET_AMMOPACK_5_45_MM", "SET_BEAR_SKIN"])

	# Kommode
	object.create_item_in_inventory(object="BUILDING_12277",equipment=["SET_MICRO_UZI"])
	# Schrankwand
	object.create_item_in_inventory(object="BUILDING_12280",equipment=["SET_SMALL_STOOL"])
	# Eimer
	object.create_item_in_inventory(object="BUILDING_1684",equipment=["SET_DART"])
	# Aschetonne
	object.create_item_in_inventory(object="BUILDING_8220",equipment=["SET_CHAIN_SAW"])
	# Kisten
	object.create_item_in_inventory(object="BUILDING_246",equipment=["SET_C4_REMOTE_CONTROL_W_NAILS"])
	# Kommode
	object.create_item_in_inventory(object="BUILDING_12291",equipment=["SET_HK_XM8"])
	# Kommode
	object.create_item_in_inventory(object="BUILDING_1769",equipment=["SET_AMMOPACK_3_12_MM"])
	# Kisten
	object.create_item_in_inventory(object="BUILDING_126",equipment=["SET_TOOTHBRUSH"])
	# Palette
	object.create_item_in_inventory(object="BUILDING_1776",equipment=["SET_COOKING_POT"])
	# Kisten
	object.create_item_in_inventory(object="BUILDING_5186",equipment=["SET_HEADPHONE"])
	# Werkbank
	object.create_item_in_inventory(object="BUILDING_5134",equipment=["SET_TRASH_CAN"])
	# Mehlsäcke
	object.create_item_in_inventory(object="BUILDING_1356",equipment=["SET_GARLIC_PRESS"])
	# Kommode
	object.create_item_in_inventory(object="BUILDING_12297",equipment=["SET_CALICO_M900_W_SILENCER"])
	# Tongefäße
	object.create_item_in_inventory(object="BUILDING_1088",equipment=["SET_MEAT_RAW_TINY"])
	# Schrankwand
	object.create_item_in_inventory(object="BUILDING_12249",equipment=["SET_HAIR_DRYER"])
	# Teppich
	object.create_item_in_inventory(object="BUILDING_10436",equipment=["SET_POWER_DRILL"])
	# Kommode
	object.create_item_in_inventory(object="BUILDING_12249",equipment=["SET_WIRE_WHISK"])
	# Holzbank
	object.create_item_in_inventory(object="BUILDING_1035",equipment=["SET_SMALL_SAND_SHOVEL"])
	# Hundehütte
	object.create_item_in_inventory(object="BUILDING_6630",equipment=["SET_SMALL_PICTURE_FRAME"])
	# Blecheimer
	object.create_item_in_inventory(object="BUILDING_6621",equipment=["SET_MEDIPACK_SMALL"])
	

	
	# Animales

	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_12468', equipment=[ 'SET_SHORT_NAILS', 'SET_P90_SMG_W_SILENCER_W_LASERPOINTER' ] )
	object.create_item_in_inventory( 'BUILDING_12481', equipment=[ 'SET_KATANA', 'SET_AMMOPACK_45_SUBSONIC', 'SET_M46_HEAVY_ARMOR' ] )
	object.create_item_in_inventory( 'BUILDING_12485', equipment=[ 'SET_PITCHER', 'SET_KEROSENE_CANISTER', 'SET_ALARM_HORN' ] )
	object.create_item_in_inventory( 'BUILDING_12486', equipment=[ 'SET_M46_ARMORED_HELMET', 'SET_MEAT_RAW_BIG', 'SET_CORN_COB' ] )
	object.create_item_in_inventory( 'BUILDING_12487', equipment=[ 'SET_MEDIPACK_SMALL', 'SET_CALICO_M950_W_SILENCER', 'SET_BOOMERANG' ] )
	object.create_item_in_inventory( 'BUILDING_12488', equipment=[ 'SET_GMG_OCSW', 'SET_AMMOPACK_5_7_MM_DUMDUM', 'SET_CLUB' ] )
	object.create_item_in_inventory( 'BUILDING_12490', equipment=[ 'SET_AMMOPACK_9_MM_SUBSONIC', 'SET_AMMOPACK_3_12_MM', 'SET_SHORT_NAILS' ] )
	object.create_item_in_inventory( 'BUILDING_12491', equipment=[ 'SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', 'SET_HEGRENADE', 'SET_THROWING_KNIFE' ] )
	object.create_item_in_inventory( 'BUILDING_12493', equipment=[ 'SET_GAS_CANISTER', 'SET_M46_STEEL_CLAD_BOOTS', 'SET_RED_SHARD' ] )
	object.create_item_in_inventory( 'BUILDING_10437', equipment=[ 'SET_MEDIPACK_BIG', 'SET_M46_GAUNTLETS', 'SET_DRUGS_VIALS_03' ] )
	object.create_item_in_inventory( 'BUILDING_12494', equipment=[ 'SET_CALICO_M950_W_SILENCER', 'SET_BIG_KNIFE', 'SET_MEDIPACK_BIG' ] )
	
	
def initRegions():
	# wird aktivirt wenn Hale das bohrgerät gefahren ist
	system.add_region(id = 'REGION_EINSTURZ',   x1 = 508.83, y1 = 247.22, x2 = 523.57, y2 = 238.03)
	system.add_region(id = 'REGION_JACOB', x1 = 518.23, y1 = 245.45, x2 = 505.74, y2 = 235.32)
	system.add_region(id = 'REGION_EINSTURZ_SAMSON',  x1 = 516.94, y1 = 245.58, x2 = 524.89, y2 = 254.70)
	system.notify_region_entered("REGION_EINSTURZ_SAMSON", objectid = 'ALTER_EGO')
	
	system.add_region("WAFFENKAMMER",540.00,283.00,555.00,264.00)
	system.notify_region_entered("WAFFENKAMMER", partyid = 'UISPIELER')

	system.add_region("KRANKENHAUS",522,519,580,558)
	system.notify_region_entered("KRANKENHAUS", partyid = 'UISPIELER')
	
	system.add_region("Saeule_N",342,247,354,260)
	system.notify_region_entered("Saeule_N", partyid = 'UISPIELER')
	system.add_region("Saeule_S",344,567,371,577)
	system.notify_region_entered("Saeule_S", partyid = 'UISPIELER')
	system.add_region("Saeule_O",569,271,577,287)
	system.notify_region_entered("Saeule_O", partyid = 'UISPIELER')
	system.add_region("Saeule_W",525,488,535,505)
	system.notify_region_entered("Saeule_W", partyid = 'UISPIELER')

	# Region Dynamitsäule_N
	system.add_region(id = 'Region_Saeule_N', x1 = 334.01, y1 = 274.16, x2 = 375.71, y2 = 287.28)
	system.notify_region_entered(region = 'Region_Saeule_N', partyid = 'UISPIELER')
	# Region Dynamitsäule_S
	system.add_region(id = 'Region_Saeule_S', x1 = 320.18, y1 = 236.20, x2 = 375.78, y2 = 234.32 )
	system.notify_region_entered(region = 'Region_Saeule_S', partyid = 'UISPIELER')
	# Region Dynamitsäule_O
	system.add_region(id = 'Region_Saeule_O', x1 = 320.25, y1 = 236.28, x2 = 327.80, y2 = 254.91)
	system.notify_region_entered(region = 'Region_Saeule_O', partyid = 'UISPIELER')
	# Region Dynamitsäule_W
	system.add_region(id = 'Region_Saeule_W', x1 = 375.73, y1 = 232.50, x2 = 383.96, y2 = 287.33)
	system.notify_region_entered(region = 'Region_Saeule_W', partyid = 'UISPIELER')
	
	# Regionen an den Säulen nach erhaltener Quest
	system.add_region(id = data().DYNAMIT[0], x1 = 569.47, y1 = 272.67, x2 = 578.93, y2 = 290.91) # 2926
	system.add_region(id = data().DYNAMIT[1], x1 = 343.54, y1 = 248.53, x2 = 352.55, y2 = 258.08) # 2927
	system.add_region(id = data().DYNAMIT[2], x1 = 358.88, y1 = 567.15, x2 = 371.82, y2 = 572.34) # 2928
	system.add_region(id = data().DYNAMIT[3], x1 = 525.27, y1 = 493.86, x2 = 532.12, y2 = 504.10) # 2929
	
	# Region WasserQuelle
	system.add_region(id = 'WASSERQUEST', x1 = 548.75, y1 = 397.13, x2 = 543.98, y2 = 391.62)
	system.notify_region_entered(region = 'WASSERQUEST', partyid = 'UISPIELER')
	# wird aktiviert wenn helcutscen durch ist
	system.add_region(id = 'RUTH', x1 = 530.00, y1 = 600.00, x2 = 600.00, y2 = 530.00)
	
	# Zeke nach öffnen der Tür
	system.add_region(id = 'ZEKE_KNACKT',  x1 = 543.75, y1 = 282.00, x2 = 555.21, y2 = 264.04)
	system.add_region(id = 'ZEKE_SPRENGT', x1 = 543.75, y1 = 282.00, x2 = 555.21, y2 = 264.04)
	
def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x=497.61, y=596.41)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=307.63, y=556.41)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=531.22, y=498.40)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=319.54, y=271.62)
	system.create_object(equipmenttype="SET_BURNET", x=553.59, y=229.52)
	system.create_object(equipmenttype="SET_ANGELICA", x=435.60, y=476.37)

def initExitZones():
	system.add_region( id = "REGION_EXIT_OST", x1 = 600.00, y1 = 530.00, x2 = 799.00, y2 = 799.00 )
	system.register_exit(regionname = "REGION_EXIT_OST")
	system.add_region( id = "REGION_EXIT_SUED", x1 = 530.00, y1 = 600.00, x2 = 799.00, y2 = 799.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED")
	

def initFX():
	for p_1 in PILAR_1:
		fxPillar_1(p_1)
	for p_2 in PILAR_2:
		fxPillar_2(p_2)
	for fbs in FIRE_BASIN_SMALL:
		fxBrennendeBasingSmall(fbs)
	for fbb in FIRE_BASIN_BIG:
		fxBrennendeBasingBig(fbb)
	for lf in FIRE:
		fxLagerFeuer(lf)
	for bar_1 in FIRE_BARACKE_1:
		fxBrennende_Baracke_1(bar_1)
	for bar_2 in FIRE_BARACKE_2:
		fxBrennende_Baracke_2(bar_2)
	for fack in FACKEL:
		fxFackel(fack)

## Feuerefecte für Baracke_1
def fxBrennende_Baracke_1(_objectid):
	system.start_effect_object(object=_objectid,node="dmyp_fire_001",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_002",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_003",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_004",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_005",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_006",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_007",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_008",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_009",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_010",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_011",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_012",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_013",parameter=fx_fire_fire_basin_big_00_2)


## Feuerefecte für Baracke_2
def fxBrennende_Baracke_2(_objectid):
	system.start_effect_object(object=_objectid,node="dmyp_fire_001",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_002",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_003",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_004",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_005",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_006",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_007",parameter=fx_fire_fire_basin_big_00_2)
	system.start_effect_object(object=_objectid,node="dmyp_fire_008",parameter=fx_fire_fire_basin_big_00_2)
	
## Feuereffekte für FIRE_BASING_BIG
def fxBrennendeBasingBig(_objectid):
	system.start_effect_object(object=_objectid,node="dmyp_fire0",parameter=fx_fire_big)
	
## Feuereffekte für FIRE_BASING_SMALL
def fxBrennendeBasingSmall(_objectid):
	system.start_effect_object(object=_objectid,node="dmyp_fire",parameter=fx_fire_basin_small)

def fxPillar_2(objectid):
	system.start_effect_object(object = objectid ,node="dmyp_fire0",parameter=fx_fire_pilar_2)
	system.start_effect_object(object = objectid ,node="dmyp_fire1",parameter=fx_fire_pilar_2)
	system.start_effect_object(object = objectid ,node="dmyp_fire2",parameter=fx_fire_pilar_2)
	system.start_effect_object(object = objectid ,node="dmyp_fire3",parameter=fx_fire_pilar_2)
	
def fxPillar_1(objectid):
	system.start_effect_object(object = objectid, node="dmyp_fire",parameter=fx_fire_pilar_1)

def fxFackel(objectid):
	system.start_effect_object(object = objectid ,node="dmyp_fire",parameter=fx_fire_pilar_2)

## Feuereffekte für FIRE (Lagerfeuer)
def fxLagerFeuer(objectid):
	system.start_effect_object(object=objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer_big)
	system.start_effect_object(object=objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=objectid,loop=True)

def on_button_down(Button):
	return False

def on_pick_up(character_id, item_id, item_type):
	# print '[debug : on_pick_up(', character_id, item_id, item_type, ')]'
	if item_id == VERTEILER:
		object.pick_up_item_direct(character_id, item_id)
		return False
	return object_events.on_pick_up(character_id, item_id, item_type)

def setAbelStartdialog():
	system.start_cutscene()
	dialogs.initCutscene_Dlg_060_AbelVerschafftSichEinenUeberblick()

# Timer wird solange immer wieder angestoßen bis sich ego in der nähe von wrigth befindet
def setTimerEgoBeiWright():
	system.notify_timer(data().TimerEgoBeiWright, data().Timervalue_EgoBeiWright)

## Minenexplosionseffekt
def animMinenExplosion(id):
	system.start_effect(startx=542.16,
				starty=274.48,
				startz=1,
				dirx=542.16,
				diry=274.48,
				dirz=1.4,
				parameter=fx_explosion_medium)
				
	sounds.play_3d_sound(sfx_id="landmine_explo",
				x=542.16,
				y=274.48,
				z=0)
				
def Dynamit_Entschaerfen(PC, object_id): # PC = person die entschärfen kann
	# print '[debug Dynamit_Entschaerfen(PC, object_id)', PC, object_id
	global Dummy
	global object_id_saule
	lambda_string_dynamit_1 = 'object.turn_to_object("'+ PC +'", "'+ object_id +'")'
	lambda_string_dynamit_2 = 'object.turn_to_object("ALTER_EGO", "'+ object_id +'")'
	system.start_cutscene()
	enemy_script.evacuate(group=system.get_pcs(), position=[object.get_x(object_id), object.get_y(object_id)], radius=3, callback = Lambda("object.turn_to_object(parameter,'%s')" % object_id, "parameter"))
	
	if (object_id.endswith('BUILDING_2929')):
		Dummy = 'dmyp_001'
		object_id_saule = 'ZONE_9_BUILDING_2852'
		object.cancel_commandos(PC)
		system.set_camera_view(Cam_Dynamit_1)
		object.set_position(PC, const.DYNAMIT[0][0][0], const.DYNAMIT[0][0][1])
		object.cancel_commandos('ALTER_EGO')
		object.set_position('ALTER_EGO', const.DYNAMIT[0][1][0], const.DYNAMIT[0][1][1])
	elif (object_id.endswith('BUILDING_2926')):
		Dummy = 'dmyp_001'
		object_id_saule = 'ZONE_9_BUILDING_6527'
		object.cancel_commandos(PC)
		system.set_camera_view(Cam_Dynamit_2)
		object.set_position(PC, const.DYNAMIT[1][0][0], const.DYNAMIT[1][0][1])
		object.cancel_commandos('ALTER_EGO')
		object.set_position('ALTER_EGO', const.DYNAMIT[1][1][0], const.DYNAMIT[1][1][1])
	elif (object_id.endswith('BUILDING_2927')):
		Dummy = 'dmyp_001'
		object_id_saule = 'ZONE_9_BUILDING_394'
		object.cancel_commandos(PC)
		system.set_camera_view(Cam_Dynamit_3)
		object.set_position(PC, const.DYNAMIT[2][0][0], const.DYNAMIT[2][0][1])
		object.cancel_commandos('ALTER_EGO')
		object.set_position('ALTER_EGO', const.DYNAMIT[2][1][0], const.DYNAMIT[2][1][1])
	elif (object_id.endswith('BUILDING_2928')):
		Dummy = 'dmyp_001'
		object_id_saule = 'ZONE_9_BUILDING_6545'
		object.cancel_commandos(PC)
		system.set_camera_view(Cam_Dynamit_4)
		object.set_position(PC, const.DYNAMIT[3][0][0], const.DYNAMIT[3][0][1])
		object.cancel_commandos('ALTER_EGO')
		object.set_position('ALTER_EGO', const.DYNAMIT[3][1][0], const.DYNAMIT[3][1][1])
	system.fade(globals.FADE_IN, callback = Lambda('Dynamit_Entschaerfen_("%s", "%s", "%s")' %(PC, object_id_saule, Dummy)))
	
	
def Dynamit_Entschaerfen_(PC, object_id_saule, Dummy):
	object.move_to_object(PC, object_id_saule, dummy=Dummy, speed=globals.MT_SLOW, callback=['ONEND', Dynamit_Entschaerfen_1])
	
def Dynamit_Entschaerfen_1(id):
	character.play_animation(id, 'CM_STEHEN_VERLETZTE_BEHANDELN_ANSCHRITT')
	character.play_animation(id, 'CM_STEHEN_VERLETZTE_BEHANDELN_LOOP', callback = ['ONEND', Lambda('Dynamit_Entschaerfen_End("%s")'%id)])
	character.play_animation(id, 'CM_STEHEN_VERLETZTE_BEHANDELN_ENDSCHRITT', callback = ['ONEND', Dynamit_Entschaerfen_2])
	
def Dynamit_Entschaerfen_2(id):
	object.cancel_commandos(id)
	enemy_script.delay(1, Lambda('object.step_away("%s")'%id))
	enemy_script.delay(3, Lambda('system.end_cutscene()'))
	
def Dynamit_Entschaerfen_End(id):
	data().DynamitEntsorgt += 1
	object.set_active_state(data().DYNAMIT_ENTSCHAERFT, False)
	object.create_item_in_inventory(id, 'SET_C4_TIMEBASED')

def init_C4_Blinker(id): 
	on_C4_Blinken_1(None)
	on_C4_Blinken_2(None)
	on_C4_Blinken_3(None)
	on_C4_Blinken_4(None)
	
def init_Banner(id = None):
	for id in BANNER:
		object.play_animation(id, 'ANIM_BANNER', callback = ['ONEND', Lambda('Banner("%s")'%id)])
	
def Banner(id = None):
	object.play_animation(id, 'ANIM_BANNER', callback = ['ONEND', Lambda('Banner("%s")'%id)])

def on_C4_Blinken_1(id):
	if object.is_active('ZONE_9_BUILDING_2926'):
		object.play_animation('ZONE_9_BUILDING_2926', 'ANIM_C4_ATTACHED_BLINKT', callback = ['ONEND', on_C4_Blinken_1])
	
def on_C4_Blinken_2(id):
	if object.is_active('ZONE_9_BUILDING_2927'):
		object.play_animation('ZONE_9_BUILDING_2927', 'ANIM_C4_ATTACHED_BLINKT', callback = ['ONEND', on_C4_Blinken_2])
	
def on_C4_Blinken_3(id):
	if object.is_active('ZONE_9_BUILDING_2928'):
		object.play_animation('ZONE_9_BUILDING_2928', 'ANIM_C4_ATTACHED_BLINKT', callback = ['ONEND', on_C4_Blinken_3])
	
def on_C4_Blinken_4(id):
	if object.is_active('ZONE_9_BUILDING_2929'):
		object.play_animation('ZONE_9_BUILDING_2929', 'ANIM_C4_ATTACHED_BLINKT', callback = ['ONEND', on_C4_Blinken_4])

def UnEquip_Weapon_Direct(char_id):
	if object.has_attribute(char_id, 'slots'):
		if 'right_hand' in object.get_attribute(char_id, 'slots'):
			if not ((object.get_attribute(char_id, 'slots')['right_hand']) == None):
				# print 'debug_UnEquip_Weapon_Direct_right_hand', char_id, object.get_attribute(char_id, 'slots')['right_hand']
				character.un_equip_direct(char_id, (object.get_attribute(char_id, 'slots')['right_hand']))
		if 'left_hand' in object.get_attribute(char_id, 'slots'):
			if not ((object.get_attribute(char_id, 'slots')['left_hand']) == None):
				# print 'debug_UnEquip_Weapon_Direct_left_hand', char_id, object.get_attribute(char_id, 'slots')['right_hand']
				character.un_equip_direct(char_id, (object.get_attribute(char_id, 'slots')['left_hand']))
	return

def DynamitQuestAbgegrochen(id, objectid):
	if not system.is_cutscene():
		if id in data().DYNAMIT:
			for id_ in data().DYNAMIT:
				data().DYNAMIT.remove(id_)
			system.start_cutscene()
			system.fade(FADE_OUT, callback = Lambda('DynamitQuestAbgegrochen_0("%s", "%s")'%(objectid, id)))
		else:
			return None
	else:
		enemy_script.delay(10, Lambda('DynamitQuestAbgegrochen("%s", "%s")'%(id, objectid)))
		
def DynamitQuestAbgegrochen_0(player_id, dynamit_id):	
	ID_View = 'ID_'+dynamit_id
	system.fade(FADE_IN)
	object.cancel_commandos('WRIGHT')
	system.set_camera_view(DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['Cam_Pos_1'])
	object.set_position('WRIGHT',  DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['Pos_Wright_1'][0],
				      DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['Pos_Wright_1'][1])
	object.move_to_object(object 		= player_id, 
			    target_object 	= DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['ID_SAEULE'],
			    dummy 		= 'dmyp_001', 
			    speed 		= globals.MT_NORMAL, 
			    callback 		= ['ONEND', Lambda('DynamitQuestAbgegrochen_1("%s", "%s")'%(player_id, ID_View))])
									
def DynamitQuestAbgegrochen_1(player_id, ID_View):
	object.cancel_commandos(player_id)
	object.turn_to_object(player_id, 'WRIGHT')
	dialogs.initCutscene_Dlg_010_SpielerHatKeineZeitMehr_IstNaheDynamit_1()
	object.move_to('WRIGHT', DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['Pos_Wright_2'][0],
				DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['Pos_Wright_2'][1],
				speed = globals.MT_FAST,
				callback =['ONEND', Lambda('DynamitQuestAbgegrochen_1_1("%s","%s")'%(player_id, ID_View))])
	

def DynamitQuestAbgegrochen_1_1(player_id, ID_View):
	system.set_camera_view(DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['Cam_Pos_2'])
	object.cancel_commandos(player_id)
	character.play_animation(player_id, 'CM_NPC_STEHEN_KRUEMMEN_START')
	character.play_animation(player_id, 'CM_NPC_STEHEN_KRUEMMEN_LOOP')
	character.play_animation(player_id, 'CM_NPC_STEHEN_KRUEMMEN_ENDE')
	object.move_to_object('WRIGHT', DYNAMIT_CUTSCENE_QUEST_ABGEBROCHEN[str(ID_View)]['ID_SAEULE'], 'dmyp_001', MT_FAST)
	character.play_animation('WRIGHT', 'CM_STEHEN_TASCHENDIEBSTAHL_VORN', callback = ['ONEND', Dynamit_Ab])
	character.play_animation('WRIGHT', 'CM_STEHEN_TASCHENDIEBSTAHL_VORN', callback = ['ONEND', DynamitQuestAbgegrochen_2])
	
	
def Dynamit_Ab(id):
	for id_ in data().DYNAMIT:
		object.set_active_state(id_, False)

def DynamitQuestAbgegrochen_2(id):
	dialogs.initCutscene_Dlg_010_SpielerHatKeineZeitMehr_IstNaheDynamit_2()
	
def DynamitQuestAbgegrochen_3(id):
	dynamic_camera.end_cutscene(chars = ['ALTER_EGO', 'WRIGHT'])



########################################################################################
### char -> PC oder NPC der einen Bereich verlassen soll wenn er sich darin befindet ###
### x -> X-Koordinate des Mittelpunktes des Bereiches				     ###
### y -> Y-Koordinate des Mittelpunktes des Bereiches				     ###
### radius -> Radius um den Mittelpunkt aus dem der PC NPC verschwinden soll	     ###
### Rückgabe -> Die neuen Punkte zu denen der Char sich begeben soll		     ###
### Rückgabe -> False, False PC NPC befinden sich nicht im ausgewählten Bereich	     ###
########################################################################################
def lauf_weg_zu(char, x, y, radius):
	X_aktuell_Char = object.get_x(char)
	Y_aktuell_Char = object.get_y(char)
	X_aktuell_Char_Null = X_aktuell_Char - x
	Y_aktuell_Char_Null = Y_aktuell_Char - y
	abstand = math.sqrt((X_aktuell_Char_Null * X_aktuell_Char_Null) + (Y_aktuell_Char_Null * Y_aktuell_Char_Null))
	if abstand < radius:
		skalar = radius - abstand
		if X_aktuell_Char_Null >= 0 and Y_aktuell_Char_Null < 0:
			return skalar + X_aktuell_Char, Y_aktuell_Char - skalar
		elif X_aktuell_Char_Null < 0 and Y_aktuell_Char_Null < 0:
			return  X_aktuell_Char - skalar, Y_aktuell_Char - skalar
		elif X_aktuell_Char_Null < 0 and Y_aktuell_Char_Null >= 0:
			return X_aktuell_Char - skalar, skalar + Y_aktuell_Char
		elif X_aktuell_Char_Null >= 0 and Y_aktuell_Char_Null >= 0:
			return skalar + X_aktuell_Char, skalar + Y_aktuell_Char
	else:
		return False, False

def Fahre_Zu(Start_X, Start_Y, Ziel_X, Ziel_Y, Step):
	# print ('Start_X, Start_Y, Ziel_X, Ziel_Y, Step'), Start_X, Start_Y, Ziel_X, Ziel_Y, Step
	X = (Ziel_X -Start_X)/Step
	Y = (Ziel_Y - Start_Y)/Step
	# print('X, Y'),X, Y
	return X, Y
	

def on_heal(character_id, character_target_id):
	object_events.on_heal(character_id, character_target_id)
	if character_target_id == 'HALE':
		if data().KrankePflegeBeendet or character_id in system.get_pcs():
			data().HALE_Gesund = True
	

def InitChestsSafes():
	object.add_closed_lock("BUILDING_12468", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_12481", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_12485", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_12486", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_12487", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_12488", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_12490", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_12491", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_12493", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_10437", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_12494", "lock1", closure_type='booby-trap')

def init_patch():
	
	if data().AbelRundgangBeendet:
		if was_zone_entered('zone_8.zone_8'):
			system.set_qb_entry_state(data('zone_8.zone_8').QB_011, globals.INACTIVE)
		system.set_qb_entry_state(data().QB_017, globals.UNCOMPLETE)
