# -*- coding: utf-8 -*-
from globals import *
import zonetext
import dialogs
import npc
from const import *
import water
import object_events
import schedules

#*** actual revision - Revision 9, 9.09.2004 **********************************

# äöü (better)

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="SEEKER",type=PT_COMPUTER)
	system.create_party(id="DORFBEWOHNER",type=PT_COMPUTER)
	system.create_party(id="Wölfe",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="NPCS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(223.0, 231.0),
	 		"SOUTH":	(404.0, 637.0),
	 		"WEST":		(213.0, 494.0),
	 		"EAST":		(408.0, 231.0),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("yellow")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Wigglers_Haus",195,265,235,245)
	
	data("rest").non_rest_areas.append("Wigglers_Haus")

def initQuestbook():
	data().QB_001 = system.register_qb_entry('ZZONE1_AIM_01')

def on_map_loaded():
	init_data()
	initParties()
	initQuestbook()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	
	# ae- and party-creation modifier | see debug_py.py for info on parameters
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

	npc.initNPCS()
	npc.initAnimals()
	initHerbs()
	initItems()
	initExitZones()
	initFX()
	system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	initWaterResources()

	#set_zone_enabled("zone_1",True)

	#system.add_region("WIGGLER",,,,)
	#system.notify_region_entered(region="WIGGLER",partyid="UISPIELER" )

	#system.add_region("SIEDLUNG",,,,)
	#system.notify_region_entered(region="SIEDLUNG",partyid="UISPIELER" )

	system.add_region("REGION_SEEKER",215,488,407,233)
	system.notify_region_entered(region="REGION_SEEKER",partyid="UISPIELER" )

	system.add_region("REGION_SEEKER_2",326,370,380,275)
	system.notify_region_entered(region="REGION_SEEKER_2",partyid="UISPIELER")

	object.set_active_state("WIGGLER",INACTIVE)
	initFoeLists()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_non_rest_areas()

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	# lagerfeuer
	system.mark_for_script_use('BUILDING_27')
	system.mark_for_script_use('BUILDING_1643')
	# kisten, truhen, tresore
	system.mark_for_script_use("BUILDING_4202")
	system.mark_for_script_use("BUILDING_2914")
	system.mark_for_script_use("BUILDING_4203")
	system.mark_for_script_use("BUILDING_4204")
	system.mark_for_script_use("BUILDING_1771")
	system.mark_for_script_use("BUILDING_3057")
	
	# Bienenstöcke ZZone 1
	system.mark_for_script_use('BUILDING_4222')
	system.mark_for_script_use('BUILDING_4220')
	system.mark_for_script_use('BUILDING_4219')
	system.mark_for_script_use('BUILDING_4221')

	

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		if not npc in SEEKER:
			object.set_immortal_state(npc, True)

def initWaterResources():
	water.set_water_source(320.9,232.0, 4)
	water.set_water_source(360.0,422.0, 2)

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_enter_region(id, objectid, partyid):
	# non-permanent triggers: objectid is list of all chars in region
	if type(objectid)==list: objectid=objectid[0]

	if (id=="REGION_SEEKER" and partyid=="UISPIELER" and data().seeker_kommentar == 0):
		if not data().player_knows_Siedlung:
			data().player_knows_Siedlung = True
			system.add_minimap_marker(319.57,284.93,"MM_002")# Siedlung	
		dialogs.initDlg_001_zurStadtkommen()

	if (id=="REGION_SEEKER_2" and partyid=="UISPIELER"):
		#object.attack("SEEKER_3","ALTER_EGO")
		object.cancel_commandos("SEEKER_3")
		#object.set_attribute( "SEEKER_3", attribute="foes", value= ["UISPIELER"])

def on_attack(operator, target):
	#print "on_attack(",operator, target,")"
	
	if not hasattr(data(), "has_been_attacked"):
		data().has_been_attacked = []
	if not target in data().has_been_attacked:
		data().has_been_attacked.append(target)
	else:
		return
	
	if object.is_npc(target):
		if object.is_destroyed(operator):
			return
		if target in ["SEEKER_1", "SEEKER_2"]:
			for id in ["SEEKER_1", "SEEKER_2"]:
				if not id in data().has_been_attacked:
					data().has_been_attacked.append(id)
					if not object.is_destroyed(id):
						object.cancel_commandos(id)
						object.attack(id,operator)
		else:
			object.cancel_commandos(target)
			object.attack(target,operator)

def on_enemy_spotted(object_id):
	#print "[debug: on_enemy_spotted:",object_id,"]"
	enemys = character.get_visible_enemies(object_id)
	if object_id in system.get_pcs():
		if len(enemys):
			for id in enemys:
				if id in SEEKER and not data().Dlg_002_Gesprochen:
					data().Dlg_002_Gesprochen = True
					dialogs.initDlg_002_Seekersehen()
					object.move_to("SEEKER_3", 378, 317, "landscape",MT_SLOW ,["ONEND",Seekerbewegung])
	else:
		if object.is_npc(object_id) and len(enemys):
			if (object_id != "WIGGLER"):
				if object_id in ["SEEKER_1", "SEEKER_2"]:
					for id in ["SEEKER_1", "SEEKER_2"]:
						if not object.is_destroyed(id):
							object.cancel_commandos(id)
							object.attack(id,random.choice(enemys))
				else:
					object.cancel_commandos(object_id)
					object.attack(object_id,random.choice(enemys))

def on_approach(target, operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

def seeker_at_garbage_container(seeker):
	sounds.play_3d_sound_object(sfx_id="seeker_at_garbage_container",object=seeker)

def on_wait_for_commando(id):
	if id == "SEEKER_0":
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP", callback=["ONEND", seeker_at_garbage_container])
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP", callback=["ONEND", seeker_at_garbage_container])
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP", callback=["ONEND", seeker_at_garbage_container])
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		object.move_to("SEEKER_0", 303.83, 259.97, "landscape",MT_SLOW )
		object.turn_to_object( "SEEKER_0", "BUILDING_1138" )
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP", callback=["ONEND", seeker_at_garbage_container])
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		character.play_animation("SEEKER_0", "CM_PRAEPARIEREN_STEHEN_LOOP")
		object.move_to("SEEKER_0", 304.81, 258.49, "landscape",MT_SLOW )
		object.turn_to_object( "SEEKER_0", "BUILDING_1137" )
		return True

	if id == "SEEKER_4":
		if object.get_attribute(id,"hitpoints") == object.get_attribute(id,"maxhitpoints"):
			object.move_to("SEEKER_4", 368.29, 277.77, "landscape",MT_SLOW )
			character.play_animation("SEEKER_4", "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START")
			character.play_animation("SEEKER_4", "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_ENDE")
			object.turn_to_object( "SEEKER_4", "BUILDING_601" )
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			character.play_animation("SEEKER_4", "CM_PRAEPARIEREN_STEHEN_LOOP")
			object.move_to("SEEKER_4", 368.29, 277.77, "landscape",MT_SLOW )
			object.turn_to_object( "SEEKER_4", "BUILDING_601" )
			return True
		else: return False
	return schedules.Activity(id)

def initItems():
	object.create_item_in_inventory("SEEKER_0", ["SET_MICRO_UZI"] + ["SET_AMMOPACK_9_MM"]*2 )
	object.create_item_in_inventory("SEEKER_1", ["SET_MICRO_UZI"] + ["SET_AMMOPACK_9_MM"]*2 )
	object.create_item_in_inventory("SEEKER_2", ["SET_MICRO_UZI"] + ["SET_AMMOPACK_9_MM"]*2 )
	object.create_item_in_inventory("SEEKER_3", ["SET_MICRO_UZI"] + ["SET_AMMOPACK_9_MM"]*2 )
	object.create_item_in_inventory("SEEKER_4", ["SET_UZI"] + ["SET_AMMOPACK_9_MM"]*2 )

	object.create_item_in_inventory("WIGGLER", ["SET_WALTER_PPK"] + ["SET_AMMOPACK_7_65_MM"]*2 )


	character.equip( "SEEKER_0", equipment="SET_MICRO_UZI" )
	character.equip( "SEEKER_1", equipment="SET_MICRO_UZI" )
	character.equip( "SEEKER_2", equipment="SET_MICRO_UZI" )
	character.equip( "SEEKER_3", equipment="SET_MICRO_UZI" )

	
	object.create_item_in_inventory("BUILDING_22", ["SET_MEAT_RAW_SMALL"] ) # niche chien
	object.create_item_in_inventory("BUILDING_1557", ["SET_AMMOPACK_5_45_MM"] ) # Mï¿½lltonne
	object.create_item_in_inventory("BUILDING_401", ["SET_MEDIPACK_SMALL"] ) # Kiste am Zaun
	object.create_item_in_inventory("BUILDING_1628", ["SET_AMMOPACK_5_45_MM","SET_OINTMANT_JAR"] ) # Tonne am Haus
	object.create_item_in_inventory("BUILDING_1645", ["SET_AMMOPACK_5_45_MM"] ) # Autowrack
	#object.create_item_in_inventory("BUILDING_1328", ["SET_MEAT_COOKED_SMALL", "SET_WATER_SKIN" ] ) # Brunnen
	object.create_item_in_inventory("BUILDING_1189", ["SET_AMMOPACK_44"]) # Fass
	object.create_item_in_inventory("BUILDING_1081", ["SET_WATERTIGHT_RING"]) #ruine
	object.create_item_in_inventory("BUILDING_358", ["SET_LONG_NAILS","SET_LEAD_PIPE"]) #ruine
	object.create_item_in_inventory("BUILDING_1562", ["SET_NORMAL_CLOTHES_2","SET_RAGS"]) #wäscheleine
	
	object.create_item_in_inventory("BUILDING_429", ["SET_SMALL_SAND_BUCKET"]) # Grab
	object.create_item_in_inventory("BUILDING_1561", ["SET_SHURIKEN"]) # Wäschekorb
	object.create_item_in_inventory("BUILDING_3002", ["SET_WATERTIGHT_RING"]) # Stahlregal
	object.create_item_in_inventory("BUILDING_3054", ["SET_AMMOPACK_5_45_MM"]) # Glastisch
	object.create_item_in_inventory("BUILDING_2920", ["SET_AMMOPACK_5_45_MM"]) # Kinderwagen
	object.create_item_in_inventory("BUILDING_391", ["SET_AMMOPACK_5_45_MM"]) # Leere Kisten
	object.create_item_in_inventory("BUILDING_2957", ["SET_WATER_SKIN"]) # Tisch
	object.create_item_in_inventory("BUILDING_2977", ["SET_MEDIPACK_SMALL"]) # Holzfässer
	object.create_item_in_inventory("BUILDING_3018", ["SET_ORDINARY_HELMET", "SET_MEAT_COOKED_SMALL"]) # Tischchen 
	
	
	# Bienenstöcke ZZ1
	object.create_item_in_inventory('BUILDING_4222', [ 'SET_BEESWAX' ] )
	object.create_item_in_inventory('BUILDING_4220', [ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	object.create_item_in_inventory('BUILDING_4219', [ 'SET_BEESWAX' ] )
	object.create_item_in_inventory('BUILDING_4221', [ 'SET_BEESWAX' ] )

	# Items in Kisten
	object.create_item_in_inventory('BUILDING_4202', [ 'SET_AMMOPACK_5_45_MM', 'SET_THROWING_KNIFE', 'SET_AMMOPACK_7_65_MM' ] )
	object.create_item_in_inventory('BUILDING_2914', [ 'SET_LEATHER_GLOVES', 'SET_STEEL_TUBE', 'SET_LOW_SHOES' ] )
	object.create_item_in_inventory('BUILDING_4203', [ 'SET_WATER_SKIN', 'SET_MEDIPACK_SMALL', 'SET_LEATHER_CAP' ] )
	object.create_item_in_inventory('BUILDING_4204', [ 'SET_WALTER_PPK_W_SILENCER', 'SET_BOOMERANG', 'SET_LEATHER_CLOTHES' ] )
	object.create_item_in_inventory('BUILDING_1771', [ 'SET_MEAT_COOKED_TINY', 'SET_MANSLAYER', 'SET_P90_SMG_W_LASERPOINTER' ])
	object.create_item_in_inventory('BUILDING_3057', [ 'SET_CLUB', 'SET_POWER_DRILL', 'SET_AMMOPACK_5_45_MM' ] )


def Seekerbewegung(id):
	object.move_to("SEEKER_3", 349, 324, "landscape",MT_SLOW ,["ONEND",Seekerbewegung1])

def Seekerbewegung1(id):
	object.move_to("SEEKER_3", 365, 333, "landscape",MT_SLOW ,["ONEND",Seekerbewegung2])

def Seekerbewegung2(id):
	object.move_to("SEEKER_3", 361, 310, "landscape",MT_SLOW ,["ONEND",Seekerbewegung3])

def Seekerbewegung3(id):
	object.move_to("SEEKER_3", 347, 303, "landscape",MT_SLOW ,["ONEND",Seekerbewegung4])

def Seekerbewegung4(id):
	object.move_to("SEEKER_3", 342, 311, "landscape",MT_SLOW ,["ONEND",Seekerbewegung])

def initExitZones():
	# Begehbarer Bereich der westliche Zone ist sehr knapp bemessen wegen einem Haus das sonst
	# mitten in der Zone stehen wï¿½rde. Jetzt steht dieses Haus halb in der Zone.
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 639.00, y2 = 217.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD")
	system.add_region( id = "REGION_EXIT_SUED", x1 = 430.12, y1 = 863.00, x2 = 0.00, y2 = 652.67 )
	system.register_exit(regionname = "REGION_EXIT_SUED")
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 652.67, x2 = 195.00, y2 = 217.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST")
	system.add_region( id = "REGION_EXIT_OST", x1 = 639.00, y1 = 217.00, x2 = 430.12, y2 = 863.00 )
	system.register_exit(regionname = "REGION_EXIT_OST")

def initFX():
	# Lagerfeuer
	system.start_effect_object("BUILDING_27",node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object("BUILDING_27",node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object("BUILDING_27",node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object("BUILDING_27",node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object("BUILDING_27",node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object("BUILDING_27",node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object="BUILDING_27",loop=True)

	system.start_effect_object("BUILDING_1643",node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object("BUILDING_1643",node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object("BUILDING_1643",node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object("BUILDING_1643",node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object("BUILDING_1643",node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object("BUILDING_1643",node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object="BUILDING_1643",loop=True)

def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 359.83, y = 404.33)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 335.44, y = 257.58)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 199.23, y = 260.56)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 200.82, y = 320.77)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 376.01, y = 508.55)

def initFoeLists():
	for id in SEEKER :
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

	#object.set_attribute( "Wolf", attribute="foes", value= PCs )
	object.set_attribute( "Hirsch_1", attribute="foes", value=["UISPIELER"])
	object.set_attribute( "Hirsch_2", attribute="foes", value=["UISPIELER"])
	object.set_attribute( "Hirsch_3", attribute="foes", value=["UISPIELER"])
	object.set_attribute( "Hirsch_4", attribute="foes", value=["UISPIELER"])
	object.set_attribute( "Hirsch_5", attribute="foes", value=["UISPIELER"])
	object.set_attribute( "Hirsch_6", attribute="foes", value=["UISPIELER"])
	object.set_attribute( "Hirsch_7", attribute="foes", value=["UISPIELER"])

# Das Sterben der Seeker
def on_object_killed(victim, attacker, weapon_type, weapon_id):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	if victim in SEEKER:
		data().SEEKERTOT += 1
		
		if data().SEEKERTOT == 5:
			object.set_active_state("WIGGLER",ACTIVE)
			dialogs.initDlg_003_Seekersindtot()

def on_timer(id):
	#print "[debug on_timer()",id,"]"
	## Zeitausloeser, triggert jede Stunde
	if (id==data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			npc.spawnAnimals(INACTIVE)
		else:
			npc.spawnAnimals(ACTIVE)
def on_pick_up( character_id, item_id, item_type ):
	#print "[debug on_pick_up", character_id, item_id,item_type,"]"
	return True


def InitChestsSafes():
	object.add_closed_lock("BUILDING_4202", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_2914", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_4203", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_4204", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_1771", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_3057", "lock1", closure_type='lock-trap')

def init_patch():
	if "ANIE" in system.get_npcs():
		if object.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True
