# -*- coding: utf-8 -*-
from globals import *
import zonetext
import dialogs
import npc
from const import *
import water
import object_events
import schedules

#*** actual revision - Revision 5, 19.07.2004 **********************************

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="DESERT_MONKS_1",type=PT_COMPUTER)
	system.create_party(id="DESERT_MONKS_2",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="NPCS",type=PT_COMPUTER)


def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(223.0, 231.0),
	 		"SOUTH":	(404.0, 637.0),
	 		"WEST":		(213.0, 494.0),
	 		"EAST":		(416.0, 256.0),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
	skies.init_sky_preset("orange")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Desertmonk_Lager_1",280,460,335,510)
		system.add_region("Desertmonk_Lager_2",390,300,340,260)

	data("rest").non_rest_areas.append("Desertmonk_Lager_1")
	data("rest").non_rest_areas.append("Desertmonk_Lager_2")

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )

	# ae- and party-creation modifier | see debug_py.py for info on parameters
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

	npc.initNPCS()
	npc.initAnimals()
	system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	initItems()
	initHerbs()
	initExitZones()
	initDialogZonen()
	initFX()
	initWaterResources()
	initFoesLists()
	checkMapDependencies()
	
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_non_rest_areas()

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	# lagerfeuer
	system.mark_for_script_use('BUILDING_918')
	system.mark_for_script_use('BUILDING_857')
	# kisten, truhen, tresore
	system.mark_for_script_use("BUILDING_1665")
	system.mark_for_script_use("BUILDING_1664")
	
	# Bienenstöcke ZZone 2
	system.mark_for_script_use('BUILDING_1666')



# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		if not npc in DESERT_MONKS_1 + DESERT_MONKS_2:
			object.set_immortal_state(npc, True)

def checkMapDependencies():
	## wiggler switch checken
	if was_zone_entered("zzone_1.zzone_1"):
		data().MitWigglerGesprochen = data("zzone_1.zzone_1").MitWigglerGesprochen
		#print "[debug: zzone_1 entered before | wiggler set to",str(data().MitWigglerGesprochen)

def initFoesLists():
	for dm in DESERT_MONKS_1:
		object.set_attribute(dm,"foes",['UISPIELER'])
	for dm in DESERT_MONKS_2:
		object.set_attribute(dm,"foes",['UISPIELER'])

def initWaterResources():
	water.set_water_source(342.2,362.6, 4)

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_approach(target, operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

def on_wait_for_commando(id):
	return schedules.Activity(id)

def initItems():
	object.create_item_in_inventory(object="DESERT_MONK_0",equipment=["SET_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_1",equipment=[	"SET_DESERT_EAGLE","SET_AMMOPACK_50","SET_AMMOPACK_50"])
	object.create_item_in_inventory(object="DESERT_MONK_2",equipment=[	"SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_3",equipment=[	"SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_4",equipment=[	"SET_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_5",equipment=[	"SET_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_6",equipment=[	"SET_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_7",equipment=[	"SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM","SET_AMMOPACK_2_12_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_8",equipment=["SET_WALTER_PPK","SET_AMMOPACK_7_65_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_9",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_10",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_11",equipment=["SET_UZI","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_12",equipment=["SET_AUTOMAG_3","SET_AMMOPACK_7_62NATO_MM"])
	object.create_item_in_inventory(object="DESERT_MONK_13",equipment=["SET_AUTOMAG_3","SET_AMMOPACK_7_62NATO_MM"])

	character.equip( "DESERT_MONK_0", equipment="SET_UZI" )
	character.equip( "DESERT_MONK_1", equipment="SET_DESERT_EAGLE" )
	character.equip( "DESERT_MONK_2", equipment="SET_MICRO_UZI" )
	character.equip( "DESERT_MONK_3", equipment="SET_MICRO_UZI" )
	character.equip( "DESERT_MONK_8", equipment="SET_WALTER_PPK" )
	character.equip( "DESERT_MONK_11", equipment="SET_UZI" )
	character.equip( "DESERT_MONK_12", equipment="SET_AUTOMAG_3" )
	character.equip( "DESERT_MONK_13", equipment="SET_AUTOMAG_3" )
	character.equip( "DESERT_MONK_7", equipment="SET_REMINGTON_M870" )

	object.create_item_in_inventory(object="BUILDING_936",equipment=data().QI_PlanOfAction[0],id=data().QI_PlanOfAction[1])
	object.set_attribute(object=data().QI_PlanOfAction[1], attribute="generic_item", value=False)
	
	object.create_item_in_inventory("BUILDING_934",["SET_BICYCLE_SEAT"])
	object.create_item_in_inventory("BUILDING_937",["SET_MP5","SET_AMMOPACK_9_MM","SET_AMMOPACK_9_MM"])
	object.create_item_in_inventory("BUILDING_938",["SET_WATER_BOTTLE"])
	object.create_item_in_inventory("BUILDING_932",["SET_MEAT_COOKED_SMALL","SET_MEAT_COOKED_TINY"])
	object.create_item_in_inventory("BUILDING_870",["SET_COOKING_POT","SET_HAIR_DRYER"])
	object.create_item_in_inventory("BUILDING_852",["SET_AMMOPACK_45"])
	object.create_item_in_inventory("BUILDING_859",["SET_BROKEN_SHOVEL"])
	object.create_item_in_inventory("BUILDING_856",["SET_MEDIPACK_SMALL"])
	object.create_item_in_inventory("BUILDING_917",["SET_CHAIN_SAW"])
	object.create_item_in_inventory("BUILDING_930",["SET_FLASHGRENADE","SET_DART"])
	object.create_item_in_inventory("BUILDING_659",["SET_LEATHER_BOOTS","SET_NORMAL_CLOTHES_3"])
	object.create_item_in_inventory("BUILDING_665",["SET_HACKSAW","SET_REEL_OF_STEEL_WIRE"])
	
	# Bienenstöcke ZZ2
	object.create_item_in_inventory( 'BUILDING_1666', equipment=[ 'SET_BEESWAX' ] )

	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_1664', equipment=[ 'SET_MICRO_UZI', 'SET_LANDMINE', 'SET_BATTERY' ] )
	object.create_item_in_inventory( 'BUILDING_1665', equipment=[ 'SET_MULTIPLE_SOCKET', 'SET_HK_UMP_45', 'SET_WATER_BOTTLE', 'SET_MEDIPACK_SMALL' ] )

	
def initHerbs():
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=215.30, y=248.5)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=332.66, y=452.68)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=356.39, y=246.06)
	system.create_object(equipmenttype="SET_ANGELICA", x=267.41, y=327.89)
	system.create_object(equipmenttype="SET_ANGELICA", x=242.82, y=466.69)
	

def initExitZones():
	# Begehbarer Bereich der westliche Zone ist sehr knapp bemessen wegen einem Haus das sonst
	# mitten in der Zone stehen wuerde. Jetzt steht dieses Haus halb in der Zone.
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 639.00, y2 = 217.00 )
	system.register_exit( regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 430.12, y1 = 863.00, x2 = 0.00, y2 = 652.67 )
	system.register_exit( regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 652.67, x2 = 201.00, y2 = 217.00 )
	system.register_exit( regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 639.00, y1 = 217.00, x2 = 430.12, y2 = 863.00 )
	system.register_exit( regionname = "REGION_EXIT_OST" )

def initFX():
	#Lagerfeuer Lichtung
	system.start_effect_object(object="BUILDING_918",node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object="BUILDING_918",node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object="BUILDING_918",node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object="BUILDING_918",node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object="BUILDING_918",node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object="BUILDING_918",node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	#Lagerfeuer Huegel
	system.start_effect_object(object="BUILDING_857",node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object="BUILDING_857",node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object="BUILDING_857",node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object="BUILDING_857",node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object="BUILDING_857",node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object="BUILDING_857",node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)

def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 396.24, y = 442.49)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 387.92, y = 577.77)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 359.82, y = 245.72)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 264.51, y = 299.47)

def initDialogZonen():
	system.add_region( id = "REGION_LICHTUNG", x1 = 260.00, y1 = 420.00, x2 = 370.00, y2 = 585.00 )
	system.notify_region_entered(region="REGION_LICHTUNG", partyid="UISPIELER")
	system.add_region( id = "REGION_HUEGEL", x1 = 275.00, y1 = 220.00, x2 = 425.00, y2 = 340.00 )
	system.notify_region_entered(region="REGION_HUEGEL", partyid="UISPIELER")

## zeitgeschaltete events
def on_timer(id):
	#print "[debug on_timer()",id,"]"
	## Zeitauslöser, triggert jede Stunde
	if (id==data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			npc.spawnAnimals(INACTIVE)
		else:
			npc.spawnAnimals(ACTIVE)
	
	if (id==data().TimerKampf_1):
		#print 'data().TimerKampf_1'
		data().Feinde_Da_1 = True
	
	if (id==data().TimerKampf_2):
		#print 'data().TimerKampf_2'
		data().Feinde_Da_2 = True
		
## betreten von regionen
def on_enter_region(id, objectid, partyid):
	# non-permanent triggers: objectid is list of all chars in region
	if type(objectid)==list: objectid=objectid[0]
	
	# desertmonks lager auf der lichtung
	if (id=="REGION_LICHTUNG" and partyid=="UISPIELER"):
		if not data().player_knows_Camp1:
			data().player_knows_Camp1 = True
			system.add_minimap_marker(315.61,492.61,"MM_001")# Camp1
		if ( data().MitWigglerGesprochen == True):
			dialogs.initDlg_001_LichtungEntdeckt_Wiggler()
		else:
			dialogs.initDlg_002_LichtungEntdeckt()

	# desertmonks lager auf dem hügel
	if (id=="REGION_HUEGEL" and partyid=="UISPIELER"):
		if not data().player_knows_Camp2:
			data().player_knows_Camp2 = True
			system.add_minimap_marker(361.64,287.20,"MM_002")# Camp2
		if ( data().MitWigglerGesprochen == True):
			dialogs.initDlg_003_HuegelEntdeckt_Wiggler()
		else:
			dialogs.initDlg_004_HuegelEntdeckt()

def killedDesertMonksLichtung():
	if ( data().DesertMonksKilledLichtung == 7 ):
		if ( data().MitWigglerGesprochen == True):
			dialogs.initDlg_005_KilledAllLichtung_Wiggler()
		else:
			dialogs.initDlg_006_KilledAllLichtung()

## toeten von objekten
def on_object_killed(victim, attacker, weapon_type, weapon_id):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)

	if victim in DESERT_MONKS_1:
		data().DesertMonksKilledLichtung+=1
		killedDesertMonksLichtung()
	
	if (attacker in data().DESERT_MONKS_1):
		for id in data().DESERT_MONKS_1:
			if victim in data().DESERT_MONKS_1[attacker]:
				data().DESERT_MONKS_1[attacker].remove(victim)
	
	if (attacker in data().DESERT_MONKS_2):
		for id in data().DESERT_MONKS_2:
			if victim in data().DESERT_MONKS_2[attacker]:
				data().DESERT_MONKS_2[attacker].remove(victim)

	if (victim in data().DESERT_MONKS_1):
		del data().DESERT_MONKS_1[victim]
		#print '#####  Kill #####', victim, data().DESERT_MONKS_1 
	
	if (victim in data().DESERT_MONKS_2):
		del data().DESERT_MONKS_2[victim]
		#print '#####  Kill #####', victim, data().DESERT_MONKS_2
				
## untersuchen von objekten
def can_examine_object( character_id, object_id ):
	if (object_id == data().QI_PlanOfAction[1]
		and character_id == "ALTER_EGO"):
		return True
	return object_events.can_examine_object( character_id, object_id )

def on_examine_object( character_id, object_id ):
	if ( object_id == data().QI_PlanOfAction[1] ):
		if ( data().MitWigglerGesprochen == True):
			dialogs.initDlg_007_SchlachtplanGefunden_Wiggler()
		else:
			dialogs.initDlg_008_SchlachtplanGefunden()
		return True
	return object_events.on_examine_object( character_id, object_id )

## aufheben von objekten
def on_pick_up( character_id, item_id, item_type ):
	#print "[debug on_pick_up", character_id, item_id, item_type,"]"
	return True

## benutzen von objekten
def can_use( character_id, object_id ):
	if character_id == "ALTER_EGO":
		if object_id == data().QI_PlanOfAction[1]:
			return True
	return object_events.can_use( character_id, object_id )

def on_use( character_id, object_id, item_id, item_type ):
	if character_id == "ALTER_EGO":
		if item_id == data().QI_PlanOfAction[1]:
			if ( data().MitWigglerGesprochen == True):
				dialogs.initDlg_007_SchlachtplanGefunden_Wiggler()
			else:
				dialogs.initDlg_008_SchlachtplanGefunden()
			return True
	return object_events.on_use( character_id, object_id, item_id, item_type )

###########################################################################
### todo sollte irgendwann die prohibit_activity einwandfrei 		###
### funktionieren sollten die timer wieder raus Thomas Horn fragen 	###
###########################################################################

## sichten von feinden
def on_enemy_spotted(object_id):
	enemys = character.get_visible_enemies(object_id)
	#print "[debug: on_enemy_spotted:",object_id,"]"
	
	if object.is_npc(object_id):
		if object_id in data().DESERT_MONKS_1 and len(enemys):
			data().DESERT_MONKS_1[object_id] = character.get_visible_enemies(object_id)
			if not data().Feinde_Da_1 and not data().PActivitye_1:
				for id_ in DESERT_MONKS_1:
					if not object.is_destroyed(id_):
						object.cancel_commandos(id_)
						prohibit_activity(id_, step_away = True)
						#print 'ProhibitActivity_1', id_, 'Feinde_Da_1', data().Feinde_Da_1
				data().PActivitye_1 = True
				system.notify_timer(data().TimerKampf_1, data().Timervalue_Kampf_1)
			elif data().Feinde_Da_1:
				for id in DESERT_MONKS_1:
					if not object.is_destroyed(id):
						#print 'id in DESERT_MONKS_1', id, data().DESERT_MONKS_1[id]
						if not len(data().DESERT_MONKS_1[id]):
							if not character.get_visible_enemies(id):
								data().DESERT_MONKS_1[id] = enemys
								#print 'neu', data().DESERT_MONKS_1[id]
							else:
								data().DESERT_MONKS_1[id] = character.get_visible_enemies(id)
								#print 'data().DESERT_MONKS_1[id]' ,data().DESERT_MONKS_1[id]
						if Is_Equip_Weapon(id):
							if len(data().DESERT_MONKS_1[id]):
								if not object.is_destroyed(data().DESERT_MONKS_1[id][0]):
									if not object.is_destroyed(id):
										object.attack(id ,data().DESERT_MONKS_1[id][0])
										#print 'object.attack', id ,data().DESERT_MONKS_1[id][0]
									
		elif object_id in data().DESERT_MONKS_2 and len(enemys):
			data().DESERT_MONKS_2[object_id] = character.get_visible_enemies(object_id)
			if not data().Feinde_Da_2 and not data().PActivitye_2:
				for id_ in DESERT_MONKS_2:
					if not object.is_destroyed(id_):
						object.cancel_commandos(id_)
						prohibit_activity(id_, step_away = True)
						#print 'ProhibitActivity_2', id_, 'Feinde_Da_2', data().Feinde_Da_2
				data().PActivitye_2 = True
				system.notify_timer(data().TimerKampf_2, data().Timervalue_Kampf_2)
			elif data().Feinde_Da_2:
				for id in DESERT_MONKS_2:
					if not object.is_destroyed(id):
						#print 'id in DESERT_MONKS_2', id, data().DESERT_MONKS_2[id]
						if not len(data().DESERT_MONKS_2[id]):
							if not character.get_visible_enemies(id):
								data().DESERT_MONKS_2[id] = enemys
								#print 'neu', data().DESERT_MONKS_2[id]
							else:
								data().DESERT_MONKS_2[id] = character.get_visible_enemies(id)
								#print 'data().DESERT_MONKS_2[id]' ,data().DESERT_MONKS_2[id]
						if Is_Equip_Weapon(id):
							if len(data().DESERT_MONKS_2[id]):
								if not object.is_destroyed(data().DESERT_MONKS_2[id][0]):
									if not object.is_destroyed(id):
										object.attack(id ,data().DESERT_MONKS_2[id][0])
										#print 'object.attack', id ,data().DESERT_MONKS_2[id][0]
		
	else:
		pass
		#object.attack(object_id,random.choice(enemys))

def on_sector_cleared(object_id):
	if object_id in data().DESERT_MONKS_1:
		for id in data().DESERT_MONKS_1:
			if not object.is_destroyed(id):
				if (character.get_visible_enemies(id)):
					return False
		data().Feinde_Da_1  = False
		data().PActivitye_1 = False
		for id in data().DESERT_MONKS_1:
			if not object.is_destroyed(id):
				data().DESERT_MONKS_2[id] = []
				allow_activity(id)
	
	if object_id in data().DESERT_MONKS_2:
		for id in data().DESERT_MONKS_2:
			if not object.is_destroyed(id):
				if (character.get_visible_enemies(id)):
					return False
		data().Feinde_Da_2  = False
		data().PActivitye_2 = False
		for id in data().DESERT_MONKS_2:
			if not object.is_destroyed(id):
				data().DESERT_MONKS_2[id] = []
				allow_activity(id)

###################################################################################
### Testet ob ein NPc, PC eine Waffe in der Hand hat 				###
### Wenn nicht gibt er ihm soweit im Inventory vorhanden eine Waffe in die Hand ###
### todo erweiterung auf die Möglichkeit das der Char etwas in der Hand hat	###
###################################################################################
def Is_Equip_Weapon(char_id):
	### hat der NPc, PC Hände ? ###
	if object.has_attribute(char_id, 'slots'):
		equ = object.get_attribute(char_id, 'slots')
		### hat der NPc, PC etwas in der rechten Hand ###
		if (equ['right_hand']):
			### ist dass was er in der Hand hat eine Waffe ###
			if object.has_attribute(equ['right_hand'], 'weapon_type'):
				### alles so wie es sein soll ende ###
				return True
		### Wenn der NPc, PC keine Waffe in der Hand hat ###
		### geht das Inventory des NPc, PC durch ###
		for id in object.get_inventory_id_list(char_id):
			### ist das gefundene Item eine Waffe ###
			if object.has_attribute(id, 'weapon_type'):
				### nimm die Waffe in die Hand ###
				character.equip_direct(char_id, id)
				### alles so wie es sein soll ende ###
				return True
	### hat der NPC, PC noch keine Hände ###
	elif not object.has_attribute(char_id, 'slots'):
		### geht das Inventory des NPc, PC durch ###
		for id in object.get_inventory_id_list(char_id):
			### ist das gefundene Item eine Waffe ###
			if object.has_attribute(id, 'weapon_type'):
				### nimm die Waffe in die Hand ###
				character.equip_direct(char_id, id)
				### alles so wie es sein soll ende ###
				return True
	### wenn keine Waffe gefunden wurde ###
	return False


def InitChestsSafes():
	object.add_closed_lock("BUILDING_1664", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_1665", "lock1", closure_type='normal')

def init_patch():
	if "ANIE" in system.get_npcs():
		if object.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True
