# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import water
import object_events
import schedules
from const import *
import npc_activities
import char_autogeneration
import cs_function as cs

#*** actual revison - Revision 13, 21.10.2004 ***********************************

# äöü (better)

def initParties():
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="ANIMALS",type=PT_COMPUTER)
    system.create_party(id="SEEKER",type=PT_COMPUTER)
    system.create_party(id="NPCS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
    if was_zone_entered("zzone_3.zzone_3"):return (343.0, 662.0)
    else:
        start_locations = { "NORTH": (311.0, 192.0), "SOUTH": (343.0, 662.0) }
        if (enterdirection in start_locations.keys()):
            return start_locations[enterdirection]
        else:
            raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
    skies.init_sky_preset("redrock")

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
        system.add_region("Stitch_und_Shuffle",315,635,250,610)
        system.add_region("Hickey",350,250,315,275)
        system.add_region("Labyrinth",420,320,215,535)

    data("rest").non_rest_areas.append("Stitch_und_Shuffle")
    data("rest").non_rest_areas.append("Hickey")
    data("rest").non_rest_areas.append("Labyrinth")

def on_map_loaded():
    init_data()
    initParties()

# place player characters
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )

# ae- and party-creation modifier | see debug_py.py for info on parameters
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

    npc.initNPCS()
    npc.initAnimals()
    char_autogeneration.init_Mercenary('MERCENARY_SEVENSOULS')
    object.set_position_free('MERCENARY_SEVENSOULS', 342.76, 498.78,0)
    initItems()
    initHerbs()
    initExitZones()
    initFX()
    initFoeLists()
    initWaterResources()

## Timer für die Tierspawns
#    system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

# Stitch und SHUFFLE
    system.add_region("STUNDST",247.00, 609.00, 316.00, 637.00)
    system.notify_region_entered(region="STUNDST", partyid="UISPIELER" )
    system.add_region("NORDEINGANG",312.00, 248.00, 340.00, 265.00)
    system.notify_region_entered(region="NORDEINGANG", objectid="ALTER_EGO" )
    
    system.add_region("Z_6 FREISCHALTUNG", 296.46, 245.61, 335.68, 227.31)
    system.notify_region_entered(region="Z_6 FREISCHALTUNG", objectid="ALTER_EGO" )
    
    schedules.init_schedules() ## immer nach dem initQuestbook()
    init_scriptuse_objects()
    InitChestsSafes()
    init_character_states()
    init_non_rest_areas()
    initQuestbook()

def initQuestbook():
    data().QB_001 = system.register_qb_entry('ZZONE3_AIM_01')

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
# lagerfeuer
    system.mark_for_script_use('BUILDING_335')
# kisten, truhen, tresore
# system.mark_for_script_use("BUILDING_3249")
    
# Bienenstöcke ZZone 3
    system.mark_for_script_use('BUILDING_5296')
    system.mark_for_script_use('BUILDING_5265')

    

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
    npcs = system.get_npcs()
#mortality
    for npc in npcs:
        if not npc in NPC_SEEKER:
            object.set_immortal_state(npc, True)
    object.set_immortal_state("STITCH", False)
    object.set_immortal_state("SHUFFLE", False)
    object.set_immortal_state("MERCENARY_SEVENSOULS", False)

def initWaterResources():
    water.set_water_source(260.3,296.4, 4)

def on_post_load():
    initFX()
    schedules.init_schedules()
    init_patch()

def on_approach(target,operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)

def can_examine_object( character_id, object_id ):
    return False

def on_examine_object( character_id, object_id ):
    return False

# NPC's bewaffnen

def initItems():
    object.create_item_in_inventory("HICKEY", ["SET_COLT_45","SET_AMMOPACK_45"])
    object.create_item_in_inventory("MERCENARY_SEVENSOULS", ["SET_COLT_45","SET_AMMOPACK_45"])

    l_armes=["SET_REMINGTON_M870"]*3+["SET_SPAS_15"]+["SET_MP5"]*2+["SET_CALICO_M950"]*2+\
        ["SET_REMINGTON_M870"]*2+["SET_MAC_10"]*2+["SET_MG_3"]+["SET_AK_74_BG_15"]*2+["SET_SIMONOV_SKS"]+\
        ["SET_MAC_10"]*2+["SET_REMINGTON_M870"]*2

    for i in range(20):
        char="SEEKER_%d" %(i+1)
        if l_armes[i]:cs.arme_npc(char,l_armes[i],2)
        else:cs.arme_npc(char)

    object.create_item_in_inventory("BUILDING_862",["SET_WATER_SKIN", "SET_TENT_CANVAS"])
    object.create_item_in_inventory("BUILDING_867",["SET_PLATE_ARMOR", "SET_PROTECTIVE_GLOVES", "SET_AMMOPACK_357"])
    object.create_item_in_inventory("BUILDING_86",["SET_BERETTA_92F","SET_AMMOPACK_7_62NATO_MM"])
    object.create_item_in_inventory("BUILDING_216",["SET_WOLF_PELT","SET_MEAT_RAW_BIG"])
    object.create_item_in_inventory("BUILDING_333",["SET_MEDIPACK_BIG","SET_RED_SHARD"])
    object.create_item_in_inventory("BUILDING_830",["SET_BROKEN_SHOVEL"])
    object.create_item_in_inventory("BUILDING_1037",["SET_HAIR_DRYER","SET_TOOTHBRUSH"])
    object.create_item_in_inventory("BUILDING_1013",["SET_TEDDY_BEAR","SET_SOLAR_CELLS"])
#klo
    object.create_item_in_inventory("BUILDING_1036",["SET_AK_47","SET_AMMOPACK_7_62SOVJET_MM"])
    object.create_item_in_inventory("BUILDING_882",["SET_BULLET_CASINGS","SET_BULLET_CASINGS"])
    object.create_item_in_inventory("BUILDING_476",["SET_CAR_EXHAUST_PIPE","SET_PLIERS"])
    object.create_item_in_inventory("BUILDING_476",["SET_BEESWAX"])
    object.create_item_in_inventory("BUILDING_1246",["SET_BELT","SET_SMALL_BAG"])
    
# Bienenstöcke ZZ3
    object.create_item_in_inventory('BUILDING_5296', ['SET_BEESWAX'])
    object.create_item_in_inventory('BUILDING_5265', ['SET_BEESWAX', 'SET_BEESWAX'])

# Items in Kisten
    object.create_item_in_inventory('BUILDING_3249', ['SET_TRANSFORMER','SET_MEDIPACK_SMALL','SET_STEEL_HELMET'])
    object.create_item_in_inventory('BUILDING_5182', ['SET_AMMOPACK_7_65_MM_SUBSONIC', 'SET_HK_G36C', 'SET_AMMOPACK_3_12_MM_QB_8'])
    object.create_item_in_inventory('BUILDING_5183', ['SET_CHAIN_MAIL', 'SET_MEDIPACK_BIG', 'SET_AMMOPACK_7_65_MM_DUMDUM'])
    object.create_item_in_inventory('BUILDING_5184', ['SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', 'SET_STEYR_TMP_W_LASERPOINTER'] )
    object.create_item_in_inventory('BUILDING_5211', ['SET_BRASS_KNUCKLES', 'SET_WATER_CAN', 'SET_MEAT_RAW_TINY'])

    
# Leichen um Siebenseele
    object.destroy("SEEKER_21")
    object.destroy("SEEKER_22")
    object.destroy("SEEKER_23")
    object.destroy("SEEKER_24")
    object.destroy("SEEKER_25")
    object.destroy("SEEKER_26")
    object.destroy("SEEKER_27")
    object.destroy("SEEKER_28")

def initHerbs():
    system.create_object(equipmenttype="SET_BURNET", x=270.74, y=424.44)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=347.17, y=415.53)
    system.create_object(equipmenttype="SET_ANGELICA", x=352.60, y=412.71)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=345.10, y=634.02)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=364.39, y=634.02)
    system.create_object(equipmenttype="SET_ANGELICA", x=335.45, y=402.59)

def initExitZones():
    system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 488.00, y2 = 200.00 )
    system.register_exit(regionname = "REGION_EXIT_NORD" )
    system.add_region( id = "REGION_EXIT_SUED", x1 = 639.00, y1 = 863.00, x2 = 200.00, y2 = 662.00 )
    system.register_exit(regionname = "REGION_EXIT_SUED" )
    system.add_region( id = "REGION_EXIT_WEST", x1 = 200.00, y1 = 863.00, x2 = 0.00, y2 = 160.00 )
    system.register_exit(regionname = "REGION_EXIT_WEST" )
    system.add_region( id = "REGION_EXIT_OST", x1 = 440.00, y1 = 0.00, x2 = 639.00, y2 = 725.00 )
    system.register_exit(regionname = "REGION_EXIT_OST" )

def initFoeLists():
    for seeker in NPC_SEEKER:
        object.set_attribute(seeker, attribute="foes", value=['UISPIELER'])

#def onKilled(id):
def on_object_killed(victim, attacker, weapon_type, weapon_id):
    object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
    if victim in NPC_SEEKER:
        data().Seeker_dead+=1
        if data().Seeker_dead == 20:
            character.add_experience_party(data().Exp_LabyrinthDurchquert)

def on_enter_region(id, objectid, partyid):
# non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid): objectid=objectid[0]
        else: return

# Region fuer Stitch und Stuffel
    if (id=="STUNDST"):
        if not data().player_knows_Labyrinth_Eingang:
            data().player_knows_Labyrinth_Eingang = True
            system.add_minimap_marker(287.49, 633.50,"MM_001")# Labyrinth-Eingang    
        if (not object.is_destroyed("STITCH") and not object.is_destroyed("SHUFFLE")):
            for id in system.get_pcs():
                object.cancel_commandos(id)
            object.set_position('ALTER_EGO',294.52, 637.18 )
            dialogs.initDlg_001_Ankommen()

# Region fuer Hickey
    if (id=="NORDEINGANG"):
        if not data().player_knows_Labyrinth_Ausgang:
            data().player_knows_Labyrinth_Ausgang = True
            system.add_minimap_marker(319.43, 216.73,"MM_003")# Labyrinth_Ausgang    
        if not object.is_destroyed("HICKEY"):
            object.cancel_commandos("ALTER_EGO")
            object.move_to("ALTER_EGO",327,254.76,"landscape",MT_FAST, callback = ['ONEND',
                Lambda("""object.move_to("HICKEY",326.86,256.04,"landscape",MT_FAST, callback = ['ONEND',
                    Lambda('dialogs.initDlg_005_Hickey()')])""")])

    if (id == 'Z_6 FREISCHALTUNG'):
        set_zone_enabled("zone_6",True)

def initFX():
    system.start_effect_object(object="BUILDING_335",node="effekt_feuer",parameter=fx_fire_lagerfeuer)
    system.start_effect_object(object="BUILDING_335",node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
    system.start_effect_object(object="BUILDING_335",node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
    system.start_effect_object(object="BUILDING_335",node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
    system.start_effect_object(object="BUILDING_335",node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
    pass
def on_button_down(Button):
    return False

# Animation fuer Siebenseele
def on_wait_for_commando(id):
    if (id == "MERCENARY_SEVENSOULS" and
        data().Geheilt == False):
        npc_activities.play_sound_injured_helper("MERCENARY_SEVENSOULS")
        character.play_animation("MERCENARY_SEVENSOULS", "CM_NPC_SIEBENSEELE_GESTE", callback=["ONEND",Lambda('object.set_position("MERCENARY_SEVENSOULS",342.85,498.85)')])
        return True
    else:
        return schedules.Activity(id)

# Tod von Siebenseele wenn er nicht beim erstenmal geheilt wurde
def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    if system.get_qb_entry_state(data().QB_001) not in [IMPOSSIBLE,COMPLETE]:
        if "MERCENARY_SEVENSOULS" in system.get_npcs():
            character.play_animation("MERCENARY_SEVENSOULS", "CM_NPC_SIEBENSEELE_STERBEN", callback=["ONEND",Lambda('object.set_attribute("MERCENARY_SEVENSOULS","hitpoints",0)')])
#object.set_attribute("MERCENARY_SEVENSOULS","hitpoints",0)
        data().Leiche_nicht_mehr_frisch = True
#    else:
#        if "MERCENARY_SEVENSOULS" in system.get_npcs():
#            object.set_active_state("MERCENARY_SEVENSOULS",INACTIVE)
    init_non_rest_areas()
    schedules.init_schedules()
    init_patch()

def on_pick_up( character_id, item_id, item_type ):
    return True

# seven wird am ende seines moves nach zone 5 verlagert
def onMoveEndSevenZone5(char_id):
    object.set_active_state(char_id,INACTIVE)
    data().sevensouls_in_zone5 = True
    
def on_timer(id):
# print "[debug on_timer()",id,"]"

    if id == data().Timer_SevenStirbt:
        if not data().Geheilt:
# print "[sevensouls stirbt jetzt!]"
            character.play_animation("MERCENARY_SEVENSOULS","CM_NPC_SIEBENSEELE_STERBEN", callback=["ONEND",Lambda('object.set_attribute("MERCENARY_SEVENSOULS","hitpoints",0)')])

    if id == data().Timer_SevenBrichtAuf:
        for wp in ROUTE_SEVEN_Z5:
            if (wp != ROUTE_SEVEN_Z5(len(ROUTE_SEVEN_Z5)-1)):
                object.move_to("MERCENARY_SEVENSOULS",wp[0],wp[1],"landscape",MT_SLOW)
            else:
                object.move_to("MERCENARY_SEVENSOULS",wp[0],wp[1],"landscape",MT_SLOW, callback=["ONEND", onMoveEndSevenZone5])

    if id == data().Timer_Untersuch:
        if not dialog.is_dialog_active():
            dialogs.initDlg_004_Siebenseele_Untersuchung()
        else:
            system.notify_timer(data().Timer_Untersuch,data().Timervalue_Untersuch)

    if id == data().Timer_DialogVerzoegern:
        if not dialog.is_dialog_active():
            dialogs.initDlg_010_Siebenseele_Gerettet()
            data().Geheilt = True
            on_wait_for_commando("MERCENARY_SEVENSOULS")
            character.change_body_mode("MERCENARY_SEVENSOULS","STAND")
        else:
            system.notify_timer(data().Timer_DialogVerzoegern,data().Timervalue_DialogVerzoegern)

## spawn animals timer
#    if (id == data().Timer_SpawnTimeChecker):
#        clock = system.get_mission_time().get_day_time()
#        if (clock >= time("06:00:00") and clock < time("22:00:00")):
#            npc.spawnAnimals(INACTIVE)
#        else:
#            npc.spawnAnimals(ACTIVE)
#        system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
    
# feinde sichten
def on_enemy_spotted(object_id):
# print "[debug: on_enemy_spotted:",object_id,"]"
    
    if not object.is_destroyed(object_id):
        if object_id in NPC_SEEKER:
            if object_id in ["SEEKER_8", "SEEKER_7"]:
                finish_activity(object_id)
                character.unequip_hands(object_id)
            object.cancel_commandos(object_id)
            prohibit_activity(object_id)
            character.arm_direct(object_id)
            enemies = character.get_visible_enemies(object_id)
            if len(enemies):
                object.attack(object_id, random.choice(enemies))

# angreifen
def on_attack(operator, target):
# print "[debug: on_attack:",operator,target,"]"
    
    if target == "HICKEY":
        if not data().hickey_angegriffen:
            data().hickey_angegriffen = True
            character.arm_direct("HICKEY")
            object.set_attribute("HICKEY","foes",['UISPIELER'])
    
    if target in ["SHUFFLE","STITCH"]:
        if not data().sunds_angegriffen:
            data().sunds_angegriffen = True
            if not object.is_destroyed("SHUFFLE"):
                object.cancel_commandos("SHUFFLE")
                character.arm_direct("SHUFFLE")
                object.set_attribute("SHUFFLE","foes",['UISPIELER'])
            
            if not object.is_destroyed("STITCH"):
                object.cancel_commandos("STITCH")
                character.arm_direct("STITCH")
                object.set_attribute("STITCH","foes",['UISPIELER'])
                
    if not object.is_destroyed(target):
        if target in NPC_SEEKER:
            on_enemy_spotted(target)

def post_lay_down_char( carrying_char_id, carried_char_id ):
    if carried_char_id == 'MERCENARY_SEVENSOULS':
        if system.get_qb_entry_state(data().QB_001)==UNCOMPLETE:
            if ((object.get_distance('ALTER_EGO', 'STITCH') <= 10) or 
                (object.get_distance('ALTER_EGO', 'SHUFFLE') <= 10)):
                data().leiche_bei_stitch_und_shuffle = True

def can_carry( char, object ) :
    if object == "MERCENARY_SEVENSOULS":
        if system.get_qb_entry_state(data().QB_001) == COMPLETE:
            return False
        return True
    return object_events.can_carry( char, object )
    
def InitChestsSafes():
    object.add_closed_lock("BUILDING_3249", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_5182", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_5183", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_5184", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_5211", "lock1", closure_type='booby-trap')

def on_attribute_change(object_id, attribute_name, new_value, old_value):
    object_events.on_attribute_change(object_id, attribute_name, new_value, old_value)
    if object_id == 'MERCENARY_SEVENSOULS' and not data().Geheilt:
        if attribute_name == 'hitpoints':
            if(new_value >= 30):
                if not dialog.is_dialog_active():
                    dialogs.initDlg_010_Siebenseele_Gerettet()
                    data().Geheilt = True
                    on_wait_for_commando("MERCENARY_SEVENSOULS")
                    character.play_animation("MERCENARY_SEVENSOULS", "CM_AUFSTEHEN_KNIEND_WAFFENLOS")
                    character.change_body_mode("MERCENARY_SEVENSOULS","STAND")
                else:
                    system.notify_timer(data().Timer_DialogVerzoegern,data().Timervalue_DialogVerzoegern)
    

def init_patch():
    if "ANIE" in system.get_npcs():
        if object.is_active("ANIE"):
            data("zone_7.zone_7").anie_folgt = True
    
#wulfs might hinder the party to leave the zone
    if object.exists("SPAWN_WOLF_1"):
        object.destroy("SPAWN_WOLF_1")
    if object.exists("SPAWN_WOLF_3"):
        object.destroy("SPAWN_WOLF_3")
    if object.exists("SPAWN_WOLF_2"):
        object.destroy("SPAWN_WOLF_2")
#emergency heal for sevensouls
    if object.exists("MERCENARY_SEVENSOULS"):
        if not data().Geheilt and object.get_attribute("MERCENARY_SEVENSOULS","hitpoints")>=30:
            data().Geheilt = True
            on_wait_for_commando("MERCENARY_SEVENSOULS")
            character.play_animation("MERCENARY_SEVENSOULS", "CM_AUFSTEHEN_KNIEND_WAFFENLOS")
            character.change_body_mode("MERCENARY_SEVENSOULS","STAND")
            character.add_experience_party(data().Exp_SiebenseeleGerettet)
            system.set_qb_entry_state(data().QB_001, IMPOSSIBLE)
            data().SiebenseeleGeheilt = 1
            data().Siebenseele_geht_zur_stadt = True
