# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
import object
import schedules
from dynamic_camera import *
import zzone_4
import enemy_script
import cs_function as cs

#*********************************************************************
#        aktuelle revison: Revision 24, 9.09.2004
#*********************************************************************

# Umlaute äöü (zum besseren speichern=)

def PlaySpeechAnimation(id):
    character.play_animation( id, "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 ) )

def on_approach( target, operator ):
    if dialog.is_dialog_active():
        return
    if schedules.Dialog(target, operator):
        return

    # vom Spieler auslösbare Dialoge mit Tyee
    if target == "TYEE":
        # Das Friedhof Quest wurde abgelehnt
        if (system.get_qb_entry_state(data().QB_001)==INACTIVE and 
            not system.get_qb_entry_state(data().QB_002) == UNCOMPLETE):
            initDlg_005_TyeeBegruesstSpieler()
        # Das Friedhof Quest ist noch nicht gelöst
        elif (system.get_qb_entry_state(data().QB_001)==INACTIVE and
            system.get_qb_entry_state(data().QB_002)==UNCOMPLETE):
            # Ian wurde gefunden
            if data().Ian_Gefunden==1:
                if data().Ian_Getoetet==0:
                    # AE spricht zum ersten mal mit Tyee, seitdem er Ian gefunden hat
                    if data().Ian_Verraten==0:
                        initCutscene_008_SpielerBerichtetIansAufenthaltsort()
                        data().Ian_Verraten=1
                    elif data().Ian_Verraten==1:
                        # AE hat Ian verraten, aber die Indianer haben ihn noch nicht umgelegt
                        if data().Ian_Indianer_Getoetet==0:
                            initDlg_009_TyeeWillIanToeten()
                        # Die Indianer haben Ian umgelegt
                        else:# data().Ian_Indianer_Getoetet==1:
                            initDlg_010_TyeeHatIanGetoetet()
                            system.set_qb_entry_state(data().QB_001,COMPLETE)
                # AE hat Ian umgelegt
                elif ((data().Ian_Getoetet==1) and (object.count_in_inventory("ALTER_EGO","ZZ4 IANS_SCALP"))):
                    initCutscene_007_SpielerBringtIansSkalp()
                else:
                    initDlg_006_TyeeFragtNachFortschritten()
            # Ian wurde nicht gefunden
            elif data().Ian_Gefunden==0:
                initDlg_006_TyeeFragtNachFortschritten()
        # Das Friedhofsquest wurde abgeschlossen
        elif system.get_qb_entry_state(data().QB_001)==COMPLETE:
            initDlg_011_TyeeIstDankbar()
        else:
            initDlg_006_TyeeFragtNachFortschritten()

    if target == "YUMA":
        # Yuma redet erst dann Englisch, wenn das Friedhof Quest abgeschlossen ist
        if system.get_qb_entry_state(data().QB_001)==COMPLETE:
            initDlg_013_YumaRedetEnglisch()
        else:
            initDlg_012_YumaRedetIndianisch()
        
    if target == "TADI":
        # InfoNPC mit 3 dynamischen Choices
        initDlg_032_TadiGibtAuskunft()

    if target == "NANTAN":
        # infoNPC mit 1 dynamischen Choice
        initDlg_033_NantanGibtAuskunft()
        
    if target == "SHAMAN":
        # infoNPC mit Standarddialog
        initDlg_034_ShamanGibtAuskunft()
        
    if target == "ANOKI":
        checkQuestItem_Necklace()
        # AE hat Anoki Quest abgelehnt
        if system.get_qb_entry_state(data().QB_003)==IMPOSSIBLE:
            initDlg_026_AnokiMagSpielerNicht()
        # AE redet zum ersten mal mit Anoki
        elif system.get_qb_entry_state(data().QB_003)==INACTIVE:
            initDlg_024_AnokiSuchtGeschenk()
        # AE hat das Quest angenommen
        elif system.get_qb_entry_state(data().QB_003)==UNCOMPLETE:
            # Abfrage ob schon ein Geschenk gefunden wurde
            if data().Anoki_Geschenk_Gefunden==1:
                initDlg_027_SpielerHatGeschenk()
            elif data().Anoki_Geschenk_Gefunden==0:
                initDlg_025_KeinGeschenkFuerAnoki()
        else:
            initDlg_026_AnokiMagSpielerNicht()

    if target == "ALESHANEE":
        # Nach dem Anoki Quest ist Aleshanee genervt, vorher hat sie nichts zu sagen
        if data().Aleshanee_Genervt==1:
            initDlg_031_AleshaneeIstGenervt()
        else:
            initDlg_030_AleshaneeHatNichtsZuSagen()
        
    if target == "IAN":
        # Wenn Ian nicht direkt beim Ritual erwischt wird, sagt er nicht viel
        if data().Ian_Ritual == 1:
            initCutscene_015_IanZelebriertRitual()
        elif data().Ian_Ritual == 2:
            initDlg_037_SpielerWillNichtMitIanReden()
        else:
            initDlg_014_IanWillNichtMitSpielerReden()
    
    if target in ["ABRAHAM","SUE_Z7","MICKEY","FJODR"]:
        if data().GoE_Tote_Ganger >=7:
            pass
        else:
            if target == "ABRAHAM":
                initDlg_129_AbrahamRedetNicht()

            if target == "SUE_Z7":
                initDlg_138_SueWillWeiter()
        
            if target == "MICKEY":
                initDlg_137_MickeyWillWeiter()
        
            if target == "FJODR":
                initDlg_139_FjodrSchweigt()
                
    if target in data().Indianer_Guards:
        initDlg_038_SpielerWillNichtMitWachenReden()

# checks if player has necklace for aleshanee
def checkQuestItem_Necklace():
    if (object.count_in_inventory("ALTER_EGO","SET_NICE_NECKLACE_CLAWS") or
        object.count_in_inventory("ALTER_EGO","SET_NICE_NECKLACE_TEETH")):
        data().Anoki_Geschenk_Gefunden = 1
    else:
        data().Anoki_Geschenk_Gefunden = 0

###############################
#Dialogmuster zum Nachgucken
#def initDlg_xxx_xxx():
#    dialog.init_dialog(type=DIALOGSMALL/LARGE)
#    dialog.add_text(text='D_XXX_T_XXX', speaker='XXXXX', follower='D_XXX_x_XXX', callback=)
#    dialog.add_choice(text='D_XXX_C_XXX_X', follower='D_XXX_x_XXX', callback=)
#    dialog.start() evtl mit check_dialog=False

#############################################################################################################################
##    Die Dialoge innerhalb der Yuma CS, die neuen Funktionen dazu sind gleich im Anhang, hinter D004, alle alten Funktionen,
##    wie gehabt am Dateiende
#############################################################################################################################

def initDlg_001_SeeYuma():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_001_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback = onDlg_001_Ende)
    data().GoE_Dialog = 1
    dialog.start()

def onDlg_001_Ende():
    Yuma_Dlg_002()

def initDlg_002_YumaFolgen():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text( text = 'D_002_T_001', speaker = 'YUMA')
    dialog.add_choice( text = 'D_002_C_001_1', follower = 'D_002_T_003')
    dialog.add_choice( text = 'D_002_C_001_2', follower = 'D_002_T_002')
    dialog.add_choice( text = 'D_002_C_001_3', follower = 'ENDDIALOG', callback= Lambda('system.set_qb_entry_state ( data().QB_001,IMPOSSIBLE ); Kampf_Yuma()'))
    dialog.add_text( text = 'D_002_T_002', speaker = 'YUMA', follower = 'D_002_C_001')
    dialog.add_text( text = 'D_002_T_003', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback=Yuma_Dlg_003)
    dialog.start()

def initCutscene_003_IndianerBringenTeamInsDorf(char_id):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text( text = 'D_003_T_001', speaker = 'ALTER_EGO', follower = 'D_003_T_002')
    dialog.add_text( text = 'D_003_T_002', speaker = 'YUMA', follower = 'D_003_T_003', callback=Ins_Dorf)
    dialog.add_text( text = 'D_003_T_003', speaker = 'ALTER_EGO', follower = 'ENDDIALOG')
    dialog.start()

def init_dialog_004_male():
    dialog.add_text( text = 'D_004_T_004', speaker = 'TYEE', follower = 'D_004_C_002')
    if object.get_attribute("ALTER_EGO", "speech") >= 85:
        dialog.add_choice( text = 'D_004_C_002_1', follower = 'D_004_T_020')
    else:
        dialog.add_choice( text = 'D_004_C_002_1', follower = 'D_004_T_010')
    dialog.add_choice( text = 'D_004_C_002_2', follower = 'D_004_T_009')
    dialog.add_choice( text = 'D_004_C_002_3', follower = 'D_004_T_008')
    dialog.add_text( text = 'D_004_T_008', speaker = 'TYEE', follower = 'ENDDIALOG', callback=Kampf_Tyee)
    dialog.add_text( text = 'D_004_T_009', speaker = 'TYEE', follower = 'D_004_C_002')
    dialog.add_text( text = 'D_004_T_010', speaker = 'TYEE', follower = 'D_004_C_003')
    dialog.add_choice( text = 'D_004_C_003_1', follower = 'D_004_T_012')
    dialog.add_choice( text = 'D_004_C_003_2', follower = 'D_004_T_011')
    dialog.add_text( text = 'D_004_T_011', speaker = 'TYEE', follower = 'ENDDIALOG', callback=Kampf_Tyee)
    dialog.add_text( text = 'D_004_T_012', speaker = 'TYEE', follower = 'D_004_C_004')
    dialog.add_choice( text = 'D_004_C_004_1', follower = 'D_004_T_014')
    dialog.add_choice( text = 'D_004_C_004_2', follower = 'D_004_T_013')
    dialog.add_text( text = 'D_004_T_013', speaker = 'TYEE', follower = 'ENDDIALOG', callback=on_dialog_004_ende2)
    dialog.add_text( text = 'D_004_T_014', speaker = 'TYEE')
    dialog.add_text( text = 'D_004_T_015', speaker = 'ALTER_EGO')
    dialog.add_text( text = 'D_004_T_016', speaker = 'TYEE', follower = 'D_004_C_005')
    dialog.add_choice( text = 'D_004_C_005_1', follower = 'D_004_T_018')
    dialog.add_choice( text = 'D_004_C_005_2', follower = 'D_004_T_017')
    dialog.add_text( text = 'D_004_T_017', speaker = 'TYEE', follower = 'ENDDIALOG', callback=on_dialog_004_ende2)
    dialog.add_text( text = 'D_004_T_018', speaker = 'TYEE', follower = 'D_004_T_019')
    dialog.add_text( text = 'D_004_T_019', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback=on_dialog_004_ende3)
    dialog.add_text( text = 'D_004_T_020', speaker = 'TYEE', follower = 'D_004_C_004')

def init_dialog_004_female():
    dialog.add_text( text = 'D_004_T_004F', speaker = 'TYEE', follower = 'D_004_C_002')
    if object.get_attribute("ALTER_EGO", "speech") >= 85:
        dialog.add_choice( text = 'D_004_C_002_1', follower = 'D_004_T_020F')
    else:
        dialog.add_choice( text = 'D_004_C_002_1', follower = 'D_004_T_010F')
    dialog.add_choice( text = 'D_004_C_002_2', follower = 'D_004_T_009F')
    dialog.add_choice( text = 'D_004_C_002_3', follower = 'D_004_T_008F')
    dialog.add_text( text = 'D_004_T_008F', speaker = 'TYEE', follower = 'ENDDIALOG', callback=Kampf_Tyee)
    dialog.add_text( text = 'D_004_T_009F', speaker = 'TYEE', follower = 'D_004_C_002')
    dialog.add_text( text = 'D_004_T_010F', speaker = 'TYEE', follower = 'D_004_C_003')
    dialog.add_choice( text = 'D_004_C_003_1', follower = 'D_004_T_012F')
    dialog.add_choice( text = 'D_004_C_003_2', follower = 'D_004_T_011F')
    dialog.add_text( text = 'D_004_T_011F', speaker = 'TYEE', follower = 'ENDDIALOG', callback=Kampf_Tyee)
    dialog.add_text( text = 'D_004_T_012F', speaker = 'TYEE', follower = 'D_004_C_004')
    dialog.add_choice( text = 'D_004_C_004_1', follower = 'D_004_T_014')
    dialog.add_choice( text = 'D_004_C_004_2', follower = 'D_004_T_013F')
    dialog.add_text( text = 'D_004_T_013F', speaker = 'TYEE', follower = 'ENDDIALOG', callback=on_dialog_004_ende2)
    dialog.add_text( text = 'D_004_T_014', speaker = 'TYEE')
    dialog.add_text( text = 'D_004_T_015', speaker = 'ALTER_EGO', follower = 'D_004_T_016F')
    dialog.add_text( text = 'D_004_T_016F', speaker = 'TYEE', follower = 'D_004_C_005')
    dialog.add_choice( text = 'D_004_C_005_1', follower = 'D_004_T_018F')
    dialog.add_choice( text = 'D_004_C_005_2', follower = 'D_004_T_017F')
    dialog.add_text( text = 'D_004_T_017F', speaker = 'TYEE', follower = 'ENDDIALOG', callback=on_dialog_004_ende2)
    dialog.add_text( text = 'D_004_T_018F', speaker = 'TYEE', follower = 'D_004_T_019')
    dialog.add_text( text = 'D_004_T_019', speaker = 'ALTER_EGO', follower = 'ENDDIALOG', callback=on_dialog_004_ende3)
    dialog.add_text( text = 'D_004_T_020F', speaker = 'TYEE', follower = 'D_004_C_004')
    
def initDlg_004_HaeuptlingHatProblem(id):
    dialog.init_dialog(type=DIALOGLARGE)
    if object.get_attribute("ALTER_EGO", "gender") == MALE:
        init_dialog_004_male()
    else:
        init_dialog_004_female()
    data().Indianer_Tt_Yuma = 1
    dialog.start(False)

def on_dialog_004_ende2():
    data().GoE_Dialog=0
    onCutsceneEnd_036_SpielerWundertSichUeberHaeuptling()

def on_dialog_004_ende3():
    if not data().player_knows_Indianer_Friedhof:
        data().player_knows_Indianer_Friedhof = True
        system.add_minimap_marker(370.57, 334.14,"MM_003")# Cimetire indien
    system.set_qb_entry_state(data().QB_001,UNCOMPLETE)
    data().GoE_Dialog=0
    onCutsceneEnd_036_SpielerWundertSichUeberHaeuptling()
    
#############################################################################################################################
##    Die Funktionen für die Yuma CS
#############################################################################################################################

def Yuma_Dlg_001() :
    ## Der Spieler hat die Region ums Indy Dorf betreten, und Yuma begegnet ihm
    #print "cam1"
    # Aufruf von Timer 1
    # system.notify_timer(data().Timer_Yuma_1,data().Timervalue_Yuma_1) # löst nichts aus
    initDlg_001_SeeYuma()
    
def Yuma_Dlg_002() :
    for id in system.get_pcs():
        object.cancel_commandos(id)
        object.turn_to_object(id,"YUMA")
    for id in data().Indianer_Patroullie_NPCs:
        if id != "INDY_GUARD_4": # data().Indianer_Patroullie_NPCs[len(data().Indianer_Patroullie_NPCs)-1]:
            object.cancel_commandos(id)
            object.turn_to_object(id,"ALTER_EGO")
        else:
            object.cancel_commandos(id)
            object.turn_to_object(id,"ALTER_EGO", callback=["ONEND",onDlg_002_EndCutscene])

def onDlg_002_EndCutscene(char_id):
    end_cutscene(chars = ['ALTER_EGO'])
    initDlg_002_YumaFolgen()

def Yuma_Dlg_003() :
    system.start_cutscene()
    for id in data().PCsNextToAE + data().Indianer_Patroullie_NPCs + ["ALTER_EGO"]:
        if data().Indianer_DOA==2:
            object.move_to(id,519.4,447.7,"landscape",MT_FAST)
        elif data().Indianer_DOA==4:
            object.move_to(id,426.7,465.9,"landscape",MT_FAST)
        elif data().Indianer_DOA==1:
            object.move_to(id,455.4,384.3,"landscape",MT_FAST)
    system.fade(FADE_OUT)
    system.notify_timer(data().Timer_MoveToVillage, data().Timervalue_MoveToVillage)

# wird vom Timer data().Timer_MoveToVillage ausgelöst
def setPostionsIndianVillage():
    #print "pcs next to ae:",data().PCsNextToAE
    # positionen setzen und danach chars bewegen
    for char_id in POS_INDICUTSCENE_VILLAGE: #.keys(): greift auch so auf die schlüssel zu
        pos = POS_INDICUTSCENE_VILLAGE[char_id][0]
        goto = POS_INDICUTSCENE_VILLAGE[char_id][1]
        if char_id != "PARTY":
            object.cancel_commandos(char_id)
            object.set_position(char_id,pos[0],pos[1])
            if char_id == "ALTER_EGO":
                object.move_to(char_id,goto[0],goto[1],"landscape",MT_FAST, callback=["ONEND",initCutscene_003_IndianerBringenTeamInsDorf])
            else:
                object.move_to(char_id,goto[0],goto[1],"landscape",MT_FAST)
        else:
            for pc_id in system.get_pcs():
                if ((pc_id != "ALTER_EGO") and (pc_id in data().PCsNextToAE)):
                    object.cancel_commandos(pc_id)
                    object.set_position(pc_id,pos[0],pos[1])
                    object.move_to(pc_id,goto[0],goto[1],"landscape",MT_FAST)
            
            if abraham_quest_z6_check():
                for goe_id in data().GoE_NPCs_in_Abrahams_Team_1:
                    if not object.is_destroyed(goe_id):
                        object.cancel_commandos(goe_id)
                        object.set_position(goe_id,pos[0],pos[1])
                        object.move_to(goe_id,goto[0],goto[1],"landscape",MT_FAST)

def abraham_quest_z6_check():
    if was_zone_entered("zone_6.zone_6"):
        if system.get_qb_entry_state(data("zone_6.zone_6").QB_020)==UNCOMPLETE:
            return True
    return False

def cs_yuma_2(xx,yy):
    counter=0
    for id in system.get_pcs():
        object.cancel_commandos(id)
        if id=="ALTER_EGO":
            if data().Indianer_DOA==2:
                object.move_to(id,xx-15,yy,grid="landscape",callback=["ONEND",Lambda('AE_Dlg_003_Tel()')])
            if data().Indianer_DOA==4:
                object.move_to(id,xx+15,yy,grid="landscape",callback=["ONEND",Lambda('AE_Dlg_003_Tel()')])
            if data().Indianer_DOA==1:
                object.move_to(id,xx,yy+15,grid="landscape",callback=["ONEND",Lambda('AE_Dlg_003_Tel()')])
        else:
            if counter==0:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-15,yy-1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+15,yy-1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx-1,yy+15,grid="landscape")
            elif counter==1:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-15,yy+1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+15,yy+1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx+1,yy+15,grid="landscape")
            elif counter==2:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-14,yy-1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+14,yy-1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx-1,yy+14,grid="landscape")
            elif counter==3:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-14,yy,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+14,yy,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx,yy+14,grid="landscape")
            elif counter==4:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-14,yy+1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+14,yy+1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx+1,yy+14,grid="landscape")
            counter=counter+1
    if abraham_quest_z6_check():
        counter=0
        for id in data().GoE_NPCs_in_Abrahams_Team_1:
            object.cancel_commandos(id)
            if counter==0:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-15,yy-1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+15,yy-1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx-1,yy+15,grid="landscape")
            elif counter==1:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-15,yy+1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+15,yy+1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx+1,yy+15,grid="landscape")
            elif counter==2:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-14,yy-1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+14,yy-1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.move_to(id,xx-1,yy+14,grid="landscape")
            if data().GoE_Fjodr_Tot==0:
                if counter==3:
                    if data().Indianer_DOA==2:
                        object.move_to(id,xx-14,yy,grid="landscape")
                    if data().Indianer_DOA==4:
                        object.move_to(id,xx+14,yy,grid="landscape")
                    if data().Indianer_DOA==1:
                        object.move_to(id,xx,yy+14,grid="landscape")
            counter=counter+1
    counter=0
    for id in data().Indianer_Patroullie_NPCs:
        object.cancel_commandos(id)
        if id=="YUMA":
            if data().Indianer_DOA==2:
                object.move_to(id,xx-14,yy,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
            if data().Indianer_DOA==4:
                object.move_to(id,xx+14,yy,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
            if data().Indianer_DOA==1:
                object.move_to(id,xx,yy+14,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
        else:
            if counter==0:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-15,yy-1,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+15,yy-1,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==1:
                    object.move_to(id,xx-1,yy+15,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
            if counter==1:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-15,yy+1,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+15,yy+1,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==1:
                    object.move_to(id,xx+1,yy+15,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
            if counter==2:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-16,yy-2,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+16,yy-2,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==1:
                    object.move_to(id,xx-2,yy+16,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
            if counter==3:
                if data().Indianer_DOA==2:
                    object.move_to(id,xx-16,yy+2,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==4:
                    object.move_to(id,xx+16,yy+2,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
                if data().Indianer_DOA==1:
                    object.move_to(id,xx+2,yy+16,grid="landscape",callback=["ONEND",Lambda('Yuma_Dlg_003_Tel(\"%s\")' %id)])
            counter=counter+1


def Yuma_Dlg_003_Tel (id) :
    # Timer 2 wird gestartet
    #print data().Indianer_Teleport, "indianer weg", id, "in arbeit"
    if id == "YUMA":
        object.cancel_commandos (id)
        TelToPosition (id, 422,475)
        data().Indianer_Teleport = data().Indianer_Teleport+1
    if id == "INDY_GUARD_1":
        object.cancel_commandos (id)
        TelToPosition (id, 423.5,475.5)
        data().Indianer_Teleport = data().Indianer_Teleport+1
    if id == "INDY_GUARD_2":
        object.cancel_commandos (id)
        TelToPosition (id, 421.5,473.5)
        data().Indianer_Teleport = data().Indianer_Teleport+1
    if id == "INDY_GUARD_3":
        object.cancel_commandos (id)
        TelToPosition (id, 425,476)
        data().Indianer_Teleport = data().Indianer_Teleport+1
    if id == "INDY_GUARD_4":
        object.cancel_commandos (id)
        TelToPosition (id, 421,472)
        data().Indianer_Teleport = data().Indianer_Teleport+1
    if data().Indianer_Teleport == 5:
        system.notify_timer(data().Timer_Yuma_2, data().Timervalue_Yuma_2)
    
def AE_Dlg_003_Tel () :
    if abraham_quest_z6_check():
        if data().GoE_Fjodr_Tot==1:
            for id in data().GoE_NPCs_in_Abrahams_Team_2:
                object.cancel_commandos ( id )
                TelToPosition (id, 424.00, 443.00)
                object.turn_to_direction (id, 45, callback = [ "ONEND", Lambda ( 'TelToPosition ( \"%s\",424,473)' %id)])
        elif data().GoE_Fjodr_Tot==0:
            for id in data().GoE_NPCs_in_Abrahams_Team_1:
                object.cancel_commandos ( id )
                TelToPosition (id, 424.00, 443.00)
                object.turn_to_direction (id, 45, callback = [ "ONEND", Lambda ( 'TelToPosition ( \"%s\",424,473)' %id)])
    for id in system.get_pcs():
        object.cancel_commandos ( id )
        TelToPosition ( id, 424.00, 443.00 )    
        object.turn_to_direction (id, 45, callback = [ "ONEND", Lambda ( 'TelToPosition ( \"%s\", 424.00, 473.00 )' % id ) ] )
    
def Ins_Dorf() :
    # system.notify_timer(data().Timer_Yuma_4, data().Timervalue_Yuma_4)
    object.move_to ( "ALTER_EGO", 450, 438, callback = ['ONEND', Ins_Dorf_])
    for id in system.get_pcs():
        if id != "ALTER_EGO":
            object.move_to(id,446.6,441.7,"landscape",MT_FAST)

    if abraham_quest_z6_check():
        if data().GoE_Fjodr_Tot==1:
            for id in data().GoE_NPCs_in_Abrahams_Team_2:
                object.move_to_object(id,"ALTER_EGO","landscape")
        elif data().GoE_Fjodr_Tot==0:
            for id in data().GoE_NPCs_in_Abrahams_Team_1:
                object.move_to_object(id,"ALTER_EGO","landscape")
    object.move_to ( "YUMA",     449.18, 440.42, "landscape")
    object.move_to ( "INDY_GUARD_1", 452.5, 441.5,     "landscape")
    object.move_to ( "INDY_GUARD_2", 447,     439,     "landscape")
    object.move_to ( "INDY_GUARD_3", 447,     437.5,     "landscape")
    object.move_to ( "INDY_GUARD_4", 447.8, 440.5,     "landscape")

def Ins_Dorf_(id):
    system.set_camera_view(CAMVIEW_TYEE_INTRO)
    zzone_4.yuma_cs_3()

def initDlg_005_TyeeBegruesstSpieler():
    dialog.init_dialog(type=DIALOGSMALL)
    if object.get_attribute("ALTER_EGO", "gender") == MALE:
        dialog.add_text(text='D_005_T_001', speaker='TYEE', follower='ENDDIALOG')
    else:
        dialog.add_text(text='D_005_T_001F', speaker='TYEE', follower='ENDDIALOG')
    dialog.start(False)
    
def initDlg_006_TyeeFragtNachFortschritten():
    dialog.init_dialog(type=DIALOGSMALL)
    if object.get_attribute("ALTER_EGO", "gender") == MALE:
        dialog.add_text(text='D_006_T_001', speaker='TYEE', follower='D_006_T_002')
    else:
        dialog.add_text(text='D_006_T_001F', speaker='TYEE', follower='D_006_T_002')
    dialog.add_text(text='D_006_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start(False)
    
def initCutscene_007_SpielerBringtIansSkalp():
    system.start_cutscene()
    pos = object.get_position("TYEE")
    object.move_to("ALTER_EGO",pos[0]+1.3,pos[1]+1.5,callback=["ONEND",onDlg_007_StartDialog])

def onDlg_007_StartDialog(char_id):
    set_conversation("ALTER_EGO","TYEE",mode="medium_deep")
    dialog.init_dialog(type=DIALOGSMALL)
    if object.get_attribute("ALTER_EGO", "gender") == MALE:
        dialog.add_text(text='D_007_T_001', speaker='ALTER_EGO', follower='D_007_T_002', callback=Lambda('set_conversation("TYEE","ALTER_EGO",mode="medium")'))
        dialog.add_text(text='D_007_T_002', speaker='TYEE', follower='D_007_T_003', callback=Lambda('set_conversation("ALTER_EGO","TYEE",mode="close")'))
        dialog.add_text(text='D_007_T_003', speaker='ALTER_EGO', follower='D_007_T_004', callback=Lambda('set_conversation("TYEE","ALTER_EGO",mode="close")'))
        dialog.add_text(text='D_007_T_004', speaker='TYEE', follower='ENDDIALOG', callback=on_dialog_007_ende)
    else:
        dialog.add_text(text='D_007_T_001', speaker='ALTER_EGO', follower='D_007_T_002F', callback=Lambda('set_conversation("TYEE","ALTER_EGO",mode="medium")'))
        dialog.add_text(text='D_007_T_002F', speaker='TYEE', follower='D_007_T_003', callback=Lambda('set_conversation("ALTER_EGO","TYEE",mode="close")'))
        dialog.add_text(text='D_007_T_003', speaker='ALTER_EGO', follower='D_007_T_004F', callback=Lambda('set_conversation("TYEE","ALTER_EGO",mode="close")'))
        dialog.add_text(text='D_007_T_004F', speaker='TYEE', follower='ENDDIALOG', callback=on_dialog_007_ende)
    dialog.start(False)

def on_dialog_007_ende():
    end_cutscene(chars=["TYEE", "ALTER_EGO"])
    system.set_qb_entry_state(data().QB_001,COMPLETE)
    system.set_qb_entry_state(data().QB_002,INACTIVE)
    system.set_qb_entry_text(data().QB_001, id_reward = "ZZONE4_AIM_01_REWARD_300" )
    character.add_experience_party(300)

def initCutscene_008_SpielerBerichtetIansAufenthaltsort():
    system.start_cutscene()
    prohibit_activity("TYEE")
    pos = object.get_position("TYEE")
    object.move_to("ALTER_EGO",pos[0]+1.3,pos[1]+1.5,callback=["ONEND",onDlg_008_StartDialog])

def onDlg_008_StartDialog(char_id):
    set_conversation("ALTER_EGO","TYEE",mode="medium_deep")
    dialog.init_dialog(type=DIALOGSMALL)

    if object.get_attribute("ALTER_EGO", "gender") == MALE:
        dialog.add_text(text='D_008_T_001', speaker='ALTER_EGO', follower='D_008_T_002', callback=Lambda('set_conversation("TYEE","ALTER_EGO",mode="close")'))
        dialog.add_text(text='D_008_T_002', speaker='TYEE', follower='ENDDIALOG', callback=on_dialog_008_ende)
    else:
        dialog.add_text(text='D_008_T_001', speaker='ALTER_EGO', follower='D_008_T_002F', callback=Lambda('set_conversation("TYEE","ALTER_EGO",mode="close")'))
        dialog.add_text(text='D_008_T_002F', speaker='TYEE', follower='ENDDIALOG', callback=on_dialog_008_ende)
    dialog.start(False)

def on_dialog_008_ende():
    allow_activity("TYEE")
    end_cutscene(chars=["TYEE", "ALTER_EGO"])
    system.set_qb_entry_state(data().QB_001,COMPLETE)
    system.set_qb_entry_state(data().QB_002,INACTIVE)
    system.set_qb_entry_text(data().QB_001, id_reward = "ZZONE4_AIM_01_REWARD" )
    character.add_experience_party(500)
    
def initDlg_009_TyeeWillIanToeten():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_009_T_001', speaker='TYEE', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_010_TyeeHatIanGetoetet():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_010_T_001', speaker='TYEE', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_011_TyeeIstDankbar():
    dialog.init_dialog(type=DIALOGSMALL)
    if object.get_attribute("ALTER_EGO","gender")==MALE:
        dialog.add_text(text='D_011_T_001', speaker='TYEE', follower='D_011_T_002')
        dialog.add_text(text='D_011_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    else:
        dialog.add_text(text='D_011_T_001F', speaker='TYEE', follower='D_011_T_002F')
        dialog.add_text(text='D_011_T_002F', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start(check_dialog=False)
    
def initDlg_012_YumaRedetIndianisch():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_012_T_001', speaker='YUMA', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_013_YumaRedetEnglisch():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_013_T_001', speaker='YUMA', follower='D_013_T_002')
    dialog.add_text(text='D_013_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_014_IanWillNichtMitSpielerReden():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_014_T_001', speaker='IAN', follower='D_014_T_002')
    dialog.add_text(text='D_014_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initCutscene_015_IanZelebriertRitual():
    system.start_cutscene()
    set_camera(CAMVIEW_IANS_RITUAL)
    object.move_to("ALTER_EGO",558.2,320.8,"landscape",MT_SLOW)
    object.turn_to_object("ALTER_EGO","IAN",callback=["ONEND",onDlg_015_StartDialog])

def onDlg_015_StartDialog(char_id):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_015_T_001', speaker='IAN', follower='D_015_T_002', callback=Lambda('prohibit_activity("IAN",False)'))#])
    dialog.add_text(text='D_015_T_002', speaker='ALTER_EGO', follower='D_015_T_003', callback=Lambda('object.turn_to_object("IAN","ALTER_EGO")'))#])
    dialog.add_text(text='D_015_T_003', speaker='IAN', follower='D_015_T_004')#, callback=Lambda('set_conversation("ALTER_EGO","IAN",mode="close")'))
    dialog.add_text(text='D_015_T_004', speaker='ALTER_EGO', follower='ENDDIALOG', callback= onDlg_015_Ende)
    data().Ian_Gefunden=1
    dialog.start()

def onDlg_015_Ende():
    system.end_cutscene()
    initDlg_016_IansSchicksalWirdEntschieden()
    
def initDlg_016_IansSchicksalWirdEntschieden():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text(text='D_016_T_001', speaker='IAN', follower='D_016_C_001')
    if cs.group_as_obj("ZZ4 IANS_RING"):
        dialog.add_choice(text='D_016_C_001_1', follower='D_016_T_002')
    dialog.add_choice(text='D_016_C_001_2', follower='D_016_T_006')
    dialog.add_choice(text='D_016_C_001_3', follower='D_016_T_004')
    dialog.add_text(text='D_016_T_002', speaker='IAN', follower='D_016_T_003')
    dialog.add_text(text='D_016_T_003', speaker='ALTER_EGO', follower='D_016_C_002')
    dialog.add_text(text='D_016_T_004', speaker='IAN', follower='D_016_T_005')
    dialog.add_text(text='D_016_T_005', speaker='ALTER_EGO', follower='D_016_C_002')
    dialog.add_choice(text='D_016_C_002_1', follower='D_016_T_006')
    dialog.add_choice(text='D_016_C_002_2', follower='D_016_T_009')
    dialog.add_choice(text='D_016_C_002_3', follower='D_016_T_011')
    dialog.add_choice(text='D_016_C_002_4', follower='D_016_T_013')
    dialog.add_text(text='D_016_T_006', speaker='IAN', follower='D_016_T_007')
    dialog.add_text(text='D_016_T_007', speaker='IAN', follower='D_016_T_008')
    # Nach 008: Kampf: Ian gegen AE
    dialog.add_text(text='D_016_T_008', speaker='ALTER_EGO', follower='ENDDIALOG', callback= onDlg_016_Ende1)
    dialog.add_text(text='D_016_T_009', speaker='IAN', follower='D_016_T_010')
    # Nach 010: Friedlich, Ian plündern =>DIALOG 017
    dialog.add_text(text='D_016_T_010', speaker='ALTER_EGO', follower='ENDDIALOG', callback= onDlg_016_Ende2)
    dialog.add_text(text='D_016_T_011', speaker='IAN', follower='D_016_T_012')
    # Nach 012: Friedlich =>DIALOG 017
    dialog.add_text(text='D_016_T_012', speaker='ALTER_EGO', follower='ENDDIALOG', callback= onDlg_016_Ende3)
    dialog.add_text(text='D_016_T_013', speaker='IAN', follower='D_016_T_014')
    # Nach 014: Friedlich =>DIALOG 018
    dialog.add_text(text='D_016_T_014', speaker='ALTER_EGO', follower='ENDDIALOG', callback= onDlg_016_Ende4)
    dialog.start(False)
## fixme: ...
# kampf
def onDlg_016_Ende1():
    object.set_attribute("IAN","foes",['UISPIELER'])
    data().Ian_Ritual = 2
    data().Ian_Getoetet = 1

#nachsatz, items, verratbar
def onDlg_016_Ende2():
    onDlg_016_Nachsatz(17)
    #data().ian_kann_verraten_werden = True

#nachsatz, verratbar
def onDlg_016_Ende3():
    onDlg_016_Nachsatz(18)
    #data().ian_kann_verraten_werden = True

#verratbar
def onDlg_016_Ende4():
    #data().ian_kann_verraten_werden = True
    data().Ian_Ritual = 2
    cs.teleport_party(455,440)
    system.set_mission_time("09:00:00")

def onDlg_016_Nachsatz(nummer):
    #print "IAN_FERTIG", str(nummer)
    ## Setzt die Unterscheidung, welcher von den beiden Dialogen, in denen AE überlegt, Ian zu verraten ausgeführt wird
    if nummer == 17:
        data().Ian_Dialogwahl=17
    else:
        data().Ian_Dialogwahl=18
    system.notify_timer(data().Timer_Ian_Dialogwahl,data().Timervalue_Ian_Dialogwahl)
    data().Ian_Ritual = 2
    
def initDlg_017_SpielerUeberlegtIanZuVerraten():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_017_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_018_SpielerWillIanVerraten():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_018_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()

#[NM] Dialog 037: Der Spieler will nicht mehr mit Ian reden
def initDlg_037_SpielerWillNichtMitIanReden():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_037_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_019_SpielerEntdecktVerwuestungen():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_019_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=Lambda('data().graves_sighted = True'))
    dialog.start()
    
def initDlg_020_SpielerUntersuchtGrab():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_020_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_020_Ende)
    dialog.start()

def onDlg_020_Ende():
    data().grave_1_examined    = True
    object.create_item_in_inventory("ALTER_EGO","SET_BROKEN_SHOVEL","ZZ4 IANS_BROKEN_SHOVEL")
    object.set_attribute("ZZ4 IANS_BROKEN_SHOVEL","generic_item",False)

def initDlg_021_SpielerUntersuchtZweitesGrab():
    dialog.init_dialog(type=DIALOGSMALL)
#    dialog.add_text(text='D_021_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_021_Ende)
    dialog.add_text(text='D_021_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_021_Ende)
    dialog.start()

def onDlg_021_Ende():
    data().grave_2_examined    = True
    object.create_item_in_inventory("ALTER_EGO","SET_RING","ZZ4 IANS_RING")
    object.set_attribute("ZZ4 IANS_RING","generic_item",False)
    if system.get_qb_entry_state(data().QB_001) == UNCOMPLETE:
        system.set_qb_entry_state(data().QB_001,INACTIVE)
        system.set_qb_entry_state(data().QB_002,UNCOMPLETE)
    if not data().player_knows_Ritualfels:
        data().player_knows_Ritualfels = True
        system.add_minimap_marker(553.49, 321.01,"MM_004")# Ritualfels
    cs.teleport_party(553,321)
    system.set_mission_time("21:59:00")

def initDlg_022_SpielerUntersuchtWeiteresGrab():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_022_T_001', speaker='ALTER_EGO', follower='D_022_T_002')
    dialog.add_text(text='D_022_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()

def initDlg_024_AnokiSuchtGeschenk():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text(text='D_024_T_001', speaker='ALTER_EGO', follower='D_024_T_002')
    dialog.add_text(text='D_024_T_002', speaker='ANOKI', follower='D_024_C_001')
    dialog.add_choice(text='D_024_C_001_1', follower='D_024_T_004')
    dialog.add_choice(text='D_024_C_001_2', follower='D_024_T_003')
    # Nach 003: Questabbruch =>DIALOG 026
    dialog.add_text(text='D_024_T_003', speaker='ANOKI', follower='ENDDIALOG', callback= Lambda('system.set_qb_entry_state(data().QB_003, IMPOSSIBLE)'))
    dialog.add_text(text='D_024_T_004', speaker='ANOKI', follower='D_024_C_002')
    dialog.add_choice(text='D_024_C_002_1', follower='D_024_T_005')
    dialog.add_choice(text='D_024_C_002_2', follower='D_024_T_007')
    dialog.add_choice(text='D_024_C_002_3', follower='D_024_T_003')
    dialog.add_text(text='D_024_T_005', speaker='ANOKI', follower='D_024_T_006')
    dialog.add_text(text='D_024_T_006', speaker='ALTER_EGO', follower='D_024_C_002')
    # Nach 007: Questannahme
    dialog.add_text(text='D_024_T_007', speaker='ANOKI', follower='ENDDIALOG', callback= Lambda('system.set_qb_entry_state(data().QB_003, UNCOMPLETE)'))
    dialog.start()
    
def initDlg_025_KeinGeschenkFuerAnoki():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_025_T_001', speaker='ANOKI', follower='D_025_T_002')
    dialog.add_text(text='D_025_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_026_AnokiMagSpielerNicht():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_026_T_001', speaker='ANOKI', follower='D_026_T_002')
    dialog.add_text(text='D_026_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_027_SpielerHatGeschenk():
    if object.count_in_inventory("ALTER_EGO","SET_NICE_NECKLACE_CLAWS"):
        object.transfer_item("ALTER_EGO","SET_NICE_NECKLACE_CLAWS","ANOKI")
    else:
        object.transfer_item("ALTER_EGO","SET_NICE_NECKLACE_TEETH","ANOKI")
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_027_T_001', speaker='ALTER_EGO', follower='D_027_T_002')
    dialog.add_text(text='D_027_T_002', speaker='ANOKI', follower='ENDDIALOG', callback= onDlg_027_Ende)
    dialog.start()

def onDlg_027_Ende():
    system.fade(FADE_OUT)
    system.notify_timer(data().Timer_AnokiUndAleshanee,data().Timervalue_AnokiUndAleshanee)
    
def initCutscene_028_AleshaneeWillAnokiNicht():
    set_conversation(first_obj = "ANOKI")
    prohibit_activity("ANOKI",False)
    prohibit_activity("ALESHANEE",False)
    pos = object.get_position("ALESHANEE")
    object.set_position("ANOKI",pos[0]+3,pos[1]+3)
    system.start_cutscene()
    system.fade(FADE_IN)
    set_conversation("ANOKI","ALESHANEE",mode="far", animate=False)
    object.move_to("ANOKI",pos[0]+1.5,pos[1]-1.0, callback=["ONEND", onDlg_028_StartDialog])

def onDlg_028_StartDialog(char_id):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_028_T_001', speaker='ANOKI', follower='D_028_T_002', callback=Lambda('set_conversation("ALESHANEE","ANOKI",mode="medium")'))
    dialog.add_text(text='D_028_T_002', speaker='ALESHANEE', follower='D_028_T_003', callback=Lambda('set_conversation("ANOKI","ALESHANEE",mode="medium")'))
    dialog.add_text(text='D_028_T_003', speaker='ANOKI', follower='D_028_T_004', callback=Lambda('set_conversation("ALESHANEE","ANOKI",mode="medium")'))
    dialog.add_text(text='D_028_T_004', speaker='ALESHANEE', follower='D_028_T_005', callback=Lambda('set_conversation("ANOKI","ALESHANEE",mode="close")'))
    dialog.add_text(text='D_028_T_005', speaker='ANOKI', follower='D_028_T_006', callback=Lambda('set_conversation("ALESHANEE","ANOKI",mode="close")'))
    dialog.add_text(text='D_028_T_006', speaker='ALESHANEE', follower='ENDDIALOG', callback= onDlg_028_Ende)
    data().Aleshanee_Genervt=1
    dialog.start()

def onDlg_028_Ende():
    allow_activity("ALESHANEE")
    set_conversation("ALESHANEE","ANOKI",mode="far",animate=False)
    object.move_to("ANOKI", 452.6,434.1, speed=MT_FAST, callback=["ONEND",onDlg_028_EndeFade])

def onDlg_028_EndeFade(char_id):
    set_conversation(first_obj = "ALTER_EGO")
    object.turn_to_object("ANOKI","BUILDING_53")
    system.fade(FADE_OUT)
    system.notify_timer(data().Timer_AnokiUndPlayer,data().Timervalue_AnokiUndPlayer)
    system.end_cutscene()

def initCutscene_029_SpielerEmpfaengtAnoki():
    pos = object.get_position("ANOKI")
    object.set_position("ALTER_EGO",pos[0]+4,pos[1]+2)
    system.start_cutscene()
    system.fade(FADE_IN)
    set_conversation("ALTER_EGO","ANOKI",mode="far", animate=False)
    object.move_to("ALTER_EGO", pos[0]+1.5,pos[1]+1.0, callback=["ONEND",onDlg_029_StartDialog])

def onDlg_029_StartDialog(char_id):
    set_conversation("ALTER_EGO","ANOKI",mode="medium")
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_029_T_001', speaker='ALTER_EGO', follower='D_029_T_002',\
        callback=Lambda('set_conversation("ANOKI","ALTER_EGO",mode="medium")'))
    dialog.add_text(text='D_029_T_002', speaker='ANOKI', follower='D_029_T_003',\
        callback=Lambda('set_conversation("ALTER_EGO","ANOKI",mode="medium")'))
    dialog.add_text(text='D_029_T_003', speaker='ALTER_EGO', follower='ENDDIALOG',\
        callback= Aleshanee_Umbenennen)
    dialog.start()
    
def Aleshanee_Umbenennen():
    system.end_cutscene()
    object.set_attribute("ALESHANEE","name",globaltext.NAME_ALESHANEE_2)
    allow_activity("ANOKI")
    system.set_qb_entry_state(data().QB_003, COMPLETE)
    character.add_experience_party(200)

def initDlg_030_AleshaneeHatNichtsZuSagen():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_030_T_001', speaker='ALESHANEE', follower='D_030_T_002')
    dialog.add_text(text='D_030_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_031_AleshaneeIstGenervt():
    dialog.init_dialog(type=DIALOGSMALL)
    # M/W Unterscheidung funktioniert
    dialog_geschlecht=0
    if object.get_attribute("ALTER_EGO","gender")=="male":
        dialog_geschlecht="D_031_T_002"
    elif object.get_attribute("ALTER_EGO","gender")=="female":
        dialog_geschlecht="D_031_T_002F"    
    dialog.add_text(text='D_031_T_001', speaker='ALESHANEE', follower=dialog_geschlecht)
    dialog.add_text(text='D_031_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.add_text(text='D_031_T_002F', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start(check_dialog=False)
    
#!!!aenderung ronny!!!
#Für die dynamischen Choices
def onDlg_032_C1_5():
    if not system.get_qb_entry_state(data().QB_001) == COMPLETE:
        if data().Tadi_C_001_5 == 1:    
            dialog.add_choice(text='D_032_C_001_5', follower='D_032_T_011',order = 4)

def onDlg_032_C1_2():
    if data().Tadi_C_001_2 == 1:    
        dialog.add_choice(text='D_032_C_001_2', follower='D_032_T_006',order = 6)

def onDlg_032_C1_4():
    if data().Tadi_C_001_4 == 1:    
        dialog.add_choice(text='D_032_C_001_4', follower='D_032_T_009',order = 5)

def initDlg_032_TadiGibtAuskunft():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text(text='D_032_T_001', speaker='ALTER_EGO', follower='D_032_T_002')
    dialog.add_text(text='D_032_T_002', speaker='TADI', follower='D_032_C_001', callback= Lambda('data().Tadi_Gesprochen = 1'))
    dialog.add_choice(text='D_032_C_001_1', follower='D_032_T_003',order = 7)
    # 2 per Default inaktiv
    if data().Tadi_C_001_2 == 1:
        dialog.add_choice(text='D_032_C_001_2', follower='D_032_T_006',order = 6)
    # 4 per Default inaktiv
    if data().Tadi_C_001_4 == 1:
        dialog.add_choice(text='D_032_C_001_4', follower='D_032_T_009',order = 4)
    # 5 nur da solange Mainquest ungelöst, per Default inaktiv
    if not system.get_qb_entry_state(data().QB_001) == COMPLETE:
        if data().Tadi_C_001_5 == 1:    
            dialog.add_choice(text='D_032_C_001_5', follower='D_032_T_011',order = 3)
    dialog.add_choice(text='D_032_C_001_6', follower='D_032_T_012',order = 2)
    dialog.add_choice(text='D_032_C_001_7', follower='D_032_T_015',order = 1)
    dialog.add_text(text='D_032_T_003', speaker='TADI', follower='D_032_T_004')
    dialog.add_text(text='D_032_T_004', speaker='ALTER_EGO', follower='D_032_T_005', callback= Lambda('data().Tadi_C_001_2=1')) # Für dyn. Choices
    # Nach 005 wird c_001_2 aktiv
    dialog.add_text(text='D_032_T_005', speaker='TADI', follower='D_032_C_001', callback=onDlg_032_C1_2) # Für dyn. Choices
    dialog.add_text(text='D_032_T_006', speaker='TADI', follower='D_032_T_007')
    dialog.add_text(text='D_032_T_007', speaker='ALTER_EGO', follower='D_032_T_008')
    dialog.add_text(text='D_032_T_008', speaker='TADI', follower='D_032_C_001')
    dialog.add_text(text='D_032_T_009', speaker='TADI', follower='D_032_C_001')
    dialog.add_text(text='D_032_T_011', speaker='TADI', follower='D_032_C_001')
    dialog.add_text(text='D_032_T_012', speaker='TADI', follower='D_032_T_013')
    dialog.add_text(text='D_032_T_013', speaker='ALTER_EGO', follower='D_032_T_014', callback= Lambda('data().Tadi_C_001_5=1')) # Für dyn. Choices
    # Nach 014 wird c_001_5 aktiv
    dialog.add_text(text='D_032_T_014', speaker='TADI', follower='D_032_C_001', callback=onDlg_032_C1_5) # Für dyn. Choices
    # Nach 015 wird mit t_016 neu gestartet
    dialog.add_text(text='D_032_T_015', speaker='TADI', follower='ENDDIALOG')
    dialog.add_text(text='D_032_T_016', speaker='TADI', follower='D_032_C_001')
    if data().Tadi_Gesprochen==1:
        dialog.jump_to(follower='D_032_T_016')
    dialog.start(check_dialog=False)

# Für dyn. Choices
def onDlg_033_C1_3():
    if data().Nantan_C_001_3 == 1:    
        dialog.add_choice(text='D_033_C_001_3', follower='D_033_T_009',order = 4)

def initDlg_033_NantanGibtAuskunft():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text(text='D_033_T_001', speaker='ALTER_EGO', follower='D_033_T_002')
    dialog.add_text(text='D_033_T_002', speaker='NANTAN', follower='D_033_C_001', callback= Lambda('data().Nantan_Gesprochen=1'))
    dialog.add_choice(text='D_033_C_001_1', follower='D_033_T_003')
    dialog.add_choice(text='D_033_C_001_2', follower='D_033_T_006')
    # 3 per Default inaktiv
    if data().Nantan_C_001_3==1:
        dialog.add_choice(text='D_033_C_001_3', follower='D_033_T_009')
    dialog.add_choice(text='D_033_C_001_4', follower='D_033_T_010')
    dialog.add_choice(text='D_033_C_001_5', follower='D_033_T_011')
    dialog.add_choice(text='D_033_C_001_6', follower='D_033_T_014')
    dialog.add_text(text='D_033_T_003', speaker='NANTAN', follower='D_033_T_004')
    dialog.add_text(text='D_033_T_004', speaker='ALTER_EGO', follower='D_033_T_005')
    dialog.add_text(text='D_033_T_005', speaker='NANTAN', follower='D_033_C_001')
    dialog.add_text(text='D_033_T_006', speaker='NANTAN', follower='D_033_T_007')
    dialog.add_text(text='D_033_T_007', speaker='ALTER_EGO', follower='D_033_T_008', callback= Lambda('data().Nantan_C_001_3=1')) # Für dyn. Choices
    # Nach 008 ist c_001_3 aktiv
    dialog.add_text(text='D_033_T_008', speaker='NANTAN', follower='D_033_C_001', callback= onDlg_033_C1_3) # Für dyn. Choices
    dialog.add_text(text='D_033_T_009', speaker='NANTAN', follower='D_033_C_001')
    dialog.add_text(text='D_033_T_010', speaker='NANTAN', follower='D_033_C_001')
    dialog.add_text(text='D_033_T_011', speaker='NANTAN', follower='D_033_T_012')
    dialog.add_text(text='D_033_T_012', speaker='ALTER_EGO', follower='D_033_T_013')
    dialog.add_text(text='D_033_T_013', speaker='NANTAN', follower='D_033_C_001')
    # Nach 014 wird mit t_015 neu gestartet
    dialog.add_text(text='D_033_T_014', speaker='NANTAN', follower='ENDDIALOG')
    dialog.add_text(text='D_033_T_015', speaker='NANTAN', follower='D_033_C_001')
    if data().Tadi_Gesprochen==1:
        dialog.jump_to(follower='D_033_T_015')
    dialog.start(check_dialog=False)
    
def initDlg_034_ShamanGibtAuskunft():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text(text='D_034_T_001', speaker='ALTER_EGO', follower='D_034_T_002')
    dialog.add_text(text='D_034_T_002', speaker='SHAMAN', follower='D_034_C_001', callback=Lambda('data().Shaman_Gesprochen=1'))
    dialog.add_choice(text='D_034_C_001_1', order=7, follower='D_034_T_003')
    dialog.add_choice(text='D_034_C_001_2', order=6, follower='D_034_T_006')
    dialog.add_choice(text='D_034_C_001_3', order=5, follower='D_034_T_011')
    dialog.add_choice(text='D_034_C_001_7', order=1, follower='D_034_T_009')
    dialog.add_text(text='D_034_T_003', speaker='SHAMAN', follower='D_034_T_004')
    dialog.add_text(text='D_034_T_004', speaker='ALTER_EGO', follower='D_034_T_005')
    dialog.add_text(text='D_034_T_005', speaker='SHAMAN', follower='D_034_C_001')
    dialog.add_text(text='D_034_T_006', speaker='SHAMAN', follower='D_034_T_007')
    dialog.add_text(text='D_034_T_007', speaker='ALTER_EGO', follower='D_034_T_008')
    dialog.add_text(text='D_034_T_008', speaker='SHAMAN', follower='D_034_C_001')
    # Nach 009 wird mit t_010 neu gestartet
    dialog.add_text(text='D_034_T_009', speaker='SHAMAN', follower='ENDDIALOG')
    dialog.add_text(text='D_034_T_010', speaker='SHAMAN', follower='D_034_C_001')
    dialog.add_text(text='D_034_T_011', speaker='SHAMAN')
    dialog.add_text(text='D_034_T_012', speaker='SHAMAN', follower='D_034_C_001',\
        callback=on_dialog_034_add_new_choices)
    dialog.add_text(text='D_034_T_013', speaker='SHAMAN')
    dialog.add_text(text='D_034_T_014', speaker='SHAMAN', follower='D_034_C_001')
    dialog.add_text(text='D_034_T_015', speaker='SHAMAN')
    dialog.add_text(text='D_034_T_016', speaker='SHAMAN', follower='D_034_C_001')
    dialog.add_text(text='D_034_T_017', speaker='SHAMAN')
    dialog.add_text(text='D_034_T_018', speaker='SHAMAN')
    dialog.add_text(text='D_034_T_019', speaker='SHAMAN', follower='D_034_C_001')
    if data().Shaman_Gesprochen==1:
        dialog.jump_to(follower='D_034_T_010')
    dialog.start(check_dialog=False)

def on_dialog_034_add_new_choices():
    dialog.add_choice(text='D_034_C_001_4', order=4, follower='D_034_T_013')
    dialog.add_choice(text='D_034_C_001_5', order=3, follower='D_034_T_015')
    dialog.add_choice(text='D_034_C_001_6', order=2, follower='D_034_T_017')

def initDlg_Comment(pc,dlg):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text=dlg, speaker=pc, follower='ENDDIALOG')
    dialog.start()
    
def initCutscene_036_SpielerWundertSichUeberHaeuptling():
    system.set_camera_view (CAMVIEW_TYEE_BEGRUESSUNG)
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text( text = 'D_036_T_004', speaker = 'ALTER_EGO', follower = 'ENDDIALOG')
    dialog.start()

def onCutscene_036_SpielerWundertSichUeberHaeuptling():
    prohibit_activity('TYEE', step_away = True)
    object.set_position('TYEE', 460.44, 435.95)
    object.move_to('TYEE', 450.87, 438.29,\
        callback = ["ONEND", onCutscene_036_SpielerWundertSichUeberHaeuptling_1])
    
def onCutscene_036_SpielerWundertSichUeberHaeuptling_1(id):
    zzone_4.yuma_cs_3_()

def onCutsceneEnd_036_SpielerWundertSichUeberHaeuptling():
    for indian_id in data().Indianer_Patroullie_NPCs + ["TYEE"]:
        #print ">>> allowactivity for",indian_id
        allow_activity(indian_id)
        
def initCutscene_140_SueIstVergiftet():
    system.start_cutscene()
    set_conversation("SUE_Z7", cam_x=5, cam_y=5, mode="medium")
    x,y,z = object.get_position("SUE_Z7")
    illsue_dialog_one()
    object.move_to("MICKEY", x+1.4,y+1.4, callback=["ONEND", illsue_check_dialog_start])
    object.move_to("FJODR", x-1.4,y+1.4, callback=["ONEND", illsue_check_dialog_start])
    object.move_to("ALTER_EGO", x-1.4,y-1.4, callback=["ONEND", illsue_check_dialog_start])
    object.move_to("ABRAHAM", x+1.4,y-1.4, callback=["ONEND", illsue_check_dialog_start])

    for id in system.get_pcs():
        if id != "ALTER_EGO":
            enemy_script.evacuate( [id], object.get_position('SUE_Z7'), 2, callbackgroup=Lambda('object.turn_to_object("%s", "SUE_Z7"'%(id)))

def illsue_check_dialog_start(char):
    if not hasattr(data(), "illsue_count_arrived"):
        data().illsue_count_arrived = 0
    object.turn_to_object(char, "SUE_Z7")
    data().illsue_count_arrived += 1
    if data().illsue_count_arrived == 4:
        onCutscene_140_SueIstVergiftet()

def illsue_dialog_one():
    #start_cutscene()
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_140_T_001', speaker='SUE_Z7', follower='ENDDIALOG')
    dialog.start()

def onCutscene_140_SueIstVergiftet():
    object.cancel_commandos('SUE_Z7')
    character.unequip_hands("SUE_Z7")
    data().Sue_Leiden = True
    onCutscene_140_SueIstVergiftet_1_2()

def onCutscene_140_SueIstVergiftet_1_2():
    set_conversation('ABRAHAM', 'SUE_Z7', mode = 'medium', first_obj = 'ABRAHAM')
    cam_abraham = 'set_conversation("ABRAHAM", "SUE_Z7", mode = "close", first_obj = "ABRAHAM")'
    cam_Sue_Z7 = 'set_conversation("SUE_Z7", "ABRAHAM", mode = "close", first_obj = "SUE_Z7")'
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_140_T_002', speaker='ABRAHAM', follower='D_140_T_003', callback = Lambda(cam_Sue_Z7))
    dialog.add_text(text='D_140_T_003', speaker='SUE_Z7', follower='D_140_T_004', callback = Lambda(cam_abraham))
    dialog.add_text(text='D_140_T_004', speaker='ABRAHAM', follower='ENDDIALOG', callback = onEndCutscene_140_SueIstVergiftet_2)
    dialog.start()

def onEndCutscene_140_SueIstVergiftet_2(id):
    end_cutscene(chars = ['SUE_Z7', 'ABRAHAM'])
    onDlg_118_SueIstVergiftet(), 

def onDlg_118_SueIstVergiftet():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.add_text(text='D_140_T_005', speaker='SUE_Z7', follower='D_118_C_001_1')
    dialog.add_choice(text='D_118_C_001_1', follower='D_118_T_005')
    dialog.add_choice(text='D_118_C_001_2', follower='D_118_T_006')
    dialog.add_choice(text='D_118_C_001_3', follower='D_118_T_008')
    dialog.add_text(text='D_118_T_005', speaker='SUE_Z7', follower='D_118_C_001')
    dialog.add_text(text='D_118_T_006', speaker='SUE_Z7', follower='D_118_T_007')
    dialog.add_text(text='D_118_T_007', speaker='ABRAHAM', follower='D_118_C_001')
    dialog.add_text(text='D_118_T_008', speaker='SUE_Z7', follower='D_118_T_009')
    dialog.add_text(text='D_118_T_009', speaker='ALTER_EGO', follower='ENDDIALOG', callback= onDlg_118_FjodrGreiftAn)
    dialog.start()
    data().Sue_Leiden = False # todo stelle überprüfen ob sue vielleicht an einer anderen stelle wieder aufstehen soll

def onDlg_118_FjodrGreiftAn():
    set_cutscene_with_camera_position('FJODR', 4, 4, mode = 'far')
    for id in system.get_pcs() + data().GoE_NPCs_in_Abrahams_Team_1:
        if not object.is_destroyed(id) and id != "FJODR":
            object.cancel_commandos(id)
            object.turn_to_object(id,"FJODR")
    data().GoE_Gift_Dialog_Vorbei=1
    data().GoE_Kampf=1
    object.cancel_commandos("FJODR")
    pos = [object.get_x("FJODR"),object.get_y("FJODR")]
    object.set_attribute("FJODR","foes", ['UISPIELER'])
    object.turn_to_object("FJODR",random.choice(system.get_pcs()))
    for id in system.get_pcs() + data().GoE_NPCs_in_Abrahams_Team_1:
        if not object.is_destroyed(id) and id != "FJODR": 
            object.turn_to_position(id,pos[0],pos[1])

#[NM/CS] Dialog 119: Fjodr war wirklich der Täter
def initCutscene_119_FjodrWars():
    for id in ["ALTER_EGO","SUE_Z7","ABRAHAM","MICKEY"]:
        if not object.is_destroyed(id):
            if id != "ALTER_EGO":
                object.turn_to_object(id,"FJODR")
            else:
                object.turn_to_object(id,"FJODR",callback=["ONEND",onDlg_119_StartDialog])

def onDlg_119_StartDialog(char_id):
    dialog.init_dialog(type=DIALOGSMALL)
    set_conversation("SUE_Z7","ALTER_EGO",mode="medium")
    dialog.add_text(text='D_119_T_001', speaker='SUE_Z7', follower='D_119_T_002', callback=Lambda('set_conversation("ALTER_EGO","SUE_Z7",mode="medium")'))
    dialog.add_text(text='D_119_T_002', speaker='ALTER_EGO', follower='D_119_T_003', callback=Lambda('set_conversation("ABRAHAM","ALTER_EGO",mode="close")'))
    dialog.add_text(text='D_119_T_003', speaker='ABRAHAM', follower='D_119_T_004', callback=Lambda('set_conversation("SUE_Z7","ALTER_EGO",mode="close")'))
    dialog.add_text(text='D_119_T_004', speaker='SUE_Z7', follower='ENDDIALOG', callback=[ onDlg_119_StartDialog_1 ])
    dialog.start()

def onDlg_119_StartDialog_1():
    end_cutscene(chars = ['SUE_Z7', 'ABRAHAM'])
    data().GoE_Dialog=0
    for id in ["SUE_Z7","ABRAHAM","MICKEY"]:
        if not object.is_destroyed(id):
            allow_activity(id)
    

#[NM/CS] Dialog 120: Der Talzugang ist von Bären umlagert
def initCutscene_120_BaerenAmTalZugang():
    system.start_cutscene()
    for id in data().GoE_NPCs_in_Abrahams_Team_2:
        object.cancel_commandos(id)
        set_activity(id, WORK_FORBIDDEN)
    system.set_camera_view(CAMVIEW_GOE_BAEREN_2)
    npc.baerenGoE(0)
    data().PCsNextToAE = []
    for id in system.get_pcs():
        if not id == "ALTER_EGO":
            if object.get_distance(id,"ALTER_EGO") <= 15.0:
                data().PCsNextToAE.append(id)
    for id in data().PCsNextToAE + data().GoE_NPCs_in_Abrahams_Team_2 + ["ALTER_EGO"]:
        object.cancel_commandos(id)
        object.set_position(id,682,442)
    
    for char_id in POS_CUTSCENE_BAEREN_1.keys():
        pos = POS_CUTSCENE_BAEREN_1[char_id]
        if char_id == "GOE":
            for id in data().GoE_NPCs_in_Abrahams_Team_2:
                if not object.is_destroyed(id):
                    if id == "ABRAHAM":
                        object.move_to(id, pos[0]+1,pos[1],"landscape",MT_FAST, callback=["ONEND", onDlg_120_StartDialog])
                    else:
                        object.move_to(id, pos[0]-1,pos[1]+1,"landscape",MT_FAST, callback=["ONEND", Lambda('object.turn_to_object("%s", "ALTER_EGO")'%(id))])
        elif char_id == "PARTY":
            for id in data().PCsNextToAE:
                if not object.is_destroyed(id):
                    object.move_to(id, pos[0],pos[1],"landscape",MT_FAST, callback=["ONEND", Lambda('object.turn_to_object("%s", "ALTER_EGO")'%(id))])
    object.cancel_commandos("ALTER_EGO")
    object.move_to("ALTER_EGO", pos[0],pos[1],"landscape",MT_FAST, callback=["ONEND", Lambda('object.turn_to_object("ALTER_EGO", "ABRAHAM")')])

def onDlg_120_StartDialog(char_id):
    object.turn_to_object(char_id, "ALTER_EGO")
    set_conversation(char_id, "ALTER_EGO", mode="medium", new_camera=False)
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_120_T_001', speaker='ABRAHAM', follower='D_120_T_002')
    dialog.add_text(text='D_120_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_120_Ende)
    dialog.start()

def onDlg_120_Ende():
    end_cutscene(chars=["ABRAHAM", "ALTER_EGO"])
    npc.baerenGoE(1)
    data().GoE_Dialog=0
    

#[NM/CS] Dialog 121: Abrahams Paradies wird enthüllt
def initCutscene_121_AbrahamsParadiesWirdEnthuellt():
    #for id in data().GoE_NPCs_in_Abrahams_Team_2:
    #    object.cancel_commandos(id)
    #    set_activity(id, WORK_FORBIDDEN)
    x,y,z = object.get_position("ABRAHAM")
    object.cancel_commandos("ALTER_EGO")
    object.set_position("ALTER_EGO", x-6,y-10)
    system.start_cutscene()
    set_conversation("ABRAHAM",cam_x=2.6, cam_y=-3, mode="medium")
    pos = object.get_position("ABRAHAM")
    object.cancel_commandos("ALTER_EGO")
    init_cutscene("ALTER_EGO", "ABRAHAM", dx=1.3, dy=-1.5)
    object.turn_to_object("ALTER_EGO", "ABRAHAM", callback=["ONEND",onDlg_121_StartDialog])
    object.turn_to_object("ABRAHAM", "ALTER_EGO")
    object.move_to("SUE_Z7",pos[0]+1.4,pos[1]+1.5, callback=["ONEND", Lambda('object.turn_to_object("SUE_Z7", "ABRAHAM")')])
    object.move_to("MICKEY",pos[0]-1.4,pos[1]+1.5, callback=["ONEND", Lambda('object.turn_to_object("MICKEY", "ABRAHAM")')])

def onDlg_121_StartDialog(char_id):
    set_conversation("ABRAHAM","ALTER_EGO", mode="medium", new_camera=False)
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_121_T_001', speaker='ABRAHAM', follower='D_121_T_002', callback=Lambda('set_conversation("ALTER_EGO",cam_x=-2.6, cam_y=3, mode="medium"); set_conversation("ALTER_EGO","ABRAHAM",mode="close", new_camera=False)'))
    dialog.add_text(text='D_121_T_002', speaker='ALTER_EGO', follower='D_121_T_003', callback=Lambda('set_conversation("ABRAHAM",cam_x=2.6, cam_y=-3, mode="medium"); set_conversation("ABRAHAM","ALTER_EGO",mode="close", new_camera=False)'))
    dialog.add_text(text='D_121_T_003', speaker='ABRAHAM', follower='ENDDIALOG', callback=initCutscene_122_GruppeIstSkeptisch)
    dialog.start()

#[NM/CS] Dialog 122: Die Gruppe ist skeptisch wegen Abrahams Paradies 
def initCutscene_122_GruppeIstSkeptisch():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_122_T_001', speaker='ABRAHAM', follower='D_122_T_002', callback=Lambda('set_conversation("SUE_Z7",cam_x=-2.5, cam_y=-3, mode="medium"); set_conversation("SUE_Z7","ALTER_EGO",mode="medium", new_camera=False)'))
    dialog.add_text(text='D_122_T_002', speaker='SUE_Z7', follower='D_122_T_003', callback=Lambda('set_conversation("ALTER_EGO",cam_x=-2.6, cam_y=3, mode="medium"); set_conversation("ALTER_EGO","SUE_Z7",mode="close_deep", new_camera=False)'))
    
    ## todo: prospekt anzeigen
    dialog.add_text(text='D_122_T_003', speaker='ALTER_EGO', follower='ENDDIALOG', callback=gardeneden_bears_end)
    dialog.start()

def gardeneden_bears_end():
    end_cutscene(chars=["SUE_Z7", "ABRAHAM", "ALTER_EGO"])
    data().GoE_Dialog=0
    for id in data().GoE_NPCs_in_Abrahams_Team_2:
        allow_activity(id)

#[NM/CS] Dialog 123: Sue und Mickey sind enttäuscht
def initCutscene_123_SueUndMickyEnttaeuscht():
    system.start_cutscene()
    set_camera(CAMVIEW_GOE_ENTTAEUSCHUNG_INTRO)
    for id in data().GoE_NPCs_in_Abrahams_Team_2:
        object.cancel_commandos(id)
        set_activity(id, WORK_FORBIDDEN)
        if id == "SUE_Z7":
            object.set_position("SUE_Z7",775,358)
        elif id == "MICKEY":
            object.set_position("MICKEY",777,358)
        elif id == "ABRAHAM":
            object.set_position("ABRAHAM",777,360)
    
    object.cancel_commandos("ALTER_EGO")
    object.set_position("ALTER_EGO",775,360)
    
    object.move_to("SUE_Z7", 788.5,329.9, "landscape",MT_FAST, callback=["ONEND",gardeneden_check_arrived])
    object.move_to("MICKEY", 787.5,329.5, "landscape",MT_FAST, callback=["ONEND",gardeneden_check_arrived])
    object.move_to("ABRAHAM", 787.5,331.0, "landscape",MT_FAST, callback=["ONEND",gardeneden_check_arrived])
    object.move_to("ALTER_EGO", 786.0,329.5, "landscape",MT_FAST, callback=["ONEND", onDlg_123_NewCameraPos])
    
    for pc in system.get_pcs():
        if pc != "ALTER_EGO":
            if object.get_distance(pc,"ALTER_EGO") <= 15.0:
                #print "[pc moved to ae: ",pc,"]"
                object.move_to(pc,786.9,324.1,"landscape",MT_FAST)

def gardeneden_check_arrived(char):
    if not hasattr(data(), "gardeneden_at_garden_arrived_counter"):
        data().gardeneden_at_garden_arrived_counter = 0
    data().gardeneden_at_garden_arrived_counter += 1
    if char != "ABRAHAM":
        object.turn_to_object(char, "ABRAHAM")
    if data().gardeneden_at_garden_arrived_counter == 3:
        onDlg_123_StartDialog(char)

def onDlg_123_NewCameraPos(char_id):
    set_camera(CAMVIEW_GOE_ENTTAUESCHUNG_2)

def onDlg_123_StartDialog(char_id):
    set_conversation("SUE_Z7", cam_x=4, cam_y=4, mode="medium")
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_123_T_001', speaker='SUE_Z7', follower='D_123_T_002', callback=Lambda('set_conversation("MICKEY", "ABRAHAM", mode="medium_deep", first_obj="MICKEY")'))
    dialog.add_text(text='D_123_T_002', speaker='MICKEY', follower='D_123_T_003', callback=Lambda('set_conversation("ABRAHAM", "MICKEY", mode="medium_deep")'))
    dialog.add_text(text='D_123_T_003', speaker='ABRAHAM', follower='ENDDIALOG', callback=Lambda('GoEGangActivate(); initCutscene_124_GangleaderSauer()'))
    dialog.start()

#[NM/CS] Dialog 124: Der Gangleader ist völlig aufgebracht
def initCutscene_124_GangleaderSauer():
    object.cancel_commandos("MICKEY")
    object.cancel_commandos("ABRAHAM")
    object.cancel_commandos("SUE_Z7")
    # fixme: positions and camera
    set_camera(CAMVIEW_GOE_GANGANGRIFF_INTRO)
    
    object.move_to("GANGLEADER",788,334,"landscape",MT_FAST, callback=["ONEND", onDlg_124_StartDialog])
    object.move_to("GANG_M_01",789,336,"landscape",MT_FAST)
    object.move_to("GANG_M_02",787,335,"landscape",MT_FAST)
    object.move_to("GANG_M_03",786,337,"landscape",MT_FAST)
    object.move_to("GANG_M_04",788,337,"landscape",MT_FAST)
    object.move_to("GANG_M_05",787,337,"landscape",MT_FAST)
    object.move_to("GANG_F_01",787,338,"landscape",MT_FAST)

def onDlg_124_StartDialog(char_id):
    set_camera(CAMVIEW_GOE_ENTTAEUSCHUNG_3)
    for id in (system.get_pcs()+data().GoE_NPCs_in_Abrahams_Team_2):
        object.turn_to_object(id,"GANGLEADER")
    set_conversation("GANGLEADER", cam_x=4, cam_y=4, mode="medium")
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_124_T_001', speaker='GANGLEADER', follower='D_124_T_002', callback=Lambda('set_conversation("ABRAHAM", "GANGLEADER", mode="medium_deep", first_obj="GANGLEADER")'))
    dialog.add_text(text='D_124_T_002', speaker='ABRAHAM', follower='D_124_T_003', callback=Lambda('set_conversation("GANGLEADER", "ABRAHAM", mode="medium_deep", first_obj="GANGLEADER")'))
    dialog.add_text(text='D_124_T_003', speaker='GANGLEADER', follower='D_124_T_004', callback=Lambda('set_conversation("ABRAHAM", "GANGLEADER", mode="close_deep", first_obj="GANGLEADER")'))
    # Nach 004 Kampf: AE+Abraham&Co gegen Gang
    dialog.add_text(text='D_124_T_004', speaker='ABRAHAM', follower='ENDDIALOG', callback=Lambda('data().GoE_Kampf=1; GoEGangKampf(); data().GoE_Dialog=0'))
    dialog.start()
    
def initDlg_125_SueNachNorden():
    set_goes_no_longer_following()
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_125_T_001', speaker='SUE_Z7', follower='D_125_T_002')
    dialog.add_text(text='D_125_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_125_SueMoveNorth)
    dialog.start()

def on_abraham_quest_ende_check_qb():
    if was_zone_entered("zone_6.zone_6"):
        if not (system.get_qb_entry_state(data("zone_6.zone_6").QB_020) == IMPOSSIBLE):
            system.set_qb_entry_state(data("zone_6.zone_6").QB_020, COMPLETE)

def onDlg_125_SueMoveNorth():
    on_abraham_quest_ende_check_qb()
    for wp in WAYPOINTS_SUE_NORDEN:
        if wp == WAYPOINTS_SUE_NORDEN[len(WAYPOINTS_SUE_NORDEN)-1]:
            object.move_to("SUE_Z7",wp[0],wp[1], callback=["ONEND",deactivate])
        else:
            object.move_to("SUE_Z7",wp[0],wp[1])

def deactivate(char_id):
    object.set_active_state(char_id,INACTIVE)

def initDlg_126_MickeyNachNorden():
    on_abraham_quest_ende_check_qb()
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_126_T_001', speaker='MICKEY', follower='D_126_T_002')
    dialog.add_text(text='D_126_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_abraham_quest_ende)
    dialog.start()

def initDlg_127_SueUndMickeyNachNorden():
    #Beide leben
    set_goes_no_longer_following()
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_127_T_001', speaker='SUE_Z7', follower='D_127_T_002')
    dialog.add_text(text='D_127_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_127_SueMickeyMoveNorth)
    dialog.start()

def onDlg_127_SueMickeyMoveNorth():
    on_abraham_quest_ende_check_qb()
    for wp in WAYPOINTS_SUE_NORDEN:
        if wp == WAYPOINTS_SUE_NORDEN[len(WAYPOINTS_SUE_NORDEN)-1]:
            object.move_to("SUE_Z7",wp[0],wp[1], callback=["ONEND",deactivate])
            object.move_to("MICKEY",wp[0],wp[1], callback=["ONEND",deactivate])
        else:
            object.move_to("SUE_Z7",wp[0],wp[1])
            object.move_to("MICKEY",wp[0],wp[1])
    
def initDlg_128_AlleUmgekommen():
    set_goes_no_longer_following()
    on_abraham_quest_ende_check_qb()
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_128_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()

def initDlg_129_AbrahamRedetNicht():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_129_T_001', speaker='ABRAHAM', follower='ENDDIALOG')
    dialog.start()

def initDlg_130_SpielerSollNachNorden():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_130_T_001', speaker='ABRAHAM', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_131_SpielerSollNachOsten():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_131_T_001', speaker='ABRAHAM', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_132_SpielerSollNachSueden():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_132_T_001', speaker='ABRAHAM', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_133_SpielerSollNachWesten():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_133_T_001', speaker='ABRAHAM', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_134_AbrahamMachtSchluss():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_134_T_001', speaker='ABRAHAM', follower='ENDDIALOG', callback=on_abraham_quest_ende)
    dialog.start()
    
def initDlg_135_AbrahamGibtWegenMickeyAuf():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_135_T_001', speaker='ABRAHAM', follower='D_135_T_002')
    dialog.add_text(text='D_135_T_002', speaker='ABRAHAM', follower='ENDDIALOG', callback=on_abraham_quest_ende)
    dialog.start()

def on_abraham_quest_ende():
    if was_zone_entered("zone_6.zone_6"):
        if not system.get_qb_entry_state(data("zone_6.zone_6").QB_020) == COMPLETE:
            system.set_qb_entry_state(data("zone_6.zone_6").QB_020, IMPOSSIBLE)
        for id in data().GoE_NPCs_in_Abrahams_Team_1:
            if not object.is_destroyed(id):
                object.set_attribute(id,"zone_transfer",False)
                object.cancel_commandos(id)
                object.move_to(id, 458,211, callback=["ONEND", Lambda('object.set_active_state("%s",0)' %(id))])

def set_goes_no_longer_following():
    for id in data().GoE_NPCs_in_Abrahams_Team_1:
        if not object.is_destroyed(id):
            object.set_attribute(id,"zone_transfer",False)
    
def initDlg_136_AbrahamGibtWegenSueAuf():
    if not object.is_destroyed('ABRAHAM'):
        dialog.init_dialog(type=DIALOGSMALL)
        dialog.add_text(text='D_136_T_001', speaker='ABRAHAM', follower='D_136_T_002')
        dialog.add_text(text='D_136_T_002', speaker='ABRAHAM', follower='ENDDIALOG', callback=on_abraham_quest_ende)
        dialog.start()
    else:
        on_abraham_quest_ende()
    
def initDlg_137_MickeyWillWeiter():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_137_T_001', speaker='MICKEY', follower='ENDDIALOG')
    dialog.start()
    
def initDlg_138_SueWillWeiter():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_138_T_001', speaker='SUE_Z7', follower='ENDDIALOG')
    dialog.start()

def initDlg_139_FjodrSchweigt():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_139_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()

####################################################################
####################################################################
########### Ab hier keine Dialoge sondern Funktionen ###############
####################################################################
####################################################################


#############################################################################################################################
## Ankommen am Indy Dorf -- wird ab heute neu überarbeitet =) 28.01.04-Heiko ################################################
#############################################################################################################################
def TelToPosition(id,x,y):
# Alternative zu SetPosition. Der Spieler und Yuma werden zum Dorfeingang teleportiert
    object.set_position(id,x,y)
    if id == "YUMA":
        object.turn_to_object("YUMA", "TYEE")
    elif id == "ALTER_EGO":
        object.turn_to_object("ALTER_EGO", "TYEE")
    else: 
        object.turn_to_object(id,"ALTER_EGO")
#############################################################################################################################
## Ankommen am Indy Dorf -- wird ab heute neu überarbeitet =) 28.01.04-Heiko ################################################
#############################################################################################################################

def GoEGangKampf():
    ## Das Ende der letzten GoE CS, in der Abraham vom Gangleader erschossen wird, danach beginnt der Kampf
    object.turn_to_object("GANGLEADER","ABRAHAM")
    #scenecam_nd("ABRAHAM","GANGLEADER", 2, 6)
    ## fixme: richtiges erschiessen
    object.set_immortal_state('ABRAHAM', False)
    character.arm_direct("GANGLEADER")
    object.attack("GANGLEADER", "ABRAHAM")
    enemy_script.delay(5.0, Lambda('object.destroy("ABRAHAM")'))
    object.set_attribute('ABRAHAM',"zone_transfer",False)
    system.end_cutscene()
    for id in data().GoE_NPCs_in_Abrahams_Team_1:
        if not object.is_destroyed(id):
            object.set_attribute(id,"zone_transfer",False)
    
    for id in data().GoE_Gang:
        object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_2)

def GoEGangActivate():
    ## Die Gang am GoE wird aktiviert
    for id in data().GoE_Gang:
        object.set_active_state(id,ACTIVE)

def Kampf_Yuma():
    #print ">>> kampf yuma"
    ##    Kampf mit Yuma, nach dem Dialog beim Überschreiten der Region
    data().GoE_Dialog=0
    data().Talked_To_Yuma=0
    for id in data().Indianer_Patroullie_NPCs:
        allow_activity(id)
        if abraham_quest_z6_check():
            if data().GoE_Fjodr_Tot == 1:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_2)
            elif data().GoE_Fjodr_Tot == 0:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_1)
        else:
            object.set_attribute(id,"foes",['UISPIELER'])
    for id in data().Indianer_Kampf_NPCs:
        if abraham_quest_z6_check():
            if data().GoE_Fjodr_Tot == 1:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_2)
            elif data().GoE_Fjodr_Tot == 0:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_1)
        else:
            object.set_attribute(id,"foes",['UISPIELER'])
        
        #if (object.get_inventory(id)[0][0][0]) in ["SET_BROWNING_B_SS_DOUBLE_BARREL", "SET_REMINGTON_M870"]:
        #    print id, object.get_inventory(id)[0][0][0]
        #    character.equip(id,object.get_inventory(id)[0][0][0])
        character.arm_direct(id)
    Flucht_Indianer()

def Kampf_Tyee():
    #print ">>> kampf tyee"
    onCutsceneEnd_036_SpielerWundertSichUeberHaeuptling() # um alle indianer wieder ins leben zu rufen (Tagesablauf)
    ##    Kampf mit allen Indianern, sobald der Tyee Dialog vom Spieler total versiebt wurde
    data().GoE_Dialog=0
    data().Talked_To_Yuma=0
    Flucht_Indianer()
    for id in data().Indianer_Patroullie_NPCs:
        if abraham_quest_z6_check():
            if data().GoE_Fjodr_Tot == 1:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_2)
            elif data().GoE_Fjodr_Tot == 0:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_1)
        else:
            object.set_attribute(id,"foes",['UISPIELER'])
    for id in data().Indianer_Kampf_NPCs:
        if abraham_quest_z6_check():
            if data().GoE_Fjodr_Tot == 1:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_2)
            elif data().GoE_Fjodr_Tot == 0:
                object.set_attribute(id,"foes",['UISPIELER']+data().GoE_NPCs_in_Abrahams_Team_1)
        else:
            object.set_attribute(id,"foes",['UISPIELER'])
        object.step_away(id)
        character.arm_direct(id)
        #if (object.get_inventory(id)[0][0][0]) in ["SET_BROWNING_B_SS_DOUBLE_BARREL", "SET_REMINGTON_M870"]:
        #    print id, object.get_inventory(id)[0][0][0]
        #    character.equip(id,object.get_inventory(id)[0][0][0])
        if id == "TYEE":
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "AVONACO":
            object.move_to(id,456,438)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "HEVATANEO":
            object.move_to(id,447,435)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "NAALNISH":
            object.move_to(id,448,440)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "TADI":
            object.move_to(id,451,439)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "SHAMAN":
            object.move_to(id,451,437)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "YANA":
            object.move_to(id,447,436)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "NANTAN":
            object.move_to(id,445,437)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "YUMA":
            object.move_to(id,446,443)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "INDY_GUARD_1":
        #    object.move_to(id,446.5,443)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "INDY_GUARD_2":
        #    object.move_to(id,445.5,443)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "INDY_GUARD_3":
        #    object.move_to(id,445,443)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
        if id == "INDY_GUARD_4":
        #    object.move_to(id,447,443)
            object.turn_to_object(id,"ALTER_EGO")
            #print id, "angekommen"
    
def Flucht_Indianer():
    data().Talked_To_Yuma=0
    for id in data().Indianer_Flucht_NPCs:
        object.step_away(id)
    system.notify_timer(data().Timer_Indianer_Fliehen,data().Timervalue_Indianer_Fliehen)
    Einer_Mehr("ALESHANEE")
    Einer_Mehr("ANOKI")
    object.move_to("CHENOA",482.87,412.88,"landscape",MT_FASTEST, callback=["ONEND",Lambda('Einer_Mehr("CHENOA")')])
    object.move_to("KIONA",464.76,434.87,"landscape",MT_FASTEST, callback=["ONEND",Lambda('Einer_Mehr("KIONA")')])

def Einer_Mehr(id):
    if id == "ALESHANEE":
        object.step_to("ALESHANEE",439.62,430.14)
    if id == "ANOKI":
        object.step_to("ANOKI",493.41,428.29)
    if id == "CHENOA":
        object.step_to("CHENOA",484.87,412.88)
    if id == "KIONA":
        object.step_to("KIONA",464.76,434.87)
    data().Indianer_Geflohen=data().Indianer_Geflohen+1


#[NM] Dialog 038: Der Spieler will nicht mit den Indianer-Wachen reden
def initDlg_038_SpielerWillNichtMitWachenReden():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text(text='D_038_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
    dialog.start()
