# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import object_events
import object
import schedules
from const import *
from dynamic_camera import *
import const
import system_events

#*********************************************************************
#        aktuelle revison: Revision 24, 9.09.2004
#*********************************************************************

# umlaute äöü (zum besseren speichern=)

def GetZoneEnterLocation(enterdirection):
    start_locations = {    
            "NORTH"    :    (458,211),
            "SOUTH"    :    (230,498),
            "WEST"    :    (264,210),
            "EAST"    :    (671,498),
        }

    if was_zone_entered("zone_6.zone_6"):
        if data("zone_6.zone_6").abraham_und_co_folgen:
            start_locations = {    
                    "NORTH"    :    (458,211),
                    "SOUTH"    :    (458,211),
                    "WEST"    :    (458,211),
                    "EAST"    :    (458,211),
                }

    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def initParties():
    system.create_party(id="INDIAN_1",type=PT_COMPUTER)
    system.create_party(id="IAN_CHASE",type=PT_COMPUTER)
    system.create_party(id="GOE_NPCS",type=PT_COMPUTER)
    system.create_party(id="GOE_GANG",type=PT_COMPUTER)
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="NPCS",type=PT_COMPUTER)


def on_init():
    skies.init_sky_preset("orange")

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
        #spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
        system.add_region("Indianer_Dorf",410,365,535,310)
        system.add_region("Ritualfels",560,335,535,310)
        system.add_region("Friedhof",385,320,350,360)
        system.add_region("Schwimmbad",865,255,750,375)

    data("rest").non_rest_areas.append("Indianer_Dorf")
    data("rest").non_rest_areas.append("Ritualfels")
    data("rest").non_rest_areas.append("Friedhof")
    data("rest").non_rest_areas.append("Schwimmbad")

def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    init_non_rest_areas()
    schedules.init_schedules()
    init_patch()

def on_map_loaded():
    init_data()
    initParties()
    # place player characters
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    # ae- and party-creation modifier | see debug_py.py for info on parameters
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

    npc.initNPCS()
    npc.initAnimals()
    initVehicles()
    initItems()
    initHerbs()
    initExitZones()
    initQuestbook()
    initFX()
    initWaterResources()

    # Die Begrenzung ums Indianerdorf, an der man Yuma begegnet
    # Regionen werden ab jetzt im überarbeiteten Teil immer in NOSW abgehandelt 28.01.04 - Heiko
    system.add_region("YumaApproachNorth",410,360,580,365)
    system.notify_region_entered( region="YumaApproachNorth", partyid="UISPIELER" )
    system.add_region("YumaApproachEast",580,360,585,500)
    system.notify_region_entered( region="YumaApproachEast", partyid="UISPIELER" )
    system.add_region("YumaApproachWest",405,360,410,500)
    system.notify_region_entered( region="YumaApproachWest", partyid="UISPIELER" )

    system.add_region("INDIANERDORF",435,370,525,490)
    system.notify_region_entered("INDIANERDORF", partyid="UISPIELER" )
    
    system.add_region("REGION_RITUALFELS",565,340,530,305)
    system.notify_region_entered("REGION_RITUALFELS", partyid="UISPIELER" )
    system.add_region("REGION_SCHWIMMBAD",875,245,740,385)
    system.notify_region_entered("REGION_SCHWIMMBAD", partyid="UISPIELER" )
    
    # Eingang zum Garden of Eden, für die Bären
    system.add_region("GOEBaeren1",685,420,693,453)
    system.add_region("GOEBaeren2",693,450,700,480)
    
    # Eingang zum Garden of Eden, ohne den Bären zu begegnen
    system.add_region("GOE1",685,240,900,245)
    system.add_region("GOE2",895,245,900,455)
    system.add_region("GOE3",700,450,895,455)
    system.add_region("GOE4",685,245,690,420)

    # Region um das Garden of Eden
    system.add_region("GOEUmkreis",775,255,866,360)

    system.add_region("REGION_INDIAN_CEMENTARY", 385,365,350,320)
    system.notify_region_entered(region="REGION_INDIAN_CEMENTARY",objectid="ALTER_EGO")
    # Der Timer für den Wolfsspawn
    system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
    
    # timer ian-chase ritual
    system.notify_timer(data().Timer_IanRitualChecker,data().Timervalue_IanRitualChecker)
    
    checkZoneDependencies()
    schedules.init_schedules() ## immer nach dem initQuestbook()
    init_scriptuse_objects()
    InitChestsSafes()
    init_character_states()
    init_non_rest_areas()
    system.notify_timer(data().Timer_Ian_ComeHome,data().Timervalue_Ian_ComeHome)

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
    # lagerfeuer
    for lf in data().OBJ_LAGERFEUER_INDIANER:
        system.mark_for_script_use(lf)
    # kisten, truhen, tresore
    #system.mark_for_script_use("BUILDING_3935")
    system.mark_for_script_use("BUILDING_3941")
    system.mark_for_script_use("BUILDING_3942")
    system.mark_for_script_use("BUILDING_3943")
    
    # Bienenstöcke ZZone 4
    system.mark_for_script_use('BUILDING_3950')
    system.mark_for_script_use('BUILDING_3951')

    

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
    npcs = system.get_npcs()
    #mortality
    for npc in npcs:
        if object.get_attribute(npc, "model") == "child":
            object.set_immortal_state(npc, True)

## checks for switches due to zones that have been entered before
def checkZoneDependencies():
    if was_zone_entered("zone_6.zone_6"):
        if data("zone_6.zone_6").abraham_und_co_folgen:
            # Der Timer für das vergiftete Wasser im Garden of Eden Quest
            system.notify_timer(data().Timer_GoE_Wasser, data().Timervalue_GoE_Wasser)
            system.notify_timer(data().Timer_GoE_Wegpunkt, data().Timervalue_GoE_Wegpunkt)
            system.notify_region_entered( region="GOE1", partyid="UISPIELER" )
            system.notify_region_entered( region="GOE2", partyid="UISPIELER" )
            system.notify_region_entered( region="GOE3", partyid="UISPIELER" )
            system.notify_region_entered( region="GOE4", partyid="UISPIELER" )
            system.notify_region_entered( region="GOEBaeren1", partyid="UISPIELER" )
            system.notify_region_entered( region="GOEBaeren2", partyid="UISPIELER" )
            system.notify_region_entered( region="GOEUmkreis", partyid="UISPIELER" )

def initWaterResources():
    water.set_water_source(480.5,389.7, 2)
    water.set_water_source(765.8,421.6, 3)

def on_post_load():
    initFX()
    schedules.init_schedules()
    init_patch()

def on_approach(target,operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)

def on_enter_region(id, objectid, partyid ):
    #print "[region enter:",id, objectid, partyid,"]"
    # non-permanent triggers: objectid is list of all chars in region
    if isinstance(objectid,list):
        if len(objectid): objectid=objectid[0]
        else: return
    
    # spieler findet Indianerdorf
    if id == "INDIANERDORF":
        if not data().player_knows_Indianerdorf:
            data().player_knows_Indianerdorf = True
            system.add_minimap_marker(481.50, 458.84,"MM_002")# Indianerdorf

    if id == "REGION_RITUALFELS":
        if not data().player_knows_Ritualfels:
            data().player_knows_Ritualfels = True
            system.add_minimap_marker(553.49, 321.01,"MM_004")# Ritualfels
            
    if id == "REGION_SCHWIMMBAD":
        if not data().player_knows_Schwimmbad:
            data().player_knows_Schwimmbad = True
            system.add_minimap_marker(829.42, 305.46,"MM_001")# Schwimmbad

    # spieler betritt den indianer friedhof
    if id == "REGION_INDIAN_CEMENTARY":
        if not data().player_knows_Indianer_Friedhof:
            data().player_knows_Indianer_Friedhof = True
            system.add_minimap_marker(370.57, 334.14,"MM_003")# Indianer-Friedhof
        if not data().graves_sighted:
            dialogs.initDlg_019_SpielerEntdecktVerwuestungen()
            #system.notify_region_entered(region="REGION_INDIAN_CEMENTARY",objectid="ALTER_EGO")

    # Abfrage für die Cutscene mit Yuma beim Indianerdorf
    if ( id in [ "YumaApproachNorth", "YumaApproachEast", "YumaApproachWest" ] and not data().IndianerdorfBetreten ) :
        data().IndianerdorfBetreten = True
        if ( data().Indianer_Tt_Yuma == 0 and 
            system.get_qb_entry_state (data().QB_001) == INACTIVE and 
            partyid == "UISPIELER") :
            data().PCsNextToAE = []
            for pc_id in system.get_pcs():
                if pc_id != "ALTER_EGO":
                    if object.get_distance(pc_id,"ALTER_EGO") <= 15.0:
                        data().PCsNextToAE.append(pc_id)
                        
            #print "pcs next to ae:",data().PCsNextToAE
            if ( id == "YumaApproachNorth" ) :
                data().Indianer_DOA = 1
                #yuma_cs_1(503,350)
                setPositionIndiIntro(0)
            if ( id == "YumaApproachEast" ) :
                data().Indianer_DOA = 2
                #yuma_cs_1(600,428)
                setPositionIndiIntro(2)
            if ( id == "YumaApproachWest" ) :
                data().Indianer_DOA = 4
                #yuma_cs_1(395,483)
                setPositionIndiIntro(1)

    # Abfrage für die Bären beim GoE
    if (id=="GOEBaeren1" or id=="GOEBaeren2"):
        if dialogs.abraham_quest_z6_check():
            if data().GoE_Baeren==0:
                data().GoE_Baeren=1
                data().GoE_Dialog=1
                dialogs.initCutscene_120_BaerenAmTalZugang()

    # Abfrage für den Zugang zum GoE ohne die Bären
    if (id=="GOE1" or id=="GOE2" or id=="GOE3" or id=="GOE4"):
        if dialogs.abraham_quest_z6_check():
            if data().GoE_Baeren==0:
                data().GoE_Baeren=1
                data().GoE_Dialog=1
                system.start_cutscene()
                set_conversation("ALTER_EGO","SUE_Z7",mode="far")
                #dialogs.scenecam_nd("ALTER_EGO","SUE_Z7", 4, 2)
                dialogs.initCutscene_121_AbrahamsParadiesWirdEnthuellt()


    # Abfrage für die Region um das GoE
    if id=="GOEUmkreis":
        if dialogs.abraham_quest_z6_check():
            data().GoE_Dialog=1
            dialogs.initCutscene_123_SueUndMickyEnttaeuscht()

# wird ausgelöst, wenn sue zu dem erschossenen fjodr gelaufen ist
def onSueReachesFjodr():
    # set_conversation(talker="SUE_Z7",cam_x=-4,cam_y=-4,mode="medium",animate=False)
    onReachFjodrStartDialog()

#helper to deactivate ian chase
def ianchase_deactivate(param=None):
    object.set_active_state("IAN", 0)
    data().ian_state = False
    allow_activity("IAN")
    system.notify_timer(data().Timer_Ian_ComeHome,data().Timervalue_Ian_ComeHome)

#helper to activate ian chase ta
def ianchase_activate(param=None):
    allow_activity("IAN")
    data().Ian_Ritual = 1
    system.notify_timer(data().Timer_Ian_ComeHome,data().Timervalue_Ian_ComeHome)
    
def on_timer(id):
    #print "[debug on_timer()",id,"]"
    if id == data().Timer_Ian_ComeHome:
        if not object.is_destroyed("IAN"):
            clock = system.get_mission_time().get_day_time()
            if clock >= time("22:00:00") or clock < time("01:30:00"):
                #make ian appear and goto ritual
                if not data().ian_state:
                    #print ">>> ian will now appear into scene, to perfom ritual"
                    object.set_active_state("IAN", 1)
                    set_activity("IAN", WORK_FORBIDDEN)
                    data().ian_state = True
                    wp = ROUTE_IAN_RITUAL[5:len(ROUTE_IAN_RITUAL)]
                    object.set_position("IAN", wp[0][0], wp[0][1])
                    for x in range (0,len(wp)):
                        if x == len(wp)-1:
                            object.move_to("IAN", wp[x][0],wp[x][1], speed=MT_SLOW, grid="landscape",\
                                callback=ianchase_activate)
                        else:
                            object.move_to("IAN", wp[x][0],wp[x][1], speed=MT_FAST, grid="landscape")
#                    object.set_position("IAN", 234.5, 156.0)
#                    for wp in ROUTE_IAN_RITUAL:
#                        if wp == ROUTE_IAN_RITUAL[-1]:
#                            object.move_to("IAN", wp[0],wp[1], speed=MT_SLOW, grid="landscape", callback=ianchase_activate)
#                        else:
#                            object.move_to("IAN", wp[0],wp[1], speed=MT_FAST, grid="landscape")
                else:
                    system.notify_timer(data().Timer_Ian_ComeHome,data().Timervalue_Ian_ComeHome)
            else:
                #make ian disappear fater leaving ritual
                if data().ian_state:
                    #print ">>> ian will now disappear from ritual performance"
                    set_activity("IAN", WORK_FORBIDDEN)
                    data().Ian_Ritual = 0
                    wps = ROUTE_IAN_RITUAL[:]
                    wps.reverse()
                    for wp in wps:
                        if wp == wps[-1]:
                            object.move_to("IAN", wp[0],wp[1], speed=MT_SLOW, grid="landscape", callback=ianchase_deactivate)
                        else:
                            object.move_to("IAN", wp[0],wp[1], speed=MT_SLOW, grid="landscape")
                else:
                    system.notify_timer(data().Timer_Ian_ComeHome,data().Timervalue_Ian_ComeHome)
                    
    """                
    if id == data().Timer_IanRitualChecker:
        if (not object.is_destroyed("IAN") and (data().Ian_Ritual != 2)):
            clock = system.get_mission_time().get_day_time()
            if clock >= time("23:00:00") or clock < time("01:00:00"):
                data().Ian_Ritual = 1
            else:
                data().Ian_Ritual = 0
            system.notify_timer(data().Timer_IanRitualChecker,data().Timervalue_IanRitualChecker)
    """
    ## anoki und der spieler nach dem aleshanee ihn verwiesen hat
    if id == data().Timer_AnokiUndPlayer:
        dialogs.initCutscene_029_SpielerEmpfaengtAnoki()

    ## anoki und aleshanee
    if id == data().Timer_AnokiUndAleshanee:
        dialogs.initCutscene_028_AleshaneeWillAnokiNicht()

    if id == data().Timer_SueRenntZuFjodr:
        #print 'data().Timer_SueRenntZuFjodr:'
        #onSueReachesFjodr()
        onReachFjodrStartDialog()

    ## spieler bewegen sich mit indianern in deren dorf
    if id == data().Timer_MoveToVillage:
        system.set_camera_view(CAMVIEW_INDIAN_VILLAGE_1) # cam am Lagerfeuer wenn Party ins Dorf geführt wird
        system.fade(FADE_IN)
        dialogs.setPostionsIndianVillage()
        
    ## todo sinn dieses Timers überprüfen
    if ( id == data().Timer_Yuma_1 ) :
        pass

    if ( id == data().Timer_Yuma_2 ) :
    ####    Wird aus der Yuma_Dlg_003_Tel() in der dialogs.py aufgerufen, handelt das ankommen am Dorf ab
        object.move_to("YUMA",425.00,472.00,"landscape",MT_NORMAL)
        object.move_to("ALTER_EGO",427.00,470.00,"landscape",MT_NORMAL)
        for id in system.get_pcs():
            if id != "ALTER_EGO":
                object.move_to_object (id,"ALTER_EGO","landscape", MT_NORMAL)
        if dialogs.abraham_quest_z6_check():
            if data().GoE_Fjodr_Tot==1:
                for id in data().GoE_NPCs_in_Abrahams_Team_2:
                    object.move_to_object (id,"ALTER_EGO","landscape", MT_NORMAL )
            elif data().GoE_Fjodr_Tot==0:
                for id in data().GoE_NPCs_in_Abrahams_Team_1:
                    object.move_to_object (id,"ALTER_EGO","landscape", MT_NORMAL )
        object.move_to("INDY_GUARD_1",426.5,472.5,"landscape",MT_NORMAL)
        object.move_to("INDY_GUARD_2",424.5,470.5,"landscape",MT_NORMAL)
        object.move_to("INDY_GUARD_3",428,473,"landscape",MT_NORMAL)
        object.move_to("INDY_GUARD_4",424,469,"landscape",MT_NORMAL)
        object.turn_to_object ("ALTER_EGO", "TYEE")
        object.turn_to_object ("YUMA", "ALTER_EGO")
        for id in data().Indianer_Guards:
            object.turn_to_object (id, "ALTER_EGO")

    if ( id == data().Timer_Yuma_3 ) :
####    Startet den Dialog mit Tyee, wenn der Spieler (und normalerweise alle Wachen) bei ihm angekommen ist
####    Wird aus der Ins_Dorf() in der dialogs.py gestartet
        dialogs.initCutscene_036_SpielerWundertSichUeberHaeuptling()    # bringt den Dialog
        dialogs.onCutscene_036_SpielerWundertSichUeberHaeuptling()    # läst den Häuptling losgehen

    if ( id == data().Timer_Yuma_4 ) :
####    Wird aus der Ins_Dorf() in der dialogs.py gestartet um die Dialogkamera für AE und Tyee einzustellen
        system.set_camera_view(CAMVIEW_TYEE_INTRO)
        yuma_cs_3()

# GoE Timer
    if (id==data().Timer_GoE_Wasser and dialogs.abraham_quest_z6_check()):
    ##    Startet den Dialog mit dem Vergifteten Wasser
        if (dialogs.abraham_quest_z6_check() and data().GoE_Fjodr_Tot==0):
            data().GoE_Dialog=1
            for id in data().GoE_NPCs_in_Abrahams_Team_1:
                object.cancel_commandos(id)
                prohibit_activity(id)
            dialogs.initCutscene_140_SueIstVergiftet()
            npcs = system.get_npcs()
            if 'FJODR' in npcs:
                object.set_immortal_state('FJODR', False)

    if (id==data().Timer_GoE_Wegpunkt and dialogs.abraham_quest_z6_check()):
    ##    Kümmert sich darum, dass der Spieler solange das GoE Quest aktiv ist, nicht allzuweit vom Weg abkommt,
    ##    bzw bricht das Quest nach einer Weile ab
        ae_x=object.get_x("ALTER_EGO")
        ae_y=object.get_y("ALTER_EGO")
        goe_x=690
        goe_y=445
        x_dist=goe_x-ae_x
        y_dist=goe_y-ae_y
        if not dialog.is_dialog_active():
            if not data().GoE_Baeren==1:
                if betrag(x_dist)>betrag(y_dist):
                    if x_dist>0:
                        dialogs.initDlg_131_SpielerSollNachOsten()
                    elif x_dist<0:
                        dialogs.initDlg_133_SpielerSollNachWesten()
                elif betrag(x_dist)<betrag(y_dist):
                    if y_dist>0:
                        dialogs.initDlg_132_SpielerSollNachSueden()
                    elif y_dist<0:
                        dialogs.initDlg_130_SpielerSollNachNorden()
        system.notify_timer(data().Timer_GoE_Wegpunkt, data().Timervalue_GoE_Wegpunkt)

    if (id==data().Timer_GoE_Abbruch and dialogs.abraham_quest_z6_check()):
        ##    Lässt die letzte Zeitspanne bis zum GoE Quest - Abbruch durchlaufen
        if dialogs.abraham_quest_z6_check():
            if not dialog.is_dialog_active():
                if not data().GoE_Baeren==1:
                    dialogs.initDlg_134_AbrahamMachtSchluss()
            else:
                system.notify_timer(data().Timer_GoE_Abbruch_2, data().Timervalue_GoE_Abbruch_2)

    if (id==data().Timer_GoE_Abbruch_2 and dialogs.abraham_quest_z6_check()):
        ##    Springt an, falls zum Timerzeitpunkt des ersten Abbruchs ein Dialog aktiv war, startet sich
        ##    selbst immer wieder neu, bis er einmal abgelaufen ist, allerdings in einem geringeren
        ##    Zeitabstand als der erste Abbruchtimer
        if dialogs.abraham_quest_z6_check():
            if not dialog.is_dialog_active():
                if not data().GoE_Baeren==1:
                    dialogs.initDlg_134_AbrahamMachtSchluss()
            else:
                system.notify_timer(data().Timer_GoE_Abbruch_2, data().Timervalue_GoE_Abbruch_2)

    ## Spawntimer
    if (id == data().Timer_SpawnTimeChecker):
        clock = system.get_mission_time().get_day_time()
        if (clock >= time("06:00:00") and clock < time("22:00:00")):
            npc.spawnAnimals(INACTIVE)
        else:
            npc.spawnAnimals(ACTIVE)
        system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

    ## Indianerfrauen und -Kinder fliehen, wenn es zum Kampf mit Yuma oder Tyee kommt
    if (id == data().Timer_Indianer_Fliehen):
        if (data().Indianer_Geflohen == 4):
            for id in data().Indianer_Flucht_NPCs:
                object.set_active_state(id,INACTIVE)
                #print id, "deaktiviert"
        else:
            system.notify_timer(data().Timer_Indianer_Fliehen,data().Timervalue_Indianer_Fliehen)

    if (id == data().Timer_Ian_Dialogwahl):
        ##    Spielt nachdem der Spieler Ian verlassen hat einen der beiden Dialoge ab, in denen
        ##    der AE überlegt, Ian zu verraten
        if not dialog.is_dialog_active():
            if data().Ian_Dialogwahl == 17:
                dialogs.initDlg_017_SpielerUeberlegtIanZuVerraten()
            elif data().Ian_Dialogwahl == 18:
                dialogs.initDlg_018_SpielerWillIanVerraten()
        else:
            system.notify_timer(data().Timer_Ian_Dialogwahl,data().Timervalue_Ian_Dialogwahl)

# tyee erblickt den spieler
def onTyeeSeesPlayer(char_id):
    dialogs.initDlg_004_HaeuptlingHatProblem()


def on_object_killed(victim, attacker, weapon_type, weapon_id):
    object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
    if victim == "IAN":
        object.set_attribute(victim,"zone_transfer",False)
        data().Ian_Getoetet = 1
        object.create_item_in_inventory("IAN","SET_SCALP","ZZ4 IANS_SCALP")
        object.set_attribute("ZZ4 IANS_SCALP","generic_item",False)

    if (victim=="BAER_1" or victim=="BAER_2"):
        ## Wird nach jedem getöteten Bären am GoE Eingang aufgerufen, sobald beide tot sind, läuft der GoE Dialog-"Schwanz" weiter durch
        data().GoE_Tote_Baeren=data().GoE_Tote_Baeren+1
        if data().GoE_Tote_Baeren >= 2:
            data().GoE_Kampf=0
            #dialogs.scenecam_nd("ALTER_EGO","SUE_Z7", 4, 2)
            data().GoE_Dialog=1
            dialogs.initCutscene_121_AbrahamsParadiesWirdEnthuellt()
    
    if (victim=="FJODR"):
        object.set_attribute(victim,"zone_transfer",False)
        ## Spielt die CS nach Fjodrs Tod durch, und schaltet für den Folgetimer auf die Version ohne Fjodr um
        data().GoE_Kampf=0
        data().GoE_Fjodr_Tot=1
        if (dialogs.abraham_quest_z6_check() and data().GoE_Gift_Dialog_Vorbei==1):
            system.start_cutscene()
            object.cancel_commandos('SUE_Z7')
            # todo sollte wenn es mal irgendwan geht auf MoveToObject umgestellt werden
            object.move_to("SUE_Z7", object.get_x("FJODR"), object.get_y("FJODR") , callback = ['ONEND', FJODR_Kill])
            #set_conversation(talker="FJODR",cam_x=3,cam_y=3,mode="far",animate=False)
            
    
    if (victim=="SUE_Z7"):
        object.set_attribute(victim,"zone_transfer",False)
        ## Sue ist gestorben, bevor das GoE erreicht wurde, deshalb bricht Abraham ab
        data().GoE_Sue_Tot=1
        if (not data().GoE_Baeren==1):
            dialogs.initDlg_136_AbrahamGibtWegenSueAuf()
    if (victim=="MICKEY"):
        object.set_attribute(victim,"zone_transfer",False)
        ## Mickey ist gestorben, bevor das GoE erreicht wurde, deshalb bricht Abraham ab
        data().GoE_Mickey_Tot=1
        if (not data().GoE_Baeren==1):
            dialogs.initDlg_135_AbrahamGibtWegenMickeyAuf()
    if (victim in data().GoE_Gang):
        ##    Wenn alle Gangmitglieder am GoE tot sind, kommt der letzte GoE Dialog, je nachdem, wer überlebt hat
        data().GoE_Tote_Ganger=data().GoE_Tote_Ganger+1
        if (data().GoE_Tote_Ganger>=7):
            # Alle Ganger sind tot
            data().GoE_Kampf=0
            if (data().GoE_Sue_Tot==1 and data().GoE_Mickey_Tot==1):
                # Sue und Mickey sind tot
                dialogs.initDlg_128_AlleUmgekommen()
            if (data().GoE_Sue_Tot==0 and data().GoE_Mickey_Tot==1):
                # Sue lebt und Mickey ist tot
                dialogs.initDlg_125_SueNachNorden()
            if (data().GoE_Sue_Tot==1 and data().GoE_Mickey_Tot==0):
                # Sue ist tot und Mickey lebt
                dialogs.initDlg_126_MickeyNachNorden()
            if (data().GoE_Sue_Tot==0 and data().GoE_Mickey_Tot==0):
                # Sue und Mickey leben
                dialogs.initDlg_127_SueUndMickeyNachNorden()
    
    if (attacker in data().Indianer_Maenllich):
        for id in data().Indianer_Maenllich:
            if victim in data().Indianer_Maenllich[attacker]:
                data().Indianer_Maenllich[attacker].remove(victim)
    
    if (attacker in system.get_pcs()):
        if victim in data().Indianer_Maenllich:
            del data().Indianer_Maenllich[victim]
            if not data().Indianer_Maenllich:
                data().AlleIndianerKilled = True
        if victim in data().Indianer_Weiblich:
            data().Indianer_Weiblich.remove(victim)

def FJODR_Kill(id):
    object.cancel_commandos('SUE_Z7')
    object.turn_to_object("SUE_Z7", "FJODR", callback = ['ONEND', FJODR_Kill_1])
    
def FJODR_Kill_1(id):
    system.notify_timer(data().Timer_SueRenntZuFjodr,data().Timervalue_SueRenntZuFjodr)

def onMoveTurnToFjodr(char_id):
    object.turn_to_object(char_id,"FJODR")

# startet den dialog nachdem sue fjodr untersucht hat
def onReachFjodrStartDialog():
    pos = [object.get_x("FJODR"),object.get_y("FJODR")]
    object.move_to("ALTER_EGO",pos[0]+0.75,pos[1]+2.0, callback=["ONEND",onMoveTurnToFjodr])
    object.move_to("ABRAHAM",pos[0]-0.75,pos[1]+2.0, callback=["ONEND",onMoveTurnToFjodr])
    set_conversation("FJODR",cam_x=-5, cam_y=-5, mode="medium")
    
    ## Die Animation, mit der Sue Fjodrs Leiche nach dem Giftdialog durchsucht
    data().GoE_Dialog=1
    character.play_animation("SUE_Z7", "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
    for i in range(1,2):
        character.play_animation("SUE_Z7", "CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
    character.play_animation("SUE_Z7", "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback=[["ONEND",Lambda('dialogs.initCutscene_119_FjodrWars()')], ['ONEND', Lambda('data().GoE_Kampf=0')]])

def on_wait_for_commando(id):
    #if not(data().Indianer_Tt_Yuma == 1 and not system.get_qb_entry_state(data().QB_001) == IMPOSSIBLE):
    #    return False
    return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
    if character_id in system.get_pcs():
        for grave in GRAEBER_GESCHLOSSEN + GRAEBER_OFFEN:
            if object_id.endswith(grave):
                return True
    return False

def on_examine_object( character_id, object_id ):
    if character_id in system.get_pcs():
        if not dialog.is_dialog_active():
            if object_id.endswith("_1179"):
                dialogs.initDlg_Comment(character_id,'D_035_T_001')
                return True
            
            for grave in GRAEBER_GESCHLOSSEN:
                if object_id.endswith(grave):
                    dialogs.initDlg_Comment(character_id,'D_023_T_001')
                    return True
    
            if object_id.endswith(GRAEBER_OFFEN[1]):
                if not data().grave_1_examined:
                    dialogs.initDlg_020_SpielerUntersuchtGrab()
                else:
                    dialogs.initDlg_022_SpielerUntersuchtWeiteresGrab()
                return True
            
            if object_id.endswith(GRAEBER_OFFEN[3]):
                if not data().grave_2_examined:
                    dialogs.initDlg_021_SpielerUntersuchtZweitesGrab()
                else:
                    dialogs.initDlg_022_SpielerUntersuchtWeiteresGrab()
                return True
    
            for grave in GRAEBER_OFFEN:
                if (    object_id.endswith(grave) and 
                    (not grave==GRAEBER_OFFEN[3]) and 
                    (not grave==GRAEBER_OFFEN[1])):
                    dialogs.initDlg_022_SpielerUntersuchtWeiteresGrab()
                    return True
    return False

def initItems():
    # vorerst nur das equipment für die 6 ganger am goe
    # Die exakte Bewaffnung fehlt noch, weil sie noch nicht im Kampfdoc steht
    object.create_item_in_inventory(object="GANG_M_01",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM"])
    object.create_item_in_inventory(object="GANG_M_02",equipment=["SET_M_16","SET_AMMOPACK_5_56_MM"])
    object.create_item_in_inventory(object="GANG_M_03",equipment=["SET_M_16","SET_AMMOPACK_5_56_MM"])
    object.create_item_in_inventory(object="GANG_M_04",equipment=["SET_HK_CAWS","SET_AMMOPACK_3_12_MM"])
    object.create_item_in_inventory(object="GANG_M_05",equipment=["SET_M_16","SET_AMMOPACK_5_56_MM"])
    object.create_item_in_inventory(object="GANG_F_01",equipment=["SET_HK_CAWS","SET_AMMOPACK_3_12_MM"])
    character.equip( "GANG_M_01", equipment="SET_REMINGTON_M870" )
    character.equip( "GANG_M_02", equipment="SET_M_16" )
    character.equip( "GANG_M_03", equipment="SET_M_16" )
    character.equip( "GANG_M_04", equipment="SET_HK_CAWS" )
    character.equip( "GANG_M_05", equipment="SET_M_16" )
    character.equip( "GANG_F_01", equipment="SET_HK_CAWS" )
    # Gangleader
    object.create_item_in_inventory(object="GANGLEADER",equipment=["SET_UZI", "SET_AMMOPACK_9_MM", "SET_BULLET_CATCH" ])
    character.equip( "GANGLEADER", equipment="SET_UZI" )
    # Aleshanee
    object.create_item_in_inventory(object="ALESHANEE",equipment=["SET_LEATHER_CLOTHES"])
    # Anoki
    object.create_item_in_inventory(object="ANOKI",equipment=["SET_LEATHER_CAP"])
    # Tadi
    object.create_item_in_inventory(object="TADI",equipment=["SET_KNIFE","SET_WATER_SKIN"])
    # Nantan
    object.create_item_in_inventory(object="NANTAN",equipment=["SET_KNIFE","SET_MEAT_COOKED"])
    # Shaman
    object.create_item_in_inventory(object="SHAMAN",equipment=["SET_KNIFE","SET_HORSE_SKIN", "SET_NECKLACE"])
    # Yana
    object.create_item_in_inventory(object="YANA",equipment=["SET_BASEBALL_BAT"])
    # Naalnish
    object.create_item_in_inventory(object="NAALNISH",equipment=["SET_BASEBALL_BAT"])
    # Avonaco
    object.create_item_in_inventory(object="AVONACO",equipment=["SET_BROWNING_B_SS_DOUBLE_BARREL", "SET_AMMOPACK_2_12_MM"])
    # Hevataneo
    object.create_item_in_inventory(object="HEVATANEO",equipment=[ "SET_BROWNING_B_SS_DOUBLE_BARREL", "SET_AMMOPACK_2_12_MM"])
    # Yuma
    object.create_item_in_inventory(object="YUMA",equipment=["SET_BROWNING_B_SS_DOUBLE_BARREL", "SET_AMMOPACK_2_12_MM"])
    # Tyee
    object.create_item_in_inventory(object="TYEE",equipment=["SET_KNIFE"])

    # Die Bewaffnung für die 4 Indianerwachen, die mit Yuma unterwegs sind
    for id in data().Indianer_Guards:
        object.create_item_in_inventory(    object=id,equipment=[ "SET_REMINGTON_M870", "SET_AMMOPACK_2_12_MM"])

    # Die Waffen werden auch angelegt
    for id in data().Indianer_Patroullie_NPCs:
        if (object.get_inventory(id)[0][0][0]) in ["SET_BROWNING_B_SS_DOUBLE_BARREL", "SET_REMINGTON_M870"]:
            #print id, object.get_inventory(id)[0][0][0]
            character.equip(id,object.get_inventory(id)[0][0][0])

    ### Gegenstände in Kisten ###
    # Säcke im Westen des Lagers
    object.create_item_in_inventory("BUILDING_676","SET_TENT_CANVAS")

    # Kiste unterm Pavillion
    object.create_item_in_inventory("BUILDING_666",["SET_MEAT_RAW_SMALL","SET_MEDIPACK_SMALL"])

    # Kiste am U-Zelt
    object.create_item_in_inventory("BUILDING_671","SET_HK_USP_45")
    
    # weitere items nach items und animals dok
    object.create_item_in_inventory("BUILDING_892","SET_BASIC_PICKLOCK")
    object.create_item_in_inventory("BUILDING_835","SET_SMALL_SAND_SHOVEL")
    object.create_item_in_inventory("BUILDING_1711","SET_SOAP")
    object.create_item_in_inventory("BUILDING_1007","SET_GAME_JOY")
    object.create_item_in_inventory("BUILDING_981","SET_BRASS_KNUCKLES")


    #gräber
    object.create_item_in_inventory("BUILDING_911",["SET_SHORT_LEATHER_STRING","SET_RIVETS"])
    object.create_item_in_inventory("BUILDING_912","SET_LONG_LEATHER_STRING")
    object.create_item_in_inventory("BUILDING_908","SET_BIG_BAG")
    object.create_item_in_inventory("BUILDING_918",["SET_SMALL_BAG","SET_DICE"])
    #säcke
    object.create_item_in_inventory("BUILDING_866","SET_SUGAR")
    #zelt
    object.create_item_in_inventory("BUILDING_1693","SET_BULLET_CATCH")
    object.create_item_in_inventory("BUILDING_676",["SET_EMPTY_BOTTLE","SET_BEAR_SKIN"])
    #kistenstapel
    object.create_item_in_inventory("BUILDING_666","SET_BOOMERANG")
    #parkbank
    object.create_item_in_inventory("BUILDING_2034","SET_CLUB")
    
    # Bienenstöcke ZZ4
    object.create_item_in_inventory( 'BUILDING_3950', equipment=[ 'SET_BEESWAX' ] )
    object.create_item_in_inventory( 'BUILDING_3951', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )

    # Items in Kisten
    #object.create_item_in_inventory( 'BUILDING_3935', equipment=[ 'SET_COPPER_WIRE', 'SET_AMMOPACK_7_65_MM_SUBSONIC_DUMDUM', 'SET_BULLETPROOF_CLOTHES' ] )
    object.create_item_in_inventory( 'BUILDING_3941', equipment=[ 'SET_MEAT_COOKED_SMALL', 'SET_BASIC_PICKLOCK', 'SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE' ] )
    object.create_item_in_inventory( 'BUILDING_3942', equipment=[ 'SET_PROTECTIVE_GLOVES', 'SET_BOOMERANG', 'SET_MEDIPACK_BIG' ] )
    object.create_item_in_inventory( 'BUILDING_3943', equipment=[ 'SET_ELECTRIC_KETTLE', 'SET_MEDIPACK_SMALL', 'SET_SHURIKEN' ] )

    
def initHerbs():
    system.create_object(equipmenttype="SET_BURNET", x=382.46, y=347.44)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=397.52, y=461.66)
    system.create_object(equipmenttype="SET_ANGELICA", x=402.98, y=390.40)
    system.create_object(equipmenttype="SET_BURNET", x=404.60, y=386.56)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=412.64, y=372.26)
    system.create_object(equipmenttype="SET_ANGELICA", x=411.99, y=450.22)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=459.58, y=492.64)

def initExitZones():
    system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 1119.00, y2 = 209.30 )
    system.register_exit(regionname = "REGION_EXIT_NORD" )
    system.add_region( id = "REGION_EXIT_SUED", x1 = 1119.00, y1 = 703.00, x2 = 200.85, y2 = 500.00 )
    system.register_exit(regionname = "REGION_EXIT_SUED" )
    system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 703.00, x2 = 200.78, y2 = 209.38 )
    system.register_exit(regionname = "REGION_EXIT_WEST" )
    system.add_region( id = "REGION_EXIT_OST", x1 = 1119.00, y1 = 209.30, x2 = 915.00, y2 = 590.00 )
    system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
    for lagerfeuer in data().OBJ_LAGERFEUER_INDIANER:
        fxLagerFeuer(lagerfeuer)

#############################################################################################################
###    Die Questbook Initialisierung, geht erst zu machen, wenn das QB global ist
def initQuestbook():
    # Vorerst erstmal nur Dummyeinträge
    data().QB_001 = system.register_qb_entry('ZZONE4_AIM_01')
    data().QB_002 = system.register_qb_entry('ZZONE4_AIM_02')
    data().QB_003 = system.register_qb_entry('ZZONE4_AIM_03')

############################################################################################################
def betrag(wert):
    if wert < 0:
        wert=wert*-1
    return wert

def initVehicles():
##################################### Auskommentiert, um Bug 7524 zu umgehen ################################
#    system.create_object("SET_BUGGY",452.7,450.8,"NAALNISH_CAR",globals.DIR_EAST)
#    object.set_active_state("NAALNISH_CAR",ACTIVE)
    pass

# Ein Lagerfeuer Effekt
def fxLagerFeuer(_objectid):
    system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
    #system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
    system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
    system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
    system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
    system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)

#def fxAscheTonne(_objectid):
    #system.start_effect_object(object=_objectid,node="aschetonne",parameter=fx_smoke_aschetonne)

def on_pick_up( character_id, item_id, item_type ):
    return True

# def in zzone_2
def Is_Equip_Weapon(char_id):
    if object.has_attribute(char_id, 'slots'):
        equ = object.get_attribute(char_id, 'slots')
        if (equ['right_hand']):
            if object.has_attribute(equ['right_hand'], 'weapon_type'):
                return True
        for id in object.get_inventory_id_list(char_id):
            if object.has_attribute(id, 'weapon_type'):
                character.equip_direct(char_id, id)
                return True
    elif not object.has_attribute(char_id, 'slots'):
        for id in object.get_inventory_id_list(char_id):
            if object.has_attribute(id, 'weapon_type'):
                character.equip_direct(char_id, id)
                return True
    return False

def on_enemy_spotted(object_id):
    enemies = character.get_visible_enemies(object_id)
    if object.is_npc(object_id) and len(enemies):
        if object_id in data().Indianer_Maenllich:
            if not data().Feinde_Da:
                data().Feinde_Da = True # zeigt den Frauen an das sie verschwinden sollen
                for id_ in data().Indianer_Weiblich:
                    if not object.is_destroyed(id_):
                        object.cancel_commandos(id_)
                for id_ in data().Indianer_Maenllich:
                    if not object.is_destroyed(id_):
                        prohibit_activity(id_, step_away = True)
            for id in data().Indianer_Maenllich:
                if not object.is_destroyed(id):
                    if not len(data().Indianer_Maenllich[id]):
                        if not character.get_visible_enemies(id):
                            data().Indianer_Maenllich[id] = enemies
                        else:
                            data().Indianer_Maenllich[id] = character.get_visible_enemies(id)
                if Is_Equip_Weapon(id):
                    if not object.is_destroyed(data().Indianer_Maenllich[id][0]):
                        object.attack(id ,data().Indianer_Maenllich[id][0])
        else:
            if len(enemies):
                object.attack(object_id,random.choice(enemies))

def on_sector_cleared(object_id):
    for id in data().Indianer_Maenllich:
        if not object.is_destroyed(id):
            if (character.get_visible_enemies(id)):
                return False
    data().Feinde_Da = False
    for id in data().Indianer_Maenllich:
        if not object.is_destroyed(id):
            data().Indianer_Maenllich[id] = []
            allow_activity(id)
    for id in data().Indianer_Weiblich:
        if not object.is_destroyed(id):
            allow_activity(id)

def on_attack(operator_id, target_id):
    #print "[debug: on_attack:",operator_id,target_id,"]"
    if (target_id in data().Indianer_Maenllich or target_id in data().Indianer_Weiblich):
        for id in data().Indianer_Maenllich:
            if not object.is_destroyed(id):
                prohibit_activity(id)
                object.set_attribute(id, "foes", ['UISPIELER'])
        data().Indianer_Angegriffen = True
        for id in data().Indianer_Weiblich:
            if not object.is_destroyed(id):
                prohibit_activity(id)
                allow_activity(id)
    if operator_id in system.get_pcs():
        if target_id in data().GoE_NPCs_in_Abrahams_Team_2:
            if system.get_qb_entry_state(data("zone_6.zone_6").QB_020) != IMPOSSIBLE:
                system.set_qb_entry_state(data("zone_6.zone_6").QB_020, IMPOSSIBLE)

def setPositionIndiIntro(enter_position):
    system.start_cutscene()
    ## Kameraeinstellung für die CS wenn Yuma ankommt
    if data().Indianer_DOA==2:
        system.set_camera_view(CAMVIEW_INDIAN_INTRO_3)
    if data().Indianer_DOA==4:
        system.set_camera_view(CAMVIEW_INDIAN_INTRO_2)
    if data().Indianer_DOA==1:
        system.set_camera_view(CAMVIEW_INDIAN_INTRO_1)

    for char_id in POS_INDICUTSCENE_SETPOS.keys():
        pos = POS_INDICUTSCENE_SETPOS[char_id][enter_position]
        if char_id == "INDIANS":
            for indian_id in data().Indianer_Patroullie_NPCs:
                prohibit_activity(indian_id,  step_away = True)
                object.cancel_commandos(indian_id)
                object.set_position(indian_id,pos[0],pos[1])
        elif char_id == "PARTY":
            for party_id in data().PCsNextToAE:
                object.cancel_commandos(party_id)
                object.set_position(party_id,pos[0],pos[1])
            if dialogs.abraham_quest_z6_check():
                for goe_id in data().GoE_NPCs_in_Abrahams_Team_1:
                    if not object.is_destroyed(goe_id):
                        object.cancel_commandos(goe_id)
                        object.set_position(goe_id,pos[0],pos[1])
        elif char_id == "ALTER_EGO":
            object.cancel_commandos("ALTER_EGO")
            object.set_position("ALTER_EGO",pos[0],pos[1])
                
    for char_id in POS_INDICUTSCENE_INTRO.keys():
        pos = POS_INDICUTSCENE_INTRO[char_id][enter_position]
        if (char_id != "PARTY"):
            if char_id == "YUMA":
                object.move_to(char_id,pos[0],pos[1],"landscape",MT_FAST,callback=["ONEND", onYumaReachesPlayer_YUMA])
            elif char_id == 'ALTER_EGO':
                object.move_to(char_id,pos[0],pos[1],callback=["ONEND", onYumaReachesPlayer_ALTER_EGO])
            else:
                object.move_to(char_id,pos[0],pos[1])
            
        else:
            for pc_id in system.get_pcs():
                if ((pc_id != "ALTER_EGO") and (pc_id in data().PCsNextToAE)):
                    object.move_to(pc_id,pos[0],pos[1])
            if dialogs.abraham_quest_z6_check():
                for goe_id in data().GoE_NPCs_in_Abrahams_Team_1:
                    if not object.is_destroyed(goe_id):
                        object.move_to(goe_id,pos[0],pos[1])

def onYumaReachesPlayer_YUMA(char_id):
    const.YUMA_DA = True
    if (const.ALTER_EGO_DA):
        const.YUMA_DA = False
        const.ALTER_EGO_DA = False
        object.turn_to_object('ALTER_EGO', 'YUMA', callback = ['ONEND', onYumaReachesPlayer_YUMA_1])
        
def onYumaReachesPlayer_YUMA_1(id):
    object.turn_to_object('YUMA', 'ALTER_EGO', callback = ['ONEND', Lambda('dialogs.Yuma_Dlg_001()')])
        
def onYumaReachesPlayer_ALTER_EGO(char_id):
    const.ALTER_EGO_DA = True
    if (const.YUMA_DA):
        const.ALTER_EGO_DA = False
        const.YUMA_DA = False
        object.turn_to_object('ALTER_EGO', 'YUMA', callback = ['ONEND', onYumaReachesPlayer_ALTER_EGO_1])
        
def onYumaReachesPlayer_ALTER_EGO_1(id):
    object.turn_to_object('YUMA', 'ALTER_EGO', callback = ['ONEND', Lambda('dialogs.Yuma_Dlg_001()')])
        

def yuma_cs_1(xx,yy):
    counter=0
    for id in system.get_pcs():
        object.cancel_commandos(id)
        if id=="ALTER_EGO":
            object.set_position(id,xx,yy)
        else:
            if counter==0:
                if data().Indianer_DOA in [2,4]:
                    object.set_position(id,xx,yy-1)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx-1,yy)
            elif counter==1:
                if data().Indianer_DOA in [2,4]:
                    object.set_position(id,xx,yy+1)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx+1,yy)
            elif counter==2:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx+1,yy-1)
                if data().Indianer_DOA in [1,4]:
                    object.set_position(id,xx-1,yy-1)
            elif counter==3:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx+1,yy)
                if data().Indianer_DOA==4:
                    object.set_position(id,xx-1,yy)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx,yy-1)
            elif counter==4:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx+1,yy+1)
                if data().Indianer_DOA==4:
                    object.set_position(id,xx-1,yy+1)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx+1,yy-1)
            counter=counter+1
        object.turn_to_object(id,"YUMA")
    
    if dialogs.abraham_quest_z6_check():
        counter=0
        for id in data().GoE_NPCs_in_Abrahams_Team_1:
            object.cancel_commandos(id)
            if counter==0:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx+2,yy-1)
                if data().Indianer_DOA==4:
                    object.set_position(id,xx-2,yy-1)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx-1,yy-2)
            elif counter==1:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx+2,yy)
                if data().Indianer_DOA==4:
                    object.set_position(id,xx-2,yy)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx,yy-2)
            elif counter==2:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx+2,yy+1)
                if data().Indianer_DOA==4:
                    object.set_position(id,xx-2,yy+1)
                if data().Indianer_DOA==1:
                    object.set_position(id,xx+1,yy-2)
            if data().GoE_Fjodr_Tot==0:
                if counter==3:
                    if data().Indianer_DOA==2:
                        object.set_position(id,xx+3,yy)
                    if data().Indianer_DOA==4:
                        object.set_position(id,xx-3,yy)
                    if data().Indianer_DOA==1:
                        object.set_position(id,xx,yy-3)
            object.turn_to_object(id,"YUMA")
            counter=counter+1
    counter=0
    for id in data().Indianer_Patroullie_NPCs:
        object.cancel_commandos(id)
        if id=="YUMA":
            if data().Indianer_DOA==2:
                object.set_position(id,xx-14,yy)
                object.move_to(id,xx-4,yy,grid="landscape")
            if data().Indianer_DOA==4:
                object.set_position(id,xx+14,yy)
                object.move_to(id,xx+4,yy,grid="landscape")
            if data().Indianer_DOA==1:
                object.set_position(id,xx,yy+14)
                object.move_to(id,xx,yy+4,grid="landscape")
        else:
            if counter==0:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx-15,yy-1)
                    object.move_to(id,xx-5,yy-1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.set_position(id,xx+15,yy-1)
                    object.move_to(id,xx+5,yy-1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.set_position(id,xx-1,yy+15)
                    object.move_to(id,xx-1,yy+5,grid="landscape")
            if counter==1:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx-15,yy+1)
                    object.move_to(id,xx-5,yy+1,grid="landscape")
                if data().Indianer_DOA==4:
                    object.set_position(id,xx+15,yy+1)
                    object.move_to(id,xx+5,yy+1,grid="landscape")
                if data().Indianer_DOA==1:
                    object.set_position(id,xx+1,yy+15)
                    object.move_to(id,xx+1,yy+5,grid="landscape")
            if counter==2:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx-16,yy-2)
                    object.move_to(id,xx-6,yy-2,grid="landscape")
                if data().Indianer_DOA==4:
                    object.set_position(id,xx+16,yy-2)
                    object.move_to(id,xx+6,yy-2,grid="landscape")
                if data().Indianer_DOA==1:
                    object.set_position(id,xx-2,yy+16)
                    object.move_to(id,xx-2,yy+6,grid="landscape")
            if counter==3:
                if data().Indianer_DOA==2:
                    object.set_position(id,xx-16,yy+2)
                    object.move_to(id,xx-6,yy+2,grid="landscape")
                if data().Indianer_DOA==4:
                    object.set_position(id,xx+16,yy+2)
                    object.move_to(id,xx+6,yy+2,grid="landscape")
                if data().Indianer_DOA==1:
                    object.set_position(id,xx+2,yy+16)
                    object.move_to(id,xx+2,yy+6,grid="landscape")
            counter=counter+1
        object.turn_to_object(id,"ALTER_EGO")

def yuma_cs_3():
    object.move_to("ALTER_EGO",450,438,"landscape",callback=["ONEND",Lambda('system.notify_timer(data().Timer_Yuma_3, data().Timervalue_Yuma_3)')])
    object.turn_to_object("ALTER_EGO","TYEE")

    if dialogs.abraham_quest_z6_check():
        counter=0
        for id in data().GoE_NPCs_in_Abrahams_Team_1:
            if not object.is_destroyed(id):
                object.cancel_commandos(id)
                if counter in [0,1,2]:
                    object.set_position(id,449,450)
                    object.move_to_object(id,"ALTER_EGO")
                if data().GoE_Fjodr_Tot==0:
                    if counter==3:
                        object.set_position(id,449,450)
                        object.move_to_object(id,"ALTER_EGO")
                object.turn_to_object(id,"TYEE")
                counter=counter+1
    counter=0
    for id in data().Indianer_Patroullie_NPCs + ['TYEE']:
        object.cancel_commandos(id)
        if id=="TYEE":
            object.move_to(id, 460.93, 439.34)
        else:
            if counter==0:
                object.set_position(id,449,450)
                object.move_to(id,452.5,441.5,"landscape",callback=["ONEND",Lambda('object.turn_to_object(\"%s\","ALTER_EGO")' %id)])
            if counter==1:
                object.set_position(id,449,450)
                object.move_to(id,447,439,"landscape",callback=["ONEND",Lambda('object.turn_to_object(\"%s\","ALTER_EGO")' %id)])
            if counter==2:
                object.set_position(id,449,450)
                object.move_to(id,447,437.5,"landscape",callback=["ONEND",Lambda('object.turn_to_object(\"%s\","ALTER_EGO")' %id)])
            if counter==3:
                object.set_position(id,449,450)
                object.move_to(id,447.8,440.5,"landscape",callback=["ONEND",Lambda('object.turn_to_object(\"%s\","ALTER_EGO")' %id)])
            counter=counter+1

def yuma_cs_3_():
    object.cancel_commandos("TYEE")
    object.turn_to_object("TYEE", "ALTER_EGO", callback = ['ONEND', yuma_cs_3_1])
    
def yuma_cs_3_1(id):
    system.end_cutscene()
    object.cancel_commandos("ALTER_EGO")
    object.turn_to_object("ALTER_EGO", "TYEE", callback = ['ONEND', dialogs.initDlg_004_HaeuptlingHatProblem])
    

########################################################################################
### char -> PC oder NPC der einen Bereich verlassen soll wenn er sich darin befindet ###
### x -> X-Koordinate des Mittelpunktes des Bereiches                     ###
### y -> Y-Koordinate des Mittelpunktes des Bereiches                     ###
### radius -> Radius um den Mittelpunkt aus dem der PC NPC verschwinden soll         ###
### Rückgabe -> Die neuen Punkte zu denen der Char sich begeben soll             ###
### Rückgabe -> False, False PC NPC befinden sich nicht im ausgewählten Bereich         ###
########################################################################################
def lauf_weg_zu(char, x, y, radius):
    X_aktuell_Char = object.get_x(char)
    Y_aktuell_Char = object.get_y(char)
    X_aktuell_Char_Null = X_aktuell_Char - x
    Y_aktuell_Char_Null = Y_aktuell_Char - y
    abstand = math.sqrt((X_aktuell_Char_Null * X_aktuell_Char_Null) + (Y_aktuell_Char_Null * Y_aktuell_Char_Null))
    if abstand < radius:
        skalar = radius - abstand
        if X_aktuell_Char_Null >= 0 and Y_aktuell_Char_Null < 0:
            return skalar + X_aktuell_Char, Y_aktuell_Char - skalar
        elif X_aktuell_Char_Null < 0 and Y_aktuell_Char_Null < 0:
            return  X_aktuell_Char - skalar, Y_aktuell_Char - skalar
        elif X_aktuell_Char_Null < 0 and Y_aktuell_Char_Null >= 0:
            return X_aktuell_Char - skalar, skalar + Y_aktuell_Char
        elif X_aktuell_Char_Null >= 0 and Y_aktuell_Char_Null >= 0:
            return skalar + X_aktuell_Char, skalar + Y_aktuell_Char
    else:
        return False, False

def InitChestsSafes():
    # object.add_closed_lock("BUILDING_3935", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_3941", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_3942", "lock1", closure_type='booby-trap')
    object.add_closed_lock("BUILDING_3943", "lock1", closure_type='normal')

def init_patch():
    if "ANIE" in system.get_npcs():
        if object.is_active("ANIE"):
            data("zone_7.zone_7").anie_folgt = True

    for pc in data().GoE_NPCs_in_Abrahams_Team_1:
        if pc in system.get_npcs():
            if object.is_destroyed(pc):
                object.set_attribute(pc, "zone_transfer", False)
        
