# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
import schedules
import zzone_5
from dynamic_camera import *
import daily_routine
import cs_function as cs

#*** actual revision: Revision 16, 21.09.2004 ***********************************

def on_approach( target, operator ):
    if dialog.is_dialog_active():
        return
    if not target in ("FRAN", "IRIS","LINCOLN","ROBIN","WARREN"):
        if schedules.Dialog( target, operator ):
            return

    if target in ("FRAN", "IRIS"):
        if( data().SpokeToFran > 0 and data().QuestSolved == 0 ):
            initDlg_003_Fran_Talk_No_Progress()
        elif( data().Fran_free > 0 ):
            initDlg_038_Fran_Talk_Lifesaver()
        else:
            initDlg_002_Fran_Talk_Quest_Information()

    if target == "LINCOLN":
        if( data().SpokeToFran > 0 and data().QuestSolved > 0):
            initDlg_039_Lincoln_Quest_Solved()
        if( data().SpokeToFran > 0 and data().Unguilty > 0 and data().QuestSolved == 0 ):
            initCutscene_036_QuestSolved()
        elif( data().SpokeToFran > 0 and data().SpokeToLincoln > 0 and data().Unguilty == 0 ):
            initDlg_006_Lincoln_No_Progress()
        elif( data().SpokeToFran > 0 and data().SpokeToLincoln == 0 and data().QuestSolved == 0 ):
            initDlg_005_Lincoln_Talk_Witches()
        elif( data().SpokeToFran == 0):
            initDlg_004_Lincoln_Scared_Stiff()
    
    if target == "JENNA":
        if(( data().QuestSolved == 0) and (data().Choice_1_taken > 0) and (data().Choice_2_taken > 0) and (data().Choice_3_taken > 0) ):
            initDlg_010_Jenna_No_Talking()
        elif ( data().SpokeToFran > 0 and data().QuestSolved == 0):
            initDlg_008_Jenna_Speaks()
        elif ( data().QuestSolved == 1 and data().JennasDown == 0):
            initCutscene_040_Jenna_Sulks()
        elif ( data().QuestSolved == 1 and data().JennasDown == 1):
            initDlg_041_Jenna_Stays_Shut()
        else:
            initDlg_007_Jenna_Bigmouth()
            
            
    if target == "MARCUS":
        if(data().SpokeToFran > 0 ):
            if (data().QuestSolved > 0 ):
                initDlg_042_Marcus_likes_Player()
            elif (data().SpokeToMarcus_bakerlist > 0):
                initDlg_035_Marcus_solves_Riddle()                
            elif (data().SpokeToMarcus > 0 and data().got_hunterlist == 0 and data().got_bakerlist == 0 ):
                initDlg_014_Marcus_No_open_questions()
            elif (data().SpokeToMarcus > 0 ):
                initDlg_034_Marcus_gets_Lists()
            elif (data().Dlg_012_finished > 0 and data().SpokeToMarcus == 0 ):
                initDlg_013_Doctor_searches_Cure()
            else:
                initCutscene_012_Doctor_stays_rational()            
        else:
            initDlg_011_Player_doesntknow_Marcus()
            
        
    if target == "ROBIN":
        if(data().SpokeToFran > 0):
            if (data().QuestSolved > 0 ):
                initDlg_043_Robin_happywitchover()
            elif ((data().got_hunterlist  > 0 ) and (data().SpokeToMarcus_hunterlist > 0 )):
                if not data().robin_after_t_018:
                    initDlg_018_Robin_happytoknow()
                    data().robin_after_t_018 = True
                else:
                    initDlg_049_Robin_gotnomeat()
            elif ((data().got_hunterlist  > 0 ) and (data().SpokeToMarcus_hunterlist == 0 ) ):
                initDlg_017_Robin_wantstoknow()
            else:
                initDlg_016_Robin_helps_Player()
        else:
            initDlg_015_Robin_warns_Player()
        
    if target == "WARREN":
        if(data().SpokeToFran > 0):
            if (data().QuestSolved > 0 ):
                if data().badBusiness == 1:
                    initDlg_045_Warren_stillmourning()
                else:
                    initCutscene_044_Warren_Businessgetsworse()
            elif ((data().got_bakerlist  > 0 ) and (data().SpokeToMarcus_bakerlist > 0 )):
                initDlg_022_Warren_dontmakehimnervous()
            elif ((data().got_bakerlist  > 0 ) and (data().SpokeToMarcus_bakerlist == 0 ) ):
                initDlg_021_Warren_wantstoknow()
            else:
                initDlg_020_Warren_helps_Player()
        else:
            initDlg_019_Warren_warns_Player()
    
## Dialog in dem die Beiden den Spieler zur Hilfe rufen, es folgt automatisch Dlg002
def initCutscene_001_Fran_Talk_Free_Willy():
    system.start_cutscene()
    set_camera(CAMVIEW_KAEFIG)
    object.cancel_commandos("ALTER_EGO")
    object.move_to("ALTER_EGO", 488.23, 262.20, grid="landscape", speed=MT_FAST)
    object.turn_to_object("FRAN","ALTER_EGO", callback=["ONEND",on_dialog_001_start])
    object.turn_to_object("ALTER_EGO","FRAN", callback=['ONEND',on_dialog_001_continue])
    object.turn_to_object("IRIS","ALTER_EGO")

def on_dialog_001_start(char):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_001_T_001", speaker = "FRAN", follower='ENDDIALOG', callback=on_dialog_001_continue)
    dialog.start()
    
def on_dialog_001_continue(char=None):
    data().talk_counter += 1
    if data().talk_counter == 2:
        data().talk_counter = 0
        system.set_camera_view(CAMVIEW_KAEFIG_AE_TALK)
        set_conversation("ALTER_EGO", "FRAN", mode="medium_deep", new_camera=False)
        dialog.init_dialog(type=DIALOGSMALL)
        dialog.add_text("D_001_T_002", speaker = "ALTER_EGO",callback = Lambda('set_conversation("FRAN", "ALTER_EGO", mode="medium_deep", new_camera=False)'))
        dialog.add_text("D_001_T_003", speaker = "FRAN" , follower = "ENDDIALOG", callback = on_dialog_001_ende )
        dialog.start()
    
def on_dialog_001_ende():
    data().Dlg_001_finished = 1
    end_cutscene(chars=['ALTER_EGO', 'FRAN', 'IRIS'])
    initDlg_002_Fran_Talk_Quest_Information()
    
## Dialog in dem der Spieler informiert wird und Quest annehmen kann
def initDlg_002_Fran_Talk_Quest_Information():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_002')
    dialog.add_choice("D_002_C_001_1", order=6, follower = "D_002_T_001", auto_deactivation='permanent' )
    dialog.add_choice("D_002_C_001_2", order=5, follower = "D_002_T_005", auto_deactivation='permanent' )
    dialog.add_choice("D_002_C_001_6", order=1, follower = "D_002_T_004", auto_deactivation='permanent' )
    dialog.add_text("D_002_T_001", speaker = "FRAN")
    dialog.add_text("D_002_T_002", speaker = "IRIS")
    dialog.add_text("D_002_T_003", speaker = "FRAN", follower = "D_002_C_001")
    dialog.add_text("D_002_T_004", speaker = "FRAN", follower = "ENDDIALOG")
    dialog.add_text("D_002_T_005", speaker = "IRIS")
    dialog.add_text("D_002_T_006", speaker = "FRAN", follower = "D_002_C_001", callback = Dlg2_Choice3_active)
    dialog.add_text("D_002_T_007", speaker = "IRIS")
    dialog.add_text("D_002_T_008", speaker = "FRAN", follower = "D_002_C_001", callback = Dlg2_Choice4and5_active)
    dialog.add_text("D_002_T_009", speaker = "FRAN")
    dialog.add_text("D_002_T_010", speaker = "IRIS", follower = "D_002_C_001")
    dialog.add_text("D_002_T_011", speaker = "IRIS")
    dialog.add_text("D_002_T_012", speaker = "FRAN")
    dialog.add_choice("D_002_C_002_1", follower = "ENDDIALOG", callback = SpokeToFran, auto_deactivation='permanent')
    dialog.add_choice("D_002_C_002_2", follower = "ENDDIALOG", auto_deactivation='permanent')
    dialog.start(False)
    
def Dlg2_Choice3_active():
    dialog.add_choice("D_002_C_001_3", order=4, follower = "D_002_T_007", auto_deactivation='permanent')
    data().Dlg002_Ch3_active = 1
    
def Dlg2_Choice4and5_active():
    dialog.add_choice("D_002_C_001_4", order=3, follower = "D_002_T_009", auto_deactivation='permanent')
    dialog.add_choice("D_002_C_001_5", order=2, follower = "D_002_T_011", auto_deactivation='permanent')
    data().Dlg002_Ch4_active = 1
    data().Dlg002_Ch5_active = 1
    
def SpokeToFran():
    system.set_qb_entry_state( data().QB_001, UNCOMPLETE )
    data().SpokeToFran = 1
    
## Spieler hat Quest angenommen, aber noch keinen Fortschritt gemacht
def initDlg_003_Fran_Talk_No_Progress():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_003_T_001", speaker = "IRIS")
    dialog.add_text("D_003_T_002", speaker = "ALTER_EGO")
    dialog.add_text("D_003_T_003", speaker = "IRIS", follower = "ENDDIALOG")
    dialog.start(False)

## Dialog in der der Spieler den Beiden ihre Befreiung verkündet
def initDlg_037_Fran_Talk_Quest_Solved(id):
    system.fade(FADE_OUT)
    system.set_camera_view(CAMVIEW_FRAN_PLAYER)
    system.fade(FADE_IN)
    object.turn_to_object("FRAN","ALTER_EGO")
    object.turn_to_object("IRIS","ALTER_EGO")
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_037_T_001", speaker = "ALTER_EGO")
    dialog.add_text("D_037_T_002", speaker = "FRAN")
    dialog.add_text("D_037_T_003", speaker = "IRIS")
    dialog.add_text("D_037_T_004", speaker = "ALTER_EGO", callback=onDlg_037_PlayerOpensCage)
    dialog.add_text("D_037_T_005", speaker = "IRIS", follower='ENDDIALOG')
    dialog.start()

def onDlg_037_PlayerOpensCage():
    object.cancel_commandos("ALTER_EGO")
    object.move_to("ALTER_EGO", 488.22, 262.48,speed=MT_SLOW)
    object.step_to("ALTER_EGO", 488.20, 261.51, speed=MT_SLOW)
    object.turn_to_direction("ALTER_EGO", globals.DIR_NORTH)
    system.set_camera_view([488.1322021484375, 269.75668334960937, 2.4521713256835937, 0.092754721641540527, -0.96784454584121704, -0.23382343351840973])
    character.play_animation("ALTER_EGO", "CM_STEHEN_TASCHENDIEBSTAHL_VORN", callback=["ONEND", onDlg_037_CageOpen])

def onDlg_037_CageOpen(char):
    object.remove_closed_lock_by_name("ZZONE_5_BUILDING_37", "lock1")
    system.set_camera_view(CAMVIEW_FRAN_PLAYER)
    object.step_to("ALTER_EGO", 488.22, 262.48, speed=MT_SLOW)
    object.move_to("ALTER_EGO", 490.42, 265.85, speed=MT_SLOW)
    object.turn_to_position("ALTER_EGO", 488, 263, callback=["ONEND", onDlg_037_GoOn])
    object.step_away("ALTER_EGO")

def onDlg_037_Ende():
    end_cutscene(chars=["FRAN","ALTER_EGO", "IRIS"])
    data().QuestSolved = 1
    if not system.get_qb_entry_state( data().QB_001 ) == globals.COMPLETE:
        system.set_qb_entry_state( data().QB_003, INACTIVE )
        system.set_qb_entry_state( data().QB_001, COMPLETE )
        character.add_experience_party(800)

def onDlg_037_GoOn(char):
    data().Fran_free = 1
    object.turn_to_position("ALTER_EGO", 488, 263)
    object.cancel_commandos("IRIS")
    object.move_to("IRIS", 488.65, 264.30, speed=MT_SLOW, grid="landscape", callback = ["ONEND",Lambda('onDlg_037_GoOn_("%s")'%char)])

def onDlg_037_GoOn_(char):
    object.step_away("IRIS")
    object.cancel_commandos("FRAN")
    object.move_to("FRAN", 490.00, 263.66, speed=MT_SLOW, grid="landscape")
    object.step_away("FRAN")
    object.turn_to_object("IRIS", "ALTER_EGO")
    object.turn_to_object("FRAN", "ALTER_EGO", callback=["ONEND", onDlg_037_ContinueDialog])

def onDlg_037_ContinueDialog(char):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_037_T_006", speaker = "ALTER_EGO", callback=Lambda('set_conversation("FRAN", "ALTER_EGO", mode="close_deep", first_obj = "FRAN")'))
    dialog.add_text("D_037_T_007", speaker = "FRAN", callback=Lambda('set_conversation("IRIS", "FRAN", mode="close")'))
    dialog.add_text("D_037_T_008", speaker = "IRIS", callback=Lambda('set_conversation("ALTER_EGO", "FRAN", mode="close_deep", first_obj="ALTER_EGO")'))
    dialog.add_text("D_037_T_009", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = onDlg_037_Ende)
    dialog.start()

## Dialog nach der Rettung, wenn der Spieler die Beiden in ihrer Hütte besucht
def initDlg_038_Fran_Talk_Lifesaver():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_038_T_001", speaker = "FRAN")
    dialog.add_text("D_038_T_002", speaker = "IRIS", follower = "ENDDIALOG")
    dialog.start(False)

## Dialog bevor man mit den 'Hexen' gesprochen hat
def initDlg_004_Lincoln_Scared_Stiff():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_004_T_001", speaker = "LINCOLN")
    dialog.add_text("D_004_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)

## Lincoln informiert den Spieler
def initDlg_005_Lincoln_Talk_Witches():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_005')
    if data().Lincoln_Restart == 0:
        dialog.add_text("D_005_T_001", speaker = "ALTER_EGO")
        dialog.add_text("D_005_T_002", speaker = "LINCOLN")
    dialog.add_choice("D_005_C_001_1", follower = "D_005_T_006", auto_deactivation='permanent')
    dialog.add_choice("D_005_C_001_2", follower = "D_005_T_007", auto_deactivation='permanent')
    dialog.add_choice("D_005_C_001_3", follower = "D_005_T_003", auto_deactivation='permanent')
    dialog.add_choice("D_005_C_001_4", follower = "ENDDIALOG", callback = Allmost_Spoke_Lincoln)
    dialog.add_text("D_005_T_003", speaker = "LINCOLN")
    dialog.add_text("D_005_T_004", speaker = "ALTER_EGO")
    dialog.add_text("D_005_T_005", speaker = "LINCOLN", follower = "D_005_C_002")
    dialog.add_text("D_005_T_006", speaker = "LINCOLN", follower = "D_005_C_002")
    dialog.add_text("D_005_T_007", speaker = "LINCOLN")
    dialog.add_text("D_005_T_008", speaker = "ALTER_EGO")
    dialog.add_text("D_005_T_009", speaker = "LINCOLN", follower = "D_005_C_002")
    dialog.add_choice("D_005_C_002_1", follower = "D_005_T_011", auto_deactivation='permanent')
    dialog.add_choice("D_005_C_002_2", follower = "D_005_T_013", auto_deactivation='permanent')
    dialog.add_choice("D_005_C_002_3", follower = "D_005_T_016", auto_deactivation='permanent')
    dialog.add_choice("D_005_C_002_4", follower = "D_005_T_010", auto_deactivation='permanent')
    dialog.add_text("D_005_T_010", speaker = "LINCOLN", follower = "ENDDIALOG", callback = SpokeToLincoln)
    dialog.add_text("D_005_T_011", speaker = "LINCOLN", follower = "D_005_C_002")
    dialog.add_text("D_005_T_013", speaker = "LINCOLN")
    dialog.add_text("D_005_T_014", speaker = "ALTER_EGO")
    dialog.add_text("D_005_T_015", speaker = "LINCOLN", follower = "ENDDIALOG", callback = SpokeToLincoln)
    dialog.add_text("D_005_T_016", speaker = "LINCOLN", follower = "ENDDIALOG", callback = SpokeToLincoln)
    dialog.start(False)

def Allmost_Spoke_Lincoln():
    data().Lincoln_Restart = 1
    
def SpokeToLincoln():
    data().SpokeToLincoln = 1
    
## Spieler hat noch nicht genug herausgefunden
def initDlg_006_Lincoln_No_Progress(): 
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_006_T_001", speaker = "ALTER_EGO")
    dialog.add_text("D_006_T_002", speaker = "LINCOLN",follower = "ENDDIALOG")
    dialog.start(False)
    
## Spieler hat die Beweise für die Unschuld der Mädchen    
    
def initCutscene_036_QuestSolved():
    system.start_cutscene()
    daily_routine.prohibit_activity("LINCOLN")
    object.cancel_commandos( object = "ALTER_EGO" )
    system.set_camera_view(CAMVIEW_QUEST_SOLVED)
    object.set_position("JENNA", x= 504,y = 274, grid="landscape")
    object.set_position("MARCUS", x = 473.6 ,y =204.6, grid="landscape")
    object.turn_to_object("LINCOLN","ALTER_EGO", callback = ["ONEND", Lincoln_Blame_Jenna])
    
def onDlg_036_JennaGetIntoHouse():
    object.turn_to_object("ALTER_EGO","JENNA")
    object.move_to( object="MARCUS", x = 520.2, y = 266.4, grid="landscape", speed = MT_FAST )
    
def Lincoln_Blame_Jenna(char):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_036_T_001", speaker = "LINCOLN",callback = Lambda('object.move_to( object="JENNA", x = 518.9, y = 270.2, grid="landscape", speed = MT_FAST)'))
    dialog.add_text("D_036_T_002", speaker = "ALTER_EGO", callback = Lambda('set_conversation("JENNA","LINCOLN", mode="medium"); onDlg_036_JennaGetIntoHouse()'))
    # jenna zur tür rein
    dialog.add_text("D_036_T_003", speaker = "JENNA",callback =  Lambda('set_conversation("LINCOLN","JENNA", mode="medium"), object.turn_to_object("MARCUS","JENNA")'))
    dialog.add_text("D_036_T_004", speaker = "LINCOLN",callback= Lambda('system.set_camera_view(CAMVIEW_NAH_JENNA_MARCUS),object.turn_to_object("MARCUS","LINCOLN"),object.turn_to_object("JENNA","MARCUS")'))
    dialog.add_text("D_036_T_005", speaker = "MARCUS")
    dialog.add_text("D_036_T_006", speaker = "MARCUS", callback = Lambda('set_conversation("JENNA","MARCUS", mode="medium")'))
    dialog.add_text("D_036_T_007", speaker = "JENNA",callback = Lambda('set_conversation("MARCUS","JENNA", mode="medium")'))
    dialog.add_text("D_036_T_008", speaker = "MARCUS", callback = Lambda('set_conversation("JENNA","MARCUS", mode="medium")'))
    dialog.add_text("D_036_T_009", speaker = "JENNA",callback = Lambda('set_conversation("MARCUS","JENNA", mode="medium")'))
    dialog.add_text("D_036_T_010", speaker = "MARCUS", callback = Lambda('set_conversation("JENNA","MARCUS", mode="medium")'))
    dialog.add_text("D_036_T_011", speaker = "JENNA",callback = Lambda('set_conversation("LINCOLN","JENNA", mode="medium")'))
    dialog.add_text("D_036_T_012", speaker = "LINCOLN", callback = Lambda('set_conversation("JENNA","LINCOLN", mode="medium")'))
    dialog.add_text("D_036_T_013", speaker = "JENNA",callback = Lambda('set_conversation("LINCOLN","JENNA", mode="medium"),object.turn_to_object("JENNA","LINCOLN")'))
    dialog.add_text("D_036_T_014", speaker = "LINCOLN",callback = Lambda('system.set_camera_view(CAMVIEW_HALBNAH_JENNA)'))
    dialog.add_text("D_036_T_015", speaker = "JENNA",callback = Lambda('set_conversation("LINCOLN","JENNA", mode="medium")'))
    dialog.add_text("D_036_T_016", speaker = "LINCOLN",follower = "ENDDIALOG", callback = QuestSolved)
    dialog.start(False)

def TalkJenna():
    data().TalkJenna = 1

def QuestSolved():
    end_cutscene(chars=["JENNA", "MARCUS", "LINCOLN", "ALTER_EGO"])
    daily_routine.allow_activity("LINCOLN")
    system.notify_region_entered(region="REGION_GRAB",partyid="UISPIELER")
    if (data().RegRogg == 0) :
        system.notify_region_entered(region="REGION_ROGGENFELD",partyid="UISPIELER")
        data().RegRogg = data().RegRogg + 1
    system.notify_region_entered(region="REGION_ZISTERNE",partyid="UISPIELER")
    
    system.start_cutscene()
    system.set_camera_view([531.08087158203125, 268.17596435546875, 8.4598722457885742, -0.91072630882263184, 0.13351169228553772, -0.39083513617515564])
    object.move_to("JENNA",439.1,280.4,"landscape",MT_SLOW)
    object.move_to("ALTER_EGO",485.76,262.56,"landscape",MT_FAST)
    object.turn_to_object("ALTER_EGO","FRAN", callback = ["ONEND",initDlg_037_Fran_Talk_Quest_Solved])
    
## Quest abgeschlossen, Mädels frei    
def initDlg_039_Lincoln_Quest_Solved():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_039')
    dialog.add_text("D_039_T_001", speaker = "LINCOLN")
    if object.get_attribute('ALTER_EGO', 'speech') > 70 :
        dialog.add_choice("D_039_C_001_1", follower = "D_039_T_002", auto_deactivation='permanent')
    else:
        dialog.add_choice("D_039_C_001_1", follower = "D_039_T_003", auto_deactivation='permanent')
    dialog.add_choice("D_039_C_001_2", follower = 'ENDDIALOG', callback = onDlg_039_Ende_1)
    dialog.add_text("D_039_T_002", speaker = "LINCOLN", follower = "ENDDIALOG", callback = onDlg_039_Ende_2)
    dialog.add_text("D_039_T_003", speaker = "LINCOLN")
    dialog.add_text("D_039_T_004", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
# ende ohne belohnung
def onDlg_039_Ende_1():
    pass
# ende mit belohnung
def onDlg_039_Ende_2():
    object.create_item_in_inventory( object="ALTER_EGO",equipment = [
                                    'SET_HEGRENADE',
                                    'SET_HEGRENADE',
                                    'SET_FRAGGRENADE',
                                    'SET_FRAGGRENADE',
                                    'SET_FRAGGRENADE',
                                    'SET_FIREGRENADE'])
    
## Spieler weiss noch nichts von den 'Hexen'
def initDlg_007_Jenna_Bigmouth():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_007_T_001", speaker = "JENNA", follower = "ENDDIALOG")
    dialog.start(False)

## Spieler befragt Jenna zu den Hexereianschuldigungen    
def initDlg_008_Jenna_Speaks():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_008')
    dialog.add_text("D_008_T_001", speaker = "JENNA", follower ="D_008_C_001")
    dialog.add_choice("D_008_C_001_1", follower = "D_008_T_002", callback = Choice_1, auto_deactivation='permanent')
    dialog.add_choice("D_008_C_001_2", follower = "D_008_T_004", callback = Choice_2, auto_deactivation='permanent')
    dialog.add_choice("D_008_C_001_3", follower = "D_008_T_007", callback = Choice_3, auto_deactivation='permanent')
    dialog.add_choice("D_008_C_001_5", follower = "ENDDIALOG", callback = initDlg_009_Jenna_Burns_Brighter)
    dialog.add_text("D_008_T_002", speaker = "JENNA", follower = "D_008_C_001")
    dialog.add_text("D_008_T_004", speaker = "JENNA")
    dialog.add_text("D_008_T_005", speaker = "ALTER_EGO")
    dialog.add_text("D_008_T_006", speaker = "JENNA", follower = "D_008_C_001")
    dialog.add_text("D_008_T_007", speaker = "JENNA", follower = "D_008_C_001")
    dialog.add_text("D_008_T_010", speaker = "JENNA", follower = "D_008_C_001")
    dialog.start(False)

def Choice_1():
    data().Choice_1_taken = 1
    data().JennasaBitch = 1
    
def Choice_2():
    data().Choice_2_taken = 1
    data().JennasaBitch = 1

def Choice_3():
    data().Choice_3_taken = 1
    data().JennasaBitch = 1
    

## Spieler weiss nun das Jenna die eigentliche Hexe ist    
def initDlg_009_Jenna_Burns_Brighter():
    if (data().JennasaBitch == 1) and (data().SpokeToJenna == 0) :
        dialog.init_dialog(type=DIALOGSMALL)
        dialog.add_text("D_009_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
        dialog.start(False)
        data().SpokeToJenna = 1

## Spieler hat wichtigere Dinge zu tun als mit Jenna zu sprechen    
def initDlg_010_Jenna_No_Talking():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_010_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)

## Jenna ist überführt und will ihre Ruhe haben
def initCutscene_040_Jenna_Sulks():
    system.start_cutscene()
    set_conversation("ALTER_EGO","JENNA", mode='medium')
    object.cancel_commandos( "JENNA" )
    prohibit_activity("JENNA")
    character.play_animation( "JENNA", "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 ) )
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_040_T_001", speaker = "JENNA", callback = Lambda('object.turn_to_object("ALTER_EGO","JENNA"),object.turn_to_object("JENNA","ALTER_EGO")'))
    dialog.add_text("D_040_T_002", speaker = "ALTER_EGO")
    dialog.add_text("D_040_T_003", speaker = "JENNA", follower = "ENDDIALOG", callback = JennasDown)
    dialog.start(False)
    
def JennasDown():
    allow_activity("JENNA")
    data().JennasDown = 1 
    system.end_cutscene()

## Jenna weigert sich mit dem Spieler zu sprechen    
def initDlg_041_Jenna_Stays_Shut():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_041_T_001", speaker = "JENNA", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler will noch nicht mit Marcus sprechen
def initDlg_011_Player_doesntknow_Marcus():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_011_T_001", speaker = "MARCUS",  follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Doktor glaubt nicht an Hexen
def initCutscene_012_Doctor_stays_rational():
    system.start_cutscene()
    init_cutscene("ALTER_EGO", "MARCUS", dx=1.4, dy=1.4)
    
    object.turn_to_object( "ALTER_EGO", "MARCUS", callback = ["ONEND", on_dialog_012_start])

def on_dialog_012_start(char=None):
    set_conversation('MARCUS','ALTER_EGO', mode="medium")
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_012_T_001", speaker = "MARCUS",callback = Lambda('set_conversation("ALTER_EGO","MARCUS", mode="medium")'))
    dialog.add_text("D_012_T_002", speaker = "ALTER_EGO", callback = Lambda('set_conversation("MARCUS","ALTER_EGO", mode="close", animate=False)'))#Lambda('system.set_camera_view(CAMVIEW_PLAYER_MARCUS)'))
    dialog.add_text("D_012_T_003", speaker = "MARCUS", callback = Lambda('set_conversation("ALTER_EGO","MARCUS", mode="medium")'))
    dialog.add_text("D_012_T_004", speaker = "ALTER_EGO", callback = Lambda('set_conversation("MARCUS","ALTER_EGO", mode="medium")'))
    dialog.add_text("D_012_T_005", speaker = "MARCUS", follower = "ENDDIALOG", callback = Dlg_012_finished )
    dialog.start(False)
    
def Dlg_012_finished():
    end_cutscene(chars=["MARCUS", "ALTER_EGO"])
    data().Dlg_012_finished = 1 
    initDlg_013_Doctor_searches_Cure()
    
## Der Doktor will die Krankheitsursachen klären 
def initDlg_013_Doctor_searches_Cure():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_013')
    dialog.add_choice("D_013_C_001_1", follower = "D_013_T_001", auto_deactivation='permanent')
    dialog.add_choice("D_013_C_001_2", follower = "D_013_T_002", auto_deactivation='permanent')
    dialog.add_choice("D_013_C_001_3", follower = "D_013_T_003", auto_deactivation='permanent')
    dialog.add_choice("D_013_C_001_4", follower = "ENDDIALOG", callback = restart_013_011)
    dialog.add_text("D_013_T_001", speaker = "MARCUS", follower = "D_013_C_001")
    dialog.add_text("D_013_T_002", speaker = "MARCUS", follower = "D_013_C_001")
    dialog.add_text("D_013_T_003", speaker = "MARCUS")
    dialog.add_text("D_013_T_004", speaker = "ALTER_EGO")
    dialog.add_text("D_013_T_005", speaker = "MARCUS")
    if (data().asked_water == 0):
        dialog.add_choice("D_013_C_002_1", follower = "D_013_T_006", auto_deactivation='permanent')
    if (data().asked_meat == 0):
        dialog.add_choice("D_013_C_002_2", follower = "D_013_T_007", auto_deactivation='permanent')
    if (data().asked_bread == 0):
        dialog.add_choice("D_013_C_002_3", follower = "D_013_T_009", auto_deactivation='permanent')
    if (data().asked_meat and data().asked_bread):
        dialog.add_choice("D_013_C_002_4", follower = "D_013_T_013", auto_deactivation='permanent')
    elif not (data().asked_meat and data().asked_bread):
        dialog.add_choice("D_013_C_002_4", follower = "D_013_T_012", auto_deactivation='permanent')
    dialog.add_text("D_013_T_006", speaker = "MARCUS", follower = "ENDDIALOG", callback = asked_water)
    dialog.add_text("D_013_T_007", speaker = "MARCUS")
    dialog.add_text("D_013_T_008", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = asked_meat)
    dialog.add_text("D_013_T_009", speaker = "MARCUS")
    dialog.add_text("D_013_T_010", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = asked_bread)
    dialog.add_text("D_013_T_011", speaker = "MARCUS", follower = "D_013_C_001")
    dialog.add_text("D_013_T_012", speaker = "MARCUS", follower = "ENDDIALOG", callback = restart_013_014 )
    dialog.add_text("D_013_T_013", speaker = "MARCUS", follower = "ENDDIALOG", callback = Marcus_spoken)
    dialog.add_text("D_013_T_014", speaker = "MARCUS", follower = "D_013_C_002")
    if( data().restart_013_014 == 1 ):
        dialog.add_text("D_013_T_014", speaker = "MARCUS", follower = "D_013_C_002" )
        dialog.jump_to(follower="D_013_T_014")
    elif( data().restart_013_011 == 1 ):
        dialog.add_text("D_013_T_011", speaker = "MARCUS", follower = "D_013_C_001" )
        dialog.jump_to(follower="D_013_T_011")

    dialog.start(False)
    
## Der Doktor will die Krankheitsursachen klären 
def initDlg_013_Doctor_searches_Cure_():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_013a')
    if (data().asked_water == 0):
        dialog.add_choice("D_013_C_002_1", follower = "D_013_T_006", auto_deactivation='permanent')
    if (data().asked_meat == 0):
        dialog.add_choice("D_013_C_002_2", follower = "D_013_T_007", auto_deactivation='permanent')
    if (data().asked_bread == 0):
        dialog.add_choice("D_013_C_002_3", follower = "D_013_T_009", auto_deactivation='permanent')
    if (data().asked_meat and data().asked_bread):
        dialog.add_choice("D_013_C_002_4", follower = "D_013_T_013", auto_deactivation='permanent')
    elif not (data().asked_meat and data().asked_bread):
        dialog.add_choice("D_013_C_002_4", follower = "D_013_T_012", auto_deactivation='permanent')
    dialog.add_text("D_013_T_006", speaker = "MARCUS", follower = "ENDDIALOG", callback = asked_water)
    dialog.add_text("D_013_T_007", speaker = "MARCUS")
    dialog.add_text("D_013_T_008", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = asked_meat)
    dialog.add_text("D_013_T_009", speaker = "MARCUS")
    dialog.add_text("D_013_T_010", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = asked_bread)
    dialog.add_text("D_013_T_011", speaker = "MARCUS", follower = "D_013_C_001")
    dialog.add_text("D_013_T_012", speaker = "MARCUS", follower = "ENDDIALOG", callback = restart_013_014 )
    dialog.add_text("D_013_T_013", speaker = "MARCUS", follower = "ENDDIALOG", callback = Marcus_spoken)
    dialog.add_text("D_013_T_014", speaker = "MARCUS", follower = "D_013_C_002")

    dialog.start(False)

def asked_water():
    data().asked_water = 1
    initDlg_013_Doctor_searches_Cure_()
    system.notify_region_entered(region="REGION_ZISTERNE",partyid="UISPIELER")
    
def asked_bread():
    data().asked_bread = 1
    initDlg_013_Doctor_searches_Cure_()
    
def asked_meat():
    data().asked_meat = 1 
    initDlg_013_Doctor_searches_Cure_()

def Marcus_spoken():
    system.set_qb_entry_state( data().QB_001, INACTIVE )
    system.set_qb_entry_state( data().QB_002, UNCOMPLETE )
    data().SpokeToMarcus = 1
    
def restart_013_011():
    data().restart_013_011 = 1
    
def restart_013_014():
    data().restart_013_014 = 1 
    
## Spieler hat keine Fragen mehr an den Doktor
def initDlg_014_Marcus_No_open_questions():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_014_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Spieler bringt die Listen zum Doktor
def initDlg_034_Marcus_gets_Lists():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_034')
    if (data().restart_034_012 > 0 ):
        dialog.add_text("D_034_T_012", speaker = "MARCUS", follower = "D_034_C_002")
    dialog.add_text("D_034_T_001", speaker = "MARCUS")
    if ("SET_BUTCHERS_LIST" in object.get_inventory_list("ALTER_EGO")):
        dialog.add_choice("D_034_C_001_1", follower = "D_034_T_002", callback = HuntersList_Delete, auto_deactivation='permanent')
    if ("SET_BAKERS_LIST" in object.get_inventory_list("ALTER_EGO")):
        dialog.add_choice("D_034_C_001_2", follower = "D_034_T_006", callback = BakersList_Delete, auto_deactivation='permanent')
    dialog.add_choice("D_034_C_001_3", follower = "ENDDIALOG", callback =  restart_034_001)
    dialog.add_text("D_034_T_002", speaker = "MARCUS")
    dialog.add_text("D_034_T_003", speaker = "ALTER_EGO")
    dialog.add_text("D_034_T_004", speaker = "MARCUS")
    dialog.add_text("D_034_T_005", speaker = "ALTER_EGO", follower = "D_034_C_001", callback = Talk_Hunterlist )
    dialog.add_text("D_034_T_006", speaker = "MARCUS")
    dialog.add_text("D_034_T_007", speaker = "ALTER_EGO")
    dialog.add_text("D_034_T_008", speaker = "MARCUS")
    dialog.add_text("D_034_T_009", speaker = "ALTER_EGO")
    dialog.add_text("D_034_T_010", speaker = "MARCUS")
    dialog.add_choice("D_034_C_002_1", follower = "D_034_T_013")
    dialog.add_choice("D_034_C_002_2", follower = "D_034_T_011")
    dialog.add_text("D_034_T_011", speaker = "MARCUS", follower = "ENDDIALOG", callback = restart_034_012 )
    dialog.add_text("D_034_T_013", speaker = "MARCUS")
    dialog.add_text("D_034_T_014", speaker = "ALTER_EGO")
    dialog.add_text("D_034_T_015", speaker = "MARCUS", follower = "ENDDIALOG", callback = Talk_Bakerlist)
    dialog.start(False)

def HuntersList_Delete():
    object.remove_item_from_inventory("ALTER_EGO", data().qi_butcherlist[1])

def BakersList_Delete():
    object.remove_item_from_inventory("ALTER_EGO", data().qi_bakerlist[1])

def Talk_Bakerlist():
    system.set_qb_entry_state( data().QB_002, INACTIVE )
    system.set_qb_entry_state( data().QB_004, UNCOMPLETE )
    if (data().RegRogg == 0) :
        system.notify_region_entered(region="REGION_ROGGENFELD",partyid="UISPIELER")
        data().RegRogg = data().RegRogg + 1
    data().SpokeToMarcus_bakerlist = 1

def Talk_Hunterlist():
    data().SpokeToMarcus_hunterlist = 1
    
def restart_034_001():
    data().restart_034_001 = 1

def restart_034_012():
    data().restart_034_012 = 1

## Spieler bringt Toxikologiebuch oder Roggen zu Marcus
def initDlg_035_Marcus_solves_Riddle():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_035')
    dialog.add_text("D_035_T_001", speaker = "MARCUS")
    if ( data().Player_got_plant > 0 or cs.group_as_obj("ZZ5 RYE_PLANTS") ) and\
        ( data().Player_got_book > 0 or cs.group_as_obj("Z6 HORATIOS_TOXBOOK") ):#Z6 HORATIOS_TOXBOOK
        if cs.group_as_obj("ZZ5 RYE_PLANTS"):
            dialog.add_choice("D_035_C_001_1", follower = "D_035_T_002", auto_deactivation='permanent')
            dialog.add_text("D_035_T_002", speaker = "MARCUS", follower = "D_035_T_003", callback = SetRayeFlag)
        if cs.group_as_obj("Z6 HORATIOS_TOXBOOK"):
            dialog.add_choice("D_035_C_001_2", follower = "D_035_T_008", auto_deactivation='permanent')
    elif cs.group_as_obj("Z6 HORATIOS_TOXBOOK") and data().Player_got_plant == 0:
        dialog.add_choice("D_035_C_001_2", follower = "D_035_T_007", auto_deactivation='permanent')
    elif cs.group_as_obj("ZZ5 RYE_PLANTS") and data().Player_got_book == 0:
        dialog.add_choice("D_035_C_001_1", follower = "D_035_T_002", auto_deactivation='permanent')
        dialog.add_text("D_035_T_002", speaker = "MARCUS", follower = "D_035_T_002a")
        dialog.add_text("D_035_T_002a", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = SetRayeFlag0)
    dialog.add_choice("D_035_C_001_3", follower = "ENDDIALOG")
    dialog.add_text("D_035_T_003", speaker = "MARCUS", callback = SetToxFlag)
    dialog.add_text("D_035_T_004", speaker = "ALTER_EGO")
    dialog.add_text("D_035_T_005", speaker = "MARCUS")
    dialog.add_text("D_035_T_006", speaker = "MARCUS", follower = "ENDDIALOG", callback = Fran_unguilty)
    dialog.add_text("D_035_T_007", speaker = "MARCUS", follower = "D_035_C_001", callback = SetToxFlag)
    dialog.add_text("D_035_T_008", speaker = "MARCUS", callback = SetToxFlag)
    dialog.add_text("D_035_T_009", speaker = "ALTER_EGO")
    dialog.add_text("D_035_T_010", speaker = "MARCUS", callback = SetRayeFlag)
    dialog.add_text("D_035_T_011", speaker = "MARCUS", follower = "ENDDIALOG", callback = Fran_unguilty )
    dialog.start(False)

def SetToxFlag():
    if not data().Player_got_book:
        object.remove_item_from_inventory("ALTER_EGO", "Z6 HORATIOS_TOXBOOK")
        data().Player_got_book = 1

def SetRayeFlag0():
    system.show_zone_map()
    SetRayeFlag()

def SetRayeFlag():
    if not data().Player_got_plant:
        if cs.group_as_obj(data().qi_ryeplants[1]):
            cs.del_party_inv(data().qi_ryeplants[1])
        data().Player_got_plant = 1
    
def Fran_unguilty():
    system.set_qb_entry_state( data().QB_004, INACTIVE )
    system.set_qb_entry_state( data().QB_003, UNCOMPLETE )
    data().Unguilty = 1
    
## Doktor freut sich den Spieler zu sehen
def initDlg_042_Marcus_likes_Player():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_042_T_001", speaker = "MARCUS",  follower = "ENDDIALOG")
    dialog.start(False)
    
## Robin warnt die Spieler
def initDlg_015_Robin_warns_Player():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_015_T_001", speaker = "ROBIN", follower = "ENDDIALOG")
    dialog.start(False)
    
## Robin glaubt nicht recht an Hexerei
def initDlg_016_Robin_helps_Player():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_016')
    if (data().restart_016_C_001 == 0 ):
        dialog.add_text("D_016_T_010", speaker = "ROBIN")
        dialog.add_text("D_016_T_011", speaker = "ALTER_EGO")
    if ( data().asked_meat > 0 ):
        dialog.add_choice("D_016_C_001_4", follower = "D_016_T_006", auto_deactivation='permanent')
    dialog.add_choice("D_016_C_001_1", follower = "D_016_T_001", auto_deactivation='permanent')
    dialog.add_choice("D_016_C_001_2", follower = "D_016_T_004", auto_deactivation='permanent')
    dialog.add_choice("D_016_C_001_3", follower = "D_016_T_005", auto_deactivation='permanent')
    dialog.add_choice("D_016_C_001_5", follower = "ENDDIALOG", callback = restart_016_C_001)
    dialog.add_text("D_016_T_001", speaker = "ROBIN")
    dialog.add_text("D_016_T_002", speaker = "ALTER_EGO")
    dialog.add_text("D_016_T_003", speaker = "ROBIN", follower = "D_016_C_001_1")
    dialog.add_text("D_016_T_004", speaker = "ROBIN", follower = "D_016_C_001_1")
    dialog.add_text("D_016_T_005", speaker = "ROBIN", follower = "D_016_C_001_1")
    dialog.add_text("D_016_T_006", speaker = "ROBIN")
    dialog.add_text("D_016_T_007", speaker = "ALTER_EGO")
    dialog.add_text("D_016_T_008", speaker = "ROBIN")
    dialog.add_text("D_016_T_009", speaker = "ROBIN", follower = "ENDDIALOG", callback = gotHunterslist )
    dialog.start(False)


def restart_016_C_001():
    data().restart_016_C_001 = 1

def gotHunterslist():
    object.create_item_in_inventory("ALTER_EGO",data().qi_butcherlist[0],data().qi_butcherlist[1])
    object.set_attribute(data().qi_butcherlist[1],"generic_item", False)
    data().got_hunterlist = 1 
    
## Robin ist neugierig auf das Ergebnis
def initDlg_017_Robin_wantstoknow():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_017_T_001", speaker = "ROBIN")
    dialog.add_text("D_017_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Robin ist erleichtert
def initDlg_018_Robin_happytoknow():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_018_T_001", speaker = "ALTER_EGO")
    dialog.add_text("D_018_T_002", speaker = "ROBIN", follower = "ENDDIALOG")
    dialog.start(False)
    
## Robin hat wieder mal kein Fleisch
def initDlg_049_Robin_gotnomeat():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_049_T_001", speaker = "ROBIN", follower = "ENDDIALOG")
    dialog.start(False)
    
## Robin ist froh das der Hexenspuk vorbei ist
def initDlg_043_Robin_happywitchover():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_043_T_001", speaker = "ROBIN", follower = "ENDDIALOG")
    dialog.start(False)
    
## Warren warnt die Spieler
def initDlg_019_Warren_warns_Player():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_019_T_001", speaker = "WARREN", follower = "ENDDIALOG")
    dialog.start(False)
    
## Warren glaubt nicht an Hexerei
def initDlg_020_Warren_helps_Player():
    dialog.init_dialog(type=DIALOGLARGE)
    dialog.set_dialog_identifier(identifier='D_020')
    if (data().restart_020_001 == 0 ):
        dialog.add_text("D_020_T_001", speaker = "WARREN")
        dialog.add_text("D_020_T_002", speaker = "ALTER_EGO")
    dialog.add_choice("D_020_C_001_1", follower = "D_020_T_003", auto_deactivation='permanent')
    dialog.add_choice("D_020_C_001_2", follower = "D_020_T_004", auto_deactivation='permanent')
    dialog.add_choice("D_020_C_001_3", follower = "D_020_T_005", auto_deactivation='permanent')
    if (data().asked_bread > 0 ):
        dialog.add_choice("D_020_C_001_4", follower = "D_020_T_006", auto_deactivation='permanent')
    dialog.add_choice("D_020_C_001_5", follower = "ENDDIALOG", callback = restartDlg020_001 )
    dialog.add_text("D_020_T_003", speaker = "WARREN", follower = "D_020_C_001")
    dialog.add_text("D_020_T_004", speaker = "WARREN", follower = "D_020_C_001", callback = PlayerKnowsField )
    dialog.add_text("D_020_T_005", speaker = "WARREN", follower = "D_020_C_001")
    dialog.add_text("D_020_T_006", speaker = "WARREN")
    dialog.add_text("D_020_T_007", speaker = "ALTER_EGO")
    dialog.add_text("D_020_T_008", speaker = "WARREN")
    dialog.add_text("D_020_T_009", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = gotBakerlist )
    dialog.start(False)
    
def restartDlg020_001():
    data().restart_020_001 = 1
    
def gotBakerlist():
    data().got_bakerlist = 1
    object.create_item_in_inventory("ALTER_EGO",data().qi_bakerlist[0],data().qi_bakerlist[1])
    object.set_attribute(data().qi_bakerlist[1], "generic_item", False)
    
def PlayerKnowsField():
    if (data().RegRogg == 0) :
        system.notify_region_entered(region="REGION_ROGGENFELD",partyid="UISPIELER")
        data().RegRogg = data().RegRogg + 1
    data().PlayerKnowsField = 1
    
## Warren ist neugierig auf das Ergebnis
def initDlg_021_Warren_wantstoknow():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_021_T_001", speaker = "WARREN")
    dialog.add_text("D_021_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)

## Der Spieler will dem Doktor nicht vorgreifen    
def initDlg_022_Warren_dontmakehimnervous():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_022_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)

## Warrens Umsatz geht zurück    
def initCutscene_044_Warren_Businessgetsworse():
    object.cancel_commandos( "WARREN" )
    prohibit_activity("WARREN")
    system.start_cutscene()
    set_conversation("WARREN","ALTER_EGO", mode='medium')
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_044_T_001", speaker = "WARREN", callback = Lambda('set_conversation("ALTER_EGO","WARREN", mode="medium")'))
    dialog.add_text("D_044_T_002", speaker = "ALTER_EGO", callback = Lambda('set_conversation("WARREN","ALTER_EGO", mode="medium")'))
    dialog.add_text("D_044_T_003", speaker = "WARREN")
    dialog.add_text("D_044_T_004", speaker = "WARREN", follower = "ENDDIALOG", callback = badBusiness)
    dialog.start(False)

def badBusiness():
    allow_activity("WARREN")
    end_cutscene(chars=["WARREN", "ALTER_EGO"])
    data().badBusiness = 1

## Warren trauert immer noch
def initDlg_045_Warren_stillmourning():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_045_T_001", speaker = "WARREN")
    dialog.add_text("D_045_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler stellt fest das Duncan schwer krank ist
def initDlg_023_Duncan_issosick():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_023_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler kann nicht mit Duncan reden
def initDlg_024_Duncan_toosicktospeak():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_023_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Duncan trauert um Liz
def initDlg_046_Duncan_mournsLiz():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_046_T_001", speaker = "DUNCAN", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler untersucht das Grab
def initDlg_025_examine_tomb():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_025_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler untersucht das Grab nach Questende
def initDlg_047_examine_tomb_later():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_047_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler wundert sich über die saubere Hütte
def initDlg_026_tiny_hut():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_026_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler fragt sich ob er in Fran und Iris Wohnung steht
def initDlg_027_tiny_hut_later():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_027_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler bewundert die Felder 
def initDlg_028_Player_seesfields():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_028_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)

## Der Spieler bewundert Warrens Felder
def initDlg_029_Player_seesWarrensfields():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_029_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start(False)
    
## Der Spieler nimmt ein paar Roggenpflanzen mit
def initCutscene_030_Player_takesplants():
    system.start_cutscene()
    system.set_camera_view(CAMVIEW_ROGGEN)
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_030_T_001", speaker = "ALTER_EGO",follower = "ENDDIALOG", callback=onDlg_030_PlayerMove)
    dialog.start()

def onDlg_030_PlayerMove():
    object.move_to( object="ALTER_EGO", x = 590, y = 236, grid="landscape", speed = MT_FAST, callback = ["ONEND",Player_gets_plant])

def Player_gets_plant(id):
    character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
    character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
    character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback = ["ONEND", Player_got_plant])    

def Player_got_plant(id):
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_030_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback=onDlg_030_PlayerGetsPlant)
    dialog.start()

def onDlg_030_PlayerGetsPlant():
    system.end_cutscene()
    object.create_item_in_inventory("ALTER_EGO",data().qi_ryeplants[0],data().qi_ryeplants[1])
    object.set_attribute(data().qi_ryeplants[1],"generic_item", False)
    data().GotPlant_orBook = 1
    
## Der Spieler betrachtet die gemähten Felder
def initDlg_48_Player_field_down():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_048_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start()
    
## Der Spieler untersucht die Zisterne
def initDlg_31_Player_examine_Water():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_031_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start()

## Der Spieler untersucht die Zisterne, weiss aber das sie nichts mit den Krankheitsfällen zu tun hat
def initDlg_32_Player_examine_innocentWater():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_032_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start()
    
## Der Spieler untersucht die Zisterne nachdem die Vergiftungen aufgeklärt wurden
def initDlg_33_Player_examine_WaterafterQuest():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_033_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start()

#[NM] Dialog 050: Der Spieler ist enttäuscht
def initDlg_050_SpielerEnttaeuscht():
    data().village_seen = True
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_050_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
    dialog.start()

#[NM] Dialog 051: Der Spieler untersucht den Info-Pfahl
def initDlg_051_SpielerUntersuchtInfoPfahl():
    dialog.init_dialog(type=DIALOGSMALL)
    dialog.add_text("D_051_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback=onDlg_051_Ende)
    dialog.start()

def onDlg_051_Ende():
    set_zone_enabled("sqzone_6", True)
    if(     ( system.get_qb_entry_state(data("zone_6.zone_6").QB_021 ) == INACTIVE )
        and ( system.get_qb_entry_state(data("zone_6.zone_6").QB_022 ) == INACTIVE ) 
      ):
        system.set_qb_entry_state(data("zone_6.zone_6").QB_021, UNCOMPLETE)
