# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
import dialogs
import schedules
import object_events
import comments
import cs_function as cs

#*** actual revision: Revision 16, 21.09.2004***********************************

def initParties():
    system.create_party(id="ANIMALS",type=PT_COMPUTER)
    system.create_party(id="UISPIELER",type=PT_HUMAN)
    system.create_party(id="NPCS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
    start_locations = {"NORTH":(868.39, 271.30), "SOUTH":(203.63, 378.41), "WEST":(203.63, 378.41),\
        "EAST":(868.39, 271.30),}
    if hasattr(data(), 'Player_got_plant') and hasattr(data(), 'Player_got_book'):
        if  data().Player_got_plant == 1 and data().Player_got_book == 0:
            start_locations = {"NORTH":(868.39, 271.30), "SOUTH":(203.63, 378.41), "WEST":(534,303),\
                    "EAST":(868.39, 271.30),}

    if (enterdirection in start_locations.keys()):
        return start_locations[enterdirection]
    else:
        raise ValueError, "no spawn location for this direction registerd: " + enterdirection

def on_init():
    skies.init_sky_preset("orange")

def init_non_rest_areas():
    data("rest").non_rest_areas = []
    if not hasattr(data(), "has_non_rest_areas"):
        data().has_non_rest_areas = True
        #spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)

def on_map_reentry():
    initFX()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    init_non_rest_areas()
    schedules.init_schedules()
    init_patch()

def anim_kl_buehne(objectid=None):
    object.play_animation('BUILDING_2230','ANIM_KL_BUEHNE',callback=['ONEND',anim_kl_buehne])
    #if not hasattr(data(),"windradsound"):
    #    data().windradsound=True
    #    sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_2230', loop=True)
    
def on_map_loaded():
    init_data()
    initParties()
    location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
    system.zone_transfer_place_characters( location[0], location[1] )
    npc.initNPCS()
    initItems()
    initHerbs()
    initExitZones()
    initFX()
    anim_kl_buehne()

    # ae- and party-creation modifier | see debug_py.py for info on parameters
    import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
    
    system.add_region( id = "REGION_KAEFIG", x1 = 500.0, y1 = 271.0, x2 = 472.0, y2 = 240.0 )
    system.notify_region_entered( region="REGION_KAEFIG", partyid="UISPIELER" )
    system.add_region( id = "REGION_ROGGENFELD", x1 = 578.0, y1 = 195.0, x2 = 676.0, y2 = 241.0 )
    system.notify_region_entered( region="REGION_ROGGENFELD", partyid="UISPIELER" )
    system.add_region( id = "REGION_ZISTERNE", x1 = 443.5, y1 = 218.4, x2 = 455.0, y2 = 226.8 )
    system.notify_region_entered( region="REGION_ZISTERNE", partyid="UISPIELER" )
    system.add_region( id = "REGION_GRAB", x1 = 460.4, y1 = 314.8, x2 = 465.0, y2 = 324.0 )
    system.notify_region_entered( region="REGION_GRAB", partyid="UISPIELER" )

    system.add_region("HAUS_LINCOLN",507,267,532,286)
    system.notify_region_entered("HAUS_LINCOLN", partyid="UISPIELER" )
    system.add_region("HAUS_JENNA",403,251,441,280)
    system.notify_region_entered("HAUS_JENNA", partyid="UISPIELER" )
    system.add_region("HAUS_MARKUS",499,304,539,344)
    system.notify_region_entered("HAUS_MARKUS", partyid="UISPIELER" )
    
    system.add_region("REGION_TRES_CABEZAS_1", 513.98, 437.62, 526.00, 482.77)
    system.add_region("REGION_TRES_CABEZAS_2", 513.98, 437.62, 526.00, 482.77)
    
    system.notify_region_entered("REGION_TRES_CABEZAS_1", partyid="UISPIELER")
    system.notify_region_entered("REGION_TRES_CABEZAS_2", partyid="UISPIELER")
    
    data().QB_001 = system.register_qb_entry('ZZONE5_AIM_01')
    data().QB_002 = system.register_qb_entry('ZZONE5_AIM_02')
    data().QB_003 = system.register_qb_entry('ZZONE5_AIM_03')
    data().QB_004 = system.register_qb_entry('ZZONE5_AIM_04')
    
    schedules.init_schedules() ## immer nach dem initQuestbook()
    init_scriptuse_objects()
    #AnimateWindrad()
    InitChestsSafes()
    init_character_states()
    init_non_rest_areas()
    init_main_npcs()

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
    # lagerfeuer
    system.mark_for_script_use("BUILDING_2410")
    # kl_buehne
    system.mark_for_script_use("BUILDING_2230")
    # kisten, truhen, tresore
    system.mark_for_script_use("BUILDING_4317")
    
    system.mark_for_script_use("ZZONE_5_BUILDING_37")
    object.add_closed_lock("ZZONE_5_BUILDING_37", "lock1", closure_type="normal")
    
    # Windrad
    #system.mark_for_script_use('BUILDING_662')
    
    # Bienenstöcke ZZone 5
    system.mark_for_script_use('BUILDING_11203')
    system.mark_for_script_use('BUILDING_11204')
    system.mark_for_script_use('BUILDING_11206')
    system.mark_for_script_use('BUILDING_11205')

    

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
    npcs = system.get_npcs()
    #mortality
    for npc in npcs:
        object.set_immortal_state(npc, True)

def on_enter_region(id, objectid, partyid ):
    # non-permanent triggers: objectid is list of all chars in region
    if type(objectid)==list: objectid=objectid[0]
    #print "[on_enter_region(",id, str(objectid), partyid,"]"
    
    if id == "HAUS_LINCOLN":
        if not data().player_knows_Lincolns_Haus:
            data().player_knows_Lincolns_Haus = True
            system.add_minimap_marker(521,272,"MM_004")# Lincolns Haus

    if id == "HAUS_JENNA":
        if not data().player_knows_Jennas_Haus:
            data().player_knows_Jennas_Haus = True
            system.add_minimap_marker(427,265,"MM_005")# Jennas Haus

    if id == "HAUS_MARKUS":
        if not data().player_knows_Marcus_Haus:
            data().player_knows_Marcus_Haus = True
            system.add_minimap_marker(527,313,"MM_006")# Marcus' Haus

    if id == "REGION_KAEFIG":
        if not data().player_knows_Kaefig:
            data().player_knows_Kaefig = True
            system.add_minimap_marker(489.05,258.09,"MM_001")# Käfig
        dialogs.initCutscene_001_Fran_Talk_Free_Willy()

    if id == "REGION_ROGGENFELD":
        if not data().player_knows_Felder:
            data().player_knows_Felder = True
            system.add_minimap_marker(676.51,210.76,"MM_002")# Felder
        if data().SpokeToMarcus_bakerlist == 1:
            if data().QuestSolved == 1:
                dialogs.initDlg_48_Player_field_down()
                data().RegRogg = data().RegRogg - 1 
            else:
                if data().Player_got_plant == 1:
                    dialogs.initDlg_029_Player_seesWarrensfields()
                    data().RegRogg = data().RegRogg - 1 
                else:
                    dialogs.initCutscene_030_Player_takesplants()
                    data().RegRogg = data().RegRogg - 1 
        else:
            if data().PlayerKnowsField == 1:
                dialogs.initDlg_029_Player_seesWarrensfields()
                data().RegRogg = data().RegRogg - 1 
            else:
                dialogs.initDlg_028_Player_seesfields()
                data().RegRogg = data().RegRogg - 1 
    
    if id == "REGION_ZISTERNE":
        if not data().player_knows_Zisterne:
            data().player_knows_Zisterne = True
            system.add_minimap_marker(449,222.2,"MM_003")# Zisterne
        if data().asked_water == 1:
            if data().QuestSolved == 1:
                dialogs.initDlg_33_Player_examine_WaterafterQuest()
            else:
                dialogs.initDlg_32_Player_examine_innocentWater()
        else:
            dialogs.initDlg_31_Player_examine_Water()

    if id == "REGION_GRAB":
        if data().QuestSolved == 1:
            dialogs.initDlg_047_examine_tomb_later()
        else:
            dialogs.initDlg_025_examine_tomb()

    if id in ["REGION_TRES_CABEZAS_1", "REGION_TRES_CABEZAS_2"]:
        if not data().village_seen:
            dialogs.initDlg_050_SpielerEnttaeuscht()
            if( was_zone_entered( "zone_6.zone_6" ) ):
                system.set_qb_entry_state(data("zone_6.zone_6").QB_019, COMPLETE)
            
def on_post_load():
    initFX()
    schedules.init_schedules()
    init_patch()

def on_approach(target,operator):
    if not object_events.on_approach(target, operator):
        dialogs.on_approach(target, operator)
    
def on_timer(id):
    #print "[debug on_timer()",id,"]"
    pass

def on_wait_for_commando(id):
    return schedules.Activity(id)

def can_leave_zone():
    return True

def cit(npc,items):
    object.create_item_in_inventory(object=npc, equipment=items)

def initItems():
    cit("BUILDING_1351", ["SET_KATANA"] )
    cit("BUILDING_1000", ["SET_BROKEN_SHOVEL","SET_SLEDGE_HAMMER"] )
    cit("BUILDING_730", ["SET_LEATHER_BOOTS","SET_LEATHER_CAP","SET_LEATHER_GLOVES"] )
    cit("BUILDING_2259", ["SET_HAIR_DRYER"] )
    cit("BUILDING_1318", ["SET_TRANSFORMER","SET_COPPER_WIRE"])#trafo
    cit("BUILDING_777", ["SET_BATTERY"])#müll
    cit("BUILDING_1110", ["SET_STEEL_TUBE"])#müll
    cit("BUILDING_1213", ["SET_PLATE_ARMOR"])#klo
    cit("BUILDING_986", ["SET_RAGS","SET_NORMAL_CLOTHES_4"])#wäscheleine
    cit("BUILDING_1181", ["SET_SILENCER"])#wäscheleine
    #kiste
    cit("BUILDING_1181", ["SET_SILENCER"])
    cit("BUILDING_734", ["SET_PAN"])
    cit("BUILDING_858", ["SET_MACHETE"])
    #container
    cit("BUILDING_795", ["SET_SLEDGE_HAMMER","SET_PLIERS"])
    #müll
    cit("BUILDING_1318", ["SET_TIN_CAN","SET_EMPTY_BOTTLE"])
    cit("BUILDING_996", ["SET_AMMONIUM_NITRATE"])
    
    # Bienenstöcke ZZ5
    cit( 'BUILDING_11203', [ 'SET_BEESWAX' ] )
    cit( 'BUILDING_11204', [ 'SET_BEESWAX', 'SET_BEESWAX' ] )
    cit( 'BUILDING_11206', [ 'SET_BEESWAX' ] )
    cit( 'BUILDING_11205', [ 'SET_BEESWAX' ] )

    cit("RONNY", ["SET_DRUGS_PILLS_01"]*40 + ["SET_DRUGS_PILLS_02"]*10 +["SET_DRUGS_PILLS_03"]*7  + ["SET_DRUGS_PILLS_04"]*5)
  
    cit("RONNY", [
            "SET_AKSU74",#AKSU74
            "SET_COLT_ANACONDA",#Colt Anaconda
            "SET_DESERT_EAGLE",#Desert Eagle
            "SET_HK_G11",#G11
            "SET_M_16",#M4A1
            "SET_MG_3",#MG3
            "SET_DRAGUNOV",#Dragonov
            "SET_AMMOPACK_2_12_MM_QB_8"]#Packen 2“12Cal qb8
            +3*["SET_AMMOPACK_4_6_MM"]#3 4,6mm Munition
            +2*["SET_AMMOPACK_3_12_MM"]#2 Packen 3“12Cal
            +4*["SET_AMMOPACK_3_12_MM_QB_8"]#4 Packen 3“12Cal qb8
            +4*["SET_AMMOPACK_2_12_MM"]#4 Packen 2“12Cal
            +4*["SET_AMMOPACK_357"]#4 Packen .357Sig
            +2*["SET_AMMOPACK_357_SUBSONIC"]#2 Packen .357Sig Subsonicmunition
            +11*["SET_AMMOPACK_5_56_MM"]#11 Packen 5,56mm Munition
            +5*["SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE"]#5 Packen 5,56mm Munition Steyr Flechette
            +12*["SET_AMMOPACK_7_62NATO_MM"]#12 Packen 7,62 nato Munition
            +8*["SET_AMMOPACK_7_62NATO_MM_DUPLEX"]#8 Packen 7,62 nato duplex Munition
            +2*["SET_AMMOPACK_7_62NATO_MM_SABOT"]#2 Packen 7,62 nato sabot Munition
            +5*["SET_AMMOPACK_5_45_MM"]#5 Packen 5,45mm Munition
            +3*["SET_AMMOPACK_9_MM"]#3 Packen 9mm Munition
            +3*["SET_AMMOPACK_9_MM_SUBSONIC"]#3 Packen 9mm Subsonicmunition
            +4*["SET_AMMOPACK_4_73_CASELESS"]#4 Packen 4,73 Caseless
            +4*["SET_MEDIPACK_SMALL"]#4 x medipack_small
            +3*["SET_MEAT_COOKED"]#3 x meat_cooked
            +2*["SET_MEAT_COOKED_SMALL"]#2 x meat_cooked_small
            +4*["SET_WATER_SKIN"]#4 x water_skin
            +2*["SET_WATER_BOTTLE"]#2 x water_bottle
            +2*["SET_MEDIPACK_BIG"]#2 x medipack_big
            +3*["SET_APPLE"]#3 x apple
            +2*["SET_CORN_COB"]#2 x corn_cob
            +4*["SET_OINTMANT_JAR"]
            +3*["SET_AMMOPACK_7_62SOVJET_MM"]
            +["SET_AMMOPACK_50",#Packen .50AE Munition
            "SET_AMMOPACK_7_62SOVJET_MM",#Packen 7,62x39mmR Munition
            "SET_POTATO",#Kartoffeln
            "SET_STEEL_HELMET",#Stahlhelm
            "SET_PLATE_ARMOR",#Plattenpanzerung
            "SET_STEEL_CLAD_BOOTS",#Stahlkappenstiefel
            "SET_DT21_STEEL_CLAD_BOOTS",#dt21 boots
            "SET_PLATE_ARMOR",#plate_armor
            "SET_PLATE_GLOVES",#plate_gloves
            "SET_STEEL_HELMET",#steel helmet
            "SET_STEEL_CLAD_BOOTS",#steel clad boots
            "SET_HACKSAW"#eisensäge
            ])

    # Items in Kisten
    cit( 'BUILDING_4317', ['SET_SUGAR', 'SET_HEGRENADE', 'SET_AMMOPACK_38_DUMDUM'] )
    cit( 'BUILDING_6929', ['SET_ALOE_VERA', 'SET_PLATE_GLOVES', 'SET_CLUB'] )
    cit( 'BUILDING_6937', ['SET_AMMOPACK_4_73_CASELESS', 'SET_STEEL_CLAD_BOOTS', 'SET_MEAT_COOKED'] )
    cit( 'BUILDING_6938', ['SET_KEROSENE_CANISTER', 'SET_AMMOPACK_7_65_MM_SUBSONIC_DUMDUM', 'SET_PLATE_ARMOR'] )
    cit( 'BUILDING_6964', ['SET_BIG_KNIFE', 'SET_SAWED_OFF_REMINGTON_M870', 'SET_HK_G11'] )
            

def initHerbs():
    system.create_object(equipmenttype="SET_BURNET", x=205.04, y=322.06)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=252.93, y=376.13)
    system.create_object(equipmenttype="SET_BURNET", x=612.56, y=482.81)
    system.create_object(equipmenttype="SET_BURNET", x=587.47, y=271.42)
    system.create_object(equipmenttype="SET_WOOD_GARLIC", x=753.93, y=308.08)
    
def initExitZones():
    system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 1119.00, y2 = 200.0 )
    system.register_exit(regionname = "REGION_EXIT_NORD" )
    system.add_region( id = "REGION_EXIT_SUED", x1 = 0.00, y1 = 703.00, x2 = 1119.00, y2 = 503.00 )
    system.register_exit(regionname = "REGION_EXIT_SUED" )
    system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 200.00, x2 = 201.0, y2 = 503.0 )
    system.register_exit(regionname = "REGION_EXIT_WEST" )
    system.add_region( id = "REGION_EXIT_OST", x1 = 915.00, y1 = 200.0, x2 = 1119.00, y2 = 503.00 )
    system.register_exit(regionname = "REGION_EXIT_OST" )

#untersuchungs callbacks
def can_examine_object(char, obj):
    if obj == "ZZONE_5_BUILDING_5493":
        return True
    return False

def on_examine_object(char, obj):
    if obj == "ZZONE_5_BUILDING_5493":
        if char == "ALTER_EGO":
            if not data().infopole_seen:
                dialogs.initDlg_051_SpielerUntersuchtInfoPfahl()
                data().infopole_seen = True
                return True
        comments.comment(char, "EXAMINE_INFOPOLE")

def initFX():
    fxLagerFeuer('ZZONE_5_BUILDING_2410')
    
def AnimateWindrad(id=None):
    object.play_animation('ZZONE_5_BUILDING_662','ANIM_WINDRAD',callback=['ONEND', AnimateWindrad])

def fxLagerFeuer(_objectid):
    system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
    #system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
    system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
    system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
    system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
    system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
    sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

def on_button_down(Button):
    return False

def on_trade(target,operator):
    if target=="RONNY":
        object.cancel_commandos(target)
        prohibit_activity(target)
        lambda_string = 'system.trading_screen(trader="%s",char="%s")' %(target,operator)
        object.turn_to_object(target, operator, callback=["ONEND", Lambda(lambda_string)])

def on_exit_trader( trader_id, negotiator_id, profit ):
    allow_activity(trader_id)
    return object_events.on_exit_trader( trader_id, negotiator_id, profit)

def can_enter_building( character_id, building_id ):
    if building_id == "ZZONE_5_BUILDING_37":
        if character_id in system.get_pcs():
            return False
    return object_events.can_enter_building( character_id, building_id )

def can_crack_lock( character_id, object_id, dummy_name ):
    if object_id == "ZZONE_5_BUILDING_37":
        return False
    return object_events.can_crack_lock( character_id, object_id, dummy_name )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id == "ZZONE_5_BUILDING_37":
        return False
    return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

def can_blast_lock( character_id, object_id, dummy ):
    if object_id == "ZZONE_5_BUILDING_37":
        return False
    return object_events.can_blast_lock( character_id, object_id, dummy )

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
    if object_id == "ZZONE_5_BUILDING_37":
        return False
    return on_blast_lock( character_id, object_id, dummy_name, x, y, z )
    
def InitChestsSafes():
    object.add_closed_lock("BUILDING_4317", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_6929", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_6937", "lock1", closure_type='normal')
    object.add_closed_lock("BUILDING_6938", "lock1", closure_type='lock-trap')
    object.add_closed_lock("BUILDING_6964", "lock1", closure_type='lock-trap')

def init_patch():
    if "ANIE" in system.get_npcs():
        if object.is_active("ANIE"):
            data("zone_7.zone_7").anie_folgt = True

    if not hasattr(data(),'QB_004'):
        data().QB_004 = -1
        data().QB_004 = system.register_qb_entry('ZZONE5_AIM_04')
        if system.get_qb_entry_state( data().QB_003) == globals.UNCOMPLETE:
            system.set_qb_entry_state( data().QB_004, INACTIVE)
        elif system.set_qb_entry_state( data().QB_002)  == globals.INACTIVE:
            system.set_qb_entry_state( data().QB_004, UNCOMPLETE)
    if not hasattr(data(),'village_seen'):
        data().village_seen = False
        if (data().QuestSolved or data().player_knows_Kaefig or data().player_knows_Felder or data().player_knows_Zisterne or data().player_knows_Lincolns_Haus or data().player_knows_Jennas_Haus or data().player_knows_Marcus_Haus):
            data().village_seen = True
            if( was_zone_entered( "zone_6.zone_6" ) ):
                if system.get_qb_entry_state(data("zone_6.zone_6").QB_019) != globals.COMPLETE:
                    system.set_qb_entry_state(data("zone_6.zone_6").QB_019, COMPLETE)
    schedules.init_schedules()
    import comments
                    
    init_main_npcs()
def init_main_npcs():
    npcs = system.get_npcs()
    if "RONNY" in npcs:
        character.set_main_quest_npc_state(char="RONNY", state=True)                
