# -*- coding: utf-8 -*-
from globals import *
from const import *
import npc
from types import *
import schedules
import zzone_6
from dynamic_camera import *
from enemy_script import *
import daily_routine

#*** actual Revision 4, 20.08.2004 ***********************************
####################
# Dialog Scheduler #
####################
def on_approach( target, operator ):
	if dialog.is_dialog_active():
		return
	if schedules.Dialog( target, operator ):
			return
			
	if target == "LEE":
		if data().First_Talk_Lee == 0:
			initCutscene_018_LeeGreetsPlayer()
		else:
			initDlg_019_LeeHasInfo()
	elif target == "ADRINA":
		initDlg_020_AdrinaEinsam()
	elif target == "DARLA":
		initDlg_021_DarlaVermisstFreundin()
	elif target == "ALBERT":
		initDlg_022_AlbertWillWeg()
		
def initDlg_020_AdrinaEinsam():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_020_T_001', speaker="ADRINA", follower='ENDDIALOG')
	dialog.start()
	
def initDlg_021_DarlaVermisstFreundin():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_021_T_001', speaker="DARLA", follower='ENDDIALOG')
	dialog.start()
	
def initDlg_022_AlbertWillWeg():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='D_022_T_001', speaker="ALBERT", follower='ENDDIALOG')
	dialog.start()
	
def initCutscene_018_LeeGreetsPlayer():
	object.cancel_commandos("LEE")
	object.turn_to_object("LEE", "ALTER_EGO")
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_SCHMIEDE)
	init_cutscene("ALTER_EGO", "LEE", dx=2, dy=0.5)
	object.turn_to_object( "ALTER_EGO", "LEE", callback=["ONEND", on_dialog_018_start])

def on_dialog_018_start(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_018_T_001", speaker = "LEE", callback = 
		Lambda('set_conversation("ALTER_EGO","LEE", mode="medium_deep")'))
		
	dialog.add_text( text = "D_018_T_002", speaker = "ALTER_EGO", callback = 
		Lambda('set_conversation("LEE","ALTER_EGO", mode="medium_deep")'))
		
	dialog.add_text( text = "D_018_T_003", speaker = "LEE", callback =
		Lambda('set_conversation("ALTER_EGO","LEE", mode="medium_deep")'))
		
	dialog.add_text( text = "D_018_T_004", speaker = "ALTER_EGO", callback = 
		Lambda('set_conversation("LEE","ALTER_EGO", mode="close_deep")'))

	dialog.add_text( text = "D_018_T_005", speaker = "LEE", follower = "ENDDIALOG", callback = Cutscene_beenden_Schmiede)
	dialog.start()

def Cutscene_beenden_Schmiede():
	end_cutscene(chars=["LEE", "ALTER_EGO"])
	initDlg_019_LeeHasInfo()
	data().First_Talk_Lee = 1	
		
def initDlg_019_LeeHasInfo():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_choice( text = "D_019_C_001_1", follower = "D_019_T_001")
	
	if (data().Schlucht_gesehen == 1 and not (system.get_qb_entry_state(data().QB_002)==COMPLETE)):
		dialog.add_choice( text = "D_019_C_001_2", follower = "D_019_T_003", callback = Schlucht_gefragt, order = 98)
	
	if data().Familie_gesehen == 0 :
		dialog.add_choice( text = "D_019_C_001_3", follower = "D_019_T_004", callback = Familienbesichtigung)
	dialog.add_choice( text = "D_019_C_001_4", follower = "D_019_T_005")
	
	if object.count_in_inventory("ALTER_EGO",data().qi_chain[1]):
		dialog.add_choice( text = "D_019_C_001_7", follower = "D_019_T_008")
	
	if (data().Balista_repariert == 1) and (data().Balista_geschossen == 0) :
		dialog.add_choice( text = "D_019_C_001_8", follower = "D_019_T_010", order = 2)
	
	if data().Balista_geschossen == 1 :
		dialog.add_choice( text = "D_019_C_001_9", follower = "D_019_T_012", order = 1)
	
	dialog.add_text( text = "D_019_T_001", speaker = "LEE")
	dialog.add_text( text = "D_019_T_002", speaker = "ALTER_EGO", follower = "D_019_C_001")
	dialog.add_text( text = "D_019_T_003", speaker = "LEE", follower = "D_019_C_001", callback=on_dialog_019_qb_update)
	dialog.add_text( text = "D_019_T_004", speaker = "LEE", follower = "D_019_C_001")
	dialog.add_text( text = "D_019_T_005", speaker = "LEE", follower = "D_019_C_001")
	dialog.add_text( text = "D_019_T_006", speaker = "LEE", follower = "D_019_C_001", callback = Balista_anschauen)
	dialog.add_text( text = "D_019_T_007", speaker = "LEE", follower = "D_019_C_001", callback = on_dialog_info_on_ballista)
	dialog.add_text( text = "D_019_T_009", speaker = "LEE", follower = "D_019_C_001")
	dialog.add_text( text = "D_019_T_010", speaker = "LEE")
	dialog.add_text( text = "D_019_T_011", speaker = "ALTER_EGO", follower = "D_019_C_001")
	dialog.add_text( text = "D_019_T_012", speaker = "LEE", follower = "D_019_C_001")
	dialog.add_text( text = "D_019_T_008", speaker = "LEE", follower = "ENDDIALOG", callback = Kette_reparieren)
	dialog.add_choice( text = "D_019_C_001_10", follower = "ENDDIALOG", order = 0)
	dialog.start(False)

def init_dialog_019_kette_geben():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_019_T_008", speaker = "LEE", follower = "ENDDIALOG", callback = Kette_reparieren)
	dialog.start()
	
def on_dialog_019_qb_update():
	if not system.get_qb_entry_state(data().QB_001) in [UNCOMPLETE, COMPLETE]:
		system.set_qb_entry_state(data().QB_001, UNCOMPLETE)

def Balista_anschauen():
	data().Balista_angeschaut = 1
	
def on_dialog_info_on_ballista():
	data().lee_info_ballista = 1
	data().Alles_fehlt = 1
	data().Balista_angeschaut = 1

def Familienbesichtigung():
	data().Familie_gesehen = 1

def Schlucht_gefragt():	
	data().Schlucht_gefragt = 1
	if data().Balista_angeschaut == 0 :
		dialog.add_choice( text = "D_019_C_001_5", follower = "D_019_T_006", order = 99)
	dialog.add_choice( text = "D_019_C_001_6", follower = "D_019_T_007", order = 99)
	
def Kette_reparieren():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_SCHMIEDE)
	object.move_to("LEE", 287.37,290.21, grid="landscape",speed = MT_SLOW, callback = ["ONEND", Kette_repariert])
	object.move_to("ALTER_EGO", 292.26, 291.36)
	object.remove_item_from_inventory("ALTER_EGO", data().qi_chain[1])

def Kette_repariert(id):
	character.play_animation("LEE" , "CM_PRAEPARIEREN_STEHEN_ANSCHRITT")
	character.play_animation("LEE" , "CM_PRAEPARIEREN_STEHEN_LOOP")
	character.play_animation("LEE" , "CM_PRAEPARIEREN_STEHEN_LOOP")
	character.play_animation("LEE" , "CM_PRAEPARIEREN_STEHEN_ENDSCHRITT")
	object.move_to("LEE", 288.74, 292.37, speed=MT_SLOW)
	object.turn_to_object("LEE","ALTER_EGO", callback=["ONEND", on_dialog_019_start])
	object.turn_to_object("ALTER_EGO","LEE")
	object.create_item_in_inventory("ALTER_EGO", data().qi_chain_repaired[0],data().qi_chain_repaired[1])
	object.set_attribute(data().qi_chain_repaired[1],"generic_item", False)

def on_dialog_019_start(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_019_T_009", speaker = "LEE", follower = "ENDDIALOG", callback = Kette_zurueck)
	dialog.start()

def Kette_zurueck():
	system.end_cutscene()
	#initDlg_019_LeeHasInfo()
	
def initDlg_006_BalistaErsterEindruck():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_006_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_007_BalistaNuetzlich():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_007_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback=on_dialog_007_ende)
	dialog.start()

def on_dialog_007_ende():
	data().Alles_fehlt = 1
	data().Balista_angeschaut = 1

def initDlg_008_RWK_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_008_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_009_WK_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_009_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_010_RK_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_010_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_011_RW_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_011_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_012_R_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_012_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()
	
def initDlg_013_W_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_013_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_014_K_fehlt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_014_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def check_balista():
	if data().Balista_Zustand == 7:
		initDlg_015_Balista_komplett()
	
def initDlg_015_Balista_komplett():
	onDlg_015_marker()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_015_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def onDlg_015_marker():
	if not data().player_knows_Balista:
		data().player_knows_Balista = True
		system.add_minimap_marker(355.96, 360.11,"MM_003")# Balista

def initDlg_029_KatapultErsterEindruck():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_029_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()

def initDlg_023_SpielerRadAnbringen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_023_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = check_balista)
	dialog.start()

def initDlg_024_SpielerWurfarmAnbringen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_024_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = check_balista)		
	dialog.start()	

def initDlg_025_SpielerKetteAnbringen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_025_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = check_balista)
	dialog.start()
	
def initDlg_026_SpielerFindetKette():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_026_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")	
	dialog.start()	

def on_dialog_027_take_wheel(char):
	data().Rad_genommen = 1
	object.create_item_in_inventory("ALTER_EGO", data().qi_wheel[0],data().qi_wheel[1])
	object.set_attribute(data().qi_wheel[1],"generic_item", False)
	object.set_active_state("BALISTA_UNFERTIG", False)
	object.set_active_state("BALISTA_UNFERTIG_OHNE_RAD", True)
	object.step_to(char, 285.65,211.66, speed=MT_SLOW, callback=["ONEND",Lambda('system.end_cutscene()')])

def initDlg_027_SpielerFindetRad():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BALLISTA_RAD)
	object.move_to("ALTER_EGO", 285.65,211.66, speed=MT_SLOW)
	object.step_to("ALTER_EGO", 284.55,211.51, speed=MT_SLOW)
	object.turn_to_object("ALTER_EGO", "BALISTA_UNFERTIG", callback=["ONEND", on_dialog_027_work])

def on_dialog_027_work(char):
	character.play_animation(char,'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_START')
	character.play_animation(char,'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_2')
	character.play_animation(char,'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_ENDE', callback=["ONEND", on_dialog_027_take_wheel])
	
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_027_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")	
	dialog.start()	
	
def initDlg_028_SpielerUntersuchtBalistawrack():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_028_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")	
	dialog.start()

def initDlg_030_SpielerUntersuchtAuto():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_030_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")	
	dialog.start()	

def initCutscene_031_SpielerFindetBlattfeder():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BALLISTA_BLATTFEDER)
	dialog.init_dialog(type=DIALOGSMALL)
	object.move_to("ALTER_EGO", 315.32, 256.30, speed=MT_SLOW)
	object.step_to("ALTER_EGO", 314.12, 256.84, speed=MT_SLOW)
	object.turn_to_object("ALTER_EGO",'ZZONE_6_BUILDING_3608', callback=["ONEND", on_dialog_031_work])
	
def on_dialog_031_work(char):
	character.play_animation(char, 'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_START')
	character.play_animation(char, 'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_3')
	character.play_animation(char, 'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_ENDE', callback=["ONEND", on_dialog_031_take_suspension])
	dialog.add_text( text = "D_031_T_001", speaker = "ALTER_EGO")
	dialog.add_text( text = "D_031_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG")
	dialog.start()
	
def on_dialog_031_take_suspension(char):
	object.step_to(char, 315.32, 256.30, speed=MT_SLOW, callback=["ONEND", Lambda('system.end_cutscene()')])
	data().Feder_genommen = 1
	object.create_item_in_inventory("ALTER_EGO", data().qi_feather[0],data().qi_feather[1])
	object.set_attribute(data().qi_feather[1],"generic_item",False)

def Cutscene_beenden():
	if system.is_cutscene():
		system.end_cutscene()

def initCutscene_001_SpielerBestauntBruecke():
	object.cancel_commandos("ALTER_EGO")
	object.set_position("ALTER_EGO", 381.60,452.9)
	data().UeberquerungVon == "DORF"
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BRUECKE)
	object.move_to(object="ALTER_EGO", x = 385.6, y = 452.9, grid="landscape", speed = MT_FAST, callback = ["ONEND", Bruecke_bestaunen])

def initCutscene_001_SpielerBestauntBruecke_AndereSeite():
	object.cancel_commandos("ALTER_EGO")
	object.set_position("ALTER_EGO", 452.7, 452.68)
	data().UeberquerungVon = "OSTEN"
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BRUECKE_ANDERESEITE)
	object.move_to(object="ALTER_EGO", x = 447.5, y = 452.44, grid="landscape", speed = MT_FAST, callback = ["ONEND", Bruecke_bestaunen])

def Bruecke_bestaunen(id):
	dialog.init_dialog(type=DIALOGSMALL)
	object.turn_to_object("ALTER_EGO", "ZZONE_6_BUILDING_4")
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_WARTEN_2")
	dialog.add_text(text = "D_001_T_001", speaker = "ALTER_EGO")
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_WARTEN_1")	
	dialog.add_text(text = "D_001_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = on_dialog_001_ende)
	dialog.start()

def on_dialog_001_ende():
	system.set_qb_entry_state(data().QB_002, UNCOMPLETE)
	data().Schlucht_gesehen = 1
	system.end_cutscene()
	
def initCutscene_002_PCFaellt(objectid):
	if not system.is_cutscene():
		system.start_cutscene()

	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				daily_routine.prohibit_activity(folger)
				object.cancel_commandos(folger)
	for pcs in system.get_pcs():
		if not pcs == objectid:
			if object.get_grid(pcs) in ["ZZONE_6_BUILDING_4_INTERIOR_GRID","ZZONE_6_BUILDING_4_INTERIOR_GRID3"]:
				object.cancel_commandos(pcs)

	if data().UeberquerungVon == "DORF":
		x,y,z = object.get_full_dummy_position("ZZONE_6_BUILDING_4", "dmyp_001")
		system.set_camera_view(CAMVIEW_BRUECKEN_CS)
		#workaround
		object.move_to(objectid, x,y, grid = 'ZZONE_6_BUILDING_4_INTERIOR_GRID2', callback=["ONEND", PCFaellt_TimerAktivieren])
		object.turn_to_direction(objectid, globals.DIR_EAST, callback = ["ONEND", PlaySturz])
	else:
		x,y,z = object.get_full_dummy_position("ZZONE_6_BUILDING_4", "dmyp_002")
		system.set_camera_view(CAMVIEW_BRUECKEN_CS_ANDERESEITE)
		#workaround
		object.move_to(objectid, x,y, grid = 'ZZONE_6_BUILDING_4_INTERIOR_GRID2', callback=["ONEND", PCFaellt_TimerAktivieren])
		object.turn_to_direction(objectid, globals.DIR_WEST, callback = ["ONEND", PlaySturz])

def PCFaellt_TimerAktivieren(id):
	system.notify_timer(data().TimerBruecke001, data().TimerBruecke001Value)
	
def PlaySturz(objectid):
	if data().UeberquerungVon == "DORF":
		system.set_camera_view(CAMVIEW_B_ENTER)
		character.play_animation(objectid, "CM_GEHEN_DURCH_BRUECKE_KRACHEN", callback = ["ONEND", NachSturzTod])
		character.play_animation(objectid, "CM_GEHEN_DURCH_BRUECKE_KRACHEN_BACKFLIP", callback=["ONEND",absturz_kill])
	else:
		system.set_camera_view(CAMVIEW_B_ANDERE_SEITE_ENTER)
		character.play_animation(objectid, "CM_GEHEN_DURCH_BRUECKE_KRACHEN_VON_DER_ANDEREN_SEITE", callback = ["ONEND", NachSturzTod])
		character.play_animation(objectid, "CM_GEHEN_DURCH_BRUECKE_KRACHEN_VON_DER_ANDEREN_SEITE_BACKFLIP", callback=["ONEND",absturz_kill])
	
def NachSturzTod(objectid):
	if data().UeberquerungVon == "DORF":
		system.set_camera_view(CAMVIEW_BRUECKE)
	else:
		system.set_camera_view(CAMVIEW_BRUECKE_ANDERESEITE)
	dialog.init_dialog(type=DIALOGSMALL)
	if objectid != "ALTER_EGO":
		dialog.add_text( text = "D_003_T_001", speaker = objectid)
		if is_in_area(["ALTER_EGO"], 45, objectid):
			dialog.add_text( text = "D_003_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = end_cutscene)
	else:
		dialog.add_text( text = "D_002_T_001", speaker = objectid, follower = "ENDDIALOG", callback = end_cutscene)
	dialog.start(False)
	
def absturz_kill(char):
	object.cancel_commandos(char)
	object.set_position_free(char, 419.40,453.49, 0, grid="landscape") # noch besser zielen
	object.step_to(char,419.0,453.0, callback=["ONEND", Lambda('object.destroy("%s")'%(char))])

	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				daily_routine.allow_activity(folger)


##############
##############

def initCutscene_005_PCUeberquertBrueckeRobben(char):
	system.start_cutscene()
	data().SindSchonDrueben = []
	
	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA","ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				object.cancel_commandos(folger)
				daily_routine.prohibit_activity(folger)
		
	if data().UeberquerungVon == "DORF":
		system.set_camera_view([421.680419921875, 458.1925048828125, 25.033969879150391, -0.80003917217254639, -0.46032479405403137, -0.38475760817527771])
	elif data().UeberquerungVon == "OSTEN":
		system.set_camera_view([415.10446166992187, 458.4453125, 24.058353424072266, 0.8241279125213623, -0.47619602084159851, -0.30667659640312195])
	system.fade(FADE_OUT, callback = Lambda('on_dialog_005_move_over_bridge("%s")'%char))

def on_dialog_005_move_over_bridge(char):
	object.cancel_commandos(char)

	if data().UeberquerungVon == "DORF":
		object.set_position(char, 412.32, 452.46, grid = 'ZZONE_6_BUILDING_4_INTERIOR_GRID2')
		object.set_direction(char, 90)
	elif data().UeberquerungVon == "OSTEN":
		object.set_position(char, 424.32, 452.46, grid = 'ZZONE_6_BUILDING_4_INTERIOR_GRID2')
		object.set_direction(char, 270)

	system.set_camera_view([418.01834106445313, 461.57107543945312, 31.268421173095703, 0.0051269517280161381, -0.59588611125946045, -0.80305272340774536])

	system.fade(FADE_IN)
	
	if data().UeberquerungVon == "DORF":
		object.move_to(char, 424.32, 452.46, grid = 'ZZONE_6_BUILDING_4_INTERIOR_GRID2', speed = MT_SLOW)
	else:
		object.move_to(char, 412.32, 452.46, grid = 'ZZONE_6_BUILDING_4_INTERIOR_GRID2', speed = MT_SLOW)
	character.change_body_mode(char,"STAND", callback = ["ONEND",Lambda('on_dialog_005_player_reaches_end("%s")'%char)])

def on_dialog_005_player_reaches_end(char):
	if data().UeberquerungVon == "DORF":
		object.move_to(char,429.32, 452.46,grid = "ZZONE_6_BUILDING_4_INTERIOR_GRID3", callback = ["ONEND",Lambda('runter_von_bruecke("%s")'%char)])
	else:
		object.move_to(char,406.32, 452.46,grid = "ZZONE_6_BUILDING_4_INTERIOR_GRID", callback = ["ONEND",Lambda('runter_von_bruecke("%s")'%char)])

def runter_von_bruecke(char):
	if data().UeberquerungVon == "DORF":
		object.move_to(char, WESTEN_NACH_BRUECKE[len(data().SindSchonDrueben)][0], WESTEN_NACH_BRUECKE[len(data().SindSchonDrueben)][1], grid = "landscape", speed = globals.MT_FAST, callback = ["ONEND",Lambda('bruecke_verlassen("%s")'%char)])
	else:
		object.move_to(char, OSTEN_NACH_BRUECKE[len(data().SindSchonDrueben)][0], OSTEN_NACH_BRUECKE[len(data().SindSchonDrueben)][1], grid = "landscape", speed = globals.MT_FAST, callback = ["ONEND",Lambda('bruecke_verlassen("%s")'%char)])

	drueben = 1
	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA","ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				if data().UeberquerungVon == "DORF":
					object.set_position(folger, WESTEN_NACH_BRUECKE[drueben][0], WESTEN_NACH_BRUECKE[drueben][1], grid = "landscape")
				else:
					object.set_position(folger, OSTEN_NACH_BRUECKE[drueben][0], OSTEN_NACH_BRUECKE[drueben][1], grid = "landscape")
				drueben += 1
				check_alle_drueben(folger)

	for pcs in system.get_pcs():
		if not object.is_destroyed(pcs):
			if not pcs == char:
				if data().UeberquerungVon == "DORF":
					object.set_position(pcs, WESTEN_NACH_BRUECKE[drueben][0], WESTEN_NACH_BRUECKE[drueben][1], grid = "landscape")
				else:
					object.set_position(pcs, OSTEN_NACH_BRUECKE[drueben][0], OSTEN_NACH_BRUECKE[drueben][1], grid = "landscape")
				object.set_attribute(pcs, "zz6_rob_over_bridge", True)
				character.set_body_mode(pcs, "STAND")
				drueben += 1
				check_alle_drueben(pcs)

def bruecke_verlassen(char):
	object.set_attribute(char, "zz6_rob_over_bridge", True)
	check_alle_drueben(char)
	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA","ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				daily_routine.allow_activity(folger)

	if system.is_cutscene():
		system.end_cutscene()
		on_dialog_005_comment_move(char)

def on_dialog_005_comment_move(objectid):
	if not data().schongerobbt:
		dialog.init_dialog(type=DIALOGSMALL)
		if objectid == "ALTER_EGO":
			dialog.add_text( text = "D_005_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
		else:
			if object.get_attribute(objectid, "gender") == "male":
				dialog.add_text( text = "D_004_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG")
			else:
				dialog.add_text( text = "D_004_T_001F", speaker = "ALTER_EGO", follower = "ENDDIALOG")
		dialog.start()
		data().schongerobbt = True

def initCutscene_016_BalistaZurSchlucht():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BALISTA_DORF)
	dialog.init_dialog(type=DIALOGSMALL)
	object.move_to("ALTER_EGO", 297.95, 304.36, grid="landscape", speed = MT_SLOW)
	object.step_to("ALTER_EGO", 296.51, 304.52, speed=MT_SLOW)
	object.turn_to_object("ALTER_EGO", "ZZONE_6_BUILDING_143", callback = ["ONEND", BalistaZurSchlucht_Text])
	
def BalistaZurSchlucht_Text(id):
	character.change_body_mode("ALTER_EGO", "KNEEL")
	dialog.add_text(text = "D_016_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = Cutscene_beenden_Balista)
	dialog.start()

def Cutscene_beenden_Balista():
	character.change_body_mode("ALTER_EGO", "STAND")
	object.step_to("ALTER_EGO", 299.03, 305.18, speed=MT_SLOW, callback=["ONEND", on_dialog_016_fade_out])

def on_dialog_016_fade_out(char):
	system.fade(FADE_OUT, on_dialog_016_reposition_after_fade_out)

def on_dialog_016_reposition_after_fade_out(param=None):
	object.set_position_free("BUILDING_143", 388.77, 366.71, -0.15)
	object.set_position("ALTER_EGO",387.32, 365.48)
	for id in system.get_pcs():
		if id != "ALTER_EGO":
			object.cancel_commandos(id)
			object.set_position(id,376.45,360.75)
			object.move_to(id, 386.04,360.94, speed=MT_SLOW)
			object.turn_to_object(id, "ALTER_EGO")

	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA","ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				daily_routine.prohibit_activity(folger)
				object.cancel_commandos(folger)
				object.set_position(folger, 384.38, 361.05)
				object.move_to(folger, 386.04, 360.94, speed=MT_SLOW, callback = ["ONEND",Lambda('daily_routine.allow_activity("%s")'%folger)])

	object.turn_to_object("ALTER_EGO", "ZZONE_6_BUILDING_143")
	object.set_direction("ZZONE_6_BUILDING_143",352.804161071777366)
	system.set_camera_view(CAMVIEW_BALISTA_SCHLUCHT)
	delay(2.0, Lambda('system.fade(FADE_IN, on_dialog_016_fade_in)'))

def on_dialog_016_fade_in(param=None):
	object.step_to('ALTER_EGO', 386.7, 365.12)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text = "D_016_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = Cutscene_beenden)
	dialog.start()

def initCutscene_017_BalistaGoldenerSchuss():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BALISTA_SCHLUCHT_BASTELN)
	object.move_to("ALTER_EGO",389.67, 364.97)
	object.step_to("ALTER_EGO",390.14, 366.08)
	object.turn_to_object("ALTER_EGO", "BALISTA_MIT_SEIL")
	character.play_animation("ALTER_EGO", "CM_NPC_MOTORRAD_SCHRAUBEN_START")
	character.play_animation("ALTER_EGO", "CM_NPC_MOTORRAD_SCHRAUBEN_LOOP_2", callback=["ONEND", on_dialog_017_ballista_mit_seil])
	character.play_animation("ALTER_EGO", "CM_NPC_MOTORRAD_SCHRAUBEN_ENDE", callback = ["ONEND", BalistaGoldenerSchuss_Text])

def on_dialog_017_ballista_mit_seil(objectid):
	object.set_active_state("BALISTA_MIT_SEIL", True)
	object.set_active_state("ZZONE_6_BUILDING_143", False)

def BalistaGoldenerSchuss_Text(id):
	object.step_to("ALTER_EGO",389.60, 364.92)
	object.move_to("ALTER_EGO",386.50, 366.12)
	object.step_to("ALTER_EGO",386.13, 366.65)
	object.turn_to_object("ALTER_EGO", "BALISTA_MIT_SEIL", callback=["ONEND", on_dialog_017_start])
	
def on_dialog_017_start(char):
	system.set_camera_view(CAMVIEW_BALISTA_SCHLUCHT_ABSCHUSS)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text = "D_017_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = BalistaGoldenerSchuss_Treffer)
	dialog.start()

def BalistaGoldenerSchuss_Treffer(id):
	system.set_camera_view(CAMVIEW_BALISTA_SCHLUCHT_TREFFER)
	data().Balista_geschossen = 1
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE",callback=BalistaGoldenerSchuss)

def BalistaGoldenerSchuss(id):
	object.step_to("ALTER_EGO", 385.93, 363.83, speed=MT_SLOW)
	object.turn_to_direction("ALTER_EGO",82.804161071777366)
	object.set_position_free("BALISTA_SEILBEFESTIGUNG", 389.0, 366.5, -0.385)
	character.play_animation("ALTER_EGO", "CM_FERNGLAS_IDLE")
	character.play_animation("ALTER_EGO", "CM_FERNGLAS_IDLE")
	object.play_animation("BALISTA_MIT_SEIL", "BALISTA_SCHIESST", callback=["ONEND", on_dialog_017_ballista_shot])

def on_dialog_017_ballista_shot(objectid):
	object.set_active_state("BALISTA_MIT_SEIL", False)
	object.set_active_state("ZZONE_6_BUILDING_143", True)
	object.set_active_state("BALISTA_SEILBEFESTIGUNG", True)

	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text( text = "D_017_T_002", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = on_dialog_017_ende)
	dialog.start()

def on_dialog_017_ende():
	system.end_cutscene()
	system.set_qb_entry_state(data().QB_001, COMPLETE)
	character.add_experience_party(data().ExpBalistaRepariert)

def hangeln_kommentar(char):
	if data().schongehangelt == False:
		dialog.init_dialog(type=DIALOGSMALL)
		if char == "ALTER_EGO":
			dialog.add_text( text = "D_005_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = Cutscene_beenden)
		elif char != "ALTER_EGO":
			if object.get_attribute(char, "gender") == "male":
				dialog.add_text( text = "D_032_T_001", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = Cutscene_beenden)
			elif object.get_attribute(char, "gender") == "female":
				dialog.add_text( text = "D_032_T_001F", speaker = "ALTER_EGO", follower = "ENDDIALOG", callback = Cutscene_beenden)
		dialog.start(False)
		data().schongehangelt = True
	#check_alle_drueben(char)
	
def spieler_hangelt_ueber_seil(char):
	data().on_wait_for_commando_pass = char
	system.fade(FADE_OUT, Lambda('hangeln_start("%s")' %(char)))
	
def hangeln_start(char):
	system.start_cutscene()
	data().SindSchonDrueben = []
	data().uebers_seil[0] = []
	data().uebers_seil[1] = []
	
	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA","ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				daily_routine.prohibit_activity(folger)
				object.cancel_commandos(folger)
				data().uebers_seil[0].append(folger)
	for pcs in system.get_pcs():
		if not pcs == "ALTER_EGO":
			data().uebers_seil[0].append(pcs)

	x = object.get_x(char)
	if x < 414.0:
		d = 262.804161071777366
		data().hangeln_nach = "westen"
	else:
		d = 82.804161071777366
		data().hangeln_nach = "osten"
	
#	object.cancel_commandos(char)
	object.set_direction_free(char, d)
	hangeln_die_zweite(char)

def hangeln_die_zweite(char):
	if data().hangeln_nach == "westen":
		object.cancel_commandos(char)
		object.set_position_free(char, 392.55, 365.85, 0, grid = 'BALISTA_SEILBEFESTIGUNG_INTERIOR_GRID')
		system.set_camera_view([379.88970947265625, 361.0426025390625, 24.775974273681641, 0.89609229564666748, 0.060961175709962845, -0.43966168165206909])
	else:
		object.cancel_commandos(char)
		object.set_position_free(char, 435.55, 360.29, 0, grid = 'BALISTA_SEILBEFESTIGUNG_INTERIOR_GRID')
		system.set_camera_view([426.56198120117187, 345.69271850585937, 21.567590713500977, 0.49383333325386047, 0.77270299196243286, -0.39882174134254456])

	system.fade(FADE_IN)
#	object.cancel_commandos(char)
	character.play_animation(char, "CM_UEBER_BRUECKE_HANGELN", callback = ["ONEND", Lambda('hangeln_die_dritte("%s")'%char)])
	delay(7,Lambda('system.fade(FADE_OUT)'))

def hangeln_die_zweite_(char):
	if data().hangeln_nach == "westen":
		object.cancel_commandos(char)
		object.set_direction_free(char, 262.804161071777366)
		object.cancel_commandos(char)
		object.set_position_free(char, 392.55, 365.85, 0, grid = 'BALISTA_SEILBEFESTIGUNG_INTERIOR_GRID')
	else:
		object.cancel_commandos(char)
		object.set_direction_free(char, 82.804161071777366)
		object.cancel_commandos(char)
		object.set_position_free(char, 435.55, 360.29, 0, grid = 'BALISTA_SEILBEFESTIGUNG_INTERIOR_GRID')
	
#	object.cancel_commandos(char)
	character.play_animation(char, "CM_UEBER_BRUECKE_HANGELN", callback = ["ONEND", Lambda('hangeln_die_dritte("%s")'%char)])

def hangeln_die_dritte(char):
	if data().hangeln_nach == "westen":
		object.cancel_commandos(char)
		object.set_position_free(char, 420.55, 362.35, 0, grid = 'BALISTA_SEILBEFESTIGUNG_INTERIOR_GRID')
		system.set_camera_view([432.0, 359.0, 18.0, -0.83840101957321167, 0.46490013599395752, -0.28452014923095703])
	else:
		object.cancel_commandos(char)
		object.set_position_free(char, 416.60, 362.8, 0, grid = 'BALISTA_SEILBEFESTIGUNG_INTERIOR_GRID')
		system.set_camera_view([400.0, 360.0, 24.0, 0.96, 0.1, -0.5])
	if len(data().uebers_seil[0]):
		nextone = data().uebers_seil[0].pop(0)
		if not nextone == "ALTER_EGO":
			data().uebers_seil[1].append(nextone)
			daily_routine.allow_activity(nextone)
			hangeln_die_zweite_(nextone)
		system.fade(FADE_IN)
#		object.cancel_commandos(char)
		character.play_animation(char, "CM_UEBER_BRUECKE_HANGELN", callback = ["ONEND", Lambda('hangeln_ende("%s")'%char)])
	else:
		system.fade(FADE_IN)
#		object.cancel_commandos(char)
		character.play_animation(char, "CM_UEBER_BRUECKE_HANGELN", callback = ["ONEND", Lambda('hangeln_ende("%s")'%char)])
		delay(7,Lambda('system.fade(FADE_OUT)'))

def hangeln_ende(char):
	#print "Schon drüben: " + `len(data().SindSchonDrueben)`
	object.cancel_commandos(char)
	if data().hangeln_nach == "osten":
		object.set_position(char, OSTEN_NACH_SEIL[len(data().SindSchonDrueben)][0], OSTEN_NACH_SEIL[len(data().SindSchonDrueben)][1])#392.09, 364.56)
		system.set_camera_view(CAMVIEW_BALISTA_ANGEKOMMEN_DORF)
	else:
		object.set_position(char, WESTEN_NACH_SEIL[len(data().SindSchonDrueben)][0], WESTEN_NACH_SEIL[len(data().SindSchonDrueben)][1])#437.332, 359.2778)
		system.set_camera_view(CAMVIEW_BALISTA_ANGEKOMMEN_ANDERE_SEITE)
#	object.cancel_commandos(char)
	daily_routine.allow_activity(char)
	system.fade(FADE_IN)
	hangeln_char_arrived(char)

def hangeln_char_arrived(char):
	check_alle_drueben(char)
	data().on_wait_for_commando_pass = None
	if not len(data().uebers_seil[1]):
		if system.is_cutscene():
			system.end_cutscene()
			hangeln_kommentar(char)
	else:
		data().uebers_seil[1].remove(data().uebers_seil[1][0])

def check_alle_drueben(char):
	data().bruecke_fuer_andere_gesperrt = False
	party = system.get_pcs()
	for folger in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not object.is_destroyed(folger) and object.is_active(folger):
				party.append(folger)
	if not char in data().SindSchonDrueben:
		data().SindSchonDrueben.append(char)
	if len(party) == len(data().SindSchonDrueben):
		party.sort()
		data().SindSchonDrueben.sort()
		print `data().SindSchonDrueben`
		print `party`
		# wenn alle drueben, qb Eintrag aendern + exp verteilen + z9 freischalten
		if not system.get_qb_entry_state(data().QB_002) == globals.COMPLETE:
			if party == data().SindSchonDrueben:
				system.set_qb_entry_state(data().QB_002, COMPLETE)
				character.add_experience_party(data().ExpUeberDieSchlucht)
				if not globals.is_zone_enabled("zone_9"):
					globals.set_zone_enabled("zone_9", True)
				return True
	return False
