# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import schedules
import object_events
import const
from const import *
import system_events

#*** actual Revision 4, 20.08.2004 ***********************************
#todo:

def initParties():
	system.create_party(id="NPCS", type=PT_COMPUTER)
	system.create_party(id="ANIMALS", type=PT_COMPUTER)
	system.create_party(id="UISPIELER", type=PT_HUMAN)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(205.1, 468.52),
			"EAST":		(552.0, 451.78),
			"SOUTH":	(552.0, 451.78),
			"WEST":		(205.1, 468.52),
	 	}
	#return start_locations["WEST"]
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection

def on_init():
	skies.init_sky_preset("yellow")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Dorf",205,205,315,315)
	
	data("rest").non_rest_areas.append("Dorf")
	
def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	initItems()
	initHerbs()
	initExitZones()
	initWaterResources()
	initFX()
	
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	
	initAnimals()
	npc.initNPCS()

	system.add_region( id = "REGION_BRUECKE_BESTAUNEN", x1 = 370.0, y1 = 431.0, x2 = 394.0, y2 = 475.0 )
	system.notify_region_entered( region="REGION_BRUECKE_BESTAUNEN", partyid="UISPIELER" )
	system.add_region( id = "REGION_BRUECKE_BESTAUNEN_ANDERESEITE", x1 = 442.2, y1 = 436.3, x2 = 467.6, y2 = 473.6 )
	system.notify_region_entered( region="REGION_BRUECKE_BESTAUNEN_ANDERESEITE", partyid="UISPIELER" )
	system.add_region( id = "REGION_LEE", x1=286.11,y1=295.98,x2=295.99,y2=286.00)
	system.notify_region_entered( region="REGION_LEE", partyid="UISPIELER" )
	system.add_region( id = "REGION_BALISTA_ANDERESEITE", x1 = 411.98, y1 = 358.14, x2 = 408.45, y2 = 360.92 )
	system.notify_region_entered( region="REGION_BALISTA_ANDERESEITE", partyid="UISPIELER", permanent=True )
	
	initZoneObjects()
	checkBalistaLook()
	initQuests()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	init_character_states()
	init_non_rest_areas()

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	system.mark_for_script_use("ZZONE_6_BUILDING_143")
	
	# Bienenstöcke ZZone 6
	system.mark_for_script_use('BUILDING_6424')
	system.mark_for_script_use('BUILDING_6425')

	

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	#mortality
	for npc in npcs:
		object.set_immortal_state(npc, True)
	animals = system.get_animals()
	for animal in animals:
		object.set_immortal_state(animal, False)

### initAnimals
################
def initAnimals():
	# Hirsche
	system.create_animal(id="HIRSCH_1", type=ANIMAL_DEER, party="ANIMALS", x=211.5, y=411.71, direction=globals.DIR_NORTH)
	system.create_animal(id="HIRSCH_2", type=ANIMAL_DEER, party="ANIMALS", x=222.74, y=408.87, direction=globals.DIR_SOUTH_WEST)

### initWaterResources
#######################
def initWaterResources():
	water.set_water_source(287.2, 478.7, 1)
	water.set_water_source(371.95, 247.76, 3)

### initZoneObjects
####################
def initZoneObjects():
	#ballista umabauen, an der der spieler arbeitet
	x,y,z = object.get_position("ZZONE_6_BUILDING_143")
	d = object.get_direction("ZZONE_6_BUILDING_143")
	object.set_active_state("ZZONE_6_BUILDING_143", False)
	
	system.create_object('RES3D_BALISTA_OHNE_KETTE', x=x, y=y, id = "BALISTA_OHNE_KETTE", direction=d)
	object.set_active_state("BALISTA_OHNE_KETTE", False)
	
	system.create_object('RES3D_BALISTA_OHNE_KETTE_WURFARM', x=x, y=y, id = "BALISTA_OHNE_KETTE_WURFARM", direction=d)
	object.set_active_state("BALISTA_OHNE_KETTE_WURFARM", False)
	
	system.create_object('RES3D_BALISTA_OHNE_RAD', x=x, y=y, id = "BALISTA_OHNE_RAD", direction=d)
	object.set_active_state("BALISTA_OHNE_RAD", False)
	
	system.create_object('RES3D_BALISTA_OHNE_RAD_KETTE', x=x, y=y, id = "BALISTA_OHNE_RAD_KETTE", direction=d)
	object.set_active_state("BALISTA_OHNE_RAD_KETTE", False)
	
	system.create_object('RES3D_BALISTA_OHNE_RAD_WURFARM', x=x, y=y, id = "BALISTA_OHNE_RAD_WURFARM", direction=d)
	object.set_active_state("BALISTA_OHNE_RAD_WURFARM", False)
	
	system.create_object('RES3D_BALISTA_OHNE_WURFARM', x=x, y=y, id = "BALISTA_OHNE_WURFARM", direction=d)
	object.set_active_state("BALISTA_OHNE_WURFARM", False)
	
	system.create_object('RES3D_BALISTA_OHNE_RAD_KETTE_WURFARM', x=x, y=y, id = "BALISTA_OHNE_ALLES", direction=d)
	object.set_active_state("BALISTA_OHNE_ALLES", True)
	
	system.create_object('RES3D_BALISTA_MIT_SEIL', x=388.77,  y=366.71, id = "BALISTA_MIT_SEIL", direction = 352.804161071777366)
	object.set_position_free("BALISTA_MIT_SEIL", 388.77, 366.71, -0.15)
	object.set_active_state("BALISTA_MIT_SEIL", False)
	
	system.create_object('RES3D_BALISTA_SEILBEFESTIGUNG', x=389.0, y=366.5, id = "BALISTA_SEILBEFESTIGUNG", direction = 352.804161071777366)
	object.set_position_free("BALISTA_SEILBEFESTIGUNG", 389.0, 366.5, -0.385)
	object.set_active_state("BALISTA_SEILBEFESTIGUNG", False)
	
	# Balista hinten
	#fertige balliste hinten austauschen und deaktivieren
	object.set_active_state("ZZONE_6_BUILDING_798", False)
	x,y,z = object.get_position("ZZONE_6_BUILDING_798")
	d = object.get_direction("ZZONE_6_BUILDING_798")
	#ballista hinten gegen scriptobjekte austauschen
	system.create_object('RES3D_BALISTA_UNFERTIG', x=x, y=y, id = "BALISTA_UNFERTIG", direction=d)
	object.set_active_state("BALISTA_UNFERTIG", True)
	system.create_object('RES3D_BALISTA_UNFERTIG_OHNE_RAD', x=x, y=y, id = "BALISTA_UNFERTIG_OHNE_RAD", direction=d)
	object.set_active_state("BALISTA_UNFERTIG_OHNE_RAD", False)
	

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)
	
def on_enter_region(id, objectid, partyid ):
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if id == "REGION_BRUECKE_BESTAUNEN":
		bruecke_marker()
		if data().Schlucht_gesehen == 1:
			return
		dialogs.initCutscene_001_SpielerBestauntBruecke()
	
	elif id == "REGION_BRUECKE_BESTAUNEN_ANDERESEITE":
		bruecke_marker()
		if data().Schlucht_gesehen == 1:
			return
		dialogs.initCutscene_001_SpielerBestauntBruecke_AndereSeite()
	
	elif id == "REGION_LEE":
		if not data().player_knows_Lees_Enklave:
			data().player_knows_Lees_Enklave = True
			system.add_minimap_marker(266.08,251.43,"MM_001")# Lees Enklave
		object.cancel_commandos("LEE")
		object.turn_to_object("LEE", "ALTER_EGO")
		dialogs.initCutscene_018_LeeGreetsPlayer()

def bruecke_marker():
	if not data().player_knows_Bruecke:
		data().player_knows_Bruecke = True
		system.add_minimap_marker(384.39,453.85,"MM_002")# Bruecke
		
def on_timer(id):
	if id == data().TimerBruecke001:
		system.notify_timer(data().TimerBruecke002, data().TimerBruecke002Value)
	elif id == data().TimerBruecke002:
		system.set_camera_view(const.CAMVIEW_B_FALLEN)
		#system.notify_timer(data().TimerBruecke003, data().TimerBruecke003Value)
	elif id == data().TimerBruecke003:
		system.notify_timer(data().TimerBruecke004, data().TimerBruecke004Value)
	elif id == data().TimerBruecke004:
		if data().UeberquerungVon == "DORF":
			system.set_camera_view(const.CAMVIEW_BRUECKEN_CS)
		else:
			system.set_camera_view(const.CAMVIEW_BRUECKEN_CS_ANDERESEITE)
		
def on_wait_for_commando(id):
	return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
	if ((object_id == "ZZONE_6_BUILDING_143") or 
		(object_id == "BALISTA_OHNE_RAD") or 
		(object_id == "BALISTA_OHNE_KETTE") or 
		(object_id == "BALISTA_OHNE_KETTE_WURFARM") or 
		(object_id == "BALISTA_OHNE_RAD") or 
		(object_id == "BALISTA_OHNE_RAD_KETTE") or 
		(object_id == "BALISTA_OHNE_RAD_WURFARM") or 
		(object_id == "BALISTA_OHNE_WURFARM") or 
		(object_id == "BALISTA_OHNE_ALLES") or 
		(object_id == "BALISTA_MIT_SEIL") or 
		(object_id == "ZZONE_6_BUILDING_3608") or
		(object_id == "BALISTA_UNFERTIG") or
		(object_id == "BALISTA_UNFERTIG_OHNE_RAD")):
		if character_id == "ALTER_EGO":
			return True
	if object_id.endswith('BUILDING_4'): 
		return False
	return False

def on_examine_object( character_id, object_id ):
	if ((object_id.endswith('BUILDING_143')) or 
		(object_id == "BALISTA_OHNE_RAD") or 
		(object_id == "BALISTA_OHNE_KETTE") or 
		(object_id == "BALISTA_OHNE_KETTE_WURFARM") or 
		(object_id == "BALISTA_OHNE_RAD") or 
		(object_id == "BALISTA_OHNE_RAD_KETTE") or 
		(object_id == "BALISTA_OHNE_RAD_WURFARM") or 
		(object_id == "BALISTA_OHNE_WURFARM") or 
		(object_id == "BALISTA_OHNE_ALLES") or 
		(object_id == "BALISTA_MIT_SEIL") or 
		(object_id == "BALISTA_SEILBEFESTIGUNG")):
		if data().Schlucht_gesehen == 0 :
			dialogs.initDlg_006_BalistaErsterEindruck()
		if data().Schlucht_gesehen == 1 :
			if data().lee_info_ballista == 0 :
				dialogs.initDlg_007_BalistaNuetzlich()
				data().lee_info_ballista = 1
			else:
				if data().Balista_Zustand == 0 :
					dialogs.initDlg_008_RWK_fehlt()
				elif data().Balista_Zustand == 4 :
					dialogs.initDlg_009_WK_fehlt()
				elif data().Balista_Zustand == 2 :
					dialogs.initDlg_010_RK_fehlt()
				elif data().Balista_Zustand == 1 :
					dialogs.initDlg_011_RW_fehlt()
				elif data().Balista_Zustand == 3 :
					dialogs.initDlg_012_R_fehlt()
				elif data().Balista_Zustand == 5 :
					dialogs.initDlg_013_W_fehlt()
				elif data().Balista_Zustand == 6 :
					dialogs.initDlg_014_K_fehlt()
				elif data().Balista_Zustand == 7 :
					dialogs.initDlg_015_Balista_komplett()
					data().Balista_repariert = 1

	if object_id in ["ZZONE_6_BUILDING_803", "ZZONE_6_BUILDING_652"]:
		dialogs.initDlg_029_KatapultErsterEindruck()

	if ((object_id == "BALISTA_UNFERTIG") or 
		(object_id == "BALISTA_UNFERTIG_OHNE_RAD")):		# Balista hinten
		if data().Alles_fehlt == 0:
			dialogs.initDlg_028_SpielerUntersuchtBalistawrack()
		if data().Alles_fehlt == 1:
			if data().Rad_genommen == 1:
				dialogs.initDlg_028_SpielerUntersuchtBalistawrack()
			else:
				dialogs.initDlg_027_SpielerFindetRad()
		
	if object_id == "ZZONE_6_BUILDING_3608":		# Schrottauto
		if data().Alles_fehlt == 0:
			dialogs.initDlg_030_SpielerUntersuchtAuto()
		if data().Alles_fehlt == 1:
			if data().Feder_genommen == 1:
				dialogs.initDlg_030_SpielerUntersuchtAuto()
			else:
				dialogs.initCutscene_031_SpielerFindetBlattfeder()				
	return False

def on_pick_up( character_id, item_id, item_type ):
	if item_id == data().qi_chain[1]:
		if data().Kette_genommen == 0:
			data().Kette_genommen = 1
			dialogs.initDlg_026_SpielerFindetKette()
		else:
			return True
	return True
	
def CanLeaveZone():
	return False

### initQuests
###############
def initQuests():
	data().QB_001 = system.register_qb_entry('ZZONE6_AIM_01')
	data().QB_002 = system.register_qb_entry('ZZONE6_AIM_02')
	
### initItems
##############
def initItems():
	system.create_object(data().qi_chain[0], 305.25, 307.28, data().qi_chain[1])
	object.set_attribute(data().qi_chain[1],"generic_item", False)
	# 
	#object.create_item_in_inventory('ZZONE_6_BUILDING_202', ["SET_POWER_DRILL"])
	# 
	object.create_item_in_inventory('ZZONE_6_BUILDING_291', ["SET_PAINTS"])
	# 
	object.create_item_in_inventory('ZZONE_6_BUILDING_335', ["SET_BUCKET_WITH_VASELINE"])
	# 
	object.create_item_in_inventory('ZZONE_6_BUILDING_247', ["SET_COPPER_WIRE"])
	
	# Elektrokasten
	object.create_item_in_inventory(object="BUILDING_2322",equipment=["SET_DART"])
	# Couch
	object.create_item_in_inventory(object="BUILDING_1335",equipment=["SET_HEAD_REST", "SET_C4_REMOTE_CONTROL_W_NAILS"])
	# Schrankwand
	object.create_item_in_inventory(object="BUILDING_1261",equipment=["SET_MP5_W_SILENCER_W_LASERPOINTER", "SET_MANSLAYER"])
	# Spind
	object.create_item_in_inventory(object="BUILDING_1291",equipment=["SET_THROWING_KNIFE"])
	# Betonröhre
	object.create_item_in_inventory(object="BUILDING_1322",equipment=["SET_BROKEN_SHOVEL", "SET_AMMOPACK_38_DUMDUM"])
	# Schrankwand
	object.create_item_in_inventory(object="BUILDING_6218",equipment=["SET_OICW", "SET_ANTITANKMINE"])
	
	
	
	# Bienenstöcke ZZ6
	object.create_item_in_inventory( 'BUILDING_6424', equipment=[ 'SET_BEESWAX' ] )
	object.create_item_in_inventory( 'BUILDING_6425', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )

	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_6255', equipment=[ 'SET_SALPETER', 'SET_HEGRENADE', 'SET_MP5_W_SILENCER_W_LASERPOINTER' ] )
	object.create_item_in_inventory( 'BUILDING_1433', equipment=[ 'SET_AMMOPACK_44_DUMDUM', 'SET_PLATE_GLOVES', 'SET_WATER_BOTTLE' ] )
	object.create_item_in_inventory( 'BUILDING_1266', equipment=[ 'SET_MEAT_COOKED_BIG', 'SET_DT21_LIGHT_ARMOR', 'SET_AMMOPACK_20_MM_HE' ] )
	object.create_item_in_inventory( 'BUILDING_6256', equipment=[ 'SET_SHURIKEN', 'SET_WOOD_GARLIC', 'SET_MACHETE' ] )
	object.create_item_in_inventory( 'BUILDING_6257', equipment=[ 'SET_AMMOPACK_38_DUMDUM', 'SET_COOKING_POT', 'SET_MEDIPACK_BIG' ] )


### initHerbs
##############
def initHerbs():
	system.create_object(equipmenttype="SET_BURNET", x=246, y=278)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=298, y=282)
	system.create_object(equipmenttype="SET_BURNET", x=249, y=274)
	system.create_object(equipmenttype="SET_BURNET", x=245, y=272)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=340, y=469)
	system.create_object(equipmenttype="SET_BURNET", x=339, y=465)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=329, y=470)
	system.create_object(equipmenttype="SET_BURNET", x=368, y=351)
	system.create_object(equipmenttype="SET_BURNET", x=361, y=352)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=365, y=345)
	

def pre_use( character_id, object_id, item_id, item_type ):
	if object_id != None:
		if object_id == "BALISTA_SEILBEFESTIGUNG":
			x = object.get_x(character_id)
			if x > 414.0:				
				object.set_attribute(object_id, "on_use_coordinates",[438.92, 358.74,0])
			else:
				object.set_attribute(object_id, "on_use_coordinates",[391.39, 364.55,0])

def can_use( character_id, object_id ):
	if data().AnzahlBenutzung < 4:
		if (object_id == "ZZONE_6_BUILDING_143"):
			return True
		if (object_id == "BALISTA_MIT_SEIL"):
			return True
		if (object_id == "BALISTA_SEILBEFESTIGUNG"):
			return True
	return object_events.can_use( character_id, object_id )

def on_use( character_id, object_id, item_id, item_type ):
	if object_id == "ZZONE_6_BUILDING_143":		# Balista
		if data().Balista_Zustand == 7:
			data().AnzahlBenutzung = data().AnzahlBenutzung + 1
			if data().AnzahlBenutzung == 1:
				dialogs.initCutscene_016_BalistaZurSchlucht()
				return True
			if data().AnzahlBenutzung == 2:
				dialogs.initCutscene_017_BalistaGoldenerSchuss()
				return True
	
	if object_id == "BALISTA_SEILBEFESTIGUNG":
		if character_id == "ALTER_EGO":
			dialogs.spieler_hangelt_ueber_seil(character_id)
		else:
			dialogs.spieler_hangelt_ueber_seil("ALTER_EGO")
		return True

	if object_id in ["BALISTA_OHNE_ALLES","BALISTA_OHNE_RAD_WURFARM","BALISTA_OHNE_RAD_KETTE","BALISTA_OHNE_RAD"]:
		if item_id == data().qi_wheel[1]:
			data().Balista_Zustand = data().Balista_Zustand + 4
			dialogs.initDlg_023_SpielerRadAnbringen()
			object.remove_item_from_inventory(character_id, data().qi_wheel[1])
			checkBalistaLook()
			#if data().Balista_Zustand == 7:
			#	dialogs.initDlg_015_Balista_komplett()
			return True
			
	if object_id in ["BALISTA_OHNE_ALLES","BALISTA_OHNE_RAD_KETTE","BALISTA_OHNE_KETTE_WURFARM","BALISTA_OHNE_KETTE"]:
		if item_id == data().qi_chain_repaired[1]:
			data().Balista_Zustand = data().Balista_Zustand + 1
			dialogs.initDlg_025_SpielerKetteAnbringen()
			object.remove_item_from_inventory(character_id, data().qi_chain_repaired[1])
			checkBalistaLook()
			#if data().Balista_Zustand == 7:
			#	dialogs.initDlg_015_Balista_komplett()
			return True
					
	if object_id in ["BALISTA_OHNE_ALLES","BALISTA_OHNE_RAD_WURFARM","BALISTA_OHNE_KETTE_WURFARM","BALISTA_OHNE_WURFARM"]:
		if item_id == data().qi_feather[1]:
			data().Balista_Zustand = data().Balista_Zustand + 2
			dialogs.initDlg_024_SpielerWurfarmAnbringen()
			object.remove_item_from_inventory(character_id, data().qi_feather[1])
			checkBalistaLook()
			#if data().Balista_Zustand == 7:
			#	dialogs.initDlg_015_Balista_komplett()
			return True
	return object_events.on_use( character_id, object_id, item_id, item_type )

def checkBalistaLook():
	if data().Balista_Zustand == 0:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_ALLES", True)
	
	if data().Balista_Zustand == 1:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_RAD_WURFARM", True)
		
	if data().Balista_Zustand == 2:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_RAD_KETTE", True)
		
	if data().Balista_Zustand == 3:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_RAD", True)
		
	if data().Balista_Zustand == 4:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_KETTE_WURFARM", True)

	if data().Balista_Zustand == 5:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_WURFARM", True)
		
	if data().Balista_Zustand == 6:
		deactivateAllBalistas()
		object.set_active_state("BALISTA_OHNE_KETTE", True)
		
	if data().Balista_Zustand == 7:
		deactivateAllBalistas()
		object.set_active_state("ZZONE_6_BUILDING_143", True)
		
def deactivateAllBalistas():
	object.set_active_state("BALISTA_OHNE_ALLES", False)
	object.set_active_state("BALISTA_OHNE_RAD_WURFARM", False)
	object.set_active_state("BALISTA_OHNE_RAD_KETTE", False)
	object.set_active_state("BALISTA_OHNE_RAD", False)
	object.set_active_state("BALISTA_OHNE_KETTE_WURFARM", False)
	object.set_active_state("BALISTA_OHNE_WURFARM", False)
	object.set_active_state("BALISTA_OHNE_KETTE", False)
	object.set_active_state("ZZONE_6_BUILDING_143", False)

### initExitZones
##################
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORTH", x1 = 190.00, y1 = 0.00, x2 = 570.00, y2 = 200.00 )
	system.register_exit(regionname = "REGION_EXIT_NORTH" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 799.00, y1 = 799.00, x2 = 570.00, y2 = 0.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )
	system.add_region( id = "REGION_EXIT_SOUTH", x1 = 190.00, y1 = 585.00, x2 = 570.00, y2 = 799.00 )
	system.register_exit(regionname = "REGION_EXIT_SOUTH" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 799.00, x2 = 190.00, y2 = 0.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )

def initFX():
	pass

def on_grid_enter( object_id, grid_id, old_grid_id ):
	if object.is_pc(object_id):
		if grid_id == "ZZONE_6_BUILDING_4_INTERIOR_GRID2":
			if not data().bruecke_fuer_andere_gesperrt:
				data().bruecke_fuer_andere_gesperrt = True
				for id in system.get_pcs():
					object.cancel_commandos(id)
			
			if not system.is_cutscene():
				if object.get_grid(object_id) == "ZZONE_6_BUILDING_4_INTERIOR_GRID3":
					data().UeberquerungVon = "OSTEN"
				else:
					data().UeberquerungVon = "DORF"
				if character.get_body_mode(object_id) == 'LIE':
					dialogs.initCutscene_005_PCUeberquertBrueckeRobben(object_id)
				elif object.has_attribute(object_id, "zz6_rob_over_bridge"):
					Dir = 90
					if data().UeberquerungVon == "OSTEN":
						Dir = 270
					object.turn_to_direction(object_id,Dir)
					character.change_body_mode(object_id, "LIE", callback = ["ONEND",Lambda('dialogs.initCutscene_005_PCUeberquertBrueckeRobben("%s")'%object_id)])
				elif (character.get_body_mode(object_id) in ['STAND','KNEEL']):
					dialogs.initCutscene_002_PCFaellt(object_id)
			else:
				return

	return object_events.on_grid_enter( object_id, grid_id, old_grid_id )

def on_begin_cutscene():
	"""is called when a cutscene is started""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()

	for mob in mobs:
		system_events.save_foes(mob)
		system_events.save_speedfactor(mob)
	
		# make sure AE is available
	if object.is_unconscious("ALTER_EGO"):
		object_events.on_resuscitate("ALTER_EGO", "ALTER_EGO")

	#make npcs and animals visible during a cutscene
	#deactivate visibility fading
	for id in (system.get_npcs() + system.get_animals()):
		object.set_attribute(id, "visibility", UIVIS_VISIBLE)
		object.set_attribute(id, "visibility_fade", False)
	
def on_end_cutscene():
	"""is called when a cutscene ends""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()

	for mob in mobs:
		system_events.restore_foes(mob)
		system_events.restore_speedfactor(mob)
	
	#activate visibilty fading
	for id in (system.get_npcs() + system.get_animals()):
		object.set_attribute(id,"visibility_fade", True)

def InitChestsSafes():
	object.add_closed_lock("BUILDING_6255", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_1433", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_1266", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_6256", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_6257", "lock1", closure_type='booby-trap')

def init_patch():
	if "ANIE" in system.get_npcs():
		if object.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True

	object.set_position_free("BALISTA_MIT_SEIL", 388.77, 366.71, -0.15)
	object.set_position_free("BALISTA_SEILBEFESTIGUNG", 389.0, 366.5, -0.385)
	object.set_direction("BALISTA_MIT_SEIL",direction = 352.804161071777366)
	object.set_direction("BALISTA_SEILBEFESTIGUNG",direction = 352.804161071777366)
	if not hasattr(data(),'uebers_seil'):
		data().uebers_seil = {0:[],1:[]}
	pass
