# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import object_events
import schedules
import enemy_script
from enemy_script import *
from const import *
import system_events
import daily_routine
import npc_activities

#*** act revison: Revision 3, 28.09.2004

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(269.23, 208.89),
			"EAST" :	(291.41, 426.67),
	 		"SOUTH":	(291.41, 426.67),
			"WEST" :	(291.41, 426.67),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection

def on_init():
	skies.init_sky_preset("cave")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Hoehlenteil_1",330,375,358,338)
		system.add_region("Hoehlenteil_2",315,285,365,240)
		system.add_region("Hoehlenteil_3",285,350,305,330)
		system.add_region("Hoehlenteil_4",360,330,385,290)

	data("rest").non_rest_areas.append("Hoehlenteil_1")
	data("rest").non_rest_areas.append("Hoehlenteil_2")
	data("rest").non_rest_areas.append("Hoehlenteil_3")
	data("rest").non_rest_areas.append("Hoehlenteil_4")

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="SCHATTEN",type=PT_COMPUTER)
	# place player characters
	location = GetZoneEnterLocation( "SOUTH" )
	system.zone_transfer_place_characters( location[0], location[1] )
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	npc.initNPCS()
	initItems()
	initExitZones()
	initFX()
	initRegions()
	data().QB_001 = system.register_qb_entry('ZZONE7_AIM_01')
	system.set_qb_entry_state(data().QB_001, UNCOMPLETE)
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	initFoeLists()
	init_character_states()
	
	# die beiden sollen knieen, wenn der Spieler ihre Huette betritt
	character.change_body_mode("SCHATTEN_015", "KNEEL")
	character.change_body_mode("SCHATTEN_016", "KNEEL")
	
	init_non_rest_areas()
	
	object.add_closed_lock("ZZONE_7_BUILDING_1044", "lock2", closure_type='normal')
	if not was_zone_entered("zone_9.zone_9"):
		delay(2.0, dialogs.initDlg_008_AbelUndAnieWartenDraussen)
	animate_banner('ZZONE_7_BUILDING_1567')
	animate_banner('ZZONE_7_BUILDING_1612')
	animate_banner('ZZONE_7_BUILDING_1511')
	animate_banner('ZZONE_7_BUILDING_1523')
	animate_banner('ZZONE_7_BUILDING_1524')
	animate_banner('SQZONE_4_BUILDING_379')
	animate_banner('SQZONE_4_BUILDING_376')
	animate_banner('SQZONE_4_BUILDING_279')
	animate_banner('ZZONE_7_BUILDING_1489')

# markieren von objecten die im script modifiziert werden
def init_scriptuse_objects():
	#lagerfeuer
	for lf in FIRE:
		system.mark_for_script_use(lf)
	#banner
	system.mark_for_script_use("ZZONE_7_BUILDING_1567")
	system.mark_for_script_use("ZZONE_7_BUILDING_1612")
	system.mark_for_script_use("ZZONE_7_BUILDING_1511")
	system.mark_for_script_use("ZZONE_7_BUILDING_1523")
	system.mark_for_script_use("ZZONE_7_BUILDING_1524")
	system.mark_for_script_use("SQZONE_4_BUILDING_379")
	system.mark_for_script_use("SQZONE_4_BUILDING_376")
	system.mark_for_script_use("SQZONE_4_BUILDING_279")
	system.mark_for_script_use("ZZONE_7_BUILDING_1489")

	#kisten, tresore, truhen
	system.mark_for_script_use("ZZONE_7_BUILDING_1437")
	system.mark_for_script_use("ZZONE_7_BUILDING_1470")
	system.mark_for_script_use("ZZONE_7_BUILDING_1641")
	system.mark_for_script_use("ZZONE_7_BUILDING_1642")
	system.mark_for_script_use("ZZONE_7_BUILDING_1643")
	system.mark_for_script_use("ZZONE_7_BUILDING_1660")
	system.mark_for_script_use("ZZONE_7_BUILDING_1690")
	system.mark_for_script_use("ZZONE_7_BUILDING_1691")
	
	# Bienenstöcke ZZone 7

	

def animate_banner(obj=None):
	object.play_animation(obj,'ANIM_BANNER', callback=["ONEND",animate_banner])

# setzen von attributen wie immortal/mortal, foes, etc
def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		object.set_immortal_state(npc, False)
		character.set_approachable_state(npc, False)
		if npc not in data().shadow_npcs:
			object.set_immortal_state(npc, True)

## TODO: Regionen ausrichten (Koordinaten)
def initRegions():
	system.add_region(data().AngriffVonHinten,259.49, 211.82, 269.26, 227.72)
	#system.add_region(data().NordExit, 267.20, 200.84, 282.75, 206.18)
	
	system.notify_region_entered(region=data().AngriffVonHinten, objectid="ALTER_EGO")
	
	system.add_region("HOEHLEEIN",200,428,400,460)
	system.notify_region_entered("HOEHLEEIN", "ALTER_EGO", permanent=True)
	system.add_region("HOEHLEAUS",200,150,400,212)
	system.notify_region_entered("HOEHLEAUS", "ALTER_EGO", permanent=True)
	
	system.add_region("HOEHLENEINGANG", 282,405,302,425)
	system.notify_region_entered("HOEHLENEINGANG", partyid="UISPIELER")
	system.add_region("HOEHLENAUSGANG", 239,230,259,247)
	system.notify_region_entered("HOEHLENAUSGANG", partyid="UISPIELER")

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

def attakieren(char):
	object.set_attribute(char, "foes", ["UISPIELER"])
	character.arm_direct(char)
	enemies = character.get_visible_enemies(char)
	if len(enemies):
		c = None
		for e in enemies:
			d = 100
			if object.get_distance(e, char) < d:
				c = e
		object.attack(char, c)

def alarm_003():
	if not object.is_destroyed("SCHATTEN_003"):
		attakieren("SCHATTEN_003")

def alarm_005():
	if not object.is_destroyed("SCHATTEN_005"):
		attakieren("SCHATTEN_005")
	alarm_006()

def alarm_006():
	if not object.is_destroyed("SCHATTEN_006"):
		attakieren("SCHATTEN_006")

def alarm_008():
	if not object.is_destroyed("SCHATTEN_008"):
		feindlich1("SCHATTEN_008")
		attakieren("SCHATTEN_008")
	alarm_009()

def alarm_009():
	if not object.is_destroyed("SCHATTEN_009"):
		feindlich1("SCHATTEN_009")
		attakieren("SCHATTEN_009")
	alarm_010()

def alarm_010():
	if not object.is_destroyed("SCHATTEN_010"):
		feindlich1("SCHATTEN_010")
		attakieren("SCHATTEN_010")
	
def on_enemy_spotted(char):
	if not object.has_attribute(char, "enemy_spotted_running"):
		object.set_attribute(char, "enemy_spotted_running", True)
	else:
		return True

	if not object.is_destroyed(char):
		if not object.is_pc(char): 
			prohibit_activity(char, False)
			if not data().Dialog001 and not char in ["SCHATTEN_003","SCHATTEN_005","SCHATTEN_006","SCHATTEN_008","SCHATTEN_009","SCHATTEN_010","SCHATTEN_015","SCHATTEN_016"]:
				if not object.is_destroyed(char):	
					dialogs.initCutscene_001_SchattenAlarm(char)
					data().Dialog001 = True
					character.arm_direct(char)
				return True

			if char == "SCHATTEN_002":
				alarm_003()

			elif char == "SCHATTEN_004":
				alarm_005()

			elif char == "SCHATTEN_007":
				alarm_008()

			elif char == "SCHATTEN_008":
				alarm_009()

			elif char == "SCHATTEN_012":
				on_enemy_spotted("SCHATTEN_013")
			elif char == "SCHATTEN_013":
				on_enemy_spotted("SCHATTEN_012")
			elif char == "SCHATTEN_014":
				on_enemy_spotted("SCHATTEN_015")
			elif char == "SCHATTEN_015":
				on_enemy_spotted("SCHATTEN_016")
			elif char == "SCHATTEN_016":
				on_enemy_spotted("SCHATTEN_015")

			attakieren(char)
			return True
	return False

def on_attack( char, target ):
	if not object.is_fighting(target) and data().Dialog001:
		on_enemy_spotted(target)

# aufstehen, feindlich werden
def feindlich(char):
	pass

def feindlich1(char):
	if not object.is_destroyed(char):
		object.cancel_commandos(char)
		object.set_attribute(char, "foes", ["UISPIELER"])

def on_grid_enter(object_id, grid_id, old_grid_id):
	if object.is_pc(object_id):
		schleichen = 0
		if object.has_attribute(object_id,"sneak"):
			schleichen = object.get_attribute(object_id,"sneak")

		if grid_id == 'SQZONE_4_BUILDING_60_INTERIOR_GRID1':
			feindlich1("SCHATTEN_003")
			if not object.is_destroyed("SCHATTEN_003"):
				object.turn_to_object("SCHATTEN_003",object_id)
				object.attack("SCHATTEN_003",object_id)

		if grid_id == 'SQZONE_4_BUILDING_122_INTERIOR_GRID1':
			feindlich1("SCHATTEN_005")
			if not object.is_destroyed("SCHATTEN_005"):
				object.turn_to_object("SCHATTEN_005",object_id)
				object.attack("SCHATTEN_005",object_id)

		if grid_id == 'SQZONE_4_BUILDING_122_INTERIOR_GRID1':
			feindlich1("SCHATTEN_006")
			if not object.is_destroyed("SCHATTEN_006"):
				object.turn_to_object("SCHATTEN_006",object_id)
				object.attack("SCHATTEN_006",object_id)

		if grid_id == 'SQZONE_4_BUILDING_330_INTERIOR_GRID1':
			feindlich1("SCHATTEN_009")
			if not object.is_destroyed("SCHATTEN_009"):
				object.turn_to_object("SCHATTEN_009",object_id)
				object.attack("SCHATTEN_009",object_id)

		if grid_id == 'SQZONE_4_BUILDING_330_INTERIOR_GRID1':
			feindlich1("SCHATTEN_010")
			if not object.is_destroyed("SCHATTEN_010"):
				object.turn_to_object("SCHATTEN_010",object_id)
				object.attack("SCHATTEN_010",object_id)

		#brücke zur waffenkammer
		if grid_id == "ZZONE_7_BUILDING_1044_INTERIOR_GRID1":
			if object_id == "ALTER_EGO":
				if not data().waffenlager_gesehen:
					data().waffenlager_gesehen = True
					dialogs.initDlg_002_VorWaffenlager()

		if grid_id == "ZZONE_7_BUILDING_1044_INTERIOR_GRID2":
			if object_id == "ALTER_EGO":
				if not data().waffenlager_innenraum_gesehen:
					data().waffenlager_innenraum_gesehen = True
					dialogs.initDlg_005_WaffenlagerLeer()

	return object_events.on_grid_enter( object_id, grid_id, old_grid_id )

def on_enter_region(id, objectid, partyid ):
	#print "[on_enter_region(", id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return

	if id == "HOEHLEEIN":
		if not data().shadows_killed:
			dialogs.initCutscene_010_Hoehlenochnichtsauber()

	if id == "HOEHLEAUS":
		if not data().shadows_killed:
			dialogs.initCutscene_010_Hoehlenochnichtsauber()
		elif not was_zone_entered("zone_9"):
			set_zone_enabled("zone_9", True)

	if id == "HOEHLENEINGANG":
		if not data().player_knows_Hoehleneingang:
			data().player_knows_Hoehleneingang = True
			system.add_minimap_marker(291,417,"MM_002")# Höhleneingang
		
	if id == "HOEHLENAUSGANG":
		if not data().player_knows_Hoehlenausgang:
			data().player_knows_Hoehlenausgang = True
			system.add_minimap_marker(248,241,"MM_003")# Höhlenausgang

	elif id == data().AngriffVonHinten:
		for schatten in ["SCHATTEN_015", "SCHATTEN_016"]:
			if not object.is_destroyed(schatten):
				character.arm_direct(schatten)
				object.move_to(schatten, x = 254.46, y = 231.35, speed=globals.MT_FAST, callback=["ONEND", HinterhaltAngriff])
	
def HinterhaltAngriff(object_id):
	enemies = character.get_visible_enemies(object_id)
	if len(enemies):
		object.attack(object_id, random.choice(enemies))

def on_object_killed(victim, attacker, weapon_type, weapon_id):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)

	hweite = 0
	if object.exists(weapon_type) and object.has_attribute(weapon_type,"hoerweite"):
		hweite = object.get_attribute(weapon_type,"hoerweite")

	if victim == "SCHATTEN_002":
		if object.get_distance_to_object(attacker,"SCHATTEN_003") < hweite:
			alarm_003()

	elif victim == "SCHATTEN_004":
		if object.get_distance_to_object(attacker,"SCHATTEN_005") < hweite:
			alarm_005()
		if object.get_distance_to_object(attacker,"SCHATTEN_006") < hweite:
			alarm_006()

	elif victim == "SCHATTEN_005":
		if object.get_distance_to_object(attacker,"SCHATTEN_006") < hweite:
			alarm_006()

	elif victim == "SCHATTEN_006":
		if object.get_distance_to_object(attacker,"SCHATTEN_005") < hweite:
			alarm_005()
			
	elif victim == "SCHATTEN_007":
		if object.get_distance_to_object(attacker,"SCHATTEN_008") < hweite:
			alarm_008()

	elif victim == "SCHATTEN_008":
		if object.get_distance_to_object(attacker,"SCHATTEN_009") < hweite:
			alarm_009()
		if object.get_distance_to_object(attacker,"SCHATTEN_010") < hweite:
			alarm_010()

	elif victim == "SCHATTEN_009":
		if object.get_distance_to_object(attacker,"SCHATTEN_010") < hweite:
			alarm_010()

	elif victim == "SCHATTEN_010":
		if object.get_distance_to_object(attacker,"SCHATTEN_009") < hweite:
			alarm_009()

	if victim in data().shadow_npcs:
		if len(data().shadow_npcs):
			if victim in data().shadow_npcs:
				data().shadow_npcs.remove(victim)
				if not len(data().shadow_npcs):
					data().shadows_killed = True
					if not was_zone_entered("zone_9.zone_9"):
						dialogs.initCutscene_009_SpielerHoltAbelUndAnieNach()
						system.set_qb_entry_state(data().QB_001, COMPLETE)
						character.add_experience_party(data().Exp)

def on_timer(id):
	#print "[debug on_timer()", id, "]"
	if not object.is_destroyed("SCHATTEN_001"):
		if id == data().TimerSchatten001:
			schedules.patrol001(id)
	
	if not object.is_destroyed("SCHATTEN_004"):
		if id == data().TimerSchatten004:
			schedules.pinkeln004(id)
			
	if not object.is_destroyed("SCHATTEN_008"):
		if id == data().TimerSchatten008:
			schedules.Barackengang008(id)
		elif id == data().TimerSchatten008b:
			schedules.InBarackeWartenFertig008(id)

def on_wait_for_commando(id):
	return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
	return False

def on_examine_object( character_id, object_id ):
	return False

def on_pick_up( character_id, item_id, item_type ):
	# Charta der Schatten lesen
	if (item_id == data().qi_charta[1]):
		dialogs.initDlg_006_DokumentNehmen()
		return True
	return True
	
def on_use( character_id, object_id, item_id, item_type ):
	#Spieler liest die Charta der Schatten
	if item_id == data().qi_charta[1]:
		dialogs.initCutscene_007_ChartaDerSchatten()
		return True
	return object_events.on_use( character_id, object_id, item_id, item_type )

def can_crack_lock_helper(char):
	picklocks = [ "SET_BASIC_PICKLOCK", "SET_VAMPED_PICKLOCK_SET", "SET_SET_OF_PICKLOCKS", data().qi_key[1]]
	for picklock in picklocks:
		if( object.count_in_inventory( char, picklock ) ):
			return True
	
def can_crack_lock( character_id, object_id, dummy_name ):
	#print '>>> can_crack_lock'
	if can_crack_lock_helper(character_id):
		#print '>>> can_crack_lock', object_id, dummy_name
		if (object_id.find('BUILDING_1044') != -1	and dummy_name == 'dmyp_door2_01'):
			return True
	return object_events.can_crack_lock( character_id, object_id, dummy_name )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
	#print ">>> on_crack_lock"
	
	# wenn der Spieler den Schluessel im Inventory hat
	if object_id.find('BUILDING_1044') != -1:
		character.play_animation(character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=["ONEND", dialogs.initDlg_004_SpielerOeffnetTuer])
		object.remove_closed_lock_by_name('ZZONE_7_BUILDING_1044', 'lock2')
		data().schloss_geknackt = True
		sounds.play_3d_sound( "lockpick_success", x, y, z )
		return True
	# ansonsten wirds per Dietrich versucht
	return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

def can_blast_lock( character_id, object_id, dummy ):
	#print ">>> can_blast_lock"
	if not has_talent( character_id, "explosives", "blast_locks" ):
		return False
	explosives = [ "SET_GUN_POWDER" ]

	for explosive in explosives:
		if( object.count_in_inventory( character_id, explosive ) ):
			return True

	return object_events.can_blast_lock( character_id, object_id, dummy )

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
	#print ">>> on_blast_lock"
	if object_id.find('BUILDING_1044') != -1:
		dummy_name = "dmyp_door2_01"
		x,y,z = object.get_full_dummy_position(object_id, dummy_name)
		data().schloss_geknackt = True
		lambda_string = 'dialogs.initDlg_004_SpielerOeffnetTuer(); object_events.on_lock_explode("%s","%s",%f,%f,%f)' %(object_id,dummy_name,x,y,0.5)
		#print ">>> lambda_string",lambda_string
		character.play_animation(character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=[ "ONEND", Lambda(lambda_string)])
		return True
	
	return on_blast_lock( character_id, object_id, dummy_name, x, y, z )

def can_leave_zone():
	return True

def initItems():
	if not hasattr(data(),"patch_patrick"):
		data().patch_patrick = 1
	
	object.create_item_in_inventory("ZZONE_7_BUILDING_1690",["SET_STEEL_CLAD_BOOTS","SET_MULTIPLE_SOCKET","SET_KEVLAR_HELMET"])
	object.create_item_in_inventory("ZZONE_7_BUILDING_1691",["SET_PROTECTIVE_GLOVES","SET_ELECTROSHOCKER","SET_MEAT_RAW"])
	

	object.create_item_in_inventory(object = 'SCHATTEN_001' ,equipment=['SET_HK_CAWS', 'SET_AMMOPACK_3_12_MM'])
	character.equip_direct("SCHATTEN_001", equipment="SET_HK_CAWS", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'SCHATTEN_002' ,equipment=['SET_M_16', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	
	object.create_item_in_inventory(object = 'SCHATTEN_003' ,equipment=['SET_M60', 'SET_AMMOPACK_7_62NATO_MM', 'SET_AMMOPACK_7_62NATO_MM'])
	
	object.create_item_in_inventory(object = 'SCHATTEN_004' ,equipment=['SET_M_16', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	
	object.create_item_in_inventory(object = 'SCHATTEN_005' ,equipment=['SET_M_16', 'SET_AMMOPACK_7_62NATO_MM', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	object.create_item_in_inventory(object = 'SCHATTEN_006' ,equipment=['SET_MP5', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM'])
	
	object.create_item_in_inventory(object = 'SCHATTEN_007' ,equipment=['SET_BARRET_M82A2'])
	character.equip_direct("SCHATTEN_007", equipment="SET_BARRET_M82A2", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'SCHATTEN_008' ,equipment=['SET_M_16', 'SET_AMMOPACK_7_62NATO_MM'])
	character.equip_direct("SCHATTEN_008", equipment="SET_M_16", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'SCHATTEN_009' ,equipment=['SET_MP5', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM'])
	object.create_item_in_inventory(object = 'SCHATTEN_010' ,equipment=['SET_MP5', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM'])
	
	object.create_item_in_inventory(object = 'SCHATTEN_011' ,equipment=['SET_M_16_M203', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_40_MM_RPG7_HE'])
	character.equip_direct("SCHATTEN_011", equipment="SET_M_16_M203", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'SCHATTEN_012' ,equipment=['SET_M_16', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	character.equip_direct("SCHATTEN_012", equipment="SET_M_16", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'SCHATTEN_013' ,equipment=['SET_REMINGTON_M870'])
	character.equip_direct("SCHATTEN_013", equipment="SET_REMINGTON_M870", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'SCHATTEN_014' ,equipment=['SET_MP5', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM', 'SET_HEGRENADE'])
	
	object.create_item_in_inventory(object = 'SCHATTEN_015' ,equipment=['SET_M60'])
	character.equip_direct("SCHATTEN_015", equipment="SET_M60", direct_ammo_load=True)
	object.create_item_in_inventory(object = 'SCHATTEN_016' ,equipment=['SET_M_16_M203', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	character.equip_direct("SCHATTEN_016", equipment="SET_M_16_M203", direct_ammo_load=True)
	
	#Charta der Schatten
	system.create_object(equipmenttype=data().qi_charta[0], x=251.64, y=245.93, id = data().qi_charta[1])
	object.set_position_free(data().qi_charta[1], 251.64, 245.93, 0.8)
	object.set_attribute(data().qi_charta[1], "generic_item", False)
	
	#Schluessel der Waffenkammer
	system.create_object(equipmenttype=data().qi_key[0], x=260.95, y=238.13, id = data().qi_key[1])
	object.set_position_free(data().qi_key[1], 260.95, 238.13, 1)
	object.set_attribute(data().qi_key[1], "generic_item", False)

	# Wäschekorb	
	# object.create_item_in_inventory( 'BUILDING_133', equipment=[ 'SET_PLASTIC_BOWL' ] )
	# Tisch
	object.create_item_in_inventory( 'BUILDING_1469', equipment=[ 'SET_STEEL_HELMET', 'SET_DART' ] )
	# Feldbett
	object.create_item_in_inventory( 'BUILDING_1433', equipment=[ 'SET_BROKEN_POCKET_CALCULATOR' ] )
	# Fass
	#object.create_item_in_inventory( 'BUILDING_116', equipment=[ 'SET_MEDIPACK_BIG', 'SET_HK_G11' ] )
	# Holzkommode
	object.create_item_in_inventory( 'BUILDING_1683', equipment=[ 'SET_CHAIN_SAW', 'SET_KEVLAR_HELMET' ] )
	# Spind
	object.create_item_in_inventory( 'BUILDING_1657', equipment=[ 'SET_AMMOPACK_BOLT', 'SET_LANDMINE' ] )
	# Hundehütte
	#object.create_item_in_inventory( 'BUILDING_923', equipment=[ 'SET_MEAT_COOKED', 'SET_AMMOPACK_357_DUMDUM' ] )
	# Holzfaß
	#object.create_item_in_inventory( 'BUILDING_373', equipment=[ 'SET_KEROSENE_CANISTER' ] )
	# Tischchen
	object.create_item_in_inventory( 'BUILDING_1686', equipment=[ 'SET_BASEBALL_BAT' ] )
	
	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_1437', equipment=[ 'SET_TIN_CAN', 'SET_AMMOPACK_44_CORBON', 'SET_KEVLAR_HELMET' ] )
	object.create_item_in_inventory( 'BUILDING_1470', equipment=[ 'SET_WATER_CAN', 'SET_MEDIPACK_BIG', 'SET_AMMOPACK_20_MM_AP' ] )
	object.create_item_in_inventory( 'BUILDING_1641', equipment=[ 'SET_DT21_LIGHT_ARMOR', 'SET_TOOTHBRUSH', 'SET_UZI_W_SILENCER_W_LASERPOINTER' ] )
	object.create_item_in_inventory( 'BUILDING_1642', equipment=[ 'SET_C4_TIMEBASED', 'SET_DT21_STEEL_CLAD_BOOTS', 'SET_KATANA' ] )
	object.create_item_in_inventory( 'BUILDING_1643', equipment=[ 'SET_RED_SHARD', 'SET_AMMOPACK_44_DUMDUM', 'SET_DT21_GAUNTLETS' ] )
	object.create_item_in_inventory( 'BUILDING_1660', equipment=[ 'SET_MEAT_COOKED_BIG', 'SET_AMMOPACK_20_MM_HE', 'SET_HK_MP7' ] )
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0, y1 = 200, x2 = 575, y2 = 0 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 0, y1 = 440, x2 = 575, y2 = 639 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )

def initFX():
	for lf in FIRE:
		fxLagerFeuer(lf)
	for sb in SMALL_BASIN:
		fxBrennendeBasingSmall(sb)
	for p_1 in PILAR_1:
		fxPillar_1(p_1)
	for p_2 in PILAR_2:
		fxPillar_2(p_2)
	
def initFoeLists():
	for id in data().shadow_npcs:
		if not id in ["SCHATTEN_003","SCHATTEN_005","SCHATTEN_006","SCHATTEN_009","SCHATTEN_010"]:
			object.set_attribute( id, attribute="foes", value=["UISPIELER"])
		
## Feuereffekte für FIRE (Lagerfeuer)
def fxLagerFeuer(objectid):
	system.start_effect_object(object=objectid, node="effekt_feuer", parameter=fx_fire_lagerfeuer_big)
	system.start_effect_object(object=objectid, node="effekt_feuer01", parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=objectid, node="effekt_feuer02", parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=objectid, node="effekt_feuer03", parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=objectid, node="effekt_feuer04", parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big", object=objectid, loop=True)
	
## Feuereffekte für FIRE_BASING_SMALL
def fxBrennendeBasingSmall(_objectid):
	system.start_effect_object(object=_objectid, node="dmyp_fire", parameter=fx_fire_basin_small)

# einzelne Fackel
def fxPillar_1(objectid):
	system.start_effect_object(object = objectid, node="dmyp_fire", parameter=fx_fire_pilar_1)

# 4er Fackel
def fxPillar_2(objectid):
	system.start_effect_object(object = objectid, node="dmyp_fire0", parameter=fx_fire_pilar_2)
	system.start_effect_object(object = objectid, node="dmyp_fire1", parameter=fx_fire_pilar_2)
	system.start_effect_object(object = objectid, node="dmyp_fire2", parameter=fx_fire_pilar_2)
	system.start_effect_object(object = objectid, node="dmyp_fire3", parameter=fx_fire_pilar_2)

def UnEquip_Weapon_Direct(char_id):
	if object.has_attribute(char_id, 'slots'):
		if 'right_hand' in object.get_attribute(char_id, 'slots'):
			if not ((object.get_attribute(char_id, 'slots')['right_hand']) == None):
				#print 'debug_UnEquip_Weapon_Direct_right_hand', char_id, object.get_attribute(char_id, 'slots')['right_hand']
				character.un_equip_direct(char_id, (object.get_attribute(char_id, 'slots')['right_hand']))
		if 'left_hand' in object.get_attribute(char_id, 'slots'):
			if not ((object.get_attribute(char_id, 'slots')['left_hand']) == None):
				#print 'debug_UnEquip_Weapon_Direct_left_hand', char_id, object.get_attribute(char_id, 'slots')['right_hand']
				character.un_equip_direct(char_id, (object.get_attribute(char_id, 'slots')['left_hand']))
	return
	
## Minenexplosionseffekt
def animMinenExplosion(id):
	system.start_effect(startx=259.27,
				starty=305.71,
				startz=1,
				dirx=259.27,
				diry=305.71,
				dirz=1.4,
				parameter=fx_explosion_medium)
				
	sounds.play_3d_sound(sfx_id="landmine_explo",
				x=259.27,
				y=305.71,
				z=0)

def on_begin_cutscene():
	"""is called when a cutscene is started""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()

	for mob in mobs:
		system_events.save_foes(mob)
		system_events.save_speedfactor(mob)
		object.cancel_commandos(mob)

	# make sure AE is available
	if object.is_unconscious("ALTER_EGO"):
		import object_events
		object_events.on_resuscitate("ALTER_EGO", "ALTER_EGO")
	
	#make npcs and animals visible during a cutscene
	#deactivate visibility fading
	for id in (system.get_npcs() + system.get_animals()):
		object.set_attribute(id, "visibility", UIVIS_VISIBLE)
		object.set_attribute(id, "visibility_fade", False)
	
def on_end_cutscene():
	"""is called when a cutscene ends""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()

	for mob in mobs:
		system_events.restore_foes(mob)
		system_events.restore_speedfactor(mob)
		
	#activate visibilty fading
	for id in (system.get_npcs() + system.get_animals()):
		object.set_attribute(id,"visibility_fade", True)

def InitChestsSafes():
	object.add_closed_lock("BUILDING_1437", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_1470", "lock1", closure_type='lock-trap')
	object.add_closed_lock("BUILDING_1641", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_1642", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_1643", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_1660", "lock1", closure_type='booby-trap')

def init_patch():
	if not hasattr(data(), "patch_patrick"):
		data().patch_patrick = 1
		object.create_item_in_inventory("ZZONE_7_BUILDING_1690",["SET_STEEL_CLAD_BOOTS","SET_MULTIPLE_SOCKET","SET_KEVLAR_HELMET"])
		object.create_item_in_inventory("ZZONE_7_BUILDING_1691",["SET_PROTECTIVE_GLOVES","SET_ELECTROSHOCKER","SET_MEAT_RAW"])

		if not object.is_destroyed("SCHATTEN_003"):
			object.cancel_commandos("SCHATTEN_003")
			object.set_position("SCHATTEN_003", 341.63, 390.23, 'SQZONE_4_BUILDING_60_INTERIOR_GRID3')
			object.move_to("SCHATTEN_003", 341.45, 390.58, 'SQZONE_4_BUILDING_60_INTERIOR_GRID3')

		if not object.is_destroyed("SCHATTEN_005"):
			object.cancel_commandos("SCHATTEN_005")
			object.set_position("SCHATTEN_005", 373.56, 317.22, 'SQZONE_4_BUILDING_122_INTERIOR_GRID2')
			object.move_to("SCHATTEN_005", 373.11, 317.21, 'SQZONE_4_BUILDING_122_INTERIOR_GRID2')
		
		if not object.is_destroyed("SCHATTEN_006"):
			object.cancel_commandos("SCHATTEN_006")
			object.set_position("SCHATTEN_006", 373.85, 312.91, 'SQZONE_4_BUILDING_122_INTERIOR_GRID3')
			object.move_to("SCHATTEN_006", 373.27, 313.00, 'SQZONE_4_BUILDING_122_INTERIOR_GRID3')
			
		if not object.is_destroyed("SCHATTEN_009"):
			object.cancel_commandos("SCHATTEN_009")
			object.set_position("SCHATTEN_009", 332.87, 278.23, 'SQZONE_4_BUILDING_330_INTERIOR_GRID3')
			object.move_to("SCHATTEN_009", 332.26, 278.34, 'SQZONE_4_BUILDING_330_INTERIOR_GRID3')
		
		if not object.is_destroyed("SCHATTEN_010"):
			object.cancel_commandos("SCHATTEN_010")
			object.set_position("SCHATTEN_010", 332.57, 284.27, 'SQZONE_4_BUILDING_330_INTERIOR_GRID2')
			object.move_to("SCHATTEN_010", 332.38, 283.86, 'SQZONE_4_BUILDING_330_INTERIOR_GRID2')
	if not hasattr(data(), "ae_beim_putzen"):
		data().ae_beim_putzen = True
		system.add_region("HOEHLEEIN",200,428,400,460)
		system.notify_region_entered("HOEHLEEIN", "ALTER_EGO", permanent=True)
		system.add_region("HOEHLEAUS",200,150,400,212)
		system.notify_region_entered("HOEHLEAUS", "ALTER_EGO", permanent=True)

