# -*- coding: utf-8 -*-
from globals import *
import npc
import dialogs
import schedules
import const
import object_events
from const import *

#*** aktuelle Revision 4, 12.10.2004 *******************************************

def GetZoneEnterLocation(enterdirection):
	start_locations = \
	{		"NORTH":	(211.04, 255.61),
			"EAST":		(211.04, 255.61),
			"SOUTH":	(211.04, 255.61),
			"WEST":		(211.04, 255.61),
	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection

def on_init():
	skies.init_sky_preset("cave")		

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionensystem.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Hoehle",200,310,305,195)
	
	data("rest").non_rest_areas.append("Hoehle")

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()

def on_map_loaded():
	init_data()
	initParties()
	# place player characters
	location = GetZoneEnterLocation( "NORTH" )
	system.zone_transfer_place_characters( location[0], location[1] )
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	npc.initNPCS()
	initItems()
	initObjects()
	initRegions()
	initExitZones()
	initFX()
	data().QB_001 = system.register_qb_entry('ZZONE8_AIM_01')
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_scriptuse_objects()
	InitChestsSafes()
	# initFoeLists()
	init_character_states()
	init_non_rest_areas()
	
def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()
	
def can_leave_zone():
	return not len(data().GNO)


# *** callbacks ****************************************************************
# approach callback
def on_approach(target,operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

# region enter callback
def on_enter_region(id, objectid, partyid ):
	print "on_enter_region(", id, objectid, partyid," )"
	
	if isinstance(objectid, list) or isinstance(objectid, tuple):
		if len(objectid):
			objectid = objectid[-1]
		else:
			return False
	
	if id == "HOEHLENEINGANG":
		if not data().player_knows_Hoehleneingang:
			data().player_knows_Hoehleneingang = True
			system.add_minimap_marker(232,249,"MM_001")# Höhleneingang

	if id == "LAGERRAUM":
		if not data().player_knows_Lagerraum:
			data().player_knows_Lagerraum = True
			system.add_minimap_marker(319,215,"MM_002")# Lagerraum
	
	if id == "REGION_CAGE_ENTRY":
		for w in ["ROWLAND", "BANKS"]:
			if w in system.get_npcs():
				object.cancel_commandos(w)
				object.turn_to_object(w, objectid)
	
	if id == "REGION_EXIT_COMMENT":
		#pc will hoehle verlassen
		if objectid in system.get_pcs():
			if not len(data().GNO) and data().WissenschaftlerGesprochen:
				dialogs.initDlg_021_SpielerBrichtZurBiosphaereAuf()
			else:
				dialogs.initDlg_023_SpielerKannHoehleNichtVerlassen()
		#gnos  fliehen
		elif objectid in data().GNO:
			data().GNO.remove(objectid)
			object.set_active_state(objectid, 0)
			dialogs.check_all_gno_gone(data().GNO)
		
	if id == "REGION_SCHLAFRAUM1":
		if data().SkelettGefunden == True:
			dialogs.initDlg_010_S2SpielerFindetSkelettZweiterFund()
		else:
			dialogs.initDlg_009_S2SpielerFindetSkelettErsterFund()
			data().SkelettGefunden = True
	
	elif id == "REGION_SCHLAFRAUM2":
		if data().SkelettGefunden == True:
			dialogs.initDlg_006_S1SpielerFindetSkelettZweiterFund()
		else:
			dialogs.initDlg_005_S1SpielerFindetSkelettErsterFund()
			data().SkelettGefunden = True
	
	elif id == "REGION_LAGERRAUM":
		if not object.is_fighting(objectid):
			dialogs.initDlg_013_SpielerBetrittLagerraum()
		else:
			enemy_script.delay(15.0, Lambda('system.notify_region_entered("REGION_LAGERRAUM", partyid="UISPIELER")'))

	elif id == "REGION_EXNORD" or id == "REGION_EXSUED":
		#print ">>> region ex"
		if not data().Dlg22WarSchon:
			#print "region ex gefeuert und ausgelöst"
			dialogs.initDlg_022_EXbedrohtGeiseln()
			data().Dlg22WarSchon = True
	
	if id == 'REGION_GNO_1_KONTACKT' and not data().Region_GNO_1_Kontackt_Betreten:
		data().Region_GNO_1_Kontackt_Betreten = True
		dialogs.initDlg_002_SpielerTrifftAufGNO()
		

# timer event callback
def on_timer(id):
	pass
	#print "[debug on_timer()", id, "]"

# activity callback
def on_wait_for_commando(id):
	return schedules.Activity(id)

# use callback
def can_use( character_id, object_id ):
	return object_events.can_use( character_id, object_id )

def on_use( character_id, object_id, item_id, item_type ):
	if character_id == "ALTER_EGO":
		if item_id == data().qi_diary[1]:
			dialogs.initDlg_001_SpielerLiestDasTagebuch()
	
	return object_events.on_use( character_id, object_id, item_id, item_type )

# exchange callback
def can_exchange( character_id, target_id, item_id, item_type ):
	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
	return False
	
def on_object_killed(victim, attacker, weapon_type, weapon_id):
	if victim == "EX":
		if not data().ex_last_dialog:
			if data().verrat:
				dialogs.initDlg_004_LetzteWorteExVerrat()
			else:
				dialogs.initDlg_003_LetzteWorteEx()
	
	if victim in data().GNO:
		data().GNO.remove(victim)
		dialogs.check_all_gno_gone(data().GNO)
			
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id)
	
# examine callback
def can_examine_object( char, obj ):
	if char == "ALTER_EGO":
		#skelette
		if obj in ['ZZONE_8_BUILDING_643','ZZONE_8_BUILDING_642', 'ZZONE_8_BUILDING_622']:
			return True
	return False

def on_examine_object( char, obj ):
	if char == 'ALTER_EGO':
		# zwei skelette in 1. schlafraum
		if obj in ['ZZONE_8_BUILDING_643','ZZONE_8_BUILDING_642']:
			if (data().schlafraum_1_skelett_1 == None or data().schlafraum_1_skelett_1 == obj):
				data().schlafraum_1_skelett_1 = obj
				dialogs.initDlg_007_SpielerUntersuchtDasErsteSkelett()
			else:
				if (data().schlafraum_1_skelett_2 == None or data().schlafraum_1_skelett_2 == obj):
					data().schlafraum_1_skelett_2 = obj
				dialogs.initDlg_008_SpielerUntersuchtDasZweiteSkelett()
		
		# skelett in 2. schlafraum
		if obj == 'ZZONE_8_BUILDING_622':
			if not data().diary_found:
				dialogs.initDlg_011_SpielerFindetDasTagebuch()
			else:
				dialogs.initDlg_012_SpielerUntersuchtDasDritteSkelett()

# pickup callback
def on_pick_up( character_id, item_id, item_type ):
	return True

def make_foe(char):
	dist = 100
	pcs = system.get_pcs()
	for pc in pcs:
		d = object.get_distance(pc, char) 
		if d < dist:
			dist = d
	
	if char in data().GNO_2:
		if not data().Dlg22WarSchon:
			object.cancel_commandos(char)
			if dist < 15.0:
				dialogs.initDlg_022_EXbedrohtGeiseln()
				data().Dlg22WarSchon = True

		if char == "EX":
			object.set_immortal_state(char, False)
			object.set_attribute(char, "hitpoints", 1000)
		object.set_attribute(char, "foes", ['UISPIELER'])

# fight callbacks
def on_enemy_spotted(object_id):
	#print ">>> on_enemy_spotted(", object_id, ")"
	"""
	if not object.has_attribute(object_id, "has_spotted_enemy"):
		object.set_attribute(object_id, "has_spotted_enemy", True)
	else:
		return False
	"""
	if object_id in system.get_pcs():
		if object_id == "ALTER_EGO":
			if data().GNOgetroffen == False:
				data().GNOgetroffen = True
				#dialogs.initDlg_002_SpielerTrifftAufGNO()
	else:
		make_foe(object_id)

def on_attack(operator, target):
	enemies = character.get_visible_enemies(operator)
	#print ">>> on_attack(", operator, target, enemies,")"
	
	if data().gno_refugees:
		
		data().gno_refugees = False
		for id in data().GNO:
			if not object.is_destroyed(id):
				object.cancel_commandos(id)
				if id != target:
					object.turn_to_object(id, target)
				if id != "EX":
					object.set_attribute(id, "foes", ['UISPIELER'])
				else:
					object.set_attribute("EX", "hitpoints", 1000)
					object.set_immortal_state("EX", False)
					object.set_attribute(id, "foes", ['UISPIELER'])
		
	if data().GNOgetroffen == False and not data().Region_GNO_1_Kontackt_Betreten:
		data().Region_GNO_1_Kontackt_Betreten = True
		data().GNOgetroffen = True
		dialogs.initDlg_002_SpielerTrifftAufGNO()
	
	if target in data().GNO:
		if target=="EX":
			make_ex_hit(target)
		else:
			make_foe(target)

def make_ex_hit(char):
	object.cancel_commandos(char)
	if not data().ex_got_hit:
		data().ex_got_hit = True
		object.cancel_commandos(char)
		object.set_attribute(char, "foes", None)
		allow_activity(char)
		object.set_attribute(char, "hitpoints", data().ex_normal_hitpoints)
		object.set_immortal_state(char, True)
		character.unequip_hands(char, direct_unequip=True)
		inventory = object.get_inventory_ids(char)
		for item in inventory:
			if item[1] > 0:
				for elem in item[0]:
					object.drop_item(char, elem)


# *** initializations **********************************************************
def initParties():
	system.create_party(id="UISPIELER", type=PT_HUMAN)
	system.create_party(id="NPCS", type=PT_COMPUTER)
	system.create_party(id="GNO", type=PT_COMPUTER)
	
# markieren von im script modifizierbaren mapobjekten
def init_scriptuse_objects():
	#lagerfeuer
	for lf in const.FIREPLACES_SMALL:
		system.mark_for_script_use(lf)
	
	#kisten
	system.mark_for_script_use("BUILDING_770")
	
	# Bienenstöcke ZZone 8
	
	

# setzt chars mortal bzw immortal + foes attribute fuer animals
def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		object.set_immortal_state(npc, False)
		character.set_approachable_state(npc, False)
		if npc not in data().GNO:
			character.set_approachable_state(npc, True)
			object.set_immortal_state(npc, True)
		#if npc in data().GNO:
		#	object.set_attribute(npc, "foes", ["UISPIELER"])
	data().ex_normal_hitpoints = object.get_attribute('EX', "hitpoints")
	#ex die anfuehrerin
	object.set_attribute("EX", "maxhitpoints", 1000)
	object.set_attribute("EX", "hitpoints", 1000)
	character.set_approachable_state("EX",True)
	object.set_immortal_state("EX",False)
	
# erzeugen von items im inventory von npcs oder in der zone
def initItems():
	object.create_item_in_inventory(object = 'GNO_SOLDAT_001' ,equipment=['SET_M_16', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_001", equipment="SET_M_16", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_002' ,equipment=['SET_SPAS_15', 'SET_AMMOPACK_2_12_MM'])
	character.equip("GNO_SOLDAT_002", equipment="SET_SPAS_15", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_003' ,equipment=['SET_SPAS_15', 'SET_AMMOPACK_2_12_MM'])
	character.equip("GNO_SOLDAT_003", equipment="SET_SPAS_15", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_004' ,equipment=['SET_HK_G41', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_004", equipment="SET_HK_G41", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_005' ,equipment=['SET_M_16', 'SET_AMMOPACK_7_62NATO_MM'])
	character.equip("GNO_SOLDAT_005", equipment="SET_M_16", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_006' ,equipment=['SET_MP5', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM'])
	character.equip("GNO_SOLDAT_006", equipment="SET_MP5", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_007' ,equipment=['SET_HK_G41', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_007", equipment="SET_HK_G41", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_008' ,equipment=['SET_HK_G41', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_008", equipment="SET_HK_G41", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_009' ,equipment=['SET_M249', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_009", equipment="SET_M249", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_010' ,equipment=['SET_M249', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_010", equipment="SET_M249", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_011' ,equipment=['SET_STEYR_TMP', 'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM'])
	character.equip("GNO_SOLDAT_011", equipment="SET_STEYR_TMP", direct_ammo_load=True)
	
	# Granatenjungs
	object.create_item_in_inventory(object = 'GNO_SOLDAT_012' ,equipment=['SET_HEGRENADE', 'SET_HEGRENADE', 'SET_AMMOPACK_5_56_MM'])
	character.equip("GNO_SOLDAT_012", equipment="SET_HEGRENADE", direct_ammo_load=True)
	
	object.create_item_in_inventory(object = 'GNO_SOLDAT_013' ,equipment=['SET_HK_G36C', 'SET_AMMOPACK_5_56_MM', 'SET_HEGRENADE'])
	character.equip("GNO_SOLDAT_013", equipment="SET_HEGRENADE", direct_ammo_load=True)
	
	# Ex
	object.create_item_in_inventory(object = 'EX' ,equipment=['SET_M_16_M203', 'SET_AMMOPACK_5_56_MM', 'SET_AMMOPACK_M79_M203'])
	character.equip("EX", equipment="SET_M_16_M203", direct_ammo_load=True)

	system.create_object("SET_HEGRENADE",308.29,298.86)
	system.create_object("SET_HEGRENADE",308.76,299.14)

	# Items in Kisten
	object.create_item_in_inventory( 'BUILDING_797', equipment=[ 'SET_RAGS', 'SET_AMMOPACK_44_CORBON_DUMDUM', 'SET_MEAT_COOKED_HUMONGOUS' ] )
	object.create_item_in_inventory( 'BUILDING_798', equipment=[ 'SET_DT21_GAUNTLETS', 'SET_MULTI_MEDIPACK', 'SET_MACHETE' ] )
	object.create_item_in_inventory( 'BUILDING_770', equipment=[ 'SET_LASER_GUN', 'SET_BICYCLE_SEAT', 'SET_M46_HEAVY_ARMOR' ] )
	object.create_item_in_inventory( 'BUILDING_799', equipment=[ 'SET_RPG7', 'SET_MAC_10_W_SILENCER', 'SET_HAIR_DRYER' ] )
	object.create_item_in_inventory( 'BUILDING_800', equipment=[ 'SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', 'SET_NIGHT_VISION_GEAR' ] )
	
	# Metallkiste
	object.create_item_in_inventory( 'BUILDING_740', equipment=[ 'SET_GARLIC_PRESS' ] )
	# Eimer
	object.create_item_in_inventory( 'BUILDING_733', equipment=[ 'SET_LANDMINE' ] )
	# Mehlsack
	#object.create_item_in_inventory( 'BUILDING_501', equipment=[ 'SET_SHURIKEN' ] )
	# Zeitungsstapel
	#object.create_item_in_inventory( 'BUILDING_503', equipment=[ 'SET_GAME_JOY' ] )
	# Aschefaß
	# object.create_item_in_inventory( 'BUILDING_507', equipment=[ 'SET_MEDIPACK_BIG' ] )
	# Schlafsack
	object.create_item_in_inventory( 'BUILDING_637', equipment=[ 'SET_WATER_BOTTLE' ] )
	# Kiste
	object.create_item_in_inventory( 'BUILDING_650', equipment=[ 'SET_POWER_DRILL', 'SET_M46_ARMORED_HELMET' ] )
	# Schlafsack
	object.create_item_in_inventory( 'BUILDING_531', equipment=[ 'SET_DT21_STEEL_CLAD_BOOTS' ] )
	# 
	system.create_object(equipmenttype="SET_TRASH_CAN", x=260, y=284)
	# 
	system.create_object(equipmenttype="SET_THROWING_KNIFE", x=261, y=284)
	# 83
	#object.create_item_in_inventory( 'BUILDING_83', equipment=[ 'SET_STEYR_TMP_W_SILENCER', 'SET_BOOMERANG' ] )
	# 
	system.create_object(equipmenttype="SET_WIRE_WHISK", x=294, y=294)
	# 
	system.create_object(equipmenttype="SET_HK_UMP_45_W_SILENCER", x=305, y=296)
	

# Erzeugen von Fahrzeugen, Spezialobjekten etc
def initObjects():
	pass

# Regionen einrichten
def initRegions():
	system.add_region("REGION_GNO_1_KONTACKT", 236.98, 242.98, 233.78, 252.83)
	system.notify_region_entered("REGION_GNO_1_KONTACKT", partyid="UISPIELER")
	system.add_region("REGION_SCHLAFRAUM1", 275.28, 206.43, 284.38, 216.15)
	system.notify_region_entered("REGION_SCHLAFRAUM1", partyid="UISPIELER")
	system.add_region("REGION_SCHLAFRAUM2", 295.92, 205.72, 302.15, 219.19)
	system.notify_region_entered("REGION_SCHLAFRAUM2", partyid="UISPIELER")
	system.add_region("REGION_LAGERRAUM", 318.22, 227.25, 326.21, 226.55)
	system.notify_region_entered("REGION_LAGERRAUM", partyid="UISPIELER")
	
	system.add_region("LAGERRAUM", 318.22, 227.25, 326.21, 226.55)
	system.notify_region_entered("LAGERRAUM", partyid="UISPIELER")

	system.add_region("REGION_EXNORD", 308.44, 269.52, 296.12, 263.92)
	system.add_region("REGION_EXSUED", 288.10, 298.13, 287.31, 303.32)
	system.notify_region_entered("REGION_EXNORD", partyid="UISPIELER")
	system.notify_region_entered("REGION_EXSUED", partyid="UISPIELER")
	
	system.add_region("REGION_EXIT_COMMENT", 211.237, 262.29, 217.92, 243.88)
	system.add_region("REGION_CAGE_ENTRY", 298.93, 285.95, 298.16, 282.75)

	system.add_region("HOEHLENEINGANG", 223,243,249,260)
	system.notify_region_entered("HOEHLENEINGANG", partyid="UISPIELER")
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.0, y1 = 200.0, x2 = 205.00, y2 = 310.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )

def initFX():
	for object_id in const.FIREPLACES_SMALL:
		fx_lagerfeuer_small(object_id)
	
	for object_id in const.BURNING_TONS:
		fx_brennende_tonne(object_id)
	
	for sb in const.SMALL_BASINS:
		fx_brennendes_basing_klein(sb)
	
	for p_1 in const.PILLARS_1:
		fx_fackel_klein(p_1)
	
	for p_2 in const.PILLARS_2:
		fx_fackel_4fach(p_2)

def fx_lagerfeuer(object_id):
	system.start_effect_object(object=object_id, node="effekt_feuer", parameter=fx_fire_lagerfeuer)
	system.start_effect_object(object=object_id, node="effekt_feuer01", parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=object_id, node="effekt_feuer02", parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=object_id, node="effekt_feuer03", parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=object_id, node="effekt_feuer04", parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=object_id,loop=True)

def fx_lagerfeuer_small(object_id):
	system.start_effect_object(object=object_id, node="effekt_feuer", parameter=fx_fire_lagerfeuer_small)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=object_id,loop=True)

def fx_brennende_tonne(object_id):
	system.start_effect_object(object=object_id, node="sort1", parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=object_id,loop=True)

## Feuereffekte für FIRE_BASING_SMALL
def fx_brennendes_basing_klein(object_id):
	system.start_effect_object(object=object_id, node="dmyp_fire", parameter=fx_fire_basin_small)

# einzelne Fackel
def fx_fackel_klein(object_id):
	system.start_effect_object(object = object_id, node="dmyp_fire", parameter=fx_fire_pilar_1)

# 4er Fackel
def fx_fackel_4fach(object_id):
	system.start_effect_object(object = object_id, node="dmyp_fire0", parameter=fx_fire_pilar_2)
	system.start_effect_object(object = object_id, node="dmyp_fire1", parameter=fx_fire_pilar_2)
	system.start_effect_object(object = object_id, node="dmyp_fire2", parameter=fx_fire_pilar_2)
	system.start_effect_object(object = object_id, node="dmyp_fire3", parameter=fx_fire_pilar_2)

def initFoeLists():
	for id in data().GNO_1:
		object.set_attribute( id, attribute="foes", value=["UISPIELER"])

def InitChestsSafes():
	object.add_closed_lock("BUILDING_797", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_798", "lock1", closure_type='normal')
	object.add_closed_lock("BUILDING_770", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_799", "lock1", closure_type='booby-trap')
	object.add_closed_lock("BUILDING_800", "lock1", closure_type='normal')

def init_patch():
	
	if not hasattr(data(), 'Region_GNO_1_Kontackt_Betreten') and not was_zone_entered('zzone_8.zzone_8'):
		system.add_region("REGION_GNO_1_KONTACKT", 236.98, 242.98, 233.78, 252.83)
		system.notify_region_entered("REGION_GNO_1_KONTACKT", partyid="UISPIELER")
		data().Region_GNO_1_Kontackt_Betreten = False
	else:
		for id in data().GNO_1:
			if not object.is_destroyed(id):
				if object.has_attribute( id, "foes"):
					data().Region_GNO_1_Kontackt_Betreten = True
					return
			else:
				data().Region_GNO_1_Kontackt_Betreten = True
				return
		data().Region_GNO_1_Kontackt_Betreten = False
			
			
			
			
			
			
