# -*- coding: utf-8 -*-
from globals import *
from item import *
import combos

def clone_weapon_type(typeid, new_typeid, attachments=None):
   assert typeid!=new_typeid
   attributes = object.get_attributes(object=typeid)
   for attribute in attributes:
      if attribute!="id":
         object.set_attribute(object=new_typeid,
            attribute=attribute,
            value=object.get_attribute(object=typeid, attribute=attribute))
   if attachments:
      value = object.get_attribute(object=typeid, attribute="value")
      weight = object.get_attribute(object=typeid, attribute="weight")

      for part in attachments:
         value+=object.get_attribute(object=part, attribute="value")
         weight+=object.get_attribute(object=part, attribute="weight")

      object.set_attribute(object=new_typeid, attribute="value", value=value)
      object.set_attribute(object=new_typeid, attribute="weight", value=weight)
      object.set_attribute(object=new_typeid, attribute="attachments", value=attachments)

      if "SET_SILENCER" in attachments:
         if object.has_attribute(typeid, "hoerweite"):
            basic_earshot = object.get_attribute(typeid, "hoerweite") / 2
         else: basic_earshot = 0.0
         earshot = min(basic_earshot, 10.0)
         object.set_attribute(object=new_typeid, attribute="hoerweite", value=earshot)

## leichte waffen
create_weapon_type(typeid='SET_WALTER_PPK')
object.set_attribute(object='SET_WALTER_PPK', attribute="name", value=globaltext.SET_WALTER_PPK_NAME)
object.set_attribute(object='SET_WALTER_PPK', attribute="hint", value=globaltext.SET_WALTER_PPK_HINT)
object.set_attribute(object='SET_WALTER_PPK', attribute="resourceui", value='RES_ITEM65X32_WEAPON_WALTER_PPK')
object.set_attribute(object='SET_WALTER_PPK', attribute="resource3d", value='RES3D_WALTER_PPK')
object.set_attribute(object='SET_WALTER_PPK', attribute="value", value=3.00)
object.set_attribute(object='SET_WALTER_PPK', attribute="weight", value=0.57)
object.set_attribute(object='SET_WALTER_PPK', attribute="stacking", value=1)
object.set_attribute(object='SET_WALTER_PPK', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_WALTER_PPK', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_WALTER_PPK', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_WALTER_PPK', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_WALTER_PPK', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_WALTER_PPK', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_WALTER_PPK', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_WALTER_PPK', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_WALTER_PPK', attribute="munitionsarten", value=['SET_AMMOPACK_7_65_MM','SET_AMMOPACK_7_65_MM_DUMDUM','SET_AMMOPACK_7_65_MM_SUBSONIC','SET_AMMOPACK_7_65_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_WALTER_PPK', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_WALTER_PPK', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_WALTER_PPK', attribute="magazingroesse",             value=7.0)
object.set_attribute(object='SET_WALTER_PPK', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_WALTER_PPK', attribute="schusspausenzeit",             value=0.8)
object.set_attribute(object='SET_WALTER_PPK', attribute="genauigkeit_bewegte_ziele",      value=0.5)
object.set_attribute(object='SET_WALTER_PPK', attribute="blockadewahrscheinlichkeit",   value=25.0)
object.set_attribute(object='SET_WALTER_PPK', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_WALTER_PPK', attribute="effects", value={
    "sound_shot"   : "shot_walther_ppk",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_WALTER_PPK_W_SILENCER')
clone_weapon_type(typeid='SET_WALTER_PPK', new_typeid='SET_WALTER_PPK_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="name", value=globaltext.SET_WALTER_PPK_W_SILENCER_NAME)
object.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="hint", value=globaltext.SET_WALTER_PPK_W_SILENCER_HINT)
object.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="resource3d", value='RES3D_WALTER_PPK_W_SILENCER')
object.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="value", value=8.00)
object.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_walther_ppk_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.1,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_WALTER_PPK','SET_SILENCER']]})

create_weapon_type(typeid='SET_SPECIAL_38')
object.set_attribute(object='SET_SPECIAL_38', attribute="name", value=globaltext.SET_SPECIAL_38_NAME)
object.set_attribute(object='SET_SPECIAL_38', attribute="hint", value=globaltext.SET_SPECIAL_38_HINT)
object.set_attribute(object='SET_SPECIAL_38', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SPECIAL_38')
object.set_attribute(object='SET_SPECIAL_38', attribute="resource3d", value='RES3D_SPECIAL_38')
object.set_attribute(object='SET_SPECIAL_38', attribute="value", value=2.00)
object.set_attribute(object='SET_SPECIAL_38', attribute="weight", value=0.270)
object.set_attribute(object='SET_SPECIAL_38', attribute="stacking", value=1)
object.set_attribute(object='SET_SPECIAL_38', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SPECIAL_38', attribute="maximale_feuerreichweite", value=10)
object.set_attribute(object='SET_SPECIAL_38', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SPECIAL_38', attribute="feuergeschwindigkeit", value=50.0)
object.set_attribute(object='SET_SPECIAL_38', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_SPECIAL_38', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_SPECIAL_38', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_SPECIAL_38', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_SPECIAL_38', attribute="munitionsarten", value=['SET_AMMOPACK_38','SET_AMMOPACK_38_DUMDUM'])
object.set_attribute(object='SET_SPECIAL_38', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_SPECIAL_38', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_SPECIAL_38', attribute="magazingroesse",             value=6.0)
object.set_attribute(object='SET_SPECIAL_38', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_SPECIAL_38', attribute="schusspausenzeit",             value=1.0)
object.set_attribute(object='SET_SPECIAL_38', attribute="genauigkeit_bewegte_ziele",      value=0.4)
object.set_attribute(object='SET_SPECIAL_38', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_SPECIAL_38', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_SPECIAL_38', attribute="effects", value={
    "sound_shot"   : "shot_special_38",
    "sound_unload"   : "revolver_discharge",
    "sound_gunjam"   : "revolver_gunjam",
    "sound_reload"   : "revolver_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.4,
    "stream_type"   : 1,
    "stream_size"   : 0.5,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_COLT_ANACONDA')
object.set_attribute(object='SET_COLT_ANACONDA', attribute="name", value=globaltext.SET_COLT_ANACONDA_NAME)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="hint", value=globaltext.SET_COLT_ANACONDA_HINT)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="resourceui", value='RES_ITEM65X32_WEAPON_COLT_ANACONDA')
object.set_attribute(object='SET_COLT_ANACONDA', attribute="resource3d", value='RES3D_COLT_ANACONDA')
object.set_attribute(object='SET_COLT_ANACONDA', attribute="value", value=8.00)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="weight", value=1.325)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="stacking", value=1)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="maximale_feuerreichweite", value=17)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="munitionsarten", value=['SET_AMMOPACK_44','SET_AMMOPACK_44_DUMDUM','SET_AMMOPACK_44_CORBON','SET_AMMOPACK_44_CORBON_DUMDUM'])
object.set_attribute(object='SET_COLT_ANACONDA', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_COLT_ANACONDA', attribute="magazingroesse",          value=6.0)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="schusspausenzeit",          value=1.2)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_COLT_ANACONDA', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_COLT_ANACONDA', attribute="effects", value={
    "sound_shot"   : "shot_colt_anaconda",
    "sound_unload"   : "revolver_discharge",
    "sound_gunjam"   : "revolver_gunjam",
    "sound_reload"   : "revolver_charge",
    "flash_type"   : 5,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_SIG_SAUER')
object.set_attribute(object='SET_SIG_SAUER', attribute="name", value=globaltext.SET_SIG_SAUER_NAME)
object.set_attribute(object='SET_SIG_SAUER', attribute="hint", value=globaltext.SET_SIG_SAUER_HINT)
object.set_attribute(object='SET_SIG_SAUER', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SAUER')
object.set_attribute(object='SET_SIG_SAUER', attribute="resource3d", value='RES3D_SIG_SAUER')
object.set_attribute(object='SET_SIG_SAUER', attribute="value", value=3.00)
object.set_attribute(object='SET_SIG_SAUER', attribute="weight", value=0.625)
object.set_attribute(object='SET_SIG_SAUER', attribute="stacking", value=1)
object.set_attribute(object='SET_SIG_SAUER', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SIG_SAUER', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_SIG_SAUER', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SIG_SAUER', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_SIG_SAUER', attribute="genauigkeit", value=1.2)
object.set_attribute(object='SET_SIG_SAUER', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_SIG_SAUER', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_SIG_SAUER', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_SIG_SAUER', attribute="munitionsarten", value=['SET_AMMOPACK_357','SET_AMMOPACK_357_DUMDUM','SET_AMMOPACK_357_SUBSONIC','SET_AMMOPACK_357_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_SIG_SAUER', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_SIG_SAUER', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_SIG_SAUER', attribute="magazingroesse",          value=13.0)
object.set_attribute(object='SET_SIG_SAUER', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_SIG_SAUER', attribute="schusspausenzeit",          value=0.6)
object.set_attribute(object='SET_SIG_SAUER', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_SIG_SAUER', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_SIG_SAUER', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_SIG_SAUER', attribute="effects", value={
    "sound_shot"   : "shot_sig_sauer",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_SIG_SAUER_W_SILENCER')
clone_weapon_type(typeid='SET_SIG_SAUER', new_typeid='SET_SIG_SAUER_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="name", value=globaltext.SET_SIG_SAUER_W_SILENCER_NAME)
object.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="hint", value=globaltext.SET_SIG_SAUER_W_SILENCER_HINT)
object.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="resource3d", value='RES3D_SIG_SAUER_W_SILENCER')
object.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="value", value=8.00)
object.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_sig_sauer_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_SIG_SAUER','SET_SILENCER']]})

create_weapon_type(typeid='SET_BERETTA_92F')
object.set_attribute(object='SET_BERETTA_92F', attribute="name", value=globaltext.SET_BERETTA_92F_NAME)
object.set_attribute(object='SET_BERETTA_92F', attribute="hint", value=globaltext.SET_BERETTA_92F_HINT)
object.set_attribute(object='SET_BERETTA_92F', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BERETTA_92F')
object.set_attribute(object='SET_BERETTA_92F', attribute="resource3d", value='RES3D_BERETTA_92F')
object.set_attribute(object='SET_BERETTA_92F', attribute="value", value=6.00)
object.set_attribute(object='SET_BERETTA_92F', attribute="weight", value=0.95)
object.set_attribute(object='SET_BERETTA_92F', attribute="stacking", value=1)
object.set_attribute(object='SET_BERETTA_92F', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BERETTA_92F', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_BERETTA_92F', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BERETTA_92F', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_BERETTA_92F', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_BERETTA_92F', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_BERETTA_92F', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_BERETTA_92F', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_BERETTA_92F', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_BERETTA_92F', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_BERETTA_92F', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_BERETTA_92F', attribute="magazingroesse",             value=15.0)
object.set_attribute(object='SET_BERETTA_92F', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_BERETTA_92F', attribute="schusspausenzeit",          value=0.7)
object.set_attribute(object='SET_BERETTA_92F', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_BERETTA_92F', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_BERETTA_92F', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_BERETTA_92F', attribute="effects", value={
    "sound_shot"   : "shot_beretta_92f",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_BERETTA_92F_W_SILENCER')
clone_weapon_type(typeid='SET_BERETTA_92F', new_typeid='SET_BERETTA_92F_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="name", value=globaltext.SET_BERETTA_92F_NAME)
object.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="hint", value=globaltext.SET_BERETTA_92F_HINT)
object.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="resource3d", value='RES3D_BERETTA_92F_W_SILENCER')
object.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="value", value=11.00)
object.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_beretta_92f_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_BERETTA_92F','SET_SILENCER']]})

create_weapon_type(typeid='SET_DESERT_EAGLE')
object.set_attribute(object='SET_DESERT_EAGLE', attribute="name", value=globaltext.SET_DESERT_EAGLE_NAME)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="hint", value=globaltext.SET_DESERT_EAGLE_HINT)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DESERT_EAGLE')
object.set_attribute(object='SET_DESERT_EAGLE', attribute="resource3d", value='RES3D_DESERT_EAGLE')
object.set_attribute(object='SET_DESERT_EAGLE', attribute="value", value=10.00)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="weight", value=2.0)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="stacking", value=1)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="maximale_feuerreichweite", value=15)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="munitionsarten", value=['SET_AMMOPACK_50', 'SET_AMMOPACK_50_AE_DUMDUM'])
object.set_attribute(object='SET_DESERT_EAGLE', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_DESERT_EAGLE', attribute="magazingroesse",             value=7.0)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="genauigkeit_bewegte_ziele",   value=0.4)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_DESERT_EAGLE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_DESERT_EAGLE', attribute="effects", value={
    "sound_shot"   : "shot_desert_eagle",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_DESERT_EAGLE_W_LASERPOINTER')
clone_weapon_type(typeid='SET_DESERT_EAGLE', new_typeid='SET_DESERT_EAGLE_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="name", value=globaltext.SET_DESERT_EAGLE_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="hint", value=globaltext.SET_DESERT_EAGLE_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="resource3d", value='RES3D_DESERT_EAGLE_W_LASERPOINTER')
object.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="value", value=13.00)
object.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "shot_desert_eagle",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})
object.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_DESERT_EAGLE','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_COLT_45')
object.set_attribute(object='SET_COLT_45', attribute="name", value=globaltext.SET_COLT_45_NAME)
object.set_attribute(object='SET_COLT_45', attribute="hint", value=globaltext.SET_COLT_45_HINT)
object.set_attribute(object='SET_COLT_45', attribute="resourceui", value='RES_ITEM65X32_WEAPON_COLT_45')
object.set_attribute(object='SET_COLT_45', attribute="resource3d", value='RES3D_COLT_45')
object.set_attribute(object='SET_COLT_45', attribute="value", value=7.00)
object.set_attribute(object='SET_COLT_45', attribute="weight", value=1.0)
object.set_attribute(object='SET_COLT_45', attribute="stacking", value=1)
object.set_attribute(object='SET_COLT_45', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_COLT_45', attribute="maximale_feuerreichweite", value=14)
object.set_attribute(object='SET_COLT_45', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_COLT_45', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_COLT_45', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_COLT_45', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_COLT_45', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_COLT_45', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_COLT_45', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_COLT_45', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_COLT_45', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_COLT_45', attribute="magazingroesse",             value=7.0)
object.set_attribute(object='SET_COLT_45', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_COLT_45', attribute="schusspausenzeit",          value=0.5)
object.set_attribute(object='SET_COLT_45', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_COLT_45', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_COLT_45', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_COLT_45', attribute="effects", value={
    "sound_shot"   : "shot_colt_45",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_COLT_45_W_SILENCER')
clone_weapon_type(typeid='SET_COLT_45', new_typeid='SET_COLT_45_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="name", value=globaltext.SET_COLT_45_W_SILENCER_NAME)
object.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="hint", value=globaltext.SET_COLT_45_W_SILENCER_HINT)
object.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="resource3d", value='RES3D_COLT_45_W_SILENCER')
object.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="value", value=12.00)
object.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_colt_45_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_COLT_45','SET_SILENCER']]})

create_weapon_type(typeid='SET_GLOCK_21')
object.set_attribute(object='SET_GLOCK_21', attribute="name", value=globaltext.SET_GLOCK_21_NAME)
object.set_attribute(object='SET_GLOCK_21', attribute="hint", value=globaltext.SET_GLOCK_21_HINT)
object.set_attribute(object='SET_GLOCK_21', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GLOCK_21')
object.set_attribute(object='SET_GLOCK_21', attribute="resource3d", value='RES3D_GLOCK_21')
object.set_attribute(object='SET_GLOCK_21', attribute="value", value=9.0)
object.set_attribute(object='SET_GLOCK_21', attribute="weight", value=0.8)
object.set_attribute(object='SET_GLOCK_21', attribute="stacking", value=1)
object.set_attribute(object='SET_GLOCK_21', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_GLOCK_21', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_GLOCK_21', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_GLOCK_21', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_GLOCK_21', attribute="genauigkeit", value=1.1)
object.set_attribute(object='SET_GLOCK_21', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_GLOCK_21', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_GLOCK_21', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_GLOCK_21', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_GLOCK_21', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_GLOCK_21', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_GLOCK_21', attribute="magazingroesse",             value=13.0)
object.set_attribute(object='SET_GLOCK_21', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_GLOCK_21', attribute="schusspausenzeit",          value=0.6)
object.set_attribute(object='SET_GLOCK_21', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_GLOCK_21', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_GLOCK_21', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_GLOCK_21', attribute="effects", value={
    "sound_shot"   : "shot_glock_21",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_GLOCK_21_W_SILENCER')
clone_weapon_type(typeid='SET_GLOCK_21', new_typeid='SET_GLOCK_21_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="name", value=globaltext.SET_GLOCK_21_W_SILENCER_NAME)
object.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="hint", value=globaltext.SET_GLOCK_21_W_SILENCER_HINT)
object.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="resource3d", value='RES3D_GLOCK_21_W_SILENCER')
object.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="value", value=14.0)
object.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_glock_21_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_GLOCK_21','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_USP_45')
object.set_attribute(object='SET_HK_USP_45', attribute="name", value=globaltext.SET_HK_USP_45_NAME)
object.set_attribute(object='SET_HK_USP_45', attribute="hint", value=globaltext.SET_HK_USP_45_HINT)
object.set_attribute(object='SET_HK_USP_45', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_USP_45')
object.set_attribute(object='SET_HK_USP_45', attribute="resource3d", value='RES3D_HK_USP_45')
object.set_attribute(object='SET_HK_USP_45', attribute="value", value=10.0)
object.set_attribute(object='SET_HK_USP_45', attribute="weight", value=0.85)
object.set_attribute(object='SET_HK_USP_45', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_USP_45', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_USP_45', attribute="maximale_feuerreichweite", value=15)
object.set_attribute(object='SET_HK_USP_45', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_HK_USP_45', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_HK_USP_45', attribute="genauigkeit", value=1.2)
object.set_attribute(object='SET_HK_USP_45', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_USP_45', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_USP_45', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_USP_45', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_HK_USP_45', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_HK_USP_45', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_HK_USP_45', attribute="magazingroesse",          value=12.0)
object.set_attribute(object='SET_HK_USP_45', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_USP_45', attribute="schusspausenzeit",          value=0.8)
object.set_attribute(object='SET_HK_USP_45', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_HK_USP_45', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_HK_USP_45', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_HK_USP_45', attribute="effects", value={
    "sound_shot"   : "shot_hk_usp_45",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_USP_45_W_SILENCER')
clone_weapon_type(typeid='SET_HK_USP_45', new_typeid='SET_HK_USP_45_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="name", value=globaltext.SET_HK_USP_45_W_SILENCER_NAME)
object.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="hint", value=globaltext.SET_HK_USP_45_W_SILENCER_HINT)
object.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="resource3d", value='RES3D_HK_USP_45_W_SILENCER')
object.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="value", value=15.0)
object.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_hk_usp_45_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_HK_USP_45','SET_SILENCER']]})

create_weapon_type(typeid='SET_CALICO_M950')
object.set_attribute(object='SET_CALICO_M950', attribute="name", value=globaltext.SET_CALICO_M950_NAME)
object.set_attribute(object='SET_CALICO_M950', attribute="hint", value=globaltext.SET_CALICO_M950_HINT)
object.set_attribute(object='SET_CALICO_M950', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CALICO_M950')
object.set_attribute(object='SET_CALICO_M950', attribute="resource3d", value='RES3D_CALICO_M950')
object.set_attribute(object='SET_CALICO_M950', attribute="value", value=12.00)
object.set_attribute(object='SET_CALICO_M950', attribute="weight", value=1.2)
object.set_attribute(object='SET_CALICO_M950', attribute="stacking", value=1)
object.set_attribute(object='SET_CALICO_M950', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_CALICO_M950', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_CALICO_M950', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_CALICO_M950', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_CALICO_M950', attribute="genauigkeit", value=0.9)
object.set_attribute(object='SET_CALICO_M950', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_CALICO_M950', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_CALICO_M950', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_CALICO_M950', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_CALICO_M950', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_CALICO_M950', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_CALICO_M950', attribute="magazingroesse",             value=50.0)
object.set_attribute(object='SET_CALICO_M950', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_CALICO_M950', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_CALICO_M950', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_CALICO_M950', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_CALICO_M950', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_CALICO_M950', attribute="effects", value={
    "sound_shot"   : "shot_calico_m950",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_CALICO_M950_W_SILENCER')
clone_weapon_type(typeid='SET_CALICO_M950', new_typeid='SET_CALICO_M950_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="name", value=globaltext.SET_CALICO_M950_NAME)
object.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="hint", value=globaltext.SET_CALICO_M950_HINT)
object.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="resource3d", value='RES3D_CALICO_M950_W_SILENCER')
object.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="value", value=17.00)
object.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_calico_m950_silenced",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_CALICO_M950','SET_SILENCER']]})


create_weapon_type(typeid='SET_AUTOMAG_3')
object.set_attribute(object='SET_AUTOMAG_3', attribute="name", value=globaltext.SET_AUTOMAG_3_NAME)
object.set_attribute(object='SET_AUTOMAG_3', attribute="hint", value=globaltext.SET_AUTOMAG_3_HINT)
object.set_attribute(object='SET_AUTOMAG_3', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AUTOMAG_3')
object.set_attribute(object='SET_AUTOMAG_3', attribute="resource3d", value='RES3D_AUTOMAG_3')
object.set_attribute(object='SET_AUTOMAG_3', attribute="value", value=7.00)
object.set_attribute(object='SET_AUTOMAG_3', attribute="weight", value=1.0)
object.set_attribute(object='SET_AUTOMAG_3', attribute="stacking", value=1)
object.set_attribute(object='SET_AUTOMAG_3', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_AUTOMAG_3', attribute="maximale_feuerreichweite", value=22)
object.set_attribute(object='SET_AUTOMAG_3', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_AUTOMAG_3', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_AUTOMAG_3', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_AUTOMAG_3', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_AUTOMAG_3', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_AUTOMAG_3', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_AUTOMAG_3', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_AUTOMAG_3', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_AUTOMAG_3', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_AUTOMAG_3', attribute="magazingroesse",          value=5.0)
object.set_attribute(object='SET_AUTOMAG_3', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_AUTOMAG_3', attribute="schusspausenzeit",          value=1.0)
object.set_attribute(object='SET_AUTOMAG_3', attribute="genauigkeit_bewegte_ziele",   value=0.4)
object.set_attribute(object='SET_AUTOMAG_3', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_AUTOMAG_3', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_AUTOMAG_3', attribute="effects", value={
    "sound_shot"   : "shot_automag_3",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.6,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_AUTOMAG_3_W_LASERPOINTER')
clone_weapon_type(typeid='SET_AUTOMAG_3', new_typeid='SET_AUTOMAG_3_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="name", value=globaltext.SET_AUTOMAG_3_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="hint", value=globaltext.SET_AUTOMAG_3_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="resource3d", value='RES3D_AUTOMAG_3_W_LASERPOINTER')
object.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="value", value=10.00)
object.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "shot_automag_3",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.55,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})
object.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_AUTOMAG_3','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_MICRO_UZI')
object.set_attribute(object='SET_MICRO_UZI', attribute="name", value=globaltext.SET_MICRO_UZI_NAME)
object.set_attribute(object='SET_MICRO_UZI', attribute="hint", value=globaltext.SET_MICRO_UZI_HINT)
object.set_attribute(object='SET_MICRO_UZI', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MICRO_UZI')
object.set_attribute(object='SET_MICRO_UZI', attribute="resource3d", value='RES3D_MICRO_UZI')
object.set_attribute(object='SET_MICRO_UZI', attribute="value", value=9.00)
object.set_attribute(object='SET_MICRO_UZI', attribute="weight", value=1.5)
object.set_attribute(object='SET_MICRO_UZI', attribute="stacking", value=1)
object.set_attribute(object='SET_MICRO_UZI', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MICRO_UZI', attribute="maximale_feuerreichweite", value=18)
object.set_attribute(object='SET_MICRO_UZI', attribute="salvenlaenge", value=6)
object.set_attribute(object='SET_MICRO_UZI', attribute="feuergeschwindigkeit", value=1500.00)
object.set_attribute(object='SET_MICRO_UZI', attribute="genauigkeit", value=0.3)
object.set_attribute(object='SET_MICRO_UZI', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_MICRO_UZI', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_MICRO_UZI', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_MICRO_UZI', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_MICRO_UZI', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
object.set_attribute(object='SET_MICRO_UZI', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_MICRO_UZI', attribute="magazingroesse",          value=30.0)
object.set_attribute(object='SET_MICRO_UZI', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_MICRO_UZI', attribute="schusspausenzeit",          value=0.5)
object.set_attribute(object='SET_MICRO_UZI', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_MICRO_UZI', attribute="blockadewahrscheinlichkeit",   value=20.0)
object.set_attribute(object='SET_MICRO_UZI', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_MICRO_UZI', attribute="effects", value={
    "sound_shot"   : "burst_micro_uzi",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_MICRO_UZI_W_SILENCER')
clone_weapon_type(typeid='SET_MICRO_UZI', new_typeid='SET_MICRO_UZI_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="name", value=globaltext.SET_MICRO_UZI_W_SILENCER_NAME)
object.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="hint", value=globaltext.SET_MICRO_UZI_W_SILENCER_HINT)
object.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="resource3d", value='RES3D_MICRO_UZI_W_SILENCER')
object.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="value", value=9.00)
object.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_micro_uzi_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_MICRO_UZI','SET_SILENCER']]})


create_weapon_type(typeid='SET_UZI')
object.set_attribute(object='SET_UZI', attribute="name", value=globaltext.SET_UZI_NAME)
object.set_attribute(object='SET_UZI', attribute="hint", value=globaltext.SET_UZI_HINT)
object.set_attribute(object='SET_UZI', attribute="resourceui", value='RES_ITEM65X32_WEAPON_UZI')
object.set_attribute(object='SET_UZI', attribute="resource3d", value='RES3D_UZI')
object.set_attribute(object='SET_UZI', attribute="value", value=10.00)
object.set_attribute(object='SET_UZI', attribute="weight", value=3.5)
object.set_attribute(object='SET_UZI', attribute="stacking", value=1)
object.set_attribute(object='SET_UZI', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_UZI', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_UZI', attribute="salvenlaenge", value=5)
object.set_attribute(object='SET_UZI', attribute="feuergeschwindigkeit", value=600.00)
object.set_attribute(object='SET_UZI', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_UZI', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_UZI', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_UZI', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_UZI', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_UZI', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
object.set_attribute(object='SET_UZI', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_UZI', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_UZI', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_UZI', attribute="schusspausenzeit",          value=0.9)
object.set_attribute(object='SET_UZI', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_UZI', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_UZI', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_UZI', attribute="effects", value={
    "sound_shot"   : "burst_uzi",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_UZI_W_SILENCER')
clone_weapon_type(typeid='SET_UZI', new_typeid='SET_UZI_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="name", value=globaltext.SET_UZI_W_SILENCER_NAME)
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="hint", value=globaltext.SET_UZI_W_SILENCER_HINT)
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="resource3d", value='RES3D_UZI_W_SILENCER')
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="resource3d", value='RES3D_UZI_W_SILENCER')
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="value", value=15.00)
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_uzi_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_UZI_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_UZI','SET_SILENCER']]})

create_weapon_type(typeid='SET_UZI_W_LASERPOINTER')
clone_weapon_type(typeid='SET_UZI', new_typeid='SET_UZI_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="name", value=globaltext.SET_UZI_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="hint", value=globaltext.SET_UZI_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="resource3d", value='RES3D_UZI_W_LASERPOINTER')
object.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="value", value=13.00)
object.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_uzi",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_UZI','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_UZI_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_UZI', new_typeid='SET_UZI_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
object.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_UZI_W_SILENCER_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_UZI_W_SILENCER_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_UZI_W_SILENCER_W_LASERPOINTER')
object.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="value", value=18.00)
object.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_uzi_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.2,
    "fade_out"      : 50})
object.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"     :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"  :   "disassemble_weapon_silencer_laserpointer",
   "combination_list": [['SET_UZI','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
                        ['SET_UZI_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
                        ['SET_UZI_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_MP5')
object.set_attribute(object='SET_MP5', attribute="name", value=globaltext.SET_MP5_NAME)
object.set_attribute(object='SET_MP5', attribute="hint", value=globaltext.SET_MP5_HINT)
object.set_attribute(object='SET_MP5', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MP5')
object.set_attribute(object='SET_MP5', attribute="resource3d", value='RES3D_MP5')
object.set_attribute(object='SET_MP5', attribute="value", value=15.00)
object.set_attribute(object='SET_MP5', attribute="weight", value=2.5)
object.set_attribute(object='SET_MP5', attribute="stacking", value=1)
object.set_attribute(object='SET_MP5', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MP5', attribute="maximale_feuerreichweite", value=22)
object.set_attribute(object='SET_MP5', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_MP5', attribute="feuergeschwindigkeit", value=800.00)
object.set_attribute(object='SET_MP5', attribute="genauigkeit", value=0.9)
object.set_attribute(object='SET_MP5', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_MP5', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_MP5', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_MP5', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_MP5', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_MP5', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_MP5', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_MP5', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_MP5', attribute="schusspausenzeit",          value=1.0)
object.set_attribute(object='SET_MP5', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_MP5', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_MP5', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_MP5', attribute="effects", value={
    "sound_shot"   : "burst_mp5",
    "sound_unload" : "smg_discharge",
    "sound_gunjam" : "smg_gunjam",
    "sound_reload" : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"  : 1,
    "stream_size"  : 0.6,
    "fade_out"     : 50})

create_weapon_type(typeid='SET_MP5_W_SILENCER')
clone_weapon_type(typeid='SET_MP5', new_typeid='SET_MP5_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_MP5_W_SILENCER', attribute="name", value=globaltext.SET_MP5_W_SILENCER_NAME)
object.set_attribute(object='SET_MP5_W_SILENCER', attribute="hint", value=globaltext.SET_MP5_W_SILENCER_HINT)
object.set_attribute(object='SET_MP5_W_SILENCER', attribute="resource3d", value='RES3D_MP5_W_SILENCER')
object.set_attribute(object='SET_MP5_W_SILENCER', attribute="values", value=20)
object.set_attribute(object='SET_MP5_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_mp5_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_MP5_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_MP5','SET_SILENCER']]})


create_weapon_type(typeid='SET_MP5_W_LASERPOINTER')
clone_weapon_type(typeid='SET_MP5', new_typeid='SET_MP5_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="name", value=globaltext.SET_MP5_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="hint", value=globaltext.SET_MP5_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="resource3d", value='RES3D_MP5_W_LASERPOINTER')
object.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="values", value=18)
object.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_mp5",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_MP5','SET_LASERPOINTER','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_MP5_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_MP5', new_typeid='SET_MP5_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
object.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_MP5_W_SILENCER_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_MP5_W_SILENCER_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_MP5_W_SILENCER_W_LASERPOINTER')
object.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="values", value=23)
object.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_mp5_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list": [['SET_MP5','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
                        ['SET_MP5_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
                        ['SET_MP5_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_MP7')
object.set_attribute(object='SET_HK_MP7', attribute="name", value=globaltext.SET_HK_MP7_NAME)
object.set_attribute(object='SET_HK_MP7', attribute="hint", value=globaltext.SET_HK_MP7_HINT)
object.set_attribute(object='SET_HK_MP7', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_MP7')
object.set_attribute(object='SET_HK_MP7', attribute="resource3d", value='RES3D_HK_MP7')
object.set_attribute(object='SET_HK_MP7', attribute="value", value=35.00)
object.set_attribute(object='SET_HK_MP7', attribute="weight", value=1.4)
object.set_attribute(object='SET_HK_MP7', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_MP7', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_MP7', attribute="maximale_feuerreichweite", value=25)
object.set_attribute(object='SET_HK_MP7', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_HK_MP7', attribute="feuergeschwindigkeit", value=950.00)
object.set_attribute(object='SET_HK_MP7', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_HK_MP7', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_MP7', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_MP7', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_MP7', attribute="munitionsarten", value=['SET_AMMOPACK_4_6_MM','SET_AMMOPACK_4_6_MM_DUMDUM','SET_AMMOPACK_4_6_MM_SUBSONIC','SET_AMMOPACK_4_6_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_HK_MP7', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
object.set_attribute(object='SET_HK_MP7', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_HK_MP7', attribute="magazingroesse",             value=20.0)
object.set_attribute(object='SET_HK_MP7', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_MP7', attribute="schusspausenzeit",          value=1.0)
object.set_attribute(object='SET_HK_MP7', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_HK_MP7', attribute="blockadewahrscheinlichkeit",   value=0.0)
object.set_attribute(object='SET_HK_MP7', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_HK_MP7', attribute="effects", value={
    "sound_shot"   : "burst_hk_mp7",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.4,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_XM8')
object.set_attribute(object='SET_HK_XM8', attribute="name", value=globaltext.SET_HK_XM8_NAME)
object.set_attribute(object='SET_HK_XM8', attribute="hint", value=globaltext.SET_HK_XM8_HINT)
object.set_attribute(object='SET_HK_XM8', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_XM8')
object.set_attribute(object='SET_HK_XM8', attribute="resource3d", value='RES3D_HK_XM8')
object.set_attribute(object='SET_HK_XM8', attribute="value", value=35.00)
object.set_attribute(object='SET_HK_XM8', attribute="weight", value=2.5)
object.set_attribute(object='SET_HK_XM8', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_XM8', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_XM8', attribute="maximale_feuerreichweite", value=36)
object.set_attribute(object='SET_HK_XM8', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_HK_XM8', attribute="feuergeschwindigkeit", value=800.00)
object.set_attribute(object='SET_HK_XM8', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_HK_XM8', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_XM8', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_XM8', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_XM8', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_HK_XM8', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_HK_XM8', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_HK_XM8', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_HK_XM8', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_XM8', attribute="schusspausenzeit",          value=2.1)
object.set_attribute(object='SET_HK_XM8', attribute="genauigkeit_bewegte_ziele",   value=0.8)
object.set_attribute(object='SET_HK_XM8', attribute="blockadewahrscheinlichkeit",   value=3.0)
object.set_attribute(object='SET_HK_XM8', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_HK_XM8', attribute="effects", value={
    "sound_shot"   : "burst_xm8",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_G11')
object.set_attribute(object='SET_HK_G11', attribute="name", value=globaltext.SET_HK_G11_NAME)
object.set_attribute(object='SET_HK_G11', attribute="hint", value=globaltext.SET_HK_G11_HINT)
object.set_attribute(object='SET_HK_G11', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G11')
object.set_attribute(object='SET_HK_G11', attribute="resource3d", value='RES3D_HK_G11')
object.set_attribute(object='SET_HK_G11', attribute="value", value=40.00)
object.set_attribute(object='SET_HK_G11', attribute="weight", value=3.8)
object.set_attribute(object='SET_HK_G11', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_G11', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_G11', attribute="maximale_feuerreichweite", value=37)
object.set_attribute(object='SET_HK_G11', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_HK_G11', attribute="feuergeschwindigkeit", value=2000.00)
object.set_attribute(object='SET_HK_G11', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_HK_G11', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_G11', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_G11', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_G11', attribute="munitionsarten", value=['SET_AMMOPACK_4_73_CASELESS'])
object.set_attribute(object='SET_HK_G11', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_HK_G11', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_HK_G11', attribute="magazingroesse",             value=45.0)
object.set_attribute(object='SET_HK_G11', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_G11', attribute="schusspausenzeit",          value=1.0)
object.set_attribute(object='SET_HK_G11', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_HK_G11', attribute="blockadewahrscheinlichkeit",   value=2.0)
object.set_attribute(object='SET_HK_G11', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_HK_G11', attribute="effects", value={
    "sound_shot"   : "burst_hk_g11",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.4,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_GMG_OCSW')
object.set_attribute(object='SET_GMG_OCSW', attribute="name", value=globaltext.SET_GMG_OCSW_NAME)
object.set_attribute(object='SET_GMG_OCSW', attribute="hint", value=globaltext.SET_GMG_OCSW_HINT)
object.set_attribute(object='SET_GMG_OCSW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GMG_OCSW')
object.set_attribute(object='SET_GMG_OCSW', attribute="resource3d", value='RES3D_GMG_OCSW')
object.set_attribute(object='SET_GMG_OCSW', attribute="value", value=100.00)
object.set_attribute(object='SET_GMG_OCSW', attribute="weight", value=14.5)
object.set_attribute(object='SET_GMG_OCSW', attribute="stacking", value=1)
object.set_attribute(object='SET_GMG_OCSW', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_GMG_OCSW', attribute="maximale_feuerreichweite", value=50)
object.set_attribute(object='SET_GMG_OCSW', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_GMG_OCSW', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_GMG_OCSW', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_GMG_OCSW', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_GMG_OCSW', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_GMG_OCSW', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_GMG_OCSW', attribute="munitionsarten", value=['SET_AMMOPACK_25_MM_HE','SET_AMMOPACK_25_MM_AP'])
object.set_attribute(object='SET_GMG_OCSW', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_GMG_OCSW', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_GMG_OCSW', attribute="magazingroesse",             value=20.0)
object.set_attribute(object='SET_GMG_OCSW', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_GMG_OCSW', attribute="schusspausenzeit",          value=1.0)
object.set_attribute(object='SET_GMG_OCSW', attribute="genauigkeit_bewegte_ziele",   value=0.4)
object.set_attribute(object='SET_GMG_OCSW', attribute="blockadewahrscheinlichkeit",   value=3.0)
object.set_attribute(object='SET_GMG_OCSW', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_GMG_OCSW', attribute="effects", value={
    "sound_shot"   : "shot_gmg_ocsw",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 5,
    "flash_size"   : 1.125,
    "stream_type"   : 1,
    "stream_size"   : 1.125,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_MAC_10')
object.set_attribute(object='SET_MAC_10', attribute="name", value=globaltext.SET_MAC_10_NAME)
object.set_attribute(object='SET_MAC_10', attribute="hint", value=globaltext.SET_MAC_10_HINT)
object.set_attribute(object='SET_MAC_10', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MAC_10')
object.set_attribute(object='SET_MAC_10', attribute="resource3d", value='RES3D_MAC_10')
object.set_attribute(object='SET_MAC_10', attribute="value", value=12.00)
object.set_attribute(object='SET_MAC_10', attribute="weight", value=3.8)
object.set_attribute(object='SET_MAC_10', attribute="stacking", value=1)
object.set_attribute(object='SET_MAC_10', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MAC_10', attribute="maximale_feuerreichweite", value=20)
object.set_attribute(object='SET_MAC_10', attribute="salvenlaenge", value=6)
object.set_attribute(object='SET_MAC_10', attribute="feuergeschwindigkeit", value=1100.00)
object.set_attribute(object='SET_MAC_10', attribute="genauigkeit", value=0.4)
object.set_attribute(object='SET_MAC_10', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_MAC_10', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_MAC_10', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_MAC_10', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_MAC_10', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
object.set_attribute(object='SET_MAC_10', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_MAC_10', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_MAC_10', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_MAC_10', attribute="schusspausenzeit",             value=1.0)
object.set_attribute(object='SET_MAC_10', attribute="genauigkeit_bewegte_ziele",      value=0.4)
object.set_attribute(object='SET_MAC_10', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_MAC_10', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_MAC_10', attribute="effects", value={
    "sound_shot"   : "burst_mac_10",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_MAC_10_W_SILENCER')
clone_weapon_type(typeid='SET_MAC_10', new_typeid='SET_MAC_10_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="name", value=globaltext.SET_MAC_10_W_SILENCER_NAME)
object.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="hint", value=globaltext.SET_MAC_10_W_SILENCER_HINT)
object.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="resource3d", value='RES3D_MAC_10_W_SILENCER')
object.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="value", value=17.00)
object.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_mac_10_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_MAC_10','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_UMP_45')
object.set_attribute(object='SET_HK_UMP_45', attribute="name", value=globaltext.SET_HK_UMP_45_NAME)
object.set_attribute(object='SET_HK_UMP_45', attribute="hint", value=globaltext.SET_HK_UMP_45_HINT)
object.set_attribute(object='SET_HK_UMP_45', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_UMP_45')
object.set_attribute(object='SET_HK_UMP_45', attribute="resource3d", value='RES3D_HK_UMP_45')
object.set_attribute(object='SET_HK_UMP_45', attribute="value", value=14.00)
object.set_attribute(object='SET_HK_UMP_45', attribute="weight", value=2.1)
object.set_attribute(object='SET_HK_UMP_45', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_UMP_45', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_UMP_45', attribute="maximale_feuerreichweite", value=24)
object.set_attribute(object='SET_HK_UMP_45', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_HK_UMP_45', attribute="feuergeschwindigkeit", value=650.00)
object.set_attribute(object='SET_HK_UMP_45', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_HK_UMP_45', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_UMP_45', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_UMP_45', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_UMP_45', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_HK_UMP_45', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_HK_UMP_45', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_HK_UMP_45', attribute="magazingroesse",          value=25.0)
object.set_attribute(object='SET_HK_UMP_45', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_UMP_45', attribute="schusspausenzeit",          value=1.2)
object.set_attribute(object='SET_HK_UMP_45', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_HK_UMP_45', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_HK_UMP_45', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_HK_UMP_45', attribute="effects", value={
    "sound_shot"   : "burst_hk_ump_45",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_UMP_45_W_SILENCER')
clone_weapon_type(typeid='SET_HK_UMP_45', new_typeid='SET_HK_UMP_45_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="name", value=globaltext.SET_HK_UMP_45_W_SILENCER_NAME)
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="hint", value=globaltext.SET_HK_UMP_45_W_SILENCER_HINT)
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="resource3d", value='RES3D_HK_UMP_45_W_SILENCER')
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="value", value=19.00)
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_hk_ump_45_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_HK_UMP_45','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_UMP_45_W_LASERPOINTER')
clone_weapon_type(typeid='SET_HK_UMP_45', new_typeid='SET_HK_UMP_45_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="name", value=globaltext.SET_HK_UMP_45_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="hint", value=globaltext.SET_HK_UMP_45_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="resource3d", value='RES3D_HK_UMP_45_W_LASERPOINTER')
object.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="value", value=17.00)
object.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_hk_ump_45",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_HK_UMP_45','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_HK_UMP_45', new_typeid='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_HK_UMP_45_W_SILENCER_W_LASERPOINTER')
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="value", value=22.00)
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_hk_ump_45_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list": [['SET_HK_UMP_45','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
                        ['SET_HK_UMP_45_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
                        ['SET_HK_UMP_45_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_STEYR_TMP')
object.set_attribute(object='SET_STEYR_TMP', attribute="name", value=globaltext.SET_STEYR_TMP_NAME)
object.set_attribute(object='SET_STEYR_TMP', attribute="hint", value=globaltext.SET_STEYR_TMP_HINT)
object.set_attribute(object='SET_STEYR_TMP', attribute="resourceui", value='RES_ITEM65X32_WEAPON_STEYR_TMP')
object.set_attribute(object='SET_STEYR_TMP', attribute="resource3d", value='RES3D_STEYR_TMP')
object.set_attribute(object='SET_STEYR_TMP', attribute="value", value=10.00)
object.set_attribute(object='SET_STEYR_TMP', attribute="weight", value=1.3)
object.set_attribute(object='SET_STEYR_TMP', attribute="stacking", value=1)
object.set_attribute(object='SET_STEYR_TMP', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_STEYR_TMP', attribute="maximale_feuerreichweite", value=22)
object.set_attribute(object='SET_STEYR_TMP', attribute="salvenlaenge", value=4)
object.set_attribute(object='SET_STEYR_TMP', attribute="feuergeschwindigkeit", value=850.00)
object.set_attribute(object='SET_STEYR_TMP', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_STEYR_TMP', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_STEYR_TMP', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_STEYR_TMP', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_STEYR_TMP', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_STEYR_TMP', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
object.set_attribute(object='SET_STEYR_TMP', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_STEYR_TMP', attribute="magazingroesse",          value=30.0)
object.set_attribute(object='SET_STEYR_TMP', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_STEYR_TMP', attribute="schusspausenzeit",          value=0.6)
object.set_attribute(object='SET_STEYR_TMP', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_STEYR_TMP', attribute="blockadewahrscheinlichkeit",   value=8.0)
object.set_attribute(object='SET_STEYR_TMP', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_STEYR_TMP', attribute="effects", value={
    "sound_shot"   : "burst_steyr_tmp",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_STEYR_TMP_W_SILENCER')
clone_weapon_type(typeid='SET_STEYR_TMP', new_typeid='SET_STEYR_TMP_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="name", value=globaltext.SET_STEYR_TMP_W_SILENCER_NAME)
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="hint", value=globaltext.SET_STEYR_TMP_W_SILENCER_HINT)
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="resource3d", value='RES3D_STEYR_TMP_W_SILENCER')
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="value", value=15.00)
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_steyr_tmp_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_STEYR_TMP','SET_SILENCER']]})

create_weapon_type(typeid='SET_STEYR_TMP_W_LASERPOINTER')
clone_weapon_type(typeid='SET_STEYR_TMP', new_typeid='SET_STEYR_TMP_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="name", value=globaltext.SET_STEYR_TMP_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="hint", value=globaltext.SET_STEYR_TMP_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="resource3d", value='RES3D_STEYR_TMP_W_LASERPOINTER')
object.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="value", value=13.00)
object.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_steyr_tmp",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_STEYR_TMP','SET_LASERPOINTER','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_STEYR_TMP', new_typeid='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_STEYR_TMP_W_SILENCER_W_LASERPOINTER')
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="value", value=18.00)
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_steyr_tmp_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list": [['SET_STEYR_TMP','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
                        ['SET_STEYR_TMP_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
                        ['SET_STEYR_TMP_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_AKSU74')
object.set_attribute(object='SET_AKSU74', attribute="name", value=globaltext.SET_AKSU74_NAME)
object.set_attribute(object='SET_AKSU74', attribute="hint", value=globaltext.SET_AKSU74_HINT)
object.set_attribute(object='SET_AKSU74', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AKSU74')
object.set_attribute(object='SET_AKSU74', attribute="resource3d", value='RES3D_AKSU74')
object.set_attribute(object='SET_AKSU74', attribute="value", value=25.00)
object.set_attribute(object='SET_AKSU74', attribute="weight", value=2.7)
object.set_attribute(object='SET_AKSU74', attribute="stacking", value=1)
object.set_attribute(object='SET_AKSU74', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_AKSU74', attribute="maximale_feuerreichweite", value=26)
object.set_attribute(object='SET_AKSU74', attribute="salvenlaenge", value=4)
object.set_attribute(object='SET_AKSU74', attribute="feuergeschwindigkeit", value=700.00)
object.set_attribute(object='SET_AKSU74', attribute="genauigkeit", value=0.5)
object.set_attribute(object='SET_AKSU74', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_AKSU74', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_AKSU74', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_AKSU74', attribute="munitionsarten", value=['SET_AMMOPACK_5_45_MM'])
object.set_attribute(object='SET_AKSU74', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_AKSU74', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_AKSU74', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_AKSU74', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_AKSU74', attribute="schusspausenzeit",             value=1.2)
object.set_attribute(object='SET_AKSU74', attribute="genauigkeit_bewegte_ziele",      value=0.4)
object.set_attribute(object='SET_AKSU74', attribute="blockadewahrscheinlichkeit",   value=7.0)
object.set_attribute(object='SET_AKSU74', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_AKSU74', attribute="effects", value={
    "sound_shot"   : "burst_aksu74",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_AKSU74_W_LASERPOINTER')
clone_weapon_type(typeid='SET_AKSU74', new_typeid='SET_AKSU74_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="name", value=globaltext.SET_AKSU74_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="hint", value=globaltext.SET_AKSU74_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="resource3d", value='RES3D_AKSU74_W_LASERPOINTER')
object.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="value", value=28.00)
object.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_aksu74",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_P90_SMG')
object.set_attribute(object='SET_P90_SMG', attribute="name", value=globaltext.SET_P90_SMG_NAME)
object.set_attribute(object='SET_P90_SMG', attribute="hint", value=globaltext.SET_P90_SMG_HINT)
object.set_attribute(object='SET_P90_SMG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_P90_SMG')
object.set_attribute(object='SET_P90_SMG', attribute="resource3d", value='RES3D_P90_SMG')
object.set_attribute(object='SET_P90_SMG', attribute="value", value=12.00)
object.set_attribute(object='SET_P90_SMG', attribute="weight", value=2.0)
object.set_attribute(object='SET_P90_SMG', attribute="stacking", value=1)
object.set_attribute(object='SET_P90_SMG', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_P90_SMG', attribute="maximale_feuerreichweite", value=27)
object.set_attribute(object='SET_P90_SMG', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_P90_SMG', attribute="feuergeschwindigkeit", value=900.00)
object.set_attribute(object='SET_P90_SMG', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_P90_SMG', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_P90_SMG', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_P90_SMG', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_P90_SMG', attribute="munitionsarten", value=['SET_AMMOPACK_5_7_MM','SET_AMMOPACK_5_7_MM_DUMDUM','SET_AMMOPACK_5_7_MM_SUBSONIC','SET_AMMOPACK_5_7_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_P90_SMG', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
object.set_attribute(object='SET_P90_SMG', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_P90_SMG', attribute="magazingroesse",             value=50.0)
object.set_attribute(object='SET_P90_SMG', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_P90_SMG', attribute="schusspausenzeit",          value=0.7)
object.set_attribute(object='SET_P90_SMG', attribute="genauigkeit_bewegte_ziele",   value=0.9)
object.set_attribute(object='SET_P90_SMG', attribute="blockadewahrscheinlichkeit",   value=20.0)
object.set_attribute(object='SET_P90_SMG', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_P90_SMG', attribute="effects", value={
    "sound_shot"   : "burst_p90_smg",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_P90_SMG_W_SILENCER')
clone_weapon_type(typeid='SET_P90_SMG', new_typeid='SET_P90_SMG_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="name", value=globaltext.SET_P90_SMG_W_SILENCER_NAME)
object.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="hint", value=globaltext.SET_P90_SMG_W_SILENCER_HINT)
object.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="resource3d", value='RES3D_P90_SMG_W_SILENCER')
object.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="value", value=17.00)
object.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "burst_p90_smg_silenced",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_P90_SMG','SET_SILENCER']]})

create_weapon_type(typeid='SET_P90_SMG_W_LASERPOINTER')
clone_weapon_type(typeid='SET_P90_SMG', new_typeid='SET_P90_SMG_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
object.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="name", value=globaltext.SET_P90_SMG_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="hint", value=globaltext.SET_P90_SMG_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="resource3d", value='RES3D_P90_SMG_W_LASERPOINTER')
object.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="value", value=15.00)
object.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_p90_smg",
    "sound_unload"   : "smg_discharge",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 0,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_P90_SMG','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_P90_SMG_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_P90_SMG', new_typeid='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
object.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_P90_SMG_W_SILENCER_W_LASERPOINTER_NAME)
object.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_P90_SMG_W_SILENCER_W_LASERPOINTER_HINT)
object.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_P90_SMG_W_SILENCER_W_LASERPOINTER')
object.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="value", value=20.00)
object.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
    "sound_shot"   : "burst_p90_smg_silenced",
    "sound_unload"   : "smg_discharg",
    "sound_gunjam"   : "smg_gunjam",
    "sound_reload"   : "smg_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_P90_SMG','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
                        ['SET_P90_SMG_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
                        ['SET_P90_SMG_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=13.00)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.2)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="stacking", value=1)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="maximale_feuerreichweite", value=17)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="genauigkeit", value=1.1)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="magazingroesse",             value=2.0)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="schusspausenzeit",          value=2.0)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "shot_browning_double_barrel",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 4,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_BROWNING_B_SS_DOUBLE_BARREL', new_typeid='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=12.00)
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.0)
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "shot_browning_double_barrel",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 4,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})
object.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   55,
   "assemble_function"      :   "assemble_weapon_sawed_off",
   "combination_list"      : [ ['SET_BROWNING_B_SS_DOUBLE_BARREL','SET_HACKSAW']]})

create_weapon_type(typeid='SET_REMINGTON_M870')
object.set_attribute(object='SET_REMINGTON_M870', attribute="name", value=globaltext.SET_REMINGTON_M870_NAME)
object.set_attribute(object='SET_REMINGTON_M870', attribute="hint", value=globaltext.SET_REMINGTON_M870_HINT)
object.set_attribute(object='SET_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_REMINGTON_M870')
object.set_attribute(object='SET_REMINGTON_M870', attribute="resource3d", value='RES3D_REMINGTON_M870')
object.set_attribute(object='SET_REMINGTON_M870', attribute="value", value=15.00)
object.set_attribute(object='SET_REMINGTON_M870', attribute="weight", value=4.1)
object.set_attribute(object='SET_REMINGTON_M870', attribute="stacking", value=1)
object.set_attribute(object='SET_REMINGTON_M870', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_REMINGTON_M870', attribute="maximale_feuerreichweite", value=20)
object.set_attribute(object='SET_REMINGTON_M870', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_REMINGTON_M870', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_REMINGTON_M870', attribute="genauigkeit", value=1.3)
object.set_attribute(object='SET_REMINGTON_M870', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_REMINGTON_M870', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_REMINGTON_M870', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_REMINGTON_M870', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
object.set_attribute(object='SET_REMINGTON_M870', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_REMINGTON_M870', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_REMINGTON_M870', attribute="magazingroesse",             value=7.0)
object.set_attribute(object='SET_REMINGTON_M870', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_REMINGTON_M870', attribute="schusspausenzeit",             value=1.8)
object.set_attribute(object='SET_REMINGTON_M870', attribute="genauigkeit_bewegte_ziele",      value=0.7)
object.set_attribute(object='SET_REMINGTON_M870', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_REMINGTON_M870', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "shot_remington_m870",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 3,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_REMINGTON_M870', new_typeid='SET_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="value", value=14.00)
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.8)
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "shot_remington_m870",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 3,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})
object.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   55,
   "assemble_function"      :   "assemble_weapon_sawed_off",
   "combination_list"      : [ ['SET_REMINGTON_M870','SET_HACKSAW']]})

create_weapon_type(typeid='SET_SPAS_15')
object.set_attribute(object='SET_SPAS_15', attribute="name", value=globaltext.SET_SPAS_15_NAME)
object.set_attribute(object='SET_SPAS_15', attribute="hint", value=globaltext.SET_SPAS_15_HINT)
object.set_attribute(object='SET_SPAS_15', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SPAS_15')
object.set_attribute(object='SET_SPAS_15', attribute="resource3d", value='RES3D_SPAS_15')
object.set_attribute(object='SET_SPAS_15', attribute="value", value=25.00)
object.set_attribute(object='SET_SPAS_15', attribute="weight", value=4.3)
object.set_attribute(object='SET_SPAS_15', attribute="stacking", value=1)
object.set_attribute(object='SET_SPAS_15', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SPAS_15', attribute="maximale_feuerreichweite", value=21)
object.set_attribute(object='SET_SPAS_15', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SPAS_15', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_SPAS_15', attribute="genauigkeit", value=1.1)
object.set_attribute(object='SET_SPAS_15', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_SPAS_15', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_SPAS_15', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_SPAS_15', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
object.set_attribute(object='SET_SPAS_15', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_SPAS_15', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_SPAS_15', attribute="magazingroesse",             value=6.0)
object.set_attribute(object='SET_SPAS_15', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_SPAS_15', attribute="schusspausenzeit",          value=1.7)
object.set_attribute(object='SET_SPAS_15', attribute="genauigkeit_bewegte_ziele",   value=0.8)
object.set_attribute(object='SET_SPAS_15', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_SPAS_15', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_SPAS_15', attribute="effects", value={
    "sound_shot"   : "shot_spas_15",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 3,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_CAWS')
object.set_attribute(object='SET_HK_CAWS', attribute="name", value=globaltext.SET_HK_CAWS_NAME)
object.set_attribute(object='SET_HK_CAWS', attribute="hint", value=globaltext.SET_HK_CAWS_HINT)
object.set_attribute(object='SET_HK_CAWS', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_CAWS')
object.set_attribute(object='SET_HK_CAWS', attribute="resource3d", value='RES3D_HK_CAWS')
object.set_attribute(object='SET_HK_CAWS', attribute="value", value=35.00)
object.set_attribute(object='SET_HK_CAWS', attribute="weight", value=4.0)
object.set_attribute(object='SET_HK_CAWS', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_CAWS', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_CAWS', attribute="maximale_feuerreichweite", value=24)
object.set_attribute(object='SET_HK_CAWS', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_HK_CAWS', attribute="feuergeschwindigkeit", value=600.00)
object.set_attribute(object='SET_HK_CAWS', attribute="genauigkeit", value=1.2)
object.set_attribute(object='SET_HK_CAWS', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_CAWS', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_CAWS', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_CAWS', attribute="munitionsarten", value=['SET_AMMOPACK_3_12_MM','SET_AMMOPACK_3_12_MM_QB_8'])
object.set_attribute(object='SET_HK_CAWS', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_HK_CAWS', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_HK_CAWS', attribute="magazingroesse",             value=10.0)
object.set_attribute(object='SET_HK_CAWS', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_CAWS', attribute="schusspausenzeit",          value=1.7)
object.set_attribute(object='SET_HK_CAWS', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_HK_CAWS', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_HK_CAWS', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_HK_CAWS', attribute="effects", value={
    "sound_shot"   : "burst_hk_caws",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 3,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_LASER_GUN')
object.set_attribute(object='SET_LASER_GUN', attribute="name", value=globaltext.SET_LASER_GUN_NAME)
object.set_attribute(object='SET_LASER_GUN', attribute="hint", value=globaltext.SET_LASER_GUN_HINT)
object.set_attribute(object='SET_LASER_GUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_LASER_GUN')
object.set_attribute(object='SET_LASER_GUN', attribute="resource3d", value='RES3D_LASER_GUN')
object.set_attribute(object='SET_LASER_GUN', attribute="value", value=50.0)
object.set_attribute(object='SET_LASER_GUN', attribute="weight", value=10.0) ## !! >>
object.set_attribute(object='SET_LASER_GUN', attribute="stacking", value=1)
object.set_attribute(object='SET_LASER_GUN', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_LASER_GUN', attribute="maximale_feuerreichweite", value=35)
object.set_attribute(object='SET_LASER_GUN', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_LASER_GUN', attribute="feuergeschwindigkeit", value=180.00)
object.set_attribute(object='SET_LASER_GUN', attribute="genauigkeit", value=2.00)
object.set_attribute(object='SET_LASER_GUN', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_LASER_GUN', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_LASER_GUN', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_LASER_GUN', attribute="munitionsarten", value=['SET_AMMOPACK_LASER_GUN'])
object.set_attribute(object='SET_LASER_GUN', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_LASER_GUN', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_LASER_GUN', attribute="magazingroesse",          value=20.0)
object.set_attribute(object='SET_LASER_GUN', attribute="hoerweite",                value=25.0)
object.set_attribute(object='SET_LASER_GUN', attribute="schusspausenzeit",          value=1.0)
object.set_attribute(object='SET_LASER_GUN', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_LASER_GUN', attribute="blockadewahrscheinlichkeit",   value=0.0)
object.set_attribute(object='SET_LASER_GUN', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_LASER_GUN', attribute="effects", value={
    "sound_shot"   : "burst_lasergun",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 7,
    "flash_size"   : 0.3,
    "stream_type"   : 2,
    "stream_size"   : 0.2,
    "fade_out"      : 50})

#todo: waffeneffekte
create_weapon_type(typeid='SET_PAINTBALL_GUN')
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="name", value=globaltext.SET_PAINTBALL_GUN_NAME)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="hint", value=globaltext.SET_PAINTBALL_GUN_HINT)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_PAINTBALL_GUN')
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="resource3d", value='RES3D_PAINTBALL_GUN')
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="value", value=3.00)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="weight", value=0.95)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="stacking", value=1)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="munitionsarten", value=['SET_PAINTBALL_GUN_AMMOPACK'])
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="magazingroesse",             value=15.0)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="schusspausenzeit",          value=0.7)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_PAINTBALL_GUN', attribute="occupied_slots", value=["right_hand"])

#todo: waffeneffekte
create_weapon_type(typeid='SET_POTATO_GUN')
object.set_attribute(object='SET_POTATO_GUN', attribute="name", value=globaltext.SET_POTATO_GUN_NAME)
object.set_attribute(object='SET_POTATO_GUN', attribute="hint", value=globaltext.SET_POTATO_GUN_HINT)
object.set_attribute(object='SET_POTATO_GUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_POTATO_GUN')
object.set_attribute(object='SET_POTATO_GUN', attribute="resource3d", value='RES3D_POTATO_GUN')
object.set_attribute(object='SET_POTATO_GUN', attribute="value", value=20.00)
object.set_attribute(object='SET_POTATO_GUN', attribute="weight", value=0.95)
object.set_attribute(object='SET_POTATO_GUN', attribute="stacking", value=1)
object.set_attribute(object='SET_POTATO_GUN', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_POTATO_GUN', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_POTATO_GUN', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_POTATO_GUN', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_POTATO_GUN', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_POTATO_GUN', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_POTATO_GUN', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_POTATO_GUN', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_POTATO_GUN', attribute="munitionsarten", value=['SET_POTATO'])
object.set_attribute(object='SET_POTATO_GUN', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_POTATO_GUN', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_POTATO_GUN', attribute="magazingroesse",             value=15.0)
object.set_attribute(object='SET_POTATO_GUN', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_POTATO_GUN', attribute="schusspausenzeit",          value=0.7)
object.set_attribute(object='SET_POTATO_GUN', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_POTATO_GUN', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_POTATO_GUN', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_POTATO_GUN', attribute="item_combination",   value={
   "difficulty_assemble"   :   65,
   "combination_list" : [[ 'SET_CAR_EXHAUST_PIPE','SET_WATERTIGHT_RING','SET_HAIR_SPRAY','SET_LIGHTER']]})
object.set_attribute(object='SET_POTATO_GUN', attribute="effects", value={
    "sound_shot"   : "shot_special_38",
    "sound_unload"   : "revolver_discharge",
    "sound_gunjam"   : "revolver_gunjam",
    "sound_reload"   : "revolver_charge",
    "flash_type"   : 5,
    "flash_size"   : 0.2,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})

## schwere waffen
create_weapon_type(typeid='SET_SIMONOV_SKS')
object.set_attribute(object='SET_SIMONOV_SKS', attribute="name", value=globaltext.SET_SIMONOV_SKS_NAME)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="hint", value=globaltext.SET_SIMONOV_SKS_HINT)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIMONOV_SKS')
object.set_attribute(object='SET_SIMONOV_SKS', attribute="resource3d", value='RES3D_SIMONOV_SKS')
object.set_attribute(object='SET_SIMONOV_SKS', attribute="value", value=30.00)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="weight", value=4.0)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="stacking", value=1)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="maximale_feuerreichweite", value=32)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="munitionsarten", value=['SET_AMMOPACK_7_62SOVJET_MM'])
object.set_attribute(object='SET_SIMONOV_SKS', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_SIMONOV_SKS', attribute="magazingroesse",             value=10.0)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="schusspausenzeit",          value=2.4)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_SIMONOV_SKS', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_SIMONOV_SKS', attribute="effects", value={
    "sound_shot"   : "shot_simonov_sks",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_AK_47')
object.set_attribute(object='SET_AK_47', attribute="name", value=globaltext.SET_AK_47_NAME)
object.set_attribute(object='SET_AK_47', attribute="hint", value=globaltext.SET_AK_47_HINT)
object.set_attribute(object='SET_AK_47', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_47')
object.set_attribute(object='SET_AK_47', attribute="resource3d", value='RES3D_AK_47')
object.set_attribute(object='SET_AK_47', attribute="value", value=25.00)
object.set_attribute(object='SET_AK_47', attribute="weight", value=3.9)
object.set_attribute(object='SET_AK_47', attribute="stacking", value=1)
object.set_attribute(object='SET_AK_47', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_AK_47', attribute="maximale_feuerreichweite", value=32)
object.set_attribute(object='SET_AK_47', attribute="salvenlaenge", value=4)
object.set_attribute(object='SET_AK_47', attribute="feuergeschwindigkeit", value=600.00)
object.set_attribute(object='SET_AK_47', attribute="genauigkeit", value=0.5)
object.set_attribute(object='SET_AK_47', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_AK_47', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_AK_47', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_AK_47', attribute="munitionsarten", value=['SET_AMMOPACK_7_62SOVJET_MM'])
object.set_attribute(object='SET_AK_47', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_AK_47', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_AK_47', attribute="magazingroesse",          value=30.0)
object.set_attribute(object='SET_AK_47', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_AK_47', attribute="schusspausenzeit",          value=1.8)
object.set_attribute(object='SET_AK_47', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_AK_47', attribute="blockadewahrscheinlichkeit",   value=7.0)
object.set_attribute(object='SET_AK_47', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_AK_47', attribute="effects", value={
    "sound_shot"   : "burst_ak_47",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_AK_47', new_typeid='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=37.00)
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.9)
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "burst_ak_47",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_AK_47','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_AK_47_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_AK_47', new_typeid='SET_AK_47_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_AK_47_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_AK_47_SAWED_OFF_REMINGTON_M870_HINT)
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_47_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_AK_47_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="value", value=39.00)
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.9)
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "burst_ak_47",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_AK_47','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_AK_74')
object.set_attribute(object='SET_AK_74', attribute="name", value=globaltext.SET_AK_74_NAME)
object.set_attribute(object='SET_AK_74', attribute="hint", value=globaltext.SET_AK_74_HINT)
object.set_attribute(object='SET_AK_74', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74')
object.set_attribute(object='SET_AK_74', attribute="resource3d", value='RES3D_AK_74')
object.set_attribute(object='SET_AK_74', attribute="value", value=25.00)
object.set_attribute(object='SET_AK_74', attribute="weight", value=4.3)
object.set_attribute(object='SET_AK_74', attribute="stacking", value=1)
object.set_attribute(object='SET_AK_74', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_AK_74', attribute="maximale_feuerreichweite", value=36)
object.set_attribute(object='SET_AK_74', attribute="salvenlaenge", value=4)
object.set_attribute(object='SET_AK_74', attribute="feuergeschwindigkeit", value=620.00)
object.set_attribute(object='SET_AK_74', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_AK_74', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_AK_74', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_AK_74', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_AK_74', attribute="munitionsarten", value=['SET_AMMOPACK_5_45_MM'])
object.set_attribute(object='SET_AK_74', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_AK_74', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_AK_74', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_AK_74', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_AK_74', attribute="schusspausenzeit",          value=2.0)
object.set_attribute(object='SET_AK_74', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_AK_74', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_AK_74', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_AK_74', attribute="effects", value={
    "sound_shot"   : "burst_ak_74",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_AK_74_BG_15')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_BG_15')
object.set_attribute(object='SET_AK_74_BG_15', attribute="name", value=globaltext.SET_AK_74_BG_15_NAME)
object.set_attribute(object='SET_AK_74_BG_15', attribute="hint", value=globaltext.SET_AK_74_BG_15_HINT)
object.set_attribute(object='SET_AK_74_BG_15', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_BG_15')
object.set_attribute(object='SET_AK_74_BG_15', attribute="resource3d", value='RES3D_AK_74_BG_15')
object.set_attribute(object='SET_AK_74_BG_15', attribute="value", value=30.00)
object.set_attribute(object='SET_AK_74_BG_15', attribute="weight", value=5.1)
object.set_attribute(object='SET_AK_74_BG_15', attribute="effects", value={
    "sound_shot"   : "burst_ak_74",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=37.00)
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=5.1)
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "burst_ak_74",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_AK_74','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_AK_74_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_AK_74_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_AK_74_SAWED_OFF_REMINGTON_M870_HINT)
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_AK_74_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="value", value=39.00)
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="weight", value=5.1)
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "burst_ak_74",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_AK_74','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_M_16')
object.set_attribute(object='SET_M_16', attribute="item_type", value="weapon")
object.set_attribute(object='SET_M_16', attribute="name", value=globaltext.SET_M_16_NAME)
object.set_attribute(object='SET_M_16', attribute="hint", value=globaltext.SET_M_16_HINT)
object.set_attribute(object='SET_M_16', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16')
object.set_attribute(object='SET_M_16', attribute="resource3d", value='RES3D_M_16')
object.set_attribute(object='SET_M_16', attribute="value", value=25.00)
object.set_attribute(object='SET_M_16', attribute="weight", value=3.0)
object.set_attribute(object='SET_M_16', attribute="stacking", value=1)
object.set_attribute(object='SET_M_16', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_M_16', attribute="maximale_feuerreichweite", value=36)
object.set_attribute(object='SET_M_16', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_M_16', attribute="feuergeschwindigkeit", value=800.0)
object.set_attribute(object='SET_M_16', attribute="genauigkeit", value=0.9)
object.set_attribute(object='SET_M_16', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_M_16', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_M_16', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_M_16', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_M_16', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_M_16', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_M_16', attribute="magazingroesse",       value=30.0)
object.set_attribute(object='SET_M_16', attribute="hoerweite",          value=40.0)
object.set_attribute(object='SET_M_16', attribute="schusspausenzeit",       value=2.1)
object.set_attribute(object='SET_M_16', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_M_16', attribute="blockadewahrscheinlichkeit",   value=18.0)
object.set_attribute(object='SET_M_16', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_M_16', attribute="effects", value={
    "sound_shot"   : "burst_m4a1",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M_16_M203')
clone_weapon_type(typeid='SET_M_16', new_typeid='SET_M_16_M203')
object.set_attribute(object='SET_M_16_M203', attribute="name", value=globaltext.SET_M_16_M203_NAME)
object.set_attribute(object='SET_M_16_M203', attribute="hint", value=globaltext.SET_M_16_M203_HINT)
object.set_attribute(object='SET_M_16_M203', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16_M203')
object.set_attribute(object='SET_M_16_M203', attribute="resource3d", value='RES3D_M_16_M203')
object.set_attribute(object='SET_M_16_M203', attribute="value", value=30.00)
object.set_attribute(object='SET_M_16_M203', attribute="weight", value=3.6)
object.set_attribute(object='SET_M_16_M203', attribute="effects", value={
    "sound_shot"   : "burst_m4a1",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_M_16', new_typeid='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=37.00)
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.6)
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "shot_m203",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_M_16','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_M_16_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_M_16', new_typeid='SET_M_16_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_M_16_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_M_16_SAWED_OFF_REMINGTON_M870_HINT)
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_M_16_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="value", value=39.00)
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.6)
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "shot_m203",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_M_16','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_CALICO_M900')
object.set_attribute(object='SET_CALICO_M900', attribute="name", value=globaltext.SET_CALICO_M900_NAME)
object.set_attribute(object='SET_CALICO_M900', attribute="hint", value=globaltext.SET_CALICO_M900_HINT)
object.set_attribute(object='SET_CALICO_M900', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CALICO_M900')
object.set_attribute(object='SET_CALICO_M900', attribute="resource3d", value='RES3D_CALICO_M900')
object.set_attribute(object='SET_CALICO_M900', attribute="value", value=25.00)
object.set_attribute(object='SET_CALICO_M900', attribute="weight", value=4.5)
object.set_attribute(object='SET_CALICO_M900', attribute="stacking", value=1)
object.set_attribute(object='SET_CALICO_M900', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_CALICO_M900', attribute="maximale_feuerreichweite", value=33)
object.set_attribute(object='SET_CALICO_M900', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_CALICO_M900', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_CALICO_M900', attribute="genauigkeit", value=0.4)
object.set_attribute(object='SET_CALICO_M900', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_CALICO_M900', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_CALICO_M900', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_CALICO_M900', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
object.set_attribute(object='SET_CALICO_M900', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_CALICO_M900', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_CALICO_M900', attribute="magazingroesse",             value=50.0)
object.set_attribute(object='SET_CALICO_M900', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_CALICO_M900', attribute="schusspausenzeit",          value=1.7)
object.set_attribute(object='SET_CALICO_M900', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_CALICO_M900', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_CALICO_M900', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_CALICO_M900', attribute="effects", value={
    "sound_shot"   : "shot_calico_m900",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.4,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_CALICO_M900_W_SILENCER')
clone_weapon_type(typeid='SET_CALICO_M900', new_typeid='SET_CALICO_M900_W_SILENCER', attachments=['SET_SILENCER'])
object.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="name", value=globaltext.SET_CALICO_M900_W_SILENCER_NAME)
object.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="hint", value=globaltext.SET_CALICO_M900_W_SILENCER_HINT)
object.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="resource3d", value='RES3D_CALICO_M900_W_SILENCER')
object.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="value", value=25.00)
object.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="effects", value={
    "sound_shot"   : "shot_calico_m900_silenced",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.3,
    "stream_type"   : 1,
    "stream_size"   : 0.4,
    "fade_out"      : 50})
object.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_weapon_silencer_laserpointer",
   "disassemble_function"   :   "disassemble_weapon_silencer_laserpointer",
   "combination_list"      : [ ['SET_CALICO_M900','SET_SILENCER']]})

create_weapon_type(typeid='SET_SA_80')
object.set_attribute(object='SET_SA_80', attribute="name", value=globaltext.SET_SA_80_NAME)
object.set_attribute(object='SET_SA_80', attribute="hint", value=globaltext.SET_SA_80_HINT)
object.set_attribute(object='SET_SA_80', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SA_80')
object.set_attribute(object='SET_SA_80', attribute="resource3d", value='RES3D_SA_80')
object.set_attribute(object='SET_SA_80', attribute="value", value=28.00)
object.set_attribute(object='SET_SA_80', attribute="weight", value=5.0)
object.set_attribute(object='SET_SA_80', attribute="stacking", value=1)
object.set_attribute(object='SET_SA_80', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SA_80', attribute="maximale_feuerreichweite", value=38)
object.set_attribute(object='SET_SA_80', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_SA_80', attribute="feuergeschwindigkeit", value=650.00)
object.set_attribute(object='SET_SA_80', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_SA_80', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_SA_80', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_SA_80', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_SA_80', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_SA_80', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_SA_80', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_SA_80', attribute="magazingroesse",          value=30.0)
object.set_attribute(object='SET_SA_80', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_SA_80', attribute="schusspausenzeit",          value=1.6)
object.set_attribute(object='SET_SA_80', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_SA_80', attribute="blockadewahrscheinlichkeit",   value=23.0)
object.set_attribute(object='SET_SA_80', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_SA_80', attribute="effects", value={
    "sound_shot"   : "burst_sa_80",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_FAMAS')
object.set_attribute(object='SET_FAMAS', attribute="name", value=globaltext.SET_FAMAS_NAME)
object.set_attribute(object='SET_FAMAS', attribute="hint", value=globaltext.SET_FAMAS_HINT)
object.set_attribute(object='SET_FAMAS', attribute="resourceui", value='RES_ITEM65X32_WEAPON_FAMAS')
object.set_attribute(object='SET_FAMAS', attribute="resource3d", value='RES3D_FAMAS')
object.set_attribute(object='SET_FAMAS', attribute="value", value=27.00)
object.set_attribute(object='SET_FAMAS', attribute="weight", value=4.0)
object.set_attribute(object='SET_FAMAS', attribute="stacking", value=1)
object.set_attribute(object='SET_FAMAS', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_FAMAS', attribute="maximale_feuerreichweite", value=34)
object.set_attribute(object='SET_FAMAS', attribute="salvenlaenge", value=5)
object.set_attribute(object='SET_FAMAS', attribute="feuergeschwindigkeit", value=1000.00)
object.set_attribute(object='SET_FAMAS', attribute="genauigkeit", value=0.5)
object.set_attribute(object='SET_FAMAS', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_FAMAS', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_FAMAS', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_FAMAS', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_FAMAS', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_FAMAS', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_FAMAS', attribute="magazingroesse",          value=30.0)
object.set_attribute(object='SET_FAMAS', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_FAMAS', attribute="schusspausenzeit",          value=1.8)
object.set_attribute(object='SET_FAMAS', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_FAMAS', attribute="blockadewahrscheinlichkeit",   value=17.0)
object.set_attribute(object='SET_FAMAS', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_FAMAS', attribute="effects", value={
    "sound_shot"   : "burst_famas",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_G36C')
object.set_attribute(object='SET_HK_G36C', attribute="name", value=globaltext.SET_HK_G36C_NAME)
object.set_attribute(object='SET_HK_G36C', attribute="hint", value=globaltext.SET_HK_G36C_HINT)
object.set_attribute(object='SET_HK_G36C', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G36C')
object.set_attribute(object='SET_HK_G36C', attribute="resource3d", value='RES3D_HK_G36C')
object.set_attribute(object='SET_HK_G36C', attribute="value", value=40.00)
object.set_attribute(object='SET_HK_G36C', attribute="weight", value=3.4)
object.set_attribute(object='SET_HK_G36C', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_G36C', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_G36C', attribute="maximale_feuerreichweite", value=37)
object.set_attribute(object='SET_HK_G36C', attribute="salvenlaenge", value=4)
object.set_attribute(object='SET_HK_G36C', attribute="feuergeschwindigkeit", value=750.00)
object.set_attribute(object='SET_HK_G36C', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_HK_G36C', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_G36C', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_G36C', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_G36C', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_HK_G36C', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_HK_G36C', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_HK_G36C', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_HK_G36C', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_G36C', attribute="schusspausenzeit",          value=1.4)
object.set_attribute(object='SET_HK_G36C', attribute="genauigkeit_bewegte_ziele",   value=0.8)
object.set_attribute(object='SET_HK_G36C', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_HK_G36C', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_HK_G36C', attribute="effects", value={
    "sound_shot"   : "burst_hk_g36c",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_HK_G36C', new_typeid='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=52.00)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.4)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "burst_hk_g36c",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_HK_G36C','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_G36C_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_HK_G36C', new_typeid='SET_HK_G36C_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_HK_G36C_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_HK_G36C_SAWED_OFF_REMINGTON_M870_HINT)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G36C_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_HK_G36C_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="value", value=54.00)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.4)
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "burst_hk_g36c",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_HK_G36C','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_G41')
object.set_attribute(object='SET_HK_G41', attribute="name", value=globaltext.SET_HK_G41_NAME)
object.set_attribute(object='SET_HK_G41', attribute="hint", value=globaltext.SET_HK_G41_HINT)
object.set_attribute(object='SET_HK_G41', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G41')
object.set_attribute(object='SET_HK_G41', attribute="resource3d", value='RES3D_HK_G41')
object.set_attribute(object='SET_HK_G41', attribute="value", value=30.00)
object.set_attribute(object='SET_HK_G41', attribute="weight", value=4.1)
object.set_attribute(object='SET_HK_G41', attribute="stacking", value=1)
object.set_attribute(object='SET_HK_G41', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HK_G41', attribute="maximale_feuerreichweite", value=34)
object.set_attribute(object='SET_HK_G41', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_HK_G41', attribute="feuergeschwindigkeit", value=600.00)
object.set_attribute(object='SET_HK_G41', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_HK_G41', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_HK_G41', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_HK_G41', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_HK_G41', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_HK_G41', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_HK_G41', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_HK_G41', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_HK_G41', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HK_G41', attribute="schusspausenzeit",             value=1.9)
object.set_attribute(object='SET_HK_G41', attribute="genauigkeit_bewegte_ziele",      value=0.6)
object.set_attribute(object='SET_HK_G41', attribute="blockadewahrscheinlichkeit",   value=17.0)
object.set_attribute(object='SET_HK_G41', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_HK_G41', attribute="effects", value={
    "sound_shot"   : "burst_hk_g41",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_HK_G41', new_typeid='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=54.00)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.4)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "burst_hk_g41",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_HK_G41','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_G41_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_HK_G41', new_typeid='SET_HK_G41_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_HK_G41_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_HK_G41_SAWED_OFF_REMINGTON_M870_HINT)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G41_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_HK_G41_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="value", value=44.00)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.4)
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "burst_hk_g41",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})
object.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_HK_G41','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_OICW')
object.set_attribute(object='SET_OICW', attribute="name", value=globaltext.SET_OICW_NAME)
object.set_attribute(object='SET_OICW', attribute="hint", value=globaltext.SET_OICW_HINT)
object.set_attribute(object='SET_OICW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_OICW')
object.set_attribute(object='SET_OICW', attribute="resource3d", value='RES3D_OICW')
object.set_attribute(object='SET_OICW', attribute="value", value=60.00)
object.set_attribute(object='SET_OICW', attribute="weight", value=6.0)
object.set_attribute(object='SET_OICW', attribute="stacking", value=1)
object.set_attribute(object='SET_OICW', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_OICW', attribute="maximale_feuerreichweite", value=35)
object.set_attribute(object='SET_OICW', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_OICW', attribute="feuergeschwindigkeit", value=750.00)
object.set_attribute(object='SET_OICW', attribute="genauigkeit", value=1.2)
object.set_attribute(object='SET_OICW', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_OICW', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_OICW', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_OICW', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_OICW', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_OICW', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_OICW', attribute="magazingroesse",             value=30.0)
object.set_attribute(object='SET_OICW', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_OICW', attribute="schusspausenzeit",          value=3.0)
object.set_attribute(object='SET_OICW', attribute="genauigkeit_bewegte_ziele",   value=1.2)
object.set_attribute(object='SET_OICW', attribute="blockadewahrscheinlichkeit",   value=18.0)
object.set_attribute(object='SET_OICW', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_OICW', attribute="effects", value={
    "sound_shot"   : "burst_oicw_gewehr",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_SIG_SG_552')
object.set_attribute(object='SET_SIG_SG_552', attribute="name", value=globaltext.SET_SIG_SG_552_NAME)
object.set_attribute(object='SET_SIG_SG_552', attribute="hint", value=globaltext.SET_SIG_SG_552_HINT)
object.set_attribute(object='SET_SIG_SG_552', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SG_552')
object.set_attribute(object='SET_SIG_SG_552', attribute="resource3d", value='RES3D_SIG_SG_552')
object.set_attribute(object='SET_SIG_SG_552', attribute="value", value=30.00)
object.set_attribute(object='SET_SIG_SG_552', attribute="weight", value=3.5)
object.set_attribute(object='SET_SIG_SG_552', attribute="stacking", value=1)
object.set_attribute(object='SET_SIG_SG_552', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SIG_SG_552', attribute="maximale_feuerreichweite", value=32)
object.set_attribute(object='SET_SIG_SG_552', attribute="salvenlaenge", value=3)
object.set_attribute(object='SET_SIG_SG_552', attribute="feuergeschwindigkeit", value=780.00)
object.set_attribute(object='SET_SIG_SG_552', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_SIG_SG_552', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_SIG_SG_552', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_SIG_SG_552', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_SIG_SG_552', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_SIG_SG_552', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_SIG_SG_552', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_SIG_SG_552', attribute="magazingroesse",             value=20.0)
object.set_attribute(object='SET_SIG_SG_552', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_SIG_SG_552', attribute="schusspausenzeit",             value=1.7)
object.set_attribute(object='SET_SIG_SG_552', attribute="genauigkeit_bewegte_ziele",      value=0.7)
object.set_attribute(object='SET_SIG_SG_552', attribute="blockadewahrscheinlichkeit",   value=17.0)
object.set_attribute(object='SET_SIG_SG_552', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_SIG_SG_552', attribute="effects", value={
    "sound_shot"   : "burst_sig_sg552",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_SIG_SG_552', new_typeid='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=42.00)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.4)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
    "sound_shot"   : "burst_sig_sg552",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_SIG_SG_552','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_SIG_SG_552', new_typeid='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870_NAME)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870_HINT)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="value", value=44.00)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.4)
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
    "sound_shot"   : "burst_sig_sg552",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})
object.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "difficulty_disassemble":   COMBO_EVERYBODY,
   "assemble_function"      :   "assemble_over_and_under_gun",
   "disassemble_function"   :   "disassemble_over_and_under_gun",
   "combination_list"      : [ ['SET_SIG_SG_552','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_STEYR_AUG')
object.set_attribute(object='SET_STEYR_AUG', attribute="name", value=globaltext.SET_STEYR_AUG_NAME)
object.set_attribute(object='SET_STEYR_AUG', attribute="hint", value=globaltext.SET_STEYR_AUG_HINT)
object.set_attribute(object='SET_STEYR_AUG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_STEYR_AUG')
object.set_attribute(object='SET_STEYR_AUG', attribute="resource3d", value='RES3D_STEYR_AUG')
object.set_attribute(object='SET_STEYR_AUG', attribute="value", value=25.00)
object.set_attribute(object='SET_STEYR_AUG', attribute="weight", value=4.1)
object.set_attribute(object='SET_STEYR_AUG', attribute="stacking", value=1)
object.set_attribute(object='SET_STEYR_AUG', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_STEYR_AUG', attribute="maximale_feuerreichweite", value=38)
object.set_attribute(object='SET_STEYR_AUG', attribute="salvenlaenge", value=4)
object.set_attribute(object='SET_STEYR_AUG', attribute="feuergeschwindigkeit", value=650.00)
object.set_attribute(object='SET_STEYR_AUG', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_STEYR_AUG', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_STEYR_AUG', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_STEYR_AUG', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_STEYR_AUG', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_STEYR_AUG', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_STEYR_AUG', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_STEYR_AUG', attribute="magazingroesse",          value=30.0)
object.set_attribute(object='SET_STEYR_AUG', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_STEYR_AUG', attribute="schusspausenzeit",          value=1.8)
object.set_attribute(object='SET_STEYR_AUG', attribute="genauigkeit_bewegte_ziele",   value=0.8)
object.set_attribute(object='SET_STEYR_AUG', attribute="blockadewahrscheinlichkeit",   value=15.0)
object.set_attribute(object='SET_STEYR_AUG', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_STEYR_AUG', attribute="effects", value={
    "sound_shot"   : "burst_steyr_aug",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M14')
object.set_attribute(object='SET_M14', attribute="name", value=globaltext.SET_M14_NAME)
object.set_attribute(object='SET_M14', attribute="hint", value=globaltext.SET_M14_HINT)
object.set_attribute(object='SET_M14', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M14')
object.set_attribute(object='SET_M14', attribute="resource3d", value='RES3D_M14')
object.set_attribute(object='SET_M14', attribute="value", value=14.00)
object.set_attribute(object='SET_M14', attribute="weight", value=4.3)
object.set_attribute(object='SET_M14', attribute="stacking", value=1)
object.set_attribute(object='SET_M14', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_M14', attribute="maximale_feuerreichweite", value=30)
object.set_attribute(object='SET_M14', attribute="salvenlaenge", value=12)
object.set_attribute(object='SET_M14', attribute="feuergeschwindigkeit", value=700.00)
object.set_attribute(object='SET_M14', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_M14', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_M14', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_M14', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_M14', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_M14', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_M14', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_M14', attribute="magazingroesse",             value=20.0)
object.set_attribute(object='SET_M14', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_M14', attribute="schusspausenzeit",          value=1.8)
object.set_attribute(object='SET_M14', attribute="genauigkeit_bewegte_ziele",   value=0.5)
object.set_attribute(object='SET_M14', attribute="blockadewahrscheinlichkeit",   value=12.0)
object.set_attribute(object='SET_M14', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_M14', attribute="effects", value={
    "sound_shot"   : "burst_m14",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_MG_3')
object.set_attribute(object='SET_MG_3', attribute="name", value=globaltext.SET_MG_3_NAME)
object.set_attribute(object='SET_MG_3', attribute="hint", value=globaltext.SET_MG_3_HINT)
object.set_attribute(object='SET_MG_3', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MG_3')
object.set_attribute(object='SET_MG_3', attribute="resource3d", value='RES3D_MG_3')
object.set_attribute(object='SET_MG_3', attribute="value", value=32.00)
object.set_attribute(object='SET_MG_3', attribute="weight", value=11.5)
object.set_attribute(object='SET_MG_3', attribute="stacking", value=1)
object.set_attribute(object='SET_MG_3', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MG_3', attribute="maximale_feuerreichweite", value=45)
object.set_attribute(object='SET_MG_3', attribute="salvenlaenge", value=18)
object.set_attribute(object='SET_MG_3', attribute="feuergeschwindigkeit", value=1200.00)
object.set_attribute(object='SET_MG_3', attribute="genauigkeit", value=0.4)
object.set_attribute(object='SET_MG_3', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_MG_3', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_MG_3', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_MG_3', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_MG_3', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_MG_3', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_MG_3', attribute="magazingroesse",             value=50.0)
object.set_attribute(object='SET_MG_3', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_MG_3', attribute="schusspausenzeit",          value=2.7)
object.set_attribute(object='SET_MG_3', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_MG_3', attribute="blockadewahrscheinlichkeit",   value=12.0)
object.set_attribute(object='SET_MG_3', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_MG_3', attribute="effects", value={
    "sound_shot"   : "burst_mg_3",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_RPK_74')
object.set_attribute(object='SET_RPK_74', attribute="name", value=globaltext.SET_RPK_74_NAME)
object.set_attribute(object='SET_RPK_74', attribute="hint", value=globaltext.SET_RPK_74_HINT)
object.set_attribute(object='SET_RPK_74', attribute="resourceui", value='RES_ITEM65X32_WEAPON_RPK_74')
object.set_attribute(object='SET_RPK_74', attribute="resource3d", value='RES3D_RPK_74')
object.set_attribute(object='SET_RPK_74', attribute="value", value=33.00)
object.set_attribute(object='SET_RPK_74', attribute="weight", value=5.0)
object.set_attribute(object='SET_RPK_74', attribute="stacking", value=1)
object.set_attribute(object='SET_RPK_74', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_RPK_74', attribute="maximale_feuerreichweite", value=42)
object.set_attribute(object='SET_RPK_74', attribute="salvenlaenge", value=12)
object.set_attribute(object='SET_RPK_74', attribute="feuergeschwindigkeit", value=600.00)
object.set_attribute(object='SET_RPK_74', attribute="genauigkeit", value=0.4)
object.set_attribute(object='SET_RPK_74', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_RPK_74', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_RPK_74', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_RPK_74', attribute="munitionsarten", value=['SET_AMMOPACK_5_45_MM'])
object.set_attribute(object='SET_RPK_74', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_RPK_74', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_RPK_74', attribute="magazingroesse",             value=45.0)
object.set_attribute(object='SET_RPK_74', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_RPK_74', attribute="schusspausenzeit",             value=2.3)
object.set_attribute(object='SET_RPK_74', attribute="genauigkeit_bewegte_ziele",      value=0.7)
object.set_attribute(object='SET_RPK_74', attribute="blockadewahrscheinlichkeit",   value=10.0)
object.set_attribute(object='SET_RPK_74', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_RPK_74', attribute="effects", value={
    "sound_shot"   : "burst_rpk_74",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M249')
object.set_attribute(object='SET_M249', attribute="name", value=globaltext.SET_M249_NAME)
object.set_attribute(object='SET_M249', attribute="hint", value=globaltext.SET_M249_HINT)
object.set_attribute(object='SET_M249', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M249')
object.set_attribute(object='SET_M249', attribute="resource3d", value='RES3D_M249')
object.set_attribute(object='SET_M249', attribute="value", value=30.00)
object.set_attribute(object='SET_M249', attribute="weight", value=6.8)
object.set_attribute(object='SET_M249', attribute="stacking", value=1)
object.set_attribute(object='SET_M249', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_M249', attribute="maximale_feuerreichweite", value=40)
object.set_attribute(object='SET_M249', attribute="salvenlaenge", value=15)
object.set_attribute(object='SET_M249', attribute="feuergeschwindigkeit", value=750.00)
object.set_attribute(object='SET_M249', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_M249', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_M249', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_M249', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_M249', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
object.set_attribute(object='SET_M249', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_M249', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_M249', attribute="magazingroesse",             value=100.0)
object.set_attribute(object='SET_M249', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_M249', attribute="schusspausenzeit",          value=2.0)
object.set_attribute(object='SET_M249', attribute="genauigkeit_bewegte_ziele",   value=0.8)
object.set_attribute(object='SET_M249', attribute="blockadewahrscheinlichkeit",   value=13.0)
object.set_attribute(object='SET_M249', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_M249', attribute="effects", value={
    "sound_shot"   : "burst_m249",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_FN_MAG')
object.set_attribute(object='SET_FN_MAG', attribute="name", value=globaltext.SET_FN_MAG_NAME)
object.set_attribute(object='SET_FN_MAG', attribute="hint", value=globaltext.SET_FN_MAG_HINT)
object.set_attribute(object='SET_FN_MAG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_FN_MAG')
object.set_attribute(object='SET_FN_MAG', attribute="resource3d", value='RES3D_FN_MAG')
object.set_attribute(object='SET_FN_MAG', attribute="value", value=35.00)
object.set_attribute(object='SET_FN_MAG', attribute="weight", value=11.0)
object.set_attribute(object='SET_FN_MAG', attribute="stacking", value=1)
object.set_attribute(object='SET_FN_MAG', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_FN_MAG', attribute="maximale_feuerreichweite", value=41)
object.set_attribute(object='SET_FN_MAG', attribute="salvenlaenge", value=15)
object.set_attribute(object='SET_FN_MAG', attribute="feuergeschwindigkeit", value=700.00)
object.set_attribute(object='SET_FN_MAG', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_FN_MAG', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_FN_MAG', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_FN_MAG', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_FN_MAG', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_FN_MAG', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_FN_MAG', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_FN_MAG', attribute="magazingroesse",             value=100.0)
object.set_attribute(object='SET_FN_MAG', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_FN_MAG', attribute="schusspausenzeit",             value=3.0)
object.set_attribute(object='SET_FN_MAG', attribute="genauigkeit_bewegte_ziele",      value=0.8)
object.set_attribute(object='SET_FN_MAG', attribute="blockadewahrscheinlichkeit",   value=12.0)
object.set_attribute(object='SET_FN_MAG', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_FN_MAG', attribute="effects", value={
    "sound_shot"   : "burst_fn_mag",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M60')
object.set_attribute(object='SET_M60', attribute="name", value=globaltext.SET_M60_NAME)
object.set_attribute(object='SET_M60', attribute="hint", value=globaltext.SET_M60_HINT)
object.set_attribute(object='SET_M60', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M60')
object.set_attribute(object='SET_M60', attribute="resource3d", value='RES3D_M60')
object.set_attribute(object='SET_M60', attribute="value", value=35.00)
object.set_attribute(object='SET_M60', attribute="weight", value=10.5)
object.set_attribute(object='SET_M60', attribute="stacking", value=1)
object.set_attribute(object='SET_M60', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_M60', attribute="maximale_feuerreichweite", value=43)
object.set_attribute(object='SET_M60', attribute="salvenlaenge", value=9)
object.set_attribute(object='SET_M60', attribute="feuergeschwindigkeit", value=550.00)
object.set_attribute(object='SET_M60', attribute="genauigkeit", value=0.5)
object.set_attribute(object='SET_M60', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_M60', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_M60', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_M60', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_M60', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
object.set_attribute(object='SET_M60', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_M60', attribute="magazingroesse",             value=100.0)
object.set_attribute(object='SET_M60', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_M60', attribute="schusspausenzeit",          value=2.5)
object.set_attribute(object='SET_M60', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_M60', attribute="blockadewahrscheinlichkeit",   value=13.0)
object.set_attribute(object='SET_M60', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_M60', attribute="effects", value={
    "sound_shot"   : "burst_m60",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 0.7,
    "stream_type"   : 1,
    "stream_size"   : 0.7,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M_79')
object.set_attribute(object='SET_M_79', attribute="name", value=globaltext.SET_M_79_NAME)
object.set_attribute(object='SET_M_79', attribute="hint", value=globaltext.SET_M_79_HINT)
object.set_attribute(object='SET_M_79', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_79')
object.set_attribute(object='SET_M_79', attribute="resource3d", value='RES3D_M_79')
object.set_attribute(object='SET_M_79', attribute="value", value=25.00)
object.set_attribute(object='SET_M_79', attribute="weight", value=3.5)
object.set_attribute(object='SET_M_79', attribute="stacking", value=1)
object.set_attribute(object='SET_M_79', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_M_79', attribute="maximale_feuerreichweite", value=30)
object.set_attribute(object='SET_M_79', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_M_79', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_M_79', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_M_79', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_M_79', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_M_79', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_M_79', attribute="munitionsarten", value=['SET_AMMOPACK_M79_M203'])
object.set_attribute(object='SET_M_79', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
object.set_attribute(object='SET_M_79', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_M_79', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_M_79', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_M_79', attribute="schusspausenzeit",          value=2.0)
object.set_attribute(object='SET_M_79', attribute="genauigkeit_bewegte_ziele",   value=0.2)
object.set_attribute(object='SET_M_79', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_M_79', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_M_79', attribute="effects", value={
    "sound_shot"   : "shot_m_79",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 5,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.8,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_RPG7')
object.set_attribute(object='SET_RPG7', attribute="name", value=globaltext.SET_RPG7_NAME)
object.set_attribute(object='SET_RPG7', attribute="hint", value=globaltext.SET_RPG7_HINT)
object.set_attribute(object='SET_RPG7', attribute="resourceui", value='RES_ITEM65X32_WEAPON_RPG7')
object.set_attribute(object='SET_RPG7', attribute="resource3d", value='RES3D_RPG7')
object.set_attribute(object='SET_RPG7', attribute="value", value=80.00)
object.set_attribute(object='SET_RPG7', attribute="weight", value=7.9)
object.set_attribute(object='SET_RPG7', attribute="stacking", value=1)
object.set_attribute(object='SET_RPG7', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_RPG7', attribute="maximale_feuerreichweite", value=50)
object.set_attribute(object='SET_RPG7', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_RPG7', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_RPG7', attribute="genauigkeit", value=5.00)
object.set_attribute(object='SET_RPG7', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_RPG7', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_RPG7', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_RPG7', attribute="munitionsarten", value=['SET_AMMOPACK_40_MM_RPG7_HE'])
object.set_attribute(object='SET_RPG7', attribute="fire_animation", value=FPA_SHOULDER_BASED)
object.set_attribute(object='SET_RPG7', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_RPG7', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_RPG7', attribute="hoerweite",                value=50.0)
object.set_attribute(object='SET_RPG7', attribute="schusspausenzeit",          value=3.0)
object.set_attribute(object='SET_RPG7', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_RPG7', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_RPG7', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_RPG7', attribute="illegal_bodymodes", value=["LIE"])
object.set_attribute(object='SET_RPG7', attribute="effects", value={
    "sound_shot"   : "shot_rpg7",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 5,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.8,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_LAW')
object.set_attribute(object='SET_LAW', attribute="name", value=globaltext.SET_LAW_NAME)
object.set_attribute(object='SET_LAW', attribute="hint", value=globaltext.SET_LAW_HINT)
object.set_attribute(object='SET_LAW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_LAW')
object.set_attribute(object='SET_LAW', attribute="resource3d", value='RES3D_LAW')
object.set_attribute(object='SET_LAW', attribute="value", value=75.00)
object.set_attribute(object='SET_LAW', attribute="weight", value=6.0)
object.set_attribute(object='SET_LAW', attribute="stacking", value=1)
object.set_attribute(object='SET_LAW', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_LAW', attribute="maximale_feuerreichweite", value=40)
object.set_attribute(object='SET_LAW', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_LAW', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_LAW', attribute="genauigkeit", value=3.00)
object.set_attribute(object='SET_LAW', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_LAW', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_LAW', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_LAW', attribute="munitionsarten", value=['SET_MUN_LAW'])
object.set_attribute(object='SET_LAW', attribute="fire_animation", value=FPA_SHOULDER_BASED)
object.set_attribute(object='SET_LAW', attribute="weapon_type", value="schwer")
object.set_attribute(object='SET_LAW', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_LAW', attribute="hoerweite",                value=50.0)
object.set_attribute(object='SET_LAW', attribute="schusspausenzeit",          value=3.5)
object.set_attribute(object='SET_LAW', attribute="genauigkeit_bewegte_ziele",   value=0.4)
object.set_attribute(object='SET_LAW', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_LAW', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_LAW', attribute="illegal_bodymodes", value=["LIE"])
object.set_attribute(object='SET_LAW', attribute="effects", value={
    "sound_shot"   : "shot_law",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 5,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.8,
    "fade_out"      : 50})

## sniper waffen
create_weapon_type(typeid='SET_DRAGUNOV')
object.set_attribute(object='SET_DRAGUNOV', attribute="name", value=globaltext.SET_DRAGUNOV_NAME)
object.set_attribute(object='SET_DRAGUNOV', attribute="hint", value=globaltext.SET_DRAGUNOV_HINT)
object.set_attribute(object='SET_DRAGUNOV', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DRAGUNOV')
object.set_attribute(object='SET_DRAGUNOV', attribute="resource3d", value='RES3D_DRAGUNOV')
object.set_attribute(object='SET_DRAGUNOV', attribute="value", value=100.00)
object.set_attribute(object='SET_DRAGUNOV', attribute="weight", value=4.3)
object.set_attribute(object='SET_DRAGUNOV', attribute="stacking", value=1)
object.set_attribute(object='SET_DRAGUNOV', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_DRAGUNOV', attribute="maximale_feuerreichweite", value=70)
object.set_attribute(object='SET_DRAGUNOV', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_DRAGUNOV', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_DRAGUNOV', attribute="genauigkeit", value=1.5)
object.set_attribute(object='SET_DRAGUNOV', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_DRAGUNOV', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_DRAGUNOV', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_DRAGUNOV', attribute="munitionsarten", value=['SET_AMMOPACK_7_62_54_MMR'])
object.set_attribute(object='SET_DRAGUNOV', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_DRAGUNOV', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_DRAGUNOV', attribute="magazingroesse",          value=10.0)
object.set_attribute(object='SET_DRAGUNOV', attribute="hoerweite",          value=40.0)
object.set_attribute(object='SET_DRAGUNOV', attribute="schusspausenzeit",       value=3.5)
object.set_attribute(object='SET_DRAGUNOV', attribute="genauigkeit_bewegte_ziele",   value=1.5)
object.set_attribute(object='SET_DRAGUNOV', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_DRAGUNOV', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_DRAGUNOV', attribute="effects", value={
    "sound_shot"   : "shot_dragunov",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 1.1,
    "stream_type"   : 1,
    "stream_size"   : 1.1,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_PSG_1')
object.set_attribute(object='SET_PSG_1', attribute="name", value=globaltext.SET_PSG_1_NAME)
object.set_attribute(object='SET_PSG_1', attribute="hint", value=globaltext.SET_PSG_1_HINT)
object.set_attribute(object='SET_PSG_1', attribute="resourceui", value='RES_ITEM65X32_WEAPON_PSG_1')
object.set_attribute(object='SET_PSG_1', attribute="resource3d", value='RES3D_PSG_1')
object.set_attribute(object='SET_PSG_1', attribute="value", value=150.00)
object.set_attribute(object='SET_PSG_1', attribute="weight", value=8.1)
object.set_attribute(object='SET_PSG_1', attribute="stacking", value=1)
object.set_attribute(object='SET_PSG_1', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_PSG_1', attribute="maximale_feuerreichweite", value=75)
object.set_attribute(object='SET_PSG_1', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_PSG_1', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_PSG_1', attribute="genauigkeit", value=2.00)
object.set_attribute(object='SET_PSG_1', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_PSG_1', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_PSG_1', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_PSG_1', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_PSG_1', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_PSG_1', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_PSG_1', attribute="magazingroesse",          value=8.0)
object.set_attribute(object='SET_PSG_1', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_PSG_1', attribute="schusspausenzeit",          value=3.6)
object.set_attribute(object='SET_PSG_1', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_PSG_1', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_PSG_1', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_PSG_1', attribute="effects", value={
    "sound_shot"   : "shot_psg_1",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 1.0,
    "stream_type"   : 1,
    "stream_size"   : 1.0,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_BARRET_M82A2')
object.set_attribute(object='SET_BARRET_M82A2', attribute="name", value=globaltext.SET_BARRET_M82A2_NAME)
object.set_attribute(object='SET_BARRET_M82A2', attribute="hint", value=globaltext.SET_BARRET_M82A2_HINT)
object.set_attribute(object='SET_BARRET_M82A2', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BARRET_M82A2')
object.set_attribute(object='SET_BARRET_M82A2', attribute="resource3d", value='RES3D_BARRET_M82A2')
object.set_attribute(object='SET_BARRET_M82A2', attribute="value", value=90.00)
object.set_attribute(object='SET_BARRET_M82A2', attribute="weight", value=12.9)
object.set_attribute(object='SET_BARRET_M82A2', attribute="stacking", value=1)
object.set_attribute(object='SET_BARRET_M82A2', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BARRET_M82A2', attribute="maximale_feuerreichweite", value=100)
object.set_attribute(object='SET_BARRET_M82A2', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BARRET_M82A2', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_BARRET_M82A2', attribute="genauigkeit", value=1.5)
object.set_attribute(object='SET_BARRET_M82A2', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_BARRET_M82A2', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_BARRET_M82A2', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_BARRET_M82A2', attribute="munitionsarten", value=['SET_AMMOPACK_50_BMG'])
object.set_attribute(object='SET_BARRET_M82A2', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_BARRET_M82A2', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_BARRET_M82A2', attribute="magazingroesse",             value=8.0)
object.set_attribute(object='SET_BARRET_M82A2', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_BARRET_M82A2', attribute="schusspausenzeit",          value=3.6)
object.set_attribute(object='SET_BARRET_M82A2', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_BARRET_M82A2', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_BARRET_M82A2', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_BARRET_M82A2', attribute="effects", value={
    "sound_shot"   : "shot_barret_m82a2",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 1.1,
    "stream_type"   : 1,
    "stream_size"   : 1.3,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_M24')
object.set_attribute(object='SET_M24', attribute="name", value=globaltext.SET_M24_NAME)
object.set_attribute(object='SET_M24', attribute="hint", value=globaltext.SET_M24_HINT)
object.set_attribute(object='SET_M24', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M24')
object.set_attribute(object='SET_M24', attribute="resource3d", value='RES3D_M24')
object.set_attribute(object='SET_M24', attribute="value", value=80.00)
object.set_attribute(object='SET_M24', attribute="weight", value=5.4)
object.set_attribute(object='SET_M24', attribute="stacking", value=1)
object.set_attribute(object='SET_M24', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_M24', attribute="maximale_feuerreichweite", value=80)
object.set_attribute(object='SET_M24', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_M24', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_M24', attribute="genauigkeit", value=2.00)
object.set_attribute(object='SET_M24', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_M24', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_M24', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_M24', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_M24', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_M24', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_M24', attribute="magazingroesse",             value=10.0)
object.set_attribute(object='SET_M24', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_M24', attribute="schusspausenzeit",          value=3.8)
object.set_attribute(object='SET_M24', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_M24', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_M24', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_M24', attribute="effects", value={
    "sound_shot"   : "shot_m24",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 1.0,
    "stream_type"   : 1,
    "stream_size"   : 1.1,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_CROSSBOW')
object.set_attribute(object='SET_CROSSBOW', attribute="name", value=globaltext.SET_CROSSBOW_NAME)
object.set_attribute(object='SET_CROSSBOW', attribute="hint", value=globaltext.SET_CROSSBOW_HINT)
object.set_attribute(object='SET_CROSSBOW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CROSSBOW')
object.set_attribute(object='SET_CROSSBOW', attribute="resource3d", value='RES3D_CROSSBOW')
object.set_attribute(object='SET_CROSSBOW', attribute="value", value=60.00)
object.set_attribute(object='SET_CROSSBOW', attribute="weight", value=4.0)
object.set_attribute(object='SET_CROSSBOW', attribute="stacking", value=1)
object.set_attribute(object='SET_CROSSBOW', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_CROSSBOW', attribute="maximale_feuerreichweite", value=33)
object.set_attribute(object='SET_CROSSBOW', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_CROSSBOW', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_CROSSBOW', attribute="genauigkeit", value=1.00)
object.set_attribute(object='SET_CROSSBOW', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_CROSSBOW', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_CROSSBOW', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_CROSSBOW', attribute="munitionsarten", value=['SET_AMMOPACK_BOLT'])
object.set_attribute(object='SET_CROSSBOW', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_CROSSBOW', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_CROSSBOW', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_CROSSBOW', attribute="hoerweite",                value=1.0)
object.set_attribute(object='SET_CROSSBOW', attribute="schusspausenzeit",          value=4.0)
object.set_attribute(object='SET_CROSSBOW', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_CROSSBOW', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_CROSSBOW', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_CROSSBOW', attribute="effects", value={
    "sound_shot"   : "shot_crossbow",
    "sound_unload"   : "crossbow_discharge",
    "sound_reload"   : "crossbow_charge"})

create_weapon_type(typeid='SET_DSR1')
object.set_attribute(object='SET_DSR1', attribute="name", value=globaltext.SET_DSR1_NAME)
object.set_attribute(object='SET_DSR1', attribute="hint", value=globaltext.SET_DSR1_HINT)
object.set_attribute(object='SET_DSR1', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DSR1')
object.set_attribute(object='SET_DSR1', attribute="resource3d", value='RES3D_DSR1')
object.set_attribute(object='SET_DSR1', attribute="value", value=200.00)
object.set_attribute(object='SET_DSR1', attribute="weight", value=5.2)
object.set_attribute(object='SET_DSR1', attribute="stacking", value=1)
object.set_attribute(object='SET_DSR1', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_DSR1', attribute="maximale_feuerreichweite", value=90)
object.set_attribute(object='SET_DSR1', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_DSR1', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_DSR1', attribute="genauigkeit", value=3.00)
object.set_attribute(object='SET_DSR1', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_DSR1', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_DSR1', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_DSR1', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
object.set_attribute(object='SET_DSR1', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_DSR1', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_DSR1', attribute="magazingroesse",             value=5.0)
object.set_attribute(object='SET_DSR1', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_DSR1', attribute="schusspausenzeit",          value=4.0)
object.set_attribute(object='SET_DSR1', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_DSR1', attribute="blockadewahrscheinlichkeit",   value=5.0)
object.set_attribute(object='SET_DSR1', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_DSR1', attribute="effects", value={
    "sound_shot"   : "shot_dsr1",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 1,
    "flash_size"   : 1.0,
    "stream_type"   : 1,
    "stream_size"   : 1.0,
    "fade_out"      : 50})

create_weapon_type(typeid='SET_RAILGUN')
object.set_attribute(object='SET_RAILGUN', attribute="name", value=globaltext.SET_RAILGUN_NAME)
object.set_attribute(object='SET_RAILGUN', attribute="hint", value=globaltext.SET_RAILGUN_HINT)
object.set_attribute(object='SET_RAILGUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_RAILGUN')
object.set_attribute(object='SET_RAILGUN', attribute="resource3d", value='RES3D_RAILGUN')
object.set_attribute(object='SET_RAILGUN', attribute="value", value=300.0)
object.set_attribute(object='SET_RAILGUN', attribute="weight", value=12.0)
object.set_attribute(object='SET_RAILGUN', attribute="stacking", value=1)
object.set_attribute(object='SET_RAILGUN', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_RAILGUN', attribute="maximale_feuerreichweite", value=150)
object.set_attribute(object='SET_RAILGUN', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_RAILGUN', attribute="feuergeschwindigkeit", value=0.00)
object.set_attribute(object='SET_RAILGUN', attribute="genauigkeit", value=2.00)
object.set_attribute(object='SET_RAILGUN', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_RAILGUN', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_RAILGUN', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_RAILGUN', attribute="munitionsarten", value=['SET_AMMOPACK_2_5_JHP_ARROW'])
object.set_attribute(object='SET_RAILGUN', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
object.set_attribute(object='SET_RAILGUN', attribute="weapon_type", value="sniper")
object.set_attribute(object='SET_RAILGUN', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_RAILGUN', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_RAILGUN', attribute="schusspausenzeit",          value=3.0)
object.set_attribute(object='SET_RAILGUN', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_RAILGUN', attribute="blockadewahrscheinlichkeit",   value=0.0)
object.set_attribute(object='SET_RAILGUN', attribute="occupied_slots", value=["left_hand","right_hand"])
object.set_attribute(object='SET_RAILGUN', attribute="effects", value={
    "sound_shot"   : "shot_railgun",
    "sound_unload"   : "rifle_discharge",
    "sound_gunjam"   : "rifle_gunjam",
    "sound_reload"   : "rifle_charge",
    "flash_type"   : 6,
    "flash_size"   : 0.5,
    "stream_type"   : 2,
    "stream_size"   : 0.7,
    "fade_out"      : 50})


## Sekundäre Waffen (z.B. Granaten, Messer, usw.)
create_throw_object_type(typeid='SET_HEGRENADE')
object.set_attribute(object='SET_HEGRENADE', attribute="name", value=globaltext.SET_HEGRENADE_NAME)
object.set_attribute(object='SET_HEGRENADE', attribute="hint", value=globaltext.SET_HEGRENADE_HINT)
object.set_attribute(object='SET_HEGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_HEGRENADE')
object.set_attribute(object='SET_HEGRENADE', attribute="resource3d", value='RES3D_HEGRENADE')
object.set_attribute(object='SET_HEGRENADE', attribute="value", value=5.00)
object.set_attribute(object='SET_HEGRENADE', attribute="weight", value=0.20)
object.set_attribute(object='SET_HEGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_HEGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_HEGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_HEGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_HEGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_HEGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_HEGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_HEGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_HEGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_HEGRENADE', attribute="munitionsarten", value=['SET_HEGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_HEGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_HEGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_HEGRENADE', attribute="magazingroesse",          value=1.0)
object.set_attribute(object='SET_HEGRENADE', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_HEGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_HEGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)
object.set_attribute(object='SET_HEGRENADE', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_FRAGGRENADE')
object.set_attribute(object='SET_FRAGGRENADE', attribute="name", value=globaltext.SET_FRAGGRENADE_NAME)
object.set_attribute(object='SET_FRAGGRENADE', attribute="hint", value=globaltext.SET_FRAGGRENADE_HINT)
object.set_attribute(object='SET_FRAGGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_FRAGGRENADE')
object.set_attribute(object='SET_FRAGGRENADE', attribute="resource3d", value='RES3D_FRAGGRENADE')
object.set_attribute(object='SET_FRAGGRENADE', attribute="value", value=7.00)
object.set_attribute(object='SET_FRAGGRENADE', attribute="weight", value=0.20)
object.set_attribute(object='SET_FRAGGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_FRAGGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_FRAGGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_FRAGGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_FRAGGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_FRAGGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_FRAGGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_FRAGGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_FRAGGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_FRAGGRENADE', attribute="munitionsarten", value=['SET_FRAGGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_FRAGGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_FRAGGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_FRAGGRENADE', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_FRAGGRENADE', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_FRAGGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_FRAGGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)
object.set_attribute(object='SET_FRAGGRENADE', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_MOLOTOV_COCKTAIL')
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="name", value=globaltext.SET_MOLOTOV_COCKTAIL_NAME)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="hint", value=globaltext.SET_MOLOTOV_COCKTAIL_HINT)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_MOLOTOV_COCKTAIL')
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="resource3d", value='RES3D_MOLOTOV_COCKTAIL')
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="value", value=5.00)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="weight", value=0.80)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="stacking", value=10)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="genauigkeit", value=0.4)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="munitionsarten", value=['SET_MOLOTOV_COCKTAIL_PSEUDOAMMO'])
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="hoerweite",                value=10.0)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="schusspausenzeit",          value=3.0)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="genauigkeit_bewegte_ziele",   value=0.2)
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="occupied_slots", value=["throw"])
object.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="item_combination",   value={
   "difficulty_assemble"   :   55,
   "combination_list"      : [ ['SET_RAGS','SET_BOTTLE_OF_HOOCH']]})

create_throw_object_type(typeid='SET_FIREGRENADE')
object.set_attribute(object='SET_FIREGRENADE', attribute="name", value=globaltext.SET_FIREGRENADE_NAME)
object.set_attribute(object='SET_FIREGRENADE', attribute="hint", value=globaltext.SET_FIREGRENADE_HINT)
object.set_attribute(object='SET_FIREGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_FIREGRENADE')
object.set_attribute(object='SET_FIREGRENADE', attribute="resource3d", value='RES3D_FIREGRENADE')
object.set_attribute(object='SET_FIREGRENADE', attribute="value", value=4.00)
object.set_attribute(object='SET_FIREGRENADE', attribute="weight", value=0.15)
object.set_attribute(object='SET_FIREGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_FIREGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_FIREGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_FIREGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_FIREGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_FIREGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_FIREGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_FIREGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_FIREGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_FIREGRENADE', attribute="munitionsarten", value=['SET_FIREGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_FIREGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_FIREGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_FIREGRENADE', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_FIREGRENADE', attribute="hoerweite",                value=10.0)
object.set_attribute(object='SET_FIREGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_FIREGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)

create_throw_object_type(typeid='SET_SMOKEGRENADE')
object.set_attribute(object='SET_SMOKEGRENADE', attribute="name", value=globaltext.SET_SMOKEGRENADE_NAME)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="hint", value=globaltext.SET_SMOKEGRENADE_HINT)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_SMOKEGRENADE')
object.set_attribute(object='SET_SMOKEGRENADE', attribute="resource3d", value='RES3D_SMOKEGRENADE')
object.set_attribute(object='SET_SMOKEGRENADE', attribute="value", value=5.00)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="weight", value=0.10)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="munitionsarten", value=['SET_SMOKEGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_SMOKEGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_SMOKEGRENADE', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)
object.set_attribute(object='SET_SMOKEGRENADE', attribute="item_combination",   value={
   "difficulty_assemble"   :   75,
   "combination_list"      : [ ['SET_SALPETER','SET_SUGAR','SET_TIN_CAN','SET_TIME_FUSE']]})

create_throw_object_type(typeid='SET_STUNGRENADE')
object.set_attribute(object='SET_STUNGRENADE', attribute="name", value=globaltext.SET_STUNGRENADE_NAME)
object.set_attribute(object='SET_STUNGRENADE', attribute="hint", value=globaltext.SET_STUNGRENADE_HINT)
object.set_attribute(object='SET_STUNGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_STUNGRENADE')
object.set_attribute(object='SET_STUNGRENADE', attribute="resource3d", value='RES3D_STUNGRENADE')
object.set_attribute(object='SET_STUNGRENADE', attribute="value", value=10.00)
object.set_attribute(object='SET_STUNGRENADE', attribute="weight", value=0.10)
object.set_attribute(object='SET_STUNGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_STUNGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_STUNGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_STUNGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_STUNGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_STUNGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_STUNGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_STUNGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_STUNGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_STUNGRENADE', attribute="munitionsarten", value=['SET_STUNGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_STUNGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_STUNGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_STUNGRENADE', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_STUNGRENADE', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_STUNGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_STUNGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)

create_throw_object_type(typeid='SET_FLASHGRENADE')
object.set_attribute(object='SET_FLASHGRENADE', attribute="name", value=globaltext.SET_FLASHGRENADE_NAME)
object.set_attribute(object='SET_FLASHGRENADE', attribute="hint", value=globaltext.SET_FLASHGRENADE_HINT)
object.set_attribute(object='SET_FLASHGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_FLASHGRENADE')
object.set_attribute(object='SET_FLASHGRENADE', attribute="resource3d", value='RES3D_FLASHGRENADE')
object.set_attribute(object='SET_FLASHGRENADE', attribute="value", value=10.00)
object.set_attribute(object='SET_FLASHGRENADE', attribute="weight", value=0.10)
object.set_attribute(object='SET_FLASHGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_FLASHGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_FLASHGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_FLASHGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_FLASHGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_FLASHGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_FLASHGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_FLASHGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_FLASHGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_FLASHGRENADE', attribute="munitionsarten", value=['SET_FLASHGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_FLASHGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_FLASHGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_FLASHGRENADE', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_FLASHGRENADE', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_FLASHGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_FLASHGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)

create_throw_object_type(typeid='SET_PHOSPHORGRENADE')
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="name", value=globaltext.SET_PHOSPHORGRENADE_NAME)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="hint", value=globaltext.SET_PHOSPHORGRENADE_HINT)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_PHOSPHORGRENADE')
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="resource3d", value='RES3D_PHOSPHORGRENADE')
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="value", value=10.00)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="weight", value=0.15)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="stacking", value=10)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="munitionsarten", value=['SET_PHOSPHORGRENADE_PSEUDOAMMO'])
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="schusspausenzeit",          value=1.5)
object.set_attribute(object='SET_PHOSPHORGRENADE', attribute="genauigkeit_bewegte_ziele",   value=0.3)

create_throw_object_type(typeid='SET_THROWING_KNIFE')
object.set_attribute(object='SET_THROWING_KNIFE', attribute="name", value=globaltext.SET_THROWING_KNIFE_NAME)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="hint", value=globaltext.SET_THROWING_KNIFE_HINT)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_THROWING_KNIFE')
object.set_attribute(object='SET_THROWING_KNIFE', attribute="resource3d", value='RES3D_THROWING_KNIFE')
object.set_attribute(object='SET_THROWING_KNIFE', attribute="value", value=3.00)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="weight", value=0.10)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="stacking", value=10)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="maximale_feuerreichweite", value=23)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="feuergeschwindigkeit", value=0)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="munitionsarten", value=['SET_THROWING_KNIFE_PSEUDOAMMO'])
object.set_attribute(object='SET_THROWING_KNIFE', attribute="fire_animation", value=FPA_THROW_KNIFE)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_THROWING_KNIFE', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="hoerweite", value=0.0)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="schusspausenzeit", value=1.5)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.5)
object.set_attribute(object='SET_THROWING_KNIFE', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_ACID_PROJECTILE')
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="name", value=globaltext.SET_ACID_PROJECTILE_NAME)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="hint", value=globaltext.SET_ACID_PROJECTILE_HINT)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_ACID_PROJECTILE')
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="resource3d", value='RES3D_ACID_PROJECTILE')
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="value", value=5.00)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="weight", value=0.10)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="stacking", value=10)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="maximale_feuerreichweite", value=15)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="munitionsarten", value=['SET_ACID_PROJECTILE_PSEUDOAMMO'])
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="magazingroesse",          value=1.0)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="hoerweite",             value=0.0)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="schusspausenzeit",          value=0.5)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="genauigkeit_bewegte_ziele",   value=0.4)
object.set_attribute(object='SET_ACID_PROJECTILE', attribute="item_combination",   value={
   "difficulty_assemble"   :   65,
   "combination_list"      : [ ['SET_SALT_ACID','SET_LIGHT_BULB']]})

create_throw_object_type(typeid='SET_BOOMERANG')
object.set_attribute(object='SET_BOOMERANG', attribute="name", value=globaltext.SET_BOOMERANG_NAME)
object.set_attribute(object='SET_BOOMERANG', attribute="hint", value=globaltext.SET_BOOMERANG_HINT)
object.set_attribute(object='SET_BOOMERANG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BOOMERANG')
object.set_attribute(object='SET_BOOMERANG', attribute="resource3d", value='RES3D_BOOMERANG')
object.set_attribute(object='SET_BOOMERANG', attribute="value", value=7.00)
object.set_attribute(object='SET_BOOMERANG', attribute="weight", value=0.25)
object.set_attribute(object='SET_BOOMERANG', attribute="stacking", value=10)
object.set_attribute(object='SET_BOOMERANG', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BOOMERANG', attribute="maximale_feuerreichweite", value=30)
object.set_attribute(object='SET_BOOMERANG', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BOOMERANG', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_BOOMERANG', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_BOOMERANG', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_BOOMERANG', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_BOOMERANG', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_BOOMERANG', attribute="munitionsarten", value=['SET_BOOMERANG_PSEUDOAMMO'])
object.set_attribute(object='SET_BOOMERANG', attribute="fire_animation", value=FPA_THROW_KNIFE)
object.set_attribute(object='SET_BOOMERANG', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_BOOMERANG', attribute="magazingroesse",          value=1.0)
object.set_attribute(object='SET_BOOMERANG', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_BOOMERANG', attribute="schusspausenzeit",          value=0.5)
object.set_attribute(object='SET_BOOMERANG', attribute="genauigkeit_bewegte_ziele",   value=0.2)

create_throw_object_type(typeid='SET_DART')
object.set_attribute(object='SET_DART', attribute="name", value=globaltext.SET_DART_NAME)
object.set_attribute(object='SET_DART', attribute="hint", value=globaltext.SET_DART_HINT)
object.set_attribute(object='SET_DART', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DART')
object.set_attribute(object='SET_DART', attribute="resource3d", value='RES3D_DART')
object.set_attribute(object='SET_DART', attribute="value", value=3.00)
object.set_attribute(object='SET_DART', attribute="weight", value=0.25)
object.set_attribute(object='SET_DART', attribute="stacking", value=10)
object.set_attribute(object='SET_DART', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_DART', attribute="maximale_feuerreichweite", value=50)
object.set_attribute(object='SET_DART', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_DART', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_DART', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_DART', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_DART', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_DART', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_DART', attribute="munitionsarten", value=['SET_DART_PSEUDOAMMO'])
object.set_attribute(object='SET_DART', attribute="fire_animation", value=FPA_THROW_KNIFE)
object.set_attribute(object='SET_DART', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_DART', attribute="magazingroesse",          value=1.0)
object.set_attribute(object='SET_DART', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_DART', attribute="schusspausenzeit",          value=0.5)
object.set_attribute(object='SET_DART', attribute="genauigkeit_bewegte_ziele",   value=0.2)
object.set_attribute(object='SET_DART', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_SHURIKEN')
object.set_attribute(object='SET_SHURIKEN', attribute="name", value=globaltext.SET_SHURIKEN_NAME)
object.set_attribute(object='SET_SHURIKEN', attribute="hint", value=globaltext.SET_SHURIKEN_HINT)
object.set_attribute(object='SET_SHURIKEN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SHURIKEN')
object.set_attribute(object='SET_SHURIKEN', attribute="resource3d", value='RES3D_SHURIKEN')
object.set_attribute(object='SET_SHURIKEN', attribute="value", value=6.00)
object.set_attribute(object='SET_SHURIKEN', attribute="weight", value=0.10)
object.set_attribute(object='SET_SHURIKEN', attribute="stacking", value=10)
object.set_attribute(object='SET_SHURIKEN', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SHURIKEN', attribute="maximale_feuerreichweite", value=15)
object.set_attribute(object='SET_SHURIKEN', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SHURIKEN', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_SHURIKEN', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_SHURIKEN', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_SHURIKEN', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_SHURIKEN', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_SHURIKEN', attribute="munitionsarten", value=['SET_SHURIKEN_PSEUDOAMMO'])
object.set_attribute(object='SET_SHURIKEN', attribute="fire_animation", value=FPA_THROW_KNIFE)
object.set_attribute(object='SET_SHURIKEN', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_SHURIKEN', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_SHURIKEN', attribute="hoerweite",                value=0.0)
object.set_attribute(object='SET_SHURIKEN', attribute="schusspausenzeit",          value=0.1)
object.set_attribute(object='SET_SHURIKEN', attribute="genauigkeit_bewegte_ziele",   value=0.8)
object.set_attribute(object='SET_SHURIKEN', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_GAS_BOMB')
object.set_attribute(object='SET_GAS_BOMB', attribute="name", value=globaltext.SET_GAS_BOMB_NAME)
object.set_attribute(object='SET_GAS_BOMB', attribute="hint", value=globaltext.SET_GAS_BOMB_HINT)
object.set_attribute(object='SET_GAS_BOMB', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GAS_BOMB')
object.set_attribute(object='SET_GAS_BOMB', attribute="resource3d", value='RES3D_GAS_BOMB')
object.set_attribute(object='SET_GAS_BOMB', attribute="value", value=3.00)
object.set_attribute(object='SET_GAS_BOMB', attribute="weight", value=1.00)
object.set_attribute(object='SET_GAS_BOMB', attribute="stacking", value=10)
object.set_attribute(object='SET_GAS_BOMB', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_GAS_BOMB', attribute="maximale_feuerreichweite", value=50)
object.set_attribute(object='SET_GAS_BOMB', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_GAS_BOMB', attribute="feuergeschwindigkeit", value=40.00)
object.set_attribute(object='SET_GAS_BOMB', attribute="kampfwert_air", value=15.00)
object.set_attribute(object='SET_GAS_BOMB', attribute="kampfwert_armoured", value=100.00)
object.set_attribute(object='SET_GAS_BOMB', attribute="kampfwert_infantry", value=100.00)
object.set_attribute(object='SET_GAS_BOMB', attribute="munitionsarten", value=['SET_GAS_BOMB_PSEUDOAMMO'])
object.set_attribute(object='SET_GAS_BOMB', attribute="fire_animation", value=FPA_THROW_GRENADE)
object.set_attribute(object='SET_GAS_BOMB', attribute="weapon_type", value="wurf")
object.set_attribute(object='SET_GAS_BOMB', attribute="magazingroesse",             value=1.0)
object.set_attribute(object='SET_GAS_BOMB', attribute="hoerweite",                value=20.0)

## explosivwaffen
create_item_type(typeid='SET_C4_TIMEBASED')
object.set_attribute(object='SET_C4_TIMEBASED', attribute="name", value=globaltext.SET_C4_TIMEBASED_NAME)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="hint", value=globaltext.SET_C4_TIMEBASED_HINT)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_C4_TIMEBASED')
object.set_attribute(object='SET_C4_TIMEBASED', attribute="resource3d", value='RES3D_C4_TIMEBASED')
object.set_attribute(object='SET_C4_TIMEBASED', attribute="value", value=15.00)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="weight", value=0.1)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="stacking", value=1)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_C4_TIMEBASED', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="hoerweite",       value=50.0)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="salvenlaenge",           value=1)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="feuergeschwindigkeit",    value=0.0)
object.set_attribute(object='SET_C4_TIMEBASED', attribute="bomb_type",    value="timebased")

create_item_type(typeid='SET_ANTITANKMINE')
object.set_attribute(object='SET_ANTITANKMINE', attribute="name", value=globaltext.SET_ANTITANKMINE_NAME)
object.set_attribute(object='SET_ANTITANKMINE', attribute="hint", value=globaltext.SET_ANTITANKMINE_HINT)
object.set_attribute(object='SET_ANTITANKMINE', attribute="resourceui", value='RES_ITEM65X32_ANTITANKMINE')
object.set_attribute(object='SET_ANTITANKMINE', attribute="resource3d", value='RES3D_ANTITANKMINE')
object.set_attribute(object='SET_ANTITANKMINE', attribute="value", value=20.00)
object.set_attribute(object='SET_ANTITANKMINE', attribute="weight", value=2)
object.set_attribute(object='SET_ANTITANKMINE', attribute="stacking", value=1)
object.set_attribute(object='SET_ANTITANKMINE', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_ANTITANKMINE', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_ANTITANKMINE', attribute="hoerweite",       value=40.0)
object.set_attribute(object='SET_ANTITANKMINE', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_ANTITANKMINE', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_ANTITANKMINE', attribute="salvenlaenge",           value=1)
object.set_attribute(object='SET_ANTITANKMINE', attribute="feuergeschwindigkeit",    value=0.0)

create_item_type(typeid='SET_LANDMINE')
object.set_attribute(object='SET_LANDMINE', attribute="name", value=globaltext.SET_LANDMINE_NAME)
object.set_attribute(object='SET_LANDMINE', attribute="hint", value=globaltext.SET_LANDMINE_HINT)
object.set_attribute(object='SET_LANDMINE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_LANDMINE')
object.set_attribute(object='SET_LANDMINE', attribute="resource3d", value='RES3D_LANDMINE')
object.set_attribute(object='SET_LANDMINE', attribute="value", value=3.00)
object.set_attribute(object='SET_LANDMINE', attribute="weight", value=0.3)
object.set_attribute(object='SET_LANDMINE', attribute="stacking", value=3)
object.set_attribute(object='SET_LANDMINE', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_LANDMINE', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_LANDMINE', attribute="hoerweite",       value=40.0)
object.set_attribute(object='SET_LANDMINE', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_LANDMINE', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_LANDMINE', attribute="salvenlaenge",           value=1)
object.set_attribute(object='SET_LANDMINE', attribute="feuergeschwindigkeit",    value=0.0)

create_item_type(typeid='SET_C4_REMOTE_CONTROL')
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="name", value=globaltext.SET_C4_REMOTE_CONTROL_NAME)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="hint", value=globaltext.SET_C4_REMOTE_CONTROL_HINT)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_C4_REMOTE_CONTROL')
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="resource3d", value='RES3D_C4_REMOTE_CONTROL')
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="value", value=30.00)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="weight", value=0.25)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="stacking", value=1)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="hoerweite",       value=50.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="salvenlaenge",            value=1)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="feuergeschwindigkeit",     value=0.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="bomb_type",     value="remotecontrol")

create_item_type(typeid='SET_C4_TIMEBASED_W_NAILS')
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="name", value=globaltext.SET_C4_TIMEBASED_W_NAILS_NAME)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="hint", value=globaltext.SET_C4_TIMEBASED_W_NAILS_HINT)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_C4_TIMEBASED_W_NAILS')
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="resource3d", value='RES3D_C4_TIMEBASED_W_NAILS')
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="value", value=16.0)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="weight", value=0.3)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="stacking", value=1)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="hoerweite",       value=50.0)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="salvenlaenge",            value=1)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="feuergeschwindigkeit",     value=0.0)
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="bomb_type",     value="timebased")
object.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="item_combination",   value={
   "difficulty_assemble"   :   95,
   "combination_list"      : [ ['SET_SHORT_NAILS','SET_C4_TIMEBASED']]})

create_item_type(typeid='SET_C4_REMOTE_CONTROL_W_NAILS')
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="name", value=globaltext.SET_C4_REMOTE_CONTROL_W_NAILS_NAME)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="hint", value=globaltext.SET_C4_REMOTE_CONTROL_W_NAILS_HINT)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_C4_REMOTE_CONTROL_W_NAILS')
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="resource3d", value='RES3D_C4_REMOTE_CONTROL_W_NAILS')
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="value", value=31.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="weight", value=0.3)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="stacking", value=1)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="hoerweite",       value=50.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="salvenlaenge",            value=1)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="feuergeschwindigkeit",     value=0.0)
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="bomb_type",     value="remotecontrol")
object.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="item_combination",   value={
   "difficulty_assemble"   :   95,
   "combination_list"      : [ ['SET_SHORT_NAILS','SET_C4_REMOTE_CONTROL']]})

create_item_type(typeid='SET_FERTILIZER_EXPLOSIVE_TIME_BASED')
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="name", value=globaltext.SET_FERTILIZER_EXPLOSIVE_TIME_BASED_NAME)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="hint", value=globaltext.SET_FERTILIZER_EXPLOSIVE_TIME_BASED_HINT)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_FERTILIZER_EXPLOSIVE_TIME_BASED')
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="resource3d", value='RES3D_FERTILIZER_EXPLOSIVE_TIME_BASED')
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="value", value=27.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="weight", value=0.2)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="stacking", value=1)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="hoerweite",       value=50.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="salvenlaenge",            value=1)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="feuergeschwindigkeit",     value=0.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="bomb_type",     value="timebased")
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "combination_list"      : [ ['SET_AMMONIUM_NITRATE', 'SET_DIESEL', 'SET_LEAD_PIPE', 'SET_TIME_FUSE']]})

create_item_type(typeid='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL')
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="name", value=globaltext.SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL_NAME)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="hint", value=globaltext.SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL_HINT)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL')
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="resource3d", value='RES3D_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL')
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="value", value=37.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="weight", value=0.2)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="stacking", value=1)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="hoerweite",       value=50.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="maximale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="salvenlaenge",            value=1)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="feuergeschwindigkeit",     value=0.0)
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="bomb_type",     value="remotecontrol")
object.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="item_combination",   value={
   "difficulty_assemble"   :   COMBO_EVERYBODY,
   "combination_list"      : [ ['SET_AMMONIUM_NITRATE', 'SET_DIESEL', 'SET_LEAD_PIPE', 'SET_REMOTE_FUSE']]})

create_item_type(typeid='SET_DYNAMITE')
object.set_attribute(object='SET_DYNAMITE', attribute="name", value=globaltext.SET_DYNAMITE_NAME)
object.set_attribute(object='SET_DYNAMITE', attribute="hint", value=globaltext.SET_DYNAMITE_HINT)
object.set_attribute(object='SET_DYNAMITE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_DYNAMITE')
object.set_attribute(object='SET_DYNAMITE', attribute="resource3d", value='RES3D_EXPLOSIVE_DYNAMITE')
object.set_attribute(object='SET_DYNAMITE', attribute="value", value=10.00)
object.set_attribute(object='SET_DYNAMITE', attribute="weight", value=0.5)
object.set_attribute(object='SET_DYNAMITE', attribute="stacking", value=1)
object.set_attribute(object='SET_DYNAMITE', attribute="weapon_type", value="explosiv")
object.set_attribute(object='SET_DYNAMITE', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_DYNAMITE', attribute="hoerweite",       value=60.0)
object.set_attribute(object='SET_DYNAMITE', attribute="minimale_feuerreichweite", value=0.0)
object.set_attribute(object='SET_DYNAMITE', attribute="maximale_feuerreichweite", value=25.0)
object.set_attribute(object='SET_DYNAMITE', attribute="salvenlaenge",           value=1)
object.set_attribute(object='SET_DYNAMITE', attribute="feuergeschwindigkeit",    value=0.0)

#close combat weapons
create_weapon_type(typeid='SET_FIST')
object.set_attribute(object='SET_FIST', attribute="value", value=0.00)
object.set_attribute(object='SET_FIST', attribute="weight", value=0.0)
object.set_attribute(object='SET_FIST', attribute="stacking", value=1)
object.set_attribute(object='SET_FIST', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_FIST', attribute="hoerweite", value=1.0)
object.set_attribute(object='SET_FIST', attribute="schusspausenzeit", value=1.0)
object.set_attribute(object='SET_FIST', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_FIST', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_FIST', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_FIST', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_FIST', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_FIST', attribute="genauigkeit_bewegte_ziele", value=1.0)
object.set_attribute(object='SET_FIST', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_FIST', attribute="occupied_slots", value=["right_hand","left_hand"])
object.set_attribute(object='SET_FIST', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BOXING)
object.set_attribute(object='SET_FIST', attribute="munitionsarten", value=['SET_FIST_PSEUDOAMMO'])
object.set_attribute(object='SET_FIST', attribute="effects", value={"sound_shot"   : ["attack_fist_01","attack_fist_02","attack_fist_03","attack_fist_04"]})
object.set_attribute(object='SET_FIST', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_BRASS_KNUCKLES')
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="name", value=globaltext.SET_BRASS_KNUCKLES_NAME)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="hint", value=globaltext.SET_BRASS_KNUCKLES_HINT)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BRASS_KNUCKLES')
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="resource3d", value='RES3D_BRASS_KNUCKLES')
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="value", value=2.00)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="weight", value=0.20)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="stacking", value=1)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="hoerweite", value=1.0)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="schusspausenzeit", value=0.7)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="genauigkeit_bewegte_ziele",   value=1.0)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BOXING)
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="munitionsarten", value=['SET_BRASS_KNUCKLES_PSEUDOAMMO'])
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="effects", value={"sound_shot"   : ["attack_fist_01","attack_fist_02","attack_fist_03","attack_fist_04"]})
object.set_attribute(object='SET_BRASS_KNUCKLES', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_MANSLAYER')
object.set_attribute(object='SET_MANSLAYER', attribute="name", value=globaltext.SET_MANSLAYER_NAME)
object.set_attribute(object='SET_MANSLAYER', attribute="hint", value=globaltext.SET_MANSLAYER_HINT)
object.set_attribute(object='SET_MANSLAYER', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_MANSLAYER')
object.set_attribute(object='SET_MANSLAYER', attribute="resource3d", value='RES3D_MANSLAYER')
object.set_attribute(object='SET_MANSLAYER', attribute="value", value=3.00)
object.set_attribute(object='SET_MANSLAYER', attribute="weight", value=1.50)
object.set_attribute(object='SET_MANSLAYER', attribute="stacking", value=1)
object.set_attribute(object='SET_MANSLAYER', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_MANSLAYER', attribute="hoerweite", value=1.0)
object.set_attribute(object='SET_MANSLAYER', attribute="schusspausenzeit", value=0.8)
object.set_attribute(object='SET_MANSLAYER', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MANSLAYER', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_MANSLAYER', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_MANSLAYER', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_MANSLAYER', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_MANSLAYER', attribute="genauigkeit_bewegte_ziele", value=1.0)
object.set_attribute(object='SET_MANSLAYER', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_MANSLAYER', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_MANSLAYER', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_MANSLAYER', attribute="munitionsarten", value=['SET_MANSLAYER_PSEUDOAMMO'])
object.set_attribute(object='SET_MANSLAYER', attribute="effects", value={"sound_shot"   : ["attack_baseball_bat"]})
object.set_attribute(object='SET_MANSLAYER', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_RUSTY_IRON_ROD')
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="name", value=globaltext.SET_RUSTY_IRON_ROD_NAME)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="hint", value=globaltext.SET_RUSTY_IRON_ROD_HINT)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_RUSTY_IRON_ROD')
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="resource3d", value='RES3D_RUSTY_IRON_ROD')
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="value", value=1.00)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="weight", value=1.00)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="stacking", value=1)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="schusspausenzeit", value=3.0)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="munitionsarten", value=['SET_RUSTY_IRON_ROD_PSEUDOAMMO'])
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="effects", value={"sound_shot"   : ["attack_baseball_bat"]})
object.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_BASEBALL_BAT')
object.set_attribute(object='SET_BASEBALL_BAT', attribute="name", value=globaltext.SET_BASEBALL_BAT_NAME)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="hint", value=globaltext.SET_BASEBALL_BAT_HINT)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BASEBALL_BAT')
object.set_attribute(object='SET_BASEBALL_BAT', attribute="resource3d", value='RES3D_BASEBALL_BAT')
object.set_attribute(object='SET_BASEBALL_BAT', attribute="value", value=3.00)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="weight", value=2.50)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="stacking", value=1)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_BASEBALL_BAT', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="schusspausenzeit", value=2.0)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="genauigkeit_bewegte_ziele", value=0.7)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="genauigkeit", value=0.8)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_BASEBALL_BAT', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_BASEBALL_BAT', attribute="munitionsarten", value=['SET_BASEBALL_BAT_PSEUDOAMMO'])
object.set_attribute(object='SET_BASEBALL_BAT', attribute="effects", value={"sound_shot"   : ["attack_baseball_bat"]})
object.set_attribute(object='SET_BASEBALL_BAT', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_SPIKED_BASEBALL_BAT')
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="name", value=globaltext.SET_SPIKED_BASEBALL_BAT_NAME)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="hint", value=globaltext.SET_SPIKED_BASEBALL_BAT_HINT)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_SPIKED_BASEBALL_BAT')
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="resource3d", value='RES3D_SPIKED_BASEBALL_BAT')
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="value", value=10.0)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="weight", value=0.2)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="stacking", value=1)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="hoerweite", value=3.0)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="schusspausenzeit", value=2.2)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="genauigkeit_bewegte_ziele", value=0.75)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="genauigkeit", value=0.9)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="munitionsarten", value=['SET_SPIKED_BASEBALL_BAT_PSEUDOAMMO'])
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="effects", value={"sound_shot"   : ["attack_baseball_bat_nails"]})
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
object.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="item_combination",   value={
   "difficulty_assemble"   :   55,
   "combination_list"      : [ ['SET_BASEBALL_BAT','SET_LONG_NAILS']]})

create_weapon_type(typeid='SET_CLUB')
object.set_attribute(object='SET_CLUB', attribute="name", value=globaltext.SET_CLUB_NAME)
object.set_attribute(object='SET_CLUB', attribute="hint", value=globaltext.SET_CLUB_HINT)
object.set_attribute(object='SET_CLUB', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_CLUB')
object.set_attribute(object='SET_CLUB', attribute="resource3d", value='RES3D_CLUB')
object.set_attribute(object='SET_CLUB', attribute="value", value=4.00)
object.set_attribute(object='SET_CLUB', attribute="weight", value=3.00)
object.set_attribute(object='SET_CLUB', attribute="stacking", value=1)
object.set_attribute(object='SET_CLUB', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_CLUB', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_CLUB', attribute="schusspausenzeit", value=1.0)
object.set_attribute(object='SET_CLUB', attribute="genauigkeit_bewegte_ziele", value=0.8)
object.set_attribute(object='SET_CLUB', attribute="genauigkeit", value=0.9)
object.set_attribute(object='SET_CLUB', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_CLUB', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_CLUB', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_CLUB', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_CLUB', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_CLUB', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_CLUB', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_CLUB', attribute="munitionsarten", value=['SET_CLUB_PSEUDOAMMO'])
object.set_attribute(object='SET_CLUB', attribute="effects", value={"sound_shot"   : ["attack_baseball_bat"]})
object.set_attribute(object='SET_CLUB', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_KNIFE')
object.set_attribute(object='SET_KNIFE', attribute="name", value=globaltext.SET_KNIFE_NAME)
object.set_attribute(object='SET_KNIFE', attribute="hint", value=globaltext.SET_KNIFE_HINT)
object.set_attribute(object='SET_KNIFE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_KNIFE')
object.set_attribute(object='SET_KNIFE', attribute="resource3d", value='RES3D_KNIFE')
object.set_attribute(object='SET_KNIFE', attribute="value", value=7.00)
object.set_attribute(object='SET_KNIFE', attribute="weight", value=0.10)
object.set_attribute(object='SET_KNIFE', attribute="stacking", value=1)
object.set_attribute(object='SET_KNIFE', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_KNIFE', attribute="hoerweite", value=0.0)
object.set_attribute(object='SET_KNIFE', attribute="schusspausenzeit", value=1.5)
object.set_attribute(object='SET_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.6)
object.set_attribute(object='SET_KNIFE', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_KNIFE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_KNIFE', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_KNIFE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_KNIFE', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_KNIFE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_KNIFE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_KNIFE', attribute="munitionsarten", value=['SET_KNIFE_PSEUDOAMMO'])
object.set_attribute(object='SET_KNIFE', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_KNIFE', attribute="effects", value={"sound_shot"   : "attack_knife"})
object.set_attribute(object='SET_KNIFE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_BIG_KNIFE')
object.set_attribute(object='SET_BIG_KNIFE', attribute="name", value=globaltext.SET_BIG_KNIFE_NAME)
object.set_attribute(object='SET_BIG_KNIFE', attribute="hint", value=globaltext.SET_BIG_KNIFE_HINT)
object.set_attribute(object='SET_BIG_KNIFE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BIG_KNIFE')
object.set_attribute(object='SET_BIG_KNIFE', attribute="resource3d", value='RES3D_BIG_KNIFE')
object.set_attribute(object='SET_BIG_KNIFE', attribute="value", value=15.00)
object.set_attribute(object='SET_BIG_KNIFE', attribute="weight", value=0.20)
object.set_attribute(object='SET_BIG_KNIFE', attribute="stacking", value=1)
object.set_attribute(object='SET_BIG_KNIFE', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_BIG_KNIFE', attribute="hoerweite", value=1.0)
object.set_attribute(object='SET_BIG_KNIFE', attribute="schusspausenzeit", value=2.5)
object.set_attribute(object='SET_BIG_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.5)
object.set_attribute(object='SET_BIG_KNIFE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_BIG_KNIFE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BIG_KNIFE', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_BIG_KNIFE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BIG_KNIFE', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_BIG_KNIFE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_BIG_KNIFE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
object.set_attribute(object='SET_BIG_KNIFE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_THRUSTING)
object.set_attribute(object='SET_BIG_KNIFE', attribute="munitionsarten", value=['SET_BIG_KNIFE_PSEUDOAMMO'])
object.set_attribute(object='SET_BIG_KNIFE', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_BIG_KNIFE', attribute="effects", value={"sound_shot"   : "attack_knife"})

create_weapon_type(typeid='SET_MACHETE')
object.set_attribute(object='SET_MACHETE', attribute="name", value=globaltext.SET_MACHETE_NAME)
object.set_attribute(object='SET_MACHETE', attribute="hint", value=globaltext.SET_MACHETE_HINT)
object.set_attribute(object='SET_MACHETE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_MACHETE')
object.set_attribute(object='SET_MACHETE', attribute="resource3d", value='RES3D_MACHETE')
object.set_attribute(object='SET_MACHETE', attribute="value", value=20.00)
object.set_attribute(object='SET_MACHETE', attribute="weight", value=1.20)
object.set_attribute(object='SET_MACHETE', attribute="stacking", value=1)
object.set_attribute(object='SET_MACHETE', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_MACHETE', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_MACHETE', attribute="schusspausenzeit", value=2.0)
object.set_attribute(object='SET_MACHETE', attribute="genauigkeit_bewegte_ziele", value=0.5)
object.set_attribute(object='SET_MACHETE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_MACHETE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_MACHETE', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_MACHETE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_MACHETE', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_MACHETE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_MACHETE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_MACHETE', attribute="munitionsarten", value=['SET_MACHETE_PSEUDOAMMO'])
object.set_attribute(object='SET_MACHETE', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_MACHETE', attribute="effects", value={"sound_shot"   : "attack_knife"})
object.set_attribute(object='SET_MACHETE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_AXE')
object.set_attribute(object='SET_AXE', attribute="name", value=globaltext.SET_AXE_NAME)
object.set_attribute(object='SET_AXE', attribute="hint", value=globaltext.SET_AXE_HINT)
object.set_attribute(object='SET_AXE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AXE')
object.set_attribute(object='SET_AXE', attribute="resource3d", value='RES3D_AXE')
object.set_attribute(object='SET_AXE', attribute="value", value=10.00)
object.set_attribute(object='SET_AXE', attribute="weight", value=4.00)
object.set_attribute(object='SET_AXE', attribute="stacking", value=1)
object.set_attribute(object='SET_AXE', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_AXE', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_AXE', attribute="schusspausenzeit", value=4.0)
object.set_attribute(object='SET_AXE', attribute="genauigkeit_bewegte_ziele", value=0.5)
object.set_attribute(object='SET_AXE', attribute="genauigkeit", value=0.5)
object.set_attribute(object='SET_AXE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_AXE', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_AXE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_AXE', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_AXE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_AXE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_AXE', attribute="munitionsarten", value=['SET_AXE_PSEUDOAMMO'])
object.set_attribute(object='SET_AXE', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_AXE', attribute="effects", value={"sound_shot"   : "attack_baseball_bat"})
object.set_attribute(object='SET_AXE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_CHAIN_SAW')
object.set_attribute(object='SET_CHAIN_SAW', attribute="name", value=globaltext.SET_CHAIN_SAW_NAME)
object.set_attribute(object='SET_CHAIN_SAW', attribute="hint", value=globaltext.SET_CHAIN_SAW_HINT)
object.set_attribute(object='SET_CHAIN_SAW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CHAIN_SAW')
object.set_attribute(object='SET_CHAIN_SAW', attribute="resource3d", value='RES3D_CHAIN_SAW')
object.set_attribute(object='SET_CHAIN_SAW', attribute="value", value=25.00)
object.set_attribute(object='SET_CHAIN_SAW', attribute="weight", value=6.00)
object.set_attribute(object='SET_CHAIN_SAW', attribute="stacking", value=1)
object.set_attribute(object='SET_CHAIN_SAW', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_CHAIN_SAW', attribute="hoerweite", value=20.0)
object.set_attribute(object='SET_CHAIN_SAW', attribute="schusspausenzeit", value=5.0)
object.set_attribute(object='SET_CHAIN_SAW', attribute="genauigkeit_bewegte_ziele", value=0.4)
object.set_attribute(object='SET_CHAIN_SAW', attribute="genauigkeit", value=0.5)
object.set_attribute(object='SET_CHAIN_SAW', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_CHAIN_SAW', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_CHAIN_SAW', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_CHAIN_SAW', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_CHAIN_SAW', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_CHAIN_SAW', attribute="fire_animation", value=FPA_CLOSE_COMBAT_CHAIN_SAW)
object.set_attribute(object='SET_CHAIN_SAW', attribute="munitionsarten", value=['SET_CHAIN_SAW_PSEUDOAMMO'])
object.set_attribute(object='SET_CHAIN_SAW', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_CHAIN_SAW', attribute="effects", value={"sound_shot"   : "attack_chainsaw"})
object.set_attribute(object='SET_CHAIN_SAW', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_KATANA')
object.set_attribute(object='SET_KATANA', attribute="name", value=globaltext.SET_KATANA_NAME)
object.set_attribute(object='SET_KATANA', attribute="hint", value=globaltext.SET_KATANA_HINT)
object.set_attribute(object='SET_KATANA', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_KATANA')
object.set_attribute(object='SET_KATANA', attribute="resource3d", value='RES3D_KATANA')
object.set_attribute(object='SET_KATANA', attribute="value", value=35.00)
object.set_attribute(object='SET_KATANA', attribute="weight", value=0.10)
object.set_attribute(object='SET_KATANA', attribute="stacking", value=1)
object.set_attribute(object='SET_KATANA', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_KATANA', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_KATANA', attribute="schusspausenzeit", value=2.5)
object.set_attribute(object='SET_KATANA', attribute="genauigkeit_bewegte_ziele",   value=0.7)
object.set_attribute(object='SET_KATANA', attribute="genauigkeit", value=0.95)
object.set_attribute(object='SET_KATANA', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_KATANA', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_KATANA', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_KATANA', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_KATANA', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_KATANA', attribute="fire_animation", value=FPA_CLOSE_COMBAT_THRUSTING)
object.set_attribute(object='SET_KATANA', attribute="munitionsarten", value=['SET_KATANA_PSEUDOAMMO'])
object.set_attribute(object='SET_KATANA', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_KATANA', attribute="effects", value={"sound_shot"   : "attack_knife"})
object.set_attribute(object='SET_KATANA', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_BROKEN_OFF_BOTTLE')
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="name", value=globaltext.SET_BROKEN_OFF_BOTTLE_NAME)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="hint", value=globaltext.SET_BROKEN_OFF_BOTTLE_HINT)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BROKEN_OFF_BOTTLE')
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="resource3d", value='RES3D_BROKEN_OFF_BOTTLE')
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="value", value=0.00)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="weight", value=0.10)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="stacking", value=1)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="schusspausenzeit", value=1.6)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="genauigkeit_bewegte_ziele",   value=0.6)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="genauigkeit", value=0.6)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="munitionsarten", value=['SET_BROKEN_OFF_BOTTLE_PSEUDOAMMO'])
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="magazingroesse",   value=1.0)
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="effects", value={"sound_shot"   : "attack_knife"})
object.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_GIANT_KNIFE')
object.set_attribute(object='SET_GIANT_KNIFE', attribute="name", value=globaltext.SET_GIANT_KNIFE_NAME)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="hint", value=globaltext.SET_GIANT_KNIFE_HINT)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GIANT_KNIFE')
object.set_attribute(object='SET_GIANT_KNIFE', attribute="resource3d", value='RES3D_GIANT_KNIFE')
object.set_attribute(object='SET_GIANT_KNIFE', attribute="value", value=17.00)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="weight", value=0.10)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="stacking", value=1)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_GIANT_KNIFE', attribute="hoerweite", value=2.0)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="schusspausenzeit", value=2.1)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.8)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="genauigkeit", value=0.9)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="maximale_feuerreichweite",   value=2)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="feuergeschwindigkeit",   value=0.0)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_GIANT_KNIFE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="munitionsarten", value=['SET_GIANT_KNIFE_PSEUDOAMMO'])
object.set_attribute(object='SET_GIANT_KNIFE', attribute="magazingroesse", value=1.0)
object.set_attribute(object='SET_GIANT_KNIFE', attribute="effects", value={"sound_shot"   : "attack_knife"})
object.set_attribute(object='SET_GIANT_KNIFE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_ELECTROSHOCKER')
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="name", value=globaltext.SET_ELECTROSHOCKER_NAME)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="hint", value=globaltext.SET_ELECTROSHOCKER_HINT)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_ELECTROSHOCKER')
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="resource3d", value='RES3D_ELECTROSHOCKER')
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="value", value=17.0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="weight", value=0.2)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="stacking", value=1)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="weapon_type", value="nahkampf")
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="hoerweite", value=1.0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="schusspausenzeit", value=2.0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="genauigkeit_bewegte_ziele",   value=0.4)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="genauigkeit", value=1.0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="maximale_feuerreichweite", value=2)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="feuergeschwindigkeit", value=0.0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="fire_animation", value=FPA_CLOSE_COMBAT_THRUSTING)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="munitionsarten", value=['SET_ELECTROSHOCKER_PSEUDOAMMO'])
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="magazingroesse",value=1.0)
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="effects", value={"sound_shot"   : "attack_electro_shocker"})
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
object.set_attribute(object='SET_ELECTROSHOCKER', attribute="item_combination",   value={
   "difficulty_assemble"   :   95,
   "combination_list"      : [ ['SET_STEEL_TUBE','SET_BATTERY','SET_TRANSFORMER','SET_COPPER_WIRE','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_WHEELTANK_CANON')
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="name", value=globaltext.SET_WALTER_PPK_NAME)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="hint", value=globaltext.SET_WALTER_PPK_HINT)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="resourceui", value='RES_ITEM65X32_WEAPON_WALTER_PPK')
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="resource3d", value='RES3D_WALTER_PPK')
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="value", value=3.00)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="weight", value=0.57)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="stacking", value=1)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="minimale_feuerreichweite", value=0)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="maximale_feuerreichweite", value=13)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="salvenlaenge", value=1)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="feuergeschwindigkeit", value=50.00)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="genauigkeit", value=0.7)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="kampfwert_air", value=0.00)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="kampfwert_armoured", value=150.00)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="kampfwert_infantry", value=150.00)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="munitionsarten", value=[])
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="weapon_type", value="leicht")
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="magazingroesse",             value=7.0)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="hoerweite",                value=40.0)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="schusspausenzeit",             value=0.8)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="genauigkeit_bewegte_ziele",      value=0.5)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="blockadewahrscheinlichkeit",   value=25.0)
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="occupied_slots", value=["right_hand"])
object.set_attribute(object='SET_WHEELTANK_CANON', attribute="effects", value={
    "sound_shot"   : "shot_walther_ppk",
    "sound_unload"   : "pistol_discharge",
    "sound_gunjam"   : "pistol_gunjam",
    "sound_reload"   : "pistol_charge",
    "flash_type"   : 2,
    "flash_size"   : 0.5,
    "stream_type"   : 1,
    "stream_size"   : 0.6,
    "fade_out"      : 50})

def generate_weapon_types():
   count = 0
   for tmp_item in system.get_item_list():
      if object.has_attribute(tmp_item,"item_type"):
         if object.get_attribute(tmp_item, "item_type")=="weapon":
            if object.has_attribute(tmp_item,"munitionsarten"):
               sup_munition = object.get_attribute(tmp_item, "munitionsarten")
               for mun_type in sup_munition:
                  if object.has_attribute(mun_type,"weapon_types"):
                     weapon_types = []
                     weapon_types = object.get_attribute(mun_type, "weapon_types")
                     weapon_types.append(tmp_item)
                     object.set_attribute(mun_type,"weapon_types",weapon_types)
                     
generate_weapon_types()

