# -*- coding: utf-8 -*-
from globals import *
import globals
import character
import object
import globaltext
import system
import character_py
import comments
import skill_tables
import grids
import string
import math
import music
import global_character
import global_item
import random
import sounds
import dialog

__doc__ = """This module contains all handlers for events related to characters. All these
handler functions implement the default behaviour of characters.

nearly all functions here can be overloaded by the zone script. if you do that it is your
responsibility to ensure that the overloading function implements the necessary behavior or calls
the default handler."""

def get_vehicle_entry_exit_animation( vehicle_type , seat, type, character ):
	attribute = None
	if type=="entry":
		attribute = "get_in_animations"
	elif type=="exit":
		attribute = "get_out_animations"
	else:
		raise ValueError, "unknown animation type" 
	if object.has_attribute( vehicle_type, attribute):
		get_in_out_animations = object.get_attribute( vehicle_type, attribute)
		if seat in get_in_out_animations:
			if character:
				return get_in_out_animations[seat][0]
			else:
				return get_in_out_animations[seat][1]
	return ""

def get_random_name( gender ):
	import random
	import globaltext
	resource_id = None
	if gender=="male":
		resource_id = "globaltext.NAME_AE_MALE_"+str(random.randint(1,20))
	elif gender == "female":
		resource_id = "globaltext.NAME_AE_FEMALE_"+str(random.randint(1,20))
	else: raise ValueError, "unknown gender"

	if resource_id:
		name = eval(resource_id)
		if name:
			return name
		else: raise ValueError
	else: raise ValueError

	return None

def create_default_talents( id, skill ):
	attr = skill+"_"+"talents"
	if not object.has_attribute( id , attr ):
		object.set_attribute( id , attr, [] )

	while (get_talent_skills(id, skill, False)):
		talents = object.get_attribute( id , attr  )
		available = get_available_talents(id, skill)
		if (len(available)):
			talents.append(available[0])
			object.set_attribute( id , attr ,talents )

def get_available_talents( id , skill ):
	talents = all_talents[skill]
	attr = skill+"_"+"talents"
	if not object.has_attribute( id , attr ):
		object.set_attribute( id , attr, [] )
	char_talents = object.get_attribute( id , attr )
	available_talents = filter(lambda source: not source in char_talents, talents)
	return available_talents

def get_talent_skills( id, skill, ignore_existing_talents ):
	value = object.get_attribute( id , skill )
	attr = skill+"_"+"talents"
	if not object.has_attribute( id , attr ):
		object.set_attribute( id , attr, [] )
	talents = object.get_attribute( id , attr )
	count = 0
	if (value >=75 and (len(talents) < 1 or ignore_existing_talents)): count+=1 
	if (value >=85 and (len(talents) < 2 or ignore_existing_talents)): count+=1
	if (value >=99 and (len(talents) < 3 or ignore_existing_talents)): count+=1
	return count

def get_hint_text( id ):
	data = None
	if object.get_attribute(id, "type")=="equipment":
		if object.has_attribute(id, "item_type"):
			if object.get_attribute(id, "item_type")=="weapon":
				weapon_type = object.get_attribute(id, "weapon_type")
				data = []
				# name
				data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME,object.get_attribute(id, "name")])

				# nick name
				nickname = globaltext.MISSION_EXTENDED_HINT_WEAPON_NICK_NAME_VALUE_NONE
				if object.has_attribute(id, "nickname"):
					nickname = object.get_attribute(id, "nickname")
				data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_NICK_NAME,nickname])

				# munition
				if weapon_type!="nahkampf":  # != close combat
					sup_munition = object.get_attribute(id, "munitionsarten")
					count = 0
					for mun_type in sup_munition:
						title = ""
						value = object.get_attribute(mun_type, "name")
						if count==0:
							title = globaltext.MISSION_EXTENDED_HINT_WEAPON_MUNITION
						#data.append([title,value])
						count+=1
						
				# bore and stack_size
				
					
					
				# weight
				weight = "%.2f kg" % object.get_attribute(id, "weight") 
				#data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_WEIGHT,weight])
				
				# weapon class
				
				# kills
				
				# bonus
				if (weapon_type=="explosive"):
					print hallo
				
				if (weapon_type=="nahkampf" or weapon_type=="explosiv" or weapon_type=="wurf"):
					# damage
					munition = object.get_attribute(id, "act_ammo_type")
					## todo: hotfix wiegels ausbauen
					if munition != '':
						damage_min = object.get_attribute(munition, "schaden_organisch_min")
						damage_max = object.get_attribute(munition, "schaden_organisch_max")
						data.append([globaltext.MISSION_EXTENDED_HINT_DAMAGE,str(damage_min) + """ / """ +  str(damage_max)])	
					# fire range
					if (weapon_type=="wurf" or weapon_type=="explosiv"):
						if object.has_attribute(id,"maximale_feuerreichweite"):
							f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_0
							f_range =  object.get_attribute(id, "maximale_feuerreichweite")
							if (f_range > 17):
								f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_1
							if (f_range > 33):
								f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_2
							if (f_range > 49):
								f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_3
						
						tmp_value=f_range_id + " (" + str(f_range) + ")" 
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE,tmp_value])

					if (weapon_type=="explosiv"):
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_0,globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_1])
					if (weapon_type=="wurf"):
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_0,globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_2])
					if (weapon_type=="nahkampf"):
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_0,globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_3])
						
				else:
					if (weapon_type=="leicht"):
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_0,globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_4])
					if (weapon_type=="schwer"):
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_0,globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_5])
					if (weapon_type=="sniper"):
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_0,globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME_6])
						
					if object.has_attribute(id,"munitionsarten"): # type de muntition pour l'arme
						stack_size = 0
						bore = ""
						sup_munition = 0
						if object.has_attribute(id,"munitionsarten"):
							sup_munition = object.get_attribute(id, "munitionsarten")
						if object.has_attribute(id,"magazingroesse"):
							stack_size = object.get_attribute(id, "magazingroesse") # nb balles chargeur
						for mun_type in sup_munition:
							if object.has_attribute(mun_type,"kaliber"):
								bore = object.get_attribute(mun_type, "kaliber")
						if bore != "" and stack_size!= 0:
							tmp_data_value = str(stack_size)  + " x " +  bore	
							data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_STACK_SIZE_BORE,tmp_data_value])
					
					
					# fire range
					if object.has_attribute(id,"maximale_feuerreichweite"):
						f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_0
						f_range =  object.get_attribute(id, "maximale_feuerreichweite") 
						if (f_range > 17):
							f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_1
						if (f_range > 33):
							f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_2
						if (f_range > 49):
							f_range_id = globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE_3
						
						tmp_value=f_range_id + " (" + str(f_range) + ")" 
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_RANGE,tmp_value])
				
					# salven
					if object.has_attribute(id,"salvenlaenge"):
						f_fusilade =  object.get_attribute(id, "salvenlaenge") 
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_FUSILLADE,str(f_fusilade)])
					
					# fire speed
					if object.has_attribute(id,"feuergeschwindigkeit"):
						f_velocity =  object.get_attribute(id, "feuergeschwindigkeit") 
						if (f_velocity > 0):
							data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_SPEED,str(f_velocity)])
						else:
							data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_FIRE_SPEED,"-"])
					# quality
					quality = "%.2f %%" % object.get_attribute(id, "quality") 
					#data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_QUALITY,quality])
				
					# weapon_accustom_skill_bonus
					text_id_accustom = globaltext.MISSION_EXTENDED_HINT_WEAPON_ACCUSTOM_0
					max_accustom = 20.0
					weapon_accustom = 0.0
					weapon_in_inventory = False
					for pc in system.get_pcs():
						inventory = object.get_inventory_id_list(pc)
						if len(inventory):
							for item in inventory:
								if len(item[0]):
									if id == item: 
										#if object.has_attribute(pc,"weapon_accustom_skill_bonus"):
										#	weapon_accustom = object.get_attribute(pc, "weapon_accustom_skill_bonus")
										weapon_in_inventory = True
										typeid = object.get_attribute(id,"typeid")
                                                                                id_kills = 0
                                                                                type_kills = 0
                                                                                if object.has_attribute(pc, "weapon_type_history"):
                                                                                        weapon_type_history = object.get_attribute(pc, "weapon_type_history")
                                                                                        if typeid in weapon_type_history:
                                                                                                type_kills = weapon_type_history[typeid]
                                                                                                type_kills = type_kills[0] + type_kills[1]
										if object.has_attribute(pc, "weapon_id_history"):
                                                                                        weapon_id_history = object.get_attribute(pc, "weapon_id_history")
                                                                                        if id in weapon_id_history:
                                                                                                id_kills = weapon_id_history[id]
                                                                                                id_kills = id_kills[0] + id_kills[1]
										weapon_accustom = skill_tables.weapon_accustoming(id_kills, type_kills)
					accustom_percent =  (weapon_accustom / max_accustom) * 100
					if accustom_percent > 24: 
						text_id_accustom  = globaltext.MISSION_EXTENDED_HINT_WEAPON_ACCUSTOM_1
					if accustom_percent > 49: 
						text_id_accustom  = globaltext.MISSION_EXTENDED_HINT_WEAPON_ACCUSTOM_4
					if accustom_percent > 74: 
						text_id_accustom  = globaltext.MISSION_EXTENDED_HINT_WEAPON_ACCUSTOM_5
					if accustom_percent > 99: 
						text_id_accustom  = globaltext.MISSION_EXTENDED_HINT_WEAPON_ACCUSTOM_6
					if weapon_in_inventory:
						data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_ACCUSTOM,text_id_accustom])
			
			elif object.get_attribute(id, "item_type")=="ammo":		
				data = []
				# name
				data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME,object.get_attribute(id, "name")])
				
				# ammo count
				if object.has_attribute(id,"act_ammo_count"):
					act_ammo_count = object.get_attribute(id, "act_ammo_count")
					max_count = object.get_attribute(id, "schuss")
					data.append([globaltext.MISSION_EXTENDED_HINT_AMMO_COUNT,str(act_ammo_count) + """ / """ +  str(max_count)])	
				
				
				# damage
				if object.has_attribute(id,"schaden_organisch_min") and object.has_attribute(id,"schaden_organisch_max"):
					damage_min = object.get_attribute(id, "schaden_organisch_min")
					damage_max = object.get_attribute(id, "schaden_organisch_max")
					data.append([globaltext.MISSION_EXTENDED_HINT_DAMAGE,str(damage_min) + """ / """ +  str(damage_max)])
				#weapons
				if object.has_attribute(id,"weapon_types"):
					weapons = object.get_attribute(id, "weapon_types")
					count = 0
					
					for weapon_type in weapons:
						has_attachement = False
						title = ""
						value = object.get_attribute(weapon_type, "name")
						
						if (object.has_attribute(weapon_type,"attachments")): 
							attachments = []
							attachments = object.get_attribute(weapon_type, "attachments")	
							if "SET_SILENCER" in attachments or  "SET_LASERPOINTER" in attachments:
								has_attachement = True 
						if not has_attachement:
							if count==0:
								title = globaltext.MISSION_EXTENDED_HINT_AMMO_WEAPONS
							data.append([title,value])
							count+=1
						
				
		else:
			data = []
			# name
			data.append([globaltext.MISSION_EXTENDED_HINT_WEAPON_TYPE_NAME,object.get_attribute(id, "name")])
			
			# armor
			if object.has_attribute(id,"armor"):
				armor = object.get_attribute(id, "armor")
				data.append([globaltext.MISSION_EXTENDED_HINT_ITEMS_ARMOR,str(armor)])
			
			# slots
			elif object.has_attribute(id,"occupied_slots") and not (object.has_attribute(id,"water_repository")):
				equiped=False
				item_slots = object.get_attribute(id, "occupied_slots")
				for pc in system.get_pcs():
					if object.has_attribute(pc, "slots"):
						slots = object.get_attribute(pc, "slots")
						for slot in slots:
							if slots[slot] == id:
								equiped = True
				if (equiped):
					data.append([globaltext.MISSION_EXTENDED_HINT_ITEMS_EQUIP,globaltext.MISSION_EXTENDED_HINT_ITEMS_EQUIP_1])
				else:
					data.append([globaltext.MISSION_EXTENDED_HINT_ITEMS_EQUIP,globaltext.MISSION_EXTENDED_HINT_ITEMS_EQUIP_0])
				
			# water_amount
			if object.has_attribute(id,"water_repository") and object.has_attribute(id,"charge"):
				charge = object.get_attribute(id, "charge")
				data.append([globaltext.MISSION_EXTENDED_HINT_ITEMS_WATER_AMOUNT,str(charge)])
			
			if object.get_attribute(id, "typeid") == "SET_MULTI_MEDIPACK":
				charge = object.get_attribute(id, "charge")
				data.append([globaltext.MISSION_EXTENDED_HINT_ITEMS_MULTI_MEDIPACK,str(charge)])
			
			# le_recovery
			if object.has_attribute(id,"le_recovery"):
				le_recovery = object.get_attribute(id, "le_recovery")
				data.append([globaltext.MISSION_EXTENDED_HINT_ITEMS_LE_RECOVERY,str(le_recovery)])
							
	elif object.get_attribute(id, "type")=="character":
		data = []	
	
		act_hp = object.get_attribute(id, "hitpoints")
		max_hp = object.get_attribute(id, "maxhitpoints")	
		percent = act_hp/max_hp * 100
		text_id_status = globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS_0
		if percent > 33: text_id_status  = globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS_1
		if percent > 66: text_id_status  = globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS_2
		if percent > 99: text_id_status  = globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS_3
		if object.is_unconscious(id): text_id_status  = globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS_4 
		if object.is_destroyed(id): text_id_status  = globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS_6
		
		
		# PC
		if id in system.get_pcs():
			#act_hp = object.get_attribute(id, "hitpoints")
			#max_hp = object.get_attribute(id, "maxhitpoints")
			le = act_hp / max_hp
			# name
			data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_NAME,object.get_attribute(id, "name")])
			# LE
			data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_LE,act_hp])
			# status
			data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS, text_id_status])
		# NPC
		else:
			#Foe
			if (object.has_attribute(id, "foes") and object.get_attribute(id, "foes") == ["UISPIELER"]):
				level_average = 0.0
				count = 0
				level_percent = 0.0
				id_sel=0
				pcs = system.get_selected_pcs()
				if not len(pcs): pcs = system.get_pcs()
				for id_sel in pcs:
					tmp_level = 0
					if object.has_attribute(id_sel,"level"):
						tmp_level = object.get_attribute(id_sel,"level")
					if tmp_level < 1:
						tmp_level = 1
					level_average = level_average + tmp_level
					count = count + 1
				if count: level_average = level_average / count
				level_foe = object.get_attribute(id,"level")
				if (level_foe < 1):
					level_foe = 1
				if level_average: level_percent =  (level_foe * 100.0) / level_average 
				
				text_id_consider = globaltext.MISSION_EXTENDED_HINT_CHARACTER_CONSIDER_0
				if level_percent > 50: text_id_consider = globaltext.MISSION_EXTENDED_HINT_CHARACTER_CONSIDER_1
				if level_percent > 75: text_id_consider = globaltext.MISSION_EXTENDED_HINT_CHARACTER_CONSIDER_2
				if level_percent > 125: text_id_consider = globaltext.MISSION_EXTENDED_HINT_CHARACTER_CONSIDER_3
				if level_percent > 150: text_id_consider = globaltext.MISSION_EXTENDED_HINT_CHARACTER_CONSIDER_4
				
				# name
				data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_NAME,object.get_attribute(id, "name")])
				# consider
				data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_CONSIDER,text_id_consider])
				# status
				data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS, text_id_status])
				
			#Friendly
			else:
				# name
				data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_NAME,object.get_attribute(id, "name")])
				# status
				data.append([globaltext.MISSION_EXTENDED_HINT_CHARACTER_STATUS, text_id_status])
				

	return data

def get_attribute_skill_text( id, attribute, value ):
	"""returns UI display strings for the attribute&skill effects"""
	return skill_tables.get_attribute_skill_text(id, attribute, value )

def get_trade_text( trader_id, character_id, value ):
	"""returns UI display strings for the charisma trading effects"""
	return skill_tables.get_trade_text( trader_id, character_id, value )

def get_load_text( character_id ):
	"""called if an update of the load display in the character detail panel is forced

character_id - id of the character"""
	load = float(character.get_load( char=character_id ))
	strength = object.get_attribute( object=character_id, attribute="strength" )

	if strength>0:
		relload = load / skill_tables.strength_max_load(strength)
	else:
		relload = 0

	text = "%.0f %s / %.0f %s (%.0f%%)" % (load,
						globaltext.MEASUREMENT_WEIGHT,
						skill_tables.strength_max_load(strength),
						globaltext.MEASUREMENT_WEIGHT,
						relload * 100)
	return text

def on_attribute_change( object_id, attribute_name, new_value, old_value ):
	"""called if an attribute of an object changes

object_id      - id of the object
attribute_name - name of attribute
new_value      - new attribute value
old_value      - old attribute value"""
	if attribute_name in skill_tables.attributes or attribute_name in skill_tables.skills:
		if type(new_value) != int:
			raise ValueError, "char '%s': value for attribute '%s' must be <type 'int'> but it is '%s'" % (object_id, attribute_name, type(new_value))

	if attribute_name=="constitution":
		if object.has_attribute( object_id, "char_creation"):
			value = object.get_attribute( object_id, "char_creation")
			if value:
				calc_life_energy_start( object_id, new_value, old_value)
	elif attribute_name=="strength":
		# update speed
		update_speed( object_id )
	elif attribute_name=="agility":
		calc_armor_value( object_id )
		# update speed
		update_speed( object_id )
	elif attribute_name=="trader":
		object.set_immortal_state( object_id, new_value )
		if new_value:
			object.set_inventory_slot_count(object_id, 300)
	elif attribute_name=="experience":
		calc_level( object_id , new_value, old_value )
		system.update_ui()
	elif attribute_name=="level":
		if (object_id in system.get_pcs() and
			old_value>0):
			sounds.play_2d_sound("level_up")
			system.update_ui()
			calc_life_energy( object_id , new_value, old_value )
		elif object_id in system.get_npcs():
			calc_npc_attribute_skills( object_id , new_value, old_value )
			calc_npc_le( object_id , new_value, old_value )
		elif object_id in system.get_animals():
			calc_npc_le( object_id , new_value, old_value )
	elif attribute_name=="body_feature":
		if object_id=="ALTER_EGO":
			calc_body_feature( object_id, new_value, old_value )
	elif attribute_name=="experience_of_life":
		if object_id=="ALTER_EGO":
			calc_experience_of_life( object_id, new_value, old_value )
	elif attribute_name=="name":
		if object_id in system.get_pcs():
			system.update_ui()
	elif attribute_name=="generic_item":
		if object.has_attribute( object_id, "item_type" ):
			object_type = object.get_attribute( object_id, "item_type" )
			if object_type == "weapon":
				# if a weapon is set as a quest item
				# then its quality is set to 100%
				if new_value == False:
					object.set_attribute( object_id, "quality", 100 )
	elif attribute_name=="bodymode":
		calc_perception_values(object_id)
		update_speed(object_id)
		if has_talent(object_id, "sniper_weapons", "camouflage"):
			if character.get_body_mode(object_id)=="LIE":
				system.add_text(globaltext.TALENT_SNIPER_CAMOUFLAGE_ON % {"char": object.get_attribute(object_id, "name")})
			else:
				system.add_text(globaltext.TALENT_SNIPER_CAMOUFLAGE_OFF % {"char": object.get_attribute(object_id, "name")})
		if has_talent(object_id, "sneak", "camouflage"):
			if character.get_body_mode(object_id)=="LIE" or character.get_body_mode(object_id)=="KNEEL":
				system.add_text(globaltext.TALENT_SNEAK_CAMOUFLAGE_ON % {"char": object.get_attribute(object_id, "name")})
			else:
				system.add_text(globaltext.TALENT_SNEAK_CAMOUFLAGE_OFF % {"char": object.get_attribute(object_id, "name")})
	elif attribute_name=="sneak":
		calc_perception_values(object_id)
	elif attribute_name.endswith("_talents"):
		helper_update_talent_effects( object_id )

def on_equipment_add( character_id, equipment_id ):
	"""called if a item is added to the character inventory

character_id - id of the character
equipment_id - id of the item"""

	# update speed and allowed moves
	update_speed( character_id )
	comments.on_equipment_add( character_id, equipment_id )

def on_equipment_remove( character_id, equipment_id ):
	"""called if an item is removed from the character inventory

character_id - id of the character
equipment_id - id of the item"""

	# update speed and allowed moves
	update_speed( character_id )

def can_climb( character_id, object_id ):
	"""returns true when the character can climb the object

character_id - id of the character
object       - id of the object to climb"""
	return True
def can_tune( character_id, object_id ):
	"""returns true when the character can tune the object

character_id - id of the character
object       - id of the car to tune"""
	if not has_talent( character_id, "technic", "tuning" ):
		return False
	if object.has_attribute(object_id, "tuning"):
		if object.get_attribute(object_id, "tuning"):
			return False
	if object.has_attribute(object_id, "type"):
		type = object.get_attribute(object_id, "type")
		if type=="vehicle":
			return True
	return False
def tune( character_id, object_id ):
	"""tune the car

character_id - id of the character
object       - id of the car to tune"""
	character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN" )
	object.set_attribute(object_id,"tuning",True)

def do_throw_weapon_fx(pShooter,pWeapon,pTarget,fTargetX,fTargetY,fTargetZ):
	#object.set_attribute(target_id, "hitpoints", hitpoints)
	animation_type = object.get_attribute(pWeapon, "fire_animation")
	#print animation_type
	if animation_type in [FPA_THROW_GRENADE,FPA_SHOULDER_BASED]:
		#print "throw_grenade "+fTargetX +" "+fTargetY +" "+fTargetZ +" "
		fx_object_id = random.choice([fx_explosion])
		system.start_effect( 
			startx=fTargetX,starty=fTargetY,startz=fTargetZ,
			dirx=0,diry=0,dirz=1,
			parameter=fx_object_id)
		sounds.play_3d_sound( "grenade_explo_frag", fTargetX, fTargetY, fTargetZ )
		radius=amount_of_piercing=damage_armor=value_structure=value_organic=0.0
		if object.has_attribute(pWeapon, "munitionsarten"):
			ammo = object.get_attribute(pWeapon, "munitionsarten")[0]
			if object.has_attribute(ammo, "schaden_organisch_max"):
				value_organic = object.get_attribute(ammo, "schaden_organisch_max")
			if object.has_attribute(ammo, "schaden_struktur_max"):
				value_structure = object.get_attribute(ammo, "schaden_struktur_max")
			if object.has_attribute(ammo, "durchschlag"):
				amount_of_piercing = object.get_attribute(ammo, "durchschlag")
			if object.has_attribute(ammo, "wirkungsbereich"):
				radius = object.get_attribute(ammo, "wirkungsbereich")
		system.hit_objects_in_ambit( pShooter, fTargetX, fTargetY, fTargetZ, radius, amount_of_piercing, 0, value_structure, value_organic )

	if animation_type in [FPA_THROW_KNIFE]:
		#print "throw_grenade "+fTargetX +" "+fTargetY +" "+fTargetZ +" "
		sounds.play_3d_sound( "bullet_hit_flash_01", fTargetX, fTargetY, fTargetZ )
		if object.has_attribute(pWeapon, "munitionsarten"):
			ammo = object.get_attribute(pWeapon, "munitionsarten")[0]
		if pTarget != "":
			if(object.has_attribute(pTarget,"type")): #jan: early out if target is no char
				if object.get_attribute(pTarget, "type")=="character":
					object.do_hit_via_weapon( pTarget, pShooter, pWeapon, ammo )



def can_stronger_armor( character_id, object_id ):
	"""returns true when the character can increse armor value of an armor

character_id - id of the character
object       - id of the car to tune"""
	if not has_talent( character_id, "technic", "stronger_armor" ):
		return False
	if not object.has_attribute(object_id, "on_stronger_armor"):
		if object.has_attribute( object_id, "typeid" ):
			object_type = object.get_attribute( object_id, "typeid" )
			if object_type in ["SET_LEATHER_CLOTHES","SET_PLATE_ARMOR","SET_CHAIN_MAIL"]:
				return True
	return False
	
def on_stronger_armor( character_id, object_id ):
	"""increse strength of armor by 1 point

character_id - id of the character
object       - id of the armor"""
	#character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN" )
	if object.has_attribute(object_id,"armor"):
		if not object.has_attribute(object_id,"on_stronger_armor"):
			object.set_attribute(object_id,"on_stronger_armor",True)
			object.set_attribute(object_id,"armor",
				object.get_attribute(object_id,"armor")+1)


def can_repair( character_id, items ):
	"""returns true when the item can be repaired

character_id - id of the character
items        - list of size one with the id of the item"""
	if len(items)==1:
		item = items[0]
		if has_talent(character_id, "technic", "repair_weapons"):
			if object.has_attribute(item, "item_type"):
				if object.get_attribute(item, "item_type")=="weapon":
					if object.has_attribute(item, "quality"):
						if object.get_attribute(item, "quality") < 100:
							return True
	return False

def on_repair( character_id, items ):
	"""called when the player wants to repair the items

character_id - id of the character
items        - list of size one with the id of the item"""
	if can_repair(character_id, items):
		object.set_attribute(items[0], "quality", 100)
		sounds.play_2d_sound("combine")
		return True
	return False

def can_disassemble( character_id, items ):
	"""returns true when the item can be disassembled

character_id - id of the character
items        - list of size one with the id of the item"""
	if len(items)==1:
		typeid = object.get_attribute(items[0], "typeid")
		if object.has_attribute(typeid, "item_combination"):
			combination = object.get_attribute(typeid, "item_combination")
			if not combination.has_key("difficulty_disassemble"):
				difficulty = COMBO_IMPOSSIBLE
			else:
				difficulty = combination["difficulty_disassemble"]
			if difficulty!=COMBO_IMPOSSIBLE:
				all_combinations = combination["combination_list"]
				for act_combination in all_combinations:
					if len(act_combination) > 0:
						return True
	return False

def on_disassemble( character_id, items ):
	"""called when the player wants to disassemble the items

character_id - id of the character
items        - list of size one with the id of the item"""
	if len(items)==1:
		item_type = object.get_attribute(items[0], "typeid")
		if object.has_attribute(item_type, "item_combination"):
			combination =  object.get_attribute(item_type, "item_combination")
			diassemble_func = combination["disassemble_function"]
			if diassemble_func!=None:
				if not combination.has_key("difficulty_disassemble"):
					difficulty = COMBO_IMPOSSIBLE
				else:
					difficulty = combination["difficulty_disassemble"]
				import skill_tables
				technic = skill_tables.technic_combination_value(
								object.get_attribute(character_id, "technic"))
				if technic >= difficulty:
					import combos
					eval_str = "combos."+diassemble_func
					function = eval(eval_str)
					if callable(function):
						if function(character_id, items[0]):
							sounds.play_2d_sound("combine")
							return True
	return False

def get_combine_items( character_id ):
	"""returns the items, in the inventory of the given character, that can be combined

character_id - id of the character
"""
	items = object.get_inventory_id_list( character_id )
	result = []
	item_types = []
	itemlist = system.get_item_list()
	for act_item in items:
		item_types.append(object.get_attribute(act_item, "typeid"))

	import skill_tables
	technic = skill_tables.technic_combination_value(
					object.get_attribute(character_id, "technic"))
	for item in itemlist:
		if object.has_attribute(item, "item_combination"):
			combination =  object.get_attribute(item, "item_combination")
			difficulty = combination["difficulty_assemble"]
			if technic >= difficulty:
				all_combinations = combination["combination_list"]
				for act_combination in all_combinations:
					for item_type in item_types:
						if item_type in act_combination:
							if not item_type in result:
								result.append(item_type)
	return result

def has_alternative_medicine( character_id ):
	equipment = object.get_inventory_id_list( character_id )

	for item in equipment:
		if object.has_attribute( item, "typeid" ):
			typeid=object.get_attribute( item, "typeid" )
			if (typeid == "SET_ALOE_VERA") or (typeid == "SET_WOOD_GARLIC") or (typeid == "SET_BURNET") :
					return True
	return False
def has_medicine( character_id ):
	equipment = object.get_inventory_id_list( character_id )

	for item in equipment:
		if object.has_attribute( item, "typeid" ):
			typeid=object.get_attribute( item, "typeid" )
			if (typeid == "SET_MEDIPACK_SMALL") or (typeid == "SET_ALOE_VERA_OINTMANT") or \
			(typeid == "SET_BURNET_OINTMANT") or (typeid == "SET_MEDIPACK_BIG") or \
			(typeid == "SET_MULTI_MEDIPACK") or (typeid == "SET_WOOD_GARLIC_OINTMANT") :
					return True
	#print "dont have medicine"
	return False

def can_activate_bomb( character_id, object_ident ):
	explosive_skill=object.get_attribute(character_id, "explosives")
	object_id=object.get_attribute( object_ident, "typeid" )
	print "can_activate_bomb: ",object_id, explosive_skill

	if(object.has_attribute(object_ident, "bomb_is_sharp")):
		if object.get_attribute(object_ident, "bomb_is_sharp") == True:
			return False
	if(explosive_skill > 54):
		if(object_id=="SET_GAS_BOMB" or \
			object_id=="SET_DYNAMITE_WITH_TIME_BASED_DETONATOR" or \
			object_id=="SET_DYNAMITE" ):
			print "i can "
			return True
	if(explosive_skill > 69):
		if(object_id=="SET_C4_TIMEBASED" or \
			object_id=="SET_C4_TIMEBASED_W_NAILS" or \
			object_id=="SET_C4_REMOTE_CONTROL_W_NAILS" or \
			object_id=="SET_ANTITANKMINE" or \
			object_id=="SET_LANDMINE" or \
			object_id=="SET_FERTILIZER_EXPLOSIVE_TIME_BASED" or \
			object_id=="SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL" or \
			object_id=="SET_C4_REMOTE_CONTROL" ):
			print "i can "
			return True
		
	print "can_t_activate_bomb "
	return False
	
def on_combine( character_id, items ):
	"""called when the player wants to combine items

character_id - id of the character
items        - list with the ids of the items
"""
	# get the list of all item types
	itemlist = system.get_item_list()
	item_types = []
	# get item types of all given items
	for act_item in items:
		item_types.append(object.get_attribute(act_item, "typeid"))
	item_types.sort()
	for item in itemlist:
		if object.has_attribute(item, "item_combination"):
			combination = object.get_attribute(item, "item_combination")
			if not isinstance(combination,dict):
				raise ValueError, "attribute must be of type dictionary"
			difficulty = combination["difficulty_assemble"]
			import skill_tables
			technic = skill_tables.technic_combination_value(
							object.get_attribute(character_id, "technic"))
			if technic >= difficulty:
				all_combinations = combination["combination_list"]
				for act_combination in all_combinations:
					combi = act_combination[:] # we need a copy, instead reference
					combi.sort()
					if item_types==combi:
						# combine explosives need special talent							
						if item in ["SET_FERTILIZER_EXPLOSIVE_TIME_BASED",
									"SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL",
									"SET_C4_TIMEBASED_W_NAILS",
									"SET_C4_REMOTE_CONTROL_W_NAILS"]:
							if not has_talent( character_id, "explosives", "build_explosives" ):
								break;

						if combination.has_key("assemble_function"):
							if combination["assemble_function"]!=None:
								assemble_function = combination["assemble_function"]
								import combos
								eval_str = "combos."+assemble_function
								function = eval(eval_str)
								if callable(function):
									if function(character_id, items, item):
										sounds.play_2d_sound("combine")
										return True
						else:
							#default assemble, no special behaviour possible, all source items
							#will be combined to one target item, all source items will be destroyed
							sounds.play_2d_sound("combine")
							print items, item 
							# remove items
							for act_item in items:
								object.remove_item_from_inventory(character_id, act_item)
							#create new item
							object.create_item_in_inventory(object=character_id, equipment=item, id=items[0]+"_COMBINED")
							return True
	sounds.play_2d_sound("combine_failed")
	return False

def can_use( character_id, object_id ):
	"""returns true for items the character is able to use

character_id - id of the character
object_id    - id of the object that should be used"""
	if global_item.can_use( character_id, object_id ):
		return True

	type = object.get_attribute(object_id, "type")
	if type=="equipment":
		typeid = object.get_attribute(object_id, "typeid")
		if object.has_attribute(object_id, "weapon_type"):
			if object.get_attribute(object_id, "weapon_type") == "explosiv":
				return True #jan: try explosives always
				#return can_activate_bomb(character_id, object_id)
		if object.has_attribute(object_id, "le_recovery"):
			if is_water_repository( object_id ):
				if object.get_attribute( object_id, "charge" )<=0:
					return False
			# le recovery item jan: some are only useable if character has skill "alternative_medicine"
			if typeid=="SET_ALOE_VERA" or typeid=="SET_WOOD_GARLIC" or typeid=="SET_BURNET" or typeid=="SET_ANGELICA":
				print "try to use herbs" 
				if not has_talent( character_id, "medicine", "alternative_medicine" ):
					print "use of herbs without talent" 
					return False
			return True

		# ignore equip items
		if object.has_attribute(object_id, "occupied_slots"):
			return False
		return True

	if object.has_attribute(object_id,"action_use"):
		return object.get_attribute(object_id,"action_use")

	return False

def is_raw_meat( item_id ):
	"""tests if the given item is raw meat.

item_id - id of the item"""
	item_type = ""

	if object.has_attribute( item_id, "typeid" ):
		item_type = object.get_attribute( item_id, "typeid" )

	meat = [	'SET_MEAT_RAW_HUMONGOUS',
			'SET_MEAT_RAW_BIG',
			'SET_MEAT_RAW',
			'SET_MEAT_RAW_SMALL',
			'SET_MEAT_RAW_TINY' ]

	# if the used item is raw meat
	if item_id in meat or item_type in meat:
		return True
	else:
		return False

def is_usable_to_improve( object_id ):
	"""tests if the given object can be used
	to improve meat.

object_id - id of the object"""

	improve = False
	object_type = None

	# check if object can purify
	if object.has_attribute( object_id, "typeid" ):
		# get the type of the object 
		object_type = object.get_attribute( object_id, "typeid" )

		# must use try/except, because the attribute system is not
		# implemented for every typeid and therefore has_attribute
		# will throw an exception, that i have to catch here
		try:
			object.has_attribute( object_type, "improve" )
		except:
			return False

		if object.has_attribute( object_type, "improve" ):
			# if meat can be purified with the object
			improve = object.get_attribute( object_type, "improve" )
	
	# if the object can be used to improve,
	# then check if it is in the right state to be used
	if improve:
		# if object is a bonfire, check if it is burning
		if object_type == "RES3D_LAGERFEUER":
			if object.has_attribute( object_type, "burning" ):
				improve = object.get_attribute( object_type, "burning" )

	if improve:
		return True
	else:
		return False


def cannot_improve_comment( character_id, object_id ):
	"""lets the char say a comment depending
	on the object he tries to use to improve

character_id - id of the character
object_id - id of the object that should be used to improve"""
	object_type = None

	if object.has_attribute( object_id, "typeid" ):
		# get the type of the object 
		object_type = object.get_attribute( object_id, "typeid" )
	
		# if object is a bonfire, check if it is burning
		if object_type == "RES3D_LAGERFEUER":
			if object.has_attribute( object_type, "burning" ):
				if not object.get_attribute( object_type, "burning" ):
					comments.comment( character_id, "IMPROVE_MEAT_FAILED_FIRE" )


def is_water_source( object_id ):
	"""returns true if the given object is a water source

object_id - id of the object that should be tested"""

	object_type = ""
	water_sources = [ "RES3D_TRES_OBJECTS_BUILDING_WATERHOLE_EMPTY", "RES3D_TRES_OBJECTS_BUILDING_WATERHOLE_FULL" ]

	if object.has_attribute( object_id, "typeid" ):
		object_type = object.get_attribute( object_id, "typeid" )

	if object_id in water_sources or object_type in water_sources:
		return True
	else:
		return False

def fill_water_repository( item_id, item_type, object_id ):
	"""fills the given item with water from the given object

item_id - item that should be filled with water
object_id - object where the water is taken from"""

	x = object.get_x( object_id )
	y = object.get_y( object_id )

	available_water   = water.get_available_water( object.get_x( object_id ), object.get_y( object_id ), 0.5 )
	current_charge	  = object.get_attribute( item_id, "charge" ) # current charge value
	max_charge	  = object.get_attribute( item_type, "charge" ) # max charge value
	charge_diff       = max_charge - current_charge # how much water is needed to fill the item up
	remaining_water   = available_water - charge_diff # how much water remains in the object

	if remaining_water < 0: # the water in the object is not enough to fill the item up
		# add the complete available_water to the item and remove it from the object
		object.set_attribute( item_id, "charge", current_charge + available_water )
		water.reduce_available_water( object.get_x( object_id ), object.get_y( object_id ), 0.5, available_water )
		system.create_object( "RES3D_TRES_OBJECTS_BUILDING_WATERHOLE_EMPTY", x, y )
	else: # there is more water in the object than neede
		object.set_attribute( item_id, "charge", max_charge )
		water.reduce_available_water( object.get_x( object_id ), object.get_y( object_id ), 0.5, charge_diff )

	system.update_ui()

def fill_all_water_repositories( character_id, water_source_id ):
	"""Tries to fill all the water repositories with the water
	from the give water source until there is no more water
	in the water source. Starts filling with water repositories
	that are partially empty.

character_id - id of the character
water_source_id - id of the source where the water is taken from"""

	sorted_items = [] # water repositories are sorted by fill level. Empty ones first
	item_type = ""
	equipment = object.get_inventory_id_list( character_id )

	available_water = water.get_available_water( object.get_x( water_source_id ), object.get_y( water_source_id ), 1 )
	if available_water == 0:
		return

	# sort water repositories by fill level
	for item in equipment:
		if is_water_repository( item ):
			if object.has_attribute( item, "typeid" ):
				item_type = object.get_attribute( item, "typeid" )
			else:
				continue

			current_charge = object.get_attribute( item, "charge" )
			max_charge = object.get_attribute( item_type, "charge" )

			if current_charge == 0:
				sorted_items.append( item )
			elif current_charge < max_charge:
				sorted_items.insert( 0, item )

	for item in sorted_items:
		available_water = water.get_available_water( object.get_x( water_source_id ), object.get_y( water_source_id ), 1 )
		if available_water <= 0:
			random_comment(  character_id, "WATER_SOURCE_EMPTY_", 1 )
			break

		if object.has_attribute( item, "typeid" ):
			item_type = object.get_attribute( item, "typeid" )
		else:
			continue

		fill_water_repository( item, item_type, water_source_id )


def use_raw_meat( character_id, meat_id ):
	"""Search for a cookingplace and use passed meat on it

character_id - id of the character
meat_id - id of the meat that should be cooked"""

	x = object.get_x( character_id )
	y = object.get_y( character_id )
	max_dist = 40

	# get all object in a 80x80 square around the char
	objects = system.get_objects( None, x - max_dist, y + max_dist, x + max_dist, y - max_dist )

	tmpObjectList = []
	# sort out all objects that are further away then 80 meters
	for tmpObject in objects:
		if object.get_distance_to_position( character_id, object.get_x( tmpObject ), object.get_y( tmpObject ) ) <= 80:
			tmpObjectList.append( tmpObject )

	objects = tmpObjectList # object list now contains only objects that are nearer or equalor equal than 80 meter

	# ( cookingplace object, dist to char )
	cooking_place = ( None, None )

	# search for the nearest cooking place
	for tmp_object in objects:
		if not is_usable_to_improve( tmp_object ):
			continue

		objectX = object.get_x( tmp_object )
		objectY = object.get_y( tmp_object )
		
		# is object in radius dist
		dist = math.hypot( x - objectX, y - objectY )
		if dist < max_dist and ( cooking_place[1] == None or dist < cooking_place[1] ):
			cooking_place = ( tmp_object, dist )

	# if a cooking place is found then cook the meat on it
	if cooking_place[0] != None:
		character.use( character_id, meat_id, cooking_place[0] )
	else:
		comments.comment( character_id, "IMPROVE_MEAT_FAILED_FIRE" )


def use_water_repository( character_id, water_repository_id ):
	"""Search for a water source and use the passed water repository on it

character_id - id of the char
water_repository_id - id of the water repository that should be used"""

	# check if the zone has unearthed water sources
	if not hasattr( data(), "water_unearthed" ):
		random_comment( character_id, "NO_WATER_SOURCE_AROUND_", 1 )
		return

	# ( xpos, ypos, dist to char )
	water_source = ( None, None, None )

	char_x = object.get_x( character_id )
	char_y = object.get_y( character_id )

	# search for the nearest unearthed water source
	for source in data().water_unearthed:
		dist =  math.hypot( char_x - source[0], char_y - source[1] )
		if dist <= 80 and ( water_source[2] == None or dist < water_source[2] ):
			water_source = ( source[0], source[1], dist )

	if water_source[0] != None:
		dist = 1
		x = water_source[0]
		y = water_source[1]

		# get the object that represents the water source.
		# use a radius to get it even if it has not the same coords as the water source
		objects = system.get_objects( None, x - dist, y - dist, x + dist, y + dist )

		# if objects are found then check for the water source object and use the
		# water repository on it
		if len( objects ) > 0:
			for tmp_object in objects:
				if is_water_source( tmp_object ):
					character.use( character_id, water_repository_id, tmp_object )
					return
	else:
		random_comment( character_id, "NO_WATER_SOURCE_AROUND_", 1 )


def pre_use( character_id, object_id, item_id, item_type ):
	"""is called directly before a char uses an item on an object.

character_id - id of the character
object_id    - id of the object that the item should be used on
               (can be the same as character_id) 
item_id      - id of the object that should be used
item_type    - type of the object that should be used """
	# do nothing by default
	None
	

def on_use( character_id, object_id, item_id, item_type ):
	"""is called when the player wants to use an item

character_id - id of the character
object_id    - id of the object that the item should be used on
               (can be the same as character_id) 
item_id      - id of the object that should be used
item_type    - type of the object that should be used"""
	print "object_events.on_use", character_id, object_id, item_id, item_type
	#default code verwaltet nur items z.Zt., return wenn kein item angegeben
	# an item is used on an other object
	if global_item.can_use( character_id, item_id ):
		if global_item.on_use( character_id, object_id, item_id, item_type ):
			return True
	
	if character_id != None and item_type != None:
		if character_id == 'MERCENARY_AGNES' and item_type in ['SET_MEAT_RAW', 'SET_MEAT_RAW_SMALL', 'SET_MEAT_RAW_TINY',
															   'SET_MEAT_COOKED_TINY', 'SET_MEAT_RAW_HUMONGOUS', 'SET_MEAT_RAW_BIG',
															   'SET_MEAT_COOKED_BIG', 'SET_MEAT_COOKED', 'SET_MEAT_COOKED_SMALL',
															   'SET_MEAT_COOKED_HUMONGOUS', 'SET_TIGER_MEAT', 'SET_RAT_MEAT',
															   'SET_BISON_MEAT', 'SET_PAN_WITH_MEAT', 'SET_SPIT_WITH_MEAT']:
			if not dialog.is_dialog_active():
				dialog.init_dialog(type=DIALOGSMALL)
				dialog.add_text(text='MKEN_AGNES_D_2', speaker=character_id, follower="ENDDIALOG")
				#dialog.add_text(text='MKEN_AGNES_D_4', speaker=character_id, follower="ENDDIALOG")
				dialog.start()
				return True
			return True
	
	if item_id != None and object_id != None:
		
		#refuel vehicles
		if object.has_attribute(object_id, "type"):
			type = object.get_attribute(object_id, "type")
			if type=="vehicle":
				if object.has_attribute(item_type, "fuel"):
					fuel = object.get_attribute(item_type, "fuel")
					current_fuel = object.get_attribute(object_id, "current_fuel_quantity")
					current_fuel+=fuel
					object.set_attribute(object_id, "current_fuel_quantity",current_fuel)
					return True

		# is raw meat used
		if is_raw_meat( item_id ):
			if is_usable_to_improve( object_id ): # is the object usable to improve the meat
				if can_cook_meat( character_id ): # is the char able to cook
					character.cook_meat( character_id, item_id, object_id )
					return True
				else:
					comments.comment( character_id, "IMPROVE_MEAT_FAILED_TOOL" )
			else:
				# char says comment on why the object 
				# can not be used to improve
				cannot_improve_comment( character_id, object_id )

		# is a water repository used
		if is_water_repository( item_id ):
			if is_water_source( object_id ):
				available_water = water.get_available_water( object.get_x( object_id ), object.get_y( object_id ), 1 )
				if available_water <= 0:
					random_comment(  character_id, "WATER_SOURCE_EMPTY_", 1 )
				else:
					fill_water_repository( item_id, item_type, object_id )

				return True

	if (item_id==None or object_id!=None):
		return False

	if (object.has_attribute(item_type, "bomb_type") and 
		len(object.get_attribute(item_type, "bomb_type"))): 
		if object.count_in_inventory(character_id, item_id):
			object.put_down_item(character_id, item_id)
		#activate or defuse?
		if ( object.has_attribute(item_id,"bomb_is_sharp")):
			if( not object.get_attribute(item_id,"bomb_is_sharp")):
				if can_activate_bomb(character_id,item_id):
					if has_talent( character_id, "explosives", "max_explosive_effect" ):
						object.set_attribute(item_id,"explosive_bonus",10)
					system.add_explosive_control(character_id, item_id)
				else:
					print "unable to activate"
					import random
					text = "HANDLE_EXPLOSIVES_DENY_001" 
					comments.comment( character_id, text )
			else:
				system.remove_explosive_control( item_id)
				chance=calc_defuse_chance(character_id,item_id)
				if(chance< random.randint(1,100)):
					fail_defuse(character_id,item_id)
				else:
					if object.has_attribute(item_id, "explosive_bonus"):
						object.set_attribute(item_id,"explosive_bonus",0)
						
		else:
			if can_activate_bomb(character_id,item_id):
				print "activate it"
				if has_talent( character_id, "explosives", "max_explosive_effect" ):
					object.set_attribute(item_id,"explosive_bonus",10)
				system.add_explosive_control(character_id, item_id)
			else:
				print "unable to activate"
				import random
				text = "HANDLE_EXPLOSIVES_DENY_001" 
				comments.comment( character_id, text )

			
				
		print "object_events.on_use", "usebomb ",item_id
		return True
		
	if object.has_attribute(item_type, "le_recovery"):
		value = object.get_attribute(character_id, "hitpoints")
		value_max = object.get_attribute(character_id, "maxhitpoints")
		if value<value_max:
			# if the item itself has no recovery value
			# take the value of the item type
			if object.has_attribute( item_id, "le_recovery" ):
				le_recovery=object.get_attribute(item_id, "le_recovery")
			else:
				le_recovery=object.get_attribute(item_type, "le_recovery")

			import skill_tables
			medicine = object.get_attribute(character_id, "medicine")
			used_charge = 0 # amount of charge that is used from the item
			remove_if_empty = True # should the item be removed from inventory if it is empty

			if item_type=="SET_MEDIPACK_SMALL":
				le_recovery+=skill_tables.medicine_medipack_standard(medicine)
				used_charge = 1
			elif (item_type=="SET_MEDIPACK_BIG"):
				le_recovery+=skill_tables.medicine_medipack_big(medicine)
				used_charge = 1
			elif (item_type=="SET_MULTI_MEDIPACK"):
				le_recovery+=skill_tables.medicine_medipack_big(medicine)
				used_charge = 1
			elif (item_type=="SET_ALOE_VERA" ):
				le_recovery+=skill_tables.medicine_aloe_vera(medicine)
				used_charge = 1
			elif (item_type=="SET_WOOD_GARLIC" ):
				le_recovery+=skill_tables.medicine_wood_garlic(medicine)
				used_charge = 1
			elif (item_type=="SET_BURNET" ):
				le_recovery+=skill_tables.medicine_burnet(medicine)
				used_charge = 1
			elif (item_type=="SET_ALOE_VERA_OINTMANT" ):
				le_recovery+=skill_tables.medicine_aloe_vera_ointmant(medicine)
				used_charge = 1
			elif (item_type=="SET_WOOD_GARLIC_OINTMANT" ):
				le_recovery+=skill_tables.medicine_wood_garlic_ointmant(medicine)
				used_charge = 1
			elif (item_type=="SET_BURNET_OINTMANT" ):
				le_recovery+=skill_tables.medicine_burnet_ointmant(medicine)
				used_charge = 1
			elif is_water_repository( item_id ): # le_recovery depends on the fill level
				current_charge    = object.get_attribute( item_id, "charge" ) # current charge value
				max_charge	  = object.get_attribute( item_type, "charge" ) # max charge value

				# calc recovery of the repository 
				old_le_recovery = le_recovery
				le_recovery = old_le_recovery * ( float(current_charge) / float(max_charge) )

				# how much recovery does the char need
				value_diff = value_max - value
				if value_diff < le_recovery:
					le_recovery = value_diff

				# calc the charge that is needed to recover
				new_charge = 0
				needed_charge = 0
				needed_charge = ( float( le_recovery ) / float( old_le_recovery ) ) * max_charge

				used_charge = needed_charge
				remove_if_empty = False
				
			value+=le_recovery
			if value>value_max:
				value = value_max
			#print "object_events.on_use", character_id
			#print "object_events.on_use", object.get_attribute(character_id, "hitpoints")
			object.set_attribute(character_id, "hitpoints", value)
			#print "object_events.on_use", character_id
			#print "object_events.on_use", object.get_attribute(character_id, "hitpoints")

			charge = 0
			if object.has_attribute(item_id, "charge"):
				charge = object.get_attribute(item_id, "charge")
				charge-=used_charge
			elif object.has_attribute(item_type, "charge"):
				charge = object.get_attribute(item_type, "charge")
				charge-=used_charge
			assert charge >= 0
			if charge == 0 and remove_if_empty:
				#print "object_events.on_use", object.get_inventory_id_list( character_id )
				equipment = object.get_inventory_id_list( character_id )
				if item_id in equipment:
					#for item in equipment:
					object.remove_item_from_inventory(character_id, item_id)
				else:
					object.pick_up_item_direct(character_id,item_id)
					object.remove_item_from_inventory(character_id,item_id)
				True
			else:
				object.set_attribute(item_id, "charge", charge)

			system.update_ui()

			return True
					
		else: return True
	
	return False

def on_use_failed( character_id, object_id, item_id, item_type ):		
	"""is called when on_use returned False for this item

character_id - id of the character
object_id    - id of the object that the item should be used on
               (can be the same as character_id) 
item_id      - id of the object that should be used
item_type    - type of the object that should be used"""
	# failed to use object/item
	import random
	text = "HANDLE_ITEM_" + str(random.randint(1,9))
	comments.comment(character_id=character_id, text=text)
	return False

def can_exchange( character_id, target_id, item_id, item_type ):
	"""return True when the item can be given from character to target

character_id - id of the character who gives
target_id    - id of the object that receives the item
item_id      - id of the object that should be transfered
item_type    - type of the object that should be transfered"""
	#print "can_exchange", character_id, target_id, item_id, item_type

	if object.has_attribute(target_id, "type"):
		type = object.get_attribute(target_id, "type")
		if type=="vehicle":
			return False

	if object.is_npc(target_id):
		if object.has_attribute(item_id, "generic_item"):
			print "generic_item", object.get_attribute(item_id, "generic_item")
			if not object.get_attribute(item_id, "generic_item"):
				text = "TRANSFER_QUESTITEM_" + str(random.randint(1,10))
				comments.comment(character_id=character_id, text=text)
				return False
	elif object.is_pc(target_id):
		return True
	return True

def on_exchange( character_id, target_id, item_id, item_type ):
	"""is called when the item should be transfered from character to target

character_id - id of the character who gives
target_id    - id of the object that receives the item
item_id      - id of the object that should be transfered
item_type    - type of the object that should be transfered"""
	#print "on_exchange", character_id, target_id, item_id, item_type
	if object.is_pc(target_id):
		if object.can_transfer_item(target_id,item_id):
			if test_exchange_explosion(character_id, target_id, item_id, item_type ):
				return True
			return False
		else:
			text = "TRANSFER_ITEM_" + str(random.randint(1,10))
			comments.comment(character_id=character_id, text=text)
			return False
	return True
def get_item_of_type_from_inventory( character_id,item_type):
	itemlist=object.get_inventory_id_list(character_id)
	for element in itemlist:
		if object.has_attribute(element, "typeid"):
			if object.get_attribute(element, "typeid") ==item_type:
				return element
	return ""

def test_exchange_explosion(character_id, target_id, item_id, item_type ):
	dodamage = False
	#print "test_explosive", character_id, item_id, item_type
	if (object.has_attribute(item_type, "weapon_type")):
		if object.get_attribute(item_type, "weapon_type")=="explosiv":
			explosives = object.get_attribute( object=target_id, attribute="explosives" )
			#print "skill: " ,explosives
			if explosives < 15:
				if random.randint(0, 9): #90% chance
					dodamage=True
			elif explosives < 40:
				if random.randint(0, 1): #50% chance
					dodamage=True
	if dodamage:
		#print "do_explosive_damage"
		object.remove_item_from_inventory(character_id,item_id)

		hitpoints=object.get_attribute(target_id, "hitpoints")
		factor=random.randint(5, 10)
		hitpoints=hitpoints*factor/100
		object.set_attribute(target_id, "hitpoints", hitpoints)
		fx_object_id = random.choice([fx_explosion,fx_explosion_medium])
		sound_object_id = random.choice(['grenade_explo_frag','grenade_explo_rpg7','various_explosive_explo'])
		pos = object.get_position(target_id)
		system.start_effect( 
			startx=pos[0],starty=pos[1],startz=pos[2],
			dirx=0,diry=0,dirz=1,
			parameter=fx_object_id)
		sounds.play_3d_sound(
			sfx_id=sound_object_id,
			x=pos[0],y=pos[1],z=pos[2])
		return False
	
	
	return True
def fail_defuse(character_id, target_id ):
	#print "do_explosive_damage"
	#hack to remove mine from the ground . (what happens if inventory is full??)
	object.pick_up_item_direct(character_id,target_id)
	object.remove_item_from_inventory(character_id,target_id)

	hitpoints=object.get_attribute(character_id, "hitpoints")
	factor=random.randint(5, 10)
	hitpoints=hitpoints*factor/100
	object.set_attribute(character_id, "hitpoints", hitpoints)
	fx_object_id = random.choice([fx_explosion,fx_explosion_medium])
	sound_object_id = random.choice(['grenade_explo_frag','grenade_explo_rpg7','various_explosive_explo'])
	pos = object.get_position(character_id)
	system.start_effect( 
		startx=pos[0],starty=pos[1],startz=pos[2],
		dirx=0,diry=0,dirz=1,
		parameter=fx_object_id)
	sounds.play_3d_sound(
		sfx_id=sound_object_id,
		x=pos[0],y=pos[1],z=pos[2])
def calc_defuse_chance( operator, target ):
	"""calculates the chance to defuse a given bomb
	Returns the chance

operator - id of the defusor
target   - id of the bomb
	"""
	defuse_bonus=0
	defuse_chance=0
	if has_talent( operator, "explosives", "defuse" ):
		defuse_bonus=30
	explosives = object.get_attribute( object=operator, attribute="explosives" )
	item_type=object.get_attribute( target, "typeid" )
	
	if(item_type=="SET_GAS_BOMB" or \
		item_type=="SET_DYNAMITE_WITH_TIME_BASED_DETONATOR" or \
		item_type=="SET_DYNAMITE" ):
		if explosives >54:
			defuse_chance=30
		if explosives >69:
			defuse_chance=50
		if explosives >84:
			defuse_chance=70
	if(item_type=="SET_C4_TIMEBASED" or \
		item_type=="SET_C4_TIMEBASED_W_NAILS" or \
		item_type=="SET_C4_REMOTE_CONTROL_W_NAILS" or \
		item_type=="SET_ANTITANKMINE" or \
		item_type=="SET_LANDMINE" or \
		item_type=="SET_FERTILIZER_EXPLOSIVE_TIME_BASED" or \
		item_type=="SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL" or \
		item_type=="SET_C4_REMOTE_CONTROL" ):
		if explosives >69:
			defuse_chance=30
		if explosives >84:
			defuse_chance=50
		if explosives >94:
			defuse_chance=70
		
	#print "defuse_chance ", defuse_chance, defuse_bonus
	return defuse_chance+defuse_bonus

"""
	pick_pocket = object.get_attribute(operator, "pick_pocket")

	# 30% better chance to steal something if the operator has the talent flatter
	# and the target is of the opposite gender
	if has_talent( operator, "pick_pocket", "flatter" ):
		if object.has_attribute( target, "gender" ):
			operator_gender = object.get_attribute( operator, "gender" )
			target_gender = object.get_attribute( target, "gender" )

			if ( operator_gender == "female" and target_gender == "male" ) or \
			   ( operator_gender == "male" and target_gender == "female" ):
				additional_chance = additional_chance + 0.3


	# chance of a successful heist will be reduced by the fact that
	# the target was bereft before
	if bereft_list.has_key( operator ):
		bereft = bereft_list[ operator ]
		
	chance = ( basic_chance_of_success + additional_chance ) * bereft
"""
	
def can_examine_object( character_id, object_id ):
	"""returns true if the object can be examined
	
character_id - id of the character
object_id    - id of the object"""

	# dead animals to examine
	if object.has_attribute(object_id, "type"):
		type = object.get_attribute(object_id, "type")
		if type=="animal":
			if not object.get_attribute( object_id, "hitpoints" ):
				return True
			else:
				return False

	# dead characters to examine
	if character.exists( object_id ):
		if object.is_destroyed( object_id ) or object.is_unconscious( object_id ):
			return True
		else:
			return False

	# normal objects
	if object.has_attribute(object_id, "typeid"):
		typeid = object.get_attribute(object_id, "typeid")
		if object.has_attribute(typeid, "examine"):
			return True

	return False

def pre_examine_object( character_id, object_id ):
	"""is called before the char starts to examine a object.
	That means before he walks to the object and examines it.

character_id - id of the character
object_id - id of the object"""
	#do nothing by default
	None

def on_examine_object( character_id, object_id ):
	"""called if an item is examined by a character

character_id - id of the character
object_id - id of the object"""

	# examine animal - refer to disembowl or loot
	if object.has_attribute(object_id, "type"):
		type = object.get_attribute(object_id, "type")
		if type=="animal":
			typeid = object.get_attribute(object_id, "typeid")
			inventorylist = object.get_inventory_list(object_id)
			if inventorylist:
				system.item_panel( character_id, object_id )
			else:
				comments.comment(character_id=character_id, text="EXAMINE_"+typeid)

	# loot characters
	if character.exists( object_id ):
		if object.is_pc( character_id ):
			inventorylist = object.get_inventory_list(object_id)
			if inventorylist:
				system.item_panel( character_id, object_id )
		else:
			# foe?
			foes = []
			if object.has_attribute( character_id, "foes" ):
				foes = object.get_attribute( character_id, "foes" )
			if object_id in foes:
				inventorylist = object.get_inventory_list(object_id)
				for item in inventorylist:
					object.transfer_item(object_id, item, character_id)

	# normal objects
	if (object.has_attribute(object_id, "typeid") and
		object.has_attribute(object_id, "type")):
		type = object.get_attribute(object_id, "type")
		if type=="building":
			typeid = object.get_attribute(object_id, "typeid")
			if object.has_attribute(typeid, "examine"):
				inventorylist = object.get_inventory_list(object_id)	

				# get the exmaine status
				is_examined = False
				if object.has_attribute( object_id, "is_examined" ):
					is_examined = object.get_attribute( object_id, "is_examined" )

				# determine object_type
				chests = [ "RES3D_TRES_OBJECTS_BUILDING_TRUHEMITSCHLOSS_ANIMATE",\
						"RES3D_TRES_OBJECTS_BUILDING_STABILEHOLZKISTEMITSCHLOSS_ANIMATE", \
						"RES3D_TRES_OBJECTS_BUILDING_GROSSEMETALLKISTEMITSCHLOSS_ANIMATE", \
						"RES3D_TRES_OBJECTS_BUILDING_FELDKISTEMITSCHLOSS_ANIMATE" ]
				object_type = None
				if string.find( typeid, "RES3D_TRESOR_" ) == 0: # object is a safe
					object_type = "safe"

				if is_locked_object( object_id ):
					if object.has_attribute( typeid, "examine_locked" ):
						examine_locked = object.get_attribute( typeid, "examine_locked" )
						if examine_locked.endswith("_"):
							text = examine_locked + str(random.randint(1,5))
							comments.comment(character_id=character_id, text=text)
						else:
							comments.comment(character_id=character_id, text=examine_locked)
					else:
						comments.comment( character_id, "EXAMINE_LOCKED_OBJECT" )
				elif inventorylist:
					if ( object_type == "safe" or typeid in chests ) and not is_examined:
						# open and show object inventory
						lambda_string = 'system.item_panel( taker="%s", object="%s" )' % ( character_id, object_id )
						object.play_animation( object_id, "ANIM_TRESOR", callback = [ "ONEND", Lambda( lambda_string ) ] )
						object.set_attribute( object_id, "is_examined", True )
					else:
						# show object inventory
						system.item_panel( character_id, object_id )
				else:
					if ( object_type == "safe" or typeid in chests ) and not is_examined:
						object.play_animation( object_id, "ANIM_TRESOR" )
						object.set_attribute( object_id, "is_examined", True )

					examine = object.get_attribute(typeid, "examine")
					if examine.endswith("_"):
						text = examine + str(random.randint(1,5))
						comments.comment(character_id=character_id, text=text)
					else:
						comments.comment(character_id=character_id, text=examine)

def is_locked_object( object_id ):
	"""Checks if the given object is locked.

object_id - id of the object that should be checked
	"""
	if object.has_attribute( object_id, "locked" ):
		locked = object.get_attribute( object_id, "locked" )
		if len( locked ) <= 0:
			return False
		else:
			return True
	else:
		return False


def can_cook_meat( character_id ):
	"""returns true if the character has the needed
	equipment to cook meat. And of course he needs meat
	to cook.

character_id - id of the character"""

	has_cooking_item = False
	cook_items = [ 'SET_PAN', 'SET_POT_ON_A_BAR', 'SET_SPIT' ]
	inventory_id_list = object.get_inventory_list( character_id )

	# check if char has one of the cooking items
	for item in cook_items:
		if item in inventory_id_list:
			has_cooking_item = True

	# if char has a cooking item then check if he
	# has raw meat to cook
	if has_cooking_item:
		meat = ['SET_MEAT_RAW_HUMONGOUS',
			'SET_MEAT_RAW_BIG',
			'SET_MEAT_RAW',
			'SET_MEAT_RAW_SMALL',
			'SET_MEAT_RAW_TINY' ]

		# exit function with True if meat is in inventory
		for x in meat:
			if x in inventory_id_list:
				return True

	return False

def on_cook_meat( character_id, object_id, item, cookAll = False ):
	"""called if meat is cooked by the character
	The raw meat is replaced with cooked meat.

character_id - id of the character
object_id - id of the meat that is cooked
item - item that is used to cook
all - determines if all meat in the chars inventory should be cooked"""

	# play a animation depending on the cooking item
	if item == "SET_PAN":
		character.play_animation( character_id, "CM_NPC_STEHEN_PFANNE_SCHWENKEN_LOOP" )
	elif item == "SET_SPIT":
		character.play_animation( character_id, "CM_KNIEND_BRATSPIESS_HALTEN_LOOP" )
	elif item == "SET_POT_ON_A_BAR":
		character.play_animation( character_id, "CM_KNIEND_KOCHTOPF_HALTEN_LOOP" )
	
	meat = {	'SET_MEAT_RAW_HUMONGOUS': 'SET_MEAT_COOKED_HUMONGOUS',
			'SET_MEAT_RAW_BIG': 'SET_MEAT_COOKED_BIG',
			'SET_MEAT_RAW': 'SET_MEAT_COOKED',
			'SET_MEAT_RAW_SMALL': 'SET_MEAT_COOKED_SMALL',
			'SET_MEAT_RAW_TINY': 'SET_MEAT_COOKED_TINY' }

	meatlist = []

	if cookAll:
		meatlist = object.get_inventory_id_list( character_id )
	else:
		meatlist = [ object_id ]

	for object_id in meatlist:
		if object.has_attribute( object_id, "typeid" ):
			object_type = object.get_attribute( object_id, "typeid" )
			# check if object is meat
			if object_type in meat.keys():
				object.remove_item_from_inventory( character_id, object_id )
				cooked_meat = meat[ object_type ]
				new_meat = object.create_item_in_inventory( character_id, cooked_meat )
				# if char has talent to cook then extend 
				# the meats recovery value by 50 percent
				if has_talent( character_id, "survival", "cook" ):
					old_recovery = object.get_attribute( new_meat, "le_recovery" )
					object.set_attribute( new_meat, "le_recovery", old_recovery * 1.5 )
				

def get_cook_position( character_id, object_id ):
	"""returns the position the char should move to
	to cook.

character_id - id of the character
object_id - id of the object where the char should move to"""

	object_type = None

	if object.has_attribute( object_id, "typeid" ):
		# get the type of the object 
		object_type = object.get_attribute( object_id, "typeid" )

	dist = 0

	if object_type == "RES3D_LAGERFEUER":
		# distance the char should move forward
		dist = math.hypot( 0.7, 0 )

	# get characters direction
	direction = object.get_direction( character_id )

	# direction is measured clockwise
	# turn it counterclockwise for sin/cos functions
	direction = 360 - direction
	# convert it from degree to radiant
	direction = 2.0 * math.pi * ( direction / 360 )

	# calc the new char positions
	char_x = object.get_x( character_id )
	char_y = object.get_y( character_id )

	desiredPosX = char_x - dist * math.sin( direction )
	desiredPosY = char_y - dist * math.cos( direction )

	return [ desiredPosX, desiredPosY, 0 ]

def remove_normal_pan( character_id ):
	"""callback function to remove the normal 
	pan from the inventory.
	"""
	object.remove_item_from_inventory( character_id, "SET_PAN" )

def remove_normal_spit( character_id ):
	"""callback function to remove the normal 
	spit from the inventory
	"""
	object.remove_item_from_inventory( character_id, "SET_SPIT" )

def cook_all_meat( character_id ):
	cook_meat( character_id, None, True )
	
def cook_meat( character_id, object_id, cookAll = False ):
	"""called to cook meat.
	Plays animation depending on the item the chars uses.
	Call other functions to replace raw with cooked meat.

character_id - id of the character
object_id - id of the object that is cooked
all - determines if all meat in the chars inventory should be cooked"""

	if not can_cook_meat( character_id ):
		return

	cook_items = [ 'SET_PAN', 'SET_SPIT' ,'SET_POT_ON_A_BAR' ]
	tmp_cook_items = []
	cooking_item = None

	# delete every item from list that is not in the inventory
	for item in cook_items:
		if object.count_in_inventory( character_id, item ): # cook items is not in inventory
			tmp_cook_items.append( item )

	cook_items = tmp_cook_items

	# check if char already has one of the cook_items equiped 
	for item in cook_items:
		if character.is_equiped( character_id, item ):
			cooking_item = item 

	if not cooking_item:
		# randomly choose cooking item and play accordant animation
		import random
		cooking_item = random.choice( cook_items )

	if cooking_item == "SET_PAN":
		character.play_animation( character_id, "CM_NPC_STEHEN_PFANNE_SCHWENKEN_HINKNIEN", [ "ONSTART", remove_normal_pan ] )
	elif cooking_item == "SET_SPIT":
		character.play_animation( character_id, "CM_KNIEND_BRATSPIESS_HALTEN_START", [ "ONSTART", remove_normal_spit ] )
	elif cooking_item == "SET_POT_ON_A_BAR":
		character.play_animation( character_id, "CM_KNIEND_KOCHTOPF_HALTEN_START" )
	
	on_cook_meat( character_id, object_id, cooking_item, cookAll )
	post_cook_meat( character_id, cooking_item )

def add_normal_pan( character_id ):
	"""callback function to add normal pan to the inventory 
	and remove the pan with meat.
	"""
	object.remove_item_from_inventory( character_id, "SET_PAN_WITH_MEAT" )
	object.create_item_in_inventory( character_id, "SET_PAN" )

def add_normal_spit( character_id ):
	"""callback funtion to add normal spit to the inventory 
	and remove the spit with meat.
	"""
	object.remove_item_from_inventory( character_id, "SET_SPIT_WITH_MEAT" )
	object.create_item_in_inventory( character_id, "SET_SPIT" )
				
def post_cook_meat( character_id, item ):
	"""called after meat is cooked.
	The item used to cook is taken back into the inventory.
	The item used before it taken again.

character_id - id of character"""

	if item == "SET_PAN":
		character.play_animation( character_id, "CM_NPC_STEHEN_PFANNE_SCHWENKEN_AUFSTEHEN",[ "ONEND", add_normal_pan ] )
	elif item == "SET_SPIT":
		character.play_animation( character_id, "CM_KNIEND_BRATSPIESS_HALTEN_ENDE", [ "ONEND", add_normal_spit ] )
	elif item == "SET_POT_ON_A_BAR":
		character.play_animation( character_id, "CM_KNIEND_KOCHTOPF_HALTEN_ENDE" )
	
	object.step_away( character_id )

def can_gut_object( character_id, object_id ):
	"""returns true if the object can be gutted

character_id - id of the character
object_id - id of the object"""
#	print "basis can_gut_object"
	typeid = ""
	if object.has_attribute( object_id, "typeid" ):
		typeid = object.get_attribute( object_id, "typeid" )

	# check for animal
	if object.has_attribute(object_id, "type"):
		type = object.get_attribute(object_id, "type")
		if type=="animal" or typeid == "RES3D_WARGKADAVER_KOPFLOS":
			# knife in inventory?
			if (object.count_in_inventory( character_id, 'SET_KNIFE' ) or
				object.count_in_inventory( character_id, 'SET_BIG_KNIFE' )):
				# dead?
				if object.is_destroyed( object_id ) or object.get_attribute( object_id, "typeid" ) == "RES3D_WARGKADAVER_KOPFLOS":
					return True
				else:
					return False
			else:
				return False
	return False

def on_heal_light_wounds( character_id, character_target_id ):
	"""
character_id - id of the character
character_target_id - id of the targetChar"""
	#print "on_heal_light_wounds", character_id, character_target_id
	mode = character.get_body_mode(character_id)
	lambdastring = 'on_heal_light_wounds_callback("%s")' %(character_target_id)
	if character_id!=character_target_id:
		if mode == "STAND":
			character.play_animation( character_id, "CM_STEHEN_UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
		if mode == "KNEEL":
			character.play_animation( character_id, "CM_KNIEND_UEBERGEBEN_WAFFENLOS", callback=["ONEND", Lambda(lambdastring)] )
		if mode == "LIE":
			character.play_animation( character_id, "CM_LIEGEN_UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
	else:
		on_heal_light_wounds_callback(character_target_id)
		
def on_heal_light_wounds_callback( character_target_id ):
	#print "on_heal_light_wounds_callback",  character_target_id
	ackhit=object.get_attribute(character_target_id, "hitpoints")
	maxhit=object.get_attribute(character_target_id, "maxhitpoints")
	#//value .85 is also tested in y2kkichar.cpp
	if ackhit/maxhit > 0.85:
		object.set_attribute(character_target_id, "hitpoints",maxhit)

def on_psychology( character_id, character_target_id ):
	#print "on_psychology", character_id, character_target_id
	lambdastring = 'on_psychology_callback("%s","%s")' %(character_id,character_target_id)
	if character_id!=character_target_id:
		if mode == "STAND":
			character.play_animation( character_id, "UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
		if mode == "KNEEL":
			character.play_animation( character_id, "UEBERGEBEN_WAFFENLOS", callback=["ONEND", Lambda(lambdastring)] )
		if mode == "LIE":
			character.play_animation( character_id, "UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
	else:
		on_psychology_callback(character_id,character_target_id)

def on_psychology_callback( character_id,character_target_id ):
	#print "on_psychology_callback",  character_target_id
	can_use_psychology=True
	if object.has_attribute(character_target_id,"psychology_bonus"):
		if object.get_attribute(character_target_id,"psychology_bonus") ==True:
			can_use_psychology=False
	if can_use_psychology==True:
		object.set_attribute(character_id, "last_use_of_psychology", system.get_mission_time())
		object.set_attribute(character_target_id, "psychology_bonus",True)
		#needed: now its time to call the bonusfunction
		
def on_heal_alternative( character_id, character_target_id ):
	"""
character_id - id of the character
character_target_id - id of the targetChar"""
	#print "on_heal_alternative", character_id, character_target_id
	mode = character.get_body_mode(character_id)
	lambdastring = 'on_heal_alternative_callback("%s","%s")' %(character_id,character_target_id)
	if character_id!=character_target_id:
		if mode == "STAND":
			character.play_animation( character_id, "CM_STEHEN_UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
		if mode == "KNEEL":
			character.play_animation( character_id, "CM_KNIEND_UEBERGEBEN_WAFFENLOS", callback=["ONEND", Lambda(lambdastring)] )
		if mode == "LIE":
			character.play_animation( character_id, "CM_LIEGEN_UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
	else:
		on_heal_alternative_callback(character_target_id)
def on_heal_alternative_callback( character_id, character_target_id ):
	#print "on_heal_alternative_callback",  character_target_id
	if object.count_in_inventory(character_id, "SET_ALOE_VERA") >0:#SET_ALOE_VERA
		item_id="SET_ALOE_VERA"#SET_ALOE_VERA
	elif object.count_in_inventory(character_id, "SET_WOOD_GARLIC") >0:
		item_id="SET_WOOD_GARLIC"
	elif object.count_in_inventory(character_id, "SET_BURNET") >0:
		item_id="SET_BURNET"
	else:
		pass
		#print "nothing to alternative heal"

	if object.has_attribute(item_id, "le_recovery"):
		value = object.get_attribute(character_target_id, "hitpoints")
		value_max = object.get_attribute(character_target_id, "maxhitpoints")
		if value<value_max:
			# if the item itself has no recovery value
			# take the value of the item type
			le_recovery=object.get_attribute(item_id, "le_recovery")

			import skill_tables
			medicine = object.get_attribute(character_id, "medicine")
			used_charge = 0 # amount of charge that is used from the item
			remove_if_empty = True # should the item be removed from inventory if it is empty
			#print "medizinskill", medicine
			if item_id=="SET_ALOE_VERA": #SET_ALOE_VERA
				le_recovery+=skill_tables.medicine_aloe_vera(medicine)
				used_charge = 1
			elif item_id=="SET_WOOD_GARLIC":
				le_recovery+=skill_tables.medicine_wood_garlic(medicine)
				used_charge = 1
			elif item_id=="SET_BURNET":
				le_recovery+=skill_tables.medicine_burnet(medicine)
				used_charge = 1
				
			value+=le_recovery
			if value>value_max:
				value = value_max
				#print "heilung mit ", value
			object.set_attribute(character_target_id, "hitpoints", value)
			if(used_charge == 1):
				object.remove_item_from_inventory( character_id,item_id )
			system.update_ui()
			
def on_heal( character_id, character_target_id ):
	"""
character_id - id of the character
character_target_id - id of the targetChar"""
	print "on_heal", character_id, character_target_id
	mode = character.get_body_mode(character_id)
	lambdastring = 'on_heal_callback("%s","%s")' %(character_id,character_target_id)
	if character_id!=character_target_id:
		if mode == "STAND":
			character.play_animation( character_id, "CM_STEHEN_UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
		if mode == "KNEEL":
			character.play_animation( character_id, "CM_KNIEND_UEBERGEBEN_WAFFENLOS", callback=["ONEND", Lambda(lambdastring)] )
		if mode == "LIE":
			character.play_animation( character_id, "CM_LIEGEN_UEBERGEBEN_WAFFENLOS" , callback=["ONEND", Lambda(lambdastring)])
	else:
		on_heal_callback(character_id, character_target_id)

def on_heal_callback( character_id, character_target_id ):
	#print "on_heal_callback",  character_target_id
	
	if object.count_in_inventory(character_id, "SET_MEDIPACK_SMALL") >0:#
		item_type="SET_MEDIPACK_SMALL"#
	elif object.count_in_inventory(character_id, "SET_ALOE_VERA_OINTMANT") >0:
		item_type="SET_ALOE_VERA_OINTMANT"
	elif object.count_in_inventory(character_id, "SET_WOOD_GARLIC_OINTMANT") >0:
		item_type="SET_WOOD_GARLIC_OINTMANT"
	elif object.count_in_inventory(character_id, "SET_BURNET_OINTMANT") >0:
		item_type="SET_BURNET_OINTMANT"
	elif object.count_in_inventory(character_id, "SET_MEDIPACK_BIG") >0:
		item_type="SET_MEDIPACK_BIG"
	elif object.count_in_inventory(character_id, "SET_MULTI_MEDIPACK") >0:
		item_type="SET_MULTI_MEDIPACK"
	else:
		pass
		#print "nothing to  heal"
	item_id=get_item_of_type_from_inventory(character_id, item_type)
	#print item_id
	if object.has_attribute(item_type, "le_recovery"):
		value = object.get_attribute(character_target_id, "hitpoints")
		value_max = object.get_attribute(character_target_id, "maxhitpoints")
		#print "heal ",value, value_max
		if value<value_max:
			# if the item itself has no recovery value
			# take the value of the item type
			if object.has_attribute( item_type, "le_recovery" ):
				le_recovery=object.get_attribute(item_type, "le_recovery")

			import skill_tables
			medicine = object.get_attribute(character_id, "medicine")
			used_charge = 0 # amount of charge that is used from the item
			remove_if_empty = True # should the item be removed from inventory if it is empty

			if item_type=="SET_MEDIPACK_SMALL":
				le_recovery+=skill_tables.medicine_medipack_standard(medicine)
				used_charge = 1
			elif (item_type=="SET_MEDIPACK_BIG"):
				le_recovery+=skill_tables.medicine_medipack_big(medicine)
				used_charge = 1
			elif (item_type=="SET_MULTI_MEDIPACK"):
				le_recovery+=skill_tables.medicine_medipack_big(medicine)
				used_charge = 1
			elif (item_type=="SET_ALOE_VERA_OINTMENT" ):
				le_recovery+=skill_tables.medicine_aloe_vera_ointment(medicine)
				used_charge = 1
			elif (item_type=="SET_WOOD_GARLIC_OINTMENT" ):
				le_recovery+=skill_tables.medicine_wood_garlic_ointment(medicine)
				used_charge = 1
			elif (item_type=="SET_BURNET_OINTMENT" ):
				le_recovery+=skill_tables.medicine_burnet_ointment(medicine)
				used_charge = 1
				
			value+=le_recovery
			if value>value_max:
				value = value_max
			object.set_attribute(character_target_id, "hitpoints", value)

			charge = 0
			if object.has_attribute(item_id, "charge"):
				charge = object.get_attribute(item_id, "charge")
				charge-=used_charge
			elif object.has_attribute(item_type, "charge"):
				charge = object.get_attribute(item_type, "charge")
				charge-=used_charge
			assert charge >= 0
			if charge == 0 and remove_if_empty:
				object.remove_item_from_inventory(character_id, item_id)
			else:
				object.set_attribute(item_id, "charge", charge)

			system.update_ui()
			object.set_attribute(character_id, "is_healing",False )

def pre_gut_object( character_id ):
	"""called before a object is gutted.
	Equips the player with a weapon needed to gut
	and marks the old item, so that it can be
	equip again after gutting.

character_id - id of the character"""

	# list of weapon that can be used to gut objects
	gut_weapons = [ 'SET_KNIFE', 'SET_BIG_KNIFE' ]

	equip_and_mark_unequiped( character_id, gut_weapons, "gut_item" )

def post_lay_down_char( carrying_char_id, carried_char_id ):
	"""Is called when a char begins to lay down the one
	he is carrying.

carrying_char_id - id of the char that is going to lay down the other
carried_char_id - id of the carried char
"""
	None

def pre_carry_char( carrying_char_id, carried_char_id ):
	"""Is called when a char begins to carry another char

carrying_char_id - id of the char that is going to char the other
carried_char_id - id of the carried char
"""
	None

def post_gut_object( character_id, object_id = None ):
	"""called after a object is gutted.
	The weapon used to gut is taken back into the inventory.
	The item used before it taken again.

character_id - id of character
object_id - id of the animal that is gutted
"""
	if object_id:
		if object.has_attribute(object_id, "typeid"):
			animal = object.get_attribute(object_id, "typeid")
			if animal == "WARG" and object.has_attribute( object_id, "has_head_in_inventory" ):
				# check if warghead is taken
				if object.count_in_inventory( object_id, "SET_WARG_HEAD" ) == 0:
					object.set_attribute( object_id, "has_head_in_inventory", None )

					# replace the warg with the head with one without it,-)
					# first save old warg data
					x = object.get_x( object_id )
					y = object.get_y( object_id )
					direction = object.get_direction( object_id )
					
					object.set_active_state( object_id, False )
					new_warg = system.create_object( "RES3D_WARGKADAVER_KOPFLOS", x, y, object_id + "_HEADLESS", direction )
					object.set_attribute( new_warg, "disembowl_level", object.get_attribute( object_id, "disembowl_level" ) )

					for item in object.get_inventory_list( object_id ):
						object.create_item_in_inventory( new_warg, item )

	unequip_and_equip_marked( character_id, "gut_item" )

def npc_ki_loot_corpse(char):
	corpse_action_range = 30
	if not system.in_combat_mode() and not object.is_fighting(char):
		# only loot if there is enough inventory space, leave reserve for scripting
		available_slots = len(object.get_inventory_ids(char)) - len(object.get_inventory_id_list(char))
		if available_slots < 6: return
		
		x = object.get_x(char)
		y = object.get_y(char)
		all_chars_in_range = system.get_objects(type="character", left=x-corpse_action_range,
			top=y-corpse_action_range, right=x+corpse_action_range, bottom=y+corpse_action_range)
		corpses = filter(lambda ch: object.is_destroyed(ch), all_chars_in_range)
		for corpse in corpses:
			# corpse should only be looted once
			if object.has_attribute(corpse, "looted_by_npc")\
			and object.get_attribute(corpse, "looted_by_npc")==True: continue
			
			# don't loot if pc is closer than 10 meter
			for pc in system.get_pcs():
				if pc != corpse and object.get_distance(pc, corpse) < 10: continue
			
			# don't loot if corpse has quest item
			cont = False
			for item in object.get_inventory_id_list(corpse):
				if object.has_attribute(item, "generic_item")\
				and object.get_attribute(item, "generic_item")==False:
					cont=True
					break
			if cont: continue
			
			#print char, "loots", corpse
			object.set_attribute(corpse, "looted_by_npc", True)
			npc_loots_npc(char, corpse)
			break
	
def npc_loots_npc(looter, looted):
	assert object.is_destroyed(looted)

	pos = get_loot_position(looted)
	if pos == None:
		object.set_attribute(looted, "looted_by_npc", False)
		return
	data("delayed_callback").pos = pos 
	data("delayed_callback").looter = looter 
	data("delayed_callback").looted = looted
	data("delayed_callback").function = npc_loots_npc_2 
	data("delayed_callback").cancel_commandos = looter 
	object.move_to(looter, pos[0], pos[1], callback=Lambda("system.notify_global_timer('delayed_callback', 100)"))
def npc_loots_npc_2():
	pos = data("delayed_callback").pos
	looter = data("delayed_callback").looter
	looted = data("delayed_callback").looted
	
	# don't loot if pc is closer than 10 meter
	for pc in system.get_pcs():
		if pc != looted and object.get_distance(pc, looted) < 10: return
		
	# play animations
	object.turn_to_direction(looter, object.get_direction_to_object(looter, looted)+pos[2])
	character.play_animation(looter, "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
	character.play_animation(looter, "CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
	character.play_animation(looter, "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE")
	
	# only loot if there is enough inventory space, leave reserve for scripting
	available_slots = object.get_inventory_slot_count(char) - len(filter(lambda slot: len(slot[0]), object.get_inventory_ids(char)))
	max_looted_items = available_slots - 5
	
	# transfer items
	loot = object.get_inventory_id_list(looted)
	while max_looted_items > 0 and len(loot):
		object.transfer_item(looted, loot.pop(0), looter)
		max_looted_items -= 1

	
def get_loot_position( looted ):
	"""Returns the position where the char
	should move to loot the corpse.

use get_gut_position if you want to loot an animal.

looted - id of the char that should be looted"""

	offsets = {
		"CM_STERBEN_ZUSAMMENSACKEN"			: [ 0.70,  0.00,   0],		
		"CM_STERBEN_SACKEN_NACH_LINKS"		: [ 0.00,  0.70,   0],		
		"CM_STERBEN_SACKEN_NACH_VORN"		: [ 0.70, -0.20,   0],		
		"CM_STERBEN_SACKEN_NACH_HINTEN"		: [-0.70,  0.20,   0],		
		"CM_STERBEN_FALLEN_NACH_VORN"		: [ 0.75, -0.05,   0],
		"CM_STERBEN_FLIEGEN_NACH_VORN"		: [ 0.75,  0.15,   0],
		"CM_STERBEN_FLIEGEN_NACH_HINTEN"	: [ 0.70,  0.00,   0],
		"CM_KNIEND_STERBEN1"				: [ 0.75, -0.10,   0],		
		"CM_LIEGEN_STERBEN"					: [ 0.65, -0.30,   0],		
		"CM_NPC_SIEBENSEELE_STERBEN"		: [-0.55,  0.55,   0]
	}
	
	# get offset
	anim = character.get_act_animation_name(char=looted)
	if anim not in offsets:
		return None
		# apparently the death animation is set with a delay. a char can be dead already but can
		# still have his old animation for a moment. 
		# raise Exception, "char '%s' has unknown death animation '%s'" % (looted, anim)
	offset = offsets[anim]
	
	# get corpse base point
	corpse_x = object.get_x(looted)
	corpse_y = object.get_y(looted)
	
	# get distance between corpse and loot point
	radius = math.sqrt(offset[0]**2 + offset[1]**2)

	# get direction of the corpse 
	direction = object.get_direction(looted)
	
	# direction to loot point for corpse direction == 0 
	target_dir = object.get_direction_to_position(looted, corpse_x + offset[0], corpse_y + offset[1])
	
	# move loot point according to rotation/direction of the corpse
	angle = math.radians(target_dir + direction)
	target_x = corpse_x + math.sin(angle) * radius
	target_y = corpse_y - math.cos(angle) * radius
	
	return [target_x, target_y, offset[2]]

	
def get_gut_position( character_id, animal_id ):
	"""Returns the position where the char
	should move to gut the object.

character_id - id of the character
animal_id - id of the animal that should be gutted"""
	print "get_gut_position", character_id, animal_id
	animal = None	
	# x and y offset from the animals position coordinates to the
	# desired char destination alongside the animals direction
	x_offset = 0.0
	y_offset = 0.0
	dir_offset = 0.0

	if object.has_attribute( animal_id, "typeid" ):
		animal = object.get_attribute( animal_id, "typeid" )
		
	pelvis_node_available = False

	if (animal=="BEAR"):
		x_offset = 0.4
		y_offset = 0.55
		dir_offset = -20
		pelvis_node_available = True
	elif (animal=="TIGER"):
		x_offset = 0.6
		y_offset = -0.7
		dir_offset = 15
		pelvis_node_available = True
	elif (animal=="WOLF"):
		x_offset = 1.2
		y_offset = -0.1
		dir_offset = 40
		pelvis_node_available = True
	elif (animal=="HORSE"):
		None
		pelvis_node_available = True
	elif (animal=="COW"):
		x_offset = 1.7
		y_offset = 0.1
		pelvis_node_available = True
	elif (animal=="DEER"):
		x_offset = 0.5
		y_offset = 0.3
		pelvis_node_available = True
	elif (animal=="HYENA"):
		x_offset = 0.5
		y_offset = 0.0
		pelvis_node_available = True
	elif (animal=="ANTELOPE"):
		x_offset = 1.0 
		y_offset = 0.2
		pelvis_node_available = True
	elif (animal=="WILDDOG"):
		x_offset = 0.5
		y_offset = 0.1
		pelvis_node_available = True
	elif (animal=="BISON"):
		x_offset = 0.7
		y_offset = 1.05
		dir_offset = 20
		pelvis_node_available = True
	elif (animal=="LIZARD"):
		x_offset = 2.0
		y_offset = 0.0
		pelvis_node_available = True
	elif (animal=="PIG"):
		x_offset = 2.0
		y_offset = 0.0
		pelvis_node_available = True
	elif (animal=="DONKEY"):
		x_offset = 2.0
		y_offset = 0.0
		pelvis_node_available = True
	elif (animal=="WARG"):
		x_offset = 0.6
		y_offset = -1.0
		dir_offset = 35
		pelvis_node_available = True
	elif (animal=="RES3D_WARGKADAVER_KOPFLOS"):
		x_offset = 1.0
		y_offset = -0.2
	else:
		x_offset = 0.0
		y_offset = 0.0

	# get direction of the animal and 
	direction = object.get_direction( animal_id ) 
	# direction is measured clockwise
	# turn it counterclockwise for sin/cos functions
	direction = 360 - direction
	# convert it from degree to radiant
	direction = 2.0 * math.pi * ( direction / 360 )

	# calc the extra angle for the offsets
	if x_offset != 0:
		extraAngle = math.atan( y_offset / x_offset )
	else:
		extraAngle = math.pi / 2.0
	
	direction = direction + extraAngle
	#print "get_gut_position", object.get_direction( animal_id ), direction

	# distance from animal position to desired
	# char destination
	dist = math.hypot( x_offset, y_offset )

	# calc the new char positions
	if pelvis_node_available:
		animal_x, animal_y, animal_z = object.get_full_dummy_position( animal_id, "Bip01 Pelvis" )
	else:
		animal_x = object.get_x( animal_id )
		animal_y = object.get_y( animal_id )

	desiredPosX = animal_x - dist * math.sin( direction )
	desiredPosY = animal_y - dist * math.cos( direction )

	direction = object.get_direction_to_position(animal_id, desiredPosX, desiredPosY)
	direction += 180
	direction += dir_offset
	return [ desiredPosX, desiredPosY, direction ]

	
def on_gut_object( character_id, object_id ):
	"""called if an item is gutted by a character
	
character_id - id of the character
object_id - id of the object"""

	old_level = 0
	if object.has_attribute( object_id, "disembowl_level" ):
		old_level = object.get_attribute( object_id, "disembowl_level" )
	new_level = object.get_attribute( object=character_id, attribute="survival" )

	old_meat = 0
	old_teeth = False
	old_claws = False
	old_pelt = False
	meat = 0
	teeth = False
	claws = False
	pelt = False

	import random
	rand = random.random()
	animal = None	

	if object.has_attribute(object_id, "typeid"):
		animal = object.get_attribute(object_id, "typeid")

	if (new_level <= 14):
		# 40% chance of injuring
		if rand < 0.4:
			object.damage( character_id, 5 )
			comments.comment(character_id=character_id, text="DISEMBOWL_INJURY")
	elif (new_level <= 39):
		# 20% chance of injuring
		if rand < 0.2:
			object.damage( character_id, 5 )
			comments.comment(character_id=character_id, text="DISEMBOWL_INJURY")

	if (new_level > old_level):
		object.set_attribute( object_id, "disembowl_level", new_level )

		# what stuff gets char
		if (new_level >= 40):
			if (new_level <= 54):
				# meat for 1 hitpoint
				meat = 1
			elif (new_level <= 69):
				# meat for 3 hitpoints
				meat = 3
			elif (new_level <= 84):
				# meat for 6 hitpoints + pelt
				meat = 6
				pelt = True
			elif (new_level <= 94):
				# meat for 8 hitpoints + pelt + claws
				meat = 8
				pelt = True
				claws = True
			else:
				# meat for 10 hitpoints + pelt + claws + teeth
				meat = 10
				pelt = True
				claws = True
				teeth = True

		# what stuff theoretically already disembowled
		if (old_level >= 40):
			if (old_level <= 54):
				# meat for 1 hitpoint
				old_meat = 1
			elif (old_level <= 69):
				# meat for 3 hitpoints
				old_meat = 3
			elif (old_level <= 84):
				# meat for 6 hitpoints + pelt
				old_meat = 6
				old_pelt = True
			elif (old_level <= 94):
				# meat for 8 hitpoints + pelt + claws
				old_meat = 8
				old_pelt = True
				old_claws = True
			else:
				# meat for 10 hitpoints + pelt + claws + teeth
				old_meat = 10
				old_pelt = True
				old_claws = True
				old_teeth = True

		# Look for existing meat in the animals inventory.
		# Remove it but remember the amount of meat to
		# add it to the newly gutted meat.
		# This prevents the existence of many small pieces
		# of meat in the animals inventory
		existing_meat = 0
		inventory = object.get_inventory_list( object_id )

		if inventory:
			meat_rating = {	'SET_MEAT_RAW_HUMONGOUS': 10,
					'SET_MEAT_RAW_BIG': 8,
					'SET_MEAT_RAW': 6,
					'SET_MEAT_RAW_SMALL': 3,
					'SET_MEAT_RAW_TINY': 1 }

			for item in inventory:
				# if the item is meat then add it to the existing meat
				if meat_rating.has_key( item ):
					existing_meat = existing_meat + meat_rating[ item ]
					# remove existing meat from the inventory
					object.remove_item_from_inventory( object_id, item )

		
		# diff of old and new stuff
		meat = meat - old_meat + existing_meat
		pelt = pelt and not old_pelt
		claws = claws and not old_claws
		teeth = teeth and not old_teeth

		# calc item list
		stuff = []
		if meat >= 10:
			meat = meat - 10
			stuff.append( "SET_MEAT_RAW_HUMONGOUS" )
		if meat >= 8:
			meat = meat - 8
			stuff.append( "SET_MEAT_RAW_BIG" )
		if meat >= 6:
			meat = meat - 6
			stuff.append( "SET_MEAT_RAW" )
		if meat >= 3:
			meat = meat - 3
			stuff.append( "SET_MEAT_RAW_SMALL" )
		# add remaining 1 hitpoint meat 
		for x in range( meat ):
			stuff.append( "SET_MEAT_RAW_TINY" )

		if (animal=="BEAR"):
			if pelt:
				stuff.append( "SET_BEAR_SKIN" )
			if claws:
				stuff.append( "SET_BEAR_CLAW" )
			if teeth:
				stuff.append( "SET_BEAR_TEETH" )
		elif (animal=="TIGER"):
			if pelt:
				stuff.append( "SET_TIGER_FUR" )
			if claws:
				stuff.append( "SET_TIGER_CLAW" )
			if teeth:
				stuff.append( "SET_TIGER_TEETH" )
		elif (animal=="WOLF"):
			if pelt:
				stuff.append( "SET_WOLF_PELT" )
			if claws:
				stuff.append( "SET_WOLF_CLAW" )
			if teeth:
				stuff.append( "SET_WOLF_TEETH" )
		elif (animal=="HORSE"):
			if pelt:
				stuff.append( "SET_HORSE_SKIN" )
		elif (animal=="COW"):
			if pelt:
				stuff.append( "SET_COW_SKIN" )
		elif (animal=="DEER"):
			if pelt:
				stuff.append( "SET_DEER_SKIN" )
		elif (animal=="HYENA"):
			if pelt:
				stuff.append( "SET_HYENA_PELT" )
			if claws:
				stuff.append( "SET_HYENA_CLAW" )
			if teeth:
				stuff.append( "SET_HYENA_TEETH" )
		elif (animal=="DONKEY"):
			None
			#if pelt:
				#stuff.append( "SET_DONKEY_PELT" )
		elif (animal=="PIG"):
			None
			#if pelt:
				#stuff.append( "SET_PIG_PELT" )
		elif (animal=="ANTELOPE"):
			if pelt:
				stuff.append( "SET_ANTELOPE_PELT" )
		elif (animal=="WILDDOG"):
			if pelt:
				stuff.append( "SET_WILD_DOG_PELT" )
			if claws:
				stuff.append( "SET_WILD_DOG_CLAW" )
			if teeth:
				stuff.append( "SET_WILD_DOG_TEETH" )
		elif animal=="WARG" or animal == "RES3D_WARGKADAVER_KOPFLOS":
			if object.count_in_inventory( object_id, "SET_WARG_HEAD" ) > 0:
				object.set_attribute( object_id, "has_head_in_inventory", True )
			None # warg has nothing to gut. But it must be recognized by this function.
		elif (animal=="BISON"):
			if pelt:
				stuff.append( "SET_BISON_SKIN" )
		else:
			raise ValueError, "unknown animal type '" + object_id + "'"

		if stuff:
			object.create_item_in_inventory(
				object=object_id, equipment=stuff)

	inventorylist = object.get_inventory_list(object_id)

	if len( inventorylist ) > 0:
		system.item_panel( character_id, object_id )


def update_speed( character_id ):
	"""calculates and sets character speed depending on strength and load
	
character_id - id of the character"""

	import skill_tables
	load = float(character.get_load( char=character_id ))

	strength = object.get_attribute( object=character_id, attribute="strength" )
	speed_factor = skill_tables.agility_move_speed(
		object.get_attribute( object=character_id, attribute="agility" ))

	if strength == 0: rel_load = 0
	else: rel_load = load / skill_tables.strength_max_load(strength)
	speed_factor *= skill_tables.strength_move_speed(rel_load)
	
	# move silent talents can influence speed for bodymodes "KNEEL" & "LIE"
	mode = character.get_body_mode(character_id)
	if mode == "KNEEL" and has_talent(character_id, "sneak", "sneak_fast"):
		speed_factor *= 1.5
	if mode == "LIE" and has_talent(character_id, "sneak", "crawl_fast"):
		speed_factor *= 2.0
		
	if character.is_carrying_char(character_id) or character.is_carried(character_id):
		speed_factor = 1.0

	object.set_attribute( object=character_id, attribute="rel_load", value=rel_load )
	object.set_attribute( object=character_id, attribute="speed_factor", value=speed_factor )


def can_equip( objectid, itemtype ):
	"""returns True if the char can equip the item
	
objectid - id of the character
itemtype - type of the item
"""
	# only player characters can equip
	if not character.exists(objectid):
		return False

	if object.is_unconscious( objectid ):
		return False

	# only items with non empty "occupied_slots" attribute are equipable
	if not object.has_attribute(itemtype, "occupied_slots"):
		return False
	if not len(object.get_attribute(itemtype, "occupied_slots")):
		return False

	# char may have unusable/forbidden slots
	if object.has_attribute(objectid, "forbidden_slots"):
		used_slots = object.get_attribute(itemtype, "occupied_slots")
		forbidden_slots = object.get_attribute(objectid, "forbidden_slots")
		for slot in used_slots:
			if slot in forbidden_slots:
				return False

	return True

def can_unequip( objectid, itemtype ):
	"""returns true if the char can unequip this item

objectid - id of the character
itemtype - type of the item
"""
	# only player characters can equip
	if not character.exists(objectid):
		return False

	if object.is_unconscious( objectid ):
		return False

	return True

def helper_appearance(objectid, appearance_slot, itemtype):
	"""helper function for on_equip and on_unequip"""
	object.set_attribute(objectid, appearance_slot, itemtype)
	character.update_appearance(objectid)
	calc_armor_value(objectid)

def helper_remove_weapon_accustomisation(objectid, itemtype, itemid):
	"""helper function for on_equip, on_unequip and on_object_killed"""

	if not objectid or not len(objectid): return
	if not itemtype or not len(itemtype): return
	if not object.has_attribute(itemtype, "item_type"): return
	if object.get_attribute(itemtype, "item_type")!="weapon": return
	slot = object.get_attribute(itemtype, "occupied_slots")[0]
	#if not object.has_attribute(objectid, "weapon_accustom_skill_bonus" + slot): return

	#jan: does currently not work for wurf weapons
	type = object.get_attribute(itemtype, "weapon_type")
	if(type=="wurf"):
		return
	
	assert len(type)
	type_list = ["schwer", "leicht", "sniper", "wurf"]
	skill_list = ["heavy_weapons", "light_weapons", "sniper_weapons", "throw_weapons"]
	if type in type_list:
		bonus = object.get_attribute(objectid, "weapon_accustom_skill_bonus" + slot)
		skill = skill_list[type_list.index(type)]
		object.set_attribute(objectid, skill,  object.get_attribute(objectid, skill) - bonus)
		# some kind of bonus must have been set; possible that it is zero
		# but the attribute has to be there
		assert object.has_attribute(objectid, "weapon_accustom_skill_bonus" + slot)
		# remove attribute
		object.set_attribute(objectid, "weapon_accustom_skill_bonus" + slot, None)

def helper_add_weapon_accustomisation(objectid, itemtype, itemid):
	"""helper function for on_equip, on_unequip and on_object_killed"""

	if not objectid or not len(objectid): return
	if not itemtype or not len(itemtype): return
	if not object.has_attribute(itemtype, "item_type"): return
	if object.get_attribute(itemtype, "item_type")!="weapon": return
	# if not objectid in system.get_pcs(): return
	slot = object.get_attribute(itemtype, "occupied_slots")[0]
	
	# danger, will robinson! "weapon_accustom_skill_bonus" didn't got removed correctly
	# skill might have a wrong value now!!!
	# slot based throw weapons use another slot as rifles or pistols so 
	# they don't interfere
	
	#jan: does currently not wor for throwing weapons, so early out here
	type = object.get_attribute(itemtype, "weapon_type")
	if(type=="wurf"):
		return
	assert not object.has_attribute(objectid, "weapon_accustom_skill_bonus" + slot)

	id_kills = 0
	type_kills = 0
	if object.has_attribute(objectid, "weapon_type_history"):
		weapon_type_history = object.get_attribute(objectid, "weapon_type_history")
		if itemtype in weapon_type_history:
			type_kills = weapon_type_history[itemtype]
			type_kills = type_kills[0] + type_kills[1]
	if object.has_attribute(objectid, "weapon_id_history"):
		weapon_id_history = object.get_attribute(objectid, "weapon_id_history")
		if itemid in weapon_id_history:
			id_kills = weapon_id_history[itemid]
			id_kills = id_kills[0] + id_kills[1]
	bonus = skill_tables.weapon_accustoming(id_kills, type_kills)
	type = object.get_attribute(itemtype, "weapon_type")
	assert len(type)
	type_list = ["schwer", "leicht", "sniper", "wurf"]
	skill_list = ["heavy_weapons", "light_weapons", "sniper_weapons", "throw_weapons"]
	if type in type_list:
		skill = skill_list[type_list.index(type)]
		object.set_attribute(objectid, "weapon_accustom_skill_bonus" + slot, bonus)
		object.set_attribute(objectid, skill,  object.get_attribute(objectid, skill) + bonus)

def helper_update_talent_effects(objectid):
	weapon_id = character.get_primary_weapon(objectid)
	if weapon_id != "":
		weapon_type = object.get_attribute(weapon_id, "typeid")
		helper_remove_talent_effects(objectid, weapon_type, weapon_id)
		helper_add_talent_effects(objectid, weapon_type, weapon_id)

def helper_remove_talent_effects(objectid, itemtype, itemid):
	"""helper function for on_equip"""
	object.set_attribute(objectid, "headshot_chance", None)
	object.set_attribute(objectid, "critical_hit_chance", None)
	object.set_attribute(objectid, "reload_speed_factor", None)
	object.set_attribute(objectid, "knockout_chance", None)
	object.set_attribute(objectid, "baffle_chance", None)
	object.set_attribute(objectid, "combo_chance", None)

def helper_add_talent_effects(objectid, itemtype, itemid):
	"""helper function for on_equip"""
	if not objectid or not len(objectid): return
	if not itemtype or not len(itemtype): return
	if not object.has_attribute(itemtype, "item_type"): return
	if object.get_attribute(itemtype, "item_type")!="weapon": return
	
	type = object.get_attribute(itemtype, "weapon_type")
	assert len(type)
	if type == "leicht":
		if has_talent(objectid, "light_weapons", "headshot"):
			object.set_attribute(objectid, "headshot_chance", 0.05)
		if has_talent(objectid, "light_weapons", "critical_hit"):
			object.set_attribute(objectid, "critical_hit_chance", 0.1)
		if has_talent(objectid, "light_weapons", "fast_reload"):
			object.set_attribute(objectid, "reload_speed_factor", 5.0)
	if type == "schwer":
		if has_talent(objectid, "heavy_weapons", "critical_hit"):
			object.set_attribute(objectid, "critical_hit_chance", 0.1)
		if has_talent(objectid, "heavy_weapons", "fast_reload"):
			object.set_attribute(objectid, "reload_speed_factor", 5.0)
	if type == "sniper":
		if has_talent(objectid, "sniper_weapons", "headshot"):
			object.set_attribute(objectid, "headshot_chance", 0.3)
	if type == "nahkampf":
		if has_talent(objectid, "close_combat", "atc"):
			object.set_attribute(objectid, "knockout_chance", 0.1)
		if has_talent(objectid, "close_combat", "baffle"):
			object.set_attribute(objectid, "baffle_chance", 0.1)
		if has_talent(objectid, "close_combat", "combo"):
			object.set_attribute(objectid, "combo_chance", 0.2)

def on_equip(objectid, itemtype, itemid):
	"""is called when a character equips an item
	
objectid - id of the character
itemtype - type of the item
itemid   - id of the item
"""
	if not can_equip( objectid, itemtype ) \
		and not (object.has_attribute(objectid, "direct_equip") \
				 and object.get_attribute(objectid, "direct_equip")):
		raise ValueError, "object '" + str(objectid) + "' can not equip item '" + itemtype + "'"

	if not object.has_attribute(objectid, "slots"):
		object.set_attribute(objectid, "slots", {})

	# unequip items to make room for the new item
	item_slots = object.get_attribute(itemtype, "occupied_slots")
	if object.has_attribute(itemtype, "blocked_slots"):
		item_slots = item_slots + object.get_attribute(itemtype, "blocked_slots")
	if not object.has_attribute(objectid, "equip_dont_setup_attributes"):
		for slot in item_slots:
			if slot in object.get_attribute(objectid, "slots"):
				if object.get_attribute(objectid, "slots")[slot]:
					character.un_equip(objectid, object.get_attribute(objectid, "slots")[slot])
		# register new item in chars equip slots
		slots = object.get_attribute(objectid, "slots")
		for slot in item_slots:
			slots[slot] = itemid
		object.set_attribute(objectid, "slots", slots)

	# set new appearance
	if "helm" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "helmet", itemtype)
	elif "boots" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "clothes_boots", itemtype)
	elif "gloves" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "clothes_gloves", itemtype)
	elif "clothes" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "clothes", itemtype)

	if not object.has_attribute(objectid, "equip_dont_setup_attributes"):
		# add skill bonus from weapon accustomisation
		helper_add_weapon_accustomisation(objectid, itemtype, itemid)
	
		# add talent effects
		helper_add_talent_effects(objectid, itemtype, itemid)
	
	if itemtype=="SET_NIGHT_VISION_GEAR" or itemtype=="SET_BINOCULARS":
		calc_perception_values(objectid)


def on_unequip(objectid, itemtype, itemid):
	"""is called when a character unequips an item
	
objectid - id of the character
itemtype - type of the item
itemid   - id of the item
"""
	#if globals.LOCAL_USER!=USER_ALEXANDER_MISELER:
	#	print "on_unequip", objectid, itemtype

	# unregister item from chars equip slots
	item_slots = object.get_attribute(itemtype, "occupied_slots")
	if object.has_attribute(itemtype, "blocked_slots"):
		item_slots = item_slots + object.get_attribute(itemtype, "blocked_slots")
		
	if not object.has_attribute(objectid, "equip_dont_setup_attributes"):
		slots = object.get_attribute(objectid, "slots")
		for slot in item_slots:
			slots[slot] = None
		object.set_attribute(objectid, "slots", slots)

	# set new appearance
	if "helm" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "helmet", None)
	elif "boots" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "clothes_boots", "naked")
	elif "gloves" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "clothes_gloves", "naked")
	elif "clothes" in object.get_attribute(itemtype, "occupied_slots"):
		helper_appearance(objectid, "clothes", "naked")

	if not object.has_attribute(objectid, "equip_dont_setup_attributes"):
		# remove weapon accustomisation skill bonus
		helper_remove_weapon_accustomisation(objectid, itemtype, itemid)

		# remove talent effects
		helper_remove_talent_effects(objectid, itemtype, itemid)

	if itemtype=="SET_NIGHT_VISION_GEAR" or itemtype=="SET_BINOCULARS":
		calc_perception_values(objectid)

def trader_filter( item_list, filter ):
	if filter=="all":
		return item_list
	filter_result = []
	if filter=="weapons":
		for item in item_list:
			if object.has_attribute(item, "item_type"):
				if object.get_attribute(item, "item_type")=="weapon":
					filter_result.append(item)
	elif filter=="ammo":
		for item in item_list:
			if object.has_attribute(item, "item_type"):
				if object.get_attribute(item, "item_type")=="ammo":
					filter_result.append(item)
	elif filter=="armor":
		for item in item_list:
			if object.has_attribute(item, "armor"):
				filter_result.append(item)
	elif filter=="le_recovery":
		for item in item_list:
			if object.has_attribute(item, "le_recovery"):
				filter_result.append(item)
	return filter_result

def on_update_trader( character_id ):
	"""is called when the trading panel opens
	
character_id - id of the trader"""
	if object.has_attribute( character_id, "last_trade" ):
		last_trade_time = object.get_attribute(character_id, "last_trade")
		act_time = system.get_mission_time()
		elapsed_time = act_time - last_trade_time
		elapsed_days = elapsed_time / time("24:00:00")
	else:
		pass

def on_exit_trader( trader_id, negotiator_id, profit ):
	"""is called when the trading panel is closed
	
trader_id     - id of the trader
negotiator_id - id of the customer
profit        - profit in percent (can be negative)
"""
	#save last trade time
	object.set_attribute( trader_id, "last_trade", system.get_mission_time() )

	#save bonus/malus
	bonus_malus = {}

	if object.has_attribute(trader_id, "bonus_malus"):
		bonus_malus = object.get_attribute( trader_id, "bonus_malus")
	value = 0
	if profit>30:
		value = 10
	elif profit>20:
		value = 5
	elif profit>10:
		value = 0
	else:
		value = -5

	bonus_malus[negotiator_id] = value
	object.set_attribute( trader_id, "bonus_malus", bonus_malus)
	#print "bonus/malus:     %s" % (bonus_malus)

def on_approach( target, operator ):
	"""is called when a player char talks to another char or object
	
target   - char/object that is talked to (can also be a player char)
operator - char that starts the talk"""
	npcs = system.get_npcs()
	if target in npcs and did_fail_heist( operator ):
		random_comment( target, "NPC_THEFT_DENY_TALK_", 5 )
		return True
	return global_character.on_approach( target, operator )

def on_party_left( character_id ):
	"""is called when a char leaves the player party

character_id - id of the char
"""
	global_character.on_party_left( character_id )

	# deactivate effect of the survive talent when the character is kicked
	# out of the party
	if object.has_attribute( character_id, "survive_active" ):
		object.set_attribute( character_id, "survive_active", None )
		object.set_attribute( character_id, "hitpoints", hitpoints * 0.9 )

	object.set_attribute( character_id, "joined_party_time", None )

def on_party_join( character_id ):
	"""is called of a char joins the party

character_id - id of the char
	"""
	object.set_attribute( character_id, "joined_party_time", system.get_mission_time() )


def can_steal_from( thief, victim ):
	"""returns true if the thief can steal from the victim.
	Therefore the thief must be an PC and the victim must 
	be a NPC.

thief - id of the thief
victim - id of the victim"""

	if object.is_npc( victim ) and object.is_pc( thief ):
		return True
	else:
		return False

def is_in_front( object_id, target_id ):
	"""test if the object is in front of the target.
	returns true if object is in front of target.

object_id - id of the object. It is check if this object is in front of target
target_id - id of the object where the above object is in front of. """
	oX,oY,oZ = object.get_position( object_id )
	tX, tY, tZ = object.get_position( target_id )

	# calc the vector from object to target
	o2t_vector = [ tX - oX, tY - oY ]
	# the north vector, because this is where the direction depends on
	north = [ 0, -1 ]

	# some intermediate steps
	numerator = ( o2t_vector[0] * north[0] + o2t_vector[1] * north[1] ) 
	denominator1 = math.sqrt( math.pow( o2t_vector[0], 2 ) + math.pow( o2t_vector[1], 2 ) )
	denominator2 = math.sqrt( math.pow( north[0], 2 ) + math.pow( north[1], 2 ) )
	denominator = denominator1 * denominator2

	# calc the direction of the object to the target in degree
	o2t_direction = 0
	if denominator != 0:
		if ( math.pi * math.acos( numerator / denominator ) ) != 0:
			o2t_direction = 180 / math.pi * math.acos( numerator / denominator )
	
	target_direction = object.get_direction( target_id )

	if target_direction < 90:
		# normalize values
		target_direction = target_direction + 90
		o2t_direction = o2t_direction + 90
		
		if o2t_direction >= 360:
			o2t_direction = o2t_direction - 360

	if abs( o2t_direction - target_direction ) <= 90:
		return False
	else:
		return True

def calc_steal_chance( target, operator ):
	"""calculates the chance to steal something from a char
	Returns the chance

operator - id of the thief
target   - id of the victim
	"""

	import skill_tables

	if not ( object.is_npc( target ) and object.is_pc( operator ) ):
		return

	pick_pocket = object.get_attribute(operator, "pick_pocket")

	# calculate the chances of a successful heist depending on the 
	# position of the operator and on his skill
	if is_in_front( operator, target ):
		basic_chance_of_success = 0.2 # 20% chance stealing something from the victim
		additional_chance = skill_tables.pick_pocket_success_front(pick_pocket)
		if has_talent( operator, "pick_pocket", "diversion" ):
			additional_chance = additional_chance + 0.1
	else:
		basic_chance_of_success = 0.4 # 40% chance stealing something from the victim
		additional_chance = skill_tables.pick_pocket_success_back(pick_pocket)
		if has_talent( operator, "pick_pocket", "slink" ):
			additional_chance = additional_chance + 0.1
	
	# 30% better chance to steal something if the operator has the talent flatter
	# and the target is of the opposite gender
	if has_talent( operator, "pick_pocket", "flatter" ):
		if object.has_attribute( target, "gender" ):
			operator_gender = object.get_attribute( operator, "gender" )
			target_gender = object.get_attribute( target, "gender" )

			if ( operator_gender == "female" and target_gender == "male" ) or \
			   ( operator_gender == "male" and target_gender == "female" ):
				additional_chance = additional_chance + 0.3

	# look if the target was bereft before.
	# the bereft attribute determines that a char tried to bereft
	# the npc before. The more often he tries the smaller the
	# bereft value gets.
	# bereft_list = { operator: bereft }
	bereft = 1.0 # 100%
	bereft_list = {}
	if object.has_attribute( target, "bereft" ):
		bereft_list = object.get_attribute( target, "bereft" )

	# chance of a successful heist will be reduced by the fact that
	# the target was bereft before
	if bereft_list.has_key( operator ):
		bereft = bereft_list[ operator ]
		
	chance = ( basic_chance_of_success + additional_chance ) * bereft

	return chance

def on_steal(target, operator):
	"""is called when a player char tries to steal something
	
operator - id of the thief
target   - id of the victim
"""	
	chance = calc_steal_chance( target, operator )

	r = random.random()

	if r < chance: # heist was successful
		inventorylist = object.get_inventory_list(target)
		# Check for talent inside_pocket
		if has_talent( operator, "pick_pocket", "inside_pocket" ):
			# if target ha snot yet an inside_pocket_item, then create one
			if not object.has_attribute( target, "inside_pocket_item" ):
				inside_pocket_item_type = get_random_item()
				inside_pocket_item_id = object.create_item_in_inventory( target, inside_pocket_item_type )
				object.set_attribute( target, "inside_pocket_item", inside_pocket_item_id )

		if inventorylist:
			# show the item panel but filter out the equiped items
			system.item_panel( operator, target, separate_out_callback )
	else: # heist was a failure
		# target will abuse operator
		lambda_string = 'heist_failure( target="%s", operator="%s" )' %( target, operator )
		object.turn_to_object( target, operator, callback=[ "ONEND", Lambda( lambda_string ) ] )

def get_random_item():
	"""Is called to randomly choose 1 out of 50 items.
	This is used fo the talent "inside pocket".
	"""

	items =[ "SET_AMMOPACK_7_62NATO_MM", "SET_AMMOPACK_5_45_MM", "SET_AMMOPACK_2_12_MM", "SET_AMMOPACK_3_12_MM", "SET_AMMOPACK_7_62SOVJET_MM", "SET_AMMOPACK_5_56_MM",
	"SET_AMMOPACK_25_MM_HE", "SET_AMMOPACK_20_MM_HE", "SET_UZI", "SET_AMMOPACK_9_MM",
	"SET_MULTI_MEDIPACK_NAME", "SET_MEDIPACK_SMALL_NAME", "SET_MEDIPACK_BIG_NAME", "SET_DUCT_TAPE", "SET_WATERTIGHT_RING", "SET_LIGHTER", "SET_LASERPOINTER",
	"SET_SHORT_NAILS", "SET_RAGS", "SET_STETHOSCOPE", "SET_LONG_NAILS", "SET_CRANK", "SET_PLIERS", "SET_BULLET_CASINGS", "SET_LIGHT_BULB",
	"SET_RASP", "SET_RIVETS", "SET_DICE", "SET_FUSE", "SET_BOTTLE_OF_HOOCH", "SET_BATTERY", "SET_HAIR_SPRAY", "SET_WALTER_PPK",
	"SET_BERETTA_92F", "SET_DESERT_EAGLE", "SET_SPECIAL_38", "SET_GLOCK_21", "SET_HEGRENADE", "SET_FRAGGRENADE", "SET_FIREGRENADE",
	"SET_SMOKEGRENADE", "SET_STUNGRENADE", "SET_FLASHGRENADE", "SET_PHOSPHORGRENADE", "SET_MOLOTOV_COCKTAIL",
	"SET_ACID_PROJECTILE", "SET_THROWING_KNIFE", "SET_SHURIKEN", "SET_DART", "SET_BRASS_KNUCKLES", "SET_KNIFE", "SET_BIG_KNIFE",
	"SET_MACHETE", "SET_AMMOPACK_7_65_MM", "SET_AMMOPACK_38", "SET_AMMOPACK_44", "SET_AMMOPACK_357", "SET_AMMOPACK_9_MM",
	"SET_AMMOPACK_50", "SET_AMMOPACK_45", "SET_AMMOPACK_50BMG", "SET_AMMOPACK_5_7_MM", "SET_AMMOPACK_4_6_MM", "SET_MEDIPACK_SMALL",
	"SET_AMMOPACK_2_12_QB_8", "SET_AMMOPACK_2_5_JHP_ARROW", "SET_AMMOPACK_4_73_CASELESS", "SET_OINTMANT_JAR", "SET_DRUGS_VIALS_01", "SET_DRUGS_VIALS_02",
	"SET_DRUGS_VIALS_03", "SET_APPLE", "SET_BREAD", "SET_CARROT" ]

	return random.choice( items )



def heist_failure( target, operator ):
	"""Is called after a heist failed and the target turne to the 
	thief. This funtcione starts a dialog about the heist between the target and the thief.

target - id of the bereft char
operator - id of the thief
	"""
	
	dialog.init_dialog( type=DIALOGSMALL )
	# random for the dialog texts
	rand = random.randint( 1, 5 )
	rand1 = random.randint( 1, 3 )
	rand2 = random.randint( 1, 3 )

	object.set_attribute( operator, "failed_heist", system.get_mission_time() )
	# increase the bereft attribute so that it is more difficult
	# for the operator to steal from the target the next time
	if not has_talent( operator, "pick_pocket", "excuse" ):
		dialog.add_text( text = "NPC_THEFT_00" + str(rand), speaker = target, follower = "ENDDIALOG" )
		bereft_list = {}
		if object.has_attribute( target, "bereft" ):
			bereft_list = object.get_attribute( target, "bereft" )

		if len( bereft_list ) > 0:
			if bereft_list.has_key( operator ):
				new_bereft = bereft_list[ operator ]
				new_bereft = new_bereft / 2.0
			else:
				new_bereft = 0.5
			bereft_list[ operator ] = new_bereft
			object.set_attribute( target, "bereft", bereft_list )
		else:
			bereft_list[ operator ] = 0.5
			object.set_attribute( target, "bereft", bereft_list )
	else:
		dialog.add_text( text = "NPC_THEFT_00" + str(rand), speaker = target, follower = "NPC_THEFT_EXCUSE_00" + str(rand1) )
		dialog.add_text( text = "NPC_THEFT_EXCUSE_00" + str(rand1), speaker = operator, follower = "NPC_THEFT_ACCEPT_EXCUSE_00"+ str(rand2) )
		dialog.add_text( text = "NPC_THEFT_ACCEPT_EXCUSE_00" + str(rand2), speaker = target, follower = "ENDDIALOG" )


	dialog.start()

def random_comment( character_id, comment_string, number_comments ):
	"""let the char say a random comment

character_id - id of the char
comment_string - base string of the comments id
number_comments - number of comments, where the id begins with the base string"""

	import random

	index = "00"
	if number_comments >= 10:
		index = "0"
	if number_comments >= 100:
		index = ""

	comment_id = comment_string + index + str(random.randint(1,number_comments))
	comments.comment( character_id, comment_id )

def get_random_comment( comment_string, number_comments ):
	"""Makes a random comment string
	"""
	import random

	index = "00"
	if number_comments >= 10:
		index = "0"
	if number_comments >= 100:
		index = ""

	comment_id = comment_string + index + str(random.randint(1,number_comments))

	return comment_id


def separate_out_callback( taker_id, source_id, item_id, item_type ):
	"""Check if item_id is equiped by the char or
	if the taker has the talent "inside_pocket", then the
	inside_pocket_item is shown too.
	This is only a callback helper function for 
	the ItemPanel in on_steal.

character_id - id of the char
item_id - id of the item
item_type - type of the item"""
	
	if object.has_attribute( source_id, "inside_pocket_item" ):
		if item_id == object.get_attribute( source_id, "inside_pocket_item" ):
			if has_talent( taker_id, "pick_pocket", "inside_pocket" ):
				return True
			else:
				return False

	return not character.is_equiped( source_id, item_id )

def did_fail_heist( character_id ):
	"""returns true if the char tried to steal from
	a npc in the past 10 minutes and failed 

character_id - id of the char"""
	
	if object.has_attribute( character_id, "failed_heist" ):
		heist_time = object.get_attribute( character_id, "failed_heist" )

		# if the last heist was more than 10 min ago then delete the attribute
		if system.get_mission_time() - heist_time > time( "00:10:00" ):
			object.set_attribute( character_id, "failed_heist", None )
			return False
		else:
			return True
	# char did not have the attribute, that means he did not steal
	# in the past 10 minutes
	else: 
		return False

def remove_bereft_attribute():
	"""remove the bereft attribute from all npcs."""
	npcs = system.get_npcs()
	
	for npc in npcs:
		if character.exists( npc ):
			if object.has_attribute( npc, "bereft"):
				object.set_attribute( npc, "bereft", None )
	

exp_table = [
	0,		#1
	100,	#2
	200,	#3
	500,	#4
	1200,	#5
	2200,	#6
	3500,	#7
	6000,	#8
	7700,	#9
	10000,	#10
	13000,	#11
	17000,	#12
	21000,	#13
	25000,	#14
	30000,	#15
	35000,	#16
	40000,	#17
	45000,	#18
	50000,	#19
	55000,	#20
	61000,	#21
	68000,	#22
	70000,	#23
	79000,	#24
	89000,	#25
	99000	#26
	]

def calc_level( character_id, new_exp, old_exp ):
	"""helper function for on_attribute_change
	
calcs and sets the new level if enough experience has been gained by the char.

character_id - id of the char
new_exp      - amount of exp the char has now
old_exp      - amount of exp the char had before

	#todo: obere grenze entfernen
	#Steigt ein Charakter auf, darf er 1 Punkt frei auf die Attribute verteilen.
	#Steigt ein Charakter auf, darf er wiederum 25 Punkte frei auf die
	#Fertigkeiten verteilen.
"""
	global exp_table
	level = object.get_attribute(object=character_id, attribute="level" )
	levelup = True
	if level==-1:
		level = 0
		levelup = False
		
	attribute_points_left = 0
	skill_points_left = 0

	if object.has_attribute(character_id, "attribute_points_left"):
		attribute_points_left = object.get_attribute(character_id, "attribute_points_left")

	if object.has_attribute(character_id, "skill_points_left"):
		skill_points_left = object.get_attribute(character_id, "skill_points_left")

	import skill_tables
	skill_points = 10
	skill_points+=skill_tables.intelligence_skill_points(
		object.get_attribute(character_id, "intelligence"))
		
	while level < len( exp_table ) and new_exp >= exp_table[level]:
		level+=1
		attribute_points_left+=1
		skill_points_left+=skill_points
		
	if levelup:
		object.set_attribute(object=character_id, 
			attribute="attribute_points_left", value=attribute_points_left)
		object.set_attribute(object=character_id, 
			attribute="skill_points_left", value=skill_points_left)
	
	object.set_attribute(object=character_id, attribute="level", value=level )

	next_level_exp = -1
	if level < len( exp_table ):
		next_level_exp = exp_table[level]
	else:
		next_level_exp = exp_table[len(exp_table) - 1]
	object.set_attribute(object=character_id, 
		attribute="experience_next_level", value=next_level_exp)

#							FA		 MA		 VE		 SU		 CR		 HC		 ME
bonus_malus_experience_of_life = {
	"close_combat":			( 0,	+15,	  0,	  0,	 +5,	  0,	-10),
	"light_weapons":		(+5,	  0,	  0,	  0,	 +5,	  0,	  0),
	"heavy_weapons":		(+5,	-10,	  0,	  0,	 -5,	  0,	  0),
	"sniper_weapons":		(+5,	  0,	  0,	  0,	 -5,	  0,	  0),
	"throw_weapons":		(-5,	+10,	  0,	+10,	  0,	  0,	 -5),
	"explosives":			( 0,	  0,	  0,	  0,	 +5,	  0,	  0),
	"survival":				( 0,	  0,	 -5,	+15,	-10,	 -5,	  0),
	"sneak":				( 0,	 +5,	 -5,	+10,	  0,	  0,	  0),
	"pick_pocket":			(-5,	  0,	  0,	  0,	+10,	  0,	  0),
	"lock_pick":			(-5,	  0,	  0,	 -5,	 +5,	+10, 	  0),
	"technic":				( 0,	  0,	+10,	 -5,	  0,	+15,	 +5),
	"driving":				( 0,	  0,	+15,	-10,	  0,	  0,	  0),
	"speech":				(-5,	  0,	  0,	 -5,	 +5,	 +5,	 +5),
	"medicine":				( 0,	  0,	  0,	  0,	  0,	 -5,	+15),
}

def calc_experience_of_life(character_id, new_value, old_value):
	"""helper function for on_attribute_change
	
calcs and sets the effects of the life experience (i.e. previous "job" experience).

character_id - id of the char
new_value    - new value
old_value    - old value

value:
	0 - Firearms
	1 - Martial Arts
	2 - Vehicles
	3 - Survival
	4 - Crime
	5 - Handcraft
	6 - Medicine
"""
	global bonus_malus_experience_of_life
	if old_value!=None:
		for entry in bonus_malus_experience_of_life:
			value=object.get_attribute(character_id, entry)
			value-=bonus_malus_experience_of_life[entry][old_value]
			object.set_attribute(character_id, entry, value)

	for entry in bonus_malus_experience_of_life:
		value=object.get_attribute(character_id, entry)
		value+=bonus_malus_experience_of_life[entry][new_value]
		object.set_attribute(character_id, entry, value)

#						none	tall	short	strong	wiry	handsome 	ugly
bonus_malus_body_features = {
	"strength":			(0,		+2,		-2,		+3,		-1,		 0,		 	0),
	"agility":			(0,		-2,		+1,		-3,		+1,		 0,		 	0),
	"dexterity":		(0,		-1,		+2,		 0,		 0,		 0,		 	0),
	"constitution":		(0,		+1,		-1,		 0,		+1,		 0,		 	0),
	"intelligence":		(0,		 0,	 	 0,		 0,		 0,		-3,			+3),
	"charisma":			(0,		 0,	 	 0,		 0,		-1,		+3,			-3),
}

def calc_body_feature(character_id, new_value, old_value):
	"""helper function for on_attribute_change
	
calcs and sets the effects of the body features.

character_id - id of the char
new_value    - new value
old_value    - new value

value:
	0 - none
	1 - tall
	2 - short
	3 - strong
	4 - wiry
	5 - handsome
	6 - ugly
"""
	global bonus_malus_body_features
	if old_value!=None:
		for entry in bonus_malus_body_features:
			value=object.get_attribute(character_id, entry)
			value-=bonus_malus_body_features[entry][old_value]
			object.set_attribute(character_id, entry, value)

	for entry in bonus_malus_body_features:
		value=object.get_attribute(character_id, entry)
		value+=bonus_malus_body_features[entry][new_value]
		object.set_attribute(character_id, entry, value)

def calc_armor_value(character_id):
	"""helper function, calcs and sets the armor the character gets from his equipment
	
character_id - id of the char
"""
	import string
	import skill_tables
	armor = skill_tables.agility_armor(object.get_attribute(character_id, "agility"))
	equipted = []
	inventory = object.get_inventory(character_id)
	for entry in inventory:
		if entry[1] != 0:
			for elem in entry[0]:
				equipted.append(elem)
	for item in equipted:
		if object.has_attribute(item, "armor"):
			armor = armor + object.get_attribute(item, "armor")
	if armor<0: armor=0
	object.set_attribute(character_id, "armor", armor)

#					base exp		exp per level
kill_exp = {
	"WOLF": 			(30,				0),
	"ANTELOPE":			(10,				0),
	"BEAR":				(40,				0),
	"COW":				( 5,				0),
	"DEER":				(20,				0),
	"HORSE":			(15,				0),
	"TIGER":			(50,				0),
	"WILDDOG":			(30,				0),
	"BISON":			(15,				0),
	"PIG":				( 5,				0),
	"DONKEY":			( 5,				0),
	"WARG":				(60,				0),
	"LIZARD_SOMA":		(40,				0),
	
	"RAT_SKULLS":		(20,				10),
	"DESERT_MONKS":		(30,				15),
	"SHADOWS":			(30,				20),
	"INDIANS":			(20,				10),
	"NOMADS":			(20,				10),
	"GNO_SOLDIERS":		(40,				15),
	"VILLAGE_PEOPLE":	(20,				10),
	"SEEKER":			(20,				10),
}

def on_object_killed(victim, attacker, weapon_type, weapon_id):
	"""called when an object gets killed/destroyed
	
attacker    - id of the attacker
victim      - id of the attacker
weapon_type - type of the weapon the attacker used, might be None or ""
weapon_id   - type of the weapon the attacker used, might be None or ""
"""
	#print "on_object_killed", victim, attacker, weapon_type, weapon_id

	PCs=system.get_pcs()
	NPCs=system.get_npcs()

	if (attacker in PCs):
		#experience per kill calculation
		type="none"
		exp=0
		if object.has_attribute(victim, "typeid"):
			type=object.get_attribute(victim, "typeid")

		if object.has_attribute(victim, "faction"):
			type=object.get_attribute(victim, "faction")

		if type in kill_exp:
			exp=kill_exp[type][0]
			level=1
			if object.has_attribute(victim, "level"):
				level=object.get_attribute(victim, "level")
			exp+=kill_exp[type][1]*(level-1)

		if exp>0:
			character.add_experience(attacker, exp)

		#kills per weapon statistics
		weapon_id_history={}
		weapon_type_history={}
		if object.has_attribute(attacker, "weapon_type_history"):
			weapon_type_history = object.get_attribute(attacker, "weapon_type_history")
		if object.has_attribute(attacker, "weapon_id_history"):
			weapon_id_history = object.get_attribute(attacker, "weapon_id_history")

		kill_count=[0,0]
		if weapon_type and len(weapon_type):
			if weapon_type in weapon_type_history:
				kill_count=weapon_type_history[weapon_type]
			if victim in NPCs or victim in PCs:
				kill_count[0] += 1
			elif victim in system.get_animals():
				kill_count[1] += 1
			weapon_type_history[weapon_type]=kill_count
			object.set_attribute(attacker, "weapon_type_history", weapon_type_history)

		kill_count=[0,0]
		if weapon_id and len(weapon_id):
			if weapon_id in weapon_id_history:
				kill_count=weapon_id_history[weapon_id]
			if victim in NPCs or victim in PCs:
				kill_count[0] += 1
			elif victim in system.get_animals():
				kill_count[1] += 1
			weapon_id_history[weapon_id]=kill_count
			object.set_attribute(attacker, "weapon_id_history", weapon_id_history)
	
			# update weapon accustomisation skill bonus
	helper_remove_weapon_accustomisation(attacker, weapon_type, weapon_id)
	helper_add_weapon_accustomisation(attacker, weapon_type, weapon_id)

	if object.has_attribute(victim, "type"):
		type = object.get_attribute(victim, "type")
		if type=="vehicle":
			vehicle_explosion( victim )
		elif type=="character":
			if object.has_attribute( victim, "gender"):
				if object.get_attribute( victim, "gender")=="male":
					if random.randint(0, 1):
						sounds.play_3d_sound_object(sfx_id=random.choice([
							"male_heavy_hit_1","male_medium_hit_1",
							"male_medium_hit_2","male_medium_hit_3",
							"male_slightly_hit_1","male_slightly_hit_2"]),
							object=victim)	
	
	# zur globalen Behandlung wen die GOE Gang getötet wird.
	# in z6 und zz4 gesonderte Bearbeitung in der zone
	if attacker in system.get_pcs():
		if victim in ["ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
			if not system.get_act_mission_name() in ['zone_6.zone_6', 'zzone_4.zzone_4']:
				if globals.was_zone_entered('zone_6.zone_6'):
					for char_id in ["ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
						if char_id in system.get_npcs():
							object.set_attribute(char_id,"zone_transfer",False)
					data("zone_6.zone_6").abraham_und_co_folgen = False
					for char in ["ABRAHAM", "SUE_Z7", "FJODR"]:
						if char in system.get_npcs():
							if not object.is_destroyed(char):
								prohibit_activity(char)
								object.set_attribute(char, "foes", ['UISPIELER'])
					if system.get_qb_entry_state(data("zone_6.zone_6").QB_020) != IMPOSSIBLE:
						system.set_qb_entry_state(data("zone_6.zone_6").QB_020, IMPOSSIBLE) 
					
	

def calc_life_energy_start(character_id, new_value, old_value):
	"""helper function for on_attribute_change
	
calcs and sets the HP a char starts with.

character_id - id of the char
new_value    - new constitution
old_value    - old constitution
"""
	import skill_tables
	value = skill_tables.constitution_life_energy_start(new_value)
	object.set_attribute(character_id, "maxhitpoints", value)
	object.set_attribute(character_id, "hitpoints", value)

def calc_life_energy(character_id, new_value, old_value):
	"""helper function for on_attribute_change
	
calcs and sets the new HP after level up.

character_id - id of the char
new_value    - new level
old_value    - old level
"""
	import skill_tables
	if old_value > 0:
		i=old_value
		max_le=object.get_attribute(character_id, "maxhitpoints")
		constitution=object.get_attribute(character_id, "constitution")
		le_gain = 0
		while i < new_value:
			#Pro Stufe erhöht sich die LE bei jedem Charakter um 4 - 8 Punkte.
			#Der Konstitutionswert beeinflusst diesen Wert durch einen Bonus.
			le_gain+=random.randint(4,8)
			le_gain+=skill_tables.constitution_life_energy_level(constitution)
			i+=1
		max_le+=le_gain
		object.set_attribute(character_id, "maxhitpoints", max_le)
		# die act. hp steigt um den wert, um die sich die max. hp erhöht hat
		act_le=object.get_attribute(character_id, "hitpoints")+le_gain
		if act_le>max_le:
			act_le=max_le
		object.set_attribute(character_id, "hitpoints", act_le)

def can_do_action(character_id, action, just_checking):
	"""returns True if the char can do the action
	
Set just_checking to true of you only want to know and to
false if you are about to execute the order.
	
known actions:
	"action_kneel"
	"action_climb"
	"action_liedown"
return defaults to True for unknown actions.
"""
	if (action=="action_kneel" or
		action=="action_climb" or
		action=="action_liedown"):

		# missing rel_load attribute; create it
		if not object.has_attribute( object=character_id, attribute="rel_load" ):
			update_speed( character_id )

		rel_load = object.get_attribute( object=character_id, attribute="rel_load" )
		deny = False
		if rel_load > 1 and action=="action_climb": deny = True
		elif rel_load > 1.1:
			if action=="action_kneel": deny = True
			elif action=="action_liedown": deny = True
		if deny:
			# not in cutscene and about to execute the action
			if not system.is_cutscene() and not just_checking:
				# not to often
				# "0:01" = 1min ingame time ~2.5s time
				current_time = system.get_mission_time()
				if not object.has_attribute( object=character_id, attribute="last_refuse_action_weight" ):
					comments.comment(character_id=character_id, text="REFUSE_ACTION_WEIGHT")
					object.set_attribute( object=character_id, \
						attribute="last_refuse_action_weight", value=current_time )
				else:
					last_refused = object.get_attribute( object=character_id, attribute="last_refuse_action_weight" )
					import timerepr
					if (current_time > last_refused) and \
						((current_time - last_refused) > timerepr.time("0:01")):
						comments.comment(character_id=character_id, text="REFUSE_ACTION_WEIGHT")
						object.set_attribute( object=character_id, \
							attribute="last_refuse_action_weight", value=current_time )
			return False
	return True

def on_water_found( character_id, x, y ):
	"""is called when the player founds a water source and diggs it
	
character_id - id of the char
x - x coordinate of the water source
y - y coordinate of the water source

"""
	# check for water_unearthed list in the data() structure
	if not hasattr(data(), "water_unearthed"):
		data().water_unearthed = []
	
	# only play animation if the source is not unearthed already
	if (x,y) not in data().water_unearthed:
		if object.count_in_inventory( character_id, "SET_SPADE" ):
			character.play_animation( character_id, "CM_NPC_STEHEN_LOCH_GRABEN_START" )
			character.play_animation( character_id, "CM_NPC_STEHEN_LOCH_GRABEN_LOOP" )
			character.play_animation( character_id, "CM_NPC_STEHEN_LOCH_GRABEN_LOOP" )
		else:
			character.play_animation( character_id, "CM_KNIEND_WASSERLOCH_GRABEN_START" )
			character.play_animation( character_id, "CM_KNIEND_WASSERLOCH_GRABEN_LOOP" )
			character.play_animation( character_id, "CM_KNIEND_WASSERLOCH_GRABEN_LOOP" )
			character.play_animation( character_id, "CM_KNIEND_WASSERLOCH_GRABEN_LOOP" )

	amount_water = water.get_available_water(x, y, 1)

	if (x,y) not in data().water_unearthed:
		if amount_water > 0:
			system.create_object( "RES3D_TRES_OBJECTS_BUILDING_WATERHOLE_FULL", x, y )
		else:
			system.create_object( "RES3D_TRES_OBJECTS_BUILDING_WATERHOLE_EMPTY", x, y )

		if object.count_in_inventory( character_id, "SET_SPADE" ):
			character.play_animation( character_id, "CM_NPC_STEHEN_LOCH_GRABEN_ENDE" )
		else:
			character.play_animation( character_id, "CM_KNIEND_WASSERLOCH_GRABEN_ENDE" )

	# the water source is now completly unearthed 
	data().water_unearthed.append( (x,y) )

def get_water_sensible_chars():
	"""returns a list of chars that can detect water
	and comment about it if they find it.
	If more than one char detects the same water source,
	then the one with the highest survival level is taken.
	"""

	# dictionary of all chars that can detect water
	# key = character_id
	# item = [ water_source_pos, survival_value ]
	chars = {}

	for character_id in system.get_pcs():
		survival = object.get_attribute( character_id, "survival" )
		range = skill_tables.survival_water_dection_range( survival ) 
		# if the water detector is equipped then water in a range of 20
		# meters can be detected
		if character.is_equiped( character_id, "SET_WATER_DETECTOR" ) and range < 20:
			range = 20

		if range > 0:
			nearest_water_source = water.get_nearest_water_source( object.get_x( character_id ), object.get_y( character_id ), range )
			# char has water source in his range
			if len( nearest_water_source ) > 0:
				found = False
				for char in chars:
					# char found who detected the same water source
					if chars[char][0] == nearest_water_source:
						found = True
						# found char has lower survival level.
						# therefore delete it from the chars list
						if  chars[char][1] < survival:
							del chars[char]
							chars[ character_id ] = [ nearest_water_source, survival ]
						break

				# no char found who detected the same water source.
				# therefore add the new char to the dict
				if not found:
					chars[ character_id ] = [ nearest_water_source, survival ]

	return chars
		
def can_detect_water_source( character_id ):
	"""return true if the char is able to detect a water 
	source. The source must be detected or digged before.
	No matter if the source is detected and/or digged before. 

character_id - id of the character
"""
	survival = object.get_attribute( character_id, "survival" )
	range = skill_tables.survival_water_dection_range( survival ) 

	# if the water detector is equipped then water in a range of 20
	# meters can be detected
	if character.is_equiped( character_id, "SET_WATER_DETECTOR" ) and range < 20:
		range = 20

	# if char can detect water
	if range > 0:
		nearest_water_source = water.get_nearest_water_source( object.get_x( character_id ), object.get_y( character_id ), range )
		# if there is a water source in the chars range that was detected before
		if len( nearest_water_source ) > 0:
			# convert coords to tuple to fit the datatype of the 
			# data.water_detected keys
			source_coords = ( nearest_water_source[0], nearest_water_source[1] )
			if source_coords in data().water_detected.keys():
				return True
		else:
			return False
	
	return False

def can_use_water_source( character_id, water_source_id ):
	"""returns true if the char can fill his water respositories up
	using the given water source. The funtion tests if the char has 
	water repositories in his inventory and if one or some of them 
	are not fully filled

character_id - id of the character
watersource_id - id of the water source"""

	if not is_water_source( water_source_id ):
		return False

	if water.get_available_water( object.get_x( water_source_id ), object.get_y( water_source_id ), 1 ) <= 0:
		return False

	equipment = object.get_inventory_id_list( character_id )

	for item in equipment:
		if is_water_repository( item ):
			if object.has_attribute( item, "typeid" ):
				item_type = object.get_attribute( item, "typeid" )
			else:
				continue

			current_charge = object.get_attribute( item, "charge" )
			max_charge = object.get_attribute( item_type, "charge" )

			if current_charge < max_charge:
				return True
	
	return False
	
	

pc_comment_counter = 0
pc_comment_cycle = 1000 * 60 * 10

def timer_events(lastcall):
	"""is called cyclic by the programm to check for new comments
	
lastcall - time in ms since the last call to timer_events
       (is useally called every second, i.e. time == 1000)
"""
	global pc_comment_counter
	pc_comment_counter+=lastcall

	comments.allow_mercenary_comments( True )

	### MUSIC ###
	music.timer_events(lastcall)
	
	### WATER ###
	import skill_tables
	PCs = system.get_pcs()
	
	# get all chars that have a water source in their range
	chars = get_water_sensible_chars()

	if len( chars ) > 0:
		for character_id in chars:
			nearest_water_source = chars[ character_id ][0]

			# check for water_detected dict in the data() structure
			# water_detected:
			# key: water source coordinates as tuple
			# item: mission time the source was detected 
			if not hasattr(data(), "water_detected"):
				data().water_detected = {}

			# convert the water source position from list to a tuple 
			# so that it can be used as a key in the data().water_detected dict
			nearest_water_source = ( nearest_water_source[0], nearest_water_source[1] )

			# water source was not detected before or the detection
			# was more than 24 hours ago
			if nearest_water_source not in data().water_detected.keys() or \
			data().water_detected[ nearest_water_source ] > system.get_mission_time() or \
			system.get_mission_time() - data().water_detected[ nearest_water_source ] > time( "24:00:00" ):
				import random
				text = "WATER_PERCEIVED_" + str(random.randint(1,3))
				comments.comment( character_id, text )
				# save detected water source and the time it was detected
				data().water_detected[ nearest_water_source ] = system.get_mission_time()

	### MERCENARY COMMENTS ###
	comments.check_for_injury_comments()

	comments.check_for_traders_in_sight()
	comments.check_for_motorbikes_in_sight()
	comments.check_for_cars_in_sight()


def on_resuscitate( aide_id, unconscious_id ):
	""" is called when a char tries to
	resuscitate another char

aide_id - id of the char that tries to resuscitate the other
unconscious_id - id of the unconscious char """

	if object.is_unconscious( unconscious_id ):
		#character.play_animation( unconscious_id, "CM_LIEGEN_WIEDERBELEBT_WERDEN_ENDE" )
		# resuscitated chars have one hitpoint
		#  and must be healed then by party members
		set_unconscious( unconscious_id, False )
		object.set_attribute( unconscious_id, "hitpoints", 1 )
		object.set_attribute( unconscious_id, "played_unconscious_anim", False )
	elif object.is_destroyed( unconscious_id ):
		genders = { "male": "MALE", "female": "FEMALE" }
		comments.comment( aide_id, "RESUSCITATION_USELESS_" + genders[ object.get_attribute( unconscious_id, "gender" ) ] )


def set_unconscious( character_id, unconscious ):
	"""sets the char unconscious if he not already is.
	After set to unconscious the char losses one hitpoint per minute.
	If the hitpoints are less than -5 then the char really dies.

	character_id - id of the char
	unconscious  - True or False. Wether or not the char is set conscious or unconscious.
	"""
	if character_id in system.get_pcs(include_unconscious = True):
		if unconscious:
			if not object.is_unconscious( character_id ):
				timer_id = "unconscious_timer_" + character_id
				object.set_attribute( character_id, "unconscious", True )
				if not object.has_attribute(character_id, "unconscious_subtract_hp") \
				or object.get_attribute(character_id, "unconscious_subtract_hp")==True:
					# start the timer that makes 1 damagpoint every minute to the char
					system.notify_global_timer( timer_id, 60000, False ) 
		else:
			object.set_attribute( character_id, "unconscious", False )
	
def get_weapon_speed_factor(char, weapon_id):
	"""returns the weapon speed factor that the char has with his equiped main weapon
	
char - id of the char
"""
	factor = 1.0

	weapon_type = object.get_attribute(weapon_id, "typeid")
	#print weapon_id
	#print weapon_type
	weapon_class = "UNKNOWN WEAPON CLASS"
	if weapon_id:
		weapon_class = object.get_attribute(weapon_id, "weapon_type")

	# include attribute & skill influence
	if weapon_class == "leicht" or weapon_class == "sniper" or weapon_class == "wurf" or weapon_class == "nahkampf":
		factor *= skill_tables.dexterity_weapons_speed(object.get_attribute(char, "dexterity"))
	elif weapon_class == "schwer":
		factor *= skill_tables.strength_heavy_weapons_speed(object.get_attribute(char, "strength"))
	else: raise AttributeError
	if weapon_class == "leicht":
		factor *= skill_tables.light_weapons_speed(object.get_attribute(char, "light_weapons"))
	elif weapon_class == "schwer":
		factor *= skill_tables.heavy_weapons_speed(object.get_attribute(char, "heavy_weapons"))
	elif weapon_class == "sniper":
		factor *= skill_tables.sniper_weapons_speed(object.get_attribute(char, "sniper_weapons"))
	elif weapon_class == "wurf":
		factor *= skill_tables.throw_weapons_speed(object.get_attribute(char, "throw_weapons"))
	elif weapon_class == "nahkampf":
		factor *= 1.0
	else: raise AttributeError
	return factor

def get_damage_factor(char, weapon_id, target):
	""" returns the damage factor that the char has with his equiped main weapon when
		attacking the target
char - id of the char
target - id of the target
"""
	factor = 1.0
	weapon_class = "UNKNOWN WEAPON CLASS"
	if weapon_id:
		weapon_class = object.get_attribute(weapon_id, "weapon_type")
	if weapon_class == "nahkampf":
		#include effects of attribute strength 
		factor *= skill_tables.strength_close_combat_damage(object.get_attribute(char, "strength"))
		#include effects of skill close combat
		factor *= skill_tables.close_combat_weapons_damage(object.get_attribute(char, "close_combat"))
		if target!=None:
			if has_talent(target, "close_combat", "stamina"):
				#include effects of talent stamina
				factor *= 0.7
	#else: raise AttributeError
	return factor

def get_hit_chance_factor(char, weapon_id, target):
	"""returns the hit chance factor that the char has with his equiped main weapon
	
char - id of the char
"""
	factor = 1.0

	#inquire weapon
	weapon_type = object.get_attribute(weapon_id, "typeid")
	#print weapon_id
	#print weapon_type
	weapon_class = "UNKNOWN WEAPON CLASS"
	if weapon_id:
		weapon_class = object.get_attribute(weapon_id, "weapon_type")

	# select skill/talent for this weapon
	# include skill influence
	if weapon_class == "leicht":
		skill = "light_weapons"
		factor *= skill_tables.light_weapons_hit_chance(object.get_attribute(char, skill))
	if weapon_class == "schwer":
		skill = "heavy_weapons"
		factor *= skill_tables.heavy_weapons_hit_chance(object.get_attribute(char, skill))
	if weapon_class == "sniper":
		skill = "sniper_weapons"
		factor *= skill_tables.sniper_weapons_hit_chance(object.get_attribute(char, skill))
	if weapon_class == "wurf":
		skill = "throw_weapons"
		factor *= skill_tables.throw_weapons_hit_chance(object.get_attribute(char, skill))
	if weapon_class == "nahkampf":
		skill = "close_combat"
		factor *= skill_tables.close_combat_weapons_hit_chance(object.get_attribute(char, skill))
		if target!=None:
			if has_talent(target, "close_combat", "avoid"):
				factor *= 0.9
	talent = skill
		
	#include body mode
	mode = character.get_body_mode(char)
	if talent in ["light_weapons", "heavy_weapons", "sniper_weapons"]\
	and has_talent(char, talent, "stable_shot"):
		#Stehend und kniend wie liegend schießen
		factor *= 1.2
	elif mode=="LIE":
		factor *= 1.2
	elif mode=="KNEEL":
		factor *= 1.1
	if object.is_moving(char):
		factor *= 0.7

	# include talent influences
	if talent in ["light_weapons", "heavy_weapons", "sniper_weapons"]\
	and has_talent(char, talent, "precision"):
		#+ 5 % zielgenauigkeit
		factor *= 1.05
		
	# include attribute influence
	if weapon_class == "leicht" or weapon_class == "sniper" or weapon_class == "wurf" or weapon_class == "nahkampf":
		factor *= skill_tables.dexterity_weapons_hitchance(object.get_attribute(char, "dexterity"))
	elif weapon_class == "schwer":
		factor *= skill_tables.strength_heavy_weapons_hitchance(object.get_attribute(char, "strength"))
	else: raise AttributeError

	# hit chance factor from ammo
	if object.has_attribute(weapon_id, "act_ammo_type"):
		ammo = object.get_attribute(weapon_id, "act_ammo_type")
		if ammo and ammo!="" and object.has_attribute(ammo, "hit_chance_factor"):
			factor *= object.get_attribute(ammo, "hit_chance_factor")

	#no effects of lighting for close combat
	if weapon_class != "nahkampf":
		# hit chance factor for brightness
		night_sight_bonus = 0.0
		if talent == "sniper_weapons" and has_talent(char, talent, "night_sight"):
			night_sight_bonus = 0.2
		d = data("sky")
		if hasattr(d, "daytime"):
			t = d.daytime
			if t == "night":
				factor *= 0.7 + night_sight_bonus
			elif t == "dusk":
				factor *= 0.85 + night_sight_bonus
			elif t == "day":
				factor *= 1.0
			elif t == "dawn":
				factor *= 0.85 + night_sight_bonus
	
			else:
				raise ValueError, "illegal value '%s' in data('sky').daytime" % str(t)
	

	return factor
	
def get_weapon_max_fire_range_factor(char, weapon_id):
	"""returns a factor that influences the weapon range for this char depending on his skills
	
char - id of the char
"""
	factor = 1.0
	
	#inquire weapon
	weapon_type = object.get_attribute(weapon_id, "typeid")
	weapon_class = "UNKNOWN WEAPON CLASS"
	if weapon_id:
		weapon_class = object.get_attribute(weapon_id, "weapon_type")

	#select skill/talent for this weapon
	if weapon_class == "leicht":
		skill = "light_weapons"
	if weapon_class == "schwer":
		skill = "heavy_weapons"
	if weapon_class == "sniper":
		skill = "sniper_weapons"
	if weapon_class == "wurf":
		skill = "throw_weapons"
	if weapon_class == "nahkampf":
		skill = "close_combat"
	talent = skill

	if talent in ["light_weapons", "heavy_weapons", "sniper_weapons"]\
	and has_talent(char, talent, "precision"):
		#+ 10 % maximale Schussdistanz
		factor *= 1.1
	
	# range factor from ammo
	if object.has_attribute(weapon_id, "act_ammo_type"):
		ammo = object.get_attribute(weapon_id, "act_ammo_type")
		if ammo and ammo!="" and object.has_attribute(ammo, "fire_range_factor"):
			factor *= object.get_attribute(ammo, "fire_range_factor")
	
	return factor

def on_grid_enter( object_id, grid_id, old_grid_id ):
	"Called if an object enters a grid."

	# handle interior grids
	if object.is_pc( object_id ):
		
		# update pcs_on_grid attribute on old grid
		if grids.has_attribute( old_grid_id, "pcs_on_grid" ):
			pcs_on_grid = grids.get_attribute( old_grid_id, "pcs_on_grid" )
			grids.set_attribute( old_grid_id, "pcs_on_grid", pcs_on_grid - 1 )

			# last pc left grid, so hide interior
			if pcs_on_grid == 1 and \
				grids.has_attribute( old_grid_id, "interior_object" ) and \
				grids.has_attribute( old_grid_id, "exterior_object" ):
					
				# check that there is really no one left in one of the interiors
				interior_object = grids.get_attribute( old_grid_id, "interior_object" )
				exterior_object = grids.get_attribute( old_grid_id, "exterior_object" )
				
				attached_grids = object.get_attribute( interior_object, "attached_grids" )
				pcs_in_interior = False
				for attached_grid in attached_grids:
					if grids.has_attribute( attached_grid, "pcs_on_grid" ):
						if grids.get_attribute( attached_grid, "pcs_on_grid" ) > 0:
							pcs_in_interior = True
							break
				
				if not pcs_in_interior:
					object.set_visible( interior_object, False )
					object.set_visible( exterior_object, True )

		# update pcs_on_grid attribute on new grid
		if not grids.has_attribute( grid_id, "pcs_on_grid" ):
			grids.set_attribute( grid_id, "pcs_on_grid", 0 )
		pcs_on_grid = grids.get_attribute( grid_id, "pcs_on_grid" )
		grids.set_attribute( grid_id, "pcs_on_grid", pcs_on_grid + 1 )

		# first pc entered grid, so show interior
		if pcs_on_grid == 0:
			#jan: changed order of "if" statements does this statement make any sense????
			if (not grids.has_attribute( grid_id, "interior_object" )) and grids.has_attribute( grid_id, "exterior_object" ):
				exterior_object = grids.get_attribute( grid_id, "exterior_object" )
				object.set_visible( exterior_object, False )
#				object.set_visible( interior_object, True )#jan: any problems with this?

			# check that there is really no one already in one of the interiors
			if grids.has_attribute( grid_id, "interior_object" ) and \
				grids.has_attribute( grid_id, "exterior_object" ):
				
				interior_object = grids.get_attribute( grid_id, "interior_object" )
				exterior_object = grids.get_attribute( grid_id, "exterior_object" )
				
				attached_grids = object.get_attribute( interior_object, "attached_grids" )
				pcs_in_interior = 0
				for attached_grid in attached_grids:
					if grids.has_attribute( attached_grid, "pcs_on_grid" ):
						pcs_in_interior += grids.get_attribute( attached_grid, "pcs_on_grid" ) > 0
				
				if pcs_in_interior == 1:
					object.set_visible( exterior_object, False )
					object.set_visible( interior_object, True )
				

		if len(system.get_selected_pcs()) > 0:
			if system.camera_in_follow_mode() and system.get_selected_pcs()[0] == object_id:
				if grid_id=="landscape":
					system.set_camera_zoom_parameters("outdoor")
				else:
					system.set_camera_zoom_parameters("indoor")

def switch_to_interior( object_id ):
	"""switchs to the interior, used in the editor"""
	if object.has_attribute( object_id, "attached_interior_objects" ):
		attached_interior_objects = object.get_attribute( object_id, "attached_interior_objects")
		object.set_visible( object_id, False )
		object.set_visible( attached_interior_objects[0], True )
		object.set_direction(attached_interior_objects[0], object.get_direction(object_id))
		object.set_position(attached_interior_objects[0], object.get_x(object_id),object.get_y(object_id))

def switch_to_exterior( object_id_exterior, object_id_interior ):
	"""switchs to the interior, used in the editor"""
	object.set_visible( object_id_interior, False )
	object.set_visible( object_id_exterior, True )

def on_enemy_spotted( object_id ):
	"""called if the player chars spot an enemy and no enemy has been visible yet"""
	music.on_enemy_spotted( object_id )


def on_sector_cleared( object_id ):
	"""called if enemies have been visible and are now gone"""
	pass
	
def on_corpse_spotted( object_id ):
	"""called if the player chars spot a corpse and no corpse has been visible yet"""
	pass

def on_attack( operator_id, target_id ):
	"""called if an object is attacked"""
	#print "on_attack",operator_id,target_id
	pass

def on_pick_up( character_id, item_id, item_type ):
	"""called if an item is picked up"""
	#print "on_pick_up", character_id, item_id, item_type
	#test if object is explosive, explode if skill to low
	if test_explosive(character_id, item_id, item_type ):
		return True

	return False
def can_pick_up(character_id, item_id):
	#cant/wont pick up a sharp bomb
	if(object.has_attribute(item_id, "bomb_is_sharp")):
		if object.get_attribute(item_id, "bomb_is_sharp") == True:
			return False
	return True
def can_defuse(character_id, item_id):
	if(object.has_attribute(item_id, "bomb_is_sharp")):
		if object.get_attribute(item_id, "bomb_is_sharp") == True:
			explosives = object.get_attribute( object=character_id, attribute="explosives" )
			item_type= object.get_attribute( item_id, "typeid" )
			if explosives <55:
				if(item_type=="SET_GAS_BOMB" or \
					item_type=="SET_DYNAMITE_WITH_TIME_BASED_DETONATOR" or \
					item_type=="SET_DYNAMITE" ):
					return False
				
			if explosives <60:
				if(item_type=="SET_C4_TIMEBASED" or \
					item_type=="SET_C4_TIMEBASED_W_NAILS" or \
					item_type=="SET_C4_REMOTE_CONTROL_W_NAILS" or \
					item_type=="SET_ANTITANKMINE" or \
					item_type=="SET_LANDMINE" or \
					item_type=="SET_FERTILIZER_EXPLOSIVE_TIME_BASED" or \
					item_type=="SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL" or \
					item_type=="SET_C4_REMOTE_CONTROL" ):
					return False
			return True
	return False

def test_explosive( character_id, item_id, item_type ):
	dodamage = False
	#print "test_explosive", character_id, item_id, item_type
	#print "test: " ,item_type, (object.has_attribute(item_type, "weapon_type"))
	if (object.has_attribute(item_type, "weapon_type")):
		if object.get_attribute(item_type, "weapon_type")=="explosiv":
			explosives = object.get_attribute( object=character_id, attribute="explosives" )
			#print "skill: " ,explosives
			if explosives < 15:
				if random.randint(0, 9): #90% chance
					dodamage=True
			elif explosives < 40:
				if random.randint(0, 1): #50% chance
					dodamage=True
	if dodamage:
		#print "do_explosive_damage"
		#		object.remove_item_from_inventory(character_id, item_type)
		hitpoints=object.get_attribute(character_id, "hitpoints")
		#do some tricks to remove the bomb from the ground
		object.pick_up_item_direct(character_id,item_id)
		object.remove_item_from_inventory(character_id,item_id)
		
		factor=random.randint(5, 10)
		hitpoints=hitpoints*factor/100
		object.set_attribute(character_id, "hitpoints", hitpoints)
		fx_object_id = random.choice([fx_explosion,fx_explosion_medium])
		sound_object_id = random.choice(['grenade_explo_frag','grenade_explo_rpg7','various_explosive_explo'])
		pos = object.get_position(character_id)
		system.start_effect( 
			startx=pos[0],starty=pos[1],startz=pos[2],
			dirx=0,diry=0,dirz=1,
			parameter=fx_object_id)
		sounds.play_3d_sound(
			sfx_id=sound_object_id,
			x=pos[0],y=pos[1],z=pos[2])
		return False
	return True

def on_put_down( character_id, item_id, item_type ):
	"""called if an item is put up"""
	#print "on_put_down", character_id, item_id, item_type
	pass

def can_put_down( character_id, item_id, item_type, x, y, grid_identifier ):
	"""
	Tests if the given item can be put down by the char
	returns true if the item can be put down
	otherwise false

	To use this function it has to be overwritten in the 
	appropriate zone script.
	"""
	
	# default return value is true
	return True
	
def get_item_3d_offset( character_id, node_name, type_id ):
	"""gets the 3d offset for the item"""
	if (object.has_attribute(type_id, "offset")):
		offset = object.get_attribute(type_id, "offset")
		if (object.has_attribute(character_id, "gender") and
			object.has_attribute(character_id, "model")):
			gender = object.get_attribute(character_id, "gender")
			model = object.get_attribute(character_id, "model")
			for entry in offset:
				if len(entry)==4:
					if (entry[0]==gender and
						entry[1]==model and
						entry[2]==node_name):
						vector = entry[3]
						if len(vector)!=3:
							raise ValueError, "vector needs entries for x,y,z"
						#print vector
						return vector
	return [0,0,0]

def is_feigning_death( character_id ):
	"""returns true if the char is feigning death

character_id - id of he char"""
	# if the char has the attr then check its state
	if object.has_attribute( character_id, "feigning_death" ):
		if object.get_attribute( character_id, "feigning_death" ) == True:
			return True
		else: # char does not have the attr, that means he is not feigning death
			return False
	else:
		return False
			


def feign_death( character_id, status = None ):
	"""determine if the char should feign death.
	The old body mode is saved in the attribute feigning_death

character_id - id of the char
status - If status true then the char feigns death.
	If status false then the char ends feigning death.
	if status None then the char switches feigning death"""

	if status == None:
		# if the char has the attr this means he is feigning death
		if object.has_attribute( character_id, "feigning_death" ):
			status = False
		else: # char does not have the attr, that means he is NOT feigning death
			status = True

	object.set_feigning_death_state( character_id, status )

def remove_from_foes_list( character_id, enemy_id ):
	"""removes the enemy from the foes list of the char

character_id - id of the char that has the enemy list
enemy_id - id of the enemy that should be removed"""

	if object.has_attribute( character_id, "foes" ):
		foes = object.get_attribute( character_id, "foes" )
		if enemy_id in foes:
			foes.remove( enemy_id )
			object.set_attribute( character_id, "foes", foes )
			# cancel the attacking commandos of the char
			object.cancel_commandos( character_id ) 
				

def has_talent( character_id, skill, talent ):
	"""returns true if the char has the talent

character_id - id of the character
skill - the skill where the talent is part of
talent - the talent itself """

	return globals.has_talent( character_id, skill, talent )

def can_use_talent_increase_moral( character_id ):
	"""check if the char can use the talent 'increase_moral'
	This talent can only be used every 24 hours

character_id - id of the char"""

	if not has_talent( character_id, "speech", "increase_moral" ):
		return False

	if object.has_attribute( character_id, "used_increase_moral" ):
		last_used = object.get_attribute( character_id, "used_increase_moral" )
		if system.get_mission_time() - last_used > time( "24:00:00" ):
			return True
		else:
			return False
	else:
		return True

def on_use_increase_moral( character_id ):
	"""the char uses the talent increase_moral.
	this gives the party a 10% bonus on the hitpoints
	for 5 minutes. If increase_moral is already active for the party, then 
	extend the time, by setting a new start time for increase_moral_active.

character_id - id of the char"""
	
	if not can_use_talent_increase_moral( character_id ):
		return

	# let the char shout some motivating words
	random_comment( character_id, "INCREASE_MORAL_", 3 )

	# set the time the char startetd to use increase_moral.
	# With this value we can measure that he would not use it twice 
	# in a time span of 24 hours.
	object.set_attribute( character_id, "used_increase_moral", system.get_mission_time() )

	# start 5 minute realtime timer
	system.notify_global_timer( "increase_moral_active_timer_" + character_id, 300000, False ) 
	
	party_members = system.get_pcs()

	for member in party_members:
		extend_hitpoints = True

		increase_moral_activated = 0 # counts how often increase_moral was activated on this char

		# if the char has the attribute increase_moral_activated
		# then do not extend his hitpoints again
		if object.has_attribute( member, "increase_moral_activated" ):
			increase_moral_activated = object.get_attribute( member, "increase_moral_activated" )
			extend_hitpoints = False

		# increase the increase_moral counter, so that the hitpoint increase holds
		# longer than 5 minutes, because increase_moral was used repeatedly on this char.
		# See system_events.on_timer how increase_moral_activated is used.
		increase_moral_activated = increase_moral_activated + 1
		if increase_moral_activated < 1:
			increase_moral_activated = 1

		object.set_attribute( member, "increase_moral_activated", increase_moral_activated )

		skills = [ "light_weapons", "heavy_weapons", "sniper_weapons", "speech", "throw_weapons", \
		"explosives", "survival", "technic", "medicine", "sneak", "driving", "pick_pocket", "lock_pick", "close_combat" ]
		if extend_hitpoints:
			for skill in skills:
				skill_value = object.get_attribute( member, skill )
				max_value = 99
				# 10 percent more on the skill
				if skill_value > 0:
					new_skill_value = skill_value * 1.1
				else:
					new_skill_value = skill_value * 0.9

				if new_skill_value > max_value:
					new_skill_value = max_value
				object.set_attribute( member, skill, int( new_skill_value ) )

	system.update_ui()



def can_use_talent_survive( character_id ):
	"""check if the char can use the talent 'survive'
	This talent can only be used every 24 hours

character_id - id of the char"""

	if not has_talent( character_id, "survival", "survive" ):
		return False

	if object.has_attribute( character_id, "used_survive" ):
		last_used = object.get_attribute( character_id, "used_survive" )
		if system.get_mission_time() - last_used > time( "24:00:00" ):
			return True
		else:
			return False
	else:
		return True

def on_use_survive( character_id ):
	"""the char uses the talent survive.
	this gives the party a 10% bonus on the hitpoints
	for 5 minutes. If survive is already active for the party, then 
	extend the time, by setting a new start time for survive_active.

character_id - id of the char"""
	
	if not can_use_talent_survive( character_id ):
		return

	# set the time the char startetd to use survive.
	# With this value we can measure that he would not use it twice 
	# in a time span of 24 hours.
	object.set_attribute( character_id, "used_survive", system.get_mission_time() )

	# start 5 minute realtime timer
	system.notify_global_timer( "survive_active_timer_" + character_id, 300000, False ) #300000, False )
	
	party_members = system.get_pcs()

	for member in party_members:
		extend_hitpoints = True

		survive_activated = 0 # counts how often survive was activated on this char

		# if the char has the attribute survive_activated
		# then do not extend his hitpoints again
		if object.has_attribute( member, "survive_activated" ):
			survive_activated = object.get_attribute( member, "survive_activated" )
			extend_hitpoints = False

		# increase the survive counter, so that the hitpoint increase holds
		# longer than 5 minutes, because survive was used repeatedly on this char.
		# See system_events.on_timer how survive_activated is used.
		survive_activated = survive_activated + 1
		if survive_activated < 1:
			survive_activated = 1

		object.set_attribute( member, "survive_activated", survive_activated )

		if extend_hitpoints:
			hitpoints = object.get_attribute( member, "hitpoints" )
			max_hitpoints = object.get_attribute( member, "maxhitpoints" )
			# 10 percent more hitpoints
			if hitpoints > 0:
				new_hitpoints = hitpoints * 1.1
			else:
				new_hitpoints = hitpoints * 0.9

			if new_hitpoints > max_hitpoints:
				new_hitpoints = max_hitpoints
			object.set_attribute( member, "hitpoints", new_hitpoints )


def on_wait_for_commando(id):
	# handle alerted chars
	if object.has_attribute(id, "alerted")\
	and object.get_attribute(id, "alerted")\
	and character.exists(id):
		weapon = character.get_primary_weapon(id)
		weapon_type = None
		if weapon:
			weapon_type = object.get_attribute(weapon, "weapon_type")
		if weapon_type and weapon_type != "nahkampf":
			if character.get_body_mode(id) != "KNEEL":
				character.change_body_mode(id, "KNEEL")
				character.aim_animation(id)
			else:
				animation_type = object.get_attribute(weapon, "fire_animation")
				if animation_type in [FPA_PISTOL_SINGLE, FPA_PISTOL_VOLLEY]:
					character.play_animation(id, "CM_KNIEND_ALARMIERT_PISTOLE")
				else:
					character.play_animation(id, "CM_KNIEND_ALARMIERT_GEWEHR")
		return True
	
	data = globals.data("rest")
	if hasattr(data, "resting") and data.resting and id in data.char_activity.keys():		
		if data.char_activity[id] == "lie_on_camping_bed":			
			character.play_animation(id, "CM_NPC_LIEGEN_BETT_LOOP")
			return True
		elif data.char_activity[id] == "lie_on_sleeping_bag":			
			character.play_animation(id, "CM_NPC_LIEGEN_LOOP")
			return True
		elif data.char_activity[id] == "read_book":			
			character.play_animation(id, "CM_NPC_SITZEN_BANK_BUCH_LESEN_LOOP")
			return True			
		elif data.char_activity[id] == "play_flute":
			character.play_animation(id, "CM_NPC_SITZEN_BANK_FLOETE_SPIELEN_LOOP")
			return True			
		elif data.char_activity[id] == "cook_meal":
			character.play_animation(id, "CM_NPC_STEHEN_PFANNE_SCHWENKEN_LOOP")
			return True
		elif data.char_activity[id] == "write_pad":
			character.play_animation(id, "CM_NPC_SITZEN_BANK_LOOP")
			return True
		elif data.char_activity[id] == "drink":
			if not random.randint(0, 10):
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_TRINKEN_LOOP")
			else:
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_LOOP")
			return True
		elif data.char_activity[id] == "eat_and_drink":
			if not random.randint(0, 10):
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_TRINKEN_LOOP")
			elif not random.randint(0, 2):				
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_ESSEN_LOOP")
			else:
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_LOOP")
			return True	
		elif data.char_activity[id] == "play_cards":
			if not random.randint(0, 5):
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_KARTEN_SPIELEN_AUSSPIELEN_LOOP")
			else:
				character.play_animation(id, "CM_NPC_SITZEN_BODEN_KARTEN_SPIELEN_GRUEBELN_LOOP")
			return True
	
	# check if this npc can/should loot a corpse
	if random.randint(0,10) == 0:
		if object.can_do_npc_ki_action(id):
			#npc_ki_loot_corpse(id)
			pass
			
	return False

def can_crack_lock( character_id, object_id, dummy ):
	"""Checks if the char is able to crack a lock.
	This is only possible if he has a picklock.

character_id - id of the char"""
	
	picklocks = [ "SET_BASIC_PICKLOCK", "SET_VAMPED_PICKLOCK_SET", "SET_SET_OF_PICKLOCKS" ]

	for picklock in picklocks:
		if( object.count_in_inventory( character_id, picklock ) ):
			return True

	return False

def can_blast_lock( character_id, object_id, dummy ):
	"""Checks if the char is able to blast a lock.

character_id - id of the char"""
	if not has_talent( character_id, "explosives", "blast_locks" ):
		return False
	explosives = [ "SET_GUN_POWDER" ]

	for explosive in explosives:
		if( object.count_in_inventory( character_id, explosive ) ):
			return True

	return False

def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):

	lock_data = {}
	lock = None
	lock_position = None

	object.remove_item_from_inventory(character_id, "SET_GUN_POWDER")

	if object.has_attribute( object_id, "exterior_object_id" ):
		object_id = object.get_attribute( object_id, "exterior_object_id" )
		
	object_type = object.get_attribute( object_id, "typeid" )
	if object.has_attribute( object_type, "lock_data" ):
		lock_data = object.get_attribute( object_type, "lock_data" )

		# search the lock by the given dummy
		for key in lock_data.keys():
			if dummy_name in lock_data[ key ][ "dummies" ]:
				lock = key
	else:
		return

	if lock == None:
		return
	
	# get the position of the lock to determine the correct animation
	lock_position = lock_data[ lock ][ "position" ]
	
	# fix von roger: position des dummys holen, dort fx starten
	x,y,z = object.get_full_dummy_position(object_id, dummy_name)
	lambda_string = 'on_lock_explode("%s",  "%s", %f, %f, %f )' %(object_id ,dummy_name, x, y, z)

	if lock_position == "bottom":
		character.play_animation( character_id, "KNIEND_TRUENSCHLOSS_KNACKEN" , callback=[ "ONEND", Lambda( lambda_string ) ])
	if lock_position == "center":
		character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN" , callback=[ "ONEND", Lambda( lambda_string ) ])
	if lock_position == "top":
		on_lock_explode(object_id,dummy_name,x,y,z)

#	lambda_string = 'char_tried_cracking( character_id="%s", object_id="%s", dummy_name="%s", x=%f, y=%f, z=%f )' %( character_id ,object_id, dummy_name, x, y, z )
#		character.play_animation( character_id, "KNIEND_TRUENSCHLOSS_KNACKEN", callback=[ "ONEND", Lambda( lambda_string ) ] )

def on_lock_explode( object_id, dummy_name, x, y, z ):
	system.start_effect( x, y, z, x, y, z, fx_explosion )
	sounds.play_3d_sound( "grenade_explo_fire", x, y, z )
	object.remove_closed_lock( object_id, dummy_name ) # lock is open because of the explosion

	
def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
	"""Equips the char with the right utilities and starts 
	the crack animations.

character_id - id of the char
object_id - id of the object thats lock is cracked
dummy_name - name of the dummy to check for locktraps
"""

	pre_crack_lock( character_id ) # quip the right picklock

	lock_data = {}
	lock = None
	lock_position = None
	global crack_lock_comments
	crack_lock_comments = []
	

	if object.has_attribute( object_id, "exterior_object_id" ):
		object_id = object.get_attribute( object_id, "exterior_object_id" )
		
	object_type = object.get_attribute( object_id, "typeid" )
	if object.has_attribute( object_type, "lock_data" ):
		lock_data = object.get_attribute( object_type, "lock_data" )

		# search the lock by the given dummy
		for key in lock_data.keys():
			if dummy_name in lock_data[ key ][ "dummies" ]:
				lock = key
	else:
		return

	if lock == None:
		return
	
	# get the position of the lock to determine the correct animation
	lock_position = lock_data[ lock ][ "position" ]

	# play a animation showing the char cracking a lock
	lambda_string = 'char_tried_cracking( character_id="%s", object_id="%s", dummy_name="%s", x=%f, y=%f, z=%f )' %( character_id ,object_id, dummy_name, x, y, z )

	if lock_position == "bottom":
		character.play_animation( character_id, "KNIEND_TRUENSCHLOSS_KNACKEN", callback=[ "ONEND", Lambda( lambda_string ) ] )
	if lock_position == "center":
		character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=[ "ONEND", Lambda( lambda_string ) ] )
	if lock_position == "top":
		None
	
def calc_crack_lock_chances( character_id, object_id, dummy_name ):
	"""Calcs the chance of the char to crack a lock, 
	the chance that the lock is destroy, and the chance to destroy the picklock
	while trying to crack a lock

	Returns all three values: 
	float - crack_lock_chance,
	bool - lock_destroyed, 
	float - destroy_picklock_chance 

character_id - id of the char who should crack a lock
object_id - id of the object thats lock is cracked
dummy_name - name of the dummy to check for locktraps
"""
	lock_data = {}
	lock = None
	lock_position = None

	object_type = object.get_attribute( object_id, "typeid" )
	if object.has_attribute( object_type, "lock_data" ):
		lock_data = object.get_attribute( object_type, "lock_data" )

		# search the lock by the given dummy
		for key in lock_data.keys():
			if dummy_name in lock_data[ key ][ "dummies" ]:
				lock = key

	if lock == None:
		return 0.0, 1.0

	cracklock_skill = 0
	bonus = 0 # is the bonus the chars get if he has some talents
	crack_lock_chance = 0.0
	destroy_picklock_chance = 0.0 # chance to destroy the picklock while cracking a lock
	lock_destroyed = False # determines if the lock is destroyed while trying to open it

	# calc the bonus. If the char uses a professionell picklock then 
	# the bonus is 5%
	# check if picklock is equiped
	professionell_picklocks = [ "SET_SET_OF_PICKLOCKS" ]

	# if a picklock is already equiped than do nothing
	for picklock in professionell_picklocks:
		if character.is_equiped( character_id, picklock ):
			bonus = 0.15

	# check if char has talent to open this particular lock
	lock_type = lock_data[ lock ][ "type" ]

	if lock_type == "door" and has_talent( character_id, "lock_pick", "specialisation_doors" ):
		bonus = bonus + 0.2
	if lock_type == "chest" and has_talent( character_id, "lock_pick", "specialisation_chests" ):
		bonus = bonus + 0.2
	if lock_type == "safe" and has_talent( character_id, "lock_pick", "specialisation_safes" ):
		bonus = bonus + 0.2

	if object.has_attribute( character_id, "lock_pick" ):
		cracklock_skill = object.get_attribute( character_id, "lock_pick" )

	# set the chance to crack the lock depending on the skill
	if 1 <= cracklock_skill <= 14:
		destroy_picklock_chance = 0.5
		# 75% destroying lock. lock stays closed anyway
		rand = random.random()
		if rand <= ( 0.75 - bonus ):
			lock_destroyed = True
	elif 15 <= cracklock_skill <= 39:
		destroy_picklock_chance = 0.4
		# 50% destroying lock. lock stays closed anyway
		rand = random.random()
		if rand <= ( 0.50 - bonus ):
			lock_destroyed = True
	elif 40 <= cracklock_skill <= 54:
		destroy_picklock_chance = 0.3
		# 100% NOT cracking the lock
		crack_lock_chance = 0.0
	elif 55 <= cracklock_skill <= 69:
		destroy_picklock_chance = 0.1
		# 20% cracking the lock
		crack_lock_chance = 0.2
	elif 70 <= cracklock_skill <= 84:
		destroy_picklock_chance = 0.05
		# 40% cracking the lock
		crack_lock_chance = 0.4
	elif 85 <= cracklock_skill <= 94:
		destroy_picklock_chance = 0.02
		# 60% cracking the lock
		crack_lock_chance = 0.6
	elif 95 <= cracklock_skill <= 99:
		# 80% cracking the lock
		crack_lock_chance = 0.8

	return ( crack_lock_chance + bonus, lock_destroyed, destroy_picklock_chance )

		
# globale var to store the crack_lock  comments
crack_lock_comments = []

def char_tried_cracking( character_id, object_id, dummy_name, x, y, z ):
	"""callback function. Is called after the crack lock animation is played.

character_id - id of the char
object_id - id of the object thats lock is cracked
dummy_name - name of the dummy to check for locktraps
	"""

	lock_data = {}
	lock = None
	lock_position = None

	object_type = object.get_attribute( object_id, "typeid" )
	if object.has_attribute( object_type, "lock_data" ):
		lock_data = object.get_attribute( object_type, "lock_data" )

		# search the lock by the given dummy
		for key in lock_data.keys():
			if dummy_name in lock_data[ key ][ "dummies" ]:
				lock = key

	# if dummy does not determine a lock
	if lock == None:
		random_comment( character_id, "CRACK_LOCK_NO_LOCK_", 2 )
		post_crack_lock( character_id, -1, object_id )
		return

	destroyed_locks = []

	# check if the lock that is determined by the given dummy is destroyed before.
	# If yes than it can not be opened anymore.
	if object.has_attribute( object_id, "destroyed_locks" ):
		destroyed_locks = object.get_attribute( object_id, "destroyed_locks" )

		# is the lock is a destroyed lock return
		# because then the lock can not be opened
		if lock in destroyed_locks:
			random_comment( character_id, "CRACK_LOCK_LOCK_ALREADY_DESTROYED_", 3 )
			return 

	crack_lock_chance, lock_destroyed, destroy_picklock_chance = calc_crack_lock_chances( character_id, object_id, dummy_name )
	
	# check the chance to crack the lock if it is not destroyed
	# before.
	global crack_lock_comments
	
	if not lock_destroyed:
		# if the lock has a trap and the char does not have the talent to deactivate it,
		# then the trap is activated
		rand = random.random()
		if rand < crack_lock_chance: # cracking was a success
			object.remove_closed_lock( object_id, dummy_name )
			crack_lock_comments.append( get_random_comment( "CRACK_LOCK_SUCCESS_", 3 ) )
		else: # cracking failed
			#random_comment( character_id, "CRACK_LOCK_FAILED_", 3 )
			crack_lock_comments.append( get_random_comment( "CRACK_LOCK_FAILED_", 3 ) )

		handle_lock_traps( character_id, object_id, lock_data, lock, dummy_name, x, y, z, destroy_picklock_chance )
	else:
		destroyed_locks.append( lock )
		crack_lock_comments.append( get_random_comment( "CRACK_LOCK_LOCK_DESTROYED_", 2 ) )
		post_crack_lock( character_id, destroy_picklock_chance, object_id )

	# set the new destroyed_locks list
	object.set_attribute( object_id, "destroyed_locks", destroyed_locks )

	if len( crack_lock_comments ) > 0:
		dialog.init_dialog( type=DIALOGSMALL )
		for x in range( len( crack_lock_comments ) ):
			if x < len( crack_lock_comments ) - 1:
				if crack_lock_comments[x + 1] in ['CRACK_LOCK_BOOBY_TRAP_001', 'CRACK_LOCK_BOOBY_TRAP_002', 'CRACK_LOCK_LOCK_TRAP_001', 'CRACK_LOCK_LOCK_TRAP_002']:
					dialog.add_text( text = crack_lock_comments[ x+1 ], speaker = character_id, follower = 'ENDDIALOG')
					break
				else:
					dialog.add_text( text = crack_lock_comments[ x ], speaker = character_id, follower = crack_lock_comments[ x + 1 ] )
			else:
				dialog.add_text( text = crack_lock_comments[ x ], speaker = character_id, follower = "ENDDIALOG" )

		dialog.start()

def handle_lock_traps( character_id, object_id, lock_data, lockname, dummy_name, x, y, z, destroy_picklock_chance ):
	"""Is called if the char has activated a trap

character_id - id of the char.
object_id - id of the building
lockname - name of the lock that was not cracked,-)
dummy_name - name of the dummy that represents the lock
x,y,z - coords of the dummy
destroy_picklock_chance - chance that the picklock is getting destroyed
"""
	comment_text = ""
	# check for closure_type of the lock that the dummy represents
	# and play the appropriate animation
	closure_type = lock_data[ lockname ][ "closure_type" ]

	# booby-trap will explode if char does not have the talent to deactivate it
	if closure_type == "booby-trap" and not has_talent( character_id, "explosives", "detect_booby_traps" ):
		lambda_string = 'post_crack_lock( character_id="%s", destroy_picklock_chance=%f, object_id="%s" )' %( character_id, destroy_picklock_chance, object_id )
		system.start_effect( x, y, z, x, y, z, fx_explosion )
		sounds.play_3d_sound( "grenade_explo_fire", x, y, z )
		character.play_animation( character_id, "CM_STEHEN_TREFFER_BAUCH" )
		#character.play_animation( character_id, "CM_NPC_SITZEN_BODEN_AUFSTEHEN" ,callback=[ "ONEND", Lambda( lambda_string ) ] )
		comment_text = get_random_comment( "CRACK_LOCK_BOOBY_TRAP_", 2 )
		# char gets 5-15 damage
		rand = random.randrange( 5, 15, 1 )
		object.damage( character_id, rand )
		object.remove_closed_lock( object_id, dummy_name ) # lock is open because of the explosion
	# lock-trap will be activated if char does not have the talent to deactivate it
	elif closure_type == "lock-trap" and not has_talent( character_id, "lock_pick", "lock_trap_trick" ):
		sounds.play_3d_sound( "throwing_knife_loop", x, y, z )
		character.play_animation( character_id, "CM_STEHEN_TREFFER_BAUCH" )
		comment_text = get_random_comment( "CRACK_LOCK_LOCK_TRAP_", 2 )

		rand = random.randrange( 1, 5, 1 )
		object.damage( character_id, rand )
		post_crack_lock( character_id, destroy_picklock_chance, object_id )
	else:
		post_crack_lock( character_id, destroy_picklock_chance, object_id )

	global crack_lock_comments
	if comment_text != "":
		crack_lock_comments.append( comment_text )


def pre_crack_lock( character_id ):
	""" called before cracking a lock.
	Char equipes picklock or blames if he did not have one

character_id - id of the char
"""
	# check if picklock is equiped
	picklocks = [ "SET_SET_OF_PICKLOCKS", "SET_BASIC_PICKLOCK", "SET_VAMPED_PICKLOCK_SET" ]

	equip_and_mark_unequiped( character_id, picklocks, "picklock_item" )
	

def post_crack_lock( character_id, destroy_picklock_chance, object_id ):
	"""called after a chars tried to crack a lock.
	The picklock is taken back into the inventory.
	The item used before it taken again.

character_id - id of character"""

	used_picklock = None
	comment_text = ""

	used_picklock = unequip_and_equip_marked( character_id, "picklock_item" )

	if used_picklock != None:
		# check if char destroyed the picklock while trying to crack a lock
		rand = random.random()
		if rand < destroy_picklock_chance:
			comment_text = get_random_comment( "CRACK_LOCK_PICKLOCK_DESTROYED_", 3 )

			if character.is_equiped( character_id, used_picklock ):
				character.un_equip( character_id, used_picklock )

			object.remove_item_from_inventory( character_id, used_picklock )

	global crack_lock_comments
	if comment_text != "":
		crack_lock_comments.append( comment_text )


def is_closed_lock_dummy( building_id, dummy_id ):
	"""checks if the given dummy is registered as a closed lock dummy
	for the given building.

building_id - id of the building
dummy_id - id of the dummy"""

	if object.has_attribute( building_id, "exterior_object_id" ):
		building_id = object.get_attribute( building_id, "exterior_object_id" )

	# test if object is a buildig
	if object.has_attribute( building_id, "type" ):
		if object.get_attribute( building_id, "type" ) == "building":
			# get locked door dummies of the building
			# and check if the given dummy exists in the list
			if object.has_attribute( building_id, "locked" ):
				locked = object.get_attribute( building_id, "locked" )
						
				if dummy_id in locked:
					return True
		
	return False

def did_detect_lock_trap( character_id, object_id, dummy_name, x, y, z ):
	"""Is called when right clicked on a lock.
	If the char has the talent to detect lock traps or
	booby traps then a glow effect is 
	shown at the lock.

character_id - id of the char
object_id - id of the object with the lock
dummy_name - nam eof the dummy that determines the lock
y,x,z - coordinates of the dummy that represents the lock
"""
	lock_data = {}
	lock = None
	lock_position = None

	if object.has_attribute( object_id, "exterior_object_id" ):
		object_id = object.get_attribute( object_id, "exterior_object_id" )

	object_type = object.get_attribute( object_id, "typeid" )
	if object.has_attribute( object_type, "lock_data" ):
		lock_data = object.get_attribute( object_type, "lock_data" )

		# search the lock by the given dummy
		for key in lock_data.keys():
			if dummy_name in lock_data[ key ][ "dummies" ]:
				lock = key
				break
	else:
		return

	if lock == None:
		return

	if has_talent( character_id, "lock_pick", "find_lock_traps" ):
		if lock_data[ lock ][ "closure_type" ] == "lock-trap":
			system.start_effect( x, y, z, x, y, z, fx_lock_trap )
	if has_talent( character_id, "explosives", "detect_booby_traps" ):
		if lock_data[ lock ][ "closure_type" ] == "booby-trap":
			system.start_effect( x, y, z, x, y, z, fx_lock_trap )

def equip_and_mark_unequiped( character_id, items, tag ):
	"""This function equips one of the given items and marks 
	the item that is unequiped to equip it again later.
	
	returns the equiped item.

character_id - id of the char
items - list of items. If char owns one of them, then this would be equiped.
tag - tag that is used to mark the unequiped item
"""
	# if a item is already equiped than do nothing
	for item in items:
		if character.is_equiped( character_id, item ):
			object.set_attribute( item, tag, "used" )
			return item

	# search for the item(s) that is/are equiped in the hands
	# of the char. Unequip it and mark it as 'swap'
	for old_item in object.get_inventory_id_list(character_id):
		if character.is_equiped( character_id, old_item ):
			if object.has_attribute( old_item, "occupied_slots" ):
				slots = object.get_attribute( old_item, "occupied_slots" )
				if "right_hand" in slots or "left_hand" in slots:
					object.set_attribute( old_item, tag, "swap" )
					character.un_equip_direct( character_id, old_item )

	# equip on of the items
	for item in items:
		if object.count_in_inventory( character_id, item ): # item is in inventory
			# equip the item and mark it as 'used'
			object.set_attribute( item, tag, "used" )
			character.equip_direct( character_id, item ) # equip the item
			
			return item

	return None


def unequip_and_equip_marked( character_id, tag ):
	"""The funtcion searches for items that have the given tag 
	and unequipes the ones marked with "used" and equips the ones marked
	with "swap"

	returns the unequiped item.

character_id - id of the char
tag - tag that is used to mark the unequiped item
	"""

	used_item = None

	for item in object.get_inventory_id_list(character_id):
		# if the slot is not empty and has the attribute tag
		if object.has_attribute( item, tag ):
			# slot item is used , so put it back in the inventory 
			# and empty the attribute
			if object.get_attribute( item, tag ) == "used":
				object.set_attribute( item, tag, None )
				used_item = item
				if character.is_equiped( character_id, item ):
					character.un_equip_direct( character_id, item )
			# slot item was used before, so take it back
			# and empty the attribute
			elif object.get_attribute( item, tag ) == "swap":
				object.set_attribute( item, tag, None )
				if not character.is_equiped( character_id, item ):
					character.equip_direct( character_id, item )

	return used_item

def pre_resuscitate( character_id ):
	"""Is called before a char tries to resuscitate another char.
	The char just unequips everything

character_id - id of the char
"""
	equip_and_mark_unequiped( character_id, [], "resuscitate_item" )

def post_resuscitate( character_id ):
	"""Is called after a char tried to resuscitate another char
	The char equips the item he has equiped before resuscitation.

character_id - id of the char
"""
	unequip_and_equip_marked( character_id, "resuscitate_item" )
	

def calc_perception_values(char, daytime_change = False):
	# inquire daytime
	daytime = "day"
	d = data("sky")
	if hasattr(d, "daytime"):
		daytime = d.daytime
		
	# has the char binoculars or a night vision device equiped?
	night_vision = False
	binoculars = False
	if object.has_attribute(char, "slots"):
		slots = object.get_attribute(char, "slots")
		if "vision" in slots and slots["vision"]:
			itemtype = object.get_attribute(slots["vision"], "typeid") 
			if itemtype=="SET_NIGHT_VISION_GEAR": night_vision = True
			elif itemtype=="SET_BINOCULARS": binoculars = True
			else: raise Exception, "unknown vision equipment '%s'" % slots["vision"]
	
	# get bodymode
	bodymode = "STAND"
	bodymode = character.get_body_mode(char)
	
	# calc range of vision in meter for this char (how far this char can see) 
	if daytime == "night":
		range_of_vision = 25
		if night_vision: range_of_vision = 50
	elif daytime == "dusk":
		range_of_vision = 35 
		if night_vision: range_of_vision = 50
		if binoculars: range_of_vision *= 1.5
	elif daytime == "day":
		range_of_vision = 50 
		if binoculars: range_of_vision *= 1.5
	elif daytime == "dawn":
		range_of_vision = 35 
		if night_vision: range_of_vision = 50
		if binoculars: range_of_vision *= 1.5
	object.set_attribute(char, "range_of_vision", range_of_vision)
	
	
	# set max range of hearing for this char (how far this char can hear)
	# nothing is heard farther than this, not even loud weapons
	object.set_attribute(char, "max_earshot", 100.0)


	# calc influence from camouflage talents
	camouflage_factor = 1.0
	if has_talent(char, "sneak", "camouflage") and bodymode in ["LIE", "KNEEL"]:
		camouflage_factor *= 0.8
	if has_talent(char, "sneak", "night_camouflage"): 
		if daytime == "night":
			camouflage_factor *= 0.7
			if daytime_change:
				system.add_text(globaltext.TALENT_SNEAK_NIGHT_CAMOUFLAGE_ON % {"char": object.get_attribute(char, "name")})
		elif daytime == "dawn" and daytime_change:
			system.add_text(globaltext.TALENT_SNEAK_NIGHT_CAMOUFLAGE_OFF % {"char": object.get_attribute(char, "name")})
	for teammate in system.get_pcs():
		if has_talent(teammate, "sneak", "group_camouflage"):
			camouflage_factor *= 0.9

	# calc visibility factor for this char
	# visibility factor is applied to the range_of_vision of everyone trying to perceive this char
	visibility_factor = 1.0
	if bodymode == "LIE":
		if has_talent(char, "sniper_weapons", "camouflage"):
			visibility_factor = 0.2
		else: visibility_factor = 0.6
	if bodymode == "KNEEL": visibility_factor = 0.8
	visibility_factor *= camouflage_factor
	#if globals.LOCAL_USER == USER_ALEXANDER_MISELER:
	#	system.add_text("visibility_factor: %.04f" % visibility_factor)
	object.set_attribute(char, "visibility_factor", visibility_factor)

	# calc audibility for this char
	object.set_attribute(char, "audibility_range_motionless", 0)
	object.set_attribute(char, "audibility_range_moving", 10) # max. distance how far this char can be heard
	skill = object.get_attribute(char, "sneak")
	agility = object.get_attribute(char, "agility")
	if bodymode == "LIE":
		audibility = 0.1
	elif bodymode == "KNEEL":
		audibility = 0.7
	else:
		audibility = 1.0
	audibility *= skill_tables.sneak_detection_factor(skill)
	audibility *= skill_tables.agility_move_silently_factor(agility)
	#if globals.LOCAL_USER == USER_ALEXANDER_MISELER:
	#	system.add_text("audibility: %.04f" % audibility)
	object.set_attribute(char, "audibility_chance", audibility) # chance to be heard when inside the audibility_range
	

def on_alert(obj):
	if globals.LOCAL_USER == USER_ALEXANDER_MISELER:
		system.add_text("alert for: %s" % obj)
	
	pc_is_foe = False
	foes = []
	if object.has_attribute( obj, "foes" ):
		foes = object.get_attribute( obj, "foes" )
	pcs = system.get_pcs()
	for pc in pcs:
		if pc in foes:
			pc_is_foe = True
			if not object.is_fighting(obj):
				object.cancel_commandos(obj)
			object.set_attribute(obj, "alerted", True)
			break
	
	if pc_is_foe:
		return random.randint(25000, 35000); # alarm time in ms
	else:		
		return 2000
		#jan allert per default.    return 0
	
def on_alert_expired(obj):
	if globals.LOCAL_USER == USER_ALEXANDER_MISELER:
		system.add_text("alert expired for: %s" % obj)
	if character.exists(obj) and not object.is_destroyed(obj):
		character.change_body_mode(obj, "STAND")
	object.set_attribute(obj, "alerted", False)

def offend( character_id, number_opponents ):
	"""Is called if a char offends some NPCs to get
	their attention.

character_id - id of the char
number_opponents - number of opponents to offend.
"""
	if number_opponents > 1:
		random_comment( character_id, "OFFEND_MULTI_", 3 )
	else:
		random_comment( character_id, "OFFEND_SINGLE_", 3 )

npc_level_table = {
	# attributes
	"strength":			((1,12),(5,13),(9,14),(13,15),(17,16),(21,17),(21,18),(29,19)),
	"agility":			((1,12),(4,13),(8,14),(12,15),(16,16),(20,17),(24,18),(28,19)),
	"dexterity":		((1,12),(3,13),(8,14),(12,15),(16,16),(19,17),(23,18),(27,19)),
	"constitution": 	((1,12),(2,13),(6,14),(10,15),(14,16),(18,17),(22,18),(26,19)),
	"intelligence": 	((1,10),),
	"charisma":			((1,12),),
	# skills
	"close_combat":		((1,55),(3,60),(6,65),(10,70),(14,75),(19,80),(24,85),(29,90)),
	"light_weapons":	((1,60),(2,65),(3,70),(5,75),(9,80),(13,85),(18,90),(28,99)),
	"heavy_weapons":	((1,60),(2,65),(4,70),(7,75),(12,80),(17,85),(22,90),(27,95)),
	"sniper_weapons":	((1,60),(8,65),(15,70),(20,75),(25,80)),
	"throw_weapons":	((1,60),(4,65),(11,70),(16,75),(21,80),(26,85)),
	"explosives":		((1,55),(13,60),(20,65)),
	"survival":			((1,50),(8,55),(19,60),(28,55)),
	"sneak":			((1,50),(5,55),(14,60),(22,65)),
	"pick_pocket":		((1,50),(10,55),(17,60),(27,65)),
	"lock_pick":		((1,50),(6,55),(16,60),(25,65)),
	"technic":			((1,50),(11,55),(21,60),(29,65)),
	"driving":			((1,50),(9,55),(18,60),(26,65)),
	"speech":			((1,50),(12,55),(23,60)),
	"medicine":			((1,50),(7,55),(15,60),(24,65)),
}

npc_animals_le_table = {
	"WOLF": 			(8,					0),
	"ANTELOPE":			(8,					0),
	"BEAR":				(14,				0),
	"COW":				(6,					0),
	"DEER":				(10,				0),
	"HORSE":			(10,				0),
	"TIGER":			(14,				0),
	"WILDDOG":			(6,					0),
	"BISON":			(12,				0),
	"PIG":				(4,					0),
	"DONKEY":			(6,					0),
	"WARG":				(18,				0),
	"LIZARD_SOMA":		(12,				0),

	"RAT_SKULLS":		(4,					2),
	"DESERT_MONKS":		(5,					3),
	"SHADOWS":			(6,					7),
	"INDIANS":			(4,					3),
	"NOMADS":			(4,					3),
	"GNO_SOLDIERS":		(6,					6),
	"VILLAGE_PEOPLE":	(4,					2),
	"SEEKER":			(4,					4),
}

hp_difficulty_factor_table = {
	0: 0.5,
	1: 0.75,
	2: 1.0,
	3: 1.5,
	4: 2,
}

def calc_npc_attribute_skills( object_id , new_value, old_value ):
	# attribute/skills
	act_level = new_value
	assert act_level > 0
	for entry in npc_level_table:
		if object.has_attribute( object_id, entry ):
			value_list = npc_level_table[entry]
			for value in value_list:
				if value[0] < act_level:
					object.set_attribute( object_id, entry, value[1] )
		else:
			raise ValueError, "attribute/skill not found"

def calc_npc_le( object_id , new_value, old_value ):
	# le
	act_level = new_value
	assert act_level > 0
	type = None
	max_hp = 10
	if object.has_attribute(object_id, "typeid"):
		type=object.get_attribute(object_id, "typeid")

	if object.has_attribute(object_id, "faction"):
		type=object.get_attribute(object_id, "faction")

	if type in npc_animals_le_table:
		max_hp = npc_animals_le_table[type][0]
		max_hp+=(act_level-1)*npc_animals_le_table[type][1]

	import options
	difficulty = options.get_attribute("difficulty")
	if difficulty in hp_difficulty_factor_table:
		max_hp*=hp_difficulty_factor_table[difficulty]
	else:
		raise ValueError, "difficulty level not found"
	if max_hp==0: max_hp=1
	object.set_attribute(object_id,"maxhitpoints",max_hp)
	object.set_attribute(object_id,"hitpoints",max_hp)

def check_lay_down_area( character_id, carried_char ):
	"""Checks if the char can lay down the carried char
	where he stands.

character_id - id of the char
carried_char - id of the char that is carried
"""
	x = object.get_x( character_id )
	y = object.get_y( character_id )

	# check if area is empty
	objects = system.get_objects( type = None, left = x - 1.5, top = y - 1.5, right = x + 1.5, bottom = y + 1.5 )
	# filter out everything that is in front of the carrying char
	objects = filter(lambda obj: is_in_front( obj, character_id ), objects)
	# filter out the carrying char and the carried char.
	objects = filter(lambda obj: obj != character_id and obj != carried_char, objects)

	if len(objects):
		if object.has_attribute( carried_char, "gender" ):
			gender = object.get_attribute( carried_char, "gender" )
			if gender == "female":
				random_comment( character_id, "CARRY_LAY_DOWN_FAILED_FEMALE_", 3 )
			else:
				random_comment( character_id, "CARRY_LAY_DOWN_FAILED_MALE_", 3 )
		return False

	return True

def vehicle_explosion_callback(id, type, triggertime):
	object.set_attribute( id , "end_explosion_chassis", True)
	object.set_attribute( id , "end_explosion_wheels", True)

def vehicle_explosion( vehicle ):
	if object.has_attribute(vehicle, "typeid"):
		typeid = object.get_attribute(vehicle, "typeid")
		
		if (typeid=="SET_PICKUP2" or
			typeid=="SET_PICKUP"):
			object.set_attribute( vehicle , "destroy_model", True)

			sounds.play_3d_sound_object("pickup_explosion", vehicle) 

			system.start_effect_object(object=vehicle,
				node="main_explosion_1",
				parameter=fx_explosion_big)

			system.start_effect_object(object=vehicle,
				node="side_explosion_1",
				parameter=fx_explosion_big)

			object.play_animation(vehicle,"PICKUP_ZERSTOERN",
				["ONTIME",vehicle_explosion_callback,2000])

			object.fade_node( vehicle, "shockwave", 500)	
			object.fade_node( vehicle, "wheel_steer_r", 2500)
			object.fade_node( vehicle, "wheel_steer_l", 2500)
			object.fade_node( vehicle, "wheel_axle_r", 2500)
			object.fade_node( vehicle, "wheel_axle_l", 2500)
			object.fade_node( vehicle, "parts_1", 2500)
			object.fade_node( vehicle, "parts_2", 2500)

		if (typeid=="SET_HUMVEE"):
			object.set_attribute( vehicle , "destroy_model", True)
			sounds.play_3d_sound_object("humvee_explosion", vehicle) 
			
			system.start_effect_object(object=vehicle,
				node="main_explosion_1",
				parameter=fx_explosion_big)

			system.start_effect_object(object=vehicle,
				node="side_explosion_1",
				parameter=fx_explosion_big)

			object.play_animation(vehicle,"HUMVEE_ZERSTOEREN",
				["ONTIME",vehicle_explosion_callback,2000])

			object.fade_node( vehicle, "shockwave", 500)	
			object.fade_node( vehicle, "wheel_steer_r", 2500)
			object.fade_node( vehicle, "wheel_steer_l", 2500)
			object.fade_node( vehicle, "wheel_axle_r", 2500)
			object.fade_node( vehicle, "wheel_axle_l", 2500)
			object.fade_node( vehicle, "parts_1", 2500)

		if (typeid=="SET_WHEELTANK"):
			object.set_attribute( vehicle , "destroy_model", True)
			sounds.play_3d_sound_object("tank_explosion", vehicle) 
			
			system.start_effect_object(object=vehicle,
				node="rest",
				parameter=fx_explosion_big)

			object.play_animation(vehicle,"WHEELTANK_ZERSTOEREN",
				["ONTIME",vehicle_explosion_callback,2000])

			object.fade_node( vehicle, "shockwave", 500)	
			object.fade_node( vehicle, "wheel_steer_r", 2500)
			object.fade_node( vehicle, "wheel_steer_l", 2500)
			object.fade_node( vehicle, "wheel_axle_r", 2500)
			object.fade_node( vehicle, "wheel_axle_l", 2500)

		if (typeid=="SET_BUGGY"):
			object.set_attribute( vehicle , "destroy_model", True)
			sounds.play_3d_sound_object("buggy_explosion", vehicle) 
			
			system.start_effect_object(object=vehicle,
				node="main_explosion_1",
				parameter=fx_explosion_big)

			system.start_effect_object(object=vehicle,
				node="side_explosion_1",
				parameter=fx_explosion_big)

			object.play_animation(vehicle,"BUGGY_ZERSTOEREN",
				["ONTIME",vehicle_explosion_callback,2000])

			object.fade_node( vehicle, "shockwave", 500)	
			object.fade_node( vehicle, "wheel_steer_r", 2500)
			object.fade_node( vehicle, "wheel_steer_l", 2500)
			object.fade_node( vehicle, "wheel_axle_r", 2500)
			object.fade_node( vehicle, "wheel_axle_l", 2500)
			object.fade_node( vehicle, "parts_1", 2500)
			object.fade_node( vehicle, "parts_2", 2500)

def on_vehicle_seat_state_change( vehicle_id ):
	#print "on_vehicle_seat_state_change"
	import vehicle
	print vehicle_id
	print vehicle.get_crew( vehicle_id )
	driver = vehicle.get_char_from_seat( vehicle_id, 0 )
	can_drive = False
	typeid = None
	speedfactor = 0.6
	fuel_consumption_factor_type = 0.0
	fuel_consumption_factor_obj = 0.0

	if object.has_attribute(vehicle_id, "typeid"):
		typeid = object.get_attribute(vehicle_id, "typeid")
		fuel_consumption_factor_type = object.get_attribute( typeid, "fuel_consumption_factor")
		#print object.get_attribute( typeid, "max_speed") 

	if driver!=None:
		if driver in system.get_pcs():
			
			if object.has_attribute( driver, "driving"):
				skill = object.get_attribute( driver, "driving")
				
				if skill > 54:
					can_drive = True
					fuel_consumption_factor_obj = fuel_consumption_factor_type 	
				if skill > 69:
					speedfactor = 0.8
					fuel_consumption_factor_obj = fuel_consumption_factor_type * 0.9
				if skill > 84:
					speedfactor = 0.9
					fuel_consumption_factor_obj = fuel_consumption_factor_type * 0.8
				if skill > 94:
					speedfactor = 1.0
					fuel_consumption_factor_obj = fuel_consumption_factor_type * 0.7
				
				if has_talent( driver, "driving", "economic_driving"):
					fuel_consumption_factor_obj = fuel_consumption_factor_obj * 0.8
					
				object.set_attribute( vehicle_id, "speed_factor", speedfactor)
				object.set_attribute( vehicle_id, "fuel_consumption_factor", fuel_consumption_factor_obj)
			
			if has_talent( driver, "driving", "driving_tricks"):
				object.set_attribute( vehicle_id, "alternative_physic_mode", True)
			else:
				object.set_attribute( vehicle_id, "alternative_physic_mode", False)
				
	
			if typeid=="SET_WHEELTANK":
				if not has_talent( driver, "driving", "tanks"):
					can_drive = False
		else:
			can_drive = True

		object.set_attribute( vehicle_id, "human_player_can_drive", can_drive)
def can_enter_building( character_id, building_id ):
	"""Called if the user clicks to enter a building. Return True if that is
allowed or False if not. E.g. you should return False if the building is locked.
That accompanied with a comments for the user."""
	return True


def on_hit( object_id ):
	"""Is called if the object gets damage

object_id - id of the damaged object
"""
	None

def can_carry( character_id, object_id ):
	"""Is called to test if the character can 
	carry the object

character_id - id of the char that should carry the object
object_id - id of the object that should be carried
"""
	return True

def post_climb( character_id ):
	"""Is called after the char is climbed
	over something

character_id - id of the char that should carry the object
"""
	None

def on_change_body_mode( object_id, new_value, old_value ):
	"""Is called if a object changes its body mode
	"""
	None

def on_cancel_step_away( character_id ):
	"""Can be used to be called for the ONCANCEL
	event in scripts.
	This function lets the char step away from 
	forbidden grids

character_id - id of the char
"""
	object.step_away( character_id )

def unequip_hands( char_id, direct_unequip = True ):
	"""makes char unequip all equiped items and weapons"""
	character.unequip_hands( char_id, direct_unequip )

def get_combat_value(weapon):
	"""calculates a value that expresses the power of the given weapon.

this is used to find out who the strongest enemy is.	
"""
	value = 0.0
	try:
		value = object.get_attribute(weapon.replace("_W_SILENCER", ""), "value")
	except:
		value = object.get_attribute(weapon, "value")
	return value
	
		